<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('../../include/miphpf/Init.php');
	require_once('../../include/sc/Init.php');

	if (!scAdminAuth::singleton()->isAuthorized(scSections::SECTION_CUSTOMERS))
		die();
	
	class scCustomersRetriever extends scAutoCompleteDataRetriever {
		
		public function outputData()
		{
			if (empty($this->_searchStr))
				return;
			
			$query = 'SELECT Customers.CustomerID, CONCAT(CustomerAddressFirstName, " ", CustomerAddressLastName, " (", CustomerEmail , ")") AS CustomerName' .
				' FROM Customers INNER JOIN CustomerAddresses USING(CustomerID)' . 
				' HAVING CustomerName LIKE "%' . miStaticDBUtil::escapeStringForLike($this->_searchStr) . '%" ORDER BY CustomerName ASC';
			$rows = $this->selectRows($query);
			
			$result = '';
			foreach ($rows as $row) {
				$result .= $this->sanitize($row['CustomerName']) . $this->_cellSeparator . $row['CustomerID'] . "\n";
			}
			echo $result;
		}
	}
	
	$customersRetriever = new scCustomersRetriever(miGetParam('q'), miGetParamDefault('limit', scAutoCompleteDataRetriever::DEFAULT_RESULTS));
	$customersRetriever->outputData();
?>