<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('../../include/miphpf/Init.php');
	require_once('../../include/sc/Init.php');

	if (!scAdminAuth::singleton()->isAuthorized(scSections::SECTION_MANUFACTURERS))
		die();
	
	class scManufacturersRetriever extends scAutoCompleteDataRetriever {
		
		public function outputData()
		{
			if (empty($this->_searchStr))
				return;
			
			$query = 'SELECT ManufacturerID, ManufacturerName ' .
				'FROM ManufacturersML ' .
				'WHERE LanguageID = ? AND ManufacturerName LIKE ? ' .
				'ORDER BY ManufacturerName ASC';
			$rows = $this->selectRows($query, array(
				scMultiLanguage::getCurrentLanguageId(), 
				'%' . miStaticDBUtil::escapeStringForLike($this->_searchStr) . '%'
			));
			
			$result = '';
			foreach ($rows as $row) {
				$result .= $this->sanitize($row['ManufacturerName']) . $this->_cellSeparator . $row['ManufacturerID'] . "\n";
			}
			echo $result;
		}
	}
	
	$manufacturersRetriever = new scManufacturersRetriever(miGetParam('q'), miGetParamDefault('limit', scManufacturersRetriever::DEFAULT_RESULTS));
	$manufacturersRetriever->outputData();
?>