<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('../include/miphpf/Init.php');
	require_once('../include/sc/Init.php');
	
	scAdminAuth::singleton()->checkAuthorization(scSections::SECTION_MODULES_CHECKOUT);

	class scCheckoutModulesView extends scView {
		protected $_templates = array(
			self::TEMPLATE_ID_EDIT => 'admin/checkout_modules/checkout_modules_edit.tmpl',
			self::TEMPLATE_ID_LIST => 'admin/checkout_modules/checkout_modules_mgmt.tmpl',
		);
		
        protected $_dataFields = array(
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'CheckoutModuleID'
        	),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'CheckoutModuleName',
				'properties' => array('readOnly' => true)
        	),
        	array(
				'field' => 'scWebFormWidgetTextML',
				'data' => 'CheckoutModuleDisplayName',
        	),
       		array(
				'field' => 'miCheckboxWidget',
				'data' => 'CheckoutModuleIsActive'
        	),
       		array(
				'field' => 'scModuleOptionsWidget',
				'data' => 'ModuleOptionFields',
				'modelStrategy' => 'scViewMapperModuleOptions',
			),
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'CheckoutModuleImage',
        		'properties' => array('readOnly' => true)
        	),
        );
		
        protected $_domainObjectDisplayName = 'Checkout module';	// _t('Checkout module');
        
        public function initWebForm(&$form)
        {
			parent::initWebForm($form);
			
        	$record = $this->getRecord();
			$record->readPK(miGetParam('CheckoutModuleID'));
        	$form->getWidget('ModuleOptionFields')->setupModuleOptions($record->get('ModuleID'), 'ICheckoutModule');
        }
        
        public function initTable($table)
        {
        	parent::initTable($table);
        	
        	new scTableRecordsPerPage($table, $this->getTablePagerObj());
        }
		
		public function preProcess($actionObj)
		{
			if ($this->getController()->getDispatcher()->getAction() == 'dmChangeIsActive')
				$actionObj->setFieldName('CheckoutModuleIsActive');
		}
	}
	
	$checkoutModules = new scSqlRecordsetML('CheckoutModules', 'CheckoutModuleID');
	$table = new scTable($checkoutModules);
	
	$view = new scCheckoutModulesView();
	$view->setRecord(new scSqlRecordML('CheckoutModules', 'CheckoutModuleID',
						array('CheckoutModuleDisplayName'), array_keys(scMultiLanguage::getActiveLanguageCodes())));
	$view->setUpSortColumn('CheckoutModuleSort');
	$view->setTable($table);
	
	$page = new scAdminDisplayController(array($view));
	$page->getDispatcher()->setActionHandler('dmChangeIsActive', 'scExecChangeIsActiveAction');
	$page->dispatchAndShow();
?>