<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('../include/miphpf/Init.php');
	require_once('../include/sc/Init.php');
	
	scAdminAuth::singleton()->checkAuthorization(scSections::SECTION_STORE_OWNER);

	class scCompanyView extends scView {
		protected $_templates = array(
			self::TEMPLATE_ID_EDIT => 'admin/company/company_edit.tmpl'
		);
		
		protected $_dataFields = array(
       		array(
				'field' => 'scWebFormWidgetTextML',
				'data' => scSettings::SETTING_COMPANY_NAME
        		),
       		array(
				'field' => 'scWebFormWidgetTextML',
				'data' => scSettings::SETTING_COMPANY_ADDRESS
        		),
       		array(
				'field' => 'scWebFormWidgetTextML',
				'data' => scSettings::SETTING_COMPANY_ADDRESS2
        		),
       		array(
				'field' => 'scWebFormWidgetTextML',
				'data' => scSettings::SETTING_COMPANY_CITY
        		),
       		array(
				'field' => 'scStateSelectWidget',
				'data' => scSettings::SETTING_COMPANY_STATE,
				'properties' => array('id' => 'CompanyState', 'originalValueField' => 'OriginalCompanyState')
        		),
       		array(
				'field' => 'miSelectWidget',
				'data' => scSettings::SETTING_COMPANY_COUNTRY,
				'properties' => array('id' => 'CompanyCountry')
        		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_COMPANY_ZIP
        		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_COMPANY_PHONE
        		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_COMPANY_PHONE2
        		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_COMPANY_FAX
        		),
        );
        
        protected $_domainObjectDisplayName = 'Store owner';	// _t('Store owner');
		
		public function initWebForm(&$form)
		{
			parent::initWebForm($form);
			
			// Set Countries
			$field = $form->getWidget(scSettings::SETTING_COMPANY_COUNTRY);
			$field->setOptions(array(0 => '') + scCountry::getCountryNames());
			
			// Set States
			$field = $form->getWidget(scSettings::SETTING_COMPANY_STATE);
			$field->setOptions(array(0 => '') + scCountry::getStateNames());
		}
	}

	miSetParam('', 0);
	
	$company = new scSqlRecordsetML('Settings', 'SettingsID');
	$table = new miTable($company);
	
	$view = new scCompanyView();
	$view->setRecord(new scPropertiesRecordML('Settings', 'SettingName', 'SettingValue', array_keys(scMultiLanguage::getActiveLanguageCodes())));
	$view->setTable($table);
	$view->addMainPageElements(array(
		'%%STATES_JS_DATA%%' => scUIUtil::getStatesJsData(),
	));
	
	$page = new scAdminDisplayController(array($view));

	$page->getDispatcher()->clearActionHandlers();
	$page->getDispatcher()->setActionHandler('', 'miEditAction');
	$page->getDispatcher()->setActionHandler('dmExecEdit', 'miExecEditAction');

	$page->dispatchAndShow();
?>