<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('../include/miphpf/Init.php');
	require_once('../include/sc/Init.php');
	
	scAdminAuth::singleton()->checkAuthorization(scSections::SECTION_GENERAL_OPTIONS);

	class scGeneralOptionsView extends scView {
		protected $_templates = array(
			self::TEMPLATE_ID_EDIT => 'admin/general_options/general_options_edit.tmpl'
		);
		
		protected $_dataFields = array(
       		array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_PRODUCT_LARGE_IMAGE_MAX_WIDTH,
				'validator' => array('scValidatorInt', 'scValidatorMinValue', 'scValidatorMaxValue'),
				'properties' => array(
								'minValue' => 5,
								'maxValue' => 1600,
								),
        		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_PRODUCT_LARGE_IMAGE_MAX_HEIGHT,
 				'validator' => array('scValidatorInt', 'scValidatorMinValue', 'scValidatorMaxValue'),
				'properties' => array(
								'minValue' => 5,
								'maxValue' => 1600,
								),
        		),
			array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_PRODUCT_IMAGE_MAX_WIDTH,
				'validator' => array('scValidatorInt', 'scValidatorMinValue', 'scValidatorMaxValue'),
				'properties' => array(
								'minValue' => 5,
								'maxValue' => 1600,
								),
        		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_PRODUCT_IMAGE_MAX_HEIGHT,
 				'validator' => array('scValidatorInt', 'scValidatorMinValue', 'scValidatorMaxValue'),
				'properties' => array(
								'minValue' => 5,
								'maxValue' => 1600,
								),
        		),
			array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_PRODUCT_IMAGE_THUMB_MAX_WIDTH,
				'validator' => array('scValidatorInt', 'scValidatorMinValue', 'scValidatorMaxValue'),
				'properties' => array(
								'minValue' => 5,
								'maxValue' => 500,
								),
        		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_PRODUCT_IMAGE_THUMB_MAX_HEIGHT,
 				'validator' => array('scValidatorInt', 'scValidatorMinValue', 'scValidatorMaxValue'),
				'properties' => array(
								'minValue' => 5,
								'maxValue' => 500,
								),
        		),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_PRODUCT_BOX_IMAGE_MAX_WIDTH,
				'validator' => array('scValidatorInt', 'scValidatorMinValue', 'scValidatorMaxValue'),
				'properties' => array(
								'minValue' => 5,
								'maxValue' => 500,
								),
        		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_PRODUCT_BOX_IMAGE_MAX_HEIGHT,
 				'validator' => array('scValidatorInt', 'scValidatorMinValue', 'scValidatorMaxValue'),
				'properties' => array(
								'minValue' => 5,
								'maxValue' => 500,
								),
        		),
        	array(
        		'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_GALLERY_ITEM_IMAGE_MAX_WIDTH,
				'validator' => array('scValidatorInt', 'scValidatorMinValue', 'scValidatorMaxValue'),
				'properties' => array(
								'minValue' => 5,
								'maxValue' => 1600,
								),
        		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_GALLERY_ITEM_IMAGE_MAX_HEIGHT,
 				'validator' => array('scValidatorInt', 'scValidatorMinValue', 'scValidatorMaxValue'),
				'properties' => array(
								'minValue' => 5,
								'maxValue' => 1600,
								),
        		),
			array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_GALLERY_ITEM_IMAGE_THUMB_MAX_WIDTH,
				'validator' => array('scValidatorInt', 'scValidatorMinValue', 'scValidatorMaxValue'),
				'properties' => array(
								'minValue' => 5,
								'maxValue' => 1000,
								),
        		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_GALLERY_ITEM_IMAGE_THUMB_MAX_HEIGHT,
 				'validator' => array('scValidatorInt', 'scValidatorMinValue', 'scValidatorMaxValue'),
				'properties' => array(
								'minValue' => 5,
								'maxValue' => 1000,
								),
        		),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_GALLERY_SHOW_TABLE_X,
 				'validator' => array('scValidatorInt', 'scValidatorMinValue', 'scValidatorMaxValue'),
				'properties' => array(
								'minValue' => 2,
								'maxValue' => 50,
								),
        		),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_GALLERY_SHOW_TABLE_Y,
 				'validator' => array('scValidatorInt', 'scValidatorMinValue', 'scValidatorMaxValue'),
				'properties' => array(
								'minValue' => 2,
								'maxValue' => 1000,
								),
        		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_MANUFACTURER_IMAGE_MAX_WIDTH,
				'validator' => array('scValidatorInt', 'scValidatorMinValue', 'scValidatorMaxValue'),
				'properties' => array(
								'minValue' => 5,
								'maxValue' => 500,
								),
        		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_MANUFACTURER_IMAGE_MAX_HEIGHT,
 				'validator' => array('scValidatorInt', 'scValidatorMinValue', 'scValidatorMaxValue'),
				'properties' => array(
								'minValue' => 5,
								'maxValue' => 500,
								),
        		),
        	array(
				'field' => 'miSelectWidget',
				'data' => scSettings::SETTING_DEFAULT_CATEGORY_VIEW_TYPE,
        		),
        	array(
				'field' => 'miSelectWidget',
				'data' => scSettings::SETTING_HOMEPAGE_VIEW_TYPE,
        		),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_CATEGORY_IMAGE_MAX_WIDTH,
 				'validator' => array('scValidatorInt', 'scValidatorMinValue', 'scValidatorMaxValue'),
				'properties' => array(
								'minValue' => 5,
								'maxValue' => 500,
								),
        		),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_CATEGORY_IMAGE_MAX_HEIGHT,
 				'validator' => array('scValidatorInt', 'scValidatorMinValue', 'scValidatorMaxValue'),
				'properties' => array(
								'minValue' => 5,
								'maxValue' => 500,
								),
        		),
        	array(
				'field' => 'miSelectWidget',
				'data' => scSettings::SETTING_DEFAULT_PRODUCT_ORDER,
        		),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_GRID_VIEW_COLUMNS,
 				'validator' => array('scValidatorInt', 'scValidatorMinValue'),
				'properties' => array(
								'minValue' => 1,
								),
        		),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_GRID_VIEW_ROWS,
 				'validator' => array('scValidatorInt', 'scValidatorMinValue'),
				'properties' => array(
								'minValue' => 1,
								),
        		),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_LIST_VIEW_PRODUCTS_PER_PAGE,
 				'validator' => array('scValidatorInt', 'scValidatorMinValue'),
				'properties' => array(
								'minValue' => 1,
								),
        		),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_CURRENCY_RATE_EXPIRE_DAYS,
 				'validator' => array('scValidatorInt', 'scValidatorMinValue'),
				'properties' => array(
								'minValue' => 1,
								),
        		),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_NEW_PRODUCTS_DAYS,
 				'validator' => array('scValidatorInt', 'scValidatorMinValue'),
				'properties' => array(
								'minValue' => 1,
								),
        		),
        	array(
				'field' => 'miCheckboxWidget',
				'data' => scSettings::SETTING_CAPTCHA_ON_REGISTER,
        		),
        	array(
				'field' => 'miCheckboxWidget',
				'data' => scSettings::SETTING_CAPTCHA_ON_REGISTER_IN_CHECKOUT,
        		),
        	array(
				'field' => 'miCheckboxWidget',
				'data' => scSettings::SETTING_SHOW_UNFINISHED_ORDERS,
        		),
        	array(
				'field' => 'miCheckboxWidget',
				'data' => scSettings::SETTING_INVENTORY_TRACKING,
        		),
        	array(
				'field' => 'miSelectWidget',
				'data' => scSettings::SETTING_OUT_OF_STOCK_HANDLING,
        		),
       		array(
				'field' => 'miCheckboxWidget',
				'data' => scSettings::SETTING_NEW_PRODUCTS_INFRONT_OF_CATEGORY_LISTING,
        		),
       		array(
				'field' => 'miCheckboxWidget',
				'data' => scSettings::SETTING_WHOLESALE_PRICES,
        		),
        	array(
				'field' => 'miSelectWidget',
				'data' => scSettings::SETTING_DISPLAY_PRICES_TAX_MODE,
        		),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_DOWNLOAD_TTL_DAYS,
 				'validator' => array('scValidatorInt', 'scValidatorMinValue'),
				'properties' => array(
								'minValue' => 1,
								),
        		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_DOWNLOAD_TTL_DOWNLOADS,
 				'validator' => array('scValidatorInt', 'scValidatorMinValue'),
				'properties' => array(
								'minValue' => 1,
								),
        		),
       		array(
				'field' => 'miCheckboxWidget',
				'data' => scSettings::SETTING_AUTO_UNLOCK_EGOODS,
        		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => scSettings::SETTING_PRODUCT_COMPARISON_MAX_PRODUCTS,
 				'validator' => array('scValidatorInt', 'scValidatorMinValue'),
				'properties' => array(
								'minValue' => 1,
								),
        		),
        	array(
        		'field' => 'miSelectWidget',
        		'data' => scSettings::SETTING_USERS_ABLE_TO_RATE,
        		),
        	array(
        		'field' => 'miSelectWidget',
        		'data' => scSettings::SETTING_USERS_ABLE_TO_REVIEW,
        	),
        	array(	
        		'field' => 'miSelectWidget',
        		'data' => scSettings::SETTING_RATING_ACTIONS_AUTOMATIC_APPROVAL,
        	),
        	
        	array(
        		'field' => 'miBaseTextWidget',
        		'data' => scSettings::SETTING_BONUS_POINTS_PURCHASE_EARN,
        		'validator' => array('scValidatorInt'),
        	),
        	array(
        		'field' => 'miBaseTextWidget',
        		'data' => scSettings::SETTING_BONUS_POINTS_PURCHASE_LIMIT,
        		'validator' => array('scValidatorInt'),
        	),
        	array(
        		'field' => 'miSelectWidget',
        		'data' => scSettings::SETTING_BONUS_POINTS_PURCHASE_LIMIT_PERIOD,
        	),
        	array(
        		'field' => 'scOrderStatusesCheckboxes',
        		'data' => scSettings::SETTING_BONUS_POINTS_ORDER_STATUSES,
        	),
        	
        	array(
        		'field' => 'miBaseTextWidget',
        		'data' => scSettings::SETTING_BONUS_POINTS_REFERRAL_EARN,
        		'validator' => array('scValidatorInt'),
        	),
        	array(
        		'field' => 'miBaseTextWidget',
        		'data' => scSettings::SETTING_BONUS_POINTS_REFERRAL_LIMIT,
        		'validator' => array('scValidatorInt'),
        	),
        	array(
        		'field' => 'miSelectWidget',
        		'data' => scSettings::SETTING_BONUS_POINTS_REFERRAL_LIMIT_PERIOD,
        	),
        	array(
        		'field' => 'miBaseTextWidget',
        		'data' => scSettings::SETTING_BONUS_POINTS_REFERRAL_COOKIE_LIFE_IN_DAYS,
        		'validator' => array('scValidatorNotZeroInt'),
        	),
        	
        	array(
        		'field' => 'miBaseTextWidget',
        		'data' => scSettings::SETTING_BONUS_POINTS_REVIEW_EARN,
        		'validator' => array('scValidatorInt'),
        	),
        	array(
        		'field' => 'miBaseTextWidget',
        		'data' => scSettings::SETTING_BONUS_POINTS_REVIEW_LIMIT,
        		'validator' => array('scValidatorInt'),
        	),
        	array(
        		'field' => 'miSelectWidget',
        		'data' => scSettings::SETTING_BONUS_POINTS_REVIEW_LIMIT_PERIOD,
        	),
        	
        	array(
        		'field' => 'miBaseTextWidget',
        		'data' => scSettings::SETTING_BONUS_POINTS_VOTE_EARN,
        		'validator' => array('scValidatorInt'),
        	),
        	array(
        		'field' => 'miBaseTextWidget',
        		'data' => scSettings::SETTING_BONUS_POINTS_VOTE_LIMIT,
        		'validator' => array('scValidatorInt'),
        	),
        	array(
        		'field' => 'miSelectWidget',
        		'data' => scSettings::SETTING_BONUS_POINTS_VOTE_LIMIT_PERIOD,
        	),
        	
        	array(
        		'field' => 'miBaseTextWidget',
        		'data' => scSettings::SETTING_BONUS_POINTS_SPEND_AMOUNT,
        		'validator' => array('scValidatorDecimal'),
        	),
        	array(
        		'field' => 'miBaseTextWidget',
        		'data' => scSettings::SETTING_BONUS_POINTS_SPEND_EARN,
        		'validator' => array('scValidatorInt'),
        	),
        	
        	array(
        		'field' => 'miBaseTextWidget',
        		'data' => scSettings::SETTING_BONUS_POINTS_CONVERSION_RATE,
        		'validator' => array('scValidatorDecimal', 'scValidatorNoEmpty'),
        		'properties' => array(
					'maxDecimals' => 4,
					),
        	),
        	array(
        		'field' => 'miCheckboxWidget',
        		'data' => scSettings::SETTING_BONUS_POINTS_MANUAL_APPROVAL,
        	),
        	array(
        		'field' => 'miCheckboxWidget',
        		'data' => scSettings::SETTING_BONUS_POINTS_MANUAL_SPENDING,
        	),
        	array(
        		'field' => 'miSelectWidget',
        		'data' => scSettings::SETTING_BONUS_POINTS_PRODUCTS_DEFAULT_MODE,
        	),
        );
        
        protected $_domainObjectDisplayName = 'General options';	// _t('General options');
		
		public function initWebForm(&$form)
		{
			parent::initWebForm($form);
			
			$widget = $form->getWidget(scSettings::SETTING_HOMEPAGE_VIEW_TYPE);
			$widget->setOptions(scProductService::getViewTypes());
			
			$widget = $form->getWidget(scSettings::SETTING_DEFAULT_CATEGORY_VIEW_TYPE);
			$widget->setOptions(scProductService::getViewTypes());
			
			$widget = $form->getWidget(scSettings::SETTING_DEFAULT_PRODUCT_ORDER);
			$widget->setOptions(scProductSortService::getSortOptionsArray());
			
			$widget = $form->getWidget(scSettings::SETTING_OUT_OF_STOCK_HANDLING);
			$widget->setOptions(scProductService::getOutOfStockHandlings());
			
			$widget = $form->getWidget(scSettings::SETTING_DISPLAY_PRICES_TAX_MODE);
			$widget->setOptions(scTax::getDisplayPricesTaxModes());
			
			$widget = $form->getWidget(scSettings::SETTING_USERS_ABLE_TO_RATE);
			$widget->setOptions(scRatingActionsSettings::getAllowRateOptions());
			
			$widget = $form->getWidget(scSettings::SETTING_USERS_ABLE_TO_REVIEW);
			$widget->setOptions(scRatingActionsSettings::getAllowReviewOptions());
			
			$widget = $form->getWidget(scSettings::SETTING_RATING_ACTIONS_AUTOMATIC_APPROVAL);
			$widget->setOptions(scRatingActionsSettings::getAutomaticApprovalOptions());
			
			$widget = $form->getWidget(scSettings::SETTING_BONUS_POINTS_PURCHASE_LIMIT_PERIOD);
			$widget->setOptions(scBonusPoints::getAllLimitPeriods());
			
			$widget = $form->getWidget(scSettings::SETTING_BONUS_POINTS_REFERRAL_LIMIT_PERIOD);
			$widget->setOptions(scBonusPoints::getAllLimitPeriods());
			
			$widget = $form->getWidget(scSettings::SETTING_BONUS_POINTS_REVIEW_LIMIT_PERIOD);
			$widget->setOptions(scBonusPoints::getAllLimitPeriods());
			
			$widget = $form->getWidget(scSettings::SETTING_BONUS_POINTS_VOTE_LIMIT_PERIOD);
			$widget->setOptions(scBonusPoints::getAllLimitPeriods());
			
			$widget = $form->getWidget(scSettings::SETTING_BONUS_POINTS_ORDER_STATUSES);
			$widget->setRadioButtons(scOrderStatuses::singleton()->getOrderStatuses());
			
			$widget = $form->getWidget(scSettings::SETTING_BONUS_POINTS_PRODUCTS_DEFAULT_MODE);
			$widget->setOptions(scBonusPoints::getAllProductCustomerPointModes(), scBonusPoints::PRODUCT_MONEY_ONLY);
			
			// Handle currency
			list($currencySymbolLeft, $currencySymbolRight) = scCurrencyUtil::getBaseCurrencySymbols();
			$this->addMainPageElements(array('%%CURRENCYSYMBOLLEFT%%' => miI18N::htmlEscape($currencySymbolLeft), '%%CURRENCYSYMBOLRIGHT%%' => miI18N::htmlEscape($currencySymbolRight)));
		}
		
		public function postProcess($actionObj, $actionResult)
		{
			parent::postProcess($actionObj, $actionResult);
			
			if ($actionResult === false)
				return;
			
			if (($actionObj instanceof miExecEditAction)) {
				// change in OUT_OF_STOCK_HANDLING setting may affect category count cache, so rebuild
				scCategories::updateProductCounts();
			}
		}
	}
	
	class scSaveAndRegenerateAction extends miExecEditAction {
		
		/**
		 * @param array $viewMapperControllerResult
		 * @return true
		 */
		protected function onSuccess($viewMapperControllerResult = null)
		{
			$loc = 'regenerate_images.php';
			$cmd = new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_REDIRECT, $loc);
			$this->_view->addControllerCommand($cmd);
			return true;
		}
	}
	
	class scOrderStatusesCheckboxes extends scMultipleCheckboxesWidget {
		
		protected function getValue()
		{
			$value = $this->_webForm->getFormData($this->_fieldName);
			$value = explode(',', $value);
			if (!is_array($value)) {
				return array();
			}
			return $value;
		}
		
		public function getData()
		{
			$data = parent::getData();
			$data[$this->_fieldName] = implode(',', $data[$this->_fieldName]);
			return $data;
		}
	}
	
	class scValidatorNotZeroInt extends scValidatorInt {
		
		protected $_regEx = '#^[1-9][0-9]*$#';
	}

	miSetParam('', 0);
	
	$company = new miSqlRecordset('Settings');
	$table = new miTable($company);
	
	$view = new scGeneralOptionsView();
	$view->setRecord(new miPropertiesRecord('Settings', 'SettingName', 'SettingValue'));
	$view->setTable($table);
	
	$page = new scAdminDisplayController(array($view));
	
	$page->getDispatcher()->clearActionHandlers();
	$page->getDispatcher()->setActionHandler('', 'miEditAction');
	$page->getDispatcher()->setActionHandler('dmExecEdit', 'miExecEditAction');
	$page->getDispatcher()->setActionHandler('dmSaveAndRegenerate', 'scSaveAndRegenerateAction');
				
	$page->dispatchAndShow();
?>