<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('../include/miphpf/Init.php');
	require_once('../include/sc/Init.php');
	
	scAdminAuth::singleton()->checkAuthorization(scSections::SECTION_HELPS);

	class scHelpsView extends scView {
		protected $_templates = array(
			self::TEMPLATE_ID_LIST => 'admin/helps/help_mgmt.tmpl',
			self::TEMPLATE_ID_EDIT => 'admin/helps/help_edit.tmpl',
			self::TEMPLATE_ID_CREATE => 'admin/helps/help_create.tmpl'
		);
		
		protected $_dataFields = array(
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'HelpID'
        		),
       		array(
				'field' => 'miTextWidget',
				'data' => 'HelpPage',
				'displayName' => 'Page'
        		),
       		array(
				'field' => 'miTextWidget',
				'data' => 'HelpPageAction',
				'displayName' => 'Action'
        		),
			array(
				'field' => 'scWebFormWidgetTextAreaML',
				'data' => 'HelpText',
				'displayName' => 'Text'
        		),
        );
        
        protected $_domainObjectDisplayName = 'Help';	// _t('Help');
        
        protected $_defaultFilterValues = array(
        	'Helps_HelpID' => '',
        );
        	
		public function initTable($table)
		{
			parent::initTable($table);
			
			new scTableRecordsPerPage($table, $this->getTablePagerObj());
		}
		
		public function initWebForm(&$form)
		{
			parent::initWebForm($form);
			
			$form->addMainPageElements(array(
				'%%CKEDITOR_CONTENTCSS%%' => scSkins::singleton()->getCurrentSkin()->getCssFilesForWysiwygEditor(),
				'%%CKEDITOR_LANGUAGE%%' => scCMS::getCkEditorLanguage()
			));
		}
	}
	
	$helps = new scSqlRecordsetML('Helps', 'HelpID');
	$helps->setSelectFields(array('Helps.*', 'Helps.HelpID as Helps_HelpID', 'HelpsML.HelpText'));
	$helps->setHavingFilterNames(array('Helps_HelpID'));
	$table = new scTable($helps);
	
	$view = new scHelpsView();
	$view->setRecord(new scSqlRecordML('Helps', 'HelpID',
		array('HelpText'), array_keys(scMultiLanguage::getActiveLanguageCodes())));
	$view->setTable($table);
	
	$page = new scAdminDisplayController(array($view));
	$page->getDispatcher()->setActionHandler('dmPrint', 'scPrintAction');
	$page->getDispatcher()->setActionHandler('dmExport', 'scExportCSVAction');
	
	$page->dispatchAndShow();
?>