<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('../include/miphpf/Init.php');
	require_once('../include/sc/Init.php');
	
	scAdminAuth::singleton()->checkAuthorization();
	
	class scInstallCheckView extends miView {
		const NUM_LAST_ORDERS = 5;
		
		public function getControllerCommands()
		{
			$t = new scTemplateParser();
			$t->readTemplate('admin/installcheck.tmpl');
			$breadcrumb = new scBreadcrumb();
			$t->assign('%%HTML_BREADCRUMB%%', $breadcrumb->getCurrentBreadcrumbHtml());
			$this->assignMessages($t);
			$html = $t->templateParse();
			
			return array(new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_HTML, $html));
		}
		
		protected function assignMessages($t)
		{
			$messages = array();
			scInstallChecks::checkSystemRequirements($messages);
			scInstallChecks::checkLicense($messages);
			scInstallChecks::checkDirectoryPermissions($messages);
			
			if (count($messages))
				$section = new miTemplateParserSectionInfo('messages', count($messages), array('%%MSG%%' => $messages));
			else
				$section = new miTemplateParserSectionInfo('ok', 1);
			$t->addSectionInfo($section);
		}
	}
	
	$page = new scAdminDisplayController(new scInstallCheckView);
	$page->showPage();
?>