<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('../include/miphpf/Init.php');
	require_once('../include/sc/Init.php');
	
	scAdminAuth::singleton()->checkAuthorization();
	
	scSkins::singleton()->setLayout(scLayout::AREA_ADMIN);
	
	class scAdministratorLicenseView extends miView {
	}

	class scLicenseInfoView extends miAction {
		function doAction() {
			$t = new scTemplateParser();
			$t->readTemplate('admin/license/license.tmpl');

			$breadcrumb = new scBreadcrumb();
			$t->assign('%%HTML_BREADCRUMB%%', $breadcrumb->getCurrentBreadcrumbHtml());
			$t->assignArray(scLicense::getProperties());
			
			$html = $t->templateParse();
			$this->_view->addControllerCommand(new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_HTML, $html));
		}
	}
	
	class scLicenseEULAView extends miAction {
		function doAction()
		{
			$eula = file_get_contents(dirname(__FILE__) . '/../docs/licenses/LICENSE.txt');
			
			$t = new scTemplateParser();
			$t->readTemplate('admin/license/eula.tmpl');
			$t->assign('%%EULA%%', miI18N::htmlEscape($eula));
			$html = $t->templateParse();
			
			$this->_view->addControllerCommand(new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_HTML, $html));
		}
	}
	
	if (miGetParamDefault('action', '') == 'EULA')
		$page = new miPage(new scAdministratorLicenseView);
	else
		$page = new scAdminDisplayController(new scAdministratorLicenseView);
	$page->getDispatcher()->clearActionHandlers();
	$page->getDispatcher()->setActionHandler('', 'scLicenseInfoView');
	$page->getDispatcher()->setActionHandler('EULA', 'scLicenseEULAView');
	
	$page->dispatchAndShow();
?>