<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('../include/miphpf/Init.php');
	require_once('../include/sc/Init.php');
	
	scAdminAuth::singleton()->checkAuthorization(scSections::SECTION_LOCALIZATION);

	class scLocalizationView extends scView {
		protected $_templates = array(
			self::TEMPLATE_ID_EDIT => 'admin/localization/localization_edit.tmpl'
		);
		
		protected $_dataFields = array(
       		array(
				'field' => 'miBaseSelectWidget',
				'data' => scSettings::SETTING_LOCALIZATION_WEIGHT_UNIT
        		),
        );
        
        protected $_domainObjectDisplayName = 'Localization';	// _t('Localization');
		
		public function initWebForm(&$form)
		{
			parent::initWebForm($form);
			
			// Set options WeightUnit
			$field = $form->getWidget(scSettings::SETTING_LOCALIZATION_WEIGHT_UNIT);
			$field->setOptions(scWeightUnits::getWeightUnits());
		}
	}

	miSetParam('', 0);
	
	$localization = new miSqlRecordset('Settings');
	$table = new miTable($localization);
	
	$view = new scLocalizationView();
	$view->setRecord(new miPropertiesRecord('Settings', 'SettingName', 'SettingValue'));
	$view->setTable($table);
	
	$page = new scAdminDisplayController(array($view));
	
	$page->getDispatcher()->clearActionHandlers();
	$page->getDispatcher()->setActionHandler('', 'miEditAction');
	$page->getDispatcher()->setActionHandler('dmExecEdit', 'miExecEditAction');
	
	$page->dispatchAndShow();
?>