<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('../include/miphpf/Init.php');
	require_once('../include/sc/Init.php');
	
	scAdminAuth::singleton()->checkAuthorization(scSections::SECTION_LOGS);

	class scLogView extends scView {
			
		protected $_templates = array(
			self::TEMPLATE_ID_LIST => 'admin/log/log_mgmt.tmpl'
		);
		
		protected $_dataFields = array(
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'LogMessage'
        	),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'LogAdministratorUsername',
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'LogCustomerEmail',
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'LogCategory',
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'LogSeverity',
        	)
        );
        
        protected $_domainObjectDisplayName = 'Application log';	// _t('Application log');

		public function initTable($table)
		{
			parent::initTable($table);
			
			new scTableRecordsPerPage($table, $this->getTablePagerObj());
			
			$log = scLog::singleton();
			scUIUtil::createDropdownFilter($this, $table, 'LogCategory', array('' => _t('All categories')) + $log->getAllCategoryTexts(), '=', '');
			scUIUtil::createDropdownFilter($this, $table, 'LogSeverity', array('' => _t('All severities')) + $log->getAllSeverityTexts(), '=', '');
		}
	}
	
	class scLogTable extends scTable {
		public function addUiElements(&$rows)
		{
			scDateTime::setTimezone();
			
			foreach ($rows as &$row) {
				$row['LogSeverity'] = scLog::singleton()->getSeverityText($row['LogSeverity']);
				$row['LogCategory'] = scLog::singleton()->getCategoryText($row['LogCategory']);
				$row['LogTimestamp'] = scDateTime::getLocalFormattedTimestamp($row['LogTimestamp']);
			}
		}
	}
	
	if (!miHasParam('sortBy')) {
		miSetParam('sortBy', 'LogTimestamp');
		miSetParam('sortDir', 'DESC');
	}
	
	$logs = new miSqlRecordset('Logs');
	$table = new scLogTable($logs);
	
	$view = new scLogView();
	$view->setTable($table);
	
	$page = new scAdminDisplayController(array($view));
	$page->dispatchAndShow();
?>