<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('../include/miphpf/Init.php');
	require_once('../include/sc/Init.php');
	
	scSkins::singleton()->setLayout(scLayout::AREA_ADMIN);
	
	class scAdministratorLogin {
		public function showLoginPage($username, $password, $msg)
		{
			$t = new scTemplateParser();
			$t->readTemplate('admin/login.tmpl');
			$t->assign('%%REFERER%%', miI18N::htmlEscape(miGetParamDefault('Referer', '')));
			$t->assign('%%USERNAME%%', miI18N::htmlEscape($username));
			$t->assign('%%PASSWORD%%', miI18N::htmlEscape($password));
			
			$t->assign('%%LANGUAGES_SELECTION%%', scMultiLanguage::singleton()->getUILanguageSelectionHtml());
			if ($msg)
				$t->assign('%%MSG%%', '<div id="message" style="margin: 10px auto;">' . miI18N::htmlEscape($msg) . '</div>');
			else
				$t->assign('%%MSG%%', miI18N::htmlEscape($msg));
			$t->templateShow();
		}
	}
	
	$username = miGetParamDefault('Username', '');
	$password = miGetParamDefault('Password', '');
	$msg = miGetParamDefault('msg', '');
	
	$login = new scAdministratorLogin();
	if ($username == '') {
		if ((miGetParamDefault('Submit', '') != '') and ($msg == ''))
			$msg = _t('Please enter username and password!');
		$login->showLoginPage($username, $password,  $msg);
		exit;
	}
	
	try {
		$user = new miSqlRecord('Administrators', 'AdministratorUsername');
		$user->readPK($username);
		
		$auth = scAdminAuth::singleton();
		if (!$auth->isCorrectPassword($user, $username, $password)) {
			$login->showLoginPage($username, $password,	_t('Invalid username and/or password. Please try again.'));
			exit;
		}
		if ($user->get('AdministratorAccessLevel') == scAdminAuth::ADMINISTRATOR_ACCESS_LEVEL_DISABLED) {
			$login->showLoginPage($username, $password, _t('Your account has been disabled.'));
			exit;
		}
		
	} catch (miDBException $exception) {
		if ($exception->getCode() == miDBException::EXCEPTION_RECORD_NOT_FOUND) {
			$login->showLoginPage($username, $password,	_t('Invalid username and/or password. Please try again.'));
			exit;
		}
		throw $exception;
	}
	
	# Create new session
	$auth = scAdminAuth::singleton();
	$auth->logIn($user->get('AdministratorID'));
	
	$location = miGetParamDefault('Referer', '');
	if (empty($location))
		$location = 'index.php';
	
	$lang = 'UILanguage=' . miGetParamDefault('UILanguage', '');
	$location = scUrlUtil::addQueryParams($location, $lang);
	
	header('Location: ' . $location);
?>