<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('../include/miphpf/Init.php');
	require_once('../include/sc/Init.php');
	
	scAdminAuth::singleton()->checkAuthorization(scSections::SECTION_ORDERS);
	scDateTime::setTimezone();
	
	class scOrdersView extends scView {
		
		const TEMPLATE_ID_INVOICE = 'invoice';
		const TEMPLATE_ID_TRANSACTIONS = 'transactions';
		const TEMPLATE_ID_EGOODS = 'egoods';
		
		protected $_templates = array(
			self::TEMPLATE_ID_LIST => 'admin/orders/order_mgmt.tmpl',
			self::TEMPLATE_ID_EDIT => 'admin/orders/order_edit.tmpl',
			
			self::TEMPLATE_ID_INVOICE => 'admin/orders/order_invoice.tmpl',
			self::TEMPLATE_ID_TRANSACTIONS => 'admin/orders/order_transactions.tmpl',
			self::TEMPLATE_ID_EGOODS => 'admin/orders/order_egoods.tmpl',
		);
        
		protected $_dataFields = array(
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderID'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderTimestamp'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderIPAddress'
        	),
        	array(
				'field' => 'miBaseSelectWidget',
				'data' => 'OrderStatus'
        	),
        	array(
				'field' => 'scPaymentStatusWidget',
				'data' => 'OrderPaymentStatus'
        	),
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderCustomerInstructions'
        	),
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderCustomerEmail'
        	),
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'CustomerID'
        	),
			
			// Shipping related
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingMethodCode'	// Contains internal shipping method code of the shipping module   
        	),
			array(
				'field' => 'miTextWidget',
				'data' => 'OrderShippingTrackingNo'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingModuleName'
        	),
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingMethodName'
        	),
			
			// Payment related
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'PaymentModuleID'
        	),
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderPaymentModuleName'
        	),
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderPaymentModuleIntegration'
        	),
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderPaymentNotes'
        	),
			array(
				'field' => 'miTextWidget',
				'data' => 'OrderPaymentTransactionNo'
        	),
			
			// Checkout module info
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'CheckoutModuleID'
        	),
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderCheckoutModuleName'
        	),
			
			// Billing info
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderBillingFirstName'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderBillingLastName'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderBillingCompany'
        	),
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderBillingPhone'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderBillingFax'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderBillingAddress1'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderBillingAddress2'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderBillingCity'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderBillingState'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderBillingStateCode'
        	),
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderBillingCountry'
        	),
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderBillingCountryCode2'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderBillingZip'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderBillingVatNumber'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShipToBillingAddress'
        	),
			
			// Shipping info
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingFirstName'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingLastName'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingCompany'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingPhone'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingFax'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingAddress1'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingAddress2'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingCity'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingState'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingStateCode'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingCountry'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingCountryCode2'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingZip'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingVatNumber'
        	),
			
			// Order totals
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderTotal'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderCurrencyCode'
        	),
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderTotalPayAmount'
        	),
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderTotalPayCurrencyCode'
        	)
        );
        
        protected $_domainObjectDisplayName = 'Order';	// _t('Order');
        
		/**
		 * @return scOrder
		 */
        protected function createDomainObject()
		{
			return new scOrder();
		}

		public function addRedirectToEgoodsControllerCommand($msg = '', $msgType = miMessage::MSG_TYPE_INFO)
		{
			$params = array(
				'action=dmShowEgoods',
				'OrderID='. miGetParam('OrderID'),
				$this->getRedirectParams($msg, $msgType)
			);
			$this->addRedirectControllerCommand($params);
		}
		
		public function addRedirectToEditControllerCommand($msg = '', $msgType = miMessage::MSG_TYPE_INFO)
		{
			$params = array(
				'action=dmEdit',
				'OrderID='. miGetParam('OrderID'),
				$this->getRedirectParams($msg, $msgType)
			);
			$this->addRedirectControllerCommand($params);
		}
        
		/**
		 * @param scOrdersTable $table
		 */
		public function initTable($table)
		{
			parent::initTable($table);
			
			// Check for the customer order history filter and override the period filter
			if (miHasParam('CustomerID')) {
				miSetParam('CustomerIDFilter', miGetParam('CustomerID'));
				$orderTimestampFilter[scSqlFilterDatePeriod::PARAM_PERIOD_TYPE] = scSqlFilterDatePeriod::PERIOD_TYPE_CUSTOM;
				$orderTimestampFilter[scSqlFilterDatePeriod::PARAM_PREDEFINED_PERIOD] = scSqlFilterDatePeriod::DATE_PERIODS_ALL_TIME;
				$orderTimestampFilter[scSqlFilterDatePeriod::PARAM_DATE_FROM] = '01/01/1995';
				$orderTimestampFilter[scSqlFilterDatePeriod::PARAM_DATE_TO] = date('d/m/Y');
				miSetParam('OrderTimestampFilter', implode(',', $orderTimestampFilter));
			}
			
			new scTableRecordsPerPage($table, $this->getTablePagerObj());
			
			scUIUtil::createDatePeriodFilter($this, $table, 'OrderTimestamp', 'date');
			$this->getTableFilterObj()->setConditionHandler('date', 'scSqlFilterOrderDatePeriod');
			
			// Set Status Filter. Default is all, excepting unfinished
			$defaultStatuses = scOrderStatuses::singleton()->getOrderStatuses();
			$showUnfinishedOrders = scSettings::getSettingValue(scSettings::SETTING_SHOW_UNFINISHED_ORDERS);
			if (empty($showUnfinishedOrders))
				unset($defaultStatuses[scOrderStatus::ORDER_STATUS_UNFINISHED]);
			$orderStatus = miGetParamDefault('OrderStatus', array_keys($defaultStatuses));
			miSetParam('OrderStatusFilter', implode(',', $orderStatus));
			
			scUIUtil::createCheckboxFilter($this, $table, 'OrderStatus', scOrderStatuses::singleton()->getAllOrderStatuses(), 'status');
			$this->getTableFilterObj()->setConditionHandler('status', 'scSqlFilterOrderCheckbox');
			
			$this->getTableFilterObj()->setConditionHandler('email', 'scSqlFilterOrderCustomerEmail');
			$this->getTableFilterObj()->setConditionHandler('customer', 'scSqlFilterOrderCustomerId');
		}
		
		/**
		 * @param miWebForm $form
		 */
		public function initWebForm(&$form)
		{
			parent::initWebForm($form);
			
			$widget = $form->getWidget('OrderStatus');
			$widget->setOptions(scOrderStatuses::singleton()->getOrderStatuses());
			
			// If there are customer instructions - display them
			if ($this->getDomainObject()->get('OrderCustomerInstructions') != '')
				$form->addTemplateSectionInfo(new miTemplateParserSectionInfo('customerInstructions'));
			
			// Same for payment notes
			if ($this->getDomainObject()->get('OrderPaymentNotes') != '')
				$form->addTemplateSectionInfo(new miTemplateParserSectionInfo('paymentNotes'));
			
			// Check if there is any difference between the order currency and total and the actually paid currency and total
			if (($this->getDomainObject()->get('OrderCurrencyCode') != $this->getDomainObject()->get('OrderTotalPayCurrencyCode')) or
				($this->getDomainObject()->get('OrderTotal') != $this->getDomainObject()->get('OrderTotalPayAmount'))) {
				$form->addTemplateSectionInfo(new miTemplateParserSectionInfo('multicurrency'));
			}
			
			if ($this->getDomainObject()->hasPerItemDiscount())
				$form->addTemplateSectionInfo(new miTemplateParserSectionInfo('orderHasPerItemDiscount', 1));
			
			if ($this->getDomainObject()->get('OrderPaymentModuleIntegration') != '')
				$form->addTemplateSectionInfo(new miTemplateParserSectionInfo('paymentModuleIntegrationMethod'));
			
			// Handle Credit Card and Check Payment info
			$this->addCreditCardInfoSection($form);
			$this->addCheckInfoSection($form);
			
			// manage the print packing slip button behavior
			$orderId = $this->getDomainObject()->get('OrderID');
			$shippingLabelModule = scShippingLabelUtil::getShippingLabelModuleImplementation($orderId);
			if ($shippingLabelModule->getPrintActionOpenType($orderId) == IShippingLabelModule::OPEN_TYPE_BLANK) {
				$targetBlank = 'target="_blank"';
				$colorboxClass = '';
			} else {
				$targetBlank = '';
				$colorboxClass = 'colorbox';
			}
			
			$form->addMainPageElements(array(
				'%%PRINT_PACKING_SLIP_TARGET%%' => $targetBlank,
				'%%PRINT_PACKING_SLIP_COLORBOX_CLASS%%' => $colorboxClass,
			));
		}
		
		protected function addCreditCardInfoSection($form)
		{
			$paymentCreditCard = new scPaymentCreditCard($this->getDomainObject()->get($this->getDomainObject()->getPKName()));
			if ($paymentCreditCard->isForUpdate()) {
				$row = $paymentCreditCard->getRow();
				$avsStatuses = scPaymentAVS::getPaymentAVSStatuses();
				$row['PaymentCreditCardAVSStatus'] = $avsStatuses[$row['PaymentCreditCardAVSStatus']];
				
				$cvnStatuses = scPaymentCVN::getPaymentCVNStatuses();
				$row['PaymentCreditCardCVNStatus'] = $cvnStatuses[$row['PaymentCreditCardCVNStatus']];
				
				$form->addTemplateSectionInfo(new miTemplateParserSectionInfo('creditCardInfo', 1, miUIUtil::templetizeAndEscapeRows($row)));
			}
		}
		
		protected function addCheckInfoSection($form)
		{
			$paymentCheck = new scPaymentCheck($this->getDomainObject()->get($this->getDomainObject()->getPKName()));
			if (!$paymentCheck->isForUpdate())
				return;
			
			// Check account type
			$checkAccountTypes = scPaymentForms::getCheckAccountTypes();
			$paymentCheck->set('FMT_PAYMENTCHECKACCOUNTTYPE', $checkAccountTypes[$paymentCheck->get('PaymentCheckAccountType')]);
			
			// Routing number name (ABA Routing Code / Sort Code)
			$paymentCheck->set('ROUTING_NUMBER_NAME', scPaymentForms::getRoutingNumberName($paymentCheck->get('PaymentCheckType')));
			
			// Check type - UK Checks, US Checks
			$checkTypes = scPaymentForms::getCheckTypes();
			$paymentCheck->set('FMT_PAYMENTCHECKTYPE', $checkTypes[$paymentCheck->get('PaymentCheckType')]);
			
			$form->addTemplateSectionInfo(new miTemplateParserSectionInfo('checkInfo', 1, miUIUtil::templetizeAndEscapeRows($paymentCheck->getRow())));
		}
	}

	/**
	 * Delete records in the table
	 */
	class scOrderExecDeleteAction extends miListAction {
		public function doAction()
		{
			try {
				$domainObject = $this->_view->getDomainObject();
				
				$orderIds = miGetParamDefault('OrderIDs', array());
				$orders = array();
				if (!empty($orderIds)) {
					$orders = new miSqlRecordset('Orders');
					$orders->addFilter(new miSqlFilterIn('OrderID', $orderIds));
					$orders = $orders->getAllRecords();
				}
				
				foreach ($orders as $orderData) {
					$domainObject->setRow($orderData);
					
					$this->_view->callPlugin($this, 'preDelete');
					$domainObject->delete();
					$this->_view->callPlugin($this, 'postDelete');
				}
				
				miSetParam(miMessage::PARAM_MESSAGE, _t('Selected order deleted successfully!'));
				miSetParam(miMessage::PARAM_MESSAGE_TYPE, miMessage::MSG_TYPE_INFO);
			} catch (miException $exception) {
				miSetParam(miMessage::PARAM_MESSAGE, $this->_view->getMessage('MI_RECORD_DELETE_FAILED_MSG'));
				miSetParam(miMessage::PARAM_MESSAGE_TYPE, miMessage::MSG_TYPE_ERROR);
			}
			return parent::doAction();
		}
	}
	
	/**
	 * Update order status in the table
	 */
	class scOrderExecUpdateStatusAction extends miListAction {
		public function doAction()
		{
			try {
				$recordsStatus = miGetParamDefault('status', array());
				
				$orderIds = array_keys($recordsStatus);
				
				$recordset = new miSqlRecordset('Orders');
				$recordset->addFilter(new miSqlFilterIn('OrderID', $orderIds));
				$orders = $recordset->getAllRecords();
				$orders = miUtil::getArrayWithKeys($orders, 'OrderID');
				
				foreach ($recordsStatus as $orderId => $status) {
					$order = new scOrder();
					if (!isset($orders[$orderId])) {
						throw new miException(sprintf(_i('Order "%s" not found.'), $orderId));
					}
					
					$order->setRow($orders[$orderId]);
					$order->updateOrderStatus($status);
				}
				
				miSetParam(miMessage::PARAM_MESSAGE, sprintf(_t('Order statuses updated successfully!'), implode(',', array_keys($recordsStatus))));
				miSetParam(miMessage::PARAM_MESSAGE_TYPE, miMessage::MSG_TYPE_INFO);
			} catch (miException $exception) {
				miSetParam(miMessage::PARAM_MESSAGE, $this->_view->getMessage('MI_RECORD_UPDATE_FAILED_MSG'));
				miSetParam(miMessage::PARAM_MESSAGE_TYPE, miMessage::MSG_TYPE_ERROR);
			}
			return parent::doAction();
		}
	}
	
	/**
	 * Show the page for updating a record in the database
	 */
	class scOrderEditAction extends miActionWithWebForm {
		public function doAction()
		{
			try {
				$model = $this->_view->getViewMapperController();
				$model->read();
				
				$this->_view->callPlugin($this, 'preShowForm');
				
				$form = $this->getWebForm();
				$this->prepareWebForm();
				
				$model->setDataToWebForm();
				$this->showForm($form, $this->_view->getTemplateFileName(miDefaultView::TEMPLATE_ID_EDIT), true);
				return true;
			} catch (miException $exception) {
				$msg = $this->_view->getMessage('MI_RECORD_EDIT_FAILED_MSG');
				$this->_view->addRedirectToListControllerCommand($msg . $exception->getMessage(), miMessage::MSG_TYPE_ERROR);
				return false;
			}
		}
		
		protected function prepareWebForm()
		{
			$form = $this->getWebForm();
			
			$domainObject = $this->_view->getDomainObject();
			$orderId = $domainObject->get($domainObject->getPKName());
			scOrdersCache::fullLoadOrderData($orderId);
			
			// Get the order information
			$order = $domainObject->getRow();
			
			$currency = $domainObject->getBaseCurrency();
			
			$templateVars = scAdminOrdersUI::singleton()->getOrderInfoVars($domainObject);
			$form->addMainPageElements(miUIUtil::templetizeRows($templateVars));
			
			$productsSection = scAdminOrdersUI::singleton()->getOrderItemsSection($domainObject, scOrdersUI::ORDER_ITEMS_WITH_IMAGES, $domainObject->getEgoods());
			$form->addTemplateSectionInfo($productsSection);
			
			if ($domainObject->hasEgoods()) {
				$form->addTemplateSectionInfo(new miTemplateParserSectionInfo('orderHasEgoods', 1));
			}
			
			$linesSection = scAdminOrdersUI::singleton()->getOrderTotalLinesSection($domainObject);
			$form->addTemplateSectionInfo($linesSection);
			
			$notesSection = $this->getOrderNotesSection($orderId);
			$form->addTemplateSectionInfo($notesSection);
			
			$operationsSection = $this->getOrderOperationsSection($domainObject);
			$form->addTemplateSectionInfo($operationsSection);
		}
		
		protected function getOrderNotesSection($orderId)
		{
			// Get the order notes
			$recordset = new miSqlRecordset('OrderNotes');
			$recordset->addFilter(new miSqlFilterEqual('OrderID', $orderId));
			
			$notes = $recordset->getRecords();
			foreach ($notes as &$note) {
				$note['OrderNoteCreationTimestamp'] = scDateTime::getLocalFormattedTimestamp($note['OrderNoteCreationTimestamp']);
				$note['OrderNoteSendToCustomer'] = (intval($note['OrderNoteSendToCustomer']) == 0) ? _t('No') : _t('Yes');
			}
			if (count($notes) > 0)
				$notesSection = new miTemplateParserSectionInfo('notes', count($notes), miUIUtil::templetizeRows(miUIUtil::transposeRows($notes)));
			else
				$notesSection = new miTemplateParserSectionInfo('nonotes');
			return $notesSection;
		}
		
		protected function getOrderOperationsSection($order)
		{
			$moduleId = $order->getModuleIdForPayment();
			try {
				$objects = scModulesFactory::getImplementation($moduleId, 'IPaymentModuleOperations');
			} catch (miException $exception) {
				// Ignore exception, and don't show any operation buttons
				return new miTemplateParserSectionInfo('operations', 0);
			}
			$definitions = $objects->getPaymentOperationDefinitions($order);
			
			$buttons = array();
			foreach ($definitions as $definition) {
				$displayName = $definition->getOperationDisplayName();
				if ($displayName == '')
					continue;
				
				$buttons[] = array(
					'BUTTON_LABEL' => $displayName,
					'OPERATION_CODE' => $definition->getOperationCode(),
				);
			}
			
			$operationsSection = new miTemplateParserSectionInfo('operations', count($buttons), miUIUtil::templetizeRows(miUIUtil::transposeRows($buttons)));
			return $operationsSection;
		}
	}
	
	/**
	 * Takes the values from the user input and update a record in the database
	 */
	class scOrderExecEditAction extends scOrderEditAction {
		public function doAction()
		{
			try {
				$model = $this->_view->getViewMapperController();
				$model->read();
				
				$form = $this->getWebForm();
				$isOk = $form->processSubmit();
				
				$dataForm = $form->getSubmittedDataRow();
				
				// Update only order status, shipping tracking no and payment transaction no
				$model->getDomainObject()->set('OrderShippingTrackingNo', $dataForm['OrderShippingTrackingNo']);
				$model->getDomainObject()->set('OrderPaymentTransactionNo', $dataForm['OrderPaymentTransactionNo']);
				$model->getDomainObject()->setOrderStatus($dataForm['OrderStatus']);
				
				if ($isOk === false) {
					$model->updateSubmittedForm($form);
					// Call miEditAction
					parent::doAction();
					return false;
				}
				
				$this->_view->callPlugin($this, 'preUpdate');
				$recordId = $model->update();
				$this->_view->callPlugin($this, 'postUpdate');
				
			} catch (miException $exception) {
				$msg = $this->_view->getMessage('MI_RECORD_UPDATE_FAILED_MSG');
				$this->_view->addRedirectToEditControllerCommand($msg . $exception->getMessage(), miMessage::MSG_TYPE_ERROR);
				return false;
			}
			$msg = sprintf($this->_view->getMessage('MI_RECORD_UPDATED_SUCCESSFULLY_MSG'), $recordId);
			$this->_view->addRedirectToEditControllerCommand($msg, miMessage::MSG_TYPE_INFO);
			return true;
		}
	}
	
	class scOrderPrintAction extends scOrderEditAction {
		protected function printOrder($templateFile)
		{
			$orderIds = trim(miGetParam('OrderID'));
			if (!is_array($orderIds)) {
				$orderIds = array($orderIds);
			}
			if (empty($orderIds)) {
				throw new miException(_t('Order not found.'));
			}
			
			$orders = array();
			$productsSection = array();
			$linesSection = array();
			$vatNumberSection = array();
			$perItemDiscountSection = array();
			$ordersUiObject = scAdminOrdersUI::singleton();
			foreach ($orderIds as $orderId) {
				scOrdersCache::fullLoadOrderData($orderId);
				$order = scOrdersCache::getOrder($orderId);
				$currency = $order->getBaseCurrency();
				
				$templateVars = $ordersUiObject->getOrderInfoVars($order, $currency);
				
				$productsSection[] = $ordersUiObject->getOrderItemsSection($order, scOrdersUI::ORDER_ITEMS_WITHOUT_IMAGES, scOrder::getOrderEgoods($orderId));
	
				$linesSection[] = $ordersUiObject->getOrderTotalLinesSection($order, $currency);
				$perItemDiscountSection[] = new miTemplateParserSectionInfo('orderHasPerItemDiscount', (int)$order->hasPerItemDiscount());
				
				$vatNumberSection[] = new miTemplateParserSectionInfo('billingVatNumber', $order->get('OrderBillingVatNumber') ? 1 : 0);
				
				$orders[] = array_merge($order->getRow(), $templateVars);
			}
			
			// Set section orders
			$ordersSection = new miTemplateParserSectionInfo();
			$ordersSection->setSectionInfo('orders', count($orders), miUIUtil::templetizeRows(miUIUtil::transposeRows($orders)));
			$ordersSection->addSubsectionsArray('products', $productsSection);
			$ordersSection->addSubsectionsArray('lines', $linesSection);
			$ordersSection->addSubsectionsArray('orderHasPerItemDiscount', $perItemDiscountSection);
			$ordersSection->addSubsectionsArray('billingVatNumber', $vatNumberSection);
			
			$template = new scTemplateParser();
			
			// Get the store owner info
			$countryId = scSettings::getSettingValue(scSettings::SETTING_COMPANY_COUNTRY);
			$countryName = ($countryId ? scCountry::getCountryName($countryId) : '');
			
			$stateId = scSettings::getSettingValue(scSettings::SETTING_COMPANY_STATE);
			$stateName = ($stateId ? ', ' . scCountry::getStateName($stateId) : '');
			$template->assignArray(array(
				'%%COMPANYNAME%%' => scSettings::getSettingValue(scSettings::SETTING_COMPANY_NAME),
				'%%COMPANYADDRESS%%' => scSettings::getSettingValue(scSettings::SETTING_COMPANY_ADDRESS),
				'%%COMPANYADDRESS2%%' => scSettings::getSettingValue(scSettings::SETTING_COMPANY_ADDRESS2),
				'%%COMPANYCITY%%' => scSettings::getSettingValue(scSettings::SETTING_COMPANY_CITY),
				'%%COMPANYSTATENAME%%' => $stateName,
				'%%COMPANYCOUNTRYNAME%%' => $countryName,
				'%%COMPANYZIP%%' => scSettings::getSettingValue(scSettings::SETTING_COMPANY_ZIP),
				'%%COMPANYPHONE%%' => scSettings::getSettingValue(scSettings::SETTING_COMPANY_PHONE),
				'%%COMPANYPHONE2%%' => scSettings::getSettingValue(scSettings::SETTING_COMPANY_PHONE2),
				'%%COMPANYFAX%%' => scSettings::getSettingValue(scSettings::SETTING_COMPANY_FAX),
				'%%HTTP_HOST%%' => scPaths::getHttpHost(),
				'%%ORDERID%%' => $orderId
			));
			// Show page
			$template->setSectionInfos(array($ordersSection));
			$template->readTemplate($templateFile);
			$template->templateShow();
		}
	}
	
	/**
	 * Print invoice(s) for one or more orders
	 */
	class scOrderPrintInvoiceAction extends scOrderPrintAction {
		
		public function doAction()
		{
			$this->printOrder($this->_view->getTemplateFileName(scOrdersView::TEMPLATE_ID_INVOICE));
			exit;
		}
	}
	
	class scPrintSinglePackingSlipAction extends miAction {
		
		public function doAction()
		{
			try {
				$orderId = (int)miGetParam('OrderID');
				$shippingLabelModule = scShippingLabelUtil::getShippingLabelModuleImplementation($orderId);
				$shippingLabelModule->handlePrintAction($orderId);
			} catch (miException $e) {
				$msg = sprintf(_t('Error occured: %s'), $e->getMessage());
				$url = 'orders.php?action=dmEdit&OrderID=' . $orderId . '&msgType=' . miMessage::MSG_TYPE_ERROR . '&msg=' . urlencode($msg);
				if ($shippingLabelModule->getPrintActionOpenType($orderId) == IShippingLabelModule::OPEN_TYPE_INLINE) {
					echo '<script type="text/javascript">top.location.href="' . $url . '";</script>';
					die;
				}
				$command = new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_REDIRECT, $url); 
				$this->_view->addControllerCommand($command);
			}
		}
	}
	
	class scOrderPrintPackingSlipsAction extends scOrderPrintAction {
		public function doAction()
		{
			$html = '';
			$orderIds = explode(',', miGetParam('OrderID'));
			try {
				foreach ($orderIds as $orderId) {
					
					// Get shipping label implementation
					$shippingLabelModule = scShippingLabelUtil::getShippingLabelModuleImplementation($orderId);
					$shippingLabel = $shippingLabelModule->getShippingLabel($orderId);
					
					// Create cache if none exists for that order
					if (!scShippingLabelCache::checkCacheExists($shippingLabel->getCacheFileName($orderId))) {
						$content = $shippingLabel->getContent($orderId);
					}
					
					// Handle different types of shipping labels
					
					if ($shippingLabel instanceof scShippingLabelImage) {
						$path = scPaths::getUrl(scPaths::getFilenamePath($shippingLabel->getCacheFileName($orderId), scPaths::RESOURCE_SHIPPING_LABEL_CACHE_FILE, scPaths::PATH_WEB));
						// FIXME Should this be in a template file?
						$html .= '<div style="page-break-after: always;" class="invoice-wrapper"><img src="' . $path . '" /></div>';
					}
					
					if ($shippingLabel instanceof scShippingLabelHtml) {
						if (isset($content)) {
							$html .= $content;
						} else {
							$fileName = $shippingLabel->getCacheFileName($orderId);
							$html .= scShippingLabelCache::getCachedContent($fileName);
						}
					}
					
					if ($shippingLabel instanceof scShippingLabelPdf) {
						throw new miException(_t('You can not bulk print PDF packing slips.'));
					}
				}
				
				// Init the template parser
				$template = new scTemplateParser();
				
				// Assign template variables
				$template->assign('%%COMPANYNAME%%', scSettings::getSettingValue(scSettings::SETTING_COMPANY_NAME));
				$template->assign('%%HTML_CONTENT%%', $html);
				
				// Show page
				$template->readTemplate(scDefaultShippingLabelModule::PRINTING_FRAME_TEMPLATE);
				$template->templateShow();
				die;
			
			} catch (miException $e) {
				$msg = sprintf(_t('Error occured: %s'), $e->getMessage());
				$url = 'orders.php?msgType=' . miMessage::MSG_TYPE_ERROR . '&msg=' . urlencode($msg);
				$command = new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_REDIRECT, $url); 
				$this->_view->addControllerCommand($command);
			}
		}
	}
	
	class scOrderAddNoteAction extends miAction {
		public function doAction()
		{
			try {
				$note = trim(miGetParam('OrderNoteText'));
				
				if (strlen($note) < 3) {
					$this->_view->addRedirectToEditControllerCommand(_t('Note too short.'), miMessage::MSG_TYPE_ERROR);
					return true;
				}
				
				$orderId = miGetParam('OrderID');
				$sendToCustomer = miGetParamDefault('OrderNoteSendToCustomer', 0) ? 1 : 0;
				
				// Check the email
				$order = new miSqlRecord('Orders', 'OrderID');
				$order->readPK($orderId);
				
				// Insert the note in the database
				$record = new miSqlRecord('OrderNotes', 'OrderNoteID');
				$record->set('OrderID', $orderId);
				$record->set('OrderNoteSendToCustomer', $sendToCustomer);
				$record->set('OrderNoteText', $note);
				$record->set('OrderNoteCreationTimestamp', time());
				
				$record->insert();
				
				// Send email notifications
				$notifications = new scEmailNotifications;
				if (!$notifications->sendOrderNote($note, $orderId, (bool) $sendToCustomer)) {
					$this->_view->addRedirectToEditControllerCommand(_t('Note added successfully, but problem occurred when sending the note email.'), miMessage::MSG_TYPE_WARNING);
					return true;
				}
				
				if (($order->get('OrderCustomerEmail') == '') and $sendToCustomer) {
					$this->_view->addRedirectToEditControllerCommand(_t('Note added successfully, but there is no customer email.'), miMessage::MSG_TYPE_WARNING);
					return true;
				}
				
				if (trim(scSettings::getSettingValue(scSettings::SETTING_EMAIL_ORDER_DEPARTMENT)) == '')
					$this->_view->addRedirectToEditControllerCommand(_t('Note added successfully, but the order department email is not set.'), miMessage::MSG_TYPE_WARNING);
				else
					$this->_view->addRedirectToEditControllerCommand(_t('Note added successfully.'), miMessage::MSG_TYPE_INFO);
				
				return true;
			} catch (miException $exception) {
				$this->_view->addRedirectToEditControllerCommand(_t('Error occurred while adding the note.'), miMessage::MSG_TYPE_ERROR);
				return false;
			}
		}
	}
	
	class scOrderDeleteNoteAction extends miAction {
		public function doAction()
		{
			try {
				$noteId = miGetParam('OrderNoteID');
				
				$record = new miSqlRecord('OrderNotes', 'OrderNoteID');
				$record->set('OrderNoteID', $noteId);
				$record->delete();
				
				$this->_view->addRedirectToEditControllerCommand(_t('Note deleted successfully.'), miMessage::MSG_TYPE_INFO);
				
			}
			catch (miException $exception)
			{
				$this->_view->addRedirectToEditControllerCommand($exception->getMessage(), miMessage::MSG_TYPE_ERROR);
			}
			
			return true;
		}
	}
	
	/**
	 * Discards the credit card info
	 * Leaves only the last 4 digits of the card
	 */
	class scDiscardCardInfoAction extends miAction {
		public function doAction()
		{
			try {
				$orderId = miGetParam('OrderID');
				
				$paymentCreditCard = new scPaymentCreditCard($orderId);
				if ($paymentCreditCard->isForUpdate()) {
					$number = $paymentCreditCard->get('PaymentCreditCardNumber');
					
					if (strlen($number) > 3) {
						$number = str_repeat('*', strlen($number) - 4) . substr($number, -4);
						$paymentCreditCard->set('PaymentCreditCardNumber', $number);
					}
					$paymentCreditCard->set('PaymentCreditCardCVN', '');
					$paymentCreditCard->update();
				}
				
				$this->_view->addRedirectToEditControllerCommand(_t('Credit card number and CVV discarded successfully.'), miMessage::MSG_TYPE_INFO);
				return true;
			} catch (miException $exception) {
				$this->_view->addRedirectToEditControllerCommand($exception->getMessage(), miMessage::MSG_TYPE_ERROR);
				return false;
			}
		}
	}
	
	/**
	 * Print all transactions associated with an order
	 *
	 */
	class scViewOrderTransactionsAction extends miAction {
		public function doAction()
		{
			$orderId = miGetParam('OrderID');
			$transactionsRs = new miSqlRecordset('Transactions');
			$transactionsRs->addFilter(new miSqlFilterEqual('OrderID', $orderId));
			$transactions = $transactionsRs->getAllRecords();
			
			$paymentStatuses = scPaymentStatus::getPaymentStatuses();
			foreach ($transactions as &$transaction) {
				$transaction['TransactionTimestamp'] = scDateTime::getLocalFormattedTimestamp($transaction['TransactionTimestamp']);
				$transaction['TransactionPaymentStatus'] = $paymentStatuses[$transaction['TransactionPaymentStatus']];
			}
			unset($transaction); // Remove the reference so that the foreach below will work
			
			$transactionsSection = new miTemplateParserSectionInfo();
			if (count($transactions)) {
				
				// Transaction details
				$transactionDetailsSections = array();
				foreach ($transactions as $key => $transaction) {
					
					$transactionDetailsRs = new miSqlRecordset('TransactionDetails');
					$transactionDetailsRs->addFilter(new miSqlFilterEqual('TransactionID', $transaction['TransactionID']));
					$transactionDetails = $transactionDetailsRs->getAllRecords();
					
					$transactionDetailsSection = new miTemplateParserSectionInfo('transactionDetails');
					$transactionDetailsSection->setIterationsCount(count($transactionDetails) ? 1 : 0);
					
					$detailsValuesSection = new miTemplateParserSectionInfo('transactionDetailValues', count($transactionDetails), miUIUtil::templetizeRows(miUIUtil::transposeRows($transactionDetails)));
					$transactionDetailsSection->addSubsection($detailsValuesSection);
					$transactionDetailsSections[] = $transactionDetailsSection;
				}
				$transactionsSection->addSubsectionsArray('transactionDetails', $transactionDetailsSections);
				
				$transactionsSection->setSectionInfo('transactions', count($transactions), miUIUtil::templetizeRows(miUIUtil::transposeRows($transactions)));
			} else
				$transactionsSection->setSectionInfo('notransactions', 1);
				
			$this->_view->initMainPageElements();
			
			$t = new scTemplateParser();
			$t->readTemplate($this->_view->getTemplateFileName(scOrdersView::TEMPLATE_ID_TRANSACTIONS));
			$t->setSectionInfos(array($transactionsSection));
			$t->assign('%%ORDERID%%', miI18N::htmlEscape($orderId));
			miTable::escapeAndAssignArray($t, $this->_view->getMainPageElements());
			
			$cmd = new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_HTML, $t->templateParse());
			$this->_view->addControllerCommand($cmd);
		}
	}
	
	class scShowEgoodsAction extends miAction {
		
		public function doAction()
		{
			try {
				$orderId = (int)miGetParam('OrderID');
				
				$domainObject = $this->_view->getDomainObject();
				$domainObject->read($orderId);
				$egoods = $domainObject->getEgoods();
				
				$currency = $domainObject->getBaseCurrency();
				$orderItemsSection = scAdminOrdersUI::singleton()->getOrderItemsSection($domainObject, scOrdersUI::ORDER_ITEMS_WITH_IMAGES, $egoods, scOrdersUI::ORDER_ITEMS_EGOODS_REQUIRED);
				$this->_view->initMainPageElements();
				
				$t = new scTemplateParser();
				$t->setSectionInfos(array($orderItemsSection));
				$t->readTemplate($this->_view->getTemplateFileName(scOrdersView::TEMPLATE_ID_EGOODS));
				$t->assign('%%ORDERID%%', miI18N::htmlEscape($orderId));
				miTable::escapeAndAssignArray($t, $this->_view->getMainPageElements());
			} catch (miException $exception) {
				$this->_view->addRedirectToEditControllerCommand(_t('Unable to display the e-goods.'), miMessage::MSG_TYPE_ERROR);
				return false;
			}
			$cmd = new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_HTML, $t->templateParse());
			$this->_view->addControllerCommand($cmd);
			return true;
		}
	}
	
	class scSendEgoodsAction extends miAction {
		
		public function doAction()
		{
			try {
				$orderId = (int)miGetParam('OrderID');
				
				$notifications = new scEmailNotifications();
				if (!$notifications->sendOrderEgoods($orderId)) {
					throw new miException(_t('Unable to send e-goods notification e-mail.'));
				}
				
				$note = _t('E-Goods notification email sent successfully.');
				// Insert the note in the database
				$record = new miSqlRecord('OrderNotes', 'OrderNoteID');
				$record->set('OrderID', $orderId);
				$record->set('OrderNoteSendToCustomer', false);
				$record->set('OrderNoteText', $note);
				$record->set('OrderNoteCreationTimestamp', time());
				$record->insert();
			} catch (miException $exception) {
				$msg = sprintf(_t('Error occurred while sending e-goods notification email: "%s".'), $exception->getMessage());
				$this->_view->addRedirectToEditControllerCommand($msg, miMessage::MSG_TYPE_ERROR);
				return false;
			}
			$this->_view->addRedirectToEditControllerCommand(_t('E-Goods notification email sent successfully.'), miMessage::MSG_TYPE_INFO);
			return true;
		}
	}
	
	class scLockEgoodAction extends miAction {
		
		public function doAction()
		{
			try {
				$egoodId = (int)miGetParam('OrderItemEgoodID');
				
				$domainObject = new scOrderItemEgood($egoodId);
				$domainObject->set('OrderItemEgoodIsLocked', $this->getNewStatus());
				$domainObject->update();
			} catch (miException $e) {
				$this->_view->addRedirectToEgoodsControllerCommand($e->getMessage(), miMessage::MSG_TYPE_ERROR);
				return false;
			}
			$this->_view->addRedirectToEgoodsControllerCommand(_t('E-Good status successfully updated.'), miMessage::MSG_TYPE_INFO);
			return true;
		}
		
		protected function getNewStatus()
		{
			return scOrderItemEgood::ORDER_ITEM_EGOOD_LOCKED;
		}
	}
	
	class scUnlockEgoodAction extends scLockEgoodAction {
		
		protected function getNewStatus()
		{
			return scOrderItemEgood::ORDER_ITEM_EGOOD_UNLOCKED;
		}
	}
	
	/**
	 * Handle all payment operations
	 */
	class scPaymentOperationsAction extends miAction {
		public function doAction()
		{
			$operationCode = miGetParam('OperationCode');
			$orderId = (int)miGetParam('OrderID');
			
			$order = new scOrder($orderId);
			$moduleId = $order->getModuleIdForPayment();
			if (!$moduleId) {
				$this->_view->addRedirectToEditControllerCommand(_t('Cannot find payment module.'), miMessage::MSG_TYPE_ERROR);
				return false;
			}
			
			$this->_view->initMainPageElements();
			
			$objects = scModulesFactory::getImplementation($moduleId, 'IPaymentModuleOperations');
			$definitions = $objects->getPaymentOperationDefinitions($order);
			
			foreach ($definitions as $definition) {
				if ($operationCode == $definition->getOperationCode()) {
					$func = $definition->getOperationFunc();
					try {
						call_user_func($func, $order, $this->_view);
						return true;
					} catch (Exception $exception) {
						$this->_view->addRedirectToEditControllerCommand(_t('Exception: ') . $exception->getMessage(), miMessage::MSG_TYPE_ERROR);
						return false;
					}
				}
			}
			
			$this->_view->addRedirectToEditControllerCommand(_t('Unknown operation.'), miMessage::MSG_TYPE_ERROR);
			return false;
		}
	}
	
	/**
	 * Payment status widget
	 *
	 */
	class scPaymentStatusWidget extends miSelectWidget {
		public function getEditableControl()
		{
			$value = $this->_webForm->getFormData($this->_fieldName);
			
			$paymentStatuses = scPaymentStatus::getPaymentStatuses();
			return array($this->_fieldName => miI18N::htmlEscape($paymentStatuses[$value]));
		}
	}
	
	class scSqlFilterOrderCheckbox extends scSqlFilterCheckbox {
		public function getSql()
		{
			if (miGetParamDefault('OrderIDFilter', '') != '')
				return '';
				
			return parent::getSql();
		}
	}
	
	class scSqlFilterOrderDatePeriod extends scSqlFilterDatePeriod {
		public function getSql()
		{
			if (miGetParamDefault('OrderIDFilter', '') != '')
				return '';
			
			return parent::getSql();
		}
	}
	
	class scSqlFilterOrderCustomerEmail extends miSqlFilterSubstring {
		public function getSql()
		{
			if (miGetParamDefault('OrderIDFilter', '') != '')
				return '';
			
			if (miGetParamDefault('CustomerIDFilter', '') != '')
				return '';
			
			return parent::getSql();
		}
	}
	
	class scSqlFilterOrderCustomerId extends miSqlFilterEqual
	{ 
		public function getSql()
		{
			if (miGetParamDefault('OrderIDFilter', '') != '')
				return '';
			
			if ((string)$this->_value == '')
				return '';
			return 'Orders.CustomerID' . $this->_operator . '"' . sql_escape_string($this->_value) . '"';
		}
	}
	
	class scOrderManagementTable extends scOrdersTable {
		
		public function addUiElements(&$rows)
		{
			parent::addUiElements($rows);
			
			$orderStatuses = scOrderStatuses::singleton()->getOrderStatuses();
			foreach ($rows as $key => $row) {
				// Set status
				$rows[$key]['HTML_STATUS'] = ''; 
				foreach ($orderStatuses as $index => $status) {
					$rows[$key]['HTML_STATUS'] .= '<option value="' . $index . '" ' . ($row['OrderStatus'] == $index ? 'selected="selected"' : '') . '>' . $status . '</option>';
				}
				if (!isset($orderStatuses[$row['OrderStatus']])) {
					$rows[$key]['HTML_STATUS'] .= '<option value="' . $row['OrderStatus'] . '" selected="selected">' . scOrderStatuses::singleton()->getOrderStatusName($row['OrderStatus']) . '</option>';
				}
			}
		}

		public function getState()
		{
			$state = parent::getState();
			
			$state['OrderStatusFilter'] = miGetParamDefault('OrderStatusFilter', '');
			$state['OrderStatusCondition'] = 'status';
			$state['OrderTimestampFilter'] = miGetParamDefault('OrderTimestampFilter', '');
			$state['OrderTimestampCondition'] = 'date';
			$state['CustomerIDFilter'] = miGetParamDefault('CustomerIDFilter', '');
			$state['CustomerIDCondition'] = 'customer';
			$state['OrderCustomerEmailFilter'] = miGetParamDefault('OrderCustomerEmailFilter', '');
			$state['OrderCustomerEmailCondition'] = 'substring';
			$state['OrderCustomerNameFilter'] = miGetParamDefault('OrderCustomerNameFilter', '');
			$state['OrderCustomerNameCondition'] = 'substring';

			return $state;
		}
	}
	
	// By default sort by order timestamp
	if (!miHasParam('sortBy')) {
		miSetParam('sortBy', 'OrderTimestamp');
		miSetParam('sortDir', 'DESC');
	}
	
	$orders = new miSqlRecordset('Orders');
	$orders->addJoinCondition('LEFT', 'Customers', 'USING(CustomerID)');
	$orders->setSelectFields(array('*, CONCAT(OrderBillingFirstName, " ", OrderBillingLastName) AS OrderCustomerName'));
	$orders->setHavingFilterNames(array('OrderCustomerName'));
	$table = new scOrderManagementTable($orders);
	
	$view = new scOrdersView();
	$view->setTable($table);
	
	$page = new scAdminDisplayController(array($view));
	$page->getDispatcher()->setActionHandler('dmExecDelete', 'scOrderExecDeleteAction');
	$page->getDispatcher()->setActionHandler('dmExecUpdateStatus', 'scOrderExecUpdateStatusAction');
	$page->getDispatcher()->setActionHandler('dmEdit', 'scOrderEditAction');
	$page->getDispatcher()->setActionHandler('dmExecEdit', 'scOrderExecEditAction');
	$page->getDispatcher()->setActionHandler('acViewOrderTransactions', 'scViewOrderTransactionsAction');
	$page->getDispatcher()->setActionHandler('acPaymentOperation', 'scPaymentOperationsAction');
	$page->getDispatcher()->setActionHandler('dmAddNote', 'scOrderAddNoteAction');
	$page->getDispatcher()->setActionHandler('dmDeleteNote', 'scOrderDeleteNoteAction');
	$page->getDispatcher()->setActionHandler('acDiscardCardInfo', 'scDiscardCardInfoAction');
	$page->getDispatcher()->setActionHandler('dmShowEgoods', 'scShowEgoodsAction');
	$page->getDispatcher()->setActionHandler('dmSendEgoods', 'scSendEgoodsAction');
	$page->getDispatcher()->setActionHandler('dmLockEgood', 'scLockEgoodAction');
	$page->getDispatcher()->setActionHandler('dmUnlockEgood', 'scUnlockEgoodAction');
	$page->getDispatcher()->setActionHandler('dmPrintInvoice', 'scOrderPrintInvoiceAction');
	$page->getDispatcher()->setActionHandler('dmPrintPackingSlips', 'scOrderPrintPackingSlipsAction');
	$page->getDispatcher()->setActionHandler('dmPrintSinglePackingSlip', 'scPrintSinglePackingSlipAction');
	$page->dispatchAndShow();
?>