<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('../include/miphpf/Init.php');
	require_once('../include/sc/Init.php');
	
	scAdminAuth::singleton()->checkAuthorization(scSections::SECTION_MODULES_PAYMENT);

	class scPaymentModulesView extends scView {
		protected $_templates = array(
			self::TEMPLATE_ID_EDIT => 'admin/payment_modules/payment_modules_edit.tmpl',
			self::TEMPLATE_ID_LIST => 'admin/payment_modules/payment_modules_mgmt.tmpl',
		);
		
        protected $_dataFields = array(
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'PaymentModuleID'
        	),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'PaymentModuleName',
				'properties' => array('readOnly' => true)
        	),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'PaymentModuleIntegrationMethod',
				'properties' => array('readOnly' => true)
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'PaymentModuleImage',
        		'properties' => array('readOnly' => true)
        	),
        	array(
				'field' => 'scWebFormWidgetTextML',
				'data' => 'PaymentModuleDisplayName',
        	),
       		array(
				'field' => 'miCheckboxWidget',
				'data' => 'PaymentModuleIsActive'
        	),
       		array(
				'field' => 'scModuleOptionsWidget',
				'data' => 'ModuleOptionFields',
				'modelStrategy' => 'scViewMapperModuleOptions',
			)
        );
		
        protected $_domainObjectDisplayName = 'Payment module';	// _t('Payment module');
        
        public function initWebForm(&$form)
        {
			parent::initWebForm($form);
			
        	$record = $this->getRecord();
			$record->readPK(miGetParam('PaymentModuleID'));
        	$form->getWidget('ModuleOptionFields')->setupModuleOptions($record->get('ModuleID'), 'IPaymentModule');
        	
        	$form->addMainPageElements(array(
				'%%CKEDITOR_CONTENTCSS%%' => scSkins::singleton()->getCurrentSkin()->getCssFilesForWysiwygEditor(),
				'%%CKEDITOR_LANGUAGE%%' => scCMS::getCkEditorLanguage()
			));
        }
        
		public function initTable($table)
		{
			parent::initTable($table);
			
			$this->getTablePagerObj()->setDefaultRecordsPerPage(500);
			new scTableRecordsPerPage($table, $this->getTablePagerObj());
		}
		
		public function preProcess($actionObj)
		{
			if ($this->getController()->getDispatcher()->getAction() == 'dmChangeIsActive')
				$actionObj->setFieldName('PaymentModuleIsActive');
		}
		
		public function initViewMapperController($viewMapperController)
		{
			$viewMapper = $viewMapperController->getViewMapper('scViewMapperModuleOptions');
			$viewMapper->setModule($this->getModule());
		}
		
		protected function getModule()
		{
			$domainObject = $this->getDomainObject();
			$domainObject->read((int)miGetParam('PaymentModuleID'));
			$className = scModulesFactory::getModuleClassName($domainObject->get('ModuleID'), 'IPaymentModule');
			return new $className($domainObject->get('ModuleID'), $domainObject->get('PaymentModuleID'));
		}
	}
	
	$paymentModules = new scSqlRecordsetML('PaymentModules', 'PaymentModuleID');
	
	$table = new scTable($paymentModules);
	
	$view = new scPaymentModulesView();
	$view->setRecord(new scSqlRecordML('PaymentModules', 'PaymentModuleID',
						array('PaymentModuleDisplayName'), array_keys(scMultiLanguage::getActiveLanguageCodes())));
	$view->setUpSortColumn('PaymentModuleSort');
	$view->setTable($table);
	
	$page = new scAdminDisplayController(array($view));
	$page->getDispatcher()->setActionHandler('dmChangeIsActive', 'scExecChangeIsActiveAction');
	$page->dispatchAndShow();
?>