<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('../../include/miphpf/Init.php');
	require_once('../../include/sc/Init.php');
	
	scAdminAuth::singleton()->checkAuthorization(scSections::SECTION_PRODUCTS);
	
	scSkins::singleton()->setLayout(scLayout::AREA_ADMIN);
	
	class scProductSelectAction extends miAction {
		public function doAction()
		{
			$categorySelectWidget = new scCategorySelect(new miWebForm(array()), array());
			$categoriesArray = array('' => _t('Select a Category')) + $categorySelectWidget->getCategoriesTree(0);
			
			$jsCallback = 'productSelected';
			if (miHasParam('JSCallback') && miGetParam('JSCallback') != '') {
				$jsCallback = miGetParam('JSCallback');
			}
			
			$noBundles = '';
			if (miGetParamDefault('noBundles', '') != '') {
				$noBundles = 'noBundles';
			}
			
			$this->_view->addMainPageElements(array(
				'%%CATEGORYID%%' => scUIUtil::getConstDropdown('Category', '', $categoriesArray, array('id' => 'CategoryID')),
				'%%JSCALLBACK%%' => $jsCallback,
				'%%NOBUNDLES%%' => $noBundles,
			));
		}
	}

	class scProductSelectView extends miDefaultView {

		protected $_templates = array(
			self::TEMPLATE_ID_VIEW => 'admin/popup/product_select.tmpl',
		);

		public function getControllerCommands()
		{
			$t = new scTemplateParser();
			$t->readTemplate($this->_templates[self::TEMPLATE_ID_VIEW]);			
			$t->assignArray($this->_mainPageElements);
			$html = $t->templateParse();
			
			return array(new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_HTML, $html));
		}
	}
	
	$view = new scProductSelectView(null);
	
	$page = new miPage(array($view));
	
	$page->getDispatcher()->clearActionHandlers();
	$page->getDispatcher()->setActionHandler('', 'scProductSelectAction');
	
	$page->dispatchAndShow();
?>