<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('../include/miphpf/Init.php');
	require_once('../include/sc/Init.php');
	
	scAdminAuth::singleton()->checkAuthorization(scSections::SECTION_PRODUCT_CLASSES);

	class scProductClassesView extends scView {
		
		protected $_templates = array(
			self::TEMPLATE_ID_LIST => 'admin/product_classes/product_class_mgmt.tmpl',
			self::TEMPLATE_ID_CREATE => 'admin/product_classes/product_class_create.tmpl',
			self::TEMPLATE_ID_EDIT => 'admin/product_classes/product_class_edit.tmpl',
		);
		
		protected $_dataFields = array(
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'ProductClassID',
			),
			array(
				'field' => 'scWebFormWidgetTextML',
				'data' => 'ProductClassName',
				'properties' => array(
					'minLength' => 1,
					'maxLength' => 255,
				),
				'displayName' => 'Name',
			),
			array(
				'field' => 'scProductClassAttributesWidget',
				'data' => 'ProductClassAttributes',
				'modelStrategy' => 'scViewMapperProductClassAttributes',
				'properties' => array(
					'foreignKey' => 'ProductClassID',
					
					'table' => 'ProductClassAttributes',
					'sortField' => 'ProductClassAttributeSort',
					'sortBy' => 'ProductClassAttributeSort',
					'foreignTablePrimaryKey' => 'ProductClassAttributeID',
					
					'valueTable' => 'ProductClassAttributeValues',
					'valueKey' => 'ProductClassAttributeValueID',
					'valueType' => 'ProductClassAttributeType',
					'valueField' => 'ProductClassAttributeValueML',
					'valueSortField' => 'ProductClassAttributeValueSort',
					'valueSortBy' => 'ProductClassAttributeValueSort',
					
					'template' => 'admin/product_classes/product_attributes_rs.tmpl',
					'fields' => array(
			       		array(
							'field' => 'miBaseTextWidget',
							'data' => 'ProductClassAttributeID'
			        	),
			       		array(
							'field' => 'scWebFormWidgetTextML',
							'data' => 'ProductClassAttributeName',
			        	),
			       		array(
							'field' => 'miBaseSelectWidget',
							'data' => 'ProductClassAttributeType',
			        	),
			       		array(
							'field' => 'miBaseSelectWidget',
							'data' => 'ProductClassAttributeValidator',
			        	),
					),
					'mlFields' => array('ProductClassAttributeName'),
				),
			),
		);
        
		protected $_domainObjectDisplayName = 'Product Class';	// _t('Product Class');
		
		public function initWebForm(&$form)
		{
			parent::initWebForm($form);
			
			$this->addMainPageElements(array(
				'%%ITEMSWITHVALUES%%' => miI18N::htmlEscape(implode(',', scProductAttributes::singleton()->getFieldTypesWithValues())),
				'%%PRODUCTCLASSATTRIBUTEVALIDATORS%%' => scJson::jsonEncode(scProductAttributes::singleton()->getAttributeValidators()),
				'%%PRODUCTCLASSATTRIBUTEVALIDATORSBYTYPE%%' => scJson::jsonEncode(scProductAttributes::singleton()->getAttributeValidatorsByType()),
			));
		}
		
		public function initTable($table)
		{
			parent::initTable($table);
			
			new scTableRecordsPerPage($table, $this->getTablePagerObj());
		}
		
		/**
		 * @return scProductClassDomainObject
		 */
		protected function createDomainObject()
		{
			return new scProductClassDomainObject();
		}
	}
	
	class scViewMapperProductClassAttributes extends scViewMapperItemsWithValues {
		
		protected function getTypesWithValues()
		{
			return scProductAttributes::singleton()->getFieldTypesWithValues();
		}
	}
	
	$recordset = new scSqlRecordsetML('ProductClasses', 'ProductClassID');
	$table = new scTable($recordset);
	
	$view = new scProductClassesView();
	$view->setTable($table);
	
	$page = new scAdminDisplayController(array($view));
	$page->getDispatcher()->setActionHandler('dmPrint', 'scPrintAction');
	$page->getDispatcher()->setActionHandler('dmExport', 'scExportCSVAction');
	
	$page->dispatchAndShow();
?>