<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('../include/miphpf/Init.php');
	require_once('../include/sc/Init.php');
	
	scAdminAuth::singleton()->checkAuthorization(scSections::SECTION_QUICK_LINKS);

	class scAdminQuickLinksView extends scView {
		protected $_templates = array(
			self::TEMPLATE_ID_LIST => 'admin/quick_links/quick_link_mgmt.tmpl',
			self::TEMPLATE_ID_EDIT => 'admin/quick_links/quick_link_edit.tmpl',
			self::TEMPLATE_ID_CREATE => 'admin/quick_links/quick_link_create.tmpl'
		);
		
		protected $_dataFields = array(
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'AdminQuickLinkID'
        		),
       		array(
				'field' => 'miTextWidget',
				'data' => 'AdminQuickLinkPage',
				'validator' => 'scValidatorNoEmpty',
				'displayName' => 'Page'
        		),
       		array(
				'field' => 'miTextWidget',
				'data' => 'AdminQuickLinkPageAction',
				'displayName' => 'Action'
        		),
			array(
				'field' => 'scWebFormWidgetTextML',
				'data' => 'AdminQuickLinkText',
				'validator' => 'scValidatorNoEmpty',
				'displayName' => 'Text'
        		),
       		array(
				'field' => 'miTextWidget',
				'data' => 'AdminQuickLinkLocation',
				'validator' => 'scValidatorNoEmpty',
				'displayName' => 'Link Location'
        		),
        );
        
        protected $_domainObjectDisplayName = 'Quick link';	// _t('Quick link');
        
        protected $_defaultFilterValues = array(
        	'AdminQuickLinks_AdminQuickLinkID' => '',
        );
        
        public function initTable($table)
		{
			parent::initTable($table);
			
			new scTableRecordsPerPage($table, $this->getTablePagerObj());
		}
	}
	
	$quickLinks = new scSqlRecordsetML('AdminQuickLinks', 'AdminQuickLinkID');
	$quickLinks->setSelectFields(array('AdminQuickLinks.*', 'AdminQuickLinks.AdminQuickLinkID as AdminQuickLinks_AdminQuickLinkID', 'AdminQuickLinksML.AdminQuickLinkText'));
	$quickLinks->setHavingFilterNames(array('AdminQuickLinks_AdminQuickLinkID'));
	$table = new scTable($quickLinks);
	
	$view = new scAdminQuickLinksView();
	$view->setRecord(new scSqlRecordML('AdminQuickLinks', 'AdminQuickLinkID', array('AdminQuickLinkText'), array_keys(scMultiLanguage::getActiveLanguageCodes())));
	$view->setTable($table);
	
	$page = new scAdminDisplayController(array($view));
	$page->getDispatcher()->setActionHandler('dmPrint', 'scPrintAction');
	$page->getDispatcher()->setActionHandler('dmExport', 'scExportCSVAction');
	$page->dispatchAndShow();
?>