<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('../include/miphpf/Init.php');
	require_once('../include/sc/Init.php');
	
	scAdminAuth::singleton()->checkAuthorization();
	
	$reportToSectionArray = array(
		'ViewsVisits' => scSections::SECTION_REPORT_VIEWS_VISITS,
		'ViewsByProduct' => scSections::SECTION_REPORT_VIEWS_BY_PRODUCT,
		'ViewsByCategory' => scSections::SECTION_REPORT_VIEWS_BY_CATEGORY,
		'SalesByProduct' => scSections::SECTION_REPORT_SALES_BY_PRODUCT,
		'SalesByCategory' => scSections::SECTION_REPORT_SALES_BY_CATEGORY,
		'SalesByCustomer' => scSections::SECTION_REPORT_SALES_BY_CUSTOMER,
		'SalesByCountry' => scSections::SECTION_REPORT_SALES_BY_COUNTRY,
		'CustomerCountries' => scSections::SECTION_REPORT_CUSTOMER_COUNTRIES,
		'AverageOrderAmount' => scSections::SECTION_REPORT_AVERAGE_ORDER_AMOUNT,
		'OrderStatuses' => scSections::SECTION_REPORT_ORDER_STATUSES,
		'OrderPaymentMethods' => scSections::SECTION_REPORT_PAYMENT_METHODS,
		'OrderShippingMethods' => scSections::SECTION_REPORT_SHIPPING_METHODS,
		'OrderTaxes' => scSections::SECTION_REPORT_TAXES,
		'ItemsPerOrder' => scSections::SECTION_REPORT_ORDER_ITEMS,
	);
	
	$report = miGetParamDefault('report', '');
	if (!isset($reportToSectionArray[$report])) {
		header('Location: denied.php?sectionName=' . urlencode(_t('Unknown Report')));
		die;
	}
	scAdminAuth::singleton()->checkAuthorization($reportToSectionArray[$report]);
		
	class scReportGenerate extends miView {
		
		public function getControllerCommands()
		{
			$reportGenerator = new scReportGenerator();
			$reportHtml = $reportGenerator->generate();
			$reportHtml = str_replace('%%HTML_BREADCRUMB%%', $this->getBreadcrumb(), $reportHtml);
			
			return array(new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_HTML, $reportHtml));
		}
		
		protected function getBreadcrumb()
		{
			$report = miGetParam('report');
			$breadcrumb = new scBreadcrumb();
			return $breadcrumb->getBreadcrumbHtml('/admin/report.php');
		}
	}
	
	$home = new scReportGenerate();
	$page = new scAdminDisplayController(array($home));
	$page->showPage();
?>