<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('../include/miphpf/Init.php');
	require_once('../include/sc/Init.php');
	
	scAdminAuth::singleton()->checkAuthorization(scSections::SECTION_SECURITY);

	class scSecurityView extends scView {
		protected $_templates = array(
			self::TEMPLATE_ID_EDIT => 'admin/security/security_edit.tmpl'
		);
		
		protected $_dataFields = array(
       		array(
				'field' => 'miBaseCheckboxWidget',
				'data' => scSettings::SETTING_SSL_ENABLED
        		),
       		array(
				'field' => 'miSelectWidget',
				'data' => scSettings::SETTING_PASSWORD_HASH_MODE
        		),
        );
        
        protected $_domainObjectDisplayName = 'Security';	// _t('Security');
        
		public function initMainPageElements()
		{
			$this->addMainPageElements(array(
				'%%HTTPS_URL%%' => scPaths::getHttpsUrl(),
			));
        	parent::initMainPageElements();
        }
        
		public function initWebForm(&$form)
		{
			parent::initWebForm($form);
			
			$widget = $form->getWidget(scSettings::SETTING_PASSWORD_HASH_MODE);
			$widget->setOptions(scAuth::getHashModes());
		}
	}

	miSetParam('', 0);
	
	$security = new miSqlRecordset('Settings');
	$table = new miTable($security);
	
	$view = new scSecurityView();
	$view->setRecord(new miPropertiesRecord('Settings', 'SettingName', 'SettingValue'));
	$view->setTable($table);
	
	$page = new scAdminDisplayController(array($view));
	
	$page->getDispatcher()->clearActionHandlers();
	$page->getDispatcher()->setActionHandler('', 'miEditAction');
	$page->getDispatcher()->setActionHandler('dmExecEdit', 'miExecEditAction');
	
	$page->dispatchAndShow();
?>