<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('../include/miphpf/Init.php');
	require_once('../include/sc/Init.php');
	
	scAdminAuth::singleton()->checkAuthorization(scSections::SECTION_SEO);

	class scSeoView extends scView {
		protected $_templates = array(
			self::TEMPLATE_ID_EDIT => 'admin/seo/seo_edit.tmpl'
		);
		
		protected $_dataFields = array(
       		array(
				'field' => 'scWebFormWidgetTextML',
				'data' => scSettings::SETTING_SEO_SITE_KEYWORDS
        		),
       		array(
				'field' => 'scWebFormWidgetTextML',
				'data' => scSettings::SETTING_SEO_SITE_DESCRIPTION
        		),
       		array(
				'field' => 'scWebFormWidgetTextML',
				'data' => scSettings::SETTING_SEO_SITE_TITLE
        		),
       		array(
				'field' => 'miCheckboxWidget',
				'data' => scSettings::SETTING_FRIENDLY_URLS,
        		),
       		array(
				'field' => 'miSelectWidget',
				'data' => scSettings::SETTING_SEO_URLS_TYPE,
        		),
		);
        
        protected $_domainObjectDisplayName = 'SEO';	// _t('SEO');
        
        /**
         * @param miWebForm $form
         */
		public function initWebForm(&$form)
		{
			parent::initWebForm($form);
			
			$widget = $form->getWidget(scSettings::SETTING_SEO_URLS_TYPE);
			$widget->setOptions(scSeoUrlTypes::getAllTypes());
		}
	}

	miSetParam('', 0);
	
	$seo = new scSqlRecordsetML('Settings', 'SettingsID');
	$table = new miTable($seo);
	
	$view = new scSeoView();
	$view->setRecord(new scPropertiesRecordML('Settings', 'SettingName', 'SettingValue',
		array_keys(scMultiLanguage::getActiveLanguageCodes())));
	$view->setTable($table);
	
	$page = new scAdminDisplayController(array($view));
	
	$page->getDispatcher()->clearActionHandlers();
	$page->getDispatcher()->setActionHandler('', 'miEditAction');
	$page->getDispatcher()->setActionHandler('dmExecEdit', 'miExecEditAction');
	
	$page->dispatchAndShow();
?>