<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('../include/miphpf/Init.php');
	require_once('../include/sc/Init.php');
	
	scAdminAuth::singleton()->checkAuthorization(scSections::SECTION_TAXES);

	class scTaxClassesView extends scView {
		protected $_templates = array(
			self::TEMPLATE_ID_LIST => 'admin/tax_classes/tax_class_mgmt.tmpl',
			self::TEMPLATE_ID_EDIT => 'admin/tax_classes/tax_class_edit.tmpl',
			self::TEMPLATE_ID_CREATE => 'admin/tax_classes/tax_class_create.tmpl'
		);
		
		protected $_dataFields = array(
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'TaxClassID'
        		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'TaxClassName',
				'validator' => 'scValidatorNoEmpty',
        		),
       		array(
				'field' => 'scWebFormFieldHidden',
				'data' => 'TaxID'
        		),
        );
        
        protected $_domainObjectDisplayName = 'Tax class';	// _t('Tax class');
        
		public function initTable($table)
		{
			parent::initTable($table);
			
			new scTableRecordsPerPage($table, $this->getTablePagerObj());
		}
		
		/**
		 * Redirects the browser to the list of items.
		 */
		public function addRedirectToListControllerCommand($msg, $msgType = miMessage::MSG_TYPE_ERROR)
		{
			$loc = 'taxes.php?action=dmEdit&' . $this->getRedirectParams($msg, $msgType) .
				'&' . 'TaxID=' . urlencode(miGetParamDefault('TaxID', ''));
			
			$cmd = new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_REDIRECT, $loc);
			$this->addControllerCommand($cmd);
		}
		
		public function addAjaxRefreshListControllerCommand($msg, $msgType = miMessage::MSG_TYPE_ERROR)
		{
			$loc = 'taxes.php?load=table&action=dmEdit&' . $this->getRedirectParams($msg, $msgType) .
				'&' . 'TaxID=' . urlencode(miGetParamDefault('TaxID', ''));
			$cmd = new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_REDIRECT, $loc);
			$this->addControllerCommand($cmd);
		}
	}
	
	
	$taxClasses = new miSqlRecordset('TaxClasses');
	$table = new scTable($taxClasses);
	
	$view = new scTaxClassesView();
	$view->setRecord(new miSqlRecord('TaxClasses', 'TaxClassID'));
	$view->setUpSortColumn('TaxClassSort');
	scSortAction::setForeignKeyClause('TaxID=' . intval(miGetParamDefault('TaxID', 0)));
	$view->setTable($table);
	$page = new scAdminDisplayController(array($view));
	$page->dispatchAndShow();
?>