<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('../../../include/miphpf/Init.php');
	require_once('../../../include/sc/Init.php');
	
	require_once(dirname(__FILE__) . '/../../../include/sc/util/soap/SoapWsdl.php');
	require_once(dirname(__FILE__) . '/../../../include/sc/util/soap/Xsd.php');
	require_once(dirname(__FILE__) . '/../../../include/sc/util/soap/Disco.php');
	require_once(dirname(__FILE__) . '/service/SoapApiService.php');
	
	function getLanguageXsdType()
	{
		$attributes = array(new scXsdAttribute('lang', 'xsd:language', 'required'));
		$simpleContentExtenstion = new scXsdSimpleContentExtension('xsd:string', $attributes);
		
		$simpleContent = new scXsdComplexTypeSimpleContent;
		$simpleContent->setExtension($simpleContentExtenstion);
		
		$complexType = new scXsdComplexType('scSoapApiMultilanguageText');
		$complexType->setSimpleContent($simpleContent);
		return $complexType;
	}
	
	$scriptUrl = scPaths::getAbsoluteUrl(scPaths::getCurrentScriptPathName());
	
	// Process WSDL request
	if (array_key_exists('wsdl', $_GET)) {
		header('Content-type: text/xml');
		
		$pregeneratedWsdlFile = dirname(__FILE__) . '/Service.wsdl';
		if (file_exists($pregeneratedWsdlFile)) {
			readfile($pregeneratedWsdlFile);
			die;
		}
		
		$uri = $scriptUrl;
		
		$xsd = new scXsd;
		$xsd->addExternalType(getLanguageXsdType());
		$xsd->addEnumClass('scSoapApiCustomerStatus');
		$xsd->addEnumClass('scSoapApiLocalOptionGroupType');
		$xsd->addEnumClass('scSoapApiLocalOptionPriceModType');
		$xsd->addEnumClass('scSoapApiOperationType');
		$xsd->addEnumClass('scSoapApiOperationStatusCode');
		$xsd->addEnumClass('scSoapApiOrderItemOptionGroupType');
		$xsd->addEnumClass('scSoapApiOrderItemOptionPriceModType');
		$xsd->addEnumClass('scSoapApiOrderPaymentStatus');
		$xsd->addEnumClass('scSoapApiOrderTotalLineType');
		$xsd->addEnumClass('scSoapApiProductClassAttributeType');
		$xsd->addEnumClass('scSoapApiProductClassAttributeValidator');
		
		$namespace = 'http://schemas.summercart.com/api/soap/v1/';
		$wsdl = new scSoapWsdl('scSoapApiService', 'SoapApiService', $uri, $namespace, $xsd);
		echo $wsdl->getWsdl();
		die;
	}
	
/*	if (array_key_exists('disco', $_GET)) {
		$uri = $scriptUrl;
		
		header('Content-type: text/xml');
		$disco = new scDisco;
		echo $disco->getDisco(array($uri));
		die;
	}*/
	
	$soapServer = null;
	set_error_handler('soapErrorsHandler');
	
	$wsdl = $scriptUrl . '?wsdl';
	//$soapServer = new SoapServer($wsdl, array('cache_wsdl' => WSDL_CACHE_NONE));
	$soapServer = new SoapServer($wsdl);
	try {
		$soapServer->setClass('scSoapApiService');
		$soapServer->handle();
	} catch (Exception $exception) {
		$soapServer->fault('Server', sprintf(_i('Uncaught exception: "%s"'), $exception->__toString()));
	}
	
	
	/**
	 * Custom errors handler
	 * @return boolean
	 */
	function soapErrorsHandler($errno, $errstr, $errfile, $errline)
	{
		global $soapServer;
		
		// if error has been supressed with an @
		if (error_reporting() == 0) {
			return false;
		}

		switch ($errno) {
			case E_NOTICE:
			case E_USER_NOTICE:
				$errors = _i('Notice');
				break;
			case E_WARNING:
			case E_USER_WARNING:
				$errors = _i('Warning');
				break;
			case E_ERROR:
			case E_USER_ERROR:
				$errors = _i('Fatal Error');
				break;
			default:
				$errors = _i('Unknown');
				break;
		}
		
		$error = sprintf(_i('PHP %s:  %s in %s on line %d'), $errors, $errstr, $errfile, $errline);
		
		if (ini_get('log_errors'))
			error_log($error);
		
		// Get the trace of the problem.
		// In some cases (e.g. Orders containing BundleItems) recursive dependencies may occur.
		// Use print_r() instead of var_export() in such a case.
		$backtrace = var_export(debug_backtrace(), true);
		if ($soapServer != null) {
			$soapServer->fault('Server', sprintf(_i('Service error: "%s", backtrace: "%s"'), $error, $backtrace));
			die;
		}
		
		// Let the normal error handler continue
		return false;
	}
?>