<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * 
	 */
	class scSoapApiOrderOperation {
		
		/**
		 * Operation: one of INSERT, UPDATE or DELETE
		 * 
		 * @var scSoapApiOperationType
		 */
		public $Operation;
		
		/**
		 * @var scSoapApiOrder
		 */
		public $Order;
	}
	
	/**
	 * Order operation result
	 */
	class scSoapApiOrderOperationResult {
		
		/**
		 * Operation: one of INSERT, UPDATE or DELETE
		 * 
		 * @var scSoapApiOperationType
		 */
		public $Operation;
		
		/**
		 * Operation status
		 * @var scSoapApiOperationStatusCode
		 */
		public $OperationStatusCode;
		
		/**
		 * Error message
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OperationStatusMessage;
		
		/**
		 * Order id
		 * @xsd minOccurs 0
		 * @var int
		 */
		public $OrderId;
		
		/**
		 * Your order reference id. Will be returned only if there is sync info for this order
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderSyncId;
	}
	
	class scSoapApiOrderItemOptionGroupType {
		
		const PRICE_MODIFIER = 'PRICE_MODIFIER';
		const VARIANT = 'VARIANT';
		const USER_TEXT = 'USER_TEXT';
		const USER_IMAGE = 'USER_IMAGE';
	}
	
	class scSoapApiOrderItemOptionPriceModType {
		
		const NONE = 'NONE';
		const AMOUNT = 'AMOUNT';
		const PERCENT = 'PERCENT';
	}
	
	/**
	 * Outbound order to synchronize
	 */
	class scSoapApiOperationsLogOrder {
		
		/**
		 * @var int
		 */
		public $OrderId;
		
		/**
		 * @var int
		 */
		public $OrderOperationsLogId;
		
		/**
		 * @var scSoapApiOperationType
		 */
		public $Operation;
		
		/**
		 * @var dateTime
		 */
		public $Timestamp;
	}
	
	/**
	 * Outbound order that has been synchronized
	 */
	class scSoapApiOperationsLogSyncedOrder {
		
		/**
		 * @var int
		 */
		public $OrderId;
		
		/**
		 * @var int
		 */
		public $OrderOperationsLogId;
	}
	
	/**
	 * Order object
	 */
	class scSoapApiOrder {
		
		/**
		 * Order id. Read only
		 * @var int
		 * @xsd minOccurs 1
		 */
		public $OrderId;
		
		/**
		 * @var int
		 * @xsd minOccurs 0
		 */
		public $OrderStatus;
		
		/**
		 * @var dateTime
		 * @xsd minOccurs 0
		 */
		public $OrderTimestamp;
		
		/**
		 * @var scSoapApiOrderPaymentStatus
		 * @xsd minOccurs 0
		 */
		public $OrderPaymentStatus;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderCustomerInstructions;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderCustomerEmail;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderShippingTrackingNo;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderShippingModuleName;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderShippingMethodName;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderPaymentModuleName;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderPaymentModuleIntegration;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderPaymentNotes;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderPaymentTransactionNo;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderCheckoutModuleName;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderCouponCode;
		
		/**
		 * @var decimal
		 * @xsd minOccurs 0
		 */
		public $OrderTotal;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderCurrencyCode;
		
		/**
		 * @var decimal
		 * @xsd minOccurs 0
		 */
		public $OrderCustomerCurrencyTotal;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderCustomerCurrencyCode;
		
		/**
		 * @var decimal
		 * @xsd minOccurs 0
		 */
		public $OrderTotalPayAmount;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderTotalPayCurrencyCode;
		
		/**
		 * @var scSoapApiOrderAddress
		 * @xsd minOccurs 0
		 */
		public $OrderBillingAddress;
		
		/**
		 * @var scSoapApiOrderAddress
		 * @xsd minOccurs 0
		 */
		public $OrderShippingAddress;
		
		/**
		 * @var scSoapApiOrderItem[]
		 * @xsd minOccurs 0
		 */
		public $OrderItems;
		
		/**
		 * @var scSoapApiOrderTotalLine[]
		 * @xsd minOccurs 0
		 */
		public $OrderTotalLines;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderCustomData;
	}
	
	class scSoapApiOrderItem {
		
		/**
		 * @var int
		 * @xsd minOccurs 1
		 */
		public $OrderItemId;
		
		/**
		 * @var decimal
		 * @xsd minOccurs 1
		 */
		public $OrderItemPrice;
		
		/**
		 * @var decimal
		 * @xsd minOccurs 1
		 */
		public $OrderItemCustomerCurrencyPrice;
		
		/**
		 * @var int
		 * @xsd minOccurs 1
		 */
		public $OrderItemQty;
		
		/**
		 * @var decimal
		 * @xsd minOccurs 0
		 */
		public $OrderItemTotal;
		
		/**
		 * @var decimal
		 * @xsd minOccurs 0
		 */
		public $OrderItemCustomerCurrencyTotal;
		
		/**
		 * @var decimal
		 * @xsd minOccurs 0
		 */
		public $OrderItemDiscount;
		
		/**
		 * @var decimal
		 * @xsd minOccurs 0
		 */
		public $OrderItemCustomerCurrencyDiscount;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderItemProductCode;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderItemProductName;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderItemCategoryName;
		
		/**
		 * @var scSoapApiOrderItem[]
		 */
		public $OrderItemBundledItems;
		
		/**
		 * @var scSoapApiOrderItemOption[]
		 * @xsd minOccurs 0
		 */
		public $OrderItemOptions;
		
		/**
		 * @var scSoapApiOrderItemLocalOption[]
		 * @xsd minOccurs 0
		 */
		public $OrderItemLocalOptions;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderItemCustomData;
	}
	
	class scSoapApiOrderItemOption {
		
		/**
		 * @var int
		 * @xsd minOccurs 1
		 */
		public $OrderItemOptionId;
		
		/**
		 * @var scSoapApiOrderItemOptionGroupType
		 * @xsd minOccurs 1
		 */
		public $OrderItemOptionGroupType;
		
		/**
		 * @var scSoapApiOrderItemOptionPriceModType
		 * @xsd minOccurs 1
		 */
		public $OrderItemOptionPriceModType;
		
		/**
		 * @var decimal
		 * @xsd minOccurs 1
		 */
		public $OrderItemOptionPriceModValue;
		
		/**
		 * @var decimal
		 * @xsd minOccurs 1
		 */
		public $OrderItemOptionPrice;
		
		/**
		 * @var decimal
		 * @xsd minOccurs 1
		 */
		public $OrderItemOptionCustomerCurrencyPrice;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderItemOptionGroupName;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderItemOptionName;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderItemOptionUserText;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderItemOptionCustomData;
		
		// TODO: Order item option images
	}
	
	class scSoapApiOrderItemLocalOption extends scSoapApiOrderItemOption {
		
		
	}
	
	class scSoapApiOrderAddress {
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $AddressFirstName;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $AddressLastName;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $AddressCompany;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $AddressPhone;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $AddressFax;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $AddressStreet1;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $AddressStreet2;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $AddressCity;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $AddressState;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $AddressCountry;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $AddressZip;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $AddressVatNumber;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $AddressCustomData;
	}
	
	/**
	 * Order total line
	 */
	class scSoapApiOrderTotalLine {
		
		/**
		 * @var int
		 * @xsd minOccurs 0
		 */
		public $OrderTotalLineId;
		
		/**
		 * @var scSoapApiOrderTotalLineType
		 * @xsd minOccurs 0
		 */
		public $OrderTotalLineType;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderTotalLineName;
		
		/**
		 * @var decimal
		 * @xsd minOccurs 0
		 */
		public $OrderTotalLineAmount;
		
		/**
		 * @var decimal
		 * @xsd minOccurs 0
		 */
		public $OrderTotalLineCustomerCurrencyAmount;
		
		/**
		 * @var int
		 * @xsd minOccurs 0
		 */
		public $OrderTotalLineSort;
		
		/**
		 * @var string
		 * @xsd minOccurs 0
		 */
		public $OrderTotalCustomData;
	}
	
	class scSoapApiOrderTotalLineType {
		
		const SUBTOTAL = 'SUBTOTAL';
		const SHIPPING = 'SHIPPING';
		const SURCHARGE = 'SURCHARGE';
		const DISCOUNT = 'DISCOUNT';
		const COUPON = 'COUPON';
		const TAX = 'TAX';
		const POINTS = 'POINTS';
		
		const OTHER = 'OTHER';
	}
	
	class scSoapApiOrderPaymentStatus {
		
		const PAYMENT_STATUS_NONE = 'PAYMENT_STATUS_NONE';
		const PAYMENT_STATUS_AT_PROCESSOR = 'PAYMENT_STATUS_AT_PROCESSOR';
		const PAYMENT_STATUS_DECLINED = 'PAYMENT_STATUS_DECLINED';
		const PAYMENT_STATUS_PENDING = 'PAYMENT_STATUS_PENDING';
		const PAYMENT_STATUS_AUTH = 'PAYMENT_STATUS_AUTH';
		const PAYMENT_STATUS_CAPTURE = 'PAYMENT_STATUS_CAPTURE';
		const PAYMENT_STATUS_PARTIAL_REFUND = 'PAYMENT_STATUS_PARTIAL_REFUND';
		const PAYMENT_STATUS_REFUND = 'PAYMENT_STATUS_REFUND';
		const PAYMENT_STATUS_CHARGEBACK = 'PAYMENT_STATUS_CHARGEBACK';
		const PAYMENT_STATUS_OTHER = 'PAYMENT_STATUS_OTHER';
		const PAYMENT_STATUS_OFFLINE = 'PAYMENT_STATUS_OFFLINE';
		const PAYMENT_STATUS_PARTIAL_CAPTURE = 'PAYMENT_STATUS_PARTIAL_CAPTURE';
		const PAYMENT_STATUS_VOID = 'PAYMENT_STATUS_VOID';
	}
	
	/**
	 * Selector for orders
	 */
	class scSoapApiOrderSelector {
		
		/**
		 * @var int[]
		 */
		public $OrderId;
	}
	
	/**
	 * Order related operations implementation
	 */
	class scSoapApiServiceOrderOperations extends scSoapApiServiceImpl {
		
		protected $_orderItems = array();
		
		protected $_orderItemOptions = array();
		
		protected $_orderItemLocalOptions = array();
		
		protected $_orderTotalLines = array();
		
		/**
		 * Retrieve orders
		 * @param $selector
		 * @return scSoapApiOrderOperationResult[]
		 */
		public function doGetOperation($entityName, $selector)
		{
			if (!isset($selector->OrderId)) {
				return array();
			}
			
			$entityIds = $selector->OrderId;
			if (empty($entityIds)) {
				return array();
			}
			if (!is_array($entityIds)) {
				$entityIds = array($entityIds);
			}
			$entityIds = array_unique($entityIds);
			
			$results = array();
			foreach ($entityIds as $orderId) {
				try {
					scOrdersCache::fullLoadOrderData($orderId);
				} catch (miDBException $exception) {
					if ($exception->getCode() == miDBException::EXCEPTION_RECORD_NOT_FOUND) {
						// If the order was not found and it caused an excetion
						continue;
					}
					throw $exception;
				}
				
				$order = scOrdersCache::getOrder($orderId);
				
				$apiOrder = scSoapApiOrderFactory::getOrder($order);
				
				$apiOrder->OrderBillingAddress = scSoapApiOrderFactory::getAddressFromOrder($order, 'OrderBilling');
				$apiOrder->OrderShippingAddress = scSoapApiOrderFactory::getAddressFromOrder($order, 'OrderShipping');
				
				$apiOrder->OrderItems = $this->getOrderItemsForOrder($order);
				$apiOrder->OrderTotalLines = $this->getOrderTotalLinesForOrder($order);
				
				$results[] = $apiOrder;
			}
			return $results;
		}
		
		/**
		 * Returns list of operations that are not yet synced
		 * @return scSoapApiOperationsLogOrder[]
		 */
		public function doGetOperationsLog()
		{
			$recordset = new miSqlRecordset('SyncOperationsLog');
			$recordset->addFilter(new miSqlFilterEqual('SyncOperationsLogHandler', scSoapApiMapping::getEntityField('Order', scSoapApiMapping::HANDLER)));
			$recordset->setOrder('SyncOperationsLogID', 'ASC');
			$records = $recordset->getAllRecords();
			
			$results = array();
			foreach ($records as $record) {
				$results[] = $this->getOperationsLogItemFromRecord($record);
			}
			return $results;
		}
		
		/**
		 * Mark operations as synced in the external system
		 * The implementation just deletes all synced operations from operations pending sync table
		 * @param scSoapApiOperationsLogSyncedOrder[] $syncedOrders
		 */
		public function doMarkOperationsLogSynced($syncedOrders)
		{
			if (!is_array($syncedOrders)) {
				$syncedOrders = array($syncedOrders);
			}
			miStaticDBUtil::startTransaction();
			foreach ($syncedOrders as $syncedOrder) {
				$sql = 'DELETE FROM SyncOperationsLog' .
					' WHERE SyncOperationsLogHandler = ?' .
					' AND LocalID = ?' .
					' AND SyncOperationsLogID <= ?';
				$handler = scSoapApiMapping::getEntityField('Order', scSoapApiMapping::HANDLER);
				miStaticDBUtil::execSQL($sql, array($handler, $syncedOrder->OrderId, $syncedOrder->OrderOperationsLogId));
			}
			miStaticDBUtil::commit();
		}
		
		protected function doInsert($entityName, $item)
		{
			throw new miException(_i('Not implemented.'));
		}
		
		protected function setItemDataToDomainObject(miDomainObject $object, $item, $isInsert)
		{
			if (isset($item->OrderStatus))
				$object->set('OrderStatus', $item->OrderStatus);
			
			// TODO: Set all supported fields
		}
		
		/**
		 * @param scSoapApiOrderOperationResult $operationResult
		 * @param object $operation
		 */
		protected function setSyncId($operationResult, $operation)
		{
			throw new miException(_i('Not implementable.'));
		}
		
		protected function getOperationsLogItemFromRecord($record)
		{
			$item = new scSoapApiOperationsLogOrder();
			$item->OrderId = $record['LocalID'];
			$item->OrderOperationsLogId = $record['SyncOperationsLogID'];
			$item->Operation = $this->getOperationsLogOperationFromRecord($record);
			$item->Timestamp = scDateTime::timestampToIso8601($record['SyncOperationsLogTimestamp']);
			return $item;
		}
		
		protected function getOperationsLogOperationFromRecord($record)
		{
			switch ($record['SyncOperationsLogOperation']) {
				case scOperationsLog::OPERATION_INSERT:
					return scSoapApiOperationType::OP_INSERT;
				
				case scOperationsLog::OPERATION_UPDATE:
					return scSoapApiOperationType::OP_UPDATE;
				
				case scOperationsLog::OPERATION_DELETE:
					return scSoapApiOperationType::OP_DELETE;
			}
			
			throw new miException(sprintf(_i('Unknown operation "%s".'), $record['SyncOperationsLogOperation']));
		}
		
		/**
		 * @param scOrder $order
		 * @param int $parentItemId
		 * @return scSoapApiOrderItem[]
		 */
		protected function getOrderItemsForOrder(scOrder $order, $parentItemId = null)
		{
			$orderItems = $order->getOrderItems();
			
			$items = array();
			foreach ($orderItems as $orderItem) {
				if ($orderItem->get('ParentOrderItemID') != $parentItemId) {
					continue;
				}
				
				$item = scSoapApiOrderFactory::getOrderItem($orderItem);
				
				$item->OrderItemBundledItems = $this->getOrderItemsForOrder($order, $orderItem->get('OrderItemID'));
				$item->OrderItemOptions = $this->getOrderItemOptionsForOrderItem($orderItem);
				$item->OrderItemLocalOptions = $this->getOrderItemLocalOptionsForOrderItem($orderItem);
				
				$items[] = $item;
			}
			return $items;
		}
		
		/**
		 * @param scOrderItem $orderItem
		 * @return scSoapApiOrderItemOption
		 */
		protected function getOrderItemOptionsForOrderItem(scOrderItem $orderItem)
		{
			$options = $orderItem->getOrderItemOptions();
			
			$items = array();
			foreach ($options as $option) {
				$items[] = scSoapApiOrderFactory::getOrderItemOption($option);
			}
			return $items;
		}
		
		/**
		 * @param scOrderItem $orderItem
		 * @return scSoapApiOrderItemOption
		 */
		protected function getOrderItemLocalOptionsForOrderItem(scOrderItem $orderItem)
		{
			$options = $orderItem->getOrderItemLocalOptions();
			
			$items = array();
			foreach ($options as $option) {
				$items[] = scSoapApiOrderFactory::getOrderItemLocalOption($option);
			}
			return $items;
		}
		
		/**
		 * @param int $orderId
		 * @return scSoapApiOrderTotalLine[]
		 */
		protected function getOrderTotalLinesForOrder(scOrder $order)
		{
			$orderTotalLines = $order->getOrderTotalLines();
			
			$lines = array();
			foreach ($orderTotalLines as $orderTotalLine) {
				$lines[] = scSoapApiOrderFactory::getOrderTotalLine($orderTotalLine);
			}
			return $lines;
		}
		
		protected function createDomainObject()
		{
			return new scOrder();
		}
	}
	
	class scSoapApiOrderFactory {
		
		/**
		 * @param scOrder $order
		 * @return scSoapApiOrder
		 */
		public static function getOrder(scOrder $order)
		{
			$item = new scSoapApiOrder();
			
			$item->OrderId = $order->get('OrderID');
			$item->OrderTimestamp = scDateTime::timestampToIso8601($order->get('OrderTimestamp'));
			
			$item->OrderCouponCode = $order->get('OrderCouponCode');
			$item->OrderCheckoutModuleName = $order->get('OrderCheckoutModuleName');
			
			$item->OrderTotal = $order->get('OrderTotal');
			$item->OrderCurrencyCode = $order->get('OrderCurrencyCode');
			$item->OrderStatus = $order->get('OrderStatus');
			
			$item->OrderCustomerCurrencyTotal = $order->get('OrderCustomerCurrencyTotal');
			$item->OrderCustomerCurrencyCode = $order->get('OrderCustomerCurrencyCode');
			
			$item->OrderPaymentModuleName = $order->get('OrderPaymentModuleName');
			$item->OrderPaymentModuleIntegration = $order->get('OrderPaymentModuleIntegration');
			$item->OrderPaymentNotes = $order->get('OrderPaymentNotes');
			$item->OrderPaymentTransactionNo = $order->get('OrderPaymentTransactionNo');
			$item->OrderPaymentStatus = self::getMappedPaymentStatus($order->get('OrderPaymentStatus'));
			$item->OrderTotalPayAmount = $order->get('OrderTotalPayAmount');
			$item->OrderTotalPayCurrencyCode = $order->get('OrderTotalPayCurrencyCode');
			
			$item->OrderShippingModuleName = $order->get('OrderShippingModuleName');
			$item->OrderShippingMethodName = $order->get('OrderShippingMethodName');
			$item->OrderShippingTrackingNo = $order->get('OrderShippingTrackingNo');
			
			$item->OrderCustomerEmail = $order->get('OrderCustomerEmail');
			$item->OrderCustomerInstructions = $order->get('OrderCustomerInstructions');
			
			return $item;
		}
		
		/**
		 * @param scOrderItem $orderItem
		 * @return scSoapApiOrderItem
		 */
		public static function getOrderItem(scOrderItem $orderItem)
		{
			$item = new scSoapApiOrderItem();
			$item->OrderItemId = $orderItem->get('OrderItemID');
			$item->OrderItemPrice = $orderItem->get('OrderItemPrice');
			$item->OrderItemCustomerCurrencyPrice = $orderItem->get('OrderItemCustomerCurrencyPrice');
			$item->OrderItemQty = $orderItem->get('OrderItemQty');
			$item->OrderItemTotal = $orderItem->get('OrderItemTotal');
			$item->OrderItemCustomerCurrencyTotal = $orderItem->get('OrderItemCustomerCurrencyTotal');
			$item->OrderItemDiscount = $orderItem->get('OrderItemDiscount');
			$item->OrderItemCustomerCurrencyDiscount = $orderItem->get('OrderItemCustomerCurrencyDiscount');
			$item->OrderItemProductCode = $orderItem->get('OrderItemProductCode');
			$item->OrderItemProductName = $orderItem->get('OrderItemProductName');
			return $item;
		}
		
		/**
		 * @param scOrderTotalLineDomainObject $orderTotalLine
		 * @return scSoapApiOrderTotalLine
		 */
		public static function getOrderTotalLine(scOrderTotalLineDomainObject $orderTotalLine)
		{
			$item = new scSoapApiOrderTotalLine();
			$item->OrderTotalLineId = $orderTotalLine->get('OrderTotalLineID');
			$item->OrderTotalLineType = self::getMappedTotalLineType($orderTotalLine->get('OrderTotalLineType'));
			$item->OrderTotalLineName = $orderTotalLine->get('OrderTotalLineName');
			$item->OrderTotalLineAmount = $orderTotalLine->get('OrderTotalLineAmount');
			$item->OrderTotalLineSort = $orderTotalLine->get('OrderTotalLineSort');
			$item->OrderTotalLineCustomerCurrencyAmount = $orderTotalLine->get('OrderTotalLineCustomerCurrencyAmount');
			return $item;
		}
		
		/**
		 * @param scOrderItemOption $option
		 * @return scSoapApiOrderItemOption
		 */
		public static function getOrderItemOption(scOrderItemOption $option)
		{
			$item = new scSoapApiOrderItemOption();
			$item->OrderItemOptionId = $option->get('OrderItemOptionID');
			$item->OrderItemOptionGroupType = self::getMappedOptionGroupType($option->get('OrderItemOptionGroupType'));
			$item->OrderItemOptionPriceModType = self::getMappedOptionPriceModType($option->get('OrderItemOptionPriceModType'));
			$item->OrderItemOptionPriceModValue = $option->get('OrderItemOptionPriceModValue');
			$item->OrderItemOptionPrice = $option->get('OrderItemOptionPrice');
			$item->OrderItemOptionCustomerCurrencyPrice = $option->get('OrderItemOptionCustomerCurrencyPrice');
			$item->OrderItemOptionGroupName = $option->get('OrderItemOptionGroupName');
			$item->OrderItemOptionName = $option->get('OrderItemOptionName');
			$item->OrderItemOptionUserText = $option->get('OrderItemOptionUserText');
			return $item;
		}
		
		/**
		 * @param scOrderItemLocalOption $option
		 * @return scSoapApiOrderItemLocalOption
		 */
		public static function getOrderItemLocalOption(scOrderItemLocalOption $option)
		{
			$item = new scSoapApiOrderItemLocalOption();
			$item->OrderItemOptionId = $option->get('OrderItemLocalOptionID');
			$item->OrderItemOptionGroupType = self::getMappedOptionGroupType($option->get('OrderItemLocalOptionGroupType'));
			$item->OrderItemOptionPriceModType = self::getMappedOptionPriceModType($option->get('OrderItemLocalOptionPriceModType'));
			$item->OrderItemOptionPriceModValue = $option->get('OrderItemLocalOptionPriceModValue');
			$item->OrderItemOptionPrice = $option->get('OrderItemLocalOptionPrice');
			$item->OrderItemOptionCustomerCurrencyPrice = $option->get('OrderItemLocalOptionCustomerCurrencyPrice');
			$item->OrderItemOptionGroupName = $option->get('OrderItemLocalOptionGroupName');
			$item->OrderItemOptionName = $option->get('OrderItemLocalOptionName');
			$item->OrderItemOptionUserText = $option->get('OrderItemLocalOptionUserText');
			return $item;
		}
		
		/**
		 * @param array $record
		 * @param string $prefix
		 * @return scSoapApiOrderAddress
		 */
		public static function getAddressFromOrder($order, $prefix = '')
		{
			$address = new scSoapApiOrderAddress();
			$address->AddressFirstName = $order->get($prefix . 'FirstName');
			$address->AddressLastName = $order->get($prefix . 'LastName');
			$address->AddressCompany = $order->get($prefix . 'Company');
			$address->AddressPhone = $order->get($prefix . 'Phone');
			$address->AddressFax = $order->get($prefix . 'Fax');
			$address->AddressStreet1 = $order->get($prefix . 'Address1');
			$address->AddressStreet2 = $order->get($prefix . 'Address2');
			$address->AddressCity = $order->get($prefix . 'City');
			$address->AddressState = $order->get($prefix . 'State');
			$address->AddressCountry = $order->get($prefix . 'Country');
			$address->AddressZip = $order->get($prefix . 'Zip');
			$address->AddressVatNumber = $order->get($prefix . 'VatNumber');
			return $address;
		}
		
		protected static function getMappedTotalLineType($scType)
		{
			switch ($scType) {
				case IOrderTotalModule::ORDER_TOTAL_TYPE_SUBTOTAL:
					return scSoapApiOrderTotalLineType::SUBTOTAL;
				case IOrderTotalModule::ORDER_TOTAL_TYPE_SHIPPING:
					return scSoapApiOrderTotalLineType::SHIPPING;
				case IOrderTotalModule::ORDER_TOTAL_TYPE_SURCHARGE:
					return scSoapApiOrderTotalLineType::SURCHARGE;
				case IOrderTotalModule::ORDER_TOTAL_TYPE_DISCOUNT:
					return scSoapApiOrderTotalLineType::DISCOUNT;
				case IOrderTotalModule::ORDER_TOTAL_TYPE_COUPON:
					return scSoapApiOrderTotalLineType::COUPON;
				case IOrderTotalModule::ORDER_TOTAL_TYPE_TAX:
					return scSoapApiOrderTotalLineType::TAX;
				case IOrderTotalModule::ORDER_TOTAL_TYPE_POINTS:
					return scSoapApiOrderTotalLineType::POINTS;
				case IOrderTotalModule::ORDER_TOTAL_TYPE_OTHER:
					return scSoapApiOrderTotalLineType::OTHER;
			}
			
			throw new miException(sprintf(_i('Invalid order total line type "%s".'), $scType));
		}
		
		protected static function getMappedPaymentStatus($scType)
		{
			switch ($scType) {
				case scPaymentStatus::PAYMENT_STATUS_NONE:
					return scSoapApiOrderPaymentStatus::PAYMENT_STATUS_NONE;
				case scPaymentStatus::PAYMENT_STATUS_AT_PROCESSOR:
					return scSoapApiOrderPaymentStatus::PAYMENT_STATUS_AT_PROCESSOR;
				case scPaymentStatus::PAYMENT_STATUS_DECLINED:
					return scSoapApiOrderPaymentStatus::PAYMENT_STATUS_DECLINED;
				case scPaymentStatus::PAYMENT_STATUS_PENDING:
					return scSoapApiOrderPaymentStatus::PAYMENT_STATUS_PENDING;
				case scPaymentStatus::PAYMENT_STATUS_AUTH:
					return scSoapApiOrderPaymentStatus::PAYMENT_STATUS_AUTH;
				case scPaymentStatus::PAYMENT_STATUS_CAPTURE:
					return scSoapApiOrderPaymentStatus::PAYMENT_STATUS_CAPTURE;
				case scPaymentStatus::PAYMENT_STATUS_PARTIAL_REFUND:
					return scSoapApiOrderPaymentStatus::PAYMENT_STATUS_PARTIAL_REFUND;
				case scPaymentStatus::PAYMENT_STATUS_REFUND:
					return scSoapApiOrderPaymentStatus::PAYMENT_STATUS_REFUND;
				case scPaymentStatus::PAYMENT_STATUS_CHARGEBACK:
					return scSoapApiOrderPaymentStatus::PAYMENT_STATUS_CHARGEBACK;
				case scPaymentStatus::PAYMENT_STATUS_OTHER:
					return scSoapApiOrderPaymentStatus::PAYMENT_STATUS_OTHER;
				case scPaymentStatus::PAYMENT_STATUS_OFFLINE:
					return scSoapApiOrderPaymentStatus::PAYMENT_STATUS_OFFLINE;
				case scPaymentStatus::PAYMENT_STATUS_PARTIAL_CAPTURE:
					return scSoapApiOrderPaymentStatus::PAYMENT_STATUS_PARTIAL_CAPTURE;
				case scPaymentStatus::PAYMENT_STATUS_VOID:
					return scSoapApiOrderPaymentStatus::PAYMENT_STATUS_VOID;
			}
			
			throw new miException(sprintf(_i('Invalid payment status "%s".'), $scType));
		}
		
		protected static function getMappedOptionGroupType($scGroupType)
		{
			switch ($scGroupType) {
				case scProductOptions::GROUP_TYPE_PRICE_MODIFIER:
					return scSoapApiOrderItemOptionGroupType::PRICE_MODIFIER;
				case scProductOptions::GROUP_TYPE_VARIANT:
					return scSoapApiOrderItemOptionGroupType::VARIANT;
				case scProductOptions::GROUP_TYPE_USER_TEXT:
					return scSoapApiOrderItemOptionGroupType::USER_TEXT;
				case scProductOptions::GROUP_TYPE_USER_IMAGE:
					return scSoapApiOrderItemOptionGroupType::USER_IMAGE;
			}
			
			throw new miException(sprintf(_i('Invalid order item option group type "%s".'), $scGroupType));
		}
		
		protected static function getMappedOptionPriceModType($scPriceModType)
		{
			switch ($scPriceModType) {
				case scProductOptions::PRODUCT_OPTION_TYPE_NONE:
					return scSoapApiOrderItemOptionPriceModType::NONE;
				case scProductOptions::PRODUCT_OPTION_TYPE_AMOUNT:
					return scSoapApiOrderItemOptionPriceModType::AMOUNT;
				case scProductOptions::PRODUCT_OPTION_TYPE_PERCENT:
					return scSoapApiOrderItemOptionPriceModType::PERCENT;
			}
			
			throw new miException(sprintf(_i('Invalid order item option price modification type "%s".'), $scPriceModType));
		}
	}
?>