<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once(dirname(__FILE__) . '/CustomerAddressSyncOperation.php');
	require_once(dirname(__FILE__) . '/CustomerSyncOperation.php');
	require_once(dirname(__FILE__) . '/CategorySyncOperation.php');
	require_once(dirname(__FILE__) . '/ManufacturerSyncOperation.php');
	require_once(dirname(__FILE__) . '/ProductSyncOperation.php');
	require_once(dirname(__FILE__) . '/ProductClassSyncOperation.php');
	require_once(dirname(__FILE__) . '/ProductClassAttributeSyncOperation.php');
	require_once(dirname(__FILE__) . '/ProductClassAttributeValueSyncOperation.php');
	require_once(dirname(__FILE__) . '/ProductAttributeValueSyncOperation.php');
	require_once(dirname(__FILE__) . '/ProductImageSyncOperation.php');
	require_once(dirname(__FILE__) . '/BundleProductSyncOperation.php');
	require_once(dirname(__FILE__) . '/LocalOptionGroupSyncOperation.php');
	require_once(dirname(__FILE__) . '/LocalOptionSyncOperation.php');
	
	/**
	 * Contains all types of sync info. Multiple types can be passed.
	 */
	class scSoapApiSyncInfos {
		
		/**
		 * 
		 * @var scSoapApiCustomerSyncInfo[]
		 */
		public $CustomerSyncInfo;
		
		/**
		 * 
		 * @var scSoapApiCustomerAddressSyncInfo[]
		 */
		public $CustomerAddressSyncInfo;
		
		/**
		 * 
		 * @var scSoapApiCategorySyncInfo[]
		 */
		public $CategorySyncInfo;
		
		/**
		 * 
		 * @var scSoapApiManufacturerSyncInfo[]
		 */
		public $ManufacturerSyncInfo;
		
		/**
		 * 
		 * @var scSoapApiProductClassSyncInfo[]
		 */
		public $ProductClassSyncInfo;
		
		/**
		 * 
		 * @var scSoapApiProductClassAttributeSyncInfo[]
		 */
		public $ProductClassAttributeSyncInfo;
		
		/**
		 * 
		 * @var scSoapApiProductClassAttributeValueSyncInfo[]
		 */
		public $ProductClassAttributeValueSyncInfo;
		
		/**
		 * 
		 * @var scSoapApiProductAttributeValueSyncInfo[]
		 */
		public $ProductAttributeValueSyncInfo;
		
		/**
		 * 
		 * @var scSoapApiProductImageSyncInfo[]
		 */
		public $ProductImageSyncInfo;
		
		/**
		 * 
		 * @var scSoapApiProductSyncInfo[]
		 */
		public $ProductSyncInfo;
		
		/**
		 * 
		 * @var scSoapApiBundleProductSyncInfo[]
		 */
		public $BundleProductSyncInfo;
		
		/**
		 * 
		 * @var scSoapApiLocalOptionSyncInfo[]
		 */
		public $LocalOptionSyncInfo;
		
		/**
		 * 
		 * @var scSoapApiLocalOptionGroupSyncInfo[]
		 */
		public $LocalOptionGroupSyncInfo;
	}
	
	/**
	 * Contains all types of sync info results. Can contain more than one type of sync infos.
	 */
	class scSoapApiSyncInfoResults {
		
		/**
		 * 
		 * @var scSoapApiCustomerSyncInfoResult[]
		 */
		public $CustomerSyncInfoResult;
		
		/**
		 * 
		 * @var scSoapApiCustomerAddressSyncInfoResult[]
		 */
		public $CustomerAddressSyncInfoResult;
		
		/**
		 * 
		 * @var scSoapApiCategorySyncInfoResult[]
		 */
		public $CategorySyncInfoResult;
		
		/**
		 * 
		 * @var scSoapApiManufacturerSyncInfoResult[]
		 */
		public $ManufacturerSyncInfoResult;
		
		/**
		 * 
		 * @var scSoapApiProductClassSyncInfoResult[]
		 */
		public $ProductClassSyncInfoResult;
		
		/**
		 * 
		 * @var scSoapApiProductClassAttributeSyncInfoResult[]
		 */
		public $ProductClassAttributeSyncInfoResult;
		
		/**
		 * 
		 * @var scSoapApiProductClassAttributeValueSyncInfoResult[]
		 */
		public $ProductClassAttributeValueSyncInfoResult;
		
		/**
		 * 
		 * @var scSoapApiProductAttributeValueSyncInfoResult[]
		 */
		public $ProductAttributeValueSyncInfoResult;
		
		/**
		 * 
		 * @var scSoapApiProductImageSyncInfoResult[]
		 */
		public $ProductImageSyncInfoResult;
		
		/**
		 * 
		 * @var scSoapApiProductSyncInfoResult[]
		 */
		public $ProductSyncInfoResult;
		
		/**
		 * 
		 * @var scSoapApiBundleProductSyncInfoResult[]
		 */
		public $BundleProductSyncInfoResult;
		
		/**
		 * 
		 * @var scSoapApiLocalOptionSyncInfoResult[]
		 */
		public $LocalOptionSyncInfoResult;
		
		/**
		 * 
		 * @var scSoapApiLocalOptionGroupSyncInfoResult[]
		 */
		public $LocalOptionGroupSyncInfoResult;
	}
	
	class scSoapApiSyncRequest extends scSoapApiSyncInfos {
		
		/**
		 * If items without sync info, i.e. items created manually from the user should be returned.
		 * These items will have operation DELETE, and ref and hashcode will be empty
		 * @var boolean
		 * @xsd minOccurs 1
		 */
		public $ReturnNonSynced;
	}
	
	class scSoapApiSyncResponse extends scSoapApiSyncInfoResults {
		
	}
	
	class scSoapApiStartSyncTransactionRequest {
		
	}
	
	class scSoapApiStartSyncTransactionResponse {
		
		/**
		 * The transaction id obtained from startSyncTransaction()
		 * @var int
		 */
		public $SyncTransactionId;
	}
	
	class scSoapApiAddSyncInfoRequest extends scSoapApiSyncInfos {
		
		/**
		 * The transaction id obtained from startSyncTransaction()
		 * @var int
		 * @xsd minOccurs 1
		 */
		public $SyncTransactionId;
	}
	
	class scSoapApiAddSyncInfoResponse {
		
	}
	
	class scSoapApiPerformSyncTransactionRequest {
		
		/**
		 * The transaction id obtained from startSyncTransaction()
		 * @var int
		 * @xsd minOccurs 1
		 */
		public $SyncTransactionId;
		
		/**
		 * If items without sync info, i.e. items created manually from the user should be returned.
		 * These items will have operation DELETE, and ref and hashcode will be empty
		 * @var boolean
		 * @xsd minOccurs 1
		 */
		public $ReturnNonSynced;
	}
	
	class scSoapApiPerformSyncTransactionResponse {
		
		/**
		 * @var int
		 * @xsd minOccurs 1
		 */
		public $OperationsCount;
	}
	
	class scSoapApiGetSyncTransactionResultsRequest {
		
		/**
		 * The transaction id obtained from startSyncTransaction()
		 * @var int
		 * @xsd minOccurs 1
		 */
		public $SyncTransactionId;
		
		/**
		 * The page number of the results. Starts from 1.
		 * @var int
		 * @xsd minOccurs 1
		 */
		public $PageNumber;
		
		/**
		 * Number of operations to be returned.
		 * @var int
		 * @xsd minOccurs 1
		 */
		public $OperationsPerPage;
	}
	
	class scSoapApiGetSyncTransactionResultsResponse extends scSoapApiSyncInfoResults {
		
	}
?>