<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('include/miphpf/Init.php');
	require_once('include/sc/Init.php');
	
	scSession::singleton()->openSession();
	
	// Resolve the URL
	class scCustomUrlResolver {
		
		public function resolve()
		{
			if (empty($_SERVER['REQUEST_URI'])) {
				$this->do404();
				die;
			}
			
			$root = substr(scPaths::getStoreWebPath(), 0,-1); // Web path without the last slash.
			$requestUri = substr($_SERVER['REQUEST_URI'], strlen($root)); // Request URI as if the store is in the root of the domain.
			$result = scUrlResolver::singleton()->resolve($requestUri);
			
			if ($result === false) {
				$this->do404();
				die;
			}
			
			if (empty($_POST) && !$result->getIsPrimary()) {
				header('HTTP/1.1 301 Moved Permanently');
				header('Location: ' . scUrlUtil::convertUrl($result->getPrimaryUrl(), scUrlUtil::URL_TYPE_ABSOLUTE));
				die;
			}
			
			$params = $result->getParams();
			foreach ($params as $param => $value) {
				miSetParam($param, $value);
			}
			scMultiLanguage::singleton()->setCurrentLanguageCode($result->getLanguageCode());
			
			if (isset($_SERVER['SCRIPT_NAME'])) {
				$pos = strpos($_SERVER['SCRIPT_NAME'], 'custom_url.php');
				if ($pos != false) {
					$_SERVER['SCRIPT_NAME'] = substr($_SERVER['SCRIPT_NAME'], 0, $pos) . $result->getHandlingScript();
				}
			}
			if (isset($_SERVER['PHP_SELF'])) {
				$pos = strpos($_SERVER['PHP_SELF'], 'custom_url.php');
				if ($pos != false) {
					$_SERVER['PHP_SELF'] = substr($_SERVER['PHP_SELF'], 0, $pos) . $result->getHandlingScript();
				}
			}
			
			require $result->getHandlingScript();
		}
		
		public function do404()
		{
			header('HTTP/1.0 404 Not Found');
			header('Status: 404 Not Found');
			echo '<html>
			<head>
				<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
				<meta http-equiv="refresh" content="1; URL=' .  scPaths::getAbsoluteUrl() . '">
			</head>
			<body>
			<h1>HTTP 404 - Not Found</h1>
			<h2>' . _t('The page that you have requested cannot be found. You will be redirected to the home page in 2 seconds.') . '</h2>
			</body></html>';
			
			die;
		}
	}
	
	$urlResolver = new scCustomUrlResolver;
	$urlResolver->resolve();
?>