<?php
	/**
	* Countries define file
	*
	* @copyright Copyright (c) 2004 Mirchev Ideas Ltd. All rights reserved.
	* @package MIPHPF
	*/
	
	/**
	 * Array with countries. The key is the 3-letter abbreviation of
	 * the country name per ISO 3166-1 alpha-3
	 * 
	 * @access public
	 */
	$miCountries = array(
		'AFG' => 'Afghanistan',
		'ALB' => 'Albania',
		'DZA' => 'Algeria',
		'ASM' => 'American Samoa',
		'AND' => 'Andorra',
		'AGO' => 'Angola',
		'AIA' => 'Anguilla',
		'ATG' => 'Antigua and Barbuda',
		'ARG' => 'Argentina',
		'ARM' => 'Armenia',
		'ABW' => 'Aruba',
		'AUS' => 'Australia',
		'AUT' => 'Austria',
		'AZE' => 'Azerbaijan',
		'BHS' => 'Bahamas',
		'BHR' => 'Bahrain',
		'BGD' => 'Bangladesh',
		'BRB' => 'Barbados',
		'BLR' => 'Belarus',
		'BEL' => 'Belgium',
		'BLZ' => 'Belize',
		'BEN' => 'Benin',
		'BMU' => 'Bermuda',
		'BTN' => 'Bhutan',
		'BOL' => 'Bolivia',
		'BIH' => 'Bosnia and Herzegovina',
		'BWA' => 'Botswana',
		'BRA' => 'Brazil',
		'VGB' => 'British Virgin Islands',
		'BRN' => 'Brunei Darussalam',
		'BGR' => 'Bulgaria',
		'BFA' => 'Burkina Faso',
		'BDI' => 'Burundi',
		'KHM' => 'Cambodia',
		'CMR' => 'Cameroon',
		'CAN' => 'Canada',
		'CPV' => 'Cape Verde',
		'CYM' => 'Cayman Islands',
		'CAF' => 'Central African Republic',
		'TCD' => 'Chad',
		'CHL' => 'Chile',
		'CHN' => 'China',
		'COL' => 'Colombia',
		'COM' => 'Comoros',
		'COG' => 'Congo',
		'COK' => 'Cook Islands',
		'CRI' => 'Costa Rica',
		'CIV' => 'Cote d\'Ivoire',
		'HRV' => 'Croatia',
		'CUB' => 'Cuba',
		'CYP' => 'Cyprus',
		'CZE' => 'Czech Republic',
		'PRK' => 'Democratic People\'s Republic of Korea',
		'COD' => 'Democratic Republic of the Congo',
		'DNK' => 'Denmark',
		'DJI' => 'Djibouti',
		'DMA' => 'Dominica',
		'DOM' => 'Dominican Republic',
		'TMP' => 'East Timor',
		'ECU' => 'Ecuador',
		'EGY' => 'Egypt',
		'SLV' => 'El Salvador',
		'GNQ' => 'Equatorial Guinea',
		'ERI' => 'Eritrea',
		'EST' => 'Estonia',
		'ETH' => 'Ethiopia',
		'EUR' => 'Europe',
		'FRO' => 'Faeroe Islands',
		'FLK' => 'Falkland Islands (Malvinas)',
		'FJI' => 'Fiji',
		'FIN' => 'Finland',
		'FRA' => 'France',
		'GUF' => 'French Guiana',
		'PYF' => 'French Polynesia',
		'GAB' => 'Gabon',
		'GMB' => 'Gambia',
		'GEO' => 'Georgia',
		'DEU' => 'Germany',
		'GHA' => 'Ghana',
		'GIB' => 'Gibraltar',
		'GRC' => 'Greece',
		'GRL' => 'Greenland',
		'GRD' => 'Grenada',
		'GLP' => 'Guadeloupe',
		'GUM' => 'Guam',
		'GTM' => 'Guatemala',
		'GIN' => 'Guinea',
		'GNB' => 'Guinea-Bissau',
		'GUY' => 'Guyana',
		'HTI' => 'Haiti',
		'VAT' => 'Holy See',
		'HND' => 'Honduras',
		'HKG' => 'Hong Kong',
		'HUN' => 'Hungary',
		'ISL' => 'Iceland',
		'IND' => 'India',
		'IDN' => 'Indonesia',
		'IRN' => 'Iran',
		'IRQ' => 'Iraq',
		'IRL' => 'Ireland',
		'ISR' => 'Israel',
		'ITA' => 'Italy',
		'JAM' => 'Jamaica',
		'JPN' => 'Japan',
		'JOR' => 'Jordan',
		'KAZ' => 'Kazakhstan',
		'KEN' => 'Kenya',
		'KIR' => 'Kiribati',
		'KWT' => 'Kuwait',
		'KGZ' => 'Kyrgyzstan',
		'LAO' => 'Lao People\'s Democratic Republic',
		'LVA' => 'Latvia',
		'LBN' => 'Lebanon',
		'LSO' => 'Lesotho',
		'LBR' => 'Liberia',
		'LBY' => 'Libyan Arab Jamahiriya',
		'LIE' => 'Liechtenstein',
		'LTU' => 'Lithuania',
		'LUX' => 'Luxembourg',
		'MAC' => 'Macao Special Administrative Region of China',
		'MDG' => 'Madagascar',
		'MWI' => 'Malawi',
		'MYS' => 'Malaysia',
		'MDV' => 'Maldives',
		'MLI' => 'Mali',
		'MLT' => 'Malta',
		'MHL' => 'Marshall Islands',
		'MTQ' => 'Martinique',
		'MRT' => 'Mauritania',
		'MUS' => 'Mauritius',
		'MEX' => 'Mexico',
		'FSM' => 'Micronesia Federated States of,',
		'MCO' => 'Monaco',
		'MNG' => 'Mongolia',
		'MNE' => 'Montenegro',
		'MSR' => 'Montserrat',
		'MAR' => 'Morocco',
		'MOZ' => 'Mozambique',
		'MMR' => 'Myanmar',
		'NAM' => 'Namibia',
		'NRU' => 'Nauru',
		'NPL' => 'Nepal',
		'NLD' => 'Netherlands',
		'ANT' => 'Netherlands Antilles',
		'NCL' => 'New Caledonia',
		'NZL' => 'New Zealand',
		'NIC' => 'Nicaragua',
		'NER' => 'Niger',
		'NGA' => 'Nigeria',
		'NIU' => 'Niue',
		'NFK' => 'Norfolk Island',
		'MNP' => 'Northern Mariana Islands',
		'NOR' => 'Norway',
		'PSE' => 'Occupied Palestinian Territory',
		'OMN' => 'Oman',
		'PAK' => 'Pakistan',
		'PLW' => 'Palau',
		'PAN' => 'Panama',
		'PNG' => 'Papua New Guinea',
		'PRY' => 'Paraguay',
		'PER' => 'Peru',
		'PHL' => 'Philippines',
		'PCN' => 'Pitcairn',
		'POL' => 'Poland',
		'PRT' => 'Portugal',
		'PRI' => 'Puerto Rico',
		'QAT' => 'Qatar',
		'KOR' => 'Republic of Korea',
		'MDA' => 'Republic of Moldova',
		'REU' => 'R<union',
		'ROM' => 'Romania',
		'RUS' => 'Russian Federation',
		'RWA' => 'Rwanda',
		'SHN' => 'Saint Helena',
		'KNA' => 'Saint Kitts and Nevis',
		'LCA' => 'Saint Lucia',
		'SPM' => 'Saint Pierre and Miquelon',
		'VCT' => 'Saint Vincent and the Grenadines',
		'WSM' => 'Samoa',
		'SMR' => 'San Marino',
		'STP' => 'Sao Tome and Principe',
		'SAU' => 'Saudi Arabia',
		'SEN' => 'Senegal',
		'SRB' => 'Serbia',
		'SYC' => 'Seychelles',
		'SLE' => 'Sierra Leone',
		'SGP' => 'Singapore',
		'SVK' => 'Slovakia',
		'SVN' => 'Slovenia',
		'SLB' => 'Solomon Islands',
		'SOM' => 'Somalia',
		'ZAF' => 'South Africa',
		'ESP' => 'Spain',
		'LKA' => 'Sri Lanka',
		'SDN' => 'Sudan',
		'SUR' => 'Suriname',
		'SJM' => 'Svalbard and Jan Mayen Islands',
		'SWZ' => 'Swaziland',
		'SWE' => 'Sweden',
		'CHE' => 'Switzerland',
		'SYR' => 'Syrian Arab Republic',
		'TWN' => 'Taiwan',
		'TJK' => 'Tajikistan',
		'THA' => 'Thailand',
		'MKD' => 'The former Yugoslav Republic of Macedonia',
		'TGO' => 'Togo',
		'TKL' => 'Tokelau',
		'TON' => 'Tonga',
		'TTO' => 'Trinidad and Tobago',
		'TUN' => 'Tunisia',
		'TUR' => 'Turkey',
		'TKM' => 'Turkmenistan',
		'TCA' => 'Turks and Caicos Islands',
		'TUV' => 'Tuvalu',
		'UGA' => 'Uganda',
		'UKR' => 'Ukraine',
		'ARE' => 'United Arab Emirates',
		'GBR' => 'United Kingdom',
		'TZA' => 'United Republic of Tanzania',
		'USA' => 'United States',
		'VIR' => 'United States Virgin Islands',
		'XXX' => 'Unknown',
		'URY' => 'Uruguay',
		'UZB' => 'Uzbekistan',
		'VUT' => 'Vanuatu',
		'VEN' => 'Venezuela',
		'VNM' => 'Viet Nam',
		'WLF' => 'Wallis and Futuna Islands',
		'ESH' => 'Western Sahara',
		'YEM' => 'Yemen',
		'YUG' => 'Yugoslavia',
		'ZMB' => 'Zambia',
		'ZWE' => 'Zimbabwe'
	);
?>