<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	// Check if Summer Cart has been setup
	if (!miSettings::singleton()->exists('MI_DEFAULT_DB_HOST')) {
		header('Location: setup/');
		exit;
	}
	
	function setupAutoloading()
	{
		$autoloadClasses = array(
			'IDashboardBox' => 'dashboard/IDashboardBox.php',
			'scDashboardBoxCategoryReport' => 'dashboard/DashboardBoxCategoryReport.php',
			'scDashboardBoxProductReport' => 'dashboard/DashboardBoxProductReport.php',
			'scDashboardBoxRecentOrders' => 'dashboard/DashboardBoxRecentOrders.php',
			'scDashboardBoxViewsVisitsReport' => 'dashboard/DashboardBoxViewsVisitsReport.php',
			
			'scViewMapperBundleProducts' => 'model/ViewMapperBundleProducts.php',
			'scViewMapperCustomUrls' => 'model/ViewMapperCustomUrls.php',
			'scViewMapperGalleryItemImage' => 'model/ViewMapperGalleryItemImage.php',
			'scViewMapperCmsBoxOptions' => 'model/ViewMapperCmsBoxOptions.php',
			'scViewMapperCmsMenuItemImage' => 'model/ViewMapperCmsMenuItemImage.php',
			'scViewMapperDynamicPageAreas' => 'model/ViewMapperDynamicPageAreas.php',
			'scViewMapperDynRows' => 'model/ViewMapperDynRows.php',
			'scViewMapperFields' => 'model/ViewMapperFields.php',
			'scViewMapperItemsWithValues' => 'model/ViewMapperItemsWithValues.php',
			'scViewMapperLocalOptions' => 'model/ViewMapperLocalOptions.php',
			'scViewMapperModuleOptions' => 'model/ViewMapperModuleOptions.php',
			'scViewMapperMultiValues' => 'model/ViewMapperMultiValues.php',
			'scViewMapperNewsletters' => 'model/ViewMapperNewsletters.php',
			'scViewMapperProductEgoods' => 'model/ViewMapperProductEgoods.php',
			'scViewMapperProductEgoodsDir' => 'model/ViewMapperProductEgoods.php',
			'scViewMapperProductImages' => 'model/ViewMapperProductImages.php',
			'scViewMapperProductOptionGroups' => 'model/ViewMapperProductOptionGroups.php',
			'scViewMapperProductPrices' => 'model/ViewMapperProductPrices.php',
			'scViewMapperProductVariantOptions' => 'model/ViewMapperProductVariantOptions.php',
			'scViewMapperProductVariants' => 'model/ViewMapperProductVariants.php',
			'scViewMapperShippingModuleOptions' => 'model/ViewMapperShippingModuleOptions.php',
			'scViewMapperTwoLevelDynRows' => 'model/ViewMapperTwoLevelDynRows.php',
			'scViewMapperUploadImage' => 'model/ViewMapperUploadImage.php',
			
			'scSqlRecord' => 'model/SqlRecord.php',
			'scSqlRecordML' => 'model/SqlRecordML.php',
			'scPropertiesRecordML' => 'model/PropertiesRecordML.php',
			
			'scSqlRecordsetML' => 'model/SqlRecordsetML.php',
			'scPreparedRecordset' => 'model/PreparedRecordset.php',
			'scSqlTreeRecordset' => 'model/SqlTreeRecordset.php',
			'scSqlTreeRecordsetML' => 'model/SqlTreeRecordsetML.php',
			
			'scSqlFilterDatePeriod' => 'model/SqlFilters.php',
			'scSqlFilterCheckbox' => 'model/SqlFilters.php',
			'scSqlFilterIsNull' => 'model/SqlFilters.php',
			'scSqlFilterOr' => 'model/SqlFilters.php',
			
			'scDomainToRecordAdapter' => 'model/DomainToRecordAdapter.php',
			
			'scDomainObject' => 'domainobj/DomainObject.php',
			'scAdministratorDomainObject' => 'domainobj/AdministratorDomainObject.php',
			'scBundleProductDomainObject' => 'domainobj/BundleProductDomainObject.php',
			'scCategoryDomainObject' => 'domainobj/CategoryDomainObject.php',
			'scCmsBoxDomainObject' => 'domainobj/CmsBoxDomainObject.php',
			'scCountryDomainObject' => 'domainobj/CountryDomainObject.php',
			'scCurrencyDomainObject' => 'domainobj/CurrencyDomainObject.php',
			'scCustomUrlDomainObject' => 'domainobj/CustomUrlDomainObject.php',
			'scCustomerAddress' => 'domainobj/CustomerAddress.php',
			'scCustomerDomainObject' => 'domainobj/CustomerDomainObject.php',
			'scCustomerGroupDomainObject' => 'domainobj/CustomerGroupDomainObject.php',
			'scBonusPointsTransaction' => 'domainobj/BonusPointsTransaction.php',
			'scEgoodDomainObject' => 'domainobj/EgoodDomainObject.php',
			'scGalleryDomainObject' => 'domainobj/GalleryDomainObject.php',
			'scGalleryItemDomainObject' => 'domainobj/GalleryItemDomainObject.php',
			'scLanguageDomainObject' => 'domainobj/LanguageDomainObject.php',
			'scLocalOptionDomainObject' => 'domainobj/LocalOptionDomainObject.php',
			'scLocalOptionGroupDomainObject' => 'domainobj/LocalOptionGroupDomainObject.php',
			'scManufacturerDomainObject' => 'domainobj/ManufacturerDomainObject.php',
			'scMenuDomainObject' => 'domainobj/MenuDomainObject.php',
			'scMenuItemDomainObject' => 'domainobj/MenuItemDomainObject.php',
			'scOptionGroupDomainObject' => 'domainobj/OptionGroupDomainObject.php',
			'scOrder' => 'domainobj/Order.php',// Order Domain Object backwards compatible with scOrder SqlRecord
			'scOrderDomainObject' => 'domainobj/Order.php',
			'scOrderItem' => 'domainobj/OrderItem.php',
			'scOrderItemEgood' => 'domainobj/OrderItemEgood.php',
			'scOrderItemLocalOption' => 'domainobj/OrderItemLocalOptionDomainObject.php',
			'scOrderItemOption' => 'domainobj/OrderItemOptionDomainObject.php',
			'scOrderTotalLineDomainObject' => 'domainobj/OrderTotalLineDomainObject.php',
			'scPaymentModule' => 'domainobj/PaymentModule.php',
			'scProductClassAttributeDomainObject' => 'domainobj/ProductClassAttributeDomainObject.php',
			'scProductClassDomainObject' => 'domainobj/ProductClassDomainObject.php',
			'scProductDomainObject' => 'domainobj/ProductDomainObject.php',
			'scProductEgood' => 'domainobj/ProductEgood.php',
			'scProductImageDomainObject' => 'domainobj/ProductImageDomainObject.php', 
			'scProductVariant' => 'domainobj/ProductVariant.php',
			'scShippingModulesDomainObject' => 'domainobj/ShippingModulesDomainObject.php',
			'scShippingZonesDomainObject' => 'domainobj/ShippingZonesDomainObject.php',
			'scSkinDomainObject' => 'domainobj/SkinDomainObject.php',
			'scStateDomainObject' => 'domainobj/StateDomainObject.php',
			
			'IAdminModule' => 'interfaces/IAdminModule.php',
			'ICartItem' => 'interfaces/ICartItem.php',
			'ICheckoutModule' => 'interfaces/ICheckoutModule.php',
			'ICheckoutModuleButton' => 'interfaces/ICheckoutModule.php',
			'ICMSBlock' => 'interfaces/ICMSBlock.php',
			'ICMSBox' => 'interfaces/ICMSBox.php',
			'ICurrencyRates' => 'interfaces/ICurrencyRates.php',
			'IFieldsDataProvider' => 'interfaces/IFieldsDataProvider.php',
			'IMenu' => 'interfaces/IMenu.php',
			'IModuleOptions' => 'interfaces/IModuleOptions.php',
			'IOrderTotalModule' => 'interfaces/IOrderTotalModule.php',
			'IProductDetails' => 'interfaces/IProductDetails.php',
			'IProductsListingFilter' => 'interfaces/IProductsListingFilter.php',
			'IPaymentModule' => 'interfaces/IPaymentModule.php',
			'IPaymentModuleOperations' => 'interfaces/IPaymentModuleOperations.php',
			'IProductListingItem' => 'interfaces/IProductListingItem.php',
			'IProductPriceModifier' => 'interfaces/IProductPriceModifier.php',
			'ISet' => 'util/Set.php',
			'IShippingLabel' => 'interfaces/IShippingLabel.php',
			'IShippingLabelModule' => 'interfaces/IShippingLabelModule.php',
			'IShippingModule' => 'interfaces/IShippingModule.php',
			'IShippingModuleCodInfo' => 'interfaces/IShippingModuleCodInfo.php',
			'IStockable' => 'interfaces/IStockable.php',
			'IUserModule' => 'interfaces/IUserModule.php',
			'scProductPriceModification' => 'interfaces/IProductPriceModifier.php',
			
			'scReportGenerator' => 'reports/ReportGenerator.php',
			'scReportUnitOfTime' => 'reports/ReportUnitOfTime.php',
			'scReportDefinitions' => 'reports/ReportDefinitions.php',
			'scReportColumnsFormatter' => 'reports/ReportColumnsFormatter.php',
			
			'scBackAction' => 'control/Actions.php',
			'scCreateAction' => 'control/CreateAndListAction.php',
			'scCreateAndListAction' => 'control/CreateAndListAction.php',
			'scExecChangeIsActiveAction' => 'control/Actions.php',
			'scExecCreateAndListAction' => 'control/CreateAndListAction.php',
			'scExecMoveUpAction' => 'control/SortActions.php',
			'scExecMoveDownAction' => 'control/SortActions.php',
			'scExportCSVAction' => 'control/Actions.php',
			'scPrintAction' => 'control/Actions.php',
			'scProductsListingAction' => 'control/ProductsListingAction.php',
			'scSortAction' => 'control/SortActions.php',
			
			'scApiPrivs' => 'util/auth/ApiPrivs.php',
			'scSections' => 'util/auth/Sections.php',
			'scAuth' => 'util/auth/Auth.php',
			'scAdminAuth' => 'util/auth/AdminAuth.php',
			'scCustomerAuth' => 'util/auth/CustomerAuth.php',
		
			'scCart' => 'util/cart/Cart.php',
			'scCartItem' => 'util/cart/CartItem.php',
			'scCartItemInfo' => 'util/cart/CartItem.php',
			'scCartItemProduct' => 'util/cart/CartItem.php',
			'scCartItemProductBundle' => 'util/cart/CartItem.php',
			'scCartItemProductVariant' => 'util/cart/CartItem.php',
			'scCartItemService' => 'util/cart/CartItemService.php',
			'ICartItemProductBundle' => 'util/cart/CartItem.php',
			'ICartItemProductVariant' => 'util/cart/CartItem.php',
			'scOrderTotal' => 'util/cart/OrderTotal.php',
			'scOrderTotalLine' => 'util/cart/OrderTotalLine.php',
			'scOrderTotalLineWithParam' => 'util/cart/OrderTotalLine.php',
			'scCartItemBundleOptionsInfo' => 'util/cart/CartItemOptions.php',
			'scCartItemBundleOptionsRetriever' => 'util/cart/CartItemOptions.php',
			'scCartItemLocalOptionsRetriever' => 'util/cart/CartItemOptions.php',
			'scCartItemOptions' => 'util/cart/CartItemOptions.php',
			'scCartItemOptionsInfo' => 'util/cart/CartItemOptions.php',
			'scCartItemOptionsRetriever' => 'util/cart/CartItemOptions.php',
			'scCartItemOptionsRetrieverInfo' => 'util/cart/CartItemOptions.php',
			'scCartItemProductOptionsRetriever' => 'util/cart/CartItemOptions.php',
			
			'scCategories' => 'util/category/Categories.php',
			'scCategorySL' => 'util/category/CategorySL.php',
			'scNestedSet' => 'util/category/NestedSet.php',
			'scTreeUtil' => 'util/category/TreeUtil.php',
			
			'scAdminMenus' => 'util/cms/AdminMenus.php',
			'scUserMenus' => 'util/cms/UserMenus.php',
			'scUserMenuItem' => 'util/cms/UserMenus.php',
			'scDynamicPages' => 'util/cms/DynamicPages.php',
			'scLayout' => 'util/cms/Layout.php',
			'scSkins' => 'util/cms/Skins.php',
			'scCMS' => 'util/cms/CMS.php',
			'scBreadcrumb' => 'util/cms/Breadcrumb.php',
			'scSkinSettingsUtil' => 'util/cms/SkinSettingsUtil.php',
			'scCmsBoxTypes' => 'util/cms/CmsBoxTypes.php',
			'scFormItem' => 'util/cms/FormItem.php',
			'scMenuItemImageTypes' => 'util/cms/MenuItemImageTypes.php',
			
			'scCurrency' => 'util/currency/Currency.php',
			'scCurrencyRate' => 'util/currency/CurrencyRate.php',
			'scCurrencyUtil' => 'util/currency/CurrencyUtil.php',
			'scMultiCurrencyAmount' => 'util/currency/MultiCurrencyAmount.php',
			'scMultiCurrencyAmountMath' => 'util/currency/MultiCurrencyAmountMath.php',
			'scUnsupportedCurrency' => 'util/currency/Currency.php',
			
			'scAddress' => 'util/customer/Address.php',
			'scBonusPoints' => 'util/customer/BonusPoints.php',
			'scCustomerGroups' => 'util/customer/CustomerGroups.php',
			'scCustomers' => 'util/customer/Customers.php',
			'scCustomerStatuses' => 'util/customer/CustomerStatuses.php',
			
			'scCryptUtil' => 'util/crypt/CryptUtil.php',
			
			'scDiscount' => 'util/discount/Discount.php',
			'scDiscountService' => 'util/discount/DiscountService.php',
			
			'scEmail' => 'util/email/Email.php',
			'scEmailAddress' => 'util/email/Email.php',
			'scEmailAttachment' => 'util/email/Email.php',
			'scEmailNotifications' => 'util/email/EmailNotifications.php',
			
			'scFile' => 'util/file/File.php',
			'scFilesUtil' => 'util/file/FilesUtil.php',
			'scUploadedFile' => 'util/file/UploadedFile.php',
			
			'scCountry' => 'util/geo/Country.php',
			'scShippingZone' => 'util/geo/ShippingZones.php',
			'scZones' => 'util/geo/Zones.php',
			
			'scInterfaceTexts' => 'util/lang/InterfaceTexts.php',
			'scMultiLanguage' => 'util/lang/MultiLanguage.php',
			'scFindTexts' => 'util/lang/FindTexts.php',
			'scXliffExport' => 'util/lang/XliffExport.php',
			'scXliffExportUserInterfaceTexts' => 'util/lang/XliffExport.php',
			'scXliffExportHelps' => 'util/lang/XliffExport.php',
			'scXliffExportQuickLinks' => 'util/lang/XliffExport.php',
			'scXliffExportCountries' => 'util/lang/XliffExport.php',
			'scXliffExportStates' => 'util/lang/XliffExport.php',
			'scXliffExportCurrencies' => 'util/lang/XliffExport.php',
			'scXliffExportOrderStatuses' => 'util/lang/XliffExport.php',
			'scXliffImport' => 'util/lang/XliffImport.php',
			'scXliffImportUserInterfaceTexts' => 'util/lang/XliffImport.php',
			'scXliffImportCurrencies' => 'util/lang/XliffImport.php',
			'scXliffImportHelps' => 'util/lang/XliffImport.php',
			'scXliffImportQuickLinks' => 'util/lang/XliffImport.php',
			'scXliffImportCountries' => 'util/lang/XliffImport.php',
			'scXliffImportStates' => 'util/lang/XliffImport.php',
			'scXliffImportOrderStatuses' => 'util/lang/XliffImport.php',
			'scArchiveZip' => 'util/archives/ArchiveZip.php',
			
			'scManufacturersCache' => 'util/manufacturer/ManufacturersCache.php',
			
			'scModulesFactory' => 'util/modules/ModulesFactory.php',
			'scModuleOptions' => 'util/modules/ModuleOptions.php',
			'scModuleOptionsInfo' => 'util/modules/ModuleOptionsInfo.php',
			'scModuleUtil' => 'util/modules/ModuleUtil.php',
			'scAdminModuleManager' => 'util/modules/ModuleManager.php',
			'scUserModuleManager' => 'util/modules/ModuleManager.php',
			
			'scOrdersCache' => 'util/order/OrdersCache.php',
			'scOrderDetailsUtil' => 'util/order/OrderDetailsUtil.php',
			'scOrdersInProgress' => 'util/order/OrdersInProgress.php',
			'scOrderService' => 'util/order/OrderService.php',
			'scOrderStatus' => 'util/order/OrderStatus.php',
			'scOrderStatuses' => 'util/order/OrderStatuses.php',
			'scOrderStatusInventoryAction' => 'util/order/OrderStatusInventoryAction.php',
			
			'scPaymentAVS' => 'util/payment/PaymentAVS.php',
			'scPaymentCVN' => 'util/payment/PaymentCVN.php',
			'scPaymentCheck' => 'util/payment/PaymentCheck.php',
			'scPaymentCreditCard' => 'util/payment/PaymentCreditCard.php',
			'scPaymentProcess' => 'util/payment/PaymentProcess.php',
			'scPaymentProcessResult' => 'util/payment/PaymentProcessResult.php',
			'scPaymentProcessException' => 'util/payment/PaymentProcessException.php',
			'scPaymentForms' => 'util/payment/PaymentForms.php',
			'scPaymentStatus' => 'util/payment/PaymentStatus.php',
			'scTransaction' => 'util/payment/Transaction.php',
			
			'scBundledProduct' => 'util/product/BundledProduct.php',
			'scBundledProductVariant' => 'util/product/BundledProductVariant.php',
			'scLocalOptions' => 'util/product/LocalOptions.php',
			'scLocalOption' => 'util/product/LocalOption.php',
			'scImageInfo' => 'util/product/ImageInfo.php',
			'scPrice' => 'util/product/Price.php',
			'scProductImageInfo' => 'util/product/ImageInfo.php',
			'scProductNoImageImageInfo' => 'util/product/ImageInfo.php',
			'scProductAttributes' => 'util/product/ProductAttributes.php',
			'scProductImage' => 'util/product/ProductImage.php',
			'scProductOption' => 'util/product/ProductOption.php',
			'scProductOptions' => 'util/product/ProductOptions.php',
			'scProductPrice' => 'util/product/ProductPrice.php',
			'scProductSL' => 'util/product/ProductSL.php',
			'scProductService' => 'util/product/ProductService.php',
			'scProductListingService' => 'util/product/ProductListingService.php',
			'scProductSortService' => 'util/product/ProductSortService.php',
			'scProductsXCategories' => 'util/product/ProductsXCategories.php',
			'scProductVariantOption' => 'util/product/ProductVariantOption.php',
			'scProductVariantsUtil' => 'util/product/ProductVariantsUtil.php',
			'scWeight' => 'util/product/Weight.php',
			'scWeightUnits' => 'util/product/WeightUnits.php',
			'scWholesalePrices' => 'util/product/WholesalePrices.php',
			
			'scShippingLabelCache' => 'util/shipping_labels/ShippingLabelCache.php',
			'scShippingLabelUtil' => 'util/shipping_labels/ShippingLabelUtil.php',
			
			// Shipping labels implementations
			'scShippingLabel' => 'util/shipping_labels/ShippingLabel.php',
			'scShippingLabelImage' => 'util/shipping_labels/ShippingLabelImage.php',
			'scShippingLabelImageJpeg' => 'util/shipping_labels/ShippingLabelImage.php',
			'scShippingLabelImageGif' => 'util/shipping_labels/ShippingLabelImage.php',
			'scShippingLabelImagePng' => 'util/shipping_labels/ShippingLabelImage.php',
			'scShippingLabelHtml' => 'util/shipping_labels/ShippingLabelHtml.php',
			'scShippingLabelPdf' => 'util/shipping_labels/ShippingLabelPdf.php',
			
			'scUserSearch' => 'util/search/UserSearch.php',
			'scSearch' => 'util/search/Search.php',
			'scSearchData' => 'util/search/Search.php',
			
			'scSession' => 'util/session/Session.php',
			'scSessionStorageDB' => 'util/session/SessionStorageDB.php',
			
			'scTax' => 'util/tax/Tax.php',
			'scVatNumbersUtil' => 'util/tax/VatNumbersUtil.php',
			
			'scUtf8' => 'util/utf8/Utf8.php',
			'scUtfCaseMappings'=> 'util/utf8/UtfCaseMappings.php',
			
			'scCustomUrls' => 'util/url/CustomUrls.php',
			'scFriendlyUrl' => 'util/url/FriendlyUrl.php',
			'scSeoUrlTypes' => 'util/url/SeoUrlTypes.php',
			'scUrlResolverFactory' => 'util/url/UrlResolverFactory.php',
			'scUrlUtil' => 'util/url/UrlUtil.php',
			'scUrlResolver' => 'util/url/UrlResolver.php',
			'IUrlResolver' => 'util/url/UrlResolver.php',
			'scBaseUrlResolver' => 'util/url/UrlResolver.php',
			'scCategoryUrlResolver' => 'util/url/UrlResolver.php',
			'scDynamicPageUrlResolver' => 'util/url/UrlResolver.php',
			'scFormUrlResolver' => 'util/url/UrlResolver.php',
			'scGalleryUrlResolver' => 'util/url/UrlResolver.php',
			'scManufacturersUrlResolver' => 'util/url/UrlResolver.php',
			'scNewsUrlResolver' => 'util/url/UrlResolver.php',
			'scProductsUrlResolver' => 'util/url/UrlResolver.php',
			'scProductVariantsUrlResolver' => 'util/url/UrlResolver.php',
			'scRichTextPageUrlResolver' => 'util/url/UrlResolver.php',
			'scWishlistUrlResolver' => 'util/url/UrlResolver.php',
			
			'scAutoCompleteDataRetriever' => 'util/AutoCompleteDataRetriever.php',
			'scCaptchaImage' => 'util/CaptchaImage.php',
			'scCaptchaSecurity' => 'util/CaptchaSecurity.php',
			'scDateTime' => 'util/DateTime.php',
			'scDebug' => 'util/Debug.php',
			'scFieldSet' => 'util/FieldSet.php',
			'scHtmlUtil' => 'util/HtmlUtil.php',
			'scHttp' => 'util/Http.php',
			'scHttpException' => 'util/Exceptions.php',
			'scImageException' => 'util/Exceptions.php',
			'scImageHandler' => 'util/ImageHandler.php',
			'scInstallChecks' => 'util/InstallChecks.php',
			'scJson' => 'util/Json.php',
			'scLicense' => 'util/License.php',
			'scLog' => 'util/Log.php',
			'scNavigationUtil' => 'util/NavigationUtil.php',
			'scOperationsLog' => 'util/OperationsLog.php',
			'scPaths' => 'util/Paths.php',
			'scPrintExportUtil' => 'util/PrintExportUtil.php',
			'scRatingActionsSettings' => 'util/RatingActionsSettings.php',
			'scCategorySeo' => 'util/Seo.php',
			'scDynamicPageSeo' => 'util/Seo.php',
			'scFormSeo' => 'util/Seo.php',
			'scGallerySeo' => 'util/Seo.php',
			'scManufacturerSeo' => 'util/Seo.php',
			'scProductSeo' => 'util/Seo.php',
			'scRichTextPageSeo' => 'util/Seo.php',
			'scSeo' => 'util/Seo.php',
			'scSet' => 'util/Set.php',
			'scSettings' => 'util/Settings.php',
			'scTemplateParser' => 'util/TemplateParser.php',
			'scUtil' => 'util/Util.php',
			'scVersion' => 'util/Version.php',
			'scXml' => 'util/Xml.php',
			
			'scByFieldErrorsHandler' => 'view/ByFieldErrorsHandler.php',
			'scTableRecordsPerPage' => 'view/TableRecordsPerPage.php',
			
			'scValidatorDecimal' => 'view/Validators.php',
			'scValidatorEmail' => 'view/Validators.php',
			'scValidatorHttp' => 'view/Validators.php',
			'scValidatorInt' => 'view/Validators.php',
			'scValidatorMaxValue' => 'view/Validators.php',
			'scValidatorMinValue' => 'view/Validators.php',
			'scValidatorNoEmpty' => 'view/Validators.php',
			'scValidatorProductExists' => 'view/Validators.php',
			'scValidatorSignedInt' => 'view/Validators.php',
			'scValidatorUniqueCustomUrl' => 'view/Validators.php',
			'scValidatorUniqueFields' => 'view/Validators.php',
			'scCurrencyExistsValidator' => 'view/Validators.php',
			'scDiscountValueValidator' => 'view/Validators.php',
			'scImageUploadedValidator' => 'view/Validators.php',
			
			'scAdminDisplayController' => 'control/AdminDisplayController.php',
			'scUserDisplayController' => 'control/UserDisplayController.php',
			'scUIUtil' => 'view/UIUtil.php',
			
			'scTable' => 'view/Table.php',
			'scBonusPointsTransactionsTable' => 'view/BonusPointsTransactionsTable.php',
			'scCustomersTable' => 'view/CustomersTable.php',
			'scDiscountsTable' => 'view/DiscountsTable.php',
			'scFeaturedProductsTable' => 'view/FeaturedProductsTable.php',
			'scMenuItemsTable' => 'view/MenuItemsTable.php',
			'scOptionGroupsTable' => 'view/OptionGroupsTable.php',
			'scOrdersTable' => 'view/OrdersTable.php',
			'scProductsTable' => 'view/ProductsTable.php',
			'scGalleryItemsTable' => 'view/GalleryItemsTable.php',
			
			'scTableSorter' => 'view/TableSorter.php',
			'scTablePager' => 'view/TablePager.php',
			'scUICart' => 'view/UICart.php',
			'scUIProducts' => 'view/UIProducts.php',
			
			'scOrdersUI' => 'view/OrdersUI.php',
			'scAdminOrdersUI' => 'view/OrdersUI.php',
			'scCustomerOrdersUI' => 'view/OrdersUI.php',
			'scEmailOrdersUI' => 'view/OrdersUI.php',
			
			'scCustomerAreaPager' => 'view/CustomerAreaPager.php',
			'scPaymentModuleWebForm' => 'view/PaymentModuleWebForm.php',
			'scMessage' => 'view/Message.php',
			'scView' => 'view/View.php',
			
			'scAmountWidget' => 'widgets/AmountWidget.php',
			'scBundleProductsWidget' => 'widgets/BundleProductsWidget.php',
			'scCategorySelect' => 'widgets/CategorySelect.php',
			'scCaptchaWidget' => 'widgets/CaptchaWidget.php',
			'scCheckoutAllowPointsWidget' => 'widgets/CheckoutAllowPointsWidget.php',
			'scCheckoutShippingMethodWidget' => 'widgets/CheckoutShippingMethodWidget.php',
			'scCheckoutPaymentMethodWidget' => 'widgets/CheckoutPaymentMethodWidget.php',
			'scCMSLayoutSelect' => 'widgets/CMSLayoutSelect.php',
			'scCmsMenuItemsWidget' => 'widgets/CMSMenuItemsWidget.php',
			'scCustomerSelectWidget' => 'widgets/CustomerSelectWidget.php',
			'scDateWidget' => 'widgets/DateWidget.php',
			'scDoubleListBoxWidget' => 'widgets/DoubleListBoxWidget.php',
			'scDynRowsWidget' => 'widgets/DynRowsWidget.php',
			'scGroupableSelectWidget' => 'widgets/GroupableSelectWidget.php',
			'scHashedPasswordWidget' => 'widgets/HashedPasswordWidget.php',
			'scItemsWithValuesWidget' => 'widgets/ItemsWithValuesWidget.php',
			'scLocalOptionGroupWidget' => 'widgets/LocalOptionGroupWidget.php',
			'scManufacturerSelectWidget' => 'widgets/ManufacturerSelectWidget.php',
			'scMultipleCheckboxesWidget' => 'widgets/MultipleCheckboxesWidget.php',
			'scSkinSettingsWidget' => 'widgets/SkinSettingsWidget.php',
			'scTableWidget' => 'widgets/TableWidget.php',
			'scTableCheckboxWidget' => 'widgets/TableCheckboxWidget.php',
			'IOptionsWidgetTable' => 'widgets/TableCheckboxWidget.php',
			'scTableRadioWidget' => 'widgets/TableRadioWidget.php',
			
			'scCityNameWidget' => 'widgets/CityNameWidget.php',
			'scCustomUrlsWidget' => 'widgets/CustomUrlsWidget.php',
			'scDefaultDynRowWidget' => 'widgets/DefaultDynRowWidget.php',
			'scFileUploadDynRowsWidget' => 'widgets/FileUploadDynRowsWidget.php',
			'scFileUploadWidget' => 'widgets/FileUploadWidget.php',
			'scFormItemsWidget' => 'widgets/FormItemsWidget.php',
			'scImageUploadWidget' => 'widgets/ImageUploadWidget.php',
			'scListBoxWidget' => 'widgets/ListBoxWidget.php',
			'scMenuItemImageWidget' => 'widgets/MenuItemImageWidget.php',
			'scMenuItemPredefinedImagesWidget' => 'widgets/MenuItemImageWidget.php',
			'scModuleOptionsWidget' => 'widgets/ModuleOptionsWidget.php',
			'scModuleOptionMultiCheckboxWidget' => 'widgets/ModuleOptionMultiCheckboxWidget.php',
			'scMultiCheckboxWidget' => 'widgets/MultiCheckboxWidget.php',
			'scMultipleCMSTextareaWidget' => 'widgets/MultipleCMSTextareaWidget.php',
			'scNewslettersWidget' => 'widgets/NewslettersWidget.php',
			'scNumberIntervalWidget' => 'widgets/ProductAttributesSearchWidget.php',
			'scOptionalSelectWidget' => 'widgets/OptionalSelectWidget.php',
			'scOptionalBaseSelectWidget' => 'widgets/OptionalSelectWidget.php',
			'scProductAttributesSearchWidget' => 'widgets/ProductAttributesSearchWidget.php',
			'scProductClassAttributesWidget' => 'widgets/ProductClassAttributesWidget.php',
			'scProductEgoodsWidget' => 'widgets/ProductEgoodsWidget.php',
			'scProductImagesRadio' => 'widgets/ProductImagesRadio.php',
			'scProductOptionsSearchWidget' => 'widgets/ProductOptionsSearchWidget.php',
			'scProductPricesWidget' => 'widgets/ProductPricesWidget.php',
			'scProductSelectWidget' => 'widgets/ProductSelectWidget.php',
			'scProductVariantImageWidget' => 'widgets/ProductVariantImageWidget.php',
			'scProductVariantOptionsListWidget' => 'widgets/ProductVariantOptionsListWidget.php',
			'scStateSelectWidget' => 'widgets/StateSelectWidget.php',
			'scVatNumberWidget' => 'widgets/VatNumberWidget.php',
			'scWebFormFieldHidden' => 'widgets/WebFormFieldHidden.php',
			'scWebFormFieldSelect' => 'widgets/WebFormFieldSelect.php',
			'scWebFormWidgetFileUpload' => 'widgets/FileUploadWidget.php',
			'scWebFormWidgetTextML' => 'widgets/WebFormWidgetTextML.php',
			'scWebFormWidgetTextAreaML' => 'widgets/WebFormWidgetTextML.php',
			'scWebFormWidgetTextarea' => 'widgets/WebFormWidgetTextarea.php',
			'scWeightWidget' => 'widgets/WeightWidget.php',
			
			'miWizardPage' => 'wizard/WizardPage.php',
			'miWizardController' => 'wizard/WizardController.php',
			'miWizardDispatcher' => 'wizard/WizardDispatcher.php',
			'miViewWizardPageAction' => 'wizard/WizardActions.php',
			'miExecWizardPageAction' => 'wizard/WizardActions.php',
			'scCheckoutWizardController' => 'wizard/CheckoutWizardController.php',
			'scCheckoutWizardDispatcher' => 'wizard/CheckoutWizardDispatcher.php',
			'scCheckoutWizardPage' => 'wizard/CheckoutWizardPage.php',
		);
		foreach ($autoloadClasses as $className => &$fileName)
			$fileName = '../sc/' . $fileName;
		miLoader::addClasses($autoloadClasses);
	}
	setupAutoloading();
	
	if (!defined('PHP_INT_MAX'))
		define('PHP_INT_MAX', intval('9223372036854775807'));
	
	// Compress the output, if ob_gzhandler is available. Always buffer the output.
	// We are using double buffring so we can get the length of the gzipped output.
	ob_start();
	$zlibCompression = strtolower(ini_get('zlib.output_compression'));
	$zlibCompression = (($zlibCompression == 'on') or ($zlibCompression == 'true') or ($zlibCompression == 'yes') or $zlibCompression);
	ob_start((function_exists('ob_gzhandler') and !$zlibCompression) ? 'ob_gzhandler' : null);
	
	@date_default_timezone_set(date_default_timezone_get());
	
	// Handle the magic quotes
	if (get_magic_quotes_runtime())
		set_magic_quotes_runtime(0);
	if (get_magic_quotes_gpc()) {
		function stripslashes_recursive($array)
		{
			$r = array();
			foreach ($array as $key => $value)
				$r[stripslashes($key)] = is_scalar($value) ? stripslashes($value) : stripslashes_recursive($value);
			return $r;
		}
		$_GET = stripslashes_recursive($_GET);
		$_POST = stripslashes_recursive($_POST);
		$_REQUEST = stripslashes_recursive($_REQUEST);
		$_COOKIE = stripslashes_recursive($_COOKIE);
		$_FILES = stripslashes_recursive($_FILES);
	}
	
	// Init session
	if (session_id() != '')
		session_destroy();
	ini_set('session.use_trans_sid', 0);
	scSessionStorageDB::singleton();
	
	// Include demo limits file, if it exists
//	if (is_readable(dirname(__FILE__) . '/../demo.php'))
//		include_once(dirname(__FILE__) . '/../demo.php');
	
	/**
	 * Dump function - dumps all it's parameters to the screen
	 * Very useful debugging tool
	 */
	function dump()
	{
		$arguments = func_get_args();
		echo '<pre>';
		foreach ($arguments as $var)
			var_dump($var);
		echo '</pre>';
	}

	/**
	 * Text translation function shortcut
	 *
	 * @param string $text
	 * @return string
	 */
	function _t($text)
	{
		return scInterfaceTexts::getTranslatedText($text);
	}
	
	/**
	 * Internal or development text - should not be translated
	 * 
	 * @param string $text
	 * @return string
	 */
	function _i($text)
	{
		return $text;
	}
?>