<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scAdminDisplayController extends miPage {
		protected $_skin;
		
		public function __construct($views)
		{
			scSkins::singleton()->setLayout(scLayout::AREA_ADMIN);
			
			parent::__construct($views);
			
			// Add up/down arrows functionality to the table
			$this->getDispatcher()->setActionHandler('dmMoveUp', 'scExecMoveUpAction');
			$this->getDispatcher()->setActionHandler('dmMoveDown', 'scExecMoveDownAction');
			$this->getDispatcher()->setActionHandler('dmBack', 'scBackAction');
			
			$this->_skin = scSkins::singleton()->getCurrentSkin();
			
			$this->setHeader('admin/header.tmpl');
			$this->setFooter('admin/footer.tmpl');
		}
		
		public function showPage()
		{
			// Is this ajax call ?
			if (miGetParamDefault('load', '') == 'table') {
//				foreach ($this->_views as $view) {
//					$view->process();
//				}
				foreach ($this->_views as $view) {
					$this->processControllerCommands($view->getControllerCommands());
				}
				return;
			}
			
			if ($this->_headerFileName) {
				$t = new scTemplateParser();
				$t->readTemplate($this->_headerFileName);
				$auth = scAdminAuth::singleton();
				
				$languagesSelection = scMultiLanguage::singleton()->getUILanguageSelectionHtml();
				$t->assign('%%LANGUAGES_SELECTION%%', $languagesSelection);
				
				$t->assign('%%CKEDITOR_KCFINDER_PATH%%', scPaths::getUrl('/modules/system/kcfinder/'));
				
				// If anything is searched save the searched phrase in the search box
				$t->assign('%%PHRASE%%', scSearch::singleton()->getSearchPhrase());
				
/*				$queryParams = scUrlUtil::parseStr($_SERVER['QUERY_STRING']);
				if (isset($queryParams['UILanguage']))
					unset($queryParams['UILanguage']);
				$t->assign('%%URL%%', htmlspecialchars($_SERVER['PHP_SELF'] . '?' . http_build_query($queryParams), ENT_QUOTES));*/
				
				$t->assign('%%ADMINISTRATORUSERNAME%%', miI18N::htmlEscape($auth->getAdministratorUsername()));
				
				// Get the boxes information to setup them in the javascript
				$file = scPaths::getCurrentScriptBaseName();
				$boxes = array();
				$leftBoxes = scLayout::getBoxes(scLayout::COLUMN_LEFT, scLayout::AREA_ADMIN, $file);
				foreach (array_keys($leftBoxes) as $boxId) {
					$row['BoxID'] = $boxId;
					$row['Position'] = 'left';
					$boxes[] = $row;
				}
				
				$rightBoxes = scLayout::getBoxes(scLayout::COLUMN_RIGHT, scLayout::AREA_ADMIN, $file);
				foreach (array_keys($rightBoxes) as $boxId) {
					$row['BoxID'] = $boxId;
					$row['Position'] = 'right';
					$boxes[] = $row;
				}
											
				$section = new miTemplateParserSectionInfo('boxesSetup', count($boxes), miUIUtil::templetizeRows(miUIUtil::transposeRows($boxes)));
				$t->addSectionInfo($section);
				
				$t->templateShow();
			}
			
			echo $this->_skin->getColumn(scLayout::COLUMN_LEFT, scLayout::AREA_ADMIN);
			
//			foreach ($this->_views as $view) {
//				$view->process();
//			}
			foreach ($this->_views as $view) {
				$this->processControllerCommands($view->getControllerCommands());
			}
			
			echo $this->_skin->getColumn(scLayout::COLUMN_RIGHT, scLayout::AREA_ADMIN);
			
			if ($this->_footerFileName) {
				$t = new scTemplateParser();
				$t->readTemplate($this->_footerFileName);
				$t->assign('%%SUMMERCART_VERSION%%', miI18N::htmlEscape(file_get_contents(dirname(__FILE__) . '/../../VERSION')));
				$t->templateShow();
			}
		}
	}
?>