<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scCreateAction extends miCreateAction {
		
		public function setWebForm($form)
		{
			$this->_webForm = $form;
		}
	}
	
	class scCreateAndListAction extends miActionWithWebForm {
		
		public function doAction()
		{
			try {
				$listAction = new miListAction($this->_view);
				$createAction = new scCreateAction($this->_view);
				$createAction->setWebForm($this->getWebForm());
				
				return $this->show($listAction, $createAction);
			} catch (miException $exception) {
				$msg = $this->_view->getMessage('MI_RECORD_LIST_FAILED_MSG');
				$msg = $msg . $exception->getMessage();
				$url = 'customers.php?' . scMessage::PARAM_MESSAGE . '=' . urlencode($msg) . '&' . scMessage::PARAM_MESSAGE_TYPE . ' = ' . scMessage::MSG_TYPE_ERROR;
				$cmd = new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_REDIRECT, $url);
				$this->_view->addControllerCommand($cmd);
				return false;
			};
		}
		
		protected function show($listAction, $createAction)
		{
			if (!$listAction->doAction()) {
				return false;
			}
			
			if (miGetParamDefault('load', '') == 'table') {
				return true;
			}
			
			return $createAction->doAction();
		}
	}
	
	class scExecCreateAndListAction extends scCreateAndListAction {
		
		public function doAction()
		{
			try {
				$form = $this->getWebForm();
				$vmController = $this->_view->getViewMapperController();
				
				$isOk = $form->processSubmit();
				$vmController->setDataFromWebForm();
				
				if ($isOk === false) {
					$vmController->updateSubmittedForm($form);
					parent::doAction();	// Call miCreateAction
					return false;
				}
				
				$this->_view->callPlugin($this, 'preCreate');
				$recordId = $vmController->insert();
				$this->_view->callPlugin($this, 'postCreate');
				
			} catch (miException $exception) {
				$msg = $this->_view->getMessage('MI_RECORD_CREATE_FAILED_MSG');
				$this->_view->addRedirectToListControllerCommand($msg . $exception->getMessage(), miMessage::MSG_TYPE_ERROR);
				return false;
			}
			$msg = sprintf($this->_view->getMessage('MI_RECORD_CREATED_SUCCESSFULLY_MSG'), $recordId);
			$this->_view->addRedirectToListControllerCommand($msg, miMessage::MSG_TYPE_INFO);
			return true;
		}
	}
?>