<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	abstract class scProductsListingAction extends miAction {
		
		abstract protected function getProducts($listingPkValue);
		abstract protected function getProductsCount($listingPkValue);
		
		protected $_cachedConditions = null;
			
		protected function getAdditionalWhereConditions()
		{
			if ($this->_cachedConditions === null) {
				$filters = scModulesFactory::getImplementations('IProductsListingFilter');
				$additionalWhereConditions = array();
				foreach ($filters as $filter) {
					$this->setStatePersistVars($filter);
					$sqlFilters = $filter->getSqlFilters();
					foreach ($sqlFilters as $sqlFilter) {
						$additionalWhereConditions[] = ' AND (' . $sqlFilter . ')';
					}
				}
				$this->_cachedConditions = array_unique($additionalWhereConditions);
			}
			
			return $this->_cachedConditions;
		}
		
		protected function setStatePersistVars(IProductsListingFilter $filter)
		{
			$persistVars = $filter->getFilterVars();
			if (empty($persistVars)) {
				return;
			}
			
			$state = miAppFactory::singleton()->getStateObj();
			$statePersistVars = $state->getPersistVars();
			$statePersistVars = array_merge($statePersistVars, $persistVars);
			$statePersistVars = array_unique($statePersistVars);
			$state->setPersistVars($statePersistVars);
		}
	}
?>