<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scDashboardBoxCategoryReport implements IDashboardBox {
		
		const NUMBER_OF_RECORDS = 10;
		
		public function getDashboardBoxHtml()
		{
			if (!scAdminAuth::singleton()->isAuthorized(scSections::SECTION_REPORT_VIEWS_BY_CATEGORY)) {
				return '';
			}
			
			$options = array(
				scReportDefinitions::REPORT_FIELD_CATEGORY_VIEWS => _t('Category views'),
			);
			$chartValue = miUIUtil::getConstDropdown('ChartValue', scReportDefinitions::REPORT_FIELD_CATEGORY_VIEWS, $options);
			
			$t = new scTemplateParser();
			$t->readTemplate('admin/dashboard/dashboard_report_categories.tmpl');
			$t->assignArray(array(
				'%%ADMINDASHBOARDBOXID%%' => IDashboardBox::DASHBOARD_BOX_CATEGORY_REPORT,
				'%%CHARTVALUE%%' => $chartValue,
				'%%CURRENCYCODE%%' => scCurrencyUtil::getBaseCurrencyCode(),
				'%%NUMBEROFRECORDS%%' => self::NUMBER_OF_RECORDS,
				'%%PERIODWIDGET%%' => scUIUtil::getTimePeriodWidgetHtml(scReportGenerator::getTimeSelectorFilterValues()),
				'%%UNITOFTIME%%' => scReportUnitOfTime::getUnitOfTimeDropdown(),
			));
			return $t->templateParse();
		}
	}
?>