<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scDashboardBoxProductReport implements IDashboardBox {
		
		const NUMBER_OF_RECORDS = 5;
		
		public function getDashboardBoxHtml()
		{
			$accessViews = scAdminAuth::singleton()->isAuthorized(scSections::SECTION_REPORT_VIEWS_BY_PRODUCT);
			$accessSales = scAdminAuth::singleton()->isAuthorized(scSections::SECTION_REPORT_SALES_BY_PRODUCT);
			if (!$accessViews && !$accessSales) {
				return '';
			}
			
			$reportOptions = array();
			$chartValueOptions = array();
			if ($accessSales) {
				$reportOptions['SalesByProduct'] = _t('Sales By Product');
				$chartValueOptions[scReportDefinitions::REPORT_FIELD_PRODUCT_SALES] = _t('Product sales');
			}
			if ($accessViews) {
				$reportOptions['ViewsByProduct'] = _t('Views By Product');
				$chartValueOptions[scReportDefinitions::REPORT_FIELD_PRODUCT_VIEWS] = _t('Product views');
			}
			$report = miUIUtil::getConstDropdown('report', key($reportOptions), $reportOptions);
			$chartValue = miUIUtil::getConstDropdown('ChartValue', key($chartValueOptions), $chartValueOptions);
			
			$t = new scTemplateParser();
			$t->readTemplate('admin/dashboard/dashboard_report_products.tmpl');
			$t->assignArray(array(
				'%%ADMINDASHBOARDBOXID%%' => IDashboardBox::DASHBOARD_BOX_PRODUCT_REPORT,
				'%%REPORT%%' => $report,
				'%%CHARTVALUE%%' => $chartValue,
				'%%CURRENCYCODE%%' => scCurrencyUtil::getBaseCurrencyCode(),
				'%%NUMBEROFRECORDS%%' => self::NUMBER_OF_RECORDS,
				'%%PERIODWIDGET%%' => scUIUtil::getTimePeriodWidgetHtml(scReportGenerator::getTimeSelectorFilterValues()),
				'%%UNITOFTIME%%' => scReportUnitOfTime::getUnitOfTimeDropdown(),
			));
			return $t->templateParse();
		}
	}
?>