<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scDashboardBoxRecentOrders implements IDashboardBox {
		
		const NUMBER_OF_RECORDS = 5;
		
		public function getDashboardBoxHtml()
		{
			if (!scAdminAuth::singleton()->isAuthorized(scSections::SECTION_ORDERS)) {
				return '';
			}
			
			$recordset = new scSqlRecordsetML('Orders', 'OrderID');
			$recordset->setOrder('OrderID', 'DESC');
			$recordset->setSelectFields(array('*, CONCAT(OrderBillingFirstName, " ", OrderBillingLastName) AS OrderCustomerName'));
			$showUnfinishedOrders = scSettings::getSettingValue(scSettings::SETTING_SHOW_UNFINISHED_ORDERS);
			if (empty($showUnfinishedOrders))
				$recordset->addFilter(new miSqlFilterNotEqual('OrderStatus', scOrderStatus::ORDER_STATUS_UNFINISHED));
			$recordset->setRecordsLimit(0, self::NUMBER_OF_RECORDS);
			
			$table = new scOrdersTable($recordset);
			return $table->parse('admin/dashboard/dashboard_recent_orders.tmpl');
		}
	}
?>