<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scBundleProductDomainObject extends miDefaultDomainObject {
		
		public function __construct()
		{
			parent::__construct(new miSqlRecord('BundleProducts', 'BundleProductID'));
		}
		
		public function __clone()
		{
			$this->_record = clone $this->_record;
		}
		
		public function insert()
		{
			$bundleProductId = parent::insert();
			
			$this->updateBundleParent($this->get('ProductID'));
			
			return $bundleProductId;
		}
		
		public function update()
		{
			// Get data that is currently in DB.
			$copy = clone $this;
			$copy->read($this->get('BundleProductID'));
			
			$bundleProductId = parent::update();
			
			$this->updateBundleParent($this->get('ProductID'));
			
			// Check if parent product id has been changed.
			// That's not a normal situation but it is a possible one.
			if ($this->get('ProductID') != $copy->get('ProductID')) {
				$this->updateBundleParent($copy->get('ProductID'));
			}
			
			return $bundleProductId;
		}
		
		public function delete($pkValue = null)
		{
			if (!is_null($pkValue)) {
				$this->read($pkValue);
			} else {
				$this->read($this->get('BundleProductID'));
			}
			
			$return = parent::delete($pkValue);
			
			$this->updateBundleParent($this->get('ProductID'));
			
			return $return;
		}
		
		protected function updateBundleParent($productId)
		{
			$parentProduct = new scProductDomainObject();
			$parentProduct->read($this->get('ProductID'));
			$parentProduct->set('ProductIsBundle', true);
			$parentProduct->retrieveBundleData();
			$parentProduct->update();
		}
	}
?>