<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scCountryDomainObject extends miDefaultDomainObject
	{
		public function __construct()
		{
			parent::__construct(new scSqlRecordML('Countries', 'CountryID',
				array('CountryName'), array_keys(scMultiLanguage::getActiveLanguageCodes())));
		}
		
		public function getTableName()
		{
			return $this->_record->getTableName();
		}
		
		public function set($field, $value)
		{
			if (($field == 'CountryCode2') or ($field == 'CountryCode3'))
				$value = strtoupper($value);
			parent::set($field, $value);
		}
		
		public function delete($pkValue = null)
		{
			$customersInCountry = new miSqlRecordset('CustomerAddresses');
			$customersInCountry->addFilter(new miSqlFilterEqual('CountryID', $pkValue));
			if ($customersInCountry->getRecordsCount() > 0) {
				throw new miException(_t('There are customers having their billing and/or shipping address in this country.'));
			}
			
			parent::delete($pkValue);
		}
	}
?>