<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scCurrencyDomainObject extends scDomainObject
	{
		protected $_currencyCodeChanged = false;
		
		public function set($name, $value)
		{
			if ($name == 'CurrencyCode') {
				if ($this->get($name) != $value) {
					$this->_currencyCodeChanged = true;
				}
				$value = strtoupper($value);
			}
			parent::set($name, $value);
		}
		
		public function insert()
		{
			$this->set('CurrencyRateLastUpdated', time());

			parent::insert();
		}
		
		public function update()
		{
			$this->set('CurrencyRateLastUpdated', time());

			parent::update();
		}
		
		public function validate()
		{
			if (($this->get('CurrencyAllowFixedPrices')) && ($this->_currencyCodeChanged))
				throw new miException(_t('You cannot change the currency code for currencies which allow fixed prices.'));
		}
	}
?>