<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scCustomerGroupDomainObject extends scDomainObject {
		
		public function __construct()
		{
			parent::__construct(new scSqlRecordML('CustomerGroups', 'CustomerGroupID',
				array('CustomerGroupName'), array_keys(scMultiLanguage::getActiveLanguageCodes())));
		}
		
		public function insert()
		{
			$customerGroupId = parent::insert();
			
			$defaultCustomerGroupId = (int)scSettings::getSettingValue(scSettings::SETTING_DEFAULT_CUSTOMER_GROUP);
			$sql = 'INSERT INTO ProductWholesalePrices (CustomerGroupID, ProductID, ProductVariantID, ProductWholesalePriceQuantity, ProductWholesalePriceAmount)' .
				'(SELECT ?, ProductID, ProductVariantID, ProductWholesalePriceQuantity, ProductWholesalePriceAmount' .
				' FROM ProductWholesalePrices WHERE CustomerGroupID=?)';
			miStaticDBUtil::execSQL($sql, array($customerGroupId, $defaultCustomerGroupId));
			
			return $customerGroupId;
		}
		
		public function delete($pkValue = null)
		{
			$customersCount = miStaticDBUtil::execSelect('SELECT COUNT(*) AS N FROM Customers WHERE CustomerGroupID = ?', array($pkValue));
			
			if (intval($customersCount[0]['N']) > 0)
				throw new miException(_t('To delete this customer group, no customers should be assigned to it.'));
			
			parent::delete($pkValue);
		}
	}
?>