<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scLocalOptionGroupDomainObject extends scOptionGroupDomainObject {
		
		public function __construct()
		{
			scDomainObject::__construct(new scSqlRecordML('LocalOptionGroups', 'LocalOptionGroupID',
				array('LocalOptionGroupName'), array_keys(scMultiLanguage::getActiveLanguageCodes())));
		}
		
		public function isVariant()
		{
			return ($this->get('LocalOptionGroupType') == scLocalOptions::GROUP_TYPE_VARIANT);
		}
		
		/**
		 * ISet::getValues
		 * @return array
		 */
		public function getValues()
		{
			if (is_null($this->_values)) {
				$recordset = new miSqlRecordset('LocalOptions');
				$recordset->setSelectFields(array('LocalOptionID'));
				$recordset->addFilter(new miSqlFilterEqual($this->getPKName(), $this->get($this->getPKName())));
				$options = $recordset->getAllRecords();
				$values = array();
				foreach ($options as $option) {
					$variantOption = new scProductVariantOption($option['LocalOptionID'], scProductVariantOption::TYPE_LOCAL);
					$variantOption->setIsNewGroup($this->_isNew);
					$values[] = array($variantOption);
				}
				$this->_values = $values;
			}
			return $this->_values;
		}
	}
?>