<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scManufacturerDomainObject extends scDomainObject {
		
		public function __construct()
		{
			parent::__construct(new scSqlRecordML('Manufacturers', 'ManufacturerID',
				array('ManufacturerName', 'ManufacturerDescription', 'ManufacturerSEOTitle'), array_keys(scMultiLanguage::getActiveLanguageCodes())));
		}
		
		public function read($pkValue)
		{
			static $cache = array();
			
			if (isset($cache[$pkValue])) {
				$this->_record->setRow($cache[$pkValue]);
				return;
			}
			
			parent::read($pkValue);
			$cache[$pkValue] = $this->_record->getRow();
		}
		
		public function delete($pkValue = null)
		{
			miStaticDBUtil::execUpdate('Products', array('ManufacturerID' => null), 'ManufacturerID', $pkValue);
			
			return parent::delete($pkValue);
		}
		
		public function getUrl()
		{
			return scFriendlyUrl::get(scFriendlyUrl::TYPE_MANUFACTURER, $this->get('ManufacturerID'), $this->getName());
		}
		
		public function getName()
		{
			$data = $this->get('ManufacturerName');
			$languageId = scMultiLanguage::getCurrentLanguageId();
			if (!isset($data[$languageId])) {
				return '';
			}
			return $data[$languageId];
		}
	}
?>