<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scMenuDomainObject extends miDefaultDomainObject {
		public function __construct()
		{
			$this->_record = new scSqlRecordML('CMSMenus', 'CMSMenuID',
					array('CMSMenuTitle'), array_keys(scMultiLanguage::getActiveLanguageCodes())); 
		}
		
		public function insert()
		{
			$record = new miSqlComplexPKRecord('ModuleClasses', array('ModuleClassInterface', 'ModuleClassName'));
			$record->readPK(
				array(
					'ModuleClassInterface' => 'ICMSBox',
					'ModuleClassName' => 'scCustomerMenuBox'
				)
			);
			
			$moduleId = $record->get('ModuleClassID');
			$values = array(
				'ModuleClassID' => $moduleId,
				'CMSBoxArea' => scLayout::AREA_CUSTOMER,
				'CMSBoxName' => $this->getMenuBoxName(),
				'CMSBoxIsActive' => $this->get('CMSMenuIsActive'),		// NOTE: Possibly not!
				'CMSBoxType' => scCmsBoxTypes::CMS_BOX_TYPE_MENU,
			);
			
			$cmsBoxId = miStaticDBUtil::execInsert('CMSBoxes', $values);
			
			$this->_record->set('CMSBoxID', $cmsBoxId);
				
			return parent::insert();
		}
		
		public function update()
		{
			$values = array('CMSBoxName' => $this->getMenuBoxName());
			miStaticDBUtil::execUpdate('CMSBoxes', $values, 'CMSBoxID', $this->get('CMSBoxID'));
			
			return parent::update();
		}
		
		public function delete($pkValue = null)
		{
			$this->_record->readPK($pkValue);
			$cmsBoxId = $this->_record->get('CMSBoxID');
			
			parent::delete($pkValue);
			
			miStaticDBUtil::execDelete('CMSBoxes', 'CMSBoxID', $cmsBoxId);
			
			return true;
		}
		
		protected function getMenuBoxName()
		{
			return _t('Menu ') . $this->get('CMSMenuName');
		}
	}
?>