<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scOrderItemOption extends miDefaultDomainObject {
		
		/**
		 * @var scOrderItem
		 */
		protected $_orderItem = null;
		
		protected $_fieldGroupType = 'OrderItemOptionGroupType';
		protected $_fieldGroupName = 'OrderItemOptionGroupName';
		
		protected $_fieldName = 'OrderItemOptionName';
		protected $_fieldPrice = 'OrderItemOptionPrice';
		protected $_fieldCustomerCurrencyPrice = 'OrderItemOptionCustomerCurrencyPrice';
		protected $_fieldUserText = 'OrderItemOptionUserText';
		protected $_fieldImage = 'OrderItemOptionImage';
		
		public function __construct()
		{
			parent::__construct($this->getRecord());
		}
		
		/**
		 * @return scOrderItem
		 */
		public function getOrderItem()
		{
			if (is_null($this->_orderItem)) {
				throw new miException(_i('Unknown order item.'));
			}
			
			return $this->_orderItem;
		}
		
		public function getName()
		{
			return $this->get($this->_fieldName);
		}
		
		/**
		 * @return scMultiCurrencyAmount
		 */
		public function getPriceChange()
		{
			$amount = scMultiCurrencyAmount::factory();
			$currency = $this->getOrderItem()->getOrder()->getBaseCurrency();
			$amount->set($currency, $this->get($this->_fieldPrice));
			$currency = $this->getOrderItem()->getOrder()->getCustomerCurrency();
			$amount->set($currency, $this->get($this->_fieldCustomerCurrencyPrice));
			return $amount;
		}
		
		public function getOptionGroupType()
		{
			return $this->get($this->_fieldGroupType);
		}
		
		public function getOptionGroupName()
		{
			return $this->get($this->_fieldGroupName);
		}
		
		public function getUserText()
		{
			return $this->get($this->_fieldUserText);
		}
		
		public function getImage()
		{
			return $this->get($this->_fieldImage);
		}
		
		public function setOrderItem(scOrderItem $orderItem)
		{
			if ($orderItem->get('OrderItemID') != $this->get('OrderItemID')) {
				throw new miException(_i('Wrong order item.'));
			}
			$this->_orderItem = $orderItem;
		}
		
		protected function getRecord()
		{
			return new miSqlRecord('OrderItemOptions', 'OrderItemOptionID');
		}
	}
?>