<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scShippingModulesDomainObject extends scDomainObject {
		
		protected $_defaultShippingModuleName = null;
		
		public function set($field, $value)
		{
			switch ($field)
			{
				case 'ShippingZoneID':
					if ($value == 0)
						$value = null;
					break;
			}
			
			parent::set($field, $value);
		}
		
		public function read($pkValue)
		{
			parent::read($pkValue);
			$displayName = $this->get('ShippingModuleDisplayName');
			foreach($displayName as $languageId => $name) {
				if (empty($name)) {
					$displayName[$languageId] = $this->getDefaultShippingModuleName();
				}
			}
			$this->set('ShippingModuleDisplayName', $displayName);
		}
		
		public function insert()
		{
			$className = scModulesFactory::getModuleClassName($this->get('ModuleID'), 'IShippingModule');
			$shippingModule = new $className($this->get('ModuleID'), null);
			$this->set('ShippingModuleImage', $shippingModule->getShippingModuleImage());
			return parent::insert();
		}
		
		protected function getDefaultShippingModuleName()
		{
			if (is_null($this->_defaultShippingModuleName)) {
				$this->_defaultShippingModuleName = scUtil::getDbValue('Modules', 'ModuleTitle', 'ModuleID', $this->get('ModuleID'), '');
			}
			return $this->_defaultShippingModuleName;
		}
		
	}
?>