<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scSkinDomainObject extends miDefaultDomainObject {
		
		const SINGLE_LOAD_SETTINGS = 1;
		const FORCE_READ_SETTINGS = 2;
		
		/**
		 * @var array
		 */
		protected $_settings = null;
		
		public function __construct()
		{
			parent::__construct(new miSqlRecord('Skins', 'SkinID'));
		}
		
		/**
		 * @param bool $forceRead
		 * @return array
		 */
		public function getSettings($forceRead = self::SINGLE_LOAD_SETTINGS)
		{
			if (is_null($this->_settings) || ($forceRead == self::FORCE_READ_SETTINGS)) {
				$recordset = new miSqlRecordset('SkinSettings');
				$recordset->addFilter(new miSqlFilterEqual('SkinID', $this->get('SkinID')));
				$this->_settings = $recordset->getAllRecords();
				$this->_settings = miUtil::getArrayWithKeys($this->_settings, 'SkinSettingName');
			}
			
			return $this->_settings;
		}
	}
?>