<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * All checkout modules implement this interface
	 */
	interface ICheckoutModule {
		const GUEST_USER_ID = 1;
		
		/**
		 * Checkout module constructor
		 */
		public function __construct($moduleId);
		
		/**
		 * Process the checkout
		 */
		public function checkout();
	}
	
	/**
	 * Returns the button used to select the checkout module
	 */
	interface ICheckoutModuleButton {
		/**
		 * Checkout module constructor
		 */
		public function __construct($moduleId);
		
		/**
		 * Returns HTML for rendering the checkout button
		 * 
		 * @param string $moduleName the module name
		 * @param string $checkoutModuleName the name of the checkout module
		 * @param string $displayName the display name as set in the admin area
		 */
		public function getButtonHtml($moduleName, $checkoutModuleName, $displayName);
	}
?>