<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * All order total modules implement this interface
	 *
	 */
	interface IOrderTotalModule {
		const ORDER_TOTAL_TYPE_SUBTOTAL = 1;
		const ORDER_TOTAL_TYPE_SHIPPING = 2;
		const ORDER_TOTAL_TYPE_SURCHARGE = 3;
		const ORDER_TOTAL_TYPE_DISCOUNT = 4;
		const ORDER_TOTAL_TYPE_COUPON = 5;
		const ORDER_TOTAL_TYPE_TAX = 6;
		const ORDER_TOTAL_TYPE_OTHER = 7;
		const ORDER_TOTAL_TYPE_POINTS = 8;
		
		/**
		 * Order total module constructor
		 */
		public function __construct($moduleId);
		
		/**
		 * Returns order total lines
		 * Each order total line array has the following keys:
		 * description - the order total description, shown to the user
		 * amount - the amount in default currency
		 * type - order total line type
		 * 
		 * @param scCart $cart the shopping cart object
		 * @return array the order total lines info
		 */
		public function getOrderTotalLines(scCart $cart);
	}
?>