<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * Items that can be listed for sale implement this interface
	 */
	interface IProductListingItem extends IStockable {
		
		/**
		 * @return int
		 */
		public function getPK();
		
		/**
		 * @return string
		 */
		public function getName();
		
		/**
		 * @return scPrice
		 */
		public function getPrice();
		
		/**
		 * @return string
		 */
		public function getDescription();
		
		/**
		 * @return string
		 */
		public function getUrl();
		
		/**
		 * @return int
		 */
		public function getProductId();
		
		/**
		 * Return the main category the product is in.
		 * @return int
		 */
		public function getCategoryId();
		
		/**
		 * Return all category IDs that the item is in including additional categories.
		 * @return array
		 */
		public function getAllCategoryIds();
		
		/**
		 * @return int
		 */
		public function getProductClassId();
		
		/**
		 * @return scImageInfo
		 */
		public function getImageInfo();
		
		/**
		 * @return int
		 */
		public function getCreateTimestamp();
		
		/**
		 * @return string
		 */
		public function getSkuCode();
		
		/**
		 * @return scWeight
		 */
		public function getWeight();
		
		/**
		 * @return int or null
		 */
		public function getManufacturerId();
		
		/**
		 * @return scManufacturerDomainObject or null
		 */
		public function getManufacturer();
		
		/**
		 * @return bool
		 */
		public function isEgood();
	}
?>