<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * Modules may give SQL conditions to be applied to the WHERE clauses of
	 * queries that are used for getting the products for a listing.
	 */
	interface IProductsListingFilter {
		
		/**
		 * Return an array of SQL conditions that are going to be used to narrow
		 * the results of products listing queries.
		 * @return array
		 */
		public function getSqlFilters();
		
		/**
		 * Return all variable names that should be used by the stateObj.
		 * @return array
		 */
		public function getFilterVars();
	}
?>