<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */

	/**
	 * Every new shipping label implementation should extend one of the base shippinglabel implementations
	 * scShippingLabelHtml
	 * scShippingLabelPdf
	 * scShippingLabelImageJpeg
	 * scShippingLabelImageGif
	 * scShippingLabelImagePng
	 * located in sc/util/shipping_labels folder
	 */
	interface IShippingLabel {
		// extensions
		const EXTENSION_HTML = 'html';
		const EXTENSION_PDF = 'pdf';
		const EXTENSION_JPG = 'jpg';
		const EXTENSION_GIF = 'gif';
		const EXTENSION_PNG = 'png';
		
		// document types - some shipping labels support a slip and labels for each package in the shipment
		const DOCUMENT_TYPE_SLIP = 'slip';
		const DOCUMENT_TYPE_LABEL = 'label';
		
		/**
		 * returns the content of the shipping label
		 * @param int $orderId
		 * @param array $params optional params
		 */
		public function getContent($orderId, $params = array());
		
		/**
		 * returns a cache file name based on $orderId and the extension
		 * @param int $orderId
		 * @param array $params
		 * @return string 
		 */
		public function getCacheFileName($orderId, $params = array());
		
		/**
		 * returns the extension of the files that are the labels stored in
		 * one of the EXTENSION_ constants
		 * @return string
		 */
		public function getExtension();
	}
?>