<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	interface IShippingLabelModule {
		
		// Open in new page
		const OPEN_TYPE_BLANK = 1;
		
		// Open in inline div 
		const OPEN_TYPE_INLINE = 2;
		
		/**
		 * Returns the content to be printed
		 * @param int $orderId
		 * @return IShippingLabel
		 */
		public function getShippingLabel($orderId);
		
		
		/**
		 * Handles the printing of shipping labels
		 * @param int $orderId
		 * @return void
		 */
		public function handlePrintAction($orderId);
		
		/**
		 * How should we handle the print packing slip button click in the order details view
		 * @param int $orderId  
		 */
		public function getPrintActionOpenType($orderId);
	}
?>