<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * Items (like products) that have quantity implement this interface 
	 */
	interface IStockable {
		
		/**
		 * Returns the current quantity in stock
		 * 
		 * @return int
		 */
		public function getQuantityInStock();
		
		/**
		 * Removes certain number of items from stock
		 * Note: under specific circumstances (i.e. concurrent purchases) it is possible to remove from stock more
		 * stock items than currently available, thus it is wise to support negative quantity.
		 * 
		 * @param int $itemsRemoved
		 */
		public function reduceQuantityInStock($itemsRemoved);
		
		/**
		 * @param int $newQuantityInStock
		 */
		public function setQuantityInStock($newQuantityInStock);
		
		/**
		 * @param int $quantity The quantity that is considered "in stock"
		 * @return bool
		 */
		public function isOutOfStock($quantity = 1);
	}
?>