<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scSqlRecord extends miSqlRecord {
		protected $_isMultiLanguage;
		
		public function __construct($table, $primaryKey, $isMultiLanguage = false)
		{
			parent::__construct($table, $primaryKey);
			$this->_isMultiLanguage = $isMultiLanguage;
		}
		
		public function read($key, $value)
		{
			if ($this->_isMultiLanguage)
				$this->readML($key, $value);
			else
				parent::read($key, $value);
		}
		
		public function readML($key, $value, $languageId = null)
		{
			if ($languageId == null)
				$languageId = scMultiLanguage::getCurrentLanguageId();
			
			$query = 'SELECT * FROM ' . $this->_table . ' JOIN ' . $this->_table .
				'ML USING(' . $this->_primaryKey . ') WHERE ' . $this->_table . '.' . $key . '="' . sql_escape_string($value) .
				'" AND LanguageID="' . sql_escape_string($languageId) . '"';
			$rows = miStaticDBUtil::execSelect($query);
			if (count($rows)<1) {
				throw new miDBException('Record not found', miDBException::EXCEPTION_RECORD_NOT_FOUND);
			}
			
			$this->_row = $rows[0];
		}
	}
?>