<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scSqlTreeRecordsetML extends scSqlTreeRecordset {
		protected $_languageId = 0;
		protected $_originalTableName = '';
		
		public function __construct($table, $primaryKey, $parentKey)
		{
			parent::__construct($table, $primaryKey, $parentKey);
			$this->_originalTableName = $table;
		}
		
		/**
		 * Sets the language id
		 * Once the language id has been set it cannot be changed
		 *
		 * @param int $languageId
		 */
		public function setLanguageId($languageId)
		{
			if ($this->_languageId or !$languageId)
				return;
			
			$this->_languageId = (int)$languageId;
			$joinCondition = 'ON ' . $this->_table . '.' . $this->_primaryKey . '=' . $this->_table . 'ML.' . $this->_primaryKey .
				' AND ' . $this->_table . 'ML.LanguageID=' . $this->_languageId; 
			$this->addJoinCondition('RIGHT', $this->_table, $joinCondition);
			$this->_table .= 'ML';
		}
		
		/**
		 * Retrieves the language id
		 *
		 * @return int
		 */
		public function getLanguageId()
		{
			return $this->_languageId;
		}
		
		protected function getNonTreeRecordset()
		{
			return new miSqlRecordset($this->_originalTableName);
		}
		
		protected function getNonTreeRecordsetPK()
		{
			return $this->_originalTableName . '.' . $this->_primaryKey;
		}
	}
?>