<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scViewMapperCmsBoxOptions extends scViewMapperModuleOptions {
		
		protected $_cmsBoxId = null;
		
		public function setCmsBoxId($cmsBoxId)
		{
			$this->_cmsBoxId = $cmsBoxId;
		}
		
		public function read()
		{
			$this->_optionValues = scModuleOptions::getCmsBoxOptions($this->_cmsBoxId, scModuleOptions::MODULE_OPTIONS_INCLUDE_FULL_ML);
			$this->callModuleModelStrategies('read');
		}
		
		protected function updateModuleOptionValues($moduleId, $moduleOptions)
		{
			// Start transaction
			miStaticDBUtil::startTransaction();
			
			// Delete the old options
			miStaticDBUtil::execDelete('CMSBoxOptions', 'CMSBoxID', $this->_cmsBoxId);
			miStaticDBUtil::execDelete('CMSBoxOptionsML', 'CMSBoxID', $this->_cmsBoxId);
			
			// Insert the option values
			foreach ($moduleOptions as $moduleOptionName => $moduleOptionValue) {
				scModuleOptions::createCmsBoxOption($this->_cmsBoxId, $moduleOptionName, $moduleOptionValue);
			}
			
			// Commit
			miStaticDBUtil::commit();
		}
	}
?>