<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scViewMapperDynamicPageAreas extends miViewMapper {
		protected $_tableName = 'CMSDynamicPageAreas';
		protected $_tableKeyName = 'CMSDynamicPageID';
		protected $_tableValueName = 'CMSDynamicPageAreaID';
		protected $_items = array(); // array with items data
		
		public function getCMSDynamicPageId()
		{
			return $this->getViewMapperController()->getDomainObject()->get($this->_tableKeyName);
		}

		public function get($fieldName)
		{
			$result = array();
			// Return the read() data into a more abstract format suitable for the widget
			foreach ($this->_items as $iItemId => $iItemData) {
				$result[$iItemId] = array(
					'id' => $iItemData['CMSDynamicPageAreaID'],
					'title' => $iItemData['CMSDynamicPageAreaTitle'],
					'value' => isset($iItemData['CMSDynamicPageAreaText']) ? $iItemData['CMSDynamicPageAreaText'] : '', 
				);
			}			
			
			return $result;
		}		
		
		public function set($fieldName, $fieldValue)
		{
			return $this->_items = $fieldValue;
		}
		
		public function read()
		{
			$sql = 'SELECT * FROM CMSDynamicPageAreas WHERE CMSDynamicPageID = "' . sql_escape_string($this->getCMSDynamicPageId()) . '"';
			$pageAreaIds = miUtil::getDBArray($sql, 'CMSDynamicPageAreaID', 'CMSDynamicPageAreaID');
			$pageAreasData = array();
			foreach ($pageAreaIds as $iPageAreaId) {
				$pageAreaRecord = new scSqlRecordML('CMSDynamicPageAreas', 'CMSDynamicPageAreaID', array('CMSDynamicPageAreaText'), array_keys(scMultiLanguage::getActiveLanguageCodes()));
				$pageAreaRecord->readPK((int) $iPageAreaId);
				$pageAreasData[(int) $iPageAreaId] = $pageAreaRecord->getRow();
			}

			$this->_items = $pageAreasData;
		}
		
		public function insert()
		{
			$this->update();
		}

		public function update()
		{
			$dynamicPageId = $this->getCMSDynamicPageId();

			// Save dynamic page areas
			$records = array();
			$pageAreaRecord = new scSqlRecordML('CMSDynamicPageAreas', 'CMSDynamicPageAreaID', array('CMSDynamicPageAreaText'), array_keys(scMultiLanguage::getActiveLanguageCodes()));
			foreach ($this->_items as $pageAreaId => $pageArea) {
				$recordRow = array(
					'CMSDynamicPageAreaID' => $pageArea['id'],
					'CMSDynamicPageAreaText' => $pageArea['value'],
				);
				$pageAreaRecord->setRow($recordRow);
				$pageAreaRecord->update();
			}
		}
	}
?>