<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scViewMapperShippingModuleOptions extends scViewMapperModuleOptions {
		protected $_shippingModuleId;
		
		public function setShippingModuleId($shippingModuleId)
		{
			$this->_shippingModuleId = $shippingModuleId;
		}
		
		public function read()
		{
			$this->_optionValues = scModuleOptions::getShippingModuleOptions($this->_shippingModuleId);
			$this->callModuleModelStrategies('read');
		}
		
		protected function updateModuleOptionValues($moduleId, $moduleOptions)
		{
			// Start transaction
			miStaticDBUtil::startTransaction();
			
			// Delete the old options
			miStaticDBUtil::execDelete('ShippingModuleOptions', 'ShippingModuleID', $this->_shippingModuleId);
			
			// Insert the option values
			foreach ($moduleOptions as $moduleOptionName => $moduleOptionValue) {
				scModuleOptions::createShippingModuleOption($this->_shippingModuleId, $moduleOptionName, $moduleOptionValue);
			}
			
			// Commit
			miStaticDBUtil::commit();
		}
	}
?>