<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	abstract class scViewMapperTwoLevelDynRows extends scViewMapperDynRows {
		
		abstract protected function readValues($rsProperties, &$records);
		abstract protected function deleteOldValues($rsProperties);
		abstract protected function addValuesToRecords($rsProperties, $records, $values);
		
		protected function readRecords($rsProperties)
		{
			$records = parent::readRecords($rsProperties);
			if (count($records) == 0)
				return $records;
			
			$values = $this->readValues($rsProperties, $records);
			$records = $this->addValuesToRecords($rsProperties, $records, $values);
			
			return $records;
		}
		
		protected function saveDynRows($rsValues, $rsProperties)
		{
			$this->deleteOldValues($rsProperties);
			
			parent::saveDynRows($rsValues, $rsProperties);
		}
		
		protected function deleteDynRows($rsProperties)
		{
			$this->deleteOldValues($rsProperties);
			
			parent::deleteDynRows($rsProperties);
		}
	}
?>