<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	abstract class scAutoCompleteDataRetriever {
		const DEFAULT_RESULTS = 10;
		const MAX_RESULTS = 100;
		const DEFAULT_CELL_SEPARATOR = "\x1f";	// ASCII code for Unit Separator
		
		/**
		 * The string to search for in the products table
		 */
		protected $_searchStr;
		
		/**
		 * The separator between the returned fields
		 */
		protected $_cellSeparator;

		/**
		 * The maximum number of records returned
		 */
		protected $_recordsLimit;
		
		public function __construct($searchStr, $recordsLimit = self::DEFAULT_RESULTS, $cellSeparator = self::DEFAULT_CELL_SEPARATOR)
		{
			$this->_searchStr = $searchStr;
			$this->_cellSeparator = $cellSeparator;
			$this->_recordsLimit = min($recordsLimit, self::MAX_RESULTS);
		}
		
		protected function sanitize($str)
		{
			return str_replace($this->_cellSeparator, '', $str);
		}
		
		protected function selectRows($query, $params = array())
		{
			if ($this->_recordsLimit) {
				$query .= ' LIMIT ' . (int) $this->_recordsLimit;
			}
			
			return miStaticDBUtil::execSelect($query, $params);
		}
		
		abstract public function outputData();
	}
?>