<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scCaptchaSecurity {
		
		// default configuration
		protected $_config = array(
			'sessionName' => 'CapthaCode',
			'minLength' => 6,
			'maxLength' => 7,
			'allowedCharacters' => 'abcDE6FdefhWXYimn2pqrs3tuvw4xyzA5BCG1gHIJ7KjkLMNP8QRSTU9VZ'
		);
		
		/*
		 * overide default config with any custom configs
		 */ 
		public function __construct($config = array())
		{
			$this->_config = array_merge($this->_config, $config);
		}
		
		/*
		 * Generates the random text for the image
		 */
		public function generateCode()
		{
			$text = '';
			$length = mt_rand($this->_config['minLength'], $this->_config['maxLength']);
			$allowedLength = strlen($this->_config['allowedCharacters']) - 1;
			
			for ($i = 0; $i < $length; $i++) {
				$text .= $this->_config['allowedCharacters'][mt_rand(0, $allowedLength)];
			}
			
			$this->storeCode($text);
		}
		
		/*
		 * Get the generated code
		 */
		public function getCode()
		{
			if (!isset($_SESSION[$this->_config['sessionName']]))
				$this->generateCode();
			return $_SESSION[$this->_config['sessionName']];
		}
		
		/*
		 * Stores the generated code
		 */
		protected function storeCode($text)
		{
			$_SESSION[$this->_config['sessionName']] = $text;
		}
	}
?>