<?php
	/**
	 * Exception classes
	 * 
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * Image operation exception
	 * @copyright Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	class scImageException extends miException {
		
		const EXCEPTION_FILE_NOT_AN_IMAGE = 1;
		const EXCEPTION_INVALID_IMAGE_FORMAT = 2;
		const EXCEPTION_IMAGE_RESIZE_ERROR = 3;
		const EXCEPTION_IMAGE_WRITE_ERROR = 4;
	}
	
	
	/**
	 * HTTP exception
	 */
	class scHttpException extends miException {
		
		protected $_httpCode;
		protected $_response;
		
		public function __construct($message, $httpCode = 0, $response = '')
		{
			parent::__construct($message);
			$this->_httpCode = $httpCode;
			$this->_response = $response;
		}
		
		/**
		 * Returns the response code from the HTTP server
		 *
		 * @return int
		 */
		public function getHttpCode()
		{
			return $this->_httpCode;
		}
		
		/**
		 * Returns the response from the HTTP server
		 *
		 * @return string
		 */
		public function getResponse()
		{
			return $this->_response;
		}
	}
?>