<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scJson {
		
		public static function jsonEncode($value)
		{
			switch (gettype($value)) {
				case 'boolean':
					return $value ? 'true' : 'false';
					
				case 'integer':
				case 'double':
					return $value;
				
				case 'string':
					return '"' . self::escapeString($value) . '"';
				
				case 'array':
					if (empty($value))
						return '[]';
					
					// Is it normal array
					if (isset($value[0]))
						return '[' . implode(',', array_map(array('scJson', 'jsonEncode'), $value)) . ']';
					
					// It is hash
					$result = array();
					foreach ($value as $key => $v)
						$result[] = self::jsonEncode($key)  .':' . self::jsonEncode($v);
					return '{' . implode(',', $result) . '}';
				
				case 'NULL':
					return 'null';
			}
			return '';
		}
		
		protected static function escapeString($string)
		{
			static $find = null;
			static $replace = null;
			
			if ($find == null) {
				$find = array('\\', '"', chr(13), chr(12), chr(10), chr(9), chr(8));
				$replace = array('\\\\', '\\"', '\r', '\f', '\n', '\t', '\b');
				foreach (array_merge(range(0, 7), array(11), range(14, 31)) as $v) {
					$find[] = chr($v);
					$replace[] = sprintf("\\u00%02x", $v);
				}
			}
			
			return str_replace($find, $replace, $string);
		}
	}
?>