<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * Helper class to store the pages navigation params in the session
	 */
	class scNavigationUtil {
		const SESSION_NAVIGATION_PARAMS = 'NavigationParams';
		
		/**
		 * Returns the navigation params array
		 * @access private
		 */
		public static function &getNavigationParamsArray()
		{
			// Initialize if necessary
			if (!isset($_SESSION[self::SESSION_NAVIGATION_PARAMS]))
				$_SESSION[self::SESSION_NAVIGATION_PARAMS] = array();
			return $_SESSION[self::SESSION_NAVIGATION_PARAMS];
		}
		
		/**
		 * Saves the navigation params
		 * The $_GET, $_POST & $_REQUEST superglobals are saved
		 * 
		 * @access public
		 */
		public static function saveNavigationParams($name)
		{
			// if action is List
			if (miGetParamDefault('action', '') == '') {
				$navParams = &scNavigationUtil::getNavigationParamsArray();
				$navParams[$name] = serialize(array($_GET, $_POST, $_REQUEST));
				$_SESSION[self::SESSION_NAVIGATION_PARAMS] = $navParams;
			}
		}
		
		/**
		 * Restore the navigation params
		 * 
		 * @access public
		 */
		public static function restoreNavigationParams($name)
		{
			$navParams = scNavigationUtil::getNavigationParamsArray();
			if (!isset($navParams[$name]))
				return;
			list($_GET, $_POST, $_REQUEST) = unserialize($navParams[$name]);
			
			miSetParam('load', '');
		}
	}
?>