<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scRatingActionsSettings
	{
		const RATING_ACTION_SETTING_ALLOW_RATE_ALL = 1;
		const RATING_ACTION_SETTING_ALLOW_RATE_REGISTERED = 2;
		const RATING_ACTION_SETTING_ALLOW_RATE_BOUGHT = 3;
		const RATING_ACTION_SETTING_ALLOW_RATE_NONE = 4;
		
		const RATING_ACTION_SETTING_ALLOW_REVIEW_ALL = 1;
		const RATING_ACTION_SETTING_ALLOW_REVIEW_REGISTERED = 2;
		const RATING_ACTION_SETTING_ALLOW_REVIEW_BOUGHT = 3;
		const RATING_ACTION_SETTING_ALLOW_REVIEW_NONE = 4;
		
		const RATING_ACTION_SETTING_AUTOMATIC_APPROVAL_ALL = 1;
		const RATING_ACTION_SETTING_AUTOMATIC_APPROVAL_REGISTERED = 2;
		const RATING_ACTION_SETTING_AUTOMATIC_APPROVAL_NONE = 3;

		public static $allowedRateSetting = array(
			self::RATING_ACTION_SETTING_ALLOW_RATE_ALL,
			self::RATING_ACTION_SETTING_ALLOW_RATE_REGISTERED,
			self::RATING_ACTION_SETTING_ALLOW_RATE_BOUGHT,
			self::RATING_ACTION_SETTING_ALLOW_RATE_NONE,
		);
		
		public static $allowedReviewSetting = array(
			self::RATING_ACTION_SETTING_ALLOW_REVIEW_ALL,
			self::RATING_ACTION_SETTING_ALLOW_REVIEW_REGISTERED,
			self::RATING_ACTION_SETTING_ALLOW_REVIEW_BOUGHT,
			self::RATING_ACTION_SETTING_ALLOW_REVIEW_NONE,
		);
		
		public static $allowedAutomaticUpdateSetting = array(
			self::RATING_ACTION_SETTING_AUTOMATIC_APPROVAL_ALL,
			self::RATING_ACTION_SETTING_AUTOMATIC_APPROVAL_REGISTERED,
			self::RATING_ACTION_SETTING_AUTOMATIC_APPROVAL_NONE,
		);
		
		public static function getAllowRateOptions()
		{
			return array(
				self::RATING_ACTION_SETTING_ALLOW_RATE_ALL => _t('All'),
				self::RATING_ACTION_SETTING_ALLOW_RATE_REGISTERED => _t('Registered customers only'),
				self::RATING_ACTION_SETTING_ALLOW_RATE_BOUGHT => _t('Only customers that have bought the product'),
				self::RATING_ACTION_SETTING_ALLOW_RATE_NONE => _t('No one'),
			);
		}
		
		public static function getAllowReviewOptions()
		{
			return array(
				self::RATING_ACTION_SETTING_ALLOW_REVIEW_ALL => _t('All'),
				self::RATING_ACTION_SETTING_ALLOW_REVIEW_REGISTERED => _t('Registered customers only'),
				self::RATING_ACTION_SETTING_ALLOW_REVIEW_BOUGHT => _t('Only customers that have bought the product'),
				self::RATING_ACTION_SETTING_ALLOW_REVIEW_NONE => _t('No one'),
			);
		}
		
		public static function getAutomaticApprovalOptions()
		{
			return array(
				self::RATING_ACTION_SETTING_AUTOMATIC_APPROVAL_ALL => _t('All'),
				self::RATING_ACTION_SETTING_AUTOMATIC_APPROVAL_REGISTERED => _t('Registered customers only'),
				self::RATING_ACTION_SETTING_AUTOMATIC_APPROVAL_NONE => _t('No one'),
			);
		}
	}
?>