<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * Class to handle all settings
	 */
	class scSettings {
		// General options
		const SETTING_PRODUCT_IMAGE_MAX_WIDTH = 'ProductImageMaxWidth';
		const SETTING_PRODUCT_IMAGE_MAX_HEIGHT = 'ProductImageMaxHeight';
		const SETTING_PRODUCT_IMAGE_THUMB_MAX_WIDTH = 'ProductImageThumbMaxWidth';
		const SETTING_PRODUCT_IMAGE_THUMB_MAX_HEIGHT = 'ProductImageThumbMaxHeight';
		const SETTING_PRODUCT_BOX_IMAGE_MAX_WIDTH = 'ProductImageBoxMaxWidth';
		const SETTING_PRODUCT_BOX_IMAGE_MAX_HEIGHT = 'ProductImageBoxMaxHeight';
		const SETTING_PRODUCT_LARGE_IMAGE_MAX_WIDTH = 'ProductImageLargeMaxWidth';
		const SETTING_PRODUCT_LARGE_IMAGE_MAX_HEIGHT = 'ProductImageLargeMaxHeight';
		const SETTING_MANUFACTURER_IMAGE_MAX_WIDTH = 'ManufacturerImageMaxWidth';
		const SETTING_MANUFACTURER_IMAGE_MAX_HEIGHT = 'ManufacturerImageMaxHeight';
		const SETTING_LANGUAGE_IMAGE_MAX_WIDTH = 'LanguageImageMaxWidth';
		const SETTING_LANGUAGE_IMAGE_MAX_HEIGHT = 'LanguageImageMaxHeight';
		const SETTING_CATEGORY_IMAGE_MAX_WIDTH = 'CategoryImageMaxWidth';
		const SETTING_CATEGORY_IMAGE_MAX_HEIGHT = 'CategoryImageMaxHeight';
		
		const SETTING_HOMEPAGE_VIEW_TYPE = 'HomepageViewType';
		const SETTING_DEFAULT_CATEGORY_VIEW_TYPE = 'DefaultCategoryViewType';
		const SETTING_DEFAULT_PRODUCT_ORDER = 'DefaultProductOrder';
		const SETTING_GRID_VIEW_COLUMNS = 'GridViewColumns';
		const SETTING_GRID_VIEW_ROWS = 'GridViewRows';
		const SETTING_LIST_VIEW_PRODUCTS_PER_PAGE = 'ListViewProductsPerPage';
		
		const SETTING_INVENTORY_TRACKING = 'InventoryTracking';
		const SETTING_OUT_OF_STOCK_HANDLING = 'OutOfStockHandling';
		
		const SETTING_NEW_PRODUCTS_INFRONT_OF_CATEGORY_LISTING = 'NewProductsInFrontOfCategoryListings';
		
		const SETTING_WHOLESALE_PRICES = 'WholesalePrices';
		
		const SETTING_DISPLAY_PRICES_TAX_MODE = 'DisplayPricesTaxMode';
		
		const SETTING_DOWNLOAD_TTL_DAYS = 'DownloadTtlDays';
		const SETTING_DOWNLOAD_TTL_DOWNLOADS = 'DownloadTtlDownloads';
		const SETTING_AUTO_UNLOCK_EGOODS = 'AutoUnlockEgoods';
		
		const SETTING_USERS_ABLE_TO_RATE = 'UsersAbleToRate';
		const SETTING_USERS_ABLE_TO_REVIEW = 'UsersAbleToReview';
		const SETTING_RATING_ACTIONS_AUTOMATIC_APPROVAL = 'RatingActionsAutomaticApproval';
		
		// Gallery
		const SETTING_GALLERY_ITEM_IMAGE_MAX_WIDTH = 'GalleryItemImageMaxWidth';
		const SETTING_GALLERY_ITEM_IMAGE_MAX_HEIGHT = 'GalleryItemImageMaxHeight';
		const SETTING_GALLERY_ITEM_IMAGE_THUMB_MAX_WIDTH = 'GalleryItemImageThumbMaxWidth';
		const SETTING_GALLERY_ITEM_IMAGE_THUMB_MAX_HEIGHT = 'GalleryItemImageThumbMaxHeight';
		const SETTING_GALLERY_SHOW_TABLE_X = 'GalleryShowTableX';
		const SETTING_GALLERY_SHOW_TABLE_Y = 'GalleryShowTableY';
		
		// Security
		const SETTING_SSL_ENABLED = 'UseSSL';
		const SETTING_PASSWORD_HASH_MODE = 'PasswordHashMode';
		
		// SEO
		const SETTING_SEO_SITE_KEYWORDS = 'SiteKeywords';
		const SETTING_SEO_SITE_DESCRIPTION = 'SiteDescription';
		const SETTING_SEO_SITE_TITLE = 'SiteTitle';
		const SETTING_FRIENDLY_URLS = 'FriendlyUrls';
		const SETTING_SEO_URLS_TYPE = 'SeoUrlsType';
		
		// Company info
		const SETTING_COMPANY_NAME = 'CompanyName';
		const SETTING_COMPANY_ADDRESS = 'CompanyAddress';
		const SETTING_COMPANY_ADDRESS2 = 'CompanyAddress2';
		const SETTING_COMPANY_CITY = 'CompanyCity';
		const SETTING_COMPANY_STATE = 'CompanyState';
		const SETTING_COMPANY_COUNTRY = 'CompanyCountry';
		const SETTING_COMPANY_ZIP = 'CompanyZIP';
		const SETTING_COMPANY_PHONE = 'CompanyPhone';
		const SETTING_COMPANY_PHONE2 = 'CompanyPhone2';
		const SETTING_COMPANY_FAX = 'CompanyFax';
		
		// Emails
		const SETTING_EMAIL_ADMINISTRATOR = 'SiteAdministratorEmail';
		const SETTING_EMAIL_ORDER_DEPARTMENT = 'OrderDepartmentEmail';
		const SETTING_EMAIL_HELP_SUPPORT = 'HelpSupportEmail';
		const SETTING_EMAIL_REPLY_TO_NOTIFICATIONS = 'ReplyToNotificationsEmail';
		const SETTING_EMAIL_REPLY_TO_NEWSLETTER = 'ReplyToNewsletterEmail';
		const SETTING_EMAIL_METHOD_OF_SENDING = 'MethodOfSendingEmails';
		const SETTING_EMAIL_SMTP_HOST = 'SmtpHost';
		const SETTING_EMAIL_SMTP_PORT = 'SmtpPort';
		const SETTING_EMAIL_SMTP_SECURITY = 'SmtpSecurity';
		const SETTING_EMAIL_USE_SMTP_AUTHENTICATION = 'UseSmtpAuthentication';
		const SETTING_EMAIL_SMTP_USERNAME = 'SmtpUsername';
		const SETTING_EMAIL_SMTP_PASSWORD = 'SmtpPassword';
		
		// Localization
		const SETTING_LOCALIZATION_WEIGHT_UNIT = 'WeightUnit';
		
		// Skins
		const SETTING_SKIN_ADMIN = 'SkinAdmin';
		const SETTING_SKIN_CUSTOMER = 'SkinCustomer';
		
		// Bonus Points
		const SETTING_BONUS_POINTS_PURCHASE_EARN = 'BonusPointsPurchaseEarn';
		const SETTING_BONUS_POINTS_PURCHASE_LIMIT = 'BonusPointsPurchaseLimit';
		const SETTING_BONUS_POINTS_PURCHASE_LIMIT_PERIOD = 'BonusPointsPurchaseLimitPeriod';
		
		const SETTING_BONUS_POINTS_REFERRAL_EARN = 'BonusPointsReferralEarn';
		const SETTING_BONUS_POINTS_REFERRAL_LIMIT = 'BonusPointsReferralLimit';
		const SETTING_BONUS_POINTS_REFERRAL_LIMIT_PERIOD = 'BonusPointsReferralLimitPeriod';
		const SETTING_BONUS_POINTS_REFERRAL_COOKIE_LIFE_IN_DAYS = 'BonusPointsReferralCookieLifeInDays';
		
		const SETTING_BONUS_POINTS_REVIEW_EARN = 'BonusPointsReviewEarn';
		const SETTING_BONUS_POINTS_REVIEW_LIMIT = 'BonusPointsReviewLimit';
		const SETTING_BONUS_POINTS_REVIEW_LIMIT_PERIOD = 'BonusPointsReviewLimitPeriod';
		
		const SETTING_BONUS_POINTS_VOTE_EARN = 'BonusPointsVoteEarn';
		const SETTING_BONUS_POINTS_VOTE_LIMIT = 'BonusPointsVoteLimit';
		const SETTING_BONUS_POINTS_VOTE_LIMIT_PERIOD = 'BonusPointsVoteLimitPeriod';
		
		const SETTING_BONUS_POINTS_SPEND_AMOUNT = 'BonusPointsSpendAmount';
		const SETTING_BONUS_POINTS_SPEND_EARN = 'BonusPointsSpendEarn';
		
		const SETTING_BONUS_POINTS_ORDER_STATUSES = 'BonusPointsOrderStatuses';
		
		const SETTING_BONUS_POINTS_CONVERSION_RATE = 'BonusPointsConversionRate';
		const SETTING_BONUS_POINTS_MANUAL_APPROVAL = 'BonusPointsManualApproval';
		const SETTING_BONUS_POINTS_MANUAL_SPENDING = 'BonusPointsManualSpending';
		
		const SETTING_BONUS_POINTS_PRODUCTS_DEFAULT_MODE = 'BonusPointsProductsDefaultMode';
		
		// Misc
		const SETTING_LAST_CURRENCYRATE_UPDATE = 'CurrencyLastUpdateTime';
		const SETTING_DEFAULT_CURRENCY = 'DefaultCurrencyID';
		const SETTING_DEFAULT_LANGUAGE = 'DefaultLanguageID';
		const SETTING_DEFAULT_COUNTRY = 'DefaultCountryID';
		const SETTING_DEFAULT_CUSTOMER_GROUP = 'DefaultCustomerGroupID';
		const SETTING_CURRENCY_RATE_EXPIRE_DAYS = 'CurrencyRateExpireDays';
		const SETTING_NEW_PRODUCTS_DAYS = 'NewProductsDays';
		const SETTING_CAPTCHA_ON_REGISTER = 'CaptchaOnRegister';
		const SETTING_CAPTCHA_ON_REGISTER_IN_CHECKOUT = 'CaptchaOnRegisterInCheckout';
		const SETTING_SHOW_UNFINISHED_ORDERS = 'ShowUnfinishedOrders';
		
		const SETTING_BOX_IMAGE_MAX_WIDTH = 'BoxImageMaxWidth';
		const SETTING_BOX_IMAGE_MAX_HEIGHT = 'BoxImageMaxHeight';
		
		const SETTING_MENU_ITEM_IMAGE_MAX_WIDTH = 'MenuItemImageMaxWidth';
		const SETTING_MENU_ITEM_IMAGE_MAX_HEIGHT = 'MenuItemImageMaxHeight';
		
		const SETTING_PRODUCT_COMPARISON_MAX_PRODUCTS = 'ProductComparisonMax';
		
		protected static $_instance = null;
		
		protected $_settings = array();
		
		protected $_mlSettingsLanaguageId = null;
		
		/**
		 * Loads the settings from the database
		 *
		 */
		protected function __construct()
		{
			$this->_settings = miUtil::getDBArray(
				'SELECT SettingName, SettingValue FROM Settings UNION ' .
				$this->getMlSettingsQuery(),
				'SettingName',
				'SettingValue'
			);
			$this->_mlSettingsLanaguageId = scMultiLanguage::getCurrentLanguageId();
		}
		
		protected function getMlSettingsQuery()
		{
			return 'SELECT SettingName, SettingValue FROM SettingsML WHERE LanguageID = ' . sql_escape_string(scMultiLanguage::getCurrentLanguageId());
		}
		
		protected function __clone() {}
		
		/**
		 * Returns the one and only instance of the class
		 *
		 * @return scSettings
		 */
		protected static function singleton()
		{
			if (is_null(self::$_instance))
				self::$_instance = new scSettings();
			
			return self::$_instance;
		}
		
		protected function get($settingName)
		{
			if ($this->_mlSettingsLanaguageId != scMultiLanguage::getCurrentLanguageId())
				$this->readMlSettings();
			
			if (array_key_exists($settingName, $this->_settings))
				return $this->_settings[$settingName];
			
			return null;
		}
		
		protected function set($settingName, $settingValue)
		{
			try {
				miStaticDBUtil::startTransaction();
				miStaticDBUtil::execDelete('Settings', 'SettingName', $settingName);
				miStaticDBUtil::execInsert('Settings', array('SettingName' => $settingName, 'SettingValue' => $settingValue));
				miStaticDBUtil::commit();
			} catch (miException $exception) {
				miStaticDBUtil::rollback();
				
				throw $exception;
			}
			
			// Update the cached settings
			$this->_settings[$settingName] = $settingValue;
		}
		
		protected function readMlSettings()
		{
			$mlSettings = miUtil::getDBArray($this->getMlSettingsQuery(), 'SettingName', 'SettingValue');
			$this->_settings = array_merge($this->_settings, $mlSettings);
			$this->_mlSettingsLanaguageId = scMultiLanguage::getCurrentLanguageId();
		}
		
		/**
		 * Proxy method
		 * Retrieves the setting value
		 */
		public static function getSettingValue($settingName) 
		{
			return self::singleton()->get($settingName);
		}

		/**
		 * Proxy method
		 * Changes a setting value
		 */
		public static function setSettingValue($settingName, $settingValue)
		{
			self::singleton()->set($settingName, $settingValue);
		}
	}
?>