<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scSections {
		const SECTION_CUSTOMERS = 1;
		const SECTION_ORDERS = 2;
		const SECTION_CUSTOMER_GROUPS = 3;
		const SECTION_BONUS_POINTS = 4;
		
		const SECTION_PRODUCTS = 100;
		const SECTION_OPTION_GROUPS = 101;
		const SECTION_CATEGORIES = 102;
		const SECTION_FEATURED_PRODUCTS = 103;
		const SECTION_MANUFACTURERS = 104;
		const SECTION_DISCOUNTS = 105;
		const SECTION_COUPONS = 106;
		const SECTION_IMPORT_EXPORT = 107;
		const SECTION_PRODUCT_CLASSES = 108;
		
		const SECTION_MODULES_SHIPPING = 200;
		const SECTION_MODULES_PAYMENT = 201;
		const SECTION_MODULES_CHECKOUT = 202;
		const SECTION_MODULES_ORDER_TOTAL = 203;
		const SECTION_MODULES_CURRENCY_RATE = 204;
		
		const SECTION_COUNTRIES = 300;
		const SECTION_STATES = 301;
		const SECTION_SHIPPING_ZONES = 302;
		const SECTION_TAXES = 303;
		
		const SECTION_RICH_TEXT_PAGES = 400;
		const SECTION_DYNAMIC_PAGES = 401;
		const SECTION_FORMS = 402;
		const SECTION_BOXES = 403;
		const SECTION_MENUS = 404;
		const SECTION_LAYOUTS = 405;
		const SECTION_SKINS = 406;
		const SECTION_NEWS = 407;
		const SECTION_NEWSLETTERS = 408;
		const SECTION_GALLERIES = 409;
		
		const SECTION_GENERAL_OPTIONS = 500;
		const SECTION_STORE_OWNER = 501;
		const SECTION_EMAILS = 502;
		const SECTION_SECURITY = 503;
		const SECTION_SEO = 504;
		const SECTION_ADMINISTRATORS = 505;
		const SECTION_LOCALIZATION = 506;
		const SECTION_ORDER_STATUSES = 507;
		const SECTION_PLUGINS = 508;
		
		const SECTION_LANGUAGES = 600;
		const SECTION_CURRENCIES = 601;
		const SECTION_HELPS = 602;
		const SECTION_QUICK_LINKS = 603;
		const SECTION_API_ACCOUNTS = 604;
		const SECTION_CUSTOM_URLS = 605;
		
		const SECTION_REPORT_SALES_BY_PRODUCT = 700;
		const SECTION_REPORT_SALES_BY_CATEGORY = 701;
		const SECTION_REPORT_SALES_BY_CUSTOMER = 702;
		const SECTION_REPORT_SALES_BY_COUNTRY = 703;
		const SECTION_REPORT_CUSTOMER_COUNTRIES = 704;
		const SECTION_REPORT_AVERAGE_ORDER_AMOUNT = 705;
		const SECTION_REPORT_ORDER_STATUSES = 706;
		const SECTION_REPORT_PAYMENT_METHODS = 707;
		const SECTION_REPORT_SHIPPING_METHODS = 708;
		const SECTION_REPORT_TAXES = 709;
		const SECTION_REPORT_ORDER_ITEMS = 710;
		const SECTION_REPORT_VIEWS_VISITS = 711;
		const SECTION_REPORT_VIEWS_BY_PRODUCT = 712;
		const SECTION_REPORT_VIEWS_BY_CATEGORY = 713;
		
		const SECTION_LOGS = 800;
		
		const SECTION_GROUP_ORDERS = 0;
		const SECTION_GROUP_PRODUCTS = 1;
		const SECTION_GROUP_MODULES = 2;
		const SECTION_GROUP_LOCATIONS_TAXES = 3;
		const SECTION_GROUP_WEBSITE_CONTENT = 4;
		const SECTION_GROUP_STORE_CONFIGURATION = 5;
		const SECTION_GROUP_LANGUAGES_CURRENCIES = 6;
		const SECTION_GROUP_REPORTS = 7;
		const SECTION_GROUP_LOGS = 8;
		
		public static function getSections()
		{
			return array(
				self::SECTION_CUSTOMERS => _t('Customers'),
				self::SECTION_CUSTOMER_GROUPS => _t('Customer Groups'),
				self::SECTION_ORDERS => _t('Orders'),
				self::SECTION_BONUS_POINTS => _t('Bonus Points'),
				
				self::SECTION_PRODUCTS => _t('Products'),
				self::SECTION_OPTION_GROUPS => _t('Products Option Groups'),
				self::SECTION_CATEGORIES => _t('Categories'),
				self::SECTION_FEATURED_PRODUCTS => _t('Featured Products'),
				self::SECTION_MANUFACTURERS => _t('Manufacturers'),
				self::SECTION_DISCOUNTS => _t('Discounts'),
				self::SECTION_COUPONS => _t('Coupons'),
				self::SECTION_IMPORT_EXPORT => _t('Import / Export'),
				self::SECTION_PRODUCT_CLASSES => _t('Product Classes'),
				
				self::SECTION_MODULES_SHIPPING => _t('Shipping Modules'),
				self::SECTION_MODULES_PAYMENT => _t('Payment Modules'),
				self::SECTION_MODULES_CHECKOUT => _t('Checkout Modules'),
				self::SECTION_MODULES_ORDER_TOTAL => _t('Order Total Modules'),
				self::SECTION_MODULES_CURRENCY_RATE => _t('Currency Rate Modules'),
				
				self::SECTION_COUNTRIES => _t('Countries'),
				self::SECTION_STATES => _t('States'),
				self::SECTION_SHIPPING_ZONES => _t('Shipping Zones'),
				self::SECTION_TAXES => _t('Taxes'),
				
				self::SECTION_RICH_TEXT_PAGES => _t('Rich Text Pages'),
				self::SECTION_DYNAMIC_PAGES => _t('Dynamic Pages'),
				self::SECTION_FORMS => _t('Forms'),
				self::SECTION_BOXES => _t('Boxes'),
				self::SECTION_MENUS => _t('Menus'),
				self::SECTION_LAYOUTS => _t('Layouts'),
				self::SECTION_SKINS => _t('Skins'),
				self::SECTION_NEWS => _t('News'),
				self::SECTION_NEWSLETTERS => _t('Newsletter'),
				self::SECTION_GALLERIES => _t('Gallery'),
				
				self::SECTION_GENERAL_OPTIONS => _t('General Options'),
				self::SECTION_STORE_OWNER => _t('Store Owner'),
				self::SECTION_EMAILS => _t('Emails'),
				self::SECTION_SECURITY => _t('Security'),
				self::SECTION_SEO => _t('SEO'),
				self::SECTION_ADMINISTRATORS => _t('Administrators'),
				self::SECTION_LOCALIZATION => _t('Localization'),
				self::SECTION_ORDER_STATUSES => _t('Order Statuses'),
				self::SECTION_PLUGINS => _t('Plugins'),
				
				self::SECTION_LANGUAGES => _t('Languages'),
				self::SECTION_CURRENCIES => _t('Currencies'),
				
				self::SECTION_REPORT_SALES_BY_PRODUCT => _t('Sales By Product'),
				self::SECTION_REPORT_SALES_BY_CATEGORY => _t('Sales By Category'),
				self::SECTION_REPORT_SALES_BY_CUSTOMER => _t('Sales By Customer'),
				self::SECTION_REPORT_SALES_BY_COUNTRY => _t('Sales By Country'),
				self::SECTION_REPORT_CUSTOMER_COUNTRIES => _t('Customer Countries'),
				self::SECTION_REPORT_AVERAGE_ORDER_AMOUNT => _t('Average Order Amount'),
				self::SECTION_REPORT_ORDER_STATUSES => _t('Order Statuses'),
				self::SECTION_REPORT_PAYMENT_METHODS => _t('Payment Methods'),
				self::SECTION_REPORT_SHIPPING_METHODS => _t('Shipping Methods'),
				self::SECTION_REPORT_TAXES => _t('Taxes'),
				self::SECTION_REPORT_ORDER_ITEMS => _t('Items Per Order'),
				self::SECTION_REPORT_VIEWS_VISITS => _t('Page Views / Unique Visitors'),
				self::SECTION_REPORT_VIEWS_BY_PRODUCT => _t('Views By Product'),
				self::SECTION_REPORT_VIEWS_BY_CATEGORY => _t('Views By Category'),
				
				self::SECTION_HELPS => _t('Helps'),
				self::SECTION_QUICK_LINKS => _t('Admin Quick Links'),
				self::SECTION_API_ACCOUNTS => _t('API Accounts'),
				self::SECTION_CUSTOM_URLS => _t('Custom Urls'),
				
				self::SECTION_LOGS => _t('Logs')
			);
		}
		
		public static function getSectionGroups()
		{
			return array(
				self::SECTION_GROUP_ORDERS => _t('Orders'),
				self::SECTION_GROUP_PRODUCTS => _t('Products'),
				self::SECTION_GROUP_MODULES => _t('Modules'),
				self::SECTION_GROUP_LOCATIONS_TAXES => _t('Locations and Taxes'),
				self::SECTION_GROUP_WEBSITE_CONTENT => _t('Website Content'),
				self::SECTION_GROUP_STORE_CONFIGURATION => _t('Store Configuration'),
				self::SECTION_GROUP_LANGUAGES_CURRENCIES => _t('Languages and Currencies'),
				self::SECTION_GROUP_REPORTS => _t('Reports'),
				self::SECTION_GROUP_LOGS => _t('Application log'),
			);
		}
		
		public static function getSectionsInGroup($sectionGroup)
		{
			$sectionsInGroups = array(
				self::SECTION_GROUP_ORDERS => array(self::SECTION_CUSTOMERS, self::SECTION_CUSTOMER_GROUPS, self::SECTION_ORDERS, self::SECTION_BONUS_POINTS),
				self::SECTION_GROUP_PRODUCTS => array(self::SECTION_PRODUCTS, self::SECTION_OPTION_GROUPS, self::SECTION_CATEGORIES,
					self::SECTION_FEATURED_PRODUCTS, self::SECTION_MANUFACTURERS, self::SECTION_DISCOUNTS, self::SECTION_COUPONS, self::SECTION_IMPORT_EXPORT, self::SECTION_PRODUCT_CLASSES),
				self::SECTION_GROUP_MODULES => array(self::SECTION_MODULES_SHIPPING, self::SECTION_MODULES_PAYMENT,
					self::SECTION_MODULES_ORDER_TOTAL, self::SECTION_MODULES_CURRENCY_RATE),
				self::SECTION_GROUP_LOCATIONS_TAXES => array(self::SECTION_COUNTRIES, self::SECTION_STATES, self::SECTION_SHIPPING_ZONES, self::SECTION_TAXES),
				self::SECTION_GROUP_WEBSITE_CONTENT => array(self::SECTION_RICH_TEXT_PAGES, self::SECTION_DYNAMIC_PAGES, self::SECTION_FORMS, self::SECTION_BOXES,
					self::SECTION_MENUS, self::SECTION_LAYOUTS, self::SECTION_SKINS, self::SECTION_NEWS, self::SECTION_NEWSLETTERS, self::SECTION_GALLERIES),
				self::SECTION_GROUP_STORE_CONFIGURATION => array(self::SECTION_GENERAL_OPTIONS, self::SECTION_STORE_OWNER, self::SECTION_EMAILS,
					self::SECTION_SECURITY, self::SECTION_SEO, self::SECTION_ADMINISTRATORS, self::SECTION_LOCALIZATION, self::SECTION_ORDER_STATUSES,
					self::SECTION_API_ACCOUNTS, self::SECTION_CUSTOM_URLS, self::SECTION_PLUGINS),
				self::SECTION_GROUP_LANGUAGES_CURRENCIES => array(self::SECTION_LANGUAGES, self::SECTION_CURRENCIES, self::SECTION_HELPS, self::SECTION_QUICK_LINKS),
				self::SECTION_GROUP_REPORTS => array(self::SECTION_REPORT_SALES_BY_PRODUCT, self::SECTION_REPORT_SALES_BY_CATEGORY,
					self::SECTION_REPORT_SALES_BY_CUSTOMER, self::SECTION_REPORT_SALES_BY_COUNTRY,
					self::SECTION_REPORT_CUSTOMER_COUNTRIES, self::SECTION_REPORT_AVERAGE_ORDER_AMOUNT,
					self::SECTION_REPORT_ORDER_STATUSES, self::SECTION_REPORT_PAYMENT_METHODS, self::SECTION_REPORT_SHIPPING_METHODS,
					self::SECTION_REPORT_TAXES, self::SECTION_REPORT_ORDER_ITEMS, self::SECTION_REPORT_VIEWS_VISITS,
					self::SECTION_REPORT_VIEWS_BY_PRODUCT, self::SECTION_REPORT_VIEWS_BY_CATEGORY),
					
				self::SECTION_GROUP_LOGS => array(self::SECTION_LOGS)
			);
			
			return $sectionsInGroups[$sectionGroup];
		}
	}
?>