<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scOrderTotalLine {
		
		/**
		 * @var string
		 */
		protected $_description;
		
		/**
		 * @var scMultiCurrencyAmount
		 */
		protected $_amount;
		
		/**
		 * @var int
		 */
		protected $_type;
		
		public function __construct($description, scMultiCurrencyAmount $amount, $type)
		{
			$this->_description = $description;
			$this->_amount = $amount;
			$this->_type = $type;
		}
		
		/**
		 * @return scMultiCurrencyAmount
		 */
		public function getAmount()
		{
			return $this->_amount;
		}
		
		public function setAmount(scMultiCurrencyAmount $amount)
		{
			$this->_amount = $amount;
		}
		
		public function getType()
		{
			return $this->_type;
		}
		
		public function getDescription()
		{
			return $this->_description;
		}
		
		public function getTranslatedDescription()
		{
			return scInterfaceTexts::getTranslatedText($this->_description);
		}
	}
	
	/**
	 * Order total line with param
	 */
	class scOrderTotalLineWithParam extends scOrderTotalLine {
		protected $_param;
		
		public function __construct($description, scMultiCurrencyAmount $amount, $type, $param)
		{
			$this->_param = $param;
			parent::__construct($description, $amount, $type);
		}
		
		public function getDescription()
		{
			return sprintf($this->_description, $this->_param);
		}
		
		public function getTranslatedDescription()
		{
			return sprintf(scInterfaceTexts::getTranslatedText($this->_description), $this->_param);
		}
		
		public function getParam()
		{
			return $this->_param;
		}
	}
?>