<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * Encapsulates the category functionality (single language use)
	 */
	class scCategorySL extends miDefaultDomainObject {
		protected $_languageId;
		
		/**
		 * Constructs the category object
		 * 
		 * @return void
		 */
		public function __construct()
		{
			$this->_record = new miSqlRecord('Categories', 'CategoryID');
			$this->_languageId = scMultiLanguage::getCurrentLanguageId();
		}
		
		/**
		 * Set the language id to use
		 * If not set the current language is used
		 * 
		 * @param int $languageId
		 */
		public function setLanguageId($languageId)
		{
			$this->_languageId = $languageId;
		}
		
		/**
		 * Reads the category information from the database
		 * 
		 * @param int $categoryId
		 * @return void
		 */
		public function read($categoryId)
		{
			$sql = 'SELECT *, Categories.CategoryID as CategoryID FROM Categories JOIN CategoriesML USING(CategoryID) WHERE Categories.CategoryID=? AND LanguageID=?';
			$rows = miStaticDBUtil::execSelect($sql, array($categoryId, $this->_languageId));
			if (empty($rows))
				throw new miException(_t('Cannot find category.'));
			$this->_record->setRow($rows[0]);
		}
	}
?>