<?php
	/**
	 * Contains the Breadcrumb class
	 * 
	 * @copyright Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * Class for displaying the breadcrumb showing the hierarchical structure of the website
	 * 
	 * @copyright Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	class scBreadcrumb extends miBreadcrumb {
		
		public function __construct()
		{
			$this->_pageNames = array(
				'/admin/' => _t('Home'),
				'/admin/apiaccounts.php' => _t('API Accounts'),
				'/admin/administrators.php' => _t('Administrators'),
				'/admin/boxes.php' => _t('Boxes'),
				'/admin/categories.php' => _t('Categories'),
				'/admin/checkout_modules.php' => _t('Checkout Modules'),
				'/admin/company.php' => _t('Company'),
				'/admin/countries.php' => _t('Countries'),
				'/admin/coupons.php' => _t('Coupons'),
				'/admin/currencies.php' => _t('Currencies'),
				'/admin/currency_rate_modules.php' => _t('Currency Rate Modules'),
				'/admin/custom_urls.php' => _t('Custom Urls'),
				'/admin/customers.php' => _t('Customers'),
				'/admin/customers_import.php' => _t('Customers Import'),
				'/admin/customer_groups.php' => _t('Customer Groups'),
				'/admin/bonus_points.php' => _t('Bonus Points'),
				'/admin/discounts.php' => _t('Discounts'),
				'/admin/dynamic_pages.php' => _t('Dynamic Pages'),
				'/admin/emails.php' => _t('Emails'),
				'/admin/featured_products.php' => _t('Featured Products'),
				'/admin/forms.php' => _t('Forms'),
				'/admin/general_options.php' => _t('General Options'),
				'/admin/helps.php' => _t('Helps'),
				'/admin/import.php' => _t('Import'),
				'/admin/installcheck.php' => _t('Install Check'),
				'/admin/languages.php' => _t('Languages'),
				'/admin/language_texts.php' => _t('Edit User Interface Translations'),
				'/admin/layouts.php' => _t('Layouts'),
				'/admin/license.php' => _t('License'),
				'/admin/localization.php' => _t('Localization'),
				'/admin/manufacturers.php' => _t('Manufacturers'),
				'/admin/menus.php' => _t('Menus'),
				'/admin/menu_items.php' => _t('Menu Items'),
				'/admin/option_groups.php' => _t('Option Groups'),
				'/admin/order_statuses.php' => _t('Order Statuses'),
				'/admin/order_total_modules.php' => _t('Order Total Modules'),
				'/admin/orders.php' => _t('Orders'),
				'/admin/payment_modules.php' => _t('Payment Modules'),
				'/admin/products.php' => _t('Products'),
				'/admin/quick_links.php' => _t('Admin Quick Links'),
				'/admin/report.php' => _t('Reports'),
				'/admin/rich_text_pages.php' => _t('Rich Text Pages'),
				'/admin/search.php' => _t('Search'),
				'/admin/security.php' => _t('Security'),
				'/admin/seo.php' => _t('SEO'),
				'/admin/shipping_modules.php' => _t('Shipping Modules'),
				'/admin/shipping_zones.php' => _t('Shipping Zones'),
				'/admin/skins.php' => _t('Skins'),
				'/admin/skin_settings.php' => _t('Skin Settings'),
				'/admin/states.php' => _t('States'),
				'/admin/taxes.php' => _t('Taxes'),
				'/admin/tax_classes.php' => _t('Tax Classes'),
				'/admin/tax_rates.php' => _t('Tax Rates'),
				'/admin/tax_zones.php' => _t('Tax Zones'),
				'/admin/log.php' => _t('Application log'),
				'/admin/plugins.php' => _t('Plugins'),
				'/admin/product_classes.php' => _t('Product Classes'),
				'/admin/galleries.php' => _t('Image Galleries'),
				'/admin/gallery_import.php' => _t('Import Images'),
				'/admin/gallery_items.php' => _t('Gallery Items'),
				
				// Report names
				'report-SalesByProduct' => _t('Sales By Product'),
				'report-SalesByCategory' => _t('Sales By Category'),
				'report-SalesByCustomer' => _t('Sales By Customer'),
				'report-SalesByCountry' => _t('Sales By Country'),
				'report-CustomerCountries' => _t('Customers Countries'),
				'report-AverageOrderAmount' => _t('Average Order Amount'),
				'report-OrderStatuses' => _t('Order Statuses'),
				'report-OrderPaymentMethods' => _t('Order Payment Methods'),
				'report-OrderShippingMethods' => _t('Order Shipping Methods'),
				'report-ItemsPerOrder' => _t('Items Per Order'),
			);
		}
		
		/**
		 * Tree containing all pages and the hierarchy between them.
		 * A page can be in both as a key or as a value. If it is as a key it might have
		 * an array of subpages.
		 * @access protected
		 */
		protected $_pages = array(
			'/admin/' => array(
				'/admin/apiaccounts.php',
				'/admin/administrators.php',
				'/admin/boxes.php',
				'/admin/categories.php',
				'/admin/checkout_modules.php',
				'/admin/company.php',
				'/admin/countries.php',
				'/admin/coupons.php',
				'/admin/currencies.php',
				'/admin/currency_rate_modules.php',
				'/admin/custom_urls.php',
				'/admin/customers.php',
				'/admin/customers_import.php',
				'/admin/customer_groups.php',
				'/admin/bonus_points.php',
				'/admin/discounts.php',
				'/admin/dynamic_pages.php',
				'/admin/rich_text_pages.php',
				'/admin/emails.php',
				'/admin/featured_products.php',
				'/admin/forms.php',
				'/admin/general_options.php',
				'/admin/helps.php',
				'/admin/import.php',
				'/admin/installcheck.php',
				'/admin/languages.php' => array('/admin/language_texts.php'),
				'/admin/layouts.php',
				'/admin/license.php',
				'/admin/localization.php',
				'/admin/manufacturers.php',
				'/admin/menus.php' => array('/admin/menu_items.php'),
				'/admin/option_groups.php',
				'/admin/order_statuses.php',
				'/admin/order_total_modules.php',
				'/admin/orders.php',
				'/admin/payment_modules.php',
				'/admin/products.php',
				'/admin/quick_links.php',
				'/admin/report.php' => array(
					'report-SalesByProduct', 'report-SalesByCategory', 'report-SalesByCustomer', 'report-SalesByCountry',
					'report-CustomerCountries',
					'report-AverageOrderAmount', 'report-OrderStatuses', 'report-OrderPaymentMethods', 'report-OrderShippingMethods',
					'report-ItemsPerOrder'),
				'/admin/search.php',
				'/admin/security.php',
				'/admin/seo.php',
				'/admin/shipping_modules.php',
				'/admin/shipping_zones.php',
				'/admin/skins.php' => array('/admin/skin_settings.php'),
				'/admin/states.php',
				'/admin/taxes.php' => array('/admin/tax_classes.php', '/admin/tax_rates.php', '/admin/tax_zones.php'),
				'/admin/log.php',
				'/admin/plugins.php',
				'/admin/product_classes.php',
				'/admin/galleries.php' => array('/admin/gallery_import.php', '/admin/gallery_items.php'),
			),
		);
		
		/**
		 * Contains the separator that is put between the breadcrumb links
		 * @access protected
		 */
		protected $_separator = '<img src="../skins/default/admin/images/icons/pointer_right.gif" class="pointer_right" alt=""/>';
		
		
		/**
		 * Contains the link template for each breadcrumb link
		 * The %%LINK%% and %%NAME%% params are replaced within it
		 * @access protected
		 */
		protected $_linkTemplate = '<a href="..%%LINK%%?action=dmBack" class="navy">%%NAME%%</a>';
		
		/**
		 * Returns the breadcrumb for the current page
		 *
		 * @return string the HTML for the breadcrumb
		 */
		public function getCurrentBreadcrumbHtml()
		{
			$page = '/' . scPaths::getCurrentScriptPathName();
			return parent::getBreadcrumbHtml($page);
		}
	}
?>