<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scCMS {
		public static function getCMSMenuItemsRecordset()
		{
			$languageId = scView::getCurrentDataLanguageId();
			$items = new scSqlRecordsetML('CMSMenuItems', 'CMSMenuItemID');
			$items->setLanguageId($languageId);
			$items->addJoinCondition('LEFT', 'CMSRichTextPages', 'ON CMSRichTextPages.CMSRichTextPageID=CMSMenuItems.CMSRichTextPageID');
			$items->addJoinCondition('LEFT', 'CMSRichTextPagesML', 'ON CMSRichTextPages.CMSRichTextPageID=CMSRichTextPagesML.CMSRichTextPageID AND CMSRichTextPagesML.LanguageID=' . $languageId);
			$items->addJoinCondition('LEFT', 'Galleries', 'ON Galleries.GalleryID=CMSMenuItems.GalleryID');
			$items->setOrder('CMSMenuItemSort', 'ASC');
			
			$selectFields[] = 'CMSMenuItems.*';
			$selectFields[] = 'CMSMenuItemsML.CMSMenuItemName';
			$selectFields[] = 'CMSRichTextPagesML.CMSRichTextPageTitle as CMSRichTextPageTitle';
			$selectFields[] = 'Galleries.GalleryName';
			$items->setSelectFields($selectFields);
			return $items;
		}
		
		public static function getCkEditorLanguage()
		{
			$supportedLanguages = array('AF', 'AR', 'BG', 'BN', 'BS', 'CA', 'CS', 'CY', 'DA', 'DE',
				'EL', 'EN', 'EO', 'ES', 'ET', 'EU', 'FA', 'FI', 'FO', 'FR', 'GL', 'GU',	'HE', 'HI',
				'HR', 'HU', 'IS', 'IT', 'JA', 'KM', 'KO', 'LT', 'MN', 'MS', 'NB', 'NL', 'NO', 'PL',
				'PT', 'RO', 'RU', 'SK', 'SL', 'SR', 'SV', 'TH', 'TR', 'UK', 'VI', 'ZH');
			
			$languageCode = scMultiLanguage::getCurrentLanguageCode();
			if (in_array($languageCode, $supportedLanguages))
				return $languageCode;
			
			return 'EN';
		}
	}
?>