<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scFormItem {
		
		const ITEM_TYPE_TEXT = 1;
		const ITEM_TYPE_TEXT_AREA = 2;
		const ITEM_TYPE_CHECKBOX = 3;
		const ITEM_TYPE_RADIO_BUTTONS = 4;
		const ITEM_TYPE_SELECT = 5;
		const ITEM_TYPE_EMAIL = 6;
		const ITEM_TYPE_NUMBER = 7;
		const ITEM_TYPE_COUNTRIES = 8;
		const ITEM_TYPE_STATES = 9;
		const ITEM_TYPE_HEADER = 10;
		const ITEM_TYPE_SEPARATOR = 11;
		const ITEM_TYPE_FILE_UPLOAD = 12;
		const ITEM_TYPE_CUSTOM_HTML = 13;
		
		const CUSTOM_HTML_FIELD_PREFIX = 'custom-field-';
		
		/**
		 * @access protected
		 */
		protected $_itemTypes;
		
		/**
		 * @access protected
		 */
		protected $_itemTypesGroups;
		
		protected function __construct()
		{
			$this->_itemTypesGroups[self::ITEM_TYPE_TEXT] = _t('Base');
			$this->_itemTypes[self::ITEM_TYPE_TEXT] = _t('Text');
			$this->_itemTypes[self::ITEM_TYPE_TEXT_AREA] = _t('Multiline Text');
			$this->_itemTypes[self::ITEM_TYPE_CHECKBOX] = _t('Checkbox');
			$this->_itemTypes[self::ITEM_TYPE_RADIO_BUTTONS] = _t('Radio Buttons');
			$this->_itemTypes[self::ITEM_TYPE_SELECT] = _t('Drop-Down List');
			
			$this->_itemTypesGroups[self::ITEM_TYPE_EMAIL] = _t('Specific');
			$this->_itemTypes[self::ITEM_TYPE_EMAIL] = _t('Email');
			$this->_itemTypes[self::ITEM_TYPE_NUMBER] = _t('Number');
			$this->_itemTypes[self::ITEM_TYPE_COUNTRIES] = _t('Countries');
			$this->_itemTypes[self::ITEM_TYPE_STATES] = _t('States');
			$this->_itemTypes[self::ITEM_TYPE_FILE_UPLOAD] = _t('File upload');
			$this->_itemTypes[self::ITEM_TYPE_CUSTOM_HTML] = _t('Custom HTML');
			
			$this->_itemTypesGroups[self::ITEM_TYPE_HEADER] = _t('Display');
			$this->_itemTypes[self::ITEM_TYPE_HEADER] = _t('Header');
			$this->_itemTypes[self::ITEM_TYPE_SEPARATOR] = _t('Separator');
			
			$this->_itemsWithValues = array(self::ITEM_TYPE_RADIO_BUTTONS, self::ITEM_TYPE_SELECT);
		}
		
		/**
		 * @return scFormItem
		 */
		public static function singleton()
		{
			static $obj = null;
			if ($obj == null)
				$obj = new scFormItem();
			return $obj;
		}
		
		public function getItemTypes()
		{
			return $this->_itemTypes;
		}
		
		public function getItemItemGroups()
		{
			return $this->_itemTypesGroups;
		}
		
		public function getItemTypesWithValues()
		{
			return array(scFormItem::ITEM_TYPE_RADIO_BUTTONS, scFormItem::ITEM_TYPE_SELECT);
		}
	}
?>