<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once(dirname(__FILE__) . '/AES.php');	
	
	class scCryptUtil {
		
		const HASH_SHA1 = 'sha1';
		const HASH_MD5 = 'md5';
		
		const CRYPT_AES = 'aes';
		
		public static function hmac($key, $data, $method = self::HASH_MD5)
		{
			$crypt = ($method == self::HASH_MD5) ? 'md5' : 'sha1';
			
			if (strlen($key) > 64)
				$key = pack('H*', $crypt($key));
			$key = str_pad($key, 64, chr(0));
			
			$ipad = str_repeat(chr(0x36), 64);
			$opad = str_repeat(chr(0x5c), 64);
			
			return $crypt(($key ^ $opad) . pack('H*', $crypt(($key ^ $ipad) . $data)));
		}
		
		/**
		 * Encrypt plaintext
		 * @param $plainText
		 * @param $key
		 * @param $method
		 * @return unknown_type
		 */
		public static function encrypt($plainText, $key, $method = self::CRYPT_AES)
		{
			$aes = new Crypt_AES();
			$aes->setKey($key);
			return $aes->encrypt($plainText);
		}
		
		/**
		 * Decrypt ciphertext
		 * @param $cipherText
		 * @param $key
		 * @param $method
		 * @return unknown_type
		 */
		public static function decrypt($cipherText, $key, $method = self::CRYPT_AES)
		{
			$aes = new Crypt_AES();
			$aes->setKey($key);
			return $aes->decrypt($cipherText);
		}
	}
?>