<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * Currency rate class
	 */
	class scCurrencyRate {
		protected $_baseCurrency;
		protected $_quoteCurrency;
		protected $_rate;
		protected $_timestamp;
		
		/**
		 * Constructs the scCurrencyRate object
		 * 
		 * @param string $baseCurrency the base currency symbol (eg. EUR)
		 * @param string $quoteCurrency the quote currency symbol (eg. USD)
		 * @param float $rate the quote rate
		 * @param int $timestamp unix timestamp of the quote
		 */
		public function __construct($baseCurrency, $quoteCurrency, $rate, $timestamp)
		{
			$this->_baseCurrency = $baseCurrency;
			$this->_quoteCurrency = $quoteCurrency;
			$this->_rate = $rate;
			$this->_timestamp = $timestamp;
		}
		
		public function getBaseCurrency()
		{
			return $this->_baseCurrency;
		}
		
		public function getQuoteCurrency()
		{
			return $this->_quoteCurrency;
		}
		
		public function getRate()
		{
			return $this->_rate;
		}
		
		public function getTimestamp()
		{
			return $this->_timestamp;
		}
	}
?>