<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scCustomers {
		
		/**
		 * @return scCustomerDomainObject
		 */
		public static function getGuestCustomer()
		{
			try {
				$customer = new scCustomerDomainObject();
				$customer->read(ICheckoutModule::GUEST_USER_ID);
				return $customer;
			} catch (miDBException $exception) {
				if ($exception->getCode() == miDBException::EXCEPTION_RECORD_NOT_FOUND) {
					throw new miException(_t('Guest customer not found.'));
				}
				throw $exception;
			}
		}
		
		/**
		 * Returns the shipping address of the currently logged customer.
		 * If there is no logged in customer the method returns the guest user's shipping address
		 * 
		 * @return array
		 */
		public static function getCurrentCustomerShippingAddress()
		{
			static $customerShippingAddress;
			
			if (is_null($customerShippingAddress)) {
				// Get the guest user if there is no logged in customer;
				if (scCustomerAuth::singleton()->isLoggedIn()) {
					$customer = scCustomerAuth::singleton()->getCustomer();
				} else {
					$customer = self::getGuestCustomer();
				}
				$customerShippingAddress = scCustomerAddress::getMappedAddressFields(scCustomerAddress::SHIPPING, $customer->getShippingAddress());
			}
			
			return $customerShippingAddress;
		}
	}
?>