<?php
	/**
	 * Copyright (c) 2011 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scFile {
		
		protected $_name = '';
		protected $_type = '';
		protected $_tempName = '';
		protected $_size = 0;
		
		public function setFileData($fileData)
		{
			$this->_name = $fileData['name'];
			$this->_type = $fileData['type'];
			$this->_tempName = $fileData['tmp_name'];
			$this->_size = $fileData['size'];
		}
		
		public function move($destination)
		{
			if (copy($this->_tempName, $destination) == false) {
				throw new miException(sprintf(_i('Unable to move file to "%s".'), $destination));
			}
			unlink($this->_tempName);
			chmod($destination, 0644);
		}
		
		/**
		 * The mime-type is provided by the uploader's browser. It has to be validated!
		 * @return string
		 */
		public function getType()
		{
			$defaultType = 'application/octet-stream';
			
			$typeParts = explode('/', $this->_type);
			
			if (count($typeParts) != 2) {
				return $defaultType;
			}
			
			$contentTypes = array( // http://www.iana.org/assignments/media-types/
				'application', 'audio', 'example',
				'image', 'message', 'model',
				'multipart', 'text','video',
			);
			
			if (!in_array($typeParts[0], $contentTypes)) {
				return $defaultType;
			}
			
			if (!preg_match('/^[a-zA-Z0-9.+-_]+$/', $typeParts[1])) {
				return $defaultType;
			}
			
			return $this->_type;
		}
		
		public function getName()
		{
			return basename($this->_name);
		}
		
		public function getTempName()
		{
			return $this->_tempName;
		}
		
		public function getContents()
		{
			if (!is_file($this->_tempName)) {
				throw new miException(_i('Access denied.'));
			}
			return file_get_contents($this->_tempName);
		}
	}
?>