<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scUploadedFile extends scFile {
		
		protected $_fieldName = '';
		protected $_error = UPLOAD_ERR_NO_FILE;
		
		public function setFieldName($filesArrayFieldName)
		{
			$this->_fieldName = $filesArrayFieldName;
		}
		
		public function setFileData($fileData)
		{
			parent::setFileData($fileData);
			$this->_error = $fileData['error'];
		}
		
		public function move($destination)
		{
			if (move_uploaded_file($this->_tempName, $destination) == false) {
				throw new miException(sprintf(_i('Unable to move temporary file to "%s".'), $destination));
			}
			chmod($destination, 0644);
		}
		
		public function hasErrors()
		{
			if ($this->_error != UPLOAD_ERR_OK) {
				return true;
			}
		}
		
		public function getContents()
		{
			if (!is_uploaded_file($this->_tempName)) {
				throw new miException(_i('Access denied.'));
			}
			return parent::getContents();
		}
		
		public function getErrorCode()
		{
			return $this->_error;
		}
		
		public function getErrorMessage()
		{
			return scFilesUtil::getUploadErrorDescription($this->_error);
		}
		
		public function getFieldName()
		{
			return $this->_fieldName;
		}
	}
?>