<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scCountry {
		public static function getCountryNames($countryIds = array(), $languageId = null)
		{
			if (is_null($languageId)) {
				$languageId = scMultiLanguage::getCurrentLanguageId();
			}
			$sql = 'SELECT Countries.CountryID, CountryName FROM Countries JOIN CountriesML' .
				' ON Countries.CountryID=CountriesML.CountryID AND LanguageID=' . intval($languageId);
			if (count($countryIds))
				$sql .= ' AND Countries.CountryID IN(' . implode(',', $countryIds)  .')';
			$sql .= ' ORDER BY CountryName ASC';
			return miUtil::getDBArray($sql, 'CountryID', 'CountryName');
		}
		
		public static function getCountryName($countryId, $languageId = false)
		{
			return scUtil::getMLDbValue('CountriesML', 'CountryName', 'CountryID', $countryId, $languageId);
		}
		
		public static function getCountryCode2($countryId)
		{
			return scUtil::getDbValue('Countries', 'CountryCode2', 'CountryID', $countryId);
		}

		public static function getCountryCode3($countryId)
		{
			return scUtil::getDbValue('Countries', 'CountryCode3', 'CountryID', $countryId);
		}
		
		public static function getCountryIdByCode2($countryCode2)
		{
			return scUtil::getDbValue('Countries', 'CountryID', 'CountryCode2', $countryCode2);
		}
		
		public static function getCountryIdByCode3($countryCode3)
		{
			return scUtil::getDbValue('Countries', 'CountryID', 'CountryCode3', $countryCode3);
		}
		
		public static function getCountryRequireValidCity($countryId)
		{
			return scUtil::getDbValue('Countries', 'CountryRequireValidCity', 'CountryID', $countryId);
		}
		
		/**
		 * 
		 * FIXME: The languageId is ignored
		 * @param int $stateId
		 * @param int $languageId
		 */
		public static function getStateName($stateId, $languageId = false)
		{
			if ($stateId == 0)
				return '';
			return scUtil::getMLDbValue('StatesML', 'StateName', 'StateID', $stateId, $languageId);
		}
		
		/**
		 * Return state id
		 * 
		 * @param int $countryId
		 * @param int $stateCode
		 */
		public static function getStateId($countryId, $stateCode)
		{
			$sql = 'SELECT StateID FROM States WHERE CountryID=? AND StateCode=?';
			$result = miStaticDBUtil::execSelect($sql, array($countryId, $stateCode));
			if (count($result) == 0)
				return null;
			
			return $result[0]['StateID'];
		}
		
		public static function getStateRows()
		{
			$query = 'SELECT * FROM States LEFT JOIN StatesML USING(StateID) WHERE LanguageID=? ORDER BY StateName ASC';
			return miStaticDBUtil::execSelect($query, array(scMultiLanguage::getCurrentLanguageId()));
		}
		
		public static function getStatesCount($countryId)
		{
			$query = 'SELECT COUNT(1) AS N FROM States WHERE CountryID=?';
			$result = miStaticDBUtil::execSelect($query, array($countryId));
			return $result[0]['N'];
		} 
		
		public static function getStateNames($stateIds = array(), $languageId = null)
		{
			if (is_null($languageId)) {
				$languageId = scMultiLanguage::getCurrentLanguageId();
			}
			$sql = 'SELECT StateID, StateName FROM StatesML WHERE LanguageID=' . intval($languageId);
			if (count($stateIds))
				$sql .= ' AND StatesML.StateID IN(' . implode(',', $stateIds)  .') ';
			$sql .= ' ORDER BY StateName ASC';
			
			return miUtil::getDBArray($sql, 'StateID', 'StateName');
		}
		
		public static function getStateCode($stateId)
		{
			return scUtil::getDbValue('States', 'StateCode', 'StateID', $stateId);
		}
	}
?>