<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scShippingZone {
		const ALL_ZONES = 0;
		
		/**
		 * Return array with all ShippingZoneIDs that match $countryId and $stateId
		 * 
		 * @param int $countryId
		 * @param int $stateId
		 * @return array
		 */
		public static function getShippingZones($countryId, $stateId)
		{
			if (($countryId == 0) and ($stateId == 0))
				return array();
			
			$sql = 'SELECT ShippingZoneID FROM ShippingZoneCountries WHERE CountryID=?' .
				'UNION SELECT ShippingZoneID FROM ShippingZoneStates WHERE StateID=?';
			$zones = miStaticDBUtil::execSelect($sql, array($countryId, $stateId));
			
			$result = array();
			foreach ($zones as $zone)
				$result[] = $zone['ShippingZoneID'];
			return $result;
		}
	}
?>