<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scOrderDetailsUtil {
		
		/**
		 * Retreaves a detail value
		 * @param int $orderId
		 * @param int $moduleId
		 * @param string $detailName
		 */
		public static function getDetail($orderId, $moduleId, $detailName)
		{
			$sql = 'SELECT OrderDetailValue FROM OrderDetails WHERE OrderID = ? AND ModuleID = ? AND OrderDetailName = ?';
			$res = miStaticDBUtil::execSelect($sql, array($orderId, $moduleId, $detailName));
			if (empty($res)) {
				throw new miException(_i('Order detail not set.'));
			}
			return $res[0]['OrderDetailValue'];
		}
		
		/**
		 * Saves a detail value
		 * @param int $orderId
		 * @param int $moduleId
		 * @param string $detailName
		 * @param string $detailValue
		 */
		public static function setDetail($orderId, $moduleId, $detailName, $detailValue)
		{
			$sql = 'REPLACE INTO OrderDetails (OrderDetailID, OrderID, ModuleID, OrderDetailName, OrderDetailValue) 
					VALUES (NULL, ?, ?, ?, ?)';
			
			miStaticDBUtil::execSQL($sql, array($orderId, $moduleId, $detailName, $detailValue));
		}
		
		public static function removeDetail($orderId, $moduleId, $detailName)
		{
			$sql = 'DELETE FROM OrderDetails WHERE OrderID = ? AND ModuleID = ? AND OrderDetailName = ?';
			miStaticDBUtil::execSQL($sql, array($orderId, $moduleId, $detailName));
		}
	}
?>