<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scPaymentCreditCard extends miSqlRecord {
		protected $_update;
		
		public function __construct($orderId = 0)
		{
			parent::__construct('PaymentCreditCards', 'PaymentCreditCardID');
			
			if ($orderId) {
				try {
					$this->read('OrderID', $orderId);
					$this->_update = true;
				} catch (miDBException $exception) {
					if ($exception->getCode() != miDBException::EXCEPTION_RECORD_NOT_FOUND)
						throw $exception;
					
					// If the read fails then set the OrderID
					$this->set('OrderID', $orderId);
				}
			}
		}
		
		public function isForUpdate()
		{
			return $this->_update;
		}
		
		public function save()
		{
			if ($this->_update)
				return $this->update();
			else
				return $this->insert();
		}
	}
?>