<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scLocalOption extends scProductOption {
		
		protected $_fieldPriceModType = 'LocalOptionPriceModType';
		protected $_fieldPriceModValue = 'LocalOptionPriceModValue';
		
		public static function getLocalOptionToProductOptionMapping()
		{
			return array(
				'LocalOptionID' => 'OptionID',
				'LocalOptionGroupID' => 'OptionGroupID',
				'LocalOptionPriceModType' => 'OptionPriceModType',
				'LocalOptionPriceModValue' => 'OptionPriceModValue',
				'LocalOptionName' => 'OptionName',
				'LocalOptionRequired' => 'OptionRequired',
				'LocalOptionGroupName' => 'OptionGroupName',
				'LocalOptionGroupType' => 'OptionGroupType',
				'LocalOptionUserText' => 'OptionUserText',
				'LocalOptionSort' => 'OptionSort',
			);
		}
		
		/**
		 * @return array
		 */
		public function getOptionInfo(scMultiCurrencyAmount $productPrice)
		{
			$optionInfo = $this->_optionInfo;
			$mapping = self::getLocalOptionToProductOptionMapping();
			
			foreach ($mapping as $mappingField => $optionField) {
				if (($mappingField != $optionField) && isset($optionInfo[$mappingField])) {
					$optionInfo[$optionField] = $optionInfo[$mappingField];
					unset($optionInfo[$mappingField]);
				}
			}
			
			$price = scPrice::factory($this->getOptionPriceChange($productPrice));
			$optionInfo['OptionPrice'] = $price->getDisplayPrice();
			if ($optionInfo['OptionPriceModValue'] > 0)
				$optionInfo['OptionPrice'] = '+' . $optionInfo['OptionPrice'];
			return $optionInfo;
		}
		
		/**
		 * @return scLocalOptionGroupDomainObject
		 */
		public function getOptionGroup()
		{
			$optionGroup = new scLocalOptionGroupDomainObject();
			$optionGroup->setRow(array(
				'LocalOptionGroupID' => $this->_optionInfo['LocalOptionGroupID'],
				'LocalOptionGroupType' => $this->_optionInfo['LocalOptionGroupType'],
				'LocalOptionGroupName' => $this->_optionInfo['LocalOptionGroupName'],
				'LanguageID' => $this->_optionInfo['LanguageID'],
			));
			return $optionGroup;
		}
	}
?>