<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scLocalOptions extends scProductOptions {
		
		/**
		 * @param array $optionIds
		 * @return array
		 */
		public static function getOptionsInfo($optionIds, $langaugeId = null)
		{
			if (count($optionIds) == 0)
				return array();
			
			$optionIds = array_map('sql_escape_string', $optionIds);
			$optionIds = '"' . implode('", "', $optionIds) . '"';
			$sql =  'SELECT *, LocalOptions.LocalOptionID AS OptionID, LocalOptions.LocalOptionGroupID AS OptionGroupID FROM LocalOptions ' .
					'LEFT JOIN LocalOptionsML USING(LocalOptionID) ' .
					'INNER JOIN LocalOptionGroups ON (LocalOptions.LocalOptionGroupID = LocalOptionGroups.LocalOptionGroupID) ' .
					'LEFT JOIN LocalOptionGroupsML ON (LocalOptionGroups.LocalOptionGroupID = LocalOptionGroupsML.LocalOptionGroupID) ' .
					'WHERE LocalOptions.LocalOptionID IN (' . $optionIds . ') AND LocalOptionsML.LanguageID = ? AND LocalOptionGroupsML.LanguageID = ?';
			
			if (is_null($langaugeId)) {
				$langaugeId = scMultiLanguage::getCurrentLanguageId();
			}
			
			$options = miStaticDBUtil::execSelect($sql, array($langaugeId, $langaugeId));
			$options = miUtil::getArrayWithKeys($options, 'OptionID');
			
			foreach ($options as $optionId => $optionData) {
				$options[$optionId]['OptionUploadedFileName'] = self::getSessionTempUserFileName('LocalOptions', $optionData['LocalOptionGroupID'], $optionId);
				$options[$optionId]['OptionUserText'] = self::getSessionTempUserText('LocalOptions', $optionData['LocalOptionGroupID'], $optionId);
			}
			
			return $options;
		}
	}
?>