<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scProductVariantOption {

		const TYPE_GLOBAL = 1;
		const TYPE_LOCAL = 2;

		/**
		 * @var int
		 */
		protected $_optionId;
		
		/**
		 * One of TYPE_GLOBAL or TYPE_LOCAL.
		 * @var int
		 */
		protected $_optionType;
		
		/**
		 * @var bool
		 */
		protected $_optionIsNew = false;
		
		/**
		 * @var bool
		 */
		protected $_optionGroupIsNew = false;

		public function __construct($optionId, $optionType, $optionIsNew = false)
		{
			$this->_optionId = $optionId;
			$this->_optionType = $optionType;
			$this->_optionIsNew = $optionIsNew;
		}
		
		public function getTableName()
		{
			switch ($this->_optionType) {
				case self::TYPE_GLOBAL:
					return 'ProductVariantOptions';

				case self::TYPE_LOCAL:
					return 'ProductVariantLocalOptions';
			}

			throw new miException(sprintf(_i('Unknown variant option type "%s".'), $this->_optionType));
		}

		public function getOptionId()
		{
			return $this->_optionId;
		}
		
		/**
		 * @param bool $isNewGroup
		 */
		public function setIsNewGroup($isNewGroup)
		{
			$this->_optionGroupIsNew = $isNewGroup;
			// If the whole group is new the option is new as well.
			if ($isNewGroup) {
				$this->setIsNew(true);
			}
		}
		
		/**
		 * @return bool
		 */
		public function isNewGroup()
		{
			return $this->_optionGroupIsNew;
		}
		
		/**
		 * @param bool $isNew
		 */
		public function setIsNew($isNew)
		{
			$this->_optionIsNew = $isNew;
		}
		
		/**
		 * @return bool
		 */
		public function isNew()
		{
			return $this->_optionIsNew;
		}
	}
?>