<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scProductsXCategories {
		
		protected static $_prepared = array();
		
		protected static $_cache = array();
		
		public static function prepareProducts($productIds)
		{
			$productIds = array_map('intval', $productIds);
			
			self::$_prepared = $productIds;
		}
		
		public static function getProductCategories($productId)
		{
			// Check if this product's categories have already been found.
			if (isset(self::$_cache[$productId])) {
				return self::$_cache[$productId];
			}
			
			// Check if the product is currently prepared.
			if (!in_array($productId, self::$_prepared)) {
				// Add it to the prepare list if needed.
				self::$_prepared[] = $productId;
			}
			
			$productIdsSql = implode(', ', self::$_prepared);
			
			// Get all categories the products belong to.
			$sql = '(SELECT ProductID, CategoryID FROM Products WHERE ProductID IN (' . $productIdsSql . '))'	.
				'UNION ALL ' .
				'(SELECT ProductID, CategoryID FROM ProductXCategories WHERE ProductID IN (' . $productIdsSql . '))';
			$result = miStaticDBUtil::execSelect($sql);
			
			if (empty($result)) {
				// Nothing to cache.
				return array();
			}
			
			// Add each product's category to the cache
			foreach ($result as $pair) {
				self::$_cache[$pair['ProductID']][] = $pair['CategoryID'];
			}
			
			// There is no data for the requested product.
			if (!isset(self::$_cache[$productId])) {
				return array();
			}
			
			return self::$_cache[$productId];
		}
	}
?>