<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * Encapsulates Weight property
	 */
	class scWeight {
		protected $_weight;
		protected $_weightUnits;
		
		/**
		 * Constructs the weight object
		 * 
		 * @param float $weight
		 * @param int $weightUnits
		 */
		public function __construct($weight, $weightUnits)
		{
			$this->setWeight($weight, $weightUnits);
		}
		
		/**
		 * Return the weight units
		 *
		 * @return int
		 */
		public function getWeightUnits()
		{
			return $this->_weightUnits;
		}
		
		/**
		 * Sets the weight
		 *
		 * @param float $weight
		 * @param int $weightUnits
		 */
		public function setWeight($weight, $weightUnits)
		{
			$this->_weight = $weight;
			$this->_weightUnits = $weightUnits;
		}
		
		/**
		 * Returns the weight
		 *
		 * @return float the weight
		 */
		public function getWeight()
		{
			return $this->_weight;
		}
		
		/**
		 * Returns the weight, converting first if necessary
		 * 
		 * @param int $weightUnits
		 * @return float the weight
		 */
		public function getWeightInUnits($weightUnits)
		{
			if ($this->_weightUnits == $weightUnits)
				return $this->_weight;
			
			if ($this->_weight == scWeightUnits::WEIGHT_UNIT_KGS)
				return $this->_weight * 0.45359237;	// Convert LBS to KGS
			else
				return $this->_weight / 0.45359237; // Convert KGS to LBS
		}
	}
?>