<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scWeightUnits {
		const WEIGHT_UNIT_KGS = 1;
		const WEIGHT_UNIT_LBS = 2;
		
		protected static $weightUnits;
		
		/**
		 * Returns the weight units
		 * 
		 * @return int the weight units
		 */
		public static function getWeightUnits()
		{
			if (isset(self::$weightUnits))
				return self::$weightUnits;
			
			self::$weightUnits = array(
				self::WEIGHT_UNIT_KGS => _t('Kgs'),
				self::WEIGHT_UNIT_LBS => _t('Lbs'),
			);
			return self::$weightUnits;
		}
		
		/**
		 * Return the current weight units
		 *
		 */
		public static function getCurrentWeightUnit()
		{
			return scSettings::getSettingValue(scSettings::SETTING_LOCALIZATION_WEIGHT_UNIT);
		}
		
		public static function getCurrentWeightUnitName()
		{
			return self::getWeightUnitsName(self::getCurrentWeightUnit());
		}
		
		/**
		 * @param int $units
		 * @return string
		 */
		public static function getWeightUnitsName($units)
		{
			$weightUnits = self::getWeightUnits();
			return $weightUnits[$units];
		}
	}
?>