<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	class scShippingLabelCache {
		
		/**
		 * Checks if cache exists
		 * @param string $fileName
		 */
		public static function checkCacheExists($fileName)
		{
			return file_exists(self::getCacheFilePath($fileName));
		}
		
		/**
		 * Retrieves cached content
		 * @param string $fileName
		 */
		public static function getCachedContent($fileName)
		{
			return file_get_contents(self::getCacheFilePath($fileName));
		}
		
		/**
		 * Caches data from shipping module 
		 * @param string $fileName
		 * @param string $content
		 */
		public static function storeShippingLabelContent($fileName, $content)
		{
			file_put_contents(self::getCacheFilePath($fileName), $content);
		}
		
		/**
		 * Return pathname to the cachefile
		 * 
		 * @param string $fileName
		 * @return string
		 */
		public static function getCacheFilePath($fileName)
		{
			return scPaths::getFilenamePath($fileName, scPaths::RESOURCE_SHIPPING_LABEL_CACHE_FILE, scPaths::PATH_FILE);
		}
	}
?>