<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */

	class scShippingLabelUtil {
		
		/**
		 * Get the shipping label module for $orderId
		 * 
		 * @param int $orderId
		 * @return IShippingLabelModule
		 */
		public static function getShippingLabelModuleImplementation($orderId)
		{
			$order = new scOrder();
			$order->read($orderId);
			
			// get shippingModuleId
			$shippingModuleId = $order->get('ShippingModuleID');
			
			// get moduleId from shippingModuleId
			$moduleId = scUtil::getDbValue('ShippingModules', 'ModuleID', 'ShippingModuleID', $shippingModuleId);
			if (empty($moduleId)) {
				return self::getDefaultShippingLabelImplementation();
			}
			
			// try to get implementation of IShippingLabelModule for current ModuleID
			try {
				$shippinLabelModule = scModulesFactory::getImplementation($moduleId, 'IShippingLabelModule');
			} catch (miException $e) {
				return self::getDefaultShippingLabelImplementation();
			}
			return $shippinLabelModule;
		}
		
		/**
		 * Returns default implementation of IShippingLabelModule
		 * @return IShippingLabelModule
		 */
		public static function getDefaultShippingLabelImplementation()
		{
			$moduleName = 'com.summercart.shippinglabel.default';
			$moduleId = scModulesFactory::getModuleIdByName($moduleName);
			return scModulesFactory::getImplementation($moduleId, 'IShippingLabelModule');
		}
	}
?>