<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * Implementation of Microsoft DISCO protocol
	 * Discovery of Web Services (DISCO)
	 *  
	 * @see http://msdn.microsoft.com/en-us/library/tewz1055%28VS.80%29.aspx
	 * @see http://lists.ebxml.org/archives/ebxml-transport/200007/msg00007.html
	 */
	class scDisco {
		/**
		 * Builds DISCO document
		 * 
		 * @param array $wsdlUrls
		 * @return string XML with the disco document
		 */
		public function getDisco($wsdlUrls)
		{
			$contractRefs = array();
			foreach ($wsdlUrls as $wsdlUrl) {
				$contractRefs[] = array(
					scXml::TAG => 'scl:contractRef',
					scXml::ATTRIBUTES => array(
						'ref' => $wsdlUrl,
					)
				);
			}
			
			$definitions = array(
				array(
					scXml::TAG => 'disco:discovery',
					scXml::ATTRIBUTES => array(
						'xmlns:scl' => 'http://schemas.xmlsoap.org/disco/scl/',
						'xmlns:disco' => 'http://schemas.xmlsoap.org/disco/',
					),
					scXml::CHILDREN => $contractRefs
				),
			);
			
			
			return '<?xml version="1.0" encoding="UTF-8"?>' . scXml::xmlWriter($definitions);
		}
	}
?>