<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scUrlResolverFactory {
			
		/**
		 * @return IUrlResolver
		 */
		public static function getUrlResolverForPageType($pageType)
		{
			switch ($pageType) {
				case scFriendlyUrl::TYPE_MANUFACTURER:
					return new scManufacturersUrlResolver();
				
				case scFriendlyUrl::TYPE_PRODUCT:
					return new scProductsUrlResolver();
				
				case scFriendlyUrl::TYPE_PRODUCT_VARIANT:
					return new scProductVariantsUrlResolver();
				
				case scFriendlyUrl::TYPE_RICH_TEXT_PAGE:
					return new scRichTextPageUrlResolver();
				
				case scFriendlyUrl::TYPE_DYNAMIC_FORM:
					return new scFormUrlResolver();
				
				case scFriendlyUrl::TYPE_CATEGORY:
					return new scCategoryUrlResolver();
				
				case scFriendlyUrl::TYPE_GALLERY:
					return new scGalleryUrlResolver();
				
				case scFriendlyUrl::TYPE_NEWS:
					return new scNewsUrlResolver();
				
				case scFriendlyUrl::TYPE_WISHLIST:
					return new scWishlistUrlResolver();
				
				case scFriendlyUrl::TYPE_PRODUCT_COMPARISON:
					return new scProductComparisonUrlResolver();
				
				case scFriendlyUrl::TYPE_DYNAMIC_PAGE:
					return new scDynamicPageUrlResolver();
			}
			
			throw new miException(sprintf(_i('Unknown page type "%s".'), $pageType));
		}
	}
?>