<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */ 

	/**
	 * lower case to uppercase mapping for UTF Characters
	 * @var array $lowerToUpperUtfTable
	 */
	class scUtfCaseMappings {
		
		public static function getLowerToUpper()
		{
			return self::$lowerToUpperUtfTable;
		}
		
		public static function getUpperToLower()
		{
			if (is_null(self::$upperToLowerUtfTable)) {
				self::$upperToLowerUtfTable = array_flip(self::$lowerToUpperUtfTable);
			}
			return self::$upperToLowerUtfTable;
		}
		
		protected static $upperToLowerUtfTable;
		protected static $lowerToUpperUtfTable = array(
		// Latin
		"a" => "A", "a" => "A", "ⓐ" => "Ⓐ", "ⓐ" => "Ⓐ", "ａ" => "Ａ", "ａ" => "Ａ", "ẚ" => "A&#x2BE;", "à" => "À", "à" => "À", "á" => "Á", 
		"á" => "Á", "â" => "Â", "â" => "Â", "ầ" => "Ầ", "ầ" => "Ầ", "ấ" => "Ấ", "ấ" => "Ấ", "ẫ" => "Ẫ", "ẫ" => "Ẫ", "ẩ" => "Ẩ", 
		"ẩ" => "Ẩ", "ã" => "Ã", "ã" => "Ã", "ā" => "Ā", "ā" => "Ā", "ă" => "Ă", "ă" => "Ă", "ằ" => "Ằ", "ằ" => "Ằ", "ắ" => "Ắ", 
		"ắ" => "Ắ", "ẵ" => "Ẵ", "ẵ" => "Ẵ", "ẳ" => "Ẳ", "ẳ" => "Ẳ", "ȧ" => "Ȧ", "ȧ" => "Ȧ", "ǡ" => "Ǡ", "ǡ" => "Ǡ", "ä" => "Ä", 
		"ä" => "Ä", "ǟ" => "Ǟ", "ǟ" => "Ǟ", "ả" => "Ả", "ả" => "Ả", "å" => "Å", "å" => "Å", "å" => "Å", "ǻ" => "Ǻ", "ǻ" => "Ǻ", 
		"ǎ" => "Ǎ", "ǎ" => "Ǎ", "ȁ" => "Ȁ", "ȁ" => "Ȁ", "ȃ" => "Ȃ", "ȃ" => "Ȃ", "ạ" => "Ạ", "ạ" => "Ạ", "ậ" => "Ậ", "ậ" => "Ậ", 
		"ặ" => "Ặ", "ặ" => "Ặ", "ḁ" => "Ḁ", "ḁ" => "Ḁ", "ą" => "Ą", "ą" => "Ą", "b" => "B", "b" => "B", "ⓑ" => "Ⓑ", "ⓑ" => "Ⓑ", 
		"ｂ" => "Ｂ", "ｂ" => "Ｂ", "ḃ" => "Ḃ", "ḃ" => "Ḃ", "ḅ" => "Ḅ", "ḅ" => "Ḅ", "ḇ" => "Ḇ", "ḇ" => "Ḇ", "c" => "C", "c" => "C", 
		"ⅽ" => "Ⅽ", "ⅽ" => "Ⅽ", "ⓒ" => "Ⓒ", "ⓒ" => "Ⓒ", "ｃ" => "Ｃ", "ｃ" => "Ｃ", "ć" => "Ć", "ć" => "Ć", "ĉ" => "Ĉ", "ĉ" => "Ĉ", 
		"ċ" => "Ċ", "ċ" => "Ċ", "č" => "Č", "č" => "Č", "ç" => "Ç", "ç" => "Ç", "ḉ" => "Ḉ", "ḉ" => "Ḉ", "d" => "D", "d" => "D", 
		"ⅾ" => "Ⅾ", "ⅾ" => "Ⅾ", "ⓓ" => "Ⓓ", "ⓓ" => "Ⓓ", "ｄ" => "Ｄ", "ｄ" => "Ｄ", "ǳ" => "Ǳ", "ǳ" => "Ǳ", "ǳ" => "Ǳ", "ǆ" => "Ǆ", 
		"ǆ" => "Ǆ", "ǆ" => "Ǆ", "ḋ" => "Ḋ", "ḋ" => "Ḋ", "ď" => "Ď", "ď" => "Ď", "ḍ" => "Ḍ", "ḍ" => "Ḍ", "ḑ" => "Ḑ", "ḑ" => "Ḑ", 
		"ḓ" => "Ḓ", "ḓ" => "Ḓ", "ḏ" => "Ḏ", "ḏ" => "Ḏ", "e" => "E", "e" => "E", "ⓔ" => "Ⓔ", "ⓔ" => "Ⓔ", "ｅ" => "Ｅ", "ｅ" => "Ｅ", 
		"è" => "È", "è" => "È", "é" => "É", "é" => "É", "ê" => "Ê", "ê" => "Ê", "ề" => "Ề", "ề" => "Ề", "ế" => "Ế", "ế" => "Ế", 
		"ễ" => "Ễ", "ễ" => "Ễ", "ể" => "Ể", "ể" => "Ể", "ẽ" => "Ẽ", "ẽ" => "Ẽ", "ē" => "Ē", "ē" => "Ē", "ḕ" => "Ḕ", "ḕ" => "Ḕ", 
		"ḗ" => "Ḗ", "ḗ" => "Ḗ", "ĕ" => "Ĕ", "ĕ" => "Ĕ", "ė" => "Ė", "ė" => "Ė", "ë" => "Ë", "ë" => "Ë", "ẻ" => "Ẻ", "ẻ" => "Ẻ", 
		"ě" => "Ě", "ě" => "Ě", "ȅ" => "Ȅ", "ȅ" => "Ȅ", "ȇ" => "Ȇ", "ȇ" => "Ȇ", "ẹ" => "Ẹ", "ẹ" => "Ẹ", "ệ" => "Ệ", "ệ" => "Ệ", 
		"ȩ" => "Ȩ", "ȩ" => "Ȩ", "ḝ" => "Ḝ", "ḝ" => "Ḝ", "ę" => "Ę", "ę" => "Ę", "ḙ" => "Ḙ", "ḙ" => "Ḙ", "ḛ" => "Ḛ", "ḛ" => "Ḛ", 
		"f" => "F", "f" => "F", "ⓕ" => "Ⓕ", "ⓕ" => "Ⓕ", "ｆ" => "Ｆ", "ｆ" => "Ｆ", "ﬀ" => "FF", "ﬃ" => "FFI", "ﬄ" => "FFL", "ﬁ" => "FI", 
		"ﬂ" => "FL", "ḟ" => "Ḟ", "ḟ" => "Ḟ", "g" => "G", "g" => "G", "ⓖ" => "Ⓖ", "ⓖ" => "Ⓖ", "ｇ" => "Ｇ", "ｇ" => "Ｇ", "ǵ" => "Ǵ", 
		"ǵ" => "Ǵ", "ĝ" => "Ĝ", "ĝ" => "Ĝ", "ḡ" => "Ḡ", "ḡ" => "Ḡ", "ğ" => "Ğ", "ğ" => "Ğ", "ġ" => "Ġ", "ġ" => "Ġ", "ǧ" => "Ǧ", 
		"ǧ" => "Ǧ", "ģ" => "Ģ", "ģ" => "Ģ", "h" => "H", "h" => "H", "ⓗ" => "Ⓗ", "ⓗ" => "Ⓗ", "ｈ" => "Ｈ", "ｈ" => "Ｈ", "ĥ" => "Ĥ", 
		"ĥ" => "Ĥ", "ḣ" => "Ḣ", "ḣ" => "Ḣ", "ḧ" => "Ḧ", "ḧ" => "Ḧ", "ȟ" => "Ȟ", "ȟ" => "Ȟ", "ḥ" => "Ḥ", "ḥ" => "Ḥ", "ḩ" => "Ḩ", 
		"ḩ" => "Ḩ", "ḫ" => "Ḫ", "ḫ" => "Ḫ", "ẖ" => "H&#x331;", "i" => "I", "i" => "I", "ⅰ" => "Ⅰ", "ⅰ" => "Ⅰ", "ⓘ" => "Ⓘ", "ⓘ" => "Ⓘ", 
		"ｉ" => "Ｉ", "ｉ" => "Ｉ", "ⅱ" => "Ⅱ", "ⅱ" => "Ⅱ", "ⅲ" => "Ⅲ", "ⅲ" => "Ⅲ", "ĳ" => "Ĳ", "ĳ" => "Ĳ", "ⅳ" => "Ⅳ", "ⅳ" => "Ⅳ", 
		"ⅸ" => "Ⅸ", "ⅸ" => "Ⅸ", "ì" => "Ì", "ì" => "Ì", "í" => "Í", "í" => "Í", "î" => "Î", "î" => "Î", "ĩ" => "Ĩ", "ĩ" => "Ĩ", 
		"ī" => "Ī", "ī" => "Ī", "ĭ" => "Ĭ", "ĭ" => "Ĭ", "i" => "İ", "ï" => "Ï", "ï" => "Ï", "ḯ" => "Ḯ", "ḯ" => "Ḯ", "ỉ" => "Ỉ", 
		"ỉ" => "Ỉ", "ǐ" => "Ǐ", "ǐ" => "Ǐ", "ȉ" => "Ȉ", "ȉ" => "Ȉ", "ȋ" => "Ȋ", "ȋ" => "Ȋ", "ị" => "Ị", "ị" => "Ị", "į" => "Į", 
		"į" => "Į", "ḭ" => "Ḭ", "ḭ" => "Ḭ", "j" => "J", "j" => "J", "ⓙ" => "Ⓙ", "ⓙ" => "Ⓙ", "ｊ" => "Ｊ", "ｊ" => "Ｊ", "ĵ" => "Ĵ", 
		"ĵ" => "Ĵ", "ǰ" => "J&#x30C;", "k" => "K", "k" => "K", "k" => "K", "ⓚ" => "Ⓚ", "ⓚ" => "Ⓚ", "ｋ" => "Ｋ", "ｋ" => "Ｋ", "ḱ" => "Ḱ", 
		"ḱ" => "Ḱ", "ǩ" => "Ǩ", "ǩ" => "Ǩ", "ḳ" => "Ḳ", "ḳ" => "Ḳ", "ķ" => "Ķ", "ķ" => "Ķ", "ḵ" => "Ḵ", "ḵ" => "Ḵ", "l" => "L", 
		"l" => "L", "ⅼ" => "Ⅼ", "ⅼ" => "Ⅼ", "ⓛ" => "Ⓛ", "ⓛ" => "Ⓛ", "ｌ" => "Ｌ", "ｌ" => "Ｌ", "ǉ" => "Ǉ", "ǉ" => "Ǉ", "ǉ" => "Ǉ", 
		"ŀ" => "Ŀ", "ŀ" => "Ŀ", "ĺ" => "Ĺ", "ĺ" => "Ĺ", "ľ" => "Ľ", "ľ" => "Ľ", "ḷ" => "Ḷ", "ḷ" => "Ḷ", "ḹ" => "Ḹ", "ḹ" => "Ḹ", 
		"ļ" => "Ļ", "ļ" => "Ļ", "ḽ" => "Ḽ", "ḽ" => "Ḽ", "ḻ" => "Ḻ", "ḻ" => "Ḻ", "m" => "M", "m" => "M", "ⅿ" => "Ⅿ", "ⅿ" => "Ⅿ", 
		"ⓜ" => "Ⓜ", "ⓜ" => "Ⓜ", "ｍ" => "Ｍ", "ｍ" => "Ｍ", "ḿ" => "Ḿ", "ḿ" => "Ḿ", "ṁ" => "Ṁ", "ṁ" => "Ṁ", "ṃ" => "Ṃ", "ṃ" => "Ṃ", 
		"n" => "N", "n" => "N", "ⓝ" => "Ⓝ", "ⓝ" => "Ⓝ", "ｎ" => "Ｎ", "ｎ" => "Ｎ", "ǌ" => "Ǌ", "ǌ" => "Ǌ", "ǌ" => "Ǌ", "ǹ" => "Ǹ", 
		"ǹ" => "Ǹ", "ń" => "Ń", "ń" => "Ń", "ñ" => "Ñ", "ñ" => "Ñ", "ṅ" => "Ṅ", "ṅ" => "Ṅ", "ň" => "Ň", "ň" => "Ň", "ṇ" => "Ṇ", 
		"ṇ" => "Ṇ", "ņ" => "Ņ", "ņ" => "Ņ", "ṋ" => "Ṋ", "ṋ" => "Ṋ", "ṉ" => "Ṉ", "ṉ" => "Ṉ", "o" => "O", "o" => "O", "ⓞ" => "Ⓞ", 
		"ⓞ" => "Ⓞ", "ｏ" => "Ｏ", "ｏ" => "Ｏ", "ò" => "Ò", "ò" => "Ò", "ó" => "Ó", "ó" => "Ó", "ô" => "Ô", "ô" => "Ô", "ồ" => "Ồ", 
		"ồ" => "Ồ", "ố" => "Ố", "ố" => "Ố", "ỗ" => "Ỗ", "ỗ" => "Ỗ", "ổ" => "Ổ", "ổ" => "Ổ", "õ" => "Õ", "õ" => "Õ", "ṍ" => "Ṍ", 
		"ṍ" => "Ṍ", "ȭ" => "Ȭ", "ȭ" => "Ȭ", "ṏ" => "Ṏ", "ṏ" => "Ṏ", "ō" => "Ō", "ō" => "Ō", "ṑ" => "Ṑ", "ṑ" => "Ṑ", "ṓ" => "Ṓ", 
		"ṓ" => "Ṓ", "ŏ" => "Ŏ", "ŏ" => "Ŏ", "ȯ" => "Ȯ", "ȯ" => "Ȯ", "ȱ" => "Ȱ", "ȱ" => "Ȱ", "ö" => "Ö", "ö" => "Ö", "ȫ" => "Ȫ", 
		"ȫ" => "Ȫ", "ỏ" => "Ỏ", "ỏ" => "Ỏ", "ő" => "Ő", "ő" => "Ő", "ǒ" => "Ǒ", "ǒ" => "Ǒ", "ȍ" => "Ȍ", "ȍ" => "Ȍ", "ȏ" => "Ȏ", 
		"ȏ" => "Ȏ", "ơ" => "Ơ", "ơ" => "Ơ", "ờ" => "Ờ", "ờ" => "Ờ", "ớ" => "Ớ", "ớ" => "Ớ", "ỡ" => "Ỡ", "ỡ" => "Ỡ", "ở" => "Ở", 
		"ở" => "Ở", "ợ" => "Ợ", "ợ" => "Ợ", "ọ" => "Ọ", "ọ" => "Ọ", "ộ" => "Ộ", "ộ" => "Ộ", "ǫ" => "Ǫ", "ǫ" => "Ǫ", "ǭ" => "Ǭ", 
		"ǭ" => "Ǭ", "p" => "P", "p" => "P", "ⓟ" => "Ⓟ", "ⓟ" => "Ⓟ", "ｐ" => "Ｐ", "ｐ" => "Ｐ", "ṕ" => "Ṕ", "ṕ" => "Ṕ", "ṗ" => "Ṗ", 
		"ṗ" => "Ṗ", "q" => "Q", "q" => "Q", "ⓠ" => "Ⓠ", "ⓠ" => "Ⓠ", "ｑ" => "Ｑ", "ｑ" => "Ｑ", "r" => "R", "r" => "R", "ⓡ" => "Ⓡ", 
		"ⓡ" => "Ⓡ", "ｒ" => "Ｒ", "ｒ" => "Ｒ", "ŕ" => "Ŕ", "ŕ" => "Ŕ", "ṙ" => "Ṙ", "ṙ" => "Ṙ", "ř" => "Ř", "ř" => "Ř", "ȑ" => "Ȑ", 
		"ȑ" => "Ȑ", "ȓ" => "Ȓ", "ȓ" => "Ȓ", "ṛ" => "Ṛ", "ṛ" => "Ṛ", "ṝ" => "Ṝ", "ṝ" => "Ṝ", "ŗ" => "Ŗ", "ŗ" => "Ŗ", "ṟ" => "Ṟ", 
		"ṟ" => "Ṟ", "s" => "S", "s" => "S", "ſ" => "S", "ⓢ" => "Ⓢ", "ⓢ" => "Ⓢ", "ｓ" => "Ｓ", "ｓ" => "Ｓ", "ß" => "SS", "ß" => "ẞ", 
		"ﬅ" => "ST", "ﬆ" => "ST", "ś" => "Ś", "ś" => "Ś", "ṥ" => "Ṥ", "ṥ" => "Ṥ", "ŝ" => "Ŝ", "ŝ" => "Ŝ", "ṡ" => "Ṡ", "ṡ" => "Ṡ", 
		"ẛ" => "Ṡ", "š" => "Š", "š" => "Š", "ṧ" => "Ṧ", "ṧ" => "Ṧ", "ṣ" => "Ṣ", "ṣ" => "Ṣ", "ṩ" => "Ṩ", "ṩ" => "Ṩ", "ș" => "Ș", 
		"ș" => "Ș", "ş" => "Ş", "ş" => "Ş", "t" => "T", "t" => "T", "ⓣ" => "Ⓣ", "ⓣ" => "Ⓣ", "ｔ" => "Ｔ", "ｔ" => "Ｔ", "ṫ" => "Ṫ", 
		"ṫ" => "Ṫ", "ẗ" => "T&#x308;", "ť" => "Ť", "ť" => "Ť", "ṭ" => "Ṭ", "ṭ" => "Ṭ", "ț" => "Ț", "ț" => "Ț", "ţ" => "Ţ", "ţ" => "Ţ", 
		"ṱ" => "Ṱ", "ṱ" => "Ṱ", "ṯ" => "Ṯ", "ṯ" => "Ṯ", "u" => "U", "u" => "U", "ⓤ" => "Ⓤ", "ⓤ" => "Ⓤ", "ｕ" => "Ｕ", "ｕ" => "Ｕ", 
		"ù" => "Ù", "ù" => "Ù", "ú" => "Ú", "ú" => "Ú", "û" => "Û", "û" => "Û", "ũ" => "Ũ", "ũ" => "Ũ", "ṹ" => "Ṹ", "ṹ" => "Ṹ", 
		"ū" => "Ū", "ū" => "Ū", "ṻ" => "Ṻ", "ṻ" => "Ṻ", "ŭ" => "Ŭ", "ŭ" => "Ŭ", "ü" => "Ü", "ü" => "Ü", "ǜ" => "Ǜ", "ǜ" => "Ǜ", 
		"ǘ" => "Ǘ", "ǘ" => "Ǘ", "ǖ" => "Ǖ", "ǖ" => "Ǖ", "ǚ" => "Ǚ", "ǚ" => "Ǚ", "ủ" => "Ủ", "ủ" => "Ủ", "ů" => "Ů", "ů" => "Ů", 
		"ű" => "Ű", "ű" => "Ű", "ǔ" => "Ǔ", "ǔ" => "Ǔ", "ȕ" => "Ȕ", "ȕ" => "Ȕ", "ȗ" => "Ȗ", "ȗ" => "Ȗ", "ư" => "Ư", "ư" => "Ư", 
		"ừ" => "Ừ", "ừ" => "Ừ", "ứ" => "Ứ", "ứ" => "Ứ", "ữ" => "Ữ", "ữ" => "Ữ", "ử" => "Ử", "ử" => "Ử", "ự" => "Ự", "ự" => "Ự", 
		"ụ" => "Ụ", "ụ" => "Ụ", "ṳ" => "Ṳ", "ṳ" => "Ṳ", "ų" => "Ų", "ų" => "Ų", "ṷ" => "Ṷ", "ṷ" => "Ṷ", "ṵ" => "Ṵ", "ṵ" => "Ṵ", 
		"v" => "V", "v" => "V", "ⅴ" => "Ⅴ", "ⅴ" => "Ⅴ", "ⓥ" => "Ⓥ", "ⓥ" => "Ⓥ", "ｖ" => "Ｖ", "ｖ" => "Ｖ", "ⅵ" => "Ⅵ", "ⅵ" => "Ⅵ", 
		"ⅶ" => "Ⅶ", "ⅶ" => "Ⅶ", "ⅷ" => "Ⅷ", "ⅷ" => "Ⅷ", "ṽ" => "Ṽ", "ṽ" => "Ṽ", "ṿ" => "Ṿ", "ṿ" => "Ṿ", "w" => "W", "w" => "W", 
		"ⓦ" => "Ⓦ", "ⓦ" => "Ⓦ", "ｗ" => "Ｗ", "ｗ" => "Ｗ", "ẁ" => "Ẁ", "ẁ" => "Ẁ", "ẃ" => "Ẃ", "ẃ" => "Ẃ", "ŵ" => "Ŵ", "ŵ" => "Ŵ", 
		"ẇ" => "Ẇ", "ẇ" => "Ẇ", "ẅ" => "Ẅ", "ẅ" => "Ẅ", "ẘ" => "W&#x30A;", "ẉ" => "Ẉ", "ẉ" => "Ẉ", "x" => "X", "x" => "X", "ⅹ" => "Ⅹ", 
		"ⅹ" => "Ⅹ", "ⓧ" => "Ⓧ", "ⓧ" => "Ⓧ", "ｘ" => "Ｘ", "ｘ" => "Ｘ", "ⅺ" => "Ⅺ", "ⅺ" => "Ⅺ", "ⅻ" => "Ⅻ", "ⅻ" => "Ⅻ", "ẋ" => "Ẋ", 
		"ẋ" => "Ẋ", "ẍ" => "Ẍ", "ẍ" => "Ẍ", "y" => "Y", "y" => "Y", "ⓨ" => "Ⓨ", "ⓨ" => "Ⓨ", "ｙ" => "Ｙ", "ｙ" => "Ｙ", "ỳ" => "Ỳ", 
		"ỳ" => "Ỳ", "ý" => "Ý", "ý" => "Ý", "ŷ" => "Ŷ", "ŷ" => "Ŷ", "ỹ" => "Ỹ", "ỹ" => "Ỹ", "ȳ" => "Ȳ", "ȳ" => "Ȳ", "ẏ" => "Ẏ", 
		"ẏ" => "Ẏ", "ÿ" => "Ÿ", "ÿ" => "Ÿ", "ỷ" => "Ỷ", "ỷ" => "Ỷ", "ẙ" => "Y&#x30A;", "ỵ" => "Ỵ", "ỵ" => "Ỵ", "z" => "Z", "z" => "Z", 
		"ⓩ" => "Ⓩ", "ⓩ" => "Ⓩ", "ｚ" => "Ｚ", "ｚ" => "Ｚ", "ź" => "Ź", "ź" => "Ź", "ẑ" => "Ẑ", "ẑ" => "Ẑ", "ż" => "Ż", "ż" => "Ż", 
		"ž" => "Ž", "ž" => "Ž", "ẓ" => "Ẓ", "ẓ" => "Ẓ", "ẕ" => "Ẕ", "ẕ" => "Ẕ", "æ" => "Æ", "æ" => "Æ", "ǽ" => "Ǽ", "ǽ" => "Ǽ", 
		"ǣ" => "Ǣ", "ǣ" => "Ǣ", "ð" => "Ð", "ð" => "Ð", "ø" => "Ø", "ø" => "Ø", "ǿ" => "Ǿ", "ǿ" => "Ǿ", "þ" => "Þ", "þ" => "Þ", 
		"đ" => "Đ", "đ" => "Đ", "ħ" => "Ħ", "ħ" => "Ħ", "ı" => "I", "ł" => "Ł", "ł" => "Ł", "ŋ" => "Ŋ", "ŋ" => "Ŋ", "œ" => "Œ", 
		"œ" => "Œ", "ŧ" => "Ŧ", "ŧ" => "Ŧ", "ƀ" => "Ƀ", "ƀ" => "Ƀ", "ƃ" => "Ƃ", "ƃ" => "Ƃ", "ƅ" => "Ƅ", "ƅ" => "Ƅ", "ƈ" => "Ƈ", 
		"ƈ" => "Ƈ", "ƌ" => "Ƌ", "ƌ" => "Ƌ", "ƒ" => "Ƒ", "ƒ" => "Ƒ", "ƕ" => "Ƕ", "ƕ" => "Ƕ", "ƙ" => "Ƙ", "ƙ" => "Ƙ", "ƚ" => "Ƚ", 
		"ƚ" => "Ƚ", "ƞ" => "Ƞ", "ƞ" => "Ƞ", "ƣ" => "Ƣ", "ƣ" => "Ƣ", "ƥ" => "Ƥ", "ƥ" => "Ƥ", "ƨ" => "Ƨ", "ƨ" => "Ƨ", "ƭ" => "Ƭ", 
		"ƭ" => "Ƭ", "ƴ" => "Ƴ", "ƴ" => "Ƴ", "ƶ" => "Ƶ", "ƶ" => "Ƶ", "ƹ" => "Ƹ", "ƹ" => "Ƹ", "ƽ" => "Ƽ", "ƽ" => "Ƽ", "ƿ" => "Ƿ", 
		"ƿ" => "Ƿ", "ǝ" => "Ǝ", "ǝ" => "Ǝ", "ǥ" => "Ǥ", "ǥ" => "Ǥ", "ȝ" => "Ȝ", "ȝ" => "Ȝ", "ȣ" => "Ȣ", "ȣ" => "Ȣ", "ȥ" => "Ȥ", 
		"ȥ" => "Ȥ", "ȼ" => "Ȼ", "ȼ" => "Ȼ", "ȿ" => "Ȿ", "ȿ" => "Ȿ", "ɀ" => "Ɀ", "ɀ" => "Ɀ", "ɂ" => "Ɂ", "ɂ" => "Ɂ", "ɇ" => "Ɇ", 
		"ɇ" => "Ɇ", "ɉ" => "Ɉ", "ɉ" => "Ɉ", "ɋ" => "Ɋ", "ɋ" => "Ɋ", "ɍ" => "Ɍ", "ɍ" => "Ɍ", "ɏ" => "Ɏ", "ɏ" => "Ɏ", "ɐ" => "Ɐ", 
		"ɐ" => "Ɐ", "ɑ" => "Ɑ", "ɑ" => "Ɑ", "ɒ" => "Ɒ", "ɒ" => "Ɒ", "ɓ" => "Ɓ", "ɓ" => "Ɓ", "ɔ" => "Ɔ", "ɔ" => "Ɔ", "ɖ" => "Ɖ", 
		"ɖ" => "Ɖ", "ɗ" => "Ɗ", "ɗ" => "Ɗ", "ə" => "Ə", "ə" => "Ə", "ɛ" => "Ɛ", "ɛ" => "Ɛ", "ɠ" => "Ɠ", "ɠ" => "Ɠ", "ɣ" => "Ɣ", 
		"ɣ" => "Ɣ", "ɨ" => "Ɨ", "ɨ" => "Ɨ", "ɩ" => "Ɩ", "ɩ" => "Ɩ", "ɫ" => "Ɫ", "ɫ" => "Ɫ", "ɯ" => "Ɯ", "ɯ" => "Ɯ", "ɱ" => "Ɱ", 
		"ɱ" => "Ɱ", "ɲ" => "Ɲ", "ɲ" => "Ɲ", "ɵ" => "Ɵ", "ɵ" => "Ɵ", "ɽ" => "Ɽ", "ɽ" => "Ɽ", "ʀ" => "Ʀ", "ʀ" => "Ʀ", "ʃ" => "Ʃ", 
		"ʃ" => "Ʃ", "ʈ" => "Ʈ", "ʈ" => "Ʈ", "ʉ" => "Ʉ", "ʉ" => "Ʉ", "ʊ" => "Ʊ", "ʊ" => "Ʊ", "ʋ" => "Ʋ", "ʋ" => "Ʋ", "ʌ" => "Ʌ", 
		"ʌ" => "Ʌ", "ʒ" => "Ʒ", "ʒ" => "Ʒ", "ǯ" => "Ǯ", "ǯ" => "Ǯ", "ŉ" => "ʼN", "ᵹ" => "Ᵹ", "ᵹ" => "Ᵹ", "ᵽ" => "Ᵽ", "ᵽ" => "Ᵽ", 
		"ỻ" => "Ỻ", "ỻ" => "Ỻ", "ỽ" => "Ỽ", "ỽ" => "Ỽ", "ỿ" => "Ỿ", "ỿ" => "Ỿ", "ⅎ" => "Ⅎ", "ⅎ" => "Ⅎ", "ↄ" => "Ↄ", "ↄ" => "Ↄ", 
		"ⱡ" => "Ⱡ", "ⱡ" => "Ⱡ", "ⱥ" => "Ⱥ", "ⱥ" => "Ⱥ", "ⱦ" => "Ⱦ", "ⱦ" => "Ⱦ", "ⱨ" => "Ⱨ", "ⱨ" => "Ⱨ", "ⱪ" => "Ⱪ", "ⱪ" => "Ⱪ", 
		"ⱬ" => "Ⱬ", "ⱬ" => "Ⱬ", "ⱳ" => "Ⱳ", "ⱳ" => "Ⱳ", "ⱶ" => "Ⱶ", "ⱶ" => "Ⱶ", "ꜣ" => "Ꜣ", "ꜣ" => "Ꜣ", "ꜥ" => "Ꜥ", "ꜥ" => "Ꜥ", 
		"ꜧ" => "Ꜧ", "ꜧ" => "Ꜧ", "ꜩ" => "Ꜩ", "ꜩ" => "Ꜩ", "ꜫ" => "Ꜫ", "ꜫ" => "Ꜫ", "ꜭ" => "Ꜭ", "ꜭ" => "Ꜭ", "ꜯ" => "Ꜯ", "ꜯ" => "Ꜯ", 
		"ꜳ" => "Ꜳ", "ꜳ" => "Ꜳ", "ꜵ" => "Ꜵ", "ꜵ" => "Ꜵ", "ꜷ" => "Ꜷ", "ꜷ" => "Ꜷ", "ꜹ" => "Ꜹ", "ꜹ" => "Ꜹ", "ꜻ" => "Ꜻ", "ꜻ" => "Ꜻ", 
		"ꜽ" => "Ꜽ", "ꜽ" => "Ꜽ", "ꜿ" => "Ꜿ", "ꜿ" => "Ꜿ", "ꝁ" => "Ꝁ", "ꝁ" => "Ꝁ", "ꝃ" => "Ꝃ", "ꝃ" => "Ꝃ", "ꝅ" => "Ꝅ", "ꝅ" => "Ꝅ", 
		"ꝇ" => "Ꝇ", "ꝇ" => "Ꝇ", "ꝉ" => "Ꝉ", "ꝉ" => "Ꝉ", "ꝋ" => "Ꝋ", "ꝋ" => "Ꝋ", "ꝍ" => "Ꝍ", "ꝍ" => "Ꝍ", "ꝏ" => "Ꝏ", "ꝏ" => "Ꝏ", 
		"ꝑ" => "Ꝑ", "ꝑ" => "Ꝑ", "ꝓ" => "Ꝓ", "ꝓ" => "Ꝓ", "ꝕ" => "Ꝕ", "ꝕ" => "Ꝕ", "ꝗ" => "Ꝗ", "ꝗ" => "Ꝗ", "ꝙ" => "Ꝙ", "ꝙ" => "Ꝙ", 
		"ꝛ" => "Ꝛ", "ꝛ" => "Ꝛ", "ꝝ" => "Ꝝ", "ꝝ" => "Ꝝ", "ꝟ" => "Ꝟ", "ꝟ" => "Ꝟ", "ꝡ" => "Ꝡ", "ꝡ" => "Ꝡ", "ꝣ" => "Ꝣ", "ꝣ" => "Ꝣ", 
		"ꝥ" => "Ꝥ", "ꝥ" => "Ꝥ", "ꝧ" => "Ꝧ", "ꝧ" => "Ꝧ", "ꝩ" => "Ꝩ", "ꝩ" => "Ꝩ", "ꝫ" => "Ꝫ", "ꝫ" => "Ꝫ", "ꝭ" => "Ꝭ", "ꝭ" => "Ꝭ", 
		"ꝯ" => "Ꝯ", "ꝯ" => "Ꝯ", "ꝺ" => "Ꝺ", "ꝺ" => "Ꝺ", "ꝼ" => "Ꝼ", "ꝼ" => "Ꝼ", "ꝿ" => "Ꝿ", "ꝿ" => "Ꝿ", "ꞁ" => "Ꞁ", "ꞁ" => "Ꞁ", 
		"ꞃ" => "Ꞃ", "ꞃ" => "Ꞃ", "ꞅ" => "Ꞅ", "ꞅ" => "Ꞅ", "ꞇ" => "Ꞇ", "ꞇ" => "Ꞇ", "ꞌ" => "Ꞌ", "ꞌ" => "Ꞌ", 
		
		// Greek
		"ͱ" => "Ͱ", "ͱ" => "Ͱ", "ͳ" => "Ͳ", "ͳ" => "Ͳ", "ͷ" => "Ͷ", "ͷ" => "Ͷ", "ͻ" => "Ͻ", "ͻ" => "Ͻ", "ͼ" => "Ͼ", "ͼ" => "Ͼ", 
		"ͽ" => "Ͽ", "ͽ" => "Ͽ", "α" => "Α", "α" => "Α", "ὰ" => "Ὰ", "ὰ" => "Ὰ", "ᾲ" => "ᾺΙ", "ά" => "Ά", "ά" => "Ά", "ά" => "Ά", 
		"ά" => "Ά", "ᾴ" => "ΆΙ", "ᾱ" => "Ᾱ", "ᾱ" => "Ᾱ", "ᾰ" => "Ᾰ", "ᾰ" => "Ᾰ", "ἀ" => "Ἀ", "ἀ" => "Ἀ", "ἂ" => "Ἂ", "ἂ" => "Ἂ", 
		"ᾂ" => "ἊΙ", "ᾂ" => "ἊΙ", "ἄ" => "Ἄ", "ἄ" => "Ἄ", "ᾄ" => "ἌΙ", "ᾄ" => "ἌΙ", "ἆ" => "Ἆ", "ἆ" => "Ἆ", "ᾆ" => "ἎΙ", "ᾆ" => "ἎΙ", 
		"ᾀ" => "ἈΙ", "ᾀ" => "ἈΙ", "ἁ" => "Ἁ", "ἁ" => "Ἁ", "ἃ" => "Ἃ", "ἃ" => "Ἃ", "ᾃ" => "ἋΙ", "ᾃ" => "ἋΙ", "ἅ" => "Ἅ", "ἅ" => "Ἅ", 
		"ᾅ" => "ἍΙ", "ᾅ" => "ἍΙ", "ἇ" => "Ἇ", "ἇ" => "Ἇ", "ᾇ" => "ἏΙ", "ᾇ" => "ἏΙ", "ᾁ" => "ἉΙ", "ᾁ" => "ἉΙ", "ᾶ" => "Α͂", "ᾷ" => "Α͂Ι", 
		"ᾳ" => "ΑΙ", "ᾳ" => "ΑΙ", "β" => "Β", "β" => "Β", "ϐ" => "Β", "γ" => "Γ", "γ" => "Γ", "δ" => "Δ", "δ" => "Δ", "ε" => "Ε", 
		"ε" => "Ε", "ϵ" => "Ε", "ὲ" => "Ὲ", "ὲ" => "Ὲ", "έ" => "Έ", "έ" => "Έ", "έ" => "Έ", "έ" => "Έ", "ἐ" => "Ἐ", "ἐ" => "Ἐ", 
		"ἒ" => "Ἒ", "ἒ" => "Ἒ", "ἔ" => "Ἔ", "ἔ" => "Ἔ", "ἑ" => "Ἑ", "ἑ" => "Ἑ", "ἓ" => "Ἓ", "ἓ" => "Ἓ", "ἕ" => "Ἕ", "ἕ" => "Ἕ", 
		"ζ" => "Ζ", "ζ" => "Ζ", "η" => "Η", "η" => "Η", "ὴ" => "Ὴ", "ὴ" => "Ὴ", "ῂ" => "ῊΙ", "ή" => "Ή", "ή" => "Ή", "ή" => "Ή", 
		"ή" => "Ή", "ῄ" => "ΉΙ", "ἠ" => "Ἠ", "ἠ" => "Ἠ", "ἢ" => "Ἢ", "ἢ" => "Ἢ", "ᾒ" => "ἪΙ", "ᾒ" => "ἪΙ", "ἤ" => "Ἤ", "ἤ" => "Ἤ", 
		"ᾔ" => "ἬΙ", "ᾔ" => "ἬΙ", "ἦ" => "Ἦ", "ἦ" => "Ἦ", "ᾖ" => "ἮΙ", "ᾖ" => "ἮΙ", "ᾐ" => "ἨΙ", "ᾐ" => "ἨΙ", "ἡ" => "Ἡ", "ἡ" => "Ἡ", 
		"ἣ" => "Ἣ", "ἣ" => "Ἣ", "ᾓ" => "ἫΙ", "ᾓ" => "ἫΙ", "ἥ" => "Ἥ", "ἥ" => "Ἥ", "ᾕ" => "ἭΙ", "ᾕ" => "ἭΙ", "ἧ" => "Ἧ", "ἧ" => "Ἧ", 
		"ᾗ" => "ἯΙ", "ᾗ" => "ἯΙ", "ᾑ" => "ἩΙ", "ᾑ" => "ἩΙ", "ῆ" => "Η͂", "ῇ" => "Η͂Ι", "ῃ" => "ΗΙ", "ῃ" => "ΗΙ", "θ" => "Θ", "θ" => "Θ", 
		"ϑ" => "Θ", "θ" => "ϴ", "ι" => "Ι", "ι" => "Ι", "ι" => "Ι", "ὶ" => "Ὶ", "ὶ" => "Ὶ", "ί" => "Ί", "ί" => "Ί", "ί" => "Ί", 
		"ί" => "Ί", "ῑ" => "Ῑ", "ῑ" => "Ῑ", "ῐ" => "Ῐ", "ῐ" => "Ῐ", "ϊ" => "Ϊ", "ϊ" => "Ϊ", "ῒ" => "Ϊ̀", "ΐ" => "Ϊ́", "ΐ" => "Ϊ́", 
		"ῗ" => "Ϊ͂", "ἰ" => "Ἰ", "ἰ" => "Ἰ", "ἲ" => "Ἲ", "ἲ" => "Ἲ", "ἴ" => "Ἴ", "ἴ" => "Ἴ", "ἶ" => "Ἶ", "ἶ" => "Ἶ", "ἱ" => "Ἱ", 
		"ἱ" => "Ἱ", "ἳ" => "Ἳ", "ἳ" => "Ἳ", "ἵ" => "Ἵ", "ἵ" => "Ἵ", "ἷ" => "Ἷ", "ἷ" => "Ἷ", "ῖ" => "Ι͂", "κ" => "Κ", "κ" => "Κ", 
		"ϰ" => "Κ", "λ" => "Λ", "λ" => "Λ", "µ" => "Μ", "μ" => "Μ", "μ" => "Μ", "ν" => "Ν", "ν" => "Ν", "ξ" => "Ξ", "ξ" => "Ξ", 
		"ο" => "Ο", "ο" => "Ο", "ὸ" => "Ὸ", "ὸ" => "Ὸ", "ό" => "Ό", "ό" => "Ό", "ό" => "Ό", "ό" => "Ό", "ὀ" => "Ὀ", "ὀ" => "Ὀ", 
		"ὂ" => "Ὂ", "ὂ" => "Ὂ", "ὄ" => "Ὄ", "ὄ" => "Ὄ", "ὁ" => "Ὁ", "ὁ" => "Ὁ", "ὃ" => "Ὃ", "ὃ" => "Ὃ", "ὅ" => "Ὅ", "ὅ" => "Ὅ", 
		"π" => "Π", "π" => "Π", "ϖ" => "Π", "ρ" => "Ρ", "ρ" => "Ρ", "ϱ" => "Ρ", "ῤ" => "Ρ̓", "ῥ" => "Ῥ", "ῥ" => "Ῥ", "σ" => "Σ", 
		"ς" => "Σ", "σ" => "Σ", "ϲ" => "Ϲ", "ϲ" => "Ϲ", "τ" => "Τ", "τ" => "Τ", "υ" => "Υ", "υ" => "Υ", "ὺ" => "Ὺ", "ὺ" => "Ὺ", 
		"ύ" => "Ύ", "ύ" => "Ύ", "ύ" => "Ύ", "ύ" => "Ύ", "ῡ" => "Ῡ", "ῡ" => "Ῡ", "ῠ" => "Ῠ", "ῠ" => "Ῠ", "ϋ" => "Ϋ", "ϋ" => "Ϋ", 
		"ῢ" => "Ϋ̀", "ΰ" => "Ϋ́", "ΰ" => "Ϋ́", "ῧ" => "Ϋ͂", "ὐ" => "Υ̓", "ὒ" => "Υ̓̀", "ὔ" => "Υ̓́", "ὖ" => "Υ̓͂", "ὑ" => "Ὑ", "ὑ" => "Ὑ", 
		"ὓ" => "Ὓ", "ὓ" => "Ὓ", "ὕ" => "Ὕ", "ὕ" => "Ὕ", "ὗ" => "Ὗ", "ὗ" => "Ὗ", "ῦ" => "Υ͂", "φ" => "Φ", "φ" => "Φ", "ϕ" => "Φ", 
		"χ" => "Χ", "χ" => "Χ", "ψ" => "Ψ", "ψ" => "Ψ", "ω" => "Ω", "ω" => "Ω", "ω" => "Ω", "ὼ" => "Ὼ", "ὼ" => "Ὼ", "ῲ" => "ῺΙ", 
		"ώ" => "Ώ", "ώ" => "Ώ", "ώ" => "Ώ", "ώ" => "Ώ", "ῴ" => "ΏΙ", "ὠ" => "Ὠ", "ὠ" => "Ὠ", "ὢ" => "Ὢ", "ὢ" => "Ὢ", "ᾢ" => "ὪΙ", 
		"ᾢ" => "ὪΙ", "ὤ" => "Ὤ", "ὤ" => "Ὤ", "ᾤ" => "ὬΙ", "ᾤ" => "ὬΙ", "ὦ" => "Ὦ", "ὦ" => "Ὦ", "ᾦ" => "ὮΙ", "ᾦ" => "ὮΙ", "ᾠ" => "ὨΙ", 
		"ᾠ" => "ὨΙ", "ὡ" => "Ὡ", "ὡ" => "Ὡ", "ὣ" => "Ὣ", "ὣ" => "Ὣ", "ᾣ" => "ὫΙ", "ᾣ" => "ὫΙ", "ὥ" => "Ὥ", "ὥ" => "Ὥ", "ᾥ" => "ὭΙ", 
		"ᾥ" => "ὭΙ", "ὧ" => "Ὧ", "ὧ" => "Ὧ", "ᾧ" => "ὯΙ", "ᾧ" => "ὯΙ", "ᾡ" => "ὩΙ", "ᾡ" => "ὩΙ", "ῶ" => "Ω͂", "ῷ" => "Ω͂Ι", "ῳ" => "ΩΙ", 
		"ῳ" => "ΩΙ", "ϗ" => "Ϗ", "ϗ" => "Ϗ", "ϙ" => "Ϙ", "ϙ" => "Ϙ", "ϛ" => "Ϛ", "ϛ" => "Ϛ", "ϝ" => "Ϝ", "ϝ" => "Ϝ", "ϟ" => "Ϟ", 
		"ϟ" => "Ϟ", "ϡ" => "Ϡ", "ϡ" => "Ϡ", "ϸ" => "Ϸ", "ϸ" => "Ϸ", "ϻ" => "Ϻ", "ϻ" => "Ϻ", 
		
		// Cyrillic
		"а" => "А", "а" => "А", "ӑ" => "Ӑ", "ӑ" => "Ӑ", "ӓ" => "Ӓ", "ӓ" => "Ӓ", "б" => "Б", "б" => "Б", "в" => "В", "в" => "В", 
		"г" => "Г", "г" => "Г", "ѓ" => "Ѓ", "ѓ" => "Ѓ", "д" => "Д", "д" => "Д", "е" => "Е", "е" => "Е", "ѐ" => "Ѐ", "ѐ" => "Ѐ", 
		"ӗ" => "Ӗ", "ӗ" => "Ӗ", "ё" => "Ё", "ё" => "Ё", "ж" => "Ж", "ж" => "Ж", "ӂ" => "Ӂ", "ӂ" => "Ӂ", "ӝ" => "Ӝ", "ӝ" => "Ӝ", 
		"з" => "З", "з" => "З", "ӟ" => "Ӟ", "ӟ" => "Ӟ", "и" => "И", "и" => "И", "ѝ" => "Ѝ", "ѝ" => "Ѝ", "ӣ" => "Ӣ", "ӣ" => "Ӣ", 
		"й" => "Й", "й" => "Й", "ӥ" => "Ӥ", "ӥ" => "Ӥ", "к" => "К", "к" => "К", "ќ" => "Ќ", "ќ" => "Ќ", "л" => "Л", "л" => "Л", 
		"м" => "М", "м" => "М", "н" => "Н", "н" => "Н", "о" => "О", "о" => "О", "ӧ" => "Ӧ", "ӧ" => "Ӧ", "п" => "П", "п" => "П", 
		"р" => "Р", "р" => "Р", "с" => "С", "с" => "С", "т" => "Т", "т" => "Т", "у" => "У", "у" => "У", "ӯ" => "Ӯ", "ӯ" => "Ӯ", 
		"ў" => "Ў", "ў" => "Ў", "ӱ" => "Ӱ", "ӱ" => "Ӱ", "ӳ" => "Ӳ", "ӳ" => "Ӳ", "ф" => "Ф", "ф" => "Ф", "х" => "Х", "х" => "Х", 
		"ц" => "Ц", "ц" => "Ц", "ч" => "Ч", "ч" => "Ч", "ӵ" => "Ӵ", "ӵ" => "Ӵ", "ш" => "Ш", "ш" => "Ш", "щ" => "Щ", "щ" => "Щ", 
		"ъ" => "Ъ", "ъ" => "Ъ", "ы" => "Ы", "ы" => "Ы", "ӹ" => "Ӹ", "ӹ" => "Ӹ", "ь" => "Ь", "ь" => "Ь", "э" => "Э", "э" => "Э", 
		"ӭ" => "Ӭ", "ӭ" => "Ӭ", "ю" => "Ю", "ю" => "Ю", "я" => "Я", "я" => "Я", "ђ" => "Ђ", "ђ" => "Ђ", "є" => "Є", "є" => "Є", 
		"ѕ" => "Ѕ", "ѕ" => "Ѕ", "і" => "І", "і" => "І", "ї" => "Ї", "ї" => "Ї", "ј" => "Ј", "ј" => "Ј", "љ" => "Љ", "љ" => "Љ", 
		"њ" => "Њ", "њ" => "Њ", "ћ" => "Ћ", "ћ" => "Ћ", "џ" => "Џ", "џ" => "Џ", "ѡ" => "Ѡ", "ѡ" => "Ѡ", "ѣ" => "Ѣ", "ѣ" => "Ѣ", 
		"ѥ" => "Ѥ", "ѥ" => "Ѥ", "ѧ" => "Ѧ", "ѧ" => "Ѧ", "ѩ" => "Ѩ", "ѩ" => "Ѩ", "ѫ" => "Ѫ", "ѫ" => "Ѫ", "ѭ" => "Ѭ", "ѭ" => "Ѭ", 
		"ѯ" => "Ѯ", "ѯ" => "Ѯ", "ѱ" => "Ѱ", "ѱ" => "Ѱ", "ѳ" => "Ѳ", "ѳ" => "Ѳ", "ѵ" => "Ѵ", "ѵ" => "Ѵ", "ѷ" => "Ѷ", "ѷ" => "Ѷ", 
		"ѹ" => "Ѹ", "ѹ" => "Ѹ", "ѻ" => "Ѻ", "ѻ" => "Ѻ", "ѽ" => "Ѽ", "ѽ" => "Ѽ", "ѿ" => "Ѿ", "ѿ" => "Ѿ", "ҁ" => "Ҁ", "ҁ" => "Ҁ", 
		"ҋ" => "Ҋ", "ҋ" => "Ҋ", "ҍ" => "Ҍ", "ҍ" => "Ҍ", "ҏ" => "Ҏ", "ҏ" => "Ҏ", "ґ" => "Ґ", "ґ" => "Ґ", "ғ" => "Ғ", "ғ" => "Ғ", 
		"ҕ" => "Ҕ", "ҕ" => "Ҕ", "җ" => "Җ", "җ" => "Җ", "ҙ" => "Ҙ", "ҙ" => "Ҙ", "қ" => "Қ", "қ" => "Қ", "ҝ" => "Ҝ", "ҝ" => "Ҝ", 
		"ҟ" => "Ҟ", "ҟ" => "Ҟ", "ҡ" => "Ҡ", "ҡ" => "Ҡ", "ң" => "Ң", "ң" => "Ң", "ҥ" => "Ҥ", "ҥ" => "Ҥ", "ҧ" => "Ҧ", "ҧ" => "Ҧ", 
		"ҩ" => "Ҩ", "ҩ" => "Ҩ", "ҫ" => "Ҫ", "ҫ" => "Ҫ", "ҭ" => "Ҭ", "ҭ" => "Ҭ", "ү" => "Ү", "ү" => "Ү", "ұ" => "Ұ", "ұ" => "Ұ", 
		"ҳ" => "Ҳ", "ҳ" => "Ҳ", "ҵ" => "Ҵ", "ҵ" => "Ҵ", "ҷ" => "Ҷ", "ҷ" => "Ҷ", "ҹ" => "Ҹ", "ҹ" => "Ҹ", "һ" => "Һ", "һ" => "Һ", 
		"ҽ" => "Ҽ", "ҽ" => "Ҽ", "ҿ" => "Ҿ", "ҿ" => "Ҿ", "ӄ" => "Ӄ", "ӄ" => "Ӄ", "ӆ" => "Ӆ", "ӆ" => "Ӆ", "ӈ" => "Ӈ", "ӈ" => "Ӈ", 
		"ӊ" => "Ӊ", "ӊ" => "Ӊ", "ӌ" => "Ӌ", "ӌ" => "Ӌ", "ӎ" => "Ӎ", "ӎ" => "Ӎ", "ӏ" => "Ӏ", "ӏ" => "Ӏ", "ӕ" => "Ӕ", "ӕ" => "Ӕ", 
		"ә" => "Ә", "ә" => "Ә", "ӛ" => "Ӛ", "ӛ" => "Ӛ", "ӡ" => "Ӡ", "ӡ" => "Ӡ", "ө" => "Ө", "ө" => "Ө", "ӫ" => "Ӫ", "ӫ" => "Ӫ", 
		"ӷ" => "Ӷ", "ӷ" => "Ӷ", "ӻ" => "Ӻ", "ӻ" => "Ӻ", "ӽ" => "Ӽ", "ӽ" => "Ӽ", "ӿ" => "Ӿ", "ӿ" => "Ӿ", "ԁ" => "Ԁ", "ԁ" => "Ԁ", 
		"ԃ" => "Ԃ", "ԃ" => "Ԃ", "ԅ" => "Ԅ", "ԅ" => "Ԅ", "ԇ" => "Ԇ", "ԇ" => "Ԇ", "ԉ" => "Ԉ", "ԉ" => "Ԉ", "ԋ" => "Ԋ", "ԋ" => "Ԋ", 
		"ԍ" => "Ԍ", "ԍ" => "Ԍ", "ԏ" => "Ԏ", "ԏ" => "Ԏ", "ԑ" => "Ԑ", "ԑ" => "Ԑ", "ԓ" => "Ԓ", "ԓ" => "Ԓ", "ԕ" => "Ԕ", "ԕ" => "Ԕ", 
		"ԗ" => "Ԗ", "ԗ" => "Ԗ", "ԙ" => "Ԙ", "ԙ" => "Ԙ", "ԛ" => "Ԛ", "ԛ" => "Ԛ", "ԝ" => "Ԝ", "ԝ" => "Ԝ", "ԟ" => "Ԟ", "ԟ" => "Ԟ", 
		"ԡ" => "Ԡ", "ԡ" => "Ԡ", "ԣ" => "Ԣ", "ԣ" => "Ԣ", "ԥ" => "Ԥ", "ԥ" => "Ԥ", "ꙁ" => "Ꙁ", "ꙁ" => "Ꙁ", "ꙃ" => "Ꙃ", "ꙃ" => "Ꙃ", 
		"ꙅ" => "Ꙅ", "ꙅ" => "Ꙅ", "ꙇ" => "Ꙇ", "ꙇ" => "Ꙇ", "ꙉ" => "Ꙉ", "ꙉ" => "Ꙉ", "ꙋ" => "Ꙋ", "ꙋ" => "Ꙋ", "ꙍ" => "Ꙍ", "ꙍ" => "Ꙍ", 
		"ꙏ" => "Ꙏ", "ꙏ" => "Ꙏ", "ꙑ" => "Ꙑ", "ꙑ" => "Ꙑ", "ꙓ" => "Ꙓ", "ꙓ" => "Ꙓ", "ꙕ" => "Ꙕ", "ꙕ" => "Ꙕ", "ꙗ" => "Ꙗ", "ꙗ" => "Ꙗ", 
		"ꙙ" => "Ꙙ", "ꙙ" => "Ꙙ", "ꙛ" => "Ꙛ", "ꙛ" => "Ꙛ", "ꙝ" => "Ꙝ", "ꙝ" => "Ꙝ", "ꙟ" => "Ꙟ", "ꙟ" => "Ꙟ", "ꙣ" => "Ꙣ", "ꙣ" => "Ꙣ", 
		"ꙥ" => "Ꙥ", "ꙥ" => "Ꙥ", "ꙧ" => "Ꙧ", "ꙧ" => "Ꙧ", "ꙩ" => "Ꙩ", "ꙩ" => "Ꙩ", "ꙫ" => "Ꙫ", "ꙫ" => "Ꙫ", "ꙭ" => "Ꙭ", "ꙭ" => "Ꙭ", 
		"ꚁ" => "Ꚁ", "ꚁ" => "Ꚁ", "ꚃ" => "Ꚃ", "ꚃ" => "Ꚃ", "ꚅ" => "Ꚅ", "ꚅ" => "Ꚅ", "ꚇ" => "Ꚇ", "ꚇ" => "Ꚇ", "ꚉ" => "Ꚉ", "ꚉ" => "Ꚉ", 
		"ꚋ" => "Ꚋ", "ꚋ" => "Ꚋ", "ꚍ" => "Ꚍ", "ꚍ" => "Ꚍ", "ꚏ" => "Ꚏ", "ꚏ" => "Ꚏ", "ꚑ" => "Ꚑ", "ꚑ" => "Ꚑ", "ꚓ" => "Ꚓ", "ꚓ" => "Ꚓ", 
		"ꚕ" => "Ꚕ", "ꚕ" => "Ꚕ", "ꚗ" => "Ꚗ", "ꚗ" => "Ꚗ", 
		
		// Armenian
		"ա" => "Ա", "ա" => "Ա", "բ" => "Բ", "բ" => "Բ", "գ" => "Գ", "գ" => "Գ", "դ" => "Դ", "դ" => "Դ", "ե" => "Ե", "ե" => "Ե", 
		"և" => "ԵՒ", "զ" => "Զ", "զ" => "Զ", "է" => "Է", "է" => "Է", "ը" => "Ը", "ը" => "Ը", "թ" => "Թ", "թ" => "Թ", "ժ" => "Ժ", 
		"ժ" => "Ժ", "ի" => "Ի", "ի" => "Ի", "լ" => "Լ", "լ" => "Լ", "խ" => "Խ", "խ" => "Խ", "ծ" => "Ծ", "ծ" => "Ծ", "կ" => "Կ", 
		"կ" => "Կ", "հ" => "Հ", "հ" => "Հ", "ձ" => "Ձ", "ձ" => "Ձ", "ղ" => "Ղ", "ղ" => "Ղ", "ճ" => "Ճ", "ճ" => "Ճ", "մ" => "Մ", 
		"մ" => "Մ", "ﬔ" => "ՄԵ", "ﬕ" => "ՄԻ", "ﬗ" => "ՄԽ", "ﬓ" => "ՄՆ", "յ" => "Յ", "յ" => "Յ", "ն" => "Ն", "ն" => "Ն", "շ" => "Շ", 
		"շ" => "Շ", "ո" => "Ո", "ո" => "Ո", "չ" => "Չ", "չ" => "Չ", "պ" => "Պ", "պ" => "Պ", "ջ" => "Ջ", "ջ" => "Ջ", "ռ" => "Ռ", 
		"ռ" => "Ռ", "ս" => "Ս", "ս" => "Ս", "վ" => "Վ", "վ" => "Վ", "ﬖ" => "ՎՆ", "տ" => "Տ", "տ" => "Տ", "ր" => "Ր", "ր" => "Ր", 
		"ց" => "Ց", "ց" => "Ց", "ւ" => "Ւ", "ւ" => "Ւ", "փ" => "Փ", "փ" => "Փ", "ք" => "Ք", "ք" => "Ք", "օ" => "Օ", "օ" => "Օ", 
		"ֆ" => "Ֆ", "ֆ" => "Ֆ", 
		
		// Georgian
		"ⴀ" => "Ⴀ", "ⴀ" => "Ⴀ", "ⴁ" => "Ⴁ", "ⴁ" => "Ⴁ", "ⴂ" => "Ⴂ", "ⴂ" => "Ⴂ", "ⴃ" => "Ⴃ", "ⴃ" => "Ⴃ", "ⴄ" => "Ⴄ", "ⴄ" => "Ⴄ", 
		"ⴅ" => "Ⴅ", "ⴅ" => "Ⴅ", "ⴆ" => "Ⴆ", "ⴆ" => "Ⴆ", "ⴇ" => "Ⴇ", "ⴇ" => "Ⴇ", "ⴈ" => "Ⴈ", "ⴈ" => "Ⴈ", "ⴉ" => "Ⴉ", "ⴉ" => "Ⴉ", 
		"ⴊ" => "Ⴊ", "ⴊ" => "Ⴊ", "ⴋ" => "Ⴋ", "ⴋ" => "Ⴋ", "ⴌ" => "Ⴌ", "ⴌ" => "Ⴌ", "ⴍ" => "Ⴍ", "ⴍ" => "Ⴍ", "ⴎ" => "Ⴎ", "ⴎ" => "Ⴎ", 
		"ⴏ" => "Ⴏ", "ⴏ" => "Ⴏ", "ⴐ" => "Ⴐ", "ⴐ" => "Ⴐ", "ⴑ" => "Ⴑ", "ⴑ" => "Ⴑ", "ⴒ" => "Ⴒ", "ⴒ" => "Ⴒ", "ⴓ" => "Ⴓ", "ⴓ" => "Ⴓ", 
		"ⴔ" => "Ⴔ", "ⴔ" => "Ⴔ", "ⴕ" => "Ⴕ", "ⴕ" => "Ⴕ", "ⴖ" => "Ⴖ", "ⴖ" => "Ⴖ", "ⴗ" => "Ⴗ", "ⴗ" => "Ⴗ", "ⴘ" => "Ⴘ", "ⴘ" => "Ⴘ", 
		"ⴙ" => "Ⴙ", "ⴙ" => "Ⴙ", "ⴚ" => "Ⴚ", "ⴚ" => "Ⴚ", "ⴛ" => "Ⴛ", "ⴛ" => "Ⴛ", "ⴜ" => "Ⴜ", "ⴜ" => "Ⴜ", "ⴝ" => "Ⴝ", "ⴝ" => "Ⴝ", 
		"ⴞ" => "Ⴞ", "ⴞ" => "Ⴞ", "ⴟ" => "Ⴟ", "ⴟ" => "Ⴟ", "ⴠ" => "Ⴠ", "ⴠ" => "Ⴠ", "ⴡ" => "Ⴡ", "ⴡ" => "Ⴡ", "ⴢ" => "Ⴢ", "ⴢ" => "Ⴢ", 
		"ⴣ" => "Ⴣ", "ⴣ" => "Ⴣ", "ⴤ" => "Ⴤ", "ⴤ" => "Ⴤ", "ⴥ" => "Ⴥ", "ⴥ" => "Ⴥ", 
		
		// Deseret
		"𐐨" => "𐐀", "𐐨" => "𐐀", "𐐩" => "𐐁", "𐐩" => "𐐁", "𐐪" => "𐐂", "𐐪" => "𐐂", "𐐫" => "𐐃", "𐐫" => "𐐃", "𐐬" => "𐐄", "𐐬" => "𐐄", 
		"𐐭" => "𐐅", "𐐭" => "𐐅", "𐐮" => "𐐆", "𐐮" => "𐐆", "𐐯" => "𐐇", "𐐯" => "𐐇", "𐐰" => "𐐈", "𐐰" => "𐐈", "𐐱" => "𐐉", "𐐱" => "𐐉", 
		"𐐲" => "𐐊", "𐐲" => "𐐊", "𐐳" => "𐐋", "𐐳" => "𐐋", "𐐴" => "𐐌", "𐐴" => "𐐌", "𐐵" => "𐐍", "𐐵" => "𐐍", "𐐶" => "𐐎", "𐐶" => "𐐎", 
		"𐐷" => "𐐏", "𐐷" => "𐐏", "𐐸" => "𐐐", "𐐸" => "𐐐", "𐐹" => "𐐑", "𐐹" => "𐐑", "𐐺" => "𐐒", "𐐺" => "𐐒", "𐐻" => "𐐓", "𐐻" => "𐐓", 
		"𐐼" => "𐐔", "𐐼" => "𐐔", "𐐽" => "𐐕", "𐐽" => "𐐕", "𐐾" => "𐐖", "𐐾" => "𐐖", "𐐿" => "𐐗", "𐐿" => "𐐗", "𐑀" => "𐐘", "𐑀" => "𐐘", 
		"𐑁" => "𐐙", "𐑁" => "𐐙", "𐑂" => "𐐚", "𐑂" => "𐐚", "𐑃" => "𐐛", "𐑃" => "𐐛", "𐑄" => "𐐜", "𐑄" => "𐐜", "𐑅" => "𐐝", "𐑅" => "𐐝", 
		"𐑆" => "𐐞", "𐑆" => "𐐞", "𐑇" => "𐐟", "𐑇" => "𐐟", "𐑈" => "𐐠", "𐑈" => "𐐠", "𐑉" => "𐐡", "𐑉" => "𐐡", "𐑊" => "𐐢", "𐑊" => "𐐢", 
		"𐑋" => "𐐣", "𐑋" => "𐐣", "𐑌" => "𐐤", "𐑌" => "𐐤", "𐑍" => "𐐥", "𐑍" => "𐐥", "𐑎" => "𐐦", "𐑎" => "𐐦", "𐑏" => "𐐧", "𐑏" => "𐐧", 
		
		
		// Coptic
		"ϣ" => "Ϣ", "ϣ" => "Ϣ", "ϥ" => "Ϥ", "ϥ" => "Ϥ", "ϧ" => "Ϧ", "ϧ" => "Ϧ", "ϩ" => "Ϩ", "ϩ" => "Ϩ", "ϫ" => "Ϫ", "ϫ" => "Ϫ", 
		"ϭ" => "Ϭ", "ϭ" => "Ϭ", "ϯ" => "Ϯ", "ϯ" => "Ϯ", "ⲁ" => "Ⲁ", "ⲁ" => "Ⲁ", "ⲃ" => "Ⲃ", "ⲃ" => "Ⲃ", "ⲅ" => "Ⲅ", "ⲅ" => "Ⲅ", 
		"ⲇ" => "Ⲇ", "ⲇ" => "Ⲇ", "ⲉ" => "Ⲉ", "ⲉ" => "Ⲉ", "ⲋ" => "Ⲋ", "ⲋ" => "Ⲋ", "ⲍ" => "Ⲍ", "ⲍ" => "Ⲍ", "ⲏ" => "Ⲏ", "ⲏ" => "Ⲏ", 
		"ⲑ" => "Ⲑ", "ⲑ" => "Ⲑ", "ⲓ" => "Ⲓ", "ⲓ" => "Ⲓ", "ⲕ" => "Ⲕ", "ⲕ" => "Ⲕ", "ⲗ" => "Ⲗ", "ⲗ" => "Ⲗ", "ⲙ" => "Ⲙ", "ⲙ" => "Ⲙ", 
		"ⲛ" => "Ⲛ", "ⲛ" => "Ⲛ", "ⲝ" => "Ⲝ", "ⲝ" => "Ⲝ", "ⲟ" => "Ⲟ", "ⲟ" => "Ⲟ", "ⲡ" => "Ⲡ", "ⲡ" => "Ⲡ", "ⲣ" => "Ⲣ", "ⲣ" => "Ⲣ", 
		"ⲥ" => "Ⲥ", "ⲥ" => "Ⲥ", "ⲧ" => "Ⲧ", "ⲧ" => "Ⲧ", "ⲩ" => "Ⲩ", "ⲩ" => "Ⲩ", "ⲫ" => "Ⲫ", "ⲫ" => "Ⲫ", "ⲭ" => "Ⲭ", "ⲭ" => "Ⲭ", 
		"ⲯ" => "Ⲯ", "ⲯ" => "Ⲯ", "ⲱ" => "Ⲱ", "ⲱ" => "Ⲱ", "ⲳ" => "Ⲳ", "ⲳ" => "Ⲳ", "ⲵ" => "Ⲵ", "ⲵ" => "Ⲵ", "ⲷ" => "Ⲷ", "ⲷ" => "Ⲷ", 
		"ⲹ" => "Ⲹ", "ⲹ" => "Ⲹ", "ⲻ" => "Ⲻ", "ⲻ" => "Ⲻ", "ⲽ" => "Ⲽ", "ⲽ" => "Ⲽ", "ⲿ" => "Ⲿ", "ⲿ" => "Ⲿ", "ⳁ" => "Ⳁ", "ⳁ" => "Ⳁ", 
		"ⳃ" => "Ⳃ", "ⳃ" => "Ⳃ", "ⳅ" => "Ⳅ", "ⳅ" => "Ⳅ", "ⳇ" => "Ⳇ", "ⳇ" => "Ⳇ", "ⳉ" => "Ⳉ", "ⳉ" => "Ⳉ", "ⳋ" => "Ⳋ", "ⳋ" => "Ⳋ", 
		"ⳍ" => "Ⳍ", "ⳍ" => "Ⳍ", "ⳏ" => "Ⳏ", "ⳏ" => "Ⳏ", "ⳑ" => "Ⳑ", "ⳑ" => "Ⳑ", "ⳓ" => "Ⳓ", "ⳓ" => "Ⳓ", "ⳕ" => "Ⳕ", "ⳕ" => "Ⳕ", 
		"ⳗ" => "Ⳗ", "ⳗ" => "Ⳗ", "ⳙ" => "Ⳙ", "ⳙ" => "Ⳙ", "ⳛ" => "Ⳛ", "ⳛ" => "Ⳛ", "ⳝ" => "Ⳝ", "ⳝ" => "Ⳝ", "ⳟ" => "Ⳟ", "ⳟ" => "Ⳟ", 
		"ⳡ" => "Ⳡ", "ⳡ" => "Ⳡ", "ⳣ" => "Ⳣ", "ⳣ" => "Ⳣ", "ⳬ" => "Ⳬ", "ⳬ" => "Ⳬ", "ⳮ" => "Ⳮ", "ⳮ" => "Ⳮ", 
		
		// Glagolitic
		"ⰰ" => "Ⰰ", "ⰰ" => "Ⰰ", "ⰱ" => "Ⰱ", "ⰱ" => "Ⰱ", "ⰲ" => "Ⰲ", "ⰲ" => "Ⰲ", "ⰳ" => "Ⰳ", "ⰳ" => "Ⰳ", "ⰴ" => "Ⰴ", "ⰴ" => "Ⰴ", 
		"ⰵ" => "Ⰵ", "ⰵ" => "Ⰵ", "ⰶ" => "Ⰶ", "ⰶ" => "Ⰶ", "ⰷ" => "Ⰷ", "ⰷ" => "Ⰷ", "ⰸ" => "Ⰸ", "ⰸ" => "Ⰸ", "ⰹ" => "Ⰹ", "ⰹ" => "Ⰹ", 
		"ⰺ" => "Ⰺ", "ⰺ" => "Ⰺ", "ⰻ" => "Ⰻ", "ⰻ" => "Ⰻ", "ⰼ" => "Ⰼ", "ⰼ" => "Ⰼ", "ⰽ" => "Ⰽ", "ⰽ" => "Ⰽ", "ⰾ" => "Ⰾ", "ⰾ" => "Ⰾ", 
		"ⰿ" => "Ⰿ", "ⰿ" => "Ⰿ", "ⱀ" => "Ⱀ", "ⱀ" => "Ⱀ", "ⱁ" => "Ⱁ", "ⱁ" => "Ⱁ", "ⱂ" => "Ⱂ", "ⱂ" => "Ⱂ", "ⱃ" => "Ⱃ", "ⱃ" => "Ⱃ", 
		"ⱄ" => "Ⱄ", "ⱄ" => "Ⱄ", "ⱅ" => "Ⱅ", "ⱅ" => "Ⱅ", "ⱆ" => "Ⱆ", "ⱆ" => "Ⱆ", "ⱇ" => "Ⱇ", "ⱇ" => "Ⱇ", "ⱈ" => "Ⱈ", "ⱈ" => "Ⱈ", 
		"ⱉ" => "Ⱉ", "ⱉ" => "Ⱉ", "ⱊ" => "Ⱊ", "ⱊ" => "Ⱊ", "ⱋ" => "Ⱋ", "ⱋ" => "Ⱋ", "ⱌ" => "Ⱌ", "ⱌ" => "Ⱌ", "ⱍ" => "Ⱍ", "ⱍ" => "Ⱍ", 
		"ⱎ" => "Ⱎ", "ⱎ" => "Ⱎ", "ⱏ" => "Ⱏ", "ⱏ" => "Ⱏ", "ⱐ" => "Ⱐ", "ⱐ" => "Ⱐ", "ⱑ" => "Ⱑ", "ⱑ" => "Ⱑ", "ⱒ" => "Ⱒ", "ⱒ" => "Ⱒ", 
		"ⱓ" => "Ⱓ", "ⱓ" => "Ⱓ", "ⱔ" => "Ⱔ", "ⱔ" => "Ⱔ", "ⱕ" => "Ⱕ", "ⱕ" => "Ⱕ", "ⱖ" => "Ⱖ", "ⱖ" => "Ⱖ", "ⱗ" => "Ⱗ", "ⱗ" => "Ⱗ", 
		"ⱘ" => "Ⱘ", "ⱘ" => "Ⱘ", "ⱙ" => "Ⱙ", "ⱙ" => "Ⱙ", "ⱚ" => "Ⱚ", "ⱚ" => "Ⱚ", "ⱛ" => "Ⱛ", "ⱛ" => "Ⱛ", "ⱜ" => "Ⱜ", "ⱜ" => "Ⱜ", 
		"ⱝ" => "Ⱝ", "ⱝ" => "Ⱝ", "ⱞ" => "Ⱞ", "ⱞ" => "Ⱞ", );
		
	}
?>