<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scBonusPointsTransactionsTable extends scTable {
		
		/**
		 * @var miTemplateParserSectionInfo[]
		 */
		protected $_isPendingSectionArray = array();
		
		/**
		 * @return miTemplateParserSectionInfo
		 */
		public function getSection()
		{
			$section = parent::getSection();
			$section->addSubsectionsArray('isPending', $this->_isPendingSectionArray);
			return $section;
		}
		
		protected function addUiElements(&$rows)
		{
			parent::addUiElements($rows);
			
			$actionTypes = scBonusPoints::getAllActionTypes();
			$actionStatuses = scBonusPoints::getAllActionStatuses();
			
			$isPending1 = new miTemplateParserSectionInfo('isPending', 1);
			$isPending0 = new miTemplateParserSectionInfo('isPending', 0);
			
			$transactionStatusClasses = array(
				scBonusPoints::TRANSACTION_STATUS_PENDING => 'pending',
				scBonusPoints::TRANSACTION_STATUS_APPROVED => 'approved',
				scBonusPoints::TRANSACTION_STATUS_VOID => 'void',
			);
			
			foreach ($rows as $key => &$row) {
				$row['FMT_BonusPointsTransactionTime'] = date(scDateTime::DATE_TIME_FORMAT, $row['BonusPointsTransactionTime']);
				$row['FMT_BonusPointsTransactionType'] = $actionTypes[$row['BonusPointsTransactionType']];
				$row['FMT_BonusPointsTransactionStatus'] = $actionStatuses[$row['BonusPointsTransactionStatus']];
				
				$row['TRANSACTION_STATUS_CLASS'] = $transactionStatusClasses[$row['BonusPointsTransactionStatus']];
				
				if ($row['BonusPointsTransactionStatus'] == scBonusPoints::TRANSACTION_STATUS_PENDING) {
					$this->_isPendingSectionArray[$key] = $isPending1;
				} else {
					$this->_isPendingSectionArray[$key] = $isPending0;
				}
			}
			
		}
	}
?>