<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * Discounts List
	 */
	class scDiscountsTable extends scTable {
		
		/**
		 * @access protected
		 */
		protected $_dateFromFieldName;
		
		/**
		 * @access protected
		 */
		protected $_dateToFieldName;
		
		/**
		 * @access protected
		 */
		protected $_typeFieldName;
		
		/**
		 * Set date from field name
		 *
		 * @access public
		 * @param string $dateFromFieldName date from field name
		 */
		public function setDateFromFieldName($dateFromFieldName)
		{
			$this->_dateFromFieldName = $dateFromFieldName;
		}
	
		/**
		 * Set date to field name
		 *
		 * @access public
		 * @param string $dateToFieldName date to field name
		 */
		public function setDateToFieldName($dateToFieldName)
		{
			$this->_dateToFieldName = $dateToFieldName;
		}
	
		/**
		 * Set type field name
		 *
		 * @access public
		 * @param string $typeFieldName type field name
		 */
		public function setTypeFieldName($typeFieldName)
		{
			$this->_typeFieldName = $typeFieldName;
		}
		
		/**
		 * Get date formated
		 *
		 * @access public
		 * @param string $date date
		 * @return string Date
		 */
		function getDateFormated($mysqlDate)
		{  
			if ($mysqlDate == '0000-00-00')
				return '';
			
			return scDateTime::getFormattedDate($mysqlDate);
		}
		
		function addUiElements(&$rows)
		{
			$discountTypes = scDiscount::getDiscountTypes();
			foreach ($rows as $key => $row) {
				// Set date from
				$rows[$key][$this->_dateFromFieldName] = $this->getDateFormated($row[$this->_dateFromFieldName]);
				// Set date to
				$rows[$key][$this->_dateToFieldName] = $this->getDateFormated($row[$this->_dateToFieldName]);
				// Set type
				$rows[$key][$this->_typeFieldName] = $discountTypes[$row[$this->_typeFieldName]];
			}
		}
	}
?>