<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * Featured Products List
	 */
	class scFeaturedProductsTable extends scTable {
		const DEFAULT_PRODUCT_THUMB_URL = 'admin/images/image-not-available/default_product_thumb.gif';
		const DEFAULT_PRODUCT_THUMB_WIDTH = 100;
		const DEFAULT_PRODUCT_THUMB_HEIGHT = 100;
		
		function addUiElements(&$rows)
		{
			$featureProductIds = $this->getFeatureProductIds($rows);
			$categories = $this->getCategoryNames($featureProductIds);
			$productImageIds = $this->getProductImageIds($rows);
			
			$defaultImage = '<img src="'.scUrlUtil::convertUrl(scSkins::singleton()->getCurrentSkin()->getCurrentSkinUrl(), scUrlUtil::URL_TYPE_DOCROOT) .
				self::DEFAULT_PRODUCT_THUMB_URL . '" width="'.self::DEFAULT_PRODUCT_THUMB_WIDTH.'" height="'.self::DEFAULT_PRODUCT_THUMB_HEIGHT.'" alt="" />';
			
			foreach ($rows as &$row) {				
				// Featured Product Categories
				$categoryNames = array();
				if ($row['FeaturedProductOnHome'])
					$categoryNames[] = _t('HOME');
				if (isset($categories[$row['FeaturedProductID']]))
					$categoryNames = array_merge($categoryNames, $categories[$row['FeaturedProductID']]);
				$row['FMT_CATEGORIES'] = implode(', ', $categoryNames);
				
				// Product Image
				$productImageId = isset($productImageIds[$row['ProductID']]) ? $productImageIds[$row['ProductID']] : false;
				if ($productImageId) {
					// Check if file exists
					if (is_file(scPaths::getItemPath($productImageId, scPaths::RESOURCE_PRODUCT_THUMB))) {
						$row['HTML_PRODUCTIMAGETHUMB'] = '<img src="../' . scPaths::getItemPath($productImageId, scPaths::RESOURCE_PRODUCT_THUMB, scPaths::PATH_WEB) . '" alt="" />';
					} else {
						$row['HTML_PRODUCTIMAGETHUMB'] = $defaultImage;
					}
				} else {
					$row['HTML_PRODUCTIMAGETHUMB'] = $defaultImage;
				} 
			}
		}
		
		protected function getFeatureProductIds($rows)
		{
			$featureProductIds = array();
			foreach ($rows as $row)
				$featureProductIds[] = $row['FeaturedProductID'];
			return $featureProductIds;
		}
		
		protected function getProductImageIds($rows)
		{
			$productIds = array();
			foreach ($rows as $row) {
				$productIds[] = (int)$row['ProductID'];
			}
			if (count($productIds) == 0)
				return array();
			
			$sql = 'SELECT ProductID,ProductImageID FROM ProductImages WHERE ProductID IN(' . implode(',', $productIds) . ') AND ProductImageIsDefault<>0';
			return miUtil::getDBArray($sql, 'ProductID', 'ProductImageID');
		}
		
		protected function getCategoryNames($featureProductIds)
		{
			$languageId = scMultiLanguage::getCurrentLanguageId();
			$sql = 'SELECT FeaturedProductID, CategoryName FROM FeaturedProductCategories JOIN Categories USING(CategoryID)' .
				' JOIN CategoriesML USING(CategoryID) WHERE LanguageID=' . $languageId .
				' AND FeaturedProductID IN(' . implode(',', $featureProductIds) . ')';
			$rows = miStaticDBUtil::execSelect($sql);
			
			$categories = array();
			foreach ($rows as $row)
				$categories[$row['FeaturedProductID']][] = $row['CategoryName'];
			return $categories;
		}
	}
?>