<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * Orders List
	 */
	class scOrdersTable extends scTable {
		
		protected $_isCustomerRegisteredSections = array();
		
		public function getSection()
		{
			if (!is_null($this->_section)) {
				return $this->_section;
			}
			
			parent::getSection();
			$this->_section->addSubsectionsArray('isCustomerRegistered', $this->_isCustomerRegisteredSections);
			return $this->_section;
		}
		
		public function addUiElements(&$rows)
		{
			scDateTime::setTimezone();
			
			$orderStatuses = scOrderStatuses::singleton()->getOrderStatuses();
			foreach ($rows as $key => $row) {
				$rows[$key]['FMT_OrderStatus'] = isset($orderStatuses[$row['OrderStatus']]) ? $orderStatuses[$row['OrderStatus']] : '';
				// Set date
				$rows[$key]['OrderDate'] = scDateTime::getLocalFormattedTimestamp($row['OrderTimestamp'], true);
				$rows[$key]['OrderTimestamp'] = scDateTime::getLocalFormattedTimestamp($row['OrderTimestamp']);
				try {
					$currency = new scCurrency($row['OrderCurrencyCode']);
					$amount = scMultiCurrencyAmount::factory();
					$amount->set($currency, $row['OrderTotal']);
					$rows[$key]['FMT_OrderTotal'] = scPrice::factory($amount)->getDisplayPrice($currency);
				} catch (miException $e) {
					$rows[$key]['FMT_OrderTotal'] = $row['OrderCurrencyCode'] . ' ' . $row['OrderTotal'];
				}
				
				$rows[$key]['FMT_OrderCustomerName'] = $row['OrderCustomerName'];
				if (!empty($row['OrderCustomerEmail'])) {
					$rows[$key]['FMT_OrderCustomerName'] .= ' (' . $row['OrderCustomerEmail'] . ')';
				}
				// Check if there is a CustomerID in the order and it is not the GUEST's one.
				// XXX: isCustomerRegistered does not say if the user still exists. He may have been deleted.
				$isCustomerRegistered = (!empty($row['CustomerID']) && $row['CustomerID'] != ICheckoutModule::GUEST_USER_ID);
				$this->_isCustomerRegisteredSections[] = new miTemplateParserSectionInfo('isCustomerRegistered', (int)$isCustomerRegistered);
			}
		}
	}
?>