<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scTablePager extends miTablePager {
		const TMPL_VAR_RECORDSET_EASY_NAVIGATOR = 'HTML_RECORDSET_EASY_NAVIGATOR';
		
		function getValues()
		{
			$firstText = _t('First');
			$lastText = _t('Last');
			$nextText = _t('Next');
			$previousText = _t('Previous');
			
			$navigator_empty = '
			<span class="nav-prev-container">
				<span class="inactive">
					<span>' . $firstText . '</span>
				</span>
				<span class="inactive">
					<span>'. $previousText . '</span>
				</span>
			</span>	
			<span class="page_sel single-pager">1</span>
			<span class="nav-next-container">
				<span class="inactive">
					<span>'. $nextText . '</span>
				</span>
				<span class="inactive">
					<span>'. $lastText . '</span>
				</span>
			</span>
		';

			$page = $this->_page;

			$recordsPerPage = $this->_recordsPerPage;
			if ($recordsPerPage < 1)
				throw new miException(miI18N::getSystemMessage('MI_RECORDS_PER_PAGE_MUST_BE_AT_LEAST_ONE'));
			
			$strNavParams = miI18N::htmlEscape($this->getNavigatorParams());
			
			if ($this->_totalRecords <= $recordsPerPage)
				$navigator = $navigator_empty;
			else {
				$navigator = '';
				$firstpage = 1;
				$lastpage = (intval(($this->_totalRecords-1) / $recordsPerPage)) + 1;
				$first = $firstpage;
				$last = $lastpage;
				if ($last > ($page + 5)) $last = $page + 5; 
				if ($first < ($page - 5)) $first = $page - 5; 
				$prevpage = ($page > 1) ? $page - 1 : 1;
				$nextpage = ($page < $lastpage) ? $page + 1 : $lastpage;
				
				$linkPrefix = '<a class="pagenav" href="javascript:SC.Home.changePageForm(\'table\', \'?load=table&amp;';
				$linkSuffix = '\', \'entire_ajax_table\')"><span>';
				
				$navigator .= '<span class="nav-prev-container">';
				if ($page == $first) {
					$navigator .= '<span class="inactive"><span>' . $firstText . '</span></span>';
					$navigator .= '<span class="inactive"><span>' . $previousText . '</span></span>';
				} else {
					$navigator .= $linkPrefix . self::PARAM_PAGE . '=1&amp;' . $strNavParams . $linkSuffix . $firstText . '</span></a>';
					$navigator .= $linkPrefix . self::PARAM_PAGE. '=' . $prevpage . '&amp;' . $strNavParams . $linkSuffix . $previousText . '</span></a>';
				}
				
				$navigator .= '</span>';
				for ($i = $first; $i <= $last; $i++) {
					if ($i == $page)
						$navigator .= '<span class="page_sel"><span>' . $page . '</span></span>';
					else
						$navigator .= $linkPrefix . self::PARAM_PAGE . '=' . $i . '&amp;' . $strNavParams . $linkSuffix . $i . '</span></a>';
				}
				$navigator .= '<span class="nav-next-container">';
				
				if ($page == $last) {
					$navigator .= '<span class="inactive"><span>' . $nextText . '</span></span>';
					$navigator .= '<span class="inactive"><span>' . $lastText . '</span></span>';
				} else {
					$navigator .= $linkPrefix . self::PARAM_PAGE . '=' . $nextpage . '&amp;' . $strNavParams . $linkSuffix . $nextText . '</span></a>';
					$navigator .= $linkPrefix . self::PARAM_PAGE . '=' . $lastpage . '&amp;' . $strNavParams . $linkSuffix . $lastText . '</span></a>';
				}
				$navigator .= '</span>';
			}
			
			// Build the easy navigator
			if ($this->_totalRecords <= $recordsPerPage)
				$easyNavigator = '<div class="topNavLeft">' . $firstText . ' | ' . $previousText .
					'</div><div class="topNavRight">' . $nextText . ' | ' . $lastText . '</div>';
			else {
				$easyNavigator = '<div class="topNavLeft">';
				if ($page > 1)
					$easyNavigator .= $linkPrefix . self::PARAM_PAGE . '=1&amp;' . $strNavParams . $linkSuffix . $firstText . '</span></a>' . ' | ' .
					$linkPrefix . self::PARAM_PAGE. '=' . $prevpage . '&amp;' . $strNavParams . $linkSuffix . $previousText . '</span></a>';
				else
					$easyNavigator .= $firstText . ' | ' . $previousText;
				$easyNavigator .= '</div><div class="topNavRight">';
				if ($page < $last)
					$easyNavigator .= $linkPrefix . self::PARAM_PAGE . '=' . $nextpage . '&amp;' . $strNavParams . $linkSuffix . $nextText . '</span></a> | ' .
						$linkPrefix . self::PARAM_PAGE . '=' . $lastpage . '&amp;' . $strNavParams . $linkSuffix . $lastText . '</span></a>';
				else
					$easyNavigator .= $nextText . ' | ' . $lastText;
				$easyNavigator .= '</div>';
			}
			$fromRecord = ($page - 1) * $recordsPerPage + 1;
			$toRecord = min($fromRecord + $recordsPerPage - 1, $this->_totalRecords);
			$easyNavigator .= '<div align="center">' . $fromRecord . '-' . $toRecord . ' of ' . $this->_totalRecords . '</div>';
			
			return array_merge(
				array(self::TMPL_VAR_RECORDSET_NAVIGATOR => $navigator, self::TMPL_VAR_RECORDSET_EASY_NAVIGATOR => $easyNavigator),
				$this->assignPosition());
		}
	}
?>