<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * Records Per Page drop-down handling class
	 */
	class scTableRecordsPerPage extends miTableFeature {
		protected $_pagerObj;
		protected $recordsPerPageArray = array(5, 10, 20, 50, 100, 500);
		
		public function __construct($table, $pagerObj)
		{
			parent::__construct($table);
			$this->_pagerObj = $pagerObj;
		}
		
		public function getValues()
		{
			foreach ($this->recordsPerPageArray as $numRecordsPerPage)
				$values[] = $numRecordsPerPage . ' ' . _t('Records per page');
			
			$options = self::getConstDropdown(
				miTablePager::PARAM_RECORDS_PER_PAGE,
				$this->_pagerObj->getRecordsPerPageParam(),
				array_combine($this->recordsPerPageArray, $values));
			return array('HTML_RECORDSPERPAGE_DROPDOWN' => $options);
		}
		
		protected function getNavigatorParams()
		{
			$navigatorParams = $this->_table->getTableFeaturesStateParams();
			unset($navigatorParams[miTablePager::PARAM_RECORDS_PER_PAGE]);
			return $this->_table->paramsArrayToUrl($navigatorParams);
		}
		
		public function getConstDropdown($name, $selected, $optionsArray)
		{
//			$url = '&load=table&' . $this->getNavigatorParams();
//			$html = '<select name="' . $name . '" onChange1="' . "SC.Home.changeRecordsForm('table', '?" .
//				miTablePager::PARAM_RECORDS_PER_PAGE . "='+this.options[this.selectedIndex].value+'" . htmlentities($url) . "', 'entire_ajax_table');" . '">' . "\n";
			$html = '<select name="' . $name . '">' . "\n";
			$selected = (string)$selected;
			foreach ($optionsArray as $key => $value)
				$html .= '<option value="' . miI18N::htmlEscape($key) . '"' . ((string)$key === $selected?' selected="selected"':'') . '>' . miI18N::htmlEscape($value) . '</option>' . "\n";
			$html .= '</select>' . "\n";
			return $html;
		}
	}
?>