<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * 
	 * @copyright Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	class scTableSorter extends miTableFeature {
		
		const TMPL_VAR_ORDER_PARAMS = 'ORDER_PARAMS';
		const TMPL_VAR_SORT_DIR_SUFFIX = '_SORT_DIR';
		const TMPL_VAR_SORT_IMAGE_SUFFIX = '_SORT_IMAGE';
		const PARAM_SORTBY = 'sortBy';
		const PARAM_SORTDIR = 'sortDir';
		
		/**
		 * Get the feature values
		 * 
		 * @access public
		 * @return array
		 */
		public function getValues()
		{
			$values = array();
			$fields = $this->_table->getRecordset()->getAllFields();
			
			$sortBy = miGetParamDefault(self::PARAM_SORTBY, '');
			$sortDir = miGetParamDefault(self::PARAM_SORTDIR, 'ASC');
			foreach ($fields as $index => $field) {
				$newSortDir = 'ASC';
				if ($sortBy == $field)
					$newSortDir = ($sortDir != 'DESC') ? 'DESC' : 'ASC';
				$values[strtoupper($field) . self::TMPL_VAR_SORT_DIR_SUFFIX] = $newSortDir;
				$values[strtoupper($field) . self::TMPL_VAR_SORT_IMAGE_SUFFIX] = ($sortBy == $field) ? (($newSortDir == 'DESC') ? '_down' : '_up' ) : '';
			}
			$values[self::TMPL_VAR_ORDER_PARAMS] = $this->_table->paramsArrayToUrl($this->getStateParams());
			return $values;
		}
		
		/**
		 * Returns associative array with params that save the feature state
		 * 
		 * @return array
		 */
		public function getStateParams()
		{
			return array(
				self::PARAM_SORTBY => miGetParamDefault(self::PARAM_SORTBY, ''),
				self::PARAM_SORTDIR => miGetParamDefault(self::PARAM_SORTDIR, '')
			);
		}
	}
?>