<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scUIProducts {
		
		public static function getTaxesSection($productId)
		{
			$taxes = scTax::getAllTaxNames();
			
			$taxesSection = new miTemplateParserSectionInfo();
			if (count($taxes))
				$taxesSection->setSectionInfo('productTaxes', count($taxes), self::getTemplatizedProductTaxes($productId, $taxes));
			else
				$taxesSection->setSectionInfo('noProductTaxes', 1);
			return $taxesSection;
		}
		
		protected static function getTemplatizedProductTaxes($productId, $taxes)
		{
			if (count($taxes) == 0)
				return array();

			// get TaxClasses for each Tax
			$query = 'SELECT TaxID, TaxClassID, TaxClassName FROM TaxClasses ORDER BY TaxClassSort ASC';
			$rows = miStaticDBUtil::execSelect($query);
			$taxClasses = array();
			foreach ($rows as $iRow) {
				$taxClasses[$iRow['TaxID']][$iRow['TaxClassID']] = $iRow['TaxClassName'];
			}
			
			$productTaxClasses = array();
			if ($productId) {
				// get TaxClasses for each product
				$query = 'SELECT PTC.TaxClassID, TC.TaxID FROM ProductTaxClasses PTC 
							JOIN TaxClasses TC ON PTC.TaxClassID = TC.TaxClassID 
							WHERE PTC.ProductID = '.(int) $productId;				
				$productTaxClasses = miUtil::getDBArray($query, 'TaxID', 'TaxClassID');
			} else {
				// get default TaxClasses
				$query = 'SELECT * FROM Taxes WHERE TaxApplyByDefault = 1';
				$productTaxClasses = miUtil::getDBArray($query, 'TaxID', 'TaxID');
			}
				
			// Assign values for each tax
			foreach ($taxes as &$iTax) {
				$taxId = $iTax['TaxID'];
				$taxClassOptions = isset($taxClasses[$taxId]) ? $taxClasses[$taxId] : array();
				$selectedTaxClass = isset($productTaxClasses[$taxId]) ? $productTaxClasses[$taxId] : 0;
				$iTax['HTML_PRODUCTTAXCLASSES'] = scUIUtil::getConstDropdown('ProductTaxClasses[]', $selectedTaxClass, $taxClassOptions, array('id' => 'ProductTaxClasses_' . $taxId));
				$iTax['HTML_PRODUCTTAXENABLED'] = $selectedTaxClass ? 'checked="checked"' : '';
			}
			
			return miUIUtil::templetizeRows(miUIUtil::transposeRows($taxes));	
		}
		
		public static function getOptionGroupsSection($productId)
		{
			$languageId = scMultiLanguage::getCurrentLanguageId();
			$query = 'SELECT OptionGroups.OptionGroupID, OptionGroupName FROM OptionGroups' .
				' LEFT JOIN OptionGroupsML ON OptionGroups.OptionGroupID=OptionGroupsML.OptionGroupID' .
				' AND LanguageID=' . $languageId;
			$optionGroups = miStaticDBUtil::execSelect($query);
			
			$optionGroupsSection = new miTemplateParserSectionInfo();
			$optionGroupsSection->setSectionInfo('productOptionGroups', count($optionGroups), self::getTemplatizedProductOptionGroups($productId, $optionGroups));
			return $optionGroupsSection;
		}
		
		protected static function getTemplatizedProductOptionGroups($productId, $optionGroups)
		{
			if (count($optionGroups) == 0)
				return array();
			
			$productOptionGroups = array();
			if ($productId) {
				// Get productOptionGroups
				$query = 'SELECT OptionGroupID FROM ProductOptionGroups WHERE ProductID = '.(int) $productId;
				$rows = miStaticDBUtil::execSelect($query);
				foreach ($rows as $key => $value) {
					$productOptionGroups[] = $value['OptionGroupID'];
				}
			}
			
			// Check the checkbox for each ProductOptionGroup
			foreach ($optionGroups as &$optionGroupRow) {
				$optionGroupRow['PRODUCTOPTIONGROUP'] = in_array($optionGroupRow['OptionGroupID'], $productOptionGroups) ? 'checked="checked"' : '';
			}
			
			return miUIUtil::templetizeRows(miUIUtil::transposeRows($optionGroups));	
		}
	}
?>