<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scCmsMenuItemsWidget extends miBaseWidget {
		public function getEditableControl()
		{
			$menus = $this->_webForm->getFormData($this->_fieldName);
			
			for ($i = 0; $i < count($menus); $i++) {
				$nameField = new scWebFormWidgetTextML($this->_webForm);
				$nameField->setFieldName('CMSMenuItemName['.$menus[$i]['CMSMenuID'].']');
				$nameField->setProperty('class', 'name'.$menus[$i]['CMSMenuID']);
				
				if (!empty($menus[$i]['CMSMenuItemName'])) {
					$menus[$i]['HTML_CMSMenuItemIsActive'] = 'checked="checked"';
					$nameField->setDefaultValue($menus[$i]['CMSMenuItemName']);
				} else {
					$menus[$i]['HTML_CMSMenuItemIsActive'] = '';
					$nameField->setProperty('disabled', 'disabled');
				}
				if (!isset($menus[$i]['CMSMenuItemID']))
					$menus[$i]['CMSMenuItemID'] = '';
					
				$menus[$i]['CMSMenuItemName'] = '';
				$menus[$i]['HTML_CMSMenuItemName'] = current($nameField->getEditableControl());
			}
			
			// Set section items
			$menusSection = new miTemplateParserSectionInfo();
			$menusSection->setSectionInfo('menus', count($menus), miUIUtil::templetizeRows(miUIUtil::transposeRows($menus)));
			
			$t = new scTemplateParser();
			$t->readTemplate('admin/rich_text_pages/cms_menu_items_table.tmpl');			
			$t->setSectionInfos(array($menusSection));
			
			return array($this->_fieldName => $t->templateParse());
		}
		
		public function getData()
		{
			$data = $this->_webForm->getFormData($this->_fieldName);
			if (is_null($data))
				$data = array();
			
			$ids = miGetParamDefault('CMSMenuItemID', array());
			$actives = miGetParamDefault('CMSMenuItemIsActive', array());
			$names = miGetParamDefault('CMSMenuItemName', array());
			
			foreach ($data as &$row) {
				$menuId = intval($row['CMSMenuID']);
				$row['CMSMenuItemID'] = isset($ids[$menuId]) ? $ids[$menuId] : 0;
				$row['CMSMenuItemName'] = isset($names[$menuId]) ? $names[$menuId] : '';
				$row['CMSMenuItemIsActive'] = isset($actives[$menuId]);
			}
			
			return array($this->_fieldName => $data);
		}
		
		public function validateData(miWebFormErrorsHandler &$errors)
		{
			$menus = $this->_webForm->getFormData($this->_fieldName);
			$activeMenus = miGetParamDefault('CMSMenuItemIsActive', array());
			$menuItemNames = miGetParamDefault('CMSMenuItemName', array());
			$activeLanguages = scMultiLanguage::singleton()->getActiveLanguages();
			foreach ($menus as $menu) {
				$menuId = intval($menu['CMSMenuID']);
				
				if (!isset($activeMenus[$menuId]) || !(bool)$activeMenus[$menuId])
					continue;
					
				$error = true;
				foreach ($activeLanguages as $activeLanguage) {
					if (isset($menuItemNames[$menuId][$activeLanguage['LanguageID']]) && !empty($menuItemNames[$menuId][$activeLanguage['LanguageID']])) {
						$error = false;
						break;
					}
				}
				
				if ($error) {
					$errors->addError($this->_fieldName, _t('Names are required to be set for all active menus.'));
					return;
				}
			}
		}
	}
?>