<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scCheckoutAllowPointsWidget extends miCheckboxWidget {
		
		public function validateData(miWebFormErrorsHandler &$errors)
		{
			if (miGetParamDefault($this->_fieldName, '') == '') {
				$cartItems = $this->getCart()->getItems();
				foreach ($cartItems as $cartItem) {
					if ($cartItem->getBonusPointsMode() == scBonusPoints::PRODUCT_POINTS_ONLY) {
						$msg = sprintf(_t('"%s" can only be bought using points.'), $cartItem->getName());
						$errors->addError($this->_fieldName, $msg);
						return;
					}
				}
			}
			
			try {
				$this->getCart()->checkMinimumPoints();
			} catch (miException $e) {
				$errors->addError($this->_fieldName, $e->getMessage());
			}
		}
		
		protected function getCart()
		{
			return scCart::getCart();
		}
	}
?>