<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scCityNameWidget extends miBaseTextWidget {
		
		public function __construct(miWebForm &$webForm, $properties = array())
		{
			parent::__construct($webForm, $properties);
		}
		
		function getEditableControl()
		{
			$t = new scTemplateParser();
			$t->readTemplate($this->_properties['template']);
			$t->assignArray(array(
				'%%FIELD_NAME%%' => $this->_fieldName,
				'%%FIELD_ID%%' => $this->_fieldName,
				'%%FIELD_VALUE%%' => $this->getValue(),
				
				'%%CITYIDFIELD_ID%%' => $this->_properties['CityIDFieldId'],
				'%%STATEIDFIELD_ID%%' => $this->_properties['StateIDFieldId'],
				'%%COUNTRYIDFIELD_ID%%' => $this->_properties['CountryIDFieldId'],
				
				// _SELECTOR vars are used as jQuery selectors.
				// Their colons (:) need to be escaped
				// as colon is a special character for jQuery.
				'%%FIELD_SELECTOR%%' => str_replace(':', "\\\\:" , $this->_fieldName),
				'%%CITYIDFIELD_SELECTOR%%' => str_replace(':', "\\\\:" , $this->_properties['CityIDFieldId']),
				'%%STATEIDFIELD_SELECTOR%%' => str_replace(':', "\\\\:" , $this->_properties['StateIDFieldId']),
				'%%COUNTRYIDFIELD_SELECTOR%%' => str_replace(':', "\\\\:" , $this->_properties['CountryIDFieldId']),
				'%%FUNCTION_IDENTIFIER%%' => str_replace('::', "" , $this->_fieldName),
			));
			
			$attributeNames = $attributeValues = array();
			if (isset($this->_properties['tabindex'])) {
				$attributeNames[] = 'tabindex';
				$attributeValues[] = $this->_properties['tabindex'];
			}
			$attributes = array(
				'%%ATTR_NAME%%' => $attributeNames,
				'%%ATTR_VALUE%%' => $attributeValues,
			);
			$t->addSectionInfo(new miTemplateParserSectionInfo('attributes', count($attributeNames), $attributes));
			
			$html = $t->templateParse();
			return array($this->_fieldName => $html);
		}
	}