<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scCustomerSelectWidget extends scListBoxWidget {
		protected function getSelectedValues()
		{
			// Set the options
			$customerIds = $this->_webForm->getFormData($this->_fieldName);
			if (empty($customerIds)) {
				$this->_options = array();
				return array();
			}
			
			$recordset = new miSqlRecordset('Customers', 'CustomerID');
			$recordset->addJoinCondition('LEFT', 'CustomerAddresses', 'ON CustomerAddresses.CustomerID = Customers.CustomerID AND CustomerAddressIsDefaultBilling = 1');
			$selectFields[] = 'Customers.CustomerID';
			$selectFields[] = 'CONCAT(CustomerAddressFirstName, " ", CustomerAddressLastName, " (", CustomerEmail , ")") as CustomerName';
			$recordset->setSelectFields($selectFields);
			$recordset->addFilter(new miSqlFilterIn('Customers.CustomerID', $customerIds));
			$this->_options = miUtil::getDBArray($recordset->getSelectQuery(), 'CustomerID', 'CustomerName');
			
			// No selected values
			return array();
		}
	}
?>