<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scDateWidget extends miBaseWidget {
		const DATE_FORMAT_VAR = 'DATE_FORMAT';
		const DATE_FORMAT_VAR_VALUE = 'dd/mm/yyyy';
		
		/**
		 * @access protected
		 */
		protected $_dateFormat = 'd/m/Y';
		
		/**
		 * @access protected
		 */
		protected $_viewDateFormat = 'd M Y';
		
		public function getControl()
		{
			$formData = $this->_webForm->getFormData($this->_fieldName);
			$date = explode('-', $formData);
			if (($date[0] == 0) and ($date[1] == 0) and ($date[2] == 0))
				return array($this->_fieldName => '');
			
			$formData = gmdate($this->_viewDateFormat, gmmktime(0, 0, 0, $date[1], $date[2], $date[0]));
			return array($this->_fieldName => miI18N::htmlEscape($formData));
		}
		
		/**
		 * Returns the date field contents to be displayed
		 * 
		 * @return array
		 */
		function getEditableControl()
		{
			$formData = $this->_webForm->getFormData($this->_fieldName);
			if ($formData === null)
				$formData = gmdate($this->_dateFormat);
			else {
				$date = explode('-', $formData);
				if (($date[0] == 0) and ($date[1] == 0) and ($date[2] == 0))
					$formData = '';
				else
					$formData = $date[2] . '/' . $date[1] . '/' . $date[0];
			}
			return array($this->_fieldName => miI18N::htmlEscape($formData), self::DATE_FORMAT_VAR => self::DATE_FORMAT_VAR_VALUE);
		}
		
		/**
		 * Process the form submissions and returns the date field data
		 * 
		 * @return array
		 */
		function getData()
		{
			$date = explode('/', miGetParamDefault($this->_fieldName, ''));
			$value = (count($date) != 3) ? '0000-00-00' : $date[2] . '-' . $date[1] . '-' . $date[0];
			return array($this->_fieldName => $value);
		}
		
		public function validateData(miWebFormErrorsHandler &$errors)
		{
			$fieldValue = miGetParamDefault($this->_fieldName, '');
//			if (($fieldValue == '') or ($fieldValue == '00/00/0000'))
//				return;
			
	    	$pieces = explode("/", $fieldValue);
			if (preg_match('#^\d{2}/\d{2}/\d{4}$#', $fieldValue) and checkdate($pieces[1], $pieces[0], $pieces[2]))
				return;
			
			$errors->addError($this->_fieldName, _t('Invalid date format.'));
		}
	}
?>