<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scWebFormWidgetFileUpload extends miBaseWidget {
		
		protected $_namePrefixSave;
		protected $_namePrefixWeb;
		protected $_nameSuffix;
		protected $_primaryKey;
		
		public function setPrimaryKey($primaryKey)
		{
			$this->_primaryKey = $primaryKey;
		}
		
		public function setPrefixSave($value)
		{
			$this->_namePrefixSave = $value;
		}
		
		public function setPrefixWeb($value)
		{
			$this->_namePrefixWeb = $value;
		}
		
		public function setSuffix($value)
		{
			$this->_nameSuffix = $value;
		}
		
		public function setProps($prefixSave, $prefixWeb, $suffix)
		{
			$this->_namePrefixSave = $prefixSave;
			$this->_namePrefixWeb = $prefixWeb;
			$this->_nameSuffix = $suffix;
		}
		
		public function getPrefixSave()
		{
			return $this->_namePrefixSave;
		}
		
		public function getPrefixWeb()
		{
			return $this->_namePrefixWeb;
		}
		
		public function getSuffix()
		{
			return $this->_nameSuffix;
		}
		
		/**
		 * TODO: V1.1 Images should be uploaded here, and not in scViewMapperProductImages
		 */
		public function getData()
		{
			return array();
		}
		
		/**
		 * Returns the field contents to be displayed
		 * 
		 * @return array
		 */
		public function getEditableControl()
		{		
			$html = '';		
			$html_missing = '';

			$pkValue = $this->_webForm->getFormData($this->_properties['primaryKey']);

			if (file_exists($this->_namePrefixSave . $pkValue . $this->_nameSuffix)) {
				$html = $this->_namePrefixWeb . $pkValue . $this->_nameSuffix;
				$html_missing = '';
			} else {
				$html = '';
				$html_missing = 'style="display: none"';
			}
			
			return array(
				$this->_fieldName => $html,
				'MISSING_'.$this->_fieldName => $html_missing,
			);
		}
	}
	
	class scFileUploadWidget extends miBaseWidget {
		
		protected $_propertyAttributes = array(
			'id',
			'size',
		);
		
		public function getData()
		{
			$return = array();
			
			if (isset($_FILES[$this->_fieldName]) && ($_FILES[$this->_fieldName]['error'] != UPLOAD_ERR_NO_FILE)) {
				$return[$this->_fieldName] = new scUploadedFile();
				$return[$this->_fieldName]->setFieldName($this->_fieldName);
				$return[$this->_fieldName]->setFileData($_FILES[$this->_fieldName]);
			}
			
			return $return;
		}
		
		public function getEditableControl()
		{
			$htmlAttributes = '';
			foreach ($this->_propertyAttributes as $attribute) {
				if (isset($this->_properties[$attribute])) {
					$htmlAttributes .= $attribute . '="' . $this->_properties[$attribute] . '" ';
				}
			}
			$widget = '<input type="file" name="' . $this->_fieldName . '" ' . $htmlAttributes . '/>';
			return array($this->_fieldName => $widget);
		}
		
		public function getControl()
		{
			$data = $this->getData();
			return array($this->_fieldName => $data[$this->_fieldName]->getContents());
		}
		
		public function validateData(miWebFormErrorsHandler &$errors)
		{
			$data = $this->getData();
			
			if (isset($data[$this->_fieldName]) && $data[$this->_fieldName]->hasErrors()) {
				$errors->addError($this->_fieldName, $data[$this->_fieldName]->getErrorMessage());
			}
		}
	}
?>