<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scFormItemsWidget extends scItemsWithValuesWidget {
		
		protected function getItemsSectionInfo()
		{
			$itemsSections = array();
			foreach ($this->_rsFormFields as $rowIndex => $rowIndexFormFields) {
				$itemsValue = array();
				$itemsValue[0] = array(
					'ROWVALUENUM' => '',
					'HTML_STYLE' => 'style="display:none"',
					'HTML_CMSFormItemValues' => $this->getMLControlHtml($rowIndex)
				);
					
				if ($rowIndex) {
					$cmsFormItemsValues = array_values($this->_webForm->getFormData('CMSFormItemsValues::' . $rowIndex . '::'));
					foreach ($cmsFormItemsValues as $key => $cmsFormItemsValue) {
						$itemsValue[] = array(
							'ROWVALUENUM' => $key+1,
							'HTML_STYLE' => '',
							'HTML_CMSFormItemValues' => $this->getMLControlHtml($rowIndex, $key+1, $cmsFormItemsValue)
						);
					}
				}
				
				// Set items section
				$itemsSections[] = new miTemplateParserSectionInfo($this->_fieldName.'_Items', count($itemsValue), miUIUtil::templetizeRows(miUIUtil::transposeRows($itemsValue)));
			}
			return $itemsSections;
		}
		
		protected function createFieldObjects()
		{
			parent::createFieldObjects();
			
			$fields = $this->getRsFieldObjs('CMSFormItemType');
			foreach ($fields as $field) {
				$field->setOptions(scFormItem::singleton()->getItemTypes());
				$field->setOptionsGroup(scFormItem::singleton()->getItemItemGroups());
			}
		}
		
		public function getData()
		{
			$result = parent::getData();
			foreach ($result['CMSFormItems'] as $key => &$formItem) {
				$formItem['CMSFormItemsValues'] = $this->getAllItemsValues($key+1);
			}
			return $result;
		}
	}
?>