<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scGroupableSelectWidget extends miSelectWidget {
		
		const GROUP_LABEL = 'label';
		const GROUP_OPTIONS = 'options';
		
		protected $_groupedOptions = array();
		
		public function setOptions($optionGroups, $defaultOptionIndex = null)
		{
			$this->_groupedOptions = $optionGroups;
			$this->_options = array();
			foreach ($optionGroups as $possibleValue => $optionGroup) {
				if (!is_array($optionGroup)) {
					$this->_options[$possibleValue] = $optionGroup;
				} else {
					$this->_options = $this->_options + $optionGroup[self::GROUP_OPTIONS];
				}
			}
		}
		
		public function getEditableControl()
		{
			$value = $this->getValue();
			
			$id = isset($this->_properties['id']) ? ' id="' . $this->_properties['id'] . '"' : '';
			$class = isset($this->_properties['class']) ? ' class="' . $this->_properties['class'] . '"' : '';
			$tabindex = isset($this->_properties['tabindex']) ? ' tabindex="' . $this->_properties['tabindex'] . '"' : '';
			$html = '<select name="' . $this->_fieldName . '"' . $id . $class . $tabindex . '>';
			foreach ($this->_groupedOptions as $possibleValue => $optionGroup) {
				if (!is_array($optionGroup)) {
					$html .= $this->getOptionHtml($possibleValue, $optionGroup, $value);
					continue; 
				}
				
				$html .= '<optgroup label="' . miI18N::htmlEscape($optionGroup[self::GROUP_LABEL]) . '">';
				foreach ($optionGroup[self::GROUP_OPTIONS] as $key => $option) {
					$html .= $this->getOptionHtml($key, $option, $value);
				}
				$html .= '</optgroup>';
			}
			$html .= '</select>';
			return array($this->_fieldName => $html);
		}
		
		protected function getOptionHtml($optionValue, $optionText, $selectedValue = null)
		{
			return '<option value="' . miI18N::htmlEscape($optionValue) . '"' . ($optionValue == $selectedValue ? ' selected="selected"':'') . '>' . miI18N::htmlEscape($optionText) . '</option>';
		}
	}
?>