<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scHashedPasswordWidget extends miBaseTextWidget {
		const HASHED = '<hashed>';
		
		function getEditableControl()
		{
			$hashMode = $this->_webForm->getFormData($this->_fieldName . 'HashMode');
			$isCreate = ((miGetParamDefault('action', '') == 'dmCreate') or (miGetParamDefault('action', '') == 'dmExecCreate'));
			if (((($hashMode === null) and $this->getValue() == '') or ($hashMode != scAuth::HASH_MODE_NONE)) and !$isCreate)
				return array($this->_fieldName => miI18N::htmlEscape(self::HASHED));
			
			return array($this->_fieldName => miI18N::htmlEscape($this->getValue()));
		}
		
		function getData()
		{
			$value = miGetParamDefault($this->_fieldName, '');
			if ($value == self::HASHED)
				return array();
			
			return array($this->_fieldName => $value);
		}
		
		public function validateData(miWebFormErrorsHandler &$errors)
		{
			$fieldValue = miGetParamDefault($this->_fieldName, '');
			if ($fieldValue == self::HASHED)
				return;
			
			if ($fieldValue == '')
				$errors->addError($this->_fieldName, _t('Field is empty.'));
		}
	}
?>