<?php
	class scItemsWithValuesWidget extends scDynRowsWidget {
		
		protected function getControlHtml($fieldName, $fieldData)
		{
			return '<input type="text" name="' . miI18N::htmlEscape($fieldName) . '" value="' . miI18N::htmlEscape($fieldData) . '"/>';
		}
		
		protected function getMLControlHtml($rowIndex, $rowValueNum = '', $data = array())
		{
			$activeLanguages = scMultiLanguage::singleton()->getActiveLanguages();
			$widget = '';
			
			$fieldName = $this->_properties['table'] . '::' . $rowIndex . '::' . $this->_properties['valueField'] . '--' . $rowValueNum . '--';
			
			foreach ($activeLanguages as $activeLanguage) {
				$languageId = $activeLanguage['LanguageID'];
				$fieldData = isset($data[$languageId]) ? $data[$languageId] : '';
				
				$widget .= '<span id="span' . miI18N::htmlEscape($fieldName . '-' . $languageId) . '" style="display:none">';
				$widget .= '<a href="javascript: SC.ML.nextLanguage(' . $languageId . ');" name="changeLanguage">';
				if (!empty($activeLanguage['LanguageImage']) and file_exists(scPaths::getStoreRootDir() . $activeLanguage['LanguageImage'])) {
					$widget .= '<img src="' . scPaths::getStoreWebPath() . $activeLanguage['LanguageImage'] . '" width="' . $activeLanguage['LanguageImageWidth'] . '" height="' . $activeLanguage['LanguageImageHeight'] . '"'.
						' alt="' . miI18N::htmlEscape($activeLanguage['LanguageName']) . '" title="' . miI18N::htmlEscape($activeLanguage['LanguageName']) . '"/>';
				} else {
					$widget .= miI18N::htmlEscape($activeLanguage['LanguageName']);
				}
				$widget .= '</a>';
				$widget .= $this->getControlHtml($fieldName . '[' . $languageId . ']', $fieldData);
				$widget .= '</span>';
			}
			
			$widget .= '<script type="text/javascript">SC.ML.registerMultilanguageControl("' . miI18N::htmlEscape($fieldName). '")</script>';
			return $widget;
		}
		
		/**
		 * Returns the field contents to be displayed
		 * 
		 * @return array
		 */
		public function getEditableControl()
		{
			$this->setWebFormData();
			$this->createFieldObjects();
			
			$fieldValues = $this->getFieldValues();
			$itemsSectionInfo = $this->getItemsSectionInfo();
			foreach ($itemsSectionInfo as $itemsSections) {
				$count = count($itemsSections->_values['%%HTML_STYLE%%']);
				$fieldValues['%%STYLEVALUES%%'][] = $count > 1 ? '' : 'style="display:none"';
				$fieldValues['%%ROWVALUESCOUNT%%'][] = $count - 1;
			}
			$sectionInfo = $this->getSectionInfo($fieldValues);
			
			$sectionInfo->addSubsectionsArray($this->_fieldName.'_Items', $itemsSectionInfo);
			return array($this->_fieldName => $this->parseTemplate($sectionInfo));
		}
		
		protected function getAllItemsValues($rowIndex)
		{
			$rowIndexFormFields = $this->_rsFormFields[$rowIndex];
			
			$rowCount = miGetParamDefault($this->_properties['table'] . '::' . $rowIndex . '::__rowCount', '');
			if ($rowCount == '')
				return array();
			
			$itemValues = array();
			for ($i = 1; $i <= $rowCount; $i++) {
				$itemValues[] = miGetParamDefault($this->_properties['table'] . '::' . $rowIndex . '::' . $this->_properties['valueField'] . '--' . $i . '--', '');
			}
			
			return $itemValues;
		}
	}
?>