<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * Multiple checkboxes widget
	 * The value is comma separated list of keys
	 */
	class scModuleOptionMultiCheckboxWidget extends miRadioWidget {
		const MAX_CHECKBOXES_PER_ROW = 10;
		
		function getEditableControl()
		{
			$value = explode(',', $this->_webForm->getFormData($this->_fieldName));
			
			$widget = '';
			$i = 0;
			foreach ($this->_radioButtons as $key => $option) {
				$checked = in_array($key, $value) ? ' checked="checked"' : '';
				$widget .= '<label><input type="checkbox" name="' . $this->_fieldName . '[]" value="' . $key . '"' . $checked . '/>' . miI18N::htmlEscape($option) . '</label>';
				
				if ((++$i % self::MAX_CHECKBOXES_PER_ROW) == 0)
					$widget .= '<br/>';
			}
			return array($this->_fieldName => $widget);
		}
		
		public function getData()
		{
			$value = miGetParamDefault($this->_fieldName, '');
			return array($this->_fieldName => implode(',', $value));
		}
	}
?>