<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scMultiCheckboxWidget extends miSelectWidget {
		
		protected $_separator = '<br />';
		
		protected $_defaultValue = 0;
		
		public function setOptions($options, $defaultValue = null)
		{
			$this->_options = $options;
			
			// Make sure the _defaultOptionIndex is valid or null
			if ($defaultValue !== null) {
				$this->_defaultValue = $defaultValue;
			}
		}
		
		/**
		 * @return array
		 */
		public function getEditableControl()
		{
			$data = $this->_webForm->getFormData($this->_fieldName);
			if (is_array($data)) {
				$value = 0;
				foreach ($data as $mark) {
					$value = $value ^ $mark;
				}
				$data = $value;
			} else if (is_null($data) && ($this->_defaultValue > 0)) {
				$data = $this->_defaultValue;
			}
			
			$currentBit = 0;
			$power = 0;
			
			$html = array();
			foreach ($this->_options as $currentBit => $option) {
				$checked = ($data & $currentBit) ? 'checked="checked"' : '';
				
				$input = '<input type="checkbox" name="'. $this->_fieldName .'[]" '. $checked .' value="'. $currentBit .'" />';
				
				if (strpos($option, '%s') === false) {
					$html[] = '<label>' . $input . ' ' . $option . '</label> ';
				} else {
					$html[] = '<label>' . sprintf($option, $input) . '</label> ';
				}
			}
			
			return array($this->_fieldName => implode($this->_separator, $html));
		}
		
		/**
		 * @return array
		 */
		public function getData()
		{
			$marks = miGetParamDefault($this->_fieldName, array());
			$value = 0;
			foreach ($marks as $mark) {
				$value = $value ^ $mark;
			}
			
			return array($this->_fieldName => $value);
		}
		
		/**
		 * @return array
		 */
		public function getControl()
		{
			return $this->getEditableControl();
		}
	}
?>