<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scOptionalSelectWidget extends miSelectWidget {
		
		/**
		 * The value of "not selected"
		 */
		const NONE_VALUE = -1;
		
		/**
		 * @return array
		 */
		public function getData()
		{
			if (isset($this->_properties['readOnly']) && $this->_properties['readOnly']) {
				return array();	
			}
			
			$data = miGetParamDefault($this->_fieldName, '');
			if ($data == $this->getNoneValue()) {
				return array($this->_fieldName => null);
			}
			
			return array($this->_fieldName => $data);
		}
		
		protected function getNoneValue()
		{
			if (array_key_exists('noneValue', $this->_properties)) {
				return $this->_properties['noneValue'];
			}
			return self::NONE_VALUE;
		}
	}
	
	class scOptionalBaseSelectWidget extends miBaseSelectWidget {
		
		/**
		 * The value of "not selected"
		 */
		const NONE_VALUE = -1;
		
		/**
		 * @return array
		 */
		public function getData()
		{
			if (isset($this->_properties['readOnly']) && $this->_properties['readOnly']) {
				return array();	
			}
			
			$data = miGetParamDefault($this->_fieldName, '');
			if ($data == $this->getNoneValue()) {
				return array($this->_fieldName => null);
			}
			
			return array($this->_fieldName => $data);
		}
		
		protected function getNoneValue()
		{
			if (array_key_exists('noneValue', $this->_properties)) {
				return $this->_properties['noneValue'];
			}
			return self::NONE_VALUE;
		}
	}
?>