<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scProductClassAttributesWidget extends scItemsWithValuesWidget {
		
		protected function getItemsSectionInfo()
		{
			$itemsSections = array();
			foreach ($this->_rsFormFields as $rowIndex => $rowIndexFormFields) {
				$itemsValue = array();
				$itemsValue[0] = array(
					'ROWVALUENUM' => '',
					'HTML_STYLE' => 'style="display:none"',
					'HTML_ProductClassAttributeValues' => $this->getMLControlHtml($rowIndex)
				);
					
				if ($rowIndex) {
					$itemsValues = $this->_webForm->getFormData('ProductClassAttributeValues::' . $rowIndex . '::');
					$itemsValueIds = array_keys($itemsValues);
					$itemsValues = array_values($itemsValues);
					foreach ($itemsValues as $key => $cmsFormItemsValue) {
						$valueIdKey = $this->_properties['table'] . '::' . $rowIndex . '::' . $this->_properties['valueKey'] . '--' . ($key+1) . '--';
						$valueIdHtml = '<input type="hidden" name="' . $valueIdKey . '" value="' . $itemsValueIds[$key] . '" />';
						$itemsValue[] = array(
							'ROWVALUENUM' => $key+1,
							'HTML_STYLE' => '',
							'HTML_ProductClassAttributeValues' => $this->getMLControlHtml($rowIndex, $key+1, $cmsFormItemsValue) . $valueIdHtml
						);
					}
				}
				
				// Set items section
				$itemsSections[] = new miTemplateParserSectionInfo($this->_fieldName.'_Items', count($itemsValue), miUIUtil::templetizeRows(miUIUtil::transposeRows($itemsValue)));
			}
			return $itemsSections;
		}
		
		protected function createFieldObjects()
		{
			parent::createFieldObjects();
			
			$fields = $this->getRsFieldObjs('ProductClassAttributeType');
			foreach ($fields as $field) {
				$field->setOptions(scProductAttributes::singleton()->getFieldTypes());
			}
			
			$fields = $this->getRsFieldObjs('ProductClassAttributeValidator');
			foreach ($fields as $field) {
				$field->setOptions(scProductAttributes::singleton()->getAttributeValidators());
			}
		}
		
		public function getData()
		{
			$result = parent::getData();
			foreach ($result['ProductClassAttributes'] as $key => &$formItem) {
				$formItem[$this->_properties['valueTable']] = $this->getAllItemsValues($key+1);
				$formItem[$this->_properties['valueKey']] = $this->getAllItemsValueIds($key+1);
			}
			return $result;
		}
		
		protected function getAllItemsValueIds($rowIndex)
		{
			$rowIndexFormFields = $this->_rsFormFields[$rowIndex];
			
			$rowCount = miGetParamDefault($this->_properties['table'] . '::' . $rowIndex . '::__rowCount', '');
			if ($rowCount == '')
				return array();
			
			$itemValueIds = array();
			for ($i = 1; $i <= $rowCount; $i++) {
				$itemValueIds[] = miGetParamDefault($this->_properties['table'] . '::' . $rowIndex . '::' . $this->_properties['valueKey'] . '--' . $i . '--', '');
			}
			
			return $itemValueIds;
		}
	}
?>