<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scProductEgoodsWidget extends scFileUploadDynRowsWidget {
		
		const EGOODS_DIR_FIELD = 'egoodsDirField';
		const EGOODS_SHARED_DIR_FIELD = 'egoodsSharedDirField';
		
		/**
		 * @var string
		 */
		protected $_dirName;
		
		/**
		 * @return string
		 */
		public function getDirName()
		{
			if (!isset($this->_dirName)) {
				$productId = $this->_webForm->getFormData($this->_foreignKeyName);
				if (is_null($productId)) {
					$this->_dirName = scPaths::EGOODS_TEMP . md5(mt_rand());
				} else {
					$this->_dirName = scPaths::EGOODS_PRODUCTS . $productId;
				}
			}
			return $this->_dirName;
		}
		
		public function getSharedDirName()
		{
			return scPaths::EGOODS_SHARED;
		}
		
		/**
		 * @param miTemplateParser $templateParser
		 */
		protected function assignTemplateVars(miTemplateParser &$templateParser)
		{
			parent::assignTemplateVars($templateParser);
			
			$properties = $this->getProperties();
			
			if (!isset($properties[self::EGOODS_DIR_FIELD]))
				throw new miException('EGOODS_DIR_FIELD needs to be defined.');
			if (!isset($properties[self::EGOODS_SHARED_DIR_FIELD]))
				throw new miException('EGOODS_SHARED_DIR_FIELD needs to be defined.');
			
			$dirField = $properties[self::EGOODS_DIR_FIELD];
			$templateArray[$dirField] = $this->getDirName();
			
			$dirField = $properties[self::EGOODS_SHARED_DIR_FIELD];
			$templateArray[$dirField] = $this->getSharedDirName();
			
			$templateParser->assignArray(miUIUtil::templetizeAndEscapeRows($templateArray));
		}
		
		/**
		 * @return array
		 */
		public function getData()
		{
			$return = parent::getData();
			
			$properties = $this->getProperties();
			
			$dirField = $properties[self::EGOODS_DIR_FIELD];
			$generatedDirName = $this->getDirName();
			$this->_dirName = miGetParamDefault($dirField, $generatedDirName);
			$return[$dirField] = $this->_dirName;
			
			return $return;
		}
	}
?>