<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scProductVariantImageWidget extends scFileUploadWidget {
		
		const MAX_WIDTH = 'maxWidth';
		const MAX_HEIGHT = 'maxHeight';
		
		const THUMB_MAX_WIDTH = 'thumbMaxWidth';
		const THUMB_MAX_HEIGHT = 'thumbMaxHeight';
		
		public function getEditableControl()
		{
			$upload = parent::getEditableControl();
			$preview = $this->getControl();
			$delete = '<br /><label>' .
				'<input type="checkbox" name="Delete' . $this->_fieldName . '" value="delete" /> ' .
				_t('Delete Image') . '</label>';
			
			return array(
				$this->_fieldName => $preview[$this->_fieldName] .
					$upload[$this->_fieldName] . $delete
			);
		}
		
		public function getControl()
		{
			list($fieldName, $suffix) = $this->getFieldNameAndSuffix();
			
			$html = '';
			$value = $this->getValue();
			if (!empty($value)) {
				if (!empty($value[$fieldName . 'Thumb' . $suffix])) {
					$html = '<img src="' . scPaths::getStoreWebPath() . $value[$fieldName . 'Thumb' . $suffix] . '" alt="" />';
				}
				if (!empty($value[$fieldName . $suffix])) {
					$html = '<a href="' . scPaths::getStoreWebPath() . $value[$fieldName . $suffix] . '" target="_blank" class="product_variant_image">' .
						$html .
						'</a><br />';
				}
			}
			
			return array($this->_fieldName => $html);
		}
		
		public function getData()
		{
			$data = parent::getData();
			
			if (empty($data) && miHasParam('Delete' . $this->_fieldName) && (miGetParam('Delete' . $this->_fieldName) == 'delete')) {
				list($fieldName, $suffix) = $this->getFieldNameAndSuffix();
				$data = array(
					$fieldName . $suffix => '',
					$fieldName . 'Width' . $suffix => 0,
					$fieldName . 'Height' . $suffix => 0,
					$fieldName . 'Size' . $suffix => 0,
					$fieldName . 'Thumb' . $suffix => '',
					$fieldName . 'ThumbWidth' . $suffix => 0,
					$fieldName . 'ThumbHeight' . $suffix => 0,
					$fieldName . 'ThumbSize' . $suffix => 0,
				);
			}
			
			return $data;
		}
		
		public function validateData(miWebFormErrorsHandler &$errors)
		{
			$data = $this->getData();
			if (isset($data[$this->_fieldName]) && ($data[$this->_fieldName] instanceof scUploadedFile) && $data[$this->_fieldName]->hasErrors()) {
				$errors->addError($this->_fieldName, $data[$this->_fieldName]->getErrorMessage());
			}
		}
		
		protected function getValue()
		{
			list($fieldName, $suffix) = $this->getFieldNameAndSuffix();
			
			$fields = array(
				$fieldName . $suffix,
				$fieldName . 'Thumb' . $suffix,
			);
			
			$value = array();
			foreach ($fields as $field) {
				$value[$field] = $this->_webForm->getFormData($field);
			}
			
			return $value;
		}
		
		protected function getDefaultValue()
		{
			return scSkins::singleton()->getCurrentSkin()->getCurrentSkinUrl() . 'admin/images/image-not-available/image_not_available.jpg';
		}
		
		protected function getFieldNameAndSuffix()
		{
			$fieldNameWithSuffix = explode('::', $this->_fieldName);
			$fieldName = array_shift($fieldNameWithSuffix);
			$suffix = '::' . implode('::', $fieldNameWithSuffix);
			return array($fieldName, $suffix);
		}
	}
?>