<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scSkinSettingsWidget extends miBaseWidget {
		
		protected $_widgets = array();
		
		public function setWidgets(array $widgets)
		{
			$this->_widgets = $widgets;
		}
		
		public function getData()
		{
			$settings = $this->getSettingsFromRequest();
			
			$result = array();
			foreach ($settings as $settingName => $settingValue)
				$result[$settingName] = $settingValue;
			return array($this->_fieldName => $result);
		}
		
		public function getEditableControl()
		{
			// Set the data fields for setting widgets
			$options = $this->_webForm->getFormData($this->_fieldName);
			foreach ($options as $optionName => $optionValue)
				$this->_webForm->setFormData($optionName, $optionValue);
			
			return array($this->_fieldName => $this->getFieldsHtml());
		}
		
		protected function getFieldsHtml()
		{
			$html = '';
			foreach ($this->_widgets as $field) {
				$html .= $this->getFieldHtml($field);
			}
			return $html;
		}
		
		protected function getFieldHtml(miBaseWidget $optionField)
		{
			$properties = $optionField->getProperties();
			
			$controls = array();
			$displayName = isset($properties['displayName']) ? $properties['displayName'] : substr($optionField->getFieldName(), strlen(scModuleOptions::MODULE_OPTION_PREFIX));
			$controls['%%DISPLAYNAME%%'] = miI18N::htmlEscape($displayName);
			$controls['%%PREFIX%%'] = isset($properties['prefix']) ? miI18N::htmlEscape($properties['prefix']) : '';
			$controls['%%SUFFIX%%'] = isset($properties['suffix']) ? miI18N::htmlEscape($properties['suffix']) : '';
			$controls['%%DESCRIPTION%%'] = isset($properties['description']) ? miI18N::htmlEscape($properties['description']) : '';
			$controls['%%FIELDNAME%%'] = miI18N::htmlEscape($optionField->getFieldName());
			
			$fieldControls = $optionField->getEditableControl();
			if (count($fieldControls) > 1)
				throw new miException(_i('Too many control variables.'));
			$controls['%%HTML_CONTROL%%'] = current($fieldControls);
			
			$t = new scTemplateParser();
			$t->assignArray($controls);
			$t->readTemplate('admin/skin_settings/setting_field.tmpl');
			return $t->templateParse();
		}
		
		protected function getSettingsFromRequest()
		{
			$result = array();
			foreach ($this->_widgets as $widget) {
				$result = array_merge($result, $widget->getData());
			}
			return $result;
		}
	}
?>