<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scTableCheckboxWidget extends scTableWidget {
		
		protected function checkIsValidTable(miTable $table)
		{
			parent::checkIsValidTable($table);
			
			if (!($table instanceof IOptionsWidgetTable)) {
				throw new miException(_i('The table used by '. __CLASS__ .' needs to implement the IOptionsWidgetTable interface.'));
			}
		}
		
		protected function prepareTable()
		{
			parent::prepareTable();
			
			$this->setTableCheckedValues();
		}
		
		protected function setTableCheckedValues()
		{
			$data = $this->_webForm->getFormData($this->_fieldName);
			$this->_table->setCheckedValues($data);
		}
	}
	
	interface IOptionsWidgetTable {
		
		/**
		 * Every Table that implements this interface needs to know
		 * which options are checked. It's the table's resposibility
		 * to represent the "checked" options. The TableCheckboxWidget
		 * will only let it know which those are.
		 * @param array $checkedValues an array of checked options
		 */
		public function setCheckedValues($checkedValues);
	}
?>