<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scTableWidget extends miBaseWidget {
		
		/**
		 * @var miTable
		 */
		protected $_table;
		
		/**
		 * @param miTable $table
		 */
		public function setTable(miTable &$table)
		{
			$this->checkIsValidTable($table);
			$this->_table = &$table;
		}
		
		protected function checkIsValidTable(miTable $table)
		{
			/* Subclasses may validate the table they need */
		}
		
		/**
		 * @throws miException
		 */
		public function checkIsInitialized()
		{
			if (!isset($this->_table)) {
				throw new miException(_i('A miTable needs to be passed to the widget.'));
			}
			if (!isset($this->_properties['template'])) {
				throw new miException(_i('A template filename needs to be passed to the widget.'));
			}
		}
		
		/**
		 * @return array
		 */
		public function getEditableControl()
		{
			return array($this->_fieldName => $this->parseTemplate($this->_properties['template']));
		}
		
		/**
		 * @return array
		 */
		public function getData()
		{
			return array($this->_fieldName => miGetParamDefault($this->_fieldName, array()));
		}
		
		/**
		 * @return array
		 */
		public function getControl()
		{
			if (!isset($this->_properties['controlTemplate']) || empty($this->_properties['controlTemplate'])) {
				return $this->getEditableControl();
			}
			return array($this->_fieldName => $this->parseTemplate($this->_properties['controlTemplate']));
		}
		
		/**
		 * @param string $templateFileName
		 * @return string
		 */
		protected function parseTemplate($templateFileName)
		{
			$this->checkIsInitialized();
			$this->prepareTable();
			return $this->_table->parse($templateFileName);
		}
		
		protected function prepareTable()
		{
			$this->_table->addMainPageElements(array(
				'%%FIELDNAME%%' => $this->_fieldName,
			));
		}
	}
?>