<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scVatNumberWidget extends miBaseTextWidget {
		
		protected $_countryField = null;
		
		public function setCountryField($countryField)
		{
			$this->_countryField = $countryField;
		}
		
		public function validateData(miWebFormErrorsHandler &$errors)
		{
			parent::validateData($errors);
			
			if ($errors->hasFieldErrors($this->_fieldName)) {
				return;
			}
			
			$vatNumber = miGetParamDefault($this->_fieldName, '');
			if (empty($vatNumber))
				return;
			
			
			if (scVatNumbersUtil::isKnownFormat($vatNumber)) {
				if (!scVatNumbersUtil::isValidNumber($vatNumber)) {
					$errors->addError($this->_fieldName, _t('Invalid VAT number.'));
					return;
				}
			}
			
			if (!isset($this->_countryField) || empty($this->_countryField)) {
				return;
			}
			
			$country = miGetParamDefault($this->_countryField, 0);
			
			$countryCode = scCountry::getCountryCode2($country);
			
			$vatCountry = scVatNumbersUtil::getCountryFromNumber($vatNumber);
			
			if (scVatNumbersUtil::isCountryFormatKnown($countryCode) and ($countryCode != $vatCountry)) {
				$errors->addError($this->_fieldName, sprintf(_t('Country and VAT number country do not match. Your VAT number should start with %s.'), $countryCode));
			}
		}
	}
?>