<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * Select field
	 */
	class scWebFormFieldSelect extends miBaseSelectWidget {
		/**
		 * @access protected
		 */
		protected $_optionsGroup = array();
		
		/**
		 * @access public
		 */
		public function setOptionsGroup($optionsGroup)
		{
			$this->_optionsGroup = $optionsGroup;
		}
		
		/**
		 * Returns the field contents to be displayed
		 * 
		 * @return array
		 */
		public function getEditableControl()
		{
			$value = $this->getValue();
			
			$html = '';
			$openGroup = false;
			foreach ($this->_options as $key => $option) {
				if (isset($this->_optionsGroup[$key])) {
					if ($openGroup) $html .= '</optgroup>';
					$html .= '<optgroup label="' . $this->_optionsGroup[$key] . '">';
					$openGroup = true;
				}
				$html .= '<option value="' . miI18N::htmlEscape($key) . '"' . ($key == $value?' selected="selected"':'') . '>' . miI18N::htmlEscape($option) . '</option>';
			}
			if ($openGroup) $html .= '</optgroup>';
			
			return array($this->_fieldName => $html);
		}
	}
?>