<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scCheckoutWizardDispatcher extends miWizardDispatcher {
		
		/**
		 * Wizard processing
		 */
		public function processWizardAction()
		{
			$this->findCurrentAndNextPages();
			
			$auth = scCustomerAuth::singleton();
			// prevent using wizard from non-logged-in users
			if (($this->getCurrentPage() != 1) && (count($this->getWizardPage(1)->getPageData()) == 0)) {
				miSetParam(miWizardDispatcher::WIZARD_CURRENT_PAGE_PARAM, 1);
				miSetParam(miWizardDispatcher::WIZARD_ACTION_PARAM, '');
				miSetParam('action', '');
				$this->_wizardAction = '';
			}
			
			// prevent login page for logged-in users
			if (($this->getCurrentPage() == 1) and $auth->isLoggedIn()) {
				miSetParam(miWizardDispatcher::WIZARD_CURRENT_PAGE_PARAM, 2);
				// set Page Data
				$customer = $auth->getCustomer();
				$data = array(
							'CustomerEmail' => $customer->get('CustomerEmail'),
							'CustomerPassword' => $customer->get('CustomerPassword'),
							'WizardAuth' => scWizardCheckout::WIZARD_AUTH_METHOD_LOGIN
							);
				$this->getWizardPage(1)->savePageData($data);
				
				// Set the address fields
				$data = $this->getWizardPage(2)->getPageData();
				if (!isset($data['CustomerBillingFirstName'])) {
					$customerAddresses = $customer->getAddresses();
					$address = $customer->getBillingAddress();
					$mapping = scCustomerAddress::getAddressFields(scCustomerAddress::BILLING);
					foreach ($mapping as $wizardField => $addressField) {
						$data[$wizardField] = '';
						if (isset($address[$addressField])) {
							$data[$wizardField] = $address[$addressField];
						}
					}
					$address = $customer->getShippingAddress();
					$mapping = scCustomerAddress::getAddressFields(scCustomerAddress::SHIPPING);
					foreach ($mapping as $wizardField => $addressField) {
						$data[$wizardField] = '';
						if (isset($address[$addressField])) {
							$data[$wizardField] = $address[$addressField];
						}
					}
					$data['CustomerShipToBillingAddress'] = ($customer->getBillingAddressId() == $customer->getShippingAddressId() ? 1 : 0);
					$this->getWizardPage(2)->savePageData($data);
				}
			}
			parent::processWizardAction();
		}
	}

	class scCheckoutWizardController extends miWizardController {
		protected $_dispatcher;
		
		public function __construct()
		{
			parent::__construct();
			
			$this->_dispatcher = new scCheckoutWizardDispatcher($this);
		}
		
		public function getDispatcher()
		{
			return $this->_dispatcher;
		}
	}
?>