<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scCheckoutWizardPage extends miWizardPage {
		
		public function __construct(miSqlRecordset $recordset = null)
		{
			$this->_persistVars[] = 'ModuleName';
			parent::__construct($recordset);			
		}
		
		public function preProcess($action)
		{
			parent::preProcess($action);
			
			if (scCart::getCart()->getItemsCount() == 0) {
				throw new miException(_t('Cart must contain at least one item.'));
			}
		}
	
		public function postProcess($actionObj, $actionResult)
		{
			parent::postProcess($actionObj, $actionResult);
			
			if (!$actionObj instanceof miExecWizardPageAction)
				return;
			
			// Keep the cart updated
			$cart = scCart::getCart();
			$pageData = $cart->getCustomerInfo();
			$pageData = array_merge($pageData, $this->getPageData());
			$cart->setCustomerInfo($pageData);
		}
		
		/**
		 * There is no list in the wizard checkout process. This is an exception
		 */
		public function addRedirectToListControllerCommand($msg, $msgType = miMessage::MSG_TYPE_ERROR)
		{
			$exception = new miException($msg);
			scPaymentProcess::handlePaymentProcessException($exception, scPaymentProcess::CALL_TYPE_DIRECT);
			exit;
		}
		
		public function setDomainObject(miDomainObject $domainObject)
		{
			$this->_domainObject = $domainObject;
		}
	}
?>