<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('include/miphpf/Init.php');
	require_once('include/sc/Init.php');
	
	scSession::singleton()->openSession();
	
	class scUserPageHome extends scView {
		public function __construct()
		{
			parent::__construct(null);
		}
	}
	
	class scHomePageAction extends miAction {
		public function doAction()
		{
			$parser = new scTemplateParser();
			
			// Get the featured products section
			$featuredProducts = $this->getHomeFeaturedProducts();
			if (scSettings::getSettingValue(scSettings::SETTING_HOMEPAGE_VIEW_TYPE) == scProductService::VIEW_GRID) {
				$productsSection = scProductService::getProductSections('products', $featuredProducts, scProductService::VIEW_GRID);
				$parser->readTemplate('customer/index_grid.tmpl');
			} else {
				$productsSection = scProductService::getProductSections('products', $featuredProducts, scProductService::VIEW_LIST);
				$parser->readTemplate('customer/index.tmpl');
			}
			
			$parser->addSectionInfo($productsSection);
			
			// Assign dynamic page areas values
			$parser->assignArray(scDynamicPages::getTemplateVars('index.php'));
			
			// Parse the template and pass it to the view
			$html = $parser->templateParse();
			$this->_view->addControllerCommand(new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_HTML, $html));
			
			return true;
		}

		protected function getHomeFeaturedProducts()
		{
			$hideOutOfStockSql = scProductService::hideOutOfStock() ? 'AND ProductQuantity > 0 ' : '';
			$variantSql = 'LEFT JOIN ProductVariants ON (ProductVariants.ProductID = Products.ProductID AND ProductVariantIsDefault<>0) ';
			
			$sql = 	'SELECT *, Products.ProductID as ProductID FROM FeaturedProducts ' . 
					'INNER JOIN Products USING(ProductID) ' .
					'LEFT JOIN ProductsML USING(ProductID) ' .
					'LEFT JOIN ProductImages ON(Products.ProductID = ProductImages.ProductID AND ProductImageIsDefault<>0) ' .
					$variantSql .
					'WHERE LanguageID = ? AND FeaturedProductOnHome <> 0 AND ProductIsActive <> 0 ' . $hideOutOfStockSql .
					'ORDER BY FeaturedProductSort';
					
			return miStaticDBUtil::execSelect($sql, array(scMultiLanguage::getCurrentLanguageId()));
		}
	}
	
	$page = new scUserDisplayController(new scUserPageHome());
	$page->setSeo(new scDynamicPageSeo('index.php', _t('Home')));
	
	$page->getDispatcher()->clearActionHandlers();
	$page->getDispatcher()->setActionHandler('', 'scHomePageAction');
	
	$page->dispatchAndShow();
?>