<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('include/miphpf/Init.php');
	require_once('include/sc/Init.php');

	scSession::singleton()->openSession();
	
	class scUserModuleController extends scUserDisplayController {
	
		public function __construct()
		{
			try {
				$module = scUserModuleManager::getModule(miGetParam('ModuleName'));
			} catch (miException $exception) {
				if (miHasParam('ModuleName')) {
					$msg = _t('Module not found: ') . miGetParam('ModuleName');
				} else {
					$msg = sprintf(miI18N::getSystemMessage('MI_EXPECTED_PARAM_ERROR_MSG'), 'ModuleName');
				}
				$url = scPaths::getStoreWebPath() . 'error.php?msg=' . urlencode($msg);
				$this->processControllerCommands(array(new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_REDIRECT, $url)));
				exit;
			}
			
			parent::__construct($module->getView());
			$module->initActionHandlers($this);
		}
	}
	
	$page = new scUserModuleController();
	$page->dispatchAndShow();
?>