<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * Google Checkout module button
	 */
	class scPaymentModuleGoogleCheckoutButton implements ICheckoutModuleButton {
		protected $_moduleId;
		
		/**
		 * Checkout module constructor
		 */
		public function __construct($moduleId)
		{
			$this->_moduleId = $moduleId;
		}
		
		/**
		 * Returns HTML for rendering the checkout button
		 */
		public function getButtonHtml($moduleName, $checkoutModuleName, $displayName)
		{
			try {
				$options = scModuleOptions::getModuleOptions($this->_moduleId, array('MerchantID'));
			
				$merchantId = $options['MerchantID'];
				$langCode = scMultiLanguage::getCurrentLanguageCode();
				
				$t = new scTemplateParser;
				$t->readTemplate('modules/checkout/google/button.tmpl');
				$t->assign('%%MODULENAME%%', miI18N::htmlEscape($moduleName));
				$t->assign('%%MERCHANTID%%', miI18N::htmlEscape($merchantId));
				$t->assign('%%LOCALE%%', miI18N::htmlEscape($this->getLocale()));
				$t->assign('%%SCHEME%%', scPaths::isCurrentPageSsl() ? 'https' : 'http');
				$t->assign('%%CHECKOUTMODULEDISPLAYNAME%%', miI18N::htmlEscape($displayName));
				return $t->templateParse();
			} catch (miException $exception) {
				// Ignore exception, but don't display button
				return '';
			}
		}
		
		protected function getLocale()
		{
			$customerInfo = scCart::getCart()->getCustomerInfo();
			$countryCode = strtoupper(scCountry::getCountryCode2($customerInfo['CustomerBillingCountry']));
			return ($countryCode == 'GB') ? 'en_GB' : 'en_US';
		}
	}
?>