<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scCp1251 {
		
		/**
		 * Convert the cyrillic letters from utf8 to cp1251
		 * converts correctly only characters to 192 to 255 in cp1251
		 */
		public static function utf8ToCp1251($s)
		{
			$out = '';
			
			$len = strlen($s);
			for ($i = 0; $i < $len; $i++)
			{
				$c = ord($s[$i]);
				if ($c < 128) {
					$out .= $s[$i];
					continue;
				}
					
				if ((($c >> 5) == 6) and (($i+1) < $len)) {	// 2-byte character
					$c2 = ord($s[$i+1]);
					$byte1 = ($c & 3) * 64 + ($c2 & 63);
					$byte2 = ($c >> 2) & 5;
					$utf8Code = $byte2 * 256 + $byte1;
					if ($utf8Code == 1025) {	// capital e oborotnaia
						$out_i = 168;
					} elseif ($utf8Code == 1105) {	// small e oborotnaia
						$out_i = 184;
					} else {
						$out_i = $utf8Code - 848;
					}
					$out .= chr($out_i);
				}
			}
			
			return $out;
		}
	}
?>