<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('../../../include/miphpf/Init.php');
	require_once('../../../include/sc/Init.php');
	
	/**
	 * Sage Pay VPS Server return script
	 */
	$result = scPaymentProcess::callPaymentModule('com.summercart.payment.sagepay.vsp_server', 'processNotify', scPaymentProcess::CALL_TYPE_NOTIFY);
	if ($result === true) {
		$status = 'OK';
		$statusDetail = '';
	} else {
		$status = 'ERROR';
		$exception = scPaymentProcess::getPaymentProcessException();
		$statusDetail = ($exception instanceof Exception) ? $exception->getMessage() : '';
	}
	
	list($orderId, $transactionId) = explode('-', miGetParamDefault('VendorTxCode', '-'));
	
	$queryParams = array('OrderID' => $orderId);
	$callPaymentModuleResult = scPaymentProcess::getPaymentModuleResult();
	if ($callPaymentModuleResult != null) {
		$queryParams['PaymentStatus'] = $callPaymentModuleResult->getPaymentStatus();
		$queryParams['PaymentNotes'] = $callPaymentModuleResult->getPaymentNotes();
	} else {
		$queryParams['PaymentStatus'] = scPaymentStatus::PAYMENT_STATUS_DECLINED;
		$queryParams['PaymentNotes'] = $statusDetail;
	}
	
	$redirectUrl = scPaths::getSecureUrl('modules/payment/sagepay/vsp_server_return.php?' . http_build_query($queryParams));
	
	echo 'Status=' . $status . "\r\n";
	echo 'RedirectURL=' . $redirectUrl . "\r\n";
	echo 'StatusDetail=' . $statusDetail . "\r\n";
?>