<?php
	/**
	 * Copyright (c) 2011 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scPaymentModuleTurkishBanksGarantiModuleOptionsRecord extends scPaymentModuleTurkishBanksModuleOptionsRecord {
		protected $_optionNames = array('OrderDescription', 'ProvisionUserID', 'ProvisionPassword', 'UserID', 'TerminalID', 'MerchantID', 'Mode', '3DSecureMode', '3DSecurePassword', 'Active');
	}
	
	class scPaymentModuleTurkishBanksGarantiSetupView extends scPaymentModuleTurkishBanksSetupView {
		
		protected $_templates = array(
			self::TEMPLATE_ID_EDIT => 'modules/payment/turkish_banks/garanti_bank_edit.tmpl',
		);
		
		protected $_dataFields = array(
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderDescription',
       		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'ProvisionUserID',
				'properties' => array('maxLength' => 32),
       		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'ProvisionPassword',
       		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'UserID',
				'properties' => array('maxLength' => 32),
       		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'TerminalID',
				'properties' => array('maxLength' => 9),
       			'validator' => array('miValidatorInt')
       		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'MerchantID',
				'properties' => array('maxLength' => 9),
       			'validator' => array('miValidatorInt')
       		),
			array(
				'field' => 'miRadioWidget',
				'data' => 'Mode',
			),
			array(
				'field' => 'miSelectWidget',
				'data' => '3DSecureMode',
			),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => '3DSecurePassword',
       		),
			array(
				'field' => 'miCheckboxWidget',
				'data' => 'Active',
			),
			array(
				'field' => 'scPaymentModuleTurkishBanksInstallmentsWidget',
				'data' => 'RSOptions',
				'modelStrategy' => 'scPaymentModuleTurkishBanksInstallmentsViewMapper',
				'properties' => array(
					'template' => 'modules/payment/turkish_banks/installments_rs.tmpl',
       				
					'fields' => array( 
			       		array(
							'field' => 'miBaseTextWidget',
							'data' => 'InstallmentNumberOfPayments',
		        		),
			       		array(
							'field' => 'miBaseTextWidget',
							'data' => 'InstallmentInterestRate',
		        		),
		        	),	
				),
        	),
		);
		
		public function initWebForm(&$form)
		{
			parent::initWebForm($form);
			
			$form->getWidget('3DSecureMode')->setOptions(array(
				'3D_PAY' => _t('3D Pay'),
				'3D_FULL' => _t('3D Full'),
				'3D_HALF' => _t('3D Half'),
			), '3D_PAY');
		}
	}
?>