<?php
	/**
	 * Copyright (c) 2011 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scPaymentModuleTurkishBanksPosnetModuleOptionsRecord extends scPaymentModuleTurkishBanksModuleOptionsRecord {
		protected $_optionNames = array('MerchantID', 'TerminalID', 'PosnetID', 'LanguageCode', 'ForwardSaleCode', 'EncryptionKey', '3dSecureCheckMask', 'Mode', 'TransactionType', 'ApiUsername', 'ApiPassword', 'Active');
	}
	
	class scPaymentModuleTurkishBanksPosnetSetupView extends scPaymentModuleTurkishBanksSetupView {
		
		protected $_templates = array(
			self::TEMPLATE_ID_EDIT => 'modules/payment/turkish_banks/posnet_bank_edit.tmpl',
		);
		
		protected $_dataFields = array(
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'MerchantID',
				'properties' => array('minLength' => 10, 'maxLength' => 10),
       			'validator' => array('miValidatorInt')
       		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'TerminalID',
				'properties' => array('minLength' => 8, 'maxLength' => 8),
       			'validator' => array('miValidatorInt')
       		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'PosnetID',
       			'validator' => array('miValidatorInt')
       		),
       		array(
				'field' => 'miSelectWidget',
				'data' => 'LanguageCode',
       		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'ForwardSaleCode',
       		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'EncryptionKey',
       		),
       		array(
				'field' => 'sc3dSecureCheckMaskWidget',
				'data' => '3dSecureCheckMask',
				'modelStrategy' => 'scViewMapper3dSecureCheckMask',
       		),
			array(
				'field' => 'miRadioWidget',
				'data' => 'Mode',
			),
			array(
				'field' => 'miSelectWidget',
				'data' => 'TransactionType',
			),
			array(
				'field' => 'miTextWidget',
				'data' => 'ApiUsername',
			),
			array(
				'field' => 'miTextWidget',
				'data' => 'ApiPassword',
			),
			array(
				'field' => 'miCheckboxWidget',
				'data' => 'Active',
			),
			array(
				'field' => 'scPaymentModuleTurkishBanksInstallmentsWidget',
				'data' => 'RSOptions',
				'modelStrategy' => 'scPaymentModuleTurkishBanksInstallmentsViewMapper',
				'properties' => array(
					'template' => 'modules/payment/turkish_banks/installments_rs.tmpl',
       				
					'fields' => array( 
			       		array(
							'field' => 'miBaseTextWidget',
							'data' => 'InstallmentNumberOfPayments',
		        		),
			       		array(
							'field' => 'miBaseTextWidget',
							'data' => 'InstallmentInterestRate',
		        		),
		        	),	
				),
        	),
		);
		
		public function initWebForm(&$form)
		{
			parent::initWebForm($form);
			
			$form->getWidget('LanguageCode')->setOptions(array(
				'en' => _i('English'), 
				'tr' => _i('Türkçe'),
			));
			
			$form->getWidget('TransactionType')->setOptions(array(
				'Auth' => _t('Authorize'),
				'Sale' => _t('Sale'),
				'SaleWP' => _t('Use Worldcard Points and Sale'),
				'Vft' => _t('Forward Sale Transaction')
			), 'Auth');
			
			$form->getWidget('3dSecureCheckMask')->setRadioButtons(array(
				0 => _t('Disapproved'),
				1 => _t('Approved') . ' (' . _t('recommended') . ')',
				2 => _t('Not a member of the bank or the cardholder Card 3D-Secure') . ' (' . _t('recommended') . ')',
				3 => _t('Card prefix is not defined in the 3D-Secure system'),
				4 => _t('Authentication Attempt') . ' (' . _t('recommended') . ')',
				5 => _t('The system is not accessible'),
				6 => _t('3D-Secure Error'),
				7 => _t('System Error'),
				8 => _t('Invalid Card'),
				9 => _t('3D-Secure system is not available for the merchant account'),
			), null);
		}
	}
	
	class sc3dSecureCheckMaskWidget extends scMultipleCheckboxesWidget {
		
		/**
		 * @return array
		 */
		public function getEditableControl()
		{
			$value = $this->getValue();
			$widget = '';
			foreach ($this->_radioButtons as $key => $option) {
				$checked = (in_array($key, $value)) ? ' checked="checked"' : '';
				$widget .= '<label><input type="checkbox" name="' . $this->_fieldName . '[]" value="' . $key . '"' . $checked . '/> <span>' . miI18N::htmlEscape($option) . '</span></label><br />';
			}
			return array($this->_fieldName => $widget);
		}
	}
	
	class scViewMapper3dSecureCheckMask extends miViewMapper {
		
		protected $_delimiter = ',';
		protected $_value;
		
		public function get($fieldName)
		{
			return $this->_value;
		}
		
		public function set($fieldName, $fieldValue)
		{
			$this->_value = $fieldValue;
			if (!empty($fieldValue)) {
				$this->_value = implode($this->_delimiter, $fieldValue);
			}
			$this->getViewMapperController()->getDomainObject()->set('3dSecureCheckMask', $this->_value);
		}
		
		public function read()
		{
			$value = $this->getViewMapperController()->getDomainObject()->get('3dSecureCheckMask');
			if (empty($value)) {
				$this->_value = array();
				return;
			}
			
			$this->_value = explode($this->_delimiter, $value);
		}
	}
?>