<?php
	/**
	 * Copyright (c) 2011 Mirchev Ideas Ltd. All rights reserved.
	 * FIXME: HSBC, Kuveyt Türk
	 */
	
	class scPaymentModuleTurkishBanksBase {
		const MODE_TEST = 'Test';
		const MODE_LIVE = 'Live';
		
		const BANK_CODE_OTHER = 'Other'; // to be used in Other Card Issuer
		
		const BANK_CODE_AKBANK = 'Akbank';
		const BANK_CODE_ANADOLUBANK = 'Anadolubank';
		const BANK_CODE_DENIZBANK = 'Denizbank';
		const BANK_CODE_FINANSBANK = 'Finansbank';
		const BANK_CODE_FORTIS = 'Fortis';
		const BANK_CODE_GARANTI = 'Garanti';
		const BANK_CODE_HALKBANK = 'Halkbank';
//		const BANK_CODE_HSBC = 'HSBC';
		const BANK_CODE_ISBANK = 'Isbank';
		const BANK_CODE_TEB = 'TEB';
		const BANK_CODE_YKB = 'YKB';
		
		protected static $_banksInfo = array(
			self::BANK_CODE_AKBANK => array(
				'name' => 'Akbank',
				'logo' => 'akbank.png',
				'3dGateUrl' => 'https://www.sanalakpos.com/servlet/est3Dgate',
				'3dGateTestUrl' => 'https://testvpos.est.com.tr/servlet/est3Dgate',
				'apiUrl' => 'https://www.sanalakpos.com/servlet/cc5ApiServer',
				'apiTestUrl' => 'https://testvpos.est.com.tr/servlet/cc5ApiServer',
			),
			self::BANK_CODE_ANADOLUBANK => array(
				'name' => 'Anadolubank',
				'logo' => 'anadolubank.png',
				'3dGateUrl' => 'https://vpos.est.com.tr/servlet/est3Dgate',
				'3dGateTestUrl' => 'https://testvpos.est.com.tr/servlet/est3Dgate',
				'apiUrl' => 'https://vpos.est.com.tr/servlet/cc5ApiServer',
				'apiTestUrl' => 'https://testvpos.est.com.tr/servlet/cc5ApiServer',
			),
			self::BANK_CODE_DENIZBANK => array(
				'name' => 'DenizBank',
				'logo' => 'denizbank.png',
				'3dGateUrl' => 'https://sanalpos.denizbank.com.tr/servlet/est3Dgate',
				'3dGateTestUrl' => 'https://testvpos.est.com.tr/servlet/est3Dgate',
				'apiUrl' => 'https://sanalpos.denizbank.com.tr/servlet/cc5ApiServer',
				'apiTestUrl' => 'https://testvpos.est.com.tr/servlet/cc5ApiServer',
			),
			self::BANK_CODE_FINANSBANK => array(
				'name' => 'Finansbank',
				'logo' => 'finansbank.png',
				'3dGateUrl' => 'https://www.fbwebpos.com/servlet/est3Dgate',
				'3dGateTestUrl' => 'https://testvpos.est.com.tr/servlet/est3Dgate',
				'apiUrl' => 'https://www.fbwebpos.com/servlet/cc5ApiServer',
				'apiTestUrl' => 'https://testvpos.est.com.tr/servlet/cc5ApiServer',
			),
			self::BANK_CODE_FORTIS => array(
				'name' => 'Fortis',
				'logo' => 'fortis.png',
				'3dGateUrl' => 'https://vpos.est.com.tr/servlet/est3Dgate',
				'3dGateTestUrl' => 'https://testvpos.est.com.tr/servlet/est3Dgate',
				'apiUrl' => 'https://vpos.est.com.tr/servlet/cc5ApiServer',
				'apiTestUrl' => 'https://testvpos.est.com.tr/servlet/cc5ApiServer',
			),
			self::BANK_CODE_GARANTI => array(
				'name' => 'Garanti Bankası',
				'logo' => 'garanti.png',
				'3dGateUrl' => 'https://sanalposprov.garanti.com.tr/servlet/gt3dengine',
				'3dGateTestUrl' => 'http://sanalposprovtest.garanti.com.tr/servlet/gt3dengine',
				'apiUrl' => '',
				'apiTestUrl' => '',
			),
			self::BANK_CODE_HALKBANK => array(
				'name' => 'Halkbank',
				'logo' => 'halkbank.png',
				'3dGateUrl' => 'https://vpos.est.com.tr/servlet/est3Dgate',
				'3dGateTestUrl' => 'https://testvpos.est.com.tr/servlet/est3Dgate',
				'apiUrl' => 'https://vpos.est.com.tr/servlet/cc5ApiServer',
				'apiTestUrl' => 'https://testvpos.est.com.tr/servlet/cc5ApiServer',
			),
/*			self::BANK_CODE_HSBC => array(
				'name' => 'HSBC',
				'logo' => '',
				'3dGateUrl' => 'https://vpos.advantage.com.tr/servlet/cardgate',
				'3dGateTestUrl' => 'https://vpostest.advantage.com.tr/servlet/cardgate',
				'apiUrl' => 'https://vpos.est.com.tr/servlet/cc5ApiServer',
				'apiTestUrl' => 'https://testvpos.est.com.tr/servlet/cc5ApiServer',
			),*/
			self::BANK_CODE_ISBANK => array(
				'name' => 'İş Bankası',
				'logo' => 'isbank.png',
				'3dGateUrl' => 'https://spos.isbank.com.tr/servlet/est3Dgate',
				'3dGateTestUrl' => 'https://testvpos.est.com.tr/servlet/est3Dgate',
				'apiUrl' => 'https://spos.isbank.com.tr/servlet/cc5ApiServer',
				'apiTestUrl' => 'https://testvpos.est.com.tr/servlet/cc5ApiServer',
			),
			self::BANK_CODE_TEB => array(
				'name' => 'TEB',
				'logo' => 'teb.png',
				'3dGateUrl' => 'https://sanalpos.teb.com.tr/servlet/est3Dgate',
				'3dGateTestUrl' => 'https://testvpos.est.com.tr/servlet/est3Dgate',
				'apiUrl' => 'https://www.sanalakpos.com/servlet/cc5ApiServer',
				'apiTestUrl' => 'https://testvpos.est.com.tr/servlet/cc5ApiServer',
			),
			self::BANK_CODE_YKB => array(
				'name' => 'Yapı Kredi Bankası',
				'logo' => 'ykb.png',
				'3dGateUrl' => 'https://www.posnet.ykb.com/3DSWebService/YKBPaymentService',
				'3dGateTestUrl' => 'http://setmpos.ykb.com/3DSWebService/YKBPaymentService',
				'apiUrl' => 'https://www.posnet.ykb.com/PosnetWebService/XML',
				'apiTestUrl' => 'http://setmpos.ykb.com/PosnetWebService/XML',
			),
		);
		
		protected $_currencyCodesToIso4217Numbers = array(
			'TRY' => '949',
			'USD' => '840',
			'EUR' => '978',
		);
		
		public static $_banksEst3d = array(
			self::BANK_CODE_AKBANK,
			self::BANK_CODE_ANADOLUBANK,
			self::BANK_CODE_DENIZBANK,
			self::BANK_CODE_FINANSBANK,
			self::BANK_CODE_FORTIS,
			self::BANK_CODE_HALKBANK,
			self::BANK_CODE_ISBANK,
			self::BANK_CODE_TEB,
		);
		
		public static $_banksPosnet = array(
			self::BANK_CODE_YKB
		);
		
		protected $_moduleId;
		
		public function __construct($moduleId)
		{
			$this->_moduleId = $moduleId;
		}
		
		/**
		 * Return the url to the bank 3d gateway
		 * @param string $bankCode
		 * @param string $mode
		 * @return string url
		 */
		protected static function getBank3dGateUrl($bankCode, $mode)
		{
			if (!isset(self::$_banksInfo[$bankCode]))
				throw new scPaymentProcessException(sprintf(_i('Unknown bank "%s".'), $bankCode));
			
			$url = ($mode == self::MODE_LIVE) ? self::$_banksInfo[$bankCode]['3dGateUrl'] : self::$_banksInfo[$bankCode]['3dGateTestUrl'];
			if ($url == '')
				throw new scPaymentProcessException(sprintf(_i('Bank "%s" does not support mode "%s".'), $bankCode, $mode));
			return $url;
		}
		
		/**
		 * Return the url to the bank api service
		 * @param string $bankCode
		 * @param string $mode
		 * @return string url
		 */
		protected static function getBankApiUrl($bankCode, $mode)
		{
			if (!isset(self::$_banksInfo[$bankCode]))
				throw new scPaymentProcessException(sprintf(_i('Unknown bank %s.'), $bankCode));
			
			$url = ($mode == self::MODE_LIVE) ? self::$_banksInfo[$bankCode]['apiUrl'] : self::$_banksInfo[$bankCode]['apiTestUrl'];
			if ($url == '')
				throw new scPaymentProcessException(sprintf(_i('Bank "%s" does not support mode "%s".'), $bankCode, $mode));
			return $url;
		}
		
		/**
		 * Return all bank names
		 * @return array(BankCode => BankName)
		 */
		public static function getBankNames()
		{
			$bankNames = array();
			foreach (self::$_banksInfo as $bankCode => $bankInfo)
				$bankNames[$bankCode] = $bankInfo['name'];
			return $bankNames;
		}
		
		public function getActiveBankNames()
		{
			$options = scModuleOptions::getModuleOptions($this->_moduleId);
			
			$bankNames = array();
			foreach (self::$_banksInfo as $bankCode => $bankInfo)
				if ((isset($options[$bankCode . '_Active']) and $options[$bankCode . '_Active']))
					$bankNames[$bankCode] = $bankInfo['name'];
			return $bankNames;
		}
		
		/**
		 * Return all banks info
		 * @return array
		 */
		public static function getBanksInfo()
		{
			return self::$_banksInfo;
		}
		
		/**
		 * Return the payment currency
		 */
		public function getPaymentCurrencyCode()
		{
			return 'TRY';
		}
		
		protected function getIso4217NumCurrencyCode($currencyCode)
		{
			if (!isset($this->_currencyCodesToIso4217Numbers[$currencyCode])) {
				throw new scPaymentProcessException(sprintf(_i('Unknown currency code "%s".'), $currencyCode));
			}
			return $this->_currencyCodesToIso4217Numbers[$currencyCode];
		}
		
		protected function getCurrencyCodeFromIso4217Num($iso4217Num)
		{
			$currencyCode = array_search($iso4217Num, $this->_currencyCodesToIso4217Numbers);
			if ($currencyCode === false) {
				throw new scPaymentProcessException(sprintf(_i('Unknown ISO 4217 number "%s".'), $iso4217Num));
			}
			return $currencyCode;
		}
		
		protected function getStandardParams($customerInfo, $clientId, $transactionType, $payAmount, $payCurrencyCode)
		{
			$isoLangCode = strtolower(scMultiLanguage::getCurrentLanguageCode());
			$lang = ($isoLangCode == 'tr') ? 'tr' : 'en';
			
			$params = array(
				'clientid' => $clientId,
				'oid' => scOrdersInProgress::singleton()->getLastOrderId(),
				'amount' => $payAmount,
				'CurrencyCode' => $payCurrencyCode,
				'rnd' => microtime(true),
				'islemtipi' => $transactionType,
				'taksit' => '',
				
				'lang' => $lang,
				'email' => $customerInfo['CustomerEmail'],
				
				// Billing
				'BillingCompany' => $customerInfo['CustomerBillingCompany'],
				'BillingName'  => $customerInfo['CustomerBillingFirstName'] . ' ' . $customerInfo['CustomerBillingLastName'],
				'BillingAddress' => $customerInfo['CustomerBillingAddress1'],
				'BillingAddress2' => $customerInfo['CustomerBillingAddress2'],
				'BillingState' => scCountry::getStateCode($customerInfo['CustomerBillingState']),
				'BillingCity' => $customerInfo['CustomerBillingCity'],
				'BillingPostcode' => $customerInfo['CustomerBillingZip'],
				'BillingPhone' => $customerInfo['CustomerBillingPhone'],
				'BillingFax' => $customerInfo['CustomerBillingFax'],
				'BillingCountry' => scCountry::getCountryCode2($customerInfo['CustomerBillingCountry']),
				
				'ShippingCompany' => $customerInfo['CustomerShippingCompany'],
				'ShippingName'  => $customerInfo['CustomerShippingFirstName'] . ' ' . $customerInfo['CustomerShippingLastName'],
				'ShippingAddress' => $customerInfo['CustomerShippingAddress1'],
				'ShippingAddress2' => $customerInfo['CustomerShippingAddress2'],
				'ShippingState' => scCountry::getStateCode($customerInfo['CustomerShippingState']),
				'ShippingCity' => $customerInfo['CustomerShippingCity'],
				'ShippingPostcode' => $customerInfo['CustomerShippingZip'],
				'ShippingPhone' => $customerInfo['CustomerShippingPhone'],
				'ShippingFax' => $customerInfo['CustomerShippingFax'],
				'ShippingCountry' => scCountry::getCountryCode2($customerInfo['CustomerShippingCountry']),

//				'Faturafirma' => $customerInfo['CustomerBillingCompany'],
//				'Fismi'  => $customerInfo['CustomerBillingFirstName'] . ' ' . $customerInfo['CustomerBillingLastName'],
//				'Fadres' => $customerInfo['CustomerBillingAddress1'],
//				'Fadres2' => $customerInfo['CustomerBillingAddress2'],
//				'Fil' => scCountry::getStateCode($customerInfo['CustomerBillingState']),
//				'Filce' => $customerInfo['CustomerBillingCity'],
//				'Fpostakodu' => $customerInfo['CustomerBillingZip'],
//				'tel' => $customerInfo['CustomerBillingPhone'],
//				'Fulkekod' => '792', // FIXME
//				
//				// Shipping
//				'NakliyeFirma' => $customerInfo['CustomerShippingCompany'],
//				'tismi'  => $customerInfo['CustomerShippingFirstName'] . ' ' . $customerInfo['CustomerShippingLastName'],
//				'tadres1' => $customerInfo['CustomerShippingAddress1'],
//				'tadres2' => $customerInfo['CustomerShippingAddress2'],
//				'til' => scCountry::getStateCode($customerInfo['CustomerShippingState']),
//				'tilce' => $customerInfo['CustomerShippingCity'],
//				'tpostakodu' => $customerInfo['CustomerShippingZip'],
//				'tulkekod' => '792', // FIXME
			);
			
			// Pass the userid only if the user is not the guest user
			if ($customerInfo['CustomerID'] != ICheckoutModule::GUEST_USER_ID)
				$params['userid'] = $customerInfo['CustomerID'];
			return $params;
		}
		
		
		/**
		 * Calculates the hash
		 * @param array $params
		 * @param string $storeKey
		 * @return string
		 */
		protected function calcHash($params, $storeKey)
		{
			$hashString = $params['clientid'] . $params['oid'] . $params['amount'] . $params['okUrl'] . $params['failUrl'] .
				$params['islemtipi'] . $params['taksit'] . $params['rnd'] . $storeKey;
			return base64_encode(pack('H*', sha1($hashString)));
		}
		
		/**
		 * Returns true if the hash is correct
		 * @param array $params
		 * @param string $storeKey
		 * @return bool
		 */
		protected function verifyHash($params, $storeKey)
		{
			$hashParamNames = explode(':', $params['HASHPARAMS']);
			
			$values = '';
			foreach ($hashParamNames as $hashParamName) {
				if (($hashParamName != '') and isset($params[$hashParamName]))
					$values .= $params[$hashParamName];
			}
			
			if ($values != $params['HASHPARAMSVAL'])
				return false;
			
			$hash = base64_encode(pack('H*', sha1($values . $storeKey)));
			return $hash == $params['HASH'];
		}
	}
?>