<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */	
	class scCanadaPostReturnCodes {
		const OK = 1 ;
		const DEFAULT_VALUES = 2 ;
		
		//API's specific: COM/ASP, Perl and Java Version  ;
		const MISSING_ARGUMENT = -2 ;
		const NO_ITEM_TO_SHIP = -5 ;
		const ILLEGAL_ITEM_WEIGHT = -6 ;
		const ILLEGAL_ITEM_DIMENSION = -7 ;
		const UNABLE_TO_OPEN_CONFIGURATION_FILE = -12 ;
		const UNABLE_TO_OPEN_LOG_FILE = -13 ;
		const CONFIGURATION_FILE_FORMAT_PROBLEM = -15 ;
		const INVALID_SOCKET_CONNECTION = -102 ;
		const UNABLE_TO_CONNECT_TO_SERVER = -106 ;
		
		//Server specific (A)  ;
		const UNKNOWN_REQUEST = -1000 ;
		const Sell_Online_EXCEPTION = -1001 ;
		const TIMEOUT_ERROR = -1002 ;
		const COMMUNICATION_ERROR = -1004 ;
		const INVALID_DATA_RECEIVED = -1005 ;
		
		//Server specific (B)  ;
		const UNABLE_TO_CONTACT_RSSS = -2000 ;
		const MERCHANT_INFO_NOT_FOUND = -2001 ;
		const PARAMETER_MISSING_IN_REQUEST = -2002 ;
		const INVALID_SHIPPERID_RECEIVED = -2003 ;
		const TOO_MANY_ITEMS = -2004 ;
		const REQUEST_TOO_BIG = -2005 ;
		
		//Server specific (C) CPC Rating Engine  ;
		const ILLEGAL_ORIGINATION = -3000 ;
		const ILLEGAL_DESTINATION = -3001 ;
		const PARCEL_TOO_LARGE = -3002 ;
		const PARCEL_TOO_SMALL = -3003 ;
		const PARCEL_OVERWEIGHT = -3004 ;
		const DLL_GENERAL_ERROR = -3005 ;
		const INVALID_CUT_OFF_TIME_FORMAT = -3006 ;
		
		//Server specific (D) Volumetric  ;
		const UNABLE_TO_PACK_GENERAL_ERROR = -4000 ;
		const UNABLE_TO_PACK_TIMEOUT = -4001 ;
		const UNABLE_TO_PACK_NO_BIN = -4002 ;
		const UNABLE_TO_PACK_NO_ITEM = -4003 ;
		const UNABLE_TO_PACK_ITEM_TOO_LARG = -4004 ;
		const UNABLE_TO_PACK_TOO_MANY_ITEM = -4005 ;
		
		//Server specific (E) XML  ;
		const XML_PARSING_ERROR = -5000 ;
		const XML_TAG_NOT_FOUND_ERROR = -5001 ;
		const XML_NUMBER_FORMAT_ERROR = -5002 ;
		const XML_EMPTY_NODE_VALUE_ERROR = -5003 ;
		const XML_CANNOT_CREATE_DOCUMENT = -5004 ;
		
		//Server specific (F) Database  ;
		const DATABASE_INITIALIZATION_ERROR = -6000 ;
		const DATABASE_READ_ERROR = -6001 ;
		const DATABASE_WRITE_ERROR = -6002 ;
		
		//Server specific (G)  ;
		const INTERNAL_PROBLEM = -50000 ;
	 	
		static $DESCRIPTIONS = null;
		
		/**
		 * 
		 * @param int $returnCode
		 */
		public static function getDescription($returnCode)
		{
			if (is_null(self::$DESCRIPTIONS)) {
				self::$DESCRIPTIONS = array(
				
					self::OK => _i('All calculation was done OK'),
					self::DEFAULT_VALUES => _i('Default shipping rates are returned due to a problem during the processing of the request. '),
					
					self::MISSING_ARGUMENT => _i('Missing argument when calling module'),
					self::NO_ITEM_TO_SHIP => _i('No Item to ship'),
					self::ILLEGAL_ITEM_WEIGHT => _i('Illegal Item weight'),
					self::ILLEGAL_ITEM_DIMENSION => _i('Illegal item dimension'),
					self::UNABLE_TO_OPEN_CONFIGURATION_FILE => _i('Can\'t open IM config file'),
					self::UNABLE_TO_OPEN_LOG_FILE => _i('Can\'t create log files'),
					self::CONFIGURATION_FILE_FORMAT_PROBLEM => _i('Invalid config file format'),
					self::INVALID_SOCKET_CONNECTION => _i('Invalid socket connection'),
					self::UNABLE_TO_CONNECT_TO_SERVER => _i('Can\'t connect to server'),
					
					self::UNKNOWN_REQUEST => _i('Unknow request type sent by client'),
					self::Sell_Online_EXCEPTION => _i('(to be updated)'),
					self::TIMEOUT_ERROR => _i('MAS Timed out'),
					self::COMMUNICATION_ERROR => _i('Socket communication break'),
					self::INVALID_DATA_RECEIVED => _i('Did not receive required data on socket.'),
					
					self::UNABLE_TO_CONTACT_RSSS => _i('Unable to estabish socket connection with RSSS'),
					self::MERCHANT_INFO_NOT_FOUND => _i('Merchant Id not found on server'),
					self::PARAMETER_MISSING_IN_REQUEST => _i('One or more parameter was not sent by the IM to the MAS'),
					self::INVALID_SHIPPERID_RECEIVED => _i('Did not receive required data on socket.'),
					self::TOO_MANY_ITEMS => _i('The request contains to many items to process it.'),
					self::REQUEST_TOO_BIG => _i('The request received on socket is larger than the maximum allowed.'),
					
					self::ILLEGAL_ORIGINATION => _i('Origin Postal Code is illegal'),
					self::ILLEGAL_DESTINATION => _i('Destination Postal Code/State Name/ Country  is illegal'),
					self::PARCEL_TOO_LARGE => _i('Parcel too large to be shipped with CPC  '),
					self::PARCEL_TOO_SMALL => _i('Parcel too small to be shipped with CPC'),
					self::PARCEL_OVERWEIGHT => _i('Parcel too heavy to be shipped with CPC'),
					self::DLL_GENERAL_ERROR => _i('Internal error code returned by the rating DLL'),
					self::INVALID_CUT_OFF_TIME_FORMAT => _i('The pick up time format is invalid or not defined.'),
					
					self::UNABLE_TO_PACK_GENERAL_ERROR => _i('Volumetric internal error '),
					self::UNABLE_TO_PACK_TIMEOUT => _i('Volumetric time out calculation error.'),
					self::UNABLE_TO_PACK_NO_BIN => _i('No bins provided to the volumetric engine. '),
					self::UNABLE_TO_PACK_NO_ITEM => _i('No items provided to the volumetric engine'),
					self::UNABLE_TO_PACK_ITEM_TOO_LARG => _i('Item is too large to be packed'),
					self::UNABLE_TO_PACK_TOO_MANY_ITEM => _i('Number of item more than maximum allowed'),
					
					self::XML_PARSING_ERROR => _i('XML Parsing error'),
					self::XML_TAG_NOT_FOUND_ERROR => _i('XML Tag not found'),
					self::XML_NUMBER_FORMAT_ERROR => _i('Node Value Number format error'),
					self::XML_EMPTY_NODE_VALUE_ERROR => _i('Node value is empty'),
					self::XML_CANNOT_CREATE_DOCUMENT => _i('Unable to create/parse XML Document'),
					
					self::DATABASE_INITIALIZATION_ERROR => _i('Unable to open the database'),
					self::DATABASE_READ_ERROR => _i('Unable to read from the database'),
					self::DATABASE_WRITE_ERROR => _i('Unable to write to the database'),
					
					self::INTERNAL_PROBLEM => _i('Internal problem - Please contact Sell Online Help Desk'),
					
				);
			}
			if (isset(self::$DESCRIPTIONS[$returnCode])) {
				return self::$DESCRIPTIONS[$returnCode];
			}
			return _sprintf(_i('Unknown return code %s.'), $returnCode);
		}
	}
?>