<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scFlatRate implements IShippingModule, IModuleOptions {
		const FLAT_RATE_SHIPPING_METHOD = 1;
		
		protected $_moduleId;
		protected $_shippingModuleId;

		public function __construct($moduleId, $shippingModuleId)
		{
			$this->_moduleId = $moduleId;
			$this->_shippingModuleId = $shippingModuleId;
		}
		
		function getShippingMethods()
		{
			return array(self::FLAT_RATE_SHIPPING_METHOD => 'Flat Rate Shipping'); // _t('Flat Rate Shipping')
		}
		
		function getShippingRates(scCart $cart, $shippingMethods)
		{
			$options = scModuleOptions::getShippingModuleOptions($this->_shippingModuleId);
			$shippingFee = isset($options['ShippingFee']) ? $options['ShippingFee'] : null;
			return array(self::SHIPPING_RATES => array(self::FLAT_RATE_SHIPPING_METHOD => $shippingFee));
		}
		
		public function getShippingModuleImage()
		{
			return 'skins/default/modules/shipping/flat_rate/logo_flat-rate-shipping.png';
		}
		
		function getOptionFields(miWebForm &$webForm)
		{
			list($currencySymbolLeft, $currencySymbolRight) = scCurrencyUtil::getBaseCurrencySymbols();
			
			$fieldsDescriptions = array(
				array(
					'field' => 'scAmountWidget',
					'data' => 'ShippingFee',
				),
			);
			
			$options = new scModuleOptionsInfo();
			$options->buildOptionFields($fieldsDescriptions, $webForm);
			$options->setTemplateFile('modules/shipping/flat_rate/options.tmpl');
			return $options;
		}
	}
?>