<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scSpeedyBgAdminModule implements IAdminModule {
		public function getView()
		{
			return new miView();
		}
		
		public function initActionHandlers(miPage $page)
		{
			scAdminAuth::singleton()->checkAuthorization(scSections::SECTION_MODULES_SHIPPING);
			$page->getDispatcher()->setActionHandler('getAccountData', 'scSpeedyGetAccountData');
			$page->getDispatcher()->setActionHandler('execImportSpeedyLocationsAction', 'scSpeedyExecImportSpeedyLocationsAction');
		}
		
	} 
	
	class scSpeedyExecImportSpeedyLocationsAction extends miAction {
		public function doAction()
		{
			if (!scAdminAuth::singleton()->isAuthorized(scSections::SECTION_MODULES_SHIPPING)) {
				die(_t('You are not authorized to perform this operation.'));
			}
			
			try {
				$moduleName = 'com.summercart.shipping.speedybg';
				$moduleId = scModulesFactory::getModuleIdByName($moduleName);
				$shippingModuleId = scUtil::getDbValue('ShippingModules', 'ShippingModuleID', 'ModuleID', $moduleId);
				$className = scModulesFactory::getModuleClassName($moduleId, 'IShippingModule');
						
				$speedy = new $className($moduleId, $shippingModuleId);
				$return = $speedy->importLocations();
				$msg = $return['message'];
			} catch (miException $e) {
				$msg = sprintf(_t('Error occured: %s'), $e->getMessage());
			}
			die($msg);
		}
	}
	
	class scSpeedyGetAccountData extends miAction {
		public function doAction()
		{
			try {
				$moduleName = 'com.summercart.shipping.speedybg';
				$moduleId = scModulesFactory::getModuleIdByName($moduleName);
				$shippingModuleId = scUtil::getDbValue('ShippingModules', 'ShippingModuleID', 'ModuleID', $moduleId);
				$className = scModulesFactory::getModuleClassName($moduleId, 'IShippingModule');
						
				$speedy = new $className($moduleId, $shippingModuleId);
				$msg = $speedy->getAccountData();
			} catch (miException $e) {
				$msg = sprintf(_t('Error occured: %s'), $e->getMessage());
			}
			die($msg);
		}
	}
?>