<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	class scDefaultShippingLabelModule implements IShippingLabelModule {
		
		const PRINTING_FRAME_TEMPLATE = 'modules/shippinglabel/default/printing_frame.tmpl';
		
		public function getShippingLabel($orderId)
		{
			$shippingLabel = new scDefaultShippingLabelHtml($orderId);
			return $shippingLabel;
		}
		
		public function handlePrintAction($orderId)
		{
			$shippingLabel = $this->getShippingLabel($orderId);
//			if (!scShippingLabelCache::checkCacheExists($shippingLabel->getCacheFileName($orderId))) {
//				$content = $shippingLabel->getContent($orderId);
//				scShippingLabelCache::storeShippingLabelContent($shippingLabel->getCacheFileName($orderId), $content);
//			}
//			$html = scShippingLabelCache::getCachedContent($shippingLabel->getCacheFileName($orderId));
			$html = $shippingLabel->getContent($orderId);
			
			// Init the template parser
			$template = new scTemplateParser();
			
			// Assign template variables
			$template->assign('%%COMPANYNAME%%', scSettings::getSettingValue(scSettings::SETTING_COMPANY_NAME));
			$template->assign('%%HTML_CONTENT%%', $html);
			$template->assign('%%ORDERID%%', $orderId);
			
			// Show page
			$template->readTemplate(self::PRINTING_FRAME_TEMPLATE);
			$template->templateShow();
			die;
		}
		
		public function getPrintActionOpenType($orderId)
		{
			return IShippingLabelModule::OPEN_TYPE_BLANK;
		}
	}
	
	class scDefaultShippingLabelOrderUI extends scAdminOrdersUI {
		
		protected $_templates = array(
			self::TEMPLATE_ORDER_DETAILS => 'modules/shippinglabel/default/default_shipping_label.tmpl',
			self::TEMPLATE_BUNDLED_ORDER_ITEMS => 'admin/orders/bundled_order_items.tmpl', // FIXME
		);
		
		/**
		 * @return scDefaultShippingLabelOrderUI
		 */
		public static function singleton()
		{
			static $instance = null;
			
			if (is_null($instance)) {
				$instance = new scDefaultShippingLabelOrderUI();
			}
			
			return $instance;
		}
	}
	
	class scDefaultShippingLabelHtml extends scShippingLabelHtml implements IShippingLabel {
		
		const SHIPPING_LABEL_TEMPLATE = '';
		
		public function getContent($orderId, $params = array())
		{
			scOrdersCache::fullLoadOrderData($orderId);
			$order = scOrdersCache::getOrder($orderId);
			$html = scDefaultShippingLabelOrderUI::singleton()->getOrderDetailsHtml($order);
			return $html;
		}
		
		public function getCacheFileName($orderId, $params = array())
		{
			return $orderId . '_' . self::DOCUMENT_TYPE_SLIP . '.' . $this->getExtension();
		}
	}
?>