<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * Get Admin Help Box content
	 */
	class scAdminHelpBox implements ICMSBox {
		protected $_boxId = 'help_zone';
		protected $_boxInfo = array();
		
		const STATE_VISIBLE = 'visible';
		const STATE_VISIBLE_ARROW = 'arrow';
		
		public function __construct($moduleId, $cmsBoxId)
		{
			// Set the default box state
			$this->_boxInfo[self::STATE_VISIBLE] = 'block';
			$this->_boxInfo[self::STATE_VISIBLE_ARROW] = 'none';
		}
		
		public function getBoxContents()
		{
			$helpText = $this->getHelpText();
			if (empty($helpText)) {
				return '';
			}
			
			$t = new scTemplateParser();
			$t->readTemplate('admin/cmsboxes/help.tmpl');
			$t->assign('%%HELPTEXT%%', $helpText);
			
			$t->assign('%%BOXID%%', $this->_boxId);
			$t->assign('%%VISIBLE%%', $this->_boxInfo[self::STATE_VISIBLE]);
			$t->assign('%%VISIBLEARROW%%', $this->_boxInfo[self::STATE_VISIBLE_ARROW]);
			
			return $t->templateParse();
		}
		
		protected function getHelpText()
		{
			// Get Current Page
			$helpPage = scPaths::getCurrentScriptBaseName();
			if ($helpPage == 'module.php')
				$helpPage = miGetParamDefault('ModuleName', '');
			
			// Get Page Help
			$recordset = new scSqlRecordsetML('Helps', 'HelpID');
			$recordset->setLanguageId(scMultiLanguage::getCurrentLanguageId());
			$recordset->addFilter(new miSqlFilterEqual('HelpPage', $helpPage));
			$helps = $recordset->getRecords();
			
			foreach ($helps as $key => $help) {
				if (($help['HelpPageAction'] != '') and
					(miGetParamDefault('action', '') != $help['HelpPageAction']) and
					(miGetParamDefault('report', '') != $help['HelpPageAction'])) {
						unset($helps[$key]);
					}
			}
			
			if (count($helps) == 0)
				return '';
			
			$helpText = '';
			foreach ($helps as $help)
				$helpText .= $helps[0]['HelpText'];
			return $helpText;
		}
		
		public function setVisible($visible = true)
		{
			if (!$visible) {
				$this->_boxInfo[self::STATE_VISIBLE] = 'none';
				$this->_boxInfo[self::STATE_VISIBLE_ARROW] = 'block';
			}
		}
	}
?>