<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * Get Admin Quick Links content
	 */
	class scAdminQuickLinksBox implements ICMSBox {
		protected $_boxId = 'quick_links';
		protected $_boxInfo = array();
		
		const STATE_VISIBLE = 'visible';
		const STATE_VISIBLE_ARROW = 'arrow';
		
		public function __construct($moduleId, $cmsBoxId)
		{
			// Set the default box state
			$this->_boxInfo[self::STATE_VISIBLE] = 'block';
			$this->_boxInfo[self::STATE_VISIBLE_ARROW] = 'none';
		}
		
		public function getBoxContents()
		{
			$links = $this->getQuickLinks();
				
			// Set Links Section
			$section = new miTemplateParserSectionInfo();
			$section->setSectionInfo('links', count($links), miUIUtil::templetizeRows(miUIUtil::transposeRows($links)));
			
			$t = new scTemplateParser();
			
			$t->readTemplate('admin/cmsboxes/quick_links.tmpl');
			$t->addSectionInfo($section);
			
			$t->assign('%%BOXID%%', $this->_boxId);
			$t->assign('%%VISIBLE%%', $this->_boxInfo[self::STATE_VISIBLE]);
			$t->assign('%%VISIBLEARROW%%', $this->_boxInfo[self::STATE_VISIBLE_ARROW]);
			
			return $t->templateParse();
		}
		
		protected function getQuickLinks()
		{
			// Get Current Page
			$linksPage = scPaths::getCurrentScriptBaseName();
			if ($linksPage == 'module.php')
				$linksPage = miGetParamDefault('ModuleName', '');
			
			// Get Links
			$recordset = new scSqlRecordsetML('AdminQuickLinks', 'AdminQuickLinkID');
			$recordset->setLanguageId(scMultiLanguage::getCurrentLanguageId());
			$recordset->addFilter(new miSqlFilterEqual('AdminQuickLinkPage', $linksPage));
			$links = $recordset->getRecords();
			
			foreach ($links as $key => $link) {
				if (($link['AdminQuickLinkPageAction'] != '') and
					(miGetParamDefault('action', '') != $link['AdminQuickLinkPageAction']) and
					(miGetParamDefault('report', '') != $link['AdminQuickLinkPageAction'])) {
						unset($links[$key]);
					}
			}
			$links = array_values($links);
			
			if (count($links) == 0)
				return array(array('AdminQuickLinkLocation' => 'quick_links.php', 'AdminQuickLinkText' => _t('Setup Quick Links')));
			
			return $links;
		}
		
		public function setVisible($visible = true)
		{
			if (!$visible) {
				$this->_boxInfo[self::STATE_VISIBLE] = 'none';
				$this->_boxInfo[self::STATE_VISIBLE_ARROW] = 'block';
			}
		}
	}
?>