<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * Get Admin Quick Links content
	 */
	class scAdminSetupWizardBox implements ICMSBox {
		protected $_boxId = 'setup_wizard';
		protected $_cmsBoxId;
		protected $_boxInfo = array();
		
		const STATE_VISIBLE = 'visible';
		const STATE_VISIBLE_ARROW = 'arrow';
		
		public function __construct($moduleId, $cmsBoxId)
		{
			// Set the default box state
			$this->_boxInfo[self::STATE_VISIBLE] = 'block';
			$this->_boxInfo[self::STATE_VISIBLE_ARROW] = 'none';
			$this->_cmsBoxId = $cmsBoxId;
		}
		
		public function getBoxContents()
		{
			$t = new scTemplateParser();
			
			$t->readTemplate('admin/cmsboxes/setup_wizard.tmpl');
			
			$t->assign('%%REQUEST_URI%%', urlencode($_SERVER['REQUEST_URI']));
			$t->assign('%%BOXID%%', $this->_boxId);
			$t->assign('%%CMSBOXID%%', $this->_cmsBoxId);
			$t->assign('%%VISIBLE%%', $this->_boxInfo[self::STATE_VISIBLE]);
			$t->assign('%%VISIBLEARROW%%', $this->_boxInfo[self::STATE_VISIBLE_ARROW]);
			
			return $t->templateParse();
		}
		
		public function setVisible($visible = true)
		{
			if (!$visible) {
				$this->_boxInfo[self::STATE_VISIBLE] = 'none';
				$this->_boxInfo[self::STATE_VISIBLE_ARROW] = 'block';
			}
		}
	}
?>