<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scCustomerCartBox implements ICMSBox {
		protected $_cmsBoxId;
		
		public function __construct($moduleId, $cmsBoxId)
		{
			$this->_cmsBoxId = $cmsBoxId;
		}
		
		public function getBoxContents()
		{
			$cart = scCart::getCart();
			$uiCart = new scUICart();
			
			$t = new scTemplateParser();
			$t->readTemplate('customer/cmsboxes/cart.tmpl');
			$t->assign('%%CMSBOXID%%', $this->_cmsBoxId);
			
			$itemsCount = $cart->getItemsCount();
			if ($itemsCount) {
				$values = array();
				$values['%%CART_ITEMS_COUNT%%'] = $itemsCount;
				$values['%%CART_ITEMS_WORD%%'] = ($cart->getItemsCount() == 1) ? _t('item') : _t('items');
				
				$values['%%SUBTOTAL%%'] = scPrice::factory(scCart::getCart()->getSubtotal())->getDisplayPrice();
				
				$subsection = new miTemplateParserSectionInfo('not_empty', 1, $values);
//				$subsection->addSubsection($uiCart->getCheckoutModulesSection());
				$t->addSectionInfo($subsection);
			} else {
				$t->addSectionInfo(new miTemplateParserSectionInfo('empty', 1));
			}
			
			return $t->templateParse();
		}
	}
?>