<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scCmsHtmlBox implements ICMSBox, IModuleOptions {
		
		protected $_moduleId;
		protected $_boxId;
		
		public function __construct($moduleId, $cmsBoxId)
		{
			$this->_moduleId = $moduleId;
			$this->_boxId = $cmsBoxId;
		}
		
		public function getBoxContents()
		{
			$options = scModuleOptions::getCmsBoxOptions($this->_boxId, scModuleOptions::MODULE_OPTIONS_INCLUDE_ML);
			
			$parser = new scTemplateParser();
			$parser->readTemplate('customer/cmsboxes/cms_html_box.tmpl');
			$parser->assign('%%CMSBOXID%%', $this->_boxId);
			$parser->assign('%%CMSHTMLBOXCONTENT%%', $options['CMSHtmlBoxContent']);
			
			if (!isset($options['CMSHtmlBoxTitleIsActive']) || !empty($options['CMSHtmlBoxTitleIsActive'])) {
				$parser->addSectionInfo(new miTemplateParserSectionInfo('cmsHtmlBoxHasTitle', 1,
					array('%%CMSHTMLBOXTITLE%%' => $options['CMSHtmlBoxTitle'])));
			}
			
			return $parser->templateParse();
		}
		
		/**
		 * @param miWebForm $webForm
		 * @return scModuleOptionsInfo
		 */
		public function getOptionFields(miWebForm &$webForm)
		{
			$title = new scWebFormWidgetTextML($webForm);
			$title->setFieldName('CMSHtmlBoxTitle');
			
			$titleIsActive = new miCheckboxWidget($webForm);
			$titleIsActive->setFieldName('CMSHtmlBoxTitleIsActive');
			$titleIsActive->setDefaultValue(1);
			
			$htmlContent = new scWebFormWidgetTextAreaML($webForm, array());
			$htmlContent->setFieldName('CMSHtmlBoxContent');
			
			$options = new scModuleOptionsInfo();
			$options->addOptionField($htmlContent);
			$options->addOptionField($title);
			$options->addOptionField($titleIsActive);
			$options->setTemplateFile('admin/boxes/edit_html_box.tmpl');
			
			return $options;
		}
	}
?>