<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scCustomerLoginBox implements ICMSBox {
		protected $_cmsBoxId;
		
		public function __construct($moduleId, $cmsBoxId)
		{
			$this->_cmsBoxId = $cmsBoxId;
		}
				
		public function getBoxContents()
		{
			$section = new miTemplateParserSectionInfo();
			
			$hasFriendlyUrlsSection = new miTemplateParserSectionInfo();
			$hasFriendlyUrlsSection->setIterationsCount(1);
			if (scFriendlyUrl::hasFriendlyUrls()) {
				$hasFriendlyUrlsSection->setSectionName('hasFriendlyUrls');
			} else {
				$hasFriendlyUrlsSection->setSectionName('noFriendlyUrls');
			}
			$section->addSubsection($hasFriendlyUrlsSection);
			
			$auth = scCustomerAuth::singleton();
			if ($auth->isLoggedIn()) {
				$customerFirstName = $auth->getCustomerFirstName();
				$customerLastName = $auth->getCustomerLastName();
				$section->setSectionInfo('logged', 1,
					array(
						'%%CUSTOMERFIRSTNAME%%' => $customerFirstName,
						'%%CUSTOMERLASTNAME%%' => $customerLastName,
					));
			} else { 
				$section->setSectionInfo('notlogged', 1);
			}
			
			$t = new scTemplateParser();
			$t->readTemplate('customer/cmsboxes/login.tmpl');
			$t->assign('%%CMSBOXID%%', $this->_cmsBoxId);
			$t->setSectionInfos(array($section));
			return $t->templateParse();
		}
	}
?>