<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scCustomerMenuTable extends miTable {
		protected $_imageSections = array();
		
		public function addUiElements(&$rows)
		{
			foreach ($rows as $row) {
				if (intval($row['CMSMenuItemImageType']) == scMenuItemImageTypes::TYPE_NO_IMAGE || empty($row['CMSMenuItemImage']))
					$this->_imageSections[] = new miTemplateParserSectionInfo('image', 0);
				else
					$this->_imageSections[] = new miTemplateParserSectionInfo('image');
			}
		}
		
		public function addMainUiElements(&$parser)
		{
			$rowsSection = $parser->getSectionInfo('rows');
			if ($rowsSection !== false)
				$rowsSection->addSubsectionsArray('image', $this->_imageSections);
		}
	}
	
	class scCustomerMenuBox implements ICMSBox, IModuleOptions {
		protected $_moduleId;
		protected $_cmsBoxId;
		
		public function __construct($moduleId, $cmsBoxId)
		{
			$this->_moduleId = $moduleId;
			$this->_cmsBoxId = $cmsBoxId;
		}
		
		public function getBoxContents()
		{			
			$menuItemRows = scUserMenus::getMenuItems(scUserMenus::MENU_LOCATION_BOX, $this->_cmsBoxId);
			$menuItemsRs = new scPreparedRecordset($menuItemRows);			
			$table = new scCustomerMenuTable($menuItemsRs);
			$table->addMainPageElements(array(
				'%%CMSMENUNAME%%' => empty($menuItemRows) ? '' : $menuItemRows[0]['CMSMenuName'],
				'%%CMSMENUTITLE%%' => empty($menuItemRows) ? '' : $menuItemRows[0]['CMSMenuTitle'],
				'%%CMSBOXID%%' => $this->_cmsBoxId
			));
			return $table->parse('customer/cmsboxes/menu.tmpl');
		}
		
		public function getOptionFields(miWebForm &$webForm)
		{
			return null;
		}
	}
?>