<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	 
	 class scBundledProductsDetails implements IProductDetails {
		
		public function getProductDetailsHtml(scProductSL $product, miTemplateParserSectionInfo $productSection)
		{
			if (!$product->get('ProductIsBundle')) {
				return;
			}
			$bundledProducts = $product->getBundleProducts();
			if (empty($bundledProducts)) {
				return;
			}
			
			$productSection->addSubsection(new miTemplateParserSectionInfo('productHasBundledProducts', 1));
			
			$section = scProductListingService::singleton()->getSection('bundledProducts', $bundledProducts, scProductService::VIEW_LIST, scProductListingService::OPTION_NO_MODULES);
			
			$t = new scTemplateParser();
			$t->readTemplate('modules/system/bundled_products/bundled_products.tmpl');
			$t->addSectionInfo($section);
			return $t->templateParse();
		}
	}
?>