<?php
	/**
	 * Copyright (c) 2011 Mirchev Ideas Ltd. All rights reserved.
	 * 
	 * @version 15.03.2011
	 */
	
	class scEditOrderModule implements IAdminModule {
		
		public function __construct()
		{
			$this->setupAutoloading();
		}
		
		public function getView()
		{
			return new scEditOrderView(null);
		}
		
		public function initActionHandlers(miPage $page)
		{
			$page->getDispatcher()->setActionHandler('', 'scEditOrderAction');
			$page->getDispatcher()->setActionHandler('dmApplyChanges', 'scEditOrderApplyAction');
			$page->getDispatcher()->setActionHandler('dmDiscardChanges', 'scEditOrderDiscardAction');
			$page->getDispatcher()->setActionHandler('dmUpdateField', 'scEditOrderUpdateField');
			$page->getDispatcher()->setActionHandler('dmAddCartItem', 'scEditOrderAddCartItemAction');
			$page->getDispatcher()->setActionHandler('dmRemoveCartItem', 'scEditOrderRemoveCartItemAction');
			$page->getDispatcher()->setActionHandler('dmSelectProduct', 'scEditOrderSelectProductAction');
			$page->getDispatcher()->setActionHandler('dmListProducts', 'scEditOrderListProductsAction');
			$page->getDispatcher()->setActionHandler('dmCreateBlank', 'scEditOrderCreateBlankOrderAction');
			$page->getDispatcher()->setActionHandler('dmValidate', 'scEditOrderValidateAjaxAction');
		}
		
		protected function setupAutoloading()
		{
			$autoloadClasses = array(
				// Interfaces
				'IObserver' => 'include/IObserver.php',
				'IObservable' => 'include/IObservable.php',
				
				// Actions
				'scEditOrderAction' => 'include/EditOrderActions.php',
				'scEditOrderApplyAction' => 'include/EditOrderActions.php',
				'scEditOrderDiscardAction' => 'include/EditOrderActions.php',
				'scEditOrderSelectProductAction' => 'include/EditOrderActions.php',
				'scEditOrderListProductsAction' => 'include/EditOrderActions.php',
				'scEditOrderCreateBlankOrderAction' => 'include/EditOrderActions.php',
				
				// AJAX Actions
				'scEditOrderUpdateField' => 'include/EditOrderAjaxActions.php',
				'scEditOrderAddCartItemAction' => 'include/EditOrderAjaxActions.php',
				'scEditOrderRemoveCartItemAction' => 'include/EditOrderAjaxActions.php',
				'scEditOrderValidateAjaxAction' => 'include/EditOrderAjaxActions.php',
				
				// Cart
				'scEditOrderCart' => 'include/EditOrderCart.php',
				'scEditOrderCartItemInfo' => 'include/EditOrderCartItemInfo.php',
				'scEditOrderCartItemProduct' => 'include/EditOrderCartItemProduct.php',
				'scEditOrderCartItemProductBundle' => 'include/EditOrderCartItemProductBundle.php',
				'scEditOrderCartItemProductVariant' => 'include/EditOrderCartItemProductVariant.php',
				'scEditOrderCartItemService' => 'include/EditOrderCartItemService.php',
				'scEditOrderCustomerInfo' => 'include/EditOrderCustomerInfo.php',
				'scEditOrderOrderTotal' => 'include/EditOrderOrderTotal.php',
				'scEditOrderDiscountCalculator' => 'include/EditOrderDiscountCalculator.php',
				'scEditOrderOrderTotalDiscount' => 'include/EditOrderOrderTotalDiscount.php',
				'scEditOrderOrderTotalPoints' => 'include/EditOrderOrderTotalPoints.php',
				'scEditOrderOrderTotalShipping' => 'include/EditOrderOrderTotalShipping.php',
				'scEditOrderProductPrice' => 'include/EditOrderProductPrice.php',
				'scEditOrderProductPriceDiscount' => 'include/EditOrderProductPriceDiscount.php',
				'scEditOrderUICart' => 'include/EditOrderUICart.php',
				'scEditOrderWholesalePrices' => 'include/EditOrderWholesalePrices.php',
				'scEditOrderProductListingService' => 'include/EditOrderProductListingService.php',
				
				'scEditOrderCartItemProductOptionsRetriever' => 'include/EditOrderCartItemProductOptionsRetriever.php',
				'scEditOrderCartItemOptionsRetriever' => 'include/EditOrderCartItemProductOptionsRetriever.php',
				'scEditOrderCartItemLocalOptionsRetriever' => 'include/EditOrderCartItemProductOptionsRetriever.php',
				
				'scEditOrderCustomerAuth' => 'include/EditOrderCustomerAuth.php',
				
				// Options Retrievers
				'scEditOrderOptionsRetriever' => 'include/EditOrderOptionsRetriever.php',
				'scEditOrderLocalOptionsRetriever' => 'include/EditOrderOptionsRetriever.php',
				
				// View
				'scEditOrderView' => 'include/EditOrderView.php',
				
				// Web form
				'scEditOrderWebForm' => 'include/EditOrderWebForm.php',
				'scEditOrderValidationErrorsHandler' => 'include/EditOrderWebForm.php',
				
				// Addresses
				'scEditOrderBillingAddress' => 'include/EditOrderAddresses.php',
				'scEditOrderShippingAddress' => 'include/EditOrderAddresses.php',
				
				// Widgets
				'scEditOrderCityIdWidget' => 'include/EditOrderCityIdWidget.php',
				'scEditOrderShippingMethodWidget' => 'include/EditOrderShippingMethodWidget.php',
				
				// Domain Object
				'scEditOrderDomainObject' => 'include/EditOrderDomainObject.php',
				
				// Order service
				'scEditOrderOrdersInProgress' => 'include/EditOrderOrdersInProgress.php',
				'scEditOrderService' => 'include/EditOrderService.php',
			);
			
			foreach ($autoloadClasses as $className => $fileName) {
				// Relative from the location of miLoader
				miLoader::addClass($className, '../../modules/system/edit_order/' . $fileName);
			}
		}
	}
?>