<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scEditOrderCityIdWidget extends miBaseTextWidget implements IObserver {
		
		public function notify(IObservable $subject, $updateField = '')
		{
			if (empty($updateField)) {
				return;
			}
			
			if (($this->_fieldName == 'OrderBillingCityID') && ($subject instanceof scEditOrderBillingAddress)) {
				$info = scEditOrderCart::getCart()->getCustomerInfo();
				if (miHasParam('OrderBillingState')) {
					$info['CustomerBillingState'] = miGetParam('OrderBillingState');
				}
				$info['CustomerBillingCityID'] = scCustomerAddress::findCityId($info['CustomerBillingState'], $info['CustomerBillingCity']);
			}
			if (($this->_fieldName == 'OrderShippingCityID') && ($subject instanceof scEditOrderShippingAddress)) {
				$info = scEditOrderCart::getCart()->getCustomerInfo();
				if (miHasParam('OrderShippingState')) {
					$info['CustomerShippingState'] = miGetParam('OrderShippingState');
				}
				$info['CustomerShippingCityID'] = scCustomerAddress::findCityId($info['CustomerShippingState'], $info['CustomerShippingCity']);
			}
			
			scEditOrderCart::getCart()->setCustomerInfo($info);
		}
	}
?>