<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scEditOrderCustomerAuth extends scCustomerAuth {
		
		protected $_inOrderCustomerIds = array();
		
		/**
		 * @return scCustomerAuth
		 */
		public static function singleton()
		{
			static $obj = null;
			if ($obj == null)
				$obj = new scEditOrderCustomerAuth;
			return $obj;
		}
		
		public function logIn($customerId)
		{
		}
		
		public function logOut()
		{
		}
		
		public function isLoggedIn()
		{
			if (!is_null($this->getInOrderCustomerId())) {
				return true;
			}
			return false;
		}
		
		public function getCustomerId()
		{
			if (!$this->isLoggedIn()) {
				return false;
			}
			return $this->getInOrderCustomerId();
		}
		
		public function getCustomer()
		{
			static $customer = false;
			
			if (!$this->isLoggedIn()) {
				return false;
			}
			
			try {
				$customer = new scCustomerDomainObject();
				$customer->read($this->getInOrderCustomerId());
			} catch (miDBException $exception) {
				$customer = false;
				if ($exception->getCode() == miDBException::EXCEPTION_RECORD_NOT_FOUND) {
					return false;
				}
				throw $exception;
			}
			
			return $customer;
		}
		
		protected function getInOrderCustomerId()
		{
			$orderId = scEditOrderCart::getCurrentOrderId();
			if (!isset($this->_inOrderCustomerIds[$orderId])) {
				$order = new scOrder($orderId);
				$this->_inOrderCustomerIds[$orderId] = $order->get('CustomerID');
			}
			return $this->_inOrderCustomerIds[$orderId];
		}
	}
?>