<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scEditOrderCustomerInfo implements IObservable {
		
		protected $_data = array();
		
		protected $_observers = array();
		
		public function set($field, $value)
		{
			$oldValue = $value;// For the first "set"
			if (array_key_exists($field, $this->_data)) {
				$oldValue = $this->_data[$field];
			}
			
			$this->_data[$field] = $value;
			if ($oldValue != $value) {
				$this->notifyObservers($field);
			}
		}
		
		public function get($field)
		{
			if (isset($this->_data[$field])) {
				return $this->_data[$field];
			}
			return null;
		}
		
		public function attachObserver(IObserver $observer)
		{
			$this->_observers[] = $observer;
		}
		
		public function detachAllObservers()
		{
			$this->_observers = array();
		}
		
		public function notifyObservers($updatedField = '')
		{
			if (empty($updatedField)) {
				return;
			}
			
			foreach ($this->_observers as $observer) {
				$observer->notify($this, $updatedField);
			}
		}
	}
?>