<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	// Make sure scOrderTotalPoints is loaded
	scModulesFactory::getActiveOrderTotalModules(IOrderTotalModule::ORDER_TOTAL_TYPE_POINTS);
	
	class scEditOrderOrderTotalPoints extends scOrderTotalPoints {
		
		/**
		 * @var scOrderTotalPoints
		 */
		protected $_pointsModule = null;
		
		/**
		 * @return int
		 */
		public static function getBonusPointsSpentInOrder(scCustomerDomainObject $customer, $orderId)
		{
			$recordset = new miSqlRecordset('BonusPointsTransactions');
			$recordset->addFilter(new miSqlFilterEqual('CustomerID', $customer->get('CustomerID')));
			$recordset->addFilter(new miSqlFilterEqual('BonusPointsTransactionType', scBonusPoints::ACTION_SPEND));
			$recordset->addFilter(new miSqlFilterEqual('BonusPointsTransactionIdentifier', $orderId));
			
			$transactions = $recordset->getAllRecords();
			if (count($transactions) > 1) {
				throw new miException(_i('Found more than one SPEND transaction for the same order.'));
			}
			if (count($transactions) == 0) {
				return 0;
			}
			return $transactions[0]['BonusPointsAmount'];
		}
		
		public function __construct($moduleId)
		{
		}
		
		public function setOrderTotalModule(scOrderTotalPoints $orderTotalModule)
		{
			$this->_pointsModule = $orderTotalModule;
		}
		
		protected function getCustomerAllowedPoints(scCart $cart)
		{
			$inOrder = scEditOrderOrderTotalPoints::getBonusPointsSpentInOrder($this->getCustomer(), scEditOrderCart::getCurrentOrderId());
			if ($inOrder == 0) {
				// If no points were used when making the order no points should be used when editing it.
				return 0;
			}
			$inCustomer = parent::getCustomerAllowedPoints($cart);
			return $inCustomer + $inOrder;
		}
		
		/**
		 * @return scCustomerDomainObject
		 */
		protected function getCustomer()
		{
			return scEditOrderCustomerAuth::singleton()->getCustomer();
		}
	}
?>