<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scEditOrderService extends scOrderService {
		
		/**
		 * @var scOrder
		 */
		protected $_currentOrder;
		
		/**
		 * @return scEditOrderService
		 */
		public static function singleton()
		{
			static $instance = null;
			if (is_null($instance)) {
				$instance = new scEditOrderService();
			}
			return $instance;
		}
		
		public function setCurrentOrder(scOrder $order)
		{
			$this->_currentOrder = $order;
		}
		
		protected function getCustomerCurrency()
		{
			return $this->_currentOrder->getCustomerCurrency();
		}
		
		protected function setOrderTotalLineData(scOrderTotalLine $orderTotalLine, scOrderTotalLineDomainObject $domainObject)
		{
			$domainObject->set('OrderTotalLineType', $orderTotalLine->getType());
			$domainObject->set('OrderTotalLineName', scInterfaceTexts::getTranslatedText($orderTotalLine->getDescription()));
			$amount = $orderTotalLine->getAmount();
			$domainObject->set('OrderTotalLineAmount', $amount->get());
			$domainObject->set('OrderTotalLineCustomerCurrencyAmount', $amount->get($this->getCustomerCurrency()));
		}
		
		protected function setOptionImageData(scLocalOption $option, scOrderItemLocalOption $domainObject)
		{
			$optionInfo = $option->getOptionInfo(scMultiCurrencyAmount::getZero());
			$filePath = str_replace(scpaths::getStoreRootDir(), '', $optionInfo['OptionUploadedFileName']);
			
			list($width, $height) = getimagesize($optionInfo['OptionUploadedFileName']);
			$domainObject->set('OrderItemOptionImage', $filePath);
			$domainObject->set('OrderItemOptionImageWidth', $width);
			$domainObject->set('OrderItemOptionImageHeight', $height);
		}
		
		protected function setLocalOptionImageData(scLocalOption $option, scOrderItemLocalOption $domainObject)
		{
			$optionInfo = $option->getOptionInfo(scMultiCurrencyAmount::getZero());
			$filePath = str_replace(scpaths::getStoreRootDir(), '', $optionInfo['OptionUploadedFileName']);
			
			list($width, $height) = getimagesize($optionInfo['OptionUploadedFileName']);
			$domainObject->set('OrderItemLocalOptionImage', $filePath);
			$domainObject->set('OrderItemLocalOptionImageWidth', $width);
			$domainObject->set('OrderItemLocalOptionImageHeight', $height);
		}
	}
?>