<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scEditOrderShippingMethodWidget extends scCheckoutShippingMethodWidget implements IObserver, IObservable {
		
		protected $_observers = array();
		
		public function notify(IObservable $subject)
		{
			if (($subject instanceof scEditOrderCart) || ($subject instanceof scEditOrderShippingAddress)) {
				if ($subject instanceof scEditOrderShippingAddress) {
					$value = $subject->getCountryId();
					if (!is_null($value)) {
						$this->setProperty('countryId', $value);
					}
					$value = $subject->getStateId();
					if (!is_null($value)) {
						$this->setProperty('stateId', $value);
					}
				}
				$this->setupShippingOptions();
				$customerInfo = scEditOrderCart::getCart()->getCustomerInfo();
				$selectedShippingMethod = $customerInfo['ShippingModuleAndMethod'];
				if (!array_key_exists($selectedShippingMethod, $this->_radioButtons)) {
					reset($this->_radioButtons);
					scEditOrderCart::getCart()->setCustomerInfoField('ShippingModuleAndMethod', key($this->_radioButtons));
				}
			}
		}
		
		public function attachObserver(IObserver $observer)
		{
			$this->_observers[] = $observer;
		}
		
		public function detachAllObservers()
		{
			$this->_observers = array();
		}
		
		public function notifyObservers()
		{
			foreach ($this->_observers as $observer) {
				$observer->notify($this);
			}
		}
		
		protected function setupShippingOptions()
		{
			$oldHash = crc32(serialize($this->_radioButtons));
			parent::setupShippingOptions();
			$newHash = crc32(serialize($this->_radioButtons));
			
			if ($oldHash != $newHash) {
				$this->notifyObservers();
			}
		}
	}
?>