<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scEditOrderView extends scView {
		
		const TEMPLATE_ID_ORDER_TOTAL_LINES = 'order_total_lines';
		const TEMPLATE_ID_CART_ITEMS = 'cart_items';
		const TEMPLATE_ID_BUNDLED_ITEMS = 'bundled_items';
		const TEMPLATE_ID_SELECT_CATEGORY = 'select_category';
		const TEMPLATE_ID_LIST_PRODUCTS = 'list_products';
		
		protected $_templates = array(
			self::TEMPLATE_ID_EDIT => 'modules/system/edit_order/edit_order.tmpl',
			self::TEMPLATE_ID_ORDER_TOTAL_LINES => 'modules/system/edit_order/edit_order_total_lines.tmpl',
			self::TEMPLATE_ID_CART_ITEMS => 'modules/system/edit_order/edit_order_cart_items.tmpl',
			self::TEMPLATE_ID_BUNDLED_ITEMS => 'modules/system/edit_order/edit_order_bundled_items.tmpl',
			self::TEMPLATE_ID_SELECT_CATEGORY => 'modules/system/edit_order/edit_order_select_category.tmpl',
			self::TEMPLATE_ID_LIST_PRODUCTS => 'modules/system/edit_order/edit_order_list_products.tmpl',
		);
        
		protected $_dataFields = array(
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderID'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderTimestamp'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderIPAddress'
        	),
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderCustomerEmail'
        	),
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'CustomerID'
        	),
			
			// Shipping related
			array(
				'field' => 'scEditOrderShippingMethodWidget',
				'data' => 'ShippingModuleAndMethod',
			),
			array(
				'field' => 'miTextWidget',
				'data' => 'OrderShippingTrackingNo'
        	),
			
			// Payment related
			array(
				'field' => 'scCheckoutPaymentMethodWidget',
				'data' => 'PaymentModuleID',
			),
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderPaymentModuleName'
        	),
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderPaymentModuleIntegration'
        	),
			array(
				'field' => 'miTextWidget',
				'data' => 'OrderPaymentTransactionNo'
        	),
			
			// Checkout module info
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'CheckoutModuleID'
        	),
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderCheckoutModuleName'
        	),
			
			// Billing info
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderBillingFirstName'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderBillingLastName'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderBillingCompany'
        	),
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderBillingPhone'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderBillingFax'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderBillingAddress1',
				'validator' => array(
					'scValidatorNoEmpty',
        		),
			),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderBillingAddress2'
        	),
        	array(
				'field' => 'scCityNameWidget',
				'data' => 'OrderBillingCity',
       			'properties' => array(
        			'template' => 'admin/widgets/city_name_widget.tmpl',
       				'CityIDFieldId' => 'OrderBillingCityID', 
       				'StateIDFieldId' => 'OrderBillingState',
       				'CountryIDFieldId' => 'OrderBillingCountry',
        			'tabindex' => 9
       				),
        		),
        	array(
        		'field' => 'scEditOrderCityIdWidget',
        		'data' => 'OrderBillingCityID',
        		),
        	array(
				'field' => 'miBaseSelectWidget',
				'data' => 'OrderBillingState'
        	),
			array(
				'field' => 'miBaseSelectWidget',
				'data' => 'OrderBillingCountry'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderBillingZip',
				'validator' => array(
					'scValidatorNoEmpty',
        		),
			),
        	array(
				'field' => 'scVatNumberWidget',
				'data' => 'OrderBillingVatNumber',
			),
        	array(
				'field' => 'miCheckboxWidget',
				'data' => 'OrderShipToBillingAddress',
        		'properties' => array(
        			'id' => 'OrderShipToBillingAddress',
        			'tabindex' => 13
        		),
        	),
			
			// Shipping info
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingFirstName'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingLastName'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingCompany'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingPhone'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingFax'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingAddress1',
				'validator' => array(
					'scValidatorNoEmpty',
        		),
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingAddress2'
        	),
        	array(
				'field' => 'scCityNameWidget',
				'data' => 'OrderShippingCity',
       			'properties' => array(
        			'template' => 'admin/widgets/city_name_widget.tmpl',
       				'CityIDFieldId' => 'OrderShippingCityID', 
       				'StateIDFieldId' => 'OrderShippingState',
       				'CountryIDFieldId' => 'OrderShippingCountry',
        			'tabindex' => 22
       				),
        		),
        	array(
        		'field' => 'scEditOrderCityIdWidget',
        		'data' => 'OrderShippingCityID',
        		),
       		array(
				'field' => 'miBaseSelectWidget',
				'data' => 'OrderShippingState'
        	),
        	array(
				'field' => 'miBaseSelectWidget',
				'data' => 'OrderShippingCountry'
        	),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'OrderShippingZip',
				'validator' => array(
					'scValidatorNoEmpty',
        		),
        	),
        	array(
				'field' => 'scVatNumberWidget',
				'data' => 'OrderShippingVatNumber',
        	),
        );
        
		public function initMainPageElements()
		{
			parent::initMainPageElements();
			$this->addMainPageElements(array(
				'%%MODULENAME%%' => miGetParam('ModuleName'),
				'%%ORDERID%%' => miGetParam('OrderID'),
			));
		}
        
		public function initWebForm(&$form)
		{
			parent::initWebForm($form);
			
			$countryNames = scCountry::getCountryNames();
			$widget = $form->getWidget('OrderShippingCountry');
			$widget->setOptions($countryNames, scSettings::getSettingValue(scSettings::SETTING_DEFAULT_COUNTRY));
			
			$widget = $form->getWidget('OrderShippingVatNumber');
			$widget->setCountryField('OrderShippingCountry');
			
			$widget = $form->getWidget('OrderBillingCountry');
			$widget->setOptions($countryNames, scSettings::getSettingValue(scSettings::SETTING_DEFAULT_COUNTRY));
			
			$widget = $form->getWidget('OrderBillingVatNumber');
			$widget->setCountryField('OrderBillingCountry');
			
			$stateNames = array(0 => '') + scCountry::getStateNames();
			$widget = $form->getWidget('OrderShippingState');
			$widget->setOptions($stateNames);
			
			$widget = $form->getWidget('OrderBillingState');
			$widget->setOptions($stateNames);
			
			$form->addMainPageElements(array('%%STATES_JS_DATA%%' => scUIUtil::getStatesJsData()));
			
			$widget = $form->getWidget('ShippingModuleAndMethod');
			$customerInfo = scEditOrderCart::getCart()->getCustomerInfo();
			$widget->setProperty('countryId', $customerInfo['CustomerShippingCountry']);
			$widget->setProperty('stateId', $customerInfo['CustomerShippingState']);
			$widget->setCart(scEditOrderCart::getCart());
		}
		
		/**
		 * @param miAction $actionObj
		 */
		public function preProcess($actionObj)
		{
			parent::preProcess($actionObj);
			
			if (!($actionObj instanceof scEditOrderListProductsAction) && !($actionObj instanceof scEditOrderCreateBlankOrderAction)) {
				$orderId = (int)miGetParam('OrderID');
				$domainObject = $this->getDomainObject();
				$domainObject->read($orderId);
				
				scEditOrderCart::setCurrentOrderId($orderId);
			}
		}
		
		public function addRedirectToOrderControllerCommand($msg, $msgType, $orderId = 0)
		{
			if ($orderId == 0) {
				$orderId = intval(miGetParam('OrderID'));
			}
			$loc = 'orders.php?action=dmEdit&OrderID=' . $orderId . '&' . $this->getRedirectParams($msg, $msgType);
			$cmd = new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_REDIRECT, $loc);
			$this->addControllerCommand($cmd);
		}
		
		/**
		 * @return scEditOrderDomainObject
		 */
        protected function createDomainObject()
		{
			return new scEditOrderDomainObject();
		}
	}
?>