<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scEditOrderWebForm extends miWebForm {
		
		/**
		 * Validates field by field.
		 * While the field is being validated the _submittedData array contains only what
		 * the field's (widget) getData() method returns.
		 *
		 * @param string $fieldName
		 */
		public function validateField($fieldName)
		{
			$errors = $this->getWebFormErrorsHandler();
			foreach ($this->_formProperties as $key => $field) {
				if ($field['data'] != $fieldName) {
					continue;
				}
				
				$widget = $this->_formFields[$key];
				$widget->validateData($errors);
				
				$originalSubmittedData = $this->_submittedData;
				$this->_submittedData = $widget->getData();
				
				if (isset($this->_validators[$key])) {
					if (is_array($this->_validators[$key])) {
						foreach ($this->_validators[$key] as $validator) {
							$validator->validate($errors);
						}
					} else {
						$this->_validators[$key]->validate($errors);
					}
				}
				
				$this->_submittedData = $originalSubmittedData;
				
				return;
			}
		}
	}
	
	class scEditOrderValidationErrorsHandler extends miWebFormErrorsHandler {
		
		public function getErrors()
		{
			return $this->_errors;
		}
	}
?>