<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	/**
	 * Needed for the implementation of the Observer design pattern.
	 * An observer is attached to an IObservable. Each time the observable's state changes
	 * it calls the Observer's notify() method giving it a reference to itself.
	 */
	interface IObserver {
		
		/**
		 * The observable (a.k.a. subject) notifies the observer that its state has changed.
		 * The observer may do its own processing knowing that the subject has somehow been changed.
		 * @param IObservable $subject
		 */
		public function notify(IObservable $subject);
	}
?>