<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scNewsletterBlast extends scDomainObject {
		
		protected $_recordMlFields = array('BlastToCustomers', 'BlastToSubscribers', 'BlastSubject', 'BlastXhtmlText');
		
		public function __construct()
		{
			$recordLanguages = array_keys(scMultiLanguage::getActiveLanguageCodes());
			
			parent::__construct(new scSqlRecordML('NLBlasts', 'BlastID', $this->_recordMlFields, $recordLanguages));
		}
		
		/**
		 * @return int
		 */
		public function getEmailsCount()
		{
			return (int)scUtil::getDbValue('NLBlastEmails', 'COUNT(BlastEmailID)', 'BlastID', $this->get('BlastID'), 0);
		}
		
		/**
		 * @return int
		 */
		public function getSentEmailsCount()
		{
			$query = 'SELECT COUNT(BlastEmailID) AS N FROM NLBlastEmails WHERE BlastID = ? AND BlastEmailStatus IN (?, ?)';
			$result = miStaticDBUtil::execSelect($query, array($this->get('BlastID'), scNewsletterBlastEmail::STATUS_SENT, scNewsletterBlastEmail::STATUS_FAILED));
			if (!isset($result[0]) || !isset($result[0]['N'])) {
				return 0;
			}
			return (int)$result[0]['N'];
		}
		
		public function get($name, $languageId = null)
		{
			$value = parent::get($name);
			
			if (!empty($languageId) && in_array($name, array_merge($this->_recordMlFields, array('LanguageID'))))
				return $value[$languageId];
			
			return $value;
		}
	}
?>