<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scNewsletterSubscribersView extends scView {
		
		protected $_domainObjectDisplayName = 'Subscriber'; // _t('Subscriber');
		
		protected $_templates = array(
			self::TEMPLATE_ID_EDIT => 'modules/system/newsletter/admin/newsletter_subscriber_edit.tmpl',
		);
		
		protected $_dataFields = array(
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'SubscriberID',
			),
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'SubscriberEmail',
				'displayName' => 'Email',
			),
			array(
				'field' => 'miSelectWidget',
				'data' => 'LanguageID',
				'displayName' => 'Language',
			),
			array(
				'field' => 'miCheckboxWidget',
				'data' => 'SubscriberIsActive',
				'displayName' => 'Is Active',
			),
		);
		
		public function __construct()
		{
			$this->_persistVars[] = 'ModuleName';
			
			parent::__construct();
		}
		
		public function initMainPageElements()
		{
			parent::initMainPageElements();
			
			$this->addMainPageElements(array('%%ALL_PARAMS%%' => miAppFactory::singleton()->getStateObj()->getStateUrlParams()));
		}
		
		public function initWebForm(&$form)
		{
			parent::initWebForm($form);
			
			$widget = $form->getWidget('LanguageID');
			$widget->setOptions(scMultiLanguage::getActiveLanguageNames());
		}
		
		protected function createDomainObject()
		{
			return new scNewsletterSubscriber();
		}
	}
?>