<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scNewsletterBaseView extends scView {
		
		public function __construct()
		{
			$this->_persistVars[] = 'ModuleName';
			
			parent::__construct();
		}
		
		public function initMainPageElements()
		{
			parent::initMainPageElements();
			
			$this->addMainPageElements(array('%%ALL_PARAMS%%' => miAppFactory::singleton()->getStateObj()->getStateUrlParams()));
		}
		
		protected function createDomainObject()
		{
			return new scNewsletter();
		}
		
		protected $_domainObjectDisplayName = 'Newsletter';	// _t('Newsletter');
	}
	
	class scNewsletterAdminView extends scNewsletterBaseView {
		
		const TEMPLATE_ID_TEST = 'test';
		const TEMPLATE_ID_BLAST = 'blast';
		const TEMPLATE_ID_BLAST_PROGRESS = 'blast_progress';
		const TEMPLATE_ID_BLAST_VIEW = 'blast_view';
		const TEMPLATE_ID_STATS = 'stats';
		const TEMPLATE_ID_STATS_BLAST = 'stats_blast';
		const TEMPLATE_ID_ADD_SUBSCRIBERS = 'add_subscribers';
		
		const DEFAULT_NEWSLETTER_DESCRIPTIONS_XHTML = 0;
		
		protected $_templates = array(
			self::TEMPLATE_ID_LIST => 'modules/system/newsletter/admin/newsletter_mgmt.tmpl',
			self::TEMPLATE_ID_CREATE => 'modules/system/newsletter/admin/newsletter_create.tmpl',
			self::TEMPLATE_ID_EDIT => 'modules/system/newsletter/admin/newsletter_edit.tmpl',
			self::TEMPLATE_ID_TEST => 'modules/system/newsletter/admin/newsletter_test.tmpl',
			self::TEMPLATE_ID_BLAST => 'modules/system/newsletter/admin/newsletter_blast.tmpl',
			self::TEMPLATE_ID_BLAST_PROGRESS => 'modules/system/newsletter/admin/newsletter_blast_progress.tmpl',
			self::TEMPLATE_ID_BLAST_VIEW => 'modules/system/newsletter/admin/newsletter_blast_view.tmpl',
			self::TEMPLATE_ID_ADD_SUBSCRIBERS => 'modules/system/newsletter/admin/newsletter_subscriber_add.tmpl',
			self::TEMPLATE_ID_STATS => 'modules/system/newsletter/admin/newsletter_stats.tmpl',
			self::TEMPLATE_ID_STATS_BLAST => 'modules/system/newsletter/admin/newsletter_stats_blast.tmpl',
		);
		
		protected $_dataFields = array(
			array(
				'field' => 'miBaseTextWidget',
				'data' => 'NewsletterID',
			),
			array(
				'field' => 'scWebFormWidgetTextML',
				'data' => 'NewsletterName',
			),
			array(
				'field' => 'scWebFormWidgetTextML',
				'data' => 'NewsletterSubject',
			),
			array(
				'field' => 'scWebFormWidgetTextAreaML',
				'data' => 'NewsletterXhtmlText',
			),
			array(
				'field' => 'miCheckboxWidget',
				'data' => 'NewsletterIsActive',
			),
			array(
				'field' => 'scMultiCheckboxWidget',
				'data' => 'NewsletterOptions',
			),
		);
		
		/**
		 * @param miAction $table
		 */
		public function preProcess($actionObj)
		{
			parent::preProcess($actionObj);
			
			if ($this->getController()->getDispatcher()->getAction() == 'dmChangeIsActive') {
				$actionObj->setFieldName('NewsletterIsActive');
			}
		}
		
		/**
		 * @param miTable $table
		 */
		public function initTable($table)
		{
			parent::initTable($table);
			
			new scTableRecordsPerPage($table, $this->getTablePagerObj());
		}
		
		/**
		 * @param miWebForm $form
		 */
		public function initWebForm(&$form)
		{
			parent::initWebForm($form);
			
			$widget = $form->getWidget('NewsletterOptions');
			$defaultOptions = scNewsletterOptions::ENABLE_OPEN_TRACKING
				| scNewsletterOptions::ENABLE_CLICK_TRACKING
				| scNewsletterOptions::CHECKED_BY_DEFAULT;
			$widget->setOptions(scNewsletterOptions::getArray(), $defaultOptions);
			
			$widget = $form->getWidget('NewsletterIsActive');
			$widget->setDefaultValue(true);
			
			// Add ML
			$this->addMainPageElements(array(
				'%%HTML_DATA_LANGUAGES%%' => $this->getDataLanguagesHtml(false),
				'%%LANGUAGEID%%' => scView::getCurrentDataLanguageId(),
				'%%CKEDITOR_CONTENTCSS%%' => scSkins::singleton()->getCurrentSkin()->getCssFilesForWysiwygEditor(),
				'%%CKEDITOR_LANGUAGE%%' => scCMS::getCkEditorLanguage()
			));
		}
	}
?>