<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	 
	 class scRelatedProductsDetails implements IProductDetails {
		
		public function getProductDetailsHtml(scProductSL $product, miTemplateParserSectionInfo $productSection)
		{
			// We check if there are any related products first. From performance perspective, if most of the products don't have related checking first
			$sql = 'SELECT * FROM RelatedProducts WHERE ProductID = ' . $product->get('ProductID') . ' ORDER BY RelatedProductSort';
			$productIds = miUtil::getDbArray($sql, 'RelatedProductID', 'RelatedProductID');
			if (!count($productIds))
				return '';
			
			// Now get the related products
			$hideOutOfStockSql = scProductService::hideOutOfStock() ? 'AND ProductQuantity > 0 ' : '';
			$variantSql = 'LEFT JOIN ProductVariants ON (ProductVariants.ProductID = Products.ProductID AND ProductVariantIsDefault<>0) ';
			
			$sql = 'SELECT Products.*, ProductsML.*, ProductImages.*, ProductVariants.*, Products.ProductID AS ProductID, Products.ProductID AS ProductIDSort, Products.CategoryID AS CategoryID' .
				' FROM RelatedProducts JOIN Products ON RelatedProductID=Products.ProductID' .
				' LEFT JOIN ProductsML ON(Products.ProductID = ProductsML.ProductID)' .
				' LEFT JOIN ProductImages ON(Products.ProductID = ProductImages.ProductID AND ProductImageIsDefault<>0)' .
				$variantSql .
				' WHERE LanguageID = ?' .
				' AND ProductIsActive <> 0 ' . $hideOutOfStockSql .
				' AND RelatedProducts.ProductID=?' .
				' ORDER BY RelatedProductSort';
			$products = miStaticDBUtil::execSelect($sql, array(scMultiLanguage::getCurrentLanguageId(), $product->get('ProductID')));
			if (!count($products)) {
				return '';
			}
			
			$relatedProductsSection = scProductService::getProductSections('relatedProducts', $products);
			
			$productSection->addSubsection(new miTemplateParserSectionInfo('productHasRelatedProducts', 1));
			
			$t = new scTemplateParser();
			$t->readTemplate('modules/system/related_products/related_products.tmpl');
			$t->addSectionInfo($relatedProductsSection);
			return $t->templateParse();
		}
	}
?>