<?php
	/**
	 * Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	class scRssFeedNews implements IRssFeed {
		
		/**
		 * Returns array containing all fields for the RSS listing
		 * 
		 * @param int $languageId the language id we need the feed in
		 * @return array
		 */
		public function getRssFeedItems($languageId)
		{
			$recordset = new scSqlRecordsetML('News', 'NewsID');
			$recordset->setLanguageId($languageId);
			$recordset->setSelectFields(array(
				'*',
				'UNIX_TIMESTAMP(NewsDate) AS NewsTimestamp'
			));
			$recordset->addFilter(new miSqlFilterEqual('NewsIsActive', 1));
			$recordset->setOrder('NewsDate', 'DESC');
			$recordset->setRecordsLimit(0, scRssFeedsModule::RSS_RESULTS_COUNT);
			$rows = $recordset->getRecords();
			
			scDateTime::setTimezone();
			
			$items = array();
			foreach ($rows as $row) {
				$item['HTML_ItemTitle'] = $row['NewsTitle'];
				$item['HTML_ItemDescription'] = $row['NewsContents'];
				
				$item['ItemTitle'] = strip_tags($row['NewsTitle']);
				$item['ItemDescription'] = strip_tags($row['NewsContents']);
				
				$item['ItemPubDate'] = date('D, d M Y H:i:s O', $row['NewsTimestamp']);
				
				$item['HTML_Enclosure'] = '';
				$url = scFriendlyUrl::get(scFriendlyUrl::TYPE_NEWS, $row['NewsID'], $row['NewsTitle']);
				$item['HTML_ItemLink'] = scXml::escape(scPaths::getUrl($url));
				
				$items[] = $item;
			}
			return $items;
		}
	}
?>