<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('include/miphpf/Init.php');
	require_once('include/sc/Init.php');
	
	scSession::singleton()->openSession();
	
	class scUserRichTextPage implements ICMSBlock {
		protected $_richTextPageRows;
		
		public function __construct()
		{
			$pageId = (int)miGetParamDefault('PageID', 0);
			
			$sql = 'SELECT * FROM CMSRichTextPages JOIN CMSRichTextPagesML USING(CMSRichTextPageID) ' .
				'WHERE CMSRichTextPages.CMSRichTextPageID=? AND LanguageID=?';
			$this->_richTextPageRows = miStaticDBUtil::execSelect($sql, array($pageId, scMultiLanguage::getCurrentLanguageId()));
		}
		
		public function getControllerCommands()
		{
			if (count($this->_richTextPageRows) == 0) {
				$url = scPaths::getStoreWebPath() . 'error.php?msg=' . urlencode(_t('Page not found.'));
				return array(new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_REDIRECT, $url));
			}
			
			$t = new scTemplateParser();
			$t->readTemplate('customer/page.tmpl');
			$t->assignArray(miUIUtil::templetizeRows($this->_richTextPageRows[0]));
			$html = $t->templateParse();
			
			return array(new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_HTML, $html));
		}
	}
	
	$userRichTextPage = new scUserRichTextPage;
	$page = new scUserDisplayController(array($userRichTextPage));
	$page->setSeo(new scRichTextPageSeo());
	$page->showPage();
?>