<?php
	/**
	 * Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('include/miphpf/Init.php');
	require_once('include/sc/Init.php');
	
	scSession::singleton()->openSession();
		
	class scUserPagePoints implements ICMSBlock {
		
		const RECORDS_PER_PAGE = 20;
		
		public function getControllerCommands()
		{
			miAppFactory::singleton()->getStateObj()->setPersistVars(array(
				'page'
			));
			
			$customer = scCustomerAuth::singleton()->getCustomer();
			
			if (!scCustomerAuth::singleton()->isLoggedIn() or ($customer === false)) {
				$loginUrl = scFriendlyUrl::get(scFriendlyUrl::TYPE_DYNAMIC_PAGE, scFriendlyUrl::DYN_PAGE_LOGIN);
				$pointsUrl = scFriendlyUrl::get(scFriendlyUrl::TYPE_DYNAMIC_PAGE, scFriendlyUrl::DYN_PAGE_POINTS);
				$loginUrl = scUrlUtil::addQueryParams($loginUrl, 'Referer=' . urlencode($pointsUrl));
				return array(new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_REDIRECT, $loginUrl));
			}
			
			scDateTime::setTimezone();
			
			$recordset = new miSqlRecordset('BonusPointsTransactions');
			$recordset->addFilter(new miSqlFilterEqual('CustomerID', scCustomerAuth::singleton()->getCustomerId()));
			$recordset->setOrder('BonusPointsTransactionTime', 'DESC');
			$recordset->setRecordsLimit(scCustomerAreaPager::getLimitOffset('page', self::RECORDS_PER_PAGE), self::RECORDS_PER_PAGE);
			
			list($pageNum, $totalPages) = scCustomerAreaPager::calculatePages('page', $recordset->getRecordsCount(), self::RECORDS_PER_PAGE);
			
			$table = new scBonusPointsTransactionsTable($recordset);
			$pointsUrl = scFriendlyUrl::get(scFriendlyUrl::TYPE_DYNAMIC_PAGE, scFriendlyUrl::DYN_PAGE_POINTS);
			$table->addMainPageElements(array(
				'%%CUSTOMERBONUSPOINTS%%' => $customer->get('CustomerBonusPoints'),
				'%%HTML_PAGER%%' => scCustomerAreaPager::getPaging($pageNum, $totalPages, $pointsUrl),
				'%%CUSTOMER_ADDRESSES_COUNT%%' => scCustomerAddress::getAddressesCountByCustomerId($_SESSION['CustomerID']),
				'%%CUSTOMER_ORDERS_COUNT%%' => scCustomerOrdersUI::getOrdersCountByCustomerId($_SESSION['CustomerID'])
			));
			$html = $table->parse('customer/myaccount/points.tmpl');
			
			return array(new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_HTML, $html));
		}
	}
	
	$userPagePoints = new scUserPagePoints();
	$page = new scUserDisplayController(array($userPagePoints));
	$page->setSeo(new scDynamicPageSeo('points.php', _t('Points')));
	$page->showPage();
?>