<?php
	/**
	 * Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.
	 */
	
	require_once('include/miphpf/Init.php');
	require_once('include/sc/Init.php');
	
	scSession::singleton()->openSession();
	
	class scUserPageRegister extends miDefaultView implements ICMSBlock {
		protected $_dataFields = array(
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'CustomerEmail',
				'validator' => array('scValidatorNoEmpty', 'scValidatorEmail'),
        		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'CustomerPassword',
				'validator' => array('scValidatorNoEmpty', 'scValidatorConfirmCustomerPassword'),
        		),
        		
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'CustomerBillingFirstName',
				'validator' => 'scValidatorNoEmpty',
        		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'CustomerBillingLastName',
				'validator' => 'scValidatorNoEmpty',
				),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'CustomerBillingCompany',
        		),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'CustomerBillingPhone',
				'validator' => 'scValidatorNoEmpty',
        		),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'CustomerBillingFax',
        		),
        	
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'CustomerBillingAddress1',
				'validator' => 'scValidatorNoEmpty',
				),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'CustomerBillingAddress2'
        		),
       		array(
				'field' => 'scCityNameWidget',
				'data' => 'CustomerBillingCity',
       			'validator' => 'scValidatorNoEmpty',
       			'properties' => array(
       				'template' => 'customer/widgets/city_name_widget.tmpl',
       				'CityIDFieldId' => 'CustomerBillingCityID', 
       				'StateIDFieldId' => 'CustomerBillingState',
       				'CountryIDFieldId' => 'CustomerBillingCountry',
       				'tabindex' => 12,
       				),
        		),
        	array(
        		'field' => 'miBaseTextWidget',
        		'data' => 'CustomerBillingCityID',
        		),
       		array(
				'field' => 'scStateSelectWidget',
				'data' => 'CustomerBillingState',
				'properties' => array('id' => 'CustomerBillingState', 'originalValueField' => 'OriginalCustomerBillingState', 'tabindex' => 11)
        		),
			array(
				'field' => 'miBaseSelectWidget',
				'data' => 'CustomerBillingCountry',
				'properties' => array('id' => 'CustomerBillingCountry')
        		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'CustomerBillingZip',
				'validator' => 'scValidatorNoEmpty',
        		),
       		array(
				'field' => 'scVatNumberWidget',
				'data' => 'CustomerBillingVatNumber',
        		),
       		array(
				'field' => 'miCheckboxWidget',
				'data' => 'CustomerShipToBillingAddress',
				'properties' => array('id' => 'CustomerShipToBillingAddress', 'defaultValue' => true, 'tabindex' => 16)
        		),
        	
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'CustomerShippingFirstName',
				'validator' => 'scValidatorNoEmpty',
        		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'CustomerShippingLastName',
				'validator' => 'scValidatorNoEmpty',
        		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'CustomerShippingCompany',
        		),
        	array(
				'field' => 'miBaseTextWidget',
				'data' => 'CustomerShippingPhone',
				'validator' => 'scValidatorNoEmpty',
        		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'CustomerShippingFax',
        		),
        	
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'CustomerShippingAddress1',
				'validator' => 'scValidatorNoEmpty',
        		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'CustomerShippingAddress2'
        		),
       		array(
				'field' => 'scCityNameWidget',
				'data' => 'CustomerShippingCity',
       			'validator' => 'scValidatorNoEmpty',
       			'properties' => array(
       				'template' => 'customer/widgets/city_name_widget.tmpl',
       				'CityIDFieldId' => 'CustomerShippingCityID', 
       				'StateIDFieldId' => 'CustomerShippingState',
       				'CountryIDFieldId' => 'CustomerShippingCountry',
       				'tabindex' => 29,
       				),
        		),	
        	array(
        		'field' => 'miBaseTextWidget',
        		'data' => 'CustomerShippingCityID',
        		),
       		array(
				'field' => 'scStateSelectWidget',
				'data' => 'CustomerShippingState',
				'properties' => array('id' => 'CustomerShippingState', 'originalValueField' => 'OriginalCustomerShippingState', 'tabindex' => 28)
        		),
       		array(
				'field' => 'miBaseSelectWidget',
				'data' => 'CustomerShippingCountry',
				'properties' => array('id' => 'CustomerShippingCountry')
        		),
       		array(
				'field' => 'miBaseTextWidget',
				'data' => 'CustomerShippingZip',
				'validator' => 'scValidatorNoEmpty',
        		),
       		array(
				'field' => 'scVatNumberWidget',
				'data' => 'CustomerShippingVatNumber',
        		),
        	array(
        		'field' => 'scNewslettersWidget',
        		'data' => 'Newsletters',
        		'properties' => array(
					'template' => 'customer/widgets/newsletters_widget.tmpl'
					),
        		),
        );
        
		public function getControllerCommands()
		{
			$action = miGetParamDefault('action', '');
			
			// If already logged in don't allow registering
			if (scCustomerAuth::singleton()->isLoggedIn() and ($action != 'RegisterSuccess')) {
				$loc = scFriendlyUrl::get(scFriendlyUrl::TYPE_DYNAMIC_PAGE, scFriendlyUrl::DYN_PAGE_PROFILE);
				return array(new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_REDIRECT, $loc));
			}
			
			if ($action == 'ExecRegister')
				$r = new scExecRegisterAction($this);
			elseif ($action == 'RegisterSuccess')
				$r = new scRegisterSuccessAction($this);
			else
				$r = new scRegisterAction($this);
			
			$r->doAction();
			
			return parent::getControllerCommands();
		}
		
		public function initWebForm(&$form)
		{
			parent::initWebForm($form);
			$form->setErrorsHandler(new scByFieldErrorsHandler);
			
			$countryNames = scCountry::getCountryNames();
			$field = $form->getWidget('CustomerBillingCountry');
			$field->setOptions($countryNames, scSettings::getSettingValue(scSettings::SETTING_DEFAULT_COUNTRY));
			
			$field = $form->getWidget('CustomerBillingVatNumber');
			$field->setCountryField('CustomerBillingCountry');
			
			$field = $form->getWidget('CustomerShippingCountry');
			$field->setOptions($countryNames, scSettings::getSettingValue(scSettings::SETTING_DEFAULT_COUNTRY));
			
			$field = $form->getWidget('CustomerShippingVatNumber');
			$field->setCountryField('CustomerShippingCountry');
			
			$stateNames = array(0 => '') + scCountry::getStateNames();
			$field = $form->getWidget('CustomerBillingState');
			$field->setOptions($stateNames);
			
			$field = $form->getWidget('CustomerShippingState');
			$field->setOptions($stateNames);
			
			// Captcha
			if (scSettings::getSettingValue(scSettings::SETTING_CAPTCHA_ON_REGISTER)) {
				$captcha = new scCaptchaWidget($form);
				$captcha->setProperty('id', 'captcha');
				$captcha->setFieldName('captcha');
				$form->addTemplateSectionInfo(new miTemplateParserSectionInfo('captcha', 1, miUIUtil::templetizeRows($captcha->getEditableControl())));
			}
			
			$form->addMainPageElements(array('%%STATES_JS_DATA%%' => scUIUtil::getStatesJsData()));
			
			$form->addValidator('CustomerEmail', new scValidatorUniqueFields($form, array('CustomerEmail'), $this->getRecord()));
			$form->addValidator('CustomerBillingCity', new scAddressValidator($form, 'CustomerBillingCityID', 'CustomerBillingCountry'));
			$form->addValidator('CustomerShippingCity', new scAddressValidator($form, 'CustomerShippingCityID', 'CustomerShippingCountry'));
		}
	}
	
	class scRegisterAction extends miAction {
		public function doAction()
		{
			$form = new miWebForm(array());
			$this->_view->initWebForm($form);

			// Assign dynamic page areas values
			$form->addMainPageElements(scDynamicPages::getTemplateVars('register.php'));
			
			if (miGetParamDefault('Referer', '') != '') {
				$referer = miGetParamDefault('Referer', '');
			} else {
				$referer = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '';
			}
			$form->addMainPageElements(array(
				'%%REFERER%%' => miI18N::htmlEscape($referer),
				'%%ENCODED_REFERER%%' => urlencode($referer),
			));
			
			$html = $form->parse('customer/register/register.tmpl', true);
			$cmd = new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_HTML, $html);
			$this->_view->addControllerCommand($cmd);
		}
	}
	
	class scExecRegisterAction extends miActionWithWebForm {
		protected function setShippingAddress($form)
		{
			miSetParam('CustomerShippingFirstName', miGetParamDefault('CustomerBillingFirstName', ''));
			miSetParam('CustomerShippingLastName', miGetParamDefault('CustomerBillingLastName', ''));
			miSetParam('CustomerShippingCompany', miGetParamDefault('CustomerBillingCompany', ''));
			miSetParam('CustomerShippingPhone', miGetParamDefault('CustomerBillingPhone', ''));
			miSetParam('CustomerShippingFax', miGetParamDefault('CustomerBillingFax', ''));
			miSetParam('CustomerShippingAddress1', miGetParamDefault('CustomerBillingAddress1', ''));
			miSetParam('CustomerShippingAddress2', miGetParamDefault('CustomerBillingAddress2', ''));
			miSetParam('CustomerShippingCity', miGetParamDefault('CustomerBillingCity', ''));
			miSetParam('CustomerShippingCityID', miGetParamDefault('CustomerBillingCityID', ''));
			miSetParam('CustomerShippingState', miGetParamDefault('CustomerBillingState', ''));
			miSetParam('CustomerShippingCountry', miGetParamDefault('CustomerBillingCountry', ''));
			miSetParam('CustomerShippingZip', miGetParamDefault('CustomerBillingZip', ''));
			miSetParam('CustomerShippingVatNumber', miGetParamDefault('CustomerBillingVatNumber', ''));
			
			// Remove validators
			$form = $this->getWebForm();
			$form->removeValidators('CustomerShippingFirstName');
			$form->removeValidators('CustomerShippingLastName');
			$form->removeValidators('CustomerShippingPhone');
			$form->removeValidators('CustomerShippingFax');
			$form->removeValidators('CustomerShippingAddress1');
			$form->removeValidators('CustomerShippingAddress2');
			$form->removeValidators('CustomerShippingCity');
			$form->removeValidators('CustomerShippingCityID');
			$form->removeValidators('CustomerShippingState');
			$form->removeValidators('CustomerShippingCountry');
			$form->removeValidators('CustomerShippingZip');
			$form->removeValidators('CustomerShippingVatNumber');
		}
		
		protected function validateCaptcha()
		{
			$captchaSecurity = new scCaptchaSecurity();
			$code = $captchaSecurity->getCode();
			
			if (empty($code) || (strtolower($code) != strtolower(miGetParam('captcha')))) {
				$err = $this->getWebForm()->getWebFormErrorsHandler();
				$err->addError('captcha', _t('Security code does not match.'));
				return false;
			}
			
			return true;
		}
		
		public function doAction()
		{
			try {
				miStaticDBUtil::startTransaction();
				
				$form = $this->getWebForm();
				
				// Set the shipping address to be the same as the billing address and clear the shipping address validators
				$shipToBillingAddress = miGetParamDefault('CustomerShipToBillingAddress', false);
				if ($shipToBillingAddress)
					$this->setShippingAddress($form);
				
				$isOk = $form->processSubmit();
				
				if (scSettings::getSettingValue(scSettings::SETTING_CAPTCHA_ON_REGISTER))
					$isOk = ($isOk && $this->validateCaptcha()); // Keep the parenthesis!
				
				if ($isOk === false) {
					// save entered data so the user should not fill all fields once again
					$form->setFormDataRow($form->getSubmittedDataRow());
					
					// Assign dynamic page areas values
					$form->addMainPageElements(scDynamicPages::getTemplateVars('register.php'));
					
					$referer = miGetParamDefault('Referer', '');
					$form->addMainPageElements(array(
						'%%REFERER%%' => miI18N::htmlEscape($referer),
						'%%ENCODED_REFERER%%' => urlencode($referer),
					));
			 	
					$this->showForm($form, 'customer/register/register.tmpl', true);
					return false;
				}
				
				// Create the customer record
				$customer = new scCustomerDomainObject();
				$customer->setRow($form->getSubmittedDataRow());
				$customer->set('CustomerStatus', scCustomerStatuses::CUSTOMER_STATUS_ACTIVE);
				$customer->set('CustomerGroupID', scSettings::getSettingValue(scSettings::SETTING_DEFAULT_CUSTOMER_GROUP));
				scBonusPoints::setNewCustomerReferrer($customer);
				$customerId = $customer->insert();
				
				$customerAddress = new scCustomerAddress();
				$customerAddress->set('CustomerID', $customerId);
				$customerAddress->set('CustomerAddressIsDefaultBilling', 1);
				$customerAddress->set('CustomerAddressIsDefaultShipping', ($shipToBillingAddress == '') ? 0 : 1);
				$mapping = scCustomerAddress::getAddressFields(scCustomerAddress::BILLING);
				foreach ($mapping as $billingField => $addressField) {
					$customerAddress->set($addressField, $form->getSubmittedData($billingField));
				}
				$customerAddress->insert();
				
				if (!$shipToBillingAddress) {
					$customerAddress = new scCustomerAddress();
					$customerAddress->set('CustomerID', $customerId);
					$customerAddress->set('CustomerAddressIsDefaultBilling', 0);
					$customerAddress->set('CustomerAddressIsDefaultShipping', 1);
					$mapping = scCustomerAddress::getAddressFields(scCustomerAddress::SHIPPING);
					foreach ($mapping as $shippingField => $addressField) {
						$customerAddress->set($addressField, $form->getSubmittedData($shippingField));
					}
					$customerAddress->insert();
				}
				
				$this->newslettersSubscribe($customer, miGetParamDefault('Newsletters', array()));
				
				// Send email
				$notifications = new scEmailNotifications();
				$notifications->sendSignupNotification($customerId);
				
				miStaticDBUtil::commit();
				
				// Log in the customer
				$auth = scCustomerAuth::singleton();
				$auth->logIn($customerId);
				scCart::getCart()->setCustomerInfo($customer->getRow());
				
			} catch (Exception $exception) {
				miStaticDBUtil::rollback();
				
				$url = scPaths::getStoreWebPath() . 'error.php?msg=' . urlencode(sprintf(_t('Register failed: %s'), $exception->getMessage()));
				$cmd = new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_REDIRECT, $url);
				$this->_view->addControllerCommand($cmd);
				return false;
			}
			
			$referer = miGetParamDefault('Referer', '');
			
			$url = scFriendlyUrl::get(scFriendlyUrl::TYPE_DYNAMIC_PAGE, scFriendlyUrl::DYN_PAGE_REGISTER);
			$url = scUrlUtil::addQueryParams($url, 'action=RegisterSuccess' . (($referer != '')  ? '&Referer=' . urlencode($referer) : ''));
			
			$cmd = new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_REDIRECT, $url);
			$this->_view->addControllerCommand($cmd);
			return true;
		}
		
		protected function newslettersSubscribe(scCustomerDomainObject $customer, $newsletters)
		{
			if (empty($newsletters))
				return;
			
			try {
				$moduleId = scModulesFactory::getModuleIdByName('com.summercart.newsletter');
				scModulesFactory::getImplementation($moduleId, 'IUserModule');
				
				foreach ($newsletters as $newsletterId => $subscribe) {
					if (!(bool)$subscribe) {
						continue;
					}
					
					$newsletter = new scNewsletter();
					$newsletter->read($newsletterId);
					$newsletter->subscribe($customer->get('CustomerEmail'), $customer->get('CustomerID'));
				}
			} catch (miException $e) {
				throw new miException(sprintf(_t('Failed to subscribe to newsletter: %s'), $e->getMessage()));
			}
		}
	}
	
	class scRegisterSuccessAction extends miAction {
		public function doAction()
		{
			$form = new miWebForm(array());
			$this->_view->initWebForm($form);

			// Assign dynamic page areas values
			$form->addMainPageElements(scDynamicPages::getTemplateVars('register.php')); 	
			
			$referer = miGetParamDefault('Referer', '');
			$parsed = scUrlUtil::parse($referer);
			if (isset($parsed[scUrlUtil::HOST]) && ($parsed[scUrlUtil::HOST] != $_SERVER['SERVER_NAME'])) {
				$referer = scFriendlyUrl::get(scFriendlyUrl::TYPE_DYNAMIC_PAGE, scFriendlyUrl::DYN_PAGE_INDEX);
			} else if (isset($parsed[scUrlUtil::PATH]) && (scUrlResolver::singleton()->is($parsed[scUrlUtil::PATH], scFriendlyUrl::TYPE_DYNAMIC_PAGE, scFriendlyUrl::DYN_PAGE_LOGIN))) {
				$referer = scFriendlyUrl::get(scFriendlyUrl::TYPE_DYNAMIC_PAGE, scFriendlyUrl::DYN_PAGE_INDEX);
			}
			
			$form->addMainPageElements(array(
				'%%REFERER%%' => miI18N::htmlEscape($referer),
				'%%ENCODED_REFERER%%' => urlencode($referer),
			));
			
			$html = $form->parse('customer/register/register_success.tmpl', false);
			$cmd = new miControllerCommand(miControllerCommand::CONTROLLER_COMMAND_HTML, $html);
			$this->_view->addControllerCommand($cmd);
		}
	}
	
	class scValidatorConfirmCustomerPassword extends miValidator {
		public function validate(miWebFormErrorsHandler &$errors)
		{
			$fieldValue = $this->_webForm->getSubmittedData($this->_fieldName);
			
			if ($fieldValue != miGetParamDefault('CustomerPasswordConfirm', ''))
				$errors->addError($this->_fieldName, _t('Passwords do not match!'));
		}
	}
	
	$userPageRegister = new scUserPageRegister(null);
	$userPageRegister->setRecord(new miSqlRecord('Customers', 'CustomerID'));
	$page = new scUserDisplayController(array($userPageRegister));
	$page->setSeo(new scDynamicPageSeo('register.php', _t('Register')));
	$page->showPage();
?>