// Copyright (c) 2008 Mirchev Ideas Ltd. All rights reserved.

SC.Discounts = new function()
{
	this.addItem = function(items, itemName, itemID) {
		var text = $('#' + itemName).val();
		var value = $('#' + itemID).val();
		
		if (text != '' && value != '' && !this.isValue(items, value)) {
		    $('#' + items).append(
				$('<option/>').attr('value', value).text(text)
		    );
		    return;
		}
		
		if (items == 'Customers')
			alert('Please enter a few letters from the customer name first and select a customer from the list.');

		if (items == 'Manufacturers')
			alert('Please enter a few letters from the manufacturer name first and select a manufacturer from the list.');
	}
	
	this.removeItems = function(items) {
	    $('#' + items + '>option:selected').remove();
	}
	
	this.isValue = function(items, value)
	{
	    var options = $('#' + items + '>option');
	    for (var i = 0; i < options.length; i++) {
			if ($(options[i]).val() == value)
		    	return true;
	    }

	    return false;
	}
	
	this.selectItems = function(items)
	{
	    $('#' + items + '>option').each(function() {
			this.selected = true;
	    });
	}
	
	this.showNumItems = function(items, countElem)
	{
	    var length = $('#' + items + '>option').length;
	    if (length == 0)
			length = '<mi:text>All</mi:text>';
	    countElem.html(String(length));
	}
	
	this.copySelected = function(fromId, toId)
	{
		SC.DMS.productCategoryLeftToRight(fromId, toId);
		SC.Discounts.showNumItems('CategoriesSelectedId', $('#CategoriesCount'));
		SC.Discounts.showNumItems('CustomerGroupsSelectedId', $('#CustomerGroupsCount'));
	}
	
	this.removeSelected = function(fromId)
	{
		SC.DMS.removeSelected(fromId);
		SC.Discounts.showNumItems('CategoriesSelectedId', $('#CategoriesCount'));
		SC.Discounts.showNumItems('CustomerGroupsSelectedId', $('#CustomerGroupsCount'));
	}
	
	this.onDiscountTypeChange = function (radioButton) {
		if (radioButton.checked && radioButton.value == 2) {
			$('#valueRow').hide();
			$('#appliesToRow').hide();
			$('#paymentModuleRow').hide();
			$('#freeShippingRow').show();
		} else {
			$('#freeShippingRow').hide();
			$('#valueRow').show();
			$('#appliesToRow').show();
			$('#paymentModuleRow').show();
		}
	}
	
	this.onDiscountApplyModeChange = function (radioButton) {
		if (radioButton.checked && radioButton.value == 2) {
			$('#paymentModuleRow').hide();
		} else {
			$('#paymentModuleRow').show();
		}
	}
}


$(document).ready( function() {

	var autocompleteSettings = {
		delay: 150,
		maxItemsToShow: 10, 
		width: 260,
		cacheLength: 1,
		matchSubset: false,
		selectFirst: true			
	};
	
	SC.Util.setDatePicker();

	$("#tabContainer").tabs(1);
	$("#tabContainer").css("display", "");
	
	// select all options
	$("#mainform").submit(function() {
		SC.DMS.selectAll("Categories");
		SC.Discounts.selectItems("Products");
		SC.Discounts.selectItems("Customers");
		SC.DMS.selectAll("CustomerGroups");
		SC.Discounts.selectItems("Manufacturers");
	});
	
	// Autocomplete products
	$("#ProductName").result(function(event, data, formatted) {
		$("#ProductID").val(data[1]);
	});
	$("#ProductName").autocomplete('ajax/GetProductsByString.php', autocompleteSettings);
	
	// Autocomplete customer
	$("#CustomerName").result(function(event, data, formatted) {
		$("#CustomerID").val(data[1]);
	});
	$("#CustomerName").autocomplete('ajax/GetCustomersByString.php', autocompleteSettings);
	
	// Autocomplete manufacturer
	$("#ManufacturerName").result(function(event, data, formatted) {
		$("#ManufacturerID").val(data[1]);
	});
	$("#ManufacturerName").autocomplete('ajax/GetManufacturersByString.php', autocompleteSettings);
	
	$('[name=DiscountType]').change(function () {SC.Discounts.onDiscountTypeChange(this);}).trigger('change');
	$('[name=CouponType]').change(function () {SC.Discounts.onDiscountTypeChange(this);}).trigger('change');
	
	$('[name=DiscountApplyMode]').change(function () {SC.Discounts.onDiscountApplyModeChange(this);}).trigger('change');
	
	// Order subtotal exceeds checkbox
	if ($('#ConditionOrderExceeds').val() != '') {
		$('#OrderSubtotalExceedsCheckbox').attr('checked', 'checked');
	} else {
		document.getElementById('ConditionOrderExceeds').disabled = true;
	}
	$('#OrderSubtotalExceedsCheckbox').click(function() {
		document.getElementById('ConditionOrderExceeds').disabled = !this.checked;
	});
	
	// Display Counts
	SC.Discounts.showNumItems('Products', $('#ProductsCount'));
	SC.Discounts.showNumItems('Customers', $('#CustomersCount'));
	SC.Discounts.showNumItems('CustomerGroupsSelectedId', $('#CustomerGroupsCount'));
	SC.Discounts.showNumItems('Manufacturers', $('#ManufacturersCount'));
	SC.Discounts.showNumItems('CategoriesSelectedId', $('#CategoriesCount'));
	
	// Setup the buttons
	$('#addProductButton').click(function() {
		SC.Discounts.addItem('Products', 'ProductName', 'ProductID');
		SC.Discounts.showNumItems('Products', $('#ProductsCount'));
	});
	$('#removeProductButton').click(function() {
		SC.Discounts.removeItems('Products');
		SC.Discounts.showNumItems('Products', $('#ProductsCount'));
	});
	$('#addCustomerButton').click(function() {
		SC.Discounts.addItem('Customers', 'CustomerName', 'CustomerID');
		SC.Discounts.showNumItems('Customers', $('#CustomersCount'));
	});
	$('#removeCustomerButton').click(function() {
		SC.Discounts.removeItems('Customers');
		SC.Discounts.showNumItems('Customers', $('#CustomersCount'));
	});
	$('#addManufacturerButton').click(function() {
		SC.Discounts.addItem('Manufacturers', 'ManufacturerName', 'ManufacturerID');
		SC.Discounts.showNumItems('Manufacturers', $('#ManufacturersCount'));
	});
	$('#removeManufacturerButton').click(function() {
		SC.Discounts.removeItems('Manufacturers');
		SC.Discounts.showNumItems('Manufacturers', $('#ManufacturersCount'));
	});
});