// Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.

SC.ProductClasses = {};
	
SC.ProductClasses = new function()
{	
	this.attributeTypeChanged = function(select)
	{
		this.showAttributeValues(select);
		this.showAttributeValidators(select);
	}
	
	this.showAttributeValues = function(select)
	{
		var rowNum = itemsRS.getRowNum('ProductClassAttributes_row', select);
		var idValues = 'ProductClassAttributes::' + rowNum + '::values';
		var valuesSection = $(document.getElementById(idValues));
		
		if (SC.Util.inArray(select.value, itemsWithValues)) {
			itemValuesRS.initRS(
				'ProductClassAttributes::' + rowNum + '::',
				function(RSName, itemRowNum) {
					SC.ML.registerMultilanguageControl('ProductClassAttributes::' + SC.ProductClasses.getItemRowNum(RSName) + '::ProductClassAttributeValueML--' + itemRowNum + '--');
					SC.ML.show();
				}
			);
			valuesSection.removeAttr('style');
			valuesSection.find(':input').attr('disabled', false);
		} else {
			valuesSection.attr('style','display:none');
			valuesSection.find(':input').attr('disabled', 'disabled');
		}
	}
	
	this.showAttributeValidators = function(select)
	{
		var attributeType = $(select).val();
		var rowNum = SC.ProductClasses.getItemRowNum($(select).attr('name'))
		var text, value;
		var validatorSelect = document.getElementById('ProductClassAttributeValidator::' + rowNum + '::');
		validatorSelect.options.length = 0;
		for (var key in attributeValidatorsByType[attributeType]) {
			value = attributeValidatorsByType[attributeType][key];
			text = attributeValidators[value]
			validatorSelect.options[validatorSelect.options.length] = new Option(text, value);
		}
		if (validatorSelect.options.length == 1) {
			$(validatorSelect).hide();
		} else {
			$(validatorSelect).show();
		}
	}
	
	this.getItemRowNum = function(RSName)
	{
		var re = new RegExp("::([0-9]+)::");
		return parseInt(RSName.match(re)[1]);
	}
}

$(function() {
	itemsRS = new constructSCRS();
	itemsRS.initRS(
		'ProductClassAttributes',
		function(RSName, rowNum) {
			SC.ML.registerMultilanguageControls(['ProductClassAttributeName::' + rowNum + '::']);
		},
		function(RSName, rowNum) {}
	);
	
	itemValuesRS = new constructSCRS();
	itemValuesRS.separator = "--";
	
	$('[id^=ProductClassAttributeType::]').each(function() {
		if (SC.Util.inArray(this.value, itemsWithValues)) {
			SC.ProductClasses.attributeTypeChanged(this);
		}
	});
});