// Copyright (c) 2009 Mirchev Ideas Ltd. All rights reserved.

SC.Products = new function() 
{
	this.Options = {};
	this.Prices = {};
	this.BonusPoints = {};
	this.Bundles = {};
	
	this.onProductTaxClick = function(element)
	{
		if (element.checked) {
			$("#ProductTaxClasses_"+element.value)[0].disabled = false;
		} else {
			$("#ProductTaxClasses_"+element.value)[0].disabled = true;
		}
	}
	
	this.showNumItems = function(items, countElem)
	{
		var obj = document.getElementById(items);
		countElem.html(String(obj.options.length));
	}
	
	this.copySelectedCategories = function(fromId, toId)
	{
		SC.DMS.productCategoryLeftToRight(fromId, toId);
		SC.Products.showNumItems('CategoriesSelectedId', $('#CategoriesCount'));
	}
	
	this.removeSelectedCategories = function(fromId)
	{
		SC.DMS.removeSelected(fromId);
		SC.Products.showNumItems('CategoriesSelectedId', $('#CategoriesCount'));
	}
	
	this.showPicturesCount = function()
	{
		$('#PicturesCount').html(String($('#RSProductImages__rowCount').val()));
	}
	
	this.showEgoodsCount = function()
	{
		$('#EgoodsCount').html(String($('#RSProductEgoods__rowCount').val()));
	}
	
	this.showWholesalePricesCount = function()
	{
		var count = $('#RSProductPrices__rowCount').val();
		$('#WholesalePricesCount').html(String(count));
		if (count > 0) {
			var quantityField = document.getElementById('ProductWholesalePriceQuantity::1::');
			quantityField.value = '1';
			quantityField.readOnly = true;
		}
		if (count > 1) { // in case we do insert before the first line
			var quantityField2 = document.getElementById('ProductWholesalePriceQuantity::2::');
			quantityField2.readOnly = false;
		}
	}
	
	this.showRelatedProductsCount = function()
	{
		$('#RelatedProductsCount').html(String($('#RSRelatedProducts__rowCount').val()));
	}
	
	this.displayXHTML = function(elem)
	{
		var inputId = elem.id.substr(6);
		var input = document.getElementById(inputId);
		var textareaId = inputId.substring(0, inputId.length-5);
		
		if (input.value == 0) {
			$(elem).html(ML_PLAIN_TEXT);
			SC.ML.removeWysiwygEditors(textareaId);
		} else {
			$(elem).html(ML_WYSWYG_EDITOR);
			SC.ML.setupWysiwygEditors(textareaId, CKEDITOR.config.language, []);
		}
	}
	
	this.toggleXHTML = function(elem)
	{
		var inputId = elem.id.substr(6);
		var input = document.getElementById(inputId);
		input.value = (input.value == 0) ? 1 : 0;
		
		this.displayXHTML(elem);
	}
}

SC.Products.Options = new function ()
{
	this.optionGroupTypePriceMod = 1;
	this.optionGroupTypeVariant = 2;
	this.optionGroupTypeUserImage = 3;
	this.optionGroupTypeUserText = 4;
	
	this.init = function () {
		SC.Products.Options.showCount();
		$('#LocalOptionGroups_table [name^="LocalOptionGroupType::"]').change(SC.Products.Options.optionTypeChanged).change();
		$('#globalOptionsTable :input').change(SC.Products.Options.optionsChanged);
		$('#LocalOptionGroups_table :input').change(SC.Products.Options.optionsChanged);
	}
	
	this.showCount = function ()
	{
		SC.Util.updateCheckedCount($("input[name^=ProductOptionGroups]"), $("#OptionsCount"));
		var totalCount = String(parseInt($("#OptionsCount").html()) + parseInt($('#LocalOptionGroups__rowCount').val()));
		$("#OptionsCount").html(totalCount);
		
		if (parseInt(totalCount) == 0) {
			$('#productVariantsHolder').hide();
			$('#productVariantsNoOptions').show();
			return;
		}
		
		var variantOptionsCount = $('#globalOptionsTable input.OptionGroupType-' + SC.Products.Options.optionGroupTypeVariant + ':checked').length;
		if (variantOptionsCount > 0) {
			return;
		}
		
		$('#LocalOptionGroups_table tbody').each(function () {
			if ($(this).attr('id') == 'LocalOptionGroups_row::::') {
				// this is the "template" row
				return;
			}
			if ($(this).find('select[name^=LocalOptionGroupType] option:selected[value=' + SC.Products.Options.optionGroupTypeVariant + ']').length) {
				variantOptionsCount += 1;
			}
		});
		if (variantOptionsCount > 0) {
			return;
		}
		
		$('#productVariantsHolder').hide();
		$('#productVariantsNoOptions').show();
	}
	
	this.optionsChanged = function ()
	{
		$('#productVariantsHolder :input').attr('disabled', true);
		$('#productVariantsHolder').hide();
		$('#productVariantsNoOptions').hide();
		$('#productVariantsNoMod').show();
	}
	
	this.optionTypeChanged = function ()
	{
		var rowNum = parseInt($(this).attr('name').substring(String('LocalOptionGroupType::').length));
		
		var priceModColumn = '[id="LocalOptionGroups::' + rowNum + '::values"] .priceModifier';
		var requiredOptionColumn = '[id="LocalOptionGroups::' + rowNum + '::values"] .requiredOption';
		
		var priceModInputSelector = priceModColumn + ' :input';
		var requiredInputSelector = requiredOptionColumn + ' :input';
		
		if (($(this).val() == SC.Products.Options.optionGroupTypeUserImage) || ($(this).val() == SC.Products.Options.optionGroupTypeUserText)) {
			$(priceModColumn).hide();
			$(requiredOptionColumn).show();
			
			$(priceModInputSelector).attr('disabled', true);
			$(requiredInputSelector).attr('disabled', false);
		} else if ($(this).val() == SC.Products.Options.optionGroupTypeVariant) {
			$(priceModColumn).hide();
			$(requiredOptionColumn).hide();
			
			$(priceModInputSelector).attr('disabled', true);
			$(requiredInputSelector).attr('disabled', true);
		} else {
			$(priceModColumn).show();
			$(requiredOptionColumn).hide();
			
			$(priceModInputSelector).attr('disabled', false);
			$(requiredInputSelector).attr('disabled', true);
		}
	}
}

SC.Products.Prices = new function ()
{
	this.init = function () {
		var productVariantsCount = $('#ProductVariants__rowCount').val();
		$('#productUsesWholesalePrices').hide();
		$('#productUsesVariantPrices').hide();
		
		if (productVariantsCount > 0) {
			$('input[name=ProductPrice]').attr('readonly', true);
			$('#productUsesVariantPrices').show();
			return;
		}
		
		var productPricesCount = 0 + $('#RSProductPrices__rowCount').val();
		if (productPricesCount > 0) {
			$('input[name=ProductPrice]').attr('readonly', 'readonly');
			$('#productUsesWholesalePrices').show();
			return;
		}
	}
}

SC.Products.Weight = new function ()
{
	this.init = function () {
		$('#productUsesVariantWeight').hide();
		$('#productUsesBundleWeight').hide();
		
		var productVariantsCount = $('#ProductVariants__rowCount').val();
		if (productVariantsCount > 0) {
			$('input[name=ProductWeight]').attr('readonly', true);
			$('#productUsesVariantWeight').show();
			return;
		}
		
		if ($('[name="ProductIsBundle"]').is(':checked')) {
			$('input[name=ProductWeight]').attr('readonly', true);
			$('#productUsesBundleWeight').show();
			return;
		}
	}
}

SC.Products.Quantity = new function ()
{
	this.init = function () {
		$('#productUsesVariantQuantities').hide();
		$('#productUsesBundleQuantities').hide();
		
		var productVariantsCount = $('#ProductVariants__rowCount').val();
		if (productVariantsCount > 0) {
			$('input[name=ProductQuantity]').attr('readonly', true);
			$('#productUsesVariantQuantities').show();
			return;
		}
		
		if ($('[name="ProductIsBundle"]').is(':checked') && $('[name="ProductBundleAutoQuantity"]').is(':checked')) {
			$('input[name=ProductQuantity]').attr('readonly', true);
			$('#productUsesBundleQuantities').show();
			return;
		}
	}
}

SC.Products.BonusPoints = new function ()
{
	this.PRODUCT_MONEY_ONLY = 0;
	this.PRODUCT_POINTS_AND_MONEY = 1;
	this.PRODUCT_POINTS_ONLY = 2;
	
	this.pointsRate = 0;
	
	this.fields = new Array();
	
	this.init = function () {
		SC.Products.BonusPoints.fields['ProductBonusPointsPrice'] = 'ProductPrice';
		
		for (var pointsField in SC.Products.BonusPoints.fields) {
			var priceField = SC.Products.BonusPoints.fields[pointsField];
			if (typeof(priceField) == 'function') {
				continue;
			}
			$('[name="' + pointsField + '"]').unbind('change').change(SC.Products.BonusPoints.pointsFieldModified).change();
			$('[name="' + priceField + '"]').unbind('change').change(SC.Products.BonusPoints.priceFieldModified);
		}
		
		$('select[name="ProductBonusPointsMode"]').change(function () {
			if ($(this).val() == SC.Products.BonusPoints.PRODUCT_MONEY_ONLY) {
				$('#ProductBonusPointsPrice').attr('readonly', 'readonly');
				$('#ProductVariants_table tr .bonusPointsColumn').css('display', 'none');
			} else {
				$('#ProductBonusPointsPrice').removeAttr('readonly');
				if ($.browser.msie && $.browser.version.substr(0,1) <= 7) {
					$('#ProductVariants_table tr .bonusPointsColumn').css('display', 'block');
				} else {
					$('#ProductVariants_table tr .bonusPointsColumn').css('display', 'table-cell');
				}
			}
		});
		$('select[name="ProductBonusPointsMode"]').change();
	}
	
	this.pointsFieldModified = function () {
		if ($(this).val() == '') {
			SC.Products.BonusPoints.showAutoPrice(this);
		} else {
			SC.Products.BonusPoints.showAutoPriceInfo(this);
		}
	}
	
	this.priceFieldModified = function () {
		var pointsField = SC.Util.arraySearch($(this).attr('name'), SC.Products.BonusPoints.fields);
		if (pointsField !== false) {
			$('[name="' + pointsField + '"]').change();
		}
	}
	
	this.showAutoPrice = function (pointsField) {
		$(pointsField).siblings('.bonusPointsAutoPrice').find('.bonusPointsAutoPriceInfo').hide();
		$(pointsField).siblings('.bonusPointsAutoPrice').find('.bonusPointsAutoPriceCalculated').show();
		var priceField = SC.Products.BonusPoints.fields[$(pointsField).attr('name')];
		priceField = $('[name="' + priceField + '"]');
		var price = Math.round(parseFloat(priceField.val()) * 10000) / 10000;
		var rate = Math.round(parseFloat(SC.Products.BonusPoints.pointsRate) * 10000) / 10000;
		var points = Math.round(price / rate);
		var html = price + ' / ' + SC.Products.BonusPoints.pointsRate + ' = ' + points;
		
		var htmlHolder = $(pointsField).siblings('.bonusPointsAutoPrice').find('.bonusPointsAutoPriceCalculated');
		htmlHolder.find('.price').html(price);
		htmlHolder.find('.rate').html(rate);
		htmlHolder.find('.points').html(points);
	}
	
	this.showAutoPriceInfo = function (field) {
		$(field).siblings('.bonusPointsAutoPrice').find('.bonusPointsAutoPriceInfo').show();
		$(field).siblings('.bonusPointsAutoPrice').find('.bonusPointsAutoPriceCalculated').hide();
	}
	
	this.calculate = function (price, rate) {
		return (Math.round(parseFloat(price) / parseFloat(rate)));
	}
}

SC.Products.Bundles = new function ()
{
	this.init = function () {
		$('#addBundleProductButton').click(function() {
			SC.Products.Bundles.addItem('BundleProducts', 'SubProductName', 'SubProductID');
		});
		$('#removeBundleProductButton').click(function() {
			SC.Products.Bundles.removeItems('BundleProducts');
		});
		$('[name="ProductIsBundle"]').click(function () {
			SC.Products.Bundles.toggleBundle();
		});
		$('[name="ProductBundleAutoQuantity"]').click(function () {
			SC.Products.Bundles.toggleBundle();
		});
		SC.Products.Bundles.toggleBundle();
	}
	
	this.toggleBundle = function () {
		$('tr.bundle-row').css('display', 'none');
		if ($('#variantsTabLink').length) {
			$("#tabContainer").tabs('enable', SC.Products.Bundles.getVariantsTabIndex());
		}
		
		if ($('[name="ProductIsBundle"]').is(':checked')) {
			if ($.browser.msie && $.browser.version.substr(0,1) <= 7) {
				$('tr.bundle-row').css('display', 'block');
			} else {
				$('tr.bundle-row').css('display', 'table-row');
			}
			
			if ($('#variantsTabLink').length) {
				$("#tabContainer").tabs('disable', SC.Products.Bundles.getVariantsTabIndex());
			}
		}
		
		SC.Products.Weight.init();
		SC.Products.Quantity.init();
	}
	
	this.getVariantsTabIndex = function ()
	{
		return $('.tabs-menu li').index($('#variantsTabLink'));
	}
	
	this.addItem = function(items, itemName, itemID) {
		var text = $('#' + itemName).val();
		var value = $('#' + itemID).val();
		
		if (text != '' && value != '' && !this.isValue(items, value)) {
		    $('#' + items).append(
				$('<option/>').attr('value', value).text(text)
		    );
		    return;
		}
	}
	
	this.removeItems = function(items) {
	    $('#' + items + '>option:selected').remove();
	}
	
	this.isValue = function(items, value)
	{
	    var options = $('#' + items + '>option');
	    for (var i = 0; i < options.length; i++) {
			if ($(options[i]).val() == value)
		    	return true;
	    }

	    return false;
	}
	
	this.selectItems = function(items)
	{
	    $('#' + items + '>option').each(function() {
			this.selected = true;
	    });
	}
}

$(document).ready( function() {
	$("#tabContainer").tabs(1);
	$("#tabContainer").css("display", "");
	
	$("#mainform").submit(function() {
		SC.DMS.selectAll("Categories");
		$('input[type="file"]').each(function () {
			if ($(this).val() == '') {
				$(this).attr('disabled', 'disabled');
			} else {
				$(this).removeAttr('disabled');
			}
		});
		SC.Products.Bundles.selectItems("BundleProducts");
	});
	
	$("input[name='ProductTaxes[]']").click(function() {
		SC.Products.onProductTaxClick(this);
	});
	$("input[name='ProductTaxes[]']").each(function() {
		SC.Products.onProductTaxClick(this);
	});
	
	$("select[name='ProductClassID']").change(function () {
		var productClassId = $(this).val();
		$.get('?action=dmGetAttributes&load=table&ProductClassID=' + productClassId, function (data) {
			$('#productAttributes').html(data);
			SC.ML.changeLanguage(SC.ML.currentLang);
		});
	});
	
	$('.xhtml_select').click(function() {
		SC.Products.toggleXHTML(this);
	});
	
	$('.product_image:gt(0)').colorbox({rel: 'product_image'});
	$('.product_variant_image:gt(0)').colorbox({rel: 'product_variant_image'});
	
	SC.Products.showNumItems('CategoriesSelectedId', $('#CategoriesCount'));
	
    $("input[name^=ProductOptionGroups]").click(function() {
		SC.Products.Options.showCount();
    });
    
    SC.Products.showPicturesCount();
    SC.Products.showEgoodsCount();
    SC.Products.showWholesalePricesCount();
    SC.Products.showRelatedProductsCount();
    SC.Products.Options.init();
    SC.Products.Prices.init();
    SC.Products.BonusPoints.init();
    SC.Products.Bundles.init();
    
	itemsRS = new constructSCRS();
	itemsRS.initRS(
		'LocalOptionGroups',
		function(RSName, rowNum) {
			SC.ML.registerMultilanguageControls(['LocalOptionGroupName::' + rowNum + '::']);
			SC.Products.Options.init();
			SC.Products.Options.optionsChanged();
		},
		function(RSName, rowNum) {
			SC.Products.Options.showCount();
			SC.Products.Options.optionsChanged();
		}
	);
	
	itemValuesRS = new constructSCRS();
	itemValuesRS.separator = "--";
	itemValuesRS.addRowCallbackFunc = function (RSName, rowNum) {
		SC.ML.registerMultilanguageControl(RSName + "LocalOptionName--" + rowNum + "--");
		SC.Products.Options.optionsChanged();
	}
	itemValuesRS.removeRowCallbackFunc = function (RSName, rowNum) {
		SC.Products.Options.optionsChanged();
	}
});