// Copyright (c) 2010 Mirchev Ideas Ltd. All rights reserved.

SC.Product = new function()
{
	this.showPopup = function(productId, e, elem)
	{
		SC.Product.setMouseCoordinates(e);
		$(elem).mousemove(SC.Product.setMouseCoordinates);
	
		var data = SC.Products.Container.getProduct(productId);		
		$('#ProductPopup').html(data);
		$('#ProductPopup').show();
	}
	
	this.hidePopup = function(elem)
	{
		$('#ProductPopup').hide();
		
		$(elem).unbind('mousemove', SC.Product.setMouseCoordinates);
	}
	
	this.setMouseCoordinates = function(e)
	{
		$('#ProductPopup').css({
			left: e.pageX + 20,
			top: e.pageY + 20
		});
	}
	
	this.saveCategoryOrder = function(url, rowObj, tableObj, categoryId)
	{
		rowObj = $(rowObj);
		
		var next = 0;
		if ((typeof(rowObj.prev().attr('id')) == 'undefined') || (!(rowObj.prev().attr('id')).match(/\d+/))) {
			next = 1;
			var targetRowObj = rowObj.next();
		} else {
			var targetRowObj = rowObj.prev(); 
		}
		
		var sourceRowId = rowObj.attr('id');
		var targetRowId = targetRowObj.attr('id');
		if (targetRowId == 0)
			return;
		
		$.post(
			url,
			{
				'action' : 'dmSaveCategorySort',
				'dragSortSourceProductId' : sourceRowId,
				'dragSortTargetProductId' : targetRowId,
				'dragSortInsertBeforeTarget' : next,
				'CategoryID' : categoryId
			},
			function(data) {
				if (data != 'OK') {
					alert(ML_SORTING_FAILED + ' ' + data);
					location.reload(true);
				}
			}
		);
	}
	
	this.enableDndSorting = function(categoryId)
	{
		var down = false;
		var temp = false;
		
		$('#notsortable_products_in_cat>.row').mousedown(function(){
			down = true;
		});
		
		$(document).mouseup(function(){
			down = false;
		});
		
		$(document).blur(function(){
			down = false;
		});
		
		var obj;
		
		$('#notsortable_products_in_cat tr').mouseover(function(){
			if (down) {
				if ($(obj).attr('id') == $(this).attr('id'))
					clearTimeout(temp);
			}
		}).mouseout(function(){
			if (down) {
				obj = this;
				temp = setTimeout('SC.Product.offerDefaultCategorySorting('+categoryId+')', 5);
			}
		});
	}
	
	this.offerDefaultCategorySorting = function(categoryId)
	{
		if (categoryId) {
			if (confirm(ML_ENABLE_DND_SORTING)) {
				SC.Home.sortForm('table', 'ProductIDSort', 'ASC', 'entire_ajax_table');
			}
		} else {
			alert(ML_FILTER_BY_CATEGORY_TO_SORT);
		}
	}
}

SC.Products.Container = new function()
{
	this._products = {};
	
	this.addProduct = function(productId, productDescription)
	{
		this._products['product_' + productId] = productDescription;
	}
	
	this.getProduct = function(productId)
	{
		return this._products['product_' + productId];
	}
}

$(function() {
	$('.productPopup').live('mouseover', function(e) {
		SC.Product.showPopup(this.id.substring(5), e, this);
	}).live('mouseout', function() {
		SC.Product.hidePopup(this);
	});

	$('#ProductPopup').css({
		position: 'absolute',
		width: '350px'
	});
});