PRODUCT_VARIANT_GLOBAL_OPTION = 1;
PRODUCT_VARIANT_LOCAL_OPTION = 2;

var selectedOptions = new Array();
selectedOptions[PRODUCT_VARIANT_GLOBAL_OPTION] = new Array();
selectedOptions[PRODUCT_VARIANT_LOCAL_OPTION] = new Array();

function variantIdentifier()
{
	selectedOptions[PRODUCT_VARIANT_GLOBAL_OPTION] = new Array();
	selectedOptions[PRODUCT_VARIANT_LOCAL_OPTION] = new Array();
	
	$('select[name^="Options[ProductOptions"]').each(function () {
		var optionTypeAndId = getOptionTypeAndId(this);
		var optionGroupId = optionTypeAndId[1];
		if (!productVariantOptions[PRODUCT_VARIANT_GLOBAL_OPTION] || !productVariantOptions[PRODUCT_VARIANT_GLOBAL_OPTION][optionGroupId]) {
			return;
		}
		var key = selectedOptions[PRODUCT_VARIANT_GLOBAL_OPTION].length;
		selectedOptions[PRODUCT_VARIANT_GLOBAL_OPTION][key] = $(this).val();
	});
	$('select[name^="Options[LocalOptions"]').each(function () {
		var optionTypeAndId = getOptionTypeAndId(this);
		var optionGroupId = optionTypeAndId[1];
		if (!productVariantOptions[PRODUCT_VARIANT_LOCAL_OPTION] || !productVariantOptions[PRODUCT_VARIANT_LOCAL_OPTION][optionGroupId]) {
			return;
		}
		var key = selectedOptions[PRODUCT_VARIANT_LOCAL_OPTION].length;
		selectedOptions[PRODUCT_VARIANT_LOCAL_OPTION][key] = $(this).val();
	});
	
	selectedOptions[PRODUCT_VARIANT_GLOBAL_OPTION].sort(variantOptionsSort);
	selectedOptions[PRODUCT_VARIANT_LOCAL_OPTION].sort(variantOptionsSort);
	
	identifier = '';
	if (selectedOptions[PRODUCT_VARIANT_GLOBAL_OPTION].length)
		identifier += PRODUCT_VARIANT_GLOBAL_OPTION + ':' + selectedOptions[PRODUCT_VARIANT_GLOBAL_OPTION].join('-') + '-';
	identifier += '|';
	if (selectedOptions[PRODUCT_VARIANT_LOCAL_OPTION].length)
		identifier += PRODUCT_VARIANT_LOCAL_OPTION + ':' + selectedOptions[PRODUCT_VARIANT_LOCAL_OPTION].join('-') + '-';
	
	return identifier;
}
function getOptionTypeAndId(optionSelect)
{
	var match = $(optionSelect).attr('name').match(/^.+\[(.+?)\]\[([0-9]+)\]/);
	if (match === null) {
		return false;
	}
	if (!match[1] || !match[2]) {
		return false;
	}
	return new Array(match[1], match[2]);
}
function variantOptionsSort(x, y)
{
	if (parseInt(x) < parseInt(y))
		return -1;
	return (parseInt(x) > parseInt(y));
}

$(function() {
	$('select[name^="Options\["]').change(function () {
		var optionTypeAndId = getOptionTypeAndId(this);
		if (optionTypeAndId === false) {
			return;
		}
		var optionType = optionTypeAndId[0];
		var optionId = optionTypeAndId[1];
		if (optionType == 'ProductOptions' && (!productVariantOptions[PRODUCT_VARIANT_GLOBAL_OPTION] || !productVariantOptions[PRODUCT_VARIANT_GLOBAL_OPTION][optionId])) {
			return;
		} else if (optionType == 'LocalOptions' && (!productVariantOptions[PRODUCT_VARIANT_LOCAL_OPTION] || !productVariantOptions[PRODUCT_VARIANT_LOCAL_OPTION][optionId])) {
			return;
		}
		
		var id = variantIdentifier();
		
		if (!productVariants[id]) {
			return;
		}
		var variant = productVariants[id];
		
		$.get(SC.storeRoot + 'product.php', {
				ProductVariantID: variant.ProductVariantID,
				action: 'variantDetailsJson',
				load: 'table'
			},
			function (data) {
				$('#ProductPricesHolder').html(data.PricesTable);
				
				// If wholesale prices is not focused hide the appended html
				var isHiddenWholesalePrices = ($('#wholesale-prices').length ? $('#wholesale-prices').is(':hidden') : true);
				$('#wholesale-prices').remove();
				$('.tabsbg-rb').append(data.WholesalePricesTab);
				if (isHiddenWholesalePrices)
					$('#wholesale-prices').hide();
				
				$('#product-page #product-images .product-image').html(data.DefaultImageHtml);
				$('.innerbox').colorbox({minWidth: 500, minHeight: 300});
				if (data.hasAddToCart) {
					$('.add-to-cart').show();
					$('.out-of-stock').hide();
				} else {
					$('.add-to-cart').hide();
					$('.out-of-stock').show();
				}
				
				for (var optionType in data['OptionTexts']) {
					for (var optionGroupId in data['OptionTexts'][optionType]) {
						for (var optionId in data['OptionTexts'][optionType][optionGroupId]) {
							var selector = 'select[name="Options[' + optionType + '][' + optionGroupId + '][]"] option[value="' + optionId + '"]';
							$(selector).text(data['OptionTexts'][optionType][optionGroupId][optionId]);
						}
					}
				}
			},
			'json'
		);
		
		$('#ProductCode').html(variant.ProductVariantCode);
		$('#ProductWeight').html(variant.ProductVariantWeight);
		if (variant.ProductVariantImage == '') {
			variant.ProductVariantImage = defaultVariantData.ProductVariantImage;
		}
		$('#ProductVariantID').val(variant.ProductVariantID);
	});
	
	$('#cart_form').submit(function() {
		var textInputs = $('#cart_form').find('input:text').get();
		
		for (index in textInputs) {
			if ($(textInputs[index]).hasClass('required') && (textInputs[index].value == '')) {
				alert('There is empty required text input!');
				return false;
			}
		}
		
		var fileInputs = $('input:file').get();
		if (fileInputs.length == 0)
			return true;
		
		$('#cart_form').attr('enctype', 'multipart/form-data').attr('encoding', 'multipart/form-data');
		for (index in fileInputs) {
			if ($(fileInputs[index]).hasClass('required') && (fileInputs[index].value == '')) {
				alert('There is empty required file input!');
				return false;
			}
		}
		return true;
	});
});