<?php
	scLog::singleton()->info('Installing product fixed prices.');
	
	try {
		miStaticDBUtil::execSQL('ALTER TABLE Currencies ADD COLUMN CurrencyAllowFixedPrices tinyint(3) unsigned NOT NULL default 0;');
		
		// Insert all new texts
		$codeTexts = array(
			'The currency code must be exactly 3 uppercase letter or digit characters.' => array(
				'BG' => 'Кодът на валутата трябва да бъде точно 3 буквено-цифрови символа.',
				'TR' => 'Para birimi kodu 3 büyük karakter olmalıdır.'
			),
			'You cannot change the currency code for currencies which allow fixed prices.' => array(
				'BG' => 'Не можете да промените кодът на валутата, защото тя позволява фиксирани цени.',
				'TR' => 'Fiyatlar ayarlandıktan sonra para birimlerinin kodlarını değiştiremezsiniz.'
			),
			'Currency code "%s" is invalid.' => array(
				'BG' => 'Кодът на валутата "%s" е невалиден.',
				'TR' => 'Geçersiz para birimi kodu "%s"'
			),
		);
		scUpdater::insertTexts($codeTexts, scInterfaceTexts::TEXT_TYPE_CODE);
		
		$templateTexts = array(
			'Allow Fixed Prices:' => array(
				'BG' => 'Разрешаване на фиксирани цени:',
				'TR' => 'İzin verilen sabit fiyatlar:'
			),
			'You may enter fixed product prices in this currency that are independent of the currency rate.' => array(
				'BG' => 'Може да въвеждате фиксирани продуктови цени в тази валута, които ще бъдат независими от обменния курс.',
				'TR' => 'Bu para biriminden sabit ürün fiyatı girebilirsiniz bağımsız para birimi.'
			),
			'auto' => array(
				'BG' => 'автом.',
				'TR' => 'oto'
			),
		);
		scUpdater::insertTexts($templateTexts, scInterfaceTexts::TEXT_TYPE_TEMPLATE);
		
		scLog::singleton()->info('Successfully installed the product fixed prices.');
	} catch (miException $e) {
		scLog::singleton()->error('Failed installing the product fixed prices: ' . $e->getMessage());
	}
?>