<?php
	
	scLog::singleton()->info('Installing Romanian payment modules.');
	
	$activeLanguages = scMultiLanguage::getActiveLanguageCodes(); // array(lid => lcode)
	$pmSort = miStaticDBUtil::execSelect('SELECT MAX(PaymentModuleSort) AS N FROM PaymentModules');
	$pmSort = $pmSort[0]['N'];
	
	try {
		miStaticDBUtil::startTransaction();
		
		$module = new miSqlRecord('Modules', 'ModuleID');
		$module->set('ModuleName', 'com.summercart.payment.euplatesc_ro');
		$module->set('ModuleVersion', '');
		$module->set('ModuleTitle', 'EuPlatesc.ro');
		$module->set('ModuleIsActive', true);
		$moduleId = $module->insert();
		
		$moduleClass = new miSqlRecord('ModuleClasses', 'ModuleClassID');
		$moduleClass->set('ModuleID', $module->getPK());
		$moduleClass->set('ModuleClassInterface', 'IPaymentModule');
		$moduleClass->set('ModuleClassName', 'scPaymentModuleEuplatescRo');
		$moduleClass->set('ModuleClassLocation', 'payment/euplatesc_ro/euplatesc.php');
		$moduleClass->insert();
		
		$paymentModule = new scSqlRecordML('PaymentModules', 'PaymentModuleID',
			array('PaymentModuleDisplayName'), array_keys($activeLanguages));
		$paymentModule->set('ModuleID', $module->getPK());
		$paymentModule->set('PaymentModuleName', 'EuPlatesc.ro');
		$paymentModule->set('PaymentModuleIntegrationMethod', '');
		$paymentModule->set('PaymentModuleImage', 'skins/default/modules/payment/euplatesc_ro/logo_euplatesc_ro.png');
		$paymentModule->set('PaymentModuleIsActive', false);
		$mlValue = array();
		foreach ($activeLanguages as $lid => $lcode)
			$mlValue[$lid] = 'EuPlatesc.ro';
		$paymentModule->set('PaymentModuleDisplayName', $mlValue);
		$paymentModule->set('PaymentModuleSort', ++$pmSort);
		
		$img = 'iVBORw0KGgoAAAANSUhEUgAAALQAAAAgCAYAAAC7OlJnAAAAGXRFWHRTb2Z0d2FyZQBBZG9iZSBJ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=';
		file_put_contents(scPaths::getStoreRootDir() . $paymentModule->get('PaymentModuleImage'), base64_decode($img));
		
		$paymentModule->insert();
		
		miStaticDBUtil::commit();
		
		scLog::singleton()->info('Successfully installed EuPlatesc.ro.');
	} catch (miException $e) {
		miStaticDBUtil::rollback();
		scLog::singleton()->error('Failed installing EuPlatesc.ro: ' . $e->getMessage());
	}
	
	try {
		miStaticDBUtil::startTransaction();
		
		$module = new miSqlRecord('Modules', 'ModuleID');
		$module->set('ModuleName', 'com.summercart.payment.mobilpay_ro.creditcard');
		$module->set('ModuleVersion', '');
		$module->set('ModuleTitle', 'Mobilpay.ro');
		$module->set('ModuleIsActive', true);
		$moduleId = $module->insert();
		
		$moduleClass = new miSqlRecord('ModuleClasses', 'ModuleClassID');
		$moduleClass->set('ModuleID', $module->getPK());
		$moduleClass->set('ModuleClassInterface', 'IPaymentModule');
		$moduleClass->set('ModuleClassName', 'scPaymentModuleMobilpayRo');
		$moduleClass->set('ModuleClassLocation', 'payment/mobilpay_ro/mobilpay.php');
		$moduleClass->insert();
		
		$paymentModule = new scSqlRecordML('PaymentModules', 'PaymentModuleID',
			array('PaymentModuleDisplayName'), array_keys($activeLanguages));
		$paymentModule->set('ModuleID', $module->getPK());
		$paymentModule->set('PaymentModuleName', 'Mobilpay.ro');
		$paymentModule->set('PaymentModuleIntegrationMethod', 'Credit Card');
		$paymentModule->set('PaymentModuleImage', 'skins/default/modules/payment/mobilpay_ro/logo_mobilpay_ro.png');
		$paymentModule->set('PaymentModuleIsActive', false);
		$mlValue = array();
		foreach ($activeLanguages as $lid => $lcode)
			$mlValue[$lid] = 'Mobilpay.ro';
		$paymentModule->set('PaymentModuleDisplayName', $mlValue);
		$paymentModule->set('PaymentModuleSort', ++$pmSort);
		
		$img = 'iVBORw0KGgoAAAANSUhEUgAAALQAAAAgCAYAAAC7OlJnAAAAGXRFWHRTb2Z0d2FyZQBBZG9iZSBJ
bWFnZVJlYWR5ccllPAAAHABJREFUeNrsW3mYVNWVP/ettXdV79XdNE1306zdLA0KEpagBkG2SCRq
EI0oWZwkxmQUozE647iQjEYHPo3GGMcYNCpERnEHZFM22brppummN+i9u6q6uqre/ubcW9WIxsw3
88cMfEPf73tUU/Xeu/fd+zu/8zvn3Eds24ahNtT+vzRuaAqG2hCgh9pQGwL0UBtqQ4AeakPtf9SE
89FpIpH40jc0MDXBtgUQOA56YsLwD/c1zaTxqmmjzeF3JHXW3zT8QTN1yHGLcPm0jK2ybbdZ5+ex
vjwsNooexZ60aWffHTXt2uSq5og9cbhwaO2txTfpCrDn+sqGDy66eCA6D7pllLxzsOf2XTXavOYe
2zzTcSbviVVj77xktO/fVd28YIHldDovHkB/5RoSCgIOJIdA/vha40P3PtO0AtGNI5RTCLFTMMFP
m/vcEDg8dBEcegRee7L83+ZPyfixppjAEQ5sywYb7PMGacJb0BFTvv3nD3pWHu+OQ18bgNeRpfCc
ASYngfVFDAPh8Bocr2GawoEjfYvyvGl2fpGj86NDoR/sOKo4ajtt0DUCsbjp5zgyRMcXiuQghHzh
oExlIzAdogGHmmM3rHuzZQWkeYEPuIFLE4H46YHATkt+Cmky8D4XcAEXkIAIXI4IipwFa58/cVP/
AAQlkCDRr8mWYSBIrL/p7//iwH9AQ5SWZTj+Zdtvx+X/5uZhr4BggovTVGLLYFGvc/Z8eroAJuHB
Idvwwsfh9Zff3bRxwcM1m3o7jdDjt5UU7HhifMnkIk8PWCYIgmECgfPyXP/t57+YNTQxkZl1F7I0
zz/+Qsvd7e1J9jVtEVlWRnLmgdEZOwgYCFJTSCCrJYAzRBAUnEAnBzurNd+WnS1Pd4VaHjxypvpw
X3/4+4BMeP7cDgc8gajAQ5ssCVHmUc56mi+yuQAaiLaGzyRDrF8t0cMW9A/EQLE1WZK4XlGym9GL
mZzIg8frhqH6wQUrOahFG8DJPDR1RpYHA/3l0y5zQGOLAn1xBXTVAbYkspEi3pMLmaCyQ8bveQS9
CqZpQXEOgTuuyQF/VseSp7oOLYnGVbi5Y/o9AX/Wu4JAmv63APC5tv9qlW+n/rEsapV/v2mIfIuY
wJsxuHlexm/TPfzbxQXe1sIM+ZidsKgHk6g1CyjDHDI+u2X9N0YGfy/y+F+diYsW0NQ1UaAR3obO
hF2yfU/Xk6vme2AV74TT3TGoatKgtlWFT1oAWvoECEUwmBQkWHiZC6K9JlSd1lE+m/DtSgkWzdCh
z10LL6gHoUONMC36lu4tDJzOXju8uGS5bmpsygkkXbyA+pbjBPaNoiE7orvnJS61LhZqVQQZG6UJ
TqRYLgVHC729btClS36hEwv/QrmEkongeahxUjii9zDR4ASm45Fc2YJbdhKITto1zyedpI33xCDR
4mQw0Lhz0623Vi8qYmNTlTioNJawDDZXLCawDexFRmGFgSOfDJhNZH7TUNEBEBB56Wx8gbbODN6k
sUYKbwJ6DgHvQK+lF9uERd+gmwaOwWZ3TqqGc4wCv1ANncUmAk5GUlbYbOwGGiI9lbNwJtCDmrzl
wR8HLhpADwJ5sEmSE97c3PLz9s4zWctypoAvLR1GFhowbWwMogMR6OoLQUuHDYcbeDjTH4OFM3Ee
pRCEuh2A4SCYwSZ4W6uCqlgrzioBWRdA4eNwQDsO4zqylqUHguXeDNcxQ9eZxkqYEIwPKDk1nda3
Y6pRtHBS+u1RHdJ37O+7q6FN8Y7OTRuYPcXxMxdH+gkuXtUZY8mJhvh1IidC+Sj+0IhMYa2u8qBz
FKAGeFD3nu7jrt5/IraiqS3qTHPz2thiz4HJIzzPixbppaZBEPi48pCfKWk4RlLTqi8/UNe/tD+m
wfhS+dNZZekvmpYVTpgk2NWt5pxsH1ge6edGXFHh+IXLYzdapshYmUfASmCrUVvL7jRDlX3xvpVd
8W6UbBJ8I3/WLRokuJ3hz25qCDfONAULpvrL36rwjNqUIBAXNTRiSYAYZ4xqitTPqu9vnBvVYqjk
LBgXKOqeEKh83LKUjv2R6n9JmH15As6uyQug2wo4iTtWmTb2ntNad35D9PTdHD6Pbekg8TLpVxRx
QI/bAYcnPCFj9JP1Pc0PzghOueaiAnQysrdBEgXoDMVGVB9vXDFnkhfcggtBQoATRXCLAXD7ApCd
WwhlJTGYURmBcFcE3uzZAZuj+6HEmwfUkZ+K94JuKUkmRM1tmAPoug3oMXpgh3qMG3Yq+/Vpvksn
mQIXR1oMrnnm+Ik3dqre7pgKI/M46F7GD/v9+y0z9jZqYOLKg3EKvr8kWPqTbxU9uX5jy5qX3++7
NKRhUKr0w+hi53XP/3y0+7JR8CsD+/BxHnj5w+7f3f1S/WpFtSEv6Grp6lEKe3r1a781K/CDx39Y
emeeJGzCeIAAb8Cpbsf4lY+17v3rzvapUQN9gIqM6nBf973F+o3/vCp91Zp1pz545WA0K4IauiBL
h+1PTHu8mAiNlPGZN6MTx0Pw9w0b977Tu62IhzhEiQ7DSBZE3VbWno79uQcjn42zEcyUcd8+/fF1
d45Z+Q9fC1SutwQ7/bhat+zV1rfXHeg5IPWQfmRpF8gYq3jbbFgxfPnMRcO+fu9zDRvuPGLW4bPh
8JDtnegY/WYAXpz98K8O9x2578mq3y9TnSokNBsuI+Vw4yXLPzOiilSVODFub/2Ba52GI4KAPi9e
n3/ggQf+zzs1DNTMGOXTo7Oz8/Ijh2teKBsNw6ZPGgVupxOoE6d5LMtKLiJH3SgC3+Fyg8uVCX85
tRXquFaIagnoMcPA4SeH7Eu9uo4sZKO8sPWkGw4ZMfD08xkFrrxGd8B/yDYMC+VGZnGuh5xsjuQ3
hwzYfayncOlU/57Hbi1atWx2VsPBhticd/fFi17f2XZdd1QtuG9l0XP3Xp/3c38Aijfv1IYfb+qc
fe3s3Dc9Dqnjufc6fnfr2obVU0a5lNceGLfy/m/51t44J/hBd78y9+XX2woau0OTvzWn6M/HToVm
bvokMfVke7M7IJGcn99YtO7e60rWTK5M8+2r7h2zbXdbntPt+sa8yswjWbli6ECNWZDhALjtipxn
vC67HZWO+If3u+7oDuvu712d9akpddpxsz/QoUXcDgx8E0SDfR17i528kJ3ny4d+vR9cnAEDdhxa
+3q+Pr2gckNzf9eEXx556pXqeC0/0jMcKj0T9jg11zDFiIAua3CyryG3MjD+4CVZE1+pjzQuCEOc
l7Dj4WKB+qPxN/20gCv8KFfK6GgwT19VF2nwlolFcMfk7z4R5HP+JJpcS5Yz/TRqG6U4kPdZqbf4
zYuGoUVk31AoNL66uvon0Wj0hrLSMteI4QWAQhQ0VQDe0jD8SWpUDKZAZWlodG/oAtt7W6FJaQEJ
QatTLWcymYuukZ5jAlWP1E3aqA+paaiSCgfVZiitO3r/3JzsnZLE1119adaPLyk3xz//XuMxURXh
lfsKV8ydGnwZWE/wQd38jBF3PHrypomVWfUbfzl+octpnUAzhPJh+f/41p7I1k9rOfepM8r8rEwn
3PPH1tV+H4n8/qdlNxRlu7eYqMezAnDiydtKT39yNP7+pg/CI7cuaf+ZJKLYjymwdErekb88PGEZ
T+wGFLdw6ajM7X5L27Xin+pmPL+53X/3i3krxpXIGev/0lZvGjZQt0+QgQnV+6hzbXxGFLqtSwoX
/yJXCr665vi65baEBo3P8YMRq36zIH/mawLHOf5w4tX1r3S+PV7CeajTWp0NPfVzS9NGfjI5vfR4
Rcbi6isyZzzl4l27GuL1V/yi6tEtnZYhtppxqI92LVpaOHfunMAl859u+ctyH65VN8SVQjFnk4FD
CAjpe3GCmxXFCl6RN2PHRP/EOw0EfZYrByTU5tMDVFnFL6603eHDh9dt3759LwL71pkzZ7pGlI5A
NuXAUKhL1XHdMLDAxaaHZeFhYiCC+pMzOKjuqYeIHgJBF0FQTeAVkwUmnEXlMzpkDDBpAU7gTLAF
BIRowUlfJ2yLHi5srK29n/Ai9RGgJMAVV3gQBBVKCtL2U5eu6hYLhAp8znYahJVkiwMuJ3cCMQo6
9idLwr48v3QG1Bgtf4S3fBpa2Ns8AHMnBOqLcpxbDF1loR96evB5xc9mjU1TkCJh+5HwUhxqGmBQ
leaVIhTMhqqDYmIsgW77G5Mzl2dnOaOt3QPph06Gr0YnAhaOhdDnp7lKGmjis1kYjdr4G0mtW8xS
BA2Z2NCpvNBhSvq4J53EsU+0HDsqA+WbOCQGFQeDehjala5V6VJ69X1jfjJucfDK5YLA71LsGOQL
wcMBKdNO9KP80FSUe1GLPsTkjPI3fTjfcbxvd+x02oFQ1cMOJJAuta+kPlwzLUt2w4zc6WtZBgcv
IOhNdZsGrgYSknxxZTkQ0LdffvnlMGzYMNAQLZqqndXUg8Hiucl5C5LMFEdWPtpRi4ukAc/zST2Z
Om+wQMFWm8oUahoosGkWAokfwnoM9h7/7Dv5RSPW+jPko8yaaTWRpswMy3mujduA+gaBjzjhzk3K
WXhfBBsDk9vlzKo+2TQBFIBRBW40Ix3NJIm05CPwUJwvPYtR2INt3Qm1bFg6DkoAl1tO3tMWcLw0
E6GBIJsRX4A3OtpUiEVV3c6WiY76WpTRJ8l80gXRvA3NkFAdTQYTKQh3BL2BTE6NHefFTeeJ0CyG
Q5Qpc+p4jWaiARJnP01QHOk7vPS99k/uOdp7LKPXCvlcXBrfkwhLPE0DGpQVeDa8Mk/hyXGuMnVr
dL8s4v/3tx9bcPWweVyn1j2lc6AXphaUnylJLzps0vI796U05XlM350Xhvb7/Z/09fUxEA7qZPo5
eJhskYzUgUyNi2uju+0OhaA2fAo9nsEYgS0uW2ByFtwU5gJlWzQDERmwYCANKjuGw0xuZO+kCVMe
FtzONuq1KZi51OLZ9mAONWkR1FiACKwU//kS2Uzzs1M5QoEkGibxJi/RbMLOJucWTXhDJGPo5T6H
yyHwtK6NcYCTT97NJsxI6YhFXkYqRrHkdIE/3Sux6gsC3uWS8HySHIKdst1zSt6WbUqWabE5slJ5
aXJ2YTlrcF5oJqjQmbF+8+l3N/x03yOvvXxq02Qk7oJr8xdt+O7wxa/keNJMS+LAxLFxqed1EPf+
WYXT3xDRVAG93KFITaBXC80+0V9zmYoIvzJn7gGHJZ4xuAtrP8l5AfTUqVPvR5aG7u7uJEhSzPw5
Q1uMDW0kQ4tGd1aCubLW7gbo0jpZUYWYAnAmSVbe8FyVlpItei9kSkvFNZBhZJcLpnWNhmvyrtiy
bN614yZVVNwr83wPRSXNQRPOCQ63DLJDTe6lsA2GHIIaHCkuuXkIz2WcTK+xqcx3s/4lgWvLywxs
pVqn/owmUmrjLR6lk5oEPZpgfYdwJYgcTCj1bJdlaQCvps+Ld1ErbA5NjvaDAO0JW5d0dajO3HQp
OqLA9RlQpyLSXC+XBJhps7SfyfvxGR00D81kkwy+PfR6kRam0DAcRIzpnMhWNaREXfT+Op5e4hth
6QJXur7hpWURKQZF3gxYc9kd624pu+H2hUULvpfnT8eb2axQxVuSlUxs2zA5OGlzIWpjXnZCD0T4
j7s//vGhxLEpQVfQmp5euY7l1P9OCf6iAjRKja1ZWVm79+/ff5aRk3o5lZrCv0XUmzbVz6n8rWKJ
cBT1c4e7H3gEg80pCB4MlpChJMS8gK6PQ42pI9CLYyPga7UjYZ58xa4brrx2/tdmzbranebu1HSN
aW3CIzs6TRU/wC85kEF9MboGJit0IDhEFNaEVT6oOMQx8UwesJqJQKlfBw1vtGB2ephzZcO2w71j
69uiS3mHDRLeh/rorgF1wft7Eo5AAQ8Lpgf+A3tO0Dq4ZRKEmKOel4jbKei0GgEv7er9VbiLOK6f
mduc4YbjNJywLQ8+J4aEPDobAcEqiYogSbaIz+yQOJ1KGiKrpQkPjkVCaYLjrI/VX4/2U6jq8fIP
e3evjLuiOO4BmB/82haTI3wP30nSZREMNFY9rjgtQy88ppz4focdFURJBjdKlQQXc0WteKECRBzG
BTfNzZu+wUKj4dwmvNq8cemnPccqF+bN/DDLkfmhhmMRLrAS/HnR0Ahaa9q0afdu2LDhrZKSEk8w
GGSATv5GFbPIonpDi0K4owPcPmQmAeVHcy9U2gUw4ExAr6xAVKRBkwwxYoKAuprWzwr6A+A9VgZx
Z0HdoqvnLZRkO6LTlB7LlBBkch1iA2qwpoGUJVQONAycdjcP3DKn0PmU7OA6dELk2raeeaAI0NaX
GN4d0S73u50fUR1b024sCEcGcjnDC4drjNI5Fcbzq1f4E8+8EHfe/Ejn+vX/yPcXZ7paWnuU8Xc/
3fKn9qZex7p7R27KDQjvxBPxb1Jd/qetXVMrK1y/njdKej9hE2HDzviiB548Pbd8oh254zt5jzV3
6tccbIrPIpoEAwkDPm2IjfKgGlYNzhHujQs2Guy+JjU3YkS+CU5hlNeUWNUv5jbgoYZn127u//hR
WuSoih7jdc6AOf6v9y4pXPzogKVoIx1FUG23gmSF4cGTj67OdAdXx/UERNQe1NoqNXJ4pm3DjM96
TzT/cvyPJjl0z+GZwdkH3+zcdb3CR6HdioDbDMD8rBnPUllvU7lh8RcUoMn52ORCtbEgCLBt27ZH
6uvr1yxZsuSs3KC6lu6QO32mEfYdqoaq2ggUpDshN8jDyfoEHDiTCYXpCXAH2sHyd0IcybTXqUPY
GWWyY2RvNrTvnQp3375o1dyJaX9IoCyRqEbHg+doCduCDdvCr//kqY5lQBnVEhDUYXj1nrKXvj7Z
d/PpXq3iGz87eagrgfJBGYB/vaWo9pYlmWPwDvC9x9paN34aL+CdMhiJCFw/ne/69Z3jFz78Usc9
6/7a980ECtP8XD+EQxHwYKB//03Zz393XtYjKBwaHvxz+58feO709eVj3OH6dt3vEST06gimmAlX
Vbq7nvhh8ZyRee62Wx+v7frrx3GJ99HqMQaGGDAbIKErxTiCd7Jderqiw6QcHX70Sz3y6+Z/ThN1
5CVegkmO0bWtdmi0bscgk/ih0lOx/dqipTdncf5mWt4+kTi1+rnW137XrDXjc0vRSc7R1QsLZ/+2
Tu9e9PqJjd8hEnpG29s03TXqwM1l37mNN7lwnCgTH6j9za6dA/vdNAhd6F+w774x319qGVw7lRy0
sMV9BYTo+l40gB5kY0VR8p793bM1FRPLfeUV46k7hv6ePqg5ehA+OhKG7c1F0BT1ghuZwOeLgS5K
0NjmB1ESIEOIQb4bF843gABvBJ83CrpnANQODUaXLH7/H26e903Q9TgNGu1zNtJTudEdUic2dhj5
lkBsybJBs/GaPF+L3wvHVV0vO95s5OuoHE0E6PBMMZwXcO+hGr6hU5kZihpensg0HUYCXksdU+D6
kHCcePBk/Mqj9TGiaAb4MZibPM5jjspzvcuKPOhxqhr7K441hO+6Ylr+w0dPRYY3tic4mpkoznPa
Uyt8J3wSNNi6DXVd8fJQmAzjqTyhIaNpEhoEU2EuEMmmIKI7J3yysy+UWfXTu6oeuJbuu86GTFg/
4Z9K3bIvP2YoHg/nUNy8ZyuVazYSCNXadO9GFCIz+tVEmpOX6tPEtDoRnbRq6VxI672K5vFdkm+3
zEkRilQa5ooow95o2/zOI81PX+UyvfBvY++/bkL6+Fd1lISEJPeCkC9634sT0DRwoAHhgQMHHnn3
vffWzF8wD07W1MCuqm7Y15ENdX3DIKL4kxt4zOQmIUAXiiEQ2+oDyKx0KykKZ5BRRAcR4LnuThiT
3a88dt81lekB/3FL15N7KOAct0h40HSaGdDZJ5U4MgpPDNqwK46V3VVFgYRiIqNz4HNLTP5Qja3p
KsRUDFgRJCKKZQkPuvlHSaisBzfSsiBiIGaY0B9NsIX2ej3s/rqmQiRu56D86fS5BHA6eJbpiMV1
wMvBJfPgdolsbuhmKcXgWM7CgX1wdOMRLhPNh9M4w4nfuUQH7NcOvbGm6qFrTMmGXD0Tnq54aFS2
K6fOtJOpSyuZ8AT6MoCJ16mmgod5NnPDsZlM7t2GZNII45LkRqN0KQ3lvQAJQR25pvax/Tt6Pkq7
KnNRx8Oj75hgWVyXnXo94csB4PkG9HnbDz0YDE6aNGlddlZ274YNb4Ctk5OKWBne3zAGwZzN2JTu
VeORgQhG78R2s8mnTEIEBWMruvvOBFWXoSmWiXrTB6Munbsxi4IZQcXxhLHIFyJwNAxJIAhgB96T
YwsqY2AooOHQDTciT8vsUorREMh4LmGRpAWCJLISPB0DNQARgzFaaqdyRnY58f8iA4uMkZzf62B/
U+Ow2JszFMDQ6cCgTKJ90x1xqKmdeJ3TgbLHQBBrGAvg726nixWJKBBpVdXpcIATZQ7PtgugITmw
byf+JhD9LBIpWfKcRj9NHCsLplMZiOT2VYuNg2aF6HeUeWVBBgnHwOReKugVEYhuyY3985CQEiUv
tr62ZV9oX5pPyIQbc+avJ0ToGrzHV2UzzneW47zvh+Z5/syC+QuWVHR3XzVtctlvxjZxK16vPrwu
ElVoLhU9pp1kYmKkCgwUUCLTlxzb8O9gmQJLiQAGW8oPF+U+Qt08l9r+aP2N1VqMtXkQ2Bte1K1z
7NUnunvMYNxFwSRS8PCp/DYk9T0rRGJf9OCQySyDB5r+lSnQJeQ700q+9kWBgcbgQCDqSKsmNS6O
Y/3JNDVG+zWTfVFdT9mavsygIbU6zCRzChwFGaGJETZelmDhGDLZWGO65ukY6CzVhCQQFTsOJ+Kt
j2u6tjHHlb0Rv/xC/Znm3Wl+ncUStKCOwBW55P5ympZkMpBmaIgEDuKADrN3yb+fevX5v3a9k0FL
8JfnzN091j/6KduEv30/4QJq52Vz0rmWTCc0zZ/WWhDM3Ua9YjAgVMUTyoQde8JlbM+xzjb0pg6a
wkv9bVgsHWtTYOgxkIwY/PauMa9NHJH2NHOkJMm+3FfkR5mHZQRGA0XCpAar2tHxsOphMrfNM4bk
z7meY0xHzxVSlUp6DwklhSAkCyuDXmGQHamkGZRXwICKky4kx8Uz7wEMtGyczBuRZMYQDUOghoX3
psZJU750G4CAvzsdkvfZU3/c8lzrhmk2Wg/FOS2u7A59MmbnmT3XzAleGvJKaZ+c3ar7ebEFeJtn
nwRSpaBUtZT+TQNyHsmCjuE/2t958Y+nNo5EloZRpBjWjPnhSq/oraOShLuAX8O6IF6SpdEzYzZc
SdSVidsWj1ztkYQ7kdxWcgIn04ra31P6FHwaMnhButw//5L0h4AFQPx/YUhJ5mYgI0kGPzv3Z100
6k6eY6z2xYuBAZNnLwdwzNNT0J99YZV8sQBMUueTVE2eH1zoL72FxbwCBbpFPv9/av/G4NjYeFOb
+YlNlPLApHd4l7vCQ7f5W+R1BOYMhShBwXYfdPG+l8+NjQbBhXBl4zGZTIGz1cXB52IZKPqiAmr7
xXlz70pw6pu7Ww76v126ZHOeM+djm+b6BbgQXky5sILCoTbU/t8FhUNtqA0BeqgNtSFAD7WLqf2n
AAMAa11B1XiOnfEAAAAASUVORK5CYII=';
		file_put_contents(scPaths::getStoreRootDir() . $paymentModule->get('PaymentModuleImage'), base64_decode($img));
		
		$paymentModule->insert();
		
		miStaticDBUtil::commit();
		
		scLog::singleton()->info('Successfully installed Mobilpay.ro.');
	} catch (miException $e) {
		miStaticDBUtil::rollback();
		scLog::singleton()->error('Failed installing Mobilpay.ro: ' . $e->getMessage());
	}
	
	try {
		miStaticDBUtil::startTransaction();
		
		$module = new miSqlRecord('Modules', 'ModuleID');
		$module->set('ModuleName', 'com.summercart.payment.epayment_ro');
		$module->set('ModuleVersion', '');
		$module->set('ModuleTitle', 'Epayment.ro');
		$module->set('ModuleIsActive', true);
		$moduleId = $module->insert();
		
		$moduleClass = new miSqlRecord('ModuleClasses', 'ModuleClassID');
		$moduleClass->set('ModuleID', $module->getPK());
		$moduleClass->set('ModuleClassInterface', 'IPaymentModule');
		$moduleClass->set('ModuleClassName', 'scPaymentModuleEpaymentRo');
		$moduleClass->set('ModuleClassLocation', 'payment/epayment_ro/epayment.php');
		$moduleClass->insert();
		
		$paymentModule = new scSqlRecordML('PaymentModules', 'PaymentModuleID',
			array('PaymentModuleDisplayName'), array_keys($activeLanguages));
		$paymentModule->set('ModuleID', $module->getPK());
		$paymentModule->set('PaymentModuleName', 'Epayment.ro');
		$paymentModule->set('PaymentModuleIntegrationMethod', '');
		$paymentModule->set('PaymentModuleImage', 'skins/default/modules/payment/epayment_ro/logo_epayment_ro.png');
		$paymentModule->set('PaymentModuleIsActive', false);
		$mlValue = array();
		foreach ($activeLanguages as $lid => $lcode)
			$mlValue[$lid] = 'Epayment.ro';
		$paymentModule->set('PaymentModuleDisplayName', $mlValue);
		$paymentModule->set('PaymentModuleSort', ++$pmSort);
		
		$img = 'iVBORw0KGgoAAAANSUhEUgAAALQAAAAgCAYAAAC7OlJnAAAAGXRFWHRTb2Z0d2FyZQBBZG9iZSBJ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=';
		file_put_contents(scPaths::getStoreRootDir() . $paymentModule->get('PaymentModuleImage'), base64_decode($img));
		
		$paymentModule->insert();
		
		miStaticDBUtil::commit();
		
		scLog::singleton()->info('Successfully installed Epayment.ro.');
	} catch (miException $e) {
		miStaticDBUtil::rollback();
		scLog::singleton()->error('Failed installing Epayment.ro: ' . $e->getMessage());
	}
	
	try {
		miStaticDBUtil::startTransaction();
		
		$module = new miSqlRecord('Modules', 'ModuleID');
		$module->set('ModuleName', 'com.summercart.payment.plationline_ro');
		$module->set('ModuleVersion', '');
		$module->set('ModuleTitle', 'PlatiOnline.ro');
		$module->set('ModuleIsActive', true);
		$moduleId = $module->insert();
		
		$moduleClass = new miSqlRecord('ModuleClasses', 'ModuleClassID');
		$moduleClass->set('ModuleID', $module->getPK());
		$moduleClass->set('ModuleClassInterface', 'IPaymentModule');
		$moduleClass->set('ModuleClassName', 'scPaymentModulePlatiOnlineRo');
		$moduleClass->set('ModuleClassLocation', 'payment/plationline_ro/plationline.php');
		$moduleClass->insert();
		
		$moduleClass = new miSqlRecord('ModuleClasses', 'ModuleClassID');
		$moduleClass->set('ModuleID', $module->getPK());
		$moduleClass->set('ModuleClassInterface', 'IPaymentModuleOperations');
		$moduleClass->set('ModuleClassName', 'scPaymentModulePlatiOnlineRoOperations');
		$moduleClass->set('ModuleClassLocation', 'payment/plationline_ro/operations.php');
		$moduleClass->insert();
		
		$paymentModule = new scSqlRecordML('PaymentModules', 'PaymentModuleID',
			array('PaymentModuleDisplayName'), array_keys($activeLanguages));
		$paymentModule->set('ModuleID', $module->getPK());
		$paymentModule->set('PaymentModuleName', 'PlatiOnline.ro');
		$paymentModule->set('PaymentModuleIntegrationMethod', '');
		$paymentModule->set('PaymentModuleImage', 'skins/default/modules/payment/plationline_ro/logo_plationline.png');
		$paymentModule->set('PaymentModuleIsActive', false);
		$mlValue = array();
		foreach ($activeLanguages as $lid => $lcode)
			$mlValue[$lid] = 'PlatiOnline.ro';
		$paymentModule->set('PaymentModuleDisplayName', $mlValue);
		$paymentModule->set('PaymentModuleSort', ++$pmSort);
		
		$img = 'iVBORw0KGgoAAAANSUhEUgAAALQAAAAgCAYAAAC7OlJnAAAAGXRFWHRTb2Z0d2FyZQBBZG9iZSBJ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';
		file_put_contents(scPaths::getStoreRootDir() . $paymentModule->get('PaymentModuleImage'), base64_decode($img));
		
		$paymentModule->insert();
		
		miStaticDBUtil::commit();
		
		scLog::singleton()->info('Successfully installed PlatiOnline.ro.');
	} catch (miException $e) {
		miStaticDBUtil::rollback();
		scLog::singleton()->error('Failed installing PlatiOnline.ro: ' . $e->getMessage());
	}
?>