<?php
	
	scLog::singleton()->info('Applying the product tax prices patch.');
	
	try {
		// Taxed prices support
		miStaticDBUtil::execSQL('ALTER TABLE Taxes ADD COLUMN TaxIncludeWithDisplayPrice TINYINT(3) UNSIGNED DEFAULT "0" NOT NULL AFTER TaxApplyByDefault;');
		miStaticDBUtil::execSQL('INSERT INTO Settings (SettingName,SettingValue) VALUES ("DisplayPricesTaxMode", "0");');				
		
		// Discounts by payment module support
		miStaticDBUtil::execSQL('ALTER TABLE Discounts
			ADD COLUMN PaymentModuleID int(10) unsigned default NULL AFTER DiscountFreeShippingMethodID,
			ADD KEY FK_Discounts_PaymentModuleID (PaymentModuleID),
			ADD CONSTRAINT FK_Discounts_PaymentModuleID FOREIGN KEY (PaymentModuleID) REFERENCES PaymentModules (PaymentModuleID) ON DELETE CASCADE ON UPDATE CASCADE;'
		);
		
		// Insert all new texts
		$codeTexts = array(
			'Include tax with price' => array(
				'BG' => 'Показване на цените с включени данъци',
				'TR' => 'Kdv Dahil Fiyat'
			),
			'Display with and without tax' => array(
				'BG' => 'Показване на цените както без, така и с включени данъци.',
				'TR' => 'Kdv dahil ve hariç.'
			),
			'%s price' => array(
				'BG' => '%s цена',
				'TR' => '%s fiyat'
			),
		);
		scUpdater::insertTexts($codeTexts, scInterfaceTexts::TEXT_TYPE_CODE);
		
		$templateTexts = array(
			'Payment module:' => array(
				'BG' => 'Модул за плащане:',
				'TR' => 'Ödeme Modulü:'
			),
			'Display prices tax mode:' => array(
				'BG' => 'Показване на цени (с или без данъци):',
				'TR' => 'Kdv görüntülüme modu:'
			),
			'Include with Display Price:' => array(
				'BG' => 'Добавяне към цените:',
				'TR' => 'Kdv dahil fiyat görüntülüme:'
			),
			'Price excl. tax:' => array(
				'BG' => 'Цена без ДДС:',
				'TR' => 'Kdv Hariç Fiyat:'
			),
			'Price inc. tax:' => array(
				'BG' => 'Цена с ДДС:',
				'TR' => 'Kdv Dahil Fiyat:'
			),
			'discounts info' => array(
				'BG' => 'отстъпки',
				'TR' => 'indirim bilgileri'
			),
		);
		scUpdater::insertTexts($templateTexts, scInterfaceTexts::TEXT_TYPE_TEMPLATE);
		
		$codeAndTemplateTexts = array(
			'(without tax)' => array(
				'BG' => '(без ДДС)',
				'TR' => '(kdv hariç)'
			),
			'(with tax)' => array(
				'BG' => '(с ДДС)',
				'TR' => '(kdv dahil)'
			),
		);
		scUpdater::insertTexts($templateTexts, scInterfaceTexts::TEXT_TYPE_CODE + scInterfaceTexts::TEXT_TYPE_TEMPLATE);
		
		scLog::singleton()->info('Successfully applied the product tax prices patch');
	} catch (miException $e) {
		scLog::singleton()->error('Failed appliyng the product tax prices patch: ' . $e->getMessage());
	}
?>
