
/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;
DROP TABLE IF EXISTS `AdminQuickLinks`;
CREATE TABLE `AdminQuickLinks` (
  `AdminQuickLinkID` int(10) unsigned NOT NULL auto_increment,
  `AdminQuickLinkPage` varchar(255) NOT NULL default '',
  `AdminQuickLinkPageAction` varchar(255) NOT NULL default '',
  `AdminQuickLinkLocation` varchar(255) NOT NULL default '',
  PRIMARY KEY  USING BTREE (`AdminQuickLinkID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `AdminQuickLinksML`;
CREATE TABLE `AdminQuickLinksML` (
  `AdminQuickLinkID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `AdminQuickLinkText` varchar(255) NOT NULL default '',
  PRIMARY KEY  USING BTREE (`AdminQuickLinkID`,`LanguageID`),
  KEY `FK_AdminQuickLinksML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_AdminQuickLinksML_AdminQuickLinkID` FOREIGN KEY (`AdminQuickLinkID`) REFERENCES `AdminQuickLinks` (`AdminQuickLinkID`) ON DELETE CASCADE,
  CONSTRAINT `FK_AdminQuickLinksML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `AdministratorPrivs`;
CREATE TABLE `AdministratorPrivs` (
  `AdministratorID` int(10) unsigned NOT NULL default '0',
  `AdministratorPrivSection` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`AdministratorID`,`AdministratorPrivSection`),
  CONSTRAINT `FK_AdministratorPrivs_AdministratorID` FOREIGN KEY (`AdministratorID`) REFERENCES `Administrators` (`AdministratorID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Administrators`;
CREATE TABLE `Administrators` (
  `AdministratorID` int(10) unsigned NOT NULL auto_increment,
  `AdministratorUsername` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  `AdministratorPassword` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  `AdministratorPasswordHashMode` tinyint(3) unsigned NOT NULL default '0',
  `AdministratorEmail` varchar(255) NOT NULL default '',
  `AdministratorAccessLevel` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`AdministratorID`),
  UNIQUE KEY `AdministratorUsername` (`AdministratorUsername`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ApiAccounts`;
CREATE TABLE `ApiAccounts` (
  `ApiAccountID` int(10) unsigned NOT NULL auto_increment,
  `ApiAccountUsername` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  `ApiAccountPassword` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  PRIMARY KEY  USING BTREE (`ApiAccountID`),
  UNIQUE KEY `ApiAuthUsername` (`ApiAccountUsername`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ApiAccountsPrivs`;
CREATE TABLE `ApiAccountsPrivs` (
  `ApiAccountID` int(10) unsigned NOT NULL default '0',
  `ApiAccountPrivEntityCode` int(10) unsigned NOT NULL default '0',
  `ApiAccountPrivOperations` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ApiAccountID`,`ApiAccountPrivEntityCode`),
  CONSTRAINT `FK_ApiAccountsPrivs_ApiAccountID` FOREIGN KEY (`ApiAccountID`) REFERENCES `ApiAccounts` (`ApiAccountID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Bestsellers`;
CREATE TABLE `Bestsellers` (
  `BestsellerID` int(10) unsigned NOT NULL auto_increment,
  `ProductID` int(10) unsigned NOT NULL default '0',
  `BestsellerSort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`BestsellerID`),
  UNIQUE KEY `BestsellerSort` (`BestsellerSort`),
  KEY `FK_Bestsellers_ProductID` (`ProductID`),
  CONSTRAINT `FK_Bestsellers_ProductID` FOREIGN KEY (`ProductID`) REFERENCES `Products` (`ProductID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `BonusPointsTransactions`;
CREATE TABLE `BonusPointsTransactions` (
  `BonusPointsTransactionID` int(10) unsigned NOT NULL auto_increment,
  `CustomerID` int(10) unsigned NOT NULL default '0',
  `BonusPointsTransactionTime` int(10) unsigned NOT NULL default '0',
  `BonusPointsTransactionType` tinyint(3) unsigned NOT NULL default '0',
  `BonusPointsTransactionReason` tinyint(3) unsigned NOT NULL default '0',
  `BonusPointsTransactionDescription` varchar(255) NOT NULL default '',
  `BonusPointsAmount` int(11) NOT NULL default '0',
  `BonusPointsTransactionIdentifier` varchar(255) NOT NULL default '',
  `BonusPointsTransactionStatus` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  USING BTREE (`BonusPointsTransactionID`),
  KEY `FK_BonusPointsTransactions_CustomerID` USING BTREE (`CustomerID`),
  CONSTRAINT `FK_BonusPointsTransactions_CustomerID` FOREIGN KEY (`CustomerID`) REFERENCES `Customers` (`CustomerID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `BundleProducts`;
CREATE TABLE `BundleProducts` (
  `BundleProductID` int(10) unsigned NOT NULL auto_increment,
  `ProductID` int(10) unsigned NOT NULL default '0',
  `SubProductID` int(10) unsigned NOT NULL default '0',
  `BundleProductQuantity` int(10) unsigned NOT NULL default '0',
  `BundleProductSort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  USING BTREE (`BundleProductID`),
  UNIQUE KEY `ProductID` USING BTREE (`ProductID`,`SubProductID`),
  UNIQUE KEY `BundleProductSort` (`ProductID`,`BundleProductSort`),
  KEY `FK_BundleProducts_SubProductID` (`SubProductID`),
  CONSTRAINT `FK_BundleProducts_ProductID` FOREIGN KEY (`ProductID`) REFERENCES `Products` (`ProductID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_BundleProducts_SubProductID` FOREIGN KEY (`SubProductID`) REFERENCES `Products` (`ProductID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CMSBoxOptions`;
CREATE TABLE `CMSBoxOptions` (
  `CMSBoxOptionID` int(10) unsigned NOT NULL auto_increment,
  `CMSBoxID` int(10) unsigned NOT NULL default '0',
  `CMSBoxOptionName` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  `CMSBoxOptionValue` mediumblob NOT NULL,
  PRIMARY KEY  (`CMSBoxOptionID`),
  KEY `FK_CMSBoxOptions_CMSBoxID` (`CMSBoxID`),
  CONSTRAINT `FK_CMSBoxOptions_CMSBoxID` FOREIGN KEY (`CMSBoxID`) REFERENCES `CMSBoxes` (`CMSBoxID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CMSBoxOptionsML`;
CREATE TABLE `CMSBoxOptionsML` (
  `CMSBoxID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `CMSBoxOptionName` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  `CMSBoxOptionValue` mediumblob NOT NULL,
  PRIMARY KEY  (`CMSBoxID`,`LanguageID`,`CMSBoxOptionName`),
  KEY `FK_CMSBoxOptionsML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_CMSBoxOptionsML_CMSBoxID` FOREIGN KEY (`CMSBoxID`) REFERENCES `CMSBoxes` (`CMSBoxID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_CMSBoxOptionsML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CMSBoxes`;
CREATE TABLE `CMSBoxes` (
  `CMSBoxID` int(10) unsigned NOT NULL auto_increment,
  `ModuleClassID` int(10) unsigned NOT NULL default '0',
  `CMSBoxType` tinyint(3) unsigned NOT NULL default '0',
  `CMSBoxArea` tinyint(3) unsigned NOT NULL default '0',
  `CMSBoxName` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  `CMSBoxIsActive` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CMSBoxID`),
  UNIQUE KEY `CMSBoxName` (`CMSBoxName`),
  KEY `FK_CMSBoxes_ModuleClassID` (`ModuleClassID`),
  CONSTRAINT `FK_CMSBoxes_ModuleClassID` FOREIGN KEY (`ModuleClassID`) REFERENCES `ModuleClasses` (`ModuleClassID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CMSDynamicPageAreas`;
CREATE TABLE `CMSDynamicPageAreas` (
  `CMSDynamicPageAreaID` int(10) unsigned NOT NULL auto_increment,
  `CMSDynamicPageID` int(10) unsigned NOT NULL default '0',
  `CMSDynamicPageAreaTitle` varchar(255) NOT NULL default '',
  `CMSDynamicPageAreaName` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`CMSDynamicPageAreaID`),
  KEY `FK_CMSDynamicPageAreas_CMSDynamicPageID` (`CMSDynamicPageID`),
  CONSTRAINT `FK_CMSDynamicPageAreas_CMSDynamicPageID` FOREIGN KEY (`CMSDynamicPageID`) REFERENCES `CMSDynamicPages` (`CMSDynamicPageID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CMSDynamicPageAreasML`;
CREATE TABLE `CMSDynamicPageAreasML` (
  `CMSDynamicPageAreaID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `CMSDynamicPageAreaText` text NOT NULL,
  PRIMARY KEY  (`CMSDynamicPageAreaID`,`LanguageID`),
  KEY `FK_CMSDynamicPageAreasML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_CMSDynamicPageAreasML_CMSDynamicPageAreaID` FOREIGN KEY (`CMSDynamicPageAreaID`) REFERENCES `CMSDynamicPageAreas` (`CMSDynamicPageAreaID`) ON DELETE CASCADE,
  CONSTRAINT `FK_CMSDynamicPageAreasML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CMSDynamicPages`;
CREATE TABLE `CMSDynamicPages` (
  `CMSDynamicPageID` int(10) unsigned NOT NULL auto_increment,
  `ModuleID` int(10) unsigned NOT NULL default '0',
  `CMSDynamicPageName` varchar(255) NOT NULL default '',
  `CMSDynamicPagePath` varchar(255) NOT NULL default '',
  `CMSLayoutID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CMSDynamicPageID`),
  UNIQUE KEY `CMSDynamicPagePath` USING BTREE (`CMSDynamicPagePath`),
  KEY `CMSLayoutID` (`CMSLayoutID`),
  KEY `FK_CMSDynamicPages_ModuleID` (`ModuleID`),
  CONSTRAINT `FK_CMSDynamicPages_CMSLayoutID` FOREIGN KEY (`CMSLayoutID`) REFERENCES `CMSLayouts` (`CMSLayoutID`),
  CONSTRAINT `FK_CMSDynamicPages_ModuleID` FOREIGN KEY (`ModuleID`) REFERENCES `Modules` (`ModuleID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CMSDynamicPagesML`;
CREATE TABLE `CMSDynamicPagesML` (
  `CMSDynamicPageID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `CMSDynamicPageTitle` varchar(255) NOT NULL default '',
  `CMSDynamicPageSEOTitle` text NOT NULL,
  `CMSDynamicPageSEOKeywords` text NOT NULL,
  `CMSDynamicPageSEODescription` text NOT NULL,
  PRIMARY KEY  (`CMSDynamicPageID`,`LanguageID`),
  KEY `FK_CMSDynamicPagesML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_CMSDynamicPagesML_CMSDynamicPageML` FOREIGN KEY (`CMSDynamicPageID`) REFERENCES `CMSDynamicPages` (`CMSDynamicPageID`) ON DELETE CASCADE,
  CONSTRAINT `FK_CMSDynamicPagesML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CMSFormItemValues`;
CREATE TABLE `CMSFormItemValues` (
  `CMSFormItemValueID` int(10) unsigned NOT NULL auto_increment,
  `CMSFormItemID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CMSFormItemValueID`),
  KEY `FK_CMSFormItemValues_CMSFormItemID` (`CMSFormItemID`),
  CONSTRAINT `FK_CMSFormItemValues_CMSFormItemID` FOREIGN KEY (`CMSFormItemID`) REFERENCES `CMSFormItems` (`CMSFormItemID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CMSFormItemValuesML`;
CREATE TABLE `CMSFormItemValuesML` (
  `CMSFormItemValueID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `CMSFormItemValue` varchar(255) NOT NULL default '',
  PRIMARY KEY  USING BTREE (`CMSFormItemValueID`,`LanguageID`),
  KEY `FK_CMSFormItemValuesML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_CMSFormItemValuesML_CMSFormItemValueID` FOREIGN KEY (`CMSFormItemValueID`) REFERENCES `CMSFormItemValues` (`CMSFormItemValueID`) ON DELETE CASCADE,
  CONSTRAINT `FK_CMSFormItemValuesML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CMSFormItems`;
CREATE TABLE `CMSFormItems` (
  `CMSFormItemID` int(10) unsigned NOT NULL auto_increment,
  `CMSFormID` int(10) unsigned NOT NULL default '0',
  `CMSFormItemType` tinyint(3) unsigned NOT NULL default '0',
  `CMSFormItemValues` mediumblob NOT NULL,
  `CMSFormItemIsActive` tinyint(3) unsigned NOT NULL default '0',
  `CMSFormItemIsRequired` tinyint(3) unsigned NOT NULL default '0',
  `CMSFormItemSort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CMSFormItemID`),
  UNIQUE KEY `CMSFormItemSort` (`CMSFormID`,`CMSFormItemSort`),
  KEY `FK_CMSFormItems_CMSFormID` (`CMSFormID`),
  CONSTRAINT `FK_CMSFormItems_CMSFormID` FOREIGN KEY (`CMSFormID`) REFERENCES `CMSForms` (`CMSFormID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CMSFormItemsML`;
CREATE TABLE `CMSFormItemsML` (
  `CMSFormItemID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `CMSFormItemName` varchar(255) NOT NULL default '',
  `CMSFormItemCustomHtml` text NOT NULL,
  PRIMARY KEY  (`CMSFormItemID`,`LanguageID`),
  KEY `FK_CMSFormItemsML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_CMSFormItemsML_CMSFormItemID` FOREIGN KEY (`CMSFormItemID`) REFERENCES `CMSFormItems` (`CMSFormItemID`) ON DELETE CASCADE,
  CONSTRAINT `FK_CMSFormItemsML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CMSForms`;
CREATE TABLE `CMSForms` (
  `CMSFormID` int(10) unsigned NOT NULL auto_increment,
  `CMSFormName` varchar(255) NOT NULL default '',
  `CMSFormEmail` varchar(255) NOT NULL default '',
  `CMSFormEnableCaptcha` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CMSFormID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CMSFormsML`;
CREATE TABLE `CMSFormsML` (
  `CMSFormID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `CMSFormTitle` varchar(255) NOT NULL default '',
  `CMSFormDescription` text NOT NULL,
  `CMSFormConfirmText` text NOT NULL,
  `CMSFormSEOTitle` text NOT NULL,
  PRIMARY KEY  (`CMSFormID`,`LanguageID`),
  KEY `FK_CMSFormsML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_CMSFormsML_CMSFormID` FOREIGN KEY (`CMSFormID`) REFERENCES `CMSForms` (`CMSFormID`) ON DELETE CASCADE,
  CONSTRAINT `FK_CMSFormsML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CMSLayoutBoxes`;
CREATE TABLE `CMSLayoutBoxes` (
  `CMSLayoutID` int(10) unsigned NOT NULL default '0',
  `CMSBoxID` int(10) unsigned NOT NULL default '0',
  `CMSLayoutBoxColumn` int(10) unsigned NOT NULL default '0',
  `CMSLayoutBoxSort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CMSLayoutID`,`CMSBoxID`),
  UNIQUE KEY `CMSLayoutBoxSort` USING BTREE (`CMSLayoutBoxSort`,`CMSLayoutBoxColumn`,`CMSLayoutID`),
  KEY `FK_CMSLayoutBoxes_CMSBoxID` (`CMSBoxID`),
  CONSTRAINT `FK_CMSLayoutBoxes_CMSBoxID` FOREIGN KEY (`CMSBoxID`) REFERENCES `CMSBoxes` (`CMSBoxID`) ON DELETE CASCADE,
  CONSTRAINT `FK_CMSLayoutBoxes_CMSLayoutID` FOREIGN KEY (`CMSLayoutID`) REFERENCES `CMSLayouts` (`CMSLayoutID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CMSLayouts`;
CREATE TABLE `CMSLayouts` (
  `CMSLayoutID` int(10) unsigned NOT NULL auto_increment,
  `CMSLayoutName` varchar(255) NOT NULL default '',
  `CMSLayoutCssClassNames` varchar(255) NOT NULL default '',
  `CMSLayoutArea` tinyint(3) unsigned NOT NULL default '0',
  `CMSLayoutIsDefault` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CMSLayoutID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CMSMenuItems`;
CREATE TABLE `CMSMenuItems` (
  `CMSMenuItemID` int(10) unsigned NOT NULL auto_increment,
  `CMSMenuID` int(10) unsigned NOT NULL default '0',
  `CMSMenuItemLinkType` tinyint(3) unsigned NOT NULL default '0',
  `CMSMenuItemURL` varchar(255) NOT NULL default '',
  `CMSRichTextPageID` int(10) unsigned default '0',
  `CMSFormID` int(10) unsigned default '0',
  `GalleryID` int(10) unsigned default NULL,
  `CMSDynamicPageID` int(10) unsigned default NULL,
  `CMSMenuItemImageType` tinyint(3) unsigned NOT NULL default '0',
  `CMSMenuItemImage` varchar(255) NOT NULL default '',
  `CMSMenuItemImageX` int(10) unsigned NOT NULL default '0',
  `CMSMenuItemImageY` int(10) unsigned NOT NULL default '0',
  `CMSMenuItemSort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CMSMenuItemID`),
  UNIQUE KEY `CMSMenuItemSort` (`CMSMenuID`,`CMSMenuItemSort`),
  KEY `CMSMenuID` (`CMSMenuID`),
  KEY `FK_CMSMenuItems_CMSFormID` (`CMSFormID`),
  KEY `FK_CMSMenuItems_CMSRichTextPageID` (`CMSRichTextPageID`),
  KEY `FK_CMSMenuItems_GalleryID` (`GalleryID`),
  KEY `FK_CMSMenuItems_CMSDynamicPageID` (`CMSDynamicPageID`),
  CONSTRAINT `FK_CMSMenuItems_CMSDynamicPageID` FOREIGN KEY (`CMSDynamicPageID`) REFERENCES `CMSDynamicPages` (`CMSDynamicPageID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_CMSMenuItems_CMSFormID` FOREIGN KEY (`CMSFormID`) REFERENCES `CMSForms` (`CMSFormID`) ON DELETE CASCADE,
  CONSTRAINT `FK_CMSMenuItems_CMSMenuID` FOREIGN KEY (`CMSMenuID`) REFERENCES `CMSMenus` (`CMSMenuID`) ON DELETE CASCADE,
  CONSTRAINT `FK_CMSMenuItems_CMSRichTextPageID` FOREIGN KEY (`CMSRichTextPageID`) REFERENCES `CMSRichTextPages` (`CMSRichTextPageID`) ON DELETE CASCADE,
  CONSTRAINT `FK_CMSMenuItems_GalleryID` FOREIGN KEY (`GalleryID`) REFERENCES `Galleries` (`GalleryID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CMSMenuItemsML`;
CREATE TABLE `CMSMenuItemsML` (
  `CMSMenuItemID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `CMSMenuItemName` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`CMSMenuItemID`,`LanguageID`),
  KEY `FK_CMSMenuItemsML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_CMSMenuItemsML_CMSMenuItemID` FOREIGN KEY (`CMSMenuItemID`) REFERENCES `CMSMenuItems` (`CMSMenuItemID`) ON DELETE CASCADE,
  CONSTRAINT `FK_CMSMenuItemsML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CMSMenus`;
CREATE TABLE `CMSMenus` (
  `CMSMenuID` int(10) unsigned NOT NULL auto_increment,
  `CMSMenuName` varchar(255) NOT NULL default '',
  `CMSMenuLocation` tinyint(3) unsigned NOT NULL default '0',
  `CMSMenuIsActive` tinyint(3) unsigned NOT NULL default '0',
  `CMSBoxID` int(10) unsigned default NULL,
  PRIMARY KEY  (`CMSMenuID`),
  KEY `FK_CMSMenus_CMSBoxID` (`CMSBoxID`),
  CONSTRAINT `FK_CMSMenus_CMSBoxID` FOREIGN KEY (`CMSBoxID`) REFERENCES `CMSBoxes` (`CMSBoxID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CMSMenusML`;
CREATE TABLE `CMSMenusML` (
  `CMSMenuID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `CMSMenuTitle` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`CMSMenuID`,`LanguageID`),
  KEY `FK_CMSMenusML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_CMSMenusML_CMSMenuID` FOREIGN KEY (`CMSMenuID`) REFERENCES `CMSMenus` (`CMSMenuID`) ON DELETE CASCADE,
  CONSTRAINT `FK_CMSMenusML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CMSRichTextPages`;
CREATE TABLE `CMSRichTextPages` (
  `CMSRichTextPageID` int(10) unsigned NOT NULL auto_increment,
  `CMSRichTextPageUrl` varchar(255) NOT NULL default '',
  `CMSLayoutID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CMSRichTextPageID`),
  KEY `FK_CMSRichTextPages_CMSLayoutID` (`CMSLayoutID`),
  CONSTRAINT `FK_CMSRichTextPages_CMSLayoutID` FOREIGN KEY (`CMSLayoutID`) REFERENCES `CMSLayouts` (`CMSLayoutID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CMSRichTextPagesML`;
CREATE TABLE `CMSRichTextPagesML` (
  `CMSRichTextPageID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `CMSRichTextPageTitle` varchar(255) NOT NULL default '',
  `CMSRichTextPageContent` mediumtext NOT NULL,
  `CMSRichTextPageSEOTitle` text NOT NULL,
  `CMSRichTextPageSEOKeywords` text NOT NULL,
  `CMSRichTextPageSEODescription` text NOT NULL,
  PRIMARY KEY  (`CMSRichTextPageID`,`LanguageID`),
  KEY `FK_CMSRichTextPagesML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_CMSRichTextPagesML_CMSRichTextPageID` FOREIGN KEY (`CMSRichTextPageID`) REFERENCES `CMSRichTextPages` (`CMSRichTextPageID`) ON DELETE CASCADE,
  CONSTRAINT `FK_CMSRichTextPagesML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Categories`;
CREATE TABLE `Categories` (
  `CategoryID` int(10) unsigned NOT NULL auto_increment,
  `CategoryParentID` int(10) unsigned default NULL,
  `CategoryLeft` int(10) unsigned NOT NULL default '0',
  `CategoryRight` int(10) unsigned NOT NULL default '0',
  `CMSLayoutID` int(10) unsigned NOT NULL default '0',
  `CategoryProductCount` int(10) unsigned NOT NULL default '0',
  `CategoryDeepProductCount` int(10) unsigned NOT NULL default '0',
  `CategorySort` int(10) unsigned NOT NULL default '0',
  `CategoryImage` varchar(255) NOT NULL default '',
  `CategoryImageWidth` int(10) unsigned NOT NULL default '0',
  `CategoryImageHeight` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CategoryID`),
  UNIQUE KEY `CategoryParentID` USING BTREE (`CategoryParentID`,`CategorySort`),
  UNIQUE KEY `CategorySort` USING BTREE (`CategorySort`,`CategoryParentID`),
  KEY `CategoryNestedSet` (`CategoryLeft`,`CategoryRight`),
  KEY `FK_Categories_CMSLayoutID` (`CMSLayoutID`),
  CONSTRAINT `FK_Categories_CategoryParentID` FOREIGN KEY (`CategoryParentID`) REFERENCES `Categories` (`CategoryID`),
  CONSTRAINT `FK_Categories_CMSLayoutID` FOREIGN KEY (`CMSLayoutID`) REFERENCES `CMSLayouts` (`CMSLayoutID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CategoriesML`;
CREATE TABLE `CategoriesML` (
  `CategoryID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `CategoryName` varchar(255) NOT NULL default '',
  `CategoryDescription` text NOT NULL,
  `CategorySEOTitle` text NOT NULL,
  `CategorySEOKeywords` text NOT NULL,
  `CategorySEODescription` text NOT NULL,
  PRIMARY KEY  (`CategoryID`,`LanguageID`),
  KEY `FK_CategoriesML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_CategoriesML_CategoryID` FOREIGN KEY (`CategoryID`) REFERENCES `Categories` (`CategoryID`) ON DELETE CASCADE,
  CONSTRAINT `FK_CategoriesML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CheckoutModules`;
CREATE TABLE `CheckoutModules` (
  `CheckoutModuleID` int(10) unsigned NOT NULL auto_increment,
  `ModuleID` int(10) unsigned NOT NULL default '0',
  `CheckoutModuleImage` varchar(255) NOT NULL default '',
  `CheckoutModuleName` varchar(255) NOT NULL default '',
  `CheckoutModuleIsActive` tinyint(3) unsigned NOT NULL default '0',
  `CheckoutModuleSort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CheckoutModuleID`),
  UNIQUE KEY `CheckoutModuleSort` (`CheckoutModuleSort`),
  UNIQUE KEY `ModuleID` (`ModuleID`),
  CONSTRAINT `FK_CheckoutModules_ModuleID` FOREIGN KEY (`ModuleID`) REFERENCES `Modules` (`ModuleID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CheckoutModulesML`;
CREATE TABLE `CheckoutModulesML` (
  `CheckoutModuleID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `CheckoutModuleDisplayName` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`CheckoutModuleID`,`LanguageID`),
  KEY `FK_CheckoutModulesML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_CheckoutModulesML_CheckoutModuleID` FOREIGN KEY (`CheckoutModuleID`) REFERENCES `CheckoutModules` (`CheckoutModuleID`) ON DELETE CASCADE,
  CONSTRAINT `FK_CheckoutModulesML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Cities`;
CREATE TABLE `Cities` (
  `CityID` int(10) unsigned NOT NULL auto_increment,
  `StateID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CityID`),
  KEY `FK_Cities_StateID` (`StateID`),
  CONSTRAINT `FK_Cities_StateID` FOREIGN KEY (`StateID`) REFERENCES `States` (`StateID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CitiesML`;
CREATE TABLE `CitiesML` (
  `CityID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `CityName` varchar(255) NOT NULL default '',
  KEY `FK_CitiesML_CityID` (`CityID`),
  KEY `FK_CitiesML_LanguageID` (`LanguageID`),
  KEY `CityName` (`CityName`),
  CONSTRAINT `FK_CitiesML_CityID` FOREIGN KEY (`CityID`) REFERENCES `Cities` (`CityID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_CitiesML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CityPostCodes`;
CREATE TABLE `CityPostCodes` (
  `CityID` int(10) unsigned NOT NULL default '0',
  `CityPostCode` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`CityID`,`CityPostCode`),
  CONSTRAINT `FK_CityPostCodes_CityID` FOREIGN KEY (`CityID`) REFERENCES `Cities` (`CityID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CitySources`;
CREATE TABLE `CitySources` (
  `CitySourceID` int(10) unsigned NOT NULL auto_increment,
  `CityID` int(10) unsigned NOT NULL default '0',
  `CitySourceModuleID` int(10) unsigned NOT NULL default '0',
  `CitySourceCode` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  PRIMARY KEY  (`CitySourceID`),
  KEY `FK_CitySources_CityID` (`CityID`),
  KEY `FK_CitySources_CitySourceModuleID` (`CitySourceModuleID`),
  CONSTRAINT `FK_CitySources_CityID` FOREIGN KEY (`CityID`) REFERENCES `Cities` (`CityID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_CitySources_CitySourceModuleID` FOREIGN KEY (`CitySourceModuleID`) REFERENCES `Modules` (`ModuleID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Countries`;
CREATE TABLE `Countries` (
  `CountryID` int(10) unsigned NOT NULL auto_increment,
  `CountryCode2` varchar(2) NOT NULL default '',
  `CountryCode3` varchar(3) NOT NULL default '',
  `CountryRequireValidCity` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CountryID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CountriesML`;
CREATE TABLE `CountriesML` (
  `CountryID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `CountryName` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`CountryID`,`LanguageID`),
  KEY `FK_CountriesML_LanguageID` (`LanguageID`),
  KEY `LanguageIDCountryName` (`LanguageID`,`CountryName`),
  CONSTRAINT `FK_CountriesML_CountryID` FOREIGN KEY (`CountryID`) REFERENCES `Countries` (`CountryID`) ON DELETE CASCADE,
  CONSTRAINT `FK_CountriesML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CouponCategories`;
CREATE TABLE `CouponCategories` (
  `CouponID` int(10) unsigned NOT NULL default '0',
  `CategoryID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CouponID`,`CategoryID`),
  KEY `FK_CouponCategories_CategoryID` (`CategoryID`),
  CONSTRAINT `FK_CouponCategories_CategoryID` FOREIGN KEY (`CategoryID`) REFERENCES `Categories` (`CategoryID`) ON DELETE CASCADE,
  CONSTRAINT `FK_CouponCategories_CouponID` FOREIGN KEY (`CouponID`) REFERENCES `Coupons` (`CouponID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CouponCustomerGroups`;
CREATE TABLE `CouponCustomerGroups` (
  `CouponID` int(10) unsigned NOT NULL default '0',
  `CustomerGroupID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CouponID`,`CustomerGroupID`),
  KEY `FK_CouponCustomerGroups_CustomerID` (`CustomerGroupID`),
  CONSTRAINT `FK_CouponCustomerGroupss_CustomerGroupID` FOREIGN KEY (`CustomerGroupID`) REFERENCES `CustomerGroups` (`CustomerGroupID`) ON DELETE CASCADE,
  CONSTRAINT `FK_CouponCustomerGroups_CouponID` FOREIGN KEY (`CouponID`) REFERENCES `Coupons` (`CouponID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CouponCustomers`;
CREATE TABLE `CouponCustomers` (
  `CouponID` int(10) unsigned NOT NULL default '0',
  `CustomerID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CouponID`,`CustomerID`),
  KEY `FK_CouponCustomers_CustomerID` (`CustomerID`),
  CONSTRAINT `FK_CouponCustomers_CouponID` FOREIGN KEY (`CouponID`) REFERENCES `Coupons` (`CouponID`) ON DELETE CASCADE,
  CONSTRAINT `FK_CouponCustomers_CustomerID` FOREIGN KEY (`CustomerID`) REFERENCES `Customers` (`CustomerID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CouponManufacturers`;
CREATE TABLE `CouponManufacturers` (
  `CouponID` int(10) unsigned NOT NULL default '0',
  `ManufacturerID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CouponID`,`ManufacturerID`),
  KEY `FK_CouponManufacturers_ManufacturerID` (`ManufacturerID`),
  CONSTRAINT `FK_CouponManufacturers_CouponID` FOREIGN KEY (`CouponID`) REFERENCES `Coupons` (`CouponID`) ON DELETE CASCADE,
  CONSTRAINT `FK_CouponManufacturers_ManufacturerID` FOREIGN KEY (`ManufacturerID`) REFERENCES `Manufacturers` (`ManufacturerID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CouponProducts`;
CREATE TABLE `CouponProducts` (
  `CouponID` int(10) unsigned NOT NULL default '0',
  `ProductID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CouponID`,`ProductID`),
  KEY `FK_CouponProducts_ProductID` (`ProductID`),
  CONSTRAINT `FK_CouponProducts_CouponID` FOREIGN KEY (`CouponID`) REFERENCES `Coupons` (`CouponID`) ON DELETE CASCADE,
  CONSTRAINT `FK_CouponProducts_ProductID` FOREIGN KEY (`ProductID`) REFERENCES `Products` (`ProductID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Coupons`;
CREATE TABLE `Coupons` (
  `CouponID` int(10) unsigned NOT NULL auto_increment,
  `CouponCode` varchar(255) NOT NULL default '',
  `CouponType` tinyint(3) unsigned NOT NULL default '0',
  `CouponApplyMode` tinyint(3) unsigned NOT NULL default '0',
  `CouponImplementation` tinyint(3) unsigned NOT NULL default '0',
  `CouponValue` decimal(10,2) unsigned NOT NULL default '0.00',
  `CouponFreeShippingMethodID` int(10) unsigned default NULL,
  `CouponValidFrom` date NOT NULL default '0000-00-00',
  `CouponValidTo` date NOT NULL default '0000-00-00',
  `CouponIsActive` tinyint(3) unsigned NOT NULL default '0',
  `CouponConditionOrderExceeds` decimal(10,2) unsigned NOT NULL default '0.00',
  `CouponUsageCount` int(10) unsigned NOT NULL default '0',
  `CouponAllowedUsageCount` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CouponID`),
  UNIQUE KEY `CouponCode` (`CouponCode`),
  KEY `FK_Coupons_ShippingMethodID` (`CouponFreeShippingMethodID`),
  CONSTRAINT `FK_Coupons_ShippingMethodID` FOREIGN KEY (`CouponFreeShippingMethodID`) REFERENCES `ShippingMethods` (`ShippingMethodID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Currencies`;
CREATE TABLE `Currencies` (
  `CurrencyID` int(10) unsigned NOT NULL auto_increment,
  `CurrencyCode` varchar(3) NOT NULL default '',
  `CurrencyDecimalSymbol` varchar(255) NOT NULL default '',
  `CurrencyThousandsSeparator` varchar(255) NOT NULL default '',
  `CurrencyNumDecimals` tinyint(3) unsigned NOT NULL default '0',
  `CurrencyRate` decimal(10,4) unsigned NOT NULL default '0.0000',
  `CurrencyRateLastUpdated` int(10) unsigned NOT NULL default '0',
  `CurrencyIsActive` tinyint(3) unsigned NOT NULL default '0',
  `CurrencySort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CurrencyID`),
  UNIQUE KEY `CurrencyCode` (`CurrencyCode`),
  UNIQUE KEY `CurrencySort` (`CurrencySort`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CurrenciesML`;
CREATE TABLE `CurrenciesML` (
  `CurrencyID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `CurrencyName` varchar(255) NOT NULL default '',
  `CurrencySymbolLeft` varchar(255) NOT NULL default '',
  `CurrencySymbolRight` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`CurrencyID`,`LanguageID`),
  KEY `FK_CurrenciesML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_CurrenciesML_CurrencyID` FOREIGN KEY (`CurrencyID`) REFERENCES `Currencies` (`CurrencyID`) ON DELETE CASCADE,
  CONSTRAINT `FK_CurrenciesML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CurrencyRateModules`;
CREATE TABLE `CurrencyRateModules` (
  `CurrencyRateModuleID` int(10) unsigned NOT NULL auto_increment,
  `ModuleID` int(10) unsigned NOT NULL default '0',
  `CurrencyRateModuleImage` varchar(255) NOT NULL default '',
  `CurrencyRateModuleName` varchar(255) NOT NULL default '',
  `CurrencyRateModuleIsActive` tinyint(3) unsigned NOT NULL default '0',
  `CurrencyRateModuleSort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CurrencyRateModuleID`),
  UNIQUE KEY `CurrencyRateModuleSort` (`CurrencyRateModuleSort`),
  UNIQUE KEY `ModuleID` (`ModuleID`),
  CONSTRAINT `FK_CurrencyRateModules_ModuleID` FOREIGN KEY (`ModuleID`) REFERENCES `Modules` (`ModuleID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CurrencyRates`;
CREATE TABLE `CurrencyRates` (
  `CurrencyRateID` int(10) unsigned NOT NULL default '0',
  `CurrencyRateBaseSymbol` char(3) NOT NULL default '',
  `CurrencyRateQuoteSymbol` char(3) NOT NULL default '',
  `CurrencyRate` decimal(10,4) unsigned NOT NULL default '0.0000',
  `CurrencyRateTimestamp` int(10) unsigned NOT NULL default '0',
  `ModuleID` int(10) unsigned default '0',
  PRIMARY KEY  (`CurrencyRateID`),
  KEY `FK_CurrencyRates_ModuleID` (`ModuleID`),
  CONSTRAINT `FK_CurrencyRates_ModuleID` FOREIGN KEY (`ModuleID`) REFERENCES `Modules` (`ModuleID`) ON DELETE SET NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CustomUrls`;
CREATE TABLE `CustomUrls` (
  `CustomUrlID` int(10) unsigned NOT NULL auto_increment,
  `CustomUrlEntityCode` tinyint(3) unsigned NOT NULL default '0',
  `CustomUrlEntityID` int(10) unsigned NOT NULL default '0',
  `CustomUrlIsCurrent` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CustomUrlID`),
  KEY `CustomUrlEntity` (`CustomUrlEntityID`,`CustomUrlEntityCode`),
  KEY `CustomUrlIsCurrent` (`CustomUrlIsCurrent`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CustomUrlsML`;
CREATE TABLE `CustomUrlsML` (
  `CustomUrlID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `CustomUrlText` varchar(255) NOT NULL default '',
  `CustomUrlHash` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CustomUrlID`,`LanguageID`),
  UNIQUE KEY `CustomUrlText` (`CustomUrlText`),
  KEY `FK_CustomUrlsML_LanguageID` (`LanguageID`),
  KEY `CustomUrlHash` (`CustomUrlHash`),
  CONSTRAINT `FK_CustomUrlsML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_CustomUrlsML_CustomUrlID` FOREIGN KEY (`CustomUrlID`) REFERENCES `CustomUrls` (`CustomUrlID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CustomerAddresses`;
CREATE TABLE `CustomerAddresses` (
  `CustomerAddressID` int(10) unsigned NOT NULL auto_increment,
  `CustomerID` int(10) unsigned NOT NULL default '0',
  `CustomerAddressIsDefaultBilling` tinyint(1) NOT NULL default '0',
  `CustomerAddressIsDefaultShipping` tinyint(1) NOT NULL default '0',
  `CustomerAddressFirstName` varchar(255) NOT NULL default '',
  `CustomerAddressLastName` varchar(255) NOT NULL default '',
  `CustomerAddressCompany` varchar(255) NOT NULL default '',
  `CustomerAddressLine1` varchar(255) NOT NULL default '',
  `CustomerAddressLine2` varchar(255) NOT NULL default '',
  `CustomerAddressCity` varchar(255) NOT NULL default '',
  `CityID` int(10) unsigned default NULL,
  `StateID` int(10) unsigned default NULL,
  `CountryID` int(10) unsigned NOT NULL default '0',
  `CustomerAddressZip` varchar(255) NOT NULL default '',
  `CustomerAddressPhone` varchar(255) NOT NULL default '',
  `CustomerAddressFax` varchar(255) NOT NULL default '',
  `CustomerAddressVatNumber` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`CustomerAddressID`),
  KEY `FK_CustomerAddresses_CustomerID` (`CustomerID`),
  KEY `FK_CustomerAddresses_StateID` (`StateID`),
  KEY `FK_CustomerAddresses_CountryID` (`CountryID`),
  KEY `FK_CustomerAddresses_CityID` (`CityID`),
  CONSTRAINT `FK_CustomerAddresses_CityID` FOREIGN KEY (`CityID`) REFERENCES `Cities` (`CityID`) ON DELETE SET NULL ON UPDATE SET NULL,
  CONSTRAINT `FK_CustomerAddresses_CountryID` FOREIGN KEY (`CountryID`) REFERENCES `Countries` (`CountryID`) ON UPDATE CASCADE,
  CONSTRAINT `FK_CustomerAddresses_CustomerID` FOREIGN KEY (`CustomerID`) REFERENCES `Customers` (`CustomerID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_CustomerAddresses_StateID` FOREIGN KEY (`StateID`) REFERENCES `States` (`StateID`) ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CustomerGroups`;
CREATE TABLE `CustomerGroups` (
  `CustomerGroupID` int(10) unsigned NOT NULL auto_increment,
  `CustomerGroupSort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`CustomerGroupID`),
  UNIQUE KEY `CustomerGroupSort` (`CustomerGroupSort`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `CustomerGroupsML`;
CREATE TABLE `CustomerGroupsML` (
  `CustomerGroupID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `CustomerGroupName` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`CustomerGroupID`,`LanguageID`),
  KEY `FK_CustomerGroupsML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_CustomerGroupsML_CustomerGroupID` FOREIGN KEY (`CustomerGroupID`) REFERENCES `CustomerGroups` (`CustomerGroupID`) ON DELETE CASCADE,
  CONSTRAINT `FK_CustomerGroupsML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Customers`;
CREATE TABLE `Customers` (
  `CustomerID` int(10) unsigned NOT NULL auto_increment,
  `CustomerEmail` varchar(255) NOT NULL default '',
  `CustomerPassword` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  `CustomerPasswordHashMode` tinyint(3) unsigned NOT NULL default '0',
  `CustomerStatus` tinyint(3) unsigned NOT NULL default '0',
  `CustomerGroupID` int(10) unsigned NOT NULL default '0',
  `CustomerBonusPoints` int(11) NOT NULL default '0',
  `CustomerReferrerID` int(10) unsigned default NULL,
  PRIMARY KEY  (`CustomerID`),
  KEY `FK_Customers_CustomerGroupID` (`CustomerGroupID`),
  KEY `FK_Customers_CustomerReferrerID` (`CustomerReferrerID`),
  CONSTRAINT `FK_Customers_CustomerReferrerID` FOREIGN KEY (`CustomerReferrerID`) REFERENCES `Customers` (`CustomerID`) ON DELETE SET NULL ON UPDATE CASCADE,
  CONSTRAINT `FK_Customers_CustomerGroupID` FOREIGN KEY (`CustomerGroupID`) REFERENCES `CustomerGroups` (`CustomerGroupID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `DiscountCategories`;
CREATE TABLE `DiscountCategories` (
  `DiscountID` int(10) unsigned NOT NULL default '0',
  `CategoryID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`DiscountID`,`CategoryID`),
  KEY `FK_DiscountCategories_CategoryID` (`CategoryID`),
  CONSTRAINT `FK_DiscountCategories_CategoryID` FOREIGN KEY (`CategoryID`) REFERENCES `Categories` (`CategoryID`) ON DELETE CASCADE,
  CONSTRAINT `FK_DiscountCategories_DiscountID` FOREIGN KEY (`DiscountID`) REFERENCES `Discounts` (`DiscountID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `DiscountCustomerGroups`;
CREATE TABLE `DiscountCustomerGroups` (
  `DiscountID` int(10) unsigned NOT NULL default '0',
  `CustomerGroupID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`DiscountID`,`CustomerGroupID`),
  KEY `FK_DiscountCustomerGroups_CustomerGroupID` (`CustomerGroupID`),
  CONSTRAINT `FK_DiscountCustomerGroups_CustomerGroupID` FOREIGN KEY (`CustomerGroupID`) REFERENCES `CustomerGroups` (`CustomerGroupID`) ON DELETE CASCADE,
  CONSTRAINT `FK_DiscountCustomerGroups_DiscountID` FOREIGN KEY (`DiscountID`) REFERENCES `Discounts` (`DiscountID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `DiscountCustomers`;
CREATE TABLE `DiscountCustomers` (
  `DiscountID` int(10) unsigned NOT NULL default '0',
  `CustomerID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`DiscountID`,`CustomerID`),
  KEY `FK_DiscountCustomers_CustomerID` (`CustomerID`),
  CONSTRAINT `FK_DiscountCustomers_CustomerID` FOREIGN KEY (`CustomerID`) REFERENCES `Customers` (`CustomerID`) ON DELETE CASCADE,
  CONSTRAINT `FK_DiscountCustomers_DiscountID` FOREIGN KEY (`DiscountID`) REFERENCES `Discounts` (`DiscountID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `DiscountManufacturers`;
CREATE TABLE `DiscountManufacturers` (
  `DiscountID` int(10) unsigned NOT NULL default '0',
  `ManufacturerID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`DiscountID`,`ManufacturerID`),
  KEY `FK_DiscountManufacturers_ManufacturerID` (`ManufacturerID`),
  CONSTRAINT `FK_DiscountManufacturers_DiscountID` FOREIGN KEY (`DiscountID`) REFERENCES `Discounts` (`DiscountID`) ON DELETE CASCADE,
  CONSTRAINT `FK_DiscountManufacturers_ManufacturerID` FOREIGN KEY (`ManufacturerID`) REFERENCES `Manufacturers` (`ManufacturerID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `DiscountProducts`;
CREATE TABLE `DiscountProducts` (
  `DiscountID` int(10) unsigned NOT NULL default '0',
  `ProductID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`DiscountID`,`ProductID`),
  KEY `FK_DiscountProducts_ProductID` (`ProductID`),
  CONSTRAINT `FK_DiscountProducts_DiscountID` FOREIGN KEY (`DiscountID`) REFERENCES `Discounts` (`DiscountID`) ON DELETE CASCADE,
  CONSTRAINT `FK_DiscountProducts_ProductID` FOREIGN KEY (`ProductID`) REFERENCES `Products` (`ProductID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Discounts`;
CREATE TABLE `Discounts` (
  `DiscountID` int(10) unsigned NOT NULL auto_increment,
  `DiscountName` varchar(255) NOT NULL default '',
  `DiscountType` tinyint(3) unsigned NOT NULL default '0',
  `DiscountApplyMode` tinyint(3) unsigned NOT NULL default '0',
  `DiscountImplementation` tinyint(3) unsigned NOT NULL default '0',
  `DiscountValue` decimal(10,2) NOT NULL default '0.00',
  `DiscountFreeShippingMethodID` int(10) unsigned default NULL,
  `DiscountValidFrom` date NOT NULL default '0000-00-00',
  `DiscountValidTo` date NOT NULL default '0000-00-00',
  `DiscountIsActive` tinyint(3) unsigned NOT NULL default '0',
  `DiscountConditionOrderExceeds` decimal(10,2) unsigned NOT NULL default '0.00',
  PRIMARY KEY  (`DiscountID`),
  KEY `FK_Discounts_ShippingMethodID` (`DiscountFreeShippingMethodID`),
  CONSTRAINT `FK_Discounts_ShippingMethodID` FOREIGN KEY (`DiscountFreeShippingMethodID`) REFERENCES `ShippingMethods` (`ShippingMethodID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `FeaturedProductCategories`;
CREATE TABLE `FeaturedProductCategories` (
  `FeaturedProductID` int(10) unsigned NOT NULL default '0',
  `CategoryID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  USING BTREE (`FeaturedProductID`,`CategoryID`),
  KEY `FK_FeaturedProductCategories_CategoryID` (`CategoryID`),
  CONSTRAINT `FK_FeaturedProductCategories_CategoryID` FOREIGN KEY (`CategoryID`) REFERENCES `Categories` (`CategoryID`) ON DELETE CASCADE,
  CONSTRAINT `FK_FeaturedProductCategories_FeaturedProductID` FOREIGN KEY (`FeaturedProductID`) REFERENCES `FeaturedProducts` (`FeaturedProductID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `FeaturedProducts`;
CREATE TABLE `FeaturedProducts` (
  `FeaturedProductID` int(10) unsigned NOT NULL auto_increment,
  `ProductID` int(10) unsigned NOT NULL default '0',
  `FeaturedProductOnHome` tinyint(3) unsigned NOT NULL default '0',
  `FeaturedProductSort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`FeaturedProductID`),
  UNIQUE KEY `ProductID` (`ProductID`),
  UNIQUE KEY `FeaturedProductSort` (`FeaturedProductSort`),
  KEY `FeaturedProductOnHome` (`FeaturedProductOnHome`),
  CONSTRAINT `FK_FeaturedProducts_ProductID` FOREIGN KEY (`ProductID`) REFERENCES `Products` (`ProductID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Galleries`;
CREATE TABLE `Galleries` (
  `GalleryID` int(10) unsigned NOT NULL auto_increment,
  `GalleryName` varchar(255) NOT NULL default '',
  `GalleryDirName` varchar(255) NOT NULL default '',
  `GalleryIsActive` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`GalleryID`),
  UNIQUE KEY `GalleryDirName` (`GalleryDirName`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `GalleriesML`;
CREATE TABLE `GalleriesML` (
  `GalleryID` int(10) unsigned NOT NULL default '0',
  `GalleryTitle` varchar(255) NOT NULL default '',
  `GalleryDescription` text NOT NULL,
  `GallerySEOTitle` text NOT NULL,
  `LanguageID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`GalleryID`,`LanguageID`),
  KEY `FK_GalleriesML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_GalleriesML_GalleryID` FOREIGN KEY (`GalleryID`) REFERENCES `Galleries` (`GalleryID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_GalleriesML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `GalleryItems`;
CREATE TABLE `GalleryItems` (
  `GalleryItemID` int(10) unsigned NOT NULL auto_increment,
  `GalleryID` int(10) unsigned NOT NULL default '0',
  `GalleryItemName` varchar(255) NOT NULL default '',
  `GalleryItemCreateTimestamp` int(10) unsigned NOT NULL default '0',
  `GalleryItemURL` text NOT NULL,
  `GalleryItemSort` int(10) unsigned NOT NULL default '0',
  `GalleryItemImage` varchar(255) NOT NULL default '',
  `GalleryItemImageWidth` int(10) unsigned NOT NULL default '0',
  `GalleryItemImageHeight` int(10) unsigned NOT NULL default '0',
  `GalleryItemImageThumb` varchar(255) NOT NULL default '',
  `GalleryItemImageThumbWidth` int(10) unsigned NOT NULL default '0',
  `GalleryItemImageThumbHeight` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`GalleryItemID`),
  UNIQUE KEY `GalleryItemSort` (`GalleryID`,`GalleryItemSort`),
  UNIQUE KEY `GalleryItemName` (`GalleryID`,`GalleryItemName`),
  KEY `FK_GalleryItems_GalleryID` (`GalleryID`),
  CONSTRAINT `FK_GalleryItems_GalleryID` FOREIGN KEY (`GalleryID`) REFERENCES `Galleries` (`GalleryID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `GalleryItemsML`;
CREATE TABLE `GalleryItemsML` (
  `GalleryItemID` int(10) unsigned NOT NULL default '0',
  `GalleryItemDescription` text NOT NULL,
  `LanguageID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`GalleryItemID`,`LanguageID`),
  KEY `FK_GalleryItems_GalleryItemID` (`GalleryItemID`),
  KEY `FK_GalleryItems_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_GalleryItems_GalleryItemID` FOREIGN KEY (`GalleryItemID`) REFERENCES `GalleryItems` (`GalleryItemID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_GalleryItems_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Helps`;
CREATE TABLE `Helps` (
  `HelpID` int(10) unsigned NOT NULL auto_increment,
  `HelpPage` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  `HelpPageAction` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`HelpID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `HelpsML`;
CREATE TABLE `HelpsML` (
  `HelpID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `HelpText` text NOT NULL,
  PRIMARY KEY  (`HelpID`,`LanguageID`),
  KEY `FK_HelpsML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_HelpsML_HelpID` FOREIGN KEY (`HelpID`) REFERENCES `Helps` (`HelpID`) ON DELETE CASCADE,
  CONSTRAINT `FK_HelpsML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Languages`;
CREATE TABLE `Languages` (
  `LanguageID` int(10) unsigned NOT NULL auto_increment,
  `LanguageName` varchar(255) NOT NULL default '',
  `LanguageCode` varchar(2) NOT NULL default '',
  `LanguageDirection` tinyint(1) unsigned NOT NULL default '0',
  `LanguageIsActive` tinyint(1) unsigned NOT NULL default '0',
  `LanguageImage` varchar(255) NOT NULL default '',
  `LanguageImageWidth` int(10) unsigned NOT NULL default '0',
  `LanguageImageHeight` int(10) unsigned NOT NULL default '0',
  `LanguagePackAuthor` varchar(255) NOT NULL default '',
  `LanguagePackDescription` varchar(255) NOT NULL default '',
  `LanguagePackLicense` varchar(255) NOT NULL default '',
  `LanguagePackPublishDate` date NOT NULL default '0000-00-00',
  `LanguageSort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`LanguageID`),
  UNIQUE KEY `LanguageCode` (`LanguageCode`),
  UNIQUE KEY `LanguageSort` (`LanguageSort`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `LocalOptionGroups`;
CREATE TABLE `LocalOptionGroups` (
  `LocalOptionGroupID` int(10) unsigned NOT NULL auto_increment,
  `ProductID` int(10) unsigned NOT NULL default '0',
  `LocalOptionGroupType` tinyint(3) unsigned NOT NULL default '0',
  `LocalOptionGroupSort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`LocalOptionGroupID`),
  UNIQUE KEY `LocalOptionGroupSort` (`ProductID`,`LocalOptionGroupSort`),
  KEY `FK_LocalOptionGroups_ProductID` (`ProductID`),
  CONSTRAINT `FK_LocalOptionGroups_ProductID` FOREIGN KEY (`ProductID`) REFERENCES `Products` (`ProductID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `LocalOptionGroupsML`;
CREATE TABLE `LocalOptionGroupsML` (
  `LocalOptionGroupID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `LocalOptionGroupName` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`LocalOptionGroupID`,`LanguageID`),
  KEY `FK_LocalOptionGroupsML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_LocalOptionGroupsML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_LocalOptionGroupsML_LocalOptionGroupID` FOREIGN KEY (`LocalOptionGroupID`) REFERENCES `LocalOptionGroups` (`LocalOptionGroupID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `LocalOptions`;
CREATE TABLE `LocalOptions` (
  `LocalOptionID` int(10) unsigned NOT NULL auto_increment,
  `LocalOptionGroupID` int(10) unsigned NOT NULL default '0',
  `LocalOptionPriceModType` tinyint(3) unsigned NOT NULL default '0',
  `LocalOptionPriceModValue` decimal(10,2) NOT NULL default '0.00',
  `LocalOptionRequired` tinyint(1) unsigned NOT NULL default '0',
  `LocalOptionSort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`LocalOptionID`),
  UNIQUE KEY `LocalOptionSort` (`LocalOptionGroupID`,`LocalOptionSort`),
  KEY `FK_LocalOptions_LocalOptionGroupID` (`LocalOptionGroupID`),
  CONSTRAINT `FK_LocalOptions_LocalOptionGroupID` FOREIGN KEY (`LocalOptionGroupID`) REFERENCES `LocalOptionGroups` (`LocalOptionGroupID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `LocalOptionsML`;
CREATE TABLE `LocalOptionsML` (
  `LocalOptionID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `LocalOptionName` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`LocalOptionID`,`LanguageID`),
  KEY `FK_LocalOptionsML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_LocalOptionsML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_LocalOptionsML_LocalOptionID` FOREIGN KEY (`LocalOptionID`) REFERENCES `LocalOptions` (`LocalOptionID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Logs`;
CREATE TABLE `Logs` (
  `LogID` int(10) unsigned NOT NULL auto_increment,
  `LogTimestamp` int(10) unsigned NOT NULL default '0',
  `LogSeverity` tinyint(3) unsigned NOT NULL default '0',
  `LogMessage` text NOT NULL,
  `LogCategory` tinyint(3) unsigned NOT NULL default '0',
  `LogAdministratorUsername` varchar(255) NOT NULL default '',
  `LogCustomerEmail` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`LogID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Manufacturers`;
CREATE TABLE `Manufacturers` (
  `ManufacturerID` int(10) unsigned NOT NULL auto_increment,
  `ManufacturerWebsite` varchar(255) NOT NULL default '',
  `ManufacturerImage` varchar(255) NOT NULL default '',
  `ManufacturerImageWidth` int(10) unsigned NOT NULL default '0',
  `ManufacturerImageHeight` int(10) unsigned NOT NULL default '0',
  `ManufacturerSort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ManufacturerID`),
  UNIQUE KEY `ManufacturerSort` (`ManufacturerSort`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ManufacturersML`;
CREATE TABLE `ManufacturersML` (
  `ManufacturerID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `ManufacturerName` varchar(255) NOT NULL default '',
  `ManufacturerDescription` text NOT NULL,
  `ManufacturerSEOTitle` text NOT NULL,
  PRIMARY KEY  (`ManufacturerID`,`LanguageID`),
  KEY `FK_ManufacturersML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_ManufacturersML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE,
  CONSTRAINT `FK_ManufacturersML_ManufacturerID` FOREIGN KEY (`ManufacturerID`) REFERENCES `Manufacturers` (`ManufacturerID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ModuleClasses`;
CREATE TABLE `ModuleClasses` (
  `ModuleClassID` int(10) unsigned NOT NULL auto_increment,
  `ModuleID` int(10) unsigned NOT NULL default '0',
  `ModuleClassInterface` varchar(255) character set ascii NOT NULL default '',
  `ModuleClassName` varchar(255) character set ascii NOT NULL default '',
  `ModuleClassLocation` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  PRIMARY KEY  (`ModuleClassID`),
  UNIQUE KEY `ModuleClassName_ModuleClassInterface` (`ModuleClassName`,`ModuleClassInterface`),
  KEY `FK_ModuleClasses_ModuleID` (`ModuleID`),
  CONSTRAINT `FK_ModuleClasses_ModuleID` FOREIGN KEY (`ModuleID`) REFERENCES `Modules` (`ModuleID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ModuleOptions`;
CREATE TABLE `ModuleOptions` (
  `ModuleOptionID` int(10) unsigned NOT NULL auto_increment,
  `ModuleID` int(10) unsigned NOT NULL default '0',
  `ModuleOptionName` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  `ModuleOptionValue` mediumblob NOT NULL,
  PRIMARY KEY  (`ModuleOptionID`),
  KEY `FK_ModuleOptions_ModuleID` (`ModuleID`),
  CONSTRAINT `FK_ModuleOptions_ModuleID` FOREIGN KEY (`ModuleID`) REFERENCES `Modules` (`ModuleID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ModuleOptionsML`;
CREATE TABLE `ModuleOptionsML` (
  `ModuleID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `ModuleOptionName` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  `ModuleOptionValue` mediumblob NOT NULL,
  PRIMARY KEY  USING BTREE (`ModuleID`,`LanguageID`,`ModuleOptionName`),
  KEY `FK_ModuleOptionsML_ModuleID` (`ModuleID`),
  KEY `FK_ModuleOptionsML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_ModuleOptionsML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE,
  CONSTRAINT `FK_ModuleOptionsML_ModuleID` FOREIGN KEY (`ModuleID`) REFERENCES `Modules` (`ModuleID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ModuleTexts`;
CREATE TABLE `ModuleTexts` (
  `ModuleID` int(10) unsigned NOT NULL default '0',
  `TextID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ModuleID`,`TextID`),
  KEY `FK_ModuleTexts_TextID` (`TextID`),
  CONSTRAINT `FK_ModuleTexts_ModuleID` FOREIGN KEY (`ModuleID`) REFERENCES `Modules` (`ModuleID`),
  CONSTRAINT `FK_ModuleTexts_TextID` FOREIGN KEY (`TextID`) REFERENCES `Texts` (`TextID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Modules`;
CREATE TABLE `Modules` (
  `ModuleID` int(10) unsigned NOT NULL auto_increment,
  `PluginID` int(10) unsigned default NULL,
  `ModuleName` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  `ModuleVersion` varchar(255) NOT NULL default '',
  `ModuleTitle` varchar(255) NOT NULL default '',
  `ModuleIsActive` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ModuleID`),
  UNIQUE KEY `ModuleName` (`ModuleName`),
  KEY `FK_Modules_PluginID` (`PluginID`),
  CONSTRAINT `FK_Modules_PluginID` FOREIGN KEY (`PluginID`) REFERENCES `Plugins` (`PluginID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `NLBlastEmailClicks`;
CREATE TABLE `NLBlastEmailClicks` (
  `BlastEmailID` int(10) unsigned NOT NULL default '0',
  `BlastEmailClickDate` date NOT NULL default '0000-00-00',
  `BlastEmailClicksCount` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`BlastEmailID`,`BlastEmailClickDate`),
  CONSTRAINT `FK_NLBlastEmailClicks_BlastEmailID` FOREIGN KEY (`BlastEmailID`) REFERENCES `NLBlastEmails` (`BlastEmailID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `NLBlastEmailOpens`;
CREATE TABLE `NLBlastEmailOpens` (
  `BlastEmailID` int(10) unsigned NOT NULL default '0',
  `BlastEmailOpenDate` date NOT NULL default '0000-00-00',
  PRIMARY KEY  (`BlastEmailID`),
  CONSTRAINT `FK_NLBlastEmailOpens_BlastEmailID` FOREIGN KEY (`BlastEmailID`) REFERENCES `NLBlastEmails` (`BlastEmailID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `NLBlastEmails`;
CREATE TABLE `NLBlastEmails` (
  `BlastEmailID` int(10) unsigned NOT NULL auto_increment,
  `BlastID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `BlastEmail` varchar(255) NOT NULL default '',
  `BlastEmailStatus` tinyint(1) unsigned NOT NULL default '0',
  `BlastEmailSentDate` date NOT NULL default '0000-00-00',
  PRIMARY KEY  (`BlastEmailID`),
  KEY `FK_NLBlastEmails_BlastID` USING BTREE (`BlastID`,`BlastEmailStatus`),
  KEY `FK_NLBlastEmails_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_NLBlastEmails_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_NLBlastEmails_BlastID` FOREIGN KEY (`BlastID`) REFERENCES `NLBlasts` (`BlastID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `NLBlasts`;
CREATE TABLE `NLBlasts` (
  `BlastID` int(10) unsigned NOT NULL auto_increment,
  `NewsletterID` int(10) unsigned NOT NULL default '0',
  `BlastIsActive` tinyint(1) unsigned NOT NULL default '0',
  `BlastDate` date NOT NULL default '0000-00-00',
  PRIMARY KEY  (`BlastID`),
  KEY `FK_NLBlasts_NewsletterID` (`NewsletterID`),
  CONSTRAINT `FK_NLBlasts_NewsletterID` FOREIGN KEY (`NewsletterID`) REFERENCES `NLNewsletters` (`NewsletterID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `NLBlastsML`;
CREATE TABLE `NLBlastsML` (
  `BlastID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `BlastToCustomers` tinyint(3) unsigned NOT NULL default '0',
  `BlastToSubscribers` tinyint(3) unsigned NOT NULL default '0',
  `BlastSubject` varchar(255) NOT NULL default '',
  `BlastXhtmlText` mediumtext NOT NULL,
  PRIMARY KEY  (`BlastID`,`LanguageID`),
  KEY `FK_NLBlastsML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_NLBlastsML_BlastID` FOREIGN KEY (`BlastID`) REFERENCES `NLBlasts` (`BlastID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_NLBlastsML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `NLNewsletters`;
CREATE TABLE `NLNewsletters` (
  `NewsletterID` int(10) unsigned NOT NULL auto_increment,
  `NewsletterIsTested` tinyint(1) unsigned NOT NULL default '0',
  `NewsletterIsActive` tinyint(1) unsigned NOT NULL default '0',
  `NewsletterOptions` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`NewsletterID`),
  KEY `NewsletterIsActive` (`NewsletterIsActive`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
DROP TABLE IF EXISTS `NLNewslettersML`;
CREATE TABLE `NLNewslettersML` (
  `NewsletterID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `NewsletterName` varchar(255) NOT NULL default '',
  `NewsletterSubject` varchar(255) NOT NULL default '',
  `NewsletterXhtmlText` mediumtext NOT NULL,
  PRIMARY KEY  (`NewsletterID`,`LanguageID`),
  KEY `FK_NLNewslettersML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_NLNewslettersML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_NLNewslettersML_NewsletterID` FOREIGN KEY (`NewsletterID`) REFERENCES `NLNewsletters` (`NewsletterID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `NLSubscribers`;
CREATE TABLE `NLSubscribers` (
  `SubscriberID` int(10) unsigned NOT NULL auto_increment,
  `NewsletterID` int(10) unsigned NOT NULL default '0',
  `CustomerID` int(10) unsigned default NULL,
  `LanguageID` int(10) unsigned default NULL,
  `SubscriberEmail` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `SubscriberIsActive` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`SubscriberID`),
  UNIQUE KEY `SubscriberEmail` (`SubscriberEmail`,`NewsletterID`),
  KEY `FK_NLSubscribers_CustomerID` (`CustomerID`),
  KEY `FK_NLSubscribers_NewsletterID` (`NewsletterID`),
  KEY `FK_NLSubscribers_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_NLSubscribers_CustomerID` FOREIGN KEY (`CustomerID`) REFERENCES `Customers` (`CustomerID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_NLSubscribers_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE SET NULL ON UPDATE CASCADE,
  CONSTRAINT `FK_NLSubscribers_NewsletterID` FOREIGN KEY (`NewsletterID`) REFERENCES `NLNewsletters` (`NewsletterID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
DROP TABLE IF EXISTS `News`;
CREATE TABLE `News` (
  `NewsID` int(10) unsigned NOT NULL auto_increment,
  `NewsDate` date NOT NULL default '0000-00-00',
  `NewsIsActive` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`NewsID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `NewsML`;
CREATE TABLE `NewsML` (
  `NewsID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `NewsTitle` varchar(255) NOT NULL default '',
  `NewsContents` mediumblob NOT NULL,
  PRIMARY KEY  (`NewsID`,`LanguageID`),
  KEY `FK_NewsML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_NewsML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE,
  CONSTRAINT `FK_NewsML_NewsID` FOREIGN KEY (`NewsID`) REFERENCES `News` (`NewsID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `OptionGroups`;
CREATE TABLE `OptionGroups` (
  `OptionGroupID` int(10) unsigned NOT NULL auto_increment,
  `OptionGroupType` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  USING BTREE (`OptionGroupID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `OptionGroupsML`;
CREATE TABLE `OptionGroupsML` (
  `OptionGroupID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `OptionGroupName` varchar(255) NOT NULL default '',
  PRIMARY KEY  USING BTREE (`OptionGroupID`,`LanguageID`),
  KEY `FK_OptionGroupsML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_OptionGroupsML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE,
  CONSTRAINT `FK_OptionGroupsML_OptionGroupID` FOREIGN KEY (`OptionGroupID`) REFERENCES `OptionGroups` (`OptionGroupID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Options`;
CREATE TABLE `Options` (
  `OptionID` int(10) unsigned NOT NULL auto_increment,
  `OptionGroupID` int(10) unsigned NOT NULL default '0',
  `OptionPriceModType` tinyint(3) unsigned NOT NULL default '0',
  `OptionPriceModValue` decimal(10,2) NOT NULL default '0.00',
  `OptionRequired` tinyint(1) unsigned NOT NULL default '0',
  `OptionSort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`OptionID`),
  UNIQUE KEY `OptionSort` (`OptionGroupID`,`OptionSort`),
  KEY `FK_Options_OptionGroupID` (`OptionGroupID`),
  CONSTRAINT `FK_Options_OptionGroupID` FOREIGN KEY (`OptionGroupID`) REFERENCES `OptionGroups` (`OptionGroupID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `OptionsML`;
CREATE TABLE `OptionsML` (
  `OptionID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `OptionName` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`OptionID`,`LanguageID`),
  KEY `FK_OptionsML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_OptionsML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE,
  CONSTRAINT `FK_OptionsML_OptionID` FOREIGN KEY (`OptionID`) REFERENCES `Options` (`OptionID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `OrderDetails`;
CREATE TABLE `OrderDetails` (
  `OrderDetailID` int(10) unsigned NOT NULL auto_increment,
  `OrderID` int(10) unsigned NOT NULL default '0',
  `ModuleID` int(10) unsigned NOT NULL default '0',
  `OrderDetailName` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  `OrderDetailValue` blob NOT NULL,
  PRIMARY KEY  (`OrderDetailID`),
  UNIQUE KEY `OrderID` (`OrderID`,`ModuleID`,`OrderDetailName`),
  KEY `FK_OrderDetails_ModuleID` (`ModuleID`),
  CONSTRAINT `FK_OrderDetails_ModuleID` FOREIGN KEY (`ModuleID`) REFERENCES `Modules` (`ModuleID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_OrderDetail_OrderID` FOREIGN KEY (`OrderID`) REFERENCES `Orders` (`OrderID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `OrderItemEgoods`;
CREATE TABLE `OrderItemEgoods` (
  `OrderItemEgoodID` int(10) unsigned NOT NULL auto_increment,
  `OrderItemID` int(10) unsigned NOT NULL default '0',
  `OrderItemEgoodFile` varchar(255) NOT NULL default '',
  `OrderItemEgoodDownloads` int(10) unsigned NOT NULL default '0',
  `OrderItemEgoodMaxDownloads` int(10) unsigned NOT NULL default '0',
  `OrderItemEgoodExpirationDate` date NOT NULL default '0000-00-00',
  `OrderItemEgoodIsLocked` tinyint(3) unsigned NOT NULL default '1',
  PRIMARY KEY  (`OrderItemEgoodID`),
  KEY `FK_OrderItemEgoods_OrderItemID` (`OrderItemID`),
  CONSTRAINT `FK_OrderItemEgoods_OrderItemID` FOREIGN KEY (`OrderItemID`) REFERENCES `OrderItems` (`OrderItemID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `OrderItemLocalOptions`;
CREATE TABLE `OrderItemLocalOptions` (
  `OrderItemLocalOptionID` int(10) unsigned NOT NULL auto_increment,
  `OrderItemID` int(10) unsigned NOT NULL default '0',
  `OrderItemLocalOptionGroupName` varchar(255) NOT NULL default '',
  `OrderItemLocalOptionGroupType` tinyint(1) unsigned NOT NULL default '0',
  `OrderItemLocalOptionName` varchar(255) NOT NULL default '',
  `OrderItemLocalOptionPriceModType` tinyint(3) unsigned NOT NULL default '0',
  `OrderItemLocalOptionPriceModValue` decimal(10,2) NOT NULL default '0.00',
  `OrderItemLocalOptionPrice` decimal(10,2) NOT NULL default '0.00',
  `OrderItemLocalOptionCustomerCurrencyPrice` decimal(10,2) NOT NULL default '0.00',
  `OrderItemLocalOptionImage` varchar(255) NOT NULL default '',
  `OrderItemLocalOptionImageHeight` int(10) unsigned NOT NULL default '0',
  `OrderItemLocalOptionImageWidth` int(10) unsigned NOT NULL default '0',
  `OrderItemLocalOptionUserText` text NOT NULL,
  PRIMARY KEY  (`OrderItemLocalOptionID`),
  KEY `FK_OrderItemLocalOptions_OrderItemID` (`OrderItemID`),
  CONSTRAINT `FK_OrderItemLocalOptions_OrderItemID` FOREIGN KEY (`OrderItemID`) REFERENCES `OrderItems` (`OrderItemID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `OrderItemOptions`;
CREATE TABLE `OrderItemOptions` (
  `OrderItemOptionID` int(10) unsigned NOT NULL auto_increment,
  `OrderItemID` int(10) unsigned NOT NULL default '0',
  `OrderItemOptionGroupName` varchar(255) NOT NULL default '',
  `OrderItemOptionGroupType` tinyint(1) unsigned NOT NULL default '0',
  `OrderItemOptionName` varchar(255) NOT NULL default '',
  `OrderItemOptionPriceModType` tinyint(3) unsigned NOT NULL default '0',
  `OrderItemOptionPriceModValue` decimal(10,2) NOT NULL default '0.00',
  `OrderItemOptionPrice` decimal(10,2) NOT NULL default '0.00',
  `OrderItemOptionCustomerCurrencyPrice` decimal(10,2) NOT NULL default '0.00',
  `OrderItemOptionImage` varchar(255) NOT NULL default '',
  `OrderItemOptionImageWidth` int(10) unsigned NOT NULL default '0',
  `OrderItemOptionImageHeight` int(10) unsigned NOT NULL default '0',
  `OrderItemOptionUserText` text NOT NULL,
  PRIMARY KEY  (`OrderItemOptionID`),
  KEY `FK_OrderItemOptions_OrderItemID` (`OrderItemID`),
  CONSTRAINT `FK_OrderItemOptions_OrderItemID` FOREIGN KEY (`OrderItemID`) REFERENCES `OrderItems` (`OrderItemID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `OrderItems`;
CREATE TABLE `OrderItems` (
  `OrderItemID` int(10) unsigned NOT NULL auto_increment,
  `OrderID` int(10) unsigned NOT NULL default '0',
  `ParentOrderItemID` int(10) unsigned default NULL,
  `ProductID` int(10) unsigned NOT NULL default '0',
  `ProductVariantID` int(10) unsigned default NULL,
  `ProductImageID` int(10) unsigned NOT NULL default '0',
  `OrderItemProductCode` varchar(255) NOT NULL default '',
  `OrderItemProductName` varchar(255) NOT NULL default '',
  `OrderItemCategoryName` varchar(255) NOT NULL default '',
  `OrderItemQty` int(10) unsigned NOT NULL default '0',
  `OrderItemDiscount` decimal(10,2) NOT NULL default '0.00',
  `OrderItemPrice` decimal(10,2) NOT NULL default '0.00',
  `OrderItemTotal` decimal(10,2) NOT NULL default '0.00',
  `OrderItemCustomerCurrencyDiscount` decimal(10,2) NOT NULL default '0.00',
  `OrderItemCustomerCurrencyPrice` decimal(10,2) NOT NULL default '0.00',
  `OrderItemCustomerCurrencyTotal` decimal(10,2) NOT NULL default '0.00',
  `OrderItemBonusPointsSpent` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`OrderItemID`),
  KEY `FK_OrderItems_OrderID` (`OrderID`),
  CONSTRAINT `FK_OrderItems_OrderID` FOREIGN KEY (`OrderID`) REFERENCES `Orders` (`OrderID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `OrderNotes`;
CREATE TABLE `OrderNotes` (
  `OrderNoteID` int(10) unsigned NOT NULL auto_increment,
  `OrderID` int(10) unsigned NOT NULL default '0',
  `OrderNoteText` text NOT NULL,
  `OrderNoteSendToCustomer` tinyint(3) unsigned NOT NULL default '0',
  `OrderNoteCreationTimestamp` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`OrderNoteID`),
  KEY `OrderID` (`OrderID`),
  CONSTRAINT `FK_OrderNotes_OrderID` FOREIGN KEY (`OrderID`) REFERENCES `Orders` (`OrderID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `OrderStatuses`;
CREATE TABLE `OrderStatuses` (
  `OrderStatusID` int(10) unsigned NOT NULL auto_increment,
  `OrderStatusSort` int(10) unsigned NOT NULL default '0',
  `OrderStatusIsActive` tinyint(1) unsigned NOT NULL default '0',
  `OrderStatusSendNotification` tinyint(1) unsigned NOT NULL default '0',
  `OrderStatusInventoryAction` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`OrderStatusID`),
  UNIQUE KEY `OrderStatusSort` USING BTREE (`OrderStatusSort`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `OrderStatusesML`;
CREATE TABLE `OrderStatusesML` (
  `OrderStatusID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `OrderStatusName` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`OrderStatusID`,`LanguageID`),
  KEY `FK_OrderStatusesML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_OrderStatusesML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE,
  CONSTRAINT `FK_OrderStatusesML_OrderStatusID` FOREIGN KEY (`OrderStatusID`) REFERENCES `OrderStatuses` (`OrderStatusID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `OrderTotalLines`;
CREATE TABLE `OrderTotalLines` (
  `OrderTotalLineID` int(10) unsigned NOT NULL auto_increment,
  `OrderID` int(10) unsigned NOT NULL default '0',
  `OrderTotalLineType` tinyint(4) unsigned NOT NULL default '0',
  `OrderTotalLineName` varchar(255) NOT NULL default '',
  `OrderTotalLineAmount` decimal(10,2) NOT NULL default '0.00',
  `OrderTotalLineCustomerCurrencyAmount` decimal(10,2) NOT NULL default '0.00',
  `OrderTotalLineSort` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`OrderTotalLineID`),
  KEY `FK_OrderTotalLines_OrderID` (`OrderID`),
  CONSTRAINT `FK_OrderTotalLines_OrderID` FOREIGN KEY (`OrderID`) REFERENCES `Orders` (`OrderID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `OrderTotalModules`;
CREATE TABLE `OrderTotalModules` (
  `OrderTotalModuleID` int(10) unsigned NOT NULL auto_increment,
  `ModuleID` int(10) unsigned NOT NULL default '0',
  `OrderTotalModuleType` tinyint(3) unsigned NOT NULL default '0',
  `OrderTotalModuleName` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  `OrderTotalModuleIsActive` tinyint(3) unsigned NOT NULL default '0',
  `OrderTotalModuleSort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`OrderTotalModuleID`),
  UNIQUE KEY `OrderTotalModuleSort` (`OrderTotalModuleSort`),
  UNIQUE KEY `ModuleID` (`ModuleID`),
  CONSTRAINT `FK_OrderTotalModules_ModuleID` FOREIGN KEY (`ModuleID`) REFERENCES `Modules` (`ModuleID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Orders`;
CREATE TABLE `Orders` (
  `OrderID` int(10) unsigned NOT NULL auto_increment,
  `OrderTimestamp` int(10) unsigned NOT NULL default '0',
  `OrderIPAddress` int(10) unsigned NOT NULL default '0',
  `OrderStatus` tinyint(3) unsigned NOT NULL default '0',
  `OrderPaymentStatus` tinyint(3) unsigned NOT NULL default '0',
  `OrderLanguageCode` varchar(2) NOT NULL default '',
  `OrderCustomerInstructions` text NOT NULL,
  `OrderCustomerEmail` varchar(255) NOT NULL default '',
  `CustomerID` int(10) unsigned NOT NULL default '0',
  `OrderCustomerReferringHash` varchar(255) NOT NULL default '',
  `ShippingModuleID` int(10) unsigned NOT NULL default '0',
  `OrderShippingMethodCode` varchar(255) NOT NULL default '',
  `OrderShippingTrackingNo` varchar(255) NOT NULL default '',
  `OrderShippingModuleName` varchar(255) NOT NULL default '',
  `OrderShippingMethodName` varchar(255) NOT NULL default '',
  `PaymentModuleID` int(10) unsigned NOT NULL default '0',
  `OrderPaymentModuleName` varchar(255) NOT NULL default '',
  `OrderPaymentModuleIntegration` varchar(255) NOT NULL default '',
  `OrderPaymentNotes` text NOT NULL,
  `OrderPaymentTransactionNo` varchar(255) NOT NULL default '',
  `CheckoutModuleID` int(10) unsigned NOT NULL default '0',
  `OrderCheckoutModuleName` varchar(255) NOT NULL default '',
  `OrderBillingFirstName` varchar(255) NOT NULL default '',
  `OrderBillingLastName` varchar(255) NOT NULL default '',
  `OrderBillingCompany` varchar(255) NOT NULL default '',
  `OrderBillingPhone` varchar(255) NOT NULL default '',
  `OrderBillingFax` varchar(255) NOT NULL default '',
  `OrderBillingAddress1` varchar(255) NOT NULL default '',
  `OrderBillingAddress2` varchar(255) NOT NULL default '',
  `OrderBillingCity` varchar(255) NOT NULL default '',
  `OrderBillingCityID` int(10) unsigned default NULL,
  `OrderBillingState` varchar(255) NOT NULL default '',
  `OrderBillingStateCode` varchar(255) NOT NULL default '',
  `OrderBillingCountry` varchar(255) NOT NULL default '',
  `OrderBillingCountryCode2` varchar(2) NOT NULL default '',
  `OrderBillingZip` varchar(255) NOT NULL default '',
  `OrderBillingVatNumber` varchar(255) NOT NULL default '',
  `OrderShipToBillingAddress` tinyint(3) unsigned NOT NULL default '0',
  `OrderShippingFirstName` varchar(255) NOT NULL default '',
  `OrderShippingLastName` varchar(255) NOT NULL default '',
  `OrderShippingCompany` varchar(255) NOT NULL default '',
  `OrderShippingPhone` varchar(255) NOT NULL default '',
  `OrderShippingFax` varchar(255) NOT NULL default '',
  `OrderShippingAddress1` varchar(255) NOT NULL default '',
  `OrderShippingAddress2` varchar(255) NOT NULL default '',
  `OrderShippingCity` varchar(255) NOT NULL default '',
  `OrderShippingCityID` int(10) unsigned default NULL,
  `OrderShippingState` varchar(255) NOT NULL default '',
  `OrderShippingStateCode` varchar(255) NOT NULL default '',
  `OrderShippingCountry` varchar(255) NOT NULL default '',
  `OrderShippingCountryCode2` varchar(2) NOT NULL default '',
  `OrderShippingZip` varchar(255) NOT NULL default '',
  `OrderShippingVatNumber` varchar(255) NOT NULL default '',
  `OrderCouponCode` varchar(255) NOT NULL default '',
  `OrderTotal` decimal(10,2) NOT NULL default '0.00',
  `OrderCurrencyCode` varchar(255) NOT NULL default '',
  `OrderTotalPayAmount` decimal(10,2) NOT NULL default '0.00',
  `OrderTotalPayCurrencyCode` varchar(3) NOT NULL default '',
  `OrderQuantitiesInStockReduced` tinyint(1) unsigned NOT NULL default '0',
  `OrderCustomerCurrencyCode` varchar(255) NOT NULL default '',
  `OrderCustomerCurrencyTotal` decimal(10,2) NOT NULL default '0.00',
  PRIMARY KEY  (`OrderID`),
  KEY `OrderTimestamp` (`OrderTimestamp`),
  KEY `OrderCustomerEmail` (`OrderCustomerEmail`),
  KEY `CustomerID` (`CustomerID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='InnoDB free: 8192 kB';
DROP TABLE IF EXISTS `PaymentChecks`;
CREATE TABLE `PaymentChecks` (
  `PaymentCheckID` int(10) unsigned NOT NULL auto_increment,
  `OrderID` int(10) unsigned NOT NULL default '0',
  `PaymentCheckType` tinyint(3) unsigned NOT NULL default '0',
  `PaymentCheckAccountType` tinyint(3) unsigned NOT NULL default '0',
  `PaymentCheckRoutingNumber` varchar(255) NOT NULL default '',
  `PaymentCheckAccount` varchar(255) NOT NULL default '',
  `PaymentCheckNameOnAccount` varchar(255) NOT NULL default '',
  `PaymentCheckBankName` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`PaymentCheckID`),
  UNIQUE KEY `OrderID` (`OrderID`),
  CONSTRAINT `FK_PaymentChecks_OrderID` FOREIGN KEY (`OrderID`) REFERENCES `Orders` (`OrderID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `PaymentCreditCards`;
CREATE TABLE `PaymentCreditCards` (
  `PaymentCreditCardID` int(10) unsigned NOT NULL auto_increment,
  `OrderID` int(10) unsigned NOT NULL default '0',
  `PaymentCreditCardNameOnCard` varchar(255) NOT NULL default '',
  `PaymentCreditCardNumber` varchar(255) NOT NULL default '',
  `PaymentCreditCardExpMonth` int(10) unsigned NOT NULL default '0',
  `PaymentCreditCardExpYear` int(10) unsigned NOT NULL default '0',
  `PaymentCreditCardCVN` varchar(4) NOT NULL default '',
  `PaymentCreditCardAVSStatus` tinyint(3) unsigned NOT NULL default '0',
  `PaymentCreditCardProcessorAVS` varchar(255) NOT NULL default '',
  `PaymentCreditCardCVNStatus` tinyint(4) unsigned NOT NULL default '0',
  `PaymentCreditCardProcessorCVN` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`PaymentCreditCardID`),
  UNIQUE KEY `OrderID` (`OrderID`),
  CONSTRAINT `FK_PaymentCreditCards_OrderID` FOREIGN KEY (`OrderID`) REFERENCES `Orders` (`OrderID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `PaymentModules`;
CREATE TABLE `PaymentModules` (
  `PaymentModuleID` int(10) unsigned NOT NULL auto_increment,
  `ModuleID` int(10) unsigned NOT NULL default '0',
  `PaymentModuleName` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  `PaymentModuleIntegrationMethod` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  `PaymentModuleImage` varchar(255) NOT NULL default '',
  `PaymentModuleIsActive` tinyint(3) unsigned NOT NULL default '0',
  `PaymentModuleSort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`PaymentModuleID`),
  UNIQUE KEY `PaymentModuleSort` (`PaymentModuleSort`),
  UNIQUE KEY `ModuleID` (`ModuleID`),
  CONSTRAINT `FK_PaymentModules_ModuleID` FOREIGN KEY (`ModuleID`) REFERENCES `Modules` (`ModuleID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `PaymentModulesML`;
CREATE TABLE `PaymentModulesML` (
  `PaymentModuleID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `PaymentModuleDisplayName` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`PaymentModuleID`,`LanguageID`),
  KEY `FK_PaymentModulesML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_PaymentModulesML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE,
  CONSTRAINT `FK_PaymentModulesML_PaymentModuleID` FOREIGN KEY (`PaymentModuleID`) REFERENCES `PaymentModules` (`PaymentModuleID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Plugins`;
CREATE TABLE `Plugins` (
  `PluginID` int(10) unsigned NOT NULL auto_increment,
  `PluginName` varchar(255) NOT NULL default '',
  `PluginImage` varchar(255) NOT NULL default '',
  `PluginImageWidth` int(10) unsigned NOT NULL default '0',
  `PluginImageHeight` int(10) unsigned NOT NULL default '0',
  `PluginAuthor` varchar(255) NOT NULL default '',
  `PluginLicense` mediumtext NOT NULL,
  `PluginVersion` varchar(255) NOT NULL default '',
  `PluginTitle` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`PluginID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ProductAttributeMultiValues`;
CREATE TABLE `ProductAttributeMultiValues` (
  `ProductAttributeValueID` int(10) unsigned NOT NULL default '0',
  `ProductClassAttributeMultiValue` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ProductAttributeValueID`,`ProductClassAttributeMultiValue`),
  KEY `FK_ProductAttributeMultiValues_ProductClassAttributeMultiValue` (`ProductClassAttributeMultiValue`),
  CONSTRAINT `FK_ProductAttributeMultiValues_ProductAttributeValueID` FOREIGN KEY (`ProductAttributeValueID`) REFERENCES `ProductAttributeValues` (`ProductAttributeValueID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_ProductAttributeMultiValues_ProductClassAttributeMultiValue` FOREIGN KEY (`ProductClassAttributeMultiValue`) REFERENCES `ProductClassAttributeValues` (`ProductClassAttributeValueID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ProductAttributeValues`;
CREATE TABLE `ProductAttributeValues` (
  `ProductAttributeValueID` int(10) unsigned NOT NULL auto_increment,
  `ProductID` int(10) unsigned NOT NULL default '0',
  `ProductClassAttributeID` int(10) unsigned NOT NULL default '0',
  `ProductClassAttributeValueID` int(10) unsigned default NULL,
  `ProductAttributeValue` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`ProductAttributeValueID`),
  UNIQUE KEY `ProductID_ProductClassAttributeID` (`ProductID`,`ProductClassAttributeID`),
  KEY `FK_ProductAttributeValues_ProductClassAttributeID` (`ProductClassAttributeID`),
  KEY `FK_ProductAttributeValues_ProductClassAttributeValueID` (`ProductClassAttributeValueID`),
  CONSTRAINT `FK_ProductAttributeValues_ProductClassAttributeID` FOREIGN KEY (`ProductClassAttributeID`) REFERENCES `ProductClassAttributes` (`ProductClassAttributeID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_ProductAttributeValues_ProductClassAttributeValueID` FOREIGN KEY (`ProductClassAttributeValueID`) REFERENCES `ProductClassAttributeValues` (`ProductClassAttributeValueID`) ON DELETE SET NULL ON UPDATE CASCADE,
  CONSTRAINT `FK_ProductAttributeValues_ProductID` FOREIGN KEY (`ProductID`) REFERENCES `Products` (`ProductID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ProductAttributeValuesML`;
CREATE TABLE `ProductAttributeValuesML` (
  `ProductAttributeValueID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `ProductAttributeValueML` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`ProductAttributeValueID`,`LanguageID`),
  KEY `FK_ProductAttributeValuesML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_ProductAttributeValuesML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_ProductAttributeValuesML_ProductAttributeValueID` FOREIGN KEY (`ProductAttributeValueID`) REFERENCES `ProductAttributeValues` (`ProductAttributeValueID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ProductClassAttributeValues`;
CREATE TABLE `ProductClassAttributeValues` (
  `ProductClassAttributeValueID` int(10) unsigned NOT NULL auto_increment,
  `ProductClassAttributeID` int(10) unsigned NOT NULL default '0',
  `ProductClassAttributeValueSort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ProductClassAttributeValueID`),
  UNIQUE KEY `ProductClassAttributeValueSort` (`ProductClassAttributeID`,`ProductClassAttributeValueSort`),
  KEY `FK_ProductClassAttributeValues_ProductClassAttributeID` (`ProductClassAttributeID`),
  CONSTRAINT `FK_ProductClassAttributeValues_ProductClassAttributeID` FOREIGN KEY (`ProductClassAttributeID`) REFERENCES `ProductClassAttributes` (`ProductClassAttributeID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ProductClassAttributeValuesML`;
CREATE TABLE `ProductClassAttributeValuesML` (
  `ProductClassAttributeValueID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `ProductClassAttributeValueML` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`ProductClassAttributeValueID`,`LanguageID`),
  KEY `FK_ProductClassAttributeValuesML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_ProductClassAttributeValuesML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_ProductClassAttributeValuesML_ProductClassAttributeValueID` FOREIGN KEY (`ProductClassAttributeValueID`) REFERENCES `ProductClassAttributeValues` (`ProductClassAttributeValueID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ProductClassAttributes`;
CREATE TABLE `ProductClassAttributes` (
  `ProductClassAttributeID` int(10) unsigned NOT NULL auto_increment,
  `ProductClassID` int(10) unsigned NOT NULL default '0',
  `ProductClassAttributeType` tinyint(3) unsigned NOT NULL default '0',
  `ProductClassAttributeValidator` tinyint(3) unsigned NOT NULL default '0',
  `ProductClassAttributeSort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ProductClassAttributeID`),
  UNIQUE KEY `ProductClassAttributeSort` (`ProductClassID`,`ProductClassAttributeSort`),
  KEY `FK_ProductClassAttributes_ProductClassID` (`ProductClassID`),
  CONSTRAINT `FK_ProductClassAttributes_ProductClassID` FOREIGN KEY (`ProductClassID`) REFERENCES `ProductClasses` (`ProductClassID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ProductClassAttributesML`;
CREATE TABLE `ProductClassAttributesML` (
  `ProductClassAttributeID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `ProductClassAttributeName` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`ProductClassAttributeID`,`LanguageID`),
  KEY `FK_ProductClassAttributesML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_ProductClassAttributesML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_ProductClassAttributesML_ProductClassAttributeID` FOREIGN KEY (`ProductClassAttributeID`) REFERENCES `ProductClassAttributes` (`ProductClassAttributeID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ProductClasses`;
CREATE TABLE `ProductClasses` (
  `ProductClassID` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`ProductClassID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ProductClassesML`;
CREATE TABLE `ProductClassesML` (
  `ProductClassID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `ProductClassName` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`ProductClassID`,`LanguageID`),
  KEY `FK_ProductClassesML_LanguageID` (`LanguageID`),
  KEY `LanguageIDProductClassName` (`LanguageID`,`ProductClassName`),
  CONSTRAINT `FK_ProductClassesML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_ProductClassesML_ProductClassID` FOREIGN KEY (`ProductClassID`) REFERENCES `ProductClasses` (`ProductClassID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ProductEgoods`;
CREATE TABLE `ProductEgoods` (
  `ProductEgoodID` int(10) unsigned NOT NULL auto_increment,
  `ProductID` int(10) unsigned NOT NULL default '0',
  `ProductEgoodFile` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`ProductEgoodID`),
  KEY `FK_ProductEgoods_ProductID` (`ProductID`),
  CONSTRAINT `FK_ProductEgoods_ProductID` FOREIGN KEY (`ProductID`) REFERENCES `Products` (`ProductID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ProductImages`;
CREATE TABLE `ProductImages` (
  `ProductImageID` int(10) unsigned NOT NULL auto_increment,
  `ProductID` int(10) unsigned NOT NULL default '0',
  `ProductImage` varchar(255) NOT NULL default '',
  `ProductImageWidth` int(10) unsigned NOT NULL default '0',
  `ProductImageHeight` int(10) unsigned NOT NULL default '0',
  `ProductImageSize` int(10) unsigned NOT NULL default '0',
  `ProductImageThumb` varchar(255) NOT NULL default '',
  `ProductImageThumbWidth` int(10) unsigned NOT NULL default '0',
  `ProductImageThumbHeight` int(10) unsigned NOT NULL default '0',
  `ProductImageThumbSize` int(10) unsigned NOT NULL default '0',
  `ProductImageIsDefault` tinyint(1) unsigned NOT NULL default '0',
  `ProductImageLarge` varchar(255) NOT NULL default '',
  `ProductImageLargeWidth` int(10) unsigned NOT NULL default '0',
  `ProductImageLargeHeight` int(10) unsigned NOT NULL default '0',
  `ProductImageLargeSize` int(10) unsigned NOT NULL default '0',
  `ProductImageBox` varchar(255) NOT NULL default '',
  `ProductImageBoxWidth` int(10) unsigned NOT NULL default '0',
  `ProductImageBoxHeight` int(10) unsigned NOT NULL default '0',
  `ProductImageBoxSize` int(10) unsigned NOT NULL default '0',
  `ProductImageOriginal` varchar(255) NOT NULL default '',
  `ProductImageOriginalName` varchar(255) NOT NULL default '',
  `ProductImageSort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ProductImageID`),
  UNIQUE KEY `ProductImageSort` (`ProductID`,`ProductImageSort`),
  KEY `FK_ProductImages_ProductID` (`ProductID`),
  CONSTRAINT `FK_ProductImages_ProductID` FOREIGN KEY (`ProductID`) REFERENCES `Products` (`ProductID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ProductOptionGroups`;
CREATE TABLE `ProductOptionGroups` (
  `ProductID` int(10) unsigned NOT NULL default '0',
  `OptionGroupID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  USING BTREE (`ProductID`,`OptionGroupID`),
  KEY `FK_ProductOptionGroups_OptionGroupID` (`OptionGroupID`),
  CONSTRAINT `FK_ProductOptionGroups_OptionGroupID` FOREIGN KEY (`OptionGroupID`) REFERENCES `OptionGroups` (`OptionGroupID`) ON DELETE CASCADE,
  CONSTRAINT `FK_ProductOptionGroups_ProductID` FOREIGN KEY (`ProductID`) REFERENCES `Products` (`ProductID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ProductRatingVotes`;
CREATE TABLE `ProductRatingVotes` (
  `ProductRatingVoteID` int(10) unsigned NOT NULL auto_increment,
  `ProductID` int(10) unsigned NOT NULL default '0',
  `RatingActionID` int(10) unsigned NOT NULL default '0',
  `ProductRatingVoteValue` tinyint(3) unsigned NOT NULL default '0',
  `ProductRatingVoteStatus` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ProductRatingVoteID`),
  KEY `FK_ProductRatingVotes_ProductID` (`ProductID`),
  KEY `FK_ProductRatingVotes_RatingActionID` (`RatingActionID`),
  CONSTRAINT `FK_ProductRatingVotes_ProductID` FOREIGN KEY (`ProductID`) REFERENCES `Products` (`ProductID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_ProductRatingVotes_RatingActionID` FOREIGN KEY (`RatingActionID`) REFERENCES `RatingActions` (`RatingActionID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ProductReviews`;
CREATE TABLE `ProductReviews` (
  `ProductReviewID` int(10) unsigned NOT NULL auto_increment,
  `ProductID` int(10) unsigned NOT NULL default '0',
  `RatingActionID` int(10) unsigned NOT NULL default '0',
  `ProductReviewText` text NOT NULL,
  `ProductReviewStatus` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ProductReviewID`),
  KEY `FK_ProductReview_ProductID` (`ProductID`),
  KEY `FK_ProductReviews_RatingActionID` (`RatingActionID`),
  CONSTRAINT `FK_ProductReviews_RatingActionID` FOREIGN KEY (`RatingActionID`) REFERENCES `RatingActions` (`RatingActionID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_ProductReview_ProductID` FOREIGN KEY (`ProductID`) REFERENCES `Products` (`ProductID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ProductTaxClasses`;
CREATE TABLE `ProductTaxClasses` (
  `ProductID` int(10) unsigned NOT NULL default '0',
  `TaxClassID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ProductID`,`TaxClassID`),
  KEY `FK_ProductTaxClasses_TaxClassID` (`TaxClassID`),
  CONSTRAINT `FK_ProductTaxClasses_ProductID` FOREIGN KEY (`ProductID`) REFERENCES `Products` (`ProductID`) ON DELETE CASCADE,
  CONSTRAINT `FK_ProductTaxClasses_TaxClassID` FOREIGN KEY (`TaxClassID`) REFERENCES `TaxClasses` (`TaxClassID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ProductVariantLocalOptions`;
CREATE TABLE `ProductVariantLocalOptions` (
  `ProductVariantID` int(10) unsigned NOT NULL default '0',
  `LocalOptionID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  USING BTREE (`ProductVariantID`,`LocalOptionID`),
  KEY `FK_ProductVariantLocalOptions_OptionID` (`LocalOptionID`),
  CONSTRAINT `FK_ProductVariantLocalOptions_LocalOptionID` FOREIGN KEY (`LocalOptionID`) REFERENCES `LocalOptions` (`LocalOptionID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_ProductVariantLocalOptions_ProductVariantID` FOREIGN KEY (`ProductVariantID`) REFERENCES `ProductVariants` (`ProductVariantID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
DROP TABLE IF EXISTS `ProductVariantOptions`;
CREATE TABLE `ProductVariantOptions` (
  `ProductVariantID` int(10) unsigned NOT NULL default '0',
  `OptionID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  USING BTREE (`ProductVariantID`,`OptionID`),
  KEY `FK_ProductVariantOptions_OptionID` (`OptionID`),
  CONSTRAINT `FK_ProductVariantOptions_OptionID` FOREIGN KEY (`OptionID`) REFERENCES `Options` (`OptionID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_ProductVariantOptions_ProductVariantID` FOREIGN KEY (`ProductVariantID`) REFERENCES `ProductVariants` (`ProductVariantID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
DROP TABLE IF EXISTS `ProductVariants`;
CREATE TABLE `ProductVariants` (
  `ProductVariantID` int(10) unsigned NOT NULL auto_increment,
  `ProductID` int(10) unsigned NOT NULL default '0',
  `ProductVariantCode` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `ProductVariantPrice` decimal(10,2) NOT NULL default '0.00',
  `ProductVariantBonusPointsPrice` int(10) unsigned default NULL,
  `ProductVariantWeight` decimal(10,3) NOT NULL default '0.000',
  `ProductVariantQuantity` int(11) NOT NULL default '0',
  `ProductVariantIsDefault` tinyint(1) unsigned NOT NULL default '0',
  `ProductVariantImage` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `ProductVariantImageWidth` int(10) unsigned NOT NULL default '0',
  `ProductVariantImageHeight` int(10) unsigned NOT NULL default '0',
  `ProductVariantImageSize` int(10) unsigned NOT NULL default '0',
  `ProductVariantImageThumb` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `ProductVariantImageThumbWidth` int(10) unsigned NOT NULL default '0',
  `ProductVariantImageThumbHeight` int(10) unsigned NOT NULL default '0',
  `ProductVariantImageThumbSize` int(10) unsigned NOT NULL default '0',
  `ProductVariantImageLarge` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `ProductVariantImageLargeWidth` int(10) unsigned NOT NULL default '0',
  `ProductVariantImageLargeHeight` int(10) unsigned NOT NULL default '0',
  `ProductVariantImageLargeSize` int(10) unsigned NOT NULL default '0',
  `ProductVariantImageBox` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `ProductVariantImageBoxWidth` int(10) unsigned NOT NULL default '0',
  `ProductVariantImageBoxHeight` int(10) unsigned NOT NULL default '0',
  `ProductVariantImageBoxSize` int(10) unsigned NOT NULL default '0',
  `ProductVariantImageOriginal` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `ProductVariantImageOriginalName` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`ProductVariantID`),
  UNIQUE KEY `ProductVariantCode` (`ProductVariantCode`),
  KEY `FK_ProductVariants_ProductID` (`ProductID`),
  CONSTRAINT `FK_ProductVariants_ProductID` FOREIGN KEY (`ProductID`) REFERENCES `Products` (`ProductID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
DROP TABLE IF EXISTS `ProductWholesalePrices`;
CREATE TABLE `ProductWholesalePrices` (
  `ProductWholesalePriceID` int(10) unsigned NOT NULL auto_increment,
  `ProductID` int(10) unsigned NOT NULL default '0',
  `ProductVariantID` int(10) unsigned default NULL,
  `CustomerGroupID` int(10) unsigned NOT NULL default '0',
  `ProductWholesalePriceQuantity` int(10) unsigned NOT NULL default '0',
  `ProductWholesalePriceAmount` decimal(10,2) NOT NULL default '0.00',
  PRIMARY KEY  USING BTREE (`ProductWholesalePriceID`),
  UNIQUE KEY `ProductWholesalePrice` (`ProductID`,`ProductVariantID`,`CustomerGroupID`,`ProductWholesalePriceQuantity`),
  KEY `FK_ProductWholesalePrices_CustomerGroupID` (`CustomerGroupID`),
  KEY `FK_ProductWholesalePrices_ProductVariantID` (`ProductVariantID`),
  CONSTRAINT `FK_ProductWholesalePrices_ProductVariantID` FOREIGN KEY (`ProductVariantID`) REFERENCES `ProductVariants` (`ProductVariantID`) ON DELETE CASCADE,
  CONSTRAINT `FK_ProductWholesalePrices_CustomerGroupID` FOREIGN KEY (`CustomerGroupID`) REFERENCES `CustomerGroups` (`CustomerGroupID`) ON DELETE CASCADE,
  CONSTRAINT `FK_ProductWholesalePrices_ProductID` FOREIGN KEY (`ProductID`) REFERENCES `Products` (`ProductID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ProductXCategories`;
CREATE TABLE `ProductXCategories` (
  `ProductID` int(10) unsigned NOT NULL default '0',
  `CategoryID` int(10) unsigned NOT NULL default '0',
  `ProductSortInCategory` int(10) NOT NULL default '0',
  PRIMARY KEY  (`ProductID`,`CategoryID`),
  UNIQUE KEY `ProductSortInCategory_CategoryID` (`ProductSortInCategory`,`CategoryID`),
  KEY `CategoryID` (`CategoryID`),
  CONSTRAINT `FK_ProductXCategories_CategoryID` FOREIGN KEY (`CategoryID`) REFERENCES `Categories` (`CategoryID`) ON DELETE CASCADE,
  CONSTRAINT `FK_ProductXCategories_ProductID` FOREIGN KEY (`ProductID`) REFERENCES `Products` (`ProductID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Products`;
CREATE TABLE `Products` (
  `ProductID` int(10) unsigned NOT NULL auto_increment,
  `ManufacturerID` int(10) unsigned default NULL,
  `ProductClassID` int(10) unsigned default NULL,
  `ProductIsActive` tinyint(1) unsigned NOT NULL default '0',
  `ProductCode` varchar(255) NOT NULL default '',
  `ProductNameXHTML` tinyint(1) unsigned NOT NULL default '0',
  `ProductDescriptionXHTML` tinyint(1) unsigned NOT NULL default '0',
  `ProductDetailedDescriptionXHTML` tinyint(1) unsigned NOT NULL default '0',
  `CategoryID` int(10) unsigned NOT NULL default '0',
  `ProductHomePageFeatured` tinyint(3) unsigned NOT NULL default '0',
  `ProductPrice` decimal(10,2) NOT NULL default '0.00',
  `ProductIsEgood` tinyint(1) unsigned NOT NULL default '0',
  `ProductIsBundle` tinyint(1) unsigned NOT NULL default '0',
  `ProductBundleAutoQuantity` tinyint(1) NOT NULL default '0',
  `ProductWeight` decimal(10,3) NOT NULL default '0.000',
  `ProductQuantity` int(11) NOT NULL default '0',
  `ProductCreatedTimestamp` int(10) unsigned NOT NULL default '0',
  `ProductSortInCategory` int(10) NOT NULL default '0',
  `ProductBonusPointsMode` tinyint(3) unsigned NOT NULL default '0',
  `ProductBonusPointsPrice` int(10) unsigned default NULL,
  PRIMARY KEY  (`ProductID`),
  UNIQUE KEY `ProductCode` (`ProductCode`),
  UNIQUE KEY `ProductSortInCategory_CategoryID` (`ProductSortInCategory`,`CategoryID`),
  KEY `CategoryID` (`CategoryID`),
  KEY `ProductPrice` (`ProductPrice`),
  KEY `ProductHomePageFeatured` (`ProductHomePageFeatured`),
  KEY `FK_Products_ManufacturerID` (`ManufacturerID`),
  KEY `FK_Products_ProductClassID` (`ProductClassID`),
  KEY `ProductCreatedTimestamp` (`ProductCreatedTimestamp`),
  CONSTRAINT `FK_Products_CategoryID` FOREIGN KEY (`CategoryID`) REFERENCES `Categories` (`CategoryID`),
  CONSTRAINT `FK_Products_ManufacturerID` FOREIGN KEY (`ManufacturerID`) REFERENCES `Manufacturers` (`ManufacturerID`),
  CONSTRAINT `FK_Products_ProductClassID` FOREIGN KEY (`ProductClassID`) REFERENCES `ProductClasses` (`ProductClassID`) ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ProductsML`;
CREATE TABLE `ProductsML` (
  `ProductID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `ProductName` varchar(255) NOT NULL default '',
  `ProductDescription` text NOT NULL,
  `ProductDetailedDescription` text NOT NULL,
  `ProductPageTitle` varchar(255) NOT NULL default '',
  `ProductMetaKeywords` text NOT NULL,
  `ProductMetaDescription` text NOT NULL,
  PRIMARY KEY  (`ProductID`,`LanguageID`),
  KEY `FK_ProductsML_LanguageID` (`LanguageID`),
  KEY `LanguageIDProductName` (`LanguageID`,`ProductName`),
  CONSTRAINT `FK_ProductsML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE,
  CONSTRAINT `FK_ProductsML_ProductID` FOREIGN KEY (`ProductID`) REFERENCES `Products` (`ProductID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `RatingActions`;
CREATE TABLE `RatingActions` (
  `RatingActionID` int(10) unsigned NOT NULL auto_increment,
  `RatingActionTimestamp` int(10) unsigned NOT NULL default '0',
  `CustomerID` int(10) unsigned default NULL,
  `RatingActionIPAddress` int(10) unsigned NOT NULL default '0',
  `RatingActionInputName` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`RatingActionID`),
  KEY `FK_RatingActions_CustomerID` (`CustomerID`),
  CONSTRAINT `FK_RatingActions_CustomerID` FOREIGN KEY (`CustomerID`) REFERENCES `Customers` (`CustomerID`) ON DELETE SET NULL ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `RelatedProducts`;
CREATE TABLE `RelatedProducts` (
  `ProductID` int(10) unsigned NOT NULL default '0',
  `RelatedProductID` int(10) unsigned NOT NULL default '0',
  `RelatedProductSort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ProductID`,`RelatedProductID`),
  UNIQUE KEY `RelatedProductSort` (`ProductID`,`RelatedProductSort`),
  KEY `FK_RelatedProducts_RelatedProductID` (`RelatedProductID`),
  CONSTRAINT `FK_RelatedProducts_ProductID` FOREIGN KEY (`ProductID`) REFERENCES `Products` (`ProductID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_RelatedProducts_RelatedProductID` FOREIGN KEY (`RelatedProductID`) REFERENCES `Products` (`ProductID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Sessions`;
CREATE TABLE `Sessions` (
  `SessionID` int(11) unsigned NOT NULL default '0',
  `SessionData` mediumblob NOT NULL,
  `SessionLastAccess` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`SessionID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Settings`;
CREATE TABLE `Settings` (
  `SettingID` int(10) unsigned NOT NULL auto_increment,
  `SettingName` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  `SettingValue` blob NOT NULL,
  PRIMARY KEY  (`SettingID`),
  UNIQUE KEY `UQ_SettingName` (`SettingName`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `SettingsML`;
CREATE TABLE `SettingsML` (
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `SettingName` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  `SettingValue` blob NOT NULL,
  PRIMARY KEY  (`LanguageID`,`SettingName`),
  CONSTRAINT `FK_SettingsML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ShippingMethods`;
CREATE TABLE `ShippingMethods` (
  `ShippingMethodID` int(10) unsigned NOT NULL auto_increment,
  `ShippingModuleID` int(10) unsigned NOT NULL default '0',
  `ShippingMethodCode` varchar(255) NOT NULL default '',
  `ShippingMethodIsActive` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ShippingMethodID`),
  KEY `FK_ShippingMethods_ShippingModuleID` (`ShippingModuleID`),
  CONSTRAINT `FK_ShippingMethods_ShippingModuleID` FOREIGN KEY (`ShippingModuleID`) REFERENCES `ShippingModules` (`ShippingModuleID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ShippingMethodsML`;
CREATE TABLE `ShippingMethodsML` (
  `ShippingMethodID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `ShippingMethodDisplayName` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`ShippingMethodID`,`LanguageID`),
  KEY `FK_ShippingMethodsML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_ShippingMethodsML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE,
  CONSTRAINT `FK_ShippingMethodsML_ShippingMethodID` FOREIGN KEY (`ShippingMethodID`) REFERENCES `ShippingMethods` (`ShippingMethodID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ShippingModuleOptions`;
CREATE TABLE `ShippingModuleOptions` (
  `ShippingModuleOptionID` int(10) unsigned NOT NULL auto_increment,
  `ShippingModuleID` int(10) unsigned NOT NULL default '0',
  `ShippingModuleOptionName` varchar(255) NOT NULL default '',
  `ShippingModuleOptionValue` mediumblob NOT NULL,
  PRIMARY KEY  (`ShippingModuleOptionID`),
  KEY `FK_ShippingModuleOptions_ShippingModuleID` (`ShippingModuleID`),
  CONSTRAINT `FK_ShippingModuleOptions_ShippingModuleID` FOREIGN KEY (`ShippingModuleID`) REFERENCES `ShippingModules` (`ShippingModuleID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ShippingModules`;
CREATE TABLE `ShippingModules` (
  `ShippingModuleID` int(10) unsigned NOT NULL auto_increment,
  `ModuleID` int(10) unsigned NOT NULL default '0',
  `ShippingZoneID` int(10) unsigned default NULL,
  `ShippingModuleName` varchar(255) NOT NULL default '',
  `ShippingModuleImage` varchar(255) NOT NULL default '',
  `ShippingModuleIsActive` tinyint(3) unsigned NOT NULL default '0',
  `ShippingModuleSort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ShippingModuleID`),
  UNIQUE KEY `ShippingModuleSort` (`ShippingModuleSort`),
  KEY `FK_ShippingModules_ModuleID` (`ModuleID`),
  KEY `FK_ShippingModules_ShippingZoneID` (`ShippingZoneID`),
  CONSTRAINT `FK_ShippingModules_ModuleID` FOREIGN KEY (`ModuleID`) REFERENCES `Modules` (`ModuleID`),
  CONSTRAINT `FK_ShippingModules_ShippingZoneID` FOREIGN KEY (`ShippingZoneID`) REFERENCES `ShippingZones` (`ShippingZoneID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ShippingModulesML`;
CREATE TABLE `ShippingModulesML` (
  `ShippingModuleID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `ShippingModuleDisplayName` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`ShippingModuleID`,`LanguageID`),
  KEY `FK_ShippingModulesML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_ShippingModulesML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE,
  CONSTRAINT `FK_ShippingModulesML_ShippingModuleID` FOREIGN KEY (`ShippingModuleID`) REFERENCES `ShippingModules` (`ShippingModuleID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ShippingTable`;
CREATE TABLE `ShippingTable` (
  `ShippingTableID` int(10) unsigned NOT NULL auto_increment,
  `ShippingModuleID` int(10) unsigned NOT NULL default '0',
  `ShippingTableUpTo` decimal(10,2) unsigned NOT NULL default '0.00',
  `ShippingTableCost` decimal(10,2) unsigned NOT NULL default '0.00',
  PRIMARY KEY  (`ShippingTableID`),
  KEY `ShippingModuleID` (`ShippingModuleID`),
  CONSTRAINT `FK_ShippingTable_ShippingModuleID` FOREIGN KEY (`ShippingModuleID`) REFERENCES `ShippingModules` (`ShippingModuleID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ShippingZoneCountries`;
CREATE TABLE `ShippingZoneCountries` (
  `ShippingZoneID` int(10) unsigned NOT NULL default '0',
  `CountryID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ShippingZoneID`,`CountryID`),
  KEY `FK_ShippingZoneCountries_CountryID` (`CountryID`),
  CONSTRAINT `FK_ShippingZoneCountries_CountryID` FOREIGN KEY (`CountryID`) REFERENCES `Countries` (`CountryID`) ON DELETE CASCADE,
  CONSTRAINT `FK_ShippingZoneCountries_ShippingZoneID` FOREIGN KEY (`ShippingZoneID`) REFERENCES `ShippingZones` (`ShippingZoneID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ShippingZoneStates`;
CREATE TABLE `ShippingZoneStates` (
  `ShippingZoneID` int(10) unsigned NOT NULL default '0',
  `StateID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`StateID`,`ShippingZoneID`),
  KEY `FK_ShippingZoneStates_ShippingZoneID` (`ShippingZoneID`),
  CONSTRAINT `FK_ShippingZoneStates_ShippingZoneID` FOREIGN KEY (`ShippingZoneID`) REFERENCES `ShippingZones` (`ShippingZoneID`) ON DELETE CASCADE,
  CONSTRAINT `FK_ShippingZoneStates_StateID` FOREIGN KEY (`StateID`) REFERENCES `States` (`StateID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `ShippingZones`;
CREATE TABLE `ShippingZones` (
  `ShippingZoneID` int(10) unsigned NOT NULL auto_increment,
  `ShippingZoneName` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`ShippingZoneID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `SkinSettings`;
CREATE TABLE `SkinSettings` (
  `SkinSettingID` int(10) unsigned NOT NULL auto_increment,
  `SkinID` int(10) unsigned NOT NULL default '0',
  `SkinSettingName` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  `SkinSettingType` tinyint(3) unsigned NOT NULL default '0',
  `SkinSettingValue` mediumblob NOT NULL,
  PRIMARY KEY  (`SkinSettingID`),
  UNIQUE KEY `SkinID` (`SkinID`,`SkinSettingName`),
  CONSTRAINT `FK_SkinSettings_SkinID` FOREIGN KEY (`SkinID`) REFERENCES `Skins` (`SkinID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Skins`;
CREATE TABLE `Skins` (
  `SkinID` int(10) unsigned NOT NULL auto_increment,
  `SkinName` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  `SkinLocation` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  `SkinHasAdmin` tinyint(3) unsigned NOT NULL default '0',
  `SkinHasUser` tinyint(3) unsigned NOT NULL default '0',
  `SkinParentID` int(10) unsigned default NULL,
  `SkinScreenshot` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`SkinID`),
  KEY `FK_Skins_SkinParentID` (`SkinParentID`),
  CONSTRAINT `FK_Skins_SkinParentID` FOREIGN KEY (`SkinParentID`) REFERENCES `Skins` (`SkinID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `StatCategoryViews`;
CREATE TABLE `StatCategoryViews` (
  `StatCategoryViewsID` int(10) unsigned NOT NULL auto_increment,
  `CategoryID` int(10) unsigned NOT NULL default '0',
  `StatCategoryViewsDate` date NOT NULL default '0000-00-00',
  `StatCategoryViewsCount` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`StatCategoryViewsID`),
  UNIQUE KEY `StatCategoryViewsDate` (`CategoryID`,`StatCategoryViewsDate`),
  CONSTRAINT `FK_StatCategoryViews_CategoryID` FOREIGN KEY (`CategoryID`) REFERENCES `Categories` (`CategoryID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `StatProductViews`;
CREATE TABLE `StatProductViews` (
  `StatProductViewsID` int(10) unsigned NOT NULL auto_increment,
  `ProductID` int(10) unsigned NOT NULL default '0',
  `StatProductViewsDate` date NOT NULL default '0000-00-00',
  `StatProductViewsCount` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  USING BTREE (`StatProductViewsID`),
  UNIQUE KEY `ProductViewsDate` (`ProductID`,`StatProductViewsDate`),
  CONSTRAINT `FK_StatProductViews_ProductID` FOREIGN KEY (`ProductID`) REFERENCES `Products` (`ProductID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `StatViewsVisits`;
CREATE TABLE `StatViewsVisits` (
  `StatViewsVisitsID` int(10) unsigned NOT NULL auto_increment,
  `StatViewsVisitsDate` date NOT NULL default '0000-00-00',
  `StatViewsCount` int(10) unsigned NOT NULL default '0',
  `StatVisitsCount` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  USING BTREE (`StatViewsVisitsID`),
  UNIQUE KEY `StatViewsVisitsDate` USING BTREE (`StatViewsVisitsDate`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `States`;
CREATE TABLE `States` (
  `StateID` int(10) unsigned NOT NULL auto_increment,
  `CountryID` int(10) unsigned NOT NULL default '0',
  `StateCode` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`StateID`),
  KEY `FK_States_CountryID` (`CountryID`),
  CONSTRAINT `FK_States_CountryID` FOREIGN KEY (`CountryID`) REFERENCES `Countries` (`CountryID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `StatesML`;
CREATE TABLE `StatesML` (
  `StateID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `StateName` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`StateID`,`LanguageID`),
  KEY `FK_StatesML_LanguageID` (`LanguageID`),
  KEY `LanguageIDStateName` (`LanguageID`,`StateName`),
  CONSTRAINT `FK_StatesML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE,
  CONSTRAINT `FK_StatesML_StateID` FOREIGN KEY (`StateID`) REFERENCES `States` (`StateID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `SyncItems`;
CREATE TABLE `SyncItems` (
  `SyncItemID` int(10) unsigned NOT NULL auto_increment,
  `SyncItemHandler` varchar(64) character set utf8 collate utf8_bin NOT NULL default '',
  `SyncItemLocalID` int(10) unsigned NOT NULL default '0',
  `SyncItemForeignID` varchar(128) character set utf8 collate utf8_bin NOT NULL default '',
  `SyncItemHashCode` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  `SyncItemLastUpdate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`SyncItemID`),
  UNIQUE KEY `Handler_LocalID` (`SyncItemHandler`,`SyncItemLocalID`),
  UNIQUE KEY `Handler_ForeignID` (`SyncItemHandler`,`SyncItemForeignID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `SyncOperationsLog`;
CREATE TABLE `SyncOperationsLog` (
  `SyncOperationsLogID` int(10) unsigned NOT NULL auto_increment,
  `SyncOperationsLogHandler` varchar(64) character set utf8 collate utf8_bin NOT NULL default '',
  `LocalID` int(10) unsigned NOT NULL default '0',
  `SyncOperationsLogOperation` tinyint(3) unsigned NOT NULL default '0',
  `SyncOperationsLogTimestamp` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  USING BTREE (`SyncOperationsLogID`),
  KEY `SyncOperationsLogHandler` USING BTREE (`SyncOperationsLogHandler`,`LocalID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `SyncTransactionItems`;
CREATE TABLE `SyncTransactionItems` (
  `SyncTransactionItemID` int(10) unsigned NOT NULL auto_increment,
  `SyncTransactionID` int(10) unsigned NOT NULL default '0',
  `SyncTransactionItemHandler` varchar(64) character set utf8 collate utf8_bin NOT NULL default '',
  `SyncTransactionItemForeignID` varchar(128) character set utf8 collate utf8_bin NOT NULL default '',
  `SyncTransactionItemHashCode` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  PRIMARY KEY  (`SyncTransactionItemID`),
  UNIQUE KEY `Transaction_Handler_ForeignID` USING BTREE (`SyncTransactionItemHandler`,`SyncTransactionItemForeignID`,`SyncTransactionID`),
  KEY `FK_SyncTransactionItems_SyncTransactionID` (`SyncTransactionID`),
  CONSTRAINT `FK_SyncTransactionItems_SyncTransactionID` FOREIGN KEY (`SyncTransactionID`) REFERENCES `SyncTransactions` (`SyncTransactionID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `SyncTransactionResults`;
CREATE TABLE `SyncTransactionResults` (
  `SyncTransactionResultID` int(10) unsigned NOT NULL auto_increment,
  `SyncTransactionID` int(10) unsigned NOT NULL default '0',
  `SyncTransactionResultHandler` varchar(64) character set utf8 collate utf8_bin NOT NULL default '',
  `SyncTransactionResultOperation` tinyint(1) NOT NULL default '0',
  `SyncTransactionResultLocalID` int(11) NOT NULL default '0',
  `SyncTransactionResultForeignID` varchar(128) character set utf8 collate utf8_bin NOT NULL default '',
  `SyncTransactionResultHashCode` varchar(255) character set utf8 collate utf8_bin NOT NULL default '',
  PRIMARY KEY  (`SyncTransactionResultID`),
  KEY `FK_SyncTransactionResult_SyncTransactionID` (`SyncTransactionID`),
  CONSTRAINT `FK_SyncTransactionResult_SyncTransactionID` FOREIGN KEY (`SyncTransactionID`) REFERENCES `SyncTransactions` (`SyncTransactionID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `SyncTransactions`;
CREATE TABLE `SyncTransactions` (
  `SyncTransactionID` int(10) unsigned NOT NULL auto_increment,
  `ApiAccountID` int(10) unsigned NOT NULL default '0',
  `SyncTransactionLastActivity` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  USING BTREE (`SyncTransactionID`),
  KEY `FK_SyncTransactions_ApiAccountID` (`ApiAccountID`),
  CONSTRAINT `FK_SyncTransactions_ApiAccountID` FOREIGN KEY (`ApiAccountID`) REFERENCES `ApiAccounts` (`ApiAccountID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `TaxClasses`;
CREATE TABLE `TaxClasses` (
  `TaxClassID` int(10) unsigned NOT NULL auto_increment,
  `TaxID` int(10) unsigned NOT NULL default '0',
  `TaxClassName` varchar(255) NOT NULL default '',
  `TaxClassSort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`TaxClassID`),
  UNIQUE KEY `TaxClassSort` (`TaxID`,`TaxClassSort`),
  CONSTRAINT `FK_TaxClasses_TaxID` FOREIGN KEY (`TaxID`) REFERENCES `Taxes` (`TaxID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `TaxRates`;
CREATE TABLE `TaxRates` (
  `TaxClassID` int(10) unsigned NOT NULL default '0',
  `TaxZoneID` int(10) unsigned NOT NULL default '0',
  `TaxRate` decimal(10,2) unsigned NOT NULL default '0.00',
  PRIMARY KEY  (`TaxClassID`,`TaxZoneID`),
  KEY `FK_TaxRates_TaxZoneID` (`TaxZoneID`),
  CONSTRAINT `FK_TaxRates_TaxClassID` FOREIGN KEY (`TaxClassID`) REFERENCES `TaxClasses` (`TaxClassID`) ON DELETE CASCADE,
  CONSTRAINT `FK_TaxRates_TaxZoneID` FOREIGN KEY (`TaxZoneID`) REFERENCES `TaxZones` (`TaxZoneID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `TaxZoneCountries`;
CREATE TABLE `TaxZoneCountries` (
  `TaxZoneID` int(10) unsigned NOT NULL default '0',
  `CountryID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`TaxZoneID`,`CountryID`),
  KEY `FK_TaxZoneCountries_CountryID` (`CountryID`),
  CONSTRAINT `FK_TaxZoneCountries_CountryID` FOREIGN KEY (`CountryID`) REFERENCES `Countries` (`CountryID`) ON DELETE CASCADE,
  CONSTRAINT `FK_TaxZoneCountries_TaxZoneID` FOREIGN KEY (`TaxZoneID`) REFERENCES `TaxZones` (`TaxZoneID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `TaxZoneStates`;
CREATE TABLE `TaxZoneStates` (
  `TaxZoneID` int(10) unsigned NOT NULL default '0',
  `StateID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`TaxZoneID`,`StateID`),
  KEY `FK_TaxZoneStates_StateID` (`StateID`),
  CONSTRAINT `FK_TaxZoneStates_StateID` FOREIGN KEY (`StateID`) REFERENCES `States` (`StateID`) ON DELETE CASCADE,
  CONSTRAINT `FK_TaxZoneStates_TaxZoneID` FOREIGN KEY (`TaxZoneID`) REFERENCES `TaxZones` (`TaxZoneID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `TaxZones`;
CREATE TABLE `TaxZones` (
  `TaxZoneID` int(10) unsigned NOT NULL auto_increment,
  `TaxID` int(10) unsigned NOT NULL default '0',
  `TaxZoneName` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`TaxZoneID`),
  KEY `FK_TaxZones_TaxID` (`TaxID`),
  CONSTRAINT `FK_TaxZones_TaxID` FOREIGN KEY (`TaxID`) REFERENCES `Taxes` (`TaxID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Taxes`;
CREATE TABLE `Taxes` (
  `TaxID` int(10) unsigned NOT NULL auto_increment,
  `TaxRegNumber` varchar(255) NOT NULL default '',
  `TaxApplyToShipping` tinyint(3) unsigned NOT NULL default '0',
  `TaxApplyByDefault` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`TaxID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `TaxesML`;
CREATE TABLE `TaxesML` (
  `TaxID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `TaxName` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`TaxID`,`LanguageID`),
  KEY `FK_TaxesML_LanguageID` (`LanguageID`),
  CONSTRAINT `FK_TaxesML_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE,
  CONSTRAINT `FK_TaxesML_TaxID` FOREIGN KEY (`TaxID`) REFERENCES `Taxes` (`TaxID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Texts`;
CREATE TABLE `Texts` (
  `TextID` int(10) unsigned NOT NULL auto_increment,
  `TextType` tinyint(3) unsigned NOT NULL default '0',
  `TextOriginal` mediumtext NOT NULL,
  `TextOriginalHash` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`TextID`),
  UNIQUE KEY `TextOriginalHash` (`TextOriginalHash`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `TextsCache`;
CREATE TABLE `TextsCache` (
  `TextID` int(10) unsigned NOT NULL default '0',
  `TextsCachePagePath` varchar(255) NOT NULL default '0',
  PRIMARY KEY  (`TextID`,`TextsCachePagePath`),
  KEY `TextsCachePagePath` (`TextsCachePagePath`),
  CONSTRAINT `FK_TextsCache_TextID` FOREIGN KEY (`TextID`) REFERENCES `Texts` (`TextID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `TextsTranslated`;
CREATE TABLE `TextsTranslated` (
  `TextID` int(10) unsigned NOT NULL default '0',
  `LanguageID` int(10) unsigned NOT NULL default '0',
  `TextOriginalHash` int(10) unsigned NOT NULL default '0',
  `TextTranslated` mediumtext NOT NULL,
  `TextIsTranslated` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`LanguageID`,`TextID`),
  UNIQUE KEY `TextOriginalHash` (`LanguageID`,`TextOriginalHash`),
  KEY `FK_TextsTranslated_TextID` (`TextID`),
  CONSTRAINT `FK_TextsTranslated_LanguageID` FOREIGN KEY (`LanguageID`) REFERENCES `Languages` (`LanguageID`) ON DELETE CASCADE,
  CONSTRAINT `FK_TextsTranslated_TextID` FOREIGN KEY (`TextID`) REFERENCES `Texts` (`TextID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `TransactionDetails`;
CREATE TABLE `TransactionDetails` (
  `TransactionDetailID` int(10) unsigned NOT NULL auto_increment,
  `TransactionID` int(10) unsigned NOT NULL default '0',
  `TransactionDetailName` varchar(255) NOT NULL default '',
  `TransactionDetailValue` blob NOT NULL,
  PRIMARY KEY  (`TransactionDetailID`),
  KEY `TransactionID` (`TransactionID`),
  CONSTRAINT `FK_TransactionDetails_TransactionID` FOREIGN KEY (`TransactionID`) REFERENCES `Transactions` (`TransactionID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `Transactions`;
CREATE TABLE `Transactions` (
  `TransactionID` int(10) unsigned NOT NULL auto_increment,
  `OrderID` int(10) unsigned NOT NULL default '0',
  `ModuleID` int(10) unsigned NOT NULL default '0',
  `TransactionTimestamp` int(10) unsigned NOT NULL default '0',
  `TransactionAmount` decimal(10,2) NOT NULL default '0.00',
  `TransactionCurrencyCode` varchar(3) NOT NULL default '',
  `TransactionCode` varchar(255) NOT NULL default '',
  `TransactionPaymentStatus` tinyint(3) unsigned NOT NULL default '0',
  `TransactionNote` text NOT NULL,
  PRIMARY KEY  (`TransactionID`),
  KEY `OrderID` (`OrderID`),
  CONSTRAINT `FK_Transactions_OrderID` FOREIGN KEY (`OrderID`) REFERENCES `Orders` (`OrderID`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `WishlistItemLocalOptions`;
CREATE TABLE `WishlistItemLocalOptions` (
  `WishlistItemID` int(10) unsigned NOT NULL default '0',
  `LocalOptionID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`WishlistItemID`,`LocalOptionID`),
  KEY `FK_WishlistItemLocalOptions_LocalOptionID` (`LocalOptionID`),
  CONSTRAINT `FK_WishlistItemLocalOptions_LocalOptionID` FOREIGN KEY (`LocalOptionID`) REFERENCES `LocalOptions` (`LocalOptionID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_WishlistItemLocalOptions_WishlistItemID` FOREIGN KEY (`WishlistItemID`) REFERENCES `WishlistItems` (`WishlistItemID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `WishlistItemOptions`;
CREATE TABLE `WishlistItemOptions` (
  `WishlistItemID` int(10) unsigned NOT NULL default '0',
  `OptionID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`WishlistItemID`,`OptionID`),
  KEY `FK_WishlistItemOptions_OptionID` (`OptionID`),
  CONSTRAINT `FK_WishlistItemOptions_OptionID` FOREIGN KEY (`OptionID`) REFERENCES `Options` (`OptionID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_WishlistItemOptions_WishlistID` FOREIGN KEY (`WishlistItemID`) REFERENCES `WishlistItems` (`WishlistItemID`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
DROP TABLE IF EXISTS `WishlistItems`;
CREATE TABLE `WishlistItems` (
  `WishlistItemID` int(10) unsigned NOT NULL auto_increment,
  `CustomerID` int(10) unsigned NOT NULL default '0',
  `ProductID` int(10) unsigned NOT NULL default '0',
  `ProductVariantID` int(10) unsigned default NULL,
  `WishlistItemQuantity` int(10) unsigned NOT NULL default '0',
  `WishlistItemAddedTimestamp` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`WishlistItemID`),
  KEY `FK_WishlistItems_ProductID` (`ProductID`),
  KEY `FK_WishlistItems_ProductVariantID` (`ProductVariantID`),
  KEY `FK_WishlistItems_CustomerID` (`CustomerID`),
  CONSTRAINT `FK_WishlistItems_CustomerID` FOREIGN KEY (`CustomerID`) REFERENCES `Customers` (`CustomerID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_WishlistItems_ProductID` FOREIGN KEY (`ProductID`) REFERENCES `Products` (`ProductID`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `FK_WishlistItems_ProductVariantID` FOREIGN KEY (`ProductVariantID`) REFERENCES `ProductVariants` (`ProductVariantID`) ON DELETE SET NULL ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

LOCK TABLES `Customers` WRITE;
/*!40000 ALTER TABLE `Customers` DISABLE KEYS */;
INSERT INTO `Customers` VALUES (1,'','',0,0,1,0,NULL);
/*!40000 ALTER TABLE `Customers` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

LOCK TABLES `CustomerAddresses` WRITE;
/*!40000 ALTER TABLE `CustomerAddresses` DISABLE KEYS */;
INSERT INTO `CustomerAddresses` VALUES (1,1,1,1,'Guest','','','','','Seattle',NULL,51,233,'98109','','','');
/*!40000 ALTER TABLE `CustomerAddresses` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

LOCK TABLES `AdminQuickLinks` WRITE;
/*!40000 ALTER TABLE `AdminQuickLinks` DISABLE KEYS */;
INSERT INTO `AdminQuickLinks` VALUES (1,'index.php','','orders.php'),(2,'index.php','','customers.php'),(3,'index.php','','products.php'),(4,'orders.php','','customers.php'),(5,'orders.php','','products.php'),(6,'orders.php','','report.php?report=SalesByProduct'),(7,'customers.php','','orders.php'),(8,'customers.php','','products.php'),(9,'customers.php','','report.php?report=SalesByCustomer'),(10,'products.php','','categories.php'),(11,'products.php','','option_groups.php'),(12,'products.php','','featured_products.php'),(13,'products.php','','manufacturers.php'),(14,'products.php','','report.php?report=SalesByProduct'),(15,'option_groups.php','','products.php'),(16,'option_groups.php','','report.php?report=SalesByProduct'),(17,'categories.php','','products.php'),(18,'categories.php','','featured_products.php'),(19,'categories.php','','report.php?report=SalesByCategory'),(20,'manufacturers.php','','products.php'),(21,'featured_products.php','','discounts.php'),(22,'featured_products.php','','coupons.php'),(23,'discounts.php','','coupons.php'),(24,'discounts.php','','products.php'),(25,'coupons.php','','discounts.php'),(26,'coupons.php','','products.php'),(27,'rich_text_pages.php','','menus.php'),(28,'rich_text_pages.php','','layouts.php'),(29,'rich_text_pages.php','','dynamic_pages.php'),(30,'dynamic_pages.php','','menus.php'),(31,'dynamic_pages.php','','layouts.php'),(32,'dynamic_pages.php','','rich_text_pages.php'),(33,'module.php?ModuleName=com.summercart.news','','products.php'),(34,'module.php?ModuleName=com.summercart.news','','boxes.php'),(35,'form.php','','menus.php'),(36,'forms.php','','layouts.php'),(37,'menus.php','','forms.php'),(38,'menus.php','','rich_text_pages.php'),(39,'menus.php','','layouts.php'),(40,'menus.php','','boxes.php'),(41,'menu_items.php','','forms.php'),(42,'menu_items.php','','rich_text_pages.php'),(43,'menu_items.php','','layouts.php'),(44,'menu_items.php','','boxes.php'),(45,'boxes.php','','menus.php'),(46,'boxes.php','','layouts.php'),(47,'skins.php','','layouts.php'),(48,'skins.php','','boxes.php'),(49,'layouts.php','','menus.php'),(50,'layouts.php','','forms.php'),(51,'layouts.php','','rich_text_pages.php'),(52,'layouts.php','','dynamic_pages.php'),(53,'report.php','SalesByProduct','products.php'),(54,'report.php','SalesByProduct','orders.php'),(55,'report.php','SalesByCategory','categories.php'),(56,'report.php','SalesByCategory','orders.php'),(57,'report.php','SalesByCustomer','customers.php'),(58,'report.php','SalesByCustomer','report.php?report=CustomerCountries'),(59,'report.php','SalesByCountry','orders.php'),(60,'report.php','SalesByCountry','report.php?report=OrderShippingMethods'),(61,'report.php','CustomerCountries','customers.php'),(62,'report.php','CustomerCountries','orders.php'),(63,'report.php','CustomerCountries','report.php?report=SalesByCountry'),(64,'report.php','CustomerCountries','report.php?report=OrderShippingMethods'),(65,'report.php','AverageOrderAmount','orders.php'),(66,'report.php','AverageOrderAmount','report.php?report=SalesByProduct'),(67,'report.php','OrderStatuses','orders.php'),(68,'report.php','OrderStatuses','order_statuses.php'),(69,'report.php','OrderPaymentMethods','payment_modules.php'),(70,'report.php','OrderShippingMethods','shipping_modules.php'),(71,'report.php','OrderTaxes','taxes.php'),(72,'report.php','OrderTaxes','report.php?report=SalesByProduct'),(73,'report.php','OrderItems','report.php?report=SalesByProduct'),(74,'report.php','OrderItems','report.php?report=AverageOrderAmount'),(75,'shipping_modules.php','','shipping_zones.php'),(76,'shipping_modules.php','','report.php?report=OrderShippingMethods'),(77,'payment_modules.php','','checkout_modules.php'),(78,'payment_modules.php','','report.php?report=OrderPaymentMethods'),(79,'checkout_modules.php','','payment_modules.php'),(80,'checkout_modules.php','','report.php?report=OrderPaymentMethods'),(81,'order_total_modules.php','','taxes.php'),(82,'order_total_modules.php','','discounts.php'),(83,'order_total_modules.php','','coupons.php'),(84,'order_total_modules.php','','shipping_modules.php'),(85,'currency_rate_modules.php','','currencies.php'),(86,'currency_rate_modules.php','','report.php?report=SalesByCountry'),(87,'general_options.php','','company.php'),(88,'general_options.php','','emails.php'),(89,'general_options.php','','security.php'),(90,'general_options.php','','seo.php'),(91,'general_options.php','','localization.php'),(92,'company.php','','general_options.php'),(93,'company.php','','emails.php'),(94,'company.php','','security.php'),(95,'company.php','','seo.php'),(96,'company.php','','localization.php'),(97,'emails.php','','general_options.php'),(98,'emails.php','','company.php'),(99,'emails.php','','security.php'),(100,'emails.php','','seo.php'),(101,'emails.php','','localization.php'),(102,'security.php','','general_options.php'),(103,'security.php','','company.php'),(104,'security.php','','emails.php'),(105,'security.php','','seo.php'),(106,'security.php','','localization.php'),(107,'seo.php','','general_options.php'),(108,'seo.php','','company.php'),(109,'seo.php','','emails.php'),(110,'seo.php','','security.php'),(111,'seo.php','','localization.php'),(112,'localization.php','','general_options.php'),(113,'localization.php','','company.php'),(114,'localization.php','','emails.php'),(115,'localization.php','','security.php'),(116,'localization.php','','seo.php'),(117,'administrators.php','','products.php'),(118,'order_statuses.php','','orders.php'),(119,'order_statuses.php','','report.php?report=OrderStatuses'),(120,'countries.php','','states.php'),(121,'countries.php','','shipping_zones.php'),(122,'countries.php','','report.php?report=SalesByCountry'),(123,'countries.php','','report.php?report=CustomerCountries'),(124,'states.php','','countries.php'),(125,'states.php','','shipping_zones.php'),(126,'taxes.php','','products.php'),(127,'taxes.php','','report.php?report=OrderTaxes'),(128,'tax_rates.php','','taxes.php'),(129,'tax_classes.php','','taxes.php'),(130,'tax_zones.php','','taxes.php'),(131,'tax_zones.php','','shipping_zones.php'),(132,'shipping_zones.php','','shipping_modules.php'),(133,'shipping_zones.php','','report.php?report=OrderShippingMethods'),(134,'languages.php','','report.php?report=SalesByCountry'),(135,'languages.php','','report.php?report=CustomerCountries'),(136,'language_texts.php','','report.php?report=SalesByCountry'),(137,'language_texts.php','','report.php?report=CustomerCountries'),(138,'currencies.php','','currency_rate_modules.php'),(139,'currencies.php','','report.php?report=SalesByCountry'),(140,'currencies.php','','report.php?report=CustomerCountries'),(141,'denied.php','','index.php'),(142,'helps.php','','index.php'),(143,'license.php','','index.php'),(144,'log.php','','index.php'),(145,'search.php','','products.php'),(146,'search.php','','orders.php'),(147,'com.summercart.news','','index.php');
/*!40000 ALTER TABLE `AdminQuickLinks` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `AdminQuickLinksML` WRITE;
/*!40000 ALTER TABLE `AdminQuickLinksML` DISABLE KEYS */;
INSERT INTO `AdminQuickLinksML` VALUES (1,1,'Orders'),(1,2,'Поръчки'),(1,3,'Siparişler'),(2,1,'Customers'),(2,2,'Клиенти'),(2,3,'Müşteriler'),(3,1,'Products'),(3,2,'Продукти'),(3,3,'Ürünler'),(4,1,'Customers'),(4,2,'Клиенти'),(4,3,'Müşteriler'),(5,1,'Products'),(5,2,'Продукти'),(5,3,'Ürünler'),(6,1,'Sales By Product Report'),(6,2,'Доклад продажби по продукти'),(6,3,'Ürün Satış raporları'),(7,1,'Orders'),(7,2,'Поръчки'),(7,3,'Siparişler'),(8,1,'Products'),(8,2,'Продукти'),(8,3,'Ürünler'),(9,1,'Sales By Customer Report'),(9,2,'Доклад продажби по клиенти'),(9,3,'Müşteri Satış raporu'),(10,1,'Categories'),(10,2,'Категории'),(10,3,'Kategoriler'),(11,1,'Product Options'),(11,2,'Продуктови опции'),(11,3,'Ürün Seçenekleri'),(12,1,'Featured Products'),(12,2,'Промо Продукти'),(12,3,'Özellikli Ürünler'),(13,1,'Manufacturers'),(13,2,'Производители'),(13,3,'Üreticiler'),(14,1,'Sales By Product Report'),(14,2,'Доклад продажби по продукти'),(14,3,'Ürün Satış raporları'),(15,1,'Products'),(15,2,'Продукти'),(15,3,'Ürünler'),(16,1,'Sales By Product Report'),(16,2,'Доклад продажби по продукти'),(16,3,'Ürün Satış raporları'),(17,1,'Products'),(17,2,'Продукти'),(17,3,'Ürünler'),(18,1,'Featured Products'),(18,2,'Промо Продукти'),(18,3,'Özellikli Ürünler'),(19,1,'Sales By Category Report'),(19,2,'Доклад продажби по категории'),(19,3,'Kategori Satış raporu'),(20,1,'Products'),(20,2,'Продукти'),(20,3,'Ürünler'),(21,1,'Discounts'),(21,2,'Отстъпки'),(21,3,'Indirimler'),(22,1,'Coupons'),(22,2,'Промо продукти'),(22,3,'Kuponlar'),(23,1,'Coupons'),(23,2,'Промо продукти'),(23,3,'Kuponlar'),(24,1,'Products'),(24,2,'Продукти'),(24,3,'Ürünler'),(25,1,'Discounts'),(25,2,'Отстъпки'),(25,3,'Indirimler'),(26,1,'Products'),(26,2,'Продукти'),(26,3,'Ürünler'),(27,1,'Menus'),(27,2,'Менюта'),(27,3,'Menü'),(28,1,'Layouts'),(28,2,'Подредби'),(28,3,'Düzenler'),(29,1,'Dynamic Pages'),(29,2,'Динамични страници'),(29,3,'Dinamik Sayfalar'),(30,1,'Menus'),(30,2,'Менюта'),(30,3,'Menü'),(31,1,'Layouts'),(31,2,'Подредби'),(31,3,'Düzenler'),(32,1,'Rich Text Pages'),(32,2,'Страници с богат текст'),(32,3,'Zengin Metin Sayfaları'),(33,1,'Products'),(33,2,'Продукти'),(33,3,'Ürünler'),(34,1,'Boxes'),(34,2,'Кутии'),(34,3,'Kutular'),(35,1,'Menus'),(35,2,'Менюта'),(35,3,'Menü'),(36,1,'Layouts'),(36,2,'Подредби'),(36,3,'Düzenler'),(37,1,'Forms'),(37,2,'Формуляри'),(37,3,'Formlar'),(38,1,'Rich Text Pages'),(38,2,'Страници с богат текст'),(38,3,'Zengin Metin Sayfaları'),(39,1,'Layouts'),(39,2,'Подредби'),(39,3,'Düzenler'),(40,1,'Boxes'),(40,2,'Кутии'),(40,3,'Kutular'),(41,1,'Forms'),(41,2,'Формуляри'),(41,3,'Formlar'),(42,1,'Rich Text Pages'),(42,2,'Страници с богат текст'),(42,3,'Zengin Metin Sayfaları'),(43,1,'Layouts'),(43,2,'Подредби'),(43,3,'Düzenler'),(44,1,'Boxes'),(44,2,'Кутии'),(44,3,'Kutular'),(45,1,'Menus'),(45,2,'Менюта'),(45,3,'Menü'),(46,1,'Layouts'),(46,2,'Подредби'),(46,3,'Düzenler'),(47,1,'Layouts'),(47,2,'Подредби'),(47,3,'Düzenler'),(48,1,'Boxes'),(48,2,'Кутии'),(48,3,'Kutular'),(49,1,'Menus'),(49,2,'Менюта'),(49,3,'Menü'),(50,1,'Forms'),(50,2,'Формуляри'),(50,3,'Formlar'),(51,1,'Rich Text Pages'),(51,2,'Страници с богат текст'),(51,3,'Zengin Metin Sayfaları'),(52,1,'Dynamic Pages'),(52,2,'Динамични страници'),(52,3,'Dinamik Sayfalar'),(53,1,'Products'),(53,2,'Продукти'),(53,3,'Ürünler'),(54,1,'Orders'),(54,2,'Поръчки'),(54,3,'Siparişler'),(55,1,'Categories'),(55,2,'Категории'),(55,3,'Kategoriler'),(56,1,'Orders'),(56,2,'Поръчки'),(56,3,'Siparişler'),(57,1,'Customers'),(57,2,'Клиенти'),(57,3,'Müşteriler'),(58,1,'Customer Countries Report'),(58,2,'Доклад държави на клиенти'),(58,3,'Müşteri Ülke raporu'),(59,1,'Orders'),(59,2,'Поръчки'),(59,3,'Siparişler'),(60,1,'Shipping Methods And Costs Report'),(60,2,'Доклад методи за доставка и такси'),(60,3,'Gönderim Metotları ve Ücret Raporu'),(61,1,'Customers'),(61,2,'Клиенти'),(61,3,'Müşteriler'),(62,1,'Orders'),(62,2,'Поръчки'),(62,3,'Siparişler'),(63,1,'Sales By Country Report'),(63,2,'Доклад продажни по дръжави'),(63,3,'Ülke Satış raporu'),(64,1,'Shipping Methods And Costs Report'),(64,2,'Доклад методи за доставка и такси'),(64,3,'Gönderim Metotları ve Ücret Raporu'),(65,1,'Orders'),(65,2,'Поръчки'),(65,3,'Siparişler'),(66,1,'Sales By Product Report'),(66,2,'Доклад продажби по продукти'),(66,3,'Ürün Satış raporları'),(67,1,'Orders'),(67,2,'Поръчки'),(67,3,'Siparişler'),(68,1,'Order Statuses'),(68,2,'Статуси на поръчки'),(68,3,'Sipariş Durumları'),(69,1,'Payment Modules'),(69,2,'Модули за плащане'),(69,3,'Ödeme Modülleri'),(70,1,'Shipping Modules'),(70,2,'Модули за доставка'),(70,3,'Gönderim Modüllleri'),(71,1,'Taxes'),(71,2,'Данъци'),(71,3,'Vergiler'),(72,1,'Sales By Product Report'),(72,2,'Доклад продажби по продукти'),(72,3,'Ürün Satış raporları'),(73,1,'Sales By Product Report'),(73,2,'Доклад продажби по продукти'),(73,3,'Ürün Satış raporları'),(74,1,'Average Order Amount Report'),(74,2,'Доклад средна сума на поръчка'),(74,3,'Ortalama Sipariş Miktarı raporu'),(75,1,'Shipping Zones'),(75,2,'Зони за доставка'),(75,3,'Gönderim Bölgeleri'),(76,1,'Shipping Methods And Costs Report'),(76,2,'Доклад методи за доставка и такси'),(76,3,'Gönderim Metotları ve Ücret Raporu'),(77,1,'Checkout Modules'),(77,2,'Чекаут модули'),(77,3,'Direkt Kasaya Ödeme Modülleri'),(78,1,'Payment Methods Report'),(78,2,'Доклад методи за плащане'),(78,3,'Ödeme Yöntem raporu'),(79,1,'Payment Modules'),(79,2,'Модули за плащане'),(79,3,'Ödeme Modülleri'),(80,1,'Payment Methods Report'),(80,2,'Доклад методи за плащане'),(80,3,'Ödeme Yöntem raporu'),(81,1,'Taxes'),(81,2,'Данъци'),(81,3,'Vergiler'),(82,1,'Discounts'),(82,2,'Отстъпки'),(82,3,'Indirimler'),(83,1,'Coupons'),(83,2,'Промо продукти'),(83,3,'Kuponlar'),(84,1,'Shipping Modules'),(84,2,'Модули за доставка'),(84,3,'Gönderim Modüllleri'),(85,1,'Currencies'),(85,2,'Валути'),(85,3,'Para Birimi'),(86,1,'Sales By Country Report'),(86,2,'Доклад продажни по дръжави'),(86,3,'Ülke Satış raporu'),(87,1,'Store Owner'),(87,2,'За магазина'),(87,3,'Mağaza Sahibi'),(88,1,'Emails'),(88,2,'Имейли'),(88,3,'Emailler'),(89,1,'Security'),(89,2,'Сигурност'),(89,3,'Güvenlik'),(90,1,'SEO'),(90,2,'Оптимизация за търсачки'),(90,3,'SEO'),(91,1,'Localization'),(91,2,'Локализация'),(91,3,'Lokalizasyon'),(92,1,'General Options'),(92,2,'Настройки'),(92,3,'Genel Seçenekler'),(93,1,'Emails'),(93,2,'Имейли'),(93,3,'Emailler'),(94,1,'Security'),(94,2,'Сигурност'),(94,3,'Güvenlik'),(95,1,'SEO'),(95,2,'Оптимизация за търсачки'),(95,3,'SEO'),(96,1,'Localization'),(96,2,'Локализация'),(96,3,'Lokalizasyon'),(97,1,'General Options'),(97,2,'Настройки'),(97,3,'Genel Seçenekler'),(98,1,'Store Owner'),(98,2,'За магазина'),(98,3,'Mağaza Sahibi'),(99,1,'Security'),(99,2,'Сигурност'),(99,3,'Güvenlik'),(100,1,'SEO'),(100,2,'Оптимизация за търсачки'),(100,3,'SEO'),(101,1,'Localization'),(101,2,'Локализация'),(101,3,'Lokalizasyon'),(102,1,'General Options'),(102,2,'Настройки'),(102,3,'Genel Seçenekler'),(103,1,'Store Owner'),(103,2,'За магазина'),(103,3,'Mağaza Sahibi'),(104,1,'Emails'),(104,2,'Имейли'),(104,3,'Emailler'),(105,1,'SEO'),(105,2,'Оптимизация за търсачки'),(105,3,'SEO'),(106,1,'Localization'),(106,2,'Локализация'),(106,3,'Lokalizasyon'),(107,1,'General Options'),(107,2,'Настройки'),(107,3,'Genel Seçenekler'),(108,1,'Store Owner'),(108,2,'За магазина'),(108,3,'Mağaza Sahibi'),(109,1,'Emails'),(109,2,'Имейли'),(109,3,'Emailler'),(110,1,'Security'),(110,2,'Сигурност'),(110,3,'Güvenlik'),(111,1,'Localization'),(111,2,'Локализация'),(111,3,'Lokalizasyon'),(112,1,'General Options'),(112,2,'Настройки'),(112,3,'Genel Seçenekler'),(113,1,'Store Owner'),(113,2,'За магазина'),(113,3,'Mağaza Sahibi'),(114,1,'Emails'),(114,2,'Имейли'),(114,3,'Emailler'),(115,1,'Security'),(115,2,'Сигурност'),(115,3,'Güvenlik'),(116,1,'SEO'),(116,2,'Оптимизация за търсачки'),(116,3,'SEO'),(117,1,'Products'),(117,2,'Продукти'),(117,3,'Ürünler'),(118,1,'Orders'),(118,2,'Поръчки'),(118,3,'Siparişler'),(119,1,'Order Statuses Report'),(119,2,'Доклад статуси на поръчки'),(119,3,'Sipariş Durum raporu'),(120,1,'States'),(120,2,'Щати'),(120,3,'Şehirler'),(121,1,'Shipping Zones'),(121,2,'Зони за доставка'),(121,3,'Gönderim Bölgeleri'),(122,1,'Sales By Country Report'),(122,2,'Доклад продажни по дръжави'),(122,3,'Ülke Satış raporu'),(123,1,'Customer Countries Report'),(123,2,'Доклад държави на клиенти'),(123,3,'Müşteri Ülke raporu'),(124,1,'Countries'),(124,2,'Държави'),(124,3,'Ülkeler'),(125,1,'Shipping Zones'),(125,2,'Зони за доставка'),(125,3,'Gönderim Bölgeleri'),(126,1,'Products'),(126,2,'Продукти'),(126,3,'Ürünler'),(127,1,'Taxes Report'),(127,2,'Доклад за данъци'),(127,3,'Vergi raporu'),(128,1,'Taxes'),(128,2,'Данъци'),(128,3,'Vergiler'),(129,1,'Taxes'),(129,2,'Данъци'),(129,3,'Vergiler'),(130,1,'Taxes'),(130,2,'Данъци'),(130,3,'Vergiler'),(131,1,'Shipping Zones'),(131,2,'Зони за доставка'),(131,3,'Gönderim Bölgeleri'),(132,1,'Shipping Modules'),(132,2,'Модули за доставка'),(132,3,'Gönderim Modüllleri'),(133,1,'Shipping Methods And Costs Report'),(133,2,'Доклад методи за доставка и такси'),(133,3,'Gönderim Metotları ve Ücret Raporu'),(134,1,'Sales By Country Report'),(134,2,'Доклад продажни по дръжави'),(134,3,'Ülke Satış raporu'),(135,1,'Customer Countries Report'),(135,2,'Доклад държави на клиенти'),(135,3,'Müşteri Ülke raporu'),(136,1,'Sales By Country Report'),(136,2,'Доклад продажни по дръжави'),(136,3,'Ülke Satış raporu'),(137,1,'Customer Countries Report'),(137,2,'Доклад държави на клиенти'),(137,3,'Müşteri Ülke raporu'),(138,1,'Currency Rate Modules'),(138,2,'Модули за валутни курсове'),(138,3,'Para Birimi Sınıflandırma Modülleri'),(139,1,'Sales By Country Report'),(139,2,'Доклад продажни по дръжави'),(139,3,'Ülke Satış raporu'),(140,1,'Customer Countries Report'),(140,2,'Доклад държави на клиенти'),(140,3,'Müşteri Ülke raporu'),(141,1,'Home'),(141,2,'Начало'),(141,3,'Anasayfa'),(142,1,'Home'),(142,2,'Начало'),(142,3,'Anasayfa'),(143,1,'Home'),(143,2,'Начало'),(143,3,'Anasayfa'),(144,1,'Home'),(144,2,'Начало'),(144,3,'Anasayfa'),(145,1,'Products'),(145,2,'Продукти'),(145,3,'Ürünler'),(146,1,'Orders'),(146,2,'Поръчки'),(146,3,'Siparişler'),(147,1,'Home'),(147,2,'Начало'),(147,3,'Anasayfa');
/*!40000 ALTER TABLE `AdminQuickLinksML` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CMSBoxes` WRITE;
/*!40000 ALTER TABLE `CMSBoxes` DISABLE KEYS */;
INSERT INTO `CMSBoxes` VALUES (1,8,1,2,'Bestsellers',1),(2,13,1,2,'Login',1),(3,7,1,2,'Categories',1),(4,9,1,2,'Manufacturers',1),(5,12,1,2,'View Cart',1),(6,11,1,2,'Search',1),(7,10,1,2,'News',1),(8,22,1,2,'Currencies',1),(9,35,1,2,'Recently viewed',1),(10,36,1,1,'Setup Wizard',1),(11,39,1,2,'New Products',1),(12,14,2,2,'Custom Menu',1),(13,48,1,2,'Dropdown Categories',1),(14,58,1,2,'Product Attributes Filter',1),(15,61,1,2,'Compare Products',1),(16,73,4,2,'Newsletter',1);
/*!40000 ALTER TABLE `CMSBoxes` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CMSBoxOptions` WRITE;
/*!40000 ALTER TABLE `CMSBoxOptions` DISABLE KEYS */;
INSERT INTO `CMSBoxOptions` VALUES (1,1,'BestsellersDays','365'),(2,1,'BestsellersCount','3'),(3,1,'BestsellersListBy','NumberOfItemsSold'),(4,4,'ManufacturersCount','7'),(5,9,'RecentlyViewedProductsCount','3'),(6,11,'NewProductsBoxProductsCount','3');
/*!40000 ALTER TABLE `CMSBoxOptions` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CMSBoxOptionsML` WRITE;
/*!40000 ALTER TABLE `CMSBoxOptionsML` DISABLE KEYS */;
/*!40000 ALTER TABLE `CMSBoxOptionsML` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CMSDynamicPages` WRITE;
/*!40000 ALTER TABLE `CMSDynamicPages` DISABLE KEYS */;
INSERT INTO `CMSDynamicPages` VALUES (1,10,'Home','index.php',1),(2,10,'Categories','categories.php',1),(3,10,'Product Details','product.php',1),(4,10,'View Cart','cart.php',1),(5,10,'Manufacturers','manufacturers.php',1),(6,10,'Search','search.php',1),(7,10,'Forms','form.php',1),(8,10,'Login','login.php',1),(9,10,'Forgotten Password','forgot_pass.php',1),(10,10,'Registration','register.php',1),(11,10,'Customer Profile','profile.php',1),(12,10,'Orders','orders.php',1),(13,10,'Order Details','view_order.php',1),(14,10,'Checkout Success','checkout_final.php?success',1),(15,10,'Checkout Pending','checkout_final.php?pending',1),(16,10,'Checkout Failure','checkout_final.php?failure',1),(17,10,'Gallery','gallery.php',1),(18,10,'Product Comparison','module.php?ModuleName=com.summercart.productcomparison',1),(19,10,'Newsletter','module.php?ModuleName=com.summercart.newsletter',1),(20,10,'Wishlist','module.php?ModuleName=com.summercart.wishlist',1),(21,10,'Points','points.php',1),(22,10,'News','module.php?ModuleName=com.summercart.news',1);
/*!40000 ALTER TABLE `CMSDynamicPages` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CMSDynamicPagesML` WRITE;
/*!40000 ALTER TABLE `CMSDynamicPagesML` DISABLE KEYS */;
INSERT INTO `CMSDynamicPagesML` VALUES (1,1,'Home','','',''),(1,2,'Начало','','',''),(1,3,'Anasayfa','','',''),(2,1,'Category','','',''),(2,2,'Категория','','',''),(2,3,'Kategoriler','','',''),(3,1,'Product Details','','',''),(3,2,'Детайли за продукт','','',''),(3,3,'Ürün Detayları','','',''),(4,1,'View Cart','','',''),(4,2,'В количката','','',''),(4,3,'Sepetim','','',''),(5,1,'Manufacturers','','',''),(5,2,'Производители','','',''),(5,3,'Üreticiler','','',''),(6,1,'Search','','',''),(6,2,'Търсене','','',''),(6,3,'Arama','','',''),(7,1,'Form','','',''),(7,2,'Формуляр','','',''),(7,3,'Formlar','','',''),(8,1,'Login','','',''),(8,2,'Вход','','',''),(8,3,'Giriş','','',''),(9,1,'Forgotten Password','','',''),(9,2,'Забравена парола','','',''),(9,3,'Parolamı Unuttum','','',''),(10,1,'Registration','','',''),(10,2,'Регистрация','','',''),(10,3,'Kayıt','','',''),(11,1,'Customer Profile','','',''),(11,2,'Профил на клиента','','',''),(11,3,'Müşteri Profili','','',''),(12,1,'Orders','','',''),(12,2,'Поръчки','','',''),(12,3,'Siparişler','','',''),(13,1,'Order Details','','',''),(13,2,'Детайли за поръчка','','',''),(13,3,'Sipariş Detayları','','',''),(14,1,'Checkout Success','','',''),(14,2,'Успешна поръчка','','',''),(14,3,'Ödeme İşlemi Başarılı','','',''),(15,1,'Checkout Pending','','',''),(15,2,'Чакаща поръчка','','',''),(15,3,'Ödeme İşlemi Bekliyor','','',''),(16,1,'Checkout Failure','','',''),(16,2,'Неуспешна поръчка','','',''),(16,3,'Ödeme Hatası','','',''),(17,1,'Gallery','','',''),(17,2,'Галерия','','',''),(17,3,'Resim Galerisi','','',''),(18,1,'Product Comparison','','',''),(18,2,'Сравнение на продукти','','',''),(18,3,'Ürün Karşılaştırma','','',''),(19,1,'Newsletter','','',''),(19,2,'Бюлетин','','',''),(19,3,'Bültenler','','',''),(20,1,'Wishlist','','',''),(20,2,'Списък с желания','','',''),(20,3,'İstek Listesi','','',''),(21,1,'Points','','',''),(21,2,'Точки','','',''),(21,3,'Puan','','',''),(22,1,'News','','',''),(22,2,'Новини','','',''),(22,3,'Haber','','','');
/*!40000 ALTER TABLE `CMSDynamicPagesML` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CMSDynamicPageAreas` WRITE;
/*!40000 ALTER TABLE `CMSDynamicPageAreas` DISABLE KEYS */;
INSERT INTO `CMSDynamicPageAreas` VALUES (1,1,'Top Area','TOP'),(2,1,'Bottom Area','BOTTOM'),(3,2,'Top Area','TOP'),(4,2,'Bottom Area','BOTTOM'),(5,3,'Top Area','TOP'),(6,3,'Bottom Area','BOTTOM'),(7,4,'Top Area','TOP'),(8,4,'Bottom Area','BOTTOM'),(9,5,'Top Area','TOP'),(10,5,'Bottom Area','BOTTOM'),(11,6,'Top Area','TOP'),(12,6,'Bottom Area','BOTTOM'),(13,7,'Top Area','TOP'),(14,7,'Bottom Area','BOTTOM'),(15,8,'Top Area','TOP'),(16,8,'Bottom Area','BOTTOM'),(17,9,'Top Area','TOP'),(18,9,'Bottom Area','BOTTOM'),(19,10,'Top Area','TOP'),(20,10,'Bottom Area','BOTTOM'),(21,11,'Top Area','TOP'),(22,11,'Bottom Area','BOTTOM'),(23,12,'Top Area','TOP'),(24,12,'Bottom Area','BOTTOM'),(25,13,'Top Area','TOP'),(26,13,'Bottom Area','BOTTOM'),(27,14,'Top Area','TOP'),(28,14,'Bottom Area','BOTTOM'),(29,15,'Top Area','TOP'),(30,15,'Bottom Area','BOTTOM'),(31,16,'Top Area','TOP'),(32,16,'Bottom Area','BOTTOM'),(33,17,'Top Area','TOP'),(34,17,'Bottom Area','BOTTOM'),(35,18,'Top Area','TOP'),(36,18,'Bottom Area','BOTTOM'),(37,19,'Top Area','TOP'),(38,19,'Bottom Area','BOTTOM'),(39,20,'Top Area','TOP'),(40,20,'Bottom Area','BOTTOM'),(41,21,'Top Area','TOP'),(42,21,'Bottom Area','BOTTOM');
/*!40000 ALTER TABLE `CMSDynamicPageAreas` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CMSDynamicPageAreasML` WRITE;
/*!40000 ALTER TABLE `CMSDynamicPageAreasML` DISABLE KEYS */;
INSERT INTO `CMSDynamicPageAreasML` VALUES (1,1,''),(1,2,''),(1,3,''),(2,1,''),(2,2,''),(2,3,''),(3,1,''),(3,2,''),(3,3,''),(4,1,''),(4,2,''),(4,3,''),(5,1,''),(5,2,''),(5,3,''),(6,1,''),(6,2,''),(6,3,''),(7,1,''),(7,2,''),(7,3,''),(8,1,''),(8,2,''),(8,3,''),(9,1,''),(9,2,''),(9,3,''),(10,1,''),(10,2,''),(10,3,''),(11,1,''),(11,2,''),(11,3,''),(12,1,''),(12,2,''),(12,3,''),(13,1,''),(13,2,''),(13,3,''),(14,1,''),(14,2,''),(14,3,''),(15,1,''),(15,2,''),(15,3,''),(16,1,''),(16,2,''),(16,3,''),(17,1,''),(17,2,''),(17,3,''),(18,1,''),(18,2,''),(18,3,''),(19,1,''),(19,2,''),(19,3,''),(20,1,''),(20,2,''),(20,3,''),(21,1,''),(21,2,''),(21,3,''),(22,1,''),(22,2,''),(22,3,''),(23,1,''),(23,2,''),(23,3,''),(24,1,''),(24,2,''),(24,3,''),(25,1,''),(25,2,''),(25,3,''),(26,1,''),(26,2,''),(26,3,''),(27,1,''),(27,2,''),(27,3,''),(28,1,''),(28,2,''),(28,3,''),(29,1,''),(29,2,''),(29,3,''),(30,1,''),(30,2,''),(30,3,''),(31,1,''),(31,2,''),(31,3,''),(32,1,''),(32,2,''),(32,3,''),(33,1,''),(33,2,''),(33,3,''),(34,1,''),(34,2,''),(34,3,''),(35,1,''),(35,2,''),(35,3,''),(36,1,''),(36,2,''),(36,3,''),(37,1,''),(37,2,''),(37,3,''),(38,1,''),(38,2,''),(38,3,''),(39,1,''),(39,2,''),(39,3,''),(40,1,''),(40,2,''),(40,3,''),(41,1,''),(41,2,''),(41,3,''),(42,1,''),(42,2,''),(42,3,'');
/*!40000 ALTER TABLE `CMSDynamicPageAreasML` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CMSForms` WRITE;
/*!40000 ALTER TABLE `CMSForms` DISABLE KEYS */;
INSERT INTO `CMSForms` VALUES (1,'Contact','',1),(2,'Return merchandise authorization','returns@example.com',0);
/*!40000 ALTER TABLE `CMSForms` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CMSFormsML` WRITE;
/*!40000 ALTER TABLE `CMSFormsML` DISABLE KEYS */;
INSERT INTO `CMSFormsML` VALUES (1,1,'Contact','Please contact us via the form below.','Thank you. Your message has been received. We will contact you as soon as possible.',''),(1,2,'Контакт','Може да се свържете с нас чрез формуляра по-долу.','Благодаря. Вашето съобщение е прието. Ще се свържем с Вас възможно най-скоро.',''),(1,3,'İletişim','Lütfen aşağıdaki form aracılığıyla bize ulaşın.','Teşekkür ederiz. İletiniz alındı. En kısa zamanda sizinle temasa geçeğiz.',''),(2,1,'Return merchandise','Please use the this form to request return merchandise authorization.','Thank you. Your request has been received. You will be contacted shortly.',''),(2,2,'Рекламации','Моля ползвайте този формуляр, за да поискате рекламация.','Благодаря. Вашата заявка бе приета успешно. Ще се свържем с Вас възможно най-скоро.',''),(2,3,'İade Talebi','İade Talepleriniz İçin Lütfen Bu Formu Kullanınız.','Talebiniz tarafımıza ulaştı, en kısa zamanda sizinle kontak kurulacaktır. Teşekkür Ederiz.','');
/*!40000 ALTER TABLE `CMSFormsML` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CMSFormItems` WRITE;
/*!40000 ALTER TABLE `CMSFormItems` DISABLE KEYS */;
INSERT INTO `CMSFormItems` VALUES (1,1,1,'',1,1,1),(2,1,6,'',1,1,2),(3,1,1,'',1,1,3),(4,1,2,'',1,1,4),(5,2,1,'',1,1,1),(6,2,6,'',1,1,2),(7,2,1,'',1,1,3),(8,2,1,'',1,1,4),(9,2,1,'',1,1,5),(10,2,1,'',1,1,6),(11,2,1,'',1,1,7),(12,2,9,'',1,1,8),(13,2,8,'',1,1,9),(14,2,1,'',1,1,10),(15,2,5,'',1,1,11),(16,2,4,'',1,1,12),(17,2,2,'',1,1,13),(18,2,12,'',1,1,14);
/*!40000 ALTER TABLE `CMSFormItems` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CMSFormItemsML` WRITE;
/*!40000 ALTER TABLE `CMSFormItemsML` DISABLE KEYS */;
INSERT INTO `CMSFormItemsML` VALUES (1,1,'Your Name',''),(1,2,'Вашето име',''),(1,3,'Adınız',''),(2,1,'E-mail',''),(2,2,'E-mail',''),(2,3,'E-Mail',''),(3,1,'Subject',''),(3,2,'Тема',''),(3,3,'Konu',''),(4,1,'Message',''),(4,2,'Съобщение',''),(4,3,'Mesaj',''),(5,1,'Your Name',''),(5,2,'Вашето име',''),(5,3,'İsminiz',''),(6,1,'E-mail',''),(6,2,'E-mail',''),(6,3,'E-Mail',''),(7,1,'Phone',''),(7,2,'Телефон',''),(7,3,'Telefon',''),(8,1,'Company',''),(8,2,'Фирма',''),(8,3,'Firma İsmi',''),(9,1,'Address',''),(9,2,'Адрес',''),(9,3,'Adres',''),(10,1,'Address (cont.)',''),(10,2,'Адрес (продължение)',''),(10,3,'İkincil Adres',''),(11,1,'City',''),(11,2,'Град',''),(11,3,'Şehir',''),(12,1,'State',''),(12,2,'Област',''),(12,3,'Devlet',''),(13,1,'Country',''),(13,2,'Държава',''),(13,3,'Ülke',''),(14,1,'Post Code',''),(14,2,'Пощенски код',''),(14,3,'Posta Kodu',''),(15,1,'Reason',''),(15,2,'Причина',''),(15,3,'İade Sebebi',''),(16,1,'Has the item been opened?',''),(16,2,'Стоката отваряна ли е?',''),(16,3,'Ürün paketi açıldı mı?',''),(17,1,'Returned Merchandise',''),(17,2,'Стока, която се връща',''),(17,3,'İade hakkında mağazaya açıklama',''),(18,1,'Attachment',''),(18,2,'Прикачен файл',''),(18,3,'Dosya','');
/*!40000 ALTER TABLE `CMSFormItemsML` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CMSFormItemValues` WRITE;
/*!40000 ALTER TABLE `CMSFormItemValues` DISABLE KEYS */;
INSERT INTO `CMSFormItemValues` VALUES (1,15),(2,15),(3,15),(4,15),(5,16),(6,16);
/*!40000 ALTER TABLE `CMSFormItemValues` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CMSFormItemValuesML` WRITE;
/*!40000 ALTER TABLE `CMSFormItemValuesML` DISABLE KEYS */;
INSERT INTO `CMSFormItemValuesML` VALUES (1,1,'Defective'),(1,2,'Дефектна'),(1,3,'Kusurlu'),(2,1,'Damaged in Shipment'),(2,2,'Повредена при транспорта'),(2,3,'Nakliyede Hasar Görmüş'),(3,1,'Shipping Error'),(3,2,'Изпратена грешна стока'),(3,3,'Gönderim Hatası'),(4,1,'Other'),(4,2,'Друго'),(4,3,'Diğer'),(5,1,'Yes'),(5,2,'Да'),(5,3,'Evet'),(6,1,'No'),(6,2,'Не'),(6,3,'Hayır');
/*!40000 ALTER TABLE `CMSFormItemValuesML` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CMSLayouts` WRITE;
/*!40000 ALTER TABLE `CMSLayouts` DISABLE KEYS */;
INSERT INTO `CMSLayouts` VALUES (1,'Default Layout','',2,1);
/*!40000 ALTER TABLE `CMSLayouts` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CMSLayoutBoxes` WRITE;
/*!40000 ALTER TABLE `CMSLayoutBoxes` DISABLE KEYS */;
INSERT INTO `CMSLayoutBoxes` VALUES (1,13,1,1),(1,14,1,2),(1,1,1,3),(1,6,1,4),(1,7,1,5),(1,4,1,6),(1,5,3,7),(1,8,3,8),(1,15,3,9),(1,9,3,10),(1,16,3,11),(1,2,3,12),(1,11,3,13),(1,12,3,14),(1,3,3,15);
/*!40000 ALTER TABLE `CMSLayoutBoxes` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CMSMenus` WRITE;
/*!40000 ALTER TABLE `CMSMenus` DISABLE KEYS */;
INSERT INTO `CMSMenus` VALUES (1,'Fast Menu',1,1,NULL),(2,'Main',2,1,NULL),(3,'Footer',3,1,NULL),(4,'Custom Menu',0,1,12);
/*!40000 ALTER TABLE `CMSMenus` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CMSMenusML` WRITE;
/*!40000 ALTER TABLE `CMSMenusML` DISABLE KEYS */;
INSERT INTO `CMSMenusML` VALUES (1,1,'Fast Menu'),(1,2,'Бързо меню'),(1,3,'Hızlı Menü'),(2,1,'Main'),(2,2,'Главно'),(2,3,'Üst'),(3,1,'Footer'),(3,2,'Футер'),(3,3,'Sayfa dipnotu'),(4,1,'Help'),(4,2,'Помощ'),(4,3,'Yardım');
/*!40000 ALTER TABLE `CMSMenusML` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CMSMenuItems` WRITE;
/*!40000 ALTER TABLE `CMSMenuItems` DISABLE KEYS */;
INSERT INTO `CMSMenuItems` VALUES (1,1,0,'callto:1800-555-5555',NULL,NULL,NULL,NULL,0,'',0,0,1),(2,1,4,'',NULL,NULL,NULL,4,0,'',0,0,2),(3,2,4,'',NULL,NULL,NULL,1,0,'',0,0,3),(4,2,1,'',3,NULL,NULL,NULL,0,'',0,0,4),(5,2,2,'',NULL,1,NULL,NULL,0,'',0,0,5),(6,3,4,'',NULL,NULL,NULL,1,0,'',0,0,6),(7,3,2,'',NULL,2,NULL,NULL,0,'',0,0,7),(8,3,1,'',3,NULL,NULL,NULL,0,'',0,0,8),(9,3,4,'',NULL,NULL,NULL,8,0,'',0,0,9),(10,3,1,'',6,NULL,NULL,NULL,0,'',0,0,10),(11,3,4,'',NULL,NULL,NULL,10,0,'',0,0,11),(12,3,2,'',NULL,1,NULL,NULL,0,'',0,0,12),(13,3,0,'search.php?action=dmAdvancedSearch',NULL,NULL,NULL,NULL,0,'',0,0,13),(14,3,1,'',4,NULL,NULL,NULL,0,'',0,0,14),(15,3,1,'',5,NULL,NULL,NULL,0,'',0,0,15),(16,4,4,'',NULL,NULL,NULL,1,0,'',0,0,16);
/*!40000 ALTER TABLE `CMSMenuItems` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CMSMenuItemsML` WRITE;
/*!40000 ALTER TABLE `CMSMenuItemsML` DISABLE KEYS */;
INSERT INTO `CMSMenuItemsML` VALUES (1,1,'Call us'),(1,2,'Обадете се'),(1,3,'Bizi Arayın'),(2,1,'View Cart'),(2,2,'Вижте Количката'),(2,3,'Sepetim'),(3,1,'Home'),(3,2,'Начало'),(3,3,'Anasayfa'),(4,1,'About Us'),(4,2,'За Нас'),(4,3,'Hakkımızda'),(5,1,'Contact Us'),(5,2,'Контакт'),(5,3,'İletişim'),(6,1,'Home'),(6,2,'Начало'),(6,3,'Anasayfa'),(7,1,'Returns'),(7,2,'Рекламации'),(7,3,'İade İsteği'),(8,1,'About Us'),(8,2,'За Нас'),(8,3,'Hakkımızda'),(9,1,'Member Login'),(9,2,'Вход'),(9,3,'Üye Girişi'),(10,1,'F.A.Q.'),(10,2,'Чести Въпроси'),(10,3,'Sık Sorulan Sorular'),(11,1,'Register'),(11,2,'Регистрация'),(11,3,'Üye Ol'),(12,1,'Contact Us'),(12,2,'Контакт'),(12,3,'İletişim'),(13,1,'Search'),(13,2,'Търсене'),(13,3,'Arama'),(14,1,'Privacy Policy'),(14,2,'Лични Данни'),(14,3,'Gizlilik İlkesi'),(15,1,'Terms & Conditions'),(15,2,'Условия'),(15,3,'Kullanım Şartları'),(16,1,'Test Menu'),(16,2,'Тестово меню'),(16,3,'Test Menü');
/*!40000 ALTER TABLE `CMSMenuItemsML` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CMSRichTextPages` WRITE;
/*!40000 ALTER TABLE `CMSRichTextPages` DISABLE KEYS */;
INSERT INTO `CMSRichTextPages` VALUES (1,'testurl',1),(2,'',1),(3,'',1),(4,'',1),(5,'',1),(6,'',1);
/*!40000 ALTER TABLE `CMSRichTextPages` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CMSRichTextPagesML` WRITE;
/*!40000 ALTER TABLE `CMSRichTextPagesML` DISABLE KEYS */;
INSERT INTO `CMSRichTextPagesML` VALUES (1,1,'Product Replacement','Please return defective items for replacement or refund.\nIf you want to return an item please contact us for a (Return Material Authorization) RMA tracking number.\nYou will need to provide the unit\'s serial number (if applicable), your return shipping address, and a daytime telephone number.','','replacement, refund','Product replacement or refund.'),(1,2,'Замяна на продукт','Моля върнете дефектните артикули за замяна, или за да Ви върнем парите.\nАко искате да върнете артикул моля свържете се с нас, за да получите ОВА (Оторизация за връщане на артикул) проследяващ номер.\nЩе е необходимо да ни предоставите серийния номер на продукта (ако има такъв), Вашия адрес където да доставим заменената стока, и телефон за връзка.','','замяна, връщане на парите',''),(1,3,'Ürün Değişimi','Ürün Değişimi Hakkında Açıklama','','replacement, refund','Product replacement or refund.'),(2,1,'Privacy Statement','We respect your privacy.\nThis Privacy Statement informs you of our privacy practices and of the choices you can make about the way your information is collected online and how that information is used.\nThis statement is readily available on our home page and at the bottom of every web page on this site.<br/>\nWe collect and use personal information to understand your needs and interests and to serve you better.\nIn addition to the information you provide, we may also collect information during your visit\nto our website through our Automatic Data Collection Tools, which include Web beacons, cookies, embedded Web links, and other commonly used information-gathering tools.<br/>\n\nThe information we collect to understand your needs and interests helps us deliver a consistent and personalized experience. For example, we may use your information to \n<ul>\n	<li>assist you in completing a transaction or order;</li>\n	<li>communicate with you about products and services;</li>\n	<li>provide service and support;</li>\n	<li>update you on new services and benefits;</li>\n	<li>provide personalized promotional offers;</li>\n	<li>select content to be communicated to you;</li>\n</ul>','','',''),(2,2,'Защита на личните данни','Ние зачитаме Вашите лични данни.\nИскаме да Ви информираме как ползваме Вашите лични данни и как тази информация се ползва.\nТова изявление е достъпно от нашата начална страница и от най-отдолу на всяка страница на този сайт.<br/>\nНие събираме и използваме лична информация, за да разберем Вашите нужди и интереси и да Ви обслужваме по-добре.\nВ допълнение към информацията, която Вие ни предоставите, ние може така също да събираме информация по време на Вашето посещение\nна нашия сайт чрез инструменти за автоматично събиране на информация, които включват бисквитки, връзки, страници и други често ползвани инструменти за събиране на информация.<br/>\n\nИнформацията която събираме, за да разберем Вашите потребности и интереси ни помага да направим Вашето посещение последователно и персонализирано. Например, ние може да използваме Вашата информация, за да Ви: \n<ul>\n	<li>помогнем при попълване на поръчка;</li>\n	<li>информираме отностно продукти или услуги;</li>\n	<li>да предоставим услуги и поддръжка;</li>\n	<li>известим за нови услуги или други ползи;</li>\n	<li>предоставим персонализирани промоционални оферти;</li>\n	<li>изберем съдържание което да Ви бъде показано;</li>\n</ul>','','',''),(2,3,'Gizlilik Bildirimi','Bu Gizlilik Bildirimi gizlilik uygulamalarımız ve sizi bilgilendirir size bilgi ve online olarak toplanan bu bilgilerin nasıl kullanıldığı hakkında yol yapabilir seçenek.\nBu ifadeyi kolayca bizim ana sayfasında mevcuttur ve bu sitede her web sayfasının altında.<br/>\nTopladığımız ve ihtiyaçlarını ve çıkarlarını anlamak için kişisel bilgilerin kullanımı ve daha iyi hizmet vermek için.\nSağladığınız bilgilere ek olarak, biz de ziyaret sırasında bilgileri toplayabilir Web sitemizi Otomatik Veri Toplama Araçları, hangi Web işaretleri, çerezler, Web bağlantıları gömülü, ve diğer genel bilgi toplama araçları maddelerini içeren aracılığıyla.<br/>\n\nSizin ihtiyaçlarını anlamak ve ilgi toplamak bilgi bize tutarlı ve kişiselleştirilmiş bir deneyim sunmak yardımcı olur. Örneğin, bilgilerinizi de kullanabiliriz.\n<ul>\n	<li>bir işlem veya sipariş tamamlanmasında yardımcı;</li>\n	<li>ürün ve hizmetleri hakkında iletişim;</li>\n	<li>servis ve destek sağlamak;</li>\n	<li>yeni hizmet ve yararları üzerinde güncelleme;</li>\n	<li>sağlamak kişiselleştirilmiş promosyon teklifleri;</li>\n	<li>seçmek içerik iletilmelidir için;</li>\n</ul>','','',''),(3,1,'About Us','We are dedicated to offering the best customer service, excellent prices and fast deliveries.<br/>\nWe spend quality time perfecting our offerings. Thus our customers enjoy the benefits of our hard work.','','about, us','About our store'),(3,2,'За нас','Ние се целим да постигнем най-доброто обслужане на клиенти, отлични цени и бързи доставки.<br/>\nТака също ние отделяме много време, за да Ви предложим най-добрите оферти. Така Вие, нашите клиенти, може да се възползвате от най-доброто на пазара.','','за нас','За нашия магазин'),(3,3,'Hakkımızda','Müşterilerimize en iyi hizmeti vermek için dünyanın en iyi yazılımı olan Summer Cart\'ı kullanıyoruz.','','about, us','About our store'),(4,1,'Privacy Policy','This is our privacy policy.','','',''),(4,2,'Политика за личните данни','Това е нашата политика за личните данни.','','',''),(4,3,'Gizlilik İlkesi','This is our privacy policy.','','',''),(5,1,'Terms & Conditions','These are our terms & conditions.','','',''),(5,2,'Условия за ползване','Това са нашите условия за ползване.','','',''),(5,3,'Kullanım Şartları','These are our terms & conditions.','','',''),(6,1,'F.A.Q.','This is our F.A.Q.','','',''),(6,2,'Често задавани въпроси','Тук може да прочетете отговорите на често задавани въпроси.','','',''),(6,3,'Sık Sorulan Sorular','This is our F.A.Q.','','','');
/*!40000 ALTER TABLE `CMSRichTextPagesML` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CheckoutModules` WRITE;
/*!40000 ALTER TABLE `CheckoutModules` DISABLE KEYS */;
INSERT INTO `CheckoutModules` VALUES (1,20,'skins/default/modules/checkout/wizard/logo.png','Wizard Checkout',1,1),(2,19,'skins/default/modules/checkout/google/logo.png','Google Checkout',1,2),(3,49,'skins/default/modules/checkout/paypal/logo.png','PayPal Express',1,3);
/*!40000 ALTER TABLE `CheckoutModules` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CheckoutModulesML` WRITE;
/*!40000 ALTER TABLE `CheckoutModulesML` DISABLE KEYS */;
INSERT INTO `CheckoutModulesML` VALUES (1,1,'Checkout'),(1,2,'Поръчка'),(1,3,'Ödeme yap'),(2,1,'Google Checkout'),(2,2,'Google Checkout'),(2,3,'Google Checkout'),(3,1,'PayPal Express'),(3,2,'PayPal Express'),(3,3,'PayPal Express');
/*!40000 ALTER TABLE `CheckoutModulesML` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `Countries` WRITE;
/*!40000 ALTER TABLE `Countries` DISABLE KEYS */;
INSERT INTO `Countries` VALUES (1,'AF','AFG',0),(2,'AX','ALA',0),(3,'AL','ALB',0),(4,'DZ','DZA',0),(5,'AS','ASM',0),(6,'AD','AND',0),(7,'AO','AGO',0),(8,'AI','AIA',0),(9,'AQ','ATA',0),(10,'AG','ATG',0),(11,'AR','ARG',0),(12,'AM','ARM',0),(13,'AW','ABW',0),(14,'AU','AUS',0),(15,'AT','AUT',0),(16,'AZ','AZE',0),(17,'BS','BHS',0),(18,'BH','BHR',0),(19,'BD','BGD',0),(20,'BB','BRB',0),(21,'BY','BLR',0),(22,'BE','BEL',0),(23,'BZ','BLZ',0),(24,'BJ','BEN',0),(25,'BM','BMU',0),(26,'BT','BTN',0),(27,'BO','BOL',0),(28,'BA','BIH',0),(29,'BW','BWA',0),(30,'BV','BVT',0),(31,'BR','BRA',0),(32,'IO','IOT',0),(33,'BN','BRN',0),(34,'BG','BGR',0),(35,'BF','BFA',0),(36,'BI','BDI',0),(37,'KH','KHM',0),(38,'CM','CMR',0),(39,'CA','CAN',0),(40,'CV','CPV',0),(41,'KY','CYM',0),(42,'CF','CAF',0),(43,'TD','TCD',0),(44,'CL','CHL',0),(45,'CN','CHN',0),(46,'CX','CXR',0),(47,'CC','CCK',0),(48,'CO','COL',0),(49,'KM','COM',0),(50,'CG','COG',0),(51,'CD','COD',0),(52,'CK','COK',0),(53,'CR','CRI',0),(54,'CI','CIV',0),(55,'HR','HRV',0),(56,'CU','CUB',0),(57,'CY','CYP',0),(58,'CZ','CZE',0),(59,'DK','DNK',0),(60,'DJ','DJI',0),(61,'DM','DMA',0),(62,'DO','DOM',0),(63,'EC','ECU',0),(64,'EG','EGY',0),(65,'SV','SLV',0),(66,'GQ','GNQ',0),(67,'ER','ERI',0),(68,'EE','EST',0),(69,'ET','ETH',0),(70,'FK','FLK',0),(71,'FO','FRO',0),(72,'FJ','FJI',0),(73,'FI','FIN',0),(74,'FR','FRA',0),(75,'GF','GUF',0),(76,'PF','PYF',0),(77,'TF','ATF',0),(78,'GA','GAB',0),(79,'GM','GMB',0),(80,'GE','GEO',0),(81,'DE','DEU',0),(82,'GH','GHA',0),(83,'GI','GIB',0),(84,'GR','GRC',0),(85,'GL','GRL',0),(86,'GD','GRD',0),(87,'GP','GLP',0),(88,'GU','GUM',0),(89,'GT','GTM',0),(90,'GG','GGY',0),(91,'GN','GIN',0),(92,'GW','GNB',0),(93,'GY','GUY',0),(94,'HT','HTI',0),(95,'HM','HMD',0),(96,'VA','VAT',0),(97,'HN','HND',0),(98,'HK','HKG',0),(99,'HU','HUN',0),(100,'IS','ISL',0),(101,'IN','IND',0),(102,'ID','IDN',0),(103,'IR','IRN',0),(104,'IQ','IRQ',0),(105,'IE','IRL',0),(106,'IM','IMN',0),(107,'IL','ISR',0),(108,'IT','ITA',0),(109,'JM','JAM',0),(110,'JP','JPN',0),(111,'JE','JEY',0),(112,'JO','JOR',0),(113,'KZ','KAZ',0),(114,'KE','KEN',0),(115,'KI','KIR',0),(116,'KP','PRK',0),(117,'KR','KOR',0),(118,'KW','KWT',0),(119,'KG','KGZ',0),(120,'LA','LAO',0),(121,'LV','LVA',0),(122,'LB','LBN',0),(123,'LS','LSO',0),(124,'LR','LBR',0),(125,'LY','LBY',0),(126,'LI','LIE',0),(127,'LT','LTU',0),(128,'LU','LUX',0),(129,'MO','MAC',0),(130,'MK','MKD',0),(131,'MG','MDG',0),(132,'MW','MWI',0),(133,'MY','MYS',0),(134,'MV','MDV',0),(135,'ML','MLI',0),(136,'MT','MLT',0),(137,'MH','MHL',0),(138,'MQ','MTQ',0),(139,'MR','MRT',0),(140,'MU','MUS',0),(141,'YT','MYT',0),(142,'MX','MEX',0),(143,'FM','FSM',0),(144,'MD','MDA',0),(145,'MC','MCO',0),(146,'MN','MNG',0),(147,'ME','MNE',0),(148,'MS','MSR',0),(149,'MA','MAR',0),(150,'MZ','MOZ',0),(151,'MM','MMR',0),(152,'NA','NAM',0),(153,'NR','NRU',0),(154,'NP','NPL',0),(155,'NL','NLD',0),(156,'AN','ANT',0),(157,'NC','NCL',0),(158,'NZ','NZL',0),(159,'NI','NIC',0),(160,'NE','NER',0),(161,'NG','NGA',0),(162,'NU','NIU',0),(163,'NF','NFK',0),(164,'MP','MNP',0),(165,'NO','NOR',0),(166,'OM','OMN',0),(167,'PK','PAK',0),(168,'PW','PLW',0),(169,'PS','PSE',0),(170,'PA','PAN',0),(171,'PG','PNG',0),(172,'PY','PRY',0),(173,'PE','PER',0),(174,'PH','PHL',0),(175,'PN','PCN',0),(176,'PL','POL',0),(177,'PT','PRT',0),(178,'PR','PRI',0),(179,'QA','QAT',0),(180,'RE','REU',0),(181,'RO','ROU',0),(182,'RU','RUS',0),(183,'RW','RWA',0),(184,'BL','BLM',0),(185,'SH','SHN',0),(186,'KN','KNA',0),(187,'LC','LCA',0),(188,'MF','MAF',0),(189,'PM','SPM',0),(190,'VC','VCT',0),(191,'WS','WSM',0),(192,'SM','SMR',0),(193,'ST','STP',0),(194,'SA','SAU',0),(195,'SN','SEN',0),(196,'RS','SRB',0),(197,'SC','SYC',0),(198,'SL','SLE',0),(199,'SG','SGP',0),(200,'SK','SVK',0),(201,'SI','SVN',0),(202,'SB','SLB',0),(203,'SO','SOM',0),(204,'ZA','ZAF',0),(205,'GS','SGS',0),(206,'ES','ESP',0),(207,'LK','LKA',0),(208,'SD','SDN',0),(209,'SR','SUR',0),(210,'SJ','SJM',0),(211,'SZ','SWZ',0),(212,'SE','SWE',0),(213,'CH','CHE',0),(214,'SY','SYR',0),(215,'TW','TWN',0),(216,'TJ','TJK',0),(217,'TZ','TZA',0),(218,'TH','THA',0),(219,'TL','TLS',0),(220,'TG','TGO',0),(221,'TK','TKL',0),(222,'TO','TON',0),(223,'TT','TTO',0),(224,'TN','TUN',0),(225,'TR','TUR',0),(226,'TM','TKM',0),(227,'TC','TCA',0),(228,'TV','TUV',0),(229,'UG','UGA',0),(230,'UA','UKR',0),(231,'AE','ARE',0),(232,'GB','GBR',0),(233,'US','USA',0),(234,'UM','UMI',0),(235,'UY','URY',0),(236,'UZ','UZB',0),(237,'VU','VUT',0),(238,'VE','VEN',0),(239,'VN','VNM',0),(240,'VG','VGB',0),(241,'VI','VIR',0),(242,'WF','WLF',0),(243,'EH','ESH',0),(244,'YE','YEM',0),(245,'ZM','ZMB',0),(246,'ZW','ZWE',0);
/*!40000 ALTER TABLE `Countries` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CountriesML` WRITE;
/*!40000 ALTER TABLE `CountriesML` DISABLE KEYS */;
INSERT INTO `CountriesML` VALUES (1,1,'Afghanistan'),(2,1,'Åland Islands'),(3,1,'Albania'),(4,1,'Algeria'),(5,1,'American Samoa'),(6,1,'Andorra'),(7,1,'Angola'),(8,1,'Anguilla'),(9,1,'Antarctica'),(10,1,'Antigua And Barbuda'),(11,1,'Argentina'),(12,1,'Armenia'),(13,1,'Aruba'),(14,1,'Australia'),(15,1,'Austria'),(16,1,'Azerbaijan'),(17,1,'Bahamas'),(18,1,'Bahrain'),(19,1,'Bangladesh'),(20,1,'Barbados'),(21,1,'Belarus'),(22,1,'Belgium'),(23,1,'Belize'),(24,1,'Benin'),(25,1,'Bermuda'),(26,1,'Bhutan'),(27,1,'Bolivia'),(28,1,'Bosnia And Herzegovina'),(29,1,'Botswana'),(30,1,'Bouvet Island'),(31,1,'Brazil'),(32,1,'British Indian Ocean Territory'),(33,1,'Brunei Darussalam'),(34,1,'Bulgaria'),(35,1,'Burkina Faso'),(36,1,'Burundi'),(37,1,'Cambodia'),(38,1,'Cameroon'),(39,1,'Canada'),(40,1,'Cape Verde'),(41,1,'Cayman Islands'),(42,1,'Central African Republic'),(43,1,'Chad'),(44,1,'Chile'),(45,1,'China'),(46,1,'Christmas Island'),(47,1,'Cocos (keeling) Islands'),(48,1,'Colombia'),(49,1,'Comoros'),(50,1,'Congo'),(51,1,'Congo, The Democratic Republic Of The'),(52,1,'Cook Islands'),(53,1,'Costa Rica'),(54,1,'Côte d\'Ivoire'),(55,1,'Croatia'),(56,1,'Cuba'),(57,1,'Cyprus'),(58,1,'Czech Republic'),(59,1,'Denmark'),(60,1,'Djibouti'),(61,1,'Dominica'),(62,1,'Dominican Republic'),(63,1,'Ecuador'),(64,1,'Egypt'),(65,1,'El Salvador'),(66,1,'Equatorial Guinea'),(67,1,'Eritrea'),(68,1,'Estonia'),(69,1,'Ethiopia'),(70,1,'Falkland Islands (malvinas)'),(71,1,'Faroe Islands'),(72,1,'Fiji'),(73,1,'Finland'),(74,1,'France'),(75,1,'French Guiana'),(76,1,'French Polynesia'),(77,1,'French Southern Territories'),(78,1,'Gabon'),(79,1,'Gambia'),(80,1,'Georgia'),(81,1,'Germany'),(82,1,'Ghana'),(83,1,'Gibraltar'),(84,1,'Greece'),(85,1,'Greenland'),(86,1,'Grenada'),(87,1,'Guadeloupe'),(88,1,'Guam'),(89,1,'Guatemala'),(90,1,'Guernsey'),(91,1,'Guinea'),(92,1,'Guinea-bissau'),(93,1,'Guyana'),(94,1,'Haiti'),(95,1,'Heard Island And Mcdonald Islands'),(96,1,'Holy See (vatican City State)'),(97,1,'Honduras'),(98,1,'Hong Kong'),(99,1,'Hungary'),(100,1,'Iceland'),(101,1,'India'),(102,1,'Indonesia'),(103,1,'Iran, Islamic Republic Of'),(104,1,'Iraq'),(105,1,'Ireland'),(106,1,'Isle Of Man'),(107,1,'Israel'),(108,1,'Italy'),(109,1,'Jamaica'),(110,1,'Japan'),(111,1,'Jersey'),(112,1,'Jordan'),(113,1,'Kazakhstan'),(114,1,'Kenya'),(115,1,'Kiribati'),(116,1,'Korea, Democratic People\'s Republic Of'),(117,1,'Korea, Republic Of'),(118,1,'Kuwait'),(119,1,'Kyrgyzstan'),(120,1,'Lao People\'s Democratic Republic'),(121,1,'Latvia'),(122,1,'Lebanon'),(123,1,'Lesotho'),(124,1,'Liberia'),(125,1,'Libyan Arab Jamahiriya'),(126,1,'Liechtenstein'),(127,1,'Lithuania'),(128,1,'Luxembourg'),(129,1,'Macao'),(130,1,'Macedonia, The Former Yugoslav Republic Of'),(131,1,'Madagascar'),(132,1,'Malawi'),(133,1,'Malaysia'),(134,1,'Maldives'),(135,1,'Mali'),(136,1,'Malta'),(137,1,'Marshall Islands'),(138,1,'Martinique'),(139,1,'Mauritania'),(140,1,'Mauritius'),(141,1,'Mayotte'),(142,1,'Mexico'),(143,1,'Micronesia, Federated States Of'),(144,1,'Moldova, Republic Of'),(145,1,'Monaco'),(146,1,'Mongolia'),(147,1,'Montenegro'),(148,1,'Montserrat'),(149,1,'Morocco'),(150,1,'Mozambique'),(151,1,'Myanmar'),(152,1,'Namibia'),(153,1,'Nauru'),(154,1,'Nepal'),(155,1,'Netherlands'),(156,1,'Netherlands Antilles'),(157,1,'New Caledonia'),(158,1,'New Zealand'),(159,1,'Nicaragua'),(160,1,'Niger'),(161,1,'Nigeria'),(162,1,'Niue'),(163,1,'Norfolk Island'),(164,1,'Northern Mariana Islands'),(165,1,'Norway'),(166,1,'Oman'),(167,1,'Pakistan'),(168,1,'Palau'),(169,1,'Palestinian Territory, Occupied'),(170,1,'Panama'),(171,1,'Papua New Guinea'),(172,1,'Paraguay'),(173,1,'Peru'),(174,1,'Philippines'),(175,1,'Pitcairn'),(176,1,'Poland'),(177,1,'Portugal'),(178,1,'Puerto Rico'),(179,1,'Qatar'),(180,1,'Reunion'),(181,1,'Romania'),(182,1,'Russian Federation'),(183,1,'Rwanda'),(184,1,'Saint BarthÉlemy'),(185,1,'Saint Helena'),(186,1,'Saint Kitts And Nevis'),(187,1,'Saint Lucia'),(188,1,'Saint Martin'),(189,1,'Saint Pierre And Miquelon'),(190,1,'Saint Vincent And The Grenadines'),(191,1,'Samoa'),(192,1,'San Marino'),(193,1,'Sao Tome And Principe'),(194,1,'Saudi Arabia'),(195,1,'Senegal'),(196,1,'Serbia'),(197,1,'Seychelles'),(198,1,'Sierra Leone'),(199,1,'Singapore'),(200,1,'Slovakia'),(201,1,'Slovenia'),(202,1,'Solomon Islands'),(203,1,'Somalia'),(204,1,'South Africa'),(205,1,'South Georgia And The South Sandwich Islands'),(206,1,'Spain'),(207,1,'Sri Lanka'),(208,1,'Sudan'),(209,1,'Suriname'),(210,1,'Svalbard And Jan Mayen'),(211,1,'Swaziland'),(212,1,'Sweden'),(213,1,'Switzerland'),(214,1,'Syrian Arab Republic'),(215,1,'Taiwan, Province Of China'),(216,1,'Tajikistan'),(217,1,'Tanzania, United Republic Of'),(218,1,'Thailand'),(219,1,'Timor-leste'),(220,1,'Togo'),(221,1,'Tokelau'),(222,1,'Tonga'),(223,1,'Trinidad And Tobago'),(224,1,'Tunisia'),(225,1,'Turkey'),(226,1,'Turkmenistan'),(227,1,'Turks And Caicos Islands'),(228,1,'Tuvalu'),(229,1,'Uganda'),(230,1,'Ukraine'),(231,1,'United Arab Emirates'),(232,1,'United Kingdom'),(233,1,'United States'),(234,1,'United States Minor Outlying Islands'),(235,1,'Uruguay'),(236,1,'Uzbekistan'),(237,1,'Vanuatu'),(238,1,'Venezuela'),(239,1,'Viet Nam'),(240,1,'Virgin Islands, British'),(241,1,'Virgin Islands, U.S.'),(242,1,'Wallis And Futuna'),(243,1,'Western Sahara'),(244,1,'Yemen'),(245,1,'Zambia'),(246,1,'Zimbabwe'),(14,2,'Австралия'),(15,2,'Австрия'),(16,2,'Азербайджан'),(3,2,'Албания'),(4,2,'Алжир'),(5,2,'Американска Самоа'),(241,2,'Американски Вирджински острови'),(7,2,'Ангола'),(8,2,'Ангуила'),(6,2,'Андора'),(9,2,'Антарктика'),(10,2,'Антигуа и Барбуда'),(11,2,'Аржентина'),(12,2,'Армения'),(13,2,'Аруба'),(1,2,'Афганистан'),(19,2,'Бангладеш'),(20,2,'Барбадос'),(17,2,'Бахамски острови'),(18,2,'Бахрейн'),(21,2,'Беларус'),(22,2,'Белгия'),(23,2,'Белиз'),(24,2,'Бенин'),(25,2,'Бермудски острови'),(27,2,'Боливия'),(28,2,'Босна и Херцеговина'),(29,2,'Ботсуана'),(31,2,'Бразилия'),(32,2,'Британска територия в Индийски океан'),(240,2,'Британски Вирджински острови'),(33,2,'Бруней Дарусалам'),(30,2,'Буве'),(35,2,'Буркина Фасо'),(36,2,'Бурунди'),(26,2,'Бутан'),(34,2,'България'),(237,2,'Вануату'),(96,2,'Ватикана'),(232,2,'Великобритания'),(238,2,'Венецуела'),(239,2,'Виетнам'),(78,2,'Габон'),(79,2,'Гамбия'),(82,2,'Гана'),(93,2,'Гаяна'),(87,2,'Гваделупа'),(89,2,'Гватемала'),(91,2,'Гвинея'),(92,2,'Гвинея-Бисау'),(81,2,'Германия'),(83,2,'Гибралтар'),(86,2,'Гренада'),(85,2,'Гренландия'),(80,2,'Грузия'),(88,2,'Гуам'),(90,2,'Гърнси'),(84,2,'Гърция'),(59,2,'Дания'),(60,2,'Джибути'),(111,2,'Джърси'),(61,2,'Доминика'),(62,2,'Доминиканска република'),(64,2,'Египет'),(63,2,'Еквадор'),(66,2,'Екваториална Гвинея'),(67,2,'Еритрея'),(68,2,'Естония'),(69,2,'Етиопия'),(245,2,'Замбия'),(243,2,'Западна Сахара'),(246,2,'Зимбабве'),(107,2,'Израел'),(219,2,'Източен Тимор'),(101,2,'Индия'),(102,2,'Индонезия'),(104,2,'Ирак'),(103,2,'Иран'),(100,2,'Исландия'),(206,2,'Испания'),(108,2,'Италия'),(244,2,'Йемен'),(112,2,'Йордания'),(113,2,'Казахстан'),(41,2,'Каймански острови'),(37,2,'Камбоджа'),(38,2,'Камерун'),(39,2,'Канада'),(40,2,'Капо Верде'),(179,2,'Катар'),(114,2,'Кения'),(57,2,'Кипър'),(119,2,'Киргизстан'),(115,2,'Кирибати'),(45,2,'Китай'),(47,2,'Кокосови острови'),(48,2,'Колумбия'),(49,2,'Коморски острови'),(50,2,'Конго'),(51,2,'Конго, Демократична република'),(53,2,'Коста Рика'),(54,2,'Кот д\'Ивоар'),(56,2,'Куба'),(118,2,'Кувейт'),(120,2,'Лаос'),(121,2,'Латвия'),(123,2,'Лесото'),(124,2,'Либерия'),(125,2,'Либия'),(122,2,'Ливан'),(127,2,'Литва'),(126,2,'Лихтенщайн'),(128,2,'Люксембург'),(139,2,'Мавритания'),(140,2,'Мавриций'),(131,2,'Мадагаскар'),(141,2,'Майот'),(129,2,'Макао'),(130,2,'Македония'),(132,2,'Малави'),(133,2,'Малайзия'),(134,2,'Малдивски острови'),(135,2,'Мали'),(234,2,'Малки далечни острови на САЩ'),(136,2,'Малта'),(149,2,'Мароко'),(138,2,'Мартиника'),(137,2,'Маршалови острови'),(142,2,'Мексико'),(151,2,'Мианмар'),(143,2,'Микронезия'),(150,2,'Мозамбик'),(144,2,'Молдова'),(145,2,'Монако'),(146,2,'Монголия'),(148,2,'Монсерат'),(152,2,'Намибия'),(153,2,'Науру'),(154,2,'Непал'),(160,2,'Нигер'),(161,2,'Нигерия'),(159,2,'Никарагуа'),(162,2,'Ниуе'),(158,2,'Нова Зеландия'),(157,2,'Нова Каледония'),(165,2,'Норвегия'),(163,2,'Норфолк'),(231,2,'Обединени арабски емирства'),(2,2,'Оланд'),(166,2,'Оман'),(46,2,'Остров Коледа'),(106,2,'Остров Ман'),(52,2,'Острови Кук'),(95,2,'Острови Хърд и Макдоналд'),(167,2,'Пакистан'),(168,2,'Палау'),(169,2,'Палестина'),(170,2,'Панама'),(171,2,'Папуа-Нова Гвинея'),(172,2,'Парагвай'),(173,2,'Перу'),(175,2,'Питкерн'),(176,2,'Полша'),(177,2,'Португалия'),(178,2,'Пуерто Рико'),(105,2,'Република Ирландия'),(180,2,'Реюнион'),(183,2,'Руанда'),(181,2,'Румъния'),(182,2,'Русия'),(65,2,'Салвадор'),(191,2,'Самоа'),(192,2,'Сан Марино'),(193,2,'Сао Томе и Принсипи'),(194,2,'Саудитска Арабия'),(211,2,'Свазиленд'),(210,2,'Свалбард и Ян Майен'),(185,2,'Света Елена'),(116,2,'Северна Корея'),(164,2,'Северни Мариански острови'),(190,2,'Сейнт Винсент и Гренадини'),(186,2,'Сейнт Китс и Невис'),(187,2,'Сейнт Лусия'),(197,2,'Сейшелски острови'),(184,2,'Сен Бартелми'),(188,2,'Сен Мартен'),(189,2,'Сен Пиер и Микелон'),(195,2,'Сенегал'),(198,2,'Сиера Леоне'),(199,2,'Сингапур'),(214,2,'Сирия'),(200,2,'Словакия'),(201,2,'Словения'),(202,2,'Соломонови острови'),(203,2,'Сомалия'),(208,2,'Судан'),(209,2,'Суринам'),(233,2,'Съединени американски щати'),(196,2,'Сърбия'),(216,2,'Таджикистан'),(215,2,'Тайван'),(218,2,'Тайланд'),(217,2,'Танзания'),(220,2,'Того'),(221,2,'Токелау'),(222,2,'Тонга'),(223,2,'Тринидад и Тобаго'),(228,2,'Тувалу'),(224,2,'Тунис'),(226,2,'Туркменистан'),(225,2,'Турция'),(227,2,'Търкс и Кайкос'),(229,2,'Уганда'),(236,2,'Узбекистан'),(230,2,'Украйна'),(99,2,'Унгария'),(242,2,'Уолис и Футуна'),(235,2,'Уругвай'),(71,2,'Фарьорски острови'),(72,2,'Фиджи'),(174,2,'Филипини'),(73,2,'Финландия'),(70,2,'Фолклендски острови'),(74,2,'Франция'),(75,2,'Френска Гвиана'),(76,2,'Френска Полинезия'),(77,2,'Френски южни и антарктически територии'),(94,2,'Хаити'),(155,2,'Холандия'),(156,2,'Холандски Антили'),(97,2,'Хондурас'),(98,2,'Хонконг'),(55,2,'Хърватия'),(42,2,'Централноафриканска република'),(43,2,'Чад'),(147,2,'Черна гора'),(58,2,'Чехия'),(44,2,'Чили'),(213,2,'Швейцария'),(212,2,'Швеция'),(207,2,'Шри Ланка'),(205,2,'Южна Джорджия и Южни Сандвичеви острови'),(117,2,'Южна Корея'),(204,2,'Южноафриканска република'),(109,2,'Ямайка'),(110,2,'Япония'),(1,3,'Afganistan'),(2,3,'Aland Adaları'),(81,3,'Almanya'),(233,3,'Amerika Birleşik Devletleri'),(234,3,'Amerika Birleşik Devletleri, Küçük Dış Adaları'),(5,3,'Amerikan Samoası'),(6,3,'Andora'),(7,3,'Angola'),(8,3,'Anguilla'),(9,3,'Antartika'),(10,3,'Antigua ve Barbuda'),(11,3,'Arjantin'),(3,3,'Arnavutluk'),(13,3,'Aruba'),(14,3,'Avusturalya'),(15,3,'Avusturya'),(16,3,'Azerbaycan'),(17,3,'Bahamalar'),(18,3,'Bahreyn'),(19,3,'Bangladeş'),(20,3,'Barbados'),(243,3,'Batı Sahara'),(22,3,'Belçika'),(23,3,'Belize'),(24,3,'Benin'),(25,3,'Bermuda'),(21,3,'Beyaz Rusya'),(231,3,'Birleşik Arap Emirlikleri'),(27,3,'Bolivya'),(28,3,'Bosna Hersek'),(29,3,'Botsvana'),(30,3,'Bouvet Adası'),(31,3,'Brezilya'),(33,3,'Brunei Darussalam'),(34,3,'Bulgaristan'),(35,3,'Burkina Faso'),(36,3,'Burundi'),(26,3,'Butan'),(232,3,'Büyük Britanya'),(43,3,'Çad'),(41,3,'Cayman Adaları'),(83,3,'Cebelitarık'),(58,3,'Çek Cumhuriyeti'),(4,3,'Cezayir'),(60,3,'Cibuti'),(45,3,'Çin'),(47,3,'Cocos (keeling) Adaları'),(52,3,'Cook Adaları'),(59,3,'Danimarka'),(61,3,'Dominik'),(62,3,'Dominik Cumhuriyeti'),(63,3,'Ekvador'),(66,3,'Ekvator Ginesi'),(65,3,'El Salvador'),(102,3,'Endonezya'),(67,3,'Eritre'),(12,3,'Ermenistan'),(68,3,'Estonya'),(70,3,'Falkland adaları'),(71,3,'Faroe Adaları'),(149,3,'Fas'),(72,3,'Fiji'),(54,3,'Fildişi Sahilleri'),(174,3,'Filipinler'),(169,3,'Filistin Toprakları, İşgal Altındaki'),(73,3,'Finlandiya'),(74,3,'Fransa'),(77,3,'Fransız Güney Bölgeleri'),(75,3,'Fransız Guyanası'),(76,3,'Fransız Polinezyası'),(78,3,'Gabon'),(79,3,'Gambiya'),(82,3,'Gana'),(91,3,'Gine'),(92,3,'Gine-Bissau'),(86,3,'Granada'),(85,3,'Grönland'),(87,3,'Guadeloupe'),(88,3,'Guam'),(89,3,'Guatemala'),(90,3,'Guernsey'),(204,3,'Güney Afrika'),(205,3,'Güney Georgia ve Güney Sandwich Adaları'),(80,3,'Gürcistan'),(93,3,'Guyana'),(69,3,'Habeşistan'),(94,3,'Haiti'),(95,3,'Heard Adası ve McDonald Adaları'),(101,3,'Hindistan'),(55,3,'Hırvatistan'),(155,3,'Hollanda'),(156,3,'Hollanda Antilleri'),(97,3,'Honduras'),(98,3,'Hong Kong'),(32,3,'İngiliz Hint Okyanus Bölgesi'),(106,3,'Insan Adası'),(104,3,'Irak'),(103,3,'İran İslam Cumhuriyeti'),(105,3,'Irlanda'),(206,3,'Ispanya'),(107,3,'Israil'),(212,3,'Isveç'),(213,3,'Isviçre'),(108,3,'Italya'),(100,3,'Izlanda'),(109,3,'Jamaika'),(110,3,'Japonya'),(111,3,'Jersey'),(112,3,'Jordan'),(37,3,'Kamboçya'),(38,3,'Kamerun'),(39,3,'Kanada'),(147,3,'Karadağ'),(179,3,'Katar'),(113,3,'Kazakistan'),(114,3,'Kenya'),(57,3,'Kıbrıs'),(119,3,'Kırgızistan'),(115,3,'Kiribati'),(48,3,'Kolombiya'),(49,3,'Komorlar'),(50,3,'Kongo'),(51,3,'Kongo Demokratik Cumhuriyeti'),(117,3,'Kore Cumhuriyeti'),(116,3,'Kore, Demokratik Halk Cumhuriyeti'),(53,3,'Kosta Rika'),(56,3,'Küba'),(118,3,'Kuveyt'),(164,3,'Kuzey Mariana Adaları'),(120,3,'Lao Demokratik Halk Cumhuriyeti'),(121,3,'Latviya'),(122,3,'Lebanon'),(123,3,'Lesoto'),(124,3,'Liberya'),(125,3,'Libya Arap Jamahiriya'),(126,3,'Liechtenstein'),(127,3,'Litvanya'),(128,3,'Lüksemburg'),(129,3,'Macao'),(99,3,'Macaristan'),(131,3,'Madagaskar'),(130,3,'Makedonya, Eski Yugoslav Cumhuriyeti'),(132,3,'Malavi'),(134,3,'Maldivler'),(133,3,'Malezya'),(135,3,'Mali'),(136,3,'Malta'),(137,3,'Marshall Adaları'),(138,3,'Martinik'),(140,3,'Mauritius'),(141,3,'Mayotte'),(142,3,'Meksika'),(143,3,'Mikronezya, Federe Devletleri'),(64,3,'Mısır'),(146,3,'Moğolistan'),(144,3,'Moldova Cumhuriyeti'),(145,3,'Monako'),(148,3,'Montserrat'),(139,3,'Moritanya'),(150,3,'Mozambik'),(151,3,'Myanmar'),(152,3,'Namibya'),(153,3,'Nauru'),(154,3,'Nepal'),(160,3,'Nijer'),(161,3,'Nijerya'),(159,3,'Nikaragua'),(162,3,'Niue'),(46,3,'Noel Adası'),(163,3,'Norfolk Adası'),(165,3,'Norveç'),(166,3,'Oman'),(42,3,'Orta Afrika Cumhuriyeti'),(236,3,'Özbekistan'),(167,3,'Pakistan'),(168,3,'Palau'),(170,3,'Panama'),(171,3,'Papua Yeni Gine'),(172,3,'Paraguay'),(173,3,'Peru'),(175,3,'Pitcairn'),(176,3,'Polonya'),(177,3,'Portekiz'),(178,3,'Porto Riko'),(180,3,'Reunion'),(181,3,'Romanya'),(183,3,'Ruanda'),(182,3,'Rusya Federasyonu'),(191,3,'Samoa'),(184,3,'San Bartelemy'),(185,3,'San Helena'),(186,3,'San Kitts ve Nevis'),(187,3,'San Lucia'),(192,3,'San Marino'),(188,3,'San Martin'),(189,3,'San Pierre ve Mikelon'),(190,3,'San Vincent ve Grenadinler'),(193,3,'Sao Tome And Principe'),(195,3,'Senegal'),(197,3,'Seyşeller'),(198,3,'Sierra Leone'),(44,3,'Şili'),(199,3,'Singapur'),(196,3,'Sırbistan'),(200,3,'Slovakya'),(201,3,'Slovenya'),(202,3,'Solomon Adaları'),(203,3,'Somali'),(207,3,'Sri Lanka'),(208,3,'Sudan'),(209,3,'Surinam'),(214,3,'Suriye Arap Cumhuriyeti'),(194,3,'Suudi Arabistan'),(210,3,'Svalbard And Jan Mayen'),(211,3,'Svaziland'),(216,3,'Tacikistan'),(217,3,'Tanzanya Cumhuriyeti'),(218,3,'Tayland'),(215,3,'Tayvan,Çin Vilayeti'),(219,3,'Timor-leste'),(220,3,'Togo'),(221,3,'Tokelau'),(222,3,'Tonga'),(223,3,'Trinidad ve Tobako'),(224,3,'Tunus'),(225,3,'Türkiye'),(226,3,'Türkmenistan'),(227,3,'Turks ve Caicos Adaları'),(228,3,'Tuvalu'),(229,3,'Uganda'),(230,3,'Ukrayna'),(235,3,'Uruguay'),(237,3,'Vanuatu'),(96,3,'Vatikan (Şehir Devleti)'),(238,3,'Venezuela'),(239,3,'Vietnam'),(241,3,'Virgin Adaları, ABD'),(240,3,'Virgin Adaları, İngiliz'),(242,3,'Wallis And Futuna'),(244,3,'Yemen'),(157,3,'Yeni Kaledonya'),(158,3,'Yeni Zelanda'),(40,3,'Yeşilburun'),(84,3,'Yunanistan'),(245,3,'Zambiya'),(246,3,'Zimbabve');
/*!40000 ALTER TABLE `CountriesML` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `Currencies` WRITE;
/*!40000 ALTER TABLE `Currencies` DISABLE KEYS */;
INSERT INTO `Currencies` VALUES (1,'USD','.',',',2,'1.0000',0,1,1),(2,'EUR','.',',',2,'0.6861',0,1,2),(3,'AUD','.',',',2,'1.1584',0,1,3),(4,'BRL','.',',',2,'1.8185',0,1,4),(5,'GBP','.',',',2,'0.5126',0,1,5),(6,'BGN','.',',',2,'1.3419',0,1,6),(7,'CAD','.',',',2,'1.0283',0,1,7),(8,'CNY','.',',',2,'7.2319',0,1,8),(9,'HRK','.',',',2,'5.0154',0,1,9),(10,'CZK','.',',',2,'17.8880',0,1,10),(11,'DKK','.',',',2,'5.1124',0,1,11),(12,'EEK','.',',',2,'10.7359',0,1,12),(13,'HKD','.',',',2,'7.8071',0,1,13),(14,'HUF','.',',',0,'177.7343',0,1,14),(15,'INR','.',',',2,'39.5500',0,1,15),(16,'ISK','.',',',0,'66.7901',0,1,16),(17,'IDR','.',',',0,'9390.0027',0,1,17),(18,'LVL','.',',',2,'0.4791',0,1,18),(19,'LTL','.',',',2,'2.3691',0,1,19),(20,'MYR','.',',',2,'3.2824',0,1,20),(21,'MXN','.',',',2,'10.9545',0,1,21),(22,'NZD','.',',',2,'1.3195',0,1,22),(23,'NOK','.',',',2,'5.5324',0,1,23),(24,'PHP','.',',',2,'41.0800',0,1,24),(25,'PLN','.',',',2,'2.4969',0,1,25),(26,'RON','.',',',2,'2.5891',0,1,26),(27,'RUB','.',',',2,'24.7035',0,1,27),(28,'SGD','.',',',2,'1.4385',0,1,28),(29,'ZAR','.',',',2,'7.1639',0,1,29),(30,'KRW','.',',',0,'953.1014',0,1,30),(31,'LKR','.',',',2,'107.9000',0,1,31),(32,'SEK','.',',',2,'6.5256',0,1,32),(33,'CHF','.',',',2,'1.0895',0,1,33),(34,'TWD','.',',',2,'32.4100',0,1,34),(35,'THB','.',',',2,'31.0141',0,1,35),(36,'TRY','.',',',2,'1.2131',0,1,36),(37,'VEF','.',',',2,'2.1446',0,1,37),(38,'JPY','.',',',0,'105.3245',0,1,38);
/*!40000 ALTER TABLE `Currencies` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CurrenciesML` WRITE;
/*!40000 ALTER TABLE `CurrenciesML` DISABLE KEYS */;
INSERT INTO `CurrenciesML` VALUES (1,1,'U.S. Dollar','$',''),(1,2,'Щатски Долар','$',''),(1,3,'Amerikan doları','$',''),(2,1,'Euro','€',''),(2,2,'Евро','€',''),(2,3,'Avro','€',''),(3,1,'Australian Dollar','$',''),(3,2,'Австралийски Долар','$',''),(3,3,'Avustralya doları','$',''),(4,1,'Brazilian Real','R$',''),(4,2,'Бразилски Реал','R$',''),(4,3,'Brezilya Reali','R$',''),(5,1,'British Pound','£',''),(5,2,'Британска Лира','£',''),(5,3,'İngiliz Poundu','£',''),(6,1,'Bulgarian Lev','','лв.'),(6,2,'Български Лев','','лв.'),(6,3,'Bulgar Levası','','лв.'),(7,1,'Canadian Dollar','','C$'),(7,2,'Кадандски Долар','','C$'),(7,3,'Kanada Doları','','C$'),(8,1,'Chinese Yuan','¥',''),(8,2,'Китайски Юан','¥',''),(8,3,'Çin Yuanı','¥',''),(9,1,'Croatian Kuna','','kn'),(9,2,'Хърватска Куна','','kn'),(9,3,'Hırvat Kunası','','kn'),(10,1,'Czech Koruna','','Kč'),(10,2,'Чешка Крона','','Kč'),(10,3,'Çek Korunası','','Kč'),(11,1,'Danish Krone','','kr'),(11,2,'Датска Крона','','kr'),(11,3,'Danimarka Kronu','','kr'),(12,1,'Estonian Kroon','','kr'),(12,2,'Естонска Крона','','kr'),(12,3,'Estonya Krunu','','kr'),(13,1,'Hong Kong Dollar','HK$',''),(13,2,'Хонг Конгски Долар','HK$',''),(13,3,'Hong Kong Doları','HK$',''),(14,1,'Hungarian Forint','','Ft'),(14,2,'Унгарски Форинт','','Ft'),(14,3,'Macar Forinti','','Ft'),(15,1,'Indian rupee','Rs.',''),(15,2,'Индийска Рупия','Rs.',''),(15,3,'Hindistan Rupisi','Rs.',''),(16,1,'Icelandic króna','','kr'),(16,2,'Исландска Крона','','kr'),(16,3,'İzlanda Kronu','','kr'),(17,1,'Indonesian Rupiah','Rp',''),(17,2,'Индонезийска Рупия','Rp',''),(17,3,'Endonezya Rupiahı','Rp',''),(18,1,'Latvian Lats','','Ls'),(18,2,'Латвийски Лат','','Ls'),(18,3,'Letonya Latı','','Ls'),(19,1,'Lithuanian Litas','','Lt'),(19,2,'Литванска Лита','','Lt'),(19,3,'Litvanya Litası','','Lt'),(20,1,'Malaysian Ringgit','RM',''),(20,2,'Малайзийски рингит','RM',''),(20,3,'Malezya Ringiti','RM',''),(21,1,'Mexican Peso','Mex$',''),(21,2,'Мексикансо Песо','Mex$',''),(21,3,'Meksika Pezosu','Mex$',''),(22,1,'New Zealand Dollar','NZ$',''),(22,2,'Новозеландски Долар','NZ$',''),(22,3,'Yeni Zelanda Doları','NZ$',''),(23,1,'Norwegian Krone','','kr'),(23,2,'Норвешка Крона','','kr'),(23,3,'Norveç Kronu','','kr'),(24,1,'Philippine Peso','','₱'),(24,2,'Филипинско Песо','','₱'),(24,3,'Filipinler Pezosu','','₱'),(25,1,'Polish złoty','',''),(25,2,'Полскa Злотa','','zł'),(25,3,'Polonya Zlotisi','','zł'),(26,1,'Romanian Leu','','L'),(26,2,'Румънска Лея','','L'),(26,3,'Romen Leyi','','L'),(27,1,'Russian Ruble','','руб'),(27,2,'Руска Рубла','','руб'),(27,3,'Rus Rublesi','','руб'),(28,1,'Singapore Dollar','S$',''),(28,2,'Сингапурски Долар','S$',''),(28,3,'Singapur Doları','S$',''),(29,1,'South African Rand','R',''),(29,2,'Южноафрикански Ранд','R',''),(29,3,'Güney Afrika Randı','R',''),(30,1,'South Korean Won','₩',''),(30,2,'Южнокорейски Вон','₩',''),(30,3,'Güney Kore Wonu','₩',''),(31,1,'Sri Lankan Rupee','Rs.',''),(31,2,'Шри Ланка Рупия','Rs.',''),(31,3,'Sri Lanka Rupisi','Rs.',''),(32,1,'Swedish Krona','','kr'),(32,2,'Шведска Крона','','kr'),(32,3,'İsveç Kronu','','kr'),(33,1,'Swiss Franc','','Fr.'),(33,2,'Швейцарски Франк','','Fr.'),(33,3,'İsviçre Frangı','','Fr.'),(34,1,'Taiwan Dollar','NT$',''),(34,2,'Тайвански Долар','NT$',''),(34,3,'Tayvan Doları','NT$',''),(35,1,'Thai Baht','฿',''),(35,2,'Тайландски Бат','฿',''),(35,3,'Tayland Bahtı','฿',''),(36,1,'Turkish New Lira','','TL'),(36,2,'Нова Турска Лира','','TL'),(36,3,'Türk Lirası','','TL'),(37,1,'Venezuelan Bolívar','','Bs.'),(37,2,'Венецуелски Боливар','','Bs.'),(37,3,'Venezuela Bolivarı','','Bs.'),(38,1,'Japanese Yen','¥',''),(38,2,'Японска Йена','¥',''),(38,3,'Japon Yeni','¥','');
/*!40000 ALTER TABLE `CurrenciesML` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CurrencyRateModules` WRITE;
/*!40000 ALTER TABLE `CurrencyRateModules` DISABLE KEYS */;
INSERT INTO `CurrencyRateModules` VALUES (1,14,'skins/default/modules/rates/ecb/logo.png','European Central Bank',1,1),(2,28,'skins/default/modules/rates/boc/logo.png','Bank of Canada',1,2),(3,29,'skins/default/modules/rates/rba/logo.png','Reserve Bank of Australia',1,3),(4,55,'skins/default/modules/rates/tcmb/logo.png','Central Bank of the Republic of Turkey',0,4);
/*!40000 ALTER TABLE `CurrencyRateModules` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CustomerGroups` WRITE;
/*!40000 ALTER TABLE `CustomerGroups` DISABLE KEYS */;
INSERT INTO `CustomerGroups` VALUES (1,1),(2,2);
/*!40000 ALTER TABLE `CustomerGroups` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CustomerGroupsML` WRITE;
/*!40000 ALTER TABLE `CustomerGroupsML` DISABLE KEYS */;
INSERT INTO `CustomerGroupsML` VALUES (1,1,'Retail'),(1,2,'На дребно'),(1,3,'Perakende satış'),(2,1,'Distributor'),(2,2,'Дистрибутор'),(2,3,'Toptan satış');
/*!40000 ALTER TABLE `CustomerGroupsML` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `Helps` WRITE;
/*!40000 ALTER TABLE `Helps` DISABLE KEYS */;
INSERT INTO `Helps` VALUES (1,'',''),(2,'orders.php',''),(3,'customers.php',''),(4,'products.php',''),(5,'option_groups.php',''),(6,'categories.php',''),(7,'manufacturers.php',''),(8,'featured_products.php',''),(9,'discounts.php',''),(10,'coupons.php',''),(11,'rich_text_pages.php',''),(12,'com.summercart.news',''),(13,'forms.php',''),(14,'menus.php',''),(15,'boxes.php',''),(16,'layouts.php',''),(17,'report.php',''),(18,'shipping_modules.php',''),(19,'payment_modules.php',''),(20,'checkout_modules.php',''),(21,'order_total_modules.php',''),(22,'currency_rate_modules.php',''),(23,'general_options.php',''),(24,'company.php',''),(25,'emails.php',''),(26,'security.php',''),(27,'seo.php',''),(28,'administrators.php',''),(29,'localization.php',''),(30,'order_statuses.php',''),(31,'countries.php',''),(32,'states.php',''),(33,'taxes.php',''),(34,'shipping_zones.php',''),(35,'languages.php',''),(36,'currencies.php','');
/*!40000 ALTER TABLE `Helps` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `HelpsML` WRITE;
/*!40000 ALTER TABLE `HelpsML` DISABLE KEYS */;
INSERT INTO `HelpsML` VALUES (1,1,''),(2,1,'<div><strong>Manage order statuses</strong></div>\n			<div>To change the statuses of multiple orders in bulk just select from drop-down menu the new applicable statuses and click on \'Update Statuses\' button.</div>\n			<div><strong>Print invoices and slips</strong></div>\n			<div>Select with check mark multiple orders and click on \'Print invoices\' button and \'Print packing slips\' button.</div>\n			<div><strong>Customize order statuses</strong></div>\n			<div>Use 10 predefined order statuses or create your own statuses.</div>\n			<div><strong>Email notifications</strong></div>\n			<div>Customers will by notified by email when you change the status of their order.</div>'),(2,2,'<div><strong>Управляване на статусите на поръчки</strong></div> <div>За да промените статусите на множество поръчки наведнъж изберете от падащото меню новите статуси и натиснете бутона \'Обновете статусите\'.</div> <div><strong>Печат на фактури и товарителници</strong></div> <div>Изберете с чек бокс множество поръчки и натиснете бутона \'Отпечатай фактури\' или бутона \'Отпечатай товарителници\'.</div> <div><strong>Ваши статуси на поръчки</strong></div> <div>Използвайте 10-те предефинирани статуси на поръчки или създайте Ваши статуси.</div> <div><strong>Email известия</strong></div> <div>Клиентите ще бъдат известени с email когато смените статуса на тяхна поръчка.</div>'),(2,3,'<div><strong>Sipariş durum Yönetimi</strong></div><div>Çoklu sipariş durumunu değiştirmek için aşağı-açılır menüden yeni durum başvurusunu seçin ve \"Durum güncelle\" yi tıklayın.</div><div><strong>Fiş ve fatura bastır</strong></div><div>Onay işaretli olançoklu siparişi seçin ve \'Fatura bastır\' ve \'Ambalaj fişlerini\' bastır butonlarına tıklayın.</div> <div><strong>Sipariş durumu özelleştir</strong></div><div>Kendi durumunu oluştur ya da hazır olan 10 adet düzeni kullan.</div><div><strong>E-posta bildirimi</strong></div><div>Sipariş durum değişikliği müşterilere e-mail aracılığıyla bildirilir.</div>'),(3,1,'<div><strong>Special discounts to valuable customers</strong></div>\n			<div>You can offer special discounts and coupons to loyal customers through \'Customers\' tab in \'Create discount\' page.</div>\n			<div><strong>View order history</strong></div>\n			<div>Order history can help you in cross-selling and upselling products to existing customers.</div>\n			<div><strong>Send email in a click</strong></div>\n			<div>Click on the customer email to open your favourite email client.</div>'),(3,2,'<div><strong>Специални отстъпки за ценни клиенти</strong></div> <div>Вие може да предложите специални отстъпки и купони на лоялни клиенти чрез таб \'Клиенти\' в страницата \'Нова отстъпка\'.</div> <div><strong>Преглед на стари поръчки</strong></div> <div>Старите поръчки могат да Ви помогнат за допълнителни продажби към текущи клиенти.</div> <div><strong>Изпратете email с един клик</strong></div> <div>Кликнете на клиентския email, за да отворите Вашия email клиент.</div>'),(3,3,'<div><strong>Özel müşteriler için indirimler</strong></div><div>Daimi müşterilerinize özel indirimler yapmak için \"Müşteriler\" sekmesinden \"İndirim Oluştur\" u kullanabilirsiniz.</div><div><strong>Sipariş geçmişini görüntüle</strong></div><div>Sipariş geçmişi mevcut müşterilere ürün satışında yardımcı olur.</div><div><strong>Tek tıkla e-posta gönder</strong></div><div>Favori e-posta istemcisi açmak için müşteri mailine tıklayın.</div>'),(4,1,'<div><strong>SKU that works for you</strong></div>\n				<div>Create a SKU (stock keeping unit) that is unique and logical to you so that you can easily handle the inventory.</div>\n				<div><strong>Hover on product images</strong></div>\n				<div>Hover the mouse on a product image and see brief description in a tooltip.</div>\n				<div><strong>Products listed in multiple categories</strong></div>\n				<div>You can add a product in multiple categories through \'Additional categories\' tab in \'Edit product\' page.</div>\n				<div><strong>100% SEO for each product</strong></div>\n				<div>Make every product page fully optimized for search engines through \'SEO\' tab in \'Edit product\' page.</div>\n				<div><strong>Image resizing</strong></div>\n				<div>Summer Cart supports image resizing and automatic thumbnail creation.</div>\n				<div><strong>Assign options to a product</strong></div>\n				<div>Activate additional options for a product through \'Options\' tab in \'Edit product\' page.</div>'),(4,2,'<div><strong>SKU което има значение за Вас</strong></div>\n				<div>Задайте SKU (артикулен номер) което е уникално и логично за Вас, за да можете лесно да управлявате инвентара.</div>\n				<div><strong>Поставете показателя върху продуктовата картинка</strong></div>\n				<div>Като преместите показателя върху продуктовата картинка ще видите кратка продуктова информация.</div>\n				<div><strong>Продукти показвани в множество категории</strong></div>\n				<div>Може да добавите продукт в множество категории чрез таб \'Допълнителни категории\' в страницата \'Edit product\'.</div>\n				<div><strong>100% SEO за всеки продукт</strong></div>\n				<div>Направете всяка продуктова страница напълно оптимизирана за търсачки чрез таб \'SEO\' в страницата \'Редактирайте продукт\'.</div>\n				<div><strong>Оразмеряване на картинки</strong></div>\n				<div>Summer Cart поддържа оразмеряване на  картинки и автоматично създаване на тъмбове (малки картинки).</div>\n				<div><strong>Добавяне на опции към продукт</strong></div>\n				<div>Добавете опции към продукта чрез таб \'Опции\' в страницата \'Редактирайте продукт\'.</div>'),(4,3,'<div><strong>SKU sizin için çalışır</strong></div><div>Kolaylıkla envanter tutabileceğiniz benzersiz ve mantıksal bir SKU (Stok birimi) oluşturun.</div><div><strong>Ürün resimlerinde gezinme</strong></div><div>Mouse\'ı ürün resminin üzerine getirdiğinizde küçük bir ipucu açıklaması görünür.</div><div><strong>Ürünler bir çok kategoride listelenir</strong></div><div>\'Kategori ekle\' sekmesindeki \'Ürün düzenle\' sayfasından biçok kategoride ürün ekleyebilirsiniz.</div><div><strong>Her ürün için 100% SEO.</strong></div><div>Ürün düzenleme sayfasındaki \'SEO\' sekmesinden, her bir ürün sayfasını arama motorlarına optimize edin.</div><div><strong>Resim Boyutlandır</strong></div><div>Summer Cart resim boyutlandırma ve otomatik küçük resim oluşturmayı destekler.</div><div><strong>Ürüne seçenekler atayın</strong></div><div>\'Ürün düzenle\'sayfasındaki \'Seçenekler\' sekmesinden ürün seçenekleri eklemeyi etkinleştirin.</div>'),(5,1,'<div><strong>Options into Option Groups</strong></div>\n				<div>A group features options of one type.</div>\n				<div><strong>Options get visible after they get assigned to products</strong></div>\n				<div>Product options get visible to customers in the Store Front only if you assign them to products.</div>\n				<div><strong>Different prices for different options</strong></div>\n				<div>The price of a product may vary depending on the options the product has. You can submit price variation for each option.</div>'),(5,2,'<div><strong>Опции в Групи Опции</strong></div>\n				<div>В една група има опции от един тип.</div>\n				<div><strong>Опциите са видими когато са закачени към продукти</strong></div>\n				<div>Продуктовите опции са видими за клиентите в магазина само след като са зададени на продукти.</div>\n				<div><strong>Различни цени за различни опции</strong></div>\n				<div>Цената на продукта може да варира в зависимост от опциите които той има. Може да зададете ценова вариация за всяка опция.</div>'),(5,3,'<div><strong>Seçenek gruplarında seçenekler</strong></div><div>Grup özellikleri tek çeşit seçenekler.</div><div><strong>Ürünlere atandıktan sonra seçenekler görülür</strong></div><div>Eğer ürünlere onları atarsanız, Ürün seçenekleri mağaza müşterilerine görünür hale gelir.</div><div><strong>Farklı çeşit için farklı fiyat</strong></div><div>Ürünün özelliklerine göre çeşitlendirilebilen ürün fiyatı. Her özellik için fiyat çeşitlendirebilirsiniz.</div>'),(6,1,'<div><strong>100% SEO for each category</strong></div>\n				<div>Make every category page fully optimized for search engines by adding SEO keywords and description.</div>\n				<div><strong>Custom layout for a category</strong></div>\n				<div>You can use one layout throughout the entire store or create a special layout for a category page.</div>\n				<div><strong>Arrange categories</strong></div>\n				<div>Arrange categories according to their priority with \'Up\' and \'Down\' buttons under \'Sort\' column.</div>'),(6,2,'<div><strong>100% SEO за всяка категория</strong></div>\n				<div>Направете всяка категорийна страница напълно оптимизирана за търсачки като добавите SEO ключови думи и описание.</div>\n				<div><strong>Различна подредба за всяка категория</strong></div>\n				<div>Може да ползвате една подредба за целия магазин или да създадете специална подредба, за дадени категорийни страници.</div>\n				<div><strong>Подредете категориите</strong></div>\n				<div>Подредете категориите според техния приоритет с бутоните \'Нагоре\' и \'Надолу\' в колона \'Сортиране\'.</div>'),(6,3,'<div><strong>Her kategori için 100% SEO</strong></div><div>Her kategori sayfasını SEO şifreleri ve açıklama ekleyerek arama motorlarına optimize edin.</div><div><strong>Kategori Özelleştir</strong></div><div>Kategoriye özel düzenleme oluşturabilir veya mağaza girişinden standart olarak düzenleyebilirsiniz.</div><div><strong>Kategori Sırala</strong></div><div>\'Sırala\' sütunundaki \'Yukarı\' ve Aşağı\' butonlarını kullanarak öncelik sırasına göre kategori sırala.</div>'),(7,1,'<div><strong>Arrange manufacturers</strong></div>\n				<div>Arrange manufacturers according to their priority with \'Up\' and \'Down\' buttons under \'Sort\' column.</div>\n				<div><strong>Show manufacturers in a location of your choice</strong></div>\n				<div>Manufacturers appear in a box in the left- or right-side column on Home page, according to your custom layout settings.</div>'),(7,2,'<div><strong>Подредете производителите</strong></div>\n				<div>Подредете производителите според техния приоритет с бутоните \'Нагори\' и \'Надолу\' в колона \'Сортиране\'.</div>\n				<div><strong>Покажи производителите на позиция по избор</strong></div>\n				<div>Производителите се показват в кутия в лявата или дясната колона на Началната страница, според вашите подредби.</div>'),(7,3,'<div><strong>Üretici Sırala.</strong></div><div>\'Sırala\' sütunundaki \'Yukarı\' ve Aşağı\' butonlarını kullanarak öncelik sırasına göre üreticileri sırala.</div><div><strong>Üreticileri seçtiğiniz lokasyonda gösterir</strong></div><div>Müşteri isteği doğrultusunda ayarlandığında, üreticiler anasayfada sağ ya da sol sütunda bir kutu içinde görünür.</div>'),(8,1,'<div><strong>Promote a product on many pages</strong></div>\n				<div>You can show a featured product on Home page as well as on multiple category pages.</div>\n				<div><strong>Special discounts on featured products</strong></div>\n				<div>You can offer special discounts on featured products through \'Products\' tab in \'Create discount\' page.</div>'),(8,2,'<div><strong>Промотирайте продукт на множество страници</strong></div>\n				<div>Може да покажете продукт на Началната страница както и произволни категорийни страници.</div>\n				<div><strong>Специални отстъпки за промо продукти</strong></div>\n				<div>Можете да предложите специални отстъпки за промо продукти чрез таб \'Продукти\' на страницата \'Нова отстъпка\'.</div>'),(8,3,'<div><strong>Bir ürünü bir çok sayfada tanıtır</strong></div><div>Özellikli bir ürünü çoklu sayfalarda olduğu gibi anasayfada da sergileyebilirsiniz.</div><div><strong>Özellikli ürünler için özel indirimler</strong></div><div>Özellikli ürünlere özel indirimleri \'İndirim Oluştur\' sayfasındaki \'ürünler\' sekmesinden oluşturabilirsiniz.</div>'),(9,1,'<div><strong>How discount goes into effect</strong></div>\n				<div>Each discount has validity period and active/inactive status. Discount becomes effective only when it has active status and the validity time comes by.</div>\n				<div><strong>Discount conditions</strong></div>\n				<div>Discount conditions are filters or restrictions you can use to shorten the list of people who receive discounts on product prices. You can apply conditions separately or in combination.</div>'),(9,2,'<div><strong>Как се активира отстъпка</strong></div>\n				<div>Всяка отстъпка има период на валидност и активен/неактивен статус. Отстъпката става ефективна само когато има активен статус и датата е в периода на валидност.</div>\n				<div><strong>Условия за отстъпка</strong></div>\n				<div>Условията за отстъпка са филтри или рестрикции, които може да ползвате, за да съкратите списъка с хора които могат да се възползват от отстъпката. Може да прилагате условията отделно или в комбинация.</div>'),(9,3,'<div><strong>İndirim nasıl yürürlüğe girer?</strong></div> <div>Her indirimin geçerlilik süresi ve aktif / pasif durumu vardır. Sadece Geçerlilik süresi (vadesi) geldiğinde ve aktif konumda olduğunda, indirim etkin olur.</div> <div><strong>İndirim koşulları</strong></div> <div> Ürün fiyatlarında indirim sahibi olan kişilerin listesini kısaltmak için İndirim koşullarını filtreleme ve kısıtlamayı kullanabilirsiniz. Ayrı ayrı ya da kombine (birleşik) koşullar uygulayabilirsiniz.</div>'),(10,1,'<div><strong>How to use coupon</strong></div>\n				<div>Create a coupon, set it\'s benefit and conditions and give the coupon code to your customers.</div>\n				<div><strong>How coupon goes into effect</strong></div>\n				<div>Each coupon has validity period and active/inactive status. Coupon becomes effective only when it has active status and the validity time comes by.</div>\n				<div><strong>Coupon conditions</strong></div>\n				<div>Coupon conditions are filters or restrictions you can use to shorten the list of people who receive the benefit of the coupon. You can apply conditions separately or in combination.</div>'),(10,2,'<div><strong>Как да ползвате купони</strong></div>\n				<div>Създайте купон, задайте неговата полза и условия и дайте купона на Вашите клиенти.</div>\n				<div><strong>Как се активира купона</strong></div>\n				<div>Всеки купон има период на валидност и активен/неактивен статус. Купона става ефективен само когато има активен статус и датата е в периода на валидност.</div>\n				<div><strong>Условия към купона</strong></div>\n				<div>Условията към купона са филтри или рестрикции, които може да ползвате, за да съкратите списъка с хора които могат да се възползват от купона. Може да прилагате условията отделно или в комбинация.</div>'),(10,3,'<div><strong>Kuponun nasıl kullanılacağı</strong></div> <div>Bir kupon oluşturun, sahip olduğu kazancı ve koşulları ayarlayın ve müşterilerinize kupunun kodunu verin.</div> <div><strong>Kupon nasıl yürürlüğe girer?</strong></div> <div>Her kuponun geçerlilik süresi ve aktif / pasif durumu var.Kupon sadece vadesi geldiğinde ve aktif durumda iken geçerli olur.</div> <div><strong>Kupon koşulları</strong></div> <div>Kupon hakkına sahip kişilerin listesini kısaltmak için Kupon koşullarını filtreleme ve kısıtlamayı kullanabilirsiniz. Ayrı ayrı ya da kombine (birleşik) koşullar uygulayabilirsiniz.</div>'),(11,1,'<div><strong>What is Rich Text page</strong></div>\n				<div>Rich Text page is a static XHTML page that contains text, graphic images, tables and links.</div>\n				<div><strong>WYSIWYG editor</strong></div>\n				<div>You can customize and create pages with no knowledge of XHTML, using the \'What You See Is What You Get\' editor. WYSIWYG allows you to add text, images, tables, links, etc.</div>\n				<div><strong>100% SEO for each page</strong></div>\n				<div>Make every page fully optimized for search engines by adding SEO keywords and description. All pages in Summer Cart are CSS based, which makes them highly search engine friendly.</div>\n				<div><strong>Links to the page</strong></div>\n				<div>When you create a page you need to insert it in a menu of your choice. This will be the access point to the new page.</div>\n				<div><strong>Custom layout for a page</strong></div>\n				<div>You can use one layout for all pages in the website or create a custom layout and apply it on some Rich Text pages.</div>'),(11,2,'<div><strong>Какво е страница с богат текст</strong></div>\n				<div>Страница с богат текст е статична XHTML страница която съдържа текст, изображения, таблици и връзки.</div>\n				<div><strong>WYSIWYG редактор</strong></div>\n				<div>Може да редактирате и създавате страници без да знаете XHTML, използвайки вградения \'What You See Is What You Get\' редактор. WYSIWYG Ви позволява да добавяте текст, картинки, таблици, връзки, други.</div>\n				<div><strong>100% SEO за всяка страница</strong></div>\n				<div>Направете всяка страница напълно оптимизирана за търсачки като добавите SEO ключови думи и описание. Всички страници в Summer Cart са CSS базирани, което ги прави лесни за парсване от търсачките.</div>\n				<div><strong>Връзки към страницата</strong></div>\n				<div>Когато създавате страница трябва да я поставите в някое меню. Така посетителите ще могат да достигат до страницата.</div>\n				<div><strong>Специална подредба за страницата</strong></div>\n				<div>Може да използвате една подредба за всички страници във Вашия сайт или да създадете специална подредба за някои страници с богат текст.</div>'),(11,3,'<div><strong>Zengin metin sayfası nedir?</strong></div> <div>Zengin metin sayfası; bağlantılar, tablolar, grafik görüntüleri içeren statik bir XHTML sayfasıdır.</div> <div><strong>WYSIWYG editörü</strong></div> <div>Gördükleriniz kavradıklarınızdır\' editörünü kullanarak, hiç XHTML bilginiz olmadan sayfalar oluşturup özelleştirebilirsiniz.</div> <div><strong>Her sayfa için %100 SEO</strong></div> <div>Arama motorları için SEO anahtar kelimeleri ve açıklama ekleyerek,her sayfayı tamamen optimize edin. Summercart\'taki tüm sayfalar CSS tabanlı olup bu da onları yüksek derecede arama motoru dostu yapar.</div> <div><strong>Sayfa bağlantıları</strong></div> <div>Seçtiğiniz bir menüye ihtiyacınız olan bir sayfayı dilediğiniz zaman ekleme. Bu yeni sayfaya erişim noktası olacaktır.</div> <div><strong>Özel sayfa düzeni</strong></div> <div>Websitesindeki tüm sayfalara tek bir düzen kullanabileceğiniz gibi, özel bir düzen oluşturup bunu bazı Zengin Metin sayfalarına uygulayabiirsiniz.</div>'),(12,1,'<div><strong>News for your store</strong></div>\n				<div>Keep your website visitors informed about hot deals, new product releases, clearance sales, discounts, special offers and more. </div>\n				<div><strong>Select date for the news</strong></div>\n				<div>News will be posted on the date you select from the calendar.</div>'),(12,2,'<div><strong>Новини за Вашия магазин</strong></div>\n				<div>Информирайте Вашите посетители за горещи оферти, нови продукти, разпродажби, отстъпки, промоции и други. </div>\n				<div><strong>Изберете дата за новината</strong></div>\n				<div>Новината ще се появи на датата която изберете от календара.</div>'),(12,3,'<div><strong>Mağazanız için haberler</strong></div> <div>Websitenizdeki ziyaretçileri, sıcak fırsatlar, yeni ürün bültenleri, açık satışlar, indirim, özel teklifler ve daha fazlası hakkında bilgilendirerek tutun.</div> <div><strong>Haberler için tarih seçimi</strong></div> <div>Haberler takvimden seçtiğiniz tarihte ilan edilecektir.</div>'),(13,1,'<div><strong>Create forms with no knowledge of XHTML</strong></div>\n				<div>You can customize and create forms with no knowledge of XHTML. Just add items into the form and submit text content.</div>\n				<div><strong>Form\'s title is visible on the website</strong></div>\n				<div>Form\'s title is visible to website visitors, form\'s name is visible to administrators only.</div>\n				<div><strong>What is \'Description\' and \'Confirm text\'</strong></div>\n				<div>In the \'Description\' field enter introductory text and politely ask website visitors to fill the form. In \'Confirm text\' write thank-you message that will appear after form is successfully submitted.</div>\n				<div><strong>11 different items types</strong></div>\n				<div>You can add as many items as you need, choosing from 11 different item types.</div>\n				<div><strong>Access the form</strong></div>\n				<div>Website visitors can access a form through its link in a menu. You need to insert the form in a menu of your choice.</div>'),(13,2,'<div><strong>Създайте формуляри без да знаете XHTML</strong></div>\n				<div>Може на променяте и създавате формуляри без XHTML знания. Просто добавете полетата във формуляра и текст с неговото описание.</div>\n				<div><strong>Заглавието на формуляра е видимо на уебсайта</strong></div>\n				<div>Заглавието на формуляра е видимо за посетителите, името на формуляра е видимо само за администраторите.</div>\n				<div><strong>Какво е \'Описание\' и \'Текст с потвърждение\'</strong></div>\n				<div>В полето \'Описание\' напишете въвеждащ текст и подкана към посетителите да попълнят формуляра. В \'Текст с потвърждение\' напишете текста който ще се покаже на потребителите след като формуляра е успешно подаден.</div>\n				<div><strong>11 различни вида полета</strong></div>\n				<div>Може да добавите колкото полета имате нужда, избирайки измежду 11 различни вида полета.</div>\n				<div><strong>Достъп до формуляра</strong></div>\n				<div>Посетителите на сайта могат да имат достъп до формуляра чрез връзка в меню. Необходимо е да поставите формуляра в някое от менютата.</div>'),(13,3,'<div><strong>XHTML bilgisi olmaksızın form oluşturma</strong></div> <div>XHTML bilgisi olmaksızın form oluşturabilir ve özelleştirebilirsiniz. Sadece forma öğeler ekleyin ve metin içeriğini gönderin.</div> <div><strong>Form başlığı websitesinde görülebilir</strong></div> <div>Website ziyaretçileri form başlığını görebilir, formun adını sadece site yöneticileri görür.</div> <div><strong>Tanımlama\' ve \'metin onaylama\' nedir</strong></div> <div>Açıklama\' alanına tanıtım metnini girin ve web site ziyaretçilerinden formu doldurmalarını isteyin(rica edin). Form başarıyla kaydedildiğinde \'metin onaylamada\' teşekkür mesajınız görünsün.</div> <div><strong>11 farklı ürün tipi</strong></div> <div>11 farklı ürün tipinden seçim yaparak, ihtiyacınız oldukça ürün(öğe) ekleyebilirsiniz.</div> <div><strong>Erişim formu</strong></div> <div>Website ziyaretçileri menüdeki bir bağlantıdan (linkten) forma erişebilirler. Seçtiğiniz bir menüye formu eklemeniz gerekir.</div>'),(14,1,'<div><strong>Customize standard menus</strong></div>\n				<div>Standard menus provide basic navigation within your website. You can easily customize any of the 3 standard menus: Fast menu, Top menu and Footer.</div>\n				<div><strong>Create new menu</strong></div>\n				<div>Create a new menu and add links, pages and/or forms in it.</div>\n				<div><strong>Menu location</strong></div>\n				<div>Custom menus get located in boxes on the website. Boxes appear in the left- or right side on the website, according to your custom layout settings.</div>\n				<div><strong>Add menu items</strong></div>\n				<div>Insert in a menu links, Rich text pages and/or forms.</div>'),(14,2,'<div><strong>Промяна на стандартните менюта</strong></div>\n				<div>Стандартните менюта предлагат базова навигация във Вашия сайт. Може лесно да промените 3-те стандартни менюта: Fast menu, Top menu и Footer.</div>\n				<div><strong>Създайте ново меню</strong></div>\n				<div>Създайте ново меню и добавете връзки, страници и/или формуляри в него.</div>\n				<div><strong>Позиция на менюто</strong></div>\n				<div>Вашите менюта се намират в кутии на уебсайта. Кутиите се появяват в лявата или дясната колона на уебсайта, според подредбите.</div>\n				<div><strong>Добавете точка в меню</strong></div>\n				<div>Може да добавяте връзки, страници с богат текст и/или формуляри като точки в меню.</div>'),(14,3,'<div><strong>Standart mennüleri özelleştirin (kişiselleştirin)</strong></div> <div>Standart menüler websitenizin içinde temel navigasyon sağlarHerhangi 3 standart menüyü kolaylıkla özelleştirebilirsiniz: Hızlı Menü, Üstbilgi ve Altbilgi.</div> <div><strong>Yeni menü oluşturma</strong></div> <div>Yeni bir menü oluşturun ve menüye bağlantılar (linkler), sayfalar ve /veya formlar ekleyin.</div> <div><strong>Menü konumlandırma</strong></div> <div>Menü özelleştirme web sitesindeki kutularda yer alır. Kutular , kişisel ayarlarınıza göre websitesinin sol ya da sağ tarafında görünür.</div> <div><strong>Menü öğeleri ekleme</strong></div> <div>Menüye bağlantılar, Zengin Metin sayfaları ve/veya formlar ekleyin.</div>'),(15,1,'<div><strong>How to use boxes</strong></div>\n				<div>If you activate a box you will show its content on the website. If you pause it, you will hide the content. All active boxes appear in \'Create layout\' and \'Edit layout\' pages in Admin Panel.</div>\n				<div><strong>Menu boxes are created automatically</strong></div>\n				<div>Whenever you create a new menu, the Summer Cart system generates a new box for it.</div>\n				<div><strong>Customize \'Bestsellers\', \'Manufacturers\' and \'Recently viewed\'</strong></div>\n				<div>You can define how many products will be shown in \'Bestsellers\' box and \'Recently viewed\' box, and how many manufacturers will be displayed in \'Manufacturers\' box.</div>'),(15,2,'<div><strong>Как да използвате кутиите</strong></div>\n				<div>Ако активирате кутия нейното съдържание ще се покаже на сайта. Ако я паузирате, ще скриете съдържанието и. Всички активни кутии се появяват в страниците \'Нова подредба\' и \'Редактирайте подредба\' в административната област.</div>\n				<div><strong>Кутиите за менюта се създават автоматично</strong></div>\n				<div>Винаги когато създадете ново меню, Summer Cart генерира нова кутия за него.</div>\n				<div><strong>Модифицирайте \'Bestsellers\', \'Manufacturers\' и \'Recently viewed\'</strong></div>\n				<div>Може да дефинирате колко продукта ще се показват в кутиите \'Bestsellers\' и \'Recently viewed\', и колко производители ще се показват в кутия \'Manufacturers\'.</div>'),(15,3,'<div><strong>Kutuların nasıl kullanıldığı</strong></div> <div>Websitesinde bir kutuyu aktive ederseniz içeriğini görürsünüz. Duraklatırsanız, içerik gizlenir. Tüm aktif kutular Yönetici panelindeki Düzenle ve Oluştur sayfalarında görünür.</div> <div><strong>Menu kutularını otomatik oluşturma</strong></div><div>Ne zaman yeni bir menü oluştursanız, Summercart sistemi onun için yeni bir kutu üretir.</div> <div><strong>Çok satanlar\' Üreticiler ve Son İzlenenler özelleştirme (müşteri isteğine göre)</strong></div> <div>\'Çok Satanlar\' ve \'Son görüntülenenler\' kutularında kaç ürün olduğunu, ve  \'Üreticiler\' kutusunda kaç üretici olduğunu belirleyebilirsiniz.</div>'),(16,1,'<div><strong>One layout in the website</strong></div>\n				<div>You can apply one layout throughout the website so that all pages will be organized identically and will show the same menus.</div>\n				<div><strong>Multiple layouts</strong></div>\n				<div>You can apply different layouts on some pages in the website. All category pages, Rich Text pages and Dynamic pages in the Summer Cart store may have custom layouts, created specifically for them.</div>\n				<div><strong>Create a layout with Drag-and-Drop</strong></div>\n				<div>To create a new layout just drag and drop the available boxes under Right and Left columns. \'Create layout\' and \'Edit layout\' pages show all active boxes within the store, boxes that are paused will not appear in layout settings.</div>'),(16,2,'<div><strong>Една подредба в целия сайт</strong></div>\n				<div>Може да ползвате една подредба из целия сайт и така всички страници ще бъдат организирани идентично и ще показва същите менюта.</div>\n				<div><strong>Множество подредби</strong></div>\n				<div>Може да ползвате различни подредби за някои от страниците в сайта. Всички категориини, страници с богат текст и динамични страници в Summer Cart могат да имат специални подредби, настроени специално за тях.</div>\n				<div><strong>Създайте подредба с Drag-and-Drop</strong></div>\n				<div>За да създадете подредба преместете наличните кутии в дясната или лявата колона. Страниците \'Нова подредба\' и \'Редактирайте подредба\' показват всички активни кутии в магазина, кутиите които са паузирани няма да се показват и са недостъпни за подредбите.</div>'),(16,3,'<div><strong>Bir websitesi planı</strong></div> <div>Websitesine, aynı menüleri gösteren ve tüm sayfaları aynı şekilde organize edebilecek bir düzen uygulayabilrsiniz.</div> <div><strong>Çoklu düzenleme</strong></div> <div>Websitesindeki bazı sayfalara farklı düzenlemeler uygulayabilirsiniz. Summercart taki Tüm kategori sayfaları, zengin metin sayfaları ve dinamik sayfalar özellikle kendileri için oluşturulan özel düzenlemeye sahip olabilirler.</div> <div><strong>Sürükle- bırak ile düzen oluşturma</strong></div> <div>Yeni bir düzen oluşturmak için sadece sağ ve sol sütundaki mevcut kutuları sürükle -bırak. \'Oluştur\' ve\' Düzenle \'sayfaları mağazadaki tüm aktif kutuları gösterir, durdurulmuş olanlar düzen ayarlarında görünmez.</div>'),(17,1,'<div><strong>Define scope and period of the report</strong></div>\n				<div>Manage the scope, the level of detail of the report through \'View\' drop-down menu. Manage time period through the \'Period\' options.</div>\n				<div><strong>What is \'View\'</strong></div>\n				<div>\'View\' shows the level of detail in a report. See summery results by selecting View Summery or check up data on daily, weekly, monthly, quarterly and yearly basis.</div>\n				<div><strong>What is \'Period\'</strong></div>\n				<div>\'Period\' shows data in the present and the past. Check up latest data by selecting Today or see general performance through a past period. You can also define your own time frame for the report.</div>\n				<div><strong>Bar chart</strong></div>\n				<div>Point the mouse to a bar from the chart and you will see in a tooltip info about the selected bar.</div>\n				<div><strong>Chart value</strong></div>\n				<div>Select what you want to analyze: e.g. sales figures or number of orders.</div>'),(17,2,'<div><strong>Дефинирайте обхвата и периода на отчета</strong></div>\n				<div>Управлявайте обхвата, нивото на детайли на отчета чрез падащото меню \'Вижте\'. Управлявайте времевия период чрез опциите за \'Период\'.</div>\n				<div><strong>Какво е \'Вижте\'</strong></div>\n				<div>\'Вижте\' показва нивото на детайли в отчета. Може да прегледате обобщени данни като изберете Резюме или да изберете да виждате данните на база ден, седмица, месец, три месеца или на година.</div>\n				<div><strong>Какво е \'Период\'</strong></div>\n				<div>\'Период\' задава период за данните. Прегледайте последните данни като изберете Днес или проследете резултатите за минал период. Така също може да зададете произволен времеви период за отчета.</div>\n				<div><strong>Диаграма с барове</strong></div>\n				<div>Поставете мишката върху някой бар от диаграмата и ще видите в малък прозорец информация за избрания бар.</div>\n				<div><strong>Стойност на диаграмата</strong></div>\n				<div>Изберете какво ще анализирате: например суми продажби или брой поръчки.</div>'),(17,3,'<div><strong>Rapor süresi ve kapsamını tanımlama</strong></div> <div>Görünüm\' açılır menüsü üzerinden rapor detay seviyesi, kapsamı yönetilir. \'Periyot\' seçeneği üzerinden zaman dilimi yönetilir.</div> <div><strong>Görünüm\' nedir</strong></div> <div>Görünüm\' rapor detay düzeyini gösterir. Günlük, haftalık, aylık, üç aylık ve yıllık bazda veri kontrol ederek View summery (özet görüntüle) seçeneği ile sonuçları görün.</div> <div><strong>Periyot nedir</strong></div> <div>Dönem\' şimdiki ve geçmiş verileri gösterir. Geçmiş periyot üzerinden genel performansı izlenir veya Bugün seçeneğiyle en son veriler kontrol edilir. Ayrıca rapor için kendi zaman aralığınızı (çerçevenizi) tanılayabilirsiniz.</div> <div><strong>Grafik çubuğu</strong></div> <div>Grafik çubuğunun üzerine mouse la gelince seçilmiş çubuğun üzerinde ipucubilgisi görünür.</div> <div><strong>Grafik değeri</strong></div> <div>Ne analiz etmek isterseniz seçin: satış rakamları, sipariş sayısı v.s.</div>'),(18,1,'<div><strong>Set shipping zones first</strong></div>\n				<div>Before you activate a shipping module, you need to set up shipping zones.</div>\n				<div><strong>Add a module many times</strong></div>\n				<div>You can add one module more than once if you need to apply it on multiple shipping zones.</div>\n				<div><strong>Predefined shipping costs</strong></div>\n				<div>Apply predefined shipping costs on orders – use Flat rate or Table based module to define fees. You can also use Free shipping module.</div>\n				<div><strong>Get shipping fees in real time</strong></div>\n				<div>Configure and use the modules of FedEx, USPS and/or UPS shipping companies and show to customers companies\' shipping fees in real time.</div>\n				<div><strong>Arrange sort order of active modules</strong></div>\n				<div>If you offer to customers two and more shipping methods, you can arrange their sort order with \'Up\' and \'Down\' buttons.</div>'),(18,2,'<div><strong>Първо настройте транспортните зони</strong></div>\n				<div>Преди да активирате модул за доставка е необходимо да настроите транспортни зони.</div>\n				<div><strong>Добавяне на модул повече от един път</strong></div>\n				<div>Може да добавите един модул повече от един път ако имате нужда да ползвате за множество транспортни зони.</div>\n				<div><strong>Предефинирани разходи за транспорт</strong></div>\n				<div>Може да ползвате предефинирани разходи за транспорт – използвайте Единна ставка или Базирана на таблица цена за доставка. Така също може да ползвате модул Безплатна доставка.</div>\n				<div><strong>Цени за доставка в реално време</strong></div>\n				<div>Настройте и ползвайте модулите за FedEx, USPS и/или UPS, за да изчислявате разхода за доставка в реално време директно от тези куриери.</div>\n				<div><strong>Подредете активните модули</strong></div>\n				<div>Ако предлагате на клиентите два или повече метода на доставка, може да ги подредите с бутоните \'Нагоре\' и \'Надолу\'.</div>'),(18,3,'<div><strong>Ilk nakliye alanlarını ayarlayın</strong></div><div>Nakliye modülünü aktive etmeden önce nakliye bölgelerini ayralamanız gerek.</div> <div><strong>Bir modülü birçok kez ekle</strong></div> <div>Birden fazla nakliye bölgesine ihtiyaç duyarsanız tek seferden fazla modül ekleyebilirsiniz.</div> <div><strong>Önceden tanımlanmış nakliye masrafları</strong></div> <div>Siparişlerde nakliye masraflarını önceden belirlerken, ücret tanımlaması için sabit oran veya modül tabanlı tablo kullan. Ayrıca ücretsiz nakliye modülünü de kullanabilirsiniz.</div> <div><strong>Gerçek zamanlı nakliye ücretlerini alın</strong></div> <div>Fedex, USPS ve /veya UPS nakliye firmalarının modüllerini kullanarak yapılandırılması müşterilerinize, şirketlerin gerçek zamanlı nakliye ücretlerini gösterir.</div> <div><strong>Etkin modül sıra düzenini ayarlama</strong></div> <div>Müşterilerinize 2 veya daha fazla nakliye seçeneği sundugunuzda onların sipariş sıralamasını \'Yukarı ve \'aşagı\' butonları ile düzenleyebilirsiniz.</div>'),(19,1,'<div><strong>Set up payment modules</strong></div>\n				<div>You can configure a module through its Options page.</div>\n				<div><strong>Arrange sort order of active modules</strong></div>\n				<div>If you offer to customers two and more payment methods, you can arrange their sort order with \'Up\' and \'Down\' buttons.</div>\n				<div><strong>Active modules appear on the website</strong></div>\n				<div>All active modules appear on the website provided they are successfully configured.</div>'),(19,2,'<div><strong>Настройте модулите за плащане</strong></div>\n				<div>Може да конфигурирате модул като изберете неговата страница с Опции.</div>\n				<div><strong>Подредете активните модули</strong></div>\n				<div>Ако предлагате на клиентите два или повече метода за плащане, може да ги подредите с бутоните \'Нагоре\' и \'Надолу\'.</div>\n				<div><strong>Активните модули са видими за клиентите</strong></div>\n				<div>Всички активни модули се виждат от клиентите стига да са успешно настроени.</div>'),(19,3,'<div><strong>Ödeme modül ayarı</strong></div><div>Modül Seçenekler sayfasından yapılandırılır.</div><div><strong>Etkin Modül sıra düzeni ayarı</strong></div><div>Müşterilerinize 2 veya daha fazla ödeme seçeneği sundugunuzda onların sipariş sıralamasını \'Yukarı ve \'aşagı\' butonları ile düzenleyebilirsiniz.</div> <div><strong>Etkin modüller websitesinde görünür</strong></div> <div>Tüm etkin modüllerin websitesinde görünmesi yapılandırmanın başarılı olmasını sağlar.</div>'),(20,1,'<div><strong>Set up checkout modules</strong></div>\n				<div>You can configure a module through its Options page.</div>\n				<div><strong>Arrange sort order of active modules</strong></div>\n				<div>If you offer to customers two and more checkout methods, you can arrange their sort order with \'Up\' and \'Down\' buttons.</div>\n				<div><strong>Active modules appear on the website</strong></div>\n				<div>All active modules appear on the website provided they are successfully configured.</div>'),(20,2,'<div><strong>Настройте модулите за поръчка</strong></div>\n				<div>Може да конфигурирате модул чрез страницата с Опции.</div>\n				<div><strong>Подредба на активните модули</strong></div>\n				<div>Ако предлагате на клиентите два или повече метода за поръчка, то може да ги подредите с бутоните \'Нагоре\' и \'Надолу\'.</div>\n				<div><strong>Активните модули се виждат от клиентите</strong></div>\n				<div>Всички активни модули се виждат от клиентите стига да са успешно конфигурирани.</div>'),(20,3,'<div><strong>Kasa modüllerini ayarlama</strong></div><div>Seçenekler sayfası üzerinden modül yapılandırabilirsiniz.</div><div><strong>Etkin modül sıra düzenini ayarlama</strong></div> <div>Müşterilerinize 2 veya daha fazla kasa seçeneği sundugunuzda onların sipariş sıralamasını \'Yukarı ve \'aşagı\' butonları ile düzenleyebilirsiniz.</div><div><strong>Tüm etkin modüllerin websitesinde görünmesi yapılandırmanın başarılı olmasını sağlar.</strong></div>'),(21,1,'<div><strong>Active modules appear in Store Front</strong></div>\n				<div>Active order total modules appear in the store front, on Confirm Order page during checkout.</div>'),(21,2,'<div><strong>Активните модули се взимат в предвид</strong></div>\n				<div>Активните модули за сума поръчка се взимат в предвид при изчисление на общата цена, и се виждат на страницата за потвърждение по време на поръчка.</div>'),(21,3,'<div><strong>Aktif (etkin) modüller ön bellekte görünür</strong></div> <div>Aktif toplam sipariş modülleri, checkout sırasında  ön bellekteki sipariş onay sayfasında görünür.</div>'),(22,1,'<div><strong>Set up currencies first</strong></div>\n				<div>Before you activate a module, you need to set up your currencies.</div>'),(22,2,'<div><strong>Първо настройте валутите</strong></div>\n				<div>Преди да активирате модул, е необходимо да настроите валутите.</div>'),(22,3,'<div><strong>Önce kurları ayarlama</strong></div> <div>Modülü aktive etmeden önce, kurları ayarlamanız gerek.</div>'),(23,1,'<div><strong>Automatic thumbnail generation</strong></div>\n				<div>Thumbnails will be automatically generated when you upload images.</div>\n				<div><strong>Product thumbnails</strong></div>\n				<div>Product thumbnails appear in product listings in the Store Front and Admin Panel.</div>\n				<div><strong>Manufacturer thumbnails</strong></div>\n				<div>Manufacturer thumbnails appear in the manufacturers listing in the Store Front.</div>'),(23,2,'<div><strong>Автоматична генерация на тъмбове</strong></div>\n				<div>Тъмбовете (малки картинки) ще бъдат генерирани автоматично когато качвате картинки.</div>\n				<div><strong>Продуктови тъмбове</strong></div>\n				<div>Продуктовите тъмбове се виждат в списъците с продукти както в клиентската, така и в административната област.</div>\n				<div><strong>Тъмбове на производителите</strong></div>\n				<div>Тъмбовете на производителите се ползват в списъка с производители в клиентската област.</div>'),(23,3,'<div><strong>Otomatik resim oluşturma</strong></div><div>Resim yüklediğinizde otomatik olarak küçülür.</div><div><strong>Ürün resimleri</strong></div><div>Yönetici paneli ve ön bellekteki ürün listelerinde ürün resimleri görünür.</div><div><strong>Üretici </strong></div><div>Ön bellekte üreticiler listesinde üretici resimleri görünür.</div>'),(24,1,'<div><strong>Business identity</strong></div>\n				<div>The information about store owner will be displayed in the footer of your store.</div>'),(24,2,'<div><strong>Бизнес идентичност</strong></div>\n				<div>Информацията за собственика ще бъде показвана най-отдолу на Вашия магазин.</div>'),(24,3,'<div><strong>İş Kimliği</strong></div><div>Mağaza sahibi hakkında bilgi mağazanın altbilgi kısmında görüntülenir.</div>'),(25,1,'<div><strong>Summer Cart system will notify you</strong></div>\n				<div>The system will use the emails you provide here to contact you for new orders, inquires and support questions.</div>'),(25,2,'<div><strong>Summer Cart ще Ви известява</strong></div>\n				<div>Системата ще използва email адресите, които дадете тук, за да Ви известява за нови поръчки, запитвания и въпроси от клиенти.</div>'),(25,3,'<div><strong>Summer Cart sistemi sizi uyarır</strong></div><div>Sistem, yeni siparişler, sorgulamalar ve destek soruları oldugunda  e-postalar aracılığıyla sizinle bağlantı kurar.</div>'),(26,1,'<div><strong>Secure connection</strong></div>\n				<div>Set up SSL and use secure connection between your store\'s server and your customers\' PCs. You will need SSL certificate.</div>'),(26,2,'<div><strong>Сигурни връзки</strong></div>\n				<div>Настройте SSL и използвайте сигурна връзка между сървъра на магазина и компютрите на Вашите клиенти. Ще имате нужда от SSL сертификат.</div>'),(26,3,'<div><strong>Güvenli bağlantı</strong></div><div>Mağazanız ile müşterinizin bilgisayarı arasında güvenli bağlantı kullanın ve SSL ayarlarınızı yapın. SSL sertifikasına ihtiyacınız olacak.</div>'),(27,1,'<div><strong>Site Keywords</strong></div>\n				<div>You can briefly outline what your store is selling, e.g. “online store, buy, TV, camera, game console, electronics”, don\'t miss your advantages too, e.g “free shipping, latest styles”.</div>\n				<div><strong>Site Description</strong></div>\n				<div>Describe in a sentence your store\'s specialty, it could be proactively like \'Buy from a huge selection of TVs, cameras and camcorders\' or informative like \'Online store for TVs, cameras, camcorders, game consoles and more. Free shipping.\'</div>'),(27,2,'<div><strong>Ключови думи за сайта</strong></div>\n				<div>Може накратко да кажете какво продавате, например “онлайн магазин, купи, телевизор, камера, игрова конзола, електроника”, не пропускайте Вашите предимства, например “безплатна доставка, последна мода”.</div>\n				<div><strong>Описание на сайта</strong></div>\n				<div>Опишете в едно изречение в какво се специализира Вашия магазин, може да бъде проактивно като \'Купете от огромен избор от телевизори, фотоапарати и камери\' или информативно като \'Онлайн магазин за телевизори, фотоапарати, камери, игрови конзоли и още. Безплатна доставка.\'</div>'),(27,3,'<div><strong>Site anahtar kelimeleri</strong></div><div>Mağazanızda sattıklarınızı kısaca özetleyebilirsiniz, örneğin online mağaza, satın al, tv, kamera, oyun konsolu, elektronik, fırsatları kaçırmayın, ücretsiz nakliye, son dönem trendleri v.s</div><div><strong>Site Açıklaması</strong></div><div>Mağazanızın sloganını tek cümleyle tanımlayın, \'tv, camera ve cam in en üst seçiminden satın alın\' gibi bir slogan proaktif olabilirdi veya \'tv, kamera ve cam lerinizin online mağazası. Ücretsiz nakliye\' gibi bilgilendirici bir slogan olabilirdi.</div>'),(28,1,'<div><strong>Full access</strong></div>\n				<div>Administrator with full access has full control on the Admin panel and can manage all Summer Cart sections.</div>\n				<div><strong>Limited access</strong></div>\n				<div>Administrator with limited access has limited control on the Admin panel and can manage only the sections in his/her permissions.</div>'),(28,2,'<div><strong>Пълен достъп</strong></div>\n				<div>Администратори с пълен достъп имат пълен контрол върху административната област и могат да ползват всички секции в Summer Cart.</div>\n				<div><strong>Ограничен достъп</strong></div>\n				<div>Администратори с ограничен достъп имат ограничен достъп до административната област и могат да управляват само секции за които имат позволение.</div>'),(28,3,'<div><strong>Tam erişim</strong></div><div>Yönetici , yönetici paneline erişimde tam denetime sahip oldugundan tüm Summercart bölümlerini yönetilebilir.</div> <div><strong>Sınırlı erişim</strong></div><div>Yönetici , yönetici paneline sınırlı erişimde sınırli denetime sahip oldugunda sadece onun izin verdiği bölümleri yönetilebilir.</div>'),(29,1,'<div><strong>Kilogram or pound</strong></div>\n				<div>Use the weight unit that is most familiar to your customers.</div>\n				<div>1 lb = 0.45359237 kg</div>\n				<div>1 kg = 2.20462262185 lbs</div>\n				<div><strong>Important: Change weight unit</strong></div>\n				<div>When you change weight unit, the system changes the unit without conversion. Remember to convert your products\' weight before or after you change the unit.</div>'),(29,2,'<div><strong>Килограм или фунт</strong></div>\n				<div>Използвайте единица за маса която е удобна за Вашите клиенти.</div>\n				<div>1 фунт = 0.45359237 кг</div>\n				<div>1 кг = 2.20462262185 фунта</div>\n				<div><strong>Важно: Промяна на единицата за маса</strong></div>\n				<div>Когато променяте единицата за маса, тя се променя без преизчисляване. Не забравяйте да конвертирате теглото на Вашите продукти преди или след като промените единицата.</div>'),(29,3,'<div><strong>Kilogram ya da libre (453 gr.)</strong></div> <div>Müşterileriniz arasında en popüler olan ağırlık birimini kullanın.</div> <div>1 libre= 0.45359237 kg.</div> <div>1 kg = 2.204622621 libredir</div> <div><strong>Önemli: Ağırlık birimi değiştir</strong></div><div>Ağırlık brimini değiştirdiğinizde, sistem birimi geri dönüşümsüz olarak değiştirir. Birimi değiştirdikten sonra değiştirmeden önce ürünlerinizin ağırlığını dönüştürmeyi unutmayın.</div>'),(30,1,'<div><strong>Arrange sort order</strong></div>\n				<div>Arrange the list of statuses for your convenience. You can put on top the statuses in frequent use.</div>\n				<div><strong>Create your own statuses</strong></div>\n				<div>You can create custom statuses that fit to your business and work best.</div>'),(30,2,'<div><strong>Подредба</strong></div>\n				<div>Подредете списъка със статуси така, че да са Ви удобни. Може да поставите най-отгоре статусите, които ползвате най-често.</div>\n				<div><strong>Създайте Ваши статуси</strong></div>\n				<div>Може да създадете Ваши статуси, които да пасват на Вашия бизнес и са Ви удобни.</div>'),(30,3,'<div><strong>Siperiş çeşidi düzenle</strong></div><div>Erişilebilirliğiniz için statü listeleri düzenleyin. Sık kullandıgınız statüleri en başa koyabilirsiniz.</div> <div><strong>Kendi statünüzü oluşturun</strong></div><div>İşinize en uygun ve düzgün çalışan müşteri statüsü oluşturabilirsiniz.</div>'),(31,1,'<div><strong>Full countries list</strong></div>\n				<div>Countries list appear in customer registration form, shipping and billing addresses of orders, tax zones, shipping zones and in any custom forms.</div>\n				<div><strong>Add states</strong></div>\n				<div>Use \'States\' link to add or edit regions within a country.</div>\n				<div><strong>Country code</strong></div>\n				<div>2 and 3-letter country codes are available in ISO 3166-1 code list.</div>'),(31,2,'<div><strong>Пълен списък с държави</strong></div>\n				<div>Списъци с държави има на клиентската регистрационна форма, адресите за плащане и доставка на поръчки, данъчни зони, транспортни зони и във Ваши формуляри.</div>\n				<div><strong>Добавете области</strong></div>\n				<div>Използвайте връзката \'Области\', за да добавите или редактирате региони в рамките на държава.</div>\n				<div><strong>Код на държава</strong></div>\n				<div>2 и 3-буквените кодове на държава са описани в списъка с кодове ISO 3166-1.</div>'),(31,3,'<div><strong>Tüm ülkelerin listesi</strong></div><div>Ülkeler listesi, sipariş fatura ve sevkiyat adresleri, vergi dilimleri, gönderim bölgeleri ziyaretçi kayıt formunda ve herhangi özel formda gözükür .</div><div><strong>Şehir ekle</strong></div><div>Bir ülkedeki bölgeleri düzenlemek veya eklemek için \'yerleşim yeri\' linkini kullanın.</div><div><strong>Ülke kodu</strong></div> <div>ISO 3166-1 kod listesinde 2 ve 3 harfli ülke kodları geçerlidir.</div>'),(32,1,'<div><strong>State code</strong></div>\n				<div>As code use common abbreviation or acronym of the state.</div>\n				<div><strong>States list</strong></div>\n				<div>States list appear in customer registration form, shipping and billing addresses of orders, tax zones, shipping zones and in any custom forms.</div>'),(32,2,'<div><strong>Код на област/щат</strong></div>\n				<div>Използвайте за код чест ползвано съкращение или акроним на областта/щата.</div>\n				<div><strong>Списък с области</strong></div>\n				<div>Списък с области има на клиентската регистрационна форма, адресите за плащане и доставка на поръчки, данъчни зони, транспортни зони и във Ваши формуляри.</div>'),(32,3,'<div><strong>Şehir kodu</strong></div><div>Kod olarak şehir baş harflerini ya da ortak bir kod kullanın.</div><div><strong>Şehir listesi</strong></div><div><strong>Şehirler listesi müşteri kayıt formunda görünür, siparişlerin sevkiyat ve fatura adresleri, vergi bölgeleri, sevkiyat bölgeleri be herhangi özel formlar.</div>'),(33,1,'<div><strong>Apply to visitors</strong></div>\n				<div>The unregistered visitors by default are considered to be the anonymous customer. Thus any tax that would apply to the anonymous customer will be displayed by default. You can modify the Anonymous customer country or state to your preferences.</div>'),(33,2,'<div><strong>Прилагане към посетители</strong></div>\n				<div>Нерегистрираните посетители по подразбиране се считат за анонимен клиент. Така всеки данък, който би бил приложен към анонимния клиент ще се показва по подразбиране. Може да промените държавата или областта на анонимния клиент както желаете.</div>'),(33,3,'<div><strong>Ziyaretçi başvurusu</strong></div><div>Varsayılan kayıt dışı ziyaretçiler anonim müşteri kabul edilir. Böylece varsayılan olarak görüntülenen bu vergi anonim müşteriler için de geçerli olacak. Tercihinize göre anonim müşterilerin ülke ve şehirlerini değiştirebilirsiniz.</div>'),(34,1,'<div><strong>Create a shipping zone</strong></div>\n				<div>Countries and states that use the same shipping method at the same cost should be added in one shipping zone.</div>\n				<div><strong>Shipping zone and shipping module</strong></div>\n				<div>A shipping module should be linked to a zone or apply to all everywhere.</div>\n				<div><strong>One zone for multiple shipping modules</strong></div>\n				<div>One zone can be assigned to multiple shipping modules. Through \'Shipping modules\' page add the shipping modules you need and link them separately to the zone.</div>\n				<div><strong>One shipping module with multiple zones</strong></div>\n				<div>One shipping module can not work with multiple shipping zones. But through \'Shipping modules\' page you can create the module several times and separately link each copy to a zone.</div>'),(34,2,'<div><strong>Създайте зона на доставка</strong></div>\n				<div>Държави и области които ползват същия метод за доставка на една цена би трябвало да са в една зона на доставка.</div>\n				<div><strong>Зона на доставка и модул за доставка</strong></div>\n				<div>Всеки модул за доставка трябва да бъде свързан с зона или да важи навсякъде.</div>\n				<div><strong>Една зона за множество модули за доставка</strong></div>\n				<div>Една зона може да свързана с повече от един модул за доставка. През страницата \'Модули за доставка\' добавете модулите за доставка и ги свържете към зоната.</div>\n				<div><strong>Един модул за доставка с множество зони</strong></div>\n				<div>Един модул за доставка не може да работи с множество зони. Но може да създадете много пъти един и същ модул и да свържете копията към различни зони.</div>'),(34,3,'<div><strong>Sevkiyat bölgesi oluştur</strong></div><div>Aynı ücret ve aynı sevkiyat yöntemini kullanan ülkeler ve şehirler tek bir bölgeye eklenmelidir.</div><div><strong>Sevkiyat müdülü ve bölgesi</strong></div><div>Bir sevkiyat modülü bir bölgeye bağlanmalı yada tüm her yerde geçerli olmalıdır.</div> <div><strong>Çoklu sevkiyat modülleri için tek bölge</strong></div> <div>Çoklu sevkiyat modülleri için tek bölge belirlenebilir. \'Sevkiyat modülleri\' sayfası üzerinden ihtiyacınız olan sevkiyat modülünü ekleyin ve onları bölgeye ayrı ayrı bağlantılayın.</div> <div><strong>Çoklu bölgeler için tek sevkiyat modülü</strong></div><div>Tek sevkiyat modülü çoklu sevkiyat bölgesiyle birlikte çalışmaz. Fakat \'sevkiyat modülü\' sayfası üzerinden çok sayıda modül oluşturabilir ve her koyayı bölgeye ayrı ayrı bağlayabilirsiniz (link).</div>'),(35,1,'<div><strong>Edit texts</strong></div>\n				<div>Use \'Edit texts\' link to translate all interface texts within the Store Front and Admin Panel.</div>\n				<div><strong>What is \'Based on\'</strong></div>\n				<div>This is the base for the new language - all translations will be copied from the \'based on\' language.</div>\n				<div><strong>Language selection bar</strong></div>\n				<div>Language Selection Bar appears in the Admin Panel, in Products, Categories, Product options, Manufacturers, Countries, States, Taxes, Rich text pages, Dynamic pages, Menus and others. All active languages appear in \'Language Selection Bar\', use it to translate the dynamic content.</div>\n				<div><strong>Languages in Store Front</strong></div>\n				<div>Active languages appear in the Store Front in a special drop-down menu.</div>'),(35,2,'<div><strong>Редактирайте текстовете</strong></div>\n				<div>Използвайте връзката \'Редактирайте текстовете\', за да преведете всички текстчета в интерфейса в клиентската и административната област.</div>\n				<div><strong>Какво е \'Основавам на\'</strong></div>\n				<div>Това е основата на която се базира новия език - копират се всички преводи от езика на който новия език се основава.</div>\n				<div><strong>Бар за избор на език</strong></div>\n				<div>Бара за избор на език се появява в административния панел в Продукти, Категории, Продуктови Опции, Производители, Държави, Области, Данъци, Страници с богат текст, Динамични страници, Менюта и др. Всички активни езици се появяват в \'Бар за избор на език\'. Използвайте го, за да преведете динамичното съдържание.</div>\n				<div><strong>Езици в клиентската област</strong></div>\n				<div>Активните езици се виждат в клиентската област в специално падащо меню.</div>'),(35,3,'<div><strong>Metin Düzenle</strong></div><div>Metinleri düzenle\' linkini(bağlantısını), Yönetici paneli ve Ön bellek içindeki tüm arayüz metinlerini çevirmek için kullanabilirsiniz.</div> <div><strong>\"Based on\" nedir</strong></div><div>Bu yeni bir yabancı dil için esas oluşturur - tüm çeviriler \'based on\' lisan menüsünden kopyalanır.</div> <div><strong>Dil seçim çubuğu</strong></div><div>Dil seçim çubuğu; Yönetici panelinde, ürünlerde, kategorilerde, üreticiler, ülkeler, şehirler (eyaletler), vergiler, Zengin metin sayfalar, dinamik sayfalar, menüler ve diğerlerinde görünür. Tüm aktif diller \'dil seçim çubuğunda\' görünür, ve siz onu dinamik içeriği çevirmek için kullanabilirsiniz.</div> <div><strong>Önbellekteki diller</strong></div><div>Aktif diller ön bellekteki özel bir aşağı-açılır menüde gözükür.</div> '),(36,1,'<div><strong>Select default currency</strong></div>\n				<div>You need to select a default currency for your store. Product prices in the Admin Panel will be listed in the default currency only, in the Store Front prices can be listed in multiple currencies.</div>\n				<div><strong>Select the source of currency rates</strong></div>\n				<div>You can receive currency rate data from 3 sources – European Central Bank, Bank of Canada, Reserve Bank of Australia.</div>\n				<div><strong>Change default currency</strong></div>\n				<div>When you change default currency, the system changes the currency without converting product prices. Remember to convert your products\' prices before or after you change default currency.</div>\n				<div><strong>Summer Cart has 39 built-in currencies</strong></div>\n				<div>You can use any of the 39 currencies which get automatically updated by the Summer Cart system daily. You can click on \'Update rates\' button to get immediate update.</div>\n				<div><strong>New currency</strong></div>\n				<div>You can create a additional currencies.</div>\n				<div><strong>Currencies in the Store Front</strong></div>\n				<div>Active currencies appear in the Store Front in a special drop-down menu. You can locate the menu in any place through your custom layout settings.</div>'),(36,2,'<div><strong>Избере валута по подразбиране</strong></div>\n				<div>Необходимо е да изберете валута по подразбиране за Вашия магазин. Продуктовите цени в административната област се показват само във валутата по подразбиране, в клиентската област цените може да бъдат показани във валута по избор на клиента.</div>\n				<div><strong>Изберете източник на валутни курсове</strong></div>\n				<div>Може да използвате валутни курсове от 3 източника – Европейската централна банка, Централната банка на Канада, Централната банка на Австралия.</div>\n				<div><strong>Сменете валутата по подразбиране</strong></div>\n				<div>Когато променяте валутата по подразбиране, системата променя валутата без да преизчислява цените на продуктите. Не забравяйте да преизчислите цените на вашите продукти преди или след като промените валутата по подразбиране.</div>\n				<div><strong>Summer Cart има 39 вградени валути</strong></div>\n				<div>Може да ползвате която и да е от 39 валути, чиито курсове ще бъдат автоматично обновявани от Summer Cart ежедневно. Може да кликнете бутона \'Обновете валутните курсове\', за да ги обновите на момента.</div>\n				<div><strong>Нова валута</strong></div>\n				<div>Също така може да добавите и нови валути.</div>\n				<div><strong>Валути в клиентската област</strong></div>\n				<div>Активните валути се показват в клиентската област в специално падащо меню. Може да поставите кутията с менюто където желаете като промените подредбите.</div>'),(36,3,'<div><strong>Varsayılan para birirmi seçin</strong></div><div>Mağazanız için varsayılan para birimi seçin. Yönetici panelindeki ürün fiyatları varsayılan para biriminde listelenir, sadece ön bellekteki fiyatlar çoklu para biriminde listelenebiilir.</div><div><strong>Döviz kur kaynağını seçin.</strong></div><div>Kur verilerini “ Avrupa Merkez Bankası,  Kanada Bankası, Avustralya Fon Bankası\" gibi 3 kaynakatan temin edilebilir.</div><div><strong>Varsayılan para birimini değiştir</strong></div><div>Varsayılan kuru değiştiğinizde, sistem kuru , geri dönülmeksizin değiştirir. Kuru değiştirmeden önce yada değiştirdikten sonra ürün fiyatlarınızı dönüştürmeyi unutmayın.</div> <div><strong>Summer Cart 39 yerleşik parabirimine sahiptir</strong></div><div>39 para biriminden herhangi birini kullanarak Summercart sisteminin günlük güncellemesini otomatik alabilirsiniz.</div> <div><strong>Yeni para birimi</strong></div><div>İlave para birimi oluşturabilirsiniz.</div><div><strong>Mağaza/Ziyaretçi bölümündeki para birimlerit</strong></div><div>Aktif kurlar ön bellekteki özel bir aşağı-açılır menüden görülür. Kişisel ayarlarınız doğrultusunda menüyü herhangi bir yeye yerleştirebilirsiniz.</div>');
/*!40000 ALTER TABLE `HelpsML` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `Languages` WRITE;
/*!40000 ALTER TABLE `Languages` DISABLE KEYS */;
INSERT INTO `Languages` VALUES (1,'English','EN',0,1,'userfiles/languages/language_1.jpg',18,12,'','','','0000-00-00',1),(2,'Български','BG',0,1,'userfiles/languages/language_2.jpg',18,12,'','','','0000-00-00',2),(3,'Türkçe','TR',0,1,'userfiles/languages/language_3.jpg',18,12,'','','','0000-00-00',3);
/*!40000 ALTER TABLE `Languages` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `Modules` WRITE;
/*!40000 ALTER TABLE `Modules` DISABLE KEYS */;
INSERT INTO `Modules` VALUES (1,NULL,'com.summercart.shipping.free','','Free Shipping',1),(2,NULL,'com.summercart.shipping.usps','','USPS Shipping',1),(3,NULL,'com.summercart.shipping.ups','','UPS Shipping',1),(4,NULL,'com.summercart.shipping.fedex','','FedEx Shipping',1),(5,NULL,'com.summercart.shipping.flatrate','','Flat Rate Shipping',1),(6,NULL,'com.summercart.payment.creditcard','','Credit Card Payment',1),(7,NULL,'com.summercart.payment.2checkout','','2Checkout Payment',1),(8,NULL,'com.summercart.payment.check','','Check Payment',1),(9,NULL,'com.summercart.ordertotal.subtotal','','Subtotal Order Total',1),(10,NULL,'com.summercart.system','','System',1),(11,NULL,'com.summercart.ordertotal.tax','','Tax Order Total',1),(12,NULL,'com.summercart.ordertotal.shipping','','Shipping Order Total',1),(13,NULL,'com.summercart.news','','News',1),(14,NULL,'com.summercart.forex.ecb','','European Central Bank Quotes',1),(15,NULL,'com.summercart.shipping.table','','Table-based Shipping',1),(16,NULL,'com.summercart.payment.authorize.sim','','Authorize.net SIM',1),(17,NULL,'com.summercart.payment.paypal.wps','','PayPal Website Payments Standard',1),(18,NULL,'com.summercart.payment.authorize.aim','','Authorize.net AIM',1),(19,NULL,'com.summercart.checkout.google','','Google Checkout (CO)',1),(20,NULL,'com.summercart.checkout.wizard','','Wizard Checkout',1),(21,NULL,'com.summercart.ordertotal.discount','','Discount Order Total',1),(22,NULL,'com.summercart.ordertotal.coupon','','Coupon Order Total',1),(23,NULL,'com.summercart.payment.cod','','Collect On Delivery',1),(24,NULL,'com.summercart.ordertotal.cod','','Collect On Delivery',1),(25,NULL,'com.summercart.shipping.digitaldelivery','','Digital Delivery',1),(26,NULL,'com.summercart.editorder','','Edit Order',1),(27,NULL,'com.summercart.payment.epaybg.paylogin','','ePay.bg',1),(28,NULL,'com.summercart.forex.boc','','Bank Of Canada Quotes',1),(29,NULL,'com.summercart.forex.rba','','Reserve Bank of Australia Quotes',1),(30,NULL,'com.summercart.payment.wire','','Wire Transfer',1),(31,NULL,'com.summercart.payment.sagepay.vsp_form','','Sage Pay VSP Form',1),(32,NULL,'com.summercart.payment.sagepay.vsp_server','','Sage Pay VSP Server',1),(33,NULL,'com.summercart.payment.sagepay.vsp_direct','','Sage Pay VSP Direct',1),(34,NULL,'com.summercart.payment.epaybg.paydirect','','ePay.bg (credit card)',0),(35,NULL,'com.summercart.ratingactions','','Rating Actions',1),(36,NULL,'com.summercart.payment.borica.gate','','Borica.bg',1),(37,NULL,'com.summercart.productattributesfilter','','Product Attributes Filter',1),(38,NULL,'com.summercart.productcomparison','','Product Comparison',1),(39,NULL,'com.summercart.payment.moneybookers.payment_gataway','','Moneybookers',1),(40,NULL,'com.summercart.payment.rbsworldpay.business_gateway','','RBS WorldPay',1),(41,NULL,'com.summercart.payment.chronopay','','ChronoPay',1),(42,NULL,'com.summercart.payment.hsbc.cpi','','HSBC CPI',1),(43,NULL,'com.summercart.payment.transcardbg.paygw','','Transcard.bg Internet Payment Gateway',1),(44,NULL,'com.summercart.sitemap_protocol','','Sitemap Protocol (www.sitemaps.org)',1),(45,NULL,'com.summercart.newsletter','','Newsletter',1),(46,NULL,'com.summercart.rss','','RSS',1),(47,NULL,'com.summercart.related_products','','Related Products',1),(48,NULL,'com.summercart.payment.paypal.payflow_pro','','PayPal Payflow Pro',1),(49,NULL,'com.summercart.checkout.paypal.express','','PayPal Express',1),(50,NULL,'com.summercart.wishlist','','Wishlist',1),(51,NULL,'com.summercart.payment.dskdirect.vpos','','DSK Direct',1),(52,NULL,'com.summercart.turkishbanks.virtualpos','','Turkish Banks Virtual POS',1),(53,NULL,'com.summercart.turkishbanks.virtualpospayhosting','','EST 3D Pay Hosting',1),(54,NULL,'com.summercart.payment.ogone','','Ogone',1),(55,NULL,'com.summercart.forex.tcmb','','Central Bank of the Republic of Turkey Quotes',1),(56,NULL,'com.summercart.ordertotal.points','','Bonus Points',1),(57,NULL,'com.summercart.payment.easypaybg','','Easypay.bg',1),(58,NULL,'com.summercart.payment.fibankbg','','FIBank',1),(59,NULL,'com.summercart.shipping.canadapost','','Canada Post',1),(60,NULL,'com.summercart.payment.moneris.hostedpage','','Moneris',1),(61,NULL,'com.summercart.shipping.speedybg','','Speedy',1),(62,NULL,'com.summercart.shipping.speedybg.admin','','Speedy import locations',1),(63,NULL,'com.summercart.shippinglabel.default','','Default shipping module label',1),(64,NULL,'com.summercart.shipping.econtbg','','Econt',1),(65,NULL,'com.summercart.payment.ccnow.hostedpage','','CCNow',1),(66,NULL,'com.summercart.payment.ubb_bg.hostedpage','','UBB.bg',1),(67,NULL,'com.summercart.payment.atos','','Atos Worldline\'s SIPS',1),(68,1,'com.summercart.products_feed','1.0','Products Feed',1),(69,NULL,'com.summercart.payment.realex.hostedpage','1.0','Realex RealAuth Redirect',1);
/*!40000 ALTER TABLE `Modules` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `ModuleClasses` WRITE;
/*!40000 ALTER TABLE `ModuleClasses` DISABLE KEYS */;
INSERT INTO `ModuleClasses` VALUES (1,1,'IShippingModule','scFreeShipping','shipping/free/free.php'),(2,2,'IShippingModule','scUSPS','shipping/usps/usps.php'),(3,7,'IPaymentModule','scPaymentModule2checkout','payment/2checkout/2checkout.php'),(4,6,'IPaymentModule','scPaymentModuleCreditCard','payment/creditcard/creditcard.php'),(5,8,'IPaymentModule','scPaymentModuleCheck','payment/check/check.php'),(6,9,'IOrderTotalModule','scOrderTotalSubtotal','ordertotal/subtotal/subtotal.php'),(7,10,'ICMSBox','scCustomerCategoriesBox','system/blocks/customer/categories_box.php'),(8,10,'ICMSBox','scCustomerBestSellersBox','system/blocks/customer/bestsellers_box.php'),(9,10,'ICMSBox','scCustomerManufacturersBox','system/blocks/customer/manufacturers_box.php'),(10,10,'ICMSBox','scNewsBox','system/news/customer/news.php'),(11,10,'ICMSBox','scCustomerSearchBox','system/blocks/customer/search_box.php'),(12,10,'ICMSBox','scCustomerCartBox','system/blocks/customer/cart_box.php'),(13,10,'ICMSBox','scCustomerLoginBox','system/blocks/customer/login_box.php'),(14,10,'ICMSBox','scCustomerMenuBox','system/blocks/customer/menu_box.php'),(15,11,'IOrderTotalModule','scOrderTotalTax','ordertotal/tax/tax.php'),(16,12,'IOrderTotalModule','scOrderTotalShipping','ordertotal/shipping/shipping.php'),(17,13,'IMenu','scNews','system/news/admin/news.php'),(18,13,'IAdminModule','scAdminNews','system/news/admin/news.php'),(19,4,'IShippingModule','scFedEx','shipping/fedex/fedex.php'),(20,3,'IShippingModule','scUPS','shipping/ups/ups.php'),(21,14,'ICurrencyRates','scCurrencyRatesECB','rates/ecb/ecb.php'),(22,10,'ICMSBox','scCustomerCurrencyBox','system/blocks/customer/currency_box.php'),(23,5,'IShippingModule','scFlatRate','shipping/flat_rate/flat_rate.php'),(24,15,'IShippingModule','scTableBased','shipping/table_based/table_based.php'),(25,16,'IPaymentModule','scPaymentModuleAuthorizeSIM','payment/authorize/sim.php'),(26,17,'IPaymentModule','scPaymentModulePayPalWPS','payment/paypal/wps.php'),(27,18,'IPaymentModule','scPaymentModuleAuthorizeAIM','payment/authorize/aim.php'),(28,13,'IUserModule','scUserNews','system/news/customer/news.php'),(29,19,'ICheckoutModule','scPaymentModuleGoogleCheckout','checkout/google/gco.php'),(30,20,'ICheckoutModule','scWizardCheckout','checkout/wizard/wizard.php'),(31,21,'IOrderTotalModule','scOrderTotalDiscount','ordertotal/discount/discount.php'),(32,21,'IProductPriceModifier','scProductPriceDiscount','ordertotal/discount/discount.php'),(33,22,'IOrderTotalModule','scOrderTotalCoupon','ordertotal/coupon/coupon.php'),(34,22,'IProductPriceModifier','scProductPriceCoupon','ordertotal/coupon/coupon.php'),(35,10,'ICMSBox','scCustomerRecentlyViewedBox','system/blocks/customer/recently_viewed.php'),(36,10,'ICMSBox','scAdminSetupWizardBox','system/blocks/admin/setup_wizard_box.php'),(37,23,'IPaymentModule','scPaymentModuleCollectOnDelivery','payment/cod/cod.php'),(38,24,'IOrderTotalModule','scOrderTotalCollectOnDelivery','ordertotal/cod/cod.php'),(39,10,'ICMSBox','scCustomerNewProductsBox','system/blocks/customer/new_products_box.php'),(40,10,'IProductPriceModifier','scProductPriceWholesalePrices','system/wholesale/prices.php'),(41,10,'IProductDetails','scWholesaleProductDetails','system/wholesale/product_details.php'),(42,25,'IShippingModule','scDigitalDeliveryShipping','shipping/digital_delivery/digital_delivery.php'),(43,26,'IAdminModule','scEditOrderModule','system/edit_order/edit_order.php'),(44,27,'IPaymentModule','scPaymentModuleEpayBgPayLogin','payment/epay_bg/epay.php'),(45,28,'ICurrencyRates','scCurrencyRatesBOC','rates/boc/boc.php'),(46,29,'ICurrencyRates','scCurrencyRatesRBA','rates/rba/rba.php'),(47,30,'IPaymentModule','scPaymentModuleWireTransfer','payment/wire/wire.php'),(48,10,'ICMSBox','scDropdownCategoriesBox','system/blocks/customer/dropdown_categories_box.php'),(49,31,'IPaymentModule','scPaymentModuleSagePayVSPForm','payment/sagepay/vsp_form.php'),(50,32,'IPaymentModule','scPaymentModuleSagePayVSPServer','payment/sagepay/vsp_server.php'),(51,33,'IPaymentModule','scPaymentModuleSagePayVSPDirect','payment/sagepay/vsp_direct.php'),(52,34,'IPaymentModule','scPaymentModuleEpayBgPayDirect','payment/epay_bg/epay.php'),(53,10,'ICMSBox','scCmsHtmlBox','system/blocks/customer/cms_html_box.php'),(54,35,'IAdminModule','scAdminRatingActionsModule','system/rating_actions/admin/rating_actions.php'),(55,35,'IUserModule','scCustomerRatingActionsModule','system/rating_actions/customer/rating_actions.php'),(56,35,'IProductDetails','scCustomerRatingActionsModule','system/rating_actions/customer/rating_actions.php'),(57,36,'IPaymentModule','scPaymentModuleBoricaGate','payment/borica/gate.php'),(58,37,'ICMSBox','scProductAtributesFilterBox','system/blocks/customer/product_attributes_filter.php'),(59,37,'IProductsListingFilter','scProductAtributesFilter','system/blocks/customer/product_attributes_filter.php'),(60,37,'IUserModule','scProductAtributesFilter','system/blocks/customer/product_attributes_filter.php'),(61,38,'ICMSBox','scProductComparisonBox','system/product_comparison/product_comparison.php'),(62,38,'IProductDetails','scProductComparisonProductDetails','system/product_comparison/product_comparison.php'),(63,38,'IUserModule','scProductComparisonUserModule','system/product_comparison/product_comparison.php'),(64,39,'IPaymentModule','scPaymentModuleMoneybookers','payment/moneybookers/moneybookers.php'),(65,40,'IPaymentModule','scPaymentModuleRBSWorldPay','payment/rbsworldpay/rbsworldpay.php'),(66,41,'IPaymentModule','scPaymentModuleChronoPay','payment/chronopay/chronopay.php'),(67,42,'IPaymentModule','scPaymentModuleHsbcCpi','payment/hsbc/cpi.php'),(68,43,'IPaymentModule','scPaymentModuleTranscardBg','payment/transcard_bg/transcard_bg.php'),(69,44,'IUserModule','scSitemapsProtocolModule','system/sitemaps_protocol/sitemaps_protocol.php'),(70,36,'IAdminModule','scPaymentModuleBoricaGateSetup','payment/borica/borica_setup.php'),(71,45,'IUserModule','scNewsletterUserModule','system/newsletter/newsletter.php'),(72,45,'IAdminModule','scNewsletterAdminModule','system/newsletter/newsletter.php'),(73,45,'ICMSBox','scNewsletterCmsBox','system/newsletter/newsletter.php'),(74,46,'IUserModule','scRssFeedsModule','system/rss/rss_feeds.php'),(75,47,'IProductDetails','scRelatedProductsDetails','system/related_products/related_products.php'),(76,48,'IPaymentModule','scPaymentModulePayPalPayflowPro','payment/paypal/payflow_pro.php'),(77,49,'ICheckoutModule','scPaymentModulePayPalExpress','checkout/paypal/express.php'),(78,17,'IPaymentModuleOperations','scPaymentModulePayPalWPSOperations','payment/paypal/operations.php'),(79,50,'IUserModule','scWishlistUserModule','system/wishlist/wishlist.php'),(80,50,'IProductDetails','scWishlistProductsDetails','system/wishlist/wishlist.php'),(81,36,'IPaymentModuleOperations','scPaymentModuleBoricaOperations','payment/borica/operations.php'),(82,19,'ICheckoutModuleButton','scPaymentModuleGoogleCheckoutButton','checkout/google/button.php'),(83,20,'ICheckoutModuleButton','scWizardCheckoutButton','checkout/wizard/button.php'),(84,49,'ICheckoutModuleButton','scPaymentModulePayPalExpressButton','checkout/paypal/button.php'),(85,51,'IPaymentModule','scPaymentModuleDskDirect','payment/dskdirect/dskdirect.php'),(86,52,'IPaymentModule','scPaymentModuleEst3d','payment/turkish_banks/3d.php'),(87,52,'IAdminModule','scPaymentModuleTurkishBanksSetup','payment/turkish_banks/banks_setup.php'),(88,53,'IPaymentModule','scPaymentModuleEst3dPayHosting','payment/turkish_banks/3dpayhosting.php'),(89,54,'IPaymentModule','scPaymentModuleOgone','payment/ogone/ogone.php'),(90,55,'ICurrencyRates','scCurrencyRatesTCMB','rates/tcmb/tcmb.php'),(91,56,'IOrderTotalModule','scOrderTotalPoints','ordertotal/points/points.php'),(92,10,'IProductDetails','scBundledProductsDetails','system/bundled_products/bundled_products.php'),(93,57,'IPaymentModule','scPaymentModuleEasypayBg','payment/epay_bg/easypay.php'),(94,58,'IPaymentModule','scPaymentModuleFIBankBg','payment/fibank_bg/fibank.php'),(95,59,'IShippingModule','scCanadaPost','shipping/canada_post/canada_post.php'),(96,60,'IPaymentModule','scPaymentModuleMonerisHostedPage','payment/moneris/moneris_hostedpage.php'),(97,61,'IShippingModule','scSpeedyBg','shipping/speedybg/speedybg.php'),(98,61,'IShippingModuleCodInfo','scSpeedyBg','shipping/speedybg/speedybg.php'),(99,62,'IAdminModule','scSpeedyBgAdminModule','shipping/speedybg/admin_module.php'),(100,61,'IShippingLabelModule','scSpeedyShippingLabelModule','shipping/speedybg/speedy_shipping_label.php'),(101,63,'IShippingLabelModule','scDefaultShippingLabelModule','shippinglabel/default/default_shipping_label.php'),(102,64,'IShippingModule','scEcontBg','shipping/econt/econtbg.php'),(103,65,'IPaymentModule','scPaymentModuleCcnowHostedPage','payment/ccnow/ccnow_hostedpage.php'),(104,66,'IPaymentModule','scPaymentModuleUbbBgHostedPage','payment/ubb_bg/ubb.php'),(105,66,'IAdminModule','scPaymentModuleUbbBgSetup','payment/ubb_bg/ubb_setup.php'),(106,67,'IPaymentModule','scPaymentModuleAtos','payment/atos/atos.php'),(107,68,'IUserModule','scProductsFeedUserModule','system/products_feed/customer/products_feed.php'),(108,68,'IAdminModule','scProductsFeedAdminModule','system/products_feed/admin/products_feed.php'),(109,64,'IShippingLabelModule','scEcontShippingLabelModule','shipping/econt/econt_shipping_label.php'),(110,69,'IPaymentModule','scPaymentModuleRealexHostedPage','payment/realex/realex.php'),(111,64,'IShippingModuleCodInfo','scEcontBg','shipping/econt/econtbg.php');
/*!40000 ALTER TABLE `ModuleClasses` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `ModuleOptions` WRITE;
/*!40000 ALTER TABLE `ModuleOptions` DISABLE KEYS */;
INSERT INTO `ModuleOptions` VALUES (1,7,'DemoMode','Y'),(2,7,'SID','125863'),(3,7,'SecretWord','secret16'),(4,8,'AcceptedCheckType','0'),(5,16,'Mode','Developer'),(6,16,'LoginID','4RPu6x4Nd'),(7,16,'MD5Hash','12345'),(8,16,'TimezoneOffset','+3'),(9,16,'TransactionKey','4X76aqcPK486Jd33'),(10,17,'Account','manage_1257029891_biz@mirchevideas.com'),(11,17,'PaymentAction','sale'),(12,17,'DefaultCurrencyCode','USD'),(13,17,'OrderDescription','Summer Cart Order'),(14,17,'Mode','Sandbox'),(15,17,'PDTIdentityToken','40BVSa7fnC3L3vK_o-rqVTms-8XmecftqAlLp58fDEZdrGoWtMon9c5k0zy'),(16,17,'ApiUsername','manage_1257029891_biz_api1.mirchevideas.com'),(17,17,'ApiPassword','1257029906'),(18,17,'ApiSignature','AiPC9BjkCyDFQXbSkoZcgqH3hpacAZ-ikMz96XeAzbCgCHQhmeED-N2H'),(19,18,'Mode','Developer'),(20,18,'LoginID','4RPu6x4Nd'),(21,18,'MD5Hash','12345'),(22,18,'TransactionKey','4X76aqcPK486Jd33'),(23,19,'BackupShippingAmount','12'),(24,19,'Mode','Sandbox'),(25,19,'DisallowUSPOBox',''),(26,19,'MerchantID','315904291165297'),(27,19,'MerchantKey','sLBiQkyP3gXNOwYIgv3ohA'),(28,19,'SellerAccountCurrencyCode','USD'),(29,19,'UseBackupShippingAmount','1'),(30,20,'AllowGuestCheckout','1'),(31,20,'AllowOrderInstructions','1'),(32,20,'RequireAcceptTerms','0'),(33,23,'MaximumAmount','10000'),(34,24,'UseShippingModuleFee','1'),(35,24,'FixedFee','10'),(36,24,'PercentFee','2'),(37,31,'Vendor','testvendor'),(38,31,'EncryptionPassword','testvendor'),(39,31,'TransactionType','PAYMENT'),(40,31,'Mode','1'),(41,31,'OrderDescription','Summer Cart Order'),(42,31,'SupportedCurrencyCodes','GBP'),(43,31,'DefaultCurrencyCode','GBP'),(44,31,'VendorEmail',''),(45,31,'SendEMail','0'),(46,31,'eMailMessage',''),(47,32,'Vendor','testvendor'),(48,32,'TransactionType','PAYMENT'),(49,32,'Mode','1'),(50,32,'OrderDescription','Summer Cart Order'),(51,32,'SupportedCurrencyCodes','GBP'),(52,32,'DefaultCurrencyCode','GBP'),(53,33,'Vendor','testvendor'),(54,33,'TransactionType','PAYMENT'),(55,33,'Mode','1'),(56,33,'OrderDescription','Summer Cart Order'),(57,33,'SupportedCurrencyCodes','GBP'),(58,33,'DefaultCurrencyCode','GBP'),(59,36,'TID','79010016'),(60,36,'ApgwPrivateKey',''),(61,36,'ApgwTestPrivateKey','-----BEGIN RSA PRIVATE KEY-----\nMIICXAIBAAKBgQCodAKxvGavNDMnAUUbY/vjupuqheXUAr7XoyYPQNOY8RSMDmoU\nMvVSrx//B04ZrQaLVw/98r4XHaIlhGBKBthDUSNo/erwuJ+H8yBic7aKOG2XqxGS\nB2kGtHyhf+tYe0vg0B+9maqGxWNL/c5ZIKLtx2sY0elDDzfP5r+a0bqkYwIDAQAB\nAoGAT5IFF8nDw2zn4LvT1f1jpY2nLGR1TLFDTn7NYpUfnnX6W7IPX502jqkUdxYP\nSUeW+MjWUAGS0z53MjuWdEFJc7ZxvyOGosW/iMDfisR3qYBE9tPjUx6xkiZC/LL6\nzaqJpRIXyFyQTDnibXUdK9WnPRx0ZRRUF0GHyLIr+fyd+NECQQDa4tAIBN4RYeN4\nplfs5azCxc40YJxajlfrgO07XIo18GOpPuCx/dZe1PHiHX5nc+23xG1JQFFFBqBE\nkrCSCUXpAkEAxQQPR18+b/K5gSXV3bvA0qA+jZ8Us82eQXPiufCSNNtp3pZZw4od\nqhq/08YVLISodMqjW4gcDvxuzgougkeMawJBAMmD52J6mLgIFxQMkQZYrSTkV2OB\nTnFQe0EmAUKVf+kI17gJW3SC7cmA4u/5l1ZHNKPrA3Jc9HVIFGUNZ+ILB4ECQAsd\n6YbLdwh2F8WTzveOCplX9W+kVFS4+38R/O8lBfr5joXC0hnYh0f77msSuEskySSd\n8o3NpleqIs55gJpVUzUCQDMPOPfblHxWQRU+Z+xxKzCHtk0XpO5yFMqzAdJzCF/6\n+MRkt2DCaLjhtcl7UnAdU3x8EtINqqNNGFE9pibNcFk=\n-----END RSA PRIVATE KEY-----'),(62,36,'AccountCurrencyCode','BGN'),(63,36,'Mode','Test'),(64,39,'PayToEmail','mb_business@mail.bg'),(65,39,'LogoURL',''),(66,39,'HideLogin','0'),(67,39,'UseIframe','1'),(68,39,'DefaultCurrencyCode','EUR'),(69,39,'SecretWord','testword'),(70,40,'InstID','235257'),(71,40,'Mode','Test'),(72,40,'AuthMode','A'),(73,40,'AllowContactEdit','0'),(74,40,'DefaultCurrencyCode','EUR'),(75,40,'MD5Secret','secret'),(76,40,'PaymentResponsePassword','pass'),(77,41,'ProductID','003725-0148-0001'),(78,41,'ProductCurrencyCode','USD'),(79,42,'StorefrontId','UK11113355WWW'),(80,42,'Mode','T'),(81,42,'TransactionType','Auth'),(82,42,'AccountCurrencyCode','GBP'),(83,42,'OrderDesc','Test Summer Cart order'),(84,42,'SharedSecret','zEeWQNKelqPE2DRFueuDq1QrASjux2lM'),(85,43,'MerchantID','000776001'),(86,43,'Mode','Test'),(87,43,'TestPrivateKey','-----BEGIN RSA PRIVATE KEY-----\nMIIBOwIBAAJBALHZ7k/55wUsV9ELSZVhcNsrRDtK527zXbey+4VdsVWhPqOThYC6\nEhMRgXVz4646BOxYofIiksgsMvLcMemC43ECAwEAAQJADeIxVFTxz9mSUWNMLzkY\nEkPiY66JOoQNANYcBGE4ArMeRfaCiiyC6uPEE1rAE2r1pRBzGYF6QbKr0PZ1aATc\nMQIhAOVfTrp6aemTWPx2N2diw9H3OT2/BhbxPwLI5KoEfDwDAiEAxn95zzGYKO3f\nZtFCUY2PxBHXIHLuqOp+04KFuTWTWnsCIQCPhDjQeTO30FhHbvhvmd6Ii7WnKtT2\nmfAhH+3ja3cIXQIhAK+8kHVVrScfYlg/D/3v3MZ0HQgHeTBnW52awxV0T18dAiAx\nji3tqDvQcpO2bvXo3h6yMO62jt7E0otrcuSOnSge8g==\n-----END RSA PRIVATE KEY-----'),(88,43,'TestTranscardCertificate','-----BEGIN CERTIFICATE-----\nMIIENzCCAx+gAwIBAgIBDjANBgkqhkiG9w0BAQQFADByMQswCQYDVQQGEwJCRzEO\nMAwGA1UECBMFU29maWExDjAMBgNVBAcTBVNvZmlhMRUwEwYDVQQKEwxUUkFOU0NB\nUkQgQUQxCzAJBgNVBAsTAkNBMR8wHQYDVQQDExZTZWN1cmUgc2VydmVycyBST09U\nIENBMB4XDTA5MDkwODIyMzgwM1oXDTExMDkwODIyMzgwM1owbDELMAkGA1UEBhMC\nQkcxDjAMBgNVBAgTBVNvZmlhMQ4wDAYDVQQHEwVTb2ZpYTEVMBMGA1UEChMMVFJB\nTlNDQVJEIEFEMQwwCgYDVQQLEwNJVEQxGDAWBgNVBAMTD3Rlc3QtcGd3LXNlcnZl\ncjCBnzANBgkqhkiG9w0BAQEFAAOBjQAwgYkCgYEAwbMDQCRmnopzx/IyCLeQ7MkZ\nkvoLmAzD7aUi92j7EqECkRfXwwSOUooqEB741TLURID5GpROEKORlcMVThfTKZvx\nmv950a7cHXRBtMmJKOc2FSQMwF6P/MQ55/0zkdHQd6QfKg+pZPcDqOvSuk9kmQSf\nAH7tlz7i+38SvXRs9nECAwEAAaOCAWAwggFcMAwGA1UdEwEB/wQCMAAwCwYDVR0P\nBAQDAgXgMCcGA1UdJQQgMB4GCCsGAQUFBwMBBggrBgEFBQcDAwYIKwYBBQUHAwQw\nHQYDVR0OBBYEFMttYU5ZJOdRAq2X0NJK/N4q15MtMIGcBgNVHSMEgZQwgZGAFC6q\nkoK22+NTsrlRozwUVxloeL8PoXakdDByMQswCQYDVQQGEwJCRzEOMAwGA1UECBMF\nU29maWExDjAMBgNVBAcTBVNvZmlhMRUwEwYDVQQKEwxUUkFOU0NBUkQgQUQxCzAJ\nBgNVBAsTAkNBMR8wHQYDVQQDExZUcmFuc2NhcmQgQUQgLSBSb290IENBggEBMAkG\nA1UdEQQCMAAwCQYDVR0SBAIwADARBglghkgBhvhCAQEEBAMCBHAwLwYJYIZIAYb4\nQgENBCIWIFRSQU5TQ0FSRCBBRCAgU2VydmVyIENlcnRpZmljYXRlMA0GCSqGSIb3\nDQEBBAUAA4IBAQDBQcwZPwRQgZGi29lgCZdQoVqyi8PLRgQG/O8m2lYVk1N+RqIC\n2uY3/GiN3ibab2FELhLnx85EEu/+Ko5cdlX57V6MeFgFXnH1OObcxYlZ4RYkM6vS\nnmPU9UrmQWYZPZMfSrtWU5v6Gr3bVdJfFAHbXN/jNom4CaeirW2ToD54FFcmob1t\nIx7JtbrJ/F6ytXhpKSZTi1SHcajiiZhTfIS6HGppLDZZ4iezzbuaovgXkU/nvoLM\n2OQQEqrqBpm7YTMEIC60YxS0hS5T/6cH+R0yVp9pQ9bYEuu67+iBvhxCYWbEs59l\nxy5zSq/zQZpxi6rrjqq7UUSwsJWaD5z4lHNv\n-----END CERTIFICATE-----'),(89,43,'LivePrivateKey',''),(90,43,'LiveTranscardCertificate','-----BEGIN CERTIFICATE-----\nMIIEATCCAumgAwIBAgIBBjANBgkqhkiG9w0BAQQFADBdMQswCQYDVQQGEwJCRzEO\nMAwGA1UECBMFU29maWExDjAMBgNVBAcTBVNvZmlhMRUwEwYDVQQKEwxUUkFOU0NB\nUkQgQUQxFzAVBgNVBAMTDlBheSBHVyByb290IENBMB4XDTA0MDYwMjE0MTAwM1oX\nDTA4MDYwMTE0MTAwM1owWDESMBAGA1UEAxMJVEMgUGF5R1cgMQswCQYDVQQGEwJC\nRzEOMAwGA1UEBxMFU29maWExDjAMBgNVBAgTBVNvZmlhMRUwEwYDVQQKEwxUUkFO\nU0NBUkQgQUQwgZ8wDQYJKoZIhvcNAQEBBQADgY0AMIGJAoGBAL5Yvmyzw29VkhXY\nsT0nIg9as2HHxP2nNjXCSAZY8fEro4A1yGAKWhOdMHTig1Aep1ShJ3CYn1yoRJ7j\nIgKLMJTHwPyrjOMtXyNVcZ1HteDJc/J4lWIH+bY35JjBMPFW7v1fudKl8o9szUKQ\nbHFWbTVh8g+f+Mews9zIagjINZU9AgMBAAGjggFTMIIBTzAMBgNVHRMBAf8EAjAA\nMB0GA1UdDgQWBBRoEZRNhNgWxSOTX1ow1ZjdQpmopTCBnAYDVR0jBIGUMIGRgBRb\ndjw6SFXaEspVru83xcMQ0u3636F2pHQwcjELMAkGA1UEBhMCQkcxDjAMBgNVBAgT\nBVNvZmlhMQ4wDAYDVQQHEwVTb2ZpYTEVMBMGA1UEChMMVFJBTlNDQVJEIEFEMQsw\nCQYDVQQLEwJDQTEfMB0GA1UEAxMWVHJhbnNjYXJkIEFEIC0gUm9vdCBDQYIBBTAO\nBgNVHQ8BAf8EBAMCBeAwNAYDVR0lAQH/BCowKAYIKwYBBQUHAwEGCCsGAQUFBwMD\nBggrBgEFBQcDBAYIKwYBBQUHAwgwEQYJYIZIAYb4QgEBBAQDAgRQMCgGCWCGSAGG\n+EIBDQQbFhlQYXkgR1cgc2VydmVyIGNlcnRpZmljYXRlMA0GCSqGSIb3DQEBBAUA\nA4IBAQCHRFMZn9nx/us/hPozbibL0wsTzuQK8YKnMTAhuPoCh8HUMlph4bJQTjEZ\nGmFCfMNapPV6jetyDcFEFZnNoPC1yaL0h1E91UiBQQt+UtISuw9JFYMcLdlYYkRN\nwJOvIbhDEARLtS0J5PnP7PU6ShFXvK0ZIyNsNH54gWHoUKsfu59hGPAu6HEc9M+l\nUvUliLSc7uda2xH+jIIIO7NBhh68NjVtSPjBFTGn6M/3iN3jp4aI7RN6fPj5Sqlp\njelc7rxetKFco6fPqeVlgE5gKw5YjkTHRO/gn8NH9K6HjH1MVLiBMzNQHcGq+JM1\nRC9OQh5C+NQNKXMaXhrz/YwJYGk6\n-----END CERTIFICATE-----'),(91,48,'Mode','Test'),(92,48,'BuyerAuthEnabled','1'),(93,48,'Vendor',''),(94,48,'Partner','PayPal'),(95,49,'Account','manage_1257029891_biz@mirchevideas.com'),(96,49,'PaymentAction','sale'),(97,49,'ApiUsername','manage_1257029891_biz_api1.mirchevideas.com'),(98,49,'ApiPassword','1257029906'),(99,49,'ApiSignature','AiPC9BjkCyDFQXbSkoZcgqH3hpacAZ-ikMz96XeAzbCgCHQhmeED-N2H'),(100,49,'AllowNote','1'),(101,49,'RequireConfirmedShippingAddress','1'),(102,49,'LandingPage','Login'),(103,49,'UseConfirmPage','1'),(104,49,'CheckoutButtonType','Dynamic'),(105,49,'DefaultCurrencyCode','USD'),(106,49,'Mode','Sandbox'),(107,51,'Mode','Live'),(108,51,'MerchantID',''),(109,51,'OrderDescription',''),(110,51,'CurrencyCode','BGN'),(111,51,'MD5Password',''),(112,52,'DefaultBankCode','Garanti'),(113,52,'Akbank_ClientID','10010'),(114,52,'Akbank_Active','1'),(115,52,'Akbank_Mode','Test'),(116,52,'Akbank_TransactionType','Auth'),(117,52,'Akbank_StoreKey','123456'),(118,52,'Akbank_ApiUsername','AKTEST'),(119,52,'Akbank_ApiPassword','AKTEST123'),(120,52,'Akbank_Installments','2:3.8,4:6.4,6:9.2,8:12'),(121,52,'Anadolubank_ClientID','90010'),(122,52,'Anadolubank_Mode','Test'),(123,52,'Anadolubank_TransactionType','Auth'),(124,52,'Anadolubank_StoreKey','123456'),(125,52,'Anadolubank_ApiUsername','ANDTEST'),(126,52,'Anadolubank_ApiPassword','ANDTEST123'),(127,52,'Denizbank_ClientID','800010'),(128,52,'Denizbank_Mode','Test'),(129,52,'Denizbank_TransactionType','Auth'),(130,52,'Denizbank_StoreKey','123456'),(131,52,'Denizbank_ApiUsername','DENIZTEST'),(132,52,'Denizbank_ApiPassword','DENIZTEST123'),(133,52,'Finansbank_ClientID','60010'),(134,52,'Finansbank_Active','1'),(135,52,'Finansbank_Mode','Test'),(136,52,'Finansbank_TransactionType','Auth'),(137,52,'Finansbank_StoreKey','123456'),(138,52,'Finansbank_ApiUsername','FINTEST'),(139,52,'Finansbank_ApiPassword','FINTEST123'),(140,52,'Finansbank_Installments','2:3.7,4:6.2,6:9.0,8:11.7,18:20,24:27.32'),(141,52,'Garanti_ClientID','100104'),(142,52,'Garanti_Active','1'),(143,52,'Garanti_Mode','Test'),(144,52,'Garanti_TransactionType','Auth'),(145,52,'Garanti_StoreKey','12345678'),(146,52,'Garanti_ApiUsername','paymentuser'),(147,52,'Garanti_ApiPassword','userpayment'),(148,52,'Garanti_Installments','2:3.9,4:6.6,6:9.3,8:12'),(149,52,'Fortis_ClientID','20010'),(150,52,'Fortis_Mode','Test'),(151,52,'Fortis_TransactionType','Auth'),(152,52,'Fortis_StoreKey','123456'),(153,52,'Fortis_ApiUsername','FORTISTEST'),(154,52,'Fortis_ApiPassword','FORTISTEST123'),(155,52,'Halkbank_ClientID','50010'),(156,52,'Halkbank_Mode','Test'),(157,52,'Halkbank_TransactionType','Auth'),(158,52,'Halkbank_StoreKey','123456'),(159,52,'Halkbank_ApiUsername','HALKTEST'),(160,52,'Halkbank_ApiPassword','HALKTEST123'),(161,52,'Isbank_ClientID','70010'),(162,52,'Isbank_Active','1'),(163,52,'Isbank_Mode','Test'),(164,52,'Isbank_TransactionType','Auth'),(165,52,'Isbank_StoreKey','123456'),(166,52,'Isbank_ApiUsername','ISTEST'),(167,52,'Isbank_ApiPassword','ISTEST123'),(168,52,'Isbank_Installments','2:3.4,3:4.4,6:7.5,9:10.6,12:13.70,18:20.20,24:26.90'),(169,52,'TEB_ClientID','40010'),(170,52,'TEB_Mode','Test'),(171,52,'TEB_TransactionType','Auth'),(172,52,'TEB_StoreKey','123456'),(173,52,'TEB_ApiUsername','TEBTEST'),(174,52,'TEB_ApiPassword','TEBTEST123'),(175,53,'Bank','Garanti'),(176,53,'ClientID',''),(177,53,'StoreKey',''),(178,54,'PSPID','mirchevideas'),(179,54,'SHA1OUT','asdfghjkl1234567890'),(180,54,'OgoneDemoMode','0'),(181,54,'OgoneTransactionType','SAL'),(182,65,'ClientID','amylove'),(183,65,'ActivationKey','123456789'),(184,65,'Method','TEST'),(185,65,'DefaultCurrencyCode','USD'),(186,66,'TransactionType','1'),(187,66,'DefaultCurrencyCode','BGN'),(188,66,'SupportedCurrencyCodes','BGN'),(189,67,'MerchantID','013044876511111'),(190,67,'CountryID','74'),(191,67,'DefaultCurrencyCode','EUR'),(192,67,'DefaultLanguageCode','EN'),(193,68,'RequireKey','1'),(194,68,'SecretKey','kjKJhdJKkhgJH');
/*!40000 ALTER TABLE `ModuleOptions` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `ModuleOptionsML` WRITE;
/*!40000 ALTER TABLE `ModuleOptionsML` DISABLE KEYS */;
INSERT INTO `ModuleOptionsML` VALUES (30,1,'WireInstructions','<div>Wire Transfer Instructions</div><div>Bank name: </div><div>Bank address: </div><div>Beneficiary name: </div><div>Beneficiary address: </div><div>Account number: </div><div>SWIFT: </div><div>Bank fees for both, the sender and recipient, should be paid by the payer.</div>'),(30,2,'WireInstructions','<div>Инструкции за банков трансфер</div><div>Име на банка: </div><div>Адрес на банка: </div><div>Име на бенефициент: </div><div>Beneficiary address: </div><div>Сметка номер: </div><div>SWIFT: </div><div>Банковите такси (включително на изпращача и получателя) трябва да се заплатят от клиента.</div>'),(30,3,'WireInstructions','<div>Havale Talimatları</div><div>Banka adı: </div><div>Banka adresi: </div><div>Alıcı adi: </div><div>Alıcı adresi: </div><div>Hesap No: </div><div>SWIFT: </div><div>Her ikisi için banka ücretleri, gönderici ve alıcı, müşteri tarafından ödenmesi gerekmektedir.</div>'),(36,1,'OrderDescription','Summer Cart Order'),(36,2,'OrderDescription','Поръчка през Summer Cart'),(36,3,'OrderDescription','Summer Cart\'dan Sipariş'),(39,1,'ConfirmationNote','Thank you for buying'),(39,1,'RecipientDescription','Summer Cart Merchant'),(39,1,'ReturnURLText','Return to store'),(39,2,'ConfirmationNote','Благодаря за покупката'),(39,2,'RecipientDescription','Summer Cart Търговец'),(39,2,'ReturnURLText','Обратно в магазина'),(39,3,'ConfirmationNote','Satın aldığınız için teşekkür ederiz'),(39,3,'RecipientDescription','Summer Cart Tüccar'),(39,3,'ReturnURLText','Mağazaya dön'),(40,1,'OrderDescription','Order from Summer Cart Merchant'),(40,2,'OrderDescription','Покупка от Summer Cart Търговец'),(40,3,'OrderDescription','Summer Cart\'dan Sipariş'),(41,1,'OrderDescription','Order from Summer Cart Merchant'),(41,2,'OrderDescription','Покупка от Summer Cart Търговец'),(41,3,'OrderDescription','Summer Cart\'dan Sipariş'),(43,1,'OrderDescription','Order from Summer Cart Merchant'),(43,2,'OrderDescription','Покупка от Summer Cart Търговец'),(43,3,'OrderDescription','Summer Cart\'dan Sipariş'),(54,1,'OgonePageTitle','Summer Cart'),(54,2,'OgonePageTitle','Summer Cart'),(54,3,'OgonePageTitle','Summer Cart');
/*!40000 ALTER TABLE `ModuleOptionsML` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `ModuleTexts` WRITE;
/*!40000 ALTER TABLE `ModuleTexts` DISABLE KEYS */;
/*!40000 ALTER TABLE `ModuleTexts` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `News` WRITE;
/*!40000 ALTER TABLE `News` DISABLE KEYS */;
INSERT INTO `News` VALUES (1,'2009-03-21',1),(2,'2009-04-03',1);
/*!40000 ALTER TABLE `News` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `NewsML` WRITE;
/*!40000 ALTER TABLE `NewsML` DISABLE KEYS */;
INSERT INTO `NewsML` VALUES (1,1,'Store Is Open','The store is ready. We are proud with what has been accomplished!'),(1,2,'Магазинът е отворен','Онлайн магазинът е готов. Гордеем се с това което сме постигнали!'),(1,3,'Mağaza açık','Mağaza Hazır! Hazır Olmasıyla Gurur Duyuyoruz.'),(2,1,'New products','We have in stock new products. Choose from our large inventory of high quality items.'),(2,2,'Нови продукти','Имаме нови продукти на склад. Избирайте от нашия каталог с висококачествени артикули.'),(2,3,'Yeni ürünler','Stoklarımızda yeni ürünlerimiz var. Yüksek kaliteli ürünleri geniş envanterimizden seçiniz.');
/*!40000 ALTER TABLE `NewsML` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `OrderStatuses` WRITE;
/*!40000 ALTER TABLE `OrderStatuses` DISABLE KEYS */;
INSERT INTO `OrderStatuses` VALUES (1,1,1,0,0),(2,2,1,0,0),(3,3,1,0,0),(4,4,1,1,0),(5,5,1,0,0),(6,6,1,0,0),(7,7,1,0,0),(8,8,1,0,0),(9,9,1,0,0),(10,10,1,0,0);
/*!40000 ALTER TABLE `OrderStatuses` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `OrderStatusesML` WRITE;
/*!40000 ALTER TABLE `OrderStatusesML` DISABLE KEYS */;
INSERT INTO `OrderStatusesML` VALUES (1,1,'Unfinished'),(1,2,'Незавършена'),(1,3,'Unfinished'),(2,1,'Payment Failed'),(2,2,'Неосъществено плащане'),(2,3,'Payment Failed'),(3,1,'Payment Pending'),(3,2,'Очаква плащане'),(3,3,'Payment Pending'),(4,1,'New'),(4,2,'Нова'),(4,3,'New'),(5,1,'In Progress'),(5,2,'Обработва се'),(5,3,'In Progress'),(6,1,'Cancelled'),(6,2,'Отказана'),(6,3,'Cancelled'),(7,1,'On Hold'),(7,2,'Задържана'),(7,3,'On Hold'),(8,1,'Delivered'),(8,2,'Доставена'),(8,3,'Delivered'),(9,1,'Returned'),(9,2,'Върната'),(9,3,'Returned'),(10,1,'Queued'),(10,2,'Чакаща'),(10,3,'Queued');
/*!40000 ALTER TABLE `OrderStatusesML` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `OrderTotalModules` WRITE;
/*!40000 ALTER TABLE `OrderTotalModules` DISABLE KEYS */;
INSERT INTO `OrderTotalModules` VALUES (1,9,1,'Subtotal',1,1),(2,56,8,'Bonus Points',1,2),(3,12,2,'Shipping',1,3),(4,21,4,'Discount',1,4),(5,22,5,'Coupon',1,5),(6,11,6,'Tax',1,6),(7,24,3,'Collect On Delivery',1,7);
/*!40000 ALTER TABLE `OrderTotalModules` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `PaymentModules` WRITE;
/*!40000 ALTER TABLE `PaymentModules` DISABLE KEYS */;
INSERT INTO `PaymentModules` VALUES (1,7,'2Checkout','V2','skins/default/modules/payment/2checkout/logo_2checkout.png',0,1),(2,16,'Authorize.net Credit Card','SIM','skins/default/modules/payment/authorize/logo_authorize.net.png',0,2),(3,18,'Authorize.net Credit Card','AIM','skins/default/modules/payment/authorize/logo_authorize.net.png',0,3),(4,30,'Bank Wire Transfer','','skins/default/modules/payment/wire/logo_wire.png',0,4),(5,36,'Borica.bg','eBorica','skins/default/modules/payment/borica/logo_borica.png',0,5),(6,8,'Check','','skins/default/modules/payment/check/logo_check.png',1,6),(7,41,'ChronoPay','','skins/default/modules/payment/chronopay/chronopay.png',0,7),(8,23,'Collect On Delivery','','skins/default/modules/payment/cod/logo_cod.png',0,8),(9,6,'Credit Card','','skins/default/modules/payment/creditcard/logo_creditcard.png',1,9),(10,51,'DSK Direct','','skins/default/modules/payment/dskdirect/logo_dskdirect.png',0,10),(11,27,'ePay.bg','','skins/default/modules/payment/epay_bg/logo_epay.bg.png',0,11),(12,34,'ePay.bg PayDirect','','skins/default/modules/payment/epay_bg/logo_epay.bg.png',0,12),(13,42,'HSBC','CPI','skins/default/modules/payment/hsbc/logo_hsbc.png',0,13),(14,39,'Moneybookers','','skins/default/modules/payment/moneybookers/logo_moneybookers.png',0,14),(15,54,'Ogone','','skins/default/modules/payment/ogone/logo_ogone.png',0,15),(16,17,'PayPal','Website Payments Standard','skins/default/modules/payment/paypal/logo_paypal.png',0,16),(17,48,'PayPal Payflow Pro','','skins/default/modules/payment/paypal/logo_paypal.png',0,17),(18,40,'RBS WorldPay','Business Gateway / Select Junior','skins/default/modules/payment/rbsworldpay/logo_rbsworldpay.png',0,18),(19,31,'Sage Pay','VSP Form','skins/default/modules/payment/sagepay/logo_sagepay.png',0,19),(20,32,'Sage Pay','VSP Server','skins/default/modules/payment/sagepay/logo_sagepay.png',0,20),(21,33,'Sage Pay','VSP Direct','skins/default/modules/payment/sagepay/logo_sagepay.png',0,21),(22,43,'Transcard.bg','','skins/default/modules/payment/transcard_bg/logo_transcard.png',0,22),(23,52,'Turkish Banks Virtual POS','','skins/default/modules/payment/turkish_banks/logo_turkish_banks.png',0,23),(24,57,'Easypay.bg','','skins/default/modules/payment/epay_bg/logo_easypay.bg.png',0,24),(25,58,'FIBank','','skins/default/modules/payment/fibank_bg/logo_fibank.png',0,25),(26,60,'Moneris','Hosted page','skins/default/modules/payment/moneris/logo_moneris.png',0,26),(27,65,'CCNow','Hosted page','skins/default/modules/payment/ccnow/logo_ccnow.png',0,27),(28,66,'UBB.bg','Hosted page','skins/default/modules/payment/ubb_bg/logo_ubb.bg.png',0,28),(29,67,'Atos','SIPS','skins/default/modules/payment/atos/logo_atos.png',0,29),(30,69,'Realex','RealAuth Redirect','skins/default/modules/payment/realex/logo_realex.png',0,30);
/*!40000 ALTER TABLE `PaymentModules` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `PaymentModulesML` WRITE;
/*!40000 ALTER TABLE `PaymentModulesML` DISABLE KEYS */;
INSERT INTO `PaymentModulesML` VALUES (1,1,'2Checkout'),(1,2,'2Checkout'),(1,3,'2Checkout'),(2,1,'Authorize.net Credit Card'),(2,2,'Authorize.net с Кредитна Карта'),(2,3,'Authorize.net Kredi Kartı'),(3,1,'Authorize.net Credit Card'),(3,2,'Authorize.net с Кредитна Карта'),(3,3,'Authorize.net Kredi Kartı'),(4,1,'Bank Wire Transfer'),(4,2,'Банков превод'),(4,3,'Banka Havalesi'),(5,1,'Borica'),(5,2,'Борика'),(5,3,'Borica'),(6,1,'Check'),(6,2,'Чек'),(6,3,'Banka çeki'),(7,1,'ChronoPay'),(7,2,'ChronoPay'),(7,3,'ChronoPay'),(8,1,'Collect on delivery'),(8,2,'Наложен платеж'),(8,3,'Teslimatta Ödeme'),(9,1,'Credit Card'),(9,2,'Кредитна Карта'),(9,3,'Kredi Kartı'),(10,1,'DSK Direct'),(10,2,'ДСК Директ'),(10,3,'DSK Direct'),(11,1,'ePay.bg'),(11,2,'ePay.bg'),(11,3,'ePay.bg'),(12,1,'ePay.bg (credit card)'),(12,2,'ePay.bg (кредитна карта)'),(12,3,'ePay.bg (kredi kartı)'),(13,1,'HSBC'),(13,2,'HSBC'),(13,3,'HSBC'),(14,1,'Moneybookers'),(14,2,'Moneybookers'),(14,3,'Moneybookers'),(15,1,'Ogone'),(15,2,'Ogone'),(15,3,'Ogone'),(16,1,'PayPal'),(16,2,'PayPal'),(16,3,'PayPal'),(17,1,'PayPal Payflow Pro'),(17,2,'PayPal Payflow Pro'),(17,3,'PayPal Payflow Pro'),(18,1,'RBS WorldPay'),(18,2,'RBS WorldPay'),(18,3,'RBS WorldPay'),(19,1,'Sage Pay VSP Form'),(19,2,'Sage Pay VSP Form'),(19,3,'Sage Pay VSP Form'),(20,1,'Sage Pay VSP Server'),(20,2,'Sage Pay VSP Server'),(20,3,'Sage Pay VSP Server'),(21,1,'Sage Pay VSP Direct'),(21,2,'Sage Pay VSP Direct'),(21,3,'Sage Pay VSP Direct'),(22,1,'Transcard'),(22,2,'Транскарт'),(22,3,'Transcard'),(23,1,'Turkish Banks Virtual POS'),(23,2,'Виртуален терминал в турска банка'),(23,3,'Türkiye Bankaları Sanal Pos'),(24,1,'Easypay.bg'),(24,2,'Easypay.bg'),(24,3,'Easypay.bg'),(25,1,'FIBank'),(25,2,'FIBank'),(25,3,'FIBank'),(26,1,'Moneris'),(26,2,'Moneris'),(26,3,'Moneris'),(27,1,'CCNow'),(27,2,'CCNow'),(27,3,'CCNow'),(28,1,'UBB.bg'),(28,2,'ОББ'),(28,3,'UBB.bg'),(29,1,'Atos Worldline'),(29,2,'Atos Worldline'),(29,3,'Atos Worldline'),(30,1,'Realex'),(30,2,'Realex'),(30,3,'Realex');
/*!40000 ALTER TABLE `PaymentModulesML` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `Plugins` WRITE;
/*!40000 ALTER TABLE `Plugins` DISABLE KEYS */;
INSERT INTO `Plugins` VALUES (1,'Products Feed','',0,0,'','','1.0','');
/*!40000 ALTER TABLE `Plugins` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `Settings` WRITE;
/*!40000 ALTER TABLE `Settings` DISABLE KEYS */;
INSERT INTO `Settings` VALUES (2,'DefaultCountryID','1'),(3,'UseSSL','0'),(4,'PasswordHashMode','1'),(5,'FriendlyUrls','0'),(6,'SeoUrlsType','1'),(7,'WeightUnit','1'),(8,'MenuItemImageMaxWidth','50'),(9,'MenuItemImageMaxHeight','50'),(10,'LanguageImageMaxWidth','24'),(11,'LanguageImageMaxHeight','24'),(12,'BoxImageMaxWidth','50'),(13,'BoxImageMaxHeight','50'),(15,'SiteAdministratorEmail',''),(16,'OrderDepartmentEmail',''),(17,'HelpSupportEmail',''),(18,'ReplyToNotificationsEmail',''),(19,'ReplyToNewsletterEmail',''),(20,'MethodOfSendingEmails',''),(21,'SmtpHost',''),(22,'SmtpPort','25'),(23,'SmtpSecurity',''),(24,'UseSmtpAuthentication',''),(25,'SmtpUsername',''),(26,'SmtpPassword',''),(29,'CompanyState',''),(30,'CompanyCountry',''),(31,'CompanyZIP',''),(32,'CompanyPhone',''),(33,'CompanyPhone2',''),(34,'CompanyFax',''),(35,'CurrencyRateExpireDays','60'),(36,'ProductImageMaxWidth','300'),(37,'ProductImageMaxHeight','400'),(38,'ProductImageThumbMaxWidth','80'),(39,'ProductImageThumbMaxHeight','80'),(40,'ProductImageBoxMaxWidth','80'),(41,'ProductImageBoxMaxHeight','80'),(42,'ProductImageLargeMaxWidth','900'),(43,'ProductImageLargeMaxHeight','700'),(44,'ManufacturerImageMaxWidth','100'),(45,'ManufacturerImageMaxHeight','100'),(46,'InventoryTracking','0'),(47,'OutOfStockHandling','0'),(48,'NewProductsInFrontOfCategoryListings','0'),(49,'WholesalePrices','1'),(50,'NewProductsDays','10'),(51,'ProductComparisonMax','3'),(52,'DownloadTtlDays','48'),(53,'DownloadTtlDownloads','1'),(54,'AutoUnlockEgoods','0'),(55,'HomepageViewType','1'),(56,'DefaultCategoryViewType','1'),(57,'GridViewColumns','3'),(58,'GridViewRows','4'),(59,'ListViewProductsPerPage','10'),(60,'CategoryImageMaxWidth','64'),(61,'CategoryImageMaxHeight','64'),(62,'GalleryItemImageMaxWidth','400'),(63,'GalleryItemImageMaxHeight','300'),(64,'GalleryItemImageThumbMaxWidth','100'),(65,'GalleryItemImageThumbMaxHeight','100'),(66,'GalleryShowTableX','5'),(67,'GalleryShowTableY','10'),(68,'UsersAbleToRate','1'),(69,'UsersAbleToReview','1'),(70,'RatingActionsAutomaticApproval','3'),(71,'BonusPointsConversionRate','0.2000'),(72,'BonusPointsPurchaseEarn','3'),(73,'BonusPointsPurchaseLimit','2'),(74,'BonusPointsPurchaseLimitPeriod','1'),(75,'BonusPointsReferralEarn','5'),(76,'BonusPointsReferralLimit','0'),(77,'BonusPointsReferralLimitPeriod','1'),(78,'BonusPointsReferralCookieLifeInDays','30'),(79,'BonusPointsReviewEarn','3'),(80,'BonusPointsReviewLimit','10'),(81,'BonusPointsReviewLimitPeriod','4'),(82,'BonusPointsVoteEarn','1'),(83,'BonusPointsVoteLimit','10'),(84,'BonusPointsVoteLimitPeriod','4'),(85,'BonusPointsSpendAmount','1000.00'),(86,'BonusPointsSpendEarn','5'),(87,'BonusPointsOrderStatuses','8'),(88,'BonusPointsManualApproval','1'),(89,'BonusPointsManualSpending','0'),(90,'BonusPointsProductsDefaultMode','0'),(91,'DefaultProductOrder','0'),(92,'CaptchaOnRegister','0'),(93,'CaptchaOnRegisterInCheckout','0'),(94,'ShowUnfinishedOrders','0'),(95,'DefaultLanguageID','1'),(96,'DefaultCurrencyID','1'),(97,'SkinAdmin','1'),(98,'SkinCustomer','6'),(99,'DefaultCustomerGroupID','1');
/*!40000 ALTER TABLE `Settings` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `SettingsML` WRITE;
/*!40000 ALTER TABLE `SettingsML` DISABLE KEYS */;
INSERT INTO `SettingsML` VALUES (1,'CompanyAddress',''),(1,'CompanyAddress2',''),(1,'CompanyCity',''),(1,'CompanyName',''),(1,'SiteDescription',''),(1,'SiteKeywords',''),(1,'SiteTitle','%%COMPANY_NAME%%: %%PAGE_NAME%%'),(2,'CompanyAddress',''),(2,'CompanyAddress2',''),(2,'CompanyCity',''),(2,'CompanyName',''),(2,'SiteDescription',''),(2,'SiteKeywords',''),(2,'SiteTitle','%%COMPANY_NAME%%: %%PAGE_NAME%%'),(3,'CompanyAddress',''),(3,'CompanyAddress2',''),(3,'CompanyCity',''),(3,'CompanyName',''),(3,'SiteDescription',''),(3,'SiteKeywords',''),(3,'SiteTitle','%%COMPANY_NAME%%: %%PAGE_NAME%%');
/*!40000 ALTER TABLE `SettingsML` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `Skins` WRITE;
/*!40000 ALTER TABLE `Skins` DISABLE KEYS */;
INSERT INTO `Skins` VALUES (1,'Default','default',1,0,NULL,'skin-screenshot.png'),(2,'Skeleton','skeleton',0,0,NULL,'skin-screenshot.png'),(3,'Greeny 2','greeny2',0,1,2,'skin-screenshot.png'),(4,'Bookstore 2','bookstore2',0,1,2,'skin-screenshot.png'),(5,'Snow 2','snow2',0,1,2,'skin-screenshot.png'),(6,'Rainbow','rainbow',0,1,2,'skin-screenshot.png');
/*!40000 ALTER TABLE `Skins` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `SkinSettings` WRITE;
/*!40000 ALTER TABLE `SkinSettings` DISABLE KEYS */;
INSERT INTO `SkinSettings` VALUES (1,1,'Logo',3,'11:customer/images/summer_cart_logo.jpg'),(2,2,'Logo',3,'11:customer/images/logo.png'),(3,3,'Logo',3,'11:customer/images/logo.png'),(4,4,'Logo',3,'11:customer/images/logo.png'),(5,5,'Logo',3,'11:customer/images/logo.png'),(6,6,'Logo',3,'11:customer/images/logo.png'),(7,6,'ShowFooterIcons',2,'1');
/*!40000 ALTER TABLE `SkinSettings` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `States` WRITE;
/*!40000 ALTER TABLE `States` DISABLE KEYS */;
INSERT INTO `States` VALUES (1,233,'AL'),(2,233,'AK'),(3,233,'AZ'),(4,233,'AR'),(5,233,'AA'),(6,233,'AE'),(7,233,'AP'),(8,233,'CA'),(9,233,'CO'),(10,233,'CT'),(11,233,'DE'),(12,233,'DC'),(13,233,'FL'),(14,233,'GA'),(15,233,'HI'),(16,233,'ID'),(17,233,'IL'),(18,233,'IN'),(19,233,'IA'),(20,233,'KS'),(21,233,'KY'),(22,233,'LA'),(23,233,'ME'),(24,233,'MD'),(25,233,'MA'),(26,233,'MI'),(27,233,'MN'),(28,233,'MS'),(29,233,'MO'),(30,233,'MT'),(31,233,'NE'),(32,233,'NV'),(33,233,'NH'),(34,233,'NJ'),(35,233,'NM'),(36,233,'NY'),(37,233,'NC'),(38,233,'ND'),(39,233,'OH'),(40,233,'OK'),(41,233,'OR'),(42,233,'PA'),(43,233,'RI'),(44,233,'SC'),(45,233,'SD'),(46,233,'TN'),(47,233,'TX'),(48,233,'UT'),(49,233,'VT'),(50,233,'VA'),(51,233,'WA'),(52,233,'WV'),(53,233,'WI'),(54,233,'WY'),(55,39,'ON'),(56,39,'QC'),(57,39,'NS'),(58,39,'NB'),(59,39,'MB'),(60,39,'BC'),(61,39,'PE'),(62,39,'SK'),(63,39,'AB'),(64,39,'NL'),(65,39,'NT'),(66,39,'YT'),(67,39,'NU'),(68,14,'NSW'),(69,14,'QLD'),(70,14,'SA'),(71,14,'TAS'),(72,14,'VIC'),(73,14,'WA'),(74,14,'ACT'),(75,14,'NT'),(76,34,'BLG'),(77,34,'BGS'),(78,34,'VAR'),(79,34,'VTR'),(80,34,'VID'),(81,34,'VRC'),(82,34,'GAB'),(83,34,'DOB'),(84,34,'KRZ'),(85,34,'KNL'),(86,34,'LOV'),(87,34,'MON'),(88,34,'PAZ'),(89,34,'PER'),(90,34,'PVN'),(91,34,'PDV'),(92,34,'RAZ'),(93,34,'RSE'),(94,34,'SLS'),(95,34,'SLV'),(96,34,'SML'),(97,34,'SFO'),(98,34,'SOF'),(99,34,'SZR'),(100,34,'TGV'),(101,34,'HKV'),(102,34,'SHU'),(103,34,'JAM');
/*!40000 ALTER TABLE `States` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `StatesML` WRITE;
/*!40000 ALTER TABLE `StatesML` DISABLE KEYS */;
INSERT INTO `StatesML` VALUES (1,1,'Alabama'),(2,1,'Alaska'),(63,1,'Alberta'),(3,1,'Arizona'),(4,1,'Arkansas'),(5,1,'Armed Forces Americas'),(6,1,'Armed Forces Europe'),(7,1,'Armed Forces Pacific'),(74,1,'Australian Capital Territory'),(76,1,'Blagoevgrad'),(60,1,'British Columbia'),(77,1,'Burgas'),(8,1,'California'),(9,1,'Colorado'),(10,1,'Connecticut'),(11,1,'Delaware'),(12,1,'District of Columbia'),(83,1,'Dobrich'),(13,1,'Florida'),(82,1,'Gabrovo'),(14,1,'Georgia'),(101,1,'Haskovo'),(15,1,'Hawaii'),(16,1,'Idaho'),(17,1,'Illinois'),(18,1,'Indiana'),(19,1,'Iowa'),(20,1,'Kansas'),(84,1,'Kardzhali'),(21,1,'Kentucky'),(85,1,'Kyustendil'),(22,1,'Louisiana'),(86,1,'Lovech'),(23,1,'Maine'),(59,1,'Manitoba'),(24,1,'Maryland'),(25,1,'Massachusetts'),(26,1,'Michigan'),(27,1,'Minnesota'),(28,1,'Mississippi'),(29,1,'Missouri'),(30,1,'Montana'),(87,1,'Montana'),(31,1,'Nebraska'),(32,1,'Nevada'),(58,1,'New Brunswick'),(33,1,'New Hampshire'),(34,1,'New Jersey'),(35,1,'New Mexico'),(68,1,'New South Wales'),(36,1,'New York'),(64,1,'Newfoundland and Labrador'),(37,1,'North Carolina'),(38,1,'North Dakota'),(75,1,'Northern Territory'),(65,1,'Northwest Territories'),(57,1,'Nova Scotia'),(67,1,'Nunavut'),(39,1,'Ohio'),(40,1,'Oklahoma'),(55,1,'Ontario'),(41,1,'Oregon'),(88,1,'Pazardzhik'),(42,1,'Pennsylvania'),(89,1,'Pernik'),(90,1,'Pleven'),(91,1,'Plovdiv'),(61,1,'Prince Edward Island'),(56,1,'Quebec'),(69,1,'Queensland'),(92,1,'Razgrad'),(43,1,'Rhode Island'),(93,1,'Ruse'),(62,1,'Saskatchewan'),(102,1,'Shumen'),(94,1,'Silistra'),(95,1,'Sliven'),(96,1,'Smolyan'),(97,1,'Sofia'),(98,1,'Sofia - Grad'),(70,1,'South Australia'),(44,1,'South Carolina'),(45,1,'South Dakota'),(99,1,'Stara Zagora'),(100,1,'Targovishte'),(71,1,'Tasmania'),(46,1,'Tennessee'),(47,1,'Texas'),(48,1,'Utah'),(78,1,'Varna'),(79,1,'Veliko Tarnovo'),(49,1,'Vermont'),(72,1,'Victoria'),(80,1,'Vidin'),(50,1,'Virginia'),(81,1,'Vratsa'),(51,1,'Washington'),(52,1,'West Virginia'),(73,1,'Western Australia'),(53,1,'Wisconsin'),(54,1,'Wyoming'),(103,1,'Yambol'),(66,1,'Yukon'),(74,2,'Австралийска столична територия'),(16,2,'Айдахо'),(19,2,'Айова'),(1,2,'Алабама'),(63,2,'Албърта'),(2,2,'Аляска'),(3,2,'Аризона'),(4,2,'Арканзас'),(76,2,'Благоевград'),(60,2,'Британска Колумбия'),(77,2,'Бургас'),(78,2,'Варна'),(51,2,'Вашингтон'),(79,2,'Велико Търново'),(49,2,'Вермонт'),(80,2,'Видин'),(72,2,'Виктория'),(50,2,'Вирджиния'),(81,2,'Враца'),(5,2,'Въоръжени сили (Америка)'),(6,2,'Въоръжени сили (Европа)'),(7,2,'Въоръжени сили (Тихия Океан)'),(82,2,'Габрово'),(11,2,'Делауеър'),(14,2,'Джорджия'),(83,2,'Добрич'),(73,2,'Западна Австралия'),(52,2,'Западна Вирджиния'),(17,2,'Илинойс'),(18,2,'Индиана'),(8,2,'Калифорния'),(20,2,'Канзас'),(56,2,'Квебек'),(21,2,'Кентъки'),(9,2,'Колорадо'),(69,2,'Куинсланд'),(10,2,'Кънектикът'),(84,2,'Кърджали'),(85,2,'Кюстендил'),(86,2,'Ловеч'),(22,2,'Луизиана'),(59,2,'Манитоба'),(25,2,'Масачузетс'),(23,2,'Мейн'),(24,2,'Мериленд'),(27,2,'Минесота'),(28,2,'Мисисипи'),(29,2,'Мисури'),(26,2,'Мичиган'),(30,2,'Монтана'),(87,2,'Монтана'),(31,2,'Небраска'),(32,2,'Невада'),(68,2,'Нов Южен Уелс'),(57,2,'Нова Скотия'),(67,2,'Нунавут'),(58,2,'Ню Брунсуик'),(34,2,'Ню Джърси'),(36,2,'Ню Йорк'),(35,2,'Ню Мексико'),(33,2,'Ню Хампшир'),(64,2,'Нюфаундленд и Лабрадор'),(40,2,'Оклахома'),(12,2,'Окръг Колумбия'),(55,2,'Онтарио'),(41,2,'Орегон'),(61,2,'Остров Принц Едуард'),(39,2,'Охайо'),(88,2,'Пазарджик'),(42,2,'Пенсилвания'),(89,2,'Перник'),(90,2,'Плевен'),(91,2,'Пловдив'),(92,2,'Разград'),(43,2,'Род Айлънд'),(93,2,'Русе'),(38,2,'Северна Дакота'),(37,2,'Северна Каролина'),(75,2,'Северна територия'),(65,2,'Северозападни територии'),(94,2,'Силистра'),(95,2,'Сливен'),(96,2,'Смолян'),(97,2,'София'),(98,2,'София - Град'),(99,2,'Стара Загора'),(62,2,'Съскачеуан'),(71,2,'Тасмания'),(47,2,'Тексас'),(46,2,'Тенеси'),(100,2,'Търговище'),(54,2,'Уайоминг'),(53,2,'Уисконсин'),(13,2,'Флорида'),(15,2,'Хаваи'),(101,2,'Хасково'),(102,2,'Шумен'),(70,2,'Южна Австралия'),(45,2,'Южна Дакота'),(44,2,'Южна Каролина'),(66,2,'Юкон'),(48,2,'Юта'),(103,2,'Ямбол'),(1,3,'Alabama'),(2,3,'Alaska'),(63,3,'Alberta'),(5,3,'Amerikan Silahlı Kuvvetler'),(3,3,'Arizona'),(4,3,'Arkansas'),(6,3,'Avrupa Silahlı Kuvvetleri'),(74,3,'Avustralya Başkent Bölgesi'),(73,3,'Batı Avustralya'),(52,3,'Batı Virjinya'),(76,3,'Blagoevgrad'),(60,3,'British Columbia'),(77,3,'Burgas'),(10,3,'Connecticut'),(11,3,'Delaware'),(83,3,'Dobrich'),(13,3,'Florida'),(82,3,'Gabrovo'),(14,3,'Georgia'),(70,3,'Güney Avustralya'),(44,3,'Güney Carolina'),(45,3,'Güney Dakota'),(101,3,'Haskovo'),(15,3,'Havai'),(16,3,'Idaho'),(17,3,'Illinois'),(18,3,'Indiana'),(19,3,'Iowa'),(8,3,'Kaliforniya'),(20,3,'Kansas'),(84,3,'Kardzhali'),(21,3,'Kentucky'),(12,3,'Kolombiya Bölgesi'),(9,3,'Kolorado'),(75,3,'Kuzey Bölgesi'),(37,3,'Kuzey Carolina'),(38,3,'Kuzey Dakota'),(65,3,'Kuzeybatı Toprakları'),(85,3,'Kyustendil'),(22,3,'Louisiana'),(86,3,'Lovech'),(23,3,'Maine'),(59,3,'Manitoba'),(24,3,'Maryland'),(25,3,'Massachusetts'),(26,3,'Michigan'),(27,3,'Minnesota'),(28,3,'Mississippi'),(29,3,'Missouri'),(30,3,'Montana'),(87,3,'Montana'),(31,3,'Nebraska'),(32,3,'Nevada'),(58,3,'New Brunswick'),(33,3,'New Hampshire'),(34,3,'New Jersey'),(35,3,'New Mexico'),(36,3,'New York'),(64,3,'Newfoundland and Labrador'),(57,3,'Nova Scotia'),(67,3,'Nunavut'),(39,3,'Ohio'),(40,3,'Oklahoma'),(55,3,'Ontario'),(41,3,'Oregon'),(7,3,'Pasifik Silahlı Kuvvetleri'),(88,3,'Pazardzhik'),(42,3,'Pensilvanya'),(89,3,'Pernik'),(90,3,'Pleven'),(91,3,'Plovdiv'),(61,3,'Prens Edward Adası'),(56,3,'Quebec'),(69,3,'Queensland'),(92,3,'Razgrad'),(43,3,'Rhode Adası'),(93,3,'Ruse'),(62,3,'Saskatchewan'),(102,3,'Shumen'),(94,3,'Silistra'),(95,3,'Sliven'),(96,3,'Smolyan'),(97,3,'Sofia'),(98,3,'Sofia - Grad'),(99,3,'Stara Zagora'),(100,3,'Targovishte'),(71,3,'Tazmanya'),(47,3,'Teksas'),(46,3,'Tennessee'),(48,3,'Utah'),(78,3,'Varna'),(79,3,'Veliko Tarnovo'),(49,3,'Vermont'),(80,3,'Vidin'),(72,3,'Viktorya'),(50,3,'Virjinya'),(81,3,'Vratsa'),(51,3,'Washington'),(53,3,'Wisconsin'),(54,3,'Wyoming'),(103,3,'Yambol'),(68,3,'Yeni Güney Galler'),(66,3,'Yukon');
/*!40000 ALTER TABLE `StatesML` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `Cities` WRITE;
/*!40000 ALTER TABLE `Cities` DISABLE KEYS */;
INSERT INTO `Cities` VALUES (1,76),(5,76),(93,76),(119,76),(139,76),(146,76),(148,76),(157,76),(173,76),(199,76),(203,76),(207,76),(224,76),(231,76),(252,76),(271,76),(293,76),(299,76),(310,76),(342,76),(349,76),(360,76),(425,76),(426,76),(488,76),(495,76),(515,76),(542,76),(560,76),(567,76),(581,76),(601,76),(647,76),(703,76),(755,76),(769,76),(773,76),(792,76),(834,76),(843,76),(850,76),(876,76),(878,76),(934,76),(943,76),(957,76),(971,76),(981,76),(1039,76),(1040,76),(1045,76),(1061,76),(1100,76),(1113,76),(1128,76),(1137,76),(1141,76),(1170,76),(1171,76),(1177,76),(1183,76),(1190,76),(1193,76),(1223,76),(1227,76),(1231,76),(1232,76),(1233,76),(1308,76),(1318,76),(1326,76),(1332,76),(1335,76),(1353,76),(1354,76),(1355,76),(1376,76),(1380,76),(1399,76),(1458,76),(1461,76),(1480,76),(1486,76),(1494,76),(1497,76),(1500,76),(1501,76),(1516,76),(1525,76),(1535,76),(1571,76),(1572,76),(1584,76),(1590,76),(1650,76),(1655,76),(1658,76),(1667,76),(1670,76),(1671,76),(1725,76),(1735,76),(1786,76),(1800,76),(1805,76),(1852,76),(1872,76),(1924,76),(1965,76),(1989,76),(2006,76),(2023,76),(2024,76),(2039,76),(2062,76),(2081,76),(2094,76),(2096,76),(2139,76),(2160,76),(2195,76),(2205,76),(2229,76),(2285,76),(2289,76),(2327,76),(2333,76),(2340,76),(2348,76),(2361,76),(2362,76),(2405,76),(2412,76),(2428,76),(2459,76),(2470,76),(2510,76),(2528,76),(2560,76),(2569,76),(2572,76),(2591,76),(2603,76),(2610,76),(2626,76),(2633,76),(2640,76),(2645,76),(2648,76),(2677,76),(2678,76),(2681,76),(2697,76),(2707,76),(2710,76),(2718,76),(2744,76),(2746,76),(2750,76),(2754,76),(2762,76),(2777,76),(2791,76),(2804,76),(2829,76),(2833,76),(2849,76),(2850,76),(2862,76),(2920,76),(2985,76),(2987,76),(2999,76),(3001,76),(3008,76),(3032,76),(3036,76),(3040,76),(3053,76),(3059,76),(3091,76),(3102,76),(3157,76),(3182,76),(3265,76),(3274,76),(3297,76),(3299,76),(3300,76),(3303,76),(3311,76),(3327,76),(3329,76),(3356,76),(3394,76),(3420,76),(3434,76),(3438,76),(3442,76),(3469,76),(3478,76),(3489,76),(3490,76),(3516,76),(3571,76),(3573,76),(3577,76),(3592,76),(3598,76),(3630,76),(3639,76),(3673,76),(3674,76),(3675,76),(3678,76),(3763,76),(3859,76),(3944,76),(3946,76),(3961,76),(4025,76),(4027,76),(4032,76),(4053,76),(4094,76),(4112,76),(4132,76),(4150,76),(4152,76),(4156,76),(4165,76),(4211,76),(4225,76),(4244,76),(4265,76),(4299,76),(4308,76),(4311,76),(4344,76),(4354,76),(4378,76),(4434,76),(4492,76),(4515,76),(4533,76),(4595,76),(4596,76),(4597,76),(4617,76),(4632,76),(4635,76),(4687,76),(4697,76),(4725,76),(4731,76),(4772,76),(4804,76),(4865,76),(4873,76),(4881,76),(4897,76),(4910,76),(4915,76),(4928,76),(4934,76),(4983,76),(5058,76),(5060,76),(5077,76),(5095,76),(5169,76),(5170,76),(5174,76),(5235,76),(5247,76),(5262,76),(5264,76),(5274,76),(5307,76),(5315,76),(5333,76),(5336,76),(5337,76),(5342,76),(5346,76),(5349,76),(5351,76),(13,77),(25,77),(72,77),(76,77),(79,77),(82,77),(113,77),(149,77),(158,77),(208,77),(221,77),(238,77),(269,77),(279,77),(290,77),(312,77),(334,77),(438,77),(478,77),(518,77),(529,77),(537,77),(569,77),(593,77),(597,77),(629,77),(652,77),(659,77),(673,77),(674,77),(678,77),(690,77),(705,77),(716,77),(745,77),(749,77),(774,77),(855,77),(861,77),(884,77),(890,77),(925,77),(930,77),(947,77),(1027,77),(1083,77),(1103,77),(1196,77),(1200,77),(1257,77),(1260,77),(1265,77),(1276,77),(1303,77),(1325,77),(1348,77),(1362,77),(1365,77),(1390,77),(1425,77),(1443,77),(1462,77),(1473,77),(1596,77),(1616,77),(1623,77),(1635,77),(1654,77),(1662,77),(1677,77),(1689,77),(1724,77),(1732,77),(1766,77),(1767,77),(1771,77),(1779,77),(1793,77),(1821,77),(1835,77),(1850,77),(1861,77),(1883,77),(1897,77),(1900,77),(1910,77),(1917,77),(1918,77),(1936,77),(1941,77),(1975,77),(1977,77),(1980,77),(2029,77),(2066,77),(2072,77),(2082,77),(2102,77),(2108,77),(2134,77),(2170,77),(2196,77),(2211,77),(2215,77),(2217,77),(2222,77),(2242,77),(2243,77),(2257,77),(2271,77),(2307,77),(2316,77),(2319,77),(2334,77),(2335,77),(2378,77),(2387,77),(2394,77),(2431,77),(2444,77),(2478,77),(2490,77),(2496,77),(2519,77),(2600,77),(2609,77),(2620,77),(2634,77),(2636,77),(2756,77),(2779,77),(2793,77),(2801,77),(2805,77),(2830,77),(2856,77),(2868,77),(2903,77),(2911,77),(2935,77),(2976,77),(2986,77),(3023,77),(3088,77),(3108,77),(3135,77),(3165,77),(3186,77),(3193,77),(3216,77),(3243,77),(3302,77),(3328,77),(3355,77),(3405,77),(3409,77),(3503,77),(3590,77),(3600,77),(3607,77),(3618,77),(3652,77),(3656,77),(3692,77),(3701,77),(3707,77),(3737,77),(3773,77),(3789,77),(3792,77),(3794,77),(3797,77),(3800,77),(3820,77),(3827,77),(3839,77),(3853,77),(3876,77),(3877,77),(3882,77),(3885,77),(3922,77),(3934,77),(3965,77),(3966,77),(3973,77),(4008,77),(4017,77),(4051,77),(4062,77),(4065,77),(4076,77),(4078,77),(4082,77),(4098,77),(4106,77),(4117,77),(4133,77),(4158,77),(4174,77),(4178,77),(4196,77),(4259,77),(4270,77),(4273,77),(4278,77),(4289,77),(4291,77),(4329,77),(4347,77),(4360,77),(4380,77),(4389,77),(4393,77),(4397,77),(4403,77),(4408,77),(4441,77),(4448,77),(4536,77),(4576,77),(4600,77),(4621,77),(4628,77),(4641,77),(4644,77),(4650,77),(4676,77),(4691,77),(4729,77),(4744,77),(4754,77),(4775,77),(4781,77),(4791,77),(4811,77),(4860,77),(4861,77),(4883,77),(4952,77),(4978,77),(5054,77),(5071,77),(5078,77),(5086,77),(5094,77),(5099,77),(5106,77),(5112,77),(5151,77),(5156,77),(5185,77),(5243,77),(5293,77),(5295,77),(5310,77),(5317,77),(5318,77),(5331,77),(5345,77),(7,78),(16,78),(59,78),(73,78),(145,78),(236,78),(246,78),(255,78),(313,78),(316,78),(375,78),(396,78),(435,78),(447,78),(462,78),(504,78),(564,78),(603,78),(612,78),(626,78),(656,78),(692,78),(704,78),(709,78),(728,78),(804,78),(816,78),(870,78),(888,78),(948,78),(976,78),(977,78),(978,78),(1062,78),(1102,78),(1104,78),(1225,78),(1242,78),(1277,78),(1345,78),(1369,78),(1391,78),(1453,78),(1460,78),(1470,78),(1476,78),(1483,78),(1508,78),(1562,78),(1687,78),(1739,78),(1756,78),(1769,78),(1789,78),(1836,78),(1879,78),(1930,78),(1942,78),(1949,78),(1956,78),(1993,78),(2025,78),(2057,78),(2073,78),(2079,78),(2083,78),(2116,78),(2147,78),(2148,78),(2161,78),(2175,78),(2194,78),(2197,78),(2250,78),(2300,78),(2317,78),(2320,78),(2323,78),(2338,78),(2417,78),(2422,78),(2442,78),(2538,78),(2554,78),(2579,78),(2581,78),(2596,78),(2604,78),(2651,78),(2716,78),(2819,78),(2837,78),(2964,78),(3020,78),(3042,78),(3097,78),(3107,78),(3142,78),(3218,78),(3238,78),(3241,78),(3250,78),(3280,78),(3281,78),(3301,78),(3333,78),(3343,78),(3391,78),(3435,78),(3479,78),(3517,78),(3575,78),(3704,78),(3721,78),(3795,78),(3801,78),(3806,78),(3821,78),(3845,78),(3879,78),(3883,78),(3897,78),(3900,78),(3941,78),(4074,78),(4079,78),(4124,78),(4134,78),(4147,78),(4268,78),(4316,78),(4330,78),(4366,78),(4390,78),(4418,78),(4453,78),(4501,78),(4512,78),(4520,78),(4572,78),(4578,78),(4616,78),(4727,78),(4792,78),(4803,78),(4912,78),(4953,78),(4988,78),(5009,78),(5050,78),(5067,78),(5082,78),(5114,78),(5209,78),(5221,78),(5229,78),(5233,78),(5252,78),(5281,78),(5320,78),(5322,78),(5341,78),(5354,78),(22,79),(26,79),(48,79),(55,79),(68,79),(94,79),(99,79),(102,79),(104,79),(117,79),(127,79),(129,79),(159,79),(181,79),(197,79),(249,79),(253,79),(268,79),(275,79),(300,79),(317,79),(337,79),(381,79),(386,79),(389,79),(436,79),(457,79),(465,79),(474,79),(498,79),(527,79),(533,79),(548,79),(554,79),(575,79),(600,79),(633,79),(638,79),(642,79),(650,79),(654,79),(683,79),(695,79),(698,79),(702,79),(717,79),(729,79),(746,79),(753,79),(766,79),(776,79),(784,79),(808,79),(812,79),(822,79),(839,79),(869,79),(892,79),(893,79),(903,79),(909,79),(916,79),(917,79),(920,79),(933,79),(946,79),(965,79),(970,79),(1020,79),(1048,79),(1049,79),(1098,79),(1101,79),(1130,79),(1136,79),(1140,79),(1142,79),(1153,79),(1159,79),(1204,79),(1206,79),(1207,79),(1210,79),(1214,79),(1215,79),(1216,79),(1217,79),(1258,79),(1315,79),(1328,79),(1334,79),(1344,79),(1347,79),(1364,79),(1371,79),(1373,79),(1379,79),(1384,79),(1392,79),(1402,79),(1418,79),(1422,79),(1424,79),(1436,79),(1448,79),(1457,79),(1490,79),(1499,79),(1527,79),(1534,79),(1546,79),(1553,79),(1559,79),(1595,79),(1604,79),(1617,79),(1620,79),(1622,79),(1627,79),(1628,79),(1631,79),(1645,79),(1673,79),(1702,79),(1706,79),(1713,79),(1752,79),(1762,79),(1765,79),(1795,79),(1820,79),(1847,79),(1967,79),(1990,79),(2036,79),(2044,79),(2049,79),(2060,79),(2090,79),(2091,79),(2098,79),(2127,79),(2138,79),(2153,79),(2189,79),(2199,79),(2226,79),(2247,79),(2248,79),(2256,79),(2259,79),(2294,79),(2298,79),(2301,79),(2314,79),(2329,79),(2339,79),(2347,79),(2370,79),(2374,79),(2379,79),(2390,79),(2395,79),(2404,79),(2440,79),(2476,79),(2488,79),(2509,79),(2556,79),(2587,79),(2601,79),(2614,79),(2664,79),(2665,79),(2673,79),(2695,79),(2699,79),(2720,79),(2729,79),(2730,79),(2795,79),(2843,79),(2865,79),(2886,79),(2921,79),(2952,79),(2982,79),(2984,79),(2989,79),(3003,79),(3004,79),(3009,79),(3038,79),(3057,79),(3077,79),(3078,79),(3083,79),(3089,79),(3100,79),(3106,79),(3132,79),(3145,79),(3181,79),(3196,79),(3212,79),(3223,79),(3230,79),(3246,79),(3251,79),(3261,79),(3262,79),(3266,79),(3268,79),(3270,79),(3296,79),(3304,79),(3313,79),(3325,79),(3326,79),(3340,79),(3342,79),(3390,79),(3413,79),(3430,79),(3470,79),(3474,79),(3486,79),(3494,79),(3514,79),(3520,79),(3527,79),(3537,79),(3561,79),(3565,79),(3595,79),(3603,79),(3614,79),(3669,79),(3679,79),(3693,79),(3694,79),(3724,79),(3731,79),(3732,79),(3755,79),(3802,79),(3809,79),(3834,79),(3844,79),(3861,79),(3864,79),(3895,79),(3898,79),(3912,79),(3918,79),(3947,79),(3950,79),(3953,79),(3976,79),(3989,79),(3994,79),(3998,79),(4006,79),(4010,79),(4014,79),(4048,79),(4068,79),(4071,79),(4101,79),(4105,79),(4108,79),(4142,79),(4148,79),(4185,79),(4195,79),(4220,79),(4239,79),(4358,79),(4365,79),(4395,79),(4450,79),(4454,79),(4478,79),(4524,79),(4542,79),(4556,79),(4565,79),(4575,79),(4580,79),(4619,79),(4623,79),(4626,79),(4636,79),(4638,79),(4653,79),(4684,79),(4690,79),(4702,79),(4716,79),(4719,79),(4722,79),(4742,79),(4786,79),(4797,79),(4810,79),(4817,79),(4841,79),(4856,79),(4878,79),(4892,79),(4909,79),(4919,79),(4926,79),(4948,79),(4960,79),(4963,79),(4975,79),(4979,79),(4989,79),(5006,79),(5012,79),(5043,79),(5049,79),(5089,79),(5126,79),(5135,79),(5158,79),(5183,79),(5184,79),(5187,79),(5188,79),(5210,79),(5213,79),(5263,79),(5266,79),(5275,79),(15,80),(45,80),(64,80),(120,80),(200,80),(201,80),(232,80),(237,80),(383,80),(407,80),(423,80),(443,80),(448,80),(463,80),(475,80),(485,80),(555,80),(735,80),(737,80),(747,80),(786,80),(806,80),(810,80),(825,80),(862,80),(887,80),(894,80),(910,80),(913,80),(922,80),(959,80),(980,80),(1050,80),(1096,80),(1154,80),(1235,80),(1251,80),(1253,80),(1261,80),(1264,80),(1312,80),(1327,80),(1378,80),(1420,80),(1429,80),(1430,80),(1541,80),(1550,80),(1653,80),(1669,80),(1680,80),(1707,80),(1742,80),(1753,80),(1761,80),(1843,80),(2045,80),(2067,80),(2071,80),(2103,80),(2157,80),(2162,80),(2225,80),(2235,80),(2263,80),(2302,80),(2331,80),(2479,80),(2483,80),(2501,80),(2516,80),(2559,80),(2639,80),(2647,80),(2662,80),(2696,80),(2885,80),(2893,80),(2901,80),(3016,80),(3022,80),(3076,80),(3220,80),(3305,80),(3317,80),(3397,80),(3398,80),(3458,80),(3467,80),(3549,80),(3585,80),(3615,80),(3631,80),(3655,80),(3671,80),(3677,80),(3766,80),(3814,80),(3823,80),(3873,80),(3875,80),(3963,80),(3967,80),(3995,80),(4012,80),(4040,80),(4085,80),(4096,80),(4139,80),(4249,80),(4266,80),(4305,80),(4336,80),(4337,80),(4359,80),(4438,80),(4458,80),(4472,80),(4510,80),(4593,80),(4709,80),(4721,80),(4734,80),(4735,80),(4749,80),(4815,80),(4829,80),(4868,80),(4887,80),(4941,80),(4942,80),(4959,80),(5100,80),(5137,80),(5141,80),(5166,80),(5189,80),(5194,80),(5203,80),(5277,80),(5284,80),(5288,80),(37,81),(138,81),(168,81),(216,81),(353,81),(420,81),(449,81),(453,81),(522,81),(556,81),(574,81),(605,81),(611,81),(615,81),(637,81),(721,81),(757,81),(791,81),(818,81),(852,81),(857,81),(900,81),(904,81),(926,81),(961,81),(962,81),(964,81),(1010,81),(1025,81),(1054,81),(1091,81),(1111,81),(1126,81),(1145,81),(1185,81),(1238,81),(1358,81),(1472,81),(1485,81),(1512,81),(1523,81),(1542,81),(1663,81),(1763,81),(1809,81),(1945,81),(1954,81),(2012,81),(2058,81),(2156,81),(2212,81),(2262,81),(2391,81),(2418,81),(2489,81),(2525,81),(2547,81),(2570,81),(2573,81),(2584,81),(2617,81),(2653,81),(2657,81),(2735,81),(2740,81),(2758,81),(2764,81),(2770,81),(2859,81),(2860,81),(2861,81),(2943,81),(2949,81),(2968,81),(2995,81),(3029,81),(3056,81),(3094,81),(3146,81),(3162,81),(3245,81),(3247,81),(3423,81),(3425,81),(3427,81),(3444,81),(3453,81),(3463,81),(3465,81),(3475,81),(3717,81),(3833,81),(3915,81),(3957,81),(4001,81),(4042,81),(4060,81),(4104,81),(4161,81),(4223,81),(4277,81),(4282,81),(4400,81),(4428,81),(4451,81),(4503,81),(4557,81),(4598,81),(4701,81),(4708,81),(4710,81),(4763,81),(4819,81),(4821,81),(4849,81),(4872,81),(4885,81),(4923,81),(4927,81),(4931,81),(4949,81),(5028,81),(5133,81),(9,82),(10,82),(42,82),(60,82),(61,82),(101,82),(103,82),(114,82),(115,82),(118,82),(122,82),(134,82),(135,82),(142,82),(165,82),(171,82),(198,82),(225,82),(242,82),(265,82),(276,82),(280,82),(318,82),(319,82),(328,82),(340,82),(363,82),(385,82),(387,82),(391,82),(405,82),(432,82),(489,82),(526,82),(571,82),(582,82),(594,82),(604,82),(606,82),(641,82),(649,82),(676,82),(694,82),(696,82),(700,82),(731,82),(788,82),(789,82),(790,82),(794,82),(827,82),(828,82),(841,82),(846,82),(874,82),(877,82),(944,82),(954,82),(955,82),(958,82),(966,82),(967,82),(985,82),(986,82),(987,82),(988,82),(992,82),(995,82),(1015,82),(1028,82),(1031,82),(1043,82),(1052,82),(1053,82),(1138,82),(1146,82),(1148,82),(1150,82),(1155,82),(1157,82),(1161,82),(1197,82),(1224,82),(1228,82),(1245,82),(1248,82),(1281,82),(1302,82),(1320,82),(1333,82),(1336,82),(1343,82),(1349,82),(1387,82),(1404,82),(1407,82),(1410,82),(1415,82),(1434,82),(1438,82),(1449,82),(1451,82),(1474,82),(1544,82),(1547,82),(1552,82),(1556,82),(1560,82),(1602,82),(1603,82),(1606,82),(1611,82),(1621,82),(1624,82),(1626,82),(1632,82),(1643,82),(1661,82),(1695,82),(1700,82),(1704,82),(1714,82),(1717,82),(1718,82),(1758,82),(1764,82),(1776,82),(1791,82),(1804,82),(1822,82),(1828,82),(1868,82),(1890,82),(1934,82),(1961,82),(1968,82),(1971,82),(1991,82),(2034,82),(2037,82),(2038,82),(2054,82),(2061,82),(2063,82),(2089,82),(2106,82),(2109,82),(2126,82),(2171,82),(2186,82),(2220,82),(2246,82),(2249,82),(2253,82),(2277,82),(2279,82),(2288,82),(2291,82),(2292,82),(2297,82),(2311,82),(2313,82),(2349,82),(2350,82),(2371,82),(2384,82),(2399,82),(2413,82),(2415,82),(2429,82),(2462,82),(2467,82),(2469,82),(2474,82),(2477,82),(2484,82),(2494,82),(2543,82),(2568,82),(2611,82),(2624,82),(2627,82),(2631,82),(2632,82),(2642,82),(2650,82),(2654,82),(2682,82),(2728,82),(2787,82),(2792,82),(2905,82),(2906,82),(2915,82),(2917,82),(2919,82),(2950,82),(2953,82),(2974,82),(2979,82),(2990,82),(3000,82),(3006,82),(3028,82),(3051,82),(3068,82),(3073,82),(3096,82),(3103,82),(3104,82),(3109,82),(3114,82),(3121,82),(3149,82),(3163,82),(3167,82),(3169,82),(3185,82),(3231,82),(3236,82),(3239,82),(3248,82),(3252,82),(3263,82),(3283,82),(3322,82),(3323,82),(3339,82),(3370,82),(3416,82),(3468,82),(3473,82),(3519,82),(3538,82),(3539,82),(3544,82),(3562,82),(3566,82),(3579,82),(3582,82),(3622,82),(3625,82),(3626,82),(3648,82),(3711,82),(3712,82),(3725,82),(3728,82),(3733,82),(3748,82),(3767,82),(3785,82),(3811,82),(3862,82),(3865,82),(3866,82),(3899,82),(3902,82),(3908,82),(3919,82),(3921,82),(3931,82),(3954,82),(3955,82),(3975,82),(3986,82),(3987,82),(3988,82),(3992,82),(4002,82),(4034,82),(4047,82),(4081,82),(4089,82),(4093,82),(4103,82),(4121,82),(4123,82),(4138,82),(4190,82),(4193,82),(4210,82),(4217,82),(4219,82),(4227,82),(4237,82),(4241,82),(4254,82),(4297,82),(4306,82),(4317,82),(4361,82),(4371,82),(4409,82),(4415,82),(4429,82),(4433,82),(4469,82),(4486,82),(4487,82),(4498,82),(4525,82),(4532,82),(4539,82),(4543,82),(4544,82),(4548,82),(4550,82),(4561,82),(4601,82),(4631,82),(4639,82),(4662,82),(4666,82),(4712,82),(4717,82),(4718,82),(4724,82),(4745,82),(4756,82),(4782,82),(4793,82),(4796,82),(4799,82),(4831,82),(4840,82),(4845,82),(4848,82),(4874,82),(4875,82),(4876,82),(4891,82),(4900,82),(4920,82),(4946,82),(4967,82),(5007,82),(5013,82),(5021,82),(5045,82),(5083,82),(5101,82),(5136,82),(5160,82),(5164,82),(5178,82),(5197,82),(5211,82),(5215,82),(5219,82),(5242,82),(5245,82),(5246,82),(5273,82),(5276,82),(5290,82),(5329,82),(5352,82),(4,83),(24,83),(33,83),(39,83),(41,83),(121,83),(128,83),(130,83),(164,83),(180,83),(190,83),(191,83),(195,83),(205,83),(260,83),(281,83),(291,83),(322,83),(330,83),(358,83),(359,83),(365,83),(371,83),(399,83),(473,83),(509,83),(539,83),(589,83),(646,83),(665,83),(672,83),(685,83),(740,83),(770,83),(780,83),(811,83),(824,83),(847,83),(854,83),(858,83),(929,83),(979,83),(982,83),(996,83),(1007,83),(1106,83),(1107,83),(1221,83),(1243,83),(1249,83),(1266,83),(1297,83),(1300,83),(1356,83),(1447,83),(1459,83),(1467,83),(1505,83),(1605,83),(1619,83),(1678,83),(1694,83),(1712,83),(1731,83),(1737,83),(1787,83),(1823,83),(1838,83),(1842,83),(1878,83),(1882,83),(1912,83),(1932,83),(1973,83),(1983,83),(1999,83),(2016,83),(2022,83),(2030,83),(2075,83),(2104,83),(2125,83),(2136,83),(2137,83),(2163,83),(2191,83),(2192,83),(2232,83),(2260,83),(2264,83),(2265,83),(2328,83),(2392,83),(2409,83),(2427,83),(2466,83),(2508,83),(2514,83),(2526,83),(2529,83),(2545,83),(2548,83),(2552,83),(2562,83),(2602,83),(2607,83),(2674,83),(2790,83),(2802,83),(2808,83),(2817,83),(2858,83),(2867,83),(2875,83),(2902,83),(2904,83),(2912,83),(3025,83),(3045,83),(3061,83),(3123,83),(3234,83),(3272,83),(3294,83),(3336,83),(3345,83),(3359,83),(3362,83),(3366,83),(3368,83),(3377,83),(3381,83),(3412,83),(3417,83),(3521,83),(3567,83),(3606,83),(3624,83),(3629,83),(3642,83),(3666,83),(3680,83),(3682,83),(3684,83),(3685,83),(3686,83),(3713,83),(3714,83),(3743,83),(3744,83),(3775,83),(3784,83),(3790,83),(3793,83),(3798,83),(3815,83),(3824,83),(3838,83),(3842,83),(3846,83),(3886,83),(3972,83),(4039,83),(4043,83),(4064,83),(4066,83),(4069,83),(4151,83),(4175,83),(4200,83),(4208,83),(4209,83),(4232,83),(4245,83),(4250,83),(4283,83),(4315,83),(4351,83),(4373,83),(4381,83),(4392,83),(4394,83),(4407,83),(4411,83),(4432,83),(4444,83),(4468,83),(4522,83),(4528,83),(4534,83),(4566,83),(4654,83),(4656,83),(4678,83),(4680,83),(4688,83),(4726,83),(4751,83),(4767,83),(4833,83),(4836,83),(4843,83),(4863,83),(4877,83),(4903,83),(4913,83),(4951,83),(4958,83),(4999,83),(5030,83),(5072,83),(5113,83),(5116,83),(5121,83),(5176,83),(5303,83),(5339,83),(5350,83),(6,84),(8,84),(12,84),(18,84),(53,84),(57,84),(78,84),(81,84),(95,84),(97,84),(98,84),(109,84),(111,84),(154,84),(175,84),(176,84),(188,84),(192,84),(214,84),(220,84),(256,84),(272,84),(274,84),(296,84),(302,84),(311,84),(327,84),(357,84),(373,84),(382,84),(384,84),(397,84),(424,84),(430,84),(437,84),(444,84),(486,84),(487,84),(493,84),(519,84),(532,84),(549,84),(609,84),(610,84),(622,84),(632,84),(640,84),(677,84),(680,84),(713,84),(761,84),(763,84),(772,84),(796,84),(802,84),(813,84),(829,84),(836,84),(849,84),(860,84),(872,84),(875,84),(883,84),(897,84),(899,84),(918,84),(923,84),(945,84),(974,84),(1009,84),(1013,84),(1030,84),(1034,84),(1063,84),(1066,84),(1075,84),(1080,84),(1088,84),(1127,84),(1129,84),(1162,84),(1174,84),(1178,84),(1187,84),(1208,84),(1213,84),(1273,84),(1274,84),(1280,84),(1288,84),(1289,84),(1293,84),(1314,84),(1322,84),(1338,84),(1360,84),(1361,84),(1368,84),(1370,84),(1372,84),(1377,84),(1394,84),(1395,84),(1396,84),(1398,84),(1442,84),(1463,84),(1464,84),(1475,84),(1491,84),(1509,84),(1524,84),(1526,84),(1563,84),(1577,84),(1586,84),(1599,84),(1618,84),(1659,84),(1682,84),(1685,84),(1690,84),(1719,84),(1721,84),(1743,84),(1744,84),(1745,84),(1757,84),(1770,84),(1773,84),(1774,84),(1780,84),(1784,84),(1827,84),(1829,84),(1833,84),(1851,84),(1856,84),(1862,84),(1875,84),(1876,84),(1880,84),(1892,84),(1893,84),(1895,84),(1905,84),(1908,84),(1909,84),(1920,84),(1938,84),(1939,84),(1940,84),(1946,84),(1947,84),(1950,84),(1952,84),(1962,84),(1969,84),(1981,84),(1986,84),(2007,84),(2026,84),(2048,84),(2093,84),(2097,84),(2112,84),(2130,84),(2135,84),(2145,84),(2152,84),(2164,84),(2179,84),(2200,84),(2201,84),(2208,84),(2219,84),(2223,84),(2227,84),(2254,84),(2287,84),(2290,84),(2306,84),(2321,84),(2322,84),(2358,84),(2369,84),(2375,84),(2385,84),(2388,84),(2401,84),(2403,84),(2423,84),(2434,84),(2445,84),(2448,84),(2455,84),(2472,84),(2500,84),(2503,84),(2507,84),(2535,84),(2544,84),(2555,84),(2561,84),(2564,84),(2586,84),(2588,84),(2593,84),(2595,84),(2613,84),(2615,84),(2646,84),(2656,84),(2666,84),(2668,84),(2676,84),(2684,84),(2691,84),(2703,84),(2708,84),(2709,84),(2719,84),(2722,84),(2743,84),(2753,84),(2765,84),(2776,84),(2800,84),(2825,84),(2827,84),(2845,84),(2857,84),(2869,84),(2887,84),(2888,84),(2890,84),(2914,84),(2929,84),(2938,84),(2954,84),(2981,84),(2997,84),(3012,84),(3041,84),(3043,84),(3044,84),(3060,84),(3080,84),(3105,84),(3115,84),(3125,84),(3126,84),(3134,84),(3141,84),(3151,84),(3153,84),(3166,84),(3171,84),(3173,84),(3179,84),(3187,84),(3191,84),(3206,84),(3207,84),(3214,84),(3215,84),(3237,84),(3240,84),(3290,84),(3316,84),(3324,84),(3331,84),(3344,84),(3351,84),(3385,84),(3387,84),(3393,84),(3404,84),(3410,84),(3454,84),(3455,84),(3462,84),(3477,84),(3480,84),(3484,84),(3509,84),(3512,84),(3513,84),(3522,84),(3526,84),(3531,84),(3542,84),(3546,84),(3548,84),(3551,84),(3552,84),(3554,84),(3560,84),(3568,84),(3612,84),(3613,84),(3632,84),(3636,84),(3650,84),(3654,84),(3661,84),(3664,84),(3681,84),(3700,84),(3747,84),(3751,84),(3752,84),(3753,84),(3758,84),(3774,84),(3791,84),(3796,84),(3808,84),(3818,84),(3829,84),(3831,84),(3837,84),(3852,84),(3857,84),(3858,84),(3878,84),(3977,84),(3979,84),(3981,84),(3985,84),(4007,84),(4021,84),(4024,84),(4028,84),(4029,84),(4038,84),(4041,84),(4045,84),(4050,84),(4052,84),(4077,84),(4099,84),(4100,84),(4109,84),(4119,84),(4131,84),(4141,84),(4143,84),(4144,84),(4166,84),(4171,84),(4176,84),(4186,84),(4197,84),(4202,84),(4207,84),(4212,84),(4214,84),(4215,84),(4216,84),(4221,84),(4246,84),(4253,84),(4269,84),(4274,84),(4276,84),(4280,84),(4281,84),(4292,84),(4293,84),(4295,84),(4296,84),(4313,84),(4331,84),(4346,84),(4368,84),(4391,84),(4404,84),(4405,84),(4413,84),(4414,84),(4417,84),(4426,84),(4436,84),(4445,84),(4449,84),(4463,84),(4464,84),(4466,84),(4490,84),(4496,84),(4497,84),(4500,84),(4508,84),(4551,84),(4554,84),(4562,84),(4564,84),(4567,84),(4570,84),(4573,84),(4586,84),(4587,84),(4588,84),(4605,84),(4627,84),(4648,84),(4663,84),(4673,84),(4674,84),(4682,84),(4683,84),(4700,84),(4704,84),(4720,84),(4730,84),(4738,84),(4764,84),(4818,84),(4826,84),(4828,84),(4835,84),(4854,84),(4869,84),(4884,84),(4901,84),(4907,84),(4916,84),(4922,84),(4950,84),(4956,84),(4968,84),(5000,84),(5008,84),(5010,84),(5011,84),(5014,84),(5015,84),(5022,84),(5047,84),(5055,84),(5056,84),(5080,84),(5081,84),(5092,84),(5096,84),(5115,84),(5118,84),(5120,84),(5129,84),(5138,84),(5140,84),(5143,84),(5147,84),(5149,84),(5152,84),(5165,84),(5193,84),(5201,84),(5212,84),(5218,84),(5220,84),(5230,84),(5239,84),(5244,84),(5249,84),(5261,84),(5268,84),(5271,84),(5279,84),(5297,84),(86,85),(87,85),(96,85),(100,85),(116,85),(153,85),(270,85),(294,85),(303,85),(304,85),(307,85),(309,85),(320,85),(321,85),(324,85),(350,85),(421,85),(502,85),(565,85),(568,85),(586,85),(648,85),(723,85),(762,85),(856,85),(866,85),(935,85),(1000,85),(1047,85),(1057,85),(1065,85),(1099,85),(1114,85),(1119,85),(1125,85),(1152,85),(1175,85),(1192,85),(1254,85),(1256,85),(1263,85),(1292,85),(1313,85),(1317,85),(1324,85),(1341,85),(1382,85),(1397,85),(1441,85),(1454,85),(1469,85),(1489,85),(1507,85),(1517,85),(1522,85),(1549,85),(1575,85),(1589,85),(1592,85),(1633,85),(1636,85),(1641,85),(1684,85),(1711,85),(1775,85),(1831,85),(1841,85),(1863,85),(1873,85),(1955,85),(2013,85),(2046,85),(2099,85),(2141,85),(2204,85),(2207,85),(2281,85),(2310,85),(2451,85),(2453,85),(2457,85),(2468,85),(2480,85),(2513,85),(2533,85),(2534,85),(2565,85),(2597,85),(2663,85),(2685,85),(2694,85),(2721,85),(2732,85),(2763,85),(2772,85),(2809,85),(2810,85),(2815,85),(2884,85),(2895,85),(2900,85),(2944,85),(3047,85),(3112,85),(3175,85),(3194,85),(3217,85),(3227,85),(3257,85),(3293,85),(3306,85),(3318,85),(3349,85),(3476,85),(3491,85),(3504,85),(3508,85),(3523,85),(3524,85),(3541,85),(3591,85),(3593,85),(3645,85),(3676,85),(3690,85),(3741,85),(3769,85),(3913,85),(3932,85),(3968,85),(3980,85),(3990,85),(4005,85),(4015,85),(4030,85),(4031,85),(4118,85),(4127,85),(4136,85),(4146,85),(4159,85),(4160,85),(4309,85),(4310,85),(4342,85),(4364,85),(4379,85),(4387,85),(4396,85),(4421,85),(4460,85),(4519,85),(4530,85),(4558,85),(4637,85),(4667,85),(4707,85),(4732,85),(4760,85),(4824,85),(4830,85),(4851,85),(4857,85),(4871,85),(4981,85),(4986,85),(4990,85),(4994,85),(4995,85),(4996,85),(4997,85),(4998,85),(5023,85),(5041,85),(5122,85),(5125,85),(5153,85),(5181,85),(5196,85),(5205,85),(5240,85),(5302,85),(2,86),(27,86),(54,86),(83,86),(88,86),(112,86),(125,86),(167,86),(170,86),(189,86),(210,86),(219,86),(230,86),(409,86),(508,86),(516,86),(590,86),(599,86),(666,86),(669,86),(699,86),(783,86),(840,86),(949,86),(960,86),(1022,86),(1024,86),(1058,86),(1069,86),(1076,86),(1079,86),(1097,86),(1184,86),(1191,86),(1219,86),(1230,86),(1234,86),(1291,86),(1351,86),(1363,86),(1389,86),(1413,86),(1450,86),(1471,86),(1493,86),(1529,86),(1613,86),(1664,86),(1668,86),(1699,86),(1722,86),(1736,86),(1738,86),(1746,86),(1864,86),(1871,86),(2002,86),(2051,86),(2080,86),(2128,86),(2146,86),(2154,86),(2158,86),(2185,86),(2270,86),(2282,86),(2305,86),(2308,86),(2623,86),(2669,86),(2680,86),(2700,86),(2727,86),(2741,86),(2747,86),(2751,86),(2773,86),(2786,86),(2814,86),(2823,86),(2907,86),(2910,86),(2956,86),(3058,86),(3069,86),(3392,86),(3395,86),(3418,86),(3528,86),(3570,86),(3589,86),(3772,86),(3787,86),(3920,86),(3930,86),(3949,86),(4019,86),(4092,86),(4230,86),(4298,86),(4300,86),(4323,86),(4324,86),(4338,86),(4349,86),(4386,86),(4410,86),(4422,86),(4507,86),(4526,86),(4541,86),(4592,86),(4686,86),(4692,86),(4694,86),(4713,86),(4746,86),(4773,86),(4842,86),(4847,86),(4905,86),(5005,86),(5085,86),(5090,86),(5139,86),(5192,86),(5225,86),(5236,86),(5305,86),(5306,86),(5309,86),(5312,86),(5313,86),(5314,86),(5316,86),(5321,86),(5325,86),(5326,86),(5327,86),(5332,86),(5334,86),(5338,86),(5343,86),(5348,86),(74,87),(133,87),(194,87),(211,87),(212,87),(222,87),(247,87),(266,87),(292,87),(297,87),(388,87),(390,87),(431,87),(450,87),(520,87),(557,87),(584,87),(613,87),(667,87),(739,87),(752,87),(756,87),(779,87),(826,87),(886,87),(924,87),(941,87),(951,87),(952,87),(989,87),(1005,87),(1037,87),(1110,87),(1116,87),(1124,87),(1131,87),(1160,87),(1182,87),(1194,87),(1278,87),(1409,87),(1455,87),(1495,87),(1511,87),(1514,87),(1536,87),(1561,87),(1566,87),(1578,87),(1583,87),(1593,87),(1601,87),(1614,87),(1728,87),(1751,87),(1755,87),(1812,87),(1830,87),(1849,87),(1922,87),(1923,87),(1998,87),(2059,87),(2210,87),(2309,87),(2344,87),(2345,87),(2353,87),(2357,87),(2368,87),(2419,87),(2421,87),(2454,87),(2495,87),(2506,87),(2549,87),(2574,87),(2736,87),(2745,87),(2766,87),(2812,87),(2877,87),(2998,87),(3017,87),(3030,87),(3034,87),(3093,87),(3128,87),(3144,87),(3198,87),(3258,87),(3363,87),(3419,87),(3464,87),(3493,87),(3556,87),(3609,87),(3705,87),(3742,87),(3768,87),(3863,87),(3880,87),(3937,87),(3984,87),(3993,87),(4248,87),(4322,87),(4339,87),(4348,87),(4357,87),(4374,87),(4385,87),(4430,87),(4474,87),(4482,87),(4555,87),(4603,87),(4612,87),(4620,87),(4752,87),(4770,87),(4965,87),(5031,87),(5032,87),(5059,87),(5064,87),(5087,87),(5132,87),(5255,87),(5260,87),(3,88),(14,88),(21,88),(34,88),(52,88),(150,88),(160,88),(235,88),(284,88),(308,88),(377,88),(410,88),(458,88),(477,88),(483,88),(576,88),(619,88),(620,88),(653,88),(687,88),(693,88),(724,88),(727,88),(754,88),(844,88),(864,88),(940,88),(973,88),(1011,88),(1035,88),(1082,88),(1112,88),(1121,88),(1169,88),(1269,88),(1357,88),(1428,88),(1468,88),(1519,88),(1569,88),(1607,88),(1629,88),(1648,88),(1740,88),(1768,88),(1818,88),(1887,88),(1951,88),(2014,88),(2031,88),(2119,88),(2181,88),(2224,88),(2231,88),(2238,88),(2363,88),(2383,88),(2487,88),(2542,88),(2628,88),(2715,88),(2731,88),(2796,88),(2874,88),(2940,88),(3015,88),(3037,88),(3090,88),(3130,88),(3133,88),(3275,88),(3334,88),(3352,88),(3357,88),(3483,88),(3495,88),(3498,88),(3499,88),(3525,88),(3533,88),(3586,88),(3611,88),(3647,88),(3670,88),(3716,88),(3896,88),(3906,88),(3964,88),(4058,88),(4063,88),(4073,88),(4164,88),(4167,88),(4173,88),(4198,88),(4240,88),(4247,88),(4252,88),(4263,88),(4275,88),(4320,88),(4369,88),(4439,88),(4585,88),(4657,88),(4728,88),(4870,88),(4882,88),(4935,88),(4964,88),(4984,88),(4993,88),(5104,88),(5146,88),(5224,88),(5231,88),(5232,88),(5328,88),(5340,88),(5353,88),(5356,88),(58,89),(89,89),(106,89),(140,89),(143,89),(161,89),(184,89),(202,89),(261,89),(262,89),(278,89),(306,89),(323,89),(333,89),(341,89),(418,89),(442,89),(455,89),(494,89),(496,89),(525,89),(572,89),(577,89),(689,89),(697,89),(741,89),(743,89),(759,89),(767,89),(778,89),(842,89),(851,89),(865,89),(939,89),(998,89),(1006,89),(1021,89),(1041,89),(1055,89),(1117,89),(1118,89),(1120,89),(1134,89),(1139,89),(1158,89),(1203,89),(1306,89),(1316,89),(1346,89),(1401,89),(1411,89),(1412,89),(1496,89),(1515,89),(1518,89),(1531,89),(1537,89),(1557,89),(1558,89),(1630,89),(1646,89),(1666,89),(1679,89),(1720,89),(1749,89),(1781,89),(1785,89),(1811,89),(1813,89),(1834,89),(1840,89),(1844,89),(1884,89),(1896,89),(1899,89),(1966,89),(1972,89),(1978,89),(2068,89),(2168,89),(2173,89),(2273,89),(2330,89),(2332,89),(2365,89),(2373,89),(2432,89),(2439,89),(2452,89),(2475,89),(2504,89),(2517,89),(2518,89),(2539,89),(2550,89),(2585,89),(2689,89),(2711,89),(2737,89),(2749,89),(2782,89),(2816,89),(2852,89),(2864,89),(3055,89),(3074,89),(3075,89),(3158,89),(3159,89),(3174,89),(3176,89),(3209,89),(3221,89),(3228,89),(3242,89),(3253,89),(3319,89),(3364,89),(3369,89),(3482,89),(3515,89),(3545,89),(3550,89),(3587,89),(3619,89),(3754,89),(3788,89),(3812,89),(3904,89),(3917,89),(3923,89),(3927,89),(3958,89),(3982,89),(3983,89),(3997,89),(3999,89),(4004,89),(4018,89),(4075,89),(4110,89),(4130,89),(4181,89),(4228,89),(4285,89),(4334,89),(4343,89),(4363,89),(4377,89),(4420,89),(4471,89),(4488,89),(4504,89),(4527,89),(4579,89),(4604,89),(4606,89),(4780,89),(4800,89),(4839,89),(4867,89),(4969,89),(5034,89),(5046,89),(5076,89),(5155,89),(5162,89),(5191,89),(5278,89),(5286,89),(5287,89),(69,90),(71,90),(75,90),(105,90),(172,90),(182,90),(209,90),(273,90),(366,90),(369,90),(414,90),(456,90),(484,90),(500,90),(503,90),(506,90),(512,90),(530,90),(559,90),(591,90),(614,90),(630,90),(651,90),(867,90),(891,90),(905,90),(997,90),(1002,90),(1135,90),(1151,90),(1163,90),(1220,90),(1229,90),(1239,90),(1246,90),(1272,90),(1290,90),(1352,90),(1359,90),(1375,90),(1433,90),(1532,90),(1543,90),(1548,90),(1551,90),(1625,90),(1729,90),(1778,90),(1826,90),(1867,90),(1913,90),(1953,90),(2084,90),(2115,90),(2117,90),(2202,90),(2278,90),(2351,90),(2377,90),(2397,90),(2398,90),(2420,90),(2571,90),(2616,90),(2618,90),(2649,90),(2683,90),(2688,90),(2698,90),(2706,90),(2717,90),(2723,90),(2726,90),(2806,90),(2840,90),(2951,90),(3048,90),(3071,90),(3180,90),(3254,90),(3264,90),(3285,90),(3332,90),(3367,90),(3380,90),(3388,90),(3543,90),(3569,90),(3580,90),(3605,90),(3627,90),(3643,90),(3660,90),(3735,90),(3910,90),(3924,90),(3959,90),(3974,90),(4013,90),(4022,90),(4097,90),(4129,90),(4155,90),(4321,90),(4326,90),(4419,90),(4467,90),(4513,90),(4518,90),(4625,90),(4672,90),(4681,90),(4714,90),(4747,90),(4787,90),(4788,90),(4805,90),(4822,90),(5042,90),(5065,90),(5148,90),(5208,90),(5289,90),(43,91),(66,91),(80,91),(85,91),(124,91),(151,91),(174,91),(183,91),(185,91),(204,91),(227,91),(234,91),(239,91),(257,91),(329,91),(331,91),(380,91),(392,91),(398,91),(400,91),(401,91),(428,91),(466,91),(470,91),(499,91),(507,91),(513,91),(534,91),(562,91),(634,91),(661,91),(671,91),(751,91),(797,91),(817,91),(831,91),(832,91),(853,91),(898,91),(1008,91),(1074,91),(1133,91),(1149,91),(1199,91),(1240,91),(1267,91),(1309,91),(1374,91),(1405,91),(1427,91),(1445,91),(1456,91),(1479,91),(1530,91),(1598,91),(1600,91),(1640,91),(1644,91),(1660,91),(1696,91),(1701,91),(1723,91),(1747,91),(1754,91),(1790,91),(1860,91),(1881,91),(1889,91),(1960,91),(1970,91),(1996,91),(2003,91),(2009,91),(2033,91),(2053,91),(2064,91),(2069,91),(2078,91),(2110,91),(2124,91),(2140,91),(2155,91),(2174,91),(2177,91),(2239,91),(2244,91),(2245,91),(2268,91),(2283,91),(2336,91),(2341,91),(2376,91),(2446,91),(2481,91),(2497,91),(2512,91),(2557,91),(2589,91),(2590,91),(2598,91),(2612,91),(2621,91),(2630,91),(2641,91),(2658,91),(2659,91),(2679,91),(2724,91),(2760,91),(2832,91),(2834,91),(2835,91),(2870,91),(2941,91),(2961,91),(2965,91),(2975,91),(2978,91),(2988,91),(2992,91),(3067,91),(3101,91),(3138,91),(3139,91),(3152,91),(3155,91),(3164,91),(3170,91),(3199,91),(3204,91),(3208,91),(3224,91),(3282,91),(3288,91),(3298,91),(3307,91),(3399,91),(3406,91),(3460,91),(3461,91),(3506,91),(3529,91),(3536,91),(3553,91),(3555,91),(3634,91),(3720,91),(3738,91),(3762,91),(3765,91),(3817,91),(3851,91),(3855,91),(3860,91),(3909,91),(3970,91),(4046,91),(4056,91),(4057,91),(4083,91),(4113,91),(4114,91),(4135,91),(4172,91),(4233,91),(4272,91),(4286,91),(4301,91),(4312,91),(4340,91),(4406,91),(4423,91),(4475,91),(4499,91),(4511,91),(4531,91),(4545,91),(4583,91),(4589,91),(4602,91),(4630,91),(4645,91),(4652,91),(4670,91),(4736,91),(4765,91),(4766,91),(4769,91),(4777,91),(4834,91),(4846,91),(4852,91),(4902,91),(4911,91),(4918,91),(4932,91),(4939,91),(4943,91),(4955,91),(4976,91),(5017,91),(5039,91),(5097,91),(5109,91),(5123,91),(5124,91),(5127,91),(5142,91),(5159,91),(5168,91),(5207,91),(5226,91),(5251,91),(5256,91),(5296,91),(5311,91),(5347,91),(126,92),(218,92),(223,92),(233,92),(286,92),(301,92),(338,92),(345,92),(370,92),(511,92),(608,92),(644,92),(714,92),(718,92),(782,92),(994,92),(1070,92),(1073,92),(1077,92),(1108,92),(1202,92),(1241,92),(1381,92),(1647,92),(1691,92),(1715,92),(1777,92),(1792,92),(1859,92),(1901,92),(1915,92),(1948,92),(1957,92),(2035,92),(2118,92),(2129,92),(2198,92),(2213,92),(2237,92),(2315,92),(2324,92),(2435,92),(2486,92),(2580,92),(2592,92),(2637,92),(2675,92),(2769,92),(2788,92),(2807,92),(2822,92),(2826,92),(2927,92),(2959,92),(2970,92),(2971,92),(3019,92),(3150,92),(3190,92),(3229,92),(3321,92),(3431,92),(3456,92),(3457,92),(3583,92),(3646,92),(3651,92),(3736,92),(3771,92),(3822,92),(3841,92),(3891,92),(3907,92),(3938,92),(3951,92),(3971,92),(4125,92),(4149,92),(4187,92),(4206,92),(4218,92),(4251,92),(4279,92),(4462,92),(4502,92),(4563,92),(4609,92),(4633,92),(4693,92),(4715,92),(4743,92),(4748,92),(4757,92),(4779,92),(4858,92),(4924,92),(4929,92),(4938,92),(5068,92),(5154,92),(5234,92),(5259,92),(5292,92),(91,93),(136,93),(156,93),(162,93),(163,93),(248,93),(254,93),(289,93),(364,93),(416,93),(427,93),(440,93),(452,93),(514,93),(528,93),(585,93),(587,93),(627,93),(722,93),(837,93),(1023,93),(1084,93),(1164,93),(1339,93),(1403,93),(1538,93),(1564,93),(1692,93),(1794,93),(2040,93),(2251,93),(2255,93),(2286,93),(2458,93),(2520,93),(2523,93),(2551,93),(2577,93),(2582,93),(2813,93),(2924,93),(2996,93),(3049,93),(3120,93),(3259,93),(3267,93),(3287,93),(3308,93),(3335,93),(3451,93),(3540,93),(3547,93),(3557,93),(3594,93),(3596,93),(3601,93),(3695,93),(3706,93),(3819,93),(4102,93),(4122,93),(4157,93),(4170,93),(4236,93),(4242,93),(4356,93),(4375,93),(4479,93),(4614,93),(4665,93),(4695,93),(4789,93),(4908,93),(4973,93),(4980,93),(5040,93),(5044,93),(5061,93),(5130,93),(5202,93),(5223,93),(5227,93),(5300,93),(11,94),(23,94),(38,94),(44,94),(92,94),(177,94),(226,94),(287,94),(339,94),(347,94),(378,94),(441,94),(467,94),(501,94),(596,94),(657,94),(662,94),(725,94),(809,94),(830,94),(833,94),(873,94),(902,94),(968,94),(1003,94),(1012,94),(1059,94),(1226,94),(1283,94),(1330,94),(1435,94),(1481,94),(1484,94),(1502,94),(1587,94),(1703,94),(1705,94),(1927,94),(1928,94),(1931,94),(1944,94),(1963,94),(2005,94),(2107,94),(2111,94),(2131,94),(2149,94),(2151,94),(2166,94),(2180,94),(2216,94),(2396,94),(2406,94),(2414,94),(2473,94),(2546,94),(2661,94),(2780,94),(2836,94),(2960,94),(3027,94),(3278,94),(3279,94),(3320,94),(3338,94),(3372,94),(3396,94),(3428,94),(3481,94),(3485,94),(3663,94),(3667,94),(3683,94),(3688,94),(3689,94),(3697,94),(3715,94),(3718,94),(3730,94),(3739,94),(3746,94),(3756,94),(3781,94),(3825,94),(3826,94),(3939,94),(4088,94),(4183,94),(4222,94),(4261,94),(4287,94),(4290,94),(4341,94),(4370,94),(4398,94),(4437,94),(4440,94),(4446,94),(4505,94),(4521,94),(4582,94),(4629,94),(4659,94),(4661,94),(4802,94),(4827,94),(4936,94),(4940,94),(4945,94),(4972,94),(5069,94),(5093,94),(5103,94),(5111,94),(5163,94),(5217,94),(5280,94),(5299,94),(67,95),(152,95),(277,95),(283,95),(305,95),(315,95),(335,95),(361,95),(374,95),(413,95),(419,95),(476,95),(538,95),(624,95),(628,95),(631,95),(871,95),(950,95),(991,95),(1029,95),(1032,95),(1094,95),(1165,95),(1236,95),(1250,95),(1268,95),(1637,95),(1726,95),(1772,95),(1788,95),(1801,95),(1857,95),(1865,95),(1888,95),(1911,95),(1919,95),(1992,95),(2085,95),(2122,95),(2178,95),(2190,95),(2214,95),(2258,95),(2284,95),(2293,95),(2299,95),(2367,95),(2450,95),(2471,95),(2505,95),(2575,95),(2606,95),(2838,95),(2839,95),(2933,95),(2936,95),(3011,95),(3050,95),(3111,95),(3113,95),(3127,95),(3211,95),(3233,95),(3255,95),(3271,95),(3284,95),(3315,95),(3374,95),(3407,95),(3414,95),(3447,95),(3502,95),(3558,95),(3608,95),(3696,95),(3828,95),(3849,95),(3901,95),(3903,95),(3969,95),(4153,95),(4169,95),(4213,95),(4224,95),(4302,95),(4350,95),(4399,95),(4401,95),(4425,95),(4461,95),(4493,95),(4506,95),(4535,95),(4584,95),(4599,95),(4640,95),(4642,95),(4643,95),(4660,95),(4677,95),(4706,95),(4739,95),(4741,95),(4758,95),(4864,95),(4971,95),(5048,95),(5131,95),(5145,95),(5186,95),(5238,95),(5323,95),(5344,95),(17,96),(35,96),(56,96),(63,96),(90,96),(137,96),(155,96),(186,96),(206,96),(282,96),(351,96),(355,96),(402,96),(403,96),(406,96),(411,96),(412,96),(422,96),(439,96),(445,96),(490,96),(491,96),(531,96),(546,96),(551,96),(552,96),(553,96),(561,96),(570,96),(618,96),(635,96),(733,96),(744,96),(765,96),(768,96),(775,96),(793,96),(795,96),(807,96),(820,96),(848,96),(881,96),(882,96),(895,96),(901,96),(911,96),(915,96),(919,96),(921,96),(936,96),(937,96),(963,96),(972,96),(1019,96),(1042,96),(1109,96),(1201,96),(1252,96),(1255,96),(1270,96),(1279,96),(1287,96),(1307,96),(1319,96),(1323,96),(1329,96),(1340,96),(1350,96),(1366,96),(1414,96),(1421,96),(1432,96),(1446,96),(1498,96),(1504,96),(1609,96),(1688,96),(1693,96),(1709,96),(1710,96),(1727,96),(1798,96),(1803,96),(1814,96),(1819,96),(1832,96),(1885,96),(1898,96),(1914,96),(1916,96),(2004,96),(2017,96),(2020,96),(2027,96),(2043,96),(2086,96),(2120,96),(2132,96),(2272,96),(2280,96),(2295,96),(2312,96),(2372,96),(2382,96),(2402,96),(2464,96),(2465,96),(2511,96),(2521,96),(2531,96),(2532,96),(2563,96),(2608,96),(2629,96),(2644,96),(2652,96),(2655,96),(2660,96),(2667,96),(2686,96),(2714,96),(2733,96),(2752,96),(2757,96),(2759,96),(2767,96),(2789,96),(2831,96),(2851,96),(2854,96),(2871,96),(2876,96),(2878,96),(2897,96),(2908,96),(2931,96),(3066,96),(3072,96),(3092,96),(3099,96),(3122,96),(3143,96),(3156,96),(3168,96),(3189,96),(3195,96),(3202,96),(3225,96),(3354,96),(3361,96),(3389,96),(3401,96),(3421,96),(3439,96),(3450,96),(3452,96),(3472,96),(3563,96),(3576,96),(3584,96),(3588,96),(3602,96),(3621,96),(3623,96),(3635,96),(3653,96),(3687,96),(3698,96),(3729,96),(3749,96),(3782,96),(3807,96),(3887,96),(3888,96),(3889,96),(3892,96),(4009,96),(4016,96),(4023,96),(4026,96),(4037,96),(4080,96),(4107,96),(4226,96),(4234,96),(4258,96),(4319,96),(4353,96),(4362,96),(4372,96),(4384,96),(4412,96),(4416,96),(4424,96),(4442,96),(4456,96),(4459,96),(4470,96),(4514,96),(4529,96),(4537,96),(4549,96),(4559,96),(4577,96),(4607,96),(4610,96),(4615,96),(4655,96),(4696,96),(4698,96),(4750,96),(4759,96),(4768,96),(4801,96),(4809,96),(4813,96),(4832,96),(4850,96),(4855,96),(4859,96),(4862,96),(4895,96),(4896,96),(4961,96),(4987,96),(4992,96),(5004,96),(5016,96),(5018,96),(5033,96),(5035,96),(5037,96),(5057,96),(5062,96),(5063,96),(5144,96),(5171,96),(5172,96),(5175,96),(5179,96),(5198,96),(5254,96),(5335,96),(20,97),(36,97),(46,97),(49,97),(108,97),(110,97),(132,97),(147,97),(166,97),(169,97),(193,97),(217,97),(229,97),(245,97),(250,97),(251,97),(258,97),(263,97),(264,97),(325,97),(326,97),(332,97),(336,97),(352,97),(356,97),(362,97),(367,97),(379,97),(404,97),(446,97),(469,97),(480,97),(492,97),(497,97),(505,97),(523,97),(544,97),(558,97),(563,97),(566,97),(580,97),(607,97),(616,97),(617,97),(645,97),(668,97),(708,97),(712,97),(742,97),(771,97),(785,97),(787,97),(859,97),(863,97),(908,97),(928,97),(932,97),(942,97),(956,97),(999,97),(1036,97),(1038,97),(1044,97),(1046,97),(1056,97),(1060,97),(1095,97),(1115,97),(1132,97),(1156,97),(1173,97),(1189,97),(1222,97),(1237,97),(1275,97),(1282,97),(1284,97),(1285,97),(1294,97),(1295,97),(1298,97),(1301,97),(1311,97),(1383,97),(1393,97),(1406,97),(1444,97),(1487,97),(1488,97),(1510,97),(1513,97),(1528,97),(1533,97),(1554,97),(1574,97),(1581,97),(1610,97),(1634,97),(1639,97),(1642,97),(1649,97),(1651,97),(1665,97),(1672,97),(1681,97),(1686,97),(1716,97),(1799,97),(1806,97),(1807,97),(1808,97),(1810,97),(1837,97),(1854,97),(1869,97),(1903,97),(1925,97),(1929,97),(1979,97),(1997,97),(2011,97),(2015,97),(2070,97),(2095,97),(2113,97),(2121,97),(2159,97),(2172,97),(2182,97),(2187,97),(2206,97),(2261,97),(2267,97),(2343,97),(2366,97),(2424,97),(2460,97),(2485,97),(2492,97),(2493,97),(2499,97),(2527,97),(2605,97),(2619,97),(2701,97),(2702,97),(2712,97),(2734,97),(2738,97),(2742,97),(2768,97),(2771,97),(2774,97),(2781,97),(2820,97),(2821,97),(2824,97),(2828,97),(2848,97),(2880,97),(2892,97),(2894,97),(2896,97),(2918,97),(2942,97),(2963,97),(2969,97),(2991,97),(3052,97),(3064,97),(3081,97),(3084,97),(3131,97),(3172,97),(3177,97),(3184,97),(3213,97),(3222,97),(3226,97),(3235,97),(3244,97),(3286,97),(3292,97),(3295,97),(3309,97),(3358,97),(3360,97),(3382,97),(3383,97),(3426,97),(3433,97),(3437,97),(3441,97),(3446,97),(3466,97),(3510,97),(3530,97),(3564,97),(3574,97),(3581,97),(3597,97),(3610,97),(3640,97),(3649,97),(3657,97),(3668,97),(3703,97),(3710,97),(3726,97),(3727,97),(3750,97),(3760,97),(3761,97),(3770,97),(3783,97),(3810,97),(3816,97),(3840,97),(3881,97),(3890,97),(3893,97),(3925,97),(3926,97),(3928,97),(3933,97),(3945,97),(3956,97),(3960,97),(3991,97),(3996,97),(4000,97),(4003,97),(4011,97),(4020,97),(4061,97),(4072,97),(4111,97),(4145,97),(4163,97),(4188,97),(4204,97),(4205,97),(4235,97),(4307,97),(4355,97),(4382,97),(4383,97),(4477,97),(4484,97),(4547,97),(4613,97),(4664,97),(4723,97),(4778,97),(4794,97),(4898,97),(4899,97),(4914,97),(4957,97),(4962,97),(4977,97),(4985,97),(4991,97),(5002,97),(5003,97),(5024,97),(5026,97),(5029,97),(5038,97),(5066,97),(5119,97),(5128,97),(5150,97),(5161,97),(5167,97),(5195,97),(5200,97),(5214,97),(5237,97),(5265,97),(5269,97),(5283,97),(5285,97),(5308,97),(5324,97),(5330,97),(131,98),(144,98),(295,98),(573,98),(578,98),(777,98),(821,98),(838,98),(993,98),(1144,98),(1478,98),(1540,98),(1555,98),(1853,98),(1858,98),(1877,98),(2052,98),(2150,98),(2342,98),(2400,98),(2578,98),(2638,98),(2687,98),(2797,98),(2811,98),(2939,98),(3087,98),(3160,98),(3197,98),(3219,98),(3289,98),(3511,98),(3616,98),(3659,98),(4182,98),(4427,98),(5036,98),(5270,98),(5304,98),(5319,98),(5355,98),(28,99),(50,99),(62,99),(65,99),(178,99),(213,99),(259,99),(344,99),(376,99),(408,99),(429,99),(433,99),(481,99),(482,99),(510,99),(543,99),(583,99),(592,99),(602,99),(623,99),(643,99),(663,99),(684,99),(706,99),(710,99),(726,99),(736,99),(748,99),(801,99),(835,99),(927,99),(1001,99),(1004,99),(1016,99),(1068,99),(1087,99),(1166,99),(1167,99),(1172,99),(1181,99),(1188,99),(1195,99),(1259,99),(1296,99),(1310,99),(1337,99),(1342,99),(1416,99),(1423,99),(1431,99),(1573,99),(1582,99),(1588,99),(1708,99),(1733,99),(1748,99),(1759,99),(1760,99),(1783,99),(1797,99),(1815,99),(1817,99),(1825,99),(1866,99),(1894,99),(1906,99),(1974,99),(1976,99),(1982,99),(1995,99),(2000,99),(2019,99),(2021,99),(2074,99),(2114,99),(2143,99),(2144,99),(2167,99),(2176,99),(2303,99),(2355,99),(2359,99),(2364,99),(2380,99),(2407,99),(2410,99),(2416,99),(2426,99),(2441,99),(2461,99),(2524,99),(2625,99),(2671,99),(2783,99),(2799,99),(2841,99),(2855,99),(2863,99),(2872,99),(2883,99),(2909,99),(2926,99),(2928,99),(2934,99),(2955,99),(2977,99),(2993,99),(3010,99),(3018,99),(3024,99),(3085,99),(3095,99),(3116,99),(3124,99),(3178,99),(3188,99),(3192,99),(3205,99),(3256,99),(3276,99),(3310,99),(3337,99),(3341,99),(3350,99),(3379,99),(3384,99),(3408,99),(3422,99),(3436,99),(3443,99),(3448,99),(3471,99),(3496,99),(3505,99),(3518,99),(3578,99),(3637,99),(3638,99),(3665,99),(3691,99),(3709,99),(3764,99),(3779,99),(3830,99),(3843,99),(3848,99),(3867,99),(3868,99),(3914,99),(3929,99),(3942,99),(3962,99),(4033,99),(4059,99),(4090,99),(4095,99),(4115,99),(4154,99),(4199,99),(4201,99),(4231,99),(4303,99),(4325,99),(4333,99),(4352,99),(4431,99),(4443,99),(4452,99),(4455,99),(4491,99),(4509,99),(4546,99),(4553,99),(4581,99),(4618,99),(4646,99),(4649,99),(4651,99),(4705,99),(4740,99),(4755,99),(4776,99),(4784,99),(4795,99),(4798,99),(4807,99),(4823,99),(4879,99),(4888,99),(4917,99),(4921,99),(4970,99),(4974,99),(5051,99),(5075,99),(5134,99),(5177,99),(5182,99),(5190,99),(5228,99),(5248,99),(5250,99),(5253,99),(5257,99),(5294,99),(5301,99),(19,100),(29,100),(47,100),(51,100),(84,100),(141,100),(179,100),(241,100),(267,100),(288,100),(346,100),(368,100),(468,100),(479,100),(547,100),(550,100),(579,100),(588,100),(655,100),(664,100),(681,100),(686,100),(691,100),(701,100),(711,100),(715,100),(760,100),(805,100),(845,100),(953,100),(1014,100),(1018,100),(1085,100),(1086,100),(1090,100),(1092,100),(1093,100),(1105,100),(1122,100),(1123,100),(1143,100),(1176,100),(1180,100),(1212,100),(1218,100),(1244,100),(1271,100),(1321,100),(1331,100),(1367,100),(1439,100),(1482,100),(1503,100),(1520,100),(1521,100),(1539,100),(1576,100),(1580,100),(1615,100),(1656,100),(1675,100),(1741,100),(1750,100),(1802,100),(1846,100),(1902,100),(1926,100),(1933,100),(1937,100),(1943,100),(1958,100),(1964,100),(2018,100),(2050,100),(2076,100),(2092,100),(2169,100),(2188,100),(2236,100),(2266,100),(2296,100),(2318,100),(2360,100),(2386,100),(2393,100),(2425,100),(2438,100),(2456,100),(2522,100),(2537,100),(2540,100),(2558,100),(2567,100),(2622,100),(2635,100),(2672,100),(2692,100),(2761,100),(2784,100),(2818,100),(2846,100),(2847,100),(2889,100),(2891,100),(2913,100),(2945,100),(2967,100),(2980,100),(3002,100),(3021,100),(3054,100),(3062,100),(3070,100),(3082,100),(3119,100),(3136,100),(3147,100),(3148,100),(3201,100),(3330,100),(3346,100),(3376,100),(3378,100),(3386,100),(3429,100),(3440,100),(3449,100),(3487,100),(3488,100),(3501,100),(3507,100),(3535,100),(3572,100),(3599,100),(3641,100),(3658,100),(3708,100),(3722,100),(3740,100),(3745,100),(3776,100),(3778,100),(3786,100),(3803,100),(3805,100),(3813,100),(3832,100),(3847,100),(3850,100),(3854,100),(3894,100),(3935,100),(3943,100),(3978,100),(4067,100),(4070,100),(4084,100),(4120,100),(4128,100),(4177,100),(4194,100),(4203,100),(4238,100),(4327,100),(4367,100),(4483,100),(4495,100),(4516,100),(4517,100),(4540,100),(4560,100),(4591,100),(4647,100),(4668,100),(4675,100),(4703,100),(4762,100),(4790,100),(4814,100),(4816,100),(4825,100),(4838,100),(4886,100),(4937,100),(4954,100),(4966,100),(4982,100),(5025,100),(5070,100),(5074,100),(5084,100),(5110,100),(5204,100),(5258,100),(5282,100),(5298,100),(30,101),(40,101),(123,101),(215,101),(228,101),(243,101),(244,101),(285,101),(343,101),(354,101),(394,101),(415,101),(454,101),(461,101),(471,101),(517,101),(521,101),(524,101),(535,101),(536,101),(540,101),(541,101),(595,101),(598,101),(625,101),(639,101),(658,101),(670,101),(679,101),(732,101),(750,101),(758,101),(781,101),(798,101),(803,101),(815,101),(819,101),(868,101),(885,101),(907,101),(912,101),(931,101),(969,101),(984,101),(990,101),(1017,101),(1026,101),(1033,101),(1051,101),(1064,101),(1071,101),(1078,101),(1081,101),(1147,101),(1168,101),(1179,101),(1186,101),(1198,101),(1209,101),(1211,101),(1286,101),(1304,101),(1388,101),(1417,101),(1419,101),(1426,101),(1437,101),(1465,101),(1477,101),(1545,101),(1565,101),(1567,101),(1568,101),(1570,101),(1579,101),(1585,101),(1591,101),(1594,101),(1597,101),(1608,101),(1612,101),(1676,101),(1697,101),(1730,101),(1796,101),(1839,101),(1845,101),(1848,101),(1891,101),(1959,101),(1985,101),(2008,101),(2010,101),(2028,101),(2032,101),(2041,101),(2077,101),(2123,101),(2142,101),(2183,101),(2209,101),(2221,101),(2230,101),(2234,101),(2252,101),(2269,101),(2274,101),(2325,101),(2346,101),(2352,101),(2354,101),(2356,101),(2389,101),(2408,101),(2411,101),(2430,101),(2437,101),(2443,101),(2447,101),(2463,101),(2498,101),(2502,101),(2541,101),(2566,101),(2583,101),(2594,101),(2705,101),(2713,101),(2725,101),(2748,101),(2778,101),(2798,101),(2842,101),(2844,101),(2866,101),(2881,101),(2882,101),(2898,101),(2916,101),(2922,101),(2923,101),(2925,101),(2932,101),(2957,101),(2966,101),(2972,101),(2973,101),(3005,101),(3007,101),(3013,101),(3031,101),(3039,101),(3079,101),(3098,101),(3110,101),(3137,101),(3140,101),(3161,101),(3183,101),(3200,101),(3203,101),(3260,101),(3273,101),(3277,101),(3347,101),(3365,101),(3400,101),(3402,101),(3403,101),(3411,101),(3415,101),(3424,101),(3459,101),(3532,101),(3534,101),(3617,101),(3620,101),(3628,101),(3662,101),(3672,101),(3702,101),(3719,101),(3734,101),(3780,101),(3799,101),(3836,101),(3869,101),(3870,101),(3871,101),(3872,101),(3874,101),(3884,101),(3905,101),(3916,101),(3948,101),(3952,101),(4044,101),(4049,101),(4055,101),(4091,101),(4116,101),(4137,101),(4168,101),(4179,101),(4180,101),(4184,101),(4189,101),(4191,101),(4192,101),(4229,101),(4243,101),(4256,101),(4257,101),(4260,101),(4262,101),(4267,101),(4284,101),(4304,101),(4314,101),(4328,101),(4332,101),(4376,101),(4402,101),(4435,101),(4465,101),(4473,101),(4476,101),(4480,101),(4538,101),(4571,101),(4608,101),(4622,101),(4658,101),(4671,101),(4679,101),(4733,101),(4737,101),(4753,101),(4774,101),(4812,101),(4837,101),(4844,101),(4853,101),(4866,101),(4893,101),(4894,101),(4906,101),(4925,101),(4947,101),(5053,101),(5079,101),(5091,101),(5098,101),(5105,101),(5107,101),(5157,101),(5173,101),(5199,101),(5206,101),(5222,101),(5241,101),(31,102),(107,102),(187,102),(240,102),(298,102),(314,102),(372,102),(434,102),(460,102),(472,102),(545,102),(621,102),(636,102),(660,102),(675,102),(682,102),(688,102),(707,102),(719,102),(730,102),(734,102),(764,102),(814,102),(879,102),(896,102),(906,102),(914,102),(938,102),(1247,102),(1299,102),(1385,102),(1408,102),(1440,102),(1452,102),(1492,102),(1506,102),(1638,102),(1674,102),(1683,102),(1782,102),(1824,102),(1855,102),(1870,102),(1874,102),(1907,102),(1921,102),(1935,102),(1987,102),(2001,102),(2042,102),(2047,102),(2055,102),(2065,102),(2087,102),(2100,102),(2101,102),(2165,102),(2218,102),(2228,102),(2233,102),(2240,102),(2275,102),(2276,102),(2326,102),(2337,102),(2436,102),(2449,102),(2482,102),(2491,102),(2515,102),(2530,102),(2553,102),(2576,102),(2670,102),(2690,102),(2693,102),(2775,102),(2785,102),(2794,102),(2873,102),(2879,102),(2946,102),(2983,102),(2994,102),(3035,102),(3046,102),(3065,102),(3086,102),(3117,102),(3129,102),(3154,102),(3210,102),(3249,102),(3269,102),(3291,102),(3312,102),(3314,102),(3348,102),(3375,102),(3432,102),(3445,102),(3497,102),(3500,102),(3559,102),(3604,102),(3633,102),(3759,102),(3777,102),(3804,102),(3911,102),(3936,102),(4035,102),(4086,102),(4140,102),(4255,102),(4271,102),(4345,102),(4388,102),(4447,102),(4457,102),(4481,102),(4485,102),(4489,102),(4552,102),(4574,102),(4594,102),(4611,102),(4624,102),(4634,102),(4689,102),(4699,102),(4711,102),(4761,102),(4771,102),(4783,102),(4806,102),(4808,102),(4889,102),(4904,102),(4930,102),(4933,102),(4944,102),(5001,102),(5052,102),(5073,102),(5088,102),(5102,102),(5117,102),(5216,102),(5272,102),(5291,102),(32,103),(70,103),(77,103),(196,103),(348,103),(393,103),(395,103),(417,103),(451,103),(459,103),(464,103),(720,103),(738,103),(799,103),(800,103),(823,103),(880,103),(889,103),(975,103),(983,103),(1067,103),(1072,103),(1089,103),(1205,103),(1262,103),(1305,103),(1386,103),(1400,103),(1466,103),(1652,103),(1657,103),(1698,103),(1734,103),(1816,103),(1886,103),(1904,103),(1984,103),(1988,103),(1994,103),(2056,103),(2088,103),(2105,103),(2133,103),(2184,103),(2193,103),(2203,103),(2241,103),(2304,103),(2381,103),(2433,103),(2536,103),(2599,103),(2643,103),(2704,103),(2739,103),(2755,103),(2803,103),(2853,103),(2899,103),(2930,103),(2937,103),(2947,103),(2948,103),(2958,103),(2962,103),(3014,103),(3026,103),(3033,103),(3063,103),(3118,103),(3232,103),(3353,103),(3371,103),(3373,103),(3492,103),(3644,103),(3699,103),(3723,103),(3757,103),(3835,103),(3856,103),(3940,103),(4036,103),(4054,103),(4087,103),(4126,103),(4162,103),(4264,103),(4288,103),(4294,103),(4318,103),(4335,103),(4494,103),(4523,103),(4568,103),(4569,103),(4590,103),(4669,103),(4685,103),(4785,103),(4820,103),(4880,103),(4890,103),(5019,103),(5020,103),(5027,103),(5108,103),(5180,103),(5267,103);
/*!40000 ALTER TABLE `Cities` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `CitiesML` WRITE;
/*!40000 ALTER TABLE `CitiesML` DISABLE KEYS */;
INSERT INTO `CitiesML` VALUES (1,1,'Ablanitsa'),(1,2,'Абланица'),(1,3,'Ablanitsa'),(2,1,'Ablanitsa'),(2,2,'Абланица'),(2,3,'Ablanitsa'),(3,1,'Ablanitsa'),(3,2,'Абланица'),(3,3,'Ablanitsa'),(4,1,'Abrit'),(4,2,'Абрит'),(4,3,'Abrit'),(5,1,'Avramovo'),(5,2,'Аврамово'),(5,3,'Avramovo'),(6,1,'Avramovo'),(6,2,'Аврамово'),(6,3,'Avramovo'),(7,1,'Avren'),(7,2,'Аврен'),(7,3,'Avren'),(8,1,'Avren'),(8,2,'Аврен'),(8,3,'Avren'),(9,1,'Agatovo'),(9,2,'Агатово'),(9,3,'Agatovo'),(10,1,'Azmanite'),(10,2,'Азманите'),(10,3,'Azmanite'),(11,1,'Aydemir'),(11,2,'Айдемир'),(11,3,'Aydemir'),(12,1,'Ayrovo'),(12,2,'Айрово'),(12,3,'Ayrovo'),(13,1,'Aytos'),(13,2,'Айтос'),(13,3,'Aytos'),(14,1,'Akandzhievo'),(14,2,'Аканджиево'),(14,3,'Akandzhievo'),(15,1,'Akatsievo'),(15,2,'Акациево'),(15,3,'Akatsievo'),(16,1,'Aksakovo'),(16,2,'Аксаково'),(16,3,'Aksakovo'),(17,1,'Alamovtsi'),(17,2,'Аламовци'),(17,3,'Alamovtsi'),(18,1,'Albantsi'),(18,2,'Албанци'),(18,3,'Albantsi'),(19,1,'Alvanovo'),(19,2,'Алваново'),(19,3,'Alvanovo'),(20,1,'Aldomirovtsi'),(20,2,'Алдомировци'),(20,3,'Aldomirovtsi'),(21,1,'Aleko Konstantinovo'),(21,2,'Алеко Константиново'),(21,3,'Aleko Konstantinovo'),(22,1,'Alekovo'),(22,2,'Алеково'),(22,3,'Alekovo'),(23,1,'Alekovo'),(23,2,'Алеково'),(23,3,'Alekovo'),(24,1,'Aleksandria'),(24,2,'Александрия'),(24,3,'Aleksandria'),(25,1,'Aleksandrovo'),(25,2,'Александрово'),(25,3,'Aleksandrovo'),(26,1,'Aleksandrovo'),(26,2,'Александрово'),(26,3,'Aleksandrovo'),(27,1,'Aleksandrovo'),(27,2,'Александрово'),(27,3,'Aleksandrovo'),(28,1,'Aleksandrovo'),(28,2,'Александрово'),(28,3,'Aleksandrovo'),(29,1,'Aleksandrovo'),(29,2,'Александрово'),(29,3,'Aleksandrovo'),(30,1,'Aleksandrovo'),(30,2,'Александрово'),(30,3,'Aleksandrovo'),(31,1,'Aleksandrovo'),(31,2,'Александрово'),(31,3,'Aleksandrovo'),(32,1,'Aleksandrovo'),(32,2,'Александрово'),(32,3,'Aleksandrovo'),(33,1,'Aleksandar Stamboliyski'),(33,2,'Александър Стамболийски'),(33,3,'Aleksandar Stamboliyski'),(34,1,'Alendarova'),(34,2,'Алендарова'),(34,3,'Alendarova'),(35,1,'Aligovska'),(35,2,'Алиговска'),(35,3,'Aligovska'),(36,1,'Alino'),(36,2,'Алино'),(36,3,'Alino'),(37,1,'Altimir'),(37,2,'Алтимир'),(37,3,'Altimir'),(38,1,'Alfatar'),(38,2,'Алфатар'),(38,3,'Alfatar'),(39,1,'Altsek'),(39,2,'Алцек'),(39,3,'Altsek'),(40,1,'Angel voyvoda'),(40,2,'Ангел войвода'),(40,3,'Angel voyvoda'),(41,1,'Angelariy'),(41,2,'Ангеларий'),(41,3,'Angelariy'),(42,1,'Angelov'),(42,2,'Ангелов'),(42,3,'Angelov'),(43,1,'Anevo'),(43,2,'Анево'),(43,3,'Anevo'),(44,1,'Antimovo'),(44,2,'Антимово'),(44,3,'Antimovo'),(45,1,'Antimovo'),(45,2,'Антимово'),(45,3,'Antimovo'),(46,1,'Anton'),(46,2,'Антон'),(46,3,'Anton'),(47,1,'Antonovo'),(47,2,'Антоново'),(47,3,'Antonovo'),(48,1,'Aplatsi'),(48,2,'Аплаци'),(48,3,'Aplatsi'),(49,1,'Aprilovo'),(49,2,'Априлово'),(49,3,'Aprilovo'),(50,1,'Aprilovo'),(50,2,'Априлово'),(50,3,'Aprilovo'),(51,1,'Aprilovo'),(51,2,'Априлово'),(51,3,'Aprilovo'),(52,1,'Apriltsi'),(52,2,'Априлци'),(52,3,'Apriltsi'),(53,1,'Apriltsi'),(53,2,'Априлци'),(53,3,'Apriltsi'),(54,1,'Apriltsi'),(54,2,'Априлци'),(54,3,'Apriltsi'),(55,1,'Arbanasi'),(55,2,'Арбанаси'),(55,3,'Arbanasi'),(56,1,'Arda'),(56,2,'Арда'),(56,3,'Arda'),(57,1,'Ardino'),(57,2,'Ардино'),(57,3,'Ardino'),(58,1,'Arzan'),(58,2,'Арзан'),(58,3,'Arzan'),(59,1,'Arkovna'),(59,2,'Арковна'),(59,3,'Arkovna'),(60,1,'Armenite'),(60,2,'Армените'),(60,3,'Armenite'),(61,1,'Armyankovtsi'),(61,2,'Армянковци'),(61,3,'Armyankovtsi'),(62,1,'Arnautito'),(62,2,'Арнаутито'),(62,3,'Arnautito'),(63,1,'Arpadzhik'),(63,2,'Арпаджик'),(63,3,'Arpadzhik'),(64,1,'Archar'),(64,2,'Арчар'),(64,3,'Archar'),(65,1,'Asen'),(65,2,'Асен'),(65,3,'Asen'),(66,1,'Asenovgrad'),(66,2,'Асеновград'),(66,3,'Asenovgrad'),(67,1,'Asenovets'),(67,2,'Асеновец'),(67,3,'Asenovets'),(68,1,'Asenovo'),(68,2,'Асеново'),(68,3,'Asenovo'),(69,1,'Asenovo'),(69,2,'Асеново'),(69,3,'Asenovo'),(70,1,'Asenovo'),(70,2,'Асеново'),(70,3,'Asenovo'),(71,1,'Asenovtsi'),(71,2,'Асеновци'),(71,3,'Asenovtsi'),(72,1,'Asparuhovo'),(72,2,'Аспарухово'),(72,3,'Asparuhovo'),(73,1,'Asparuhovo'),(73,2,'Аспарухово'),(73,3,'Asparuhovo'),(74,1,'Asparuhovo'),(74,2,'Аспарухово'),(74,3,'Asparuhovo'),(75,1,'Asparuhovo'),(75,2,'Аспарухово'),(75,3,'Asparuhovo'),(76,1,'Atia'),(76,2,'Атия'),(76,3,'Atia'),(77,1,'Atolovo'),(77,2,'Атолово'),(77,3,'Atolovo'),(78,1,'Austa'),(78,2,'Ауста'),(78,3,'Austa'),(79,1,'Aheloy'),(79,2,'Ахелой'),(79,3,'Aheloy'),(80,1,'Ahmatovo'),(80,2,'Ахматово'),(80,3,'Ahmatovo'),(81,1,'Ahryansko'),(81,2,'Ахрянско'),(81,3,'Ahryansko'),(82,1,'Ahtopol'),(82,2,'Ахтопол'),(82,3,'Ahtopol'),(83,1,'Baba Stana'),(83,2,'Баба Стана'),(83,3,'Baba Stana'),(84,1,'Baba Tonka'),(84,2,'Баба Тонка'),(84,3,'Baba Tonka'),(85,1,'Babek'),(85,2,'Бабек'),(85,3,'Babek'),(86,1,'Babino'),(86,2,'Бабино'),(86,3,'Babino'),(87,1,'Babinska reka'),(87,2,'Бабинска река'),(87,3,'Babinska reka'),(88,1,'Babintsi'),(88,2,'Бабинци'),(88,3,'Babintsi'),(89,1,'Babitsa'),(89,2,'Бабица'),(89,3,'Babitsa'),(90,1,'Bablon'),(90,2,'Баблон'),(90,3,'Bablon'),(91,1,'Babovo'),(91,2,'Бабово'),(91,3,'Babovo'),(92,1,'Babuk'),(92,2,'Бабук'),(92,3,'Babuk'),(93,1,'Babyak'),(93,2,'Бабяк'),(93,3,'Babyak'),(94,1,'Bagalevtsi'),(94,2,'Багалевци'),(94,3,'Bagalevtsi'),(95,1,'Bagra'),(95,2,'Багра'),(95,3,'Bagra'),(96,1,'Bagrentsi'),(96,2,'Багренци'),(96,3,'Bagrentsi'),(97,1,'Bagriltsi'),(97,2,'Багрилци'),(97,3,'Bagriltsi'),(98,1,'Bagryanka'),(98,2,'Багрянка'),(98,3,'Bagryanka'),(99,1,'Badevtsi'),(99,2,'Бадевци'),(99,3,'Badevtsi'),(100,1,'Badino'),(100,2,'Бадино'),(100,3,'Badino'),(101,1,'Baeva livada'),(101,2,'Баева ливада'),(101,3,'Baeva livada'),(102,1,'Baevtsi'),(102,2,'Баевци'),(102,3,'Baevtsi'),(103,1,'Baevtsi'),(103,2,'Баевци'),(103,3,'Baevtsi'),(104,1,'Bazhdari'),(104,2,'Баждари'),(104,3,'Bazhdari'),(105,1,'Baykal'),(105,2,'Байкал'),(105,3,'Baykal'),(106,1,'Baykalsko'),(106,2,'Байкалско'),(106,3,'Baykalsko'),(107,1,'Baykovo'),(107,2,'Байково'),(107,3,'Baykovo'),(108,1,'Baylovo'),(108,2,'Байлово'),(108,3,'Baylovo'),(109,1,'Bakalite'),(109,2,'Бакалите'),(109,3,'Bakalite'),(110,1,'Bakyovo'),(110,2,'Бакьово'),(110,3,'Bakyovo'),(111,1,'Balabanovo'),(111,2,'Балабаново'),(111,3,'Balabanovo'),(112,1,'Balabansko'),(112,2,'Балабанско'),(112,3,'Balabansko'),(113,1,'Balabanchevo'),(113,2,'Балабанчево'),(113,3,'Balabanchevo'),(114,1,'Balaleya'),(114,2,'Балалея'),(114,3,'Balaleya'),(115,1,'Balanite'),(115,2,'Баланите'),(115,3,'Balanite'),(116,1,'Balanovo'),(116,2,'Баланово'),(116,3,'Balanovo'),(117,1,'Balvan'),(117,2,'Балван'),(117,3,'Balvan'),(118,1,'Balvantsite'),(118,2,'Балванците'),(118,3,'Balvantsite'),(119,1,'Baldevo'),(119,2,'Балдево'),(119,3,'Baldevo'),(120,1,'Baley'),(120,2,'Балей'),(120,3,'Baley'),(121,1,'Balik'),(121,2,'Балик'),(121,3,'Balik'),(122,1,'Balinovtsi'),(122,2,'Балиновци'),(122,3,'Balinovtsi'),(123,1,'Balkan'),(123,2,'Балкан'),(123,3,'Balkan'),(124,1,'Balkan mahala'),(124,2,'Балкан махала'),(124,3,'Balkan mahala'),(125,1,'Balkanets'),(125,2,'Балканец'),(125,3,'Balkanets'),(126,1,'Balkanski'),(126,2,'Балкански'),(126,3,'Balkanski'),(127,1,'Balkantsi'),(127,2,'Балканци'),(127,3,'Balkantsi'),(128,1,'Balkantsi'),(128,2,'Балканци'),(128,3,'Balkantsi'),(129,1,'Balutsi'),(129,2,'Балуци'),(129,3,'Balutsi'),(130,1,'Balchik'),(130,2,'Балчик'),(130,3,'Balchik'),(131,1,'Balsha'),(131,2,'Балша'),(131,3,'Balsha'),(132,1,'Balyovtsi'),(132,2,'Бальовци'),(132,3,'Balyovtsi'),(133,1,'Balyuvitsa'),(133,2,'Балювица'),(133,3,'Balyuvitsa'),(134,1,'Banari'),(134,2,'Банари'),(134,3,'Banari'),(135,1,'Bangeytsi'),(135,2,'Бангейци'),(135,3,'Bangeytsi'),(136,1,'Baniska'),(136,2,'Баниска'),(136,3,'Baniska'),(137,1,'Banite'),(137,2,'Баните'),(137,3,'Banite'),(138,1,'Banitsa'),(138,2,'Баница'),(138,3,'Banitsa'),(139,1,'Banichan'),(139,2,'Баничан'),(139,3,'Banichan'),(140,1,'Banishte'),(140,2,'Банище'),(140,3,'Banishte'),(141,1,'Bankovets'),(141,2,'Банковец'),(141,3,'Bankovets'),(142,1,'Bankovtsi'),(142,2,'Банковци'),(142,3,'Bankovtsi'),(143,1,'Bankya'),(143,2,'Банкя'),(143,3,'Bankya'),(144,1,'Bankya'),(144,2,'Банкя'),(144,3,'Bankya'),(145,1,'Banovo'),(145,2,'Баново'),(145,3,'Banovo'),(146,1,'Bansko'),(146,2,'Банско'),(146,3,'Bansko'),(147,1,'Banchovtsi'),(147,2,'Банчовци'),(147,3,'Banchovtsi'),(148,1,'Banya'),(148,2,'Баня'),(148,3,'Banya'),(149,1,'Banya'),(149,2,'Баня'),(149,3,'Banya'),(150,1,'Banya'),(150,2,'Баня'),(150,3,'Banya'),(151,1,'Banya'),(151,2,'Баня'),(151,3,'Banya'),(152,1,'Banya'),(152,2,'Баня'),(152,3,'Banya'),(153,1,'Barakovo'),(153,2,'Бараково'),(153,3,'Barakovo'),(154,1,'Baratsi'),(154,2,'Бараци'),(154,3,'Baratsi'),(155,1,'Barutin'),(155,2,'Барутин'),(155,3,'Barutin'),(156,1,'Basarbovo'),(156,2,'Басарбово'),(156,3,'Basarbovo'),(157,1,'Baskaltsi'),(157,2,'Баскалци'),(157,3,'Baskaltsi'),(158,1,'Bata'),(158,2,'Бата'),(158,3,'Bata'),(159,1,'Batak'),(159,2,'Батак'),(159,3,'Batak'),(160,1,'Batak'),(160,2,'Батак'),(160,3,'Batak'),(161,1,'Batanovtsi'),(161,2,'Батановци'),(161,3,'Batanovtsi'),(162,1,'Batin'),(162,2,'Батин'),(162,3,'Batin'),(163,1,'Batishnitsa'),(163,2,'Батишница'),(163,3,'Batishnitsa'),(164,1,'Batovo'),(164,2,'Батово'),(164,3,'Batovo'),(165,1,'Batoshevo'),(165,2,'Батошево'),(165,3,'Batoshevo'),(166,1,'Batulia'),(166,2,'Батулия'),(166,3,'Batulia'),(167,1,'Batultsi'),(167,2,'Батулци'),(167,3,'Batultsi'),(168,1,'Baurene'),(168,2,'Баурене'),(168,3,'Baurene'),(169,1,'Bahalin'),(169,2,'Бахалин'),(169,3,'Bahalin'),(170,1,'Bahovitsa'),(170,2,'Баховица'),(170,3,'Bahovitsa'),(171,1,'Bahretsi'),(171,2,'Бахреци'),(171,3,'Bahretsi'),(172,1,'Batsova mahala'),(172,2,'Бацова махала'),(172,3,'Batsova mahala'),(173,1,'Bachevo'),(173,2,'Бачево'),(173,3,'Bachevo'),(174,1,'Bachkovo'),(174,2,'Бачково'),(174,3,'Bachkovo'),(175,1,'Bashevo'),(175,2,'Башево'),(175,3,'Bashevo'),(176,1,'Bashtino'),(176,2,'Бащино'),(176,3,'Bashtino'),(177,1,'Bashtino'),(177,2,'Бащино'),(177,3,'Bashtino'),(178,1,'Bashtino'),(178,2,'Бащино'),(178,3,'Bashtino'),(179,1,'Bayachevo'),(179,2,'Баячево'),(179,3,'Bayachevo'),(180,1,'Bdintsi'),(180,2,'Бдинци'),(180,3,'Bdintsi'),(181,1,'Bebrovo'),(181,2,'Беброво'),(181,3,'Bebrovo'),(182,1,'Beglezh'),(182,2,'Беглеж'),(182,3,'Beglezh'),(183,1,'Begovo'),(183,2,'Бегово'),(183,3,'Begovo'),(184,1,'Begunovtsi'),(184,2,'Бегуновци'),(184,3,'Begunovtsi'),(185,1,'Beguntsi'),(185,2,'Бегунци'),(185,3,'Beguntsi'),(186,1,'Beden'),(186,2,'Беден'),(186,3,'Beden'),(187,1,'Bedzhene'),(187,2,'Беджене'),(187,3,'Bedzhene'),(188,1,'Bedrovo'),(188,2,'Бедрово'),(188,3,'Bedrovo'),(189,1,'Bezhanovo'),(189,2,'Бежаново'),(189,3,'Bezhanovo'),(190,1,'Bezhanovo'),(190,2,'Бежаново'),(190,3,'Bezhanovo'),(191,1,'Bezvoditsa'),(191,2,'Безводица'),(191,3,'Bezvoditsa'),(192,1,'Bezvodno'),(192,2,'Безводно'),(192,3,'Bezvodno'),(193,1,'Bezden'),(193,2,'Безден'),(193,3,'Bezden'),(194,1,'Bezdenitsa'),(194,2,'Безденица'),(194,3,'Bezdenitsa'),(195,1,'Bezmer'),(195,2,'Безмер'),(195,3,'Bezmer'),(196,1,'Bezmer'),(196,2,'Безмер'),(196,3,'Bezmer'),(197,1,'Beykovtsi'),(197,2,'Бейковци'),(197,3,'Beykovtsi'),(198,1,'Bekriite'),(198,2,'Бекриите'),(198,3,'Bekriite'),(199,1,'Bel kamen'),(199,2,'Бел камен'),(199,3,'Bel kamen'),(200,1,'Bela'),(200,2,'Бела'),(200,3,'Bela'),(201,1,'Bela Rada'),(201,2,'Бела Рада'),(201,3,'Bela Rada'),(202,1,'Belanitsa'),(202,2,'Беланица'),(202,3,'Belanitsa'),(203,1,'Belasitsa'),(203,2,'Беласица'),(203,3,'Belasitsa'),(204,1,'Belashtitsa'),(204,2,'Белащица'),(204,3,'Belashtitsa'),(205,1,'Belgun'),(205,2,'Белгун'),(205,3,'Belgun'),(206,1,'Belev dol'),(206,2,'Белев дол'),(206,3,'Belev dol'),(207,1,'Belevehchevo'),(207,2,'Белевехчево'),(207,3,'Belevehchevo'),(208,1,'Belevren'),(208,2,'Белеврен'),(208,3,'Belevren'),(209,1,'Belene'),(209,2,'Белене'),(209,3,'Belene'),(210,1,'Belentsi'),(210,2,'Беленци'),(210,3,'Belentsi'),(211,1,'Beli breg'),(211,2,'Бели брег'),(211,3,'Beli breg'),(212,1,'Beli brod'),(212,2,'Бели брод'),(212,3,'Beli brod'),(213,1,'Beli bryag'),(213,2,'Бели бряг'),(213,3,'Beli bryag'),(214,1,'Beli vir'),(214,2,'Бели вир'),(214,3,'Beli vir'),(215,1,'Beli dol'),(215,2,'Бели дол'),(215,3,'Beli dol'),(216,1,'Beli izvor'),(216,2,'Бели извор'),(216,3,'Beli izvor'),(217,1,'Beli iskar'),(217,2,'Бели Искър'),(217,3,'Beli iskar'),(218,1,'Beli Lom'),(218,2,'Бели Лом'),(218,3,'Beli Lom'),(219,1,'Beli Osam'),(219,2,'Бели Осъм'),(219,3,'Beli Osam'),(220,1,'Beli plast'),(220,2,'Бели пласт'),(220,3,'Beli plast'),(221,1,'Belila'),(221,2,'Белила'),(221,3,'Belila'),(222,1,'Belimel'),(222,2,'Белимел'),(222,3,'Belimel'),(223,1,'Belintsi'),(223,2,'Белинци'),(223,3,'Belintsi'),(224,1,'Belitsa'),(224,2,'Белица'),(224,3,'Belitsa'),(225,1,'Belitsa'),(225,2,'Белица'),(225,3,'Belitsa'),(226,1,'Belitsa'),(226,2,'Белица'),(226,3,'Belitsa'),(227,1,'Belitsa'),(227,2,'Белица'),(227,3,'Belitsa'),(228,1,'Belitsa'),(228,2,'Белица'),(228,3,'Belitsa'),(229,1,'Belitsa'),(229,2,'Белица'),(229,3,'Belitsa'),(230,1,'Belish'),(230,2,'Белиш'),(230,3,'Belish'),(231,1,'Belo pole'),(231,2,'Бело поле'),(231,3,'Belo pole'),(232,1,'Belo pole'),(232,2,'Бело поле'),(232,3,'Belo pole'),(233,1,'Belovets'),(233,2,'Беловец'),(233,3,'Belovets'),(234,1,'Belovitsa'),(234,2,'Беловица'),(234,3,'Belovitsa'),(235,1,'Belovo'),(235,2,'Белово'),(235,3,'Belovo'),(236,1,'Belogradets'),(236,2,'Белоградец'),(236,3,'Belogradets'),(237,1,'Belogradchik'),(237,2,'Белоградчик'),(237,3,'Belogradchik'),(238,1,'Belodol'),(238,2,'Белодол'),(238,3,'Belodol'),(239,1,'Belozem'),(239,2,'Белозем'),(239,3,'Belozem'),(240,1,'Belokopitovo'),(240,2,'Белокопитово'),(240,3,'Belokopitovo'),(241,1,'Belomortsi'),(241,2,'Беломорци'),(241,3,'Belomortsi'),(242,1,'Belomazhite'),(242,2,'Беломъжите'),(242,3,'Belomazhite'),(243,1,'Belopoltsi'),(243,2,'Белополци'),(243,3,'Belopoltsi'),(244,1,'Belopolyane'),(244,2,'Белополяне'),(244,3,'Belopolyane'),(245,1,'Belopoptsi'),(245,2,'Белопопци'),(245,3,'Belopoptsi'),(246,1,'Beloslav'),(246,2,'Белослав'),(246,3,'Beloslav'),(247,1,'Belotintsi'),(247,2,'Белотинци'),(247,3,'Belotintsi'),(248,1,'Beltsov'),(248,2,'Белцов'),(248,3,'Beltsov'),(249,1,'Belchevtsi'),(249,2,'Белчевци'),(249,3,'Belchevtsi'),(250,1,'Belchin'),(250,2,'Белчин'),(250,3,'Belchin'),(251,1,'Belchinski bani'),(251,2,'Белчински бани'),(251,3,'Belchinski bani'),(252,1,'Belyovo'),(252,2,'Бельово'),(252,3,'Belyovo'),(253,1,'Belyakovets'),(253,2,'Беляковец'),(253,3,'Belyakovets'),(254,1,'Belyanovo'),(254,2,'Беляново'),(254,3,'Belyanovo'),(255,1,'Benkovski'),(255,2,'Бенковски'),(255,3,'Benkovski'),(256,1,'Benkovski'),(256,2,'Бенковски'),(256,3,'Benkovski'),(257,1,'Benkovski'),(257,2,'Бенковски'),(257,3,'Benkovski'),(258,1,'Benkovski'),(258,2,'Бенковски'),(258,3,'Benkovski'),(259,1,'Benkovski'),(259,2,'Бенковски'),(259,3,'Benkovski'),(260,1,'Benkovski'),(260,2,'Бенковски'),(260,3,'Benkovski'),(261,1,'Berayntsi'),(261,2,'Берайнци'),(261,3,'Berayntsi'),(262,1,'Berende'),(262,2,'Беренде'),(262,3,'Berende'),(263,1,'Berende'),(263,2,'Беренде'),(263,3,'Berende'),(264,1,'Berende izvor'),(264,2,'Беренде извор'),(264,3,'Berende izvor'),(265,1,'Berievo'),(265,2,'Бериево'),(265,3,'Berievo'),(266,1,'Berkovitsa'),(266,2,'Берковица'),(266,3,'Berkovitsa'),(267,1,'Berkovski'),(267,2,'Берковски'),(267,3,'Berkovski'),(268,1,'Berkovtsi'),(268,2,'Берковци'),(268,3,'Berkovtsi'),(269,1,'Beronovo'),(269,2,'Бероново'),(269,3,'Beronovo'),(270,1,'Bersin'),(270,2,'Берсин'),(270,3,'Bersin'),(271,1,'Beslen'),(271,2,'Беслен'),(271,3,'Beslen'),(272,1,'Besnurka'),(272,2,'Беснурка'),(272,3,'Besnurka'),(273,1,'Bivolare'),(273,2,'Биволаре'),(273,3,'Bivolare'),(274,1,'Bivolyane'),(274,2,'Биволяне'),(274,3,'Bivolyane'),(275,1,'Bizhovtsi'),(275,2,'Бижовци'),(275,3,'Bizhovtsi'),(276,1,'Bizhovtsi'),(276,2,'Бижовци'),(276,3,'Bizhovtsi'),(277,1,'Bikovo'),(277,2,'Биково'),(277,3,'Bikovo'),(278,1,'Bilintsi'),(278,2,'Билинци'),(278,3,'Bilintsi'),(279,1,'Bilka'),(279,2,'Билка'),(279,3,'Bilka'),(280,1,'Bilkini'),(280,2,'Билкини'),(280,3,'Bilkini'),(281,1,'Bilo'),(281,2,'Било'),(281,3,'Bilo'),(282,1,'Bilyanska'),(282,2,'Билянска'),(282,3,'Bilyanska'),(283,1,'Binkos'),(283,2,'Бинкос'),(283,3,'Binkos'),(284,1,'Birkova'),(284,2,'Биркова'),(284,3,'Birkova'),(285,1,'Biser'),(285,2,'Бисер'),(285,3,'Biser'),(286,1,'Bisertsi'),(286,2,'Бисерци'),(286,3,'Bisertsi'),(287,1,'Bistra'),(287,2,'Бистра'),(287,3,'Bistra'),(288,1,'Bistra'),(288,2,'Бистра'),(288,3,'Bistra'),(289,1,'Bistrentsi'),(289,2,'Бистренци'),(289,3,'Bistrentsi'),(290,1,'Bistrets'),(290,2,'Бистрец'),(290,3,'Bistrets'),(291,1,'Bistrets'),(291,2,'Бистрец'),(291,3,'Bistrets'),(292,1,'Bistrilitsa'),(292,2,'Бистрилица'),(292,3,'Bistrilitsa'),(293,1,'Bistritsa'),(293,2,'Бистрица'),(293,3,'Bistritsa'),(294,1,'Bistritsa'),(294,2,'Бистрица'),(294,3,'Bistritsa'),(295,1,'Bistritsa'),(295,2,'Бистрица'),(295,3,'Bistritsa'),(296,1,'Bistrogled'),(296,2,'Бистроглед'),(296,3,'Bistrogled'),(297,1,'Blagovo'),(297,2,'Благово'),(297,3,'Blagovo'),(298,1,'Blagovo'),(298,2,'Благово'),(298,3,'Blagovo'),(299,1,'Blagoevgrad'),(299,2,'Благоевград'),(299,3,'Blagoevgrad'),(300,1,'Blagoevo'),(300,2,'Благоево'),(300,3,'Blagoevo'),(301,1,'Blagoevo'),(301,2,'Благоево'),(301,3,'Blagoevo'),(302,1,'Blagun'),(302,2,'Благун'),(302,3,'Blagun'),(303,1,'Blazhievo'),(303,2,'Блажиево'),(303,3,'Blazhievo'),(304,1,'Blatets'),(304,2,'Блатец'),(304,3,'Blatets'),(305,1,'Blatets'),(305,2,'Блатец'),(305,3,'Blatets'),(306,1,'Blateshnitsa'),(306,2,'Блатешница'),(306,3,'Blateshnitsa'),(307,1,'Blatino'),(307,2,'Блатино'),(307,3,'Blatino'),(308,1,'Blatnitsa'),(308,2,'Блатница'),(308,3,'Blatnitsa'),(309,1,'Blato'),(309,2,'Блато'),(309,3,'Blato'),(310,1,'Blatska'),(310,2,'Блатска'),(310,3,'Blatska'),(311,1,'Blenika'),(311,2,'Бленика'),(311,3,'Blenika'),(312,1,'Bliznak'),(312,2,'Близнак'),(312,3,'Bliznak'),(313,1,'Bliznatsi'),(313,2,'Близнаци'),(313,3,'Bliznatsi'),(314,1,'Bliznatsi'),(314,2,'Близнаци'),(314,3,'Bliznatsi'),(315,1,'Bliznets'),(315,2,'Близнец'),(315,3,'Bliznets'),(316,1,'Blaskovo'),(316,2,'Блъсково'),(316,3,'Blaskovo'),(317,1,'Blaskovtsi'),(317,2,'Блъсковци'),(317,3,'Blaskovtsi'),(318,1,'Boazat'),(318,2,'Боазът'),(318,3,'Boazat'),(319,1,'Bobevtsi'),(319,2,'Бобевци'),(319,3,'Bobevtsi'),(320,1,'Bobeshino'),(320,2,'Бобешино'),(320,3,'Bobeshino'),(321,1,'Bobov dol'),(321,2,'Бобов дол'),(321,3,'Bobov dol'),(322,1,'Bobovets'),(322,2,'Бобовец'),(322,3,'Bobovets'),(323,1,'Boboratsi'),(323,2,'Бобораци'),(323,3,'Boboratsi'),(324,1,'Boboshevo'),(324,2,'Бобошево'),(324,3,'Boboshevo'),(325,1,'Bov'),(325,2,'Бов'),(325,3,'Bov'),(326,1,'Bov'),(326,2,'Бов'),(326,3,'Bov'),(327,1,'Bogatino'),(327,2,'Богатино'),(327,3,'Bogatino'),(328,1,'Bogatovo'),(328,2,'Богатово'),(328,3,'Bogatovo'),(329,1,'Bogdan'),(329,2,'Богдан'),(329,3,'Bogdan'),(330,1,'Bogdan'),(330,2,'Богдан'),(330,3,'Bogdan'),(331,1,'Bogdanitsa'),(331,2,'Богданица'),(331,3,'Bogdanitsa'),(332,1,'Bogdanlia'),(332,2,'Богданлия'),(332,3,'Bogdanlia'),(333,1,'Bogdanov dol'),(333,2,'Богданов дол'),(333,3,'Bogdanov dol'),(334,1,'Bogdanovo'),(334,2,'Богданово'),(334,3,'Bogdanovo'),(335,1,'Bogdanovo'),(335,2,'Богданово'),(335,3,'Bogdanovo'),(336,1,'Bogdanovtsi'),(336,2,'Богдановци'),(336,3,'Bogdanovtsi'),(337,1,'Bogdansko'),(337,2,'Богданско'),(337,3,'Bogdansko'),(338,1,'Bogdantsi'),(338,2,'Богданци'),(338,3,'Bogdantsi'),(339,1,'Bogdantsi'),(339,2,'Богданци'),(339,3,'Bogdantsi'),(340,1,'Bogdanchovtsi'),(340,2,'Богданчовци'),(340,3,'Bogdanchovtsi'),(341,1,'Bogoyna'),(341,2,'Богойна'),(341,3,'Bogoyna'),(342,1,'Bogolin'),(342,2,'Боголин'),(342,3,'Bogolin'),(343,1,'Bogomil'),(343,2,'Богомил'),(343,3,'Bogomil'),(344,1,'Bogomilovo'),(344,2,'Богомилово'),(344,3,'Bogomilovo'),(345,1,'Bogomiltsi'),(345,2,'Богомилци'),(345,3,'Bogomiltsi'),(346,1,'Bogomolsko'),(346,2,'Богомолско'),(346,3,'Bogomolsko'),(347,1,'Bogorovo'),(347,2,'Богорово'),(347,3,'Bogorovo'),(348,1,'Bogorovo'),(348,2,'Богорово'),(348,3,'Bogorovo'),(349,1,'Bogoroditsa'),(349,2,'Богородица'),(349,3,'Bogoroditsa'),(350,1,'Bogoslov'),(350,2,'Богослов'),(350,3,'Bogoslov'),(351,1,'Bogutevo'),(351,2,'Богутево'),(351,3,'Bogutevo'),(352,1,'Bogyovtsi'),(352,2,'Богьовци'),(352,3,'Bogyovtsi'),(353,1,'Bodenets'),(353,2,'Боденец'),(353,3,'Bodenets'),(354,1,'Bodrovo'),(354,2,'Бодрово'),(354,3,'Bodrovo'),(355,1,'Boevo'),(355,2,'Боево'),(355,3,'Boevo'),(356,1,'Boeritsa'),(356,2,'Боерица'),(356,3,'Boeritsa'),(357,1,'Bozhak'),(357,2,'Божак'),(357,3,'Bozhak'),(358,1,'Bozhan'),(358,2,'Божан'),(358,3,'Bozhan'),(359,1,'Bozhanovo'),(359,2,'Божаново'),(359,3,'Bozhanovo'),(360,1,'Bozhdovo'),(360,2,'Бождово'),(360,3,'Bozhdovo'),(361,1,'Bozhevtsi'),(361,2,'Божевци'),(361,3,'Bozhevtsi'),(362,1,'Bozhenitsa'),(362,2,'Боженица'),(362,3,'Bozhenitsa'),(363,1,'Bozhentsite'),(363,2,'Боженците'),(363,3,'Bozhentsite'),(364,1,'Bozhichen'),(364,2,'Божичен'),(364,3,'Bozhichen'),(365,1,'Bozhurets'),(365,2,'Божурец'),(365,3,'Bozhurets'),(366,1,'Bozhuritsa'),(366,2,'Божурица'),(366,3,'Bozhuritsa'),(367,1,'Bozhurishte'),(367,2,'Божурище'),(367,3,'Bozhurishte'),(368,1,'Bozhurka'),(368,2,'Божурка'),(368,3,'Bozhurka'),(369,1,'Bozhurluk'),(369,2,'Божурлук'),(369,3,'Bozhurluk'),(370,1,'Bozhurovo'),(370,2,'Божурово'),(370,3,'Bozhurovo'),(371,1,'Bozhurovo'),(371,2,'Божурово'),(371,3,'Bozhurovo'),(372,1,'Bozhurovo'),(372,2,'Божурово'),(372,3,'Bozhurovo'),(373,1,'Bozhurtsi'),(373,2,'Божурци'),(373,3,'Bozhurtsi'),(374,1,'Bozadzhii'),(374,2,'Бозаджии'),(374,3,'Bozadzhii'),(375,1,'Bozveliysko'),(375,2,'Бозвелийско'),(375,3,'Bozveliysko'),(376,1,'Bozduganovo'),(376,2,'Боздуганово'),(376,3,'Bozduganovo'),(377,1,'Bozyova'),(377,2,'Бозьова'),(377,3,'Bozyova'),(378,1,'Boil'),(378,2,'Боил'),(378,3,'Boil'),(379,1,'Boykovets'),(379,2,'Бойковец'),(379,3,'Boykovets'),(380,1,'Boykovo'),(380,2,'Бойково'),(380,3,'Boykovo'),(381,1,'Boykovtsi'),(381,2,'Бойковци'),(381,3,'Boykovtsi'),(382,1,'Boynik'),(382,2,'Бойник'),(382,3,'Boynik'),(383,1,'Boynitsa'),(383,2,'Бойница'),(383,3,'Boynitsa'),(384,1,'Boyno'),(384,2,'Бойно'),(384,3,'Boyno'),(385,1,'Boynovtsi'),(385,2,'Бойновци'),(385,3,'Boynovtsi'),(386,1,'Boychevi kolibi'),(386,2,'Бойчеви колиби'),(386,3,'Boychevi kolibi'),(387,1,'Boycheta'),(387,2,'Бойчета'),(387,3,'Boycheta'),(388,1,'Boychinovtsi'),(388,2,'Бойчиновци'),(388,3,'Boychinovtsi'),(389,1,'Boychovtsi'),(389,2,'Бойчовци'),(389,3,'Boychovtsi'),(390,1,'Bokilovtsi'),(390,2,'Бокиловци'),(390,3,'Bokilovtsi'),(391,1,'Boltata'),(391,2,'Болтата'),(391,3,'Boltata'),(392,1,'Bolyarino'),(392,2,'Болярино'),(392,3,'Bolyarino'),(393,1,'Bolyarovo'),(393,2,'Болярово'),(393,3,'Bolyarovo'),(394,1,'Bolyarski izvor'),(394,2,'Болярски извор'),(394,3,'Bolyarski izvor'),(395,1,'Bolyarsko'),(395,2,'Болярско'),(395,3,'Bolyarsko'),(396,1,'Bolyartsi'),(396,2,'Болярци'),(396,3,'Bolyartsi'),(397,1,'Bolyartsi'),(397,2,'Болярци'),(397,3,'Bolyartsi'),(398,1,'Bolyartsi'),(398,2,'Болярци'),(398,3,'Bolyartsi'),(399,1,'Bonevo'),(399,2,'Бонево'),(399,3,'Bonevo'),(400,1,'Bor'),(400,2,'Бор'),(400,3,'Bor'),(401,1,'Borets'),(401,2,'Борец'),(401,3,'Borets'),(402,1,'Borie'),(402,2,'Борие'),(402,3,'Borie'),(403,1,'Borika'),(403,2,'Борика'),(403,3,'Borika'),(404,1,'Borika'),(404,2,'Борика'),(404,3,'Borika'),(405,1,'Boriki'),(405,2,'Борики'),(405,3,'Boriki'),(406,1,'Borikovo'),(406,2,'Бориково'),(406,3,'Borikovo'),(407,1,'Borilovets'),(407,2,'Бориловец'),(407,3,'Borilovets'),(408,1,'Borilovo'),(408,2,'Борилово'),(408,3,'Borilovo'),(409,1,'Borima'),(409,2,'Борима'),(409,3,'Borima'),(410,1,'Borimechkovo'),(410,2,'Боримечково'),(410,3,'Borimechkovo'),(411,1,'Borino'),(411,2,'Борино'),(411,3,'Borino'),(412,1,'Borinovo'),(412,2,'Бориново'),(412,3,'Borinovo'),(413,1,'Borintsi'),(413,2,'Боринци'),(413,3,'Borintsi'),(414,1,'Borislav'),(414,2,'Борислав'),(414,3,'Borislav'),(415,1,'Borislavtsi'),(415,2,'Бориславци'),(415,3,'Borislavtsi'),(416,1,'Borisovo'),(416,2,'Борисово'),(416,3,'Borisovo'),(417,1,'Borisovo'),(417,2,'Борисово'),(417,3,'Borisovo'),(418,1,'Bornarevo'),(418,2,'Борнарево'),(418,3,'Bornarevo'),(419,1,'Borov dol'),(419,2,'Боров дол'),(419,3,'Borov dol'),(420,1,'Borovan'),(420,2,'Борован'),(420,3,'Borovan'),(421,1,'Borovets'),(421,2,'Боровец'),(421,3,'Borovets'),(422,1,'Borovina'),(422,2,'Боровина'),(422,3,'Borovina'),(423,1,'Borovitsa'),(423,2,'Боровица'),(423,3,'Borovitsa'),(424,1,'Borovitsa'),(424,2,'Боровица'),(424,3,'Borovitsa'),(425,1,'Borovichene'),(425,2,'Боровичене'),(425,3,'Borovichene'),(426,1,'Borovo'),(426,2,'Борово'),(426,3,'Borovo'),(427,1,'Borovo'),(427,2,'Борово'),(427,3,'Borovo'),(428,1,'Borovo'),(428,2,'Борово'),(428,3,'Borovo'),(429,1,'Borovo'),(429,2,'Борово'),(429,3,'Borovo'),(430,1,'Borovsko'),(430,2,'Боровско'),(430,3,'Borovsko'),(431,1,'Borovtsi'),(431,2,'Боровци'),(431,3,'Borovtsi'),(432,1,'Borskoto'),(432,2,'Борското'),(432,3,'Borskoto'),(433,1,'Borushtitsa'),(433,2,'Борущица'),(433,3,'Borushtitsa'),(434,1,'Bortsi'),(434,2,'Борци'),(434,3,'Bortsi'),(435,1,'Boryana'),(435,2,'Боряна'),(435,3,'Boryana'),(436,1,'Bosevtsi'),(436,2,'Босевци'),(436,3,'Bosevtsi'),(437,1,'Bosilitsa'),(437,2,'Босилица'),(437,3,'Bosilitsa'),(438,1,'Bosilkovo'),(438,2,'Босилково'),(438,3,'Bosilkovo'),(439,1,'Bosilkovo'),(439,2,'Босилково'),(439,3,'Bosilkovo'),(440,1,'Bosilkovtsi'),(440,2,'Босилковци'),(440,3,'Bosilkovtsi'),(441,1,'Bosna'),(441,2,'Босна'),(441,3,'Bosna'),(442,1,'Bosnek'),(442,2,'Боснек'),(442,3,'Bosnek'),(443,1,'Bostanite'),(443,2,'Бостаните'),(443,3,'Bostanite'),(444,1,'Bostantsi'),(444,2,'Бостанци'),(444,3,'Bostantsi'),(445,1,'Bostina'),(445,2,'Бостина'),(445,3,'Bostina'),(446,1,'Botevgrad'),(446,2,'Ботевград'),(446,3,'Botevgrad'),(447,1,'Botevo'),(447,2,'Ботево'),(447,3,'Botevo'),(448,1,'Botevo'),(448,2,'Ботево'),(448,3,'Botevo'),(449,1,'Botevo'),(449,2,'Ботево'),(449,3,'Botevo'),(450,1,'Botevo'),(450,2,'Ботево'),(450,3,'Botevo'),(451,1,'Botevo'),(451,2,'Ботево'),(451,3,'Botevo'),(452,1,'Botrov'),(452,2,'Ботров'),(452,3,'Botrov'),(453,1,'Botunya'),(453,2,'Ботуня'),(453,3,'Botunya'),(454,1,'Boturche'),(454,2,'Ботурче'),(454,3,'Boturche'),(455,1,'Bohova'),(455,2,'Бохова'),(455,3,'Bohova'),(456,1,'Bohot'),(456,2,'Бохот'),(456,3,'Bohot'),(457,1,'Bochkovtsi'),(457,2,'Бочковци'),(457,3,'Bochkovtsi'),(458,1,'Boshulya'),(458,2,'Бошуля'),(458,3,'Boshulya'),(459,1,'Boyadzhik'),(459,2,'Бояджик'),(459,3,'Boyadzhik'),(460,1,'Boyan'),(460,2,'Боян'),(460,3,'Boyan'),(461,1,'Boyan Botevo'),(461,2,'Боян Ботево'),(461,3,'Boyan Botevo'),(462,1,'Boyana'),(462,2,'Бояна'),(462,3,'Boyana'),(463,1,'Boyanovo'),(463,2,'Бояново'),(463,3,'Boyanovo'),(464,1,'Boyanovo'),(464,2,'Бояново'),(464,3,'Boyanovo'),(465,1,'Boyanovtsi'),(465,2,'Бояновци'),(465,3,'Boyanovtsi'),(466,1,'Boyantsi'),(466,2,'Боянци'),(466,3,'Boyantsi'),(467,1,'Bradvari'),(467,2,'Брадвари'),(467,3,'Bradvari'),(468,1,'Braknitsa'),(468,2,'Бракница'),(468,3,'Braknitsa'),(469,1,'Brakyovtsi'),(469,2,'Бракьовци'),(469,3,'Brakyovtsi'),(470,1,'Branipole'),(470,2,'Браниполе'),(470,3,'Branipole'),(471,1,'Branitsa'),(471,2,'Браница'),(471,3,'Branitsa'),(472,1,'Branichevo'),(472,2,'Браничево'),(472,3,'Branichevo'),(473,1,'Branishte'),(473,2,'Бранище'),(473,3,'Branishte'),(474,1,'Brankovtsi'),(474,2,'Бранковци'),(474,3,'Brankovtsi'),(475,1,'Brankovtsi'),(475,2,'Бранковци'),(475,3,'Brankovtsi'),(476,1,'Bratan'),(476,2,'Братан'),(476,3,'Bratan'),(477,1,'Bratanitsa'),(477,2,'Братаница'),(477,3,'Bratanitsa'),(478,1,'Bratovo'),(478,2,'Братово'),(478,3,'Bratovo'),(479,1,'Bratovo'),(479,2,'Братово'),(479,3,'Bratovo'),(480,1,'Bratushkovo'),(480,2,'Братушково'),(480,3,'Bratushkovo'),(481,1,'Bratya Daskalovi'),(481,2,'Братя Даскалови'),(481,3,'Bratya Daskalovi'),(482,1,'Bratya Kunchevi'),(482,2,'Братя Кунчеви'),(482,3,'Bratya Kunchevi'),(483,1,'Bratsigovo'),(483,2,'Брацигово'),(483,3,'Bratsigovo'),(484,1,'Bregare'),(484,2,'Брегаре'),(484,3,'Bregare'),(485,1,'Bregovo'),(485,2,'Брегово'),(485,3,'Bregovo'),(486,1,'Bregovo'),(486,2,'Брегово'),(486,3,'Bregovo'),(487,1,'Brezhana'),(487,2,'Брежана'),(487,3,'Brezhana'),(488,1,'Brezhani'),(488,2,'Брежани'),(488,3,'Brezhani'),(489,1,'Brezhnitsite'),(489,2,'Брежниците'),(489,3,'Brezhnitsite'),(490,1,'Breza'),(490,2,'Бреза'),(490,3,'Breza'),(491,1,'Breze'),(491,2,'Брезе'),(491,3,'Breze'),(492,1,'Breze'),(492,2,'Брезе'),(492,3,'Breze'),(493,1,'Brezen'),(493,2,'Брезен'),(493,3,'Brezen'),(494,1,'Breznik'),(494,2,'Брезник'),(494,3,'Breznik'),(495,1,'Breznitsa'),(495,2,'Брезница'),(495,3,'Breznitsa'),(496,1,'Breznishki izvor'),(496,2,'Брезнишки извор'),(496,3,'Breznishki izvor'),(497,1,'Brezovdol'),(497,2,'Брезовдол'),(497,3,'Brezovdol'),(498,1,'Brezovo'),(498,2,'Брезово'),(498,3,'Brezovo'),(499,1,'Brezovo'),(499,2,'Брезово'),(499,3,'Brezovo'),(500,1,'Brenitsa'),(500,2,'Бреница'),(500,3,'Brenitsa'),(501,1,'Brenitsa'),(501,2,'Бреница'),(501,3,'Brenitsa'),(502,1,'Brest'),(502,2,'Брест'),(502,3,'Brest'),(503,1,'Brest'),(503,2,'Брест'),(503,3,'Brest'),(504,1,'Brestak'),(504,2,'Брестак'),(504,3,'Brestak'),(505,1,'Brestaka'),(505,2,'Брестака'),(505,3,'Brestaka'),(506,1,'Breste'),(506,2,'Бресте'),(506,3,'Breste'),(507,1,'Brestnik'),(507,2,'Брестник'),(507,3,'Brestnik'),(508,1,'Brestnitsa'),(508,2,'Брестница'),(508,3,'Brestnitsa'),(509,1,'Brestnitsa'),(509,2,'Брестница'),(509,3,'Brestnitsa'),(510,1,'Brestova'),(510,2,'Брестова'),(510,3,'Brestova'),(511,1,'Brestovene'),(511,2,'Брестовене'),(511,3,'Brestovene'),(512,1,'Brestovets'),(512,2,'Брестовец'),(512,3,'Brestovets'),(513,1,'Brestovitsa'),(513,2,'Брестовица'),(513,3,'Brestovitsa'),(514,1,'Brestovitsa'),(514,2,'Брестовица'),(514,3,'Brestovitsa'),(515,1,'Brestovo'),(515,2,'Брестово'),(515,3,'Brestovo'),(516,1,'Brestovo'),(516,2,'Брестово'),(516,3,'Brestovo'),(517,1,'Brod'),(517,2,'Брод'),(517,3,'Brod'),(518,1,'Brodilovo'),(518,2,'Бродилово'),(518,3,'Brodilovo'),(519,1,'Brosh'),(519,2,'Брош'),(519,3,'Brosh'),(520,1,'Brusartsi'),(520,2,'Брусарци'),(520,3,'Brusartsi'),(521,1,'Brusevtsi'),(521,2,'Брусевци'),(521,3,'Brusevtsi'),(522,1,'Brusen'),(522,2,'Брусен'),(522,3,'Brusen'),(523,1,'Brusen'),(523,2,'Брусен'),(523,3,'Brusen'),(524,1,'Brusino'),(524,2,'Брусино'),(524,3,'Brusino'),(525,1,'Brusnik'),(525,2,'Брусник'),(525,3,'Brusnik'),(526,1,'Branetsite'),(526,2,'Брънеците'),(526,3,'Branetsite'),(527,1,'Brachkovtsi'),(527,2,'Бръчковци'),(527,3,'Brachkovtsi'),(528,1,'Brashlen'),(528,2,'Бръшлен'),(528,3,'Brashlen'),(529,1,'Brashlyan'),(529,2,'Бръшлян'),(529,3,'Brashlyan'),(530,1,'Brashlyanitsa'),(530,2,'Бръшляница'),(530,3,'Brashlyanitsa'),(531,1,'Brashten'),(531,2,'Бръщен'),(531,3,'Brashten'),(532,1,'Bryagovets'),(532,2,'Бряговец'),(532,3,'Bryagovets'),(533,1,'Bryagovitsa'),(533,2,'Бряговица'),(533,3,'Bryagovitsa'),(534,1,'Bryagovo'),(534,2,'Брягово'),(534,3,'Bryagovo'),(535,1,'Bryagovo'),(535,2,'Брягово'),(535,3,'Bryagovo'),(536,1,'Bryast'),(536,2,'Бряст'),(536,3,'Bryast'),(537,1,'Bryastovets'),(537,2,'Брястовец'),(537,3,'Bryastovets'),(538,1,'Bryastovo'),(538,2,'Брястово'),(538,3,'Bryastovo'),(539,1,'Bryastovo'),(539,2,'Брястово'),(539,3,'Bryastovo'),(540,1,'Bryastovo'),(540,2,'Брястово'),(540,3,'Bryastovo'),(541,1,'Bubino'),(541,2,'Бубино'),(541,3,'Bubino'),(542,1,'Budiltsi'),(542,2,'Будилци'),(542,3,'Budiltsi'),(543,1,'Buzovgrad'),(543,2,'Бузовград'),(543,3,'Buzovgrad'),(544,1,'Buzyakovtsi'),(544,2,'Бузяковци'),(544,3,'Buzyakovtsi'),(545,1,'Buynovitsa'),(545,2,'Буйновица'),(545,3,'Buynovitsa'),(546,1,'Buynovo'),(546,2,'Буйново'),(546,3,'Buynovo'),(547,1,'Buynovo'),(547,2,'Буйново'),(547,3,'Buynovo'),(548,1,'Buynovtsi'),(548,2,'Буйновци'),(548,3,'Buynovtsi'),(549,1,'Buk'),(549,2,'Бук'),(549,3,'Buk'),(550,1,'Bukak'),(550,2,'Букак'),(550,3,'Bukak'),(551,1,'Bukata'),(551,2,'Буката'),(551,3,'Bukata'),(552,1,'Bukatsite'),(552,2,'Букаците'),(552,3,'Bukatsite'),(553,1,'Bukova polyana'),(553,2,'Букова поляна'),(553,3,'Bukova polyana'),(554,1,'Bukovets'),(554,2,'Буковец'),(554,3,'Bukovets'),(555,1,'Bukovets'),(555,2,'Буковец'),(555,3,'Bukovets'),(556,1,'Bukovets'),(556,2,'Буковец'),(556,3,'Bukovets'),(557,1,'Bukovets'),(557,2,'Буковец'),(557,3,'Bukovets'),(558,1,'Bukovets'),(558,2,'Буковец'),(558,3,'Bukovets'),(559,1,'Bukovlak'),(559,2,'Буковлък'),(559,3,'Bukovlak'),(560,1,'Bukovo'),(560,2,'Буково'),(560,3,'Bukovo'),(561,1,'Bukovo'),(561,2,'Буково'),(561,3,'Bukovo'),(562,1,'Bukovo'),(562,2,'Буково'),(562,3,'Bukovo'),(563,1,'Bukorovtsi'),(563,2,'Букоровци'),(563,3,'Bukorovtsi'),(564,1,'Bulair'),(564,2,'Булаир'),(564,3,'Bulair'),(565,1,'Bunovo'),(565,2,'Буново'),(565,3,'Bunovo'),(566,1,'Bunovo'),(566,2,'Буново'),(566,3,'Bunovo'),(567,1,'Buntsevo'),(567,2,'Бунцево'),(567,3,'Buntsevo'),(568,1,'Buranovo'),(568,2,'Бураново'),(568,3,'Buranovo'),(569,1,'Burgas'),(569,2,'Бургас'),(569,3,'Burgas'),(570,1,'Burevo'),(570,2,'Бурево'),(570,3,'Burevo'),(571,1,'Burya'),(571,2,'Буря'),(571,3,'Burya'),(572,1,'Busintsi'),(572,2,'Бусинци'),(572,3,'Busintsi'),(573,1,'Busmantsi'),(573,2,'Бусманци'),(573,3,'Busmantsi'),(574,1,'Butan'),(574,2,'Бутан'),(574,3,'Butan'),(575,1,'Butovo'),(575,2,'Бутово'),(575,3,'Butovo'),(576,1,'Butreva'),(576,2,'Бутрева'),(576,3,'Butreva'),(577,1,'Butrointsi'),(577,2,'Бутроинци'),(577,3,'Butrointsi'),(578,1,'Buhovo'),(578,2,'Бухово'),(578,3,'Buhovo'),(579,1,'Buhovtsi'),(579,2,'Буховци'),(579,3,'Buhovtsi'),(580,1,'Buchin prohod'),(580,2,'Бучин проход'),(580,3,'Buchin prohod'),(581,1,'Buchino'),(581,2,'Бучино'),(581,3,'Buchino'),(582,1,'Buchukovtsi'),(582,2,'Бучуковци'),(582,3,'Buchukovtsi'),(583,1,'Badeshte'),(583,2,'Бъдеще'),(583,3,'Badeshte'),(584,1,'Bazovets'),(584,2,'Бъзовец'),(584,3,'Bazovets'),(585,1,'Bazovets'),(585,2,'Бъзовец'),(585,3,'Bazovets'),(586,1,'Bazovitsa'),(586,2,'Бъзовица'),(586,3,'Bazovitsa'),(587,1,'Bazan'),(587,2,'Бъзън'),(587,3,'Bazan'),(588,1,'Balgaranovo'),(588,2,'Българаново'),(588,3,'Balgaranovo'),(589,1,'Balgarevo'),(589,2,'Българево'),(589,3,'Balgarevo'),(590,1,'Balgarene'),(590,2,'Българене'),(590,3,'Balgarene'),(591,1,'Balgarene'),(591,2,'Българене'),(591,3,'Balgarene'),(592,1,'Balgarene'),(592,2,'Българене'),(592,3,'Balgarene'),(593,1,'Balgari'),(593,2,'Българи'),(593,3,'Balgari'),(594,1,'Balgari'),(594,2,'Българи'),(594,3,'Balgari'),(595,1,'Balgarin'),(595,2,'Българин'),(595,3,'Balgarin'),(596,1,'Balgarka'),(596,2,'Българка'),(596,3,'Balgarka'),(597,1,'Balgarovo'),(597,2,'Българово'),(597,3,'Balgarovo'),(598,1,'Balgarska polyana'),(598,2,'Българска поляна'),(598,3,'Balgarska polyana'),(599,1,'Balgarski izvor'),(599,2,'Български извор'),(599,3,'Balgarski izvor'),(600,1,'Balgarsko Slivovo'),(600,2,'Българско Сливово'),(600,3,'Balgarsko Slivovo'),(601,1,'Balgarchevo'),(601,2,'Българчево'),(601,3,'Balgarchevo'),(602,1,'Banzareto'),(602,2,'Бънзарето'),(602,3,'Banzareto'),(603,1,'Bardarevo'),(603,2,'Бърдарево'),(603,3,'Bardarevo'),(604,1,'Bardarite'),(604,2,'Бърдарите'),(604,3,'Bardarite'),(605,1,'Bardarski geran'),(605,2,'Бърдарски геран'),(605,3,'Bardarski geran'),(606,1,'Bardeni'),(606,2,'Бърдени'),(606,3,'Bardeni'),(607,1,'Bardo'),(607,2,'Бърдо'),(607,3,'Bardo'),(608,1,'Bardokva'),(608,2,'Бърдоква'),(608,3,'Bardokva'),(609,1,'Barza reka'),(609,2,'Бърза река'),(609,3,'Barza reka'),(610,1,'Barzeya'),(610,2,'Бързея'),(610,3,'Barzeya'),(611,1,'Barzina'),(611,2,'Бързина'),(611,3,'Barzina'),(612,1,'Barzitsa'),(612,2,'Бързица'),(612,3,'Barzitsa'),(613,1,'Barzia'),(613,2,'Бързия'),(613,3,'Barzia'),(614,1,'Barkach'),(614,2,'Бъркач'),(614,3,'Barkach'),(615,1,'Barkachevo'),(615,2,'Бъркачево'),(615,3,'Barkachevo'),(616,1,'Barlozhnitsa'),(616,2,'Бърложница'),(616,3,'Barlozhnitsa'),(617,1,'Barlya'),(617,2,'Бърля'),(617,3,'Barlya'),(618,1,'Barchevo'),(618,2,'Бърчево'),(618,3,'Barchevo'),(619,1,'Bata'),(619,2,'Бъта'),(619,3,'Bata'),(620,1,'Byaga'),(620,2,'Бяга'),(620,3,'Byaga'),(621,1,'Byal bryag'),(621,2,'Бял бряг'),(621,3,'Byal bryag'),(622,1,'Byal izvor'),(622,2,'Бял извор'),(622,3,'Byal izvor'),(623,1,'Byal izvor'),(623,2,'Бял извор'),(623,3,'Byal izvor'),(624,1,'Byal kladenets'),(624,2,'Бял кладенец'),(624,3,'Byal kladenets'),(625,1,'Byal kladenets'),(625,2,'Бял кладенец'),(625,3,'Byal kladenets'),(626,1,'Byala'),(626,2,'Бяла'),(626,3,'Byala'),(627,1,'Byala'),(627,2,'Бяла'),(627,3,'Byala'),(628,1,'Byala'),(628,2,'Бяла'),(628,3,'Byala'),(629,1,'Byala voda'),(629,2,'Бяла вода'),(629,3,'Byala voda'),(630,1,'Byala voda'),(630,2,'Бяла вода'),(630,3,'Byala voda'),(631,1,'Byala palanka'),(631,2,'Бяла паланка'),(631,3,'Byala palanka'),(632,1,'Byala polyana'),(632,2,'Бяла поляна'),(632,3,'Byala polyana'),(633,1,'Byala reka'),(633,2,'Бяла река'),(633,3,'Byala reka'),(634,1,'Byala reka'),(634,2,'Бяла река'),(634,3,'Byala reka'),(635,1,'Byala reka'),(635,2,'Бяла река'),(635,3,'Byala reka'),(636,1,'Byala reka'),(636,2,'Бяла река'),(636,3,'Byala reka'),(637,1,'Byala Slatina'),(637,2,'Бяла Слатина'),(637,3,'Byala Slatina'),(638,1,'Byala cherkva'),(638,2,'Бяла черква'),(638,3,'Byala cherkva'),(639,1,'Byalgradets'),(639,2,'Бялградец'),(639,3,'Byalgradets'),(640,1,'Byalka'),(640,2,'Бялка'),(640,3,'Byalka'),(641,1,'Byalkovo'),(641,2,'Бялково'),(641,3,'Byalkovo'),(642,1,'Byalkovtsi'),(642,2,'Бялковци'),(642,3,'Byalkovtsi'),(643,1,'Byalo pole'),(643,2,'Бяло поле'),(643,3,'Byalo pole'),(644,1,'Vazovo'),(644,2,'Вазово'),(644,3,'Vazovo'),(645,1,'Vakarel'),(645,2,'Вакарел'),(645,3,'Vakarel'),(646,1,'Vaklino'),(646,2,'Ваклино'),(646,3,'Vaklino'),(647,1,'Vaklinovo'),(647,2,'Ваклиново'),(647,3,'Vaklinovo'),(648,1,'Vaksevo'),(648,2,'Ваксево'),(648,3,'Vaksevo'),(649,1,'Valevtsi'),(649,2,'Валевци'),(649,3,'Valevtsi'),(650,1,'Valeto'),(650,2,'Валето'),(650,3,'Valeto'),(651,1,'Varana'),(651,2,'Варана'),(651,3,'Varana'),(652,1,'Varvara'),(652,2,'Варвара'),(652,3,'Varvara'),(653,1,'Varvara'),(653,2,'Варвара'),(653,3,'Varvara'),(654,1,'Vardim'),(654,2,'Вардим'),(654,3,'Vardim'),(655,1,'Vardun'),(655,2,'Вардун'),(655,3,'Vardun'),(656,1,'Varna'),(656,2,'Варна'),(656,3,'Varna'),(657,1,'Varnentsi'),(657,2,'Варненци'),(657,3,'Varnentsi'),(658,1,'Varnik'),(658,2,'Варник'),(658,3,'Varnik'),(659,1,'Varovnik'),(659,2,'Варовник'),(659,3,'Varovnik'),(660,1,'Vasil Drumev'),(660,2,'Васил Друмев'),(660,3,'Vasil Drumev'),(661,1,'Vasil Levski'),(661,2,'Васил Левски'),(661,3,'Vasil Levski'),(662,1,'Vasil Levski'),(662,2,'Васил Левски'),(662,3,'Vasil Levski'),(663,1,'Vasil Levski'),(663,2,'Васил Левски'),(663,3,'Vasil Levski'),(664,1,'Vasil Levski'),(664,2,'Васил Левски'),(664,3,'Vasil Levski'),(665,1,'Vasilevo'),(665,2,'Василево'),(665,3,'Vasilevo'),(666,1,'Vasilkovska mahala'),(666,2,'Василковска махала'),(666,3,'Vasilkovska mahala'),(667,1,'Vasilovtsi'),(667,2,'Василовци'),(667,3,'Vasilovtsi'),(668,1,'Vasilovtsi'),(668,2,'Василовци'),(668,3,'Vasilovtsi'),(669,1,'Vasilyovo'),(669,2,'Васильово'),(669,3,'Vasilyovo'),(670,1,'Vaskovo'),(670,2,'Васково'),(670,3,'Vaskovo'),(671,1,'Vedrare'),(671,2,'Ведраре'),(671,3,'Vedrare'),(672,1,'Vedrina'),(672,2,'Ведрина'),(672,3,'Vedrina'),(673,1,'Vedrovo'),(673,2,'Ведрово'),(673,3,'Vedrovo'),(674,1,'Vezenkovo'),(674,2,'Везенково'),(674,3,'Vezenkovo'),(675,1,'Vekilski'),(675,2,'Векилски'),(675,3,'Vekilski'),(676,1,'Velentsi'),(676,2,'Веленци'),(676,3,'Velentsi'),(677,1,'Veleshani'),(677,2,'Велешани'),(677,3,'Veleshani'),(678,1,'Velika'),(678,2,'Велика'),(678,3,'Velika'),(679,1,'Velikan'),(679,2,'Великан'),(679,3,'Velikan'),(680,1,'Velikdenche'),(680,2,'Великденче'),(680,3,'Velikdenche'),(681,1,'Velikdenche'),(681,2,'Великденче'),(681,3,'Velikdenche'),(682,1,'Veliki Preslav'),(682,2,'Велики Преслав'),(682,3,'Veliki Preslav'),(683,1,'Veliko Tarnovo'),(683,2,'Велико Търново'),(683,3,'Veliko Tarnovo'),(684,1,'Velikovo'),(684,2,'Великово'),(684,3,'Velikovo'),(685,1,'Velikovo'),(685,2,'Великово'),(685,3,'Velikovo'),(686,1,'Velikovtsi'),(686,2,'Великовци'),(686,3,'Velikovtsi'),(687,1,'Velingrad'),(687,2,'Велинград'),(687,3,'Velingrad'),(688,1,'Velino'),(688,2,'Велино'),(688,3,'Velino'),(689,1,'Velinovo'),(689,2,'Велиново'),(689,3,'Velinovo'),(690,1,'Velislav'),(690,2,'Велислав'),(690,3,'Velislav'),(691,1,'Velichka'),(691,2,'Величка'),(691,3,'Velichka'),(692,1,'Velichkovo'),(692,2,'Величково'),(692,3,'Velichkovo'),(693,1,'Velichkovo'),(693,2,'Величково'),(693,3,'Velichkovo'),(694,1,'Velkovo'),(694,2,'Велково'),(694,3,'Velkovo'),(695,1,'Velkovtsi'),(695,2,'Велковци'),(695,3,'Velkovtsi'),(696,1,'Velkovtsi'),(696,2,'Велковци'),(696,3,'Velkovtsi'),(697,1,'Velkovtsi'),(697,2,'Велковци'),(697,3,'Velkovtsi'),(698,1,'Velchevo'),(698,2,'Велчево'),(698,3,'Velchevo'),(699,1,'Velchevo'),(699,2,'Велчево'),(699,3,'Velchevo'),(700,1,'Velchovtsi'),(700,2,'Велчовци'),(700,3,'Velchovtsi'),(701,1,'Velyovo'),(701,2,'Вельово'),(701,3,'Velyovo'),(702,1,'Velyuvtsi'),(702,2,'Велювци'),(702,3,'Velyuvtsi'),(703,1,'Velyushtets'),(703,2,'Велющец'),(703,3,'Velyushtets'),(704,1,'Venelin'),(704,2,'Венелин'),(704,3,'Venelin'),(705,1,'Venets'),(705,2,'Венец'),(705,3,'Venets'),(706,1,'Venets'),(706,2,'Венец'),(706,3,'Venets'),(707,1,'Venets'),(707,2,'Венец'),(707,3,'Venets'),(708,1,'Venkovets'),(708,2,'Венковец'),(708,3,'Venkovets'),(709,1,'Venchan'),(709,2,'Венчан'),(709,3,'Venchan'),(710,1,'Veren'),(710,2,'Верен'),(710,3,'Veren'),(711,1,'Verentsi'),(711,2,'Веренци'),(711,3,'Verentsi'),(712,1,'Verinsko'),(712,2,'Веринско'),(712,3,'Verinsko'),(713,1,'Versko'),(713,2,'Верско'),(713,3,'Versko'),(714,1,'Veselets'),(714,2,'Веселец'),(714,3,'Veselets'),(715,1,'Veselets'),(715,2,'Веселец'),(715,3,'Veselets'),(716,1,'Veselie'),(716,2,'Веселие'),(716,3,'Veselie'),(717,1,'Veselina'),(717,2,'Веселина'),(717,3,'Veselina'),(718,1,'Veselina'),(718,2,'Веселина'),(718,3,'Veselina'),(719,1,'Veselinovo'),(719,2,'Веселиново'),(719,3,'Veselinovo'),(720,1,'Veselinovo'),(720,2,'Веселиново'),(720,3,'Veselinovo'),(721,1,'Veslets'),(721,2,'Веслец'),(721,3,'Veslets'),(722,1,'Vetovo'),(722,2,'Ветово'),(722,3,'Vetovo'),(723,1,'Vetren'),(723,2,'Ветрен'),(723,3,'Vetren'),(724,1,'Vetren'),(724,2,'Ветрен'),(724,3,'Vetren'),(725,1,'Vetren'),(725,2,'Ветрен'),(725,3,'Vetren'),(726,1,'Vetren'),(726,2,'Ветрен'),(726,3,'Vetren'),(727,1,'Vetren dol'),(727,2,'Ветрен дол'),(727,3,'Vetren dol'),(728,1,'Vetrino'),(728,2,'Ветрино'),(728,3,'Vetrino'),(729,1,'Vetrintsi'),(729,2,'Ветринци'),(729,3,'Vetrintsi'),(730,1,'Vetrishte'),(730,2,'Ветрище'),(730,3,'Vetrishte'),(731,1,'Vetrovo'),(731,2,'Ветрово'),(731,3,'Vetrovo'),(732,1,'Vetrushka'),(732,2,'Ветрушка'),(732,3,'Vetrushka'),(733,1,'Vehtino'),(733,2,'Вехтино'),(733,3,'Vehtino'),(734,1,'Vehtovo'),(734,2,'Вехтово'),(734,3,'Vehtovo'),(735,1,'Veshtitsa'),(735,2,'Вещица'),(735,3,'Veshtitsa'),(736,1,'Viden'),(736,2,'Виден'),(736,3,'Viden'),(737,1,'Vidin'),(737,2,'Видин'),(737,3,'Vidin'),(738,1,'Vidintsi'),(738,2,'Видинци'),(738,3,'Vidintsi'),(739,1,'Vidlitsa'),(739,2,'Видлица'),(739,3,'Vidlitsa'),(740,1,'Vidno'),(740,2,'Видно'),(740,3,'Vidno'),(741,1,'Vidrar'),(741,2,'Видрар'),(741,3,'Vidrar'),(742,1,'Vidrare'),(742,2,'Видраре'),(742,3,'Vidrare'),(743,1,'Vidritsa'),(743,2,'Видрица'),(743,3,'Vidritsa'),(744,1,'Vievo'),(744,2,'Виево'),(744,3,'Vievo'),(745,1,'Vizitsa'),(745,2,'Визица'),(745,3,'Vizitsa'),(746,1,'Vilare'),(746,2,'Виларе'),(746,3,'Vilare'),(747,1,'Vinarovo'),(747,2,'Винарово'),(747,3,'Vinarovo'),(748,1,'Vinarovo'),(748,2,'Винарово'),(748,3,'Vinarovo'),(749,1,'Vinarsko'),(749,2,'Винарско'),(749,3,'Vinarsko'),(750,1,'Vinevo'),(750,2,'Винево'),(750,3,'Vinevo'),(751,1,'Vinitsa'),(751,2,'Виница'),(751,3,'Vinitsa'),(752,1,'Vinishte'),(752,2,'Винище'),(752,3,'Vinishte'),(753,1,'Vinograd'),(753,2,'Виноград'),(753,3,'Vinograd'),(754,1,'Vinogradets'),(754,2,'Виноградец'),(754,3,'Vinogradets'),(755,1,'Vinogradi'),(755,2,'Виногради'),(755,3,'Vinogradi'),(756,1,'Virove'),(756,2,'Вирове'),(756,3,'Virove'),(757,1,'Virovsko'),(757,2,'Вировско'),(757,3,'Virovsko'),(758,1,'Vis'),(758,2,'Вис'),(758,3,'Vis'),(759,1,'Viskyar'),(759,2,'Вискяр'),(759,3,'Viskyar'),(760,1,'Visok'),(760,2,'Висок'),(760,3,'Visok'),(761,1,'Visoka'),(761,2,'Висока'),(761,3,'Visoka'),(762,1,'Visoka mogila'),(762,2,'Висока могила'),(762,3,'Visoka mogila'),(763,1,'Visoka polyana'),(763,2,'Висока поляна'),(763,3,'Visoka polyana'),(764,1,'Visoka polyana'),(764,2,'Висока поляна'),(764,3,'Visoka polyana'),(765,1,'Visokite'),(765,2,'Високите'),(765,3,'Visokite'),(766,1,'Visokovtsi'),(766,2,'Високовци'),(766,3,'Visokovtsi'),(767,1,'Vitanovtsi'),(767,2,'Витановци'),(767,3,'Vitanovtsi'),(768,1,'Vitina'),(768,2,'Витина'),(768,3,'Vitina'),(769,1,'Vihren'),(769,2,'Вихрен'),(769,3,'Vihren'),(770,1,'Vichovo'),(770,2,'Вичово'),(770,3,'Vichovo'),(771,1,'Vishan'),(771,2,'Вишан'),(771,3,'Vishan'),(772,1,'Vishegrad'),(772,2,'Вишеград'),(772,3,'Vishegrad'),(773,1,'Vishlene'),(773,2,'Вишлене'),(773,3,'Vishlene'),(774,1,'Vishna'),(774,2,'Вишна'),(774,3,'Vishna'),(775,1,'Vishnevo'),(775,2,'Вишнево'),(775,3,'Vishnevo'),(776,1,'Vishovgrad'),(776,2,'Вишовград'),(776,3,'Vishovgrad'),(777,1,'Vladaya'),(777,2,'Владая'),(777,3,'Vladaya'),(778,1,'Vladimir'),(778,2,'Владимир'),(778,3,'Vladimir'),(779,1,'Vladimirovo'),(779,2,'Владимирово'),(779,3,'Vladimirovo'),(780,1,'Vladimirovo'),(780,2,'Владимирово'),(780,3,'Vladimirovo'),(781,1,'Vladimirovo'),(781,2,'Владимирово'),(781,3,'Vladimirovo'),(782,1,'Vladimirovtsi'),(782,2,'Владимировци'),(782,3,'Vladimirovtsi'),(783,1,'Vladinya'),(783,2,'Владиня'),(783,3,'Vladinya'),(784,1,'Vladislav'),(784,2,'Владислав'),(784,3,'Vladislav'),(785,1,'Vladislavtsi'),(785,2,'Владиславци'),(785,3,'Vladislavtsi'),(786,1,'Vladichentsi'),(786,2,'Владиченци'),(786,3,'Vladichentsi'),(787,1,'Vlado Trichkov'),(787,2,'Владо Тричков'),(787,3,'Vlado Trichkov'),(788,1,'Vladovtsi'),(788,2,'Владовци'),(788,3,'Vladovtsi'),(789,1,'Vlaychovtsi'),(789,2,'Влайчовци'),(789,3,'Vlaychovtsi'),(790,1,'Vlasatili'),(790,2,'Власатили'),(790,3,'Vlasatili'),(791,1,'Vlasatitsa'),(791,2,'Власатица'),(791,3,'Vlasatitsa'),(792,1,'Vlahi'),(792,2,'Влахи'),(792,3,'Vlahi'),(793,1,'Vlahovo'),(793,2,'Влахово'),(793,3,'Vlahovo'),(794,1,'Vlahovtsi'),(794,2,'Влаховци'),(794,3,'Vlahovtsi'),(795,1,'Vodata'),(795,2,'Водата'),(795,3,'Vodata'),(796,1,'Vodach'),(796,2,'Водач'),(796,3,'Vodach'),(797,1,'Voden'),(797,2,'Воден'),(797,3,'Voden'),(798,1,'Voden'),(798,2,'Воден'),(798,3,'Voden'),(799,1,'Voden'),(799,2,'Воден'),(799,3,'Voden'),(800,1,'Vodenichane'),(800,2,'Воденичане'),(800,3,'Vodenichane'),(801,1,'Vodenicharovo'),(801,2,'Воденичарово'),(801,3,'Vodenicharovo'),(802,1,'Vodenicharsko'),(802,2,'Воденичарско'),(802,3,'Vodenicharsko'),(803,1,'Vodentsi'),(803,2,'Воденци'),(803,3,'Vodentsi'),(804,1,'Voditsa'),(804,2,'Водица'),(804,3,'Voditsa'),(805,1,'Voditsa'),(805,2,'Водица'),(805,3,'Voditsa'),(806,1,'Vodna'),(806,2,'Водна'),(806,3,'Vodna'),(807,1,'Vodni pad'),(807,2,'Водни пад'),(807,3,'Vodni pad'),(808,1,'Vodno'),(808,2,'Водно'),(808,3,'Vodno'),(809,1,'Vodno'),(809,2,'Водно'),(809,3,'Vodno'),(810,1,'Vodnyantsi'),(810,2,'Воднянци'),(810,3,'Vodnyantsi'),(811,1,'Vodnyantsi'),(811,2,'Воднянци'),(811,3,'Vodnyantsi'),(812,1,'Vodoley'),(812,2,'Водолей'),(812,3,'Vodoley'),(813,1,'Vozhdovo'),(813,2,'Вождово'),(813,3,'Vozhdovo'),(814,1,'Voyvoda'),(814,2,'Войвода'),(814,3,'Voyvoda'),(815,1,'Voyvodenets'),(815,2,'Войводенец'),(815,3,'Voyvodenets'),(816,1,'Voyvodino'),(816,2,'Войводино'),(816,3,'Voyvodino'),(817,1,'Voyvodinovo'),(817,2,'Войводиново'),(817,3,'Voyvodinovo'),(818,1,'Voyvodovo'),(818,2,'Войводово'),(818,3,'Voyvodovo'),(819,1,'Voyvodovo'),(819,2,'Войводово'),(819,3,'Voyvodovo'),(820,1,'Voykova laka'),(820,2,'Войкова лъка'),(820,3,'Voykova laka'),(821,1,'Voynegovtsi'),(821,2,'Войнеговци'),(821,3,'Voynegovtsi'),(822,1,'Voynezha'),(822,2,'Войнежа'),(822,3,'Voynezha'),(823,1,'Voynika'),(823,2,'Войника'),(823,3,'Voynika'),(824,1,'Voynikovo'),(824,2,'Войниково'),(824,3,'Voynikovo'),(825,1,'Voynitsa'),(825,2,'Войница'),(825,3,'Voynitsa'),(826,1,'Voynitsi'),(826,2,'Войници'),(826,3,'Voynitsi'),(827,1,'Voynitsite'),(827,2,'Войниците'),(827,3,'Voynitsite'),(828,1,'Voynishka'),(828,2,'Войнишка'),(828,3,'Voynishka'),(829,1,'Voynovo'),(829,2,'Войново'),(829,3,'Voynovo'),(830,1,'Voynovo'),(830,2,'Войново'),(830,3,'Voynovo'),(831,1,'Voynyagovo'),(831,2,'Войнягово'),(831,3,'Voynyagovo'),(832,1,'Voysil'),(832,2,'Войсил'),(832,3,'Voysil'),(833,1,'Vokil'),(833,2,'Вокил'),(833,3,'Vokil'),(834,1,'Volno'),(834,2,'Волно'),(834,3,'Volno'),(835,1,'Volovarovo'),(835,2,'Воловарово'),(835,3,'Volovarovo'),(836,1,'Volovartsi'),(836,2,'Воловарци'),(836,3,'Volovartsi'),(837,1,'Volovo'),(837,2,'Волово'),(837,3,'Volovo'),(838,1,'Voluyak'),(838,2,'Волуяк'),(838,3,'Voluyak'),(839,1,'Voneshta voda'),(839,2,'Вонеща вода'),(839,3,'Voneshta voda'),(840,1,'Vrabevo'),(840,2,'Врабево'),(840,3,'Vrabevo'),(841,1,'Vrabtsite'),(841,2,'Врабците'),(841,3,'Vrabtsite'),(842,1,'Vrabcha'),(842,2,'Врабча'),(842,3,'Vrabcha'),(843,1,'Vrakupovitsa'),(843,2,'Вракуповица'),(843,3,'Vrakupovitsa'),(844,1,'Vranentsi'),(844,2,'Враненци'),(844,3,'Vranentsi'),(845,1,'Vrani kon'),(845,2,'Врани кон'),(845,3,'Vrani kon'),(846,1,'Vranilovtsi'),(846,2,'Враниловци'),(846,3,'Vranilovtsi'),(847,1,'Vranino'),(847,2,'Вранино'),(847,3,'Vranino'),(848,1,'Vranintsi'),(848,2,'Вранинци'),(848,3,'Vranintsi'),(849,1,'Vransko'),(849,2,'Вранско'),(849,3,'Vransko'),(850,1,'Vranya'),(850,2,'Враня'),(850,3,'Vranya'),(851,1,'Vranya stena'),(851,2,'Враня стена'),(851,3,'Vranya stena'),(852,1,'Vranyak'),(852,2,'Враняк'),(852,3,'Vranyak'),(853,1,'Vrata'),(853,2,'Врата'),(853,3,'Vrata'),(854,1,'Vratarite'),(854,2,'Вратарите'),(854,3,'Vratarite'),(855,1,'Vratitsa'),(855,2,'Вратица'),(855,3,'Vratitsa'),(856,1,'Vrattsa'),(856,2,'Вратца'),(856,3,'Vrattsa'),(857,1,'Vratsa'),(857,2,'Враца'),(857,3,'Vratsa'),(858,1,'Vrachantsi'),(858,2,'Врачанци'),(858,3,'Vrachantsi'),(859,1,'Vrachesh'),(859,2,'Врачеш'),(859,3,'Vrachesh'),(860,1,'Vrelo'),(860,2,'Врело'),(860,3,'Vrelo'),(861,1,'Vresovo'),(861,2,'Вресово'),(861,3,'Vresovo'),(862,1,'Vrav'),(862,2,'Връв'),(862,3,'Vrav'),(863,1,'Vradlovtsi'),(863,2,'Връдловци'),(863,3,'Vradlovtsi'),(864,1,'Vsemirtsi'),(864,2,'Всемирци'),(864,3,'Vsemirtsi'),(865,1,'Vukan'),(865,2,'Вукан'),(865,3,'Vukan'),(866,1,'Vukovo'),(866,2,'Вуково'),(866,3,'Vukovo'),(867,1,'Vabel'),(867,2,'Въбел'),(867,3,'Vabel'),(868,1,'Vaglarovo'),(868,2,'Въгларово'),(868,3,'Vaglarovo'),(869,1,'Vaglevtsi'),(869,2,'Въглевци'),(869,3,'Vaglevtsi'),(870,1,'Vaglen'),(870,2,'Въглен'),(870,3,'Vaglen'),(871,1,'Vaglen'),(871,2,'Въглен'),(871,3,'Vaglen'),(872,1,'Vazel'),(872,2,'Възел'),(872,3,'Vazel'),(873,1,'Valkan'),(873,2,'Вълкан'),(873,3,'Valkan'),(874,1,'Valkov dol'),(874,2,'Вълков дол'),(874,3,'Valkov dol'),(875,1,'Valkovich'),(875,2,'Вълкович'),(875,3,'Valkovich'),(876,1,'Valkovo'),(876,2,'Вълково'),(876,3,'Valkovo'),(877,1,'Valkovtsi'),(877,2,'Вълковци'),(877,3,'Valkovtsi'),(878,1,'Valkosel'),(878,2,'Вълкосел'),(878,3,'Valkosel'),(879,1,'Valnari'),(879,2,'Вълнари'),(879,3,'Valnari'),(880,1,'Valcha polyana'),(880,2,'Вълча поляна'),(880,3,'Valcha polyana'),(881,1,'Valchan'),(881,2,'Вълчан'),(881,3,'Valchan'),(882,1,'Valchan dol'),(882,2,'Вълчан дол'),(882,3,'Valchan dol'),(883,1,'Valchanka'),(883,2,'Вълчанка'),(883,3,'Valchanka'),(884,1,'Valchanovo'),(884,2,'Вълчаново'),(884,3,'Valchanovo'),(885,1,'Valche pole'),(885,2,'Вълче поле'),(885,3,'Valche pole'),(886,1,'Valchedram'),(886,2,'Вълчедръм'),(886,3,'Valchedram'),(887,1,'Valchek'),(887,2,'Вълчек'),(887,3,'Valchek'),(888,1,'Valchi dol'),(888,2,'Вълчи дол'),(888,3,'Valchi dol'),(889,1,'Valchi izvor'),(889,2,'Вълчи извор'),(889,3,'Valchi izvor'),(890,1,'Valchin'),(890,2,'Вълчин'),(890,3,'Valchin'),(891,1,'Valchitran'),(891,2,'Вълчитрън'),(891,3,'Valchitran'),(892,1,'Valchovtsi'),(892,2,'Вълчовци'),(892,3,'Valchovtsi'),(893,1,'Valchovtsi'),(893,2,'Вълчовци'),(893,3,'Valchovtsi'),(894,1,'Varba'),(894,2,'Върба'),(894,3,'Varba'),(895,1,'Varba'),(895,2,'Върба'),(895,3,'Varba'),(896,1,'Varbak'),(896,2,'Върбак'),(896,3,'Varbak'),(897,1,'Varben'),(897,2,'Върбен'),(897,3,'Varben'),(898,1,'Varben'),(898,2,'Върбен'),(898,3,'Varben'),(899,1,'Varbentsi'),(899,2,'Върбенци'),(899,3,'Varbentsi'),(900,1,'Varbeshnitsa'),(900,2,'Върбешница'),(900,3,'Varbeshnitsa'),(901,1,'Varbina'),(901,2,'Върбина'),(901,3,'Varbina'),(902,1,'Varbino'),(902,2,'Върбино'),(902,3,'Varbino'),(903,1,'Varbitsa'),(903,2,'Върбица'),(903,3,'Varbitsa'),(904,1,'Varbitsa'),(904,2,'Върбица'),(904,3,'Varbitsa'),(905,1,'Varbitsa'),(905,2,'Върбица'),(905,3,'Varbitsa'),(906,1,'Varbitsa'),(906,2,'Върбица'),(906,3,'Varbitsa'),(907,1,'Varbitsa'),(907,2,'Върбица'),(907,3,'Varbitsa'),(908,1,'Varbnitsa'),(908,2,'Върбница'),(908,3,'Varbnitsa'),(909,1,'Varbovka'),(909,2,'Върбовка'),(909,3,'Varbovka'),(910,1,'Varbovo'),(910,2,'Върбово'),(910,3,'Varbovo'),(911,1,'Varbovo'),(911,2,'Върбово'),(911,3,'Varbovo'),(912,1,'Varbovo'),(912,2,'Върбово'),(912,3,'Varbovo'),(913,1,'Varbovchets'),(913,2,'Върбовчец'),(913,3,'Varbovchets'),(914,1,'Varbyane'),(914,2,'Върбяне'),(914,3,'Varbyane'),(915,1,'Vargov dol'),(915,2,'Въргов дол'),(915,3,'Vargov dol'),(916,1,'Varzilkovtsi'),(916,2,'Вързилковци'),(916,3,'Varzilkovtsi'),(917,1,'Varzulitsa'),(917,2,'Вързулица'),(917,3,'Varzulitsa'),(918,1,'Varli dol'),(918,2,'Върли дол'),(918,3,'Varli dol'),(919,1,'Varli dol'),(919,2,'Върли дол'),(919,3,'Varli dol'),(920,1,'Varlinka'),(920,2,'Върлинка'),(920,3,'Varlinka'),(921,1,'Varlino'),(921,2,'Върлино'),(921,3,'Varlino'),(922,1,'Vartop'),(922,2,'Въртоп'),(922,3,'Vartop'),(923,1,'Varhari'),(923,2,'Върхари'),(923,3,'Varhari'),(924,1,'Varshets'),(924,2,'Вършец'),(924,3,'Varshets'),(925,1,'Varshilo'),(925,2,'Вършило'),(925,3,'Varshilo'),(926,1,'Gabare'),(926,2,'Габаре'),(926,3,'Gabare'),(927,1,'Gabarevo'),(927,2,'Габарево'),(927,3,'Gabarevo'),(928,1,'Gaber'),(928,2,'Габер'),(928,3,'Gaber'),(929,1,'Gaber'),(929,2,'Габер'),(929,3,'Gaber'),(930,1,'Gaberovo'),(930,2,'Габерово'),(930,3,'Gaberovo'),(931,1,'Gaberovo'),(931,2,'Габерово'),(931,3,'Gaberovo'),(932,1,'Gabra'),(932,2,'Габра'),(932,3,'Gabra'),(933,1,'Gabraka'),(933,2,'Габрака'),(933,3,'Gabraka'),(934,1,'Gabrene'),(934,2,'Габрене'),(934,3,'Gabrene'),(935,1,'Gabreshevtsi'),(935,2,'Габрешевци'),(935,3,'Gabreshevtsi'),(936,1,'Gabrina'),(936,2,'Габрина'),(936,3,'Gabrina'),(937,1,'Gabritsa'),(937,2,'Габрица'),(937,3,'Gabritsa'),(938,1,'Gabritsa'),(938,2,'Габрица'),(938,3,'Gabritsa'),(939,1,'Gabrovdol'),(939,2,'Габровдол'),(939,3,'Gabrovdol'),(940,1,'Gabrovitsa'),(940,2,'Габровица'),(940,3,'Gabrovitsa'),(941,1,'Gabrovnitsa'),(941,2,'Габровница'),(941,3,'Gabrovnitsa'),(942,1,'Gabrovnitsa'),(942,2,'Габровница'),(942,3,'Gabrovnitsa'),(943,1,'Gabrovo'),(943,2,'Габрово'),(943,3,'Gabrovo'),(944,1,'Gabrovo'),(944,2,'Габрово'),(944,3,'Gabrovo'),(945,1,'Gabrovo'),(945,2,'Габрово'),(945,3,'Gabrovo'),(946,1,'Gabrovtsi'),(946,2,'Габровци'),(946,3,'Gabrovtsi'),(947,1,'Gabar'),(947,2,'Габър'),(947,3,'Gabar'),(948,1,'Gabarnitsa'),(948,2,'Габърница'),(948,3,'Gabarnitsa'),(949,1,'Gabarska'),(949,2,'Габърска'),(949,3,'Gabarska'),(950,1,'Gavrailovo'),(950,2,'Гавраилово'),(950,3,'Gavrailovo'),(951,1,'Gavril Genovo'),(951,2,'Гаврил Геново'),(951,3,'Gavril Genovo'),(952,1,'Gaganitsa'),(952,2,'Гаганица'),(952,3,'Gaganitsa'),(953,1,'Gagovo'),(953,2,'Гагово'),(953,3,'Gagovo'),(954,1,'Gaydari'),(954,2,'Гайдари'),(954,3,'Gaydari'),(955,1,'Gaykini'),(955,2,'Гайкини'),(955,3,'Gaykini'),(956,1,'Gaytanevo'),(956,2,'Гайтанево'),(956,3,'Gaytanevo'),(957,1,'Gaytaninovo'),(957,2,'Гайтаниново'),(957,3,'Gaytaninovo'),(958,1,'Gaytanite'),(958,2,'Гайтаните'),(958,3,'Gaytanite'),(959,1,'Gaytantsi'),(959,2,'Гайтанци'),(959,3,'Gaytantsi'),(960,1,'Galata'),(960,2,'Галата'),(960,3,'Galata'),(961,1,'Galatin'),(961,2,'Галатин'),(961,3,'Galatin'),(962,1,'Galiche'),(962,2,'Галиче'),(962,3,'Galiche'),(963,1,'Galishte'),(963,2,'Галище'),(963,3,'Galishte'),(964,1,'Galovo'),(964,2,'Галово'),(964,3,'Galovo'),(965,1,'Ganev dol'),(965,2,'Ганев дол'),(965,3,'Ganev dol'),(966,1,'Ganchovets'),(966,2,'Ганчовец'),(966,3,'Ganchovets'),(967,1,'Garvan'),(967,2,'Гарван'),(967,3,'Garvan'),(968,1,'Garvan'),(968,2,'Гарван'),(968,3,'Garvan'),(969,1,'Garvanovo'),(969,2,'Гарваново'),(969,3,'Garvanovo'),(970,1,'Gashtevtsi'),(970,2,'Гащевци'),(970,3,'Gashtevtsi'),(971,1,'Gega'),(971,2,'Гега'),(971,3,'Gega'),(972,1,'Gela'),(972,2,'Гела'),(972,3,'Gela'),(973,1,'Gelemenovo'),(973,2,'Гелеменово'),(973,3,'Gelemenovo'),(974,1,'General Geshevo'),(974,2,'Генерал Гешево'),(974,3,'General Geshevo'),(975,1,'General inzovo'),(975,2,'Генерал Инзово'),(975,3,'General inzovo'),(976,1,'General Kantardzhievo'),(976,2,'Генерал Кантарджиево'),(976,3,'General Kantardzhievo'),(977,1,'General Kiselovo'),(977,2,'Генерал Киселово'),(977,3,'General Kiselovo'),(978,1,'General Kolevo'),(978,2,'Генерал Колево'),(978,3,'General Kolevo'),(979,1,'General Kolevo'),(979,2,'Генерал Колево'),(979,3,'General Kolevo'),(980,1,'General Marinovo'),(980,2,'Генерал Мариново'),(980,3,'General Marinovo'),(981,1,'General Todorov'),(981,2,'Генерал Тодоров'),(981,3,'General Todorov'),(982,1,'General Toshevo'),(982,2,'Генерал Тошево'),(982,3,'General Toshevo'),(983,1,'General Toshevo'),(983,2,'Генерал Тошево'),(983,3,'General Toshevo'),(984,1,'Generalovo'),(984,2,'Генералово'),(984,3,'Generalovo'),(985,1,'Genovtsi'),(985,2,'Геновци'),(985,3,'Genovtsi'),(986,1,'Genchovtsi'),(986,2,'Генчовци'),(986,3,'Genchovtsi'),(987,1,'Genchovtsi'),(987,2,'Генчовци'),(987,3,'Genchovtsi'),(988,1,'Genya'),(988,2,'Геня'),(988,3,'Genya'),(989,1,'Georgi Damyanovo'),(989,2,'Георги Дамяново'),(989,3,'Georgi Damyanovo'),(990,1,'Georgi Dobrevo'),(990,2,'Георги Добрево'),(990,3,'Georgi Dobrevo'),(991,1,'Gergevets'),(991,2,'Гергевец'),(991,3,'Gergevets'),(992,1,'Gergini'),(992,2,'Гергини'),(992,3,'Gergini'),(993,1,'German'),(993,2,'Герман'),(993,3,'German'),(994,1,'Getsovo'),(994,2,'Гецово'),(994,3,'Getsovo'),(995,1,'Gesha'),(995,2,'Геша'),(995,3,'Gesha'),(996,1,'Geshanovo'),(996,2,'Гешаново'),(996,3,'Geshanovo'),(997,1,'Gigen'),(997,2,'Гиген'),(997,3,'Gigen'),(998,1,'Gigintsi'),(998,2,'Гигинци'),(998,3,'Gigintsi'),(999,1,'Gintsi'),(999,2,'Гинци'),(999,3,'Gintsi'),(1000,1,'Girchevtsi'),(1000,2,'Гирчевци'),(1000,3,'Girchevtsi'),(1001,1,'Gita'),(1001,2,'Гита'),(1001,3,'Gita'),(1002,1,'Glava'),(1002,2,'Глава'),(1002,3,'Glava'),(1003,1,'Glavan'),(1003,2,'Главан'),(1003,3,'Glavan'),(1004,1,'Glavan'),(1004,2,'Главан'),(1004,3,'Glavan'),(1005,1,'Glavanovtsi'),(1005,2,'Главановци'),(1005,3,'Glavanovtsi'),(1006,1,'Glavanovtsi'),(1006,2,'Главановци'),(1006,3,'Glavanovtsi'),(1007,1,'Glavantsi'),(1007,2,'Главанци'),(1007,3,'Glavantsi'),(1008,1,'Glavatar'),(1008,2,'Главатар'),(1008,3,'Glavatar'),(1009,1,'Glavatartsi'),(1009,2,'Главатарци'),(1009,3,'Glavatartsi'),(1010,1,'Glavatsi'),(1010,2,'Главаци'),(1010,3,'Glavatsi'),(1011,1,'Glavinitsa'),(1011,2,'Главиница'),(1011,3,'Glavinitsa'),(1012,1,'Glavinitsa'),(1012,2,'Главиница'),(1012,3,'Glavinitsa'),(1013,1,'Glavnik'),(1013,2,'Главник'),(1013,3,'Glavnik'),(1014,1,'Glashatay'),(1014,2,'Глашатай'),(1014,3,'Glashatay'),(1015,1,'Gledatsi'),(1015,2,'Гледаци'),(1015,3,'Gledatsi'),(1016,1,'Gledachevo'),(1016,2,'Гледачево'),(1016,3,'Gledachevo'),(1017,1,'Gledka'),(1017,2,'Гледка'),(1017,3,'Gledka'),(1018,1,'Gloginka'),(1018,2,'Глогинка'),(1018,3,'Gloginka'),(1019,1,'Glogino'),(1019,2,'Глогино'),(1019,3,'Glogino'),(1020,1,'Glogovets'),(1020,2,'Глоговец'),(1020,3,'Glogovets'),(1021,1,'Glogovitsa'),(1021,2,'Глоговица'),(1021,3,'Glogovitsa'),(1022,1,'Glogovo'),(1022,2,'Глогово'),(1022,3,'Glogovo'),(1023,1,'Glodzhevo'),(1023,2,'Глоджево'),(1023,3,'Glodzhevo'),(1024,1,'Glozhene'),(1024,2,'Гложене'),(1024,3,'Glozhene'),(1025,1,'Glozhene'),(1025,2,'Гложене'),(1025,3,'Glozhene'),(1026,1,'Glumovo'),(1026,2,'Глумово'),(1026,3,'Glumovo'),(1027,1,'Glumche'),(1027,2,'Глумче'),(1027,3,'Glumche'),(1028,1,'Glutnitsite'),(1028,2,'Глутниците'),(1028,3,'Glutnitsite'),(1029,1,'Glufishevo'),(1029,2,'Глуфишево'),(1029,3,'Glufishevo'),(1030,1,'Gluhar'),(1030,2,'Глухар'),(1030,3,'Gluhar'),(1031,1,'Glushka'),(1031,2,'Глушка'),(1031,3,'Glushka'),(1032,1,'Glushnik'),(1032,2,'Глушник'),(1032,3,'Glushnik'),(1033,1,'Gnezdare'),(1033,2,'Гнездаре'),(1033,3,'Gnezdare'),(1034,1,'Gnyazdovo'),(1034,2,'Гняздово'),(1034,3,'Gnyazdovo'),(1035,1,'Govedare'),(1035,2,'Говедаре'),(1035,3,'Govedare'),(1036,1,'Govedartsi'),(1036,2,'Говедарци'),(1036,3,'Govedartsi'),(1037,1,'Govezhda'),(1037,2,'Говежда'),(1037,3,'Govezhda'),(1038,1,'Godech'),(1038,2,'Годеч'),(1038,3,'Godech'),(1039,1,'Godeshevo'),(1039,2,'Годешево'),(1039,3,'Godeshevo'),(1040,1,'Godlevo'),(1040,2,'Годлево'),(1040,3,'Godlevo'),(1041,1,'Goz'),(1041,2,'Гоз'),(1041,3,'Goz'),(1042,1,'Gozdevitsa'),(1042,2,'Гоздевица'),(1042,3,'Gozdevitsa'),(1043,1,'Gozdeyka'),(1043,2,'Гоздейка'),(1043,3,'Gozdeyka'),(1044,1,'Golak'),(1044,2,'Голак'),(1044,3,'Golak'),(1045,1,'Golem Tsalim'),(1045,2,'Голем Цалим'),(1045,3,'Golem Tsalim'),(1046,1,'Golema Rakovitsa'),(1046,2,'Голема Раковица'),(1046,3,'Golema Rakovitsa'),(1047,1,'Golema Fucha'),(1047,2,'Голема Фуча'),(1047,3,'Golema Fucha'),(1048,1,'Golemani'),(1048,2,'Големани'),(1048,3,'Golemani'),(1049,1,'Golemanite'),(1049,2,'Големаните'),(1049,3,'Golemanite'),(1050,1,'Golemanovo'),(1050,2,'Големаново'),(1050,3,'Golemanovo'),(1051,1,'Golemantsi'),(1051,2,'Големанци'),(1051,3,'Golemantsi'),(1052,1,'Golemi Balgareni'),(1052,2,'Големи Българени'),(1052,3,'Golemi Balgareni'),(1053,1,'Golemi Stanchovtsi'),(1053,2,'Големи Станчовци'),(1053,3,'Golemi Stanchovtsi'),(1054,1,'Golemo Babino'),(1054,2,'Големо Бабино'),(1054,3,'Golemo Babino'),(1055,1,'Golemo Buchino'),(1055,2,'Големо Бучино'),(1055,3,'Golemo Buchino'),(1056,1,'Golemo Malovo'),(1056,2,'Големо Малово'),(1056,3,'Golemo Malovo'),(1057,1,'Golemo selo'),(1057,2,'Големо село'),(1057,3,'Golemo selo'),(1058,1,'Golets'),(1058,2,'Голец'),(1058,3,'Golets'),(1059,1,'Golesh'),(1059,2,'Голеш'),(1059,3,'Golesh'),(1060,1,'Golesh'),(1060,2,'Голеш'),(1060,3,'Golesh'),(1061,1,'Goleshovo'),(1061,2,'Голешово'),(1061,3,'Goleshovo'),(1062,1,'Golitsa'),(1062,2,'Голица'),(1062,3,'Golitsa'),(1063,1,'Golobrad'),(1063,2,'Голобрад'),(1063,3,'Golobrad'),(1064,1,'Golobradovo'),(1064,2,'Голобрадово'),(1064,3,'Golobradovo'),(1065,1,'Golyam Varbovnik'),(1065,2,'Голям Върбовник'),(1065,3,'Golyam Varbovnik'),(1066,1,'Golyam Devesil'),(1066,2,'Голям Девесил'),(1066,3,'Golyam Devesil'),(1067,1,'Golyam Dervent'),(1067,2,'Голям Дервент'),(1067,3,'Golyam Dervent'),(1068,1,'Golyam dol'),(1068,2,'Голям дол'),(1068,3,'Golyam dol'),(1069,1,'Golyam izvor'),(1069,2,'Голям извор'),(1069,3,'Golyam izvor'),(1070,1,'Golyam izvor'),(1070,2,'Голям извор'),(1070,3,'Golyam izvor'),(1071,1,'Golyam izvor'),(1071,2,'Голям извор'),(1071,3,'Golyam izvor'),(1072,1,'Golyam manastir'),(1072,2,'Голям манастир'),(1072,3,'Golyam manastir'),(1073,1,'Golyam Porovets'),(1073,2,'Голям Поровец'),(1073,3,'Golyam Porovets'),(1074,1,'Golyam chardak'),(1074,2,'Голям чардак'),(1074,3,'Golyam chardak'),(1075,1,'Golyama bara'),(1075,2,'Голяма бара'),(1075,3,'Golyama bara'),(1076,1,'Golyama Brestnitsa'),(1076,2,'Голяма Брестница'),(1076,3,'Golyama Brestnitsa'),(1077,1,'Golyama voda'),(1077,2,'Голяма вода'),(1077,3,'Golyama voda'),(1078,1,'Golyama dolina'),(1078,2,'Голяма долина'),(1078,3,'Golyama dolina'),(1079,1,'Golyama Zhelyazna'),(1079,2,'Голяма Желязна'),(1079,3,'Golyama Zhelyazna'),(1080,1,'Golyama Chinka'),(1080,2,'Голяма Чинка'),(1080,3,'Golyama Chinka'),(1081,1,'Golyamo Asenovo'),(1081,2,'Голямо Асеново'),(1081,3,'Golyamo Asenovo'),(1082,1,'Golyamo Belovo'),(1082,2,'Голямо Белово'),(1082,3,'Golyamo Belovo'),(1083,1,'Golyamo Bukovo'),(1083,2,'Голямо Буково'),(1083,3,'Golyamo Bukovo'),(1084,1,'Golyamo Vranovo'),(1084,2,'Голямо Враново'),(1084,3,'Golyamo Vranovo'),(1085,1,'Golyamo gradishte'),(1085,2,'Голямо градище'),(1085,3,'Golyamo gradishte'),(1086,1,'Golyamo Dolyane'),(1086,2,'Голямо Доляне'),(1086,3,'Golyamo Dolyane'),(1087,1,'Golyamo Dryanovo'),(1087,2,'Голямо Дряново'),(1087,3,'Golyamo Dryanovo'),(1088,1,'Golyamo Kamenyane'),(1088,2,'Голямо Каменяне'),(1088,3,'Golyamo Kamenyane'),(1089,1,'Golyamo Krushevo'),(1089,2,'Голямо Крушево'),(1089,3,'Golyamo Krushevo'),(1090,1,'Golyamo novo'),(1090,2,'Голямо ново'),(1090,3,'Golyamo novo'),(1091,1,'Golyamo Peshtene'),(1091,2,'Голямо Пещене'),(1091,3,'Golyamo Peshtene'),(1092,1,'Golyamo Sokolovo'),(1092,2,'Голямо Соколово'),(1092,3,'Golyamo Sokolovo'),(1093,1,'Golyamo tsarkvishte'),(1093,2,'Голямо църквище'),(1093,3,'Golyamo tsarkvishte'),(1094,1,'Golyamo Chochoveni'),(1094,2,'Голямо Чочовени'),(1094,3,'Golyamo Chochoveni'),(1095,1,'Golyanovtsi'),(1095,2,'Голяновци'),(1095,3,'Golyanovtsi'),(1096,1,'Gomotartsi'),(1096,2,'Гомотарци'),(1096,3,'Gomotartsi'),(1097,1,'Goran'),(1097,2,'Горан'),(1097,3,'Goran'),(1098,1,'Goranovtsi'),(1098,2,'Горановци'),(1098,3,'Goranovtsi'),(1099,1,'Goranovtsi'),(1099,2,'Горановци'),(1099,3,'Goranovtsi'),(1100,1,'Goreme'),(1100,2,'Гореме'),(1100,3,'Goreme'),(1101,1,'Goren Enevets'),(1101,2,'Горен Еневец'),(1101,3,'Goren Enevets'),(1102,1,'Goren chiflik'),(1102,2,'Горен чифлик'),(1102,3,'Goren chiflik'),(1103,1,'Goritsa'),(1103,2,'Горица'),(1103,3,'Goritsa'),(1104,1,'Goritsa'),(1104,2,'Горица'),(1104,3,'Goritsa'),(1105,1,'Goritsa'),(1105,2,'Горица'),(1105,3,'Goritsa'),(1106,1,'Goritsa'),(1106,2,'Горица'),(1106,3,'Goritsa'),(1107,1,'Gorichane'),(1107,2,'Горичане'),(1107,3,'Gorichane'),(1108,1,'Gorichevo'),(1108,2,'Горичево'),(1108,3,'Gorichevo'),(1109,1,'Gorna Arda'),(1109,2,'Горна Арда'),(1109,3,'Gorna Arda'),(1110,1,'Gorna Bela rechka'),(1110,2,'Горна Бела речка'),(1110,3,'Gorna Bela rechka'),(1111,1,'Gorna Beshovitsa'),(1111,2,'Горна Бешовица'),(1111,3,'Gorna Beshovitsa'),(1112,1,'Gorna Birkova'),(1112,2,'Горна Биркова'),(1112,3,'Gorna Birkova'),(1113,1,'Gorna Breznitsa'),(1113,2,'Горна Брезница'),(1113,3,'Gorna Breznitsa'),(1114,1,'Gorna Brestnitsa'),(1114,2,'Горна Брестница'),(1114,3,'Gorna Brestnitsa'),(1115,1,'Gorna Vasilitsa'),(1115,2,'Горна Василица'),(1115,3,'Gorna Vasilitsa'),(1116,1,'Gorna Verenitsa'),(1116,2,'Горна Вереница'),(1116,3,'Gorna Verenitsa'),(1117,1,'Gorna Vrabcha'),(1117,2,'Горна Врабча'),(1117,3,'Gorna Vrabcha'),(1118,1,'Gorna Glogovitsa'),(1118,2,'Горна Глоговица'),(1118,3,'Gorna Glogovitsa'),(1119,1,'Gorna Grashtitsa'),(1119,2,'Горна Гращица'),(1119,3,'Gorna Grashtitsa'),(1120,1,'Gorna Dikanya'),(1120,2,'Горна Диканя'),(1120,3,'Gorna Dikanya'),(1121,1,'Gorna Dabeva'),(1121,2,'Горна Дъбева'),(1121,3,'Gorna Dabeva'),(1122,1,'Gorna Zlatitsa'),(1122,2,'Горна Златица'),(1122,3,'Gorna Zlatitsa'),(1123,1,'Gorna Kabda'),(1123,2,'Горна Кабда'),(1123,3,'Gorna Kabda'),(1124,1,'Gorna Kovachitsa'),(1124,2,'Горна Ковачица'),(1124,3,'Gorna Kovachitsa'),(1125,1,'Gorna Koznitsa'),(1125,2,'Горна Козница'),(1125,3,'Gorna Koznitsa'),(1126,1,'Gorna Kremena'),(1126,2,'Горна Кремена'),(1126,3,'Gorna Kremena'),(1127,1,'Gorna krepost'),(1127,2,'Горна крепост'),(1127,3,'Gorna krepost'),(1128,1,'Gorna Krushitsa'),(1128,2,'Горна Крушица'),(1128,3,'Gorna Krushitsa'),(1129,1,'Gorna kula'),(1129,2,'Горна кула'),(1129,3,'Gorna kula'),(1130,1,'Gorna Lipnitsa'),(1130,2,'Горна Липница'),(1130,3,'Gorna Lipnitsa'),(1131,1,'Gorna Luka'),(1131,2,'Горна Лука'),(1131,3,'Gorna Luka'),(1132,1,'Gorna Malina'),(1132,2,'Горна Малина'),(1132,3,'Gorna Malina'),(1133,1,'Gorna mahala'),(1133,2,'Горна махала'),(1133,3,'Gorna mahala'),(1134,1,'Gorna Melna'),(1134,2,'Горна Мелна'),(1134,3,'Gorna Melna'),(1135,1,'Gorna Mitropolia'),(1135,2,'Горна Митрополия'),(1135,3,'Gorna Mitropolia'),(1136,1,'Gorna Oryahovitsa'),(1136,2,'Горна Оряховица'),(1136,3,'Gorna Oryahovitsa'),(1137,1,'Gorna Ribnitsa'),(1137,2,'Горна Рибница'),(1137,3,'Gorna Ribnitsa'),(1138,1,'Gorna Rositsa'),(1138,2,'Горна Росица'),(1138,3,'Gorna Rositsa'),(1139,1,'Gorna Sekirna'),(1139,2,'Горна Секирна'),(1139,3,'Gorna Sekirna'),(1140,1,'Gorna Studena'),(1140,2,'Горна Студена'),(1140,3,'Gorna Studena'),(1141,1,'Gorna Sushitsa'),(1141,2,'Горна Сушица'),(1141,3,'Gorna Sushitsa'),(1142,1,'Gorna Hadzhiyska'),(1142,2,'Горна Хаджийска'),(1142,3,'Gorna Hadzhiyska'),(1143,1,'Gorna Hubavka'),(1143,2,'Горна Хубавка'),(1143,3,'Gorna Hubavka'),(1144,1,'Gorni Bogrov'),(1144,2,'Горни Богров'),(1144,3,'Gorni Bogrov'),(1145,1,'Gorni Vadin'),(1145,2,'Горни Вадин'),(1145,3,'Gorni Vadin'),(1146,1,'Gorni Varpishta'),(1146,2,'Горни Върпища'),(1146,3,'Gorni Varpishta'),(1147,1,'Gorni Glavanak'),(1147,2,'Горни Главанак'),(1147,3,'Gorni Glavanak'),(1148,1,'Gorni Damyanovtsi'),(1148,2,'Горни Дамяновци'),(1148,3,'Gorni Damyanovtsi'),(1149,1,'Gorni Domlyan'),(1149,2,'Горни Домлян'),(1149,3,'Gorni Domlyan'),(1150,1,'Gorni Dragoycha'),(1150,2,'Горни Драгойча'),(1150,3,'Gorni Dragoycha'),(1151,1,'Gorni Dabnik'),(1151,2,'Горни Дъбник'),(1151,3,'Gorni Dabnik'),(1152,1,'Gorni Koriten'),(1152,2,'Горни Коритен'),(1152,3,'Gorni Koriten'),(1153,1,'Gorni kray'),(1153,2,'Горни край'),(1153,3,'Gorni kray'),(1154,1,'Gorni Lom'),(1154,2,'Горни Лом'),(1154,3,'Gorni Lom'),(1155,1,'Gorni Marentsi'),(1155,2,'Горни Маренци'),(1155,3,'Gorni Marentsi'),(1156,1,'Gorni Okol'),(1156,2,'Горни Окол'),(1156,3,'Gorni Okol'),(1157,1,'Gorni Radkovtsi'),(1157,2,'Горни Радковци'),(1157,3,'Gorni Radkovtsi'),(1158,1,'Gorni Romantsi'),(1158,2,'Горни Романци'),(1158,3,'Gorni Romantsi'),(1159,1,'Gorni Tanchevtsi'),(1159,2,'Горни Танчевци'),(1159,3,'Gorni Tanchevtsi'),(1160,1,'Gorni Tsibar'),(1160,2,'Горни Цибър'),(1160,3,'Gorni Tsibar'),(1161,1,'Gorni Tsonevtsi'),(1161,2,'Горни Цоневци'),(1161,3,'Gorni Tsonevtsi'),(1162,1,'Gorni Yurutsi'),(1162,2,'Горни Юруци'),(1162,3,'Gorni Yurutsi'),(1163,1,'Gornik'),(1163,2,'Горник'),(1163,3,'Gornik'),(1164,1,'Gorno Ablanovo'),(1164,2,'Горно Абланово'),(1164,3,'Gorno Ablanovo'),(1165,1,'Gorno Aleksandrovo'),(1165,2,'Горно Александрово'),(1165,3,'Gorno Aleksandrovo'),(1166,1,'Gorno Belevo'),(1166,2,'Горно Белево'),(1166,3,'Gorno Belevo'),(1167,1,'Gorno Botevo'),(1167,2,'Горно Ботево'),(1167,3,'Gorno Botevo'),(1168,1,'Gorno Voyvodino'),(1168,2,'Горно Войводино'),(1168,3,'Gorno Voyvodino'),(1169,1,'Gorno varshilo'),(1169,2,'Горно вършило'),(1169,3,'Gorno varshilo'),(1170,1,'Gorno Draglishte'),(1170,2,'Горно Драглище'),(1170,3,'Gorno Draglishte'),(1171,1,'Gorno Dryanovo'),(1171,2,'Горно Дряново'),(1171,3,'Gorno Dryanovo'),(1172,1,'Gorno izvorovo'),(1172,2,'Горно Изворово'),(1172,3,'Gorno izvorovo'),(1173,1,'Gorno Kamartsi'),(1173,2,'Горно Камарци'),(1173,3,'Gorno Kamartsi'),(1174,1,'Gorno Kirkovo'),(1174,2,'Горно Кирково'),(1174,3,'Gorno Kirkovo'),(1175,1,'Gorno Kobile'),(1175,2,'Горно Кобиле'),(1175,3,'Gorno Kobile'),(1176,1,'Gorno Kozarevo'),(1176,2,'Горно Козарево'),(1176,3,'Gorno Kozarevo'),(1177,1,'Gorno Kraishte'),(1177,2,'Горно Краище'),(1177,3,'Gorno Kraishte'),(1178,1,'Gorno Kapinovo'),(1178,2,'Горно Къпиново'),(1178,3,'Gorno Kapinovo'),(1179,1,'Gorno Lukovo'),(1179,2,'Горно Луково'),(1179,3,'Gorno Lukovo'),(1180,1,'Gorno Novkovo'),(1180,2,'Горно Новково'),(1180,3,'Gorno Novkovo'),(1181,1,'Gorno novo selo'),(1181,2,'Горно ново село'),(1181,3,'Gorno novo selo'),(1182,1,'Gorno Ozirovo'),(1182,2,'Горно Озирово'),(1182,3,'Gorno Ozirovo'),(1183,1,'Gorno Osenovo'),(1183,2,'Горно Осеново'),(1183,3,'Gorno Osenovo'),(1184,1,'Gorno Pavlikene'),(1184,2,'Горно Павликене'),(1184,3,'Gorno Pavlikene'),(1185,1,'Gorno Peshtene'),(1185,2,'Горно Пещене'),(1185,3,'Gorno Peshtene'),(1186,1,'Gorno pole'),(1186,2,'Горно поле'),(1186,3,'Gorno pole'),(1187,1,'Gorno Prahovo'),(1187,2,'Горно Прахово'),(1187,3,'Gorno Prahovo'),(1188,1,'Gorno Sahrane'),(1188,2,'Горно Сахране'),(1188,3,'Gorno Sahrane'),(1189,1,'Gorno selo'),(1189,2,'Горно село'),(1189,3,'Gorno selo'),(1190,1,'Gorno Spanchevo'),(1190,2,'Горно Спанчево'),(1190,3,'Gorno Spanchevo'),(1191,1,'Gorno trape'),(1191,2,'Горно трапе'),(1191,3,'Gorno trape'),(1192,1,'Gorno Uyno'),(1192,2,'Горно Уйно'),(1192,3,'Gorno Uyno'),(1193,1,'Gorno Harsovo'),(1193,2,'Горно Хърсово'),(1193,3,'Gorno Harsovo'),(1194,1,'Gorno Tserovene'),(1194,2,'Горно Церовене'),(1194,3,'Gorno Tserovene'),(1195,1,'Gorno Cherkovishte'),(1195,2,'Горно Черковище'),(1195,3,'Gorno Cherkovishte'),(1196,1,'Gorno Yabalkovo'),(1196,2,'Горно Ябълково'),(1196,3,'Gorno Yabalkovo'),(1197,1,'Gornova mogila'),(1197,2,'Горнова могила'),(1197,3,'Gornova mogila'),(1198,1,'Gornoseltsi'),(1198,2,'Горноселци'),(1198,3,'Gornoseltsi'),(1199,1,'Gornoslav'),(1199,2,'Горнослав'),(1199,3,'Gornoslav'),(1200,1,'Gorovo'),(1200,2,'Горово'),(1200,3,'Gorovo'),(1201,1,'Gorovo'),(1201,2,'Горово'),(1201,3,'Gorovo'),(1202,1,'Gorotsvet'),(1202,2,'Гороцвет'),(1202,3,'Gorotsvet'),(1203,1,'Gorochevtsi'),(1203,2,'Горочевци'),(1203,3,'Gorochevtsi'),(1204,1,'Gorska'),(1204,2,'Горска'),(1204,3,'Gorska'),(1205,1,'Gorska polyana'),(1205,2,'Горска поляна'),(1205,3,'Gorska polyana'),(1206,1,'Gorski goren Trambesh'),(1206,2,'Горски горен Тръмбеш'),(1206,3,'Gorski goren Trambesh'),(1207,1,'Gorski dolen Trambesh'),(1207,2,'Горски долен Тръмбеш'),(1207,3,'Gorski dolen Trambesh'),(1208,1,'Gorski izvor'),(1208,2,'Горски извор'),(1208,3,'Gorski izvor'),(1209,1,'Gorski izvor'),(1209,2,'Горски извор'),(1209,3,'Gorski izvor'),(1210,1,'Gorski Senovets'),(1210,2,'Горски Сеновец'),(1210,3,'Gorski Senovets'),(1211,1,'Gorsko'),(1211,2,'Горско'),(1211,3,'Gorsko'),(1212,1,'Gorsko Ablanovo'),(1212,2,'Горско Абланово'),(1212,3,'Gorsko Ablanovo'),(1213,1,'Gorsko Dyulevo'),(1213,2,'Горско Дюлево'),(1213,3,'Gorsko Dyulevo'),(1214,1,'Gorsko Kalugerovo'),(1214,2,'Горско Калугерово'),(1214,3,'Gorsko Kalugerovo'),(1215,1,'Gorsko Kosovo'),(1215,2,'Горско Косово'),(1215,3,'Gorsko Kosovo'),(1216,1,'Gorsko novo selo'),(1216,2,'Горско ново село'),(1216,3,'Gorsko novo selo'),(1217,1,'Gorsko Pisarevo'),(1217,2,'Горско Писарево'),(1217,3,'Gorsko Pisarevo'),(1218,1,'Gorsko selo'),(1218,2,'Горско село'),(1218,3,'Gorsko selo'),(1219,1,'Gorsko Slivovo'),(1219,2,'Горско Сливово'),(1219,3,'Gorsko Slivovo'),(1220,1,'Gortalovo'),(1220,2,'Горталово'),(1220,3,'Gortalovo'),(1221,1,'Gorun'),(1221,2,'Горун'),(1221,3,'Gorun'),(1222,1,'Gorunaka'),(1222,2,'Горунака'),(1222,3,'Gorunaka'),(1223,1,'Gorchevo'),(1223,2,'Горчево'),(1223,3,'Gorchevo'),(1224,1,'Goryani'),(1224,2,'Горяни'),(1224,3,'Goryani'),(1225,1,'Gospodinovo'),(1225,2,'Господиново'),(1225,3,'Gospodinovo'),(1226,1,'Gospodinovo'),(1226,2,'Господиново'),(1226,3,'Gospodinovo'),(1227,1,'Gospodintsi'),(1227,2,'Господинци'),(1227,3,'Gospodintsi'),(1228,1,'Gostilitsa'),(1228,2,'Гостилица'),(1228,3,'Gostilitsa'),(1229,1,'Gostilya'),(1229,2,'Гостиля'),(1229,3,'Gostilya'),(1230,1,'Gostinya'),(1230,2,'Гостиня'),(1230,3,'Gostinya'),(1231,1,'Gostun'),(1231,2,'Гостун'),(1231,3,'Gostun'),(1232,1,'Gotse Delchev'),(1232,2,'Гоце Делчев'),(1232,3,'Gotse Delchev'),(1233,1,'Gradevo'),(1233,2,'Градево'),(1233,3,'Gradevo'),(1234,1,'Gradezhnitsa'),(1234,2,'Градежница'),(1234,3,'Gradezhnitsa'),(1235,1,'Gradets'),(1235,2,'Градец'),(1235,3,'Gradets'),(1236,1,'Gradets'),(1236,2,'Градец'),(1236,3,'Gradets'),(1237,1,'Gradets'),(1237,2,'Градец'),(1237,3,'Gradets'),(1238,1,'Gradeshnitsa'),(1238,2,'Градешница'),(1238,3,'Gradeshnitsa'),(1239,1,'Gradina'),(1239,2,'Градина'),(1239,3,'Gradina'),(1240,1,'Gradina'),(1240,2,'Градина'),(1240,3,'Gradina'),(1241,1,'Gradina'),(1241,2,'Градина'),(1241,3,'Gradina'),(1242,1,'Gradinarovo'),(1242,2,'Градинарово'),(1242,3,'Gradinarovo'),(1243,1,'Gradini'),(1243,2,'Градини'),(1243,3,'Gradini'),(1244,1,'Gradinka'),(1244,2,'Градинка'),(1244,3,'Gradinka'),(1245,1,'Gradishte'),(1245,2,'Градище'),(1245,3,'Gradishte'),(1246,1,'Gradishte'),(1246,2,'Градище'),(1246,3,'Gradishte'),(1247,1,'Gradishte'),(1247,2,'Градище'),(1247,3,'Gradishte'),(1248,1,'Gradnitsa'),(1248,2,'Градница'),(1248,3,'Gradnitsa'),(1249,1,'Gradnitsa'),(1249,2,'Градница'),(1249,3,'Gradnitsa'),(1250,1,'Gradsko'),(1250,2,'Градско'),(1250,3,'Gradsko'),(1251,1,'Gradskovski kolibi'),(1251,2,'Градсковски колиби'),(1251,3,'Gradskovski kolibi'),(1252,1,'Gradat'),(1252,2,'Градът'),(1252,3,'Gradat'),(1253,1,'Gramada'),(1253,2,'Грамада'),(1253,3,'Gramada'),(1254,1,'Gramade'),(1254,2,'Грамаде'),(1254,3,'Gramade'),(1255,1,'Gramade'),(1255,2,'Грамаде'),(1255,3,'Gramade'),(1256,1,'Gramazhdano'),(1256,2,'Грамаждано'),(1256,3,'Gramazhdano'),(1257,1,'Gramatikovo'),(1257,2,'Граматиково'),(1257,3,'Gramatikovo'),(1258,1,'Gramatitsi'),(1258,2,'Граматици'),(1258,3,'Gramatitsi'),(1259,1,'Granit'),(1259,2,'Гранит'),(1259,3,'Granit'),(1260,1,'Granitets'),(1260,2,'Гранитец'),(1260,3,'Granitets'),(1261,1,'Granitovo'),(1261,2,'Гранитово'),(1261,3,'Granitovo'),(1262,1,'Granitovo'),(1262,2,'Гранитово'),(1262,3,'Granitovo'),(1263,1,'Granitsa'),(1263,2,'Граница'),(1263,3,'Granitsa'),(1264,1,'Granichak'),(1264,2,'Граничак'),(1264,3,'Granichak'),(1265,1,'Granichar'),(1265,2,'Граничар'),(1265,3,'Granichar'),(1266,1,'Granichar'),(1266,2,'Граничар'),(1266,3,'Granichar'),(1267,1,'Graf ignatievo'),(1267,2,'Граф Игнатиево'),(1267,3,'Graf ignatievo'),(1268,1,'Grafitovo'),(1268,2,'Графитово'),(1268,3,'Grafitovo'),(1269,1,'Grashevo'),(1269,2,'Грашево'),(1269,3,'Grashevo'),(1270,1,'Grashtitsa'),(1270,2,'Гращица'),(1270,3,'Grashtitsa'),(1271,1,'Greevtsi'),(1271,2,'Греевци'),(1271,3,'Greevtsi'),(1272,1,'Grivitsa'),(1272,2,'Гривица'),(1272,3,'Grivitsa'),(1273,1,'Grivka'),(1273,2,'Гривка'),(1273,3,'Grivka'),(1274,1,'Grivyak'),(1274,2,'Гривяк'),(1274,3,'Grivyak'),(1275,1,'Grigorevo'),(1275,2,'Григорево'),(1275,3,'Grigorevo'),(1276,1,'Grozden'),(1276,2,'Грозден'),(1276,3,'Grozden'),(1277,1,'Grozdyovo'),(1277,2,'Гроздьово'),(1277,3,'Grozdyovo'),(1278,1,'Gromshin'),(1278,2,'Громшин'),(1278,3,'Gromshin'),(1279,1,'Grohotno'),(1279,2,'Грохотно'),(1279,3,'Grohotno'),(1280,1,'Gruevo'),(1280,2,'Груево'),(1280,3,'Gruevo'),(1281,1,'Grablevtsi'),(1281,2,'Гръблевци'),(1281,3,'Grablevtsi'),(1282,1,'Gralska padina'),(1282,2,'Грълска падина'),(1282,3,'Gralska padina'),(1283,1,'Grancharovo'),(1283,2,'Грънчарово'),(1283,3,'Grancharovo'),(1284,1,'Gubesh'),(1284,2,'Губеш'),(1284,3,'Gubesh'),(1285,1,'Gubislav'),(1285,2,'Губислав'),(1285,3,'Gubislav'),(1286,1,'Gugutka'),(1286,2,'Гугутка'),(1286,3,'Gugutka'),(1287,1,'Gudevitsa'),(1287,2,'Гудевица'),(1287,3,'Gudevitsa'),(1288,1,'Guliyka'),(1288,2,'Гулийка'),(1288,3,'Guliyka'),(1289,1,'Gulia'),(1289,2,'Гулия'),(1289,3,'Gulia'),(1290,1,'Gulyantsi'),(1290,2,'Гулянци'),(1290,3,'Gulyantsi'),(1291,1,'Gumoshtnik'),(1291,2,'Гумощник'),(1291,3,'Gumoshtnik'),(1292,1,'Gurbanovtsi'),(1292,2,'Гурбановци'),(1292,3,'Gurbanovtsi'),(1293,1,'Gurgulitsa'),(1293,2,'Гургулица'),(1293,3,'Gurgulitsa'),(1294,1,'Gurgulyat'),(1294,2,'Гургулят'),(1294,3,'Gurgulyat'),(1295,1,'Gurkovo'),(1295,2,'Гурково'),(1295,3,'Gurkovo'),(1296,1,'Gurkovo'),(1296,2,'Гурково'),(1296,3,'Gurkovo'),(1297,1,'Gurkovo'),(1297,2,'Гурково'),(1297,3,'Gurkovo'),(1298,1,'Gurmazovo'),(1298,2,'Гурмазово'),(1298,3,'Gurmazovo'),(1299,1,'Gusla'),(1299,2,'Гусла'),(1299,3,'Gusla'),(1300,1,'Guslar'),(1300,2,'Гуслар'),(1300,3,'Guslar'),(1301,1,'Gutsal'),(1301,2,'Гуцал'),(1301,3,'Gutsal'),(1302,1,'Gabene'),(1302,2,'Гъбене'),(1302,3,'Gabene'),(1303,1,'Galabets'),(1303,2,'Гълъбец'),(1303,3,'Galabets'),(1304,1,'Galabets'),(1304,2,'Гълъбец'),(1304,3,'Galabets'),(1305,1,'Galabintsi'),(1305,2,'Гълъбинци'),(1305,3,'Galabintsi'),(1306,1,'Galabnik'),(1306,2,'Гълъбник'),(1306,3,'Galabnik'),(1307,1,'Galabovo'),(1307,2,'Гълъбово'),(1307,3,'Galabovo'),(1308,1,'Galabovo'),(1308,2,'Гълъбово'),(1308,3,'Galabovo'),(1309,1,'Galabovo'),(1309,2,'Гълъбово'),(1309,3,'Galabovo'),(1310,1,'Galabovo'),(1310,2,'Гълъбово'),(1310,3,'Galabovo'),(1311,1,'Galabovtsi'),(1311,2,'Гълъбовци'),(1311,3,'Galabovtsi'),(1312,1,'Gamzovo'),(1312,2,'Гъмзово'),(1312,3,'Gamzovo'),(1313,1,'Garbino'),(1313,2,'Гърбино'),(1313,3,'Garbino'),(1314,1,'Garbishte'),(1314,2,'Гърбище'),(1314,3,'Garbishte'),(1315,1,'Gardevtsi'),(1315,2,'Гърдевци'),(1315,3,'Gardevtsi'),(1316,1,'Garlo'),(1316,2,'Гърло'),(1316,3,'Garlo'),(1317,1,'Garlyano'),(1317,2,'Гърляно'),(1317,3,'Garlyano'),(1318,1,'Garmen'),(1318,2,'Гърмен'),(1318,3,'Garmen'),(1319,1,'Garnati'),(1319,2,'Гърнати'),(1319,3,'Garnati'),(1320,1,'Garnya'),(1320,2,'Гърня'),(1320,3,'Garnya'),(1321,1,'Garchinovo'),(1321,2,'Гърчиново'),(1321,3,'Garchinovo'),(1322,1,'Gaskovo'),(1322,2,'Гъсково'),(1322,3,'Gaskovo'),(1323,1,'Gyovren'),(1323,2,'Гьоврен'),(1323,3,'Gyovren'),(1324,1,'Gyueshevo'),(1324,2,'Гюешево'),(1324,3,'Gyueshevo'),(1325,1,'Gyulyovtsa'),(1325,2,'Гюльовца'),(1325,3,'Gyulyovtsa'),(1326,1,'Gyurgevo'),(1326,2,'Гюргево'),(1326,3,'Gyurgevo'),(1327,1,'Gyurgich'),(1327,2,'Гюргич'),(1327,3,'Gyurgich'),(1328,1,'Daveri'),(1328,2,'Давери'),(1328,3,'Daveri'),(1329,1,'Davidkovo'),(1329,2,'Давидково'),(1329,3,'Davidkovo'),(1330,1,'Davidovo'),(1330,2,'Давидово'),(1330,3,'Davidovo'),(1331,1,'Davidovo'),(1331,2,'Давидово'),(1331,3,'Davidovo'),(1332,1,'Dagonovo'),(1332,2,'Дагоново'),(1332,3,'Dagonovo'),(1333,1,'Daevtsi'),(1333,2,'Даевци'),(1333,3,'Daevtsi'),(1334,1,'Daynovtsi'),(1334,2,'Дайновци'),(1334,3,'Daynovtsi'),(1335,1,'Damyanitsa'),(1335,2,'Дамяница'),(1335,3,'Damyanitsa'),(1336,1,'Damyanovo'),(1336,2,'Дамяново'),(1336,3,'Damyanovo'),(1337,1,'Daskal-Atanasovo'),(1337,2,'Даскал-Атанасово'),(1337,3,'Daskal-Atanasovo'),(1338,1,'Daskalovo'),(1338,2,'Даскалово'),(1338,3,'Daskalovo'),(1339,1,'Dve mogili'),(1339,2,'Две могили'),(1339,3,'Dve mogili'),(1340,1,'Dve topoli'),(1340,2,'Две тополи'),(1340,3,'Dve topoli'),(1341,1,'Dvorishte'),(1341,2,'Дворище'),(1341,3,'Dvorishte'),(1342,1,'Dvorishte'),(1342,2,'Дворище'),(1342,3,'Dvorishte'),(1343,1,'Debel dyal'),(1343,2,'Дебел дял'),(1343,3,'Debel dyal'),(1344,1,'Debelets'),(1344,2,'Дебелец'),(1344,3,'Debelets'),(1345,1,'Debelets'),(1345,2,'Дебелец'),(1345,3,'Debelets'),(1346,1,'Debeli lag'),(1346,2,'Дебели лаг'),(1346,3,'Debeli lag'),(1347,1,'Debeli rat'),(1347,2,'Дебели рът'),(1347,3,'Debeli rat'),(1348,1,'Debelt'),(1348,2,'Дебелт'),(1348,3,'Debelt'),(1349,1,'Debeltsovo'),(1349,2,'Дебелцово'),(1349,3,'Debeltsovo'),(1350,1,'Debelyanovo'),(1350,2,'Дебеляново'),(1350,3,'Debelyanovo'),(1351,1,'Debnevo'),(1351,2,'Дебнево'),(1351,3,'Debnevo'),(1352,1,'Debovo'),(1352,2,'Дебово'),(1352,3,'Debovo'),(1353,1,'Debochitsa'),(1353,2,'Дебочица'),(1353,3,'Debochitsa'),(1354,1,'Debren'),(1354,2,'Дебрен'),(1354,3,'Debren'),(1355,1,'Debrene'),(1355,2,'Дебрене'),(1355,3,'Debrene'),(1356,1,'Debrene'),(1356,2,'Дебрене'),(1356,3,'Debrene'),(1357,1,'Debrashtitsa'),(1357,2,'Дебръщица'),(1357,3,'Debrashtitsa'),(1358,1,'Devene'),(1358,2,'Девене'),(1358,3,'Devene'),(1359,1,'Deventsi'),(1359,2,'Девенци'),(1359,3,'Deventsi'),(1360,1,'Devesilitsa'),(1360,2,'Девесилица'),(1360,3,'Devesilitsa'),(1361,1,'Devesilovo'),(1361,2,'Девесилово'),(1361,3,'Devesilovo'),(1362,1,'Devetak'),(1362,2,'Деветак'),(1362,3,'Devetak'),(1363,1,'Devetaki'),(1363,2,'Деветаки'),(1363,3,'Devetaki'),(1364,1,'Devetatsite'),(1364,2,'Деветаците'),(1364,3,'Devetatsite'),(1365,1,'Devetintsi'),(1365,2,'Деветинци'),(1365,3,'Devetintsi'),(1366,1,'Devin'),(1366,2,'Девин'),(1366,3,'Devin'),(1367,1,'Devino'),(1367,2,'Девино'),(1367,3,'Devino'),(1368,1,'Devintsi'),(1368,2,'Девинци'),(1368,3,'Devintsi'),(1369,1,'Devnya'),(1369,2,'Девня'),(1369,3,'Devnya'),(1370,1,'Dedets'),(1370,2,'Дедец'),(1370,3,'Dedets'),(1371,1,'Dedina'),(1371,2,'Дедина'),(1371,3,'Dedina'),(1372,1,'Dedino'),(1372,2,'Дедино'),(1372,3,'Dedino'),(1373,1,'Dedintsi'),(1373,2,'Дединци'),(1373,3,'Dedintsi'),(1374,1,'Dedovo'),(1374,2,'Дедово'),(1374,3,'Dedovo'),(1375,1,'Dekov'),(1375,2,'Деков'),(1375,3,'Dekov'),(1376,1,'Delvino'),(1376,2,'Делвино'),(1376,3,'Delvino'),(1377,1,'Delvino'),(1377,2,'Делвино'),(1377,3,'Delvino'),(1378,1,'Deleyna'),(1378,2,'Делейна'),(1378,3,'Deleyna'),(1379,1,'Delova mahala'),(1379,2,'Делова махала'),(1379,3,'Delova mahala'),(1380,1,'Delchevo'),(1380,2,'Делчево'),(1380,3,'Delchevo'),(1381,1,'Delchevo'),(1381,2,'Делчево'),(1381,3,'Delchevo'),(1382,1,'Delyan'),(1382,2,'Делян'),(1382,3,'Delyan'),(1383,1,'Delyan'),(1383,2,'Делян'),(1383,3,'Delyan'),(1384,1,'Delyanovtsi'),(1384,2,'Деляновци'),(1384,3,'Delyanovtsi'),(1385,1,'Dennitsa'),(1385,2,'Денница'),(1385,3,'Dennitsa'),(1386,1,'Dennitsa'),(1386,2,'Денница'),(1386,3,'Dennitsa'),(1387,1,'Denchevtsi'),(1387,2,'Денчевци'),(1387,3,'Denchevtsi'),(1388,1,'Dervishka mogila'),(1388,2,'Дервишка могила'),(1388,3,'Dervishka mogila'),(1389,1,'Dermantsi'),(1389,2,'Дерманци'),(1389,3,'Dermantsi'),(1390,1,'Detelina'),(1390,2,'Детелина'),(1390,3,'Detelina'),(1391,1,'Detelina'),(1391,2,'Детелина'),(1391,3,'Detelina'),(1392,1,'Dechkovtsi'),(1392,2,'Дечковци'),(1392,3,'Dechkovtsi'),(1393,1,'Dzhamuzovtsi'),(1393,2,'Джамузовци'),(1393,3,'Dzhamuzovtsi'),(1394,1,'Dzhanka'),(1394,2,'Джанка'),(1394,3,'Dzhanka'),(1395,1,'Dzhebel'),(1395,2,'Джебел'),(1395,3,'Dzhebel'),(1396,1,'Dzhelepsko'),(1396,2,'Джелепско'),(1396,3,'Dzhelepsko'),(1397,1,'Dzherman'),(1397,2,'Джерман'),(1397,3,'Dzherman'),(1398,1,'Dzherovo'),(1398,2,'Джерово'),(1398,3,'Dzherovo'),(1399,1,'Dzhigurovo'),(1399,2,'Джигурово'),(1399,3,'Dzhigurovo'),(1400,1,'Dzhinot'),(1400,2,'Джинот'),(1400,3,'Dzhinot'),(1401,1,'Dzhinchovtsi'),(1401,2,'Джинчовци'),(1401,3,'Dzhinchovtsi'),(1402,1,'Dzhulyunitsa'),(1402,2,'Джулюница'),(1402,3,'Dzhulyunitsa'),(1403,1,'Dzhulyunitsa'),(1403,2,'Джулюница'),(1403,3,'Dzhulyunitsa'),(1404,1,'Dzhumriite'),(1404,2,'Джумриите'),(1404,3,'Dzhumriite'),(1405,1,'Dzhurkovo'),(1405,2,'Джурково'),(1405,3,'Dzhurkovo'),(1406,1,'Dzhurovo'),(1406,2,'Джурово'),(1406,3,'Dzhurovo'),(1407,1,'Dzhurovtsi'),(1407,2,'Джуровци'),(1407,3,'Dzhurovtsi'),(1408,1,'Dibich'),(1408,2,'Дибич'),(1408,3,'Dibich'),(1409,1,'Diva Slatina'),(1409,2,'Дива Слатина'),(1409,3,'Diva Slatina'),(1410,1,'Divetsi'),(1410,2,'Дивеци'),(1410,3,'Divetsi'),(1411,1,'Divlya'),(1411,2,'Дивля'),(1411,3,'Divlya'),(1412,1,'Divotino'),(1412,2,'Дивотино'),(1412,3,'Divotino'),(1413,1,'Divchovoto'),(1413,2,'Дивчовото'),(1413,3,'Divchovoto'),(1414,1,'Dimanovo'),(1414,2,'Диманово'),(1414,3,'Dimanovo'),(1415,1,'Dimievtsi'),(1415,2,'Димиевци'),(1415,3,'Dimievtsi'),(1416,1,'Dimitrievo'),(1416,2,'Димитриево'),(1416,3,'Dimitrievo'),(1417,1,'Dimitrovgrad'),(1417,2,'Димитровград'),(1417,3,'Dimitrovgrad'),(1418,1,'Dimitrovtsi'),(1418,2,'Димитровци'),(1418,3,'Dimitrovtsi'),(1419,1,'Dimitrovche'),(1419,2,'Димитровче'),(1419,3,'Dimitrovche'),(1420,1,'Dimovo'),(1420,2,'Димово'),(1420,3,'Dimovo'),(1421,1,'Dimovo'),(1421,2,'Димово'),(1421,3,'Dimovo'),(1422,1,'Dimovtsi'),(1422,2,'Димовци'),(1422,3,'Dimovtsi'),(1423,1,'Dimovtsi'),(1423,2,'Димовци'),(1423,3,'Dimovtsi'),(1424,1,'Dimcha'),(1424,2,'Димча'),(1424,3,'Dimcha'),(1425,1,'Dimchevo'),(1425,2,'Димчево'),(1425,3,'Dimchevo'),(1426,1,'Dinevo'),(1426,2,'Динево'),(1426,3,'Dinevo'),(1427,1,'Dink'),(1427,2,'Динк'),(1427,3,'Dink'),(1428,1,'Dinkata'),(1428,2,'Динката'),(1428,3,'Dinkata'),(1429,1,'Dinkovitsa'),(1429,2,'Динковица'),(1429,3,'Dinkovitsa'),(1430,1,'Dinkovo'),(1430,2,'Динково'),(1430,3,'Dinkovo'),(1431,1,'Dinya'),(1431,2,'Диня'),(1431,3,'Dinya'),(1432,1,'Diralo'),(1432,2,'Дирало'),(1432,3,'Diralo'),(1433,1,'Disevitsa'),(1433,2,'Дисевица'),(1433,3,'Disevitsa'),(1434,1,'Dismanitsa'),(1434,2,'Дисманица'),(1434,3,'Dismanitsa'),(1435,1,'Dichevo'),(1435,2,'Дичево'),(1435,3,'Dichevo'),(1436,1,'Dichin'),(1436,2,'Дичин'),(1436,3,'Dichin'),(1437,1,'Dlagnevo'),(1437,2,'Длъгнево'),(1437,3,'Dlagnevo'),(1438,1,'Dlagnya'),(1438,2,'Длъгня'),(1438,3,'Dlagnya'),(1439,1,'Dlazhka polyana'),(1439,2,'Длъжка поляна'),(1439,3,'Dlazhka polyana'),(1440,1,'Dlazhko'),(1440,2,'Длъжко'),(1440,3,'Dlazhko'),(1441,1,'Dlahchevo-Sablyar'),(1441,2,'Длъхчево-Сабляр'),(1441,3,'Dlahchevo-Sablyar'),(1442,1,'Doborsko'),(1442,2,'Доборско'),(1442,3,'Doborsko'),(1443,1,'Dobra polyana'),(1443,2,'Добра поляна'),(1443,3,'Dobra polyana'),(1444,1,'Dobravitsa'),(1444,2,'Добравица'),(1444,3,'Dobravitsa'),(1445,1,'Dobralak'),(1445,2,'Добралък'),(1445,3,'Dobralak'),(1446,1,'Dobreva cheresha'),(1446,2,'Добрева череша'),(1446,3,'Dobreva cheresha'),(1447,1,'Dobrevo'),(1447,2,'Добрево'),(1447,3,'Dobrevo'),(1448,1,'Dobrevtsi'),(1448,2,'Добревци'),(1448,3,'Dobrevtsi'),(1449,1,'Dobrevtsi'),(1449,2,'Добревци'),(1449,3,'Dobrevtsi'),(1450,1,'Dobrevtsi'),(1450,2,'Добревци'),(1450,3,'Dobrevtsi'),(1451,1,'Dobrenite'),(1451,2,'Добрените'),(1451,3,'Dobrenite'),(1452,1,'Dobri Voynikovo'),(1452,2,'Добри Войниково'),(1452,3,'Dobri Voynikovo'),(1453,1,'Dobri dol'),(1453,2,'Добри дол'),(1453,3,'Dobri dol'),(1454,1,'Dobri dol'),(1454,2,'Добри дол'),(1454,3,'Dobri dol'),(1455,1,'Dobri dol'),(1455,2,'Добри дол'),(1455,3,'Dobri dol'),(1456,1,'Dobri dol'),(1456,2,'Добри дол'),(1456,3,'Dobri dol'),(1457,1,'Dobri dyal'),(1457,2,'Добри дял'),(1457,3,'Dobri dyal'),(1458,1,'Dobri laki'),(1458,2,'Добри лаки'),(1458,3,'Dobri laki'),(1459,1,'Dobrin'),(1459,2,'Добрин'),(1459,3,'Dobrin'),(1460,1,'Dobrina'),(1460,2,'Добрина'),(1460,3,'Dobrina'),(1461,1,'Dobrinishte'),(1461,2,'Добринище'),(1461,3,'Dobrinishte'),(1462,1,'Dobrinovo'),(1462,2,'Добриново'),(1462,3,'Dobrinovo'),(1463,1,'Dobrinovo'),(1463,2,'Добриново'),(1463,3,'Dobrinovo'),(1464,1,'Dobrintsi'),(1464,2,'Добринци'),(1464,3,'Dobrintsi'),(1465,1,'Dobrich'),(1465,2,'Добрич'),(1465,3,'Dobrich'),(1466,1,'Dobrich'),(1466,2,'Добрич'),(1466,3,'Dobrich'),(1467,1,'Dobrich'),(1467,2,'Добрич'),(1467,3,'Dobrich'),(1468,1,'Dobrovnitsa'),(1468,2,'Добровница'),(1468,3,'Dobrovnitsa'),(1469,1,'Dobrovo'),(1469,2,'Доброво'),(1469,3,'Dobrovo'),(1470,1,'Dobrogled'),(1470,2,'Доброглед'),(1470,3,'Dobrogled'),(1471,1,'Dobrodan'),(1471,2,'Добродан'),(1471,3,'Dobrodan'),(1472,1,'Dobrolevo'),(1472,2,'Добролево'),(1472,3,'Dobrolevo'),(1473,1,'Dobromir'),(1473,2,'Добромир'),(1473,3,'Dobromir'),(1474,1,'Dobromirka'),(1474,2,'Добромирка'),(1474,3,'Dobromirka'),(1475,1,'Dobromirtsi'),(1475,2,'Добромирци'),(1475,3,'Dobromirtsi'),(1476,1,'Dobroplodno'),(1476,2,'Доброплодно'),(1476,3,'Dobroplodno'),(1477,1,'Dobroselets'),(1477,2,'Доброселец'),(1477,3,'Dobroselets'),(1478,1,'Dobroslavtsi'),(1478,2,'Доброславци'),(1478,3,'Dobroslavtsi'),(1479,1,'Dobrostan'),(1479,2,'Добростан'),(1479,3,'Dobrostan'),(1480,1,'Dobrotino'),(1480,2,'Добротино'),(1480,3,'Dobrotino'),(1481,1,'Dobrotitsa'),(1481,2,'Добротица'),(1481,3,'Dobrotitsa'),(1482,1,'Dobrotitsa'),(1482,2,'Добротица'),(1482,3,'Dobrotitsa'),(1483,1,'Dobrotich'),(1483,2,'Добротич'),(1483,3,'Dobrotich'),(1484,1,'Dobrudzhanka'),(1484,2,'Добруджанка'),(1484,3,'Dobrudzhanka'),(1485,1,'Dobrusha'),(1485,2,'Добруша'),(1485,3,'Dobrusha'),(1486,1,'Dobarsko'),(1486,2,'Добърско'),(1486,3,'Dobarsko'),(1487,1,'Dobarchin'),(1487,2,'Добърчин'),(1487,3,'Dobarchin'),(1488,1,'Doganovo'),(1488,2,'Доганово'),(1488,3,'Doganovo'),(1489,1,'Dozhdevitsa'),(1489,2,'Дождевица'),(1489,3,'Dozhdevitsa'),(1490,1,'Doynovtsi'),(1490,2,'Дойновци'),(1490,3,'Doynovtsi'),(1491,1,'Doyrantsi'),(1491,2,'Дойранци'),(1491,3,'Doyrantsi'),(1492,1,'Doyrantsi'),(1492,2,'Дойранци'),(1492,3,'Doyrantsi'),(1493,1,'Doyrentsi'),(1493,2,'Дойренци'),(1493,3,'Doyrentsi'),(1494,1,'Dokatichevo'),(1494,2,'Докатичево'),(1494,3,'Dokatichevo'),(1495,1,'Doktor Yosifovo'),(1495,2,'Доктор Йосифово'),(1495,3,'Doktor Yosifovo'),(1496,1,'Dokyovtsi'),(1496,2,'Докьовци'),(1496,3,'Dokyovtsi'),(1497,1,'Dolen'),(1497,2,'Долен'),(1497,3,'Dolen'),(1498,1,'Dolen'),(1498,2,'Долен'),(1498,3,'Dolen'),(1499,1,'Dolen Enevets'),(1499,2,'Долен Еневец'),(1499,3,'Dolen Enevets'),(1500,1,'Dolene'),(1500,2,'Долене'),(1500,3,'Dolene'),(1501,1,'Doleni'),(1501,2,'Долени'),(1501,3,'Doleni'),(1502,1,'Dolets'),(1502,2,'Долец'),(1502,3,'Dolets'),(1503,1,'Dolets'),(1503,2,'Долец'),(1503,3,'Dolets'),(1504,1,'Dolie'),(1504,2,'Долие'),(1504,3,'Dolie'),(1505,1,'Dolina'),(1505,2,'Долина'),(1505,3,'Dolina'),(1506,1,'Dolina'),(1506,2,'Долина'),(1506,3,'Dolina'),(1507,1,'Dolistovo'),(1507,2,'Долистово'),(1507,3,'Dolistovo'),(1508,1,'Dolishte'),(1508,2,'Долище'),(1508,3,'Dolishte'),(1509,1,'Dolishte'),(1509,2,'Долище'),(1509,3,'Dolishte'),(1510,1,'Dolna banya'),(1510,2,'Долна баня'),(1510,3,'Dolna banya'),(1511,1,'Dolna Bela rechka'),(1511,2,'Долна Бела речка'),(1511,3,'Dolna Bela rechka'),(1512,1,'Dolna Beshovitsa'),(1512,2,'Долна Бешовица'),(1512,3,'Dolna Beshovitsa'),(1513,1,'Dolna Vasilitsa'),(1513,2,'Долна Василица'),(1513,3,'Dolna Vasilitsa'),(1514,1,'Dolna Verenitsa'),(1514,2,'Долна Вереница'),(1514,3,'Dolna Verenitsa'),(1515,1,'Dolna Vrabcha'),(1515,2,'Долна Врабча'),(1515,3,'Dolna Vrabcha'),(1516,1,'Dolna Gradeshnitsa'),(1516,2,'Долна Градешница'),(1516,3,'Dolna Gradeshnitsa'),(1517,1,'Dolna Grashtitsa'),(1517,2,'Долна Гращица'),(1517,3,'Dolna Grashtitsa'),(1518,1,'Dolna Dikanya'),(1518,2,'Долна Диканя'),(1518,3,'Dolna Dikanya'),(1519,1,'Dolna Dabeva'),(1519,2,'Долна Дъбева'),(1519,3,'Dolna Dabeva'),(1520,1,'Dolna Zlatitsa'),(1520,2,'Долна Златица'),(1520,3,'Dolna Zlatitsa'),(1521,1,'Dolna Kabda'),(1521,2,'Долна Кабда'),(1521,3,'Dolna Kabda'),(1522,1,'Dolna Koznitsa'),(1522,2,'Долна Козница'),(1522,3,'Dolna Koznitsa'),(1523,1,'Dolna Kremena'),(1523,2,'Долна Кремена'),(1523,3,'Dolna Kremena'),(1524,1,'Dolna krepost'),(1524,2,'Долна крепост'),(1524,3,'Dolna krepost'),(1525,1,'Dolna Krushitsa'),(1525,2,'Долна Крушица'),(1525,3,'Dolna Krushitsa'),(1526,1,'Dolna kula'),(1526,2,'Долна кула'),(1526,3,'Dolna kula'),(1527,1,'Dolna Lipnitsa'),(1527,2,'Долна Липница'),(1527,3,'Dolna Lipnitsa'),(1528,1,'Dolna Malina'),(1528,2,'Долна Малина'),(1528,3,'Dolna Malina'),(1529,1,'Dolna Margatina'),(1529,2,'Долна Маргатина'),(1529,3,'Dolna Margatina'),(1530,1,'Dolna mahala'),(1530,2,'Долна махала'),(1530,3,'Dolna mahala'),(1531,1,'Dolna Melna'),(1531,2,'Долна Мелна'),(1531,3,'Dolna Melna'),(1532,1,'Dolna Mitropolia'),(1532,2,'Долна Митрополия'),(1532,3,'Dolna Mitropolia'),(1533,1,'Dolna Nevlya'),(1533,2,'Долна Невля'),(1533,3,'Dolna Nevlya'),(1534,1,'Dolna Oryahovitsa'),(1534,2,'Долна Оряховица'),(1534,3,'Dolna Oryahovitsa'),(1535,1,'Dolna Ribnitsa'),(1535,2,'Долна Рибница'),(1535,3,'Dolna Ribnitsa'),(1536,1,'Dolna Riksa'),(1536,2,'Долна Рикса'),(1536,3,'Dolna Riksa'),(1537,1,'Dolna Sekirna'),(1537,2,'Долна Секирна'),(1537,3,'Dolna Sekirna'),(1538,1,'Dolna Studena'),(1538,2,'Долна Студена'),(1538,3,'Dolna Studena'),(1539,1,'Dolna Hubavka'),(1539,2,'Долна Хубавка'),(1539,3,'Dolna Hubavka'),(1540,1,'Dolni Bogrov'),(1540,2,'Долни Богров'),(1540,3,'Dolni Bogrov'),(1541,1,'Dolni Boshnyak'),(1541,2,'Долни Бошняк'),(1541,3,'Dolni Boshnyak'),(1542,1,'Dolni Vadin'),(1542,2,'Долни Вадин'),(1542,3,'Dolni Vadin'),(1543,1,'Dolni Vit'),(1543,2,'Долни Вит'),(1543,3,'Dolni Vit'),(1544,1,'Dolni Varpishta'),(1544,2,'Долни Върпища'),(1544,3,'Dolni Varpishta'),(1545,1,'Dolni Glavanak'),(1545,2,'Долни Главанак'),(1545,3,'Dolni Glavanak'),(1546,1,'Dolni Damyanovtsi'),(1546,2,'Долни Дамяновци'),(1546,3,'Dolni Damyanovtsi'),(1547,1,'Dolni Dragoycha'),(1547,2,'Долни Драгойча'),(1547,3,'Dolni Dragoycha'),(1548,1,'Dolni Dabnik'),(1548,2,'Долни Дъбник'),(1548,3,'Dolni Dabnik'),(1549,1,'Dolni Koriten'),(1549,2,'Долни Коритен'),(1549,3,'Dolni Koriten'),(1550,1,'Dolni Lom'),(1550,2,'Долни Лом'),(1550,3,'Dolni Lom'),(1551,1,'Dolni Lukovit'),(1551,2,'Долни Луковит'),(1551,3,'Dolni Lukovit'),(1552,1,'Dolni Marentsi'),(1552,2,'Долни Маренци'),(1552,3,'Dolni Marentsi'),(1553,1,'Dolni Maryan'),(1553,2,'Долни Марян'),(1553,3,'Dolni Maryan'),(1554,1,'Dolni Okol'),(1554,2,'Долни Окол'),(1554,3,'Dolni Okol'),(1555,1,'Dolni Pasarel'),(1555,2,'Долни Пасарел'),(1555,3,'Dolni Pasarel'),(1556,1,'Dolni Radkovtsi'),(1556,2,'Долни Радковци'),(1556,3,'Dolni Radkovtsi'),(1557,1,'Dolni Rakovets'),(1557,2,'Долни Раковец'),(1557,3,'Dolni Rakovets'),(1558,1,'Dolni Romantsi'),(1558,2,'Долни Романци'),(1558,3,'Dolni Romantsi'),(1559,1,'Dolni Tanchevtsi'),(1559,2,'Долни Танчевци'),(1559,3,'Dolni Tanchevtsi'),(1560,1,'Dolni Tomchevtsi'),(1560,2,'Долни Томчевци'),(1560,3,'Dolni Tomchevtsi'),(1561,1,'Dolni Tsibar'),(1561,2,'Долни Цибър'),(1561,3,'Dolni Tsibar'),(1562,1,'Dolni chiflik'),(1562,2,'Долни чифлик'),(1562,3,'Dolni chiflik'),(1563,1,'Dolni Yurutsi'),(1563,2,'Долни Юруци'),(1563,3,'Dolni Yurutsi'),(1564,1,'Dolno Ablanovo'),(1564,2,'Долно Абланово'),(1564,3,'Dolno Ablanovo'),(1565,1,'Dolno Belevo'),(1565,2,'Долно Белево'),(1565,3,'Dolno Belevo'),(1566,1,'Dolno Belotintsi'),(1566,2,'Долно Белотинци'),(1566,3,'Dolno Belotintsi'),(1567,1,'Dolno Botevo'),(1567,2,'Долно Ботево'),(1567,3,'Dolno Botevo'),(1568,1,'Dolno Voyvodino'),(1568,2,'Долно Войводино'),(1568,3,'Dolno Voyvodino'),(1569,1,'Dolno varshilo'),(1569,2,'Долно вършило'),(1569,3,'Dolno varshilo'),(1570,1,'Dolno Golemantsi'),(1570,2,'Долно Големанци'),(1570,3,'Dolno Golemantsi'),(1571,1,'Dolno Draglishte'),(1571,2,'Долно Драглище'),(1571,3,'Dolno Draglishte'),(1572,1,'Dolno Dryanovo'),(1572,2,'Долно Дряново'),(1572,3,'Dolno Dryanovo'),(1573,1,'Dolno izvorovo'),(1573,2,'Долно изворово'),(1573,3,'Dolno izvorovo'),(1574,1,'Dolno Kamartsi'),(1574,2,'Долно Камарци'),(1574,3,'Dolno Kamartsi'),(1575,1,'Dolno Kobile'),(1575,2,'Долно Кобиле'),(1575,3,'Dolno Kobile'),(1576,1,'Dolno Kozarevo'),(1576,2,'Долно Козарево'),(1576,3,'Dolno Kozarevo'),(1577,1,'Dolno Kapinovo'),(1577,2,'Долно Къпиново'),(1577,3,'Dolno Kapinovo'),(1578,1,'Dolno Linevo'),(1578,2,'Долно Линево'),(1578,3,'Dolno Linevo'),(1579,1,'Dolno Lukovo'),(1579,2,'Долно Луково'),(1579,3,'Dolno Lukovo'),(1580,1,'Dolno Novkovo'),(1580,2,'Долно Новково'),(1580,3,'Dolno Novkovo'),(1581,1,'Dolno novo selo'),(1581,2,'Долно ново село'),(1581,3,'Dolno novo selo'),(1582,1,'Dolno novo selo'),(1582,2,'Долно ново село'),(1582,3,'Dolno novo selo'),(1583,1,'Dolno Ozirovo'),(1583,2,'Долно Озирово'),(1583,3,'Dolno Ozirovo'),(1584,1,'Dolno Osenovo'),(1584,2,'Долно Осеново'),(1584,3,'Dolno Osenovo'),(1585,1,'Dolno pole'),(1585,2,'Долно поле'),(1585,3,'Dolno pole'),(1586,1,'Dolno Prahovo'),(1586,2,'Долно Прахово'),(1586,3,'Dolno Prahovo'),(1587,1,'Dolno Ryahovo'),(1587,2,'Долно Ряхово'),(1587,3,'Dolno Ryahovo'),(1588,1,'Dolno Sahrane'),(1588,2,'Долно Сахране'),(1588,3,'Dolno Sahrane'),(1589,1,'Dolno selo'),(1589,2,'Долно село'),(1589,3,'Dolno selo'),(1590,1,'Dolno Spanchevo'),(1590,2,'Долно Спанчево'),(1590,3,'Dolno Spanchevo'),(1591,1,'Dolno Sadievo'),(1591,2,'Долно Съдиево'),(1591,3,'Dolno Sadievo'),(1592,1,'Dolno Uyno'),(1592,2,'Долно Уйно'),(1592,3,'Dolno Uyno'),(1593,1,'Dolno Tserovene'),(1593,2,'Долно Церовене'),(1593,3,'Dolno Tserovene'),(1594,1,'Dolno Cherkovishte'),(1594,2,'Долно Черковище'),(1594,3,'Dolno Cherkovishte'),(1595,1,'Dolno Shivachevo'),(1595,2,'Долно Шивачево'),(1595,3,'Dolno Shivachevo'),(1596,1,'Dolno Yabalkovo'),(1596,2,'Долно Ябълково'),(1596,3,'Dolno Yabalkovo'),(1597,1,'Dolnoseltsi'),(1597,2,'Долноселци'),(1597,3,'Dolnoseltsi'),(1598,1,'Dolnoslav'),(1598,2,'Долнослав'),(1598,3,'Dolnoslav'),(1599,1,'Domishte'),(1599,2,'Домище'),(1599,3,'Domishte'),(1600,1,'Domlyan'),(1600,2,'Домлян'),(1600,3,'Domlyan'),(1601,1,'Dondukovo'),(1601,2,'Дондуково'),(1601,3,'Dondukovo'),(1602,1,'Donino'),(1602,2,'Донино'),(1602,3,'Donino'),(1603,1,'Donkino'),(1603,2,'Донкино'),(1603,3,'Donkino'),(1604,1,'Donkovtsi'),(1604,2,'Донковци'),(1604,3,'Donkovtsi'),(1605,1,'Donchevo'),(1605,2,'Дончево'),(1605,3,'Donchevo'),(1606,1,'Donchovtsi'),(1606,2,'Дончовци'),(1606,3,'Donchovtsi'),(1607,1,'Dorkovo'),(1607,2,'Дорково'),(1607,3,'Dorkovo'),(1608,1,'Dositeevo'),(1608,2,'Доситеево'),(1608,3,'Dositeevo'),(1609,1,'Dospat'),(1609,2,'Доспат'),(1609,3,'Dospat'),(1610,1,'Dospey'),(1610,2,'Доспей'),(1610,3,'Dospey'),(1611,1,'Docha'),(1611,2,'Доча'),(1611,3,'Docha'),(1612,1,'Drabishna'),(1612,2,'Драбишна'),(1612,3,'Drabishna'),(1613,1,'Dragana'),(1613,2,'Драгана'),(1613,3,'Dragana'),(1614,1,'Draganitsa'),(1614,2,'Драганица'),(1614,3,'Draganitsa'),(1615,1,'Draganovets'),(1615,2,'Драгановец'),(1615,3,'Draganovets'),(1616,1,'Draganovo'),(1616,2,'Драганово'),(1616,3,'Draganovo'),(1617,1,'Draganovo'),(1617,2,'Драганово'),(1617,3,'Draganovo'),(1618,1,'Draganovo'),(1618,2,'Драганово'),(1618,3,'Draganovo'),(1619,1,'Draganovo'),(1619,2,'Драганово'),(1619,3,'Draganovo'),(1620,1,'Draganovtsi'),(1620,2,'Драгановци'),(1620,3,'Draganovtsi'),(1621,1,'Draganovtsi'),(1621,2,'Драгановци'),(1621,3,'Draganovtsi'),(1622,1,'Draganoskovtsi'),(1622,2,'Драганосковци'),(1622,3,'Draganoskovtsi'),(1623,1,'Dragantsi'),(1623,2,'Драганци'),(1623,3,'Dragantsi'),(1624,1,'Draganchetata'),(1624,2,'Драганчетата'),(1624,3,'Draganchetata'),(1625,1,'Dragash voyvoda'),(1625,2,'Драгаш войвода'),(1625,3,'Dragash voyvoda'),(1626,1,'Dragievtsi'),(1626,2,'Драгиевци'),(1626,3,'Dragievtsi'),(1627,1,'Dragizhevo'),(1627,2,'Драгижево'),(1627,3,'Dragizhevo'),(1628,1,'Dragiytsi'),(1628,2,'Драгийци'),(1628,3,'Dragiytsi'),(1629,1,'Draginovo'),(1629,2,'Драгиново'),(1629,3,'Draginovo'),(1630,1,'Dragichevo'),(1630,2,'Драгичево'),(1630,3,'Dragichevo'),(1631,1,'Dragnevtsi'),(1631,2,'Драгневци'),(1631,3,'Dragnevtsi'),(1632,1,'Dragnevtsi'),(1632,2,'Драгневци'),(1632,3,'Dragnevtsi'),(1633,1,'Dragovishtitsa'),(1633,2,'Драговищица'),(1633,3,'Dragovishtitsa'),(1634,1,'Dragovishtitsa'),(1634,2,'Драговищица'),(1634,3,'Dragovishtitsa'),(1635,1,'Dragovo'),(1635,2,'Драгово'),(1635,3,'Dragovo'),(1636,1,'Dragodan'),(1636,2,'Драгодан'),(1636,3,'Dragodan'),(1637,1,'Dragodanovo'),(1637,2,'Драгоданово'),(1637,3,'Dragodanovo'),(1638,1,'Dragoevo'),(1638,2,'Драгоево'),(1638,3,'Dragoevo'),(1639,1,'Dragoil'),(1639,2,'Драгоил'),(1639,3,'Dragoil'),(1640,1,'Dragoynovo'),(1640,2,'Драгойново'),(1640,3,'Dragoynovo'),(1641,1,'Dragoychintsi'),(1641,2,'Драгойчинци'),(1641,3,'Dragoychintsi'),(1642,1,'Dragoman'),(1642,2,'Драгоман'),(1642,3,'Dragoman'),(1643,1,'Dragomani'),(1643,2,'Драгомани'),(1643,3,'Dragomani'),(1644,1,'Dragomir'),(1644,2,'Драгомир'),(1644,3,'Dragomir'),(1645,1,'Dragomirovo'),(1645,2,'Драгомирово'),(1645,3,'Dragomirovo'),(1646,1,'Dragomirovo'),(1646,2,'Драгомирово'),(1646,3,'Dragomirovo'),(1647,1,'Dragomazh'),(1647,2,'Драгомъж'),(1647,3,'Dragomazh'),(1648,1,'Dragor'),(1648,2,'Драгор'),(1648,3,'Dragor'),(1649,1,'Dragotintsi'),(1649,2,'Драготинци'),(1649,3,'Dragotintsi'),(1650,1,'Dragush'),(1650,2,'Драгуш'),(1650,3,'Dragush'),(1651,1,'Dragushinovo'),(1651,2,'Драгушиново'),(1651,3,'Dragushinovo'),(1652,1,'Drazhevo'),(1652,2,'Дражево'),(1652,3,'Drazhevo'),(1653,1,'Drazhintsi'),(1653,2,'Дражинци'),(1653,3,'Drazhintsi'),(1654,1,'Draka'),(1654,2,'Драка'),(1654,3,'Draka'),(1655,1,'Drakata'),(1655,2,'Драката'),(1655,3,'Drakata'),(1656,1,'Dralfa'),(1656,2,'Дралфа'),(1656,3,'Dralfa'),(1657,1,'Drama'),(1657,2,'Драма'),(1657,3,'Drama'),(1658,1,'Drangovo'),(1658,2,'Дрангово'),(1658,3,'Drangovo'),(1659,1,'Drangovo'),(1659,2,'Дрангово'),(1659,3,'Drangovo'),(1660,1,'Drangovo'),(1660,2,'Дрангово'),(1660,3,'Drangovo'),(1661,1,'Drandarite'),(1661,2,'Драндарите'),(1661,3,'Drandarite'),(1662,1,'Drachevo'),(1662,2,'Драчево'),(1662,3,'Drachevo'),(1663,1,'Drashan'),(1663,2,'Драшан'),(1663,3,'Drashan'),(1664,1,'Drashkova polyana'),(1664,2,'Драшкова поляна'),(1664,3,'Drashkova polyana'),(1665,1,'Dreatin'),(1665,2,'Дреатин'),(1665,3,'Dreatin'),(1666,1,'Dren'),(1666,2,'Дрен'),(1666,3,'Dren'),(1667,1,'Drenkovo'),(1667,2,'Дренково'),(1667,3,'Drenkovo'),(1668,1,'Drenov'),(1668,2,'Дренов'),(1668,3,'Drenov'),(1669,1,'Drenovets'),(1669,2,'Дреновец'),(1669,3,'Drenovets'),(1670,1,'Drenovitsa'),(1670,2,'Дреновица'),(1670,3,'Drenovitsa'),(1671,1,'Drenovo'),(1671,2,'Дреново'),(1671,3,'Drenovo'),(1672,1,'Drenovo'),(1672,2,'Дреново'),(1672,3,'Drenovo'),(1673,1,'Drenta'),(1673,2,'Дрента'),(1673,3,'Drenta'),(1674,1,'Drentsi'),(1674,2,'Дренци'),(1674,3,'Drentsi'),(1675,1,'Drinovo'),(1675,2,'Дриново'),(1675,3,'Drinovo'),(1676,1,'Dripchevo'),(1676,2,'Дрипчево'),(1676,3,'Dripchevo'),(1677,1,'Dropla'),(1677,2,'Дропла'),(1677,3,'Dropla'),(1678,1,'Dropla'),(1678,2,'Дропла'),(1678,3,'Dropla'),(1679,1,'Drugan'),(1679,2,'Друган'),(1679,3,'Drugan'),(1680,1,'Druzhba'),(1680,2,'Дружба'),(1680,3,'Druzhba'),(1681,1,'Druzhevo'),(1681,2,'Дружево'),(1681,3,'Druzhevo'),(1682,1,'Druzhintsi'),(1682,2,'Дружинци'),(1682,3,'Druzhintsi'),(1683,1,'Drumevo'),(1683,2,'Друмево'),(1683,3,'Drumevo'),(1684,1,'Drumohar'),(1684,2,'Друмохар'),(1684,3,'Drumohar'),(1685,1,'Drumche'),(1685,2,'Друмче'),(1685,3,'Drumche'),(1686,1,'Dramsha'),(1686,2,'Дръмша'),(1686,3,'Dramsha'),(1687,1,'Drandar'),(1687,2,'Дръндар'),(1687,3,'Drandar'),(1688,1,'Dryanka'),(1688,2,'Дрянка'),(1688,3,'Dryanka'),(1689,1,'Dryankovets'),(1689,2,'Дрянковец'),(1689,3,'Dryankovets'),(1690,1,'Dryanova glava'),(1690,2,'Дрянова глава'),(1690,3,'Dryanova glava'),(1691,1,'Dryanovets'),(1691,2,'Дряновец'),(1691,3,'Dryanovets'),(1692,1,'Dryanovets'),(1692,2,'Дряновец'),(1692,3,'Dryanovets'),(1693,1,'Dryanovets'),(1693,2,'Дряновец'),(1693,3,'Dryanovets'),(1694,1,'Dryanovets'),(1694,2,'Дряновец'),(1694,3,'Dryanovets'),(1695,1,'Dryanovo'),(1695,2,'Дряново'),(1695,3,'Dryanovo'),(1696,1,'Dryanovo'),(1696,2,'Дряново'),(1696,3,'Dryanovo'),(1697,1,'Dryanovo'),(1697,2,'Дряново'),(1697,3,'Dryanovo'),(1698,1,'Dryanovo'),(1698,2,'Дряново'),(1698,3,'Dryanovo'),(1699,1,'Dryanska'),(1699,2,'Дрянска'),(1699,3,'Dryanska'),(1700,1,'Dryanat'),(1700,2,'Дрянът'),(1700,3,'Dryanat'),(1701,1,'Duvanlii'),(1701,2,'Дуванлии'),(1701,3,'Duvanlii'),(1702,1,'Dukovtsi'),(1702,2,'Дуковци'),(1702,3,'Dukovtsi'),(1703,1,'Dulovo'),(1703,2,'Дулово'),(1703,3,'Dulovo'),(1704,1,'Dumnitsi'),(1704,2,'Думници'),(1704,3,'Dumnitsi'),(1705,1,'Dunavets'),(1705,2,'Дунавец'),(1705,3,'Dunavets'),(1706,1,'Dunavtsi'),(1706,2,'Дунавци'),(1706,3,'Dunavtsi'),(1707,1,'Dunavtsi'),(1707,2,'Дунавци'),(1707,3,'Dunavtsi'),(1708,1,'Dunavtsi'),(1708,2,'Дунавци'),(1708,3,'Dunavtsi'),(1709,1,'Dunevo'),(1709,2,'Дунево'),(1709,3,'Dunevo'),(1710,1,'Dunya'),(1710,2,'Дуня'),(1710,3,'Dunya'),(1711,1,'Dupnitsa'),(1711,2,'Дупница'),(1711,3,'Dupnitsa'),(1712,1,'Durankulak'),(1712,2,'Дуранкулак'),(1712,3,'Durankulak'),(1713,1,'Durovtsi'),(1713,2,'Дуровци'),(1713,3,'Durovtsi'),(1714,1,'Durcha'),(1714,2,'Дурча'),(1714,3,'Durcha'),(1715,1,'Duhovets'),(1715,2,'Духовец'),(1715,3,'Duhovets'),(1716,1,'Dushantsi'),(1716,2,'Душанци'),(1716,3,'Dushantsi'),(1717,1,'Dushevo'),(1717,2,'Душево'),(1717,3,'Dushevo'),(1718,1,'Dushevski kolibi'),(1718,2,'Душевски колиби'),(1718,3,'Dushevski kolibi'),(1719,1,'Dushinkovo'),(1719,2,'Душинково'),(1719,3,'Dushinkovo'),(1720,1,'Dushintsi'),(1720,2,'Душинци'),(1720,3,'Dushintsi'),(1721,1,'Dushka'),(1721,2,'Душка'),(1721,3,'Dushka'),(1722,1,'Daben'),(1722,2,'Дъбен'),(1722,3,'Daben'),(1723,1,'Dabene'),(1723,2,'Дъбене'),(1723,3,'Dabene'),(1724,1,'Dabnik'),(1724,2,'Дъбник'),(1724,3,'Dabnik'),(1725,1,'Dabnitsa'),(1725,2,'Дъбница'),(1725,3,'Dabnitsa'),(1726,1,'Dabova'),(1726,2,'Дъбова'),(1726,3,'Dabova'),(1727,1,'Dabova'),(1727,2,'Дъбова'),(1727,3,'Dabova'),(1728,1,'Dabova mahala'),(1728,2,'Дъбова махала'),(1728,3,'Dabova mahala'),(1729,1,'Dabovan'),(1729,2,'Дъбован'),(1729,3,'Dabovan'),(1730,1,'Dabovets'),(1730,2,'Дъбовец'),(1730,3,'Dabovets'),(1731,1,'Dabovik'),(1731,2,'Дъбовик'),(1731,3,'Dabovik'),(1732,1,'Dabovitsa'),(1732,2,'Дъбовица'),(1732,3,'Dabovitsa'),(1733,1,'Dabovo'),(1733,2,'Дъбово'),(1733,3,'Dabovo'),(1734,1,'Dabovo'),(1734,2,'Дъбово'),(1734,3,'Dabovo'),(1735,1,'Dabrava'),(1735,2,'Дъбрава'),(1735,3,'Dabrava'),(1736,1,'Dabrava'),(1736,2,'Дъбрава'),(1736,3,'Dabrava'),(1737,1,'Dabrava'),(1737,2,'Дъбрава'),(1737,3,'Dabrava'),(1738,1,'Dabravata'),(1738,2,'Дъбравата'),(1738,3,'Dabravata'),(1739,1,'Dabravino'),(1739,2,'Дъбравино'),(1739,3,'Dabravino'),(1740,1,'Dabravite'),(1740,2,'Дъбравите'),(1740,3,'Dabravite'),(1741,1,'Dabravitsa'),(1741,2,'Дъбравица'),(1741,3,'Dabravitsa'),(1742,1,'Dabravka'),(1742,2,'Дъбравка'),(1742,3,'Dabravka'),(1743,1,'Dazhdino'),(1743,2,'Дъждино'),(1743,3,'Dazhdino'),(1744,1,'Dazhdovnik'),(1744,2,'Дъждовник'),(1744,3,'Dazhdovnik'),(1745,1,'Dazhdovnitsa'),(1745,2,'Дъждовница'),(1745,3,'Dazhdovnitsa'),(1746,1,'Dalbok dol'),(1746,2,'Дълбок дол'),(1746,3,'Dalbok dol'),(1747,1,'Dalbok izvor'),(1747,2,'Дълбок извор'),(1747,3,'Dalbok izvor'),(1748,1,'Dalboki'),(1748,2,'Дълбоки'),(1748,3,'Dalboki'),(1749,1,'Dalga luka'),(1749,2,'Дълга лука'),(1749,3,'Dalga luka'),(1750,1,'Dalgach'),(1750,2,'Дългач'),(1750,3,'Dalgach'),(1751,1,'Dalgi del'),(1751,2,'Дълги дел'),(1751,3,'Dalgi del'),(1752,1,'Dalgi pripek'),(1752,2,'Дълги припек'),(1752,3,'Dalgi pripek'),(1753,1,'Dalgo pole'),(1753,2,'Дълго поле'),(1753,3,'Dalgo pole'),(1754,1,'Dalgo pole'),(1754,2,'Дълго поле'),(1754,3,'Dalgo pole'),(1755,1,'Dalgodeltsi'),(1755,2,'Дългоделци'),(1755,3,'Dalgodeltsi'),(1756,1,'Dalgopol'),(1756,2,'Дългопол'),(1756,3,'Dalgopol'),(1757,1,'Dangovo'),(1757,2,'Дънгово'),(1757,3,'Dangovo'),(1758,1,'Darvari'),(1758,2,'Дървари'),(1758,3,'Darvari'),(1759,1,'Darzhava'),(1759,2,'Държава'),(1759,3,'Darzhava'),(1760,1,'Darzhaven'),(1760,2,'Държавен'),(1760,3,'Darzhaven'),(1761,1,'Darzhanitsa'),(1761,2,'Държаница'),(1761,3,'Darzhanitsa'),(1762,1,'Darlevtsi'),(1762,2,'Дърлевци'),(1762,3,'Darlevtsi'),(1763,1,'Darmantsi'),(1763,2,'Дърманци'),(1763,3,'Darmantsi'),(1764,1,'Daskarite'),(1764,2,'Дъскарите'),(1764,3,'Daskarite'),(1765,1,'Daskot'),(1765,2,'Дъскот'),(1765,3,'Daskot'),(1766,1,'Daskotna'),(1766,2,'Дъскотна'),(1766,3,'Daskotna'),(1767,1,'Dyulevo'),(1767,2,'Дюлево'),(1767,3,'Dyulevo'),(1768,1,'Dyulevo'),(1768,2,'Дюлево'),(1768,3,'Dyulevo'),(1769,1,'Dyulino'),(1769,2,'Дюлино'),(1769,3,'Dyulino'),(1770,1,'Dyulitsa'),(1770,2,'Дюлица'),(1770,3,'Dyulitsa'),(1771,1,'Dyulya'),(1771,2,'Дюля'),(1771,3,'Dyulya'),(1772,1,'Dyadovo'),(1772,2,'Дядово'),(1772,3,'Dyadovo'),(1773,1,'Dyadovsko'),(1773,2,'Дядовско'),(1773,3,'Dyadovsko'),(1774,1,'Dyadovtsi'),(1774,2,'Дядовци'),(1774,3,'Dyadovtsi'),(1775,1,'Dyakovo'),(1775,2,'Дяково'),(1775,3,'Dyakovo'),(1776,1,'Dyalak'),(1776,2,'Дялък'),(1776,3,'Dyalak'),(1777,1,'Dyankovo'),(1777,2,'Дянково'),(1777,3,'Dyankovo'),(1778,1,'Evlogievo'),(1778,2,'Евлогиево'),(1778,3,'Evlogievo'),(1779,1,'Evrenozovo'),(1779,2,'Евренозово'),(1779,3,'Evrenozovo'),(1780,1,'Egrek'),(1780,2,'Егрек'),(1780,3,'Egrek'),(1781,1,'Egalnitsa'),(1781,2,'Егълница'),(1781,3,'Egalnitsa'),(1782,1,'Edinakovtsi'),(1782,2,'Единаковци'),(1782,3,'Edinakovtsi'),(1783,1,'Edrevo'),(1783,2,'Едрево'),(1783,3,'Edrevo'),(1784,1,'Edrino'),(1784,2,'Едрино'),(1784,3,'Edrino'),(1785,1,'Ezdimirtsi'),(1785,2,'Ездимирци'),(1785,3,'Ezdimirtsi'),(1786,1,'Ezerets'),(1786,2,'Езерец'),(1786,3,'Ezerets'),(1787,1,'Ezerets'),(1787,2,'Езерец'),(1787,3,'Ezerets'),(1788,1,'Ezero'),(1788,2,'Езеро'),(1788,3,'Ezero'),(1789,1,'Ezerovo'),(1789,2,'Езерово'),(1789,3,'Ezerovo'),(1790,1,'Ezerovo'),(1790,2,'Езерово'),(1790,3,'Ezerovo'),(1791,1,'Ezeroto'),(1791,2,'Езерото'),(1791,3,'Ezeroto'),(1792,1,'Ezerche'),(1792,2,'Езерче'),(1792,3,'Ezerche'),(1793,1,'Ekzarh Antimovo'),(1793,2,'Екзарх Антимово'),(1793,3,'Ekzarh Antimovo'),(1794,1,'Ekzarh Yosif'),(1794,2,'Екзарх Йосиф'),(1794,3,'Ekzarh Yosif'),(1795,1,'Elena'),(1795,2,'Елена'),(1795,3,'Elena'),(1796,1,'Elena'),(1796,2,'Елена'),(1796,3,'Elena'),(1797,1,'Elenino'),(1797,2,'Еленино'),(1797,3,'Elenino'),(1798,1,'Elenka'),(1798,2,'Еленка'),(1798,3,'Elenka'),(1799,1,'Elenov dol'),(1799,2,'Еленов дол'),(1799,3,'Elenov dol'),(1800,1,'Elenovo'),(1800,2,'Еленово'),(1800,3,'Elenovo'),(1801,1,'Elenovo'),(1801,2,'Еленово'),(1801,3,'Elenovo'),(1802,1,'Elenovo'),(1802,2,'Еленово'),(1802,3,'Elenovo'),(1803,1,'Elenska'),(1803,2,'Еленска'),(1803,3,'Elenska'),(1804,1,'Elentsite'),(1804,2,'Еленците'),(1804,3,'Elentsite'),(1805,1,'Eleshnitsa'),(1805,2,'Елешница'),(1805,3,'Eleshnitsa'),(1806,1,'Eleshnitsa'),(1806,2,'Елешница'),(1806,3,'Eleshnitsa'),(1807,1,'Elin Pelin'),(1807,2,'Елин Пелин'),(1807,3,'Elin Pelin'),(1808,1,'Elin Pelin'),(1808,2,'Елин Пелин'),(1808,3,'Elin Pelin'),(1809,1,'Eliseyna'),(1809,2,'Елисейна'),(1809,3,'Eliseyna'),(1810,1,'Elov dol'),(1810,2,'Елов дол'),(1810,3,'Elov dol'),(1811,1,'Elovdol'),(1811,2,'Еловдол'),(1811,3,'Elovdol'),(1812,1,'Elovitsa'),(1812,2,'Еловица'),(1812,3,'Elovitsa'),(1813,1,'Elovitsa'),(1813,2,'Еловица'),(1813,3,'Elovitsa'),(1814,1,'Elhovets'),(1814,2,'Елховец'),(1814,3,'Elhovets'),(1815,1,'Elhovo'),(1815,2,'Елхово'),(1815,3,'Elhovo'),(1816,1,'Elhovo'),(1816,2,'Елхово'),(1816,3,'Elhovo'),(1817,1,'Elhovo'),(1817,2,'Елхово'),(1817,3,'Elhovo'),(1818,1,'Elshitsa'),(1818,2,'Елшица'),(1818,3,'Elshitsa'),(1819,1,'Elyovo'),(1819,2,'Ельово'),(1819,3,'Elyovo'),(1820,1,'Emen'),(1820,2,'Емен'),(1820,3,'Emen'),(1821,1,'Emona'),(1821,2,'Емона'),(1821,3,'Emona'),(1822,1,'Enev rat'),(1822,2,'Енев рът'),(1822,3,'Enev rat'),(1823,1,'Enevo'),(1823,2,'Енево'),(1823,3,'Enevo'),(1824,1,'Enevo'),(1824,2,'Енево'),(1824,3,'Enevo'),(1825,1,'Enina'),(1825,2,'Енина'),(1825,3,'Enina'),(1826,1,'Enitsa'),(1826,2,'Еница'),(1826,3,'Enitsa'),(1827,1,'Enchets'),(1827,2,'Енчец'),(1827,3,'Enchets'),(1828,1,'Enchovtsi'),(1828,2,'Енчовци'),(1828,3,'Enchovtsi'),(1829,1,'Enyovche'),(1829,2,'Еньовче'),(1829,3,'Enyovche'),(1830,1,'Erden'),(1830,2,'Ерден'),(1830,3,'Erden'),(1831,1,'Eremia'),(1831,2,'Еремия'),(1831,3,'Eremia'),(1832,1,'Erma reka'),(1832,2,'Ерма река'),(1832,3,'Erma reka'),(1833,1,'Erovete'),(1833,2,'Еровете'),(1833,3,'Erovete'),(1834,1,'Erul'),(1834,2,'Ерул'),(1834,3,'Erul'),(1835,1,'Esen'),(1835,2,'Есен'),(1835,3,'Esen'),(1836,1,'Esenitsa'),(1836,2,'Есеница'),(1836,3,'Esenitsa'),(1837,1,'Etropole'),(1837,2,'Етрополе'),(1837,3,'Etropole'),(1838,1,'Efreytor Bakalovo'),(1838,2,'Ефрейтор Бакалово'),(1838,3,'Efreytor Bakalovo'),(1839,1,'Efrem'),(1839,2,'Ефрем'),(1839,3,'Efrem'),(1840,1,'Zhablyano'),(1840,2,'Жабляно'),(1840,3,'Zhablyano'),(1841,1,'Zhabokrat'),(1841,2,'Жабокрът'),(1841,3,'Zhabokrat'),(1842,1,'Zheglartsi'),(1842,2,'Жегларци'),(1842,3,'Zheglartsi'),(1843,1,'Zheglitsa'),(1843,2,'Жеглица'),(1843,3,'Zheglitsa'),(1844,1,'Zhedna'),(1844,2,'Жедна'),(1844,3,'Zhedna'),(1845,1,'Zhelezari'),(1845,2,'Железари'),(1845,3,'Zhelezari'),(1846,1,'Zhelezari'),(1846,2,'Железари'),(1846,3,'Zhelezari'),(1847,1,'Zhelezartsi'),(1847,2,'Железарци'),(1847,3,'Zhelezartsi'),(1848,1,'Zhelezino'),(1848,2,'Железино'),(1848,3,'Zhelezino'),(1849,1,'Zhelezna'),(1849,2,'Железна'),(1849,3,'Zhelezna'),(1850,1,'Zheleznik'),(1850,2,'Железник'),(1850,3,'Zheleznik'),(1851,1,'Zheleznik'),(1851,2,'Железник'),(1851,3,'Zheleznik'),(1852,1,'Zheleznitsa'),(1852,2,'Железница'),(1852,3,'Zheleznitsa'),(1853,1,'Zheleznitsa'),(1853,2,'Железница'),(1853,3,'Zheleznitsa'),(1854,1,'Zhelen'),(1854,2,'Желен'),(1854,3,'Zhelen'),(1855,1,'Zhelad'),(1855,2,'Желъд'),(1855,3,'Zhelad'),(1856,1,'Zheladovo'),(1856,2,'Желъдово'),(1856,3,'Zheladovo'),(1857,1,'Zhelyu voyvoda'),(1857,2,'Желю войвода'),(1857,3,'Zhelyu voyvoda'),(1858,1,'Zhelyava'),(1858,2,'Желява'),(1858,3,'Zhelyava'),(1859,1,'Zhelyazkovets'),(1859,2,'Желязковец'),(1859,3,'Zhelyazkovets'),(1860,1,'Zhelyazno'),(1860,2,'Желязно'),(1860,3,'Zhelyazno'),(1861,1,'Zhelyazovo'),(1861,2,'Желязово'),(1861,3,'Zhelyazovo'),(1862,1,'Zhenda'),(1862,2,'Женда'),(1862,3,'Zhenda'),(1863,1,'Zheravino'),(1863,2,'Жеравино'),(1863,3,'Zheravino'),(1864,1,'Zheravitsa'),(1864,2,'Жеравица'),(1864,3,'Zheravitsa'),(1865,1,'Zheravna'),(1865,2,'Жеравна'),(1865,3,'Zheravna'),(1866,1,'Zhergovets'),(1866,2,'Жерговец'),(1866,3,'Zhergovets'),(1867,1,'Zhernov'),(1867,2,'Жернов'),(1867,3,'Zhernov'),(1868,1,'Zhivko'),(1868,2,'Живко'),(1868,3,'Zhivko'),(1869,1,'Zhivkovo'),(1869,2,'Живково'),(1869,3,'Zhivkovo'),(1870,1,'Zhivkovo'),(1870,2,'Живково'),(1870,3,'Zhivkovo'),(1871,1,'Zhidov dol'),(1871,2,'Жидов дол'),(1871,3,'Zhidov dol'),(1872,1,'Zhizhevo'),(1872,2,'Жижево'),(1872,3,'Zhizhevo'),(1873,1,'Zhilentsi'),(1873,2,'Жиленци'),(1873,3,'Zhilentsi'),(1874,1,'Zhilino'),(1874,2,'Жилино'),(1874,3,'Zhilino'),(1875,1,'Zhinzifovo'),(1875,2,'Жинзифово'),(1875,3,'Zhinzifovo'),(1876,1,'Zhitarnik'),(1876,2,'Житарник'),(1876,3,'Zhitarnik'),(1877,1,'Zhiten'),(1877,2,'Житен'),(1877,3,'Zhiten'),(1878,1,'Zhiten'),(1878,2,'Житен'),(1878,3,'Zhiten'),(1879,1,'Zhitnitsa'),(1879,2,'Житница'),(1879,3,'Zhitnitsa'),(1880,1,'Zhitnitsa'),(1880,2,'Житница'),(1880,3,'Zhitnitsa'),(1881,1,'Zhitnitsa'),(1881,2,'Житница'),(1881,3,'Zhitnitsa'),(1882,1,'Zhitnitsa'),(1882,2,'Житница'),(1882,3,'Zhitnitsa'),(1883,1,'Zhitosvyat'),(1883,2,'Житосвят'),(1883,3,'Zhitosvyat'),(1884,1,'Zhitusha'),(1884,2,'Житуша'),(1884,3,'Zhitusha'),(1885,1,'Zhrebevo'),(1885,2,'Жребево'),(1885,3,'Zhrebevo'),(1886,1,'Zhrebino'),(1886,2,'Жребино'),(1886,3,'Zhrebino'),(1887,1,'Zhrebichko'),(1887,2,'Жребичко'),(1887,3,'Zhrebichko'),(1888,1,'Zhalt bryag'),(1888,2,'Жълт бряг'),(1888,3,'Zhalt bryag'),(1889,1,'Zhalt kamak'),(1889,2,'Жълт камък'),(1889,3,'Zhalt kamak'),(1890,1,'Zhaltesh'),(1890,2,'Жълтеш'),(1890,3,'Zhaltesh'),(1891,1,'Zhalti bryag'),(1891,2,'Жълти бряг'),(1891,3,'Zhalti bryag'),(1892,1,'Zhalti rid'),(1892,2,'Жълти рид'),(1892,3,'Zhalti rid'),(1893,1,'Zhaltika'),(1893,2,'Жълтика'),(1893,3,'Zhaltika'),(1894,1,'Zhaltopop'),(1894,2,'Жълтопоп'),(1894,3,'Zhaltopop'),(1895,1,'Zhaltusha'),(1895,2,'Жълтуша'),(1895,3,'Zhaltusha'),(1896,1,'Zabel'),(1896,2,'Забел'),(1896,3,'Zabel'),(1897,1,'Zabernovo'),(1897,2,'Заберново'),(1897,3,'Zabernovo'),(1898,1,'Zabardo'),(1898,2,'Забърдо'),(1898,3,'Zabardo'),(1899,1,'Zavala'),(1899,2,'Завала'),(1899,3,'Zavala'),(1900,1,'Zavet'),(1900,2,'Завет'),(1900,3,'Zavet'),(1901,1,'Zavet'),(1901,2,'Завет'),(1901,3,'Zavet'),(1902,1,'Zavetno'),(1902,2,'Заветно'),(1902,3,'Zavetno'),(1903,1,'Zavidovtsi'),(1903,2,'Завидовци'),(1903,3,'Zavidovtsi'),(1904,1,'Zavoy'),(1904,2,'Завой'),(1904,3,'Zavoy'),(1905,1,'Zavoya'),(1905,2,'Завоя'),(1905,3,'Zavoya'),(1906,1,'Zagore'),(1906,2,'Загоре'),(1906,3,'Zagore'),(1907,1,'Zagoriche'),(1907,2,'Загориче'),(1907,3,'Zagoriche'),(1908,1,'Zagorski'),(1908,2,'Загорски'),(1908,3,'Zagorski'),(1909,1,'Zagorsko'),(1909,2,'Загорско'),(1909,3,'Zagorsko'),(1910,1,'Zagortsi'),(1910,2,'Загорци'),(1910,3,'Zagortsi'),(1911,1,'Zagortsi'),(1911,2,'Загорци'),(1911,3,'Zagortsi'),(1912,1,'Zagortsi'),(1912,2,'Загорци'),(1912,3,'Zagortsi'),(1913,1,'Zagrazhden'),(1913,2,'Загражден'),(1913,3,'Zagrazhden'),(1914,1,'Zagrazhden'),(1914,2,'Загражден'),(1914,3,'Zagrazhden'),(1915,1,'Zadruga'),(1915,2,'Задруга'),(1915,3,'Zadruga'),(1916,1,'Zaevite'),(1916,2,'Заевите'),(1916,3,'Zaevite'),(1917,1,'Zaimchevo'),(1917,2,'Заимчево'),(1917,3,'Zaimchevo'),(1918,1,'Zaychar'),(1918,2,'Зайчар'),(1918,3,'Zaychar'),(1919,1,'Zaychari'),(1919,2,'Зайчари'),(1919,3,'Zaychari'),(1920,1,'Zaychino'),(1920,2,'Зайчино'),(1920,3,'Zaychino'),(1921,1,'Zaychino oreshe'),(1921,2,'Зайчино ореше'),(1921,3,'Zaychino oreshe'),(1922,1,'Zamfir'),(1922,2,'Замфир'),(1922,3,'Zamfir'),(1923,1,'Zamfirovo'),(1923,2,'Замфирово'),(1923,3,'Zamfirovo'),(1924,1,'Zanoga'),(1924,2,'Занога'),(1924,3,'Zanoga'),(1925,1,'Zanoge'),(1925,2,'Заноге'),(1925,3,'Zanoge'),(1926,1,'Zaraevo'),(1926,2,'Зараево'),(1926,3,'Zaraevo'),(1927,1,'Zaritsa'),(1927,2,'Зарица'),(1927,3,'Zaritsa'),(1928,1,'Zarnik'),(1928,2,'Зарник'),(1928,3,'Zarnik'),(1929,1,'Zasele'),(1929,2,'Заселе'),(1929,3,'Zasele'),(1930,1,'Zasmyano'),(1930,2,'Засмяно'),(1930,3,'Zasmyano'),(1931,1,'Zafirovo'),(1931,2,'Зафирово'),(1931,3,'Zafirovo'),(1932,1,'Zahari Stoyanovo'),(1932,2,'Захари Стояново'),(1932,3,'Zahari Stoyanovo'),(1933,1,'Zahari Stoyanovo'),(1933,2,'Захари Стояново'),(1933,3,'Zahari Stoyanovo'),(1934,1,'Zaya'),(1934,2,'Зая'),(1934,3,'Zaya'),(1935,1,'Zvegor'),(1935,2,'Звегор'),(1935,3,'Zvegor'),(1936,1,'Zvezda'),(1936,2,'Звезда'),(1936,3,'Zvezda'),(1937,1,'Zvezda'),(1937,2,'Звезда'),(1937,3,'Zvezda'),(1938,1,'Zvezdel'),(1938,2,'Звездел'),(1938,3,'Zvezdel'),(1939,1,'Zvezdelina'),(1939,2,'Звезделина'),(1939,3,'Zvezdelina'),(1940,1,'Zvezden'),(1940,2,'Звезден'),(1940,3,'Zvezden'),(1941,1,'Zvezdets'),(1941,2,'Звездец'),(1941,3,'Zvezdets'),(1942,1,'Zvezditsa'),(1942,2,'Звездица'),(1942,3,'Zvezditsa'),(1943,1,'Zvezditsa'),(1943,2,'Звездица'),(1943,3,'Zvezditsa'),(1944,1,'Zvenimir'),(1944,2,'Звенимир'),(1944,3,'Zvenimir'),(1945,1,'Zverino'),(1945,2,'Зверино'),(1945,3,'Zverino'),(1946,1,'Zvinitsa'),(1946,2,'Звиница'),(1946,3,'Zvinitsa'),(1947,1,'Zvanarka'),(1947,2,'Звънарка'),(1947,3,'Zvanarka'),(1948,1,'Zvanartsi'),(1948,2,'Звънарци'),(1948,3,'Zvanartsi'),(1949,1,'Zvanets'),(1949,2,'Звънец'),(1949,3,'Zvanets'),(1950,1,'Zvanika'),(1950,2,'Звъника'),(1950,3,'Zvanika'),(1951,1,'Zvanichevo'),(1951,2,'Звъничево'),(1951,3,'Zvanichevo'),(1952,1,'Zvanche'),(1952,2,'Звънче'),(1952,3,'Zvanche'),(1953,1,'Zgalevo'),(1953,2,'Згалево'),(1953,3,'Zgalevo'),(1954,1,'Zgorigrad'),(1954,2,'Згориград'),(1954,3,'Zgorigrad'),(1955,1,'Zgurovo'),(1955,2,'Згурово'),(1955,3,'Zgurovo'),(1956,1,'Zdravets'),(1956,2,'Здравец'),(1956,3,'Zdravets'),(1957,1,'Zdravets'),(1957,2,'Здравец'),(1957,3,'Zdravets'),(1958,1,'Zdravets'),(1958,2,'Здравец'),(1958,3,'Zdravets'),(1959,1,'Zdravets'),(1959,2,'Здравец'),(1959,3,'Zdravets'),(1960,1,'Zdravets'),(1960,2,'Здравец'),(1960,3,'Zdravets'),(1961,1,'Zdravkovets'),(1961,2,'Здравковец'),(1961,3,'Zdravkovets'),(1962,1,'Zdravchets'),(1962,2,'Здравчец'),(1962,3,'Zdravchets'),(1963,1,'Zebil'),(1963,2,'Зебил'),(1963,3,'Zebil'),(1964,1,'Zelena morava'),(1964,2,'Зелена морава'),(1964,3,'Zelena morava'),(1965,1,'Zelendol'),(1965,2,'Зелендол'),(1965,3,'Zelendol'),(1966,1,'Zelenigrad'),(1966,2,'Зелениград'),(1966,3,'Zelenigrad'),(1967,1,'Zelenik'),(1967,2,'Зеленик'),(1967,3,'Zelenik'),(1968,1,'Zelenika'),(1968,2,'Зеленика'),(1968,3,'Zelenika'),(1969,1,'Zelenikovo'),(1969,2,'Зелениково'),(1969,3,'Zelenikovo'),(1970,1,'Zelenikovo'),(1970,2,'Зелениково'),(1970,3,'Zelenikovo'),(1971,1,'Zeleno darvo'),(1971,2,'Зелено дърво'),(1971,3,'Zeleno darvo'),(1972,1,'Zemen'),(1972,2,'Земен'),(1972,3,'Zemen'),(1973,1,'Zementsi'),(1973,2,'Земенци'),(1973,3,'Zementsi'),(1974,1,'Zemlen'),(1974,2,'Землен'),(1974,3,'Zemlen'),(1975,1,'Zetyovo'),(1975,2,'Зетьово'),(1975,3,'Zetyovo'),(1976,1,'Zetyovo'),(1976,2,'Зетьово'),(1976,3,'Zetyovo'),(1977,1,'Zidarovo'),(1977,2,'Зидарово'),(1977,3,'Zidarovo'),(1978,1,'Zidartsi'),(1978,2,'Зидарци'),(1978,3,'Zidartsi'),(1979,1,'Zimevitsa'),(1979,2,'Зимевица'),(1979,3,'Zimevitsa'),(1980,1,'Zimen'),(1980,2,'Зимен'),(1980,3,'Zimen'),(1981,1,'Zimzelen'),(1981,2,'Зимзелен'),(1981,3,'Zimzelen'),(1982,1,'Zimnitsa'),(1982,2,'Зимница'),(1982,3,'Zimnitsa'),(1983,1,'Zimnitsa'),(1983,2,'Зимница'),(1983,3,'Zimnitsa'),(1984,1,'Zimnitsa'),(1984,2,'Зимница'),(1984,3,'Zimnitsa'),(1985,1,'Zimovina'),(1985,2,'Зимовина'),(1985,3,'Zimovina'),(1986,1,'Zimornitsa'),(1986,2,'Зиморница'),(1986,3,'Zimornitsa'),(1987,1,'Zlatar'),(1987,2,'Златар'),(1987,3,'Zlatar'),(1988,1,'Zlatari'),(1988,2,'Златари'),(1988,3,'Zlatari'),(1989,1,'Zlataritsa'),(1989,2,'Златарица'),(1989,3,'Zlataritsa'),(1990,1,'Zlataritsa'),(1990,2,'Златарица'),(1990,3,'Zlataritsa'),(1991,1,'Zlatevtsi'),(1991,2,'Златевци'),(1991,3,'Zlatevtsi'),(1992,1,'Zlati voyvoda'),(1992,2,'Злати войвода'),(1992,3,'Zlati voyvoda'),(1993,1,'Zlatina'),(1993,2,'Златина'),(1993,3,'Zlatina'),(1994,1,'Zlatinitsa'),(1994,2,'Златиница'),(1994,3,'Zlatinitsa'),(1995,1,'Zlatirat'),(1995,2,'Златирът'),(1995,3,'Zlatirat'),(1996,1,'Zlatitrap'),(1996,2,'Златитрап'),(1996,3,'Zlatitrap'),(1997,1,'Zlatitsa'),(1997,2,'Златица'),(1997,3,'Zlatitsa'),(1998,1,'Zlatia'),(1998,2,'Златия'),(1998,3,'Zlatia'),(1999,1,'Zlatia'),(1999,2,'Златия'),(1999,3,'Zlatia'),(2000,1,'Zlatna livada'),(2000,2,'Златна ливада'),(2000,3,'Zlatna livada'),(2001,1,'Zlatna niva'),(2001,2,'Златна нива'),(2001,3,'Zlatna niva'),(2002,1,'Zlatna Panega'),(2002,2,'Златна Панега'),(2002,3,'Zlatna Panega'),(2003,1,'Zlatovrah'),(2003,2,'Златовръх'),(2003,3,'Zlatovrah'),(2004,1,'Zlatograd'),(2004,2,'Златоград'),(2004,3,'Zlatograd'),(2005,1,'Zlatoklas'),(2005,2,'Златоклас'),(2005,3,'Zlatoklas'),(2006,1,'Zlatolist'),(2006,2,'Златолист'),(2006,3,'Zlatolist'),(2007,1,'Zlatolist'),(2007,2,'Златолист'),(2007,3,'Zlatolist'),(2008,1,'Zlatopole'),(2008,2,'Златополе'),(2008,3,'Zlatopole'),(2009,1,'Zlatosel'),(2009,2,'Златосел'),(2009,3,'Zlatosel'),(2010,1,'Zlatoustovo'),(2010,2,'Златоустово'),(2010,3,'Zlatoustovo'),(2011,1,'Zlatusha'),(2011,2,'Златуша'),(2011,3,'Zlatusha'),(2012,1,'Zlidol'),(2012,2,'Злидол'),(2012,3,'Zlidol'),(2013,1,'Zlogosh'),(2013,2,'Злогош'),(2013,3,'Zlogosh'),(2014,1,'Zlokuchene'),(2014,2,'Злокучене'),(2014,3,'Zlokuchene'),(2015,1,'Zlokuchene'),(2015,2,'Злокучене'),(2015,3,'Zlokuchene'),(2016,1,'Zmeevo'),(2016,2,'Змеево'),(2016,3,'Zmeevo'),(2017,1,'Zmeitsa'),(2017,2,'Змеица'),(2017,3,'Zmeitsa'),(2018,1,'Zmeyno'),(2018,2,'Змейно'),(2018,3,'Zmeyno'),(2019,1,'Zmeyovo'),(2019,2,'Змейово'),(2019,3,'Zmeyovo'),(2020,1,'Zmievo'),(2020,2,'Змиево'),(2020,3,'Zmievo'),(2021,1,'Znamenosets'),(2021,2,'Знаменосец'),(2021,3,'Znamenosets'),(2022,1,'Zograf'),(2022,2,'Зограф'),(2022,3,'Zograf'),(2023,1,'Zoychene'),(2023,2,'Зойчене'),(2023,3,'Zoychene'),(2024,1,'Zornitsa'),(2024,2,'Зорница'),(2024,3,'Zornitsa'),(2025,1,'Zornitsa'),(2025,2,'Зорница'),(2025,3,'Zornitsa'),(2026,1,'Zornitsa'),(2026,2,'Зорница'),(2026,3,'Zornitsa'),(2027,1,'Zornitsa'),(2027,2,'Зорница'),(2027,3,'Zornitsa'),(2028,1,'Zornitsa'),(2028,2,'Зорница'),(2028,3,'Zornitsa'),(2029,1,'Zornitsa'),(2029,2,'Зорница'),(2029,3,'Zornitsa'),(2030,1,'Zarnevo'),(2030,2,'Зърнево'),(2030,3,'Zarnevo'),(2031,1,'ivaylo'),(2031,2,'Ивайло'),(2031,3,'ivaylo'),(2032,1,'ivaylovgrad'),(2032,2,'Ивайловград'),(2032,3,'ivaylovgrad'),(2033,1,'ivan Vazovo'),(2033,2,'Иван Вазово'),(2033,3,'ivan Vazovo'),(2034,1,'ivan Dimov'),(2034,2,'Иван Димов'),(2034,3,'ivan Dimov'),(2035,1,'ivan Shishmanovo'),(2035,2,'Иван Шишманово'),(2035,3,'ivan Shishmanovo'),(2036,1,'ivanivanovtsi'),(2036,2,'Иванивановци'),(2036,3,'ivanivanovtsi'),(2037,1,'ivanili'),(2037,2,'Иванили'),(2037,3,'ivanili'),(2038,1,'ivankovtsi'),(2038,2,'Иванковци'),(2038,3,'ivankovtsi'),(2039,1,'ivanovo'),(2039,2,'Иваново'),(2039,3,'ivanovo'),(2040,1,'ivanovo'),(2040,2,'Иваново'),(2040,3,'ivanovo'),(2041,1,'ivanovo'),(2041,2,'Иваново'),(2041,3,'ivanovo'),(2042,1,'ivanovo'),(2042,2,'Иваново'),(2042,3,'ivanovo'),(2043,1,'ivanovo'),(2043,2,'Иваново'),(2043,3,'ivanovo'),(2044,1,'ivanovtsi'),(2044,2,'Ивановци'),(2044,3,'ivanovtsi'),(2045,1,'ivanovtsi'),(2045,2,'Ивановци'),(2045,3,'ivanovtsi'),(2046,1,'ivanovtsi'),(2046,2,'Ивановци'),(2046,3,'ivanovtsi'),(2047,1,'ivanski'),(2047,2,'Ивански'),(2047,3,'ivanski'),(2048,1,'ivantsi'),(2048,2,'Иванци'),(2048,3,'ivantsi'),(2049,1,'ivancha'),(2049,2,'Иванча'),(2049,3,'ivancha'),(2050,1,'ivancha'),(2050,2,'Иванча'),(2050,3,'ivancha'),(2051,1,'ivanshnitsa'),(2051,2,'Иваншница'),(2051,3,'ivanshnitsa'),(2052,1,'ivanyane'),(2052,2,'Иваняне'),(2052,3,'ivanyane'),(2053,1,'iganovo'),(2053,2,'Иганово'),(2053,3,'iganovo'),(2054,1,'iglika'),(2054,2,'Иглика'),(2054,3,'iglika'),(2055,1,'iglika'),(2055,2,'Иглика'),(2055,3,'iglika'),(2056,1,'iglika'),(2056,2,'Иглика'),(2056,3,'iglika'),(2057,1,'ignatievo'),(2057,2,'Игнатиево'),(2057,3,'ignatievo'),(2058,1,'ignatitsa'),(2058,2,'Игнатица'),(2058,3,'ignatitsa'),(2059,1,'ignatovo'),(2059,2,'Игнатово'),(2059,3,'ignatovo'),(2060,1,'ignatovtsi'),(2060,2,'Игнатовци'),(2060,3,'ignatovtsi'),(2061,1,'ignatovtsi'),(2061,2,'Игнатовци'),(2061,3,'ignatovtsi'),(2062,1,'igralishte'),(2062,2,'Игралище'),(2062,3,'igralishte'),(2063,1,'idilevo'),(2063,2,'Идилево'),(2063,3,'idilevo'),(2064,1,'izbeglii'),(2064,2,'Избеглии'),(2064,3,'izbeglii'),(2065,1,'izbul'),(2065,2,'Избул'),(2065,3,'izbul'),(2066,1,'izvor'),(2066,2,'Извор'),(2066,3,'izvor'),(2067,1,'izvor'),(2067,2,'Извор'),(2067,3,'izvor'),(2068,1,'izvor'),(2068,2,'Извор'),(2068,3,'izvor'),(2069,1,'izvor'),(2069,2,'Извор'),(2069,3,'izvor'),(2070,1,'izvor'),(2070,2,'Извор'),(2070,3,'izvor'),(2071,1,'izvor mahala'),(2071,2,'Извор махала'),(2071,3,'izvor mahala'),(2072,1,'izvorishte'),(2072,2,'Изворище'),(2072,3,'izvorishte'),(2073,1,'izvornik'),(2073,2,'Изворник'),(2073,3,'izvornik'),(2074,1,'izvorovo'),(2074,2,'Изворово'),(2074,3,'izvorovo'),(2075,1,'izvorovo'),(2075,2,'Изворово'),(2075,3,'izvorovo'),(2076,1,'izvorovo'),(2076,2,'Изворово'),(2076,3,'izvorovo'),(2077,1,'izvorovo'),(2077,2,'Изворово'),(2077,3,'izvorovo'),(2078,1,'izvorovo'),(2078,2,'Изворово'),(2078,3,'izvorovo'),(2079,1,'izvorsko'),(2079,2,'Изворско'),(2079,3,'izvorsko'),(2080,1,'izvorche'),(2080,2,'Изворче'),(2080,3,'izvorche'),(2081,1,'izgrev'),(2081,2,'Изгрев'),(2081,3,'izgrev'),(2082,1,'izgrev'),(2082,2,'Изгрев'),(2082,3,'izgrev'),(2083,1,'izgrev'),(2083,2,'Изгрев'),(2083,3,'izgrev'),(2084,1,'izgrev'),(2084,2,'Изгрев'),(2084,3,'izgrev'),(2085,1,'izgrev'),(2085,2,'Изгрев'),(2085,3,'izgrev'),(2086,1,'izgrev'),(2086,2,'Изгрев'),(2086,3,'izgrev'),(2087,1,'izgrev'),(2087,2,'Изгрев'),(2087,3,'izgrev'),(2088,1,'izgrev'),(2088,2,'Изгрев'),(2088,3,'izgrev'),(2089,1,'iztochnik'),(2089,2,'Източник'),(2089,3,'iztochnik'),(2090,1,'ilakov rat'),(2090,2,'Илаков рът'),(2090,3,'ilakov rat'),(2091,1,'ilevtsi'),(2091,2,'Илевци'),(2091,3,'ilevtsi'),(2092,1,'iliyno'),(2092,2,'Илийно'),(2092,3,'iliyno'),(2093,1,'iliysko'),(2093,2,'Илийско'),(2093,3,'iliysko'),(2094,1,'ilinden'),(2094,2,'Илинден'),(2094,3,'ilinden'),(2095,1,'ilinden'),(2095,2,'Илинден'),(2095,3,'ilinden'),(2096,1,'ilindentsi'),(2096,2,'Илинденци'),(2096,3,'ilindentsi'),(2097,1,'ilinitsa'),(2097,2,'Илиница'),(2097,3,'ilinitsa'),(2098,1,'iliyuvtsi'),(2098,2,'Илиювци'),(2098,3,'iliyuvtsi'),(2099,1,'ilia'),(2099,2,'Илия'),(2099,3,'ilia'),(2100,1,'ilia Blaskovo'),(2100,2,'Илия Блъсково'),(2100,3,'ilia Blaskovo'),(2101,1,'imrenchevo'),(2101,2,'Имренчево'),(2101,3,'imrenchevo'),(2102,1,'indzhe voyvoda'),(2102,2,'Индже войвода'),(2102,3,'indzhe voyvoda'),(2103,1,'inovo'),(2103,2,'Иново'),(2103,3,'inovo'),(2104,1,'irechek'),(2104,2,'Иречек'),(2104,3,'irechek'),(2105,1,'irechekovo'),(2105,2,'Иречеково'),(2105,3,'irechekovo'),(2106,1,'irinetsi'),(2106,2,'Иринеци'),(2106,3,'irinetsi'),(2107,1,'irnik'),(2107,2,'Ирник'),(2107,3,'irnik'),(2108,1,'iskra'),(2108,2,'Искра'),(2108,3,'iskra'),(2109,1,'iskra'),(2109,2,'Искра'),(2109,3,'iskra'),(2110,1,'iskra'),(2110,2,'Искра'),(2110,3,'iskra'),(2111,1,'iskra'),(2111,2,'Искра'),(2111,3,'iskra'),(2112,1,'iskra'),(2112,2,'Искра'),(2112,3,'iskra'),(2113,1,'iskrets'),(2113,2,'Искрец'),(2113,3,'iskrets'),(2114,1,'iskritsa'),(2114,2,'Искрица'),(2114,3,'iskritsa'),(2115,1,'iskar'),(2115,2,'Искър'),(2115,3,'iskar'),(2116,1,'iskar'),(2116,2,'Искър'),(2116,3,'iskar'),(2117,1,'iskar'),(2117,2,'Искър'),(2117,3,'iskar'),(2118,1,'isperih'),(2118,2,'Исперих'),(2118,3,'isperih'),(2119,1,'isperihovo'),(2119,2,'Исперихово'),(2119,3,'isperihovo'),(2120,1,'isyovtsi'),(2120,2,'Исьовци'),(2120,3,'isyovtsi'),(2121,1,'ihtiman'),(2121,2,'Ихтиман'),(2121,3,'ihtiman'),(2122,1,'ichera'),(2122,2,'Ичера'),(2122,3,'ichera'),(2123,1,'Yerusalimovo'),(2123,2,'Йерусалимово'),(2123,3,'Yerusalimovo'),(2124,1,'Yoakim Gruevo'),(2124,2,'Йоаким Груево'),(2124,3,'Yoakim Gruevo'),(2125,1,'Yovkovo'),(2125,2,'Йовково'),(2125,3,'Yovkovo'),(2126,1,'Yovovtsi'),(2126,2,'Йововци'),(2126,3,'Yovovtsi'),(2127,1,'Yovchevtsi'),(2127,2,'Йовчевци'),(2127,3,'Yovchevtsi'),(2128,1,'Yoglav'),(2128,2,'Йоглав'),(2128,3,'Yoglav'),(2129,1,'Yonkovo'),(2129,2,'Йонково'),(2129,3,'Yonkovo'),(2130,1,'Yonchovo'),(2130,2,'Йончово'),(2130,3,'Yonchovo'),(2131,1,'Yordanovo'),(2131,2,'Йорданово'),(2131,3,'Yordanovo'),(2132,1,'Kokorovo'),(2132,2,'Кокорово'),(2132,3,'Kokorovo'),(2133,1,'Kabile'),(2133,2,'Кабиле'),(2133,3,'Kabile'),(2134,1,'Kableshkovo'),(2134,2,'Каблешково'),(2134,3,'Kableshkovo'),(2135,1,'Kableshkovo'),(2135,2,'Каблешково'),(2135,3,'Kableshkovo'),(2136,1,'Kableshkovo'),(2136,2,'Каблешково'),(2136,3,'Kableshkovo'),(2137,1,'Kavarna'),(2137,2,'Каварна'),(2137,3,'Kavarna'),(2138,1,'Kavlak'),(2138,2,'Кавлак'),(2138,3,'Kavlak'),(2139,1,'Kavrakirovo'),(2139,2,'Кавракирово'),(2139,3,'Kavrakirovo'),(2140,1,'Kadievo'),(2140,2,'Кадиево'),(2140,3,'Kadievo'),(2141,1,'Kadrovitsa'),(2141,2,'Кадровица'),(2141,3,'Kadrovitsa'),(2142,1,'Kazak'),(2142,2,'Казак'),(2142,3,'Kazak'),(2143,1,'Kazanka'),(2143,2,'Казанка'),(2143,3,'Kazanka'),(2144,1,'Kazanlak'),(2144,2,'Казанлък'),(2144,3,'Kazanlak'),(2145,1,'Kazatsite'),(2145,2,'Казаците'),(2145,3,'Kazatsite'),(2146,1,'Kazachevo'),(2146,2,'Казачево'),(2146,3,'Kazachevo'),(2147,1,'Kazashka reka'),(2147,2,'Казашка река'),(2147,3,'Kazashka reka'),(2148,1,'Kazashko'),(2148,2,'Казашко'),(2148,3,'Kazashko'),(2149,1,'Kazimir'),(2149,2,'Казимир'),(2149,3,'Kazimir'),(2150,1,'Kazichene'),(2150,2,'Казичене'),(2150,3,'Kazichene'),(2151,1,'Kaynardzha'),(2151,2,'Кайнарджа'),(2151,3,'Kaynardzha'),(2152,1,'Kalaydzhievo'),(2152,2,'Калайджиево'),(2152,3,'Kalaydzhievo'),(2153,1,'Kalaydzhii'),(2153,2,'Калайджии'),(2153,3,'Kalaydzhii'),(2154,1,'Kaleytsa'),(2154,2,'Калейца'),(2154,3,'Kaleytsa'),(2155,1,'Kalekovets'),(2155,2,'Калековец'),(2155,3,'Kalekovets'),(2156,1,'Kalen'),(2156,2,'Кален'),(2156,3,'Kalen'),(2157,1,'Kalenik'),(2157,2,'Каленик'),(2157,3,'Kalenik'),(2158,1,'Kalenik'),(2158,2,'Каленик'),(2158,3,'Kalenik'),(2159,1,'Kalenovtsi'),(2159,2,'Каленовци'),(2159,3,'Kalenovtsi'),(2160,1,'Kalimantsi'),(2160,2,'Калиманци'),(2160,3,'Kalimantsi'),(2161,1,'Kalimantsi'),(2161,2,'Калиманци'),(2161,3,'Kalimantsi'),(2162,1,'Kalina'),(2162,2,'Калина'),(2162,3,'Kalina'),(2163,1,'Kalina'),(2163,2,'Калина'),(2163,3,'Kalina'),(2164,1,'Kalinka'),(2164,2,'Калинка'),(2164,3,'Kalinka'),(2165,1,'Kalino'),(2165,2,'Калино'),(2165,3,'Kalino'),(2166,1,'Kalipetrovo'),(2166,2,'Калипетрово'),(2166,3,'Kalipetrovo'),(2167,1,'Kalitinovo'),(2167,2,'Калитиново'),(2167,3,'Kalitinovo'),(2168,1,'Kalishte'),(2168,2,'Калище'),(2168,3,'Kalishte'),(2169,1,'Kalnishte'),(2169,2,'Калнище'),(2169,3,'Kalnishte'),(2170,1,'Kalovo'),(2170,2,'Калово'),(2170,3,'Kalovo'),(2171,1,'Kalomen'),(2171,2,'Каломен'),(2171,3,'Kalomen'),(2172,1,'Kalotina'),(2172,2,'Калотина'),(2172,3,'Kalotina'),(2173,1,'Kalotintsi'),(2173,2,'Калотинци'),(2173,3,'Kalotintsi'),(2174,1,'Kalofer'),(2174,2,'Калофер'),(2174,3,'Kalofer'),(2175,1,'Kaloyan'),(2175,2,'Калоян'),(2175,3,'Kaloyan'),(2176,1,'Kaloyanovets'),(2176,2,'Калояновец'),(2176,3,'Kaloyanovets'),(2177,1,'Kaloyanovo'),(2177,2,'Калояново'),(2177,3,'Kaloyanovo'),(2178,1,'Kaloyanovo'),(2178,2,'Калояново'),(2178,3,'Kaloyanovo'),(2179,1,'Kaloyantsi'),(2179,2,'Калоянци'),(2179,3,'Kaloyantsi'),(2180,1,'Kalugerene'),(2180,2,'Калугерене'),(2180,3,'Kalugerene'),(2181,1,'Kalugerovo'),(2181,2,'Калугерово'),(2181,3,'Kalugerovo'),(2182,1,'Kalugerovo'),(2182,2,'Калугерово'),(2182,3,'Kalugerovo'),(2183,1,'Kalugerovo'),(2183,2,'Калугерово'),(2183,3,'Kalugerovo'),(2184,1,'Kalchevo'),(2184,2,'Калчево'),(2184,3,'Kalchevo'),(2185,1,'Kalchevska'),(2185,2,'Калчевска'),(2185,3,'Kalchevska'),(2186,1,'Kalchovtsi'),(2186,2,'Калчовци'),(2186,3,'Kalchovtsi'),(2187,1,'Kambelevtsi'),(2187,2,'Камбелевци'),(2187,3,'Kambelevtsi'),(2188,1,'Kamburovo'),(2188,2,'Камбурово'),(2188,3,'Kamburovo'),(2189,1,'Kamen'),(2189,2,'Камен'),(2189,3,'Kamen'),(2190,1,'Kamen'),(2190,2,'Камен'),(2190,3,'Kamen'),(2191,1,'Kamen'),(2191,2,'Камен'),(2191,3,'Kamen'),(2192,1,'Kamen bryag'),(2192,2,'Камен бряг'),(2192,3,'Kamen bryag'),(2193,1,'Kamen vrah'),(2193,2,'Камен връх'),(2193,3,'Kamen vrah'),(2194,1,'Kamen dyal'),(2194,2,'Камен дял'),(2194,3,'Kamen dyal'),(2195,1,'Kamena'),(2195,2,'Камена'),(2195,3,'Kamena'),(2196,1,'Kamenar'),(2196,2,'Каменар'),(2196,3,'Kamenar'),(2197,1,'Kamenar'),(2197,2,'Каменар'),(2197,3,'Kamenar'),(2198,1,'Kamenar'),(2198,2,'Каменар'),(2198,3,'Kamenar'),(2199,1,'Kamenari'),(2199,2,'Каменари'),(2199,3,'Kamenari'),(2200,1,'Kamenartsi'),(2200,2,'Каменарци'),(2200,3,'Kamenartsi'),(2201,1,'Kamenets'),(2201,2,'Каменец'),(2201,3,'Kamenets'),(2202,1,'Kamenets'),(2202,2,'Каменец'),(2202,3,'Kamenets'),(2203,1,'Kamenets'),(2203,2,'Каменец'),(2203,3,'Kamenets'),(2204,1,'Kamenik'),(2204,2,'Каменик'),(2204,3,'Kamenik'),(2205,1,'Kamenitsa'),(2205,2,'Каменица'),(2205,3,'Kamenitsa'),(2206,1,'Kamenitsa'),(2206,2,'Каменица'),(2206,3,'Kamenitsa'),(2207,1,'Kamenichka Skakavitsa'),(2207,2,'Каменичка Скакавица'),(2207,3,'Kamenichka Skakavitsa'),(2208,1,'Kamenka'),(2208,2,'Каменка'),(2208,3,'Kamenka'),(2209,1,'Kamenna reka'),(2209,2,'Каменна река'),(2209,3,'Kamenna reka'),(2210,1,'Kamenna Riksa'),(2210,2,'Каменна Рикса'),(2210,3,'Kamenna Riksa'),(2211,1,'Kameno'),(2211,2,'Камено'),(2211,3,'Kameno'),(2212,1,'Kameno pole'),(2212,2,'Камено поле'),(2212,3,'Kameno pole'),(2213,1,'Kamenovo'),(2213,2,'Каменово'),(2213,3,'Kamenovo'),(2214,1,'Kamenovo'),(2214,2,'Каменово'),(2214,3,'Kamenovo'),(2215,1,'Kamensko'),(2215,2,'Каменско'),(2215,3,'Kamensko'),(2216,1,'Kamentsi'),(2216,2,'Каменци'),(2216,3,'Kamentsi'),(2217,1,'Kamenyak'),(2217,2,'Каменяк'),(2217,3,'Kamenyak'),(2218,1,'Kamenyak'),(2218,2,'Каменяк'),(2218,3,'Kamenyak'),(2219,1,'Kamenyane'),(2219,2,'Каменяне'),(2219,3,'Kamenyane'),(2220,1,'Kameshtitsa'),(2220,2,'Камещица'),(2220,3,'Kameshtitsa'),(2221,1,'Kamilski dol'),(2221,2,'Камилски дол'),(2221,3,'Kamilski dol'),(2222,1,'Kamchia'),(2222,2,'Камчия'),(2222,3,'Kamchia'),(2223,1,'Kandilka'),(2223,2,'Кандилка'),(2223,3,'Kandilka'),(2224,1,'Kandovi'),(2224,2,'Кандови'),(2224,3,'Kandovi'),(2225,1,'Kanits'),(2225,2,'Каниц'),(2225,3,'Kanits'),(2226,1,'Kantari'),(2226,2,'Кантари'),(2226,3,'Kantari'),(2227,1,'Kanyak'),(2227,2,'Каняк'),(2227,3,'Kanyak'),(2228,1,'Kaolinovo'),(2228,2,'Каолиново'),(2228,3,'Kaolinovo'),(2229,1,'Kapatovo'),(2229,2,'Капатово'),(2229,3,'Kapatovo'),(2230,1,'Kapitan Andreevo'),(2230,2,'Капитан Андреево'),(2230,3,'Kapitan Andreevo'),(2231,1,'Kapitan Dimitrievo'),(2231,2,'Капитан Димитриево'),(2231,3,'Kapitan Dimitrievo'),(2232,1,'Kapitan Dimitrovo'),(2232,2,'Капитан Димитрово'),(2232,3,'Kapitan Dimitrovo'),(2233,1,'Kapitan Petko'),(2233,2,'Капитан Петко'),(2233,3,'Kapitan Petko'),(2234,1,'Kapitan Petko voyvoda'),(2234,2,'Капитан Петко войвода'),(2234,3,'Kapitan Petko voyvoda'),(2235,1,'Kapitanovtsi'),(2235,2,'Капитановци'),(2235,3,'Kapitanovtsi'),(2236,1,'Kapishte'),(2236,2,'Капище'),(2236,3,'Kapishte'),(2237,1,'Kara Mihal'),(2237,2,'Кара Михал'),(2237,3,'Kara Mihal'),(2238,1,'Karabunar'),(2238,2,'Карабунар'),(2238,3,'Karabunar'),(2239,1,'Karavelovo'),(2239,2,'Каравелово'),(2239,3,'Karavelovo'),(2240,1,'Karavelovo'),(2240,2,'Каравелово'),(2240,3,'Karavelovo'),(2241,1,'Karavelovo'),(2241,2,'Каравелово'),(2241,3,'Karavelovo'),(2242,1,'Karavelyovo'),(2242,2,'Каравельово'),(2242,3,'Karavelyovo'),(2243,1,'Karageorgievo'),(2243,2,'Карагеоргиево'),(2243,3,'Karageorgievo'),(2244,1,'Karadzhalovo'),(2244,2,'Караджалово'),(2244,3,'Karadzhalovo'),(2245,1,'Karadzhovo'),(2245,2,'Караджово'),(2245,3,'Karadzhovo'),(2246,1,'Karaivantsa'),(2246,2,'Караиванца'),(2246,3,'Karaivantsa'),(2247,1,'Karaivantsi'),(2247,2,'Караиванци'),(2247,3,'Karaivantsi'),(2248,1,'Karaisen'),(2248,2,'Караисен'),(2248,3,'Karaisen'),(2249,1,'Karali'),(2249,2,'Карали'),(2249,3,'Karali'),(2250,1,'Karamanite'),(2250,2,'Караманите'),(2250,3,'Karamanite'),(2251,1,'Karamanovo'),(2251,2,'Караманово'),(2251,3,'Karamanovo'),(2252,1,'Karamantsi'),(2252,2,'Караманци'),(2252,3,'Karamantsi'),(2253,1,'Karamichevtsi'),(2253,2,'Карамичевци'),(2253,3,'Karamichevtsi'),(2254,1,'Karamfil'),(2254,2,'Карамфил'),(2254,3,'Karamfil'),(2255,1,'Karan Varbovka'),(2255,2,'Каран Върбовка'),(2255,3,'Karan Varbovka'),(2256,1,'Karandili'),(2256,2,'Карандили'),(2256,3,'Karandili'),(2257,1,'Karanovo'),(2257,2,'Караново'),(2257,3,'Karanovo'),(2258,1,'Karanovo'),(2258,2,'Караново'),(2258,3,'Karanovo'),(2259,1,'Karantsi'),(2259,2,'Каранци'),(2259,3,'Karantsi'),(2260,1,'Karapelit'),(2260,2,'Карапелит'),(2260,3,'Karapelit'),(2261,1,'Karapoltsi'),(2261,2,'Караполци'),(2261,3,'Karapoltsi'),(2262,1,'Karash'),(2262,2,'Караш'),(2262,3,'Karash'),(2263,1,'Karbintsi'),(2263,2,'Карбинци'),(2263,3,'Karbintsi'),(2264,1,'Karvuna'),(2264,2,'Карвуна'),(2264,3,'Karvuna'),(2265,1,'Kardam'),(2265,2,'Кардам'),(2265,3,'Kardam'),(2266,1,'Kardam'),(2266,2,'Кардам'),(2266,3,'Kardam'),(2267,1,'Karlievo'),(2267,2,'Карлиево'),(2267,3,'Karlievo'),(2268,1,'Karlovo'),(2268,2,'Карлово'),(2268,3,'Karlovo'),(2269,1,'Karlovsko'),(2269,2,'Карловско'),(2269,3,'Karlovsko'),(2270,1,'Karlukovo'),(2270,2,'Карлуково'),(2270,3,'Karlukovo'),(2271,1,'Karnobat'),(2271,2,'Карнобат'),(2271,3,'Karnobat'),(2272,1,'Kasapsko'),(2272,2,'Касапско'),(2272,3,'Kasapsko'),(2273,1,'Kasilag'),(2273,2,'Касилаг'),(2273,3,'Kasilag'),(2274,1,'Kasnakovo'),(2274,2,'Каснаково'),(2274,3,'Kasnakovo'),(2275,1,'Kaspichan'),(2275,2,'Каспичан'),(2275,3,'Kaspichan'),(2276,1,'Kaspichan'),(2276,2,'Каспичан'),(2276,3,'Kaspichan'),(2277,1,'Kastel'),(2277,2,'Кастел'),(2277,3,'Kastel'),(2278,1,'Kateritsa'),(2278,2,'Катерица'),(2278,3,'Kateritsa'),(2279,1,'Katrandzhii'),(2279,2,'Катранджии'),(2279,3,'Katrandzhii'),(2280,1,'Katranitsa'),(2280,2,'Катраница'),(2280,3,'Katranitsa'),(2281,1,'Katrishte'),(2281,2,'Катрище'),(2281,3,'Katrishte'),(2282,1,'Katunets'),(2282,2,'Катунец'),(2282,3,'Katunets'),(2283,1,'Katunitsa'),(2283,2,'Катуница'),(2283,3,'Katunitsa'),(2284,1,'Katunishte'),(2284,2,'Катунище'),(2284,3,'Katunishte'),(2285,1,'Katuntsi'),(2285,2,'Катунци'),(2285,3,'Katuntsi'),(2286,1,'Katselovo'),(2286,2,'Кацелово'),(2286,3,'Katselovo'),(2287,1,'Kachulka'),(2287,2,'Качулка'),(2287,3,'Kachulka'),(2288,1,'Kashentsi'),(2288,2,'Кашенци'),(2288,3,'Kashentsi'),(2289,1,'Kashina'),(2289,2,'Кашина'),(2289,3,'Kashina'),(2290,1,'Kayaloba'),(2290,2,'Каялоба'),(2290,3,'Kayaloba'),(2291,1,'Kereka'),(2291,2,'Керека'),(2291,3,'Kereka'),(2292,1,'Kerenite'),(2292,2,'Керените'),(2292,3,'Kerenite'),(2293,1,'Kermen'),(2293,2,'Кермен'),(2293,3,'Kermen'),(2294,1,'Kesarevo'),(2294,2,'Кесарево'),(2294,3,'Kesarevo'),(2295,1,'Kesten'),(2295,2,'Кестен'),(2295,3,'Kesten'),(2296,1,'Kestenovo'),(2296,2,'Кестеново'),(2296,3,'Kestenovo'),(2297,1,'Kievtsi'),(2297,2,'Киевци'),(2297,3,'Kievtsi'),(2298,1,'Kilifarevo'),(2298,2,'Килифарево'),(2298,3,'Kilifarevo'),(2299,1,'Kipilovo'),(2299,2,'Кипилово'),(2299,3,'Kipilovo'),(2300,1,'Kipra'),(2300,2,'Кипра'),(2300,3,'Kipra'),(2301,1,'Kirevtsi'),(2301,2,'Киревци'),(2301,3,'Kirevtsi'),(2302,1,'Kireevo'),(2302,2,'Киреево'),(2302,3,'Kireevo'),(2303,1,'Kirilovo'),(2303,2,'Кирилово'),(2303,3,'Kirilovo'),(2304,1,'Kirilovo'),(2304,2,'Кирилово'),(2304,3,'Kirilovo'),(2305,1,'Kirkova mahala'),(2305,2,'Киркова махала'),(2305,3,'Kirkova mahala'),(2306,1,'Kirkovo'),(2306,2,'Кирково'),(2306,3,'Kirkovo'),(2307,1,'Kirovo'),(2307,2,'Кирово'),(2307,3,'Kirovo'),(2308,1,'Kirchevo'),(2308,2,'Кирчево'),(2308,3,'Kirchevo'),(2309,1,'Kiselevo'),(2309,2,'Киселево'),(2309,3,'Kiselevo'),(2310,1,'Kiselitsa'),(2310,2,'Киселица'),(2310,3,'Kiselitsa'),(2311,1,'Kiselkovtsi'),(2311,2,'Киселковци'),(2311,3,'Kiselkovtsi'),(2312,1,'Kiselchovo'),(2312,2,'Киселчово'),(2312,3,'Kiselchovo'),(2313,1,'Kisiytsite'),(2313,2,'Кисийците'),(2313,3,'Kisiytsite'),(2314,1,'Kisyovtsi'),(2314,2,'Кисьовци'),(2314,3,'Kisyovtsi'),(2315,1,'Kitanchevo'),(2315,2,'Китанчево'),(2315,3,'Kitanchevo'),(2316,1,'Kiten'),(2316,2,'Китен'),(2316,3,'Kiten'),(2317,1,'Kiten'),(2317,2,'Китен'),(2317,3,'Kiten'),(2318,1,'Kitino'),(2318,2,'Китино'),(2318,3,'Kitino'),(2319,1,'Kitka'),(2319,2,'Китка'),(2319,3,'Kitka'),(2320,1,'Kitka'),(2320,2,'Китка'),(2320,3,'Kitka'),(2321,1,'Kitna'),(2321,2,'Китна'),(2321,3,'Kitna'),(2322,1,'Kitnitsa'),(2322,2,'Китница'),(2322,3,'Kitnitsa'),(2323,1,'Kichevo'),(2323,2,'Кичево'),(2323,3,'Kichevo'),(2324,1,'Kichenitsa'),(2324,2,'Киченица'),(2324,3,'Kichenitsa'),(2325,1,'Kladenets'),(2325,2,'Кладенец'),(2325,3,'Kladenets'),(2326,1,'Kladenets'),(2326,2,'Кладенец'),(2326,3,'Kladenets'),(2327,1,'Kladentsi'),(2327,2,'Кладенци'),(2327,3,'Kladentsi'),(2328,1,'Kladentsi'),(2328,2,'Кладенци'),(2328,3,'Kladentsi'),(2329,1,'Kladni dyal'),(2329,2,'Кладни дял'),(2329,3,'Kladni dyal'),(2330,1,'Kladnitsa'),(2330,2,'Кладница'),(2330,3,'Kladnitsa'),(2331,1,'Kladorub'),(2331,2,'Кладоруб'),(2331,3,'Kladorub'),(2332,1,'Klenovik'),(2332,2,'Кленовик'),(2332,3,'Klenovik'),(2333,1,'Klepalo'),(2333,2,'Клепало'),(2333,3,'Klepalo'),(2334,1,'Klikach'),(2334,2,'Кликач'),(2334,3,'Klikach'),(2335,1,'Klimash'),(2335,2,'Климаш'),(2335,3,'Klimash'),(2336,1,'Kliment'),(2336,2,'Климент'),(2336,3,'Kliment'),(2337,1,'Kliment'),(2337,2,'Климент'),(2337,3,'Kliment'),(2338,1,'Klimentovo'),(2338,2,'Климентово'),(2338,3,'Klimentovo'),(2339,1,'Klimentovo'),(2339,2,'Климентово'),(2339,3,'Klimentovo'),(2340,1,'Klisura'),(2340,2,'Клисура'),(2340,3,'Klisura'),(2341,1,'Klisura'),(2341,2,'Клисура'),(2341,3,'Klisura'),(2342,1,'Klisura'),(2342,2,'Клисура'),(2342,3,'Klisura'),(2343,1,'Klisura'),(2343,2,'Клисура'),(2343,3,'Klisura'),(2344,1,'Klisuritsa'),(2344,2,'Клисурица'),(2344,3,'Klisuritsa'),(2345,1,'Klisurski manastir'),(2345,2,'Клисурски манастир'),(2345,3,'Klisurski manastir'),(2346,1,'Klokotnitsa'),(2346,2,'Клокотница'),(2346,3,'Klokotnitsa'),(2347,1,'Klashka reka'),(2347,2,'Клъшка река'),(2347,3,'Klashka reka'),(2348,1,'Klyuch'),(2348,2,'Ключ'),(2348,3,'Klyuch'),(2349,1,'Kmetovtsi'),(2349,2,'Кметовци'),(2349,3,'Kmetovtsi'),(2350,1,'Kmetcheta'),(2350,2,'Кметчета'),(2350,3,'Kmetcheta'),(2351,1,'Knezha'),(2351,2,'Кнежа'),(2351,3,'Knezha'),(2352,1,'Knizhovnik'),(2352,2,'Книжовник'),(2352,3,'Knizhovnik'),(2353,1,'Knyazheva mahala'),(2353,2,'Княжева махала'),(2353,3,'Knyazheva mahala'),(2354,1,'Knyazhevo'),(2354,2,'Княжево'),(2354,3,'Knyazhevo'),(2355,1,'Knyazhevsko'),(2355,2,'Княжевско'),(2355,3,'Knyazhevsko'),(2356,1,'Kobilino'),(2356,2,'Кобилино'),(2356,3,'Kobilino'),(2357,1,'Kobilyak'),(2357,2,'Кобиляк'),(2357,3,'Kobilyak'),(2358,1,'Kobilyane'),(2358,2,'Кобиляне'),(2358,3,'Kobilyane'),(2359,1,'Kovach'),(2359,2,'Ковач'),(2359,3,'Kovach'),(2360,1,'Kovachevets'),(2360,2,'Ковачевец'),(2360,3,'Kovachevets'),(2361,1,'Kovachevitsa'),(2361,2,'Ковачевица'),(2361,3,'Kovachevitsa'),(2362,1,'Kovachevo'),(2362,2,'Ковачево'),(2362,3,'Kovachevo'),(2363,1,'Kovachevo'),(2363,2,'Ковачево'),(2363,3,'Kovachevo'),(2364,1,'Kovachevo'),(2364,2,'Ковачево'),(2364,3,'Kovachevo'),(2365,1,'Kovachevtsi'),(2365,2,'Ковачевци'),(2365,3,'Kovachevtsi'),(2366,1,'Kovachevtsi'),(2366,2,'Ковачевци'),(2366,3,'Kovachevtsi'),(2367,1,'Kovachite'),(2367,2,'Ковачите'),(2367,3,'Kovachite'),(2368,1,'Kovachitsa'),(2368,2,'Ковачица'),(2368,3,'Kovachitsa'),(2369,1,'Kovil'),(2369,2,'Ковил'),(2369,3,'Kovil'),(2370,1,'Koevtsi'),(2370,2,'Коевци'),(2370,3,'Koevtsi'),(2371,1,'Koevtsi'),(2371,2,'Коевци'),(2371,3,'Koevtsi'),(2372,1,'Kozhari'),(2372,2,'Кожари'),(2372,3,'Kozhari'),(2373,1,'Kozhintsi'),(2373,2,'Кожинци'),(2373,3,'Kozhintsi'),(2374,1,'Kozhlyuvtsi'),(2374,2,'Кожлювци'),(2374,3,'Kozhlyuvtsi'),(2375,1,'Kozhuhartsi'),(2375,2,'Кожухарци'),(2375,3,'Kozhuhartsi'),(2376,1,'Kozanovo'),(2376,2,'Козаново'),(2376,3,'Kozanovo'),(2377,1,'Kozar Belene'),(2377,2,'Козар Белене'),(2377,3,'Kozar Belene'),(2378,1,'Kozare'),(2378,2,'Козаре'),(2378,3,'Kozare'),(2379,1,'Kozarevets'),(2379,2,'Козаревец'),(2379,3,'Kozarevets'),(2380,1,'Kozarevets'),(2380,2,'Козаревец'),(2380,3,'Kozarevets'),(2381,1,'Kozarevo'),(2381,2,'Козарево'),(2381,3,'Kozarevo'),(2382,1,'Kozarka'),(2382,2,'Козарка'),(2382,3,'Kozarka'),(2383,1,'Kozarsko'),(2383,2,'Козарско'),(2383,3,'Kozarsko'),(2384,1,'Kozi rog'),(2384,2,'Кози рог'),(2384,3,'Kozi rog'),(2385,1,'Kozitsa'),(2385,2,'Козица'),(2385,3,'Kozitsa'),(2386,1,'Kozitsa'),(2386,2,'Козица'),(2386,3,'Kozitsa'),(2387,1,'Kozichino'),(2387,2,'Козичино'),(2387,3,'Kozichino'),(2388,1,'Kozlevo'),(2388,2,'Козлево'),(2388,3,'Kozlevo'),(2389,1,'Kozlets'),(2389,2,'Козлец'),(2389,3,'Kozlets'),(2390,1,'Kozlovets'),(2390,2,'Козловец'),(2390,3,'Kozlovets'),(2391,1,'Kozloduy'),(2391,2,'Козлодуй'),(2391,3,'Kozloduy'),(2392,1,'Kozloduytsi'),(2392,2,'Козлодуйци'),(2392,3,'Kozloduytsi'),(2393,1,'Kozma prezviter'),(2393,2,'Козма презвитер'),(2393,3,'Kozma prezviter'),(2394,1,'Koznitsa'),(2394,2,'Козница'),(2394,3,'Koznitsa'),(2395,1,'Kozya reka'),(2395,2,'Козя река'),(2395,3,'Kozya reka'),(2396,1,'Kozyak'),(2396,2,'Козяк'),(2396,3,'Kozyak'),(2397,1,'Koilovtsi'),(2397,2,'Коиловци'),(2397,3,'Koilovtsi'),(2398,1,'Koynare'),(2398,2,'Койнаре'),(2398,3,'Koynare'),(2399,1,'Koychovtsi'),(2399,2,'Койчовци'),(2399,3,'Koychovtsi'),(2400,1,'Kokalyane'),(2400,2,'Кокаляне'),(2400,3,'Kokalyane'),(2401,1,'Kokiche'),(2401,2,'Кокиче'),(2401,3,'Kokiche'),(2402,1,'Kokortsi'),(2402,2,'Кокорци'),(2402,3,'Kokortsi'),(2403,1,'Kokoshane'),(2403,2,'Кокошане'),(2403,3,'Kokoshane'),(2404,1,'Kolari'),(2404,2,'Колари'),(2404,3,'Kolari'),(2405,1,'Kolarovo'),(2405,2,'Коларово'),(2405,3,'Kolarovo'),(2406,1,'Kolarovo'),(2406,2,'Коларово'),(2406,3,'Kolarovo'),(2407,1,'Kolarovo'),(2407,2,'Коларово'),(2407,3,'Kolarovo'),(2408,1,'Kolarovo'),(2408,2,'Коларово'),(2408,3,'Kolarovo'),(2409,1,'Kolartsi'),(2409,2,'Коларци'),(2409,3,'Kolartsi'),(2410,1,'Kolena'),(2410,2,'Колена'),(2410,3,'Kolena'),(2411,1,'Kolets'),(2411,2,'Колец'),(2411,3,'Kolets'),(2412,1,'Kolibite'),(2412,2,'Колибите'),(2412,3,'Kolibite'),(2413,1,'Kolishovtsi'),(2413,2,'Колишовци'),(2413,3,'Kolishovtsi'),(2414,1,'Kolobar'),(2414,2,'Колобър'),(2414,3,'Kolobar'),(2415,1,'Kolyu Ganev'),(2415,2,'Колю Ганев'),(2415,3,'Kolyu Ganev'),(2416,1,'Kolyu Marinovo'),(2416,2,'Колю Мариново'),(2416,3,'Kolyu Marinovo'),(2417,1,'Komarevo'),(2417,2,'Комарево'),(2417,3,'Komarevo'),(2418,1,'Komarevo'),(2418,2,'Комарево'),(2418,3,'Komarevo'),(2419,1,'Komarevo'),(2419,2,'Комарево'),(2419,3,'Komarevo'),(2420,1,'Komarevo'),(2420,2,'Комарево'),(2420,3,'Komarevo'),(2421,1,'Komoshtitsa'),(2421,2,'Комощица'),(2421,3,'Komoshtitsa'),(2422,1,'Komunari'),(2422,2,'Комунари'),(2422,3,'Komunari'),(2423,1,'Komuniga'),(2423,2,'Комунига'),(2423,3,'Komuniga'),(2424,1,'Komshtitsa'),(2424,2,'Комщица'),(2424,3,'Komshtitsa'),(2425,1,'Konak'),(2425,2,'Конак'),(2425,3,'Konak'),(2426,1,'Konare'),(2426,2,'Конаре'),(2426,3,'Konare'),(2427,1,'Konare'),(2427,2,'Конаре'),(2427,3,'Konare'),(2428,1,'Konarsko'),(2428,2,'Конарско'),(2428,3,'Konarsko'),(2429,1,'Konarskoto'),(2429,2,'Конарското'),(2429,3,'Konarskoto'),(2430,1,'Kondovo'),(2430,2,'Кондово'),(2430,3,'Kondovo'),(2431,1,'Kondolovo'),(2431,2,'Кондолово'),(2431,3,'Kondolovo'),(2432,1,'Kondofrey'),(2432,2,'Кондофрей'),(2432,3,'Kondofrey'),(2433,1,'Konevets'),(2433,2,'Коневец'),(2433,3,'Konevets'),(2434,1,'Konevo'),(2434,2,'Конево'),(2434,3,'Konevo'),(2435,1,'Konevo'),(2435,2,'Конево'),(2435,3,'Konevo'),(2436,1,'Konevo'),(2436,2,'Конево'),(2436,3,'Konevo'),(2437,1,'Konnitsi'),(2437,2,'Конници'),(2437,3,'Konnitsi'),(2438,1,'Konop'),(2438,2,'Коноп'),(2438,3,'Konop'),(2439,1,'Konska'),(2439,2,'Конска'),(2439,3,'Konska'),(2440,1,'Konstantin'),(2440,2,'Константин'),(2440,3,'Konstantin'),(2441,1,'Konstantinovets'),(2441,2,'Константиновец'),(2441,3,'Konstantinovets'),(2442,1,'Konstantinovo'),(2442,2,'Константиново'),(2442,3,'Konstantinovo'),(2443,1,'Konstantinovo'),(2443,2,'Константиново'),(2443,3,'Konstantinovo'),(2444,1,'Konstantinovo'),(2444,2,'Константиново'),(2444,3,'Konstantinovo'),(2445,1,'Kontil'),(2445,2,'Контил'),(2445,3,'Kontil'),(2446,1,'Konush'),(2446,2,'Конуш'),(2446,3,'Konush'),(2447,1,'Konush'),(2447,2,'Конуш'),(2447,3,'Konush'),(2448,1,'Konche'),(2448,2,'Конче'),(2448,3,'Konche'),(2449,1,'Konyovets'),(2449,2,'Коньовец'),(2449,3,'Konyovets'),(2450,1,'Konyovo'),(2450,2,'Коньово'),(2450,3,'Konyovo'),(2451,1,'Konyavo'),(2451,2,'Коняво'),(2451,3,'Konyavo'),(2452,1,'Kopanitsa'),(2452,2,'Копаница'),(2452,3,'Kopanitsa'),(2453,1,'Kopilovtsi'),(2453,2,'Копиловци'),(2453,3,'Kopilovtsi'),(2454,1,'Kopilovtsi'),(2454,2,'Копиловци'),(2454,3,'Kopilovtsi'),(2455,1,'Kopitnik'),(2455,2,'Копитник'),(2455,3,'Kopitnik'),(2456,1,'Koprets'),(2456,2,'Копрец'),(2456,3,'Koprets'),(2457,1,'Kopriva'),(2457,2,'Коприва'),(2457,3,'Kopriva'),(2458,1,'Koprivets'),(2458,2,'Копривец'),(2458,3,'Koprivets'),(2459,1,'Koprivlen'),(2459,2,'Копривлен'),(2459,3,'Koprivlen'),(2460,1,'Koprivshtitsa'),(2460,2,'Копривщица'),(2460,3,'Koprivshtitsa'),(2461,1,'Koprinka'),(2461,2,'Копринка'),(2461,3,'Koprinka'),(2462,1,'Kopcheliite'),(2462,2,'Копчелиите'),(2462,3,'Kopcheliite'),(2463,1,'Koren'),(2463,2,'Корен'),(2463,3,'Koren'),(2464,1,'Koriite'),(2464,2,'Кориите'),(2464,3,'Koriite'),(2465,1,'Koritata'),(2465,2,'Коритата'),(2465,3,'Koritata'),(2466,1,'Koriten'),(2466,2,'Коритен'),(2466,3,'Koriten'),(2467,1,'Koriata'),(2467,2,'Корията'),(2467,3,'Koriata'),(2468,1,'Korkina'),(2468,2,'Коркина'),(2468,3,'Korkina'),(2469,1,'Kormyansko'),(2469,2,'Кормянско'),(2469,3,'Kormyansko'),(2470,1,'Kornitsa'),(2470,2,'Корница'),(2470,3,'Kornitsa'),(2471,1,'Korten'),(2471,2,'Кортен'),(2471,3,'Korten'),(2472,1,'Kos'),(2472,2,'Кос'),(2472,3,'Kos'),(2473,1,'Kosara'),(2473,2,'Косара'),(2473,3,'Kosara'),(2474,1,'Kosarka'),(2474,2,'Косарка'),(2474,3,'Kosarka'),(2475,1,'Kosacha'),(2475,2,'Косача'),(2475,3,'Kosacha'),(2476,1,'Kosevtsi'),(2476,2,'Косевци'),(2476,3,'Kosevtsi'),(2477,1,'Kosilka'),(2477,2,'Косилка'),(2477,3,'Kosilka'),(2478,1,'Kosovets'),(2478,2,'Косовец'),(2478,3,'Kosovets'),(2479,1,'Kosovo'),(2479,2,'Косово'),(2479,3,'Kosovo'),(2480,1,'Kosovo'),(2480,2,'Косово'),(2480,3,'Kosovo'),(2481,1,'Kosovo'),(2481,2,'Косово'),(2481,3,'Kosovo'),(2482,1,'Kosovo'),(2482,2,'Косово'),(2482,3,'Kosovo'),(2483,1,'Kosta Perchevo'),(2483,2,'Коста Перчево'),(2483,3,'Kosta Perchevo'),(2484,1,'Kostadinite'),(2484,2,'Костадините'),(2484,3,'Kostadinite'),(2485,1,'Kostadinkino'),(2485,2,'Костадинкино'),(2485,3,'Kostadinkino'),(2486,1,'Kostandenets'),(2486,2,'Костанденец'),(2486,3,'Kostandenets'),(2487,1,'Kostandovo'),(2487,2,'Костандово'),(2487,3,'Kostandovo'),(2488,1,'Kostel'),(2488,2,'Костел'),(2488,3,'Kostel'),(2489,1,'Kostelevo'),(2489,2,'Костелево'),(2489,3,'Kostelevo'),(2490,1,'Kosten'),(2490,2,'Костен'),(2490,3,'Kosten'),(2491,1,'Kostena reka'),(2491,2,'Костена река'),(2491,3,'Kostena reka'),(2492,1,'Kostenets'),(2492,2,'Костенец'),(2492,3,'Kostenets'),(2493,1,'Kostenets'),(2493,2,'Костенец'),(2493,3,'Kostenets'),(2494,1,'Kostenkovtsi'),(2494,2,'Костенковци'),(2494,3,'Kostenkovtsi'),(2495,1,'Kostentsi'),(2495,2,'Костенци'),(2495,3,'Kostentsi'),(2496,1,'Kosti'),(2496,2,'Кости'),(2496,3,'Kosti'),(2497,1,'Kostievo'),(2497,2,'Костиево'),(2497,3,'Kostievo'),(2498,1,'Kostilkovo'),(2498,2,'Костилково'),(2498,3,'Kostilkovo'),(2499,1,'Kostinbrod'),(2499,2,'Костинброд'),(2499,3,'Kostinbrod'),(2500,1,'Kostino'),(2500,2,'Костино'),(2500,3,'Kostino'),(2501,1,'Kostichovtsi'),(2501,2,'Костичовци'),(2501,3,'Kostichovtsi'),(2502,1,'Kostur'),(2502,2,'Костур'),(2502,3,'Kostur'),(2503,1,'Kosturino'),(2503,2,'Костурино'),(2503,3,'Kosturino'),(2504,1,'Kosturintsi'),(2504,2,'Костуринци'),(2504,3,'Kosturintsi'),(2505,1,'Kotel'),(2505,2,'Котел'),(2505,3,'Kotel'),(2506,1,'Kotenovtsi'),(2506,2,'Котеновци'),(2506,3,'Kotenovtsi'),(2507,1,'Kotlari'),(2507,2,'Котлари'),(2507,3,'Kotlari'),(2508,1,'Kotlentsi'),(2508,2,'Котленци'),(2508,3,'Kotlentsi'),(2509,1,'Kotutsi'),(2509,2,'Котуци'),(2509,3,'Kotutsi'),(2510,1,'Kochan'),(2510,2,'Кочан'),(2510,3,'Kochan'),(2511,1,'Kochani'),(2511,2,'Кочани'),(2511,3,'Kochani'),(2512,1,'Kochevo'),(2512,2,'Кочево'),(2512,3,'Kochevo'),(2513,1,'Kocherinovo'),(2513,2,'Кочериново'),(2513,3,'Kocherinovo'),(2514,1,'Kochmar'),(2514,2,'Кочмар'),(2514,3,'Kochmar'),(2515,1,'Kochovo'),(2515,2,'Кочово'),(2515,3,'Kochovo'),(2516,1,'Koshava'),(2516,2,'Кошава'),(2516,3,'Koshava'),(2517,1,'Kosharevo'),(2517,2,'Кошарево'),(2517,3,'Kosharevo'),(2518,1,'Kosharite'),(2518,2,'Кошарите'),(2518,3,'Kosharite'),(2519,1,'Kosharitsa'),(2519,2,'Кошарица'),(2519,3,'Kosharitsa'),(2520,1,'Kosharna'),(2520,2,'Кошарна'),(2520,3,'Kosharna'),(2521,1,'Koshnitsa'),(2521,2,'Кошница'),(2521,3,'Koshnitsa'),(2522,1,'Koshnichari'),(2522,2,'Кошничари'),(2522,3,'Koshnichari'),(2523,1,'Koshov'),(2523,2,'Кошов'),(2523,3,'Koshov'),(2524,1,'Kravino'),(2524,2,'Кравино'),(2524,3,'Kravino'),(2525,1,'Kravoder'),(2525,2,'Краводер'),(2525,3,'Kravoder'),(2526,1,'Kragulevo'),(2526,2,'Крагулево'),(2526,3,'Kragulevo'),(2527,1,'Kraevo'),(2527,2,'Краево'),(2527,3,'Kraevo'),(2528,1,'Kraishte'),(2528,2,'Краище'),(2528,3,'Kraishte'),(2529,1,'Kraishte'),(2529,2,'Краище'),(2529,3,'Kraishte'),(2530,1,'Kraygortsi'),(2530,2,'Крайгорци'),(2530,3,'Kraygortsi'),(2531,1,'Krayna'),(2531,2,'Крайна'),(2531,3,'Krayna'),(2532,1,'Krayna'),(2532,2,'Крайна'),(2532,3,'Krayna'),(2533,1,'Krayni dol'),(2533,2,'Крайни дол'),(2533,3,'Krayni dol'),(2534,1,'Kraynitsi'),(2534,2,'Крайници'),(2534,3,'Kraynitsi'),(2535,1,'Krayno selo'),(2535,2,'Крайно село'),(2535,3,'Krayno selo'),(2536,1,'Kraynovo'),(2536,2,'Крайново'),(2536,3,'Kraynovo'),(2537,1,'Kraypole'),(2537,2,'Крайполе'),(2537,3,'Kraypole'),(2538,1,'Krakra'),(2538,2,'Кракра'),(2538,3,'Krakra'),(2539,1,'Kralev dol'),(2539,2,'Кралев дол'),(2539,3,'Kralev dol'),(2540,1,'Kralevo'),(2540,2,'Кралево'),(2540,3,'Kralevo'),(2541,1,'Kralevo'),(2541,2,'Кралево'),(2541,3,'Kralevo'),(2542,1,'Krali Marko'),(2542,2,'Крали Марко'),(2542,3,'Krali Marko'),(2543,1,'Kramolin'),(2543,2,'Крамолин'),(2543,3,'Kramolin'),(2544,1,'Kran'),(2544,2,'Кран'),(2544,3,'Kran'),(2545,1,'Kranevo'),(2545,2,'Кранево'),(2545,3,'Kranevo'),(2546,1,'Kranovo'),(2546,2,'Краново'),(2546,3,'Kranovo'),(2547,1,'Krapets'),(2547,2,'Крапец'),(2547,3,'Krapets'),(2548,1,'Krapets'),(2548,2,'Крапец'),(2548,3,'Krapets'),(2549,1,'Krapchene'),(2549,2,'Крапчене'),(2549,3,'Krapchene'),(2550,1,'Krasava'),(2550,2,'Красава'),(2550,3,'Krasava'),(2551,1,'Krasen'),(2551,2,'Красен'),(2551,3,'Krasen'),(2552,1,'Krasen'),(2552,2,'Красен'),(2552,3,'Krasen'),(2553,1,'Krasen dol'),(2553,2,'Красен дол'),(2553,3,'Krasen dol'),(2554,1,'Krasimir'),(2554,2,'Красимир'),(2554,3,'Krasimir'),(2555,1,'Krasino'),(2555,2,'Красино'),(2555,3,'Krasino'),(2556,1,'Krasno gradishte'),(2556,2,'Красно градище'),(2556,3,'Krasno gradishte'),(2557,1,'Krasnovo'),(2557,2,'Красново'),(2557,3,'Krasnovo'),(2558,1,'Krasnoseltsi'),(2558,2,'Красноселци'),(2558,3,'Krasnoseltsi'),(2559,1,'Krachimir'),(2559,2,'Крачимир'),(2559,3,'Krachimir'),(2560,1,'Kremen'),(2560,2,'Кремен'),(2560,3,'Kremen'),(2561,1,'Kremen'),(2561,2,'Кремен'),(2561,3,'Kremen'),(2562,1,'Kremena'),(2562,2,'Кремена'),(2562,3,'Kremena'),(2563,1,'Kremene'),(2563,2,'Кремене'),(2563,3,'Kremene'),(2564,1,'Kremenets'),(2564,2,'Кременец'),(2564,3,'Kremenets'),(2565,1,'Kremenik'),(2565,2,'Кременик'),(2565,3,'Kremenik'),(2566,1,'Krepost'),(2566,2,'Крепост'),(2566,3,'Krepost'),(2567,1,'Krepcha'),(2567,2,'Крепча'),(2567,3,'Krepcha'),(2568,1,'Kreslyuvtsi'),(2568,2,'Креслювци'),(2568,3,'Kreslyuvtsi'),(2569,1,'Kresna'),(2569,2,'Кресна'),(2569,3,'Kresna'),(2570,1,'Kreta'),(2570,2,'Крета'),(2570,3,'Kreta'),(2571,1,'Kreta'),(2571,2,'Крета'),(2571,3,'Kreta'),(2572,1,'Kribul'),(2572,2,'Крибул'),(2572,3,'Kribul'),(2573,1,'Kriva bara'),(2573,2,'Крива бара'),(2573,3,'Kriva bara'),(2574,1,'Kriva bara'),(2574,2,'Крива бара'),(2574,3,'Kriva bara'),(2575,1,'Kriva krusha'),(2575,2,'Крива круша'),(2575,3,'Kriva krusha'),(2576,1,'Kriva reka'),(2576,2,'Крива река'),(2576,3,'Kriva reka'),(2577,1,'Krivina'),(2577,2,'Кривина'),(2577,3,'Krivina'),(2578,1,'Krivina'),(2578,2,'Кривина'),(2578,3,'Krivina'),(2579,1,'Krivini'),(2579,2,'Кривини'),(2579,3,'Krivini'),(2580,1,'Krivitsa'),(2580,2,'Кривица'),(2580,3,'Krivitsa'),(2581,1,'Krivnya'),(2581,2,'Кривня'),(2581,3,'Krivnya'),(2582,1,'Krivnya'),(2582,2,'Кривня'),(2582,3,'Krivnya'),(2583,1,'Krivo pole'),(2583,2,'Криво поле'),(2583,3,'Krivo pole'),(2584,1,'Krivodol'),(2584,2,'Криводол'),(2584,3,'Krivodol'),(2585,1,'Krivonos'),(2585,2,'Кривонос'),(2585,3,'Krivonos'),(2586,1,'Krilatitsa'),(2586,2,'Крилатица'),(2586,3,'Krilatitsa'),(2587,1,'Krilyuvtsi'),(2587,2,'Крилювци'),(2587,3,'Krilyuvtsi'),(2588,1,'Krin'),(2588,2,'Крин'),(2588,3,'Krin'),(2589,1,'Krislovo'),(2589,2,'Крислово'),(2589,3,'Krislovo'),(2590,1,'Krichim'),(2590,2,'Кричим'),(2590,3,'Krichim'),(2591,1,'Kromidovo'),(2591,2,'Кромидово'),(2591,3,'Kromidovo'),(2592,1,'Kroyach'),(2592,2,'Крояч'),(2592,3,'Kroyach'),(2593,1,'Kroyachevo'),(2593,2,'Кроячево'),(2593,3,'Kroyachevo'),(2594,1,'Krum'),(2594,2,'Крум'),(2594,3,'Krum'),(2595,1,'Krumovgrad'),(2595,2,'Крумовград'),(2595,3,'Krumovgrad'),(2596,1,'Krumovo'),(2596,2,'Крумово'),(2596,3,'Krumovo'),(2597,1,'Krumovo'),(2597,2,'Крумово'),(2597,3,'Krumovo'),(2598,1,'Krumovo'),(2598,2,'Крумово'),(2598,3,'Krumovo'),(2599,1,'Krumovo'),(2599,2,'Крумово'),(2599,3,'Krumovo'),(2600,1,'Krumovo gradishte'),(2600,2,'Крумово градище'),(2600,3,'Krumovo gradishte'),(2601,1,'Krumchevtsi'),(2601,2,'Крумчевци'),(2601,3,'Krumchevtsi'),(2602,1,'Krupen'),(2602,2,'Крупен'),(2602,3,'Krupen'),(2603,1,'Krupnik'),(2603,2,'Крупник'),(2603,3,'Krupnik'),(2604,1,'Krusha'),(2604,2,'Круша'),(2604,3,'Krusha'),(2605,1,'Krusha'),(2605,2,'Круша'),(2605,3,'Krusha'),(2606,1,'Krushare'),(2606,2,'Крушаре'),(2606,3,'Krushare'),(2607,1,'Krushari'),(2607,2,'Крушари'),(2607,3,'Krushari'),(2608,1,'Krushev dol'),(2608,2,'Крушев дол'),(2608,3,'Krushev dol'),(2609,1,'Krushevets'),(2609,2,'Крушевец'),(2609,3,'Krushevets'),(2610,1,'Krushevo'),(2610,2,'Крушево'),(2610,3,'Krushevo'),(2611,1,'Krushevo'),(2611,2,'Крушево'),(2611,3,'Krushevo'),(2612,1,'Krushevo'),(2612,2,'Крушево'),(2612,3,'Krushevo'),(2613,1,'Krushevska'),(2613,2,'Крушевска'),(2613,3,'Krushevska'),(2614,1,'Krusheto'),(2614,2,'Крушето'),(2614,3,'Krusheto'),(2615,1,'Krushka'),(2615,2,'Крушка'),(2615,3,'Krushka'),(2616,1,'Krushovene'),(2616,2,'Крушовене'),(2616,3,'Krushovene'),(2617,1,'Krushovitsa'),(2617,2,'Крушовица'),(2617,3,'Krushovitsa'),(2618,1,'Krushovitsa'),(2618,2,'Крушовица'),(2618,3,'Krushovitsa'),(2619,1,'Krushovitsa'),(2619,2,'Крушовица'),(2619,3,'Krushovitsa'),(2620,1,'Krushovo'),(2620,2,'Крушово'),(2620,3,'Krushovo'),(2621,1,'Krushovo'),(2621,2,'Крушово'),(2621,3,'Krushovo'),(2622,1,'Krusholak'),(2622,2,'Крушолак'),(2622,3,'Krusholak'),(2623,1,'Krushuna'),(2623,2,'Крушуна'),(2623,3,'Krushuna'),(2624,1,'Kravenik'),(2624,2,'Кръвеник'),(2624,3,'Kravenik'),(2625,1,'Kran'),(2625,2,'Крън'),(2625,3,'Kran'),(2626,1,'Krandzhilitsa'),(2626,2,'Крънджилица'),(2626,3,'Krandzhilitsa'),(2627,1,'Krancha'),(2627,2,'Крънча'),(2627,3,'Krancha'),(2628,1,'Krastava'),(2628,2,'Кръстава'),(2628,3,'Krastava'),(2629,1,'Krastatitsa'),(2629,2,'Кръстатица'),(2629,3,'Krastatitsa'),(2630,1,'Krastevich'),(2630,2,'Кръстевич'),(2630,3,'Krastevich'),(2631,1,'Krastenyatsite'),(2631,2,'Кръстеняците'),(2631,3,'Krastenyatsite'),(2632,1,'Krastets'),(2632,2,'Кръстец'),(2632,3,'Krastets'),(2633,1,'Krastiltsi'),(2633,2,'Кръстилци'),(2633,3,'Krastiltsi'),(2634,1,'Krastina'),(2634,2,'Кръстина'),(2634,3,'Krastina'),(2635,1,'Krashno'),(2635,2,'Кръшно'),(2635,3,'Krashno'),(2636,1,'Kubadin'),(2636,2,'Кубадин'),(2636,3,'Kubadin'),(2637,1,'Kubrat'),(2637,2,'Кубрат'),(2637,3,'Kubrat'),(2638,1,'Kubratovo'),(2638,2,'Кубратово'),(2638,3,'Kubratovo'),(2639,1,'Kudelin'),(2639,2,'Куделин'),(2639,3,'Kudelin'),(2640,1,'Kuzyovo'),(2640,2,'Кузьово'),(2640,3,'Kuzyovo'),(2641,1,'Kuklen'),(2641,2,'Куклен'),(2641,3,'Kuklen'),(2642,1,'Kuklya'),(2642,2,'Кукля'),(2642,3,'Kuklya'),(2643,1,'Kukorevo'),(2643,2,'Кукорево'),(2643,3,'Kukorevo'),(2644,1,'Kukuvitsa'),(2644,2,'Кукувица'),(2644,3,'Kukuvitsa'),(2645,1,'Kukurahtsevo'),(2645,2,'Кукурахцево'),(2645,3,'Kukurahtsevo'),(2646,1,'Kukuryak'),(2646,2,'Кукуряк'),(2646,3,'Kukuryak'),(2647,1,'Kula'),(2647,2,'Кула'),(2647,3,'Kula'),(2648,1,'Kulata'),(2648,2,'Кулата'),(2648,3,'Kulata'),(2649,1,'Kulina voda'),(2649,2,'Кулина вода'),(2649,3,'Kulina voda'),(2650,1,'Kumanite'),(2650,2,'Куманите'),(2650,3,'Kumanite'),(2651,1,'Kumanovo'),(2651,2,'Куманово'),(2651,3,'Kumanovo'),(2652,1,'Kundevo'),(2652,2,'Кундево'),(2652,3,'Kundevo'),(2653,1,'Kunino'),(2653,2,'Кунино'),(2653,3,'Kunino'),(2654,1,'Kupen'),(2654,2,'Купен'),(2654,3,'Kupen'),(2655,1,'Kupen'),(2655,2,'Купен'),(2655,3,'Kupen'),(2656,1,'Kuptsite'),(2656,2,'Купците'),(2656,3,'Kuptsite'),(2657,1,'Kurnovo'),(2657,2,'Курново'),(2657,3,'Kurnovo'),(2658,1,'Kurtovo'),(2658,2,'Куртово'),(2658,3,'Kurtovo'),(2659,1,'Kurtovo Konare'),(2659,2,'Куртово Конаре'),(2659,3,'Kurtovo Konare'),(2660,1,'Kutela'),(2660,2,'Кутела'),(2660,3,'Kutela'),(2661,1,'Kutlovitsa'),(2661,2,'Кутловица'),(2661,3,'Kutlovitsa'),(2662,1,'Kutovo'),(2662,2,'Кутово'),(2662,3,'Kutovo'),(2663,1,'Kutugertsi'),(2663,2,'Кутугерци'),(2663,3,'Kutugertsi'),(2664,1,'Kutsarovtsi'),(2664,2,'Куцаровци'),(2664,3,'Kutsarovtsi'),(2665,1,'Kutsina'),(2665,2,'Куцина'),(2665,3,'Kutsina'),(2666,1,'Kutsovo'),(2666,2,'Куцово'),(2666,3,'Kutsovo'),(2667,1,'Kushla'),(2667,2,'Кушла'),(2667,3,'Kushla'),(2668,1,'Kaklitsa'),(2668,2,'Къклица'),(2668,3,'Kaklitsa'),(2669,1,'Kakrina'),(2669,2,'Къкрина'),(2669,3,'Kakrina'),(2670,1,'Kalnovo'),(2670,2,'Кълново'),(2670,3,'Kalnovo'),(2671,1,'Kanchevo'),(2671,2,'Кънчево'),(2671,3,'Kanchevo'),(2672,1,'Kapinets'),(2672,2,'Къпинец'),(2672,3,'Kapinets'),(2673,1,'Kapinovo'),(2673,2,'Къпиново'),(2673,3,'Kapinovo'),(2674,1,'Kapinovo'),(2674,2,'Къпиново'),(2674,3,'Kapinovo'),(2675,1,'Kapinovtsi'),(2675,2,'Къпиновци'),(2675,3,'Kapinovtsi'),(2676,1,'Kardzhali'),(2676,2,'Кърджали'),(2676,3,'Kardzhali'),(2677,1,'Karlanovo'),(2677,2,'Кърланово'),(2677,3,'Karlanovo'),(2678,1,'Karnalovo'),(2678,2,'Кърналово'),(2678,3,'Karnalovo'),(2679,1,'Karnare'),(2679,2,'Кърнаре'),(2679,3,'Karnare'),(2680,1,'Karpachevo'),(2680,2,'Кърпачево'),(2680,3,'Karpachevo'),(2681,1,'Karpelevo'),(2681,2,'Кърпелево'),(2681,3,'Karpelevo'),(2682,1,'Kartipanya'),(2682,2,'Къртипъня'),(2682,3,'Kartipanya'),(2683,1,'Kartozhabene'),(2683,2,'Къртожабене'),(2683,3,'Kartozhabene'),(2684,1,'Karchovsko'),(2684,2,'Кърчовско'),(2684,3,'Karchovsko'),(2685,1,'Karshalevo'),(2685,2,'Кършалево'),(2685,3,'Karshalevo'),(2686,1,'Kasak'),(2686,2,'Късак'),(2686,3,'Kasak'),(2687,1,'Katina'),(2687,2,'Кътина'),(2687,3,'Katina'),(2688,1,'Kashin'),(2688,2,'Къшин'),(2688,3,'Kashin'),(2689,1,'Kashle'),(2689,2,'Къшле'),(2689,3,'Kashle'),(2690,1,'Kyolmen'),(2690,2,'Кьолмен'),(2690,3,'Kyolmen'),(2691,1,'Kyosevo'),(2691,2,'Кьосево'),(2691,3,'Kyosevo'),(2692,1,'Kyosevtsi'),(2692,2,'Кьосевци'),(2692,3,'Kyosevtsi'),(2693,1,'Kyulevcha'),(2693,2,'Кюлевча'),(2693,3,'Kyulevcha'),(2694,1,'Kyustendil'),(2694,2,'Кюстендил'),(2694,3,'Kyustendil'),(2695,1,'Lagerite'),(2695,2,'Лагерите'),(2695,3,'Lagerite'),(2696,1,'Lagoshevtsi'),(2696,2,'Лагошевци'),(2696,3,'Lagoshevtsi'),(2697,1,'Ladarevo'),(2697,2,'Ладарево'),(2697,3,'Ladarevo'),(2698,1,'Lazarovo'),(2698,2,'Лазарово'),(2698,3,'Lazarovo'),(2699,1,'Lazartsi'),(2699,2,'Лазарци'),(2699,3,'Lazartsi'),(2700,1,'Lakarevo'),(2700,2,'Лакарево'),(2700,3,'Lakarevo'),(2701,1,'Lakatnik'),(2701,2,'Лакатник'),(2701,3,'Lakatnik'),(2702,1,'Lakatnik'),(2702,2,'Лакатник'),(2702,3,'Lakatnik'),(2703,1,'Lale'),(2703,2,'Лале'),(2703,3,'Lale'),(2704,1,'Lalkovo'),(2704,2,'Лалково'),(2704,3,'Lalkovo'),(2705,1,'Lambuh'),(2705,2,'Ламбух'),(2705,3,'Lambuh'),(2706,1,'Laskar'),(2706,2,'Ласкар'),(2706,3,'Laskar'),(2707,1,'Laskarevo'),(2707,2,'Ласкарево'),(2707,3,'Laskarevo'),(2708,1,'Latinka'),(2708,2,'Латинка'),(2708,3,'Latinka'),(2709,1,'Lebed'),(2709,2,'Лебед'),(2709,3,'Lebed'),(2710,1,'Lebnitsa'),(2710,2,'Лебница'),(2710,3,'Lebnitsa'),(2711,1,'Leva reka'),(2711,2,'Лева река'),(2711,3,'Leva reka'),(2712,1,'Levishte'),(2712,2,'Левище'),(2712,3,'Levishte'),(2713,1,'Levka'),(2713,2,'Левка'),(2713,3,'Levka'),(2714,1,'Levochevo'),(2714,2,'Левочево'),(2714,3,'Levochevo'),(2715,1,'Levski'),(2715,2,'Левски'),(2715,3,'Levski'),(2716,1,'Levski'),(2716,2,'Левски'),(2716,3,'Levski'),(2717,1,'Levski'),(2717,2,'Левски'),(2717,3,'Levski'),(2718,1,'Levunovo'),(2718,2,'Левуново'),(2718,3,'Levunovo'),(2719,1,'Levtsi'),(2719,2,'Левци'),(2719,3,'Levtsi'),(2720,1,'Ledenik'),(2720,2,'Леденик'),(2720,3,'Ledenik'),(2721,1,'Lelintsi'),(2721,2,'Лелинци'),(2721,3,'Lelintsi'),(2722,1,'Lenishte'),(2722,2,'Ленище'),(2722,3,'Lenishte'),(2723,1,'Lenkovo'),(2723,2,'Ленково'),(2723,3,'Lenkovo'),(2724,1,'Lenovo'),(2724,2,'Леново'),(2724,3,'Lenovo'),(2725,1,'Lensko'),(2725,2,'Ленско'),(2725,3,'Lensko'),(2726,1,'Lepitsa'),(2726,2,'Лепица'),(2726,3,'Lepitsa'),(2727,1,'Lesidren'),(2727,2,'Лесидрен'),(2727,3,'Lesidren'),(2728,1,'Lesicharka'),(2728,2,'Лесичарка'),(2728,3,'Lesicharka'),(2729,1,'Lesiche'),(2729,2,'Лесиче'),(2729,3,'Lesiche'),(2730,1,'Lesicheri'),(2730,2,'Лесичери'),(2730,3,'Lesicheri'),(2731,1,'Lesichovo'),(2731,2,'Лесичово'),(2731,3,'Lesichovo'),(2732,1,'Leska'),(2732,2,'Леска'),(2732,3,'Leska'),(2733,1,'Leska'),(2733,2,'Леска'),(2733,3,'Leska'),(2734,1,'Leskovdol'),(2734,2,'Лесковдол'),(2734,3,'Leskovdol'),(2735,1,'Leskovets'),(2735,2,'Лесковец'),(2735,3,'Leskovets'),(2736,1,'Leskovets'),(2736,2,'Лесковец'),(2736,3,'Leskovets'),(2737,1,'Leskovets'),(2737,2,'Лесковец'),(2737,3,'Leskovets'),(2738,1,'Lesnovo'),(2738,2,'Лесново'),(2738,3,'Lesnovo'),(2739,1,'Lesovo'),(2739,2,'Лесово'),(2739,3,'Lesovo'),(2740,1,'Lesura'),(2740,2,'Лесура'),(2740,3,'Lesura'),(2741,1,'Letnitsa'),(2741,2,'Летница'),(2741,3,'Letnitsa'),(2742,1,'Letnitsa'),(2742,2,'Летница'),(2742,3,'Letnitsa'),(2743,1,'Letovnik'),(2743,2,'Летовник'),(2743,3,'Letovnik'),(2744,1,'Lehovo'),(2744,2,'Лехово'),(2744,3,'Lehovo'),(2745,1,'Lehchevo'),(2745,2,'Лехчево'),(2745,3,'Lehchevo'),(2746,1,'Leshko'),(2746,2,'Лешко'),(2746,3,'Leshko'),(2747,1,'Leshko presoi'),(2747,2,'Лешко пресои'),(2747,3,'Leshko presoi'),(2748,1,'Leshnikovo'),(2748,2,'Лешниково'),(2748,3,'Leshnikovo'),(2749,1,'Leshnikovtsi'),(2749,2,'Лешниковци'),(2749,3,'Leshnikovtsi'),(2750,1,'Leshnitsa'),(2750,2,'Лешница'),(2750,3,'Leshnitsa'),(2751,1,'Leshnitsa'),(2751,2,'Лешница'),(2751,3,'Leshnitsa'),(2752,1,'Leshtak'),(2752,2,'Лещак'),(2752,3,'Leshtak'),(2753,1,'Leshtarka'),(2753,2,'Лещарка'),(2753,3,'Leshtarka'),(2754,1,'Leshten'),(2754,2,'Лещен'),(2754,3,'Leshten'),(2755,1,'Leyarovo'),(2755,2,'Леярово'),(2755,3,'Leyarovo'),(2756,1,'Livada'),(2756,2,'Ливада'),(2756,3,'Livada'),(2757,1,'Livade'),(2757,2,'Ливаде'),(2757,3,'Livade'),(2758,1,'Lik'),(2758,2,'Лик'),(2758,3,'Lik'),(2759,1,'Lilekovo'),(2759,2,'Лилеково'),(2759,3,'Lilekovo'),(2760,1,'Lilkovo'),(2760,2,'Лилково'),(2760,3,'Lilkovo'),(2761,1,'Lilyak'),(2761,2,'Лиляк'),(2761,3,'Lilyak'),(2762,1,'Lilyanovo'),(2762,2,'Лиляново'),(2762,3,'Lilyanovo'),(2763,1,'Lilyach'),(2763,2,'Лиляч'),(2763,3,'Lilyach'),(2764,1,'Lilyache'),(2764,2,'Лиляче'),(2764,3,'Lilyache'),(2765,1,'Limets'),(2765,2,'Лимец'),(2765,3,'Limets'),(2766,1,'Lipen'),(2766,2,'Липен'),(2766,3,'Lipen'),(2767,1,'Lipets'),(2767,2,'Липец'),(2767,3,'Lipets'),(2768,1,'Lipintsi'),(2768,2,'Липинци'),(2768,3,'Lipintsi'),(2769,1,'Lipnik'),(2769,2,'Липник'),(2769,3,'Lipnik'),(2770,1,'Lipnitsa'),(2770,2,'Липница'),(2770,3,'Lipnitsa'),(2771,1,'Lipnitsa'),(2771,2,'Липница'),(2771,3,'Lipnitsa'),(2772,1,'Lisets'),(2772,2,'Лисец'),(2772,3,'Lisets'),(2773,1,'Lisets'),(2773,2,'Лисец'),(2773,3,'Lisets'),(2774,1,'Lisets'),(2774,2,'Лисец'),(2774,3,'Lisets'),(2775,1,'Lisi vrah'),(2775,2,'Лиси връх'),(2775,3,'Lisi vrah'),(2776,1,'Lisitsite'),(2776,2,'Лисиците'),(2776,3,'Lisitsite'),(2777,1,'Lisia'),(2777,2,'Лисия'),(2777,3,'Lisia'),(2778,1,'Lisovo'),(2778,2,'Лисово'),(2778,3,'Lisovo'),(2779,1,'Listets'),(2779,2,'Листец'),(2779,3,'Listets'),(2780,1,'Listets'),(2780,2,'Листец'),(2780,3,'Listets'),(2781,1,'Litakovo'),(2781,2,'Литаково'),(2781,3,'Litakovo'),(2782,1,'Lobosh'),(2782,2,'Лобош'),(2782,3,'Lobosh'),(2783,1,'Lovets'),(2783,2,'Ловец'),(2783,3,'Lovets'),(2784,1,'Lovets'),(2784,2,'Ловец'),(2784,3,'Lovets'),(2785,1,'Lovets'),(2785,2,'Ловец'),(2785,3,'Lovets'),(2786,1,'Lovech'),(2786,2,'Ловеч'),(2786,3,'Lovech'),(2787,1,'Lovnidol'),(2787,2,'Ловнидол'),(2787,3,'Lovnidol'),(2788,1,'Lovsko'),(2788,2,'Ловско'),(2788,3,'Lovsko'),(2789,1,'Lovtsi'),(2789,2,'Ловци'),(2789,3,'Lovtsi'),(2790,1,'Lovchantsi'),(2790,2,'Ловчанци'),(2790,3,'Lovchantsi'),(2791,1,'Logodazh'),(2791,2,'Логодаж'),(2791,3,'Logodazh'),(2792,1,'Loza'),(2792,2,'Лоза'),(2792,3,'Loza'),(2793,1,'Lozarevo'),(2793,2,'Лозарево'),(2793,3,'Lozarevo'),(2794,1,'Lozevo'),(2794,2,'Лозево'),(2794,3,'Lozevo'),(2795,1,'Lozen'),(2795,2,'Лозен'),(2795,3,'Lozen'),(2796,1,'Lozen'),(2796,2,'Лозен'),(2796,3,'Lozen'),(2797,1,'Lozen'),(2797,2,'Лозен'),(2797,3,'Lozen'),(2798,1,'Lozen'),(2798,2,'Лозен'),(2798,3,'Lozen'),(2799,1,'Lozen'),(2799,2,'Лозен'),(2799,3,'Lozen'),(2800,1,'Lozengradtsi'),(2800,2,'Лозенградци'),(2800,3,'Lozengradtsi'),(2801,1,'Lozenets'),(2801,2,'Лозенец'),(2801,3,'Lozenets'),(2802,1,'Lozenets'),(2802,2,'Лозенец'),(2802,3,'Lozenets'),(2803,1,'Lozenets'),(2803,2,'Лозенец'),(2803,3,'Lozenets'),(2804,1,'Lozenitsa'),(2804,2,'Лозеница'),(2804,3,'Lozenitsa'),(2805,1,'Lozitsa'),(2805,2,'Лозица'),(2805,3,'Lozitsa'),(2806,1,'Lozitsa'),(2806,2,'Лозица'),(2806,3,'Lozitsa'),(2807,1,'Loznitsa'),(2807,2,'Лозница'),(2807,3,'Loznitsa'),(2808,1,'Loznitsa'),(2808,2,'Лозница'),(2808,3,'Loznitsa'),(2809,1,'Lozno'),(2809,2,'Лозно'),(2809,3,'Lozno'),(2810,1,'Lokvata'),(2810,2,'Локвата'),(2810,3,'Lokvata'),(2811,1,'Lokorsko'),(2811,2,'Локорско'),(2811,3,'Lokorsko'),(2812,1,'Lom'),(2812,2,'Лом'),(2812,3,'Lom'),(2813,1,'Lom Cherkovna'),(2813,2,'Лом Черковна'),(2813,3,'Lom Cherkovna'),(2814,1,'Lomets'),(2814,2,'Ломец'),(2814,3,'Lomets'),(2815,1,'Lomnitsa'),(2815,2,'Ломница'),(2815,3,'Lomnitsa'),(2816,1,'Lomnitsa'),(2816,2,'Ломница'),(2816,3,'Lomnitsa'),(2817,1,'Lomnitsa'),(2817,2,'Ломница'),(2817,3,'Lomnitsa'),(2818,1,'Lomtsi'),(2818,2,'Ломци'),(2818,3,'Lomtsi'),(2819,1,'Lopushna'),(2819,2,'Лопушна'),(2819,3,'Lopushna'),(2820,1,'Lopushnya'),(2820,2,'Лопушня'),(2820,3,'Lopushnya'),(2821,1,'Lopyan'),(2821,2,'Лопян'),(2821,3,'Lopyan'),(2822,1,'Ludogortsi'),(2822,2,'Лудогорци'),(2822,3,'Ludogortsi'),(2823,1,'Lukovit'),(2823,2,'Луковит'),(2823,3,'Lukovit'),(2824,1,'Lukovo'),(2824,2,'Луково'),(2824,3,'Lukovo'),(2825,1,'Lulichka'),(2825,2,'Луличка'),(2825,3,'Lulichka'),(2826,1,'Lavino'),(2826,2,'Лъвино'),(2826,3,'Lavino'),(2827,1,'Lavovo'),(2827,2,'Лъвово'),(2827,3,'Lavovo'),(2828,1,'Laga'),(2828,2,'Лъга'),(2828,3,'Laga'),(2829,1,'Lazhnitsa'),(2829,2,'Лъжница'),(2829,3,'Lazhnitsa'),(2830,1,'Laka'),(2830,2,'Лъка'),(2830,3,'Laka'),(2831,1,'Laka'),(2831,2,'Лъка'),(2831,3,'Laka'),(2832,1,'Lakavitsa'),(2832,2,'Лъкавица'),(2832,3,'Lakavitsa'),(2833,1,'Laki'),(2833,2,'Лъки'),(2833,3,'Laki'),(2834,1,'Laki'),(2834,2,'Лъки'),(2834,3,'Laki'),(2835,1,'Lyuben'),(2835,2,'Любен'),(2835,3,'Lyuben'),(2836,1,'Lyuben'),(2836,2,'Любен'),(2836,3,'Lyuben'),(2837,1,'Lyuben Karavelovo'),(2837,2,'Любен Каравелово'),(2837,3,'Lyuben Karavelovo'),(2838,1,'Lyubenets'),(2838,2,'Любенец'),(2838,3,'Lyubenets'),(2839,1,'Lyubenova mahala'),(2839,2,'Любенова махала'),(2839,3,'Lyubenova mahala'),(2840,1,'Lyubenovo'),(2840,2,'Любеново'),(2840,3,'Lyubenovo'),(2841,1,'Lyubenovo'),(2841,2,'Любеново'),(2841,3,'Lyubenovo'),(2842,1,'Lyubenovo'),(2842,2,'Любеново'),(2842,3,'Lyubenovo'),(2843,1,'Lyubentsi'),(2843,2,'Любенци'),(2843,3,'Lyubentsi'),(2844,1,'Lyubimets'),(2844,2,'Любимец'),(2844,3,'Lyubimets'),(2845,1,'Lyubino'),(2845,2,'Любино'),(2845,3,'Lyubino'),(2846,1,'Lyubichevo'),(2846,2,'Любичево'),(2846,3,'Lyubichevo'),(2847,1,'Lyublen'),(2847,2,'Люблен'),(2847,3,'Lyublen'),(2848,1,'Lyubnitsa'),(2848,2,'Любница'),(2848,3,'Lyubnitsa'),(2849,1,'Lyubovishte'),(2849,2,'Любовище'),(2849,3,'Lyubovishte'),(2850,1,'Lyubovka'),(2850,2,'Любовка'),(2850,3,'Lyubovka'),(2851,1,'Lyubcha'),(2851,2,'Любча'),(2851,3,'Lyubcha'),(2852,1,'Lyulin'),(2852,2,'Люлин'),(2852,3,'Lyulin'),(2853,1,'Lyulin'),(2853,2,'Люлин'),(2853,3,'Lyulin'),(2854,1,'Lyulka'),(2854,2,'Люлка'),(2854,3,'Lyulka'),(2855,1,'Lyulyak'),(2855,2,'Люляк'),(2855,3,'Lyulyak'),(2856,1,'Lyulyakovo'),(2856,2,'Люляково'),(2856,3,'Lyulyakovo'),(2857,1,'Lyulyakovo'),(2857,2,'Люляково'),(2857,3,'Lyulyakovo'),(2858,1,'Lyulyakovo'),(2858,2,'Люляково'),(2858,3,'Lyulyakovo'),(2859,1,'Lyutadzhik'),(2859,2,'Лютаджик'),(2859,3,'Lyutadzhik'),(2860,1,'Lyutibrod'),(2860,2,'Лютиброд'),(2860,3,'Lyutibrod'),(2861,1,'Lyutidol'),(2861,2,'Лютидол'),(2861,3,'Lyutidol'),(2862,1,'Lyutovo'),(2862,2,'Лютово'),(2862,3,'Lyutovo'),(2863,1,'Lyava reka'),(2863,2,'Лява река'),(2863,3,'Lyava reka'),(2864,1,'Lyalintsi'),(2864,2,'Лялинци'),(2864,3,'Lyalintsi'),(2865,1,'Lyaskovets'),(2865,2,'Лясковец'),(2865,3,'Lyaskovets'),(2866,1,'Lyaskovets'),(2866,2,'Лясковец'),(2866,3,'Lyaskovets'),(2867,1,'Lyaskovo'),(2867,2,'Лясково'),(2867,3,'Lyaskovo'),(2868,1,'Lyaskovo'),(2868,2,'Лясково'),(2868,3,'Lyaskovo'),(2869,1,'Lyaskovo'),(2869,2,'Лясково'),(2869,3,'Lyaskovo'),(2870,1,'Lyaskovo'),(2870,2,'Лясково'),(2870,3,'Lyaskovo'),(2871,1,'Lyaskovo'),(2871,2,'Лясково'),(2871,3,'Lyaskovo'),(2872,1,'Lyaskovo'),(2872,2,'Лясково'),(2872,3,'Lyaskovo'),(2873,1,'Lyatno'),(2873,2,'Лятно'),(2873,3,'Lyatno'),(2874,1,'Lyahovo'),(2874,2,'Ляхово'),(2874,3,'Lyahovo'),(2875,1,'Lyahovo'),(2875,2,'Ляхово'),(2875,3,'Lyahovo'),(2876,1,'Magardzhitsa'),(2876,2,'Магарджица'),(2876,3,'Magardzhitsa'),(2877,1,'Madan'),(2877,2,'Мадан'),(2877,3,'Madan'),(2878,1,'Madan'),(2878,2,'Мадан'),(2878,3,'Madan'),(2879,1,'Madara'),(2879,2,'Мадара'),(2879,3,'Madara'),(2880,1,'Madzhare'),(2880,2,'Маджаре'),(2880,3,'Madzhare'),(2881,1,'Madzhari'),(2881,2,'Маджари'),(2881,3,'Madzhari'),(2882,1,'Madzharovo'),(2882,2,'Маджарово'),(2882,3,'Madzharovo'),(2883,1,'Madzherito'),(2883,2,'Маджерито'),(2883,3,'Madzherito'),(2884,1,'Mazarachevo'),(2884,2,'Мазарачево'),(2884,3,'Mazarachevo'),(2885,1,'Mayor Uzunovo'),(2885,2,'Майор Узуново'),(2885,3,'Mayor Uzunovo'),(2886,1,'Maysko'),(2886,2,'Майско'),(2886,3,'Maysko'),(2887,1,'Maystorovo'),(2887,2,'Майсторово'),(2887,3,'Maystorovo'),(2888,1,'Mak'),(2888,2,'Мак'),(2888,3,'Mak'),(2889,1,'Makariopolsko'),(2889,2,'Макариополско'),(2889,3,'Makariopolsko'),(2890,1,'Makedontsi'),(2890,2,'Македонци'),(2890,3,'Makedontsi'),(2891,1,'Makovo'),(2891,2,'Маково'),(2891,3,'Makovo'),(2892,1,'Makotsevo'),(2892,2,'Макоцево'),(2892,3,'Makotsevo'),(2893,1,'Makresh'),(2893,2,'Макреш'),(2893,3,'Makresh'),(2894,1,'Mala Rakovitsa'),(2894,2,'Мала Раковица'),(2894,3,'Mala Rakovitsa'),(2895,1,'Mala Fucha'),(2895,2,'Мала Фуча'),(2895,3,'Mala Fucha'),(2896,1,'Mala tsarkva'),(2896,2,'Мала църква'),(2896,3,'Mala tsarkva'),(2897,1,'Malevo'),(2897,2,'Малево'),(2897,3,'Malevo'),(2898,1,'Malevo'),(2898,2,'Малево'),(2898,3,'Malevo'),(2899,1,'Malenovo'),(2899,2,'Маленово'),(2899,3,'Malenovo'),(2900,1,'Mali Varbovnik'),(2900,2,'Мали Върбовник'),(2900,3,'Mali Varbovnik'),(2901,1,'Mali Drenovets'),(2901,2,'Мали Дреновец'),(2901,3,'Mali Drenovets'),(2902,1,'Mali izvor'),(2902,2,'Мали извор'),(2902,3,'Mali izvor'),(2903,1,'Malina'),(2903,2,'Малина'),(2903,3,'Malina'),(2904,1,'Malina'),(2904,2,'Малина'),(2904,3,'Malina'),(2905,1,'Malini'),(2905,2,'Малини'),(2905,3,'Malini'),(2906,1,'Malinovo'),(2906,2,'Малиново'),(2906,3,'Malinovo'),(2907,1,'Malinovo'),(2907,2,'Малиново'),(2907,3,'Malinovo'),(2908,1,'Malka Arda'),(2908,2,'Малка Арда'),(2908,3,'Malka Arda'),(2909,1,'Malka Vereya'),(2909,2,'Малка Верея'),(2909,3,'Malka Vereya'),(2910,1,'Malka Zhelyazna'),(2910,2,'Малка Желязна'),(2910,3,'Malka Zhelyazna'),(2911,1,'Malka polyana'),(2911,2,'Малка поляна'),(2911,3,'Malka polyana'),(2912,1,'Malka Smolnitsa'),(2912,2,'Малка Смолница'),(2912,3,'Malka Smolnitsa'),(2913,1,'Malka Cherkovna'),(2913,2,'Малка Черковна'),(2913,3,'Malka Cherkovna'),(2914,1,'Malka Chinka'),(2914,2,'Малка Чинка'),(2914,3,'Malka Chinka'),(2915,1,'Malki Balgareni'),(2915,2,'Малки Българени'),(2915,3,'Malki Balgareni'),(2916,1,'Malki Voden'),(2916,2,'Малки Воден'),(2916,3,'Malki Voden'),(2917,1,'Malki Varshets'),(2917,2,'Малки Вършец'),(2917,3,'Malki Varshets'),(2918,1,'Malki iskar'),(2918,2,'Малки Искър'),(2918,3,'Malki iskar'),(2919,1,'Malki Stanchovtsi'),(2919,2,'Малки Станчовци'),(2919,3,'Malki Stanchovtsi'),(2920,1,'Malki Tsalim'),(2920,2,'Малки Цалим'),(2920,3,'Malki Tsalim'),(2921,1,'Malki chiflik'),(2921,2,'Малки чифлик'),(2921,3,'Malki chiflik'),(2922,1,'Malko Asenovo'),(2922,2,'Малко Асеново'),(2922,3,'Malko Asenovo'),(2923,1,'Malko Bryagovo'),(2923,2,'Малко Брягово'),(2923,3,'Malko Bryagovo'),(2924,1,'Malko Vranovo'),(2924,2,'Малко Враново'),(2924,3,'Malko Vranovo'),(2925,1,'Malko gradishte'),(2925,2,'Малко градище'),(2925,3,'Malko gradishte'),(2926,1,'Malko Dryanovo'),(2926,2,'Малко Дряново'),(2926,3,'Malko Dryanovo'),(2927,1,'Malko Yonkovo'),(2927,2,'Малко Йонково'),(2927,3,'Malko Yonkovo'),(2928,1,'Malko Kadievo'),(2928,2,'Малко Кадиево'),(2928,3,'Malko Kadievo'),(2929,1,'Malko Kamenyane'),(2929,2,'Малко Каменяне'),(2929,3,'Malko Kamenyane'),(2930,1,'Malko Kirilovo'),(2930,2,'Малко Кирилово'),(2930,3,'Malko Kirilovo'),(2931,1,'Malko Krushevo'),(2931,2,'Малко Крушево'),(2931,3,'Malko Krushevo'),(2932,1,'Malko Popovo'),(2932,2,'Малко Попово'),(2932,3,'Malko Popovo'),(2933,1,'Malko selo'),(2933,2,'Малко село'),(2933,3,'Malko selo'),(2934,1,'Malko Tranovo'),(2934,2,'Малко Тръново'),(2934,3,'Malko Tranovo'),(2935,1,'Malko Tarnovo'),(2935,2,'Малко Търново'),(2935,3,'Malko Tarnovo'),(2936,1,'Malko Chochoveni'),(2936,2,'Малко Чочовени'),(2936,3,'Malko Chochoveni'),(2937,1,'Malko Sharkovo'),(2937,2,'Малко Шарково'),(2937,3,'Malko Sharkovo'),(2938,1,'Malkoch'),(2938,2,'Малкоч'),(2938,3,'Malkoch'),(2939,1,'Malo Buchino'),(2939,2,'Мало Бучино'),(2939,3,'Malo Buchino'),(2940,1,'Malo Konare'),(2940,2,'Мало Конаре'),(2940,3,'Malo Konare'),(2941,1,'Malo Krushevo'),(2941,2,'Мало Крушево'),(2941,3,'Malo Krushevo'),(2942,1,'Malo Malovo'),(2942,2,'Мало Малово'),(2942,3,'Malo Malovo'),(2943,1,'Malo Peshtene'),(2943,2,'Мало Пещене'),(2943,3,'Malo Peshtene'),(2944,1,'Malo selo'),(2944,2,'Мало село'),(2944,3,'Malo selo'),(2945,1,'Malogradets'),(2945,2,'Малоградец'),(2945,3,'Malogradets'),(2946,1,'Malomir'),(2946,2,'Маломир'),(2946,3,'Malomir'),(2947,1,'Malomir'),(2947,2,'Маломир'),(2947,3,'Malomir'),(2948,1,'Malomirovo'),(2948,2,'Маломирово'),(2948,3,'Malomirovo'),(2949,1,'Malorad'),(2949,2,'Малорад'),(2949,3,'Malorad'),(2950,1,'Malusha'),(2950,2,'Малуша'),(2950,3,'Malusha'),(2951,1,'Malchika'),(2951,2,'Малчика'),(2951,3,'Malchika'),(2952,1,'Malchovtsi'),(2952,2,'Малчовци'),(2952,3,'Malchovtsi'),(2953,1,'Malchovtsi'),(2953,2,'Малчовци'),(2953,3,'Malchovtsi'),(2954,1,'Malak Devesil'),(2954,2,'Малък Девесил'),(2954,3,'Malak Devesil'),(2955,1,'Malak dol'),(2955,2,'Малък дол'),(2955,3,'Malak dol'),(2956,1,'Malak izvor'),(2956,2,'Малък извор'),(2956,3,'Malak izvor'),(2957,1,'Malak izvor'),(2957,2,'Малък извор'),(2957,3,'Malak izvor'),(2958,1,'Malak manastir'),(2958,2,'Малък манастир'),(2958,3,'Malak manastir'),(2959,1,'Malak Porovets'),(2959,2,'Малък Поровец'),(2959,3,'Malak Porovets'),(2960,1,'Malak Preslavets'),(2960,2,'Малък Преславец'),(2960,3,'Malak Preslavets'),(2961,1,'Malak chardak'),(2961,2,'Малък чардак'),(2961,3,'Malak chardak'),(2962,1,'Mamarchevo'),(2962,2,'Мамарчево'),(2962,3,'Mamarchevo'),(2963,1,'Manaselska reka'),(2963,2,'Манаселска река'),(2963,3,'Manaselska reka'),(2964,1,'Manastir'),(2964,2,'Манастир'),(2964,3,'Manastir'),(2965,1,'Manastir'),(2965,2,'Манастир'),(2965,3,'Manastir'),(2966,1,'Manastir'),(2966,2,'Манастир'),(2966,3,'Manastir'),(2967,1,'Manastiritsa'),(2967,2,'Манастирица'),(2967,3,'Manastiritsa'),(2968,1,'Manastirishte'),(2968,2,'Манастирище'),(2968,3,'Manastirishte'),(2969,1,'Manastirishte'),(2969,2,'Манастирище'),(2969,3,'Manastirishte'),(2970,1,'Manastirsko'),(2970,2,'Манастирско'),(2970,3,'Manastirsko'),(2971,1,'Manastirtsi'),(2971,2,'Манастирци'),(2971,3,'Manastirtsi'),(2972,1,'Mandra'),(2972,2,'Мандра'),(2972,3,'Mandra'),(2973,1,'Mandritsa'),(2973,2,'Мандрица'),(2973,3,'Mandritsa'),(2974,1,'Manevtsi'),(2974,2,'Маневци'),(2974,3,'Manevtsi'),(2975,1,'Manole'),(2975,2,'Маноле'),(2975,3,'Manole'),(2976,1,'Manolich'),(2976,2,'Манолич'),(2976,3,'Manolich'),(2977,1,'Manolovo'),(2977,2,'Манолово'),(2977,3,'Manolovo'),(2978,1,'Manolsko Konare'),(2978,2,'Манолско Конаре'),(2978,3,'Manolsko Konare'),(2979,1,'Manoya'),(2979,2,'Маноя'),(2979,3,'Manoya'),(2980,1,'Manushevtsi'),(2980,2,'Манушевци'),(2980,3,'Manushevtsi'),(2981,1,'Manchevo'),(2981,2,'Манчево'),(2981,3,'Manchevo'),(2982,1,'Marafeltsi'),(2982,2,'Марафелци'),(2982,3,'Marafeltsi'),(2983,1,'Marash'),(2983,2,'Мараш'),(2983,3,'Marash'),(2984,1,'Margovtsi'),(2984,2,'Марговци'),(2984,3,'Margovtsi'),(2985,1,'Marikostinovo'),(2985,2,'Марикостиново'),(2985,3,'Marikostinovo'),(2986,1,'Marinka'),(2986,2,'Маринка'),(2986,3,'Marinka'),(2987,1,'Marino pole'),(2987,2,'Марино поле'),(2987,3,'Marino pole'),(2988,1,'Marino pole'),(2988,2,'Марино поле'),(2988,3,'Marino pole'),(2989,1,'Marinovtsi'),(2989,2,'Мариновци'),(2989,3,'Marinovtsi'),(2990,1,'Marinovtsi'),(2990,2,'Мариновци'),(2990,3,'Marinovtsi'),(2991,1,'Maritsa'),(2991,2,'Марица'),(2991,3,'Maritsa'),(2992,1,'Markovo'),(2992,2,'Марково'),(2992,3,'Markovo'),(2993,1,'Markovo'),(2993,2,'Марково'),(2993,3,'Markovo'),(2994,1,'Markovo'),(2994,2,'Марково'),(2994,3,'Markovo'),(2995,1,'Markovo ravnishte'),(2995,2,'Марково равнище'),(2995,3,'Markovo ravnishte'),(2996,1,'Marten'),(2996,2,'Мартен'),(2996,3,'Marten'),(2997,1,'Martino'),(2997,2,'Мартино'),(2997,3,'Martino'),(2998,1,'Martinovo'),(2998,2,'Мартиново'),(2998,3,'Martinovo'),(2999,1,'Marulevo'),(2999,2,'Марулево'),(2999,3,'Marulevo'),(3000,1,'Marutsekovtsi'),(3000,2,'Маруцековци'),(3000,3,'Marutsekovtsi'),(3001,1,'Marchevo'),(3001,2,'Марчево'),(3001,3,'Marchevo'),(3002,1,'Marchino'),(3002,2,'Марчино'),(3002,3,'Marchino'),(3003,1,'Maryan'),(3003,2,'Марян'),(3003,3,'Maryan'),(3004,1,'Maslarevo'),(3004,2,'Масларево'),(3004,3,'Maslarevo'),(3005,1,'Maslinovo'),(3005,2,'Маслиново'),(3005,3,'Maslinovo'),(3006,1,'Mateshovtsi'),(3006,2,'Матешовци'),(3006,3,'Mateshovtsi'),(3007,1,'Matochina'),(3007,2,'Маточина'),(3007,3,'Matochina'),(3008,1,'Mahalata'),(3008,2,'Махалата'),(3008,3,'Mahalata'),(3009,1,'Mahalnitsi'),(3009,2,'Махалници'),(3009,3,'Mahalnitsi'),(3010,1,'Matsa'),(3010,2,'Маца'),(3010,3,'Matsa'),(3011,1,'Medven'),(3011,2,'Медвен'),(3011,3,'Medven'),(3012,1,'Medevtsi'),(3012,2,'Медевци'),(3012,3,'Medevtsi'),(3013,1,'Meden buk'),(3013,2,'Меден бук'),(3013,3,'Meden buk'),(3014,1,'Meden kladenets'),(3014,2,'Меден кладенец'),(3014,3,'Meden kladenets'),(3015,1,'Medeni polyani'),(3015,2,'Медени поляни'),(3015,3,'Medeni polyani'),(3016,1,'Medeshevtsi'),(3016,2,'Медешевци'),(3016,3,'Medeshevtsi'),(3017,1,'Medkovets'),(3017,2,'Медковец'),(3017,3,'Medkovets'),(3018,1,'Mednikarovo'),(3018,2,'Медникарово'),(3018,3,'Mednikarovo'),(3019,1,'Medovene'),(3019,2,'Медовене'),(3019,3,'Medovene'),(3020,1,'Medovets'),(3020,2,'Медовец'),(3020,3,'Medovets'),(3021,1,'Medovina'),(3021,2,'Медовина'),(3021,3,'Medovina'),(3022,1,'Medovnitsa'),(3022,2,'Медовница'),(3022,3,'Medovnitsa'),(3023,1,'Medovo'),(3023,2,'Медово'),(3023,3,'Medovo'),(3024,1,'Medovo'),(3024,2,'Медово'),(3024,3,'Medovo'),(3025,1,'Medovo'),(3025,2,'Медово'),(3025,3,'Medovo'),(3026,1,'Mezhda'),(3026,2,'Межда'),(3026,3,'Mezhda'),(3027,1,'Mezhden'),(3027,2,'Межден'),(3027,3,'Mezhden'),(3028,1,'Mezhdeni'),(3028,2,'Междени'),(3028,3,'Mezhdeni'),(3029,1,'Mezdra'),(3029,2,'Мездра'),(3029,3,'Mezdra'),(3030,1,'Mezdreya'),(3030,2,'Мездрея'),(3030,3,'Mezdreya'),(3031,1,'Mezek'),(3031,2,'Мезек'),(3031,3,'Mezek'),(3032,1,'Melnik'),(3032,2,'Мелник'),(3032,3,'Melnik'),(3033,1,'Melnitsa'),(3033,2,'Мелница'),(3033,3,'Melnitsa'),(3034,1,'Melyane'),(3034,2,'Меляне'),(3034,3,'Melyane'),(3035,1,'Mengishevo'),(3035,2,'Менгишево'),(3035,3,'Mengishevo'),(3036,1,'Mendovo'),(3036,2,'Мендово'),(3036,3,'Mendovo'),(3037,1,'Menenkyovo'),(3037,2,'Мененкьово'),(3037,3,'Menenkyovo'),(3038,1,'Merdanya'),(3038,2,'Мерданя'),(3038,3,'Merdanya'),(3039,1,'Merichleri'),(3039,2,'Меричлери'),(3039,3,'Merichleri'),(3040,1,'Mesta'),(3040,2,'Места'),(3040,3,'Mesta'),(3041,1,'Metlika'),(3041,2,'Метлика'),(3041,3,'Metlika'),(3042,1,'Metlichina'),(3042,2,'Метличина'),(3042,3,'Metlichina'),(3043,1,'Metlichina'),(3043,2,'Метличина'),(3043,3,'Metlichina'),(3044,1,'Metlichka'),(3044,2,'Метличка'),(3044,3,'Metlichka'),(3045,1,'Metodievo'),(3045,2,'Методиево'),(3045,3,'Metodievo'),(3046,1,'Metodievo'),(3046,2,'Методиево'),(3046,3,'Metodievo'),(3047,1,'Metohia'),(3047,2,'Метохия'),(3047,3,'Metohia'),(3048,1,'Mechka'),(3048,2,'Мечка'),(3048,3,'Mechka'),(3049,1,'Mechka'),(3049,2,'Мечка'),(3049,3,'Mechka'),(3050,1,'Mechkarevo'),(3050,2,'Мечкарево'),(3050,3,'Mechkarevo'),(3051,1,'Mechkovitsa'),(3051,2,'Мечковица'),(3051,3,'Mechkovitsa'),(3052,1,'Mechkovtsi'),(3052,2,'Мечковци'),(3052,3,'Mechkovtsi'),(3053,1,'Mechkul'),(3053,2,'Мечкул'),(3053,3,'Mechkul'),(3054,1,'Mechovo'),(3054,2,'Мечово'),(3054,3,'Mechovo'),(3055,1,'Meshtitsa'),(3055,2,'Мещица'),(3055,3,'Meshtitsa'),(3056,1,'Mizia'),(3056,2,'Мизия'),(3056,3,'Mizia'),(3057,1,'Miykovtsi'),(3057,2,'Мийковци'),(3057,3,'Miykovtsi'),(3058,1,'Mikre'),(3058,2,'Микре'),(3058,3,'Mikre'),(3059,1,'Mikrevo'),(3059,2,'Микрево'),(3059,3,'Mikrevo'),(3060,1,'Miladinovo'),(3060,2,'Миладиново'),(3060,3,'Miladinovo'),(3061,1,'Miladinovtsi'),(3061,2,'Миладиновци'),(3061,3,'Miladinovtsi'),(3062,1,'Miladinovtsi'),(3062,2,'Миладиновци'),(3062,3,'Miladinovtsi'),(3063,1,'Miladinovtsi'),(3063,2,'Миладиновци'),(3063,3,'Miladinovtsi'),(3064,1,'Milanovo'),(3064,2,'Миланово'),(3064,3,'Milanovo'),(3065,1,'Milanovo'),(3065,2,'Миланово'),(3065,3,'Milanovo'),(3066,1,'Mile'),(3066,2,'Миле'),(3066,3,'Mile'),(3067,1,'Milevo'),(3067,2,'Милево'),(3067,3,'Milevo'),(3068,1,'Milevtsi'),(3068,2,'Милевци'),(3068,3,'Milevtsi'),(3069,1,'Milencha'),(3069,2,'Миленча'),(3069,3,'Milencha'),(3070,1,'Milino'),(3070,2,'Милино'),(3070,3,'Milino'),(3071,1,'Milkovitsa'),(3071,2,'Милковица'),(3071,3,'Milkovitsa'),(3072,1,'Milkovo'),(3072,2,'Милково'),(3072,3,'Milkovo'),(3073,1,'Milkovtsi'),(3073,2,'Милковци'),(3073,3,'Milkovtsi'),(3074,1,'Milkyovtsi'),(3074,2,'Милкьовци'),(3074,3,'Milkyovtsi'),(3075,1,'Miloslavtsi'),(3075,2,'Милославци'),(3075,3,'Miloslavtsi'),(3076,1,'Milchina laka'),(3076,2,'Милчина лъка'),(3076,3,'Milchina laka'),(3077,1,'Mindya'),(3077,2,'Миндя'),(3077,3,'Mindya'),(3078,1,'Minevtsi'),(3078,2,'Миневци'),(3078,3,'Minevtsi'),(3079,1,'Mineralni bani'),(3079,2,'Минерални бани'),(3079,3,'Mineralni bani'),(3080,1,'Minzuhar'),(3080,2,'Минзухар'),(3080,3,'Minzuhar'),(3081,1,'Mirkovo'),(3081,2,'Мирково'),(3081,3,'Mirkovo'),(3082,1,'Mirovets'),(3082,2,'Мировец'),(3082,3,'Mirovets'),(3083,1,'Mirovo'),(3083,2,'Мирово'),(3083,3,'Mirovo'),(3084,1,'Mirovo'),(3084,2,'Мирово'),(3084,3,'Mirovo'),(3085,1,'Mirovo'),(3085,2,'Мирово'),(3085,3,'Mirovo'),(3086,1,'Mirovtsi'),(3086,2,'Мировци'),(3086,3,'Mirovtsi'),(3087,1,'Mirovyane'),(3087,2,'Мировяне'),(3087,3,'Mirovyane'),(3088,1,'Mirolyubovo'),(3088,2,'Миролюбово'),(3088,3,'Mirolyubovo'),(3089,1,'Mirchovtsi'),(3089,2,'Мирчовци'),(3089,3,'Mirchovtsi'),(3090,1,'Miryantsi'),(3090,2,'Мирянци'),(3090,3,'Miryantsi'),(3091,1,'Mitino'),(3091,2,'Митино'),(3091,3,'Mitino'),(3092,1,'Mitovska'),(3092,2,'Митовска'),(3092,3,'Mitovska'),(3093,1,'Mitrovtsi'),(3093,2,'Митровци'),(3093,3,'Mitrovtsi'),(3094,1,'Mihaylovo'),(3094,2,'Михайлово'),(3094,3,'Mihaylovo'),(3095,1,'Mihaylovo'),(3095,2,'Михайлово'),(3095,3,'Mihaylovo'),(3096,1,'Mihaylovtsi'),(3096,2,'Михайловци'),(3096,3,'Mihaylovtsi'),(3097,1,'Mihalich'),(3097,2,'Михалич'),(3097,3,'Mihalich'),(3098,1,'Mihalich'),(3098,2,'Михалич'),(3098,3,'Mihalich'),(3099,1,'Mihalkovo'),(3099,2,'Михалково'),(3099,3,'Mihalkovo'),(3100,1,'Mihaltsi'),(3100,2,'Михалци'),(3100,3,'Mihaltsi'),(3101,1,'Mihiltsi'),(3101,2,'Михилци'),(3101,3,'Mihiltsi'),(3102,1,'Mihnevo'),(3102,2,'Михнево'),(3102,3,'Mihnevo'),(3103,1,'Mihovtsi'),(3103,2,'Миховци'),(3103,3,'Mihovtsi'),(3104,1,'Michkovtsi'),(3104,2,'Мичковци'),(3104,3,'Michkovtsi'),(3105,1,'Mishevsko'),(3105,2,'Мишевско'),(3105,3,'Mishevsko'),(3106,1,'Mishemorkov han'),(3106,2,'Мишеморков хан'),(3106,3,'Mishemorkov han'),(3107,1,'Mlada gvardia'),(3107,2,'Млада гвардия'),(3107,3,'Mlada gvardia'),(3108,1,'Mladezhko'),(3108,2,'Младежко'),(3108,3,'Mladezhko'),(3109,1,'Mladen'),(3109,2,'Младен'),(3109,3,'Mladen'),(3110,1,'Mladinovo'),(3110,2,'Младиново'),(3110,3,'Mladinovo'),(3111,1,'Mladovo'),(3111,2,'Младово'),(3111,3,'Mladovo'),(3112,1,'Mlamolovo'),(3112,2,'Мламолово'),(3112,3,'Mlamolovo'),(3113,1,'Mlekarevo'),(3113,2,'Млекарево'),(3113,3,'Mlekarevo'),(3114,1,'Mlechevo'),(3114,2,'Млечево'),(3114,3,'Mlechevo'),(3115,1,'Mlechino'),(3115,2,'Млечино'),(3115,3,'Mlechino'),(3116,1,'Mogila'),(3116,2,'Могила'),(3116,3,'Mogila'),(3117,1,'Mogila'),(3117,2,'Могила'),(3117,3,'Mogila'),(3118,1,'Mogila'),(3118,2,'Могила'),(3118,3,'Mogila'),(3119,1,'Mogilets'),(3119,2,'Могилец'),(3119,3,'Mogilets'),(3120,1,'Mogilino'),(3120,2,'Могилино'),(3120,3,'Mogilino'),(3121,1,'Mogilite'),(3121,2,'Могилите'),(3121,3,'Mogilite'),(3122,1,'Mogilitsa'),(3122,2,'Могилица'),(3122,3,'Mogilitsa'),(3123,1,'Mogilishte'),(3123,2,'Могилище'),(3123,3,'Mogilishte'),(3124,1,'Mogilovo'),(3124,2,'Могилово'),(3124,3,'Mogilovo'),(3125,1,'Mogilyane'),(3125,2,'Могиляне'),(3125,3,'Mogilyane'),(3126,1,'Modren'),(3126,2,'Модрен'),(3126,3,'Modren'),(3127,1,'Mokren'),(3127,2,'Мокрен'),(3127,3,'Mokren'),(3128,1,'Mokresh'),(3128,2,'Мокреш'),(3128,3,'Mokresh'),(3129,1,'Mokresh'),(3129,2,'Мокреш'),(3129,3,'Mokresh'),(3130,1,'Mokrishte'),(3130,2,'Мокрище'),(3130,3,'Mokrishte'),(3131,1,'Momin prohod'),(3131,2,'Момин проход'),(3131,3,'Momin prohod'),(3132,1,'Momin sbor'),(3132,2,'Момин сбор'),(3132,3,'Momin sbor'),(3133,1,'Momina klisura'),(3133,2,'Момина клисура'),(3133,3,'Momina klisura'),(3134,1,'Momina salza'),(3134,2,'Момина сълза'),(3134,3,'Momina salza'),(3135,1,'Momina tsarkva'),(3135,2,'Момина църква'),(3135,3,'Momina tsarkva'),(3136,1,'Momino'),(3136,2,'Момино'),(3136,3,'Momino'),(3137,1,'Momino'),(3137,2,'Момино'),(3137,3,'Momino'),(3138,1,'Momino selo'),(3138,2,'Момино село'),(3138,3,'Momino selo'),(3139,1,'Mominsko'),(3139,2,'Моминско'),(3139,3,'Mominsko'),(3140,1,'Momkovo'),(3140,2,'Момково'),(3140,3,'Momkovo'),(3141,1,'Momchilgrad'),(3141,2,'Момчилград'),(3141,3,'Momchilgrad'),(3142,1,'Momchilovo'),(3142,2,'Момчилово'),(3142,3,'Momchilovo'),(3143,1,'Momchilovtsi'),(3143,2,'Момчиловци'),(3143,3,'Momchilovtsi'),(3144,1,'Montana'),(3144,2,'Монтана'),(3144,3,'Montana'),(3145,1,'Morava'),(3145,2,'Морава'),(3145,3,'Morava'),(3146,1,'Moravitsa'),(3146,2,'Моравица'),(3146,3,'Moravitsa'),(3147,1,'Moravitsa'),(3147,2,'Моравица'),(3147,3,'Moravitsa'),(3148,1,'Moravka'),(3148,2,'Моравка'),(3148,3,'Moravka'),(3149,1,'Morovetsite'),(3149,2,'Моровеците'),(3149,3,'Morovetsite'),(3150,1,'Mortagonovo'),(3150,2,'Мортагоново'),(3150,3,'Mortagonovo'),(3151,1,'Moryantsi'),(3151,2,'Морянци'),(3151,3,'Moryantsi'),(3152,1,'Moskovets'),(3152,2,'Московец'),(3152,3,'Moskovets'),(3153,1,'Most'),(3153,2,'Мост'),(3153,3,'Most'),(3154,1,'Mostich'),(3154,2,'Мостич'),(3154,3,'Mostich'),(3155,1,'Mostovo'),(3155,2,'Мостово'),(3155,3,'Mostovo'),(3156,1,'Mochure'),(3156,2,'Мочуре'),(3156,3,'Mochure'),(3157,1,'Moshtanets'),(3157,2,'Мощанец'),(3157,3,'Moshtanets'),(3158,1,'Mraketintsi'),(3158,2,'Мракетинци'),(3158,3,'Mraketintsi'),(3159,1,'Mramor'),(3159,2,'Мрамор'),(3159,3,'Mramor'),(3160,1,'Mramor'),(3160,2,'Мрамор'),(3160,3,'Mramor'),(3161,1,'Mramor'),(3161,2,'Мрамор'),(3161,3,'Mramor'),(3162,1,'Mramoren'),(3162,2,'Мраморен'),(3162,3,'Mramoren'),(3163,1,'Mrahori'),(3163,2,'Мрахори'),(3163,3,'Mrahori'),(3164,1,'Mrachenik'),(3164,2,'Мраченик'),(3164,3,'Mrachenik'),(3165,1,'Mrezhichko'),(3165,2,'Мрежичко'),(3165,3,'Mrezhichko'),(3166,1,'Mrezhichko'),(3166,2,'Мрежичко'),(3166,3,'Mrezhichko'),(3167,1,'Mrazetsi'),(3167,2,'Мръзеци'),(3167,3,'Mrazetsi'),(3168,1,'Mugla'),(3168,2,'Мугла'),(3168,3,'Mugla'),(3169,1,'Muzga'),(3169,2,'Музга'),(3169,3,'Muzga'),(3170,1,'Muldava'),(3170,2,'Мулдава'),(3170,3,'Muldava'),(3171,1,'Murga'),(3171,2,'Мурга'),(3171,3,'Murga'),(3172,1,'Murgash'),(3172,2,'Мургаш'),(3172,3,'Murgash'),(3173,1,'Murgovo'),(3173,2,'Мургово'),(3173,3,'Murgovo'),(3174,1,'Mureno'),(3174,2,'Мурено'),(3174,3,'Mureno'),(3175,1,'Mursalevo'),(3175,2,'Мурсалево'),(3175,3,'Mursalevo'),(3176,1,'Murtintsi'),(3176,2,'Муртинци'),(3176,3,'Murtintsi'),(3177,1,'Musachevo'),(3177,2,'Мусачево'),(3177,3,'Musachevo'),(3178,1,'Musachevo'),(3178,2,'Мусачево'),(3178,3,'Musachevo'),(3179,1,'Musevo'),(3179,2,'Мусево'),(3179,3,'Musevo'),(3180,1,'Muselievo'),(3180,2,'Муселиево'),(3180,3,'Muselievo'),(3181,1,'Musina'),(3181,2,'Мусина'),(3181,3,'Musina'),(3182,1,'Musomishta'),(3182,2,'Мусомища'),(3182,3,'Musomishta'),(3183,1,'Mustrak'),(3183,2,'Мустрак'),(3183,3,'Mustrak'),(3184,1,'Muhovo'),(3184,2,'Мухово'),(3184,3,'Muhovo'),(3185,1,'Mutsya'),(3185,2,'Муця'),(3185,3,'Mutsya'),(3186,1,'Maglen'),(3186,2,'Мъглен'),(3186,3,'Maglen'),(3187,1,'Maglene'),(3187,2,'Мъглене'),(3187,3,'Maglene'),(3188,1,'Maglizh'),(3188,2,'Мъглиж'),(3188,3,'Maglizh'),(3189,1,'Maglishta'),(3189,2,'Мъглища'),(3189,3,'Maglishta'),(3190,1,'Madrevo'),(3190,2,'Мъдрево'),(3190,3,'Madrevo'),(3191,1,'Madrets'),(3191,2,'Мъдрец'),(3191,3,'Madrets'),(3192,1,'Madrets'),(3192,2,'Мъдрец'),(3192,3,'Madrets'),(3193,1,'Madrino'),(3193,2,'Мъдрино'),(3193,3,'Madrino'),(3194,1,'Marvodol'),(3194,2,'Мърводол'),(3194,3,'Marvodol'),(3195,1,'Marzyan'),(3195,2,'Мързян'),(3195,3,'Marzyan'),(3196,1,'Martvinata'),(3196,2,'Мъртвината'),(3196,3,'Martvinata'),(3197,1,'Marchaevo'),(3197,2,'Мърчаево'),(3197,3,'Marchaevo'),(3198,1,'Marchevo'),(3198,2,'Мърчево'),(3198,3,'Marchevo'),(3199,1,'Matenitsa'),(3199,2,'Мътеница'),(3199,3,'Matenitsa'),(3200,1,'Navasen'),(3200,2,'Навъсен'),(3200,3,'Navasen'),(3201,1,'Nadarevo'),(3201,2,'Надарево'),(3201,3,'Nadarevo'),(3202,1,'Nadartsi'),(3202,2,'Надарци'),(3202,3,'Nadartsi'),(3203,1,'Nadezhden'),(3203,2,'Надежден'),(3203,3,'Nadezhden'),(3204,1,'Nayden Gerovo'),(3204,2,'Найден Герово'),(3204,3,'Nayden Gerovo'),(3205,1,'Naydenovo'),(3205,2,'Найденово'),(3205,3,'Naydenovo'),(3206,1,'Nane'),(3206,2,'Нане'),(3206,3,'Nane'),(3207,1,'Nanovitsa'),(3207,2,'Нановица'),(3207,3,'Nanovitsa'),(3208,1,'Narechenski bani'),(3208,2,'Нареченски бани'),(3208,3,'Narechenski bani'),(3209,1,'Nasalevtsi'),(3209,2,'Насалевци'),(3209,3,'Nasalevtsi'),(3210,1,'Naum'),(3210,2,'Наум'),(3210,3,'Naum'),(3211,1,'Nauchene'),(3211,2,'Научене'),(3211,3,'Nauchene'),(3212,1,'Natsovtsi'),(3212,2,'Нацовци'),(3212,3,'Natsovtsi'),(3213,1,'Nachevo'),(3213,2,'Начево'),(3213,3,'Nachevo'),(3214,1,'Nebeska'),(3214,2,'Небеска'),(3214,3,'Nebeska'),(3215,1,'Nevestino'),(3215,2,'Невестино'),(3215,3,'Nevestino'),(3216,1,'Nevestino'),(3216,2,'Невестино'),(3216,3,'Nevestino'),(3217,1,'Nevestino'),(3217,2,'Невестино'),(3217,3,'Nevestino'),(3218,1,'Nevsha'),(3218,2,'Невша'),(3218,3,'Nevsha'),(3219,1,'Negovan'),(3219,2,'Негован'),(3219,3,'Negovan'),(3220,1,'Negovanovtsi'),(3220,2,'Неговановци'),(3220,3,'Negovanovtsi'),(3221,1,'Negovantsi'),(3221,2,'Негованци'),(3221,3,'Negovantsi'),(3222,1,'Negushevo'),(3222,2,'Негушево'),(3222,3,'Negushevo'),(3223,1,'Nedan'),(3223,2,'Недан'),(3223,3,'Nedan'),(3224,1,'Nedelevo'),(3224,2,'Неделево'),(3224,3,'Nedelevo'),(3225,1,'Nedelino'),(3225,2,'Неделино'),(3225,3,'Nedelino'),(3226,1,'Nedelishte'),(3226,2,'Неделище'),(3226,3,'Nedelishte'),(3227,1,'Nedelkova Grashtitsa'),(3227,2,'Неделкова Гращица'),(3227,3,'Nedelkova Grashtitsa'),(3228,1,'Nedelkovo'),(3228,2,'Неделково'),(3228,3,'Nedelkovo'),(3229,1,'Nedoklan'),(3229,2,'Недоклан'),(3229,3,'Nedoklan'),(3230,1,'Nedyalkovtsi'),(3230,2,'Недялковци'),(3230,3,'Nedyalkovtsi'),(3231,1,'Nedyalkovtsi'),(3231,2,'Недялковци'),(3231,3,'Nedyalkovtsi'),(3232,1,'Nedyalsko'),(3232,2,'Недялско'),(3232,3,'Nedyalsko'),(3233,1,'Neykovo'),(3233,2,'Нейково'),(3233,3,'Neykovo'),(3234,1,'Neykovo'),(3234,2,'Нейково'),(3234,3,'Neykovo'),(3235,1,'Neykyovets'),(3235,2,'Нейкьовец'),(3235,3,'Neykyovets'),(3236,1,'Neychovtsi'),(3236,2,'Нейчовци'),(3236,3,'Neychovtsi'),(3237,1,'Nenkovo'),(3237,2,'Ненково'),(3237,3,'Nenkovo'),(3238,1,'Nenovo'),(3238,2,'Неново'),(3238,3,'Nenovo'),(3239,1,'Nenovtsi'),(3239,2,'Неновци'),(3239,3,'Nenovtsi'),(3240,1,'Neofit Bozvelievo'),(3240,2,'Неофит Бозвелиево'),(3240,3,'Neofit Bozvelievo'),(3241,1,'Neofit Rilski'),(3241,2,'Неофит Рилски'),(3241,3,'Neofit Rilski'),(3242,1,'Nepraznentsi'),(3242,2,'Непразненци'),(3242,3,'Nepraznentsi'),(3243,1,'Nesebar'),(3243,2,'Несебър'),(3243,3,'Nesebar'),(3244,1,'Nesla'),(3244,2,'Несла'),(3244,3,'Nesla'),(3245,1,'Nefela'),(3245,2,'Нефела'),(3245,3,'Nefela'),(3246,1,'Neshevtsi'),(3246,2,'Нешевци'),(3246,3,'Neshevtsi'),(3247,1,'Nivyanin'),(3247,2,'Нивянин'),(3247,3,'Nivyanin'),(3248,1,'Nikachkovtsi'),(3248,2,'Никачковци'),(3248,3,'Nikachkovtsi'),(3249,1,'Nikola Kozlevo'),(3249,2,'Никола Козлево'),(3249,3,'Nikola Kozlevo'),(3250,1,'Nikolaevka'),(3250,2,'Николаевка'),(3250,3,'Nikolaevka'),(3251,1,'Nikolaevo'),(3251,2,'Николаево'),(3251,3,'Nikolaevo'),(3252,1,'Nikolaevo'),(3252,2,'Николаево'),(3252,3,'Nikolaevo'),(3253,1,'Nikolaevo'),(3253,2,'Николаево'),(3253,3,'Nikolaevo'),(3254,1,'Nikolaevo'),(3254,2,'Николаево'),(3254,3,'Nikolaevo'),(3255,1,'Nikolaevo'),(3255,2,'Николаево'),(3255,3,'Nikolaevo'),(3256,1,'Nikolaevo'),(3256,2,'Николаево'),(3256,3,'Nikolaevo'),(3257,1,'Nikolichevtsi'),(3257,2,'Николичевци'),(3257,3,'Nikolichevtsi'),(3258,1,'Nikolovo'),(3258,2,'Николово'),(3258,3,'Nikolovo'),(3259,1,'Nikolovo'),(3259,2,'Николово'),(3259,3,'Nikolovo'),(3260,1,'Nikolovo'),(3260,2,'Николово'),(3260,3,'Nikolovo'),(3261,1,'Nikolovtsi'),(3261,2,'Николовци'),(3261,3,'Nikolovtsi'),(3262,1,'Nikolchovtsi'),(3262,2,'Николчовци'),(3262,3,'Nikolchovtsi'),(3263,1,'Nikolchovtsi'),(3263,2,'Николчовци'),(3263,3,'Nikolchovtsi'),(3264,1,'Nikopol'),(3264,2,'Никопол'),(3264,3,'Nikopol'),(3265,1,'Nikudin'),(3265,2,'Никудин'),(3265,3,'Nikudin'),(3266,1,'Nikyup'),(3266,2,'Никюп'),(3266,3,'Nikyup'),(3267,1,'Nisovo'),(3267,2,'Нисово'),(3267,3,'Nisovo'),(3268,1,'Nichovtsi'),(3268,2,'Ничовци'),(3268,3,'Nichovtsi'),(3269,1,'Nova byala reka'),(3269,2,'Нова бяла река'),(3269,3,'Nova byala reka'),(3270,1,'Nova Varbovka'),(3270,2,'Нова Върбовка'),(3270,3,'Nova Varbovka'),(3271,1,'Nova Zagora'),(3271,2,'Нова Загора'),(3271,3,'Nova Zagora'),(3272,1,'Nova Kamena'),(3272,2,'Нова Камена'),(3272,3,'Nova Kamena'),(3273,1,'Nova livada'),(3273,2,'Нова ливада'),(3273,3,'Nova livada'),(3274,1,'Nova Lovcha'),(3274,2,'Нова Ловча'),(3274,3,'Nova Lovcha'),(3275,1,'Nova mahala'),(3275,2,'Нова махала'),(3275,3,'Nova mahala'),(3276,1,'Nova mahala'),(3276,2,'Нова махала'),(3276,3,'Nova mahala'),(3277,1,'Nova Nadezhda'),(3277,2,'Нова Надежда'),(3277,3,'Nova Nadezhda'),(3278,1,'Nova Popina'),(3278,2,'Нова Попина'),(3278,3,'Nova Popina'),(3279,1,'Nova Cherna'),(3279,2,'Нова Черна'),(3279,3,'Nova Cherna'),(3280,1,'Nova Shipka'),(3280,2,'Нова Шипка'),(3280,3,'Nova Shipka'),(3281,1,'Novakovo'),(3281,2,'Новаково'),(3281,3,'Novakovo'),(3282,1,'Novakovo'),(3282,2,'Новаково'),(3282,3,'Novakovo'),(3283,1,'Novakovtsi'),(3283,2,'Новаковци'),(3283,3,'Novakovtsi'),(3284,1,'Novachevo'),(3284,2,'Новачево'),(3284,3,'Novachevo'),(3285,1,'Novachene'),(3285,2,'Новачене'),(3285,3,'Novachene'),(3286,1,'Novachene'),(3286,2,'Новачене'),(3286,3,'Novachene'),(3287,1,'Novgrad'),(3287,2,'Новград'),(3287,3,'Novgrad'),(3288,1,'Novi izvor'),(3288,2,'Нови извор'),(3288,3,'Novi izvor'),(3289,1,'Novi iskar'),(3289,2,'Нови Искър'),(3289,3,'Novi iskar'),(3290,1,'Novi pazar'),(3290,2,'Нови пазар'),(3290,3,'Novi pazar'),(3291,1,'Novi pazar'),(3291,2,'Нови пазар'),(3291,3,'Novi pazar'),(3292,1,'Novi han'),(3292,2,'Нови хан'),(3292,3,'Novi han'),(3293,1,'Novi chiflik'),(3293,2,'Нови чифлик'),(3293,3,'Novi chiflik'),(3294,1,'Novo Botevo'),(3294,2,'Ново Ботево'),(3294,3,'Novo Botevo'),(3295,1,'Novo bardo'),(3295,2,'Ново бърдо'),(3295,3,'Novo bardo'),(3296,1,'Novo gradishte'),(3296,2,'Ново градище'),(3296,3,'Novo gradishte'),(3297,1,'Novo Delchevo'),(3297,2,'Ново Делчево'),(3297,3,'Novo Delchevo'),(3298,1,'Novo Zhelezare'),(3298,2,'Ново Железаре'),(3298,3,'Novo Zhelezare'),(3299,1,'Novo Konomladi'),(3299,2,'Ново Кономлади'),(3299,3,'Novo Konomladi'),(3300,1,'Novo Leski'),(3300,2,'Ново Лески'),(3300,3,'Novo Leski'),(3301,1,'Novo Oryahovo'),(3301,2,'Ново Оряхово'),(3301,3,'Novo Oryahovo'),(3302,1,'Novo Panicharevo'),(3302,2,'Ново Паничарево'),(3302,3,'Novo Panicharevo'),(3303,1,'Novo selo'),(3303,2,'Ново село'),(3303,3,'Novo selo'),(3304,1,'Novo selo'),(3304,2,'Ново село'),(3304,3,'Novo selo'),(3305,1,'Novo selo'),(3305,2,'Ново село'),(3305,3,'Novo selo'),(3306,1,'Novo selo'),(3306,2,'Ново село'),(3306,3,'Novo selo'),(3307,1,'Novo selo'),(3307,2,'Ново село'),(3307,3,'Novo selo'),(3308,1,'Novo selo'),(3308,2,'Ново село'),(3308,3,'Novo selo'),(3309,1,'Novo selo'),(3309,2,'Ново село'),(3309,3,'Novo selo'),(3310,1,'Novo selo'),(3310,2,'Ново село'),(3310,3,'Novo selo'),(3311,1,'Novo Hodzhovo'),(3311,2,'Ново Ходжово'),(3311,3,'Novo Hodzhovo'),(3312,1,'Novo Yankovo'),(3312,2,'Ново Янково'),(3312,3,'Novo Yankovo'),(3313,1,'Novogortsi'),(3313,2,'Новогорци'),(3313,3,'Novogortsi'),(3314,1,'Novosel'),(3314,2,'Новосел'),(3314,3,'Novosel'),(3315,1,'Novoselets'),(3315,2,'Новоселец'),(3315,3,'Novoselets'),(3316,1,'Novoselishte'),(3316,2,'Новоселище'),(3316,3,'Novoselishte'),(3317,1,'Novoseltsi'),(3317,2,'Новоселци'),(3317,3,'Novoseltsi'),(3318,1,'Novoselyane'),(3318,2,'Новоселяне'),(3318,3,'Novoselyane'),(3319,1,'Noevtsi'),(3319,2,'Ноевци'),(3319,3,'Noevtsi'),(3320,1,'Nozharevo'),(3320,2,'Ножарево'),(3320,3,'Nozharevo'),(3321,1,'Nozharovo'),(3321,2,'Ножарово'),(3321,3,'Nozharovo'),(3322,1,'Nozherite'),(3322,2,'Ножерите'),(3322,3,'Nozherite'),(3323,1,'Noseite'),(3323,2,'Носеите'),(3323,3,'Noseite'),(3324,1,'Nochevo'),(3324,2,'Ночево'),(3324,3,'Nochevo'),(3325,1,'Nyushkovtsi'),(3325,2,'Нюшковци'),(3325,3,'Nyushkovtsi'),(3326,1,'Obedinenie'),(3326,2,'Обединение'),(3326,3,'Obedinenie'),(3327,1,'Obel'),(3327,2,'Обел'),(3327,3,'Obel'),(3328,1,'Obzor'),(3328,2,'Обзор'),(3328,3,'Obzor'),(3329,1,'Obidim'),(3329,2,'Обидим'),(3329,3,'Obidim'),(3330,1,'Obitel'),(3330,2,'Обител'),(3330,3,'Obitel'),(3331,1,'Obichnik'),(3331,2,'Обичник'),(3331,3,'Obichnik'),(3332,1,'Obnova'),(3332,2,'Обнова'),(3332,3,'Obnova'),(3333,1,'Oborishte'),(3333,2,'Оборище'),(3333,3,'Oborishte'),(3334,1,'Oborishte'),(3334,2,'Оборище'),(3334,3,'Oborishte'),(3335,1,'Obretenik'),(3335,2,'Обретеник'),(3335,3,'Obretenik'),(3336,1,'Obrochishte'),(3336,2,'Оброчище'),(3336,3,'Obrochishte'),(3337,1,'Obruchishte'),(3337,2,'Обручище'),(3337,3,'Obruchishte'),(3338,1,'Oven'),(3338,2,'Овен'),(3338,3,'Oven'),(3339,1,'Ovoshtartsi'),(3339,2,'Овощарци'),(3339,3,'Ovoshtartsi'),(3340,1,'Ovoshtna'),(3340,2,'Овощна'),(3340,3,'Ovoshtna'),(3341,1,'Ovoshtnik'),(3341,2,'Овощник'),(3341,3,'Ovoshtnik'),(3342,1,'Ovcha mogila'),(3342,2,'Овча могила'),(3342,3,'Ovcha mogila'),(3343,1,'Ovchaga'),(3343,2,'Овчага'),(3343,3,'Ovchaga'),(3344,1,'Ovchari'),(3344,2,'Овчари'),(3344,3,'Ovchari'),(3345,1,'Ovcharovo'),(3345,2,'Овчарово'),(3345,3,'Ovcharovo'),(3346,1,'Ovcharovo'),(3346,2,'Овчарово'),(3346,3,'Ovcharovo'),(3347,1,'Ovcharovo'),(3347,2,'Овчарово'),(3347,3,'Ovcharovo'),(3348,1,'Ovcharovo'),(3348,2,'Овчарово'),(3348,3,'Ovcharovo'),(3349,1,'Ovchartsi'),(3349,2,'Овчарци'),(3349,3,'Ovchartsi'),(3350,1,'Ovchartsi'),(3350,2,'Овчарци'),(3350,3,'Ovchartsi'),(3351,1,'Ovchevo'),(3351,2,'Овчево'),(3351,3,'Ovchevo'),(3352,1,'Ovchepoltsi'),(3352,2,'Овчеполци'),(3352,3,'Ovchepoltsi'),(3353,1,'Ovchi kladenets'),(3353,2,'Овчи кладенец'),(3353,3,'Ovchi kladenets'),(3354,1,'Ogled'),(3354,2,'Оглед'),(3354,3,'Ogled'),(3355,1,'Ognen'),(3355,2,'Огнен'),(3355,3,'Ognen'),(3356,1,'Ognyanovo'),(3356,2,'Огняново'),(3356,3,'Ognyanovo'),(3357,1,'Ognyanovo'),(3357,2,'Огняново'),(3357,3,'Ognyanovo'),(3358,1,'Ognyanovo'),(3358,2,'Огняново'),(3358,3,'Ognyanovo'),(3359,1,'Ognyanovo'),(3359,2,'Огняново'),(3359,3,'Ognyanovo'),(3360,1,'Ogoya'),(3360,2,'Огоя'),(3360,3,'Ogoya'),(3361,1,'Ogradna'),(3361,2,'Оградна'),(3361,3,'Ogradna'),(3362,1,'Ograzhden'),(3362,2,'Огражден'),(3362,3,'Ograzhden'),(3363,1,'Odorovtsi'),(3363,2,'Одоровци'),(3363,3,'Odorovtsi'),(3364,1,'Odranitsa'),(3364,2,'Одраница'),(3364,3,'Odranitsa'),(3365,1,'Odrintsi'),(3365,2,'Одринци'),(3365,3,'Odrintsi'),(3366,1,'Odrintsi'),(3366,2,'Одринци'),(3366,3,'Odrintsi'),(3367,1,'Odarne'),(3367,2,'Одърне'),(3367,3,'Odarne'),(3368,1,'Odartsi'),(3368,2,'Одърци'),(3368,3,'Odartsi'),(3369,1,'Ozarnovtsi'),(3369,2,'Озърновци'),(3369,3,'Ozarnovtsi'),(3370,1,'Okoliite'),(3370,2,'Околиите'),(3370,3,'Okoliite'),(3371,1,'Okop'),(3371,2,'Окоп'),(3371,3,'Okop'),(3372,1,'Okorsh'),(3372,2,'Окорш'),(3372,3,'Okorsh'),(3373,1,'Oman'),(3373,2,'Оман'),(3373,3,'Oman'),(3374,1,'Omarchevo'),(3374,2,'Омарчево'),(3374,3,'Omarchevo'),(3375,1,'Omarchevo'),(3375,2,'Омарчево'),(3375,3,'Omarchevo'),(3376,1,'Omurtag'),(3376,2,'Омуртаг'),(3376,3,'Omurtag'),(3377,1,'Onogur'),(3377,2,'Оногур'),(3377,3,'Onogur'),(3378,1,'Opaka'),(3378,2,'Опака'),(3378,3,'Opaka'),(3379,1,'Opan'),(3379,2,'Опан'),(3379,3,'Opan'),(3380,1,'Opanets'),(3380,2,'Опанец'),(3380,3,'Opanets'),(3381,1,'Opanets'),(3381,2,'Опанец'),(3381,3,'Opanets'),(3382,1,'Opitsvet'),(3382,2,'Опицвет'),(3382,3,'Opitsvet'),(3383,1,'Opletnya'),(3383,2,'Оплетня'),(3383,3,'Opletnya'),(3384,1,'Opalchenets'),(3384,2,'Опълченец'),(3384,3,'Opalchenets'),(3385,1,'Opalchensko'),(3385,2,'Опълченско'),(3385,3,'Opalchensko'),(3386,1,'Orach'),(3386,2,'Орач'),(3386,3,'Orach'),(3387,1,'Oreh'),(3387,2,'Орех'),(3387,3,'Oreh'),(3388,1,'Orehovitsa'),(3388,2,'Ореховица'),(3388,3,'Orehovitsa'),(3389,1,'Orehovo'),(3389,2,'Орехово'),(3389,3,'Orehovo'),(3390,1,'Oresh'),(3390,2,'Ореш'),(3390,3,'Oresh'),(3391,1,'Oreshak'),(3391,2,'Орешак'),(3391,3,'Oreshak'),(3392,1,'Oreshak'),(3392,2,'Орешак'),(3392,3,'Oreshak'),(3393,1,'Oreshari'),(3393,2,'Орешари'),(3393,3,'Oreshari'),(3394,1,'Oreshe'),(3394,2,'Ореше'),(3394,3,'Oreshe'),(3395,1,'Oreshene'),(3395,2,'Орешене'),(3395,3,'Oreshene'),(3396,1,'Oreshene'),(3396,2,'Орешене'),(3396,3,'Oreshene'),(3397,1,'Oreshets'),(3397,2,'Орешец'),(3397,3,'Oreshets'),(3398,1,'Oreshets'),(3398,2,'Орешец'),(3398,3,'Oreshets'),(3399,1,'Oreshets'),(3399,2,'Орешец'),(3399,3,'Oreshets'),(3400,1,'Oreshets'),(3400,2,'Орешец'),(3400,3,'Oreshets'),(3401,1,'Oreshets'),(3401,2,'Орешец'),(3401,3,'Oreshets'),(3402,1,'Oreshino'),(3402,2,'Орешино'),(3402,3,'Oreshino'),(3403,1,'Oreshnik'),(3403,2,'Орешник'),(3403,3,'Oreshnik'),(3404,1,'Oreshnitsa'),(3404,2,'Орешница'),(3404,3,'Oreshnitsa'),(3405,1,'Orizare'),(3405,2,'Оризаре'),(3405,3,'Orizare'),(3406,1,'Orizari'),(3406,2,'Оризари'),(3406,3,'Orizari'),(3407,1,'Orizari'),(3407,2,'Оризари'),(3407,3,'Orizari'),(3408,1,'Orizovo'),(3408,2,'Оризово'),(3408,3,'Orizovo'),(3409,1,'Orlintsi'),(3409,2,'Орлинци'),(3409,3,'Orlintsi'),(3410,1,'Orlitsa'),(3410,2,'Орлица'),(3410,3,'Orlitsa'),(3411,1,'Orlov dol'),(3411,2,'Орлов дол'),(3411,3,'Orlov dol'),(3412,1,'Orlova mogila'),(3412,2,'Орлова могила'),(3412,3,'Orlova mogila'),(3413,1,'Orlovets'),(3413,2,'Орловец'),(3413,3,'Orlovets'),(3414,1,'Orlovo'),(3414,2,'Орлово'),(3414,3,'Orlovo'),(3415,1,'Orlovo'),(3415,2,'Орлово'),(3415,3,'Orlovo'),(3416,1,'Orlovtsi'),(3416,2,'Орловци'),(3416,3,'Orlovtsi'),(3417,1,'Orlyak'),(3417,2,'Орляк'),(3417,3,'Orlyak'),(3418,1,'Orlyane'),(3418,2,'Орляне'),(3418,3,'Orlyane'),(3419,1,'Orsoya'),(3419,2,'Орсоя'),(3419,3,'Orsoya'),(3420,1,'Ortsevo'),(3420,2,'Орцево'),(3420,3,'Ortsevo'),(3421,1,'Oryahovets'),(3421,2,'Оряховец'),(3421,3,'Oryahovets'),(3422,1,'Oryahovitsa'),(3422,2,'Оряховица'),(3422,3,'Oryahovitsa'),(3423,1,'Oryahovo'),(3423,2,'Оряхово'),(3423,3,'Oryahovo'),(3424,1,'Oryahovo'),(3424,2,'Оряхово'),(3424,3,'Oryahovo'),(3425,1,'Oselna'),(3425,2,'Оселна'),(3425,3,'Oselna'),(3426,1,'Oselna'),(3426,2,'Оселна'),(3426,3,'Oselna'),(3427,1,'Osen'),(3427,2,'Осен'),(3427,3,'Osen'),(3428,1,'Osen'),(3428,2,'Осен'),(3428,3,'Osen'),(3429,1,'Osen'),(3429,2,'Осен'),(3429,3,'Osen'),(3430,1,'Osenarite'),(3430,2,'Осенарите'),(3430,3,'Osenarite'),(3431,1,'Osenets'),(3431,2,'Осенец'),(3431,3,'Osenets'),(3432,1,'Osenovets'),(3432,2,'Осеновец'),(3432,3,'Osenovets'),(3433,1,'Osenovlag'),(3433,2,'Осеновлаг'),(3433,3,'Osenovlag'),(3434,1,'Osenovo'),(3434,2,'Осеново'),(3434,3,'Osenovo'),(3435,1,'Osenovo'),(3435,2,'Осеново'),(3435,3,'Osenovo'),(3436,1,'Osetenovo'),(3436,2,'Осетеново'),(3436,3,'Osetenovo'),(3437,1,'Osikovitsa'),(3437,2,'Осиковица'),(3437,3,'Osikovitsa'),(3438,1,'Osikovo'),(3438,2,'Осиково'),(3438,3,'Osikovo'),(3439,1,'Osikovo'),(3439,2,'Осиково'),(3439,3,'Osikovo'),(3440,1,'Osikovo'),(3440,2,'Осиково'),(3440,3,'Osikovo'),(3441,1,'Osikovska Lakavitsa'),(3441,2,'Осиковска Лакавица'),(3441,3,'Osikovska Lakavitsa'),(3442,1,'Osina'),(3442,2,'Осина'),(3442,3,'Osina'),(3443,1,'Oslarka'),(3443,2,'Осларка'),(3443,3,'Oslarka'),(3444,1,'Oslen Krivodol'),(3444,2,'Ослен Криводол'),(3444,3,'Oslen Krivodol'),(3445,1,'Osmar'),(3445,2,'Осмар'),(3445,3,'Osmar'),(3446,1,'Osoitsa'),(3446,2,'Осоица'),(3446,3,'Osoitsa'),(3447,1,'Ostra mogila'),(3447,2,'Остра могила'),(3447,3,'Ostra mogila'),(3448,1,'Ostra mogila'),(3448,2,'Остра могила'),(3448,3,'Ostra mogila'),(3449,1,'Ostrets'),(3449,2,'Острец'),(3449,3,'Ostrets'),(3450,1,'Ostri pazlak'),(3450,2,'Остри пазлак'),(3450,3,'Ostri pazlak'),(3451,1,'Ostritsa'),(3451,2,'Острица'),(3451,3,'Ostritsa'),(3452,1,'Ostritsa'),(3452,2,'Острица'),(3452,3,'Ostritsa'),(3453,1,'Ostrov'),(3453,2,'Остров'),(3453,3,'Ostrov'),(3454,1,'Ostrovets'),(3454,2,'Островец'),(3454,3,'Ostrovets'),(3455,1,'Ostrovitsa'),(3455,2,'Островица'),(3455,3,'Ostrovitsa'),(3456,1,'Ostrovo'),(3456,2,'Острово'),(3456,3,'Ostrovo'),(3457,1,'Ostrovche'),(3457,2,'Островче'),(3457,3,'Ostrovche'),(3458,1,'Ostrokaptsi'),(3458,2,'Острокапци'),(3458,3,'Ostrokaptsi'),(3459,1,'Ostar kamak'),(3459,2,'Остър камък'),(3459,3,'Ostar kamak'),(3460,1,'Otets Kirilovo'),(3460,2,'Отец Кирилово'),(3460,3,'Otets Kirilovo'),(3461,1,'Otets Paisievo'),(3461,2,'Отец Паисиево'),(3461,3,'Otets Paisievo'),(3462,1,'Ohlyuvets'),(3462,2,'Охлювец'),(3462,3,'Ohlyuvets'),(3463,1,'Ohoden'),(3463,2,'Оходен'),(3463,3,'Ohoden'),(3464,1,'Ohrid'),(3464,2,'Охрид'),(3464,3,'Ohrid'),(3465,1,'Ochindol'),(3465,2,'Очиндол'),(3465,3,'Ochindol'),(3466,1,'Ochusha'),(3466,2,'Очуша'),(3466,3,'Ochusha'),(3467,1,'Oshane'),(3467,2,'Ошане'),(3467,3,'Oshane'),(3468,1,'Oshanite'),(3468,2,'Ошаните'),(3468,3,'Oshanite'),(3469,1,'Oshtava'),(3469,2,'Ощава'),(3469,3,'Oshtava'),(3470,1,'Pavel'),(3470,2,'Павел'),(3470,3,'Pavel'),(3471,1,'Pavel banya'),(3471,2,'Павел баня'),(3471,3,'Pavel banya'),(3472,1,'Pavelsko'),(3472,2,'Павелско'),(3472,3,'Pavelsko'),(3473,1,'Pavlevtsi'),(3473,2,'Павлевци'),(3473,3,'Pavlevtsi'),(3474,1,'Pavlikeni'),(3474,2,'Павликени'),(3474,3,'Pavlikeni'),(3475,1,'Pavolche'),(3475,2,'Паволче'),(3475,3,'Pavolche'),(3476,1,'Padala'),(3476,2,'Падала'),(3476,3,'Padala'),(3477,1,'Padalo'),(3477,2,'Падало'),(3477,3,'Padalo'),(3478,1,'Padesh'),(3478,2,'Падеш'),(3478,3,'Padesh'),(3479,1,'Padina'),(3479,2,'Падина'),(3479,3,'Padina'),(3480,1,'Padina'),(3480,2,'Падина'),(3480,3,'Padina'),(3481,1,'Padina'),(3481,2,'Падина'),(3481,3,'Padina'),(3482,1,'Padine'),(3482,2,'Падине'),(3482,3,'Padine'),(3483,1,'Pazardzhik'),(3483,2,'Пазарджик'),(3483,3,'Pazardzhik'),(3484,1,'Pazartsi'),(3484,2,'Пазарци'),(3484,3,'Pazartsi'),(3485,1,'Paisievo'),(3485,2,'Паисиево'),(3485,3,'Paisievo'),(3486,1,'Paisiy'),(3486,2,'Паисий'),(3486,3,'Paisiy'),(3487,1,'Paydushko'),(3487,2,'Пайдушко'),(3487,3,'Paydushko'),(3488,1,'Palamartsa'),(3488,2,'Паламарца'),(3488,3,'Palamartsa'),(3489,1,'Palat'),(3489,2,'Палат'),(3489,3,'Palat'),(3490,1,'Palatik'),(3490,2,'Палатик'),(3490,3,'Palatik'),(3491,1,'Palatovo'),(3491,2,'Палатово'),(3491,3,'Palatovo'),(3492,1,'Palauzovo'),(3492,2,'Палаузово'),(3492,3,'Palauzovo'),(3493,1,'Palilula'),(3493,2,'Палилула'),(3493,3,'Palilula'),(3494,1,'Palitsi'),(3494,2,'Палици'),(3494,3,'Palitsi'),(3495,1,'Pamidovo'),(3495,2,'Памидово'),(3495,3,'Pamidovo'),(3496,1,'Pamukchii'),(3496,2,'Памукчии'),(3496,3,'Pamukchii'),(3497,1,'Pamukchii'),(3497,2,'Памукчии'),(3497,3,'Pamukchii'),(3498,1,'Panagyurishte'),(3498,2,'Панагюрище'),(3498,3,'Panagyurishte'),(3499,1,'Panagyurski kolonii'),(3499,2,'Панагюрски колонии'),(3499,3,'Panagyurski kolonii'),(3500,1,'Panayot Volovo'),(3500,2,'Панайот Волово'),(3500,3,'Panayot Volovo'),(3501,1,'Panayot Hitovo'),(3501,2,'Панайот Хитово'),(3501,3,'Panayot Hitovo'),(3502,1,'Panaretovtsi'),(3502,2,'Панаретовци'),(3502,3,'Panaretovtsi'),(3503,1,'Panitsovo'),(3503,2,'Паницово'),(3503,3,'Panitsovo'),(3504,1,'Panicharevo'),(3504,2,'Паничарево'),(3504,3,'Panicharevo'),(3505,1,'Panicherevo'),(3505,2,'Паничерево'),(3505,3,'Panicherevo'),(3506,1,'Panicheri'),(3506,2,'Паничери'),(3506,3,'Panicheri'),(3507,1,'Panichino'),(3507,2,'Паничино'),(3507,3,'Panichino'),(3508,1,'Panichishte'),(3508,2,'Паничище'),(3508,3,'Panichishte'),(3509,1,'Panichkovo'),(3509,2,'Паничково'),(3509,3,'Panichkovo'),(3510,1,'Panovtsi'),(3510,2,'Пановци'),(3510,3,'Panovtsi'),(3511,1,'Pancharevo'),(3511,2,'Панчарево'),(3511,3,'Pancharevo'),(3512,1,'Panchevo'),(3512,2,'Панчево'),(3512,3,'Panchevo'),(3513,1,'Paprat'),(3513,2,'Папрат'),(3513,3,'Paprat'),(3514,1,'Papratliva'),(3514,2,'Папратлива'),(3514,3,'Papratliva'),(3515,1,'Paramun'),(3515,2,'Парамун'),(3515,3,'Paramun'),(3516,1,'Paril'),(3516,2,'Парил'),(3516,3,'Paril'),(3517,1,'Partizani'),(3517,2,'Партизани'),(3517,3,'Partizani'),(3518,1,'Partizanin'),(3518,2,'Партизанин'),(3518,3,'Partizanin'),(3519,1,'Parchovtsi'),(3519,2,'Парчовци'),(3519,3,'Parchovtsi'),(3520,1,'Paskalevets'),(3520,2,'Паскалевец'),(3520,3,'Paskalevets'),(3521,1,'Paskalevo'),(3521,2,'Паскалево'),(3521,3,'Paskalevo'),(3522,1,'Paspal'),(3522,2,'Паспал'),(3522,3,'Paspal'),(3523,1,'Pastra'),(3523,2,'Пастра'),(3523,3,'Pastra'),(3524,1,'Pastuh'),(3524,2,'Пастух'),(3524,3,'Pastuh'),(3525,1,'Patalenitsa'),(3525,2,'Паталеница'),(3525,3,'Patalenitsa'),(3526,1,'Patitsa'),(3526,2,'Патица'),(3526,3,'Patitsa'),(3527,1,'Patresh'),(3527,2,'Патреш'),(3527,3,'Patresh'),(3528,1,'Patreshko'),(3528,2,'Патрешко'),(3528,3,'Patreshko'),(3529,1,'Patriarh Evtimovo'),(3529,2,'Патриарх Евтимово'),(3529,3,'Patriarh Evtimovo'),(3530,1,'Paunovo'),(3530,2,'Пауново'),(3530,3,'Paunovo'),(3531,1,'Pashintsi'),(3531,2,'Пашинци'),(3531,3,'Pashintsi'),(3532,1,'Pashkul'),(3532,2,'Пашкул'),(3532,3,'Pashkul'),(3533,1,'Pashovi'),(3533,2,'Пашови'),(3533,3,'Pashovi'),(3534,1,'Pashovo'),(3534,2,'Пашово'),(3534,3,'Pashovo'),(3535,1,'Pevets'),(3535,2,'Певец'),(3535,3,'Pevets'),(3536,1,'Pevtsite'),(3536,2,'Певците'),(3536,3,'Pevtsite'),(3537,1,'Peykovtsi'),(3537,2,'Пейковци'),(3537,3,'Peykovtsi'),(3538,1,'Peyna'),(3538,2,'Пейна'),(3538,3,'Peyna'),(3539,1,'Peyovtsi'),(3539,2,'Пейовци'),(3539,3,'Peyovtsi'),(3540,1,'Peychinovo'),(3540,2,'Пейчиново'),(3540,3,'Peychinovo'),(3541,1,'Pelatikovo'),(3541,2,'Пелатиково'),(3541,3,'Pelatikovo'),(3542,1,'Pelin'),(3542,2,'Пелин'),(3542,3,'Pelin'),(3543,1,'Pelishat'),(3543,2,'Пелишат'),(3543,3,'Pelishat'),(3544,1,'Penkovtsi'),(3544,2,'Пенковци'),(3544,3,'Penkovtsi'),(3545,1,'Penkyovtsi'),(3545,2,'Пенкьовци'),(3545,3,'Penkyovtsi'),(3546,1,'Penyovo'),(3546,2,'Пеньово'),(3546,3,'Penyovo'),(3547,1,'Pepelina'),(3547,2,'Пепелина'),(3547,3,'Pepelina'),(3548,1,'Pepelishte'),(3548,2,'Пепелище'),(3548,3,'Pepelishte'),(3549,1,'Perilovets'),(3549,2,'Периловец'),(3549,3,'Perilovets'),(3550,1,'Pernik'),(3550,2,'Перник'),(3550,3,'Pernik'),(3551,1,'Perperek'),(3551,2,'Перперек'),(3551,3,'Perperek'),(3552,1,'Perunika'),(3552,2,'Перуника'),(3552,3,'Perunika'),(3553,1,'Perushtitsa'),(3553,2,'Перущица'),(3553,3,'Perushtitsa'),(3554,1,'Pesnopoy'),(3554,2,'Песнопой'),(3554,3,'Pesnopoy'),(3555,1,'Pesnopoy'),(3555,2,'Песнопой'),(3555,3,'Pesnopoy'),(3556,1,'Pesochnitsa'),(3556,2,'Песочница'),(3556,3,'Pesochnitsa'),(3557,1,'Pet kladentsi'),(3557,2,'Пет кладенци'),(3557,3,'Pet kladentsi'),(3558,1,'Pet mogili'),(3558,2,'Пет могили'),(3558,3,'Pet mogili'),(3559,1,'Pet mogili'),(3559,2,'Пет могили'),(3559,3,'Pet mogili'),(3560,1,'Petelovo'),(3560,2,'Петелово'),(3560,3,'Petelovo'),(3561,1,'Petko Karavelovo'),(3561,2,'Петко Каравелово'),(3561,3,'Petko Karavelovo'),(3562,1,'Petko Slaveykov'),(3562,2,'Петко Славейков'),(3562,3,'Petko Slaveykov'),(3563,1,'Petkovo'),(3563,2,'Петково'),(3563,3,'Petkovo'),(3564,1,'Petkovo'),(3564,2,'Петково'),(3564,3,'Petkovo'),(3565,1,'Petkovtsi'),(3565,2,'Петковци'),(3565,3,'Petkovtsi'),(3566,1,'Petkovtsi'),(3566,2,'Петковци'),(3566,3,'Petkovtsi'),(3567,1,'Petleshkovo'),(3567,2,'Петлешково'),(3567,3,'Petleshkovo'),(3568,1,'Petlino'),(3568,2,'Петлино'),(3568,3,'Petlino'),(3569,1,'Petokladentsi'),(3569,2,'Петокладенци'),(3569,3,'Petokladentsi'),(3570,1,'Petrevene'),(3570,2,'Петревене'),(3570,3,'Petrevene'),(3571,1,'Petrelik'),(3571,2,'Петрелик'),(3571,3,'Petrelik'),(3572,1,'Petrino'),(3572,2,'Петрино'),(3572,3,'Petrino'),(3573,1,'Petrich'),(3573,2,'Петрич'),(3573,3,'Petrich'),(3574,1,'Petrich'),(3574,2,'Петрич'),(3574,3,'Petrich'),(3575,1,'Petrov dol'),(3575,2,'Петров дол'),(3575,3,'Petrov dol'),(3576,1,'Petrov dol'),(3576,2,'Петров дол'),(3576,3,'Petrov dol'),(3577,1,'Petrovo'),(3577,2,'Петрово'),(3577,3,'Petrovo'),(3578,1,'Petrovo'),(3578,2,'Петрово'),(3578,3,'Petrovo'),(3579,1,'Petrovtsi'),(3579,2,'Петровци'),(3579,3,'Petrovtsi'),(3580,1,'Petarnitsa'),(3580,2,'Петърница'),(3580,3,'Petarnitsa'),(3581,1,'Petarch'),(3581,2,'Петърч'),(3581,3,'Petarch'),(3582,1,'Petsovtsi'),(3582,2,'Пецовци'),(3582,3,'Petsovtsi'),(3583,1,'Pechenitsa'),(3583,2,'Печеница'),(3583,3,'Pechenitsa'),(3584,1,'Pechinska'),(3584,2,'Печинска'),(3584,3,'Pechinska'),(3585,1,'Peshakovo'),(3585,2,'Пешаково'),(3585,3,'Peshakovo'),(3586,1,'Peshtera'),(3586,2,'Пещера'),(3586,3,'Peshtera'),(3587,1,'Peshtera'),(3587,2,'Пещера'),(3587,3,'Peshtera'),(3588,1,'Peshtera'),(3588,2,'Пещера'),(3588,3,'Peshtera'),(3589,1,'Peshterna'),(3589,2,'Пещерна'),(3589,3,'Peshterna'),(3590,1,'Peshtersko'),(3590,2,'Пещерско'),(3590,3,'Peshtersko'),(3591,1,'Piperevo'),(3591,2,'Пиперево'),(3591,3,'Piperevo'),(3592,1,'Piperitsa'),(3592,2,'Пиперица'),(3592,3,'Piperitsa'),(3593,1,'Piperkov chiflik'),(3593,2,'Пиперков чифлик'),(3593,3,'Piperkov chiflik'),(3594,1,'Piperkovo'),(3594,2,'Пиперково'),(3594,3,'Piperkovo'),(3595,1,'Piramidata'),(3595,2,'Пирамидата'),(3595,3,'Piramidata'),(3596,1,'Pirgovo'),(3596,2,'Пиргово'),(3596,3,'Pirgovo'),(3597,1,'Pirdop'),(3597,2,'Пирдоп'),(3597,3,'Pirdop'),(3598,1,'Pirin'),(3598,2,'Пирин'),(3598,3,'Pirin'),(3599,1,'Pirinets'),(3599,2,'Пиринец'),(3599,3,'Pirinets'),(3600,1,'Pirne'),(3600,2,'Пирне'),(3600,3,'Pirne'),(3601,1,'Pisanets'),(3601,2,'Писанец'),(3601,3,'Pisanets'),(3602,1,'Pisanitsa'),(3602,2,'Писаница'),(3602,3,'Pisanitsa'),(3603,1,'Pisarevo'),(3603,2,'Писарево'),(3603,3,'Pisarevo'),(3604,1,'Pisarevo'),(3604,2,'Писарево'),(3604,3,'Pisarevo'),(3605,1,'Pisarovo'),(3605,2,'Писарово'),(3605,3,'Pisarovo'),(3606,1,'Pisarovo'),(3606,2,'Писарово'),(3606,3,'Pisarovo'),(3607,1,'Pismenovo'),(3607,2,'Писменово'),(3607,3,'Pismenovo'),(3608,1,'Pitovo'),(3608,2,'Питово'),(3608,3,'Pitovo'),(3609,1,'Pishurka'),(3609,2,'Пишурка'),(3609,3,'Pishurka'),(3610,1,'Pishtane'),(3610,2,'Пищане'),(3610,3,'Pishtane'),(3611,1,'Pishtigovo'),(3611,2,'Пищигово'),(3611,3,'Pishtigovo'),(3612,1,'Piavets'),(3612,2,'Пиявец'),(3612,3,'Piavets'),(3613,1,'Plazishte'),(3613,2,'Плазище'),(3613,3,'Plazishte'),(3614,1,'Plakovo'),(3614,2,'Плаково'),(3614,3,'Plakovo'),(3615,1,'Plakuder'),(3615,2,'Плакудер'),(3615,3,'Plakuder'),(3616,1,'Plana'),(3616,2,'Плана'),(3616,3,'Plana'),(3617,1,'Planinets'),(3617,2,'Планинец'),(3617,3,'Planinets'),(3618,1,'Planinitsa'),(3618,2,'Планиница'),(3618,3,'Planinitsa'),(3619,1,'Planinitsa'),(3619,2,'Планиница'),(3619,3,'Planinitsa'),(3620,1,'Planinovo'),(3620,2,'Планиново'),(3620,3,'Planinovo'),(3621,1,'Planinsko'),(3621,2,'Планинско'),(3621,3,'Planinsko'),(3622,1,'Planintsi'),(3622,2,'Планинци'),(3622,3,'Planintsi'),(3623,1,'Planintsi'),(3623,2,'Планинци'),(3623,3,'Planintsi'),(3624,1,'Plachidol'),(3624,2,'Плачидол'),(3624,3,'Plachidol'),(3625,1,'Plachka'),(3625,2,'Плачка'),(3625,3,'Plachka'),(3626,1,'Plachkovtsi'),(3626,2,'Плачковци'),(3626,3,'Plachkovtsi'),(3627,1,'Pleven'),(3627,2,'Плевен'),(3627,3,'Pleven'),(3628,1,'Plevun'),(3628,2,'Плевун'),(3628,3,'Plevun'),(3629,1,'Plenimir'),(3629,2,'Пленимир'),(3629,3,'Plenimir'),(3630,1,'Pletena'),(3630,2,'Плетена'),(3630,3,'Pletena'),(3631,1,'Pleshivets'),(3631,2,'Плешивец'),(3631,3,'Pleshivets'),(3632,1,'Pleshintsi'),(3632,2,'Плешинци'),(3632,3,'Pleshintsi'),(3633,1,'Pliska'),(3633,2,'Плиска'),(3633,3,'Pliska'),(3634,1,'Plovdiv'),(3634,2,'Пловдив'),(3634,3,'Plovdiv'),(3635,1,'Plovdivtsi'),(3635,2,'Пловдивци'),(3635,3,'Plovdivtsi'),(3636,1,'Plovka'),(3636,2,'Пловка'),(3636,3,'Plovka'),(3637,1,'Plodovitovo'),(3637,2,'Плодовитово'),(3637,3,'Plodovitovo'),(3638,1,'Ploska mogila'),(3638,2,'Плоска могила'),(3638,3,'Ploska mogila'),(3639,1,'Ploski'),(3639,2,'Плоски'),(3639,3,'Ploski'),(3640,1,'Plazishte'),(3640,2,'Плъзище'),(3640,3,'Plazishte'),(3641,1,'Plastina'),(3641,2,'Плъстина'),(3641,3,'Plastina'),(3642,1,'Pobeda'),(3642,2,'Победа'),(3642,3,'Pobeda'),(3643,1,'Pobeda'),(3643,2,'Победа'),(3643,3,'Pobeda'),(3644,1,'Pobeda'),(3644,2,'Победа'),(3644,3,'Pobeda'),(3645,1,'Pobit kamak'),(3645,2,'Побит камък'),(3645,3,'Pobit kamak'),(3646,1,'Pobit kamak'),(3646,2,'Побит камък'),(3646,3,'Pobit kamak'),(3647,1,'Pobit kamak'),(3647,2,'Побит камък'),(3647,3,'Pobit kamak'),(3648,1,'Pobak'),(3648,2,'Побък'),(3648,3,'Pobak'),(3649,1,'Povalirazh'),(3649,2,'Повалиръж'),(3649,3,'Povalirazh'),(3650,1,'Povet'),(3650,2,'Повет'),(3650,3,'Povet'),(3651,1,'Podayva'),(3651,2,'Подайва'),(3651,3,'Podayva'),(3652,1,'Podvis'),(3652,2,'Подвис'),(3652,3,'Podvis'),(3653,1,'Podvis'),(3653,2,'Подвис'),(3653,3,'Podvis'),(3654,1,'Podvrah'),(3654,2,'Подвръх'),(3654,3,'Podvrah'),(3655,1,'Podgore'),(3655,2,'Подгоре'),(3655,3,'Podgore'),(3656,1,'Podgorets'),(3656,2,'Подгорец'),(3656,3,'Podgorets'),(3657,1,'Podgorie'),(3657,2,'Подгорие'),(3657,3,'Podgorie'),(3658,1,'Podgoritsa'),(3658,2,'Подгорица'),(3658,3,'Podgoritsa'),(3659,1,'Podgumer'),(3659,2,'Подгумер'),(3659,3,'Podgumer'),(3660,1,'Podem'),(3660,2,'Подем'),(3660,3,'Podem'),(3661,1,'Podkova'),(3661,2,'Подкова'),(3661,3,'Podkova'),(3662,1,'Podkrepa'),(3662,2,'Подкрепа'),(3662,3,'Podkrepa'),(3663,1,'Podles'),(3663,2,'Подлес'),(3663,3,'Podles'),(3664,1,'Podrumche'),(3664,2,'Подрумче'),(3664,3,'Podrumche'),(3665,1,'Podslon'),(3665,2,'Подслон'),(3665,3,'Podslon'),(3666,1,'Podslon'),(3666,2,'Подслон'),(3666,3,'Podslon'),(3667,1,'Pozharevo'),(3667,2,'Пожарево'),(3667,3,'Pozharevo'),(3668,1,'Pozharevo'),(3668,2,'Пожарево'),(3668,3,'Pozharevo'),(3669,1,'Pozhernik'),(3669,2,'Пожерник'),(3669,3,'Pozhernik'),(3670,1,'Poibrene'),(3670,2,'Поибрене'),(3670,3,'Poibrene'),(3671,1,'Pokrayna'),(3671,2,'Покрайна'),(3671,3,'Pokrayna'),(3672,1,'Pokrovan'),(3672,2,'Покрован'),(3672,3,'Pokrovan'),(3673,1,'Pokrovnik'),(3673,2,'Покровник'),(3673,3,'Pokrovnik'),(3674,1,'Polena'),(3674,2,'Полена'),(3674,3,'Polena'),(3675,1,'Polenitsa'),(3675,2,'Поленица'),(3675,3,'Polenitsa'),(3676,1,'Poletintsi'),(3676,2,'Полетинци'),(3676,3,'Poletintsi'),(3677,1,'Poletkovtsi'),(3677,2,'Полетковци'),(3677,3,'Poletkovtsi'),(3678,1,'Poleto'),(3678,2,'Полето'),(3678,3,'Poleto'),(3679,1,'Polikraishte'),(3679,2,'Поликраище'),(3679,3,'Polikraishte'),(3680,1,'Polkovnik Dyakovo'),(3680,2,'Полковник Дяково'),(3680,3,'Polkovnik Dyakovo'),(3681,1,'Polkovnik Zhelyazovo'),(3681,2,'Полковник Желязово'),(3681,3,'Polkovnik Zhelyazovo'),(3682,1,'Polkovnik ivanovo'),(3682,2,'Полковник Иваново'),(3682,3,'Polkovnik ivanovo'),(3683,1,'Polkovnik Lambrinovo'),(3683,2,'Полковник Ламбриново'),(3683,3,'Polkovnik Lambrinovo'),(3684,1,'Polkovnik Minkovo'),(3684,2,'Полковник Минково'),(3684,3,'Polkovnik Minkovo'),(3685,1,'Polkovnik Savovo'),(3685,2,'Полковник Савово'),(3685,3,'Polkovnik Savovo'),(3686,1,'Polkovnik Sveshtarovo'),(3686,2,'Полковник Свещарово'),(3686,3,'Polkovnik Sveshtarovo'),(3687,1,'Polkovnik Serafimovo'),(3687,2,'Полковник Серафимово'),(3687,3,'Polkovnik Serafimovo'),(3688,1,'Polkovnik Taslakovo'),(3688,2,'Полковник Таслаково'),(3688,3,'Polkovnik Taslakovo'),(3689,1,'Polkovnik Cholakovo'),(3689,2,'Полковник Чолаково'),(3689,3,'Polkovnik Cholakovo'),(3690,1,'Polska Skakavitsa'),(3690,2,'Полска Скакавица'),(3690,3,'Polska Skakavitsa'),(3691,1,'Polski Gradets'),(3691,2,'Полски Градец'),(3691,3,'Polski Gradets'),(3692,1,'Polski izvor'),(3692,2,'Полски извор'),(3692,3,'Polski izvor'),(3693,1,'Polski Senovets'),(3693,2,'Полски Сеновец'),(3693,3,'Polski Senovets'),(3694,1,'Polski Trambesh'),(3694,2,'Полски Тръмбеш'),(3694,3,'Polski Trambesh'),(3695,1,'Polsko Kosovo'),(3695,2,'Полско Косово'),(3695,3,'Polsko Kosovo'),(3696,1,'Polsko Padarevo'),(3696,2,'Полско Пъдарево'),(3696,3,'Polsko Padarevo'),(3697,1,'Polyana'),(3697,2,'Поляна'),(3697,3,'Polyana'),(3698,1,'Polyana'),(3698,2,'Поляна'),(3698,3,'Polyana'),(3699,1,'Polyana'),(3699,2,'Поляна'),(3699,3,'Polyana'),(3700,1,'Polyanets'),(3700,2,'Полянец'),(3700,3,'Polyanets'),(3701,1,'Polyanovo'),(3701,2,'Поляново'),(3701,3,'Polyanovo'),(3702,1,'Polyanovo'),(3702,2,'Поляново'),(3702,3,'Polyanovo'),(3703,1,'Polyantsi'),(3703,2,'Полянци'),(3703,3,'Polyantsi'),(3704,1,'Polyatsite'),(3704,2,'Поляците'),(3704,3,'Polyatsite'),(3705,1,'Pomezhdin'),(3705,2,'Помеждин'),(3705,3,'Pomezhdin'),(3706,1,'Pomen'),(3706,2,'Помен'),(3706,3,'Pomen'),(3707,1,'Pomorie'),(3707,2,'Поморие'),(3707,3,'Pomorie'),(3708,1,'Pomoshtitsa'),(3708,2,'Помощица'),(3708,3,'Pomoshtitsa'),(3709,1,'Pomoshtnik'),(3709,2,'Помощник'),(3709,3,'Pomoshtnik'),(3710,1,'Ponor'),(3710,2,'Понор'),(3710,3,'Ponor'),(3711,1,'Popari'),(3711,2,'Попари'),(3711,3,'Popari'),(3712,1,'Popgergevtsi'),(3712,2,'Попгергевци'),(3712,3,'Popgergevtsi'),(3713,1,'Popgrigorovo'),(3713,2,'Попгригорово'),(3713,3,'Popgrigorovo'),(3714,1,'Popgruevo'),(3714,2,'Попгруево'),(3714,3,'Popgruevo'),(3715,1,'Popina'),(3715,2,'Попина'),(3715,3,'Popina'),(3716,1,'Popintsi'),(3716,2,'Попинци'),(3716,3,'Popintsi'),(3717,1,'Popitsa'),(3717,2,'Попица'),(3717,3,'Popitsa'),(3718,1,'Popkralevo'),(3718,2,'Попкралево'),(3718,3,'Popkralevo'),(3719,1,'Popovets'),(3719,2,'Поповец'),(3719,3,'Popovets'),(3720,1,'Popovitsa'),(3720,2,'Поповица'),(3720,3,'Popovitsa'),(3721,1,'Popovich'),(3721,2,'Попович'),(3721,3,'Popovich'),(3722,1,'Popovo'),(3722,2,'Попово'),(3722,3,'Popovo'),(3723,1,'Popovo'),(3723,2,'Попово'),(3723,3,'Popovo'),(3724,1,'Popovtsi'),(3724,2,'Поповци'),(3724,3,'Popovtsi'),(3725,1,'Popovtsi'),(3725,2,'Поповци'),(3725,3,'Popovtsi'),(3726,1,'Popovtsi'),(3726,2,'Поповци'),(3726,3,'Popovtsi'),(3727,1,'Popovyane'),(3727,2,'Поповяне'),(3727,3,'Popovyane'),(3728,1,'Popraykovtsi'),(3728,2,'Попрайковци'),(3728,3,'Popraykovtsi'),(3729,1,'Poprelka'),(3729,2,'Попрелка'),(3729,3,'Poprelka'),(3730,1,'Poprusanovo'),(3730,2,'Попрусаново'),(3730,3,'Poprusanovo'),(3731,1,'Poprusevtsi'),(3731,2,'Попрусевци'),(3731,3,'Poprusevtsi'),(3732,1,'Popska'),(3732,2,'Попска'),(3732,3,'Popska'),(3733,1,'Popska'),(3733,2,'Попска'),(3733,3,'Popska'),(3734,1,'Popsko'),(3734,2,'Попско'),(3734,3,'Popsko'),(3735,1,'Pordim'),(3735,2,'Пордим'),(3735,3,'Pordim'),(3736,1,'Poroishte'),(3736,2,'Пороище'),(3736,3,'Poroishte'),(3737,1,'Poroy'),(3737,2,'Порой'),(3737,3,'Poroy'),(3738,1,'Poroyna'),(3738,2,'Поройна'),(3738,3,'Poroyna'),(3739,1,'Poroyno'),(3739,2,'Поройно'),(3739,3,'Poroyno'),(3740,1,'Poroyno'),(3740,2,'Поройно'),(3740,3,'Poroyno'),(3741,1,'Porominovo'),(3741,2,'Пороминово'),(3741,3,'Porominovo'),(3742,1,'Portitovtsi'),(3742,2,'Портитовци'),(3742,3,'Portitovtsi'),(3743,1,'Poruchik Kardzhievo'),(3743,2,'Поручик Кърджиево'),(3743,3,'Poruchik Kardzhievo'),(3744,1,'Poruchik Chunchevo'),(3744,2,'Поручик Чунчево'),(3744,3,'Poruchik Chunchevo'),(3745,1,'Posabina'),(3745,2,'Посабина'),(3745,3,'Posabina'),(3746,1,'Posev'),(3746,2,'Посев'),(3746,3,'Posev'),(3747,1,'Postnik'),(3747,2,'Постник'),(3747,3,'Postnik'),(3748,1,'Potok'),(3748,2,'Поток'),(3748,3,'Potok'),(3749,1,'Potoka'),(3749,2,'Потока'),(3749,3,'Potoka'),(3750,1,'Potop'),(3750,2,'Потоп'),(3750,3,'Potop'),(3751,1,'Potocharka'),(3751,2,'Поточарка'),(3751,3,'Potocharka'),(3752,1,'Potoche'),(3752,2,'Поточе'),(3752,3,'Potoche'),(3753,1,'Potochnitsa'),(3753,2,'Поточница'),(3753,3,'Potochnitsa'),(3754,1,'Potsarnentsi'),(3754,2,'Поцърненци'),(3754,3,'Potsarnentsi'),(3755,1,'Pravda'),(3755,2,'Правда'),(3755,3,'Pravda'),(3756,1,'Pravda'),(3756,2,'Правда'),(3756,3,'Pravda'),(3757,1,'Pravdino'),(3757,2,'Правдино'),(3757,3,'Pravdino'),(3758,1,'Pravdolyub'),(3758,2,'Правдолюб'),(3758,3,'Pravdolyub'),(3759,1,'Praventsi'),(3759,2,'Правенци'),(3759,3,'Praventsi'),(3760,1,'Pravets'),(3760,2,'Правец'),(3760,3,'Pravets'),(3761,1,'Praveshka Lakavitsa'),(3761,2,'Правешка Лакавица'),(3761,3,'Praveshka Lakavitsa'),(3762,1,'Pravishte'),(3762,2,'Правище'),(3762,3,'Pravishte'),(3763,1,'Pravo bardo'),(3763,2,'Право бърдо'),(3763,3,'Pravo bardo'),(3764,1,'Pravoslav'),(3764,2,'Православ'),(3764,3,'Pravoslav'),(3765,1,'Pravoslaven'),(3765,2,'Православен'),(3765,3,'Pravoslaven'),(3766,1,'Prauzhda'),(3766,2,'Праужда'),(3766,3,'Prauzhda'),(3767,1,'Prahali'),(3767,2,'Прахали'),(3767,3,'Prahali'),(3768,1,'Prevala'),(3768,2,'Превала'),(3768,3,'Prevala'),(3769,1,'Prekolnitsa'),(3769,2,'Преколница'),(3769,3,'Prekolnitsa'),(3770,1,'Prekraste'),(3770,2,'Прекръсте'),(3770,3,'Prekraste'),(3771,1,'Prelez'),(3771,2,'Прелез'),(3771,3,'Prelez'),(3772,1,'Prelom'),(3772,2,'Прелом'),(3772,3,'Prelom'),(3773,1,'Preobrazhentsi'),(3773,2,'Преображенци'),(3773,3,'Preobrazhentsi'),(3774,1,'Preseka'),(3774,2,'Пресека'),(3774,3,'Preseka'),(3775,1,'Preselentsi'),(3775,2,'Преселенци'),(3775,3,'Preselentsi'),(3776,1,'Preselets'),(3776,2,'Преселец'),(3776,3,'Preselets'),(3777,1,'Preselka'),(3777,2,'Преселка'),(3777,3,'Preselka'),(3778,1,'Presian'),(3778,2,'Пресиян'),(3778,3,'Presian'),(3779,1,'Preslaven'),(3779,2,'Преславен'),(3779,3,'Preslaven'),(3780,1,'Preslavets'),(3780,2,'Преславец'),(3780,3,'Preslavets'),(3781,1,'Preslavtsi'),(3781,2,'Преславци'),(3781,3,'Preslavtsi'),(3782,1,'Presoka'),(3782,2,'Пресока'),(3782,3,'Presoka'),(3783,1,'Prespa'),(3783,2,'Преспа'),(3783,3,'Prespa'),(3784,1,'Prespa'),(3784,2,'Преспа'),(3784,3,'Prespa'),(3785,1,'Prestoy'),(3785,2,'Престой'),(3785,3,'Prestoy'),(3786,1,'Presyak'),(3786,2,'Пресяк'),(3786,3,'Presyak'),(3787,1,'Presyaka'),(3787,2,'Пресяка'),(3787,3,'Presyaka'),(3788,1,'Priboy'),(3788,2,'Прибой'),(3788,3,'Priboy'),(3789,1,'Prilep'),(3789,2,'Прилеп'),(3789,3,'Prilep'),(3790,1,'Prilep'),(3790,2,'Прилеп'),(3790,3,'Prilep'),(3791,1,'Prileptsi'),(3791,2,'Прилепци'),(3791,3,'Prileptsi'),(3792,1,'Primorsko'),(3792,2,'Приморско'),(3792,3,'Primorsko'),(3793,1,'Primortsi'),(3793,2,'Приморци'),(3793,3,'Primortsi'),(3794,1,'Pripek'),(3794,2,'Припек'),(3794,3,'Pripek'),(3795,1,'Pripek'),(3795,2,'Припек'),(3795,3,'Pripek'),(3796,1,'Pripek'),(3796,2,'Припек'),(3796,3,'Pripek'),(3797,1,'Prisad'),(3797,2,'Присад'),(3797,3,'Prisad'),(3798,1,'Prisad'),(3798,2,'Присад'),(3798,3,'Prisad'),(3799,1,'Prisadets'),(3799,2,'Присадец'),(3799,3,'Prisadets'),(3800,1,'Priseltsi'),(3800,2,'Приселци'),(3800,3,'Priseltsi'),(3801,1,'Priseltsi'),(3801,2,'Приселци'),(3801,3,'Priseltsi'),(3802,1,'Prisovo'),(3802,2,'Присово'),(3802,3,'Prisovo'),(3803,1,'Prisoyna'),(3803,2,'Присойна'),(3803,3,'Prisoyna'),(3804,1,'Pristoe'),(3804,2,'Пристое'),(3804,3,'Pristoe'),(3805,1,'Probuda'),(3805,2,'Пробуда'),(3805,3,'Probuda'),(3806,1,'Provadia'),(3806,2,'Провадия'),(3806,3,'Provadia'),(3807,1,'Progled'),(3807,2,'Проглед'),(3807,3,'Progled'),(3808,1,'Progres'),(3808,2,'Прогрес'),(3808,3,'Progres'),(3809,1,'Prodanovtsi'),(3809,2,'Продановци'),(3809,3,'Prodanovtsi'),(3810,1,'Prodanovtsi'),(3810,2,'Продановци'),(3810,3,'Prodanovtsi'),(3811,1,'Prodanovtsi'),(3811,2,'Продановци'),(3811,3,'Prodanovtsi'),(3812,1,'Prodancha'),(3812,2,'Проданча'),(3812,3,'Prodancha'),(3813,1,'Prolaz'),(3813,2,'Пролаз'),(3813,3,'Prolaz'),(3814,1,'Prolaznitsa'),(3814,2,'Пролазница'),(3814,3,'Prolaznitsa'),(3815,1,'Prolez'),(3815,2,'Пролез'),(3815,3,'Prolez'),(3816,1,'Prolesha'),(3816,2,'Пролеша'),(3816,3,'Prolesha'),(3817,1,'Prolom'),(3817,2,'Пролом'),(3817,3,'Prolom'),(3818,1,'Propast'),(3818,2,'Пропаст'),(3818,3,'Propast'),(3819,1,'Prosena'),(3819,2,'Просена'),(3819,3,'Prosena'),(3820,1,'Prosenik'),(3820,2,'Просеник'),(3820,3,'Prosenik'),(3821,1,'Prosechen'),(3821,2,'Просечен'),(3821,3,'Prosechen'),(3822,1,'Prostorno'),(3822,2,'Просторно'),(3822,3,'Prostorno'),(3823,1,'Protopopintsi'),(3823,2,'Протопопинци'),(3823,3,'Protopopintsi'),(3824,1,'Profesor Zlatarski'),(3824,2,'Професор Златарски'),(3824,3,'Profesor Zlatarski'),(3825,1,'Profesor ishirkovo'),(3825,2,'Професор Иширково'),(3825,3,'Profesor ishirkovo'),(3826,1,'Prohlada'),(3826,2,'Прохлада'),(3826,3,'Prohlada'),(3827,1,'Prohod'),(3827,2,'Проход'),(3827,3,'Prohod'),(3828,1,'Prohorovo'),(3828,2,'Прохорово'),(3828,3,'Prohorovo'),(3829,1,'Pryaporets'),(3829,2,'Пряпорец'),(3829,3,'Pryaporets'),(3830,1,'Pryaporets'),(3830,2,'Пряпорец'),(3830,3,'Pryaporets'),(3831,1,'Ptichar'),(3831,2,'Птичар'),(3831,3,'Ptichar'),(3832,1,'Ptichevo'),(3832,2,'Птичево'),(3832,3,'Ptichevo'),(3833,1,'Pudria'),(3833,2,'Пудрия'),(3833,3,'Pudria'),(3834,1,'Pushevo'),(3834,2,'Пушево'),(3834,3,'Pushevo'),(3835,1,'Pchela'),(3835,2,'Пчела'),(3835,3,'Pchela'),(3836,1,'Pchelari'),(3836,2,'Пчелари'),(3836,3,'Pchelari'),(3837,1,'Pchelarovo'),(3837,2,'Пчеларово'),(3837,3,'Pchelarovo'),(3838,1,'Pchelarovo'),(3838,2,'Пчеларово'),(3838,3,'Pchelarovo'),(3839,1,'Pchelin'),(3839,2,'Пчелин'),(3839,3,'Pchelin'),(3840,1,'Pchelin'),(3840,2,'Пчелин'),(3840,3,'Pchelin'),(3841,1,'Pchelina'),(3841,2,'Пчелина'),(3841,3,'Pchelina'),(3842,1,'Pchelino'),(3842,2,'Пчелино'),(3842,3,'Pchelino'),(3843,1,'Pchelinovo'),(3843,2,'Пчелиново'),(3843,3,'Pchelinovo'),(3844,1,'Pchelishte'),(3844,2,'Пчелище'),(3844,3,'Pchelishte'),(3845,1,'Pchelnik'),(3845,2,'Пчелник'),(3845,3,'Pchelnik'),(3846,1,'Pchelnik'),(3846,2,'Пчелник'),(3846,3,'Pchelnik'),(3847,1,'Pchelno'),(3847,2,'Пчелно'),(3847,3,'Pchelno'),(3848,1,'Pshenichevo'),(3848,2,'Пшеничево'),(3848,3,'Pshenichevo'),(3849,1,'Padarevo'),(3849,2,'Пъдарево'),(3849,3,'Padarevo'),(3850,1,'Padarino'),(3850,2,'Пъдарино'),(3850,3,'Padarino'),(3851,1,'Padarsko'),(3851,2,'Пъдарско'),(3851,3,'Padarsko'),(3852,1,'Padartsi'),(3852,2,'Пъдарци'),(3852,3,'Padartsi'),(3853,1,'Panchevo'),(3853,2,'Пънчево'),(3853,3,'Panchevo'),(3854,1,'Parvan'),(3854,2,'Първан'),(3854,3,'Parvan'),(3855,1,'Parvenets'),(3855,2,'Първенец'),(3855,3,'Parvenets'),(3856,1,'Parvenets'),(3856,2,'Първенец'),(3856,3,'Parvenets'),(3857,1,'Parventsi'),(3857,2,'Първенци'),(3857,3,'Parventsi'),(3858,1,'Parvitsa'),(3858,2,'Първица'),(3858,3,'Parvitsa'),(3859,1,'Parvomay'),(3859,2,'Първомай'),(3859,3,'Parvomay'),(3860,1,'Parvomay'),(3860,2,'Първомай'),(3860,3,'Parvomay'),(3861,1,'Parvomaytsi'),(3861,2,'Първомайци'),(3861,3,'Parvomaytsi'),(3862,1,'Parzhigrah'),(3862,2,'Пържиграх'),(3862,3,'Parzhigrah'),(3863,1,'Parlichevo'),(3863,2,'Пърличево'),(3863,3,'Parlichevo'),(3864,1,'Parovtsi'),(3864,2,'Пъровци'),(3864,3,'Parovtsi'),(3865,1,'Partevtsi'),(3865,2,'Пъртевци'),(3865,3,'Partevtsi'),(3866,1,'Parsha'),(3866,2,'Пърша'),(3866,3,'Parsha'),(3867,1,'Pastren'),(3867,2,'Пъстрен'),(3867,3,'Pastren'),(3868,1,'Pastrovo'),(3868,2,'Пъстрово'),(3868,3,'Pastrovo'),(3869,1,'Pastrogor'),(3869,2,'Пъстрогор'),(3869,3,'Pastrogor'),(3870,1,'Pastrook'),(3870,2,'Пъстроок'),(3870,3,'Pastrook'),(3871,1,'Patnikovo'),(3871,2,'Пътниково'),(3871,3,'Patnikovo'),(3872,1,'Pyasachevo'),(3872,2,'Пясъчево'),(3872,3,'Pyasachevo'),(3873,1,'Rabisha'),(3873,2,'Рабиша'),(3873,3,'Rabisha'),(3874,1,'Rabovo'),(3874,2,'Рабово'),(3874,3,'Rabovo'),(3875,1,'Rabrovo'),(3875,2,'Раброво'),(3875,3,'Rabrovo'),(3876,1,'Ravadinovo'),(3876,2,'Равадиново'),(3876,3,'Ravadinovo'),(3877,1,'Ravda'),(3877,2,'Равда'),(3877,3,'Ravda'),(3878,1,'Raven'),(3878,2,'Равен'),(3878,3,'Raven'),(3879,1,'Ravna'),(3879,2,'Равна'),(3879,3,'Ravna'),(3880,1,'Ravna'),(3880,2,'Равна'),(3880,3,'Ravna'),(3881,1,'Ravna'),(3881,2,'Равна'),(3881,3,'Ravna'),(3882,1,'Ravna gora'),(3882,2,'Равна гора'),(3882,3,'Ravna gora'),(3883,1,'Ravna gora'),(3883,2,'Равна гора'),(3883,3,'Ravna gora'),(3884,1,'Ravna gora'),(3884,2,'Равна гора'),(3884,3,'Ravna gora'),(3885,1,'Ravnets'),(3885,2,'Равнец'),(3885,3,'Ravnets'),(3886,1,'Ravnets'),(3886,2,'Равнец'),(3886,3,'Ravnets'),(3887,1,'Ravnil'),(3887,2,'Равнил'),(3887,3,'Ravnil'),(3888,1,'Ravninata'),(3888,2,'Равнината'),(3888,3,'Ravninata'),(3889,1,'Ravnishta'),(3889,2,'Равнища'),(3889,3,'Ravnishta'),(3890,1,'Ravnishte'),(3890,2,'Равнище'),(3890,3,'Ravnishte'),(3891,1,'Ravno'),(3891,2,'Равно'),(3891,3,'Ravno'),(3892,1,'Ravno nivishte'),(3892,2,'Равно нивище'),(3892,3,'Ravno nivishte'),(3893,1,'Ravno pole'),(3893,2,'Равно поле'),(3893,3,'Ravno pole'),(3894,1,'Ravno selo'),(3894,2,'Равно село'),(3894,3,'Ravno selo'),(3895,1,'Ravnovo'),(3895,2,'Равново'),(3895,3,'Ravnovo'),(3896,1,'Ravnogor'),(3896,2,'Равногор'),(3896,3,'Ravnogor'),(3897,1,'Radan voyvoda'),(3897,2,'Радан войвода'),(3897,3,'Radan voyvoda'),(3898,1,'Radanovo'),(3898,2,'Раданово'),(3898,3,'Radanovo'),(3899,1,'Radancheto'),(3899,2,'Раданчето'),(3899,3,'Radancheto'),(3900,1,'Radevo'),(3900,2,'Радево'),(3900,3,'Radevo'),(3901,1,'Radevo'),(3901,2,'Радево'),(3901,3,'Radevo'),(3902,1,'Radevtsi'),(3902,2,'Радевци'),(3902,3,'Radevtsi'),(3903,1,'Radetski'),(3903,2,'Радецки'),(3903,3,'Radetski'),(3904,1,'Radibosh'),(3904,2,'Радибош'),(3904,3,'Radibosh'),(3905,1,'Radievo'),(3905,2,'Радиево'),(3905,3,'Radievo'),(3906,1,'Radilovo'),(3906,2,'Радилово'),(3906,3,'Radilovo'),(3907,1,'Radingrad'),(3907,2,'Радинград'),(3907,3,'Radingrad'),(3908,1,'Radino'),(3908,2,'Радино'),(3908,3,'Radino'),(3909,1,'Radinovo'),(3909,2,'Радиново'),(3909,3,'Radinovo'),(3910,1,'Radishevo'),(3910,2,'Радишево'),(3910,3,'Radishevo'),(3911,1,'Radko Dimitrievo'),(3911,2,'Радко Димитриево'),(3911,3,'Radko Dimitrievo'),(3912,1,'Radkovtsi'),(3912,2,'Радковци'),(3912,3,'Radkovtsi'),(3913,1,'Radlovtsi'),(3913,2,'Радловци'),(3913,3,'Radlovtsi'),(3914,1,'Radnevo'),(3914,2,'Раднево'),(3914,3,'Radnevo'),(3915,1,'Radovene'),(3915,2,'Радовене'),(3915,3,'Radovene'),(3916,1,'Radovets'),(3916,2,'Радовец'),(3916,3,'Radovets'),(3917,1,'Radovo'),(3917,2,'Радово'),(3917,3,'Radovo'),(3918,1,'Radovtsi'),(3918,2,'Радовци'),(3918,3,'Radovtsi'),(3919,1,'Radovtsi'),(3919,2,'Радовци'),(3919,3,'Radovtsi'),(3920,1,'Radoevskoto'),(3920,2,'Радоевското'),(3920,3,'Radoevskoto'),(3921,1,'Radoevtsi'),(3921,2,'Радоевци'),(3921,3,'Radoevtsi'),(3922,1,'Radoynovo'),(3922,2,'Радойново'),(3922,3,'Radoynovo'),(3923,1,'Radomir'),(3923,2,'Радомир'),(3923,3,'Radomir'),(3924,1,'Radomirtsi'),(3924,2,'Радомирци'),(3924,3,'Radomirtsi'),(3925,1,'Radotina'),(3925,2,'Радотина'),(3925,3,'Radotina'),(3926,1,'Raduil'),(3926,2,'Радуил'),(3926,3,'Raduil'),(3927,1,'Raduy'),(3927,2,'Радуй'),(3927,3,'Raduy'),(3928,1,'Radulovtsi'),(3928,2,'Радуловци'),(3928,3,'Radulovtsi'),(3929,1,'Raduntsi'),(3929,2,'Радунци'),(3929,3,'Raduntsi'),(3930,1,'Radyuvene'),(3930,2,'Радювене'),(3930,3,'Radyuvene'),(3931,1,'Raevtsi'),(3931,2,'Раевци'),(3931,3,'Raevtsi'),(3932,1,'Razhdavitsa'),(3932,2,'Раждавица'),(3932,3,'Razhdavitsa'),(3933,1,'Razboishte'),(3933,2,'Разбоище'),(3933,3,'Razboishte'),(3934,1,'Razboyna'),(3934,2,'Разбойна'),(3934,3,'Razboyna'),(3935,1,'Razboyna'),(3935,2,'Разбойна'),(3935,3,'Razboyna'),(3936,1,'Razvigorovo'),(3936,2,'Развигорово'),(3936,3,'Razvigorovo'),(3937,1,'Razgrad'),(3937,2,'Разград'),(3937,3,'Razgrad'),(3938,1,'Razgrad'),(3938,2,'Разград'),(3938,3,'Razgrad'),(3939,1,'Razdel'),(3939,2,'Раздел'),(3939,3,'Razdel'),(3940,1,'Razdel'),(3940,2,'Раздел'),(3940,3,'Razdel'),(3941,1,'Razdelna'),(3941,2,'Разделна'),(3941,3,'Razdelna'),(3942,1,'Razdelna'),(3942,2,'Разделна'),(3942,3,'Razdelna'),(3943,1,'Razdeltsi'),(3943,2,'Разделци'),(3943,3,'Razdeltsi'),(3944,1,'Razdol'),(3944,2,'Раздол'),(3944,3,'Razdol'),(3945,1,'Razliv'),(3945,2,'Разлив'),(3945,3,'Razliv'),(3946,1,'Razlog'),(3946,2,'Разлог'),(3946,3,'Razlog'),(3947,1,'Razsoha'),(3947,2,'Разсоха'),(3947,3,'Razsoha'),(3948,1,'Raykova mogila'),(3948,2,'Райкова могила'),(3948,3,'Raykova mogila'),(3949,1,'Raykovska'),(3949,2,'Райковска'),(3949,3,'Raykovska'),(3950,1,'Raykovtsi'),(3950,2,'Райковци'),(3950,3,'Raykovtsi'),(3951,1,'Raynino'),(3951,2,'Райнино'),(3951,3,'Raynino'),(3952,1,'Raynovo'),(3952,2,'Райново'),(3952,3,'Raynovo'),(3953,1,'Raynovtsi'),(3953,2,'Райновци'),(3953,3,'Raynovtsi'),(3954,1,'Raynovtsi'),(3954,2,'Райновци'),(3954,3,'Raynovtsi'),(3955,1,'Raynushkovtsi'),(3955,2,'Райнушковци'),(3955,3,'Raynushkovtsi'),(3956,1,'Rayovo'),(3956,2,'Райово'),(3956,3,'Rayovo'),(3957,1,'Rakevo'),(3957,2,'Ракево'),(3957,3,'Rakevo'),(3958,1,'Rakilovtsi'),(3958,2,'Ракиловци'),(3958,3,'Rakilovtsi'),(3959,1,'Rakita'),(3959,2,'Ракита'),(3959,3,'Rakita'),(3960,1,'Rakita'),(3960,2,'Ракита'),(3960,3,'Rakita'),(3961,1,'Rakitna'),(3961,2,'Ракитна'),(3961,3,'Rakitna'),(3962,1,'Rakitnitsa'),(3962,2,'Ракитница'),(3962,3,'Rakitnitsa'),(3963,1,'Rakitnitsa'),(3963,2,'Ракитница'),(3963,3,'Rakitnitsa'),(3964,1,'Rakitovo'),(3964,2,'Ракитово'),(3964,3,'Rakitovo'),(3965,1,'Raklinovo'),(3965,2,'Раклиново'),(3965,3,'Raklinovo'),(3966,1,'Raklitsa'),(3966,2,'Раклица'),(3966,3,'Raklitsa'),(3967,1,'Rakovitsa'),(3967,2,'Раковица'),(3967,3,'Rakovitsa'),(3968,1,'Rakovo'),(3968,2,'Раково'),(3968,3,'Rakovo'),(3969,1,'Rakovo'),(3969,2,'Раково'),(3969,3,'Rakovo'),(3970,1,'Rakovski'),(3970,2,'Раковски'),(3970,3,'Rakovski'),(3971,1,'Rakovski'),(3971,2,'Раковски'),(3971,3,'Rakovski'),(3972,1,'Rakovski'),(3972,2,'Раковски'),(3972,3,'Rakovski'),(3973,1,'Rakovskovo'),(3973,2,'Раковсково'),(3973,3,'Rakovskovo'),(3974,1,'Ralevo'),(3974,2,'Ралево'),(3974,3,'Ralevo'),(3975,1,'Ralevtsi'),(3975,2,'Ралевци'),(3975,3,'Ralevtsi'),(3976,1,'Ralinovtsi'),(3976,2,'Ралиновци'),(3976,3,'Ralinovtsi'),(3977,1,'Ralitsa'),(3977,2,'Ралица'),(3977,3,'Ralitsa'),(3978,1,'Ralitsa'),(3978,2,'Ралица'),(3978,3,'Ralitsa'),(3979,1,'Ralichevo'),(3979,2,'Раличево'),(3979,3,'Ralichevo'),(3980,1,'Ranentsi'),(3980,2,'Раненци'),(3980,3,'Ranentsi'),(3981,1,'Rani list'),(3981,2,'Рани лист'),(3981,3,'Rani list'),(3982,1,'Rani lug'),(3982,2,'Рани луг'),(3982,3,'Rani lug'),(3983,1,'Rasnik'),(3983,2,'Расник'),(3983,3,'Rasnik'),(3984,1,'Rasovo'),(3984,2,'Расово'),(3984,3,'Rasovo'),(3985,1,'Rastnik'),(3985,2,'Растник'),(3985,3,'Rastnik'),(3986,1,'Rahovtsi'),(3986,2,'Раховци'),(3986,3,'Rahovtsi'),(3987,1,'Rachevtsi'),(3987,2,'Рачевци'),(3987,3,'Rachevtsi'),(3988,1,'Rachovtsi'),(3988,2,'Рачовци'),(3988,3,'Rachovtsi'),(3989,1,'Rashevtsi'),(3989,2,'Рашевци'),(3989,3,'Rashevtsi'),(3990,1,'Rashka Grashtitsa'),(3990,2,'Рашка Гращица'),(3990,3,'Rashka Grashtitsa'),(3991,1,'Rashkovo'),(3991,2,'Рашково'),(3991,3,'Rashkovo'),(3992,1,'Rashovite'),(3992,2,'Рашовите'),(3992,3,'Rashovite'),(3993,1,'Rashovitsa'),(3993,2,'Рашовица'),(3993,3,'Rashovitsa'),(3994,1,'Rayuvtsi'),(3994,2,'Раювци'),(3994,3,'Rayuvtsi'),(3995,1,'Rayanovtsi'),(3995,2,'Раяновци'),(3995,3,'Rayanovtsi'),(3996,1,'Rayanovtsi'),(3996,2,'Раяновци'),(3996,3,'Rayanovtsi'),(3997,1,'Rayantsi'),(3997,2,'Раянци'),(3997,3,'Rayantsi'),(3998,1,'Rebrevtsi'),(3998,2,'Ребревци'),(3998,3,'Rebrevtsi'),(3999,1,'Rebro'),(3999,2,'Ребро'),(3999,3,'Rebro'),(4000,1,'Rebrovo'),(4000,2,'Реброво'),(4000,3,'Rebrovo'),(4001,1,'Rebarkovo'),(4001,2,'Ребърково'),(4001,3,'Rebarkovo'),(4002,1,'Redeshkovtsi'),(4002,2,'Редешковци'),(4002,3,'Redeshkovtsi'),(4003,1,'Redina'),(4003,2,'Редина'),(4003,3,'Redina'),(4004,1,'Rezhantsi'),(4004,2,'Режанци'),(4004,3,'Rezhantsi'),(4005,1,'Rezhintsi'),(4005,2,'Режинци'),(4005,3,'Rezhintsi'),(4006,1,'Rezach'),(4006,2,'Резач'),(4006,3,'Rezach'),(4007,1,'Rezbartsi'),(4007,2,'Резбарци'),(4007,3,'Rezbartsi'),(4008,1,'Rezovo'),(4008,2,'Резово'),(4008,3,'Rezovo'),(4009,1,'Reka'),(4009,2,'Река'),(4009,3,'Reka'),(4010,1,'Rekichka'),(4010,2,'Рекичка'),(4010,3,'Rekichka'),(4011,1,'Relyovo'),(4011,2,'Рельово'),(4011,3,'Relyovo'),(4012,1,'Replyana'),(4012,2,'Репляна'),(4012,3,'Replyana'),(4013,1,'Reselets'),(4013,2,'Реселец'),(4013,3,'Reselets'),(4014,1,'Resen'),(4014,2,'Ресен'),(4014,3,'Resen'),(4015,1,'Resilovo'),(4015,2,'Ресилово'),(4015,3,'Resilovo'),(4016,1,'Rechani'),(4016,2,'Речани'),(4016,3,'Rechani'),(4017,1,'Rechitsa'),(4017,2,'Речица'),(4017,3,'Rechitsa'),(4018,1,'Reyanovtsi'),(4018,2,'Реяновци'),(4018,3,'Reyanovtsi'),(4019,1,'Ribaritsa'),(4019,2,'Рибарица'),(4019,3,'Ribaritsa'),(4020,1,'Ribaritsa'),(4020,2,'Рибарица'),(4020,3,'Ribaritsa'),(4021,1,'Ribartsi'),(4021,2,'Рибарци'),(4021,3,'Ribartsi'),(4022,1,'Riben'),(4022,2,'Рибен'),(4022,3,'Riben'),(4023,1,'Riben dol'),(4023,2,'Рибен дол'),(4023,3,'Riben dol'),(4024,1,'Ribino'),(4024,2,'Рибино'),(4024,3,'Ribino'),(4025,1,'Ribnik'),(4025,2,'Рибник'),(4025,3,'Ribnik'),(4026,1,'Ribnitsa'),(4026,2,'Рибница'),(4026,3,'Ribnitsa'),(4027,1,'Ribnovo'),(4027,2,'Рибново'),(4027,3,'Ribnovo'),(4028,1,'Ridino'),(4028,2,'Ридино'),(4028,3,'Ridino'),(4029,1,'Ridovo'),(4029,2,'Ридово'),(4029,3,'Ridovo'),(4030,1,'Rila'),(4030,2,'Рила'),(4030,3,'Rila'),(4031,1,'Rilski manastir'),(4031,2,'Рилски манастир'),(4031,3,'Rilski manastir'),(4032,1,'Riltsi'),(4032,2,'Рилци'),(4032,3,'Riltsi'),(4033,1,'Risimanovo'),(4033,2,'Рисиманово'),(4033,3,'Risimanovo'),(4034,1,'Ritya'),(4034,2,'Ритя'),(4034,3,'Ritya'),(4035,1,'Rish'),(4035,2,'Риш'),(4035,3,'Rish'),(4036,1,'Robovo'),(4036,2,'Робово'),(4036,3,'Robovo'),(4037,1,'Rovina'),(4037,2,'Ровина'),(4037,3,'Rovina'),(4038,1,'Rogach'),(4038,2,'Рогач'),(4038,3,'Rogach'),(4039,1,'Rogachevo'),(4039,2,'Рогачево'),(4039,3,'Rogachevo'),(4040,1,'Roglets'),(4040,2,'Роглец'),(4040,3,'Roglets'),(4041,1,'Rogozari'),(4041,2,'Рогозари'),(4041,3,'Rogozari'),(4042,1,'Rogozen'),(4042,2,'Рогозен'),(4042,3,'Rogozen'),(4043,1,'Rogozina'),(4043,2,'Рогозина'),(4043,3,'Rogozina'),(4044,1,'Rogozinovo'),(4044,2,'Рогозиново'),(4044,3,'Rogozinovo'),(4045,1,'Rogozche'),(4045,2,'Рогозче'),(4045,3,'Rogozche'),(4046,1,'Rogosh'),(4046,2,'Рогош'),(4046,3,'Rogosh'),(4047,1,'Rogulyat'),(4047,2,'Рогулят'),(4047,3,'Rogulyat'),(4048,1,'Rodina'),(4048,2,'Родина'),(4048,3,'Rodina'),(4049,1,'Rodopi'),(4049,2,'Родопи'),(4049,3,'Rodopi'),(4050,1,'Rodopsko'),(4050,2,'Родопско'),(4050,3,'Rodopsko'),(4051,1,'Rozhden'),(4051,2,'Рожден'),(4051,3,'Rozhden'),(4052,1,'Rozhdensko'),(4052,2,'Рожденско'),(4052,3,'Rozhdensko'),(4053,1,'Rozhen'),(4053,2,'Рожен'),(4053,3,'Rozhen'),(4054,1,'Roza'),(4054,2,'Роза'),(4054,3,'Roza'),(4055,1,'Rozino'),(4055,2,'Розино'),(4055,3,'Rozino'),(4056,1,'Rozino'),(4056,2,'Розино'),(4056,3,'Rozino'),(4057,1,'Rozovets'),(4057,2,'Розовец'),(4057,3,'Rozovets'),(4058,1,'Rozovo'),(4058,2,'Розово'),(4058,3,'Rozovo'),(4059,1,'Rozovo'),(4059,2,'Розово'),(4059,3,'Rozovo'),(4060,1,'Roman'),(4060,2,'Роман'),(4060,3,'Roman'),(4061,1,'Ropot'),(4061,2,'Ропот'),(4061,3,'Ropot'),(4062,1,'Rosen'),(4062,2,'Росен'),(4062,3,'Rosen'),(4063,1,'Rosen'),(4063,2,'Росен'),(4063,3,'Rosen'),(4064,1,'Rosen'),(4064,2,'Росен'),(4064,3,'Rosen'),(4065,1,'Rosenovo'),(4065,2,'Росеново'),(4065,3,'Rosenovo'),(4066,1,'Rosenovo'),(4066,2,'Росеново'),(4066,3,'Rosenovo'),(4067,1,'Rosina'),(4067,2,'Росина'),(4067,3,'Rosina'),(4068,1,'Rositsa'),(4068,2,'Росица'),(4068,3,'Rositsa'),(4069,1,'Rositsa'),(4069,2,'Росица'),(4069,3,'Rositsa'),(4070,1,'Rositsa'),(4070,2,'Росица'),(4070,3,'Rositsa'),(4071,1,'Rosno'),(4071,2,'Росно'),(4071,3,'Rosno'),(4072,1,'Rosoman'),(4072,2,'Росоман'),(4072,3,'Rosoman'),(4073,1,'Rohleva'),(4073,2,'Рохлева'),(4073,3,'Rohleva'),(4074,1,'Royak'),(4074,2,'Рояк'),(4074,3,'Royak'),(4075,1,'Rudartsi'),(4075,2,'Рударци'),(4075,3,'Rudartsi'),(4076,1,'Rudina'),(4076,2,'Рудина'),(4076,3,'Rudina'),(4077,1,'Rudina'),(4077,2,'Рудина'),(4077,3,'Rudina'),(4078,1,'Rudnik'),(4078,2,'Рудник'),(4078,3,'Rudnik'),(4079,1,'Rudnik'),(4079,2,'Рудник'),(4079,3,'Rudnik'),(4080,1,'Rudozem'),(4080,2,'Рудозем'),(4080,3,'Rudozem'),(4081,1,'Ruevtsi'),(4081,2,'Руевци'),(4081,3,'Ruevtsi'),(4082,1,'Ruen'),(4082,2,'Руен'),(4082,3,'Ruen'),(4083,1,'Ruen'),(4083,2,'Руен'),(4083,3,'Ruen'),(4084,1,'Ruets'),(4084,2,'Руец'),(4084,3,'Ruets'),(4085,1,'Ruzhintsi'),(4085,2,'Ружинци'),(4085,3,'Ruzhintsi'),(4086,1,'Ruzhitsa'),(4086,2,'Ружица'),(4086,3,'Ruzhitsa'),(4087,1,'Ruzhitsa'),(4087,2,'Ружица'),(4087,3,'Ruzhitsa'),(4088,1,'Ruyno'),(4088,2,'Руйно'),(4088,3,'Ruyno'),(4089,1,'Ruychovtsi'),(4089,2,'Руйчовци'),(4089,3,'Ruychovtsi'),(4090,1,'Rumanya'),(4090,2,'Руманя'),(4090,3,'Rumanya'),(4091,1,'Rumelia'),(4091,2,'Румелия'),(4091,3,'Rumelia'),(4092,1,'Rumyantsevo'),(4092,2,'Румянцево'),(4092,3,'Rumyantsevo'),(4093,1,'Runya'),(4093,2,'Руня'),(4093,3,'Runya'),(4094,1,'Rupite'),(4094,2,'Рупите'),(4094,3,'Rupite'),(4095,1,'Rupkite'),(4095,2,'Рупките'),(4095,3,'Rupkite'),(4096,1,'Ruptsi'),(4096,2,'Рупци'),(4096,3,'Ruptsi'),(4097,1,'Ruptsi'),(4097,2,'Рупци'),(4097,3,'Ruptsi'),(4098,1,'Rupcha'),(4098,2,'Рупча'),(4098,3,'Rupcha'),(4099,1,'Rusalina'),(4099,2,'Русалина'),(4099,3,'Rusalina'),(4100,1,'Rusalsko'),(4100,2,'Русалско'),(4100,3,'Rusalsko'),(4101,1,'Rusalya'),(4101,2,'Русаля'),(4101,3,'Rusalya'),(4102,1,'Ruse'),(4102,2,'Русе'),(4102,3,'Ruse'),(4103,1,'Rusinovtsi'),(4103,2,'Русиновци'),(4103,3,'Rusinovtsi'),(4104,1,'Ruska Bela'),(4104,2,'Руска Бела'),(4104,3,'Ruska Bela'),(4105,1,'Ruskovtsi'),(4105,2,'Русковци'),(4105,3,'Ruskovtsi'),(4106,1,'Rusokastro'),(4106,2,'Русокастро'),(4106,3,'Rusokastro'),(4107,1,'Rustan'),(4107,2,'Рустан'),(4107,3,'Rustan'),(4108,1,'Ruhovtsi'),(4108,2,'Руховци'),(4108,3,'Ruhovtsi'),(4109,1,'Ruchey'),(4109,2,'Ручей'),(4109,3,'Ruchey'),(4110,1,'Razhavets'),(4110,2,'Ръжавец'),(4110,3,'Razhavets'),(4111,1,'Razhana'),(4111,2,'Ръжана'),(4111,3,'Razhana'),(4112,1,'Razhdak'),(4112,2,'Ръждак'),(4112,3,'Razhdak'),(4113,1,'Razhevo'),(4113,2,'Ръжево'),(4113,3,'Razhevo'),(4114,1,'Razhevo Konare'),(4114,2,'Ръжево Конаре'),(4114,3,'Razhevo Konare'),(4115,1,'Razhena'),(4115,2,'Ръжена'),(4115,3,'Razhena'),(4116,1,'Razhenovo'),(4116,2,'Ръженово'),(4116,3,'Razhenovo'),(4117,1,'Razhitsa'),(4117,2,'Ръжица'),(4117,3,'Razhitsa'),(4118,1,'Rasovo'),(4118,2,'Ръсово'),(4118,3,'Rasovo'),(4119,1,'Rat'),(4119,2,'Рът'),(4119,3,'Rat'),(4120,1,'Ratlina'),(4120,2,'Рътлина'),(4120,3,'Ratlina'),(4121,1,'Ryazkovtsi'),(4121,2,'Рязковци'),(4121,3,'Ryazkovtsi'),(4122,1,'Ryahovo'),(4122,2,'Ряхово'),(4122,3,'Ryahovo'),(4123,1,'Ryahovtsite'),(4123,2,'Ряховците'),(4123,3,'Ryahovtsite'),(4124,1,'Sava'),(4124,2,'Сава'),(4124,3,'Sava'),(4125,1,'Savin'),(4125,2,'Савин'),(4125,3,'Savin'),(4126,1,'Savino'),(4126,2,'Савино'),(4126,3,'Savino'),(4127,1,'Savoyski'),(4127,2,'Савойски'),(4127,3,'Savoyski'),(4128,1,'Sadina'),(4128,2,'Садина'),(4128,3,'Sadina'),(4129,1,'Sadovets'),(4129,2,'Садовец'),(4129,3,'Sadovets'),(4130,1,'Sadovik'),(4130,2,'Садовик'),(4130,3,'Sadovik'),(4131,1,'Sadovitsa'),(4131,2,'Садовица'),(4131,3,'Sadovitsa'),(4132,1,'Sadovo'),(4132,2,'Садово'),(4132,3,'Sadovo'),(4133,1,'Sadovo'),(4133,2,'Садово'),(4133,3,'Sadovo'),(4134,1,'Sadovo'),(4134,2,'Садово'),(4134,3,'Sadovo'),(4135,1,'Sadovo'),(4135,2,'Садово'),(4135,3,'Sadovo'),(4136,1,'Sazhdenik'),(4136,2,'Сажденик'),(4136,3,'Sazhdenik'),(4137,1,'Sakartsi'),(4137,2,'Сакарци'),(4137,3,'Sakartsi'),(4138,1,'Salasuka'),(4138,2,'Саласука'),(4138,3,'Salasuka'),(4139,1,'Salash'),(4139,2,'Салаш'),(4139,3,'Salash'),(4140,1,'Salmanovo'),(4140,2,'Салманово'),(4140,3,'Salmanovo'),(4141,1,'Samovila'),(4141,2,'Самовила'),(4141,3,'Samovila'),(4142,1,'Samovodene'),(4142,2,'Самоводене'),(4142,3,'Samovodene'),(4143,1,'Samodiva'),(4143,2,'Самодива'),(4143,3,'Samodiva'),(4144,1,'Samokitka'),(4144,2,'Самокитка'),(4144,3,'Samokitka'),(4145,1,'Samokov'),(4145,2,'Самоков'),(4145,3,'Samokov'),(4146,1,'Samoranovo'),(4146,2,'Самораново'),(4146,3,'Samoranovo'),(4147,1,'Samotino'),(4147,2,'Самотино'),(4147,3,'Samotino'),(4148,1,'Samsiite'),(4148,2,'Самсиите'),(4148,3,'Samsiite'),(4149,1,'Samuil'),(4149,2,'Самуил'),(4149,3,'Samuil'),(4150,1,'Samuilova krepost'),(4150,2,'Самуилова крепост'),(4150,3,'Samuilova krepost'),(4151,1,'Samuilovo'),(4151,2,'Самуилово'),(4151,3,'Samuilovo'),(4152,1,'Samuilovo'),(4152,2,'Самуилово'),(4152,3,'Samuilovo'),(4153,1,'Samuilovo'),(4153,2,'Самуилово'),(4153,3,'Samuilovo'),(4154,1,'Samuilovo'),(4154,2,'Самуилово'),(4154,3,'Samuilovo'),(4155,1,'Sanadinovo'),(4155,2,'Санадиново'),(4155,3,'Sanadinovo'),(4156,1,'Sandanski'),(4156,2,'Сандански'),(4156,3,'Sandanski'),(4157,1,'Sandrovo'),(4157,2,'Сандрово'),(4157,3,'Sandrovo'),(4158,1,'San-Stefano'),(4158,2,'Сан-Стефано'),(4158,3,'San-Stefano'),(4159,1,'Sapareva banya'),(4159,2,'Сапарева баня'),(4159,3,'Sapareva banya'),(4160,1,'Saparevo'),(4160,2,'Сапарево'),(4160,3,'Saparevo'),(4161,1,'Saraevo'),(4161,2,'Сараево'),(4161,3,'Saraevo'),(4162,1,'Saransko'),(4162,2,'Саранско'),(4162,3,'Saransko'),(4163,1,'Sarantsi'),(4163,2,'Саранци'),(4163,3,'Sarantsi'),(4164,1,'Saraya'),(4164,2,'Сарая'),(4164,3,'Saraya'),(4165,1,'Satovcha'),(4165,2,'Сатовча'),(4165,3,'Satovcha'),(4166,1,'Sbor'),(4166,2,'Сбор'),(4166,3,'Sbor'),(4167,1,'Sbor'),(4167,2,'Сбор'),(4167,3,'Sbor'),(4168,1,'Sborino'),(4168,2,'Сборино'),(4168,3,'Sborino'),(4169,1,'Sborishte'),(4169,2,'Сборище'),(4169,3,'Sborishte'),(4170,1,'Svalenik'),(4170,2,'Сваленик'),(4170,3,'Svalenik'),(4171,1,'Svatbare'),(4171,2,'Сватбаре'),(4171,3,'Svatbare'),(4172,1,'Svezhen'),(4172,2,'Свежен'),(4172,3,'Svezhen'),(4173,1,'Sveta Petka'),(4173,2,'Света Петка'),(4173,3,'Sveta Petka'),(4174,1,'Sveti Vlas'),(4174,2,'Свети Влас'),(4174,3,'Sveti Vlas'),(4175,1,'Sveti Nikola'),(4175,2,'Свети Никола'),(4175,3,'Sveti Nikola'),(4176,1,'Svetlen'),(4176,2,'Светлен'),(4176,3,'Svetlen'),(4177,1,'Svetlen'),(4177,2,'Светлен'),(4177,3,'Svetlen'),(4178,1,'Svetlina'),(4178,2,'Светлина'),(4178,3,'Svetlina'),(4179,1,'Svetlina'),(4179,2,'Светлина'),(4179,3,'Svetlina'),(4180,1,'Svetlina'),(4180,2,'Светлина'),(4180,3,'Svetlina'),(4181,1,'Svetlya'),(4181,2,'Светля'),(4181,3,'Svetlya'),(4182,1,'Svetovrachene'),(4182,2,'Световрачене'),(4182,3,'Svetovrachene'),(4183,1,'Svetoslav'),(4183,2,'Светослав'),(4183,3,'Svetoslav'),(4184,1,'Svetoslav'),(4184,2,'Светослав'),(4184,3,'Svetoslav'),(4185,1,'Svetoslavtsi'),(4185,2,'Светославци'),(4185,3,'Svetoslavtsi'),(4186,1,'Svetulka'),(4186,2,'Светулка'),(4186,3,'Svetulka'),(4187,1,'Sveshtari'),(4187,2,'Свещари'),(4187,3,'Sveshtari'),(4188,1,'Svidnya'),(4188,2,'Свидня'),(4188,3,'Svidnya'),(4189,1,'Svilengrad'),(4189,2,'Свиленград'),(4189,3,'Svilengrad'),(4190,1,'Svinarski dol'),(4190,2,'Свинарски дол'),(4190,3,'Svinarski dol'),(4191,1,'Svirachi'),(4191,2,'Свирачи'),(4191,3,'Svirachi'),(4192,1,'Svirkovo'),(4192,2,'Свирково'),(4192,3,'Svirkovo'),(4193,1,'Svirtsi'),(4193,2,'Свирци'),(4193,3,'Svirtsi'),(4194,1,'Svirchovo'),(4194,2,'Свирчово'),(4194,3,'Svirchovo'),(4195,1,'Svishtov'),(4195,2,'Свищов'),(4195,3,'Svishtov'),(4196,1,'Svoboda'),(4196,2,'Свобода'),(4196,3,'Svoboda'),(4197,1,'Svoboda'),(4197,2,'Свобода'),(4197,3,'Svoboda'),(4198,1,'Svoboda'),(4198,2,'Свобода'),(4198,3,'Svoboda'),(4199,1,'Svoboda'),(4199,2,'Свобода'),(4199,3,'Svoboda'),(4200,1,'Svoboda'),(4200,2,'Свобода'),(4200,3,'Svoboda'),(4201,1,'Svoboden'),(4201,2,'Свободен'),(4201,3,'Svoboden'),(4202,1,'Svobodinovo'),(4202,2,'Свободиново'),(4202,3,'Svobodinovo'),(4203,1,'Svoboditsa'),(4203,2,'Свободица'),(4203,3,'Svoboditsa'),(4204,1,'Svoge'),(4204,2,'Своге'),(4204,3,'Svoge'),(4205,1,'Svode'),(4205,2,'Своде'),(4205,3,'Svode'),(4206,1,'Sevar'),(4206,2,'Севар'),(4206,3,'Sevar'),(4207,1,'Sevdalina'),(4207,2,'Севдалина'),(4207,3,'Sevdalina'),(4208,1,'Severnyak'),(4208,2,'Северняк'),(4208,3,'Severnyak'),(4209,1,'Severtsi'),(4209,2,'Северци'),(4209,3,'Severtsi'),(4210,1,'Sevlievo'),(4210,2,'Севлиево'),(4210,3,'Sevlievo'),(4211,1,'Sedelets'),(4211,2,'Седелец'),(4211,3,'Sedelets'),(4212,1,'Sedefche'),(4212,2,'Седефче'),(4212,3,'Sedefche'),(4213,1,'Sedlarevo'),(4213,2,'Седларево'),(4213,3,'Sedlarevo'),(4214,1,'Sedlari'),(4214,2,'Седлари'),(4214,3,'Sedlari'),(4215,1,'Sedlartsi'),(4215,2,'Седларци'),(4215,3,'Sedlartsi'),(4216,1,'Sedlovina'),(4216,2,'Седловина'),(4216,3,'Sedlovina'),(4217,1,'Sedyankovtsi'),(4217,2,'Седянковци'),(4217,3,'Sedyankovtsi'),(4218,1,'Seydol'),(4218,2,'Сейдол'),(4218,3,'Seydol'),(4219,1,'Seykovtsi'),(4219,2,'Сейковци'),(4219,3,'Seykovtsi'),(4220,1,'Seymenite'),(4220,2,'Сеймените'),(4220,3,'Seymenite'),(4221,1,'Sekirka'),(4221,2,'Секирка'),(4221,3,'Sekirka'),(4222,1,'Sekulovo'),(4222,2,'Секулово'),(4222,3,'Sekulovo'),(4223,1,'Selanovtsi'),(4223,2,'Селановци'),(4223,3,'Selanovtsi'),(4224,1,'Seliminovo'),(4224,2,'Селиминово'),(4224,3,'Seliminovo'),(4225,1,'Selishte'),(4225,2,'Селище'),(4225,3,'Selishte'),(4226,1,'Selishte'),(4226,2,'Селище'),(4226,3,'Selishte'),(4227,1,'Selishte'),(4227,2,'Селище'),(4227,3,'Selishte'),(4228,1,'Selishten dol'),(4228,2,'Селищен дол'),(4228,3,'Selishten dol'),(4229,1,'Selska polyana'),(4229,2,'Селска поляна'),(4229,3,'Selska polyana'),(4230,1,'Seltse'),(4230,2,'Селце'),(4230,3,'Seltse'),(4231,1,'Seltse'),(4231,2,'Селце'),(4231,3,'Seltse'),(4232,1,'Seltse'),(4232,2,'Селце'),(4232,3,'Seltse'),(4233,1,'Seltsi'),(4233,2,'Селци'),(4233,3,'Seltsi'),(4234,1,'Selcha'),(4234,2,'Селча'),(4234,3,'Selcha'),(4235,1,'Selyanin'),(4235,2,'Селянин'),(4235,3,'Selyanin'),(4236,1,'Semerdzhievo'),(4236,2,'Семерджиево'),(4236,3,'Semerdzhievo'),(4237,1,'Semerdzhiite'),(4237,2,'Семерджиите'),(4237,3,'Semerdzhiite'),(4238,1,'Semertsi'),(4238,2,'Семерци'),(4238,3,'Semertsi'),(4239,1,'Semkovtsi'),(4239,2,'Семковци'),(4239,3,'Semkovtsi'),(4240,1,'Semchinovo'),(4240,2,'Семчиново'),(4240,3,'Semchinovo'),(4241,1,'Sennik'),(4241,2,'Сенник'),(4241,3,'Sennik'),(4242,1,'Senovo'),(4242,2,'Сеново'),(4242,3,'Senovo'),(4243,1,'Senoklas'),(4243,2,'Сеноклас'),(4243,3,'Senoklas'),(4244,1,'Senokos'),(4244,2,'Сенокос'),(4244,3,'Senokos'),(4245,1,'Senokos'),(4245,2,'Сенокос'),(4245,3,'Senokos'),(4246,1,'Sentse'),(4246,2,'Сенце'),(4246,3,'Sentse'),(4247,1,'Septemvri'),(4247,2,'Септември'),(4247,3,'Septemvri'),(4248,1,'Septemvriytsi'),(4248,2,'Септемврийци'),(4248,3,'Septemvriytsi'),(4249,1,'Septemvriytsi'),(4249,2,'Септемврийци'),(4249,3,'Septemvriytsi'),(4250,1,'Septemvriytsi'),(4250,2,'Септемврийци'),(4250,3,'Septemvriytsi'),(4251,1,'Seslav'),(4251,2,'Сеслав'),(4251,3,'Seslav'),(4252,1,'Sestrimo'),(4252,2,'Сестримо'),(4252,3,'Sestrimo'),(4253,1,'Sestrinsko'),(4253,2,'Сестринско'),(4253,3,'Sestrinsko'),(4254,1,'Sechen kamak'),(4254,2,'Сечен камък'),(4254,3,'Sechen kamak'),(4255,1,'Sechishte'),(4255,2,'Сечище'),(4255,3,'Sechishte'),(4256,1,'Siv kladenets'),(4256,2,'Сив кладенец'),(4256,3,'Siv kladenets'),(4257,1,'Siva reka'),(4257,2,'Сива река'),(4257,3,'Siva reka'),(4258,1,'Sivino'),(4258,2,'Сивино'),(4258,3,'Sivino'),(4259,1,'Sigmen'),(4259,2,'Сигмен'),(4259,3,'Sigmen'),(4260,1,'Silen'),(4260,2,'Силен'),(4260,3,'Silen'),(4261,1,'Silistra'),(4261,2,'Силистра'),(4261,3,'Silistra'),(4262,1,'Simeonovgrad'),(4262,2,'Симеоновград'),(4262,3,'Simeonovgrad'),(4263,1,'Simeonovets'),(4263,2,'Симеоновец'),(4263,3,'Simeonovets'),(4264,1,'Simeonovo'),(4264,2,'Симеоново'),(4264,3,'Simeonovo'),(4265,1,'Simitli'),(4265,2,'Симитли'),(4265,3,'Simitli'),(4266,1,'Sinagovtsi'),(4266,2,'Синаговци'),(4266,3,'Sinagovtsi'),(4267,1,'Sinapovo'),(4267,2,'Синапово'),(4267,3,'Sinapovo'),(4268,1,'Sindel'),(4268,2,'Синдел'),(4268,3,'Sindel'),(4269,1,'Sindeltsi'),(4269,2,'Синделци'),(4269,3,'Sindeltsi'),(4270,1,'Sinemorets'),(4270,2,'Синеморец'),(4270,3,'Sinemorets'),(4271,1,'Sini vir'),(4271,2,'Сини вир'),(4271,3,'Sini vir'),(4272,1,'Sini vrah'),(4272,2,'Сини връх'),(4272,3,'Sini vrah'),(4273,1,'Sini rid'),(4273,2,'Сини рид'),(4273,3,'Sini rid'),(4274,1,'Siniger'),(4274,2,'Синигер'),(4274,3,'Siniger'),(4275,1,'Sinitovo'),(4275,2,'Синитово'),(4275,3,'Sinitovo'),(4276,1,'Sinchets'),(4276,2,'Синчец'),(4276,3,'Sinchets'),(4277,1,'Sinyo bardo'),(4277,2,'Синьо бърдо'),(4277,3,'Sinyo bardo'),(4278,1,'Sinyo kamene'),(4278,2,'Синьо камене'),(4278,3,'Sinyo kamene'),(4279,1,'Sinya voda'),(4279,2,'Синя вода'),(4279,3,'Sinya voda'),(4280,1,'Sipey'),(4280,2,'Сипей'),(4280,3,'Sipey'),(4281,1,'Sipets'),(4281,2,'Сипец'),(4281,3,'Sipets'),(4282,1,'Sirakovo'),(4282,2,'Сираково'),(4282,3,'Sirakovo'),(4283,1,'Sirakovo'),(4283,2,'Сираково'),(4283,3,'Sirakovo'),(4284,1,'Sirakovo'),(4284,2,'Сираково'),(4284,3,'Sirakovo'),(4285,1,'Sirishtnik'),(4285,2,'Сирищник'),(4285,3,'Sirishtnik'),(4286,1,'Sitovo'),(4286,2,'Ситово'),(4286,3,'Sitovo'),(4287,1,'Sitovo'),(4287,2,'Ситово'),(4287,3,'Sitovo'),(4288,1,'Sitovo'),(4288,2,'Ситово'),(4288,3,'Sitovo'),(4289,1,'Skala'),(4289,2,'Скала'),(4289,3,'Skala'),(4290,1,'Skala'),(4290,2,'Скала'),(4290,3,'Skala'),(4291,1,'Skalak'),(4291,2,'Скалак'),(4291,3,'Skalak'),(4292,1,'Skalak'),(4292,2,'Скалак'),(4292,3,'Skalak'),(4293,1,'Skalina'),(4293,2,'Скалина'),(4293,3,'Skalina'),(4294,1,'Skalitsa'),(4294,2,'Скалица'),(4294,3,'Skalitsa'),(4295,1,'Skalishte'),(4295,2,'Скалище'),(4295,3,'Skalishte'),(4296,1,'Skalna glava'),(4296,2,'Скална глава'),(4296,3,'Skalna glava'),(4297,1,'Skalsko'),(4297,2,'Скалско'),(4297,3,'Skalsko'),(4298,1,'Skandaloto'),(4298,2,'Скандалото'),(4298,3,'Skandaloto'),(4299,1,'Sklave'),(4299,2,'Склаве'),(4299,3,'Sklave'),(4300,1,'Skobelevo'),(4300,2,'Скобелево'),(4300,3,'Skobelevo'),(4301,1,'Skobelevo'),(4301,2,'Скобелево'),(4301,3,'Skobelevo'),(4302,1,'Skobelevo'),(4302,2,'Скобелево'),(4302,3,'Skobelevo'),(4303,1,'Skobelevo'),(4303,2,'Скобелево'),(4303,3,'Skobelevo'),(4304,1,'Skobelevo'),(4304,2,'Скобелево'),(4304,3,'Skobelevo'),(4305,1,'Skomlya'),(4305,2,'Скомля'),(4305,3,'Skomlya'),(4306,1,'Skortsite'),(4306,2,'Скорците'),(4306,3,'Skortsite'),(4307,1,'Skravena'),(4307,2,'Скравена'),(4307,3,'Skravena'),(4308,1,'Skrebatno'),(4308,2,'Скребатно'),(4308,3,'Skrebatno'),(4309,1,'Skrino'),(4309,2,'Скрино'),(4309,3,'Skrino'),(4310,1,'Skrinyano'),(4310,2,'Скриняно'),(4310,3,'Skrinyano'),(4311,1,'Skrat'),(4311,2,'Скрът'),(4311,3,'Skrat'),(4312,1,'Skutare'),(4312,2,'Скутаре'),(4312,3,'Skutare'),(4313,1,'Skarbino'),(4313,2,'Скърбино'),(4313,3,'Skarbino'),(4314,1,'Slaveevo'),(4314,2,'Славеево'),(4314,3,'Slaveevo'),(4315,1,'Slaveevo'),(4315,2,'Славеево'),(4315,3,'Slaveevo'),(4316,1,'Slaveykovo'),(4316,2,'Славейково'),(4316,3,'Slaveykovo'),(4317,1,'Slaveykovo'),(4317,2,'Славейково'),(4317,3,'Slaveykovo'),(4318,1,'Slaveykovo'),(4318,2,'Славейково'),(4318,3,'Slaveykovo'),(4319,1,'Slaveyno'),(4319,2,'Славейно'),(4319,3,'Slaveyno'),(4320,1,'Slavovitsa'),(4320,2,'Славовица'),(4320,3,'Slavovitsa'),(4321,1,'Slavovitsa'),(4321,2,'Славовица'),(4321,3,'Slavovitsa'),(4322,1,'Slavotin'),(4322,2,'Славотин'),(4322,3,'Slavotin'),(4323,1,'Slavshtitsa'),(4323,2,'Славщица'),(4323,3,'Slavshtitsa'),(4324,1,'Slavyani'),(4324,2,'Славяни'),(4324,3,'Slavyani'),(4325,1,'Slavyanin'),(4325,2,'Славянин'),(4325,3,'Slavyanin'),(4326,1,'Slavyanovo'),(4326,2,'Славяново'),(4326,3,'Slavyanovo'),(4327,1,'Slavyanovo'),(4327,2,'Славяново'),(4327,3,'Slavyanovo'),(4328,1,'Slavyanovo'),(4328,2,'Славяново'),(4328,3,'Slavyanovo'),(4329,1,'Slavyantsi'),(4329,2,'Славянци'),(4329,3,'Slavyantsi'),(4330,1,'Sladka voda'),(4330,2,'Сладка вода'),(4330,3,'Sladka voda'),(4331,1,'Sladkodum'),(4331,2,'Сладкодум'),(4331,3,'Sladkodum'),(4332,1,'Sladun'),(4332,2,'Сладун'),(4332,3,'Sladun'),(4333,1,'Sladak kladenets'),(4333,2,'Сладък кладенец'),(4333,3,'Sladak kladenets'),(4334,1,'Slakovtsi'),(4334,2,'Слаковци'),(4334,3,'Slakovtsi'),(4335,1,'Slamino'),(4335,2,'Сламино'),(4335,3,'Slamino'),(4336,1,'Slana bara'),(4336,2,'Слана бара'),(4336,3,'Slana bara'),(4337,1,'Slanotran'),(4337,2,'Сланотрън'),(4337,3,'Slanotran'),(4338,1,'Slatina'),(4338,2,'Слатина'),(4338,3,'Slatina'),(4339,1,'Slatina'),(4339,2,'Слатина'),(4339,3,'Slatina'),(4340,1,'Slatina'),(4340,2,'Слатина'),(4340,3,'Slatina'),(4341,1,'Slatina'),(4341,2,'Слатина'),(4341,3,'Slatina'),(4342,1,'Slatino'),(4342,2,'Слатино'),(4342,3,'Slatino'),(4343,1,'Slatino'),(4343,2,'Слатино'),(4343,3,'Slatino'),(4344,1,'Slashten'),(4344,2,'Слащен'),(4344,3,'Slashten'),(4345,1,'Slivak'),(4345,2,'Сливак'),(4345,3,'Slivak'),(4346,1,'Slivarka'),(4346,2,'Сливарка'),(4346,3,'Slivarka'),(4347,1,'Slivarovo'),(4347,2,'Сливарово'),(4347,3,'Slivarovo'),(4348,1,'Slivata'),(4348,2,'Сливата'),(4348,3,'Slivata'),(4349,1,'Slivek'),(4349,2,'Сливек'),(4349,3,'Slivek'),(4350,1,'Sliven'),(4350,2,'Сливен'),(4350,3,'Sliven'),(4351,1,'Sliventsi'),(4351,2,'Сливенци'),(4351,3,'Sliventsi'),(4352,1,'Slivito'),(4352,2,'Сливито'),(4352,3,'Slivito'),(4353,1,'Slivka'),(4353,2,'Сливка'),(4353,3,'Slivka'),(4354,1,'Slivnitsa'),(4354,2,'Сливница'),(4354,3,'Slivnitsa'),(4355,1,'Slivnitsa'),(4355,2,'Сливница'),(4355,3,'Slivnitsa'),(4356,1,'Slivo pole'),(4356,2,'Сливо поле'),(4356,3,'Slivo pole'),(4357,1,'Slivovik'),(4357,2,'Сливовик'),(4357,3,'Slivovik'),(4358,1,'Slivovitsa'),(4358,2,'Сливовица'),(4358,3,'Slivovitsa'),(4359,1,'Slivovnik'),(4359,2,'Сливовник'),(4359,3,'Slivovnik'),(4360,1,'Slivovo'),(4360,2,'Сливово'),(4360,3,'Slivovo'),(4361,1,'Slivovo'),(4361,2,'Сливово'),(4361,3,'Slivovo'),(4362,1,'Slivovo'),(4362,2,'Сливово'),(4362,3,'Slivovo'),(4363,1,'Slishovtsi'),(4363,2,'Слишовци'),(4363,3,'Slishovtsi'),(4364,1,'Slokoshtitsa'),(4364,2,'Слокощица'),(4364,3,'Slokoshtitsa'),(4365,1,'Slomer'),(4365,2,'Сломер'),(4365,3,'Slomer'),(4366,1,'Slanchevo'),(4366,2,'Слънчево'),(4366,3,'Slanchevo'),(4367,1,'Slanchovets'),(4367,2,'Слънчовец'),(4367,3,'Slanchovets'),(4368,1,'Slanchogled'),(4368,2,'Слънчоглед'),(4368,3,'Slanchogled'),(4369,1,'Smilets'),(4369,2,'Смилец'),(4369,3,'Smilets'),(4370,1,'Smilets'),(4370,2,'Смилец'),(4370,3,'Smilets'),(4371,1,'Smilovtsi'),(4371,2,'Смиловци'),(4371,3,'Smilovtsi'),(4372,1,'Smilyan'),(4372,2,'Смилян'),(4372,3,'Smilyan'),(4373,1,'Smin'),(4373,2,'Смин'),(4373,3,'Smin'),(4374,1,'Smirnenski'),(4374,2,'Смирненски'),(4374,3,'Smirnenski'),(4375,1,'Smirnenski'),(4375,2,'Смирненски'),(4375,3,'Smirnenski'),(4376,1,'Smirnentsi'),(4376,2,'Смирненци'),(4376,3,'Smirnentsi'),(4377,1,'Smirov dol'),(4377,2,'Смиров дол'),(4377,3,'Smirov dol'),(4378,1,'Smolevo'),(4378,2,'Смолево'),(4378,3,'Smolevo'),(4379,1,'Smolichano'),(4379,2,'Смоличано'),(4379,3,'Smolichano'),(4380,1,'Smolnik'),(4380,2,'Смолник'),(4380,3,'Smolnik'),(4381,1,'Smolnitsa'),(4381,2,'Смолница'),(4381,3,'Smolnitsa'),(4382,1,'Smolsko'),(4382,2,'Смолско'),(4382,3,'Smolsko'),(4383,1,'Smolcha'),(4383,2,'Смолча'),(4383,3,'Smolcha'),(4384,1,'Smolyan'),(4384,2,'Смолян'),(4384,3,'Smolyan'),(4385,1,'Smolyanovtsi'),(4385,2,'Смоляновци'),(4385,3,'Smolyanovtsi'),(4386,1,'Smochan'),(4386,2,'Смочан'),(4386,3,'Smochan'),(4387,1,'Smochevo'),(4387,2,'Смочево'),(4387,3,'Smochevo'),(4388,1,'Smyadovo'),(4388,2,'Смядово'),(4388,3,'Smyadovo'),(4389,1,'Snezha'),(4389,2,'Снежа'),(4389,3,'Snezha'),(4390,1,'Snezhina'),(4390,2,'Снежина'),(4390,3,'Snezhina'),(4391,1,'Snezhinka'),(4391,2,'Снежинка'),(4391,3,'Snezhinka'),(4392,1,'Snop'),(4392,2,'Сноп'),(4392,3,'Snop'),(4393,1,'Snyagovo'),(4393,2,'Снягово'),(4393,3,'Snyagovo'),(4394,1,'Snyagovo'),(4394,2,'Снягово'),(4394,3,'Snyagovo'),(4395,1,'Sovata'),(4395,2,'Совата'),(4395,3,'Sovata'),(4396,1,'Sovolyano'),(4396,2,'Соволяно'),(4396,3,'Sovolyano'),(4397,1,'Sozopol'),(4397,2,'Созопол'),(4397,3,'Sozopol'),(4398,1,'Sokol'),(4398,2,'Сокол'),(4398,3,'Sokol'),(4399,1,'Sokol'),(4399,2,'Сокол'),(4399,3,'Sokol'),(4400,1,'Sokolare'),(4400,2,'Соколаре'),(4400,3,'Sokolare'),(4401,1,'Sokolartsi'),(4401,2,'Соколарци'),(4401,3,'Sokolartsi'),(4402,1,'Sokolentsi'),(4402,2,'Соколенци'),(4402,3,'Sokolentsi'),(4403,1,'Sokolets'),(4403,2,'Соколец'),(4403,3,'Sokolets'),(4404,1,'Sokolino'),(4404,2,'Соколино'),(4404,3,'Sokolino'),(4405,1,'Sokolite'),(4405,2,'Соколите'),(4405,3,'Sokolite'),(4406,1,'Sokolitsa'),(4406,2,'Соколица'),(4406,3,'Sokolitsa'),(4407,1,'Sokolnik'),(4407,2,'Соколник'),(4407,3,'Sokolnik'),(4408,1,'Sokolovo'),(4408,2,'Соколово'),(4408,3,'Sokolovo'),(4409,1,'Sokolovo'),(4409,2,'Соколово'),(4409,3,'Sokolovo'),(4410,1,'Sokolovo'),(4410,2,'Соколово'),(4410,3,'Sokolovo'),(4411,1,'Sokolovo'),(4411,2,'Соколово'),(4411,3,'Sokolovo'),(4412,1,'Sokolovtsi'),(4412,2,'Соколовци'),(4412,3,'Sokolovtsi'),(4413,1,'Sokolsko'),(4413,2,'Соколско'),(4413,3,'Sokolsko'),(4414,1,'Sokolyane'),(4414,2,'Соколяне'),(4414,3,'Sokolyane'),(4415,1,'Solari'),(4415,2,'Солари'),(4415,3,'Solari'),(4416,1,'Solishta'),(4416,2,'Солища'),(4416,3,'Solishta'),(4417,1,'Solishte'),(4417,2,'Солище'),(4417,3,'Solishte'),(4418,1,'Solnik'),(4418,2,'Солник'),(4418,3,'Solnik'),(4419,1,'Somovit'),(4419,2,'Сомовит'),(4419,3,'Somovit'),(4420,1,'Sopitsa'),(4420,2,'Сопица'),(4420,3,'Sopitsa'),(4421,1,'Sopovo'),(4421,2,'Сопово'),(4421,3,'Sopovo'),(4422,1,'Sopot'),(4422,2,'Сопот'),(4422,3,'Sopot'),(4423,1,'Sopot'),(4423,2,'Сопот'),(4423,3,'Sopot'),(4424,1,'Sopotot'),(4424,2,'Сопотот'),(4424,3,'Sopotot'),(4425,1,'Sotirya'),(4425,2,'Сотиря'),(4425,3,'Sotirya'),(4426,1,'Sofiytsi'),(4426,2,'Софийци'),(4426,3,'Sofiytsi'),(4427,1,'Sofia'),(4427,2,'София'),(4427,3,'Sofia'),(4428,1,'Sofronievo'),(4428,2,'Софрониево'),(4428,3,'Sofronievo'),(4429,1,'Spantsi'),(4429,2,'Спанци'),(4429,3,'Spantsi'),(4430,1,'Spanchevtsi'),(4430,2,'Спанчевци'),(4430,3,'Spanchevtsi'),(4431,1,'Spasovo'),(4431,2,'Спасово'),(4431,3,'Spasovo'),(4432,1,'Spasovo'),(4432,2,'Спасово'),(4432,3,'Spasovo'),(4433,1,'Spasovtsi'),(4433,2,'Спасовци'),(4433,3,'Spasovtsi'),(4434,1,'Spatovo'),(4434,2,'Спатово'),(4434,3,'Spatovo'),(4435,1,'Spahievo'),(4435,2,'Спахиево'),(4435,3,'Spahievo'),(4436,1,'Spoluka'),(4436,2,'Сполука'),(4436,3,'Spoluka'),(4437,1,'Sratsimir'),(4437,2,'Срацимир'),(4437,3,'Sratsimir'),(4438,1,'Sratsimirovo'),(4438,2,'Срацимирово'),(4438,3,'Sratsimirovo'),(4439,1,'Srebrinovo'),(4439,2,'Сребриново'),(4439,3,'Srebrinovo'),(4440,1,'Srebarna'),(4440,2,'Сребърна'),(4440,3,'Srebarna'),(4441,1,'Sredets'),(4441,2,'Средец'),(4441,3,'Sredets'),(4442,1,'Sredets'),(4442,2,'Средец'),(4442,3,'Sredets'),(4443,1,'Sredets'),(4443,2,'Средец'),(4443,3,'Sredets'),(4444,1,'Sredina'),(4444,2,'Средина'),(4444,3,'Sredina'),(4445,1,'Sredinka'),(4445,2,'Срединка'),(4445,3,'Sredinka'),(4446,1,'Sredishte'),(4446,2,'Средище'),(4446,3,'Sredishte'),(4447,1,'Sredkovets'),(4447,2,'Средковец'),(4447,3,'Sredkovets'),(4448,1,'Sredna mahala'),(4448,2,'Средна махала'),(4448,3,'Sredna mahala'),(4449,1,'Srednevo'),(4449,2,'Среднево'),(4449,3,'Srednevo'),(4450,1,'Sredni kolibi'),(4450,2,'Средни колиби'),(4450,3,'Sredni kolibi'),(4451,1,'Sredni rat'),(4451,2,'Средни рът'),(4451,3,'Sredni rat'),(4452,1,'Sredno gradishte'),(4452,2,'Средно градище'),(4452,3,'Sredno gradishte'),(4453,1,'Sredno selo'),(4453,2,'Средно село'),(4453,3,'Sredno selo'),(4454,1,'Sredno selo'),(4454,2,'Средно село'),(4454,3,'Sredno selo'),(4455,1,'Srednogorovo'),(4455,2,'Средногорово'),(4455,3,'Srednogorovo'),(4456,1,'Srednogortsi'),(4456,2,'Средногорци'),(4456,3,'Srednogortsi'),(4457,1,'Srednya'),(4457,2,'Средня'),(4457,3,'Srednya'),(4458,1,'Sredogriv'),(4458,2,'Средогрив'),(4458,3,'Sredogriv'),(4459,1,'Sredok'),(4459,2,'Средок'),(4459,3,'Sredok'),(4460,1,'Sredorek'),(4460,2,'Средорек'),(4460,3,'Sredorek'),(4461,1,'Sredorek'),(4461,2,'Средорек'),(4461,3,'Sredorek'),(4462,1,'Sredoseltsi'),(4462,2,'Средоселци'),(4462,3,'Sredoseltsi'),(4463,1,'Sredska'),(4463,2,'Средска'),(4463,3,'Sredska'),(4464,1,'Sredsko'),(4464,2,'Средско'),(4464,3,'Sredsko'),(4465,1,'Srem'),(4465,2,'Срем'),(4465,3,'Srem'),(4466,1,'Sransko'),(4466,2,'Срънско'),(4466,3,'Sransko'),(4467,1,'Stavertsi'),(4467,2,'Ставерци'),(4467,3,'Stavertsi'),(4468,1,'Staevtsi'),(4468,2,'Стаевци'),(4468,3,'Staevtsi'),(4469,1,'Staynovtsi'),(4469,2,'Стайновци'),(4469,3,'Staynovtsi'),(4470,1,'Staychin dol'),(4470,2,'Стайчин дол'),(4470,3,'Staychin dol'),(4471,1,'Staychovtsi'),(4471,2,'Стайчовци'),(4471,3,'Staychovtsi'),(4472,1,'Stakevtsi'),(4472,2,'Стакевци'),(4472,3,'Stakevtsi'),(4473,1,'Stalevo'),(4473,2,'Сталево'),(4473,3,'Stalevo'),(4474,1,'Staliyska mahala'),(4474,2,'Сталийска махала'),(4474,3,'Staliyska mahala'),(4475,1,'Stamboliyski'),(4475,2,'Стамболийски'),(4475,3,'Stamboliyski'),(4476,1,'Stamboliyski'),(4476,2,'Стамболийски'),(4476,3,'Stamboliyski'),(4477,1,'Stambolovo'),(4477,2,'Стамболово'),(4477,3,'Stambolovo'),(4478,1,'Stambolovo'),(4478,2,'Стамболово'),(4478,3,'Stambolovo'),(4479,1,'Stambolovo'),(4479,2,'Стамболово'),(4479,3,'Stambolovo'),(4480,1,'Stambolovo'),(4480,2,'Стамболово'),(4480,3,'Stambolovo'),(4481,1,'Stan'),(4481,2,'Стан'),(4481,3,'Stan'),(4482,1,'Stanevo'),(4482,2,'Станево'),(4482,3,'Stanevo'),(4483,1,'Stanets'),(4483,2,'Станец'),(4483,3,'Stanets'),(4484,1,'Stanintsi'),(4484,2,'Станинци'),(4484,3,'Stanintsi'),(4485,1,'Stanovets'),(4485,2,'Становец'),(4485,3,'Stanovets'),(4486,1,'Stancha'),(4486,2,'Станча'),(4486,3,'Stancha'),(4487,1,'Stanchov han'),(4487,2,'Станчов хан'),(4487,3,'Stanchov han'),(4488,1,'Stanyovtsi'),(4488,2,'Станьовци'),(4488,3,'Stanyovtsi'),(4489,1,'Stanyantsi'),(4489,2,'Станянци'),(4489,3,'Stanyantsi'),(4490,1,'Star chitak'),(4490,2,'Стар читак'),(4490,3,'Star chitak'),(4491,1,'Stara Zagora'),(4491,2,'Стара Загора'),(4491,3,'Stara Zagora'),(4492,1,'Stara Kresna'),(4492,2,'Стара Кресна'),(4492,3,'Stara Kresna'),(4493,1,'Stara reka'),(4493,2,'Стара река'),(4493,3,'Stara reka'),(4494,1,'Stara reka'),(4494,2,'Стара река'),(4494,3,'Stara reka'),(4495,1,'Stara rechka'),(4495,2,'Стара речка'),(4495,3,'Stara rechka'),(4496,1,'Stareyshino'),(4496,2,'Старейшино'),(4496,3,'Stareyshino'),(4497,1,'Stari chal'),(4497,2,'Стари чал'),(4497,3,'Stari chal'),(4498,1,'Starilkovtsi'),(4498,2,'Старилковци'),(4498,3,'Starilkovtsi'),(4499,1,'Staro Zhelezare'),(4499,2,'Старо Железаре'),(4499,3,'Staro Zhelezare'),(4500,1,'Staro myasto'),(4500,2,'Старо място'),(4500,3,'Staro myasto'),(4501,1,'Staro Oryahovo'),(4501,2,'Старо Оряхово'),(4501,3,'Staro Oryahovo'),(4502,1,'Staro selishte'),(4502,2,'Старо селище'),(4502,3,'Staro selishte'),(4503,1,'Staro selo'),(4503,2,'Старо село'),(4503,3,'Staro selo'),(4504,1,'Staro selo'),(4504,2,'Старо село'),(4504,3,'Staro selo'),(4505,1,'Staro selo'),(4505,2,'Старо село'),(4505,3,'Staro selo'),(4506,1,'Staro selo'),(4506,2,'Старо село'),(4506,3,'Staro selo'),(4507,1,'Staro selo'),(4507,2,'Старо село'),(4507,3,'Staro selo'),(4508,1,'Starovo'),(4508,2,'Старово'),(4508,3,'Starovo'),(4509,1,'Starozagorski bani'),(4509,2,'Старозагорски бани'),(4509,3,'Starozagorski bani'),(4510,1,'Staropatitsa'),(4510,2,'Старопатица'),(4510,3,'Staropatitsa'),(4511,1,'Starosel'),(4511,2,'Старосел'),(4511,3,'Starosel'),(4512,1,'Staroselets'),(4512,2,'Староселец'),(4512,3,'Staroselets'),(4513,1,'Staroseltsi'),(4513,2,'Староселци'),(4513,3,'Staroseltsi'),(4514,1,'Startsevo'),(4514,2,'Старцево'),(4514,3,'Startsevo'),(4515,1,'Starchevo'),(4515,2,'Старчево'),(4515,3,'Starchevo'),(4516,1,'Starchishte'),(4516,2,'Старчище'),(4516,3,'Starchishte'),(4517,1,'Stevrek'),(4517,2,'Стеврек'),(4517,3,'Stevrek'),(4518,1,'Stezherovo'),(4518,2,'Стежерово'),(4518,3,'Stezherovo'),(4519,1,'Stensko'),(4519,2,'Стенско'),(4519,3,'Stensko'),(4520,1,'Stefan Karadzha'),(4520,2,'Стефан Караджа'),(4520,3,'Stefan Karadzha'),(4521,1,'Stefan Karadzha'),(4521,2,'Стефан Караджа'),(4521,3,'Stefan Karadzha'),(4522,1,'Stefan Karadzha'),(4522,2,'Стефан Караджа'),(4522,3,'Stefan Karadzha'),(4523,1,'Stefan Karadzhovo'),(4523,2,'Стефан Караджово'),(4523,3,'Stefan Karadzhovo'),(4524,1,'Stefan Stambolovo'),(4524,2,'Стефан Стамболово'),(4524,3,'Stefan Stambolovo'),(4525,1,'Stefanovo'),(4525,2,'Стефаново'),(4525,3,'Stefanovo'),(4526,1,'Stefanovo'),(4526,2,'Стефаново'),(4526,3,'Stefanovo'),(4527,1,'Stefanovo'),(4527,2,'Стефаново'),(4527,3,'Stefanovo'),(4528,1,'Stefanovo'),(4528,2,'Стефаново'),(4528,3,'Stefanovo'),(4529,1,'Stikal'),(4529,2,'Стикъл'),(4529,3,'Stikal'),(4530,1,'Stob'),(4530,2,'Стоб'),(4530,3,'Stob'),(4531,1,'Stoevo'),(4531,2,'Стоево'),(4531,3,'Stoevo'),(4532,1,'Stoevtsi'),(4532,2,'Стоевци'),(4532,3,'Stoevtsi'),(4533,1,'Stozha'),(4533,2,'Стожа'),(4533,3,'Stozha'),(4534,1,'Stozher'),(4534,2,'Стожер'),(4534,3,'Stozher'),(4535,1,'Stoil voyvoda'),(4535,2,'Стоил войвода'),(4535,3,'Stoil voyvoda'),(4536,1,'Stoilovo'),(4536,2,'Стоилово'),(4536,3,'Stoilovo'),(4537,1,'Stoykite'),(4537,2,'Стойките'),(4537,3,'Stoykite'),(4538,1,'Stoykovo'),(4538,2,'Стойково'),(4538,3,'Stoykovo'),(4539,1,'Stoykovtsi'),(4539,2,'Стойковци'),(4539,3,'Stoykovtsi'),(4540,1,'Stoynovo'),(4540,2,'Стойново'),(4540,3,'Stoynovo'),(4541,1,'Stoynovskoto'),(4541,2,'Стойновското'),(4541,3,'Stoynovskoto'),(4542,1,'Stoychevtsi'),(4542,2,'Стойчевци'),(4542,3,'Stoychevtsi'),(4543,1,'Stoychovtsi'),(4543,2,'Стойчовци'),(4543,3,'Stoychovtsi'),(4544,1,'Stokite'),(4544,2,'Стоките'),(4544,3,'Stokite'),(4545,1,'Stoletovo'),(4545,2,'Столетово'),(4545,3,'Stoletovo'),(4546,1,'Stoletovo'),(4546,2,'Столетово'),(4546,3,'Stoletovo'),(4547,1,'Stolnik'),(4547,2,'Столник'),(4547,3,'Stolnik'),(4548,1,'Stolat'),(4548,2,'Столът'),(4548,3,'Stolat'),(4549,1,'Stomanevo'),(4549,2,'Стоманево'),(4549,3,'Stomanevo'),(4550,1,'Stomanetsite'),(4550,2,'Стоманеците'),(4550,3,'Stomanetsite'),(4551,1,'Stomantsi'),(4551,2,'Стоманци'),(4551,3,'Stomantsi'),(4552,1,'Stoyan Mihaylovski'),(4552,2,'Стоян Михайловски'),(4552,3,'Stoyan Mihaylovski'),(4553,1,'Stoyan-Zaimovo'),(4553,2,'Стоян-Заимово'),(4553,3,'Stoyan-Zaimovo'),(4554,1,'Stoyanovo'),(4554,2,'Стояново'),(4554,3,'Stoyanovo'),(4555,1,'Stoyanovo'),(4555,2,'Стояново'),(4555,3,'Stoyanovo'),(4556,1,'Stoyanovtsi'),(4556,2,'Стояновци'),(4556,3,'Stoyanovtsi'),(4557,1,'Stoyanovtsi'),(4557,2,'Стояновци'),(4557,3,'Stoyanovtsi'),(4558,1,'Stradalovo'),(4558,2,'Страдалово'),(4558,3,'Stradalovo'),(4559,1,'Strazha'),(4559,2,'Стража'),(4559,3,'Strazha'),(4560,1,'Strazha'),(4560,2,'Стража'),(4560,3,'Strazha'),(4561,1,'Strazhata'),(4561,2,'Стражата'),(4561,3,'Strazhata'),(4562,1,'Strazhevtsi'),(4562,2,'Стражевци'),(4562,3,'Strazhevtsi'),(4563,1,'Strazhets'),(4563,2,'Стражец'),(4563,3,'Strazhets'),(4564,1,'Strazhets'),(4564,2,'Стражец'),(4564,3,'Strazhets'),(4565,1,'Strazhitsa'),(4565,2,'Стражица'),(4565,3,'Strazhitsa'),(4566,1,'Strazhitsa'),(4566,2,'Стражица'),(4566,3,'Strazhitsa'),(4567,1,'Strazhnitsa'),(4567,2,'Стражница'),(4567,3,'Strazhnitsa'),(4568,1,'Straldzha'),(4568,2,'Стралджа'),(4568,3,'Straldzha'),(4569,1,'Strandzha'),(4569,2,'Странджа'),(4569,3,'Strandzha'),(4570,1,'Strandzhevo'),(4570,2,'Странджево'),(4570,3,'Strandzhevo'),(4571,1,'Stransko'),(4571,2,'Странско'),(4571,3,'Stransko'),(4572,1,'Strahil'),(4572,2,'Страхил'),(4572,3,'Strahil'),(4573,1,'Strahil voyvoda'),(4573,2,'Страхил войвода'),(4573,3,'Strahil voyvoda'),(4574,1,'Strahilitsa'),(4574,2,'Страхилица'),(4574,3,'Strahilitsa'),(4575,1,'Strahilovo'),(4575,2,'Страхилово'),(4575,3,'Strahilovo'),(4576,1,'Stratsin'),(4576,2,'Страцин'),(4576,3,'Stratsin'),(4577,1,'Strashimir'),(4577,2,'Страшимир'),(4577,3,'Strashimir'),(4578,1,'Strashimirovo'),(4578,2,'Страшимирово'),(4578,3,'Strashimirovo'),(4579,1,'Strezimirovtsi'),(4579,2,'Стрезимировци'),(4579,3,'Strezimirovtsi'),(4580,1,'Strelets'),(4580,2,'Стрелец'),(4580,3,'Strelets'),(4581,1,'Strelets'),(4581,2,'Стрелец'),(4581,3,'Strelets'),(4582,1,'Strelkovo'),(4582,2,'Стрелково'),(4582,3,'Strelkovo'),(4583,1,'Streltsi'),(4583,2,'Стрелци'),(4583,3,'Streltsi'),(4584,1,'Streltsi'),(4584,2,'Стрелци'),(4584,3,'Streltsi'),(4585,1,'Strelcha'),(4585,2,'Стрелча'),(4585,3,'Strelcha'),(4586,1,'Stremovo'),(4586,2,'Стремово'),(4586,3,'Stremovo'),(4587,1,'Stremtsi'),(4587,2,'Стремци'),(4587,3,'Stremtsi'),(4588,1,'Strizhba'),(4588,2,'Стрижба'),(4588,3,'Strizhba'),(4589,1,'Stroevo'),(4589,2,'Строево'),(4589,3,'Stroevo'),(4590,1,'Stroyno'),(4590,2,'Стройно'),(4590,3,'Stroyno'),(4591,1,'Stroynovtsi'),(4591,2,'Стройновци'),(4591,3,'Stroynovtsi'),(4592,1,'Strugat'),(4592,2,'Стругът'),(4592,3,'Strugat'),(4593,1,'Struindol'),(4593,2,'Струиндол'),(4593,3,'Struindol'),(4594,1,'Struino'),(4594,2,'Струино'),(4594,3,'Struino'),(4595,1,'Struma'),(4595,2,'Струма'),(4595,3,'Struma'),(4596,1,'Strumeshnitsa'),(4596,2,'Струмешница'),(4596,3,'Strumeshnitsa'),(4597,1,'Strumyani'),(4597,2,'Струмяни'),(4597,3,'Strumyani'),(4598,1,'Strupets'),(4598,2,'Струпец'),(4598,3,'Strupets'),(4599,1,'Strupets'),(4599,2,'Струпец'),(4599,3,'Strupets'),(4600,1,'Struya'),(4600,2,'Струя'),(4600,3,'Struya'),(4601,1,'Stramtsi'),(4601,2,'Стръмци'),(4601,3,'Stramtsi'),(4602,1,'Stryama'),(4602,2,'Стряма'),(4602,3,'Stryama'),(4603,1,'Stubel'),(4603,2,'Стубел'),(4603,3,'Stubel'),(4604,1,'Studen izvor'),(4604,2,'Студен извор'),(4604,3,'Studen izvor'),(4605,1,'Studen kladenets'),(4605,2,'Студен кладенец'),(4605,3,'Studen kladenets'),(4606,1,'Studena'),(4606,2,'Студена'),(4606,3,'Studena'),(4607,1,'Studena'),(4607,2,'Студена'),(4607,3,'Studena'),(4608,1,'Studena'),(4608,2,'Студена'),(4608,3,'Studena'),(4609,1,'Studenets'),(4609,2,'Студенец'),(4609,3,'Studenets'),(4610,1,'Studenets'),(4610,2,'Студенец'),(4610,3,'Studenets'),(4611,1,'Studenitsa'),(4611,2,'Студеница'),(4611,3,'Studenitsa'),(4612,1,'Studeno buche'),(4612,2,'Студено буче'),(4612,3,'Studeno buche'),(4613,1,'Stargel'),(4613,2,'Стъргел'),(4613,3,'Stargel'),(4614,1,'Starmen'),(4614,2,'Стърмен'),(4614,3,'Starmen'),(4615,1,'Starnitsa'),(4615,2,'Стърница'),(4615,3,'Starnitsa'),(4616,1,'Suvorovo'),(4616,2,'Суворово'),(4616,3,'Suvorovo'),(4617,1,'Sugarevo'),(4617,2,'Сугарево'),(4617,3,'Sugarevo'),(4618,1,'Sulitsa'),(4618,2,'Сулица'),(4618,3,'Sulitsa'),(4619,1,'Sultani'),(4619,2,'Султани'),(4619,3,'Sultani'),(4620,1,'Sumer'),(4620,2,'Сумер'),(4620,3,'Sumer'),(4621,1,'Sungurlare'),(4621,2,'Сунгурларе'),(4621,3,'Sungurlare'),(4622,1,'Susam'),(4622,2,'Сусам'),(4622,3,'Susam'),(4623,1,'Suha reka'),(4623,2,'Суха река'),(4623,3,'Suha reka'),(4624,1,'Suha reka'),(4624,2,'Суха река'),(4624,3,'Suha reka'),(4625,1,'Suhache'),(4625,2,'Сухаче'),(4625,3,'Suhache'),(4626,1,'Suhindol'),(4626,2,'Сухиндол'),(4626,3,'Suhindol'),(4627,1,'Suhovo'),(4627,2,'Сухово'),(4627,3,'Suhovo'),(4628,1,'Suhodol'),(4628,2,'Суходол'),(4628,3,'Suhodol'),(4629,1,'Suhodol'),(4629,2,'Суходол'),(4629,3,'Suhodol'),(4630,1,'Suhozem'),(4630,2,'Сухозем'),(4630,3,'Suhozem'),(4631,1,'Suholoevtsi'),(4631,2,'Сухолоевци'),(4631,3,'Suholoevtsi'),(4632,1,'Suhostrel'),(4632,2,'Сухострел'),(4632,3,'Suhostrel'),(4633,1,'Sushevo'),(4633,2,'Сушево'),(4633,3,'Sushevo'),(4634,1,'Sushina'),(4634,2,'Сушина'),(4634,3,'Sushina'),(4635,1,'Sushitsa'),(4635,2,'Сушица'),(4635,3,'Sushitsa'),(4636,1,'Sushitsa'),(4636,2,'Сушица'),(4636,3,'Sushitsa'),(4637,1,'Sushitsa'),(4637,2,'Сушица'),(4637,3,'Sushitsa'),(4638,1,'Sabkovtsi'),(4638,2,'Събковци'),(4638,3,'Sabkovtsi'),(4639,1,'Sabotkovtsi'),(4639,2,'Съботковци'),(4639,3,'Sabotkovtsi'),(4640,1,'Sabrano'),(4640,2,'Събрано'),(4640,3,'Sabrano'),(4641,1,'Sadievo'),(4641,2,'Съдиево'),(4641,3,'Sadievo'),(4642,1,'Sadievo'),(4642,2,'Съдиево'),(4642,3,'Sadievo'),(4643,1,'Sadiysko pole'),(4643,2,'Съдийско поле'),(4643,3,'Sadiysko pole'),(4644,1,'Saedinenie'),(4644,2,'Съединение'),(4644,3,'Saedinenie'),(4645,1,'Saedinenie'),(4645,2,'Съединение'),(4645,3,'Saedinenie'),(4646,1,'Saedinenie'),(4646,2,'Съединение'),(4646,3,'Saedinenie'),(4647,1,'Saedinenie'),(4647,2,'Съединение'),(4647,3,'Saedinenie'),(4648,1,'Sarnak'),(4648,2,'Сърнак'),(4648,3,'Sarnak'),(4649,1,'Sarnevets'),(4649,2,'Сърневец'),(4649,3,'Sarnevets'),(4650,1,'Sarnevo'),(4650,2,'Сърнево'),(4650,3,'Sarnevo'),(4651,1,'Sarnevo'),(4651,2,'Сърнево'),(4651,3,'Sarnevo'),(4652,1,'Sarnegor'),(4652,2,'Сърнегор'),(4652,3,'Sarnegor'),(4653,1,'Sarnentsi'),(4653,2,'Сърненци'),(4653,3,'Sarnentsi'),(4654,1,'Sarnets'),(4654,2,'Сърнец'),(4654,3,'Sarnets'),(4655,1,'Sarnino'),(4655,2,'Сърнино'),(4655,3,'Sarnino'),(4656,1,'Sarnino'),(4656,2,'Сърнино'),(4656,3,'Sarnino'),(4657,1,'Sarnitsa'),(4657,2,'Сърница'),(4657,3,'Sarnitsa'),(4658,1,'Sarnitsa'),(4658,2,'Сърница'),(4658,3,'Sarnitsa'),(4659,1,'Sarpovo'),(4659,2,'Сърпово'),(4659,3,'Sarpovo'),(4660,1,'Sartsevo'),(4660,2,'Сърцево'),(4660,3,'Sartsevo'),(4661,1,'Syanovo'),(4661,2,'Сяново'),(4661,3,'Syanovo'),(4662,1,'Syarovtsi'),(4662,2,'Сяровци'),(4662,3,'Syarovtsi'),(4663,1,'Syartsi'),(4663,2,'Сярци'),(4663,3,'Syartsi'),(4664,1,'Taban'),(4664,2,'Табан'),(4664,3,'Taban'),(4665,1,'Tabachka'),(4665,2,'Табачка'),(4665,3,'Tabachka'),(4666,1,'Tabashka'),(4666,2,'Табашка'),(4666,3,'Tabashka'),(4667,1,'Tavalichevo'),(4667,2,'Таваличево'),(4667,3,'Tavalichevo'),(4668,1,'Taymishte'),(4668,2,'Таймище'),(4668,3,'Taymishte'),(4669,1,'Tamarino'),(4669,2,'Тамарино'),(4669,3,'Tamarino'),(4670,1,'Tatarevo'),(4670,2,'Татарево'),(4670,3,'Tatarevo'),(4671,1,'Tatarevo'),(4671,2,'Татарево'),(4671,3,'Tatarevo'),(4672,1,'Tatari'),(4672,2,'Татари'),(4672,3,'Tatari'),(4673,1,'Tatkovo'),(4673,2,'Татково'),(4673,3,'Tatkovo'),(4674,1,'Tatul'),(4674,2,'Татул'),(4674,3,'Tatul'),(4675,1,'Tvardintsi'),(4675,2,'Твърдинци'),(4675,3,'Tvardintsi'),(4676,1,'Tvarditsa'),(4676,2,'Твърдица'),(4676,3,'Tvarditsa'),(4677,1,'Tvarditsa'),(4677,2,'Твърдица'),(4677,3,'Tvarditsa'),(4678,1,'Tvarditsa'),(4678,2,'Твърдица'),(4678,3,'Tvarditsa'),(4679,1,'Teketo'),(4679,2,'Текето'),(4679,3,'Teketo'),(4680,1,'Telerig'),(4680,2,'Телериг'),(4680,3,'Telerig'),(4681,1,'Telish'),(4681,2,'Телиш'),(4681,3,'Telish'),(4682,1,'Telcharka'),(4682,2,'Телчарка'),(4682,3,'Telcharka'),(4683,1,'Temenuga'),(4683,2,'Теменуга'),(4683,3,'Temenuga'),(4684,1,'Temenuga'),(4684,2,'Теменуга'),(4684,3,'Temenuga'),(4685,1,'Tenevo'),(4685,2,'Тенево'),(4685,3,'Tenevo'),(4686,1,'Tepava'),(4686,2,'Тепава'),(4686,3,'Tepava'),(4687,1,'Teplen'),(4687,2,'Теплен'),(4687,3,'Teplen'),(4688,1,'Tervel'),(4688,2,'Тервел'),(4688,3,'Tervel'),(4689,1,'Tervel'),(4689,2,'Тервел'),(4689,3,'Tervel'),(4690,1,'Terziite'),(4690,2,'Терзиите'),(4690,3,'Terziite'),(4691,1,'Terziysko'),(4691,2,'Терзийско'),(4691,3,'Terziysko'),(4692,1,'Terziysko'),(4692,2,'Терзийско'),(4692,3,'Terziysko'),(4693,1,'Terter'),(4693,2,'Тертер'),(4693,3,'Terter'),(4694,1,'Teteven'),(4694,2,'Тетевен'),(4694,3,'Teteven'),(4695,1,'Tetovo'),(4695,2,'Тетово'),(4695,3,'Tetovo'),(4696,1,'Teshel'),(4696,2,'Тешел'),(4696,3,'Teshel'),(4697,1,'Teshovo'),(4697,2,'Тешово'),(4697,3,'Teshovo'),(4698,1,'Tikale'),(4698,2,'Тикале'),(4698,3,'Tikale'),(4699,1,'Timarevo'),(4699,2,'Тимарево'),(4699,3,'Timarevo'),(4700,1,'Tintyava'),(4700,2,'Тинтява'),(4700,3,'Tintyava'),(4701,1,'Tipchenitsa'),(4701,2,'Типченица'),(4701,3,'Tipchenitsa'),(4702,1,'Titevtsi'),(4702,2,'Титевци'),(4702,3,'Titevtsi'),(4703,1,'Tihovets'),(4703,2,'Тиховец'),(4703,3,'Tihovets'),(4704,1,'Tihomir'),(4704,2,'Тихомир'),(4704,3,'Tihomir'),(4705,1,'Tihomirovo'),(4705,2,'Тихомирово'),(4705,3,'Tihomirovo'),(4706,1,'Ticha'),(4706,2,'Тича'),(4706,3,'Ticha'),(4707,1,'Tishanovo'),(4707,2,'Тишаново'),(4707,3,'Tishanovo'),(4708,1,'Tishevitsa'),(4708,2,'Тишевица'),(4708,3,'Tishevitsa'),(4709,1,'Tianovtsi'),(4709,2,'Тияновци'),(4709,3,'Tianovtsi'),(4710,1,'Tlachene'),(4710,2,'Тлачене'),(4710,3,'Tlachene'),(4711,1,'Todor ikonomovo'),(4711,2,'Тодор Икономово'),(4711,3,'Todor ikonomovo'),(4712,1,'Todoretsite'),(4712,2,'Тодореците'),(4712,3,'Todoretsite'),(4713,1,'Todorichene'),(4713,2,'Тодоричене'),(4713,3,'Todorichene'),(4714,1,'Todorovo'),(4714,2,'Тодорово'),(4714,3,'Todorovo'),(4715,1,'Todorovo'),(4715,2,'Тодорово'),(4715,3,'Todorovo'),(4716,1,'Todorovtsi'),(4716,2,'Тодоровци'),(4716,3,'Todorovtsi'),(4717,1,'Todorovtsi'),(4717,2,'Тодоровци'),(4717,3,'Todorovtsi'),(4718,1,'Todorcheta'),(4718,2,'Тодорчета'),(4718,3,'Todorcheta'),(4719,1,'Todyuvtsi'),(4719,2,'Тодювци'),(4719,3,'Todyuvtsi'),(4720,1,'Tokachka'),(4720,2,'Токачка'),(4720,3,'Tokachka'),(4721,1,'Tolovitsa'),(4721,2,'Толовица'),(4721,3,'Tolovitsa'),(4722,1,'Tombeto'),(4722,2,'Томбето'),(4722,3,'Tombeto'),(4723,1,'Tompsan'),(4723,2,'Томпсън'),(4723,3,'Tompsan'),(4724,1,'Tomchevtsi'),(4724,2,'Томчевци'),(4724,3,'Tomchevtsi'),(4725,1,'Tonsko dabe'),(4725,2,'Тонско дабе'),(4725,3,'Tonsko dabe'),(4726,1,'Topola'),(4726,2,'Топола'),(4726,3,'Topola'),(4727,1,'Topoli'),(4727,2,'Тополи'),(4727,3,'Topoli'),(4728,1,'Topoli dol'),(4728,2,'Тополи дол'),(4728,3,'Topoli dol'),(4729,1,'Topolitsa'),(4729,2,'Тополица'),(4729,3,'Topolitsa'),(4730,1,'Topolka'),(4730,2,'Тополка'),(4730,3,'Topolka'),(4731,1,'Topolnitsa'),(4731,2,'Тополница'),(4731,3,'Topolnitsa'),(4732,1,'Topolnitsa'),(4732,2,'Тополница'),(4732,3,'Topolnitsa'),(4733,1,'Topolovgrad'),(4733,2,'Тополовград'),(4733,3,'Topolovgrad'),(4734,1,'Topolovets'),(4734,2,'Тополовец'),(4734,3,'Topolovets'),(4735,1,'Topolovets'),(4735,2,'Тополовец'),(4735,3,'Topolovets'),(4736,1,'Topolovo'),(4736,2,'Тополово'),(4736,3,'Topolovo'),(4737,1,'Topolovo'),(4737,2,'Тополово'),(4737,3,'Topolovo'),(4738,1,'Topolchane'),(4738,2,'Тополчане'),(4738,3,'Topolchane'),(4739,1,'Topolchane'),(4739,2,'Тополчане'),(4739,3,'Topolchane'),(4740,1,'Topolyane'),(4740,2,'Тополяне'),(4740,3,'Topolyane'),(4741,1,'Topuzevo'),(4741,2,'Топузево'),(4741,3,'Topuzevo'),(4742,1,'Topuzi'),(4742,2,'Топузи'),(4742,3,'Topuzi'),(4743,1,'Topchii'),(4743,2,'Топчии'),(4743,3,'Topchii'),(4744,1,'Topchiysko'),(4744,2,'Топчийско'),(4744,3,'Topchiysko'),(4745,1,'Torbalazhite'),(4745,2,'Торбалъжите'),(4745,3,'Torbalazhite'),(4746,1,'Toros'),(4746,2,'Торос'),(4746,3,'Toros'),(4747,1,'Totleben'),(4747,2,'Тотлебен'),(4747,3,'Totleben'),(4748,1,'Tochilari'),(4748,2,'Точилари'),(4748,3,'Tochilari'),(4749,1,'Toshevtsi'),(4749,2,'Тошевци'),(4749,3,'Toshevtsi'),(4750,1,'Trave'),(4750,2,'Траве'),(4750,3,'Trave'),(4751,1,'Travnik'),(4751,2,'Травник'),(4751,3,'Travnik'),(4752,1,'Traykovo'),(4752,2,'Трайково'),(4752,3,'Traykovo'),(4753,1,'Trakiets'),(4753,2,'Тракиец'),(4753,3,'Trakiets'),(4754,1,'Trakiytsi'),(4754,2,'Тракийци'),(4754,3,'Trakiytsi'),(4755,1,'Trakia'),(4755,2,'Тракия'),(4755,3,'Trakia'),(4756,1,'Trapeskovtsi'),(4756,2,'Трапесковци'),(4756,3,'Trapeskovtsi'),(4757,1,'Trapishte'),(4757,2,'Трапище'),(4757,3,'Trapishte'),(4758,1,'Trapoklovo'),(4758,2,'Трапоклово'),(4758,3,'Trapoklovo'),(4759,1,'Trebishte'),(4759,2,'Требище'),(4759,3,'Trebishte'),(4760,1,'Treklyano'),(4760,2,'Трекляно'),(4760,3,'Treklyano'),(4761,1,'Trem'),(4761,2,'Трем'),(4761,3,'Trem'),(4762,1,'Treskavets'),(4762,2,'Трескавец'),(4762,3,'Treskavets'),(4763,1,'Tri kladentsi'),(4763,2,'Три кладенци'),(4763,3,'Tri kladentsi'),(4764,1,'Tri mogili'),(4764,2,'Три могили'),(4764,3,'Tri mogili'),(4765,1,'Tri mogili'),(4765,2,'Три могили'),(4765,3,'Tri mogili'),(4766,1,'Trivoditsi'),(4766,2,'Триводици'),(4766,3,'Trivoditsi'),(4767,1,'Trigortsi'),(4767,2,'Тригорци'),(4767,3,'Trigortsi'),(4768,1,'Trigrad'),(4768,2,'Триград'),(4768,3,'Trigrad'),(4769,1,'Trilistnik'),(4769,2,'Трилистник'),(4769,3,'Trilistnik'),(4770,1,'Trifonovo'),(4770,2,'Трифоново'),(4770,3,'Trifonovo'),(4771,1,'Troitsa'),(4771,2,'Троица'),(4771,3,'Troitsa'),(4772,1,'Troskovo'),(4772,2,'Тросково'),(4772,3,'Troskovo'),(4773,1,'Troyan'),(4773,2,'Троян'),(4773,3,'Troyan'),(4774,1,'Troyan'),(4774,2,'Троян'),(4774,3,'Troyan'),(4775,1,'Troyanovo'),(4775,2,'Трояново'),(4775,3,'Troyanovo'),(4776,1,'Troyanovo'),(4776,2,'Трояново'),(4776,3,'Troyanovo'),(4777,1,'Trud'),(4777,2,'Труд'),(4777,3,'Trud'),(4778,1,'Trudovets'),(4778,2,'Трудовец'),(4778,3,'Trudovets'),(4779,1,'Trabach'),(4779,2,'Тръбач'),(4779,3,'Trabach'),(4780,1,'Tran'),(4780,2,'Трън'),(4780,3,'Tran'),(4781,1,'Tranak'),(4781,2,'Трънак'),(4781,3,'Tranak'),(4782,1,'Tranito'),(4782,2,'Трънито'),(4782,3,'Tranito'),(4783,1,'Tranitsa'),(4783,2,'Тръница'),(4783,3,'Tranitsa'),(4784,1,'Trankovo'),(4784,2,'Трънково'),(4784,3,'Trankovo'),(4785,1,'Trankovo'),(4785,2,'Трънково'),(4785,3,'Trankovo'),(4786,1,'Trankovtsi'),(4786,2,'Трънковци'),(4786,3,'Trankovtsi'),(4787,1,'Tranchovitsa'),(4787,2,'Трънчовица'),(4787,3,'Tranchovitsa'),(4788,1,'Trastenik'),(4788,2,'Тръстеник'),(4788,3,'Trastenik'),(4789,1,'Trastenik'),(4789,2,'Тръстеник'),(4789,3,'Trastenik'),(4790,1,'Trastika'),(4790,2,'Тръстика'),(4790,3,'Trastika'),(4791,1,'Trastikovo'),(4791,2,'Тръстиково'),(4791,3,'Trastikovo'),(4792,1,'Trastikovo'),(4792,2,'Тръстиково'),(4792,3,'Trastikovo'),(4793,1,'Tryavna'),(4793,2,'Трявна'),(4793,3,'Tryavna'),(4794,1,'Tuden'),(4794,2,'Туден'),(4794,3,'Tuden'),(4795,1,'Tulovo'),(4795,2,'Тулово'),(4795,3,'Tulovo'),(4796,1,'Tumbalovo'),(4796,2,'Тумбалово'),(4796,3,'Tumbalovo'),(4797,1,'Tumbevtsi'),(4797,2,'Тумбевци'),(4797,3,'Tumbevtsi'),(4798,1,'Turia'),(4798,2,'Турия'),(4798,3,'Turia'),(4799,1,'Turkincha'),(4799,2,'Туркинча'),(4799,3,'Turkincha'),(4800,1,'Turokovtsi'),(4800,2,'Туроковци'),(4800,3,'Turokovtsi'),(4801,1,'Turyan'),(4801,2,'Турян'),(4801,3,'Turyan'),(4802,1,'Tutrakan'),(4802,2,'Тутракан'),(4802,3,'Tutrakan'),(4803,1,'Tutrakantsi'),(4803,2,'Тутраканци'),(4803,3,'Tutrakantsi'),(4804,1,'Tuhovishta'),(4804,2,'Туховища'),(4804,3,'Tuhovishta'),(4805,1,'Tuchenitsa'),(4805,2,'Тученица'),(4805,3,'Tuchenitsa'),(4806,1,'Tushovitsa'),(4806,2,'Тушовица'),(4806,3,'Tushovitsa'),(4807,1,'Tazha'),(4807,2,'Тъжа'),(4807,3,'Tazha'),(4808,1,'Takach'),(4808,2,'Тъкач'),(4808,3,'Takach'),(4809,1,'Tanka bara'),(4809,2,'Тънка бара'),(4809,3,'Tanka bara'),(4810,1,'Tanki rat'),(4810,2,'Тънки рът'),(4810,3,'Tanki rat'),(4811,1,'Tankovo'),(4811,2,'Тънково'),(4811,3,'Tankovo'),(4812,1,'Tankovo'),(4812,2,'Тънково'),(4812,3,'Tankovo'),(4813,1,'Tankoto'),(4813,2,'Тънкото'),(4813,3,'Tankoto'),(4814,1,'Tapchileshtovo'),(4814,2,'Тъпчилещово'),(4814,3,'Tapchileshtovo'),(4815,1,'Targovishte'),(4815,2,'Търговище'),(4815,3,'Targovishte'),(4816,1,'Targovishte'),(4816,2,'Търговище'),(4816,3,'Targovishte'),(4817,1,'Tarkasheni'),(4817,2,'Търкашени'),(4817,3,'Tarkasheni'),(4818,1,'Tarna'),(4818,2,'Търна'),(4818,3,'Tarna'),(4819,1,'Tarnava'),(4819,2,'Търнава'),(4819,3,'Tarnava'),(4820,1,'Tarnava'),(4820,2,'Търнава'),(4820,3,'Tarnava'),(4821,1,'Tarnak'),(4821,2,'Търнак'),(4821,3,'Tarnak'),(4822,1,'Tarnene'),(4822,2,'Търнене'),(4822,3,'Tarnene'),(4823,1,'Tarnicheni'),(4823,2,'Търничени'),(4823,3,'Tarnicheni'),(4824,1,'Tarnovlag'),(4824,2,'Търновлаг'),(4824,3,'Tarnovlag'),(4825,1,'Tarnovtsa'),(4825,2,'Търновца'),(4825,3,'Tarnovtsa'),(4826,1,'Tarnovtsi'),(4826,2,'Търновци'),(4826,3,'Tarnovtsi'),(4827,1,'Tarnovtsi'),(4827,2,'Търновци'),(4827,3,'Tarnovtsi'),(4828,1,'Tarnoslivka'),(4828,2,'Търносливка'),(4828,3,'Tarnoslivka'),(4829,1,'Tarnyane'),(4829,2,'Търняне'),(4829,3,'Tarnyane'),(4830,1,'Tarsino'),(4830,2,'Търсино'),(4830,3,'Tarsino'),(4831,1,'Tarhovo'),(4831,2,'Търхово'),(4831,3,'Tarhovo'),(4832,1,'Taran'),(4832,2,'Търън'),(4832,3,'Taran'),(4833,1,'Tyulenovo'),(4833,2,'Тюленово'),(4833,3,'Tyulenovo'),(4834,1,'Tyurkmen'),(4834,2,'Тюркмен'),(4834,3,'Tyurkmen'),(4835,1,'Tyutyunche'),(4835,2,'Тютюнче'),(4835,3,'Tyutyunche'),(4836,1,'Tyanevo'),(4836,2,'Тянево'),(4836,3,'Tyanevo'),(4837,1,'Tyanevo'),(4837,2,'Тянево'),(4837,3,'Tyanevo'),(4838,1,'Ugledno'),(4838,2,'Угледно'),(4838,3,'Ugledno'),(4839,1,'Uglyartsi'),(4839,2,'Углярци'),(4839,3,'Uglyartsi'),(4840,1,'Ugorelets'),(4840,2,'Угорелец'),(4840,3,'Ugorelets'),(4841,1,'Ugoryalkovtsi'),(4841,2,'Угорялковци'),(4841,3,'Ugoryalkovtsi'),(4842,1,'Ugarchin'),(4842,2,'Угърчин'),(4842,3,'Ugarchin'),(4843,1,'Uzovo'),(4843,2,'Узово'),(4843,3,'Uzovo'),(4844,1,'Uzundzhovo'),(4844,2,'Узунджово'),(4844,3,'Uzundzhovo'),(4845,1,'Uzunite'),(4845,2,'Узуните'),(4845,3,'Uzunite'),(4846,1,'Uzunovo'),(4846,2,'Узуново'),(4846,3,'Uzunovo'),(4847,1,'Umarevtsi'),(4847,2,'Умаревци'),(4847,3,'Umarevtsi'),(4848,1,'Urvata'),(4848,2,'Урвата'),(4848,3,'Urvata'),(4849,1,'Urovene'),(4849,2,'Уровене'),(4849,3,'Urovene'),(4850,1,'Uruchevtsi'),(4850,2,'Уручевци'),(4850,3,'Uruchevtsi'),(4851,1,'Usoyka'),(4851,2,'Усойка'),(4851,3,'Usoyka'),(4852,1,'Ustina'),(4852,2,'Устина'),(4852,3,'Ustina'),(4853,1,'Ustrem'),(4853,2,'Устрем'),(4853,3,'Ustrem'),(4854,1,'Ustren'),(4854,2,'Устрен'),(4854,3,'Ustren'),(4855,1,'Uhlovitsa'),(4855,2,'Ухловица'),(4855,3,'Uhlovitsa'),(4856,1,'Ushevtsi'),(4856,2,'Ушeвци'),(4856,3,'Ushevtsi'),(4857,1,'Ushi'),(4857,2,'Уши'),(4857,3,'Ushi'),(4858,1,'Ushintsi'),(4858,2,'Ушинци'),(4858,3,'Ushintsi'),(4859,1,'Fabrika'),(4859,2,'Фабрика'),(4859,3,'Fabrika'),(4860,1,'Fazanovo'),(4860,2,'Фазаново'),(4860,3,'Fazanovo'),(4861,1,'Fakia'),(4861,2,'Факия'),(4861,3,'Fakia'),(4862,1,'Fatovo'),(4862,2,'Фатово'),(4862,3,'Fatovo'),(4863,1,'Feldfebel Denkovo'),(4863,2,'Фелдфебел Денково'),(4863,3,'Feldfebel Denkovo'),(4864,1,'Filaretovo'),(4864,2,'Филаретово'),(4864,3,'Filaretovo'),(4865,1,'Filipovo'),(4865,2,'Филипово'),(4865,3,'Filipovo'),(4866,1,'Filipovo'),(4866,2,'Филипово'),(4866,3,'Filipovo'),(4867,1,'Filipovtsi'),(4867,2,'Филиповци'),(4867,3,'Filipovtsi'),(4868,1,'Florentin'),(4868,2,'Флорентин'),(4868,3,'Florentin'),(4869,1,'Fotinovo'),(4869,2,'Фотиново'),(4869,3,'Fotinovo'),(4870,1,'Fotinovo'),(4870,2,'Фотиново'),(4870,3,'Fotinovo'),(4871,1,'Frolosh'),(4871,2,'Фролош'),(4871,3,'Frolosh'),(4872,1,'Furen'),(4872,2,'Фурен'),(4872,3,'Furen'),(4873,1,'Fargovo'),(4873,2,'Фъргово'),(4873,3,'Fargovo'),(4874,1,'Fargovtsi'),(4874,2,'Фърговци'),(4874,3,'Fargovtsi'),(4875,1,'Farevtsi'),(4875,2,'Фъревци'),(4875,3,'Farevtsi'),(4876,1,'Fartuni'),(4876,2,'Фъртуни'),(4876,3,'Fartuni'),(4877,1,'Hadzhi Dimitar'),(4877,2,'Хаджи Димитър'),(4877,3,'Hadzhi Dimitar'),(4878,1,'Hadzhidimitrovo'),(4878,2,'Хаджидимитрово'),(4878,3,'Hadzhidimitrovo'),(4879,1,'Hadzhidimitrovo'),(4879,2,'Хаджидимитрово'),(4879,3,'Hadzhidimitrovo'),(4880,1,'Hadzhidimitrovo'),(4880,2,'Хаджидимитрово'),(4880,3,'Hadzhidimitrovo'),(4881,1,'Hadzhidimovo'),(4881,2,'Хаджидимово'),(4881,3,'Hadzhidimovo'),(4882,1,'Hadzhievo'),(4882,2,'Хаджиево'),(4882,3,'Hadzhievo'),(4883,1,'Hadzhiite'),(4883,2,'Хаджиите'),(4883,3,'Hadzhiite'),(4884,1,'Hadzhiysko'),(4884,2,'Хаджийско'),(4884,3,'Hadzhiysko'),(4885,1,'Hayredin'),(4885,2,'Хайредин'),(4885,3,'Hayredin'),(4886,1,'Halvadzhiysko'),(4886,2,'Халваджийско'),(4886,3,'Halvadzhiysko'),(4887,1,'Halovski kolibi'),(4887,2,'Халовски колиби'),(4887,3,'Halovski kolibi'),(4888,1,'Han Asparuhovo'),(4888,2,'Хан Аспарухово'),(4888,3,'Han Asparuhovo'),(4889,1,'Han Krum'),(4889,2,'Хан Крум'),(4889,3,'Han Krum'),(4890,1,'Hanovo'),(4890,2,'Ханово'),(4890,3,'Hanovo'),(4891,1,'Haracherite'),(4891,2,'Харачерите'),(4891,3,'Haracherite'),(4892,1,'Harvalovtsi'),(4892,2,'Харваловци'),(4892,3,'Harvalovtsi'),(4893,1,'Harmanli'),(4893,2,'Харманли'),(4893,3,'Harmanli'),(4894,1,'Haskovo'),(4894,2,'Хасково'),(4894,3,'Haskovo'),(4895,1,'Hasovitsa'),(4895,2,'Хасовица'),(4895,3,'Hasovitsa'),(4896,1,'Hvoyna'),(4896,2,'Хвойна'),(4896,3,'Hvoyna'),(4897,1,'Hvostyane'),(4897,2,'Хвостяне'),(4897,3,'Hvostyane'),(4898,1,'Hvarchil'),(4898,2,'Хвърчил'),(4898,3,'Hvarchil'),(4899,1,'Herakovo'),(4899,2,'Хераково'),(4899,3,'Herakovo'),(4900,1,'Hirevo'),(4900,2,'Хирево'),(4900,3,'Hirevo'),(4901,1,'Hisar'),(4901,2,'Хисар'),(4901,3,'Hisar'),(4902,1,'Hisarya'),(4902,2,'Хисаря'),(4902,3,'Hisarya'),(4903,1,'Hitovo'),(4903,2,'Хитово'),(4903,3,'Hitovo'),(4904,1,'Hitrino'),(4904,2,'Хитрино'),(4904,3,'Hitrino'),(4905,1,'Hlevene'),(4905,2,'Хлевене'),(4905,3,'Hlevene'),(4906,1,'Hlyabovo'),(4906,2,'Хлябово'),(4906,3,'Hlyabovo'),(4907,1,'Hodzhovtsi'),(4907,2,'Ходжовци'),(4907,3,'Hodzhovtsi'),(4908,1,'Hotantsa'),(4908,2,'Хотанца'),(4908,3,'Hotantsa'),(4909,1,'Hotnitsa'),(4909,2,'Хотница'),(4909,3,'Hotnitsa'),(4910,1,'Hotovo'),(4910,2,'Хотово'),(4910,3,'Hotovo'),(4911,1,'Hrabrino'),(4911,2,'Храбрино'),(4911,3,'Hrabrino'),(4912,1,'Hrabrovo'),(4912,2,'Храброво'),(4912,3,'Hrabrovo'),(4913,1,'Hrabrovo'),(4913,2,'Храброво'),(4913,3,'Hrabrovo'),(4914,1,'Hrabarsko'),(4914,2,'Храбърско'),(4914,3,'Hrabarsko'),(4915,1,'Hrasna'),(4915,2,'Храсна'),(4915,3,'Hrasna'),(4916,1,'Hrastovo'),(4916,2,'Храстово'),(4916,3,'Hrastovo'),(4917,1,'Hristianovo'),(4917,2,'Християново'),(4917,3,'Hristianovo'),(4918,1,'Hristo Danovo'),(4918,2,'Христо Даново'),(4918,3,'Hristo Danovo'),(4919,1,'Hristovtsi'),(4919,2,'Христовци'),(4919,3,'Hristovtsi'),(4920,1,'Hristovtsi'),(4920,2,'Христовци'),(4920,3,'Hristovtsi'),(4921,1,'Hrishteni'),(4921,2,'Хрищени'),(4921,3,'Hrishteni'),(4922,1,'Hromitsa'),(4922,2,'Хромица'),(4922,3,'Hromitsa'),(4923,1,'Hubavene'),(4923,2,'Хубавене'),(4923,3,'Hubavene'),(4924,1,'Huma'),(4924,2,'Хума'),(4924,3,'Huma'),(4925,1,'Huhla'),(4925,2,'Хухла'),(4925,3,'Huhla'),(4926,1,'Hanevtsi'),(4926,2,'Хъневци'),(4926,3,'Hanevtsi'),(4927,1,'Harlets'),(4927,2,'Хърлец'),(4927,3,'Harlets'),(4928,1,'Harsovo'),(4928,2,'Хърсово'),(4928,3,'Harsovo'),(4929,1,'Harsovo'),(4929,2,'Хърсово'),(4929,3,'Harsovo'),(4930,1,'Harsovo'),(4930,2,'Хърсово'),(4930,3,'Harsovo'),(4931,1,'Tsakonitsa'),(4931,2,'Цаконица'),(4931,3,'Tsakonitsa'),(4932,1,'Tsalapitsa'),(4932,2,'Цалапица'),(4932,3,'Tsalapitsa'),(4933,1,'Tsani Ginchevo'),(4933,2,'Цани Гинчево'),(4933,3,'Tsani Ginchevo'),(4934,1,'Tsaparevo'),(4934,2,'Цапарево'),(4934,3,'Tsaparevo'),(4935,1,'Tsar Asen'),(4935,2,'Цар Асен'),(4935,3,'Tsar Asen'),(4936,1,'Tsar Asen'),(4936,2,'Цар Асен'),(4936,3,'Tsar Asen'),(4937,1,'Tsar Asen'),(4937,2,'Цар Асен'),(4937,3,'Tsar Asen'),(4938,1,'Tsar Kaloyan'),(4938,2,'Цар Калоян'),(4938,3,'Tsar Kaloyan'),(4939,1,'Tsar Kaloyan'),(4939,2,'Цар Калоян'),(4939,3,'Tsar Kaloyan'),(4940,1,'Tsar Samuil'),(4940,2,'Цар Самуил'),(4940,3,'Tsar Samuil'),(4941,1,'Tsar Simeonovo'),(4941,2,'Цар Симеоново'),(4941,3,'Tsar Simeonovo'),(4942,1,'Tsar Shishmanovo'),(4942,2,'Цар Шишманово'),(4942,3,'Tsar Shishmanovo'),(4943,1,'Tsaratsovo'),(4943,2,'Царацово'),(4943,3,'Tsaratsovo'),(4944,1,'Tsarev brod'),(4944,2,'Царев брод'),(4944,3,'Tsarev brod'),(4945,1,'Tsarev dol'),(4945,2,'Царев дол'),(4945,3,'Tsarev dol'),(4946,1,'Tsareva livada'),(4946,2,'Царева ливада'),(4946,3,'Tsareva livada'),(4947,1,'Tsareva polyana'),(4947,2,'Царева поляна'),(4947,3,'Tsareva polyana'),(4948,1,'Tsarevets'),(4948,2,'Царевец'),(4948,3,'Tsarevets'),(4949,1,'Tsarevets'),(4949,2,'Царевец'),(4949,3,'Tsarevets'),(4950,1,'Tsarevets'),(4950,2,'Царевец'),(4950,3,'Tsarevets'),(4951,1,'Tsarevets'),(4951,2,'Царевец'),(4951,3,'Tsarevets'),(4952,1,'Tsarevo'),(4952,2,'Царево'),(4952,3,'Tsarevo'),(4953,1,'Tsarevtsi'),(4953,2,'Царевци'),(4953,3,'Tsarevtsi'),(4954,1,'Tsarevtsi'),(4954,2,'Царевци'),(4954,3,'Tsarevtsi'),(4955,1,'Tsarimir'),(4955,2,'Царимир'),(4955,3,'Tsarimir'),(4956,1,'Tsarino'),(4956,2,'Царино'),(4956,3,'Tsarino'),(4957,1,'Tsarichina'),(4957,2,'Царичина'),(4957,3,'Tsarichina'),(4958,1,'Tsarichino'),(4958,2,'Царичино'),(4958,3,'Tsarichino'),(4959,1,'Tsar-Petrovo'),(4959,2,'Цар-Петрово'),(4959,3,'Tsar-Petrovo'),(4960,1,'Tsarski izvor'),(4960,2,'Царски извор'),(4960,3,'Tsarski izvor'),(4961,1,'Tsatsarovtsi'),(4961,2,'Цацаровци'),(4961,3,'Tsatsarovtsi'),(4962,1,'Tsatsarovtsi'),(4962,2,'Цацаровци'),(4962,3,'Tsatsarovtsi'),(4963,1,'Tsveklyuvtsi'),(4963,2,'Цвеклювци'),(4963,3,'Tsveklyuvtsi'),(4964,1,'Tsvetino'),(4964,2,'Цветино'),(4964,3,'Tsvetino'),(4965,1,'Tsvetkova bara'),(4965,2,'Цветкова бара'),(4965,3,'Tsvetkova bara'),(4966,1,'Tsvetnitsa'),(4966,2,'Цветница'),(4966,3,'Tsvetnitsa'),(4967,1,'Tsvyatkovtsi'),(4967,2,'Цвятковци'),(4967,3,'Tsvyatkovtsi'),(4968,1,'Tsvyatovo'),(4968,2,'Цвятово'),(4968,3,'Tsvyatovo'),(4969,1,'Tsegrilovtsi'),(4969,2,'Цегриловци'),(4969,3,'Tsegrilovtsi'),(4970,1,'Tselina'),(4970,2,'Целина'),(4970,3,'Tselina'),(4971,1,'Tsenino'),(4971,2,'Ценино'),(4971,3,'Tsenino'),(4972,1,'Tsenovich'),(4972,2,'Ценович'),(4972,3,'Tsenovich'),(4973,1,'Tsenovo'),(4973,2,'Ценово'),(4973,3,'Tsenovo'),(4974,1,'Tsenovo'),(4974,2,'Ценово'),(4974,3,'Tsenovo'),(4975,1,'Tseperanite'),(4975,2,'Цепераните'),(4975,3,'Tseperanite'),(4976,1,'Tseretelevo'),(4976,2,'Церетелево'),(4976,3,'Tseretelevo'),(4977,1,'Tseretsel'),(4977,2,'Церецел'),(4977,3,'Tseretsel'),(4978,1,'Tserkovski'),(4978,2,'Церковски'),(4978,3,'Tserkovski'),(4979,1,'Tserova koria'),(4979,2,'Церова кория'),(4979,3,'Tserova koria'),(4980,1,'Tserovets'),(4980,2,'Церовец'),(4980,3,'Tserovets'),(4981,1,'Tserovitsa'),(4981,2,'Церовица'),(4981,3,'Tserovitsa'),(4982,1,'Tserovishte'),(4982,2,'Церовище'),(4982,3,'Tserovishte'),(4983,1,'Tserovo'),(4983,2,'Церово'),(4983,3,'Tserovo'),(4984,1,'Tserovo'),(4984,2,'Церово'),(4984,3,'Tserovo'),(4985,1,'Tserovo'),(4985,2,'Церово'),(4985,3,'Tserovo'),(4986,1,'Tsiklovo'),(4986,2,'Циклово'),(4986,3,'Tsiklovo'),(4987,1,'Tsirka'),(4987,2,'Цирка'),(4987,3,'Tsirka'),(4988,1,'Tsonevo'),(4988,2,'Цонево'),(4988,3,'Tsonevo'),(4989,1,'Tsonkovtsi'),(4989,2,'Цонковци'),(4989,3,'Tsonkovtsi'),(4990,1,'Tsreshnovo'),(4990,2,'Црешново'),(4990,3,'Tsreshnovo'),(4991,1,'Tsraklevtsi'),(4991,2,'Цръклевци'),(4991,3,'Tsraklevtsi'),(4992,1,'Tsrancha'),(4992,2,'Црънча'),(4992,3,'Tsrancha'),(4993,1,'Tsrancha'),(4993,2,'Црънча'),(4993,3,'Tsrancha'),(4994,1,'Tsarvaritsa'),(4994,2,'Църварица'),(4994,3,'Tsarvaritsa'),(4995,1,'Tsarvena yabalka'),(4995,2,'Цървена ябълка'),(4995,3,'Tsarvena yabalka'),(4996,1,'Tsarvendol'),(4996,2,'Цървендол'),(4996,3,'Tsarvendol'),(4997,1,'Tsarvenyano'),(4997,2,'Цървеняно'),(4997,3,'Tsarvenyano'),(4998,1,'Tsarvishte'),(4998,2,'Цървище'),(4998,3,'Tsarvishte'),(4999,1,'Tsarkva'),(4999,2,'Църква'),(4999,3,'Tsarkva'),(5000,1,'Tsarkvitsa'),(5000,2,'Църквица'),(5000,3,'Tsarkvitsa'),(5001,1,'Tsarkvitsa'),(5001,2,'Църквица'),(5001,3,'Tsarkvitsa'),(5002,1,'Tsarkvishte'),(5002,2,'Църквище'),(5002,3,'Tsarkvishte'),(5003,1,'Chavdar'),(5003,2,'Чавдар'),(5003,3,'Chavdar'),(5004,1,'Chavdar'),(5004,2,'Чавдар'),(5004,3,'Chavdar'),(5005,1,'Chavdartsi'),(5005,2,'Чавдарци'),(5005,3,'Chavdartsi'),(5006,1,'Chavdartsi'),(5006,2,'Чавдарци'),(5006,3,'Chavdartsi'),(5007,1,'Chavei'),(5007,2,'Чавеи'),(5007,3,'Chavei'),(5008,1,'Chavka'),(5008,2,'Чавка'),(5008,3,'Chavka'),(5009,1,'Chayka'),(5009,2,'Чайка'),(5009,3,'Chayka'),(5010,1,'Chayka'),(5010,2,'Чайка'),(5010,3,'Chayka'),(5011,1,'Chakalarovo'),(5011,2,'Чакаларово'),(5011,3,'Chakalarovo'),(5012,1,'Chakali'),(5012,2,'Чакали'),(5012,3,'Chakali'),(5013,1,'Chakalite'),(5013,2,'Чакалите'),(5013,3,'Chakalite'),(5014,1,'Chakaltsi'),(5014,2,'Чакалци'),(5014,3,'Chakaltsi'),(5015,1,'Chal'),(5015,2,'Чал'),(5015,3,'Chal'),(5016,1,'Chala'),(5016,2,'Чала'),(5016,3,'Chala'),(5017,1,'Chalakovi'),(5017,2,'Чалъкови'),(5017,3,'Chalakovi'),(5018,1,'Chamla'),(5018,2,'Чамла'),(5018,3,'Chamla'),(5019,1,'Chargan'),(5019,2,'Чарган'),(5019,3,'Chargan'),(5020,1,'Charda'),(5020,2,'Чарда'),(5020,3,'Charda'),(5021,1,'Charkovo'),(5021,2,'Чарково'),(5021,3,'Charkovo'),(5022,1,'Chegantsi'),(5022,2,'Чеганци'),(5022,3,'Chegantsi'),(5023,1,'Chekanets'),(5023,2,'Чеканец'),(5023,3,'Chekanets'),(5024,1,'Chekanets'),(5024,2,'Чеканец'),(5024,3,'Chekanets'),(5025,1,'Chekantsi'),(5025,2,'Чеканци'),(5025,3,'Chekantsi'),(5026,1,'Chekanchevo'),(5026,2,'Чеканчево'),(5026,3,'Chekanchevo'),(5027,1,'Chelnik'),(5027,2,'Челник'),(5027,3,'Chelnik'),(5028,1,'Chelopek'),(5028,2,'Челопек'),(5028,3,'Chelopek'),(5029,1,'Chelopech'),(5029,2,'Челопеч'),(5029,3,'Chelopech'),(5030,1,'Chelopechene'),(5030,2,'Челопечене'),(5030,3,'Chelopechene'),(5031,1,'Chelyustnitsa'),(5031,2,'Челюстница'),(5031,3,'Chelyustnitsa'),(5032,1,'Chemish'),(5032,2,'Чемиш'),(5032,3,'Chemish'),(5033,1,'Chepelare'),(5033,2,'Чепеларе'),(5033,3,'Chepelare'),(5034,1,'Chepino'),(5034,2,'Чепино'),(5034,3,'Chepino'),(5035,1,'Chepintsi'),(5035,2,'Чепинци'),(5035,3,'Chepintsi'),(5036,1,'Chepintsi'),(5036,2,'Чепинци'),(5036,3,'Chepintsi'),(5037,1,'Chepleten'),(5037,2,'Чеплетен'),(5037,3,'Chepleten'),(5038,1,'Cheparlintsi'),(5038,2,'Чепърлинци'),(5038,3,'Cheparlintsi'),(5039,1,'Cherven'),(5039,2,'Червен'),(5039,3,'Cherven'),(5040,1,'Cherven'),(5040,2,'Червен'),(5040,3,'Cherven'),(5041,1,'Cherven breg'),(5041,2,'Червен брег'),(5041,3,'Cherven breg'),(5042,1,'Cherven bryag'),(5042,2,'Червен бряг'),(5042,3,'Cherven bryag'),(5043,1,'Chervena'),(5043,2,'Червена'),(5043,3,'Chervena'),(5044,1,'Chervena voda'),(5044,2,'Червена вода'),(5044,3,'Chervena voda'),(5045,1,'Chervena lokva'),(5045,2,'Червена локва'),(5045,3,'Chervena lokva'),(5046,1,'Chervena mogila'),(5046,2,'Червена могила'),(5046,3,'Chervena mogila'),(5047,1,'Chervena skala'),(5047,2,'Червена скала'),(5047,3,'Chervena skala'),(5048,1,'Chervenakovo'),(5048,2,'Червенаково'),(5048,3,'Chervenakovo'),(5049,1,'Chervenkovtsi'),(5049,2,'Червенковци'),(5049,3,'Chervenkovtsi'),(5050,1,'Cherventsi'),(5050,2,'Червенци'),(5050,3,'Cherventsi'),(5051,1,'Cherganovo'),(5051,2,'Черганово'),(5051,3,'Cherganovo'),(5052,1,'Cherencha'),(5052,2,'Черенча'),(5052,3,'Cherencha'),(5053,1,'Cherepovo'),(5053,2,'Черепово'),(5053,3,'Cherepovo'),(5054,1,'Cheresha'),(5054,2,'Череша'),(5054,3,'Cheresha'),(5055,1,'Chereshitsa'),(5055,2,'Черешица'),(5055,3,'Chereshitsa'),(5056,1,'Chereshka'),(5056,2,'Черешка'),(5056,3,'Chereshka'),(5057,1,'Chereshkite'),(5057,2,'Черешките'),(5057,3,'Chereshkite'),(5058,1,'Chereshnitsa'),(5058,2,'Черешница'),(5058,3,'Chereshnitsa'),(5059,1,'Chereshovitsa'),(5059,2,'Черешовица'),(5059,3,'Chereshovitsa'),(5060,1,'Chereshovo'),(5060,2,'Черешово'),(5060,3,'Chereshovo'),(5061,1,'Chereshovo'),(5061,2,'Черешово'),(5061,3,'Chereshovo'),(5062,1,'Chereshovo'),(5062,2,'Черешово'),(5062,3,'Chereshovo'),(5063,1,'Chereshovska reka'),(5063,2,'Черешовска река'),(5063,3,'Chereshovska reka'),(5064,1,'Cherkaski'),(5064,2,'Черкаски'),(5064,3,'Cherkaski'),(5065,1,'Cherkovitsa'),(5065,2,'Черковица'),(5065,3,'Cherkovitsa'),(5066,1,'Cherkovishte'),(5066,2,'Черковище'),(5066,3,'Cherkovishte'),(5067,1,'Cherkovna'),(5067,2,'Черковна'),(5067,3,'Cherkovna'),(5068,1,'Cherkovna'),(5068,2,'Черковна'),(5068,3,'Cherkovna'),(5069,1,'Cherkovna'),(5069,2,'Черковна'),(5069,3,'Cherkovna'),(5070,1,'Cherkovna'),(5070,2,'Черковна'),(5070,3,'Cherkovna'),(5071,1,'Cherkovo'),(5071,2,'Черково'),(5071,3,'Cherkovo'),(5072,1,'Cherna'),(5072,2,'Черна'),(5072,3,'Cherna'),(5073,1,'Cherna'),(5073,2,'Черна'),(5073,3,'Cherna'),(5074,1,'Cherna voda'),(5074,2,'Черна вода'),(5074,3,'Cherna voda'),(5075,1,'Cherna gora'),(5075,2,'Черна гора'),(5075,3,'Cherna gora'),(5076,1,'Cherna gora'),(5076,2,'Черна гора'),(5076,3,'Cherna gora'),(5077,1,'Cherna Mesta'),(5077,2,'Черна Места'),(5077,3,'Cherna Mesta'),(5078,1,'Cherna mogila'),(5078,2,'Черна могила'),(5078,3,'Cherna mogila'),(5079,1,'Cherna mogila'),(5079,2,'Черна могила'),(5079,3,'Cherna mogila'),(5080,1,'Cherna niva'),(5080,2,'Черна нива'),(5080,3,'Cherna niva'),(5081,1,'Cherna skala'),(5081,2,'Черна скала'),(5081,3,'Cherna skala'),(5082,1,'Chernevo'),(5082,2,'Чернево'),(5082,3,'Chernevo'),(5083,1,'Chernevtsi'),(5083,2,'Черневци'),(5083,3,'Chernevtsi'),(5084,1,'Cherni bryag'),(5084,2,'Черни бряг'),(5084,3,'Cherni bryag'),(5085,1,'Cherni Vit'),(5085,2,'Черни Вит'),(5085,3,'Cherni Vit'),(5086,1,'Cherni vrah'),(5086,2,'Черни връх'),(5086,3,'Cherni vrah'),(5087,1,'Cherni vrah'),(5087,2,'Черни връх'),(5087,3,'Cherni vrah'),(5088,1,'Cherni vrah'),(5088,2,'Черни връх'),(5088,3,'Cherni vrah'),(5089,1,'Cherni dyal'),(5089,2,'Черни дял'),(5089,3,'Cherni dyal'),(5090,1,'Cherni Osam'),(5090,2,'Черни Осъм'),(5090,3,'Cherni Osam'),(5091,1,'Cherni rid'),(5091,2,'Черни рид'),(5091,3,'Cherni rid'),(5092,1,'Chernigovo'),(5092,2,'Чернигово'),(5092,3,'Chernigovo'),(5093,1,'Chernik'),(5093,2,'Черник'),(5093,3,'Chernik'),(5094,1,'Chernitsa'),(5094,2,'Черница'),(5094,3,'Chernitsa'),(5095,1,'Cherniche'),(5095,2,'Черниче'),(5095,3,'Cherniche'),(5096,1,'Chernichevo'),(5096,2,'Черничево'),(5096,3,'Chernichevo'),(5097,1,'Chernichevo'),(5097,2,'Черничево'),(5097,3,'Chernichevo'),(5098,1,'Chernichino'),(5098,2,'Черничино'),(5098,3,'Chernichino'),(5099,1,'Cherno more'),(5099,2,'Черно море'),(5099,3,'Cherno more'),(5100,1,'Cherno pole'),(5100,2,'Черно поле'),(5100,3,'Cherno pole'),(5101,1,'Chernovrah'),(5101,2,'Черновръх'),(5101,3,'Chernovrah'),(5102,1,'Chernoglavtsi'),(5102,2,'Черноглавци'),(5102,3,'Chernoglavtsi'),(5103,1,'Chernogor'),(5103,2,'Черногор'),(5103,3,'Chernogor'),(5104,1,'Chernogorovo'),(5104,2,'Черногорово'),(5104,3,'Chernogorovo'),(5105,1,'Chernogorovo'),(5105,2,'Черногорово'),(5105,3,'Chernogorovo'),(5106,1,'Chernograd'),(5106,2,'Черноград'),(5106,3,'Chernograd'),(5107,1,'Chernodab'),(5107,2,'Чернодъб'),(5107,3,'Chernodab'),(5108,1,'Chernozem'),(5108,2,'Чернозем'),(5108,3,'Chernozem'),(5109,1,'Chernozemen'),(5109,2,'Черноземен'),(5109,3,'Chernozemen'),(5110,1,'Chernokaptsi'),(5110,2,'Чернокапци'),(5110,3,'Chernokaptsi'),(5111,1,'Chernolik'),(5111,2,'Чернолик'),(5111,3,'Chernolik'),(5112,1,'Chernomorets'),(5112,2,'Черноморец'),(5112,3,'Chernomorets'),(5113,1,'Chernomortsi'),(5113,2,'Черноморци'),(5113,3,'Chernomortsi'),(5114,1,'Chernook'),(5114,2,'Черноок'),(5114,3,'Chernook'),(5115,1,'Chernooki'),(5115,2,'Чернооки'),(5115,3,'Chernooki'),(5116,1,'Chernookovo'),(5116,2,'Чернооково'),(5116,3,'Chernookovo'),(5117,1,'Chernookovo'),(5117,2,'Чернооково'),(5117,3,'Chernookovo'),(5118,1,'Chernoochene'),(5118,2,'Черноочене'),(5118,3,'Chernoochene'),(5119,1,'Chernyovo'),(5119,2,'Черньово'),(5119,3,'Chernyovo'),(5120,1,'Chernyovtsi'),(5120,2,'Черньовци'),(5120,3,'Chernyovtsi'),(5121,1,'Chestimensko'),(5121,2,'Честименско'),(5121,3,'Chestimensko'),(5122,1,'Chetirtsi'),(5122,2,'Четирци'),(5122,3,'Chetirtsi'),(5123,1,'Chetroka'),(5123,2,'Четрока'),(5123,3,'Chetroka'),(5124,1,'Chehlare'),(5124,2,'Чехларе'),(5124,3,'Chehlare'),(5125,1,'Cheshlyantsi'),(5125,2,'Чешлянци'),(5125,3,'Cheshlyantsi'),(5126,1,'Cheshma'),(5126,2,'Чешма'),(5126,3,'Cheshma'),(5127,1,'Cheshnegirovo'),(5127,2,'Чешнегирово'),(5127,3,'Cheshnegirovo'),(5128,1,'Chibaovtsi'),(5128,2,'Чибаовци'),(5128,3,'Chibaovtsi'),(5129,1,'Chilik'),(5129,2,'Чилик'),(5129,3,'Chilik'),(5130,1,'Chilnov'),(5130,2,'Чилнов'),(5130,3,'Chilnov'),(5131,1,'Chintulovo'),(5131,2,'Чинтулово'),(5131,3,'Chintulovo'),(5132,1,'Chiprovtsi'),(5132,2,'Чипровци'),(5132,3,'Chiprovtsi'),(5133,1,'Chiren'),(5133,2,'Чирен'),(5133,3,'Chiren'),(5134,1,'Chirpan'),(5134,2,'Чирпан'),(5134,3,'Chirpan'),(5135,1,'Chistovo'),(5135,2,'Чистово'),(5135,3,'Chistovo'),(5136,1,'Chitakovtsi'),(5136,2,'Читаковци'),(5136,3,'Chitakovtsi'),(5137,1,'Chiflik'),(5137,2,'Чифлик'),(5137,3,'Chiflik'),(5138,1,'Chiflik'),(5138,2,'Чифлик'),(5138,3,'Chiflik'),(5139,1,'Chiflik'),(5139,2,'Чифлик'),(5139,3,'Chiflik'),(5140,1,'Chichevo'),(5140,2,'Чичево'),(5140,3,'Chichevo'),(5141,1,'Chichil'),(5141,2,'Чичил'),(5141,3,'Chichil'),(5142,1,'Choba'),(5142,2,'Чоба'),(5142,3,'Choba'),(5143,1,'Chobanka'),(5143,2,'Чобанка'),(5143,3,'Chobanka'),(5144,1,'Chokmanovo'),(5144,2,'Чокманово'),(5144,3,'Chokmanovo'),(5145,1,'Chokoba'),(5145,2,'Чокоба'),(5145,3,'Chokoba'),(5146,1,'Cholakova'),(5146,2,'Чолакова'),(5146,3,'Cholakova'),(5147,1,'Chomakovo'),(5147,2,'Чомаково'),(5147,3,'Chomakovo'),(5148,1,'Chomakovtsi'),(5148,2,'Чомаковци'),(5148,3,'Chomakovtsi'),(5149,1,'Chorbadzhiysko'),(5149,2,'Чорбаджийско'),(5149,3,'Chorbadzhiysko'),(5150,1,'Chorul'),(5150,2,'Чорул'),(5150,3,'Chorul'),(5151,1,'Chubra'),(5151,2,'Чубра'),(5151,3,'Chubra'),(5152,1,'Chubrika'),(5152,2,'Чубрика'),(5152,3,'Chubrika'),(5153,1,'Chudintsi'),(5153,2,'Чудинци'),(5153,3,'Chudintsi'),(5154,1,'Chudomir'),(5154,2,'Чудомир'),(5154,3,'Chudomir'),(5155,1,'Chuypetlovo'),(5155,2,'Чуйпетлово'),(5155,3,'Chuypetlovo'),(5156,1,'Chukarka'),(5156,2,'Чукарка'),(5156,3,'Chukarka'),(5157,1,'Chukarovo'),(5157,2,'Чукарово'),(5157,3,'Chukarovo'),(5158,1,'Chukata'),(5158,2,'Чуката'),(5158,3,'Chukata'),(5159,1,'Chukata'),(5159,2,'Чуката'),(5159,3,'Chukata'),(5160,1,'Chukilite'),(5160,2,'Чукилите'),(5160,3,'Chukilite'),(5161,1,'Chukovezer'),(5161,2,'Чуковезер'),(5161,3,'Chukovezer'),(5162,1,'Chukovets'),(5162,2,'Чуковец'),(5162,3,'Chukovets'),(5163,1,'Chukovets'),(5163,2,'Чуковец'),(5163,3,'Chukovets'),(5164,1,'Chukovo'),(5164,2,'Чуково'),(5164,3,'Chukovo'),(5165,1,'Chukovo'),(5165,2,'Чуково'),(5165,3,'Chukovo'),(5166,1,'Chuprene'),(5166,2,'Чупрене'),(5166,3,'Chuprene'),(5167,1,'Churek'),(5167,2,'Чурек'),(5167,3,'Churek'),(5168,1,'Churen'),(5168,2,'Чурен'),(5168,3,'Churen'),(5169,1,'Churilovo'),(5169,2,'Чурилово'),(5169,3,'Churilovo'),(5170,1,'Churicheni'),(5170,2,'Чуричени'),(5170,3,'Churicheni'),(5171,1,'Churka'),(5171,2,'Чурка'),(5171,3,'Churka'),(5172,1,'Churukovo'),(5172,2,'Чуруково'),(5172,3,'Churukovo'),(5173,1,'Chuchuliga'),(5173,2,'Чучулига'),(5173,3,'Chuchuliga'),(5174,1,'Chuchuligovo'),(5174,2,'Чучулигово'),(5174,3,'Chuchuligovo'),(5175,1,'Chuchur'),(5175,2,'Чучур'),(5175,3,'Chuchur'),(5176,1,'Shabla'),(5176,2,'Шабла'),(5176,3,'Shabla'),(5177,1,'Shanovo'),(5177,2,'Шаново'),(5177,3,'Shanovo'),(5178,1,'Sharani'),(5178,2,'Шарани'),(5178,3,'Sharani'),(5179,1,'Sharenska'),(5179,2,'Шаренска'),(5179,3,'Sharenska'),(5180,1,'Sharkovo'),(5180,2,'Шарково'),(5180,3,'Sharkovo'),(5181,1,'Shatrovo'),(5181,2,'Шатрово'),(5181,3,'Shatrovo'),(5182,1,'Sheynovo'),(5182,2,'Шейново'),(5182,3,'Sheynovo'),(5183,1,'Shemshevo'),(5183,2,'Шемшево'),(5183,3,'Shemshevo'),(5184,1,'Sheremetya'),(5184,2,'Шереметя'),(5184,3,'Sheremetya'),(5185,1,'Shivarovo'),(5185,2,'Шиварово'),(5185,3,'Shivarovo'),(5186,1,'Shivachevo'),(5186,2,'Шивачево'),(5186,3,'Shivachevo'),(5187,1,'Shiliveri'),(5187,2,'Шиливери'),(5187,3,'Shiliveri'),(5188,1,'Shilkovtsi'),(5188,2,'Шилковци'),(5188,3,'Shilkovtsi'),(5189,1,'Shipikova mahala'),(5189,2,'Шипикова махала'),(5189,3,'Shipikova mahala'),(5190,1,'Shipka'),(5190,2,'Шипка'),(5190,3,'Shipka'),(5191,1,'Shipkovitsa'),(5191,2,'Шипковица'),(5191,3,'Shipkovitsa'),(5192,1,'Shipkovo'),(5192,2,'Шипково'),(5192,3,'Shipkovo'),(5193,1,'Shipok'),(5193,2,'Шипок'),(5193,3,'Shipok'),(5194,1,'Shipot'),(5194,2,'Шипот'),(5194,3,'Shipot'),(5195,1,'Shipochane'),(5195,2,'Шипочане'),(5195,3,'Shipochane'),(5196,1,'Shipochano'),(5196,2,'Шипочано'),(5196,3,'Shipochano'),(5197,1,'Shipchenite'),(5197,2,'Шипчените'),(5197,3,'Shipchenite'),(5198,1,'Shiroka laka'),(5198,2,'Широка лъка'),(5198,3,'Shiroka laka'),(5199,1,'Shiroka polyana'),(5199,2,'Широка поляна'),(5199,3,'Shiroka polyana'),(5200,1,'Shiroki dol'),(5200,2,'Широки дол'),(5200,3,'Shiroki dol'),(5201,1,'Shiroko pole'),(5201,2,'Широко поле'),(5201,3,'Shiroko pole'),(5202,1,'Shirokovo'),(5202,2,'Широково'),(5202,3,'Shirokovo'),(5203,1,'Shishentsi'),(5203,2,'Шишенци'),(5203,3,'Shishentsi'),(5204,1,'Shishkovitsa'),(5204,2,'Шишковица'),(5204,3,'Shishkovitsa'),(5205,1,'Shishkovtsi'),(5205,2,'Шишковци'),(5205,3,'Shishkovtsi'),(5206,1,'Shishmanovo'),(5206,2,'Шишманово'),(5206,3,'Shishmanovo'),(5207,1,'Shishmantsi'),(5207,2,'Шишманци'),(5207,3,'Shishmantsi'),(5208,1,'Shiakovo'),(5208,2,'Шияково'),(5208,3,'Shiakovo'),(5209,1,'Shkorpilovtsi'),(5209,2,'Шкорпиловци'),(5209,3,'Shkorpilovtsi'),(5210,1,'Shodekovtsi'),(5210,2,'Шодековци'),(5210,3,'Shodekovtsi'),(5211,1,'Shopite'),(5211,2,'Шопите'),(5211,3,'Shopite'),(5212,1,'Shoptsi'),(5212,2,'Шопци'),(5212,3,'Shoptsi'),(5213,1,'Shubetsi'),(5213,2,'Шубеци'),(5213,3,'Shubetsi'),(5214,1,'Shuma'),(5214,2,'Шума'),(5214,3,'Shuma'),(5215,1,'Shumata'),(5215,2,'Шумата'),(5215,3,'Shumata'),(5216,1,'Shumen'),(5216,2,'Шумен'),(5216,3,'Shumen'),(5217,1,'Shumentsi'),(5217,2,'Шуменци'),(5217,3,'Shumentsi'),(5218,1,'Shumnatitsa'),(5218,2,'Шумнатица'),(5218,3,'Shumnatitsa'),(5219,1,'Shushnya'),(5219,2,'Шушня'),(5219,3,'Shushnya'),(5220,1,'Shterna'),(5220,2,'Щерна'),(5220,3,'Shterna'),(5221,1,'Shtipsko'),(5221,2,'Щипско'),(5221,3,'Shtipsko'),(5222,1,'Shtit'),(5222,2,'Щит'),(5222,3,'Shtit'),(5223,1,'Shtraklevo'),(5223,2,'Щръклево'),(5223,3,'Shtraklevo'),(5224,1,'Shtarkovo'),(5224,2,'Щърково'),(5224,3,'Shtarkovo'),(5225,1,'Aglen'),(5225,2,'Ъглен'),(5225,3,'Aglen'),(5226,1,'Yugovo'),(5226,2,'Югово'),(5226,3,'Yugovo'),(5227,1,'Yudelnik'),(5227,2,'Юделник'),(5227,3,'Yudelnik'),(5228,1,'Yulievo'),(5228,2,'Юлиево'),(5228,3,'Yulievo'),(5229,1,'Yunak'),(5229,2,'Юнак'),(5229,3,'Yunak'),(5230,1,'Yunatsi'),(5230,2,'Юнаци'),(5230,3,'Yunatsi'),(5231,1,'Yunatsite'),(5231,2,'Юнаците'),(5231,3,'Yunatsite'),(5232,1,'Yundola'),(5232,2,'Юндола'),(5232,3,'Yundola'),(5233,1,'Yunets'),(5233,2,'Юнец'),(5233,3,'Yunets'),(5234,1,'Yuper'),(5234,2,'Юпер'),(5234,3,'Yuper'),(5235,1,'Yurukovo'),(5235,2,'Юруково'),(5235,3,'Yurukovo'),(5236,1,'Yablanitsa'),(5236,2,'Ябланица'),(5236,3,'Yablanitsa'),(5237,1,'Yablanitsa'),(5237,2,'Ябланица'),(5237,3,'Yablanitsa'),(5238,1,'Yablanovo'),(5238,2,'Ябланово'),(5238,3,'Yablanovo'),(5239,1,'Yabalkovets'),(5239,2,'Ябълковец'),(5239,3,'Yabalkovets'),(5240,1,'Yabalkovo'),(5240,2,'Ябълково'),(5240,3,'Yabalkovo'),(5241,1,'Yabalkovo'),(5241,2,'Ябълково'),(5241,3,'Yabalkovo'),(5242,1,'Yabalkovtsi'),(5242,2,'Ябълковци'),(5242,3,'Yabalkovtsi'),(5243,1,'Yabalchevo'),(5243,2,'Ябълчево'),(5243,3,'Yabalchevo'),(5244,1,'Yabalcheni'),(5244,2,'Ябълчени'),(5244,3,'Yabalcheni'),(5245,1,'Yavor'),(5245,2,'Явор'),(5245,3,'Yavor'),(5246,1,'Yavorets'),(5246,2,'Яворец'),(5246,3,'Yavorets'),(5247,1,'Yavornitsa'),(5247,2,'Яворница'),(5247,3,'Yavornitsa'),(5248,1,'Yavorovets'),(5248,2,'Яворовец'),(5248,3,'Yavorovets'),(5249,1,'Yavorovo'),(5249,2,'Яворово'),(5249,3,'Yavorovo'),(5250,1,'Yavorovo'),(5250,2,'Яворово'),(5250,3,'Yavorovo'),(5251,1,'Yavrovo'),(5251,2,'Яврово'),(5251,3,'Yavrovo'),(5252,1,'Yagnilo'),(5252,2,'Ягнило'),(5252,3,'Yagnilo'),(5253,1,'Yagoda'),(5253,2,'Ягода'),(5253,3,'Yagoda'),(5254,1,'Yagodina'),(5254,2,'Ягодина'),(5254,3,'Yagodina'),(5255,1,'Yagodovo'),(5255,2,'Ягодово'),(5255,3,'Yagodovo'),(5256,1,'Yagodovo'),(5256,2,'Ягодово'),(5256,3,'Yagodovo'),(5257,1,'Yazdach'),(5257,2,'Яздач'),(5257,3,'Yazdach'),(5258,1,'Yazovets'),(5258,2,'Язовец'),(5258,3,'Yazovets'),(5259,1,'Yakim Gruevo'),(5259,2,'Яким Груево'),(5259,3,'Yakim Gruevo'),(5260,1,'Yakimovo'),(5260,2,'Якимово'),(5260,3,'Yakimovo'),(5261,1,'Yakovitsa'),(5261,2,'Яковица'),(5261,3,'Yakovitsa'),(5262,1,'Yakovo'),(5262,2,'Яково'),(5262,3,'Yakovo'),(5263,1,'Yakovtsi'),(5263,2,'Яковци'),(5263,3,'Yakovtsi'),(5264,1,'Yakoruda'),(5264,2,'Якоруда'),(5264,3,'Yakoruda'),(5265,1,'Yalbotina'),(5265,2,'Ялботина'),(5265,3,'Yalbotina'),(5266,1,'Yalovo'),(5266,2,'Ялово'),(5266,3,'Yalovo'),(5267,1,'Yambol'),(5267,2,'Ямбол'),(5267,3,'Yambol'),(5268,1,'Yamino'),(5268,2,'Ямино'),(5268,3,'Yamino'),(5269,1,'Yamna'),(5269,2,'Ямна'),(5269,3,'Yamna'),(5270,1,'Yana'),(5270,2,'Яна'),(5270,3,'Yana'),(5271,1,'Yanino'),(5271,2,'Янино'),(5271,3,'Yanino'),(5272,1,'Yankovo'),(5272,2,'Янково'),(5272,3,'Yankovo'),(5273,1,'Yankovtsi'),(5273,2,'Янковци'),(5273,3,'Yankovtsi'),(5274,1,'Yanovo'),(5274,2,'Яново'),(5274,3,'Yanovo'),(5275,1,'Yantra'),(5275,2,'Янтра'),(5275,3,'Yantra'),(5276,1,'Yantra'),(5276,2,'Янтра'),(5276,3,'Yantra'),(5277,1,'Yanyovets'),(5277,2,'Яньовец'),(5277,3,'Yanyovets'),(5278,1,'Yardzhilovtsi'),(5278,2,'Ярджиловци'),(5278,3,'Yardzhilovtsi'),(5279,1,'Yarebitsa'),(5279,2,'Яребица'),(5279,3,'Yarebitsa'),(5280,1,'Yarebitsa'),(5280,2,'Яребица'),(5280,3,'Yarebitsa'),(5281,1,'Yarebichna'),(5281,2,'Яребична'),(5281,3,'Yarebichna'),(5282,1,'Yarebichno'),(5282,2,'Яребично'),(5282,3,'Yarebichno'),(5283,1,'Yarebkovitsa'),(5283,2,'Яребковица'),(5283,3,'Yarebkovitsa'),(5284,1,'Yarlovitsa'),(5284,2,'Ярловица'),(5284,3,'Yarlovitsa'),(5285,1,'Yarlovo'),(5285,2,'Ярлово'),(5285,3,'Yarlovo'),(5286,1,'Yarlovtsi'),(5286,2,'Ярловци'),(5286,3,'Yarlovtsi'),(5287,1,'Yaroslavtsi'),(5287,2,'Ярославци'),(5287,3,'Yaroslavtsi'),(5288,1,'Yasen'),(5288,2,'Ясен'),(5288,3,'Yasen'),(5289,1,'Yasen'),(5289,2,'Ясен'),(5289,3,'Yasen'),(5290,1,'Yasenite'),(5290,2,'Ясените'),(5290,3,'Yasenite'),(5291,1,'Yasenkovo'),(5291,2,'Ясенково'),(5291,3,'Yasenkovo'),(5292,1,'Yasenovets'),(5292,2,'Ясеновец'),(5292,3,'Yasenovets'),(5293,1,'Yasenovo'),(5293,2,'Ясеново'),(5293,3,'Yasenovo'),(5294,1,'Yasenovo'),(5294,2,'Ясеново'),(5294,3,'Yasenovo'),(5295,1,'Yasna polyana'),(5295,2,'Ясна поляна'),(5295,3,'Yasna polyana'),(5296,1,'Yasno pole'),(5296,2,'Ясно поле'),(5296,3,'Yasno pole'),(5297,1,'Yastreb'),(5297,2,'Ястреб'),(5297,3,'Yastreb'),(5298,1,'Yastrebino'),(5298,2,'Ястребино'),(5298,3,'Yastrebino'),(5299,1,'Yastrebna'),(5299,2,'Ястребна'),(5299,3,'Yastrebna'),(5300,1,'Yastrebovo'),(5300,2,'Ястребово'),(5300,3,'Yastrebovo'),(5301,1,'Yastrebovo'),(5301,2,'Ястребово'),(5301,3,'Yastrebovo'),(5302,1,'Yahinovo'),(5302,2,'Яхиново'),(5302,3,'Yahinovo'),(5303,1,'Albena'),(5303,2,'Албена'),(5303,3,'Albena'),(5304,1,'Aleko'),(5304,2,'Алеко'),(5304,3,'Aleko'),(5305,1,'Asen'),(5305,2,'Асен'),(5305,3,'Asen'),(5306,1,'Beklemeto'),(5306,2,'Беклемето'),(5306,3,'Beklemeto'),(5307,1,'Bodrost'),(5307,2,'Бодрост'),(5307,3,'Bodrost'),(5308,1,'Borovets'),(5308,2,'Боровец'),(5308,3,'Borovets'),(5309,1,'Brezovo'),(5309,2,'Брезово'),(5309,3,'Brezovo'),(5310,1,'Burgaski mineralni bani'),(5310,2,'Бургаски минерални бани'),(5310,3,'Burgaski mineralni bani'),(5311,1,'Byala cherkva'),(5311,2,'Бяла черква'),(5311,3,'Byala cherkva'),(5312,1,'Golyamo osoe'),(5312,2,'Голямо осое'),(5312,3,'Golyamo osoe'),(5313,1,'Gornoto selo'),(5313,2,'Горното село'),(5313,3,'Gornoto selo'),(5314,1,'Gorunyovo'),(5314,2,'Горуньово'),(5314,3,'Gorunyovo'),(5315,1,'Dragostin'),(5315,2,'Драгостин'),(5315,3,'Dragostin'),(5316,1,'Dalga livada'),(5316,2,'Дълга ливада'),(5316,3,'Dalga livada'),(5317,1,'Dyuni'),(5317,2,'Дюни'),(5317,3,'Dyuni'),(5318,1,'Elenite'),(5318,2,'Елените'),(5318,3,'Elenite'),(5319,1,'Zlatni mostove'),(5319,2,'Златни мостове'),(5319,3,'Zlatni mostove'),(5320,1,'Zlatni pyasatsi'),(5320,2,'Златни пясъци'),(5320,3,'Zlatni pyasatsi'),(5321,1,'Zorenishki dol'),(5321,2,'Зоренишки дол'),(5321,3,'Zorenishki dol'),(5322,1,'Kamchia'),(5322,2,'Камчия'),(5322,3,'Kamchia'),(5323,1,'Karandila'),(5323,2,'Карандила'),(5323,3,'Karandila'),(5324,1,'Kostenets'),(5324,2,'Костенец'),(5324,3,'Kostenets'),(5325,1,'Krivina'),(5325,2,'Кривина'),(5325,3,'Krivina'),(5326,1,'Krakozhabene'),(5326,2,'Кръкожабене'),(5326,3,'Krakozhabene'),(5327,1,'Lozeto'),(5327,2,'Лозето'),(5327,3,'Lozeto'),(5328,1,'Lakavitsa'),(5328,2,'Лъкавица'),(5328,3,'Lakavitsa'),(5329,1,'Lyulyatsite'),(5329,2,'Люляците'),(5329,3,'Lyulyatsite'),(5330,1,'Malyovitsa'),(5330,2,'Мальовица'),(5330,3,'Malyovitsa'),(5331,1,'Mezhdunaroden mladezhki tsentar'),(5331,2,'Международен младежки център'),(5331,3,'Mezhdunaroden mladezhki tsentar'),(5332,1,'Mishkarete'),(5332,2,'Мишкарете'),(5332,3,'Mishkarete'),(5333,1,'Ognyanovski mineralni bani'),(5333,2,'Огняновски минерални бани'),(5333,3,'Ognyanovski mineralni bani'),(5334,1,'Oresha'),(5334,2,'Ореша'),(5334,3,'Oresha'),(5335,1,'Pamporovo'),(5335,2,'Пампорово'),(5335,3,'Pamporovo'),(5336,1,'Popina laka'),(5336,2,'Попина лъка'),(5336,3,'Popina laka'),(5337,1,'Popovi livadi'),(5337,2,'Попови ливади'),(5337,3,'Popovi livadi'),(5338,1,'Ravna'),(5338,2,'Равна'),(5338,3,'Ravna'),(5339,1,'Rusalka'),(5339,2,'Русалка'),(5339,3,'Rusalka'),(5340,1,'Sv. konstantin'),(5340,2,'Св. константин'),(5340,3,'Sv. konstantin'),(5341,1,'Sv. sv. konstantin i elena'),(5341,2,'Св. св. константин и елена'),(5341,3,'Sv. sv. konstantin i elena'),(5342,1,'Semkovo'),(5342,2,'Семково'),(5342,3,'Semkovo'),(5343,1,'Slatina'),(5343,2,'Слатина'),(5343,3,'Slatina'),(5344,1,'Slivenski mineralni bani'),(5344,2,'Сливенски минерални бани'),(5344,3,'Slivenski mineralni bani'),(5345,1,'Slanchev bryag'),(5345,2,'Слънчев бряг'),(5345,3,'Slanchev bryag'),(5346,1,'Sredna'),(5346,2,'Средна'),(5346,3,'Sredna'),(5347,1,'Studenets'),(5347,2,'Студенец'),(5347,3,'Studenets'),(5348,1,'Topilishta'),(5348,2,'Топилища'),(5348,3,'Topilishta'),(5349,1,'Treshtenik'),(5349,2,'Трещеник'),(5349,3,'Treshtenik'),(5350,1,'Tuzlata'),(5350,2,'Тузлата'),(5350,3,'Tuzlata'),(5351,1,'Turichka cherkva'),(5351,2,'Туричка черква'),(5351,3,'Turichka cherkva'),(5352,1,'Uzana'),(5352,2,'Узана'),(5352,3,'Uzana'),(5353,1,'Tsigov chark'),(5353,2,'Цигов чарк'),(5353,3,'Tsigov chark'),(5354,1,'Chayka'),(5354,2,'Чайка'),(5354,3,'Chayka'),(5355,1,'Shtarkelovo gnezdo'),(5355,2,'Щъркелово гнездо'),(5355,3,'Shtarkelovo gnezdo'),(5356,1,'Yazovir batak'),(5356,2,'Язовир батак'),(5356,3,'Yazovir batak');
/*!40000 ALTER TABLE `CitiesML` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `Texts` WRITE;
/*!40000 ALTER TABLE `Texts` DISABLE KEYS */;
INSERT INTO `Texts` VALUES (1,3,'Create',2289755597),(2,2,'Create Administrator',1037276004),(3,2,'Account',2995482424),(4,2,'Permissions',2876326840),(5,2,'Administrator Account',892126259),(6,2,'Username:',1483083269),(7,2,'Password:',1618169985),(8,2,'Email:',1143805008),(9,2,'Access Level:',3428050462),(10,2,'Administrator Sections',1169514477),(11,2,'Administrator permissions can be applied only when the administrator account has access level \"Limited\".',2590913965),(12,2,'Edit',554135844),(13,2,'Edit Administrator',2016076131),(14,2,'Update',2676568142),(15,2,'Are you sure you wish to delete this administrator?',4168197166),(16,3,'Administrators',3395160503),(17,2,'New Administrator',578394630),(18,2,'Export',1159730082),(19,2,'Print',3558298466),(20,3,'Username',19424289),(21,3,'Email',642995056),(22,2,'Access Level',1358691240),(23,2,'Delete',1035893169),(24,2,'No records found.',1991199118),(25,2,'Filter Administrators',2437429846),(26,2,'Username...',401120404),(27,2,'Email...',759615668),(28,2,'Reset Filters',4173485446),(29,2,'Create API Account',3440991137),(30,2,'Edit API Account',979098257),(31,2,'API Account Permissions:',856131234),(32,2,'Are you sure you wish to delete this API account?',594535439),(33,3,'API Accounts',510619022),(34,2,'New API Account',769722276),(35,3,'ID',299066170),(36,3,'Password',3434357891),(37,2,'Filter API Accounts',1422021308),(38,2,'ID...',1656057158),(39,2,'Add Transaction',2029384602),(40,2,'Customer email:',1621185387),(41,2,'Customer will:',2085752545),(42,2,'points',666537513),(43,2,'Description:',3730803834),(44,3,'Bonus Points',1829616372),(45,2,'Are you sure you wish to delete this transaction?',786362779),(46,3,'Customer',2018503775),(47,2,'Time',3483776891),(48,3,'Action',1080068516),(49,3,'Points',538348319),(50,3,'Description',3950563313),(51,2,'Status',2091671594),(52,2,'Approve',1273029392),(53,3,'Void',1917417168),(54,2,'Customer Email...',3845477),(55,2,'Filter Transactions',3090480774),(56,3,'Customers',3768765570),(57,2,'Create Box',1399724308),(58,2,'Box Type:',2522791519),(59,2,'Box Name:',1029537327),(60,2,'Options',529056539),(61,2,'Box Options',4121317825),(62,2,'Edit Box Options',2919767447),(63,2,'Active:',905343091),(64,2,'Are you sure you wish to delete this box?',710380569),(65,3,'Boxes',204512749),(66,2,'New Box',4110683034),(67,2,'Area',2007405142),(68,3,'Name',4262580536),(69,3,'Active',1286797620),(70,3,'Type',753727511),(71,2,'Change status',3664733115),(72,2,'Title:',3387538849),(73,2,'Show title:',3718166553),(74,2,'Content:',1116506645),(75,2,'Create Category',3332629561),(76,2,'Parent Category:',2611773477),(77,2,'Name:',1022533488),(78,2,'Image:',3904062056),(79,2,'Layout:',2509092508),(80,2,'SEO Title:',1653073578),(81,2,'You can use %%COMPANY_NAME%%, %%PAGE_NAME%%, %%PAGE_NUMBER%% and %%FMT_PAGE_NUMBER%% which will be automatically replaced.',592908905),(82,2,'SEO Keywords:',3851858000),(83,2,'SEO Description:',4119834834),(84,2,'Are you sure you wish to delete this category, all subcategories, and all listed products?',4159192542),(85,2,'Delete category',590884430),(86,2,'You chose to delete category: ',3735244906),(87,2,'Deleting this category will also remove',914164045),(88,2,'subcategories.',34053083),(89,2,'products in current category and its subcategories.',345866253),(90,2,'Subcategories that will be deleted',721012472),(91,3,'Category name',491010218),(92,2,'No subcategories.',962550496),(93,2,'Products that will be deleted',1048183235),(94,3,'SKU',2570549838),(95,3,'Product name',2960715841),(96,3,'Category',4282022807),(97,3,'Price',185142749),(98,2,'No products.',1294350323),(99,2,'Edit Category',1213241423),(100,2,'Are you sure you wish to delete this category and all subcategories?',4285491557),(101,3,'Categories',1974355384),(102,2,'New Category',2407014471),(103,3,'Products',1254897676),(104,2,'Sort',4044774684),(105,2,'products',3015334490),(106,2,'Edit Checkout Module',282756568),(107,2,'Edit Checkout Module Options',3257114989),(108,2,'Checkout Module Name:',2359548218),(109,2,'Checkout Module Display Name:',1010515290),(110,2,'Options:',2658432784),(111,3,'Checkout Modules',2133747315),(112,2,'Display Name',382242975),(113,2,'Slide right',1235981300),(114,3,'Help',2830496658),(115,2,'Slide left',2037939570),(116,2,'Last Orders',4097332503),(117,3,'Today',1914014145),(118,3,'Yesterday',1741006997),(119,2,'Quick Links',873400667),(120,2,'Are you sure?\\nThe setup wizard can be enabled later through \"Website Content :: Boxes\" menu.',1407211951),(121,2,'Setup Wizard',2820672820),(122,2,'Quick setup steps:',71361365),(123,2,'1. Store owner',318403058),(124,2,'2. Emails',1063320005),(125,2,'3. Currencies',1497918823),(126,2,'and',133536621),(127,3,'Localization',2163033279),(128,2,'4. Payment',237900732),(129,2,'5. Shipping Modules',842685971),(130,2,'Zones',1141612140),(131,2,'6. Checkout',1263603970),(132,2,'Create <a href=\"categories.php\">categories</a> and <a href=\"products.php\">products</a>.',2472554517),(133,2,'Start selling !',418204617),(134,2,'Remove Box',2645630361),(135,2,'Company - Store Owner',3522603177),(136,2,'Company Name:',839502324),(137,2,'Company Country:',1766359513),(138,2,'Company State:',3551868704),(139,2,'Company City:',4205699080),(140,2,'Company Address:',1467534244),(141,2,'Company Address 2:',3184102455),(142,2,'Company ZIP:',2799088763),(143,3,'Phone:',3951350519),(144,2,'Phone 2:',1211405980),(145,3,'Fax:',4156838822),(146,2,'Create Country',115514393),(147,2,'ISO 3166-1-alpha-2:',3747125869),(148,2,'2-letter country code',2020171218),(149,2,'ISO 3166-1-alpha-3:',3326323500),(150,2,'3-letter country code',3887324748),(151,2,'Edit Country',1265701764),(152,2,'Require valid customer city',1323169768),(153,2,'Make sure you have a full database of states and cities for this country before enabling',2446631621),(154,2,'Are you sure you wish to delete this country?',1154463460),(155,3,'Countries',3751241998),(156,2,'New Country',3026300927),(157,3,'Code 2',2221352256),(158,3,'Code 3',4083160534),(159,3,'States',913207931),(160,2,'Default',753088835),(161,2,'Set default',2535385811),(162,2,'Filter Countries',419496075),(163,2,'Country name...',971770418),(164,2,'2-Letter code...',699852639),(165,2,'3-Letter code...',2279503566),(166,2,'Create Coupon',4039929781),(167,2,'Code:',728504189),(168,2,'Type:',2549178112),(169,2,'Apply mode',3648363398),(170,2,'Value:',839626980),(171,2,'Shipping Method:',307808580),(172,2,'Valid From:',2338252958),(173,2,'Valid To:',464626289),(174,2,'Allowed uses:',2285077413),(175,2,'Coupon Conditions:',1100149183),(176,2,'Note: The coupon will be accepted only if all conditions are satisfied.',3517418852),(177,3,'Order',887667868),(178,3,'Customer Groups',3571547723),(179,3,'Manufacturers',656937191),(180,2,'Order subtotal exceeds',1940046458),(181,2,'Add product',311605988),(182,2,'Choose product',2644734124),(183,2,'Browse ...',515919727),(184,2,'Remove products',2677780045),(185,2,'Customer Name:',3319213447),(186,2,'Add customer',2398662531),(187,2,'Remove customers',3786205714),(188,2,'Manufacturer Name:',2426276932),(189,2,'Add manufacturer',3292489674),(190,2,'Remove manufacturers',1328338441),(191,2,'Edit Coupon',3508710101),(192,2,'Used:',3336226318),(193,2,'Are you sure you wish to delete this coupon?',495727280),(194,3,'Coupons',987310212),(195,2,'New Coupon',3472138508),(196,3,'Code',3609698214),(197,3,'Value',3702945584),(198,3,'Valid From',4013556806),(199,3,'Valid To',3211622985),(200,2,'Filter Coupons',895329285),(201,2,'Coupon Code...',3273198802),(202,2,'Coupon Value...',3255354999),(203,2,'Create Currency',2847503815),(204,2,'Code: (3-letters)',2257604640),(205,2,'Symbol Left:',4049401116),(206,2,'Symbol Right:',1068033941),(207,2,'Decimal Symbol:',4261341808),(208,2,'Thousands Separator:',2106014093),(209,2,'Number Decimals:',885873369),(210,2,'Rate:',2316664076),(211,2,'Edit Currency',659163569),(212,2,'Are you sure you wish to delete this currency?',1867670234),(213,2,'WARNING: Changing the default currency will change all prices to the new currency. No conversion is applied. Are you sure?',3101993193),(214,3,'Currencies',2023310659),(215,2,'New Currency',3764564409),(216,2,'Rate to',1144470778),(217,2,'Rate Updated',3198531662),(218,2,'Filter Currencies',3851265157),(219,2,'Currency Name...',2102318287),(220,2,'Currency Code...',730052110),(221,2,'Currency Rate...',2965428102),(222,2,'Update Currency Rates',3735031810),(223,3,'Currency Rate Modules',4255488631),(224,2,'Edit Currency Rate Module Options',3131407025),(225,2,'Currency Rate Module Name:',1363597389),(226,2,'Rates',2232779832),(227,2,'Currency Rates',3857138066),(228,2,'Currency Rates Of %%BANKNAME%%',2277816345),(229,2,'Base currency',3218697270),(230,2,'Quote currency',1628591218),(231,3,'Rate',2145292295),(232,2,'Date of update',1616759769),(233,2,'I will use custom urls',1503822767),(234,2,'Custom Url',495143701),(235,2,'Custom Url Is Current',810799440),(236,2,'Insert',3261111235),(237,2,'Remove',1865160710),(238,2,'Add url',734138096),(239,2,'Create Custom Url',1303866686),(240,2,'Url:',2242273707),(241,2,'Product:',1171046712),(242,2,'Category:',2056915619),(243,2,'Manufacturer:',673769939),(244,2,'Form:',872336839),(245,2,'Rich Text Page:',639522870),(246,2,'Gallery:',724805283),(247,2,'Dynamic Page:',13213407),(248,2,'Is Current:',1180273410),(249,2,'If a custom url is not current the visitor will be redirected to the current url of this page.',1457006762),(250,2,'Edit Custom Url',1835073706),(251,2,'Are you sure you wish to delete this custom url?',950790732),(252,3,'Custom Urls',1993255083),(253,2,'New Custom Url',1610774068),(254,3,'URL',1657866020),(255,2,'Entity',159662430),(256,2,'Entity Name',1271107802),(257,2,'Is Current',1063193523),(258,2,'Filter custom urls',586873638),(259,2,'Custom url text...',3760750716),(260,2,'Page ID...',2971479636),(261,2,'Create Customer Group',3465963864),(262,2,'Edit Customer Group',1354171785),(263,2,'Are you sure you wish to delete this customer group?',2030727810),(264,2,'New Customer Group',1832239909),(265,2,'Filter Customer Groups',62372502),(266,2,'Customer Group Name...',3534204887),(267,2,'Default billing address',3626964749),(268,2,'Default shipping address',1298866674),(269,2,'First Name:',1633266105),(270,2,'Last Name:',3952088495),(271,2,'Company:',190101345),(272,2,'VAT Number:',1987276054),(273,2,'Country:',1241179085),(274,2,'State:',963545935),(275,2,'City:',4099323532),(276,2,'Zip / Post Code:',3152090975),(277,2,'Address 1:',469117031),(278,2,'Address 2:',819690404),(279,2,'Add new',3025604379),(280,2,'Create Customer',1104573425),(281,2,'Customer Group:',3688990591),(282,2,'Status:',3486077833),(283,2,'Addresses:',2951236299),(284,2,'Newsletters:',84373228),(285,2,'Edit Customer',3475312519),(286,2,'Points:',2569416001),(287,2,'View Points History',671550159),(288,2,'Are you sure you wish to delete this customer?',2684393541),(289,2,'New Customer',135116687),(290,3,'Customer name',3259950746),(291,2,'Billing Address',1416126568),(292,2,'Order History',3631425621),(293,2,'Filter Customers',640984327),(294,2,'Customer name...',1938273026),(295,2,'Newsletters',139694043),(296,2,'Select the newsletters you want to subscribe for.',4134497924),(297,2,'Most Recent Orders',724096885),(298,2,'Last 5 Orders',3505840376),(299,3,'Date',179083332),(300,2,'Details',3181064726),(301,3,'Total',65982042),(302,2,'View all',2682620377),(303,3,'Views By Category',3178444827),(304,2,'No data for selcted period.',922052886),(305,2,'Settings',473154195),(306,2,'Period:',2812958730),(307,3,'Views By Product',3878477080),(308,3,'Sales By Product',686891096),(309,3,'Page Views / Unique Visitors',327582746),(310,2,'Access Denied',3785762269),(311,2,'Access denied to section \"%%SECTIONNAME%%\"!',3706373094),(312,2,'Create Discount',554650102),(313,2,'Discount Conditions:',859799067),(314,2,'Note: The discount will be granted only if all conditions are satisfied.',1753317527),(315,2,'Edit Discount',2952541568),(316,2,'Are you sure you wish to delete this discount?',1040504028),(317,3,'Discounts',2124840987),(318,2,'New Discount',1758760328),(319,2,'Filter Discounts',3090213278),(320,2,'Discount Name...',384779057),(321,2,'Discount Value...',401325246),(322,2,'Edit Dynamic Page',1151858065),(323,2,'Page:',4004852549),(324,2,'menu',2097494675),(325,2,'Dynamic Page Areas:',882035683),(326,3,'Dynamic Pages',264857579),(327,2,'Filter Dynamic Pages',3344210772),(328,2,'Page Name...',1435067696),(329,3,'Emails',1261301092),(330,2,'More info about the error',3826974845),(331,2,'Email Addresses',1840744469),(332,2,'Site Administrator Email:',3361431098),(333,2,'Order Department Email:',1294274427),(334,2,'Multiple emails separated by comma are supported.',2997004959),(335,2,'Help/Support Email:',2993599821),(336,2,'Reply-to Notifications Email:',221380787),(337,2,'This email will be put in From and Reply-To headers when sending notification emails to customers.',3044419721),(338,2,'Reply-to Newsletter Email:',2894426120),(339,2,'Method of Sending Emails:',4185941722),(340,2,'SMTP Server Settings',1666559931),(341,2,'SMTP Host:',3142575940),(342,2,'SMTP port:',735870516),(343,2,'Use SMTP Authentication:',3062696543),(344,2,'SMTP Username:',3330392952),(345,2,'SMTP Password:',4271152636),(346,2,'SMTP Security:',3837661202),(347,2,'Update and Send Test Email',3521870156),(348,2,'This is a test email.',2896921823),(349,2,'This email was sent from <a href=\"%%STORE_ROOT_URL%%\">%%COMPANYNAME%%</a> for the sole purpose to test email setup.',1220736883),(350,2,'Create Featured Product',4016487210),(351,3,'Product',485965105),(352,2,'Browse',2071043849),(353,2,'Feature on Home Page',3650456851),(354,2,'Edit Featured Product',859962406),(355,2,'Are you sure you wish remove this product from featured?',1653583751),(356,3,'Featured Products',1136261839),(357,2,'Search Product:',4064565271),(358,2,'Product name...',561596911),(359,2,'Filter Products',3497791286),(360,2,'New Featured Product',1140086212),(361,2,'Image',83635035),(362,2,'Featured In',2942734885),(363,2,'Create Form',2382706641),(364,2,'Confirm text:',2948666624),(365,2,'Enable captcha:',813452922),(366,2,'Edit Form',3121551407),(367,2,'Item Name',3478282366),(368,2,'Item Type',498026833),(369,2,'Required',435013471),(370,2,'Input and select fields should have name prefixed with custom-field-, eg:',418411255),(371,2,'Are you sure you wish to delete this form?',1891574076),(372,3,'Forms',1023292659),(373,2,'New Form',2225337316),(374,2,'Filter Forms',4144669664),(375,2,'Form Name...',2659577502),(376,2,'Create Gallery',314191173),(377,2,'Gallery Name',247289170),(378,2,'Gallery Title',1197503405),(379,2,'Gallery Description',1915678372),(380,2,'Gallery Active',964021644),(381,3,'SEO Title',1435567424),(382,2,'Edit Gallery',1596564184),(383,2,'Import Images From Folder',558160881),(384,2,'Are you sure you wish to delete this gallery?',637989770),(385,2,'Galleries',1979706388),(386,2,'New Gallery',2688097955),(387,3,'Title',3942078319),(388,2,'Filter Galleries',3010037137),(389,2,'Gallery Name...',124201707),(390,2,'Are you sure you want to delete gallery images before importing?',1412881386),(391,2,'Import images in \"%%GALLERYNAME%%\"',1032305907),(392,2,'Images found in directory \"%%DIRECTORY%%\"',3152560996),(393,2,'Delete gallery images before import',2488537117),(394,2,'Import Selected Images',1916110845),(395,2,'Create Gallery Item',3958908650),(396,2,'URL:',678364137),(397,2,'Edit Gallery Item',3453375687),(398,2,'Are you sure you wish to delete this item?',1822348166),(399,3,'Gallery Items',2370364043),(400,2,'New Gallery Item',2607950393),(401,2,'Added',176078831),(402,2,'Sort order',4035319854),(403,3,'General Options',2468205517),(404,2,'Images',3887315804),(405,2,'E-Goods',854454908),(406,2,'Ratings &amp; Reviews',1361241570),(407,2,'Miscellaneous',4043640331),(408,2,'Upon upload the images will be automatically resized to fit in the sizes specified below.',269276975),(409,2,'Product Images',1384850146),(410,2,'Large image max width:',2918703136),(411,2,'Large image max height:',492802816),(412,2,'Normal image max width:',3881581214),(413,2,'Normal image max height:',835495505),(414,2,'Thumbnail image max width:',921966431),(415,2,'Thumbnail image max height:',3716086874),(416,2,'Box image max width:',4157063781),(417,2,'Box image max height:',464721469),(418,2,'Save settings and regenerate product images',361089098),(419,2,'Manufacturers Images',220566877),(420,2,'Categories Images',3680048988),(421,2,'Gallery Images',2457112548),(422,2,'Gallery grid images per row:',1517437511),(423,2,'Gallery grid rows per page:',2504331047),(424,2,'Fullsize image max width:',2769143229),(425,2,'Fullsize image max height:',2481555164),(426,2,'Download link will stay active for:',2240765858),(427,2,'days',3957652582),(428,2,'Max downloads per E-Good:',2004198218),(429,2,'downloads',1265870005),(430,2,'Auto unlock of E-Goods:',539322459),(431,2,'Products can be rated by:',716429498),(432,2,'Products can be reviewed by:',2645711072),(433,2,'Automatically approve ratings and reviews by:',77241868),(434,2,'Products per page',3055675652),(435,2,'Default category view:',1383366238),(436,2,'Default product order:',3434089996),(437,2,'Grid view columns:',1369760445),(438,2,'Grid view rows:',1737381562),(439,2,'List view products:',382330550),(440,2,'Homepage view:',2083096048),(441,2,'Automatic inventory tracking:',750111958),(442,2,'When products are out of stock:',2380118066),(443,2,'Add new products to the front of the category listings:',402006418),(444,2,'Enable wholesale prices:',1909781453),(445,2,'Currency rates expire after:',4223135822),(446,2,'Products are considered new for:',1281194530),(447,2,'Maximum number of products to compare:',1202775632),(448,2,'Captcha on register:',924304961),(449,2,'Captcha on register in checkout:',62763753),(450,2,'Show unfinished orders:',3951021838),(451,2,'A friend referral earns',662215137),(452,2,'Limit to ',4060238471),(453,2,'uses per ',3898582405),(454,2,'Referral cookie life',414650819),(455,2,'A review earns',1563505666),(456,2,'A vote earns',1869955673),(457,2,'A purchase earns ',3808845936),(458,2,'Order statuses',1215727740),(459,2,'Spending ',2482087779),(460,2,'earns',1902986711),(461,2,'1 point equals',1689585026),(462,2,'when buying products.',3856038733),(463,2,'Manually approve point actions',4263381803),(464,2,'Let customers decide whether to spend points or not',2536097032),(465,2,'By default new products can be purchased with',1205939790),(466,2,'Summer Cart - Admin Panel',351951855),(467,2,'Search...',2616496417),(468,2,'Click to hide',2986050059),(469,2,'Welcome',4168505391),(470,2,'Logout',845213721),(471,3,'Language',766317539),(472,2,'Open Customer Area',2329144481),(473,3,'Home',3521422318),(474,2,'Store',1050048371),(475,3,'Website Content',1625540659),(476,3,'Reports',1050844889),(477,3,'Plugins',590925805),(478,3,'Search',3009207953),(479,3,'Sales',2856345408),(480,3,'Orders',3800299736),(481,3,'Product Options',870606089),(482,3,'Product Classes',3778863435),(483,3,'Import',2598554411),(484,2,'Promotion',1139605362),(485,3,'Rich Text Pages',689873154),(486,3,'News',3185653358),(487,3,'Newsletter',836273688),(488,3,'Image Galleries',586864587),(489,2,'Website Layout',2018988773),(490,3,'Menus',3014928331),(491,3,'Skins',549626884),(492,3,'Layouts',2592952232),(493,2,'Sales Reports',4132776560),(494,3,'Sales By Category',3412108406),(495,3,'Sales By Customer',1276457918),(496,3,'Sales By Country',2831740307),(497,2,'Customer Reports',1076937254),(498,3,'Customer Countries',779024177),(499,2,'Page Views / Visits',2809413986),(500,2,'Order Reports',248971099),(501,3,'Average Order Amount',3484514641),(502,3,'Order Statuses',2969627178),(503,3,'Payment Methods',2107866557),(504,3,'Shipping Methods',492318832),(505,3,'Taxes',55544060),(506,3,'Items Per Order',1911357502),(507,3,'Modules',3775560267),(508,3,'Shipping',3563746674),(509,3,'Payment',2727722385),(510,3,'Checkout',1447972632),(511,3,'Order Total',4237855332),(512,3,'Currency Rate',1033236376),(513,2,'Store<br />Configuration',3354049021),(514,2,'General',26480598),(515,3,'Store Owner',242724770),(516,3,'Security',1022211991),(517,3,'SEO',4208373434),(518,2,'Locations &amp; Taxes',2509950185),(519,3,'Shipping Zones',2642707482),(520,2,'Languages &amp; Currencies',4252246553),(521,3,'Languages',572576218),(522,2,'Create Help',3557463602),(523,2,'Page Action:',1389658646),(524,2,'Text:',3505702287),(525,2,'Edit Help',3758143948),(526,2,'Are you sure you wish to delete this help?',1239850335),(527,3,'Helps',94865552),(528,2,'New Help',3735835143),(529,3,'Page',3023575326),(530,2,'Filter Helps',3461554051),(531,2,'Page name...',2587122860),(532,2,'Import Products',1153217644),(533,2,'CSV File:',2478860166),(534,2,'Please make sure that the CSV file has the correct format. Take a look at the <a href=\"%%SKIN_URL%%admin/import/products.csv\" target=\"_blank\">example CSV file</a>.',2147132762),(535,2,'Languages:',1915366692),(536,3,'All',55916349),(537,2,'Auto-create manufacturers:',3997793959),(538,2,'Auto-create categories:',4116337988),(539,2,'Auto-create product classes:',517128142),(540,2,'Delete all products before import:',1866055727),(541,2,'WARNING! This will result in the deletion of ALL current products!',1059048098),(542,2,'Optionally you can choose to remove all current products first.',2862194528),(543,2,'Allow partial success:',2682384428),(544,2,'By default all products are imported as a single transaction that either succeeds or not. Allowing partial success will apply the changes to all successfully imported products even if part of the import fails.',2388344707),(545,2,'Imported Products',2960504523),(546,2,'Updated Products',1831847519),(547,2,'Imported New Categories',3527257968),(548,2,'Imported New Manufacturers',1963134496),(549,2,'Imported New Product Classes',2676543370),(550,2,'Products with failed images',2162755878),(551,2,'Installation check fails for:<br/><strong>%%PROBLEMS%%</strong>.',946252235),(552,2,'License Info',2196203420),(553,2,'Application Log',2194961893),(554,3,'Install Check',3504735353),(555,2,'Your installation passes the install checks.',2743614721),(556,2,'Find texts',3855422341),(557,2,'Find texts results',2654260861),(558,2,'Found texts',2860613836),(559,2,'Found template texts',3939961270),(560,2,'Found code texts',1533893826),(561,2,'All unique texts count',1505227595),(562,2,'Update operation results',4279887624),(563,2,'Previous texts count',384604181),(564,2,'Added texts count',1807440099),(565,2,'Removed texts count',1545029533),(566,2,'Return',2687646265),(567,2,'Create Language',338988109),(568,2,'Based On:',94494848),(569,2,'2-character language code (ISO 639-1)',1005997555),(570,2,'Direction:',151362824),(571,2,'While most languages are written left-to-right, some languages, like Arabic and Hebrew are written right-to-left.',1192782810),(572,2,'Icon:',3299575374),(573,2,'May take some time.',1030573456),(574,2,'Edit Language',2596794427),(575,3,'Info',1807457897),(576,2,'Language Pack',3440977850),(577,2,'Xliff Files',1786319641),(578,2,'Download language pack',3455484701),(579,2,'Author:',1320282873),(580,2,'License:',2302973021),(581,2,'Publish Date:',3070820891),(582,2,'Language pack:',4273363598),(583,2,'Download / upload xliff files',967710941),(584,2,'A language pack contains xliff files. XLIFF is an internationally standardized file format for software localization and translation.',1393277713),(585,2,'Download xliff files',1334522620),(586,2,'Interface language texts',1059175203),(587,2,'Download XLIFF',1094608267),(588,3,'Admin Quick Links',3513281581),(589,2,'Upload xliff files',2057606105),(590,2,'Upload XLIFF',2454456072),(591,2,'This is a php.ini setting beyond Summer Cart control. Please contact your hosting company to increase the upload limit.',1148527715),(592,2,'Install',3765929189),(593,2,'Install Language Pack',1116465884),(594,2,'Language pack file:',1257387828),(595,2,'It is a a zip file that contains the translations for one language.',2368833844),(596,2,'Please visit <a href=\"http://www.summercart.com/\" target=\"_blank\">www.summercart.com</a> to find language packs.',4220357726),(597,2,'Maximum upload file size is %%MAXUPLOADSIZE%%.',1623261434),(598,2,'How to increase?',3548864002),(599,2,'Language Pack Successfully Installed.',1877622045),(600,2,'Language pack info',1710096959),(601,2,'Successfully installed language files',1010286815),(602,2,'File',749574446),(603,2,'Texts to be translated',2331169344),(604,2,'Installed translations',401915326),(605,2,'Missing translations',2164804145),(606,2,'Unused translations',3360604285),(607,2,'Texts with missing translations',3714345229),(608,2,'details',1915095946),(609,2,'Unused translations for texts',1455164762),(610,2,'Continue',3935651977),(611,3,'Edit User Interface Translations',1851207096),(612,2,'Original Text',1496342308),(613,2,'Text in',424200871),(614,2,'Check all',3749695353),(615,2,'Translation approved',446897115),(616,2,'Filter User Interface Translations',106014150),(617,2,'Text ID...',2166909919),(618,2,'Original Text...',1056778569),(619,2,'Translated Text...',122880609),(620,2,'Filter Translations',2485861965),(621,2,'User Interface Translations',291378377),(622,2,'Are you sure you wish to delete this language?',1652720925),(623,2,'WARNING: Changing the default language will change the language used to store the order items names. Are you sure?',105775009),(624,2,'Languages Management',771978002),(625,2,'New Language',1575962675),(626,2,'translate',1242588023),(627,2,'view all',1720970127),(628,2,'Filter Languages',3837179999),(629,2,'Language Name...',69925236),(630,2,'Update User Interface Texts',568052308),(631,2,'Create Layout',2924034901),(632,2,'CSS Class Names',956611263),(633,2,'Edit Layout',2410151477),(634,2,'Layout ID',4287890366),(635,2,'Are you sure you wish to delete this layout?',3185071516),(636,2,'Layouts Management',1205307603),(637,2,'New Layout',2423387628),(638,2,'Change default layout',2968916085),(639,2,'Filter Layouts',2500444969),(640,2,'Layout Name...',146829847),(641,2,'End-User License Agreement',412693723),(642,2,'Summer Cart License Info',2682984555),(643,2,'Licensed To:',2323996648),(644,2,'License Type:',1523516778),(645,2,'Website:',3545320687),(646,2,'License Code:',3864153367),(647,2,'Check Authenticity',3045320497),(648,2,'Demo:',63961100),(649,2,'Weight Unit:',4203975461),(650,2,'WARNING: Changing the weight unit will change all product weights in the store to the new unit. No conversion is applied.',2784187960),(651,3,'Application log',3130602245),(652,2,'Message',2030045667),(653,3,'Administrator',3953216932),(654,3,'Customer Email',3749110151),(655,2,'Severity',253145917),(656,2,'Filter log entries',316635914),(657,2,'Message...',1613063122),(658,2,'Administrator Name...',1158643050),(659,2,'Log entries',3873015737),(660,2,'Please enable JavaScript. Summer Cart requires JavaScript to function properly.',750740131),(661,2,'Please login',4049669701),(662,2,'Language:',757082350),(663,2,'Log In',3342318177),(664,2,'Create Manufacturer',2168853892),(665,2,'Edit Manufacturer',2808637353),(666,2,'Are you sure you wish to delete this manufacturer?',2944624444),(667,2,'New Manufacturer',4056684887),(668,3,'Website',2295489659),(669,2,'Filter Manufacturers',4021677144),(670,2,'Manufacturer Name...',277105412),(671,2,'Manufacturer Site...',2536423828),(672,2,'Create Menu Item',3208812707),(673,2,'Edit Menu Items',1958220373),(674,2,'Edit Menu Item',111853526),(675,3,'Menu Items',73030122),(676,2,'New Menu Item',146153308),(677,2,'Link Type',1691918083),(678,2,'Links To',2604631168),(679,2,'Create Menu',2710106125),(680,2,'Menu Name:',410452179),(681,2,'Menu Location:',1232203988),(682,2,'Menu Title:',2249378412),(683,2,'Menu Active:',3496752393),(684,2,'Edit Menu',2508382195),(685,2,'Are you sure you wish to delete this menu?',4294259204),(686,2,'New Menu',2871931960),(687,2,'Location',2817059741),(688,2,'Filter Menus',2017505496),(689,2,'Menu Name...',657625883),(690,2,'See all',3805367665),(691,2,'Create Option Group',3553794789),(692,2,'Edit Option Group',4126992584),(693,2,'Are you sure you wish to delete this option group?',2462623563),(694,3,'Option Groups',500159910),(695,2,'New Option Group',2740491830),(696,2,'Filter Option Groups',3578931481),(697,2,'Option Group...',4236806916),(698,2,'Price Modifier',3523343456),(699,2,'Modification Type',3590926850),(700,3,'Amount',2299360628),(701,3,'% of product price',1956349703),(702,2,'Create Order Status',424616805),(703,2,'Send Notification:',1360519729),(704,2,'Inventory Action:',3743557245),(705,2,'Edit Order Status',1063342408),(706,2,'Are you sure you wish to delete this order status?',3081471352),(707,2,'New Order Status',1774530486),(708,2,'Notification',2808458546),(709,2,'Inventory',870107285),(710,3,'Predefined',2067839808),(711,2,'Change',1207696150),(712,2,'Filter Order Statuses',3927366091),(713,2,'Order status...',620095717),(714,2,'Edit Order Total Module Options',2006019800),(715,2,'Order Total Module Name:',1031408549),(716,3,'Order Total Modules',3825478277),(717,2,'image',3309110367),(718,2,'SKU:',2247323090),(719,2,'Administrative note is too short.',4125291397),(720,2,'Are you sure you want to delete this note?',2288505237),(721,2,'The CVV and all but the last 4 digits of the credit card number will be discarded. Are you sure?',3215528822),(722,2,'Print invoice',1929955923),(723,2,'Print packing slip and labels for order #%%ORDERID%%',3642958753),(724,2,'Print Packing Slip',3185707023),(725,2,'Edit Order',3094574373),(726,2,'Order Details',2381271956),(727,2,'Order number',1460565179),(728,2,'Order date',3551558051),(729,2,'Customer Info',4157998837),(730,3,'IP Address',1436479071),(731,2,'Billing information',3735532719),(732,2,'Bill To:',3702440234),(733,2,'Address:',2009770416),(734,2,'see map',2245635979),(735,2,'Shipping information',3912290734),(736,2,'Ship To:',1058344987),(737,2,'Shipping Info',855323776),(738,3,'Shipping method',3890635123),(739,2,'Shipping tracking №',580378663),(740,2,'View Transactions',81762214),(741,3,'Payment method',2888137196),(742,2,'Payment transaction №',2405271545),(743,2,'Credit Card Info',2941008396),(744,2,'Discard',2347830614),(745,2,'Cardholder Name:',3961855662),(746,2,'Card Number:',2373507299),(747,2,'Card Expiration:',1022260215),(748,2,'CVV / CVC Code:',3551303276),(749,2,'AVS:',1028089187),(750,2,'CVN:',1747108340),(751,2,'Check Info',3135544870),(752,2,'Name on Account:',4264007409),(753,2,'Account Number:',2210243515),(754,2,'Bank Name:',2205281729),(755,2,'Account Type:',3899945616),(756,2,'Special instructions from customer',1255983578),(757,2,'Payment notes',525886687),(758,2,'Ordered products',30367324),(759,3,'Quantity',1720022112),(760,3,'Discount',412538456),(761,2,'Price per unit',3940561649),(762,2,'Order total',1029285216),(763,2,'Customer paid in',3391103084),(764,2,'Send E-Goods',2313543638),(765,2,'View E-Goods',1995554626),(766,2,'Payment Status',2396005286),(767,2,'Administrative notes about this order',772090503),(768,2,'Note',1871664426),(769,2,'Sent to customer',1364489895),(770,2,'Created',2105576996),(771,2,'No order notes.',3519893586),(772,2,'New admin note',3920048843),(773,2,'Send the administrative note to customer',1426351852),(774,2,'Note contents:',123366371),(775,2,'Add note',1135686316),(776,2,'Unlock',1833481689),(777,2,'Lock',666711088),(778,2,'Downloads',3380749846),(779,2,'Expires',1428246800),(780,2,'Downloadable',1649497623),(781,3,'Yes',1303016265),(782,3,'No',4063104189),(783,2,'Invoice for order #%%ORDERID%%',1011106260),(784,2,'Invoice',1608003288),(785,2,'Order date:',1526887444),(786,2,'Shipping method:',3722834136),(787,2,'Shipping tracking №:',2972062900),(788,2,'Payment method:',3172908309),(789,2,'Payment transaction №:',3504349440),(790,2,'Please select orders first.',1736041562),(791,2,'Are you sure you wish to delete selected orders?',2516486077),(792,2,'Are you sure you wish to update all orders statuses?',3353338619),(793,2,'Search Orders',2453634288),(794,2,'Order ID...',2646813048),(795,2,'Customer Name...',3157953182),(796,2,'Create Order',3796017169),(797,2,'Update Statuses',3514807676),(798,2,'Print Invoices',275359193),(799,2,'Print Packing Slips',2332831890),(800,2,'Transactions',4070162868),(801,2,'Order ID:',551895527),(802,2,'Transaction Code',1507437924),(803,2,'Detail Name',4099588478),(804,2,'Detail Value',1124325509),(805,2,'No transactions found.',3399427310),(806,2,'Edit Payment Module',4234656813),(807,2,'Edit Payment Module Options',52654519),(808,2,'Payment Module Name:',909362514),(809,2,'Payment Module Display Name:',3629807128),(810,3,'Payment Modules',100059395),(811,2,'Integration Method',4023227825),(812,2,'Edit Plugin Options',1621980064),(813,2,'Plugin Name:',3696483166),(814,2,'Install Plugin',1155909498),(815,2,'Plugin package file:',3228116228),(816,2,'Plugin Modules',2612794959),(817,2,'Plugin',4005700258),(818,2,'Module',193471262),(819,2,'Please select image first.',3424629120),(820,2,'Only images can be uploaded. Please select JPG, PNG or GIF.',1392705431),(821,2,'Upload Image',3487826600),(822,2,'Select Image',1336794860),(823,2,'Preview',1983387308),(824,2,'Auto-generate thumb.',703179297),(825,2,'Thumb:',45485956),(826,2,'Close',3535843008),(827,2,'Apply Now',303993805),(828,2,'Cancel',1371193412),(829,2,'Please select print fields.',2589634787),(830,2,'Select the data you want to print',4118653070),(831,2,'Please select product.',3624458271),(832,2,'Please select category:',4054035588),(833,2,'products found.',737252216),(834,2,'Select Product',2057586828),(835,2,'Product Attributes',3711818894),(836,2,'Add value',3628166978),(837,2,'Add attribute',4145562852),(838,2,'Create Product Class',313419750),(839,2,'Attributes',2126945696),(840,2,'Edit Product Class',1465325025),(841,2,'Are you sure you wish to delete this product class?',4232330976),(842,2,'New Product Class',218394244),(843,2,'Product Class...',2631993219),(844,2,'Filter Product Classes',912926102),(845,2,'Find product',4142080300),(846,2,'switch to<br/>WYSIWYG editor<br/>',4293700324),(847,2,'switch to<br/>Plain text',589944230),(848,2,'Pictures',1980386710),(849,2,'Additional Categories',2584338874),(850,2,'Prices',3815204975),(851,2,'Related Products',3563717080),(852,2,'Bundle',2732013515),(853,2,'Item Number (SKU)',854319462),(854,3,'Manufacturer',624639268),(855,3,'Product Name',273309567),(856,2,'Brief Description',314147162),(857,3,'Detailed Description',2857272176),(858,2,'Available for Sale',2224570068),(859,3,'Weight',6377591),(860,2,'lbs, kgs',1892211746),(861,3,'Tax Classes',2146757560),(862,2,'No taxes defined.',3641567454),(863,2,'Product Page Title',2594461011),(864,2,'You can use %%COMPANY_NAME%%, %%PAGE_NAME%%, %%CATEGORY_NAME%% and %%CATEGORY_BRANCH%% which will be automatically replaced.',3570241586),(865,2,'Meta Keywords',2164287666),(866,2,'Meta Description',39755518),(867,2,'Global Options',3424188446),(868,2,'Product Option',3893533752),(869,2,'Product is E-Good:',4250554258),(870,3,'Product Class',3302799654),(871,2,'Attribute',2022403416),(872,2,'Available with bonus points',626226205),(873,2,'Price in points',2254132409),(874,2,'Leave blank for auto-price.',1807972765),(875,2,'If left blank the price in points will be ',3714791612),(876,2,'Product is bundle',2824029570),(877,2,'Auto-quantities',3047654571),(878,2,'If enabled changing a subproduct quantity will automatically update the bundle quantity.',2431883014),(879,2,'Included products',954096422),(880,2,'Are you sure you wish to delete this product and all of its e-good files?',3664961198),(881,2,'Delete product',3366923039),(882,2,'Product to be deleted:',3917002164),(883,2,'Deleting this product will also remove %%EGOODSCOUNT%% e-good files.',2664546985),(884,2,'Files that will be deleted:',2130013892),(885,2,'Edit Product',3410550351),(886,2,'Variants',1257124279),(887,2,'see variants',1778871822),(888,2,'see wholesale prices',2818503275),(889,2,'see bundles',2445281649),(890,2,'Click on thumb to see larger image.',335754544),(891,2,'You need to add options of type \"variant\" to have product variants.',4292304212),(892,2,'You need to save any changes you have made to this product\'s options before editing variants.',3629807937),(893,2,'Save',4115961312),(894,2,'Save And Close',2619480116),(895,2,'That would remove all E-Goods from this product. Are you sure?',1021041466),(896,2,'Add Product E-Good',166431123),(897,2,'Product E-Good is a file (image, movie, document, mp3 or other) that is to be used only by this product.',3751438319),(898,2,'Add Shared E-Good',75466410),(899,2,'Shared E-Good is a file that can be used by more than one product.',4183963746),(900,2,'Note: When a product is deleted all of its E-Goods are deleted along with it, while the shared E-Goods will be left intact.',428357396),(901,2,'Image Thumb',3210431157),(902,2,'Upload new image',3929915345),(903,2,'Add picture',3607359936),(904,3,'Local Options',1146293855),(905,2,'Add option',3810910862),(906,2,'You have to filter by category to be able to reorder products.',384259134),(907,2,'Sorting failed.',387876210),(908,2,'Enable drag and drop sorting?',3932571580),(909,2,'Drag products vertically to reorder them in the category.',1400665124),(910,2,'Are you sure you wish to delete this product?',1224315921),(911,2,'Search Product',691153231),(912,2,'Product number (SKU)...',1043481812),(913,2,'Product Name...',4005851251),(914,2,'Additional filters',1372295029),(915,2,'Price from...',2850335413),(916,2,'Price to...',454427117),(917,2,'Product Description...',903571526),(918,2,'New Product',878207540),(919,2,'Reorder products',2115538962),(920,2,'Qty',4038453503),(921,3,'Duplicate',2427847608),(922,2,'Wholesale Prices',1291634369),(923,2,'Customer Group Prices',912557301),(924,2,'Add price row',4016236161),(925,2,'Reset variants wholesale prices',1348646173),(926,2,'Are you sure you want to reset variants wholesale prices for this product?',4218420269),(927,2,'Bi-directional',1377088974),(928,2,'Create Admin Quick Link',3967730406),(929,2,'Link Text:',3395691925),(930,2,'Link Location:',2990819220),(931,2,'Edit Admin Quick Link',811173354),(932,2,'Are you sure you wish to delete this link?',1543674835),(933,2,'New Quick Link',322693661),(934,3,'Link Location',4129737893),(935,2,'Filter Admin Quick Links',2046232192),(936,2,'Regenerate images',2989896966),(937,2,'Product images',1428629460),(938,2,'Variant images',570540454),(939,2,'Go to general settings',3979516769),(940,2,'Error: ',1682980639),(941,2,'Warning: ',3119939844),(942,2,'Report',3280171698),(943,2,'View (Unit of Time):',1128758787),(944,2,'Download as CSV',1567988421),(945,2,'Chart',613877038),(946,2,'Table',937992258),(947,2,'Chart value:',1435361928),(948,2,'Top:',3482545072),(949,2,'Currency:',552652585),(950,2,'You need to upgrade your Flash Player.',4292548849),(951,2,'Records:',1918578068),(952,2,'No data for selected period.',1797036103),(953,3,'Menu',3711407533),(954,2,'Create Rich Text Page',1404066370),(955,2,'Add to menus:',775396182),(956,2,'Edit Rich Text Page',3448845971),(957,2,'Are you sure you wish to delete this rich text page?',231048233),(958,2,'New Rich Text Page',4027838527),(959,3,'Layout',1033268948),(960,2,'Open in customer area',3264327005),(961,2,'Filter Rich Text Pages',4266157535),(962,2,'You don\'t have permissions to see the search results.',1611866998),(963,2,'Search Results',1708902902),(964,2,'Search in the following product fields:',3377439838),(965,2,'Search in the following order fields:',4229313245),(966,2,'Results in products:',1089105628),(967,2,'No products match your query.',2101845315),(968,2,'Results in orders:',904043044),(969,2,'No orders match your query.',1661959455),(970,2,'Use SSL:',287223950),(971,2,'Before enabling SSL please make sure that <a href=\"%%HTTPS_URL%%login.php\" target=\"_blank\">this SSL link</a> works. It should successfully open a secure login page.',322374794),(972,2,'Password store mode:',591812916),(973,2,'Site Title:',637222123),(974,2,'You can use %%COMPANY_NAME%% and %%PAGE_NAME%% which will be automatically replaced.',2078895898),(975,2,'Site Keywords:',3064612706),(976,2,'Site Description:',2800913026),(977,2,'SE-Friendly URLs:',452323653),(978,2,'SE-Friendly URLs require working mod_rewrite Apache module.<br/>Before enabling SE-friendly URLs please check that they work<br/>correctly on your server by following <a href=\"../manufacturers.html\" target=\"_blank\">this link</a>. If it fails to open<br/>the manufacturers listing page please contact your hosting provider.',1248220876),(979,2,'SE-Friendly URLs Type:',234548374),(980,2,'\"en\" will be replaced with the current language code.',1890709483),(981,2,'Sitemap:',145668893),(982,2,'Summer Cart automatically generates a <a target=\"_blank\" href=\"../sitemap.xml\">XML file</a> with information<br />that helps search engines like Google, Yahoo and Bing<br />to find and index all of your pages.<br />The <a target=\"_blank\" href=\"../sitemap.xml\">XML file</a> is compliant with the official Sitemap Protocol.',1787636607),(983,2,'Setup New Shipping Module',1997999718),(984,3,'Shipping Modules',1695384782),(985,2,'Select module:',1206177630),(986,2,'Edit Shipping Module Options',1640552363),(987,2,'Shipping Module Name:',2460261966),(988,2,'Shipping Module Display Name:',1465446556),(989,2,'Shipping Zone:',2458156334),(990,2,'Methods:',3644878690),(991,2,'Method',1509244758),(992,3,'Display name',3069853601),(993,2,'Are you sure you wish to delete this shipping module?',2763921508),(994,2,'New Shipping Module',917579977),(995,2,'Shipping Zone',1503249872),(996,2,'Create Shipping Zone',2414549776),(997,2,'Choose Country:',1051933231),(998,2,'Choose States:',2634450168),(999,2,'Edit Shipping Zone',3390204183),(1000,2,'Are you sure you wish to delete this zone?',139103139),(1001,2,'New Shipping Zone',2420183666),(1002,2,'Edit skin \"%%SKINNAME%%\" settings',559872952),(1003,2,'Skins Management',900681827),(1004,3,'Customer Area',3955952330),(1005,3,'Admin Area',1667261560),(1006,2,'The following skins were detected, but not installed automatically, because they are for different Summer Cart version. You may attempt to install such skins by clicking the install button.',2399413882),(1007,2,'Skin Name:',2261691191),(1008,2,'For Summer Cart Version:',2648372470),(1009,2,'Create a State',2304637720),(1010,2,'Edit a State',3301864581),(1011,2,'Are you sure you wish to delete this state?',509600253),(1012,2,'Manage States',2461920694),(1013,2,'New State',3795944341),(1014,3,'Country',2630807802),(1015,2,'Filter States',2988164914),(1016,2,'State Name...',1120297998),(1017,2,'State Code...',336266959),(1018,2,'Create Tax Classes',3541575390),(1019,2,'Create Tax Class',3592612221),(1020,2,'Edit Tax Class',1875561992),(1021,2,'New Tax Class',1641442946),(1022,3,'Up',3591424722),(1023,3,'Down',3167567621),(1024,3,'Tax Rates',1323977902),(1025,2,'Update Tax Rates',4286733379),(1026,2,'Create Tax Zones',3198370186),(1027,2,'Create Tax Zone',2805721639),(1028,2,'Edit Tax Zones',122382079),(1029,2,'Edit Tax Zone',701011537),(1030,3,'Tax Zones',2415154938),(1031,2,'New Tax Zone',4007669337),(1032,2,'Create Tax',3578194776),(1033,2,'Tax Name:',4144846822),(1034,2,'Registration Number:',2564721856),(1035,2,'Apply to Shipping:',2659130368),(1036,2,'Apply by Default:',1468898402),(1037,2,'Edit Tax',2981161265),(1038,2,'Are you sure you wish to delete this tax?',1438361936),(1039,2,'New Tax',1932327382),(1040,3,'Registration Number',63310942),(1041,2,'Apply To Shipping',2457820364),(1042,2,'Apply By Default',2770220216),(1043,2,'Edit Tax Rates',3327491243),(1044,2,'Filter Taxes',3367706607),(1045,2,'Choose image to upload',4136245189),(1046,2,'Upload...',842812345),(1047,2,'Images larger than %%IMAGE_MAX_WIDTH%%x%%IMAGE_MAX_HEIGHT%% px will be scaled down automatically.',3457770897),(1048,2,'Last 30 days',3215342),(1049,3,'Last 7 days',3043440391),(1050,2,'This month',3922919155),(1051,2,'Last month',1507105497),(1052,2,'This year',36063916),(1053,2,'Last year',3571073750),(1054,3,'All time',1009032439),(1055,2,'Specific Date',403610525),(1056,2,'All Dates Before',3060721506),(1057,2,'All Dates After',3086509526),(1058,2,'Date Range',1570709765),(1059,2,'Start date',2717396598),(1060,2,'End date',111718006),(1061,3,'Next',2753412866),(1062,2,'Prev',483403627),(1063,2,'Done',2954842005),(1064,2,'Merchant ID:',4274732151),(1065,2,'Merchant Key:',2453922054),(1066,2,'The backup shipping amount will be used if the Shipping Calculation call-back fails.<br/>\nYour customers will pay the backup shipping amount if accurate shipping amount cannot be determined.<br/>\nIf you don\'t use the backup shipping amount and the call-back fails the customer will be notified that they cannot ship to that address.<br/>',3676946771),(1067,2,'Use Backup Shipping Amount:',1672584572),(1068,2,'Backup Shipping Amount:',1083706231),(1069,2,'Check this option if you do NOT ship to PO Boxes.',2330328948),(1070,2,'Disallow US Post-Office Box:',3372155483),(1071,2,'Seller Account Currency:',2052058202),(1072,2,'Mode:',2489100572),(1073,2,'Quick setup instructions',147726518),(1074,2,'Please login to your Google Checkout account, click on Settings tab, and choose Integration menu.',1017425442),(1075,2,'1. Check \"My company will only post digitally signed carts.\" checkbox.',144205977),(1076,2,'2. Set \"API callback URL:\" to \"%%HTTPS%%modules/checkout/google/notify.php?gkey=[Merchant_Key]&amp;gid=[Merchant_ID]\". Replace [Merchant_Key] and [Merchant_ID] with the actual values.',3022219378),(1077,2,'3. Set \"Callback method\" to be XML.',1228526745),(1078,2,'In \"Advanced settings\" check the following options:',401607006),(1079,2,'1. Provide the first name, last name and full name of the buyer and order recipient in separate fields in the new order notification.',2549034529),(1080,2,'2. Return the buyer\'s ship-to phone number in the new order notification.',3348692449),(1081,2,'3. Return the buyer\'s billing phone number in the new order notification.',3645134935),(1082,2,'While logged into your Google Checkout account you can check for integration errors from the Tools tab, Integration Console menu.',412387362),(1083,3,'General options',1554049617),(1084,2,'Your account log-in email or the Secure Merchant Account ID.',835196441),(1085,2,'Account:',1019086286),(1086,2,'Payment Action:',554271247),(1087,2,'Allow Customer Note:',3611595129),(1088,2,'Require Confirmed Shipping Address:',3000703641),(1089,2,'PayPal Landing Page:',1520063823),(1090,2,'Use Confirm Page:',1645277103),(1091,2,'When using the additional confirm page Summer Cart makes sure that the correct tax and shipping are calculated.',1368278113),(1092,2,'Checkout Button Type:',2771442886),(1093,2,'API Access',2848467461),(1094,2,'API Access allows you to perform Capture, Reauthorization, Refund and Void operations directly from Summer Cart order management screen. To allow API Access:',2578337366),(1095,2,'Log in to your account at <a href=\"https://www.paypal.com/\" target=\"_blank\">https://www.paypal.com/</a>',2942559741),(1096,2,'Under \"My Account\" tab choose \"Profile\" subtab',927331701),(1097,2,'Click on the link \"API Access\" under the \"Account Information\" column',3877642009),(1098,2,'Click \"Request API Credentials\" link',2847613079),(1099,2,'Select \"Request API signature\" and click \"Agree and Submit\"',1389165952),(1100,2,'PayPal will display \"API account username\", \"API Password\" and \"Signature\". Enter them in the fields below',4065605080),(1101,2,'Click \"Done\"',1731671543),(1102,2,'API Username:',253979313),(1103,2,'API Password:',926299189),(1104,2,'API Signature:',2524839449),(1105,2,'If checked the customer will confirm the order on PayPal.',2363892471),(1106,2,'Default Currency',2923539806),(1107,2,'The default currency will be used if the current customer currency is not supported by PayPal.',2153718755),(1108,2,'The default currency must exists in <a href=\"currencies.php\">currencies management.</a>',147299665),(1109,2,'Default Currency:',2557676385),(1110,2,'Allow guest checkout',515095047),(1111,2,'User can enter order instructions during checkout',402334869),(1112,2,'Require the user to accept the terms and conditions',3811724674),(1113,2,'Terms and conditions',1299144461),(1114,2,'Create News',3244184526),(1115,2,'Add News',837680854),(1116,2,'Date:',1706368814),(1117,2,'Edit News',4115954736),(1118,2,'Are you sure you wish to delete this news?',4260919213),(1119,2,'Filter News',684042718),(1120,2,'News Title...',1521578592),(1121,2,'The following fees will be applied when customer selects Collect On Delivery payment method:',1705759856),(1122,2,'Use shipping module CoD fee if it is available:',3011918322),(1123,2,'Fixed Amount:',4071801088),(1124,2,'Proportional Fee:',1584702284),(1125,2,'Demo Mode:',32364822),(1126,2,'To set up the secret word, login to your 2CO Account and look under the \"Look &amp; Feel\" section.',2025693602),(1127,2,'The secret word is used to sign the transaction data that Summer Cart receives from 2Checkout.',166627762),(1128,2,'Secret Word',4243974355),(1129,2,'Secret Word:',187187385),(1130,2,'Please remember to login to your 2CO Account and set both \"Approved URL\" and \"Pending URL\" under the \"Look &amp; Feel\" section to',1836520064),(1131,2,'Direct Return should be set to \"No\".',3313317985),(1132,2,'Atos Worldwide E - Transactions - Secure Internet Payment',2455784416),(1133,2,'Choose a method to pay',2759416782),(1134,2,'Default Language:',2510548134),(1135,2,'Please make sure that folder modules/payment/atos/executables/ has the \'request\' and \'response\' files and that they are executable. You will receive the files from your bank.',2838166432),(1136,2,'API Login ID:',1252629769),(1137,2,'Transaction Key:',2504138788),(1138,2,'MD5 Hash:',1332928208),(1139,2,'Timezone Offset:',30186195),(1140,2,'hours',2317008269),(1141,2,'Keys are already generated. This operation will delete current keys and the module will not work until new certificates are entered.',1677552814),(1142,2,'Key is already generated. Please confirm generation of new key.',1499286651),(1143,2,'Borica payment module setup wizard',3787401028),(1144,2,'Data to be used in the certificate',3391458734),(1145,2,'State/Province:',929483243),(1146,2,'Locality (city):',3619342144),(1147,2,'Organization Unit:',247743386),(1148,2,'Common name:',2563698514),(1149,2,'Generate keys wizard',3253870329),(1150,2,'Step 1:',487826370),(1151,2,'Generate live private key, test private key and their CSRs for payment gateway.',3578621044),(1152,2,'Generate',40894957),(1153,2,'Step 2:',910094337),(1154,2,'Generate private key and CSR for eTLog.',3851170156),(1155,2,'Download <strong>live</strong> payment gateway CSR (<a href=\"?ModuleName=com.summercart.payment.borica.gate&amp;action=acDownloadApgwCSR\">download</a>), <strong>test</strong> payment gateway CSR (<a href=\"?ModuleName=com.summercart.payment.borica.gate&amp;action=acDownloadApgwTestCSR\">download</a>) and eTLog CSR (<a href=\"?ModuleName=com.summercart.payment.borica.gate&amp;action=acDownloadEtlogCSR\">download</a>) files and send them to your bank.',4053559235),(1156,2,'The bank will send you back three certificates - for the live payment gateway, test payment gateway and for eTLog.',1801018908),(1157,2,'Send the Return URL, listed on the previous page, to your bank.',3174182879),(1158,2,'Step 3:',791003456),(1159,2,'Set the 8-digit Terminal ID (TID) that you have received from your bank in the previous screen.',172391364),(1160,2,'Step 4:',1617188743),(1161,2,'Put the eTLog certificate contents in the field below and get the .p12 file.',2727466293),(1162,2,'The certificate starts with \"-----BEGIN CERTIFICATE-----\".',3878699623),(1163,2,'Get .p12 file',3003313697),(1164,2,'Import the .p12 file into your browser.',3471349272),(1165,2,'Return to Borica module',1196369362),(1166,2,'Terminal ID (TID):',3425203614),(1167,2,'8-digit code provided by your bank.',3978171891),(1168,2,'Order Description:',442304913),(1169,2,'Please enter the description line for the order.',2254540171),(1170,2,'Account Currency:',728497053),(1171,2,'Private Key for Live APGW:',1580903947),(1172,2,'The private key starts with \"-----BEGIN RSA PRIVATE KEY-----\".',4044169584),(1173,2,'Private Key for Test APGW:',87950621),(1174,2,'Certificate for Live APGW:',1034705443),(1175,2,'Certificate for Test APGW:',1722347829),(1176,2,'Configuration steps:',1556796273),(1177,2,'Use the \"<a href=\"module.php?ModuleName=com.summercart.payment.borica.gate&amp;action=acBoricaSetupWizard\">Borica payment module setup wizard</a>\".',1451649640),(1178,2,'Return URL:',3028765641),(1179,3,'Reversal',2288359418),(1180,2,'Total order amount:',914933220),(1181,2,'Refund amount:',1794229843),(1182,2,'Client ID:',2310413392),(1183,2,'Activation Key:',1706633060),(1184,2,'Method:',2522822593),(1185,2,'Accepted Check Types:',1614476677),(1186,2,'Product ID:',2281461740),(1187,2,'Product Currency:',1739691339),(1188,2,'Maximum Amount:',2751553006),(1189,2,'To charge a fee if the customer selects \"Collect on delivery\" payment method please remember to activate the corresponding \"Collect on delivery\" order total module. The fee is set in the total module.',3064029683),(1190,2,'Will be provided by DSK Bank.',3060458674),(1191,2,'Currency Code:',1268699863),(1192,2,'MD5 Password',372582953),(1193,2,'MD5 Password:',1454021497),(1194,2,'The MD5 password is required. It is used to sign the transaction data that Summer Cart sends to and receives from DSK Direct.',1155475729),(1195,2,'IMPORTANT NOTICE',4233366650),(1196,2,'If you don\'t have SSL enabled your customers will see warnings in their browsers at the end of the payment process.',1780295817),(1197,2,'If the customer clicks cancel the store will not be notified about the payment.',3901631899),(1198,2,'Client number:',2461502548),(1199,2,'Secret Key:',2223644698),(1200,2,'Payment Request<br />Expiration Time:',2646160959),(1201,2,'Payment instructions:',1847368024),(1202,2,'Merchant number:',3287268887),(1203,2,'Merchant name:',1571859967),(1204,2,'Merchant password:',173849435),(1205,2,'Order description:',40686185),(1206,2,'Storefront ID:',887383748),(1207,2,'13-character string in the form of UK12345678CUR.',4252987528),(1208,2,'Transaction Type:',3793027758),(1209,2,'Shared Secret',2443707600),(1210,2,'Shared Secret:',2454473967),(1211,2,'You will receive your shared secret (32-character string) from HSBC.',4044273798),(1212,2,'Default currency:',444762562),(1213,2,'If the user checks out with currency different from USD or CAD which one to use',3199946140),(1214,2,'Payment note:',274243051),(1215,2,'Options CAD',31088455),(1216,2,'Hosted payment page id:',2952545973),(1217,2,'Hosted payment page key:',3744805632),(1218,2,'Options USD',1636167766),(1219,2,'Additional information for the Moneris Merchant Hosted Configuration',2527265290),(1220,2,'For Response Method choose GET or POST and enter the following URL in the Response URL field:',630578004),(1221,2,'In the Security Features check the <strong>\"Enable Transaction Verification\"</strong> checkbox.',3137146140),(1222,2,'Select <strong>\"Displayed as XML on our server\"</strong> option of the \"Response Method\" section.',3150990615),(1223,2,'Leave the <strong>\"Response URL\"</strong> field empty.',2158506343),(1224,2,'Merchant Pay To Email:',2202504530),(1225,2,'Recipient Description:',3975230462),(1226,2,'Logo URL:',2822597311),(1227,2,'URL to your logo, it should start with https://. It will be displayed on the payment page.',2639952004),(1228,2,'Hide Login:',3283790610),(1229,2,'If checked Moneybookers will not allow the customer to login into existing Moneybookers account.',4038141604),(1230,2,'Use Iframe:',28162475),(1231,2,'If checked the payment form will be embeded within the merchant site, otherwise the user will be redirected to Moneybookers site to complete the payment.',2831228941),(1232,2,'Confirmation screen',1008152630),(1233,2,'Shown at the Confirmation screen (end step of the process)',2431019173),(1234,2,'Confirmation note:',910248752),(1235,2,'You may use &lt;br&gt; for line breaks.',3787582312),(1236,2,'Return URL Text:',3195721565),(1237,2,'The text on the button to return to store when the user finishes his payment.',1977604747),(1238,2,'The default currency will be used if the current customer currency is not supported by Moneybookers.',2999123729),(1239,2,'To set up the secret word, login to your Moneybookers Account and look under the \"Merchant Tools\" section.',1600929358),(1240,2,'The secret word is used to sign the transaction data that Summer Cart receives from Moneybookers.',1503288321),(1241,2,'PSPID can be found on the left side of your Ogone account page.',3635999792),(1242,2,'PSPID:',614528529),(1243,2,'Title on the payment page:',2741808256),(1244,2,'SHA-1-IN signature from your Ogone account (found in \"Technical information\" -> \"Data and origin verification\" -> \"SHA-1-IN Signature\")',737850223),(1245,2,'SHA-1-IN:',390345667),(1246,2,'SHA-1-OUT signature from your Ogone account (found in \"Technical information\" -> \"Transaction feedback\" -> \"SHA-1-OUT Signature\")',546023244),(1247,2,'SHA-1-OUT:',3625104482),(1248,2,'Enabled Currencies:',1411657282),(1249,2,'Important',1213247299),(1250,2,'Please enable the \"I want to receive transaction feedback parameters on the redirection URLs\" option. You can find it in your Ogone account by going to \"Configuration\" -> \"Technical Information\" screen, in the \"Transaction Feedback\" tab.',2279891751),(1251,3,'Capture',1145282425),(1252,2,'Already captured amount:',1073846020),(1253,2,'Capture amount:',55238551),(1254,2,'Is final:',2927438680),(1255,2,'There will be more capture operations',3190779602),(1256,2,'This is the final capture',3769638272),(1257,2,'Note (optional):',1229371311),(1258,2,'Vendor ID:',205308943),(1259,2,'Partner:',429771270),(1260,2,'User:',3661788121),(1261,2,'If you haven\'t created any user put Vendor ID here.',178066530),(1262,2,'Enable Buyer Authentication:',3029983581),(1263,2,'If checked 3D secure auth (\"Verified By Visa\" and \"SecureCode\") will be attempted.',1359090026),(1264,3,'Reauthorization',2360048237),(1265,2,'Reauthorization amount:',2303808259),(1266,3,'Refund',1551896942),(1267,2,'Captured amount:',1145322128),(1268,2,'Transaction to refund:',2162064995),(1269,2,'Full',1078819742),(1270,2,'Partial',1706748264),(1271,2,'Please enter the description line for the order. If left empty customers can enter the description at time of purchase.',864998091),(1272,2,'Payment Data Transfer (PDT)',2974419541),(1273,2,'Please enable PDT.',1828463134),(1274,2,'Click on the link \"Website Payment Preferences\" under the \"Selling Preferences\" column',3741902324),(1275,2,'Enable \"Auto-Return\" (and copy and paste the Return URL shown below)',3902299500),(1276,2,'Enable \"Payment Data Transfer\"',1874574508),(1277,2,'Click \"Save\"',1193147294),(1278,2,'PayPal will show you the PDT identity token. Put it in the field below.',3825642984),(1279,2,'PDT Identity Token:',1104199793),(1280,2,'Language Encoding',4230348253),(1281,2,'By default PayPal sends notifications in windows-1252 encoding, which will mangle any non-western characters.',3935609386),(1282,2,'Instead PayPal should be informed to send the notifications in UTF-8. Here is how:',1916601122),(1283,2,'Click on the link \"Language Encoding\" under the \"Selling Preferences\" column',1853139557),(1284,2,'Select the \"More Options\" button',1699103402),(1285,2,'Using the drop down menu select UTF-8 and select \"Yes\" to use this preference with IPN',1143435416),(1286,2,'Click \"Save\" ',4271664381),(1287,2,'Installation ID:',1371444183),(1288,2,'Auth Mode:',3981919405),(1289,2,'Please note that to use &quot;Pre Auth&quot; you might need to request it from WorldPay support.',3623864170),(1290,2,'Allow contacts edit:',3767901768),(1291,2,'If checked the customers will be able to edit their name and address at the RBS WorldPay site.',4075630300),(1292,2,'The default currency will be used if the current customer currency is not supported by RBS WorldPay.',3435607478),(1293,2,'MD5 secret for transactions<br />(up to 16 characters):',3435195543),(1294,2,'The secret word is used to sign the transaction data that Summer Cart sends to RBS WorldPay.',1099005614),(1295,2,'Payment Response Password:',1785134662),(1296,2,'It is used to verify the response from RBS WorldPay.',2128563735),(1297,2,'Login to your RBS WorldPay Account and look in the \"Installations\" menu',1756952934),(1298,2,'Choose the \"Installation\" you wish to configure',841163493),(1299,2,'Set \"Payment Response URL\" to \"%%HTTPS%%modules/payment/rbsworldpay/response.php\"',990984551),(1300,2,'Check the \"Payment Response enabled?\" checkbox',1938529821),(1301,2,'Check the \"Enable the Shopper Response\" checkbox',118523628),(1302,2,'Set \"Payment Response password\". Remember to enter it above',4057498740),(1303,2,'Set \"MD5 secret for transactions\". Remember to enter it above',2130128007),(1304,2,'Secret:',193969084),(1305,2,'Account (optional):',2399392064),(1306,2,'Auto capture:',2661746016),(1307,2,'Referral URL:',4089531088),(1308,2,'Vendor:',2409134777),(1309,2,'The default currency will be used if the current customer currency is not supported by Sage Pay.',1253391832),(1310,2,'Encryption Password:',3157569171),(1311,2,'Emails from Sage Pay',1001769353),(1312,2,'Vendor Email (optional):',2769525101),(1313,2,'Vendor email address to receive transaction information. Multiple email addresses can be entered separated by \":\" (colon).',2774351315),(1314,2,'Send emails with transaction info:',199766793),(1315,2,'Message to the customer (optional):',926829729),(1316,2,'If provided, will be included toward the top of the customer confirmation emails.',1242364881),(1317,2,'9-digit',2683762813),(1318,2,'Private Key for Live mode:',624437297),(1319,2,'Private Key for Test mode:',2117894951),(1320,2,'Transcard certificate for Live mode:',1223025197),(1321,2,'Transcard certificate for Test mode:',333531451),(1322,2,'Edit bank %%BANKNAME%%',515708534),(1323,2,'Edit bank',2429941028),(1324,2,'Store ID:',1651168334),(1325,2,'Is Active:',434599511),(1326,2,'Store Key',44303849),(1327,2,'Store Key:',3453667558),(1328,2,'The store key is required. It is used to sign the transaction data that Summer Cart sends to and receives from your bank.',1466148554),(1329,2,'Installments:',1132470983),(1330,2,'You may offer payment in installments to your customers. Please set the number of installments and the interest rate.',1278578948),(1331,2,'Installments',3869367668),(1332,2,'Interest rate (%)',649126636),(1333,2,'Default bank:',69889613),(1334,2,'The default bank will be used to process the payment the customer selects \"Card from another bank\".',3695363791),(1335,2,'Banks',1791432850),(1336,2,'Logo',1153185069),(1337,2,'Terminal Aliases:',1633730451),(1338,2,'Upload resource.cgn file provided by UBB:',2554014956),(1339,2,'Use the \"<a href=\"module.php?ModuleName=com.summercart.payment.ubb_bg.hostedpage&amp;action=acUbbBgSetupWizard\">UBB payment module setup wizard</a>\".',3108494789),(1340,2,'UBB.bg payment module setup wizard',2147088633),(1341,2,'Upload resource.cgn file',2731437692),(1342,2,'Return to UBB.bg module',2377979207),(1343,2,'Bank info and wire instructions:',2255685458),(1344,2,'Retailer ID:',3948245510),(1345,2,'Postal Code:',2382770493),(1346,2,'Optional. In this field, you can supply the Postal Code of your warehouse. <strong>Must be Canadian</strong>.',2828876885),(1347,2,'Turnaround Time:',494733389),(1348,2,'Optional. In this field, you can specify the time it takes between receiving an order and getting the order ready to ship.',3169761664),(1349,2,'e-Econt username:',2361988811),(1350,2,'e-Econt password:',3034335311),(1351,2,'e-Econt',2848807441),(1352,2,'Login to e-Econt',3849822505),(1353,2,'Contact Information',2970828923),(1354,2,'Company name:',4090029808),(1355,2,'Person name:',3007368028),(1356,2,'Address',3270727197),(1357,2,'Street address 1:',2025602183),(1358,2,'Street address 2:',1402040132),(1359,2,'Pickup from:',87389314),(1360,2,'Delivery receipt:',1915995396),(1361,2,'Minimum declared amount (optional):',2234420808),(1362,2,'If set, shipments with lower value will not have any declared value.',3907473293),(1363,2,'CD agreement number (optional):',4108804899),(1364,2,'Please contact Econt to obtain collect on delivery agreement number.',4061175651),(1365,2,'Client number (optional):',3184466366),(1366,2,'Please enter your FedEx account number. Your meter number will be obtained automatically.',431111556),(1367,2,'Meter Number:',830283296),(1368,2,'Ship From',1115236530),(1369,2,'Contact Details',3657543221),(1370,2,'Person Name:',1921115224),(1371,2,'Department:',2670906935),(1372,2,'Only digits',1124291200),(1373,2,'Pager Number:',4131668273),(1374,2,'State Or Province Code:',3968392638),(1375,2,'Country Code:',3313956470),(1376,2,'Misc',3751130500),(1377,2,'Insurance:',610088699),(1378,2,'Shipments will be insured for the order subtotal amount.',2475299491),(1379,2,'Packaging Weight:',1763209963),(1380,2,'This weight will be added to the goods weight.',1472220333),(1381,2,'Shipping Fee:',1457601935),(1382,2,'Client',3236430179),(1383,2,'Test account data',3309533356),(1384,2,'Account information',2288290833),(1385,2,'Additional options',4186509951),(1386,2,'Fragile goods:',1484115338),(1387,2,'Add insurance:',3859110517),(1388,2,'Documents:',3096612495),(1389,2,'Include VAT:',3513682807),(1390,2,'Handling type:',1988450491),(1391,2,'Handling amount:',3669659083),(1392,2,'Initialisation',202443566),(1393,2,'Locations:',1894811959),(1394,2,'Get locations from Speedy',213284011),(1395,2,'Importing locations can take some time, please be patient.',1993580989),(1396,2,'You have made changes to the form. If you continue all changes would be lost. Do you want to continue?',1968273914),(1397,2,'Importing cities could take some time. Do you want to continue?',382735039),(1398,2,'Loading',2564620584),(1399,2,'Parcels count:',1117520404),(1400,2,'Pickup date:',3857914122),(1401,2,'Print packing slip',98663625),(1402,2,'Delete packing slip',2718602126),(1403,2,'Deleting the shipping label will only delete it from Summer Cart database and will allow you to generate new packing slip for this order.',387154378),(1404,2,'You should also cancel it through Speedy\'s WebClients interface or by calling Speedy\'s customer service.',488747049),(1405,2,'Print label',53144288),(1406,2,'Are you sure you want to delete this packing slip?',957135579),(1407,2,'Up To Weight/Subtotal/Quantity',1799531275),(1408,2,'Cost',3088333762),(1409,2,'Please enter your UPS User ID, Password and XML Access Number:',860927180),(1410,2,'UserID:',3699446743),(1411,2,'XML Access Number:',3165438484),(1412,2,'Server:',2402760031),(1413,2,'Pickup Type:',3598087712),(1414,2,'Package Type:',1275046918),(1415,2,'Customer Classification',1095994250),(1416,2,'Select how your UPS account is classified.',2862999173),(1417,2,'Please enter your USPS User ID:',806419272),(1418,2,'Packing Slip',2386614917),(1419,2,'Packing slip for order #%%ORDERID%%',1625579401),(1420,2,'Consider orders placed in the last',2571559162),(1421,2,'Number of best sellers to display',1658504578),(1422,2,'List by',760001896),(1423,3,'Display',3278654271),(1424,2,'manufacturers',2488687378),(1425,2,'Number of new products to display',1896218232),(1426,2,'Shipping address is the same as billing',234900711),(1427,2,'Add Item',858079896),(1428,2,'Remove Item',1347538713),(1429,2,'Product options:',2492926120),(1430,2,'List Price:',3909844064),(1431,2,'Price:',3966210395),(1432,2,'Add to cart',1444368431),(1433,2,'Out of stock',2685524125),(1434,2,'Add Products',1158486406),(1435,2,'Product Name:',3567521997),(1436,2,'Filter',2020104747),(1437,2,'include subcategories',917550841),(1438,2,'Grand Total',1437113292),(1439,2,'Blast',2408483464),(1440,2,'To be able to send newsletter in this language you have to fill the Subject field.',213186513),(1441,2,'Blast Newsletter',666948076),(1442,2,'Subject:',1565721205),(1443,2,'Message:',762611188),(1444,2,'Send to customers:',2676347204),(1445,2,'Send to subscribers:',2633172727),(1446,2,'Blast Progress',4061451667),(1447,2,'Stop',426031496),(1448,2,'Start New Process',1124418244),(1449,2,'Blasting successfully completed.',2755086305),(1450,2,'Are you sure you want to start a new process?',2265563646),(1451,2,'Are you sure you want to stop this blast?',2955059868),(1452,2,'Newsletter Statistics',3129553589),(1453,2,'Blast Statistics',3147226886),(1454,2,'View Blast',1485082975),(1455,2,'Subscribe to newsletter:',3614080499),(1456,2,'Notify admin upon subscribe:',2746901891),(1457,2,'Create Newsletter',1642897459),(1458,2,'Add Newsletter',3168659782),(1459,2,'Edit Newsletter',1094372775),(1460,2,'Are you sure you wish to delete this newsletter?',3859046914),(1461,2,'Subscribers',2840697211),(1462,3,'Test',2018365746),(1463,2,'Stats',2525382830),(1464,2,'View',1590625456),(1465,2,'Tested',254338594),(1466,2,'Test first',747041944),(1467,2,'Newsletter name...',714700702),(1468,2,'Filter Newsletters',2060057791),(1469,2,'Show',2453435967),(1470,2,'Subject',879953894),(1471,2,'Emails Sent',1475250567),(1472,2,'Emails Opened',3918409999),(1473,2,'Email Clicks',1493021949),(1474,2,'Detailed Statistics',2679662937),(1475,2,'Detailed statistics',3504695945),(1476,2,'View blast',2571484763),(1477,2,'Add Subscribers',621797607),(1478,2,'Subscribers:',3547385618),(1479,2,'Subscriber emails separated by commas and/or new lines.',1079513077),(1480,2,'Add',3310826759),(1481,2,'Edit Subscriber',2461995782),(1482,2,'Are you sure you wish to delete this subscriber?',1191605410),(1483,2,'Filter Subscribers',3687574047),(1484,2,'Test Newsletter',2952046730),(1485,2,'Emails:',1587199635),(1486,2,'Send Test',3858340892),(1487,2,'Products Feed Options',2779812973),(1488,2,'Require key:',2663971073),(1489,2,'Secret key:',616075044),(1490,2,'Generate link',506785837),(1491,2,'Ratings and Reviews',3482811661),(1492,2,'Edit Rating and Reviews',1743133016),(1493,2,'IP Address:',4019184820),(1494,2,'Customer:',4020385206),(1495,2,'Review Content:',3323015556),(1496,2,'Rating:',235652961),(1497,2,'Are you sure you wish to delete this rating?',643703905),(1498,2,'Rating',3743752980),(1499,2,'Review',2129626352),(1500,2,'Filter Ratings',244298452),(1501,2,'Review Text...',4190646508),(1502,2,'IP Address...',2867445730),(1503,2,'Ratings',17514069),(1504,2,'Powered by',1132259710),(1505,2,'Welcome %%CUSTOMERFIRSTNAME%% %%CUSTOMERLASTNAME%%!',908066045),(1506,2,'Log Out',312708084),(1507,3,'Login',1808393236),(1508,3,'Register',2794398274),(1509,2,'Profile',1323996051),(1510,2,'Addresses',3980130229),(1511,2,'Add address',3432436168),(1512,2,'Edit address',3673263359),(1513,2,'Are you sure you want to delete this address?',86938300),(1514,2,'Default Billing',749705681),(1515,2,'Default Shipping',3926602309),(1516,2,'Bundled items:',480959536),(1517,3,'View Cart',2891456104),(1518,2,'Continue Shopping',961073464),(1519,2,'Apply coupon',3421549997),(1520,2,'Remove coupon',1821239519),(1521,2,'Empty Cart',3850054737),(1522,2,'%%CATEGORYPRODUCTCOUNT%% product(s)',782637220),(1523,2,'Subcategories',3592219198),(1524,3,'Grid view',566031201),(1525,2,'Featured products',3134167193),(1526,2,'<strong>Page %%PAGE%%</strong> of %%NUMPAGES%%',2568203735),(1527,2,'Show products comparison',3768902734),(1528,3,'List view',1111523802),(1529,2,'Billing / Shipping Address',58290041),(1530,2,'Billing / Shipping Methods',1490417553),(1531,2,'Confirmation',1343015364),(1532,2,'Final',756315074),(1533,2,'Checkout Failure',1879189093),(1534,2,'Your payment has been declined. Please try again.',4020425545),(1535,2,'Try Again',3453780242),(1536,2,'Checkout success',4045718410),(1537,2,'Thank you! Your order has been successfully processed, but your payment is still pending.',1210789654),(1538,2,'Thank you! Your order has been successfully processed.',906094716),(1539,2,'Authentication',869314853),(1540,2,'Register for checkout',1805277448),(1541,2,'Confirm Password:',3099258724),(1542,2,'Security code:',822156319),(1543,2,'Security code',1626898610),(1544,2,'Reload the image',847984313),(1545,2,'Please enter the letters you see in the box. Doing so helps prevent automated programs from abusing this form.',789590253),(1546,2,'Guest Checkout',3407541179),(1547,2,'If you use Guest Checkout there is no need to register. However you won\'t be able to see your past orders.',2121996478),(1548,2,'Optional email: ',3307505785),(1549,2,'* Please note that your email address will be used only to send you order notifications.',2421870257),(1550,2,'Address Information',3362839566),(1551,2,'Shipping Address',1190439064),(1552,2,'Next Step',610800229),(1553,2,'Select address',1797069372),(1554,2,'Confirm Order',2317107991),(1555,2,'Bill To',2007405874),(1556,2,'Ship To',2944186042),(1557,2,'Contact',2212487076),(1558,2,'Payment Method',2877914330),(1559,2,'Shippnig Method',1727468277),(1560,2,'Cart information',994804795),(1561,2,'I agree to the terms and conditions',4001707996),(1562,2,'Prev Step',2111172529),(1563,2,'Modify',4032482767),(1564,2,'Billing Method',3412837404),(1565,2,'Use bonus points.',4210788597),(1566,3,'Shipping Method',3762971717),(1567,2,'Special instructions?',2591431184),(1568,2,'Bestsellers',30083613),(1569,2,'Shopping Cart',442779427),(1570,2,'Cart is empty.',3355742105),(1571,2,'Items:',456003789),(1572,2,'Total:',2679332891),(1573,2,'View &amp; Checkout',2765451054),(1574,2,'Hello',4157704578),(1575,3,'Wishlist',1704413287),(1576,2,'New Products',982410204),(1577,2,'Recently Viewed',2154430034),(1578,2,'Advanced Search',792727095),(1579,3,'Forgotten Password',2784385862),(1580,2,'Your email is:',39256687),(1581,2,'Your password is:',1830307645),(1582,2,'Please follow <a href=\"%%HTTPS%%login.php\">this</a> link to login.',1014130425),(1583,2,'To reset your password follow this link:',4065048850),(1584,2,'Form submitted:',2663571239),(1585,2,'You can download your purchases from the',519137004),(1586,2,'E-Goods delivery section',376591614),(1587,2,'Please feel free to contact us:',2129829755),(1588,2,'To view this order details',2320060907),(1589,2,'click here',626704452),(1590,2,'There is important update about your order',4192191998),(1591,2,'has sent you an invitation to take a look at the following product:',2228299012),(1592,2,'Thank you for registering!',1535433401),(1593,2,'Your profile:',3313959608),(1594,3,'Error',2619118453),(1595,2,'An error has occurred during the processing of your request. If the error persist please contact the store owner.',2367234431),(1596,2,'<a href=\"http://www.summercart.com/\" target=\"_blank\">shopping cart software</a>',2226783450),(1597,2,'The password will be sent to your email address.',1429023383),(1598,2,'Send password',58328078),(1599,2,'New password:',1679901357),(1600,2,'Confirm new password:',1791768478),(1601,2,'Reset password',1541818425),(1602,2,'Your password was successfully reset.',4158181270),(1603,2,'Please procced to login.',3756970489),(1604,3,'Success',2696799790),(1605,2,'Submit',949859957),(1606,3,'Gallery',2291548582),(1607,2,'Welcome to our store!',3504437773),(1608,2,'Our Featured Products',3335690486),(1609,2,'View details',909788852),(1610,2,'Quantity:',1507512851),(1611,2,'View all products from %%MANUFACTURERNAME%%',57972069),(1612,2,'products found from',4142905463),(1613,2,'<b>Page %%PAGE%%</b> of %%NUMPAGES%%',2027916259),(1614,2,'Shipping info',2462686142),(1615,2,'You paid in',570706577),(1616,2,'Special instructions',3334723224),(1617,3,'Product Image',3970606310),(1618,2,'Download',2171396134),(1619,3,'My Orders',3862370978),(1620,2,'You do not have any orders yet.',3541515099),(1621,2,'Your points:',3852454006),(1622,2,'Account Information',251134918),(1623,2,'Leave blank to preserve current password.',2438360217),(1624,2,'You currently have: ',686869563),(1625,2,'Default Billing Address',2673283087),(1626,2,'Default Shipping Address',2515100435),(1627,2,'Back to My Orders',1600593306),(1628,2,'Summer Cart - Send To Friend',3714655035),(1629,2,'Your Name:',1198176300),(1630,2,'Your Email:',646681000),(1631,2,'Your Friend\'s Email:',2118475349),(1632,2,'Additional Notes:',2458683357),(1633,2,'Send',121738739),(1634,2,'Add to compare list',2380011981),(1635,2,'Remove from compare list',2729119880),(1636,2,'Weight:',3664753648),(1637,2,'Product options',4233714837),(1638,2,'Send to friend',2016129824),(1639,2,'Rate this product',1763323970),(1640,2,'Reviews',2798506643),(1641,2,'Quantity discounts',966531448),(1642,2,'Bundled Products',2155498677),(1643,2,'by',1070322242),(1644,2,'Registration Success',2403360959),(1645,2,'You will shortly receive an e-mail from us confirming your registration.',3287053070),(1646,2,'Please enter your search criteria:',710245342),(1647,2,'Find Products Containing:',474009099),(1648,2,'also search in products details',3028788705),(1649,2,'Product Code:',3275397312),(1650,3,'From',422055502),(1651,3,'To',1107555942),(1652,2,'Product Class:',3334958971),(1653,2,'Modify search',872791843),(1654,2,'PayPal Express Checkout',3676457160),(1655,2,'Confirm Payment',1474342248),(1656,2,'Latest News',2900568731),(1657,2,'RSS 2.0',1988906978),(1658,2,'Subscribe',3930643869),(1659,2,'View all news',1982922322),(1660,2,'Billing Method - Check',3780062704),(1661,2,'Billing Method - Credit Card',2643468480),(1662,2,'Please enter your 3 or 4 digit CVV / CVC code, if available.',2302948229),(1663,2,'Easypay.bg payment note',3242636189),(1664,2,'Payment code',891620106),(1665,2,'Billing Method - Credit / Debit Card',3862000488),(1666,2,'Card Type:',451678722),(1667,2,'Card Start:',2159650956),(1668,2,'(where available)',2759988489),(1669,2,'Issue Number:',3570763641),(1670,2,'(Older Switch cards only. 1 or 2 digits as printed on the card)',1628353965),(1671,2,'Card Issuer:',2358789045),(1672,3,'Cash',2794146439),(1673,2,'Compare Products',4076891506),(1674,2,'Some products in your list cannot be compared.',3434387737),(1675,2,'There are no products in your compare list.',3174868567),(1676,2,'Remove product',723556371),(1677,2,'This product is incompatible.',733929904),(1678,2,'You need to have at least 2 products in your comparison list to see comparison.',356924018),(1679,2,'Show comparison',247356116),(1680,2,'Enter your email to subscribe to %%NEWSLETTERNAME%%:',3027694245),(1681,2,'Please provide a valid email address.',1707695583),(1682,2,'Thank you for subscribing for our newsletter \"%%NEWSLETTERNAME%%\".',116380646),(1683,2,'If you don\'t want to recieve any more e-mails for \"%%NEWSLETTERNAME%%\", please enter your email address below and click \"Unsubscribe\".',1674439883),(1684,3,'Unsubscribe',602980313),(1685,2,'You have successfully unsubscribed.',3231745282),(1686,2,'Your name: (optional)',1195251778),(1687,2,'Write your review:',3340366533),(1688,2,'Rate this product:',2360675507),(1689,2,'Please wait',3397765978),(1690,2,'Create your own wishlist and send it to your friends to let them know what you need.',1435329933),(1691,2,'Type your friends\' e-mails separated by commas to send them your complete wishlist and let them know what you need.',1919431210),(1692,2,'Remove from wishlist',778980276),(1693,2,'Add to wishlist',4076650759),(1694,1,'Access denied.',971690898),(1695,1,'Address successfully created.',206424473),(1696,1,'Address successfully updated.',3931780025),(1697,1,'Address successfully deleted.',1988007368),(1698,1,'Default addresses successfully changed.',3033757558),(1699,1,'My Addresses',337247436),(1700,1,'All access levels',1060537073),(1701,1,'API Account',1643484871),(1702,1,'All statuses',3978665514),(1703,1,'There is no customer with this email address.',910769710),(1704,1,'Box options',974874717),(1705,1,'Unknown',1654365787),(1706,1,'Can\'t delete this type of box.',1214010334),(1707,1,' successfully deleted.',3427545285),(1708,1,'Discounts: ',462477906),(1709,1,' were automatically disabled to prevent unpredicted behaviour.',1969273851),(1710,1,'Coupons: ',893657890),(1711,1,'Checkout module',1286454575),(1712,1,'Store owner',3484844198),(1713,1,'Default country cannot be deleted.',4154148757),(1714,1,'Default country successfully set.',2616533983),(1715,1,'Require Valid City',1673566086),(1716,1,'Available Categories',2626115326),(1717,1,'Selected Categories',158388602),(1718,1,'Available Customer Groups',4192083481),(1719,1,'Selected Customer Groups',1904975299),(1720,1,'Coupon',1662204468),(1721,1,'All coupon types',1223637619),(1722,1,'Currency',2418076265),(1723,1,'Invalid decimal.',799914036),(1724,1,'Default currency successfully set. Currency rates updated.',359110422),(1725,1,'Currency rates updated.',1622119860),(1726,1,'Default currency cannot be deleted.',2777361223),(1727,1,'Default currency cannot be deactivated.',3484117332),(1728,1,'Expired',3606238423),(1729,1,'Symbol Left',2273128141),(1730,1,'Symbol Right',311113914),(1731,1,'Decimal Symbol',2474211846),(1732,1,'Thousands Separator',2412596371),(1733,1,'Number Decimals',2900972917),(1734,1,'Currency rate module',1228535726),(1735,1,'All page types',349111103),(1736,1,'Not current',3673409282),(1737,1,'Current',323882391),(1738,1,'Url cannot be empty.',765567539),(1739,1,'Url already exists.',71930170),(1740,1,'Field is empty.',2992138442),(1741,1,'Customer Group',1428478262),(1742,1,'Default customer group successfully set.',4280560865),(1743,1,'Default customer group cannot be deleted.',916359985),(1744,1,'Customer Group Name',1426270757),(1745,1,'All countries',3972781833),(1746,1,'All customer groups',3326678627),(1747,1,'This email is already registered.',3712848290),(1748,1,'Admin updated number of points.',3309684772),(1749,1,'The guest customer cannot be deleted.',2978604238),(1750,1,'Invalid integer.',3514388826),(1751,1,'First Name',1027349186),(1752,1,'Last Name',2437538009),(1753,1,'Company',2147627219),(1754,1,'Address 1',4175916105),(1755,1,'Address 2',1643003379),(1756,1,'City',2372513034),(1757,1,'State',1649606143),(1758,1,'Phone',2240723161),(1759,1,'Fax',2842594184),(1760,1,'Country ID',1194661543),(1761,1,'State ID',233403792),(1762,1,'Other',412686884),(1763,1,'All discount types',2605367606),(1764,1,'Dynamic page',1724252194),(1765,1,'via php mail() fuction',2245059026),(1766,1,'via SMTP server',3459792051),(1767,1,'None',3751981041),(1768,1,'SSL',2135378647),(1769,1,'TLS',979001145),(1770,1,'Summer Cart test email',1928099550),(1771,1,'Data updated but couldn\'t send email to %s. Please check the setup.',2494957135),(1772,1,'Data updated and email was successfully sent to %s.',3429979993),(1773,1,'Featured product',281341089),(1774,1,'Featured in',987936391),(1775,1,'HOME',1195630948),(1776,1,'This product is already featured.',1544782654),(1777,1,'Create a product first.',2447820944),(1778,1,'Form',4072297073),(1779,1,'Confirm text',3294903477),(1780,1,'Enable captcha',3336299507),(1781,1,'No images selected.',1891647104),(1782,1,'Successfully imported %d images.',2519533548),(1783,1,'Gallery item',4021789044),(1784,1,'Text',2612594937),(1785,1,'No file uploaded.',1954655468),(1786,1,'Error during upload (error code %d).',1324475515),(1787,1,'Cannot open file %s.',311012738),(1788,1,'Import failed! Reason: ',506301268),(1789,1,'Partial success. %d products imported, %d products updated. Import stopped on line #%d with message: ',1073345337),(1790,1,'Import successful.',468324764),(1791,1,'All found images imported successfully.',2100858350),(1792,1,'Unknown header \"%s\".',765083125),(1793,1,'Unable to copy \"%s\" to \"%s\".',3929581076),(1794,1,'Product with SKU \"%s\" already exists!',829264720),(1795,1,'Category \"%s\" not found.',2438984671),(1796,1,'Default Layout not set.',1582254705),(1797,1,'Manufacturer \"%s\" not found.',4089697667),(1798,1,'Product class \"%s\" not found.',1044163623),(1799,1,'System requirements',3633141250),(1800,1,'License',2564148613),(1801,1,'Directory permissions',709512653),(1802,1,'Not approved',93151306),(1803,1,'Approved',2233580107),(1804,1,'Successfully updated language texts.',2644336511),(1805,1,'Default language successfully set.',3414354415),(1806,1,'Default language cannot be deleted.',3507618035),(1807,1,'Default language cannot be deactivated.',2655559150),(1808,1,'Could not create language pack.',784760254),(1809,1,'The uploaded file is too large (%s bytes).',445195722),(1810,1,'Please upload file.',2015382419),(1811,1,'You should upload language pack file (.zip).',1207227239),(1812,1,'Error processing \"%s\": %s',2956520505),(1813,1,'Cound not find langpack.xml in the language pack archive.',1061572800),(1814,1,'Language with code \"%s\" already exists.',2677450897),(1815,1,'Cannot find image file \"%s\" in the language pack archive.',2697320117),(1816,1,'Uploaded XLIFF filename \"%s\" is invalid.',1441564075),(1817,1,'Error uploading the file: %s (error code %s).',4057922485),(1818,1,'Internal error.',342401503),(1819,1,'The uploaded file is empty.',1897767757),(1820,1,'You should upload translation file (.xlf).',4151929386),(1821,1,'%d%% translated',3838021215),(1822,1,'Direction',3166393104),(1823,1,'Language Pack Author',778796279),(1824,1,'Language Pack Description',1079379558),(1825,1,'Language Pack License',3785170304),(1826,1,'Language Pack Publish Date',3589568588),(1827,1,'Available',662578726),(1828,1,'Top',647256362),(1829,1,'Left',3663022166),(1830,1,'Right',1963678224),(1831,1,'Bottom',2398320530),(1832,1,'Failed to save boxes layout: ',3685643230),(1833,1,'Default layout successfully changed.',3119399505),(1834,1,'To delete this layout, no dynamic pages, categories or rich text pages should refer to it.',1593855280),(1835,1,'All categories',3959000229),(1836,1,'All severities',716071528),(1837,1,'Please enter username and password!',2142461233),(1838,1,'Invalid username and/or password. Please try again.',1315737212),(1839,1,'Your account has been disabled.',2495292229),(1840,1,'Menu item',774316269),(1841,1,'Option group',3060702529),(1842,1,'Order status',3130920691),(1843,1,'This status cannot be disabled.',706177376),(1844,1,'Sending notifications for this status cannot be disabled.',4262583638),(1845,1,'Cannot delete predefined order status \"%s\".',1148841405),(1846,1,'There are orders with status \"%s\". You cannot delete it.',2909636378),(1847,1,'Order total module',437395479),(1848,1,'Subtotal must always precede other order total modules.',4087417155),(1849,1,'Selected order deleted successfully!',2472366501),(1850,1,'Order statuses updated successfully!',1258584605),(1851,1,'Order not found.',2277936408),(1852,1,'Error occured: %s',1060205392),(1853,1,'You can not bulk print PDF packing slips.',2255065229),(1854,1,'Note too short.',1534955588),(1855,1,'Note added successfully, but problem occurred when sending the note email.',884912915),(1856,1,'Note added successfully, but there is no customer email.',1847838487),(1857,1,'Note added successfully, but the order department email is not set.',2924919114),(1858,1,'Note added successfully.',2680044958),(1859,1,'Error occurred while adding the note.',2978673432),(1860,1,'Note deleted successfully.',3269079827),(1861,1,'Credit card number and CVV discarded successfully.',3735730144),(1862,1,'Unable to display the e-goods.',2256931719),(1863,1,'Unable to send e-goods notification e-mail.',67482292),(1864,1,'E-Goods notification email sent successfully.',3667787196),(1865,1,'Error occurred while sending e-goods notification email: \"%s\".',1170936893),(1866,1,'E-Good status successfully updated.',3304927357),(1867,1,'Cannot find payment module.',2005744939),(1868,1,'Exception: ',64071581),(1869,1,'Unknown operation.',1840034131),(1870,1,'Payment module',4267206052),(1871,1,'Plugin successfully installed.',1419919011),(1872,1,'PHP extension ZIP is not installed. Please contact your hosting provider to enable it.',762253123),(1873,1,'Cannot read ZIP archive. Error %d: %s',1983809766),(1874,1,'Could not create folder \"%s\"',2476158058),(1875,1,'File \"%s\" already exists.',2932655328),(1876,1,'Cannot open ZIP archive entry.',3392287738),(1877,1,'The uploaded file is not an image.',3525337433),(1878,1,'Cannot save the uploaded file!',3648249677),(1879,1,'Please upload an image.',3068422154),(1880,1,'Select a Category',2833957309),(1881,1,'All manufacturers',3705767946),(1882,1,'All product classes',998618569),(1883,1,'A product bundle must have subproducts.',895607553),(1884,1,'All bundled products must have a minimum quantity of 1.',1452315037),(1885,1,'A product bundle can contain other bundles but cannot contain itself.',2642524106),(1886,1,'A product bundle cannot have variant options.',4060421234),(1887,1,'Invalid number.',4111963927),(1888,1,'Create a category first.',2418193025),(1889,1,'Product Is E-Good',3039632037),(1890,1,'Class',747255451),(1891,1,'Quick link',3465050114),(1892,1,'Unknown Report',299357700),(1893,1,'Rich text page',3938568113),(1894,1,'Content',829950261),(1895,1,'Shipping module',3046866235),(1896,1,'This shipping module must have one instance and cannot be added.',3465572544),(1897,1,'Shipping module successfully created. Please setup the module.',3580000547),(1898,1,'This shipping module must have one instance and cannot be deleted.',695430002),(1899,1,'Shipping zone',4188760814),(1900,1,'Available Countries',2501974536),(1901,1,'Selected Countries',3723238592),(1902,1,'Available States',3554809502),(1903,1,'Selected States',1478574432),(1904,1,'Cannot create directory \"%s\".',521597972),(1905,1,'Skin selection',3947037298),(1906,1,'Skin location \"%s\" is not a valid directory.',3732254855),(1907,1,'Skin description \"%s\" not found.',31452408),(1908,1,'Unable to read skin description \"%s\".',1311354019),(1909,1,'The skin \"%s\" is for another version of the software.',3052803159),(1910,1,'Automatically installed %d skin(s).',548770039),(1911,1,'Cannot read \"skin.xml\".',4139653556),(1912,1,'Skin installed successfully.',2887437011),(1913,1,'Activate',1326475003),(1914,1,'State Code',1998283438),(1915,1,'Tax class',649384201),(1916,1,'Tax rates',2401985450),(1917,1,'You need to define tax classes and tax zones first.',2273774407),(1918,1,'Tax zone',1049680567),(1919,1,'Tax',3066887318),(1920,1,'Coupon applied.',2848081516),(1921,1,'Coupon removed.',2659381137),(1922,1,'Cannot find category.',612906988),(1923,1,'Unknown module name: \"%s\".',3760882688),(1924,1,'You are not allowed to view order %d!',1658215604),(1925,1,'Checkout Final',2072252968),(1926,1,'The page that you have requested cannot be found. You will be redirected to the home page in 2 seconds.',567520697),(1927,1,'Please enter email.',1365745153),(1928,1,'Email not found. Please try again.',35798503),(1929,1,'Your password has been sent to %s. Please check your mail.',478502169),(1930,1,'You have already changed your password.',4210502971),(1931,1,'Passwords mismatch.',2736803437),(1932,1,'View form failed: ',500224504),(1933,1,'Security code does not match.',2067417858),(1934,1,'Cannot find gallery.',4247598002),(1935,1,'Access denied! This operation is disallowed in Summer Cart demo.',2939161884),(1936,1,'Module option \"%s\" is not set. Please setup \"%s\" module.',2851240815),(1937,1,'No print fields selected.',3794871534),(1938,1,'item',521872670),(1939,1,'items',3776899405),(1940,1,'Category views',3469939714),(1941,1,'Product sales',2211971065),(1942,1,'Product views',4188410682),(1943,1,'You cannot delete the account you are currently logged in with.',3800588496),(1944,1,'You cannot limit and/or disable the only full access account.',246908558),(1945,1,'There are customers having their billing and/or shipping address in this country.',4197307457),(1946,1,'Rich Text Page',3355634220),(1947,1,'Dynamic Page',3337924380),(1948,1,'Customer\'s last address cannot be deleted.',4060101575),(1949,1,'To delete this customer group, no customers should be assigned to it.',976736592),(1950,1,'File \"%s\" not found.',3520615993),(1951,1,'Could not create gallery directory.',3326180459),(1952,1,'Could not create gallery images directory.',1961186936),(1953,1,'Could not create gallery thumbnails directory.',2776549596),(1954,1,'Gallery renaming failed: duplicate directory name.',2733256268),(1955,1,'Gallery renaming failed.',3209771303),(1956,1,'Left-to-right',821124640),(1957,1,'Right-to-left',609036854),(1958,1,'You cannot disable the only active language.',2495182195),(1959,1,'Menu ',1104553861),(1960,1,'Could not send new order email for order %s.',3544640745),(1961,1,'New order',1966796274),(1962,1,'Based on spent amount for order %s.',2188138777),(1963,1,'Referred customer %s.',1252764064),(1964,1,'Maximum number of downloads reached.',2216265504),(1965,1,'E-Good download link has expired.',3487080762),(1966,1,'E-Good is locked.',2021271368),(1967,1,'There are products of this product class.',46009503),(1968,1,'Product \"%s\" found as bundled product. This would cause recursive dependency.',2066183052),(1969,1,'Original image not found. Product ID: %s.',2372983258),(1970,1,'Original variant image not found. Product ID: %s',2699549413),(1971,1,'To delete this shipping zone, no shipping modules should refer to it.',741113889),(1972,1,'This Month',672387575),(1973,1,'Last Month',2551559645),(1974,1,'This Year',2719278482),(1975,1,'Last Year',1961422312),(1976,1,'Copying e-good file failed.',3576125411),(1977,1,'Moving e-good files failed.',1440618055),(1978,1,'Duplicating image failed: ',2751018395),(1979,1,'Failed to delete image \"%s\".',1885574410),(1980,1,'Thumb copying from \"%s\" to \"%s\" failed.',3854097274),(1981,1,'Image copying from \"%s\" to \"%s\" failed.',942111230),(1982,1,'Unknown (%s)',2928828387),(1983,1,'Payment Module ',4153723213),(1984,1,'Page Views / Unique Visits',3102305494),(1985,1,'Page Views',60420241),(1986,1,'Unique Visitors',3328718076),(1987,1,'Number of orders',3589852710),(1988,1,'Customer country',769758617),(1989,1,'Shipping costs',1989299678),(1990,1,'Payment costs',2975766011),(1991,1,'Number of items',2211629218),(1992,1,'Category Name',3178665876),(1993,1,'-Empty name-',1617569995),(1994,1,'Day',3723325296),(1995,1,'Week',4217947902),(1996,1,'Month',1333214978),(1997,1,'Quarter',3543980187),(1998,1,'Year',464575497),(1999,1,'Summary',26566655),(2000,1,'Daily',1331463278),(2001,1,'Weekly',1500557074),(2002,1,'Monthly',622395140),(2003,1,'Quarterly',3153405383),(2004,1,'Yearly',4293902794),(2005,1,'Jan',1419823037),(2006,1,'Feb',811644918),(2007,1,'Mar',1173261687),(2008,1,'Apr',523065091),(2009,1,'May',3527169279),(2010,1,'Jun',2047742184),(2011,1,'Jul',2483057092),(2012,1,'Aug',260523949),(2013,1,'Sep',3644106533),(2014,1,'Oct',2638192302),(2015,1,'Nov',3729185465),(2016,1,'Dec',1155748622),(2017,1,'Curl request failed for \"%s\". Response code \"%d\".',1571557308),(2018,1,'File \"%s\" is not an image.',3673143881),(2019,1,'Image copying failed.',1325301612),(2020,1,'Invalid image format.',606702645),(2021,1,'Image resizing failed.',3243865366),(2022,1,'The destination directory \"%s\" cannot be created.',4273361783),(2023,1,'\"%s\" is not a directory.',4017556963),(2024,1,'\"%s\" is not writable.',2065388674),(2025,1,'Image write error.',134666524),(2026,1,'Summer Cart is not licensed for this website. Please obtain a valid license.<br/><a href=\"http://www.summercart.com/\" target=\"_blank\">Buy License</a> | <a href=\"license.php\">License Info</a>',4057668941),(2027,1,'Summer Cart is not activated. The store functionality will be limited.<br/> <a href=\"#\">Activate Now</a>',1659361011),(2028,1,'Summer Cart has been activated for another server. The store functionality will be limited.<br/> <a href=\"#\">Reactivate Now</a>',3301984207),(2029,1,'Folder \"%s\" cannot be created. You might not be able to upload images. <a href=\"#\">Help</a>',687696898),(2030,1,'Folder \"%s\" is not writable. You might not be able to upload images. <a href=\"#\">Help</a>',2187267186),(2031,1,'Cannot write to \"%s\". Your e-goods will not be secure. <a href=\"#\">Help</a>',10074882),(2032,1,'PHP version is too old. Summer Cart needs at least PHP version 5.1.',1322276977),(2033,1,'Safe mode must be off.',1035921460),(2034,1,'php.ini option file_uploads must be on.',79325551),(2035,1,'PHP extension \"%s\" is required.',1349081457),(2036,1,'GIF support is required.',3687500167),(2037,1,'JPEG support is required.',3476745476),(2038,1,'PNG support is required.',4096294307),(2039,1,'Expires today',3083089325),(2040,1,'Expires in 1 day',1362021340),(2041,1,'Expires in %d days',3637722135),(2042,1,'Critical',2922609053),(2043,1,'Warning',2415109466),(2044,1,'Debug',2909038755),(2045,1,'Currency rates',606498454),(2046,1,'Directory %s does not exist!',1565131615),(2047,1,'Directory %s is not writtable!',2084164920),(2048,1,'The free disk space is low. You have %s bytes free space (%2.2f%% of total).',2728886836),(2049,1,'Registered customers only',934284482),(2050,1,'Only customers that have bought the product',3415746634),(2051,1,'No one',3136150270),(2052,1,'(page %s of %s)',2302751552),(2053,1,'Disabled',2106068149),(2054,1,'Limited',387805115),(2055,1,'Full Access',129195397),(2056,1,'Product Class Attribute',4247900106),(2057,1,'Product Class Attribute Value',2185697575),(2058,1,'Product Attribute',1070217018),(2059,1,'Bundle Product',1377533868),(2060,1,'Local Option',1481202745),(2061,1,'Customer Address',3160476386),(2062,1,'Cleartext',95021649),(2063,1,'Secure one-way hash (salted HMAC-SHA1)',2243593445),(2064,1,'Products Option Groups',413329838),(2065,1,'Import / Export',1885055086),(2066,1,'Logs',1354590562),(2067,1,'Locations and Taxes',2361144370),(2068,1,'Store Configuration',2906653211),(2069,1,'Languages and Currencies',1427690073),(2070,1,'You already used a coupon.',3174898911),(2071,1,'Not all conditions for this coupon are met.',2890332796),(2072,1,'Coupon module is not active.',3958051832),(2073,1,'\"%s\" is only available for registered customers.',1988732736),(2074,1,'You have insufficient bonus points.',1249500137),(2075,1,'Retrieving weight of intangible item.',1845102359),(2076,1,'There are only %d \"%s\" left.',2519874081),(2077,1,'\"%s\" is out of stock.',2892561836),(2078,1,'Invalid product option.',3298488485),(2079,1,'Only image uploads are accepted.',2386879254),(2080,1,'Please upload image.',2166328991),(2081,1,'Please enter text.',1518930363),(2082,1,'Invalid product.',3997504040),(2083,1,'Invalid product variant.',2082714463),(2084,1,'Order total module exception: \"%s\".',4244972103),(2085,1,'Products & Categories',4043964841),(2086,1,'Languages & Currencies',3474686068),(2087,1,'Product List',178379105),(2088,1,'Import/Export Catalog',3045310965),(2089,1,'Pages',3786787441),(2090,1,'Reports Center',2808863634),(2091,1,'Skin Settings',4255372828),(2092,1,'Import Images',853338739),(2093,1,'Customers Countries',3263330688),(2094,1,'Order Payment Methods',1894666010),(2095,1,'Order Shipping Methods',1441221385),(2096,1,'System Box',2170361627),(2097,1,'Menu Box',1651446388),(2098,1,'XHTML Box',1127429936),(2099,1,'Newsletter Box',653914245),(2100,1,'Base',1619415391),(2101,1,'Multiline Text',1124959784),(2102,1,'Checkbox',3876416187),(2103,1,'Radio Buttons',1938514344),(2104,1,'Drop-Down List',3636078245),(2105,1,'Specific',3199764228),(2106,1,'Number',2436635234),(2107,1,'File upload',857141173),(2108,1,'Custom HTML',3531875685),(2109,1,'Header',1776201207),(2110,1,'Separator',352538411),(2111,1,'No image',544785870),(2112,1,'Predefined image',512670514),(2113,1,'Custom image',3832912090),(2114,1,'Skin not found.',3895991404),(2115,1,'Skin location \"%s\" is invalid.',2914208189),(2116,1,'Cannot find column template!',3366602241),(2117,1,'Box',820252378),(2118,1,'Fast Menu',658583250),(2119,1,'Footer',3852271717),(2120,1,'Missing CMSBoxID when getting box menu items!',3221496229),(2121,1,'Currency not found.',3863017503),(2122,1,'Cannot update rate for %s to %s.',317351350),(2123,1,'Error from module \"%s\": %s.',720872515),(2124,1,'Cannot find default currency.',21006379),(2125,1,'Money only',998958233),(2126,1,'Points and money',1825210422),(2127,1,'Points only',2478440028),(2128,1,'Earn',1939374383),(2129,1,'Spend',756222009),(2130,1,'Pending',459817765),(2131,1,'7 days',2749143752),(2132,1,'30 days',201091938),(2133,1,'Return points.',3799853467),(2134,1,'Guest customer not found.',3112438038),(2135,1,'Free Shipping',4288268905),(2136,1,'Per product',1307767082),(2137,1,'Per product quantity',4195381753),(2138,1,'To subtotal',3695383545),(2139,1,'Information for product',3085648491),(2140,1,'Unknown product id \"%s\".',3772192490),(2141,1,'Signup notification',3659740162),(2142,1,'Form: %s',1447205245),(2143,1,'Cannot send new order notification - customer email is missing.',2968891335),(2144,1,'Cannot send new order notification - customer and administrator emails are missing.',3772435740),(2145,1,'Thank you for ordering!',671016963),(2146,1,'Your order will be fulfilled as soon as possible.',2462374820),(2147,1,'New order #',2383097839),(2148,1,'No E-Goods to send.',1274645748),(2149,1,'Cannot deliver E-Goods - customer email is missing.',2159688091),(2150,1,'E-Goods delivery for order #%s',1190481691),(2151,1,'Administrative note for order #',3563440502),(2152,1,'Order status changed to \"%s\".',1532224661),(2153,1,'Order #%s status changed',1115676460),(2154,1,'No error.',2925959239),(2155,1,'File size exceeds the upload_max_filesize directive in php.ini.',1323556796),(2156,1,'The uploaded file exceeds the maximum upload file size.',2000894469),(2157,1,'The uploaded file was only partially uploaded.',2774220693),(2158,1,'Missing temporary folder.',3406465656),(2159,1,'Failed to write file to disk.',2410278471),(2160,1,'File upload stopped by extension.',2302500411),(2161,1,'Unknown error.',4225751778),(2162,1,'GB',1714678657),(2163,1,'MB',2631664395),(2164,1,'KB',3397821581),(2165,1,'Default language is not set!',1952198132),(2166,1,'Expected target language code \"%s\", but found \"%s\".',2963564181),(2167,1,'Could not find langauge with language code %s.',1065373100),(2168,1,'Unknown option field %s.',2347183978),(2169,1,'Invalid module classes definitions.',2761744303),(2170,1,'Cannot find implementation for %s, ModuleID %s.',2298128384),(2171,1,'Trying to load class \"%s\" that does not exist.',3245286568),(2172,1,'Trying to load class \"%s\" that have ambiguous name.',3238758531),(2173,1,'Cannot find module file %s.',1847543081),(2174,1,'Cannot find module class %s in file %s.',279504134),(2175,1,'Module not found.',2556760663),(2176,1,'Cannot load shipping module id %s. Error: \"%s\".',988886446),(2177,1,'Reserve quantities',3288027779),(2178,1,'Do nothing',2972889638),(2179,1,'Return quantities to stock',3524378733),(2180,1,'Cannot find shipping module with ShippingModuleID \"%s\"!',2090210153),(2181,1,'Cannot find shipping module name for ShippingModuleID \"%s\".',4143372495),(2182,1,'Unknown shipping method \"%s\" for shipping module \"%s\".',907459679),(2183,1,'Cannot find payment module with PaymentModuleID \"%s\".',3983654493),(2184,1,'Cannot find checkout module with CheckoutModuleID \"%s\".',4154823801),(2185,1,'No address',2306327481),(2186,1,'Not applicable',809146176),(2187,1,'Unavailable',4005971042),(2188,1,'Unavailable - timeout',2198393684),(2189,1,'Not supported',38979051),(2190,1,'No match',2669544596),(2191,1,'Zip match',2574025683),(2192,1,'Street match',2709164901),(2193,1,'Full match',3130867008),(2194,1,'Intl - not supported',160801151),(2195,1,'Intl - no match',3331178104),(2196,1,'Intl - postal code match',1232421026),(2197,1,'Intl - street match',3183552170),(2198,1,'Intl - full match',1675788961),(2199,1,'Match',3147491841),(2200,1,'Not available',1358543466),(2201,1,'Not submitted',3882939189),(2202,1,'US Checks',3812260290),(2203,1,'UK Checks',1281643356),(2204,1,'Checking',2135669230),(2205,1,'Savings',3720111745),(2206,1,'ABA Routing Number:',1093252924),(2207,1,'Sort Code:',784571595),(2208,1,'Processing payment exception: ',2460243919),(2209,1,'Details:',3764852828),(2210,1,'Redirecting to payment processor...',645800559),(2211,1,'Payment Process',2908525122),(2212,1,'Currency code mismatch.',2245602422),(2213,1,'OrderID',250637667),(2214,1,'Received currency',2063252635),(2215,1,'Expected currency',556738789),(2216,1,'Payment amount mismatch.',465800015),(2217,1,'Received amount',2554316093),(2218,1,'Expected amount',2038651890),(2219,1,'Missing param \"%s\".',2285410388),(2220,1,'Pending payment info from processor',1744188893),(2221,1,'Declined',2515268484),(2222,1,'Auth',1491869543),(2223,1,'Partial Refund',1611532643),(2224,1,'Chargeback',514019258),(2225,1,'Offline',396418990),(2226,1,'Partial Capture',986607068),(2227,1,'Cannot find OrderID with TransactionCode=%s and ModuleID=%s.',423320567),(2228,1,'Multi-Language Text',1090077381),(2229,1,'Multiple Select',4047669267),(2230,1,'No validator',844974025),(2231,1,'Not selected',3782412241),(2232,1,'Price modifier',729257526),(2233,1,'Variant',1056867889),(2234,1,'User Image',1394044103),(2235,1,'User Text',407613837),(2236,1,'Cannot find product.',2480034857),(2237,1,'Keep selling',3801695625),(2238,1,'Hide product',529233592),(2239,1,'\"Out of stock\" tag',2922029292),(2240,1,'Sort by relevance',298651342),(2241,1,'Sort by price (low to high)',4236668364),(2242,1,'Sort by price (high to low)',2206108970),(2243,1,'Sort by product name',1594729176),(2244,1,'Sort by product code',1983638598),(2245,1,'Kgs',1614702293),(2246,1,'Lbs',403080213),(2247,1,'SEO Keywords',1281633745),(2248,1,'SEO Description',2401170763),(2249,1,'Billing first name',1856554936),(2250,1,'Billing last name',779633653),(2251,1,'Billing company',3643031354),(2252,1,'Shipping first name',569783891),(2253,1,'Shipping last name',2944137814),(2254,1,'Shipping company',3417896906),(2255,1,'Product code',2572074719),(2256,1,'Order Status',3174173637),(2257,1,'Cannot find tax record.',256217995),(2258,1,'Invalid VAT number.',3634676075),(2259,1,'There are errors with the form below.<br/>Please correct them and resubmit.',1961341087),(2260,1,'There is an error with the form below.<br/>Please correct it and resubmit.',3020941352),(2261,1,'Previous',4223270794),(2262,1,'%d more address',2991817930),(2263,1,'%d more addresses',1268737845),(2264,1,'First',1404092755),(2265,1,'Last',3941140126),(2266,1,'Records per page',2072815210),(2267,1,'Choose',2286432583),(2268,1,'No minValue property is specified for field %s.',2261280103),(2269,1,'The value must be no smaller than %d.',374970102),(2270,1,'No maxValue property is specified for field %s.',2961549300),(2271,1,'The value must be no bigger than %d.',1003243756),(2272,1,'Invalid email format.',217690918),(2273,1,'Not unique.',3322238850),(2274,1,'Invalid http url.',1411741488),(2275,1,'\"existsIn\" property must be specified for field %s.',2233986892),(2276,1,'Record does not exist.',290530147),(2277,1,'The selected currency is not defined. You can define new currencies using the Currencies management screen.',3176614794),(2278,1,'A shipping method has to be selected.',4140752483),(2279,1,'Value cannot be empty.',3613250963),(2280,1,'Please enter a valid city name.',2108643981),(2281,1,'Record',2627246759),(2282,1,'%s successfully created.',3688544399),(2283,1,'%s successfully updated.',1036862127),(2284,1,'%s successfully deleted.',2716460254),(2285,1,'Names are required to be set for all active menus.',4031308951),(2286,1,'-- Top Level --',3847004789),(2287,1,'\"%s\" can only be bought using points.',2880630370),(2288,1,'There are no available billing methods for your order!',3619229128),(2289,1,'Unknown billing method selected.',1923584595),(2290,1,'From %s: %s.',3416367529),(2291,1,'Exception \"%s\".',3519133715),(2292,1,'Free',3978063606),(2293,1,'Notices:<br/>',2241996831),(2294,1,'There are no available shipping methods for your order!',3749391800),(2295,1,'Invalid date format.',2905832602),(2296,1,'This module has no options.',238049363),(2297,1,'Options template file not set.',2376570436),(2298,1,'Too many control variables.',489853662),(2299,1,'Any',1556001108),(2300,1,'Invalid quantity.',1890732172),(2301,1,'Duplicate quantity.',3503465937),(2302,1,'Invalid amount.',31134505),(2303,1,'First row quantity must be 1.',2806581010),(2304,1,'Delete Image',2163897815),(2305,1,'Country and VAT number country do not match. Your VAT number should start with %s.',3094486824),(2306,1,'Cart must contain at least one item.',2455112543),(2307,1,'Error processing your request: ',462582378),(2308,1,'Wizard exception: ',3823642818),(2309,1,'Please enter e-mail and password.',2254663015),(2310,1,'Cannot find manufacturer.',3161538148),(2311,1,'Module not found: ',844478805),(2312,1,'Merchat ID or Merchant Key do not match.',4204349676),(2313,1,'Google Checkout Exception: ',4278307332),(2314,1,'Tax zone \"%s\" cannot be used in Google Checkout.',694481955),(2315,1,'Google Checkout supports only one tax class per product.',2467941403),(2316,1,'Google Checkout error: \"%s\".',1909915985),(2317,1,'Production',2628825648),(2318,1,'Sandbox',693618939),(2319,1,'Shipping cost currency mismatch. Expected \"%s\", found \"%s\".',345221533),(2320,1,'Tax currency mismatch. Expected \"%s\", found \"%s\".',1078094406),(2321,1,'New fulfillment state: %s.',2593546886),(2322,1,'Eligible for protection: %s.',2169159268),(2323,1,'Account age: %d days.',1298284562),(2324,1,'IP address: ',2810099095),(2325,1,'Total: %s %s',3604752062),(2326,1,'Auth Expiration %s',2492447259),(2327,1,'Unknown Google Checkout notification: %s',923861602),(2328,1,'Unknown payment status.',3951170399),(2329,1,'Order already paid.',3594121633),(2330,1,'Static',2272013587),(2331,1,'Dynamic',2216047400),(2332,1,'PayPal notification validation failed.',3895911047),(2333,1,'Result',348570661),(2334,1,'Test IPN to live system.',4022760396),(2335,1,'Invalid username or password.',981519419),(2336,1,'Exception during login: ',3232414853),(2337,1,'Passwords do not match!',1381658824),(2338,1,'Exception during register: ',2004258259),(2339,1,'Guest checkout is not enabled.',171087513),(2340,1,'Exception during checkout: ',69326121),(2341,1,'Proceed to payment',1685420733),(2342,1,'Finalize order',1513996144),(2343,1,'Please agree to the terms.',334391769),(2344,1,'Exception during processing payment: ',3217002174),(2345,1,'New address',635515012),(2346,1,'C.O.D. fee',2416563426),(2347,1,'Coupon %s',1686551835),(2348,1,'Invalid coupon.',2012040438),(2349,1,'%s bonus points',1084554444),(2350,1,'Invalid ShippingModuleID.',1440107854),(2351,1,'Exception from shipping module %s: %s.',1351567222),(2352,1,'No shipping rates for the selected shipping module %s.',2979398362),(2353,1,'No shipping rate for the selected shipping method \"%s\". Shipping module \"%s\".',1671436555),(2354,1,'Subtotal',1105882322),(2355,1,'Tax %s',901155661),(2356,1,'Invalid 2Checkout key. Please check you Secret Word.',1508301426),(2357,1,'Order in demo mode.',2161169993),(2358,1,'Unknown processing code.',2749440435),(2359,1,'Processing Code',3886614059),(2360,1,'Payment cancelled by customer.',4170617483),(2361,1,'Payment failed.',618085942),(2362,1,'Processing error.',779453244),(2363,1,'Response Code',3011160535),(2364,1,'Response Subcode',2833827248),(2365,1,'Response Reason Text',3449546607),(2366,1,'Response Reason Code',2164617264),(2367,1,'MD5 Hash does not match.',1110416711),(2368,1,'Live',4080894865),(2369,1,'Demo',1987080350),(2370,1,'Developer',3876194617),(2371,1,'Store owner country not set.',1620695427),(2372,1,'Store owner city not set.',713582701),(2373,1,'Store owner company name not set.',2283940953),(2374,1,'Administrator email address not set.',4104488403),(2375,1,'Two private keys and CSRs generated.',2870212386),(2376,1,'Error generating key: ',3054805519),(2377,1,'Private key and CSR generated.',72922377),(2378,1,'Generate key first.',1428422942),(2379,1,'Invalid certificate.',1631500600),(2380,1,'OK',3610695981),(2381,1,'Cannot verify Borica signature. The message was corrupted or the store certificate is invalid.',196033053),(2382,1,'Terminal ID (TID) does not match.',1074052831),(2383,1,'Unknown response code: %s.',2033581598),(2384,1,'Success.',3533853291),(2385,1,'Network error.',2631704872),(2386,1,'Foreign network failure.',3318243894),(2387,1,'Time-out at IEM.',2557496871),(2388,1,'Transaction failed.',3849667764),(2389,1,'Reversal already placed.',3104815222),(2390,1,'Duplicate transaction.',3300264337),(2391,1,'Unsuccessful 3D auth.',76042179),(2392,1,'Canceled transaction.',3156081746),(2393,1,'Invalid message signature.',3980295143),(2394,1,'Reversal failed.',1551420085),(2395,1,'Funds refunded successfully.',2846181355),(2396,1,'Test payment.',2031090396),(2397,1,'Invalid routing number.',1558229877),(2398,1,'Invalid sort code.',3153024680),(2399,1,'Please enter the account number.',3499759594),(2400,1,'Please enter the bank name.',993638850),(2401,1,'Please enter the name on account.',3597456143),(2402,1,'You exceeded the Collect On Delivery payment limit. Maximum amount is %d %s.',2868789593),(2403,1,'Please enter the name on card.',1440228075),(2404,1,'Invalid card number.',3119284692),(2405,1,'Invalid expiration date.',3231650341),(2406,1,'Invalid CVV code.',1390469070),(2407,1,'Unknown payment status %s.',4234528552),(2408,1,'MD5 signature not enabled in your DSK account. Please contact DSK.',1492592544),(2409,1,'Merchant does not match.',3194788682),(2410,1,'Simulator',53661188),(2411,1,'Required OrderID parameter is missing.',2645749437),(2412,1,'Pay time: %s, Borica code %s.',3784136527),(2413,1,'Pay time: %s.',40437855),(2414,1,'Payment expired.',2535456934),(2415,1,'Notification.',3332691567),(2416,1,'Error occured.',3954423699),(2417,1,'Could not find IDN.',3415975849),(2418,1,'Invalid return from proccessor.',690338763),(2419,1,'Unknown currency code.',2595626995),(2420,1,'Moneris payment module is not set up correctly.',1820587442),(2421,1,'Payment cancelled.',239591290),(2422,1,'Moneris transaction verification failed.',145849291),(2423,1,'Invalid security verification. Check your SHA-1-OUT signature.',2181488235),(2424,1,'Sale',1165586235),(2425,1,'Funds captured successfully.',3583367802),(2426,1,'Authorization voided successfully.',941378614),(2427,1,'Funds reauthorized successfully.',800552064),(2428,1,'Please enable Payment Data Transfer.',3761312504),(2429,1,'Error verifing Payment Data Transfer. Please check your PDT identity token. %s',3157827527),(2430,1,'Return to merchant',1433195732),(2431,1,'Invalid response from Realex. Please contact the owner of the store.',956808071),(2432,1,'Enabled',2672067096),(2433,1,'Successful',711999057),(2434,1,'Declined by Bank',3540366563),(2435,1,'Referral by Bank',248552064),(2436,1,'Card reported lost or stolen',3201209846),(2437,1,'Error with bank systems',2261189006),(2438,1,'Error with Realex Payments systems',1750758678),(2439,1,'Incorrect XML message formation or content',2970791877),(2440,1,'Client deactivated',1620246495),(2441,1,'Invalid start date.',1245642798),(2442,1,'Invalid issue number.',1860431565),(2443,1,'Error status from Sage Pay: %s (%s).',841623692),(2444,1,'Invalid data from Sage Pay.',1452716031),(2445,1,'Do not send',3234925912),(2446,1,'Send to customer and vendor',1915472064),(2447,1,'Send to vendor only',1798404581),(2448,1,'There are no active banks.',3178107275),(2449,1,'Other card issuer',2966302554),(2450,1,'Hash signature is incorrect. Please check your store key.',1045070230),(2451,1,'3D authentication failed. Reason: %s',1106862291),(2452,1,'Bank options updated successfully.',1528080076),(2453,1,'Please configure the bank before activating it.',3456911010),(2454,1,'Bank deactivated successfully.',989631439),(2455,1,'Bank activated successfully.',3104487354),(2456,1,'PreAuth: Authorize only',112362174),(2457,1,'Invalid number of installments.',3694170451),(2458,1,'Invalid interest rate.',2580567245),(2459,1,'Dublicated number of installments.',3698181533),(2460,1,'UBB.bg error: %s.',2682797684),(2461,1,'UBB module is not set up.',304847185),(2462,1,'Error from ubb.bg: \"%s\"',2200299116),(2463,1,'Purchase',2556539757),(2464,1,'Please use the setup wizard.',4173210494),(2465,1,'No terminal aliases found.',2759125876),(2466,1,'Success! Terminal aliases found: %s.',2134707015),(2467,1,'Please setup Canada Post merchant ID first.',3807098547),(2468,1,'Digital Delivery',371692282),(2469,1,'Invalid e-Econt username/password.',3892566628),(2470,1,'Missing product in order number: %s.',3131417127),(2471,1,'Missing product variant in order number: %s.',89269609),(2472,1,'Order %s has zero total weight.',2104340469),(2473,1,'Missing payment module in order number: %s',1827194367),(2474,1,'Connection Error.',2708038800),(2475,1,'Invalid request.',645570083),(2476,1,'Door',718797587),(2477,1,'Office',1945988660),(2478,1,'Credit',460155848),(2479,1,'Invalid city.',947161889),(2480,1,'Invalid zip.',525438188),(2481,1,'City and zip do not match.',3674152100),(2482,1,'Phone is not valid - digits only, multiple numbers are seperated with \",\".',1338961600),(2483,1,'Please setup FedEx Account Number first.',1559384534),(2484,1,'Flat Rate Shipping',1943503702),(2485,1,'You are not authorized to perform this operation.',4287710637),(2486,1,'Please enter username and password.',4010557600),(2487,1,'Could not authenticate to Speedy.',2013728466),(2488,1,'Please choose parcels count',2717330026),(2489,1,'Print packing slip and labels for order #%d',2969808959),(2490,1,'Speedy shipping module is not configured.',3761590774),(2491,1,'Fixed',1594417462),(2492,1,'Percent',2920004005),(2493,1,'An error occured while importing cities with message: ',718850353),(2494,1,'Locations were imported successfully. New cities imported: %d. Cities updated: %d.',3909116274),(2495,1,'Please specify state.',496065408),(2496,1,'Could not find city \"%s\" in our city list for state \"%s\". Please check your spelling.',475143414),(2497,1,'Could not find CityID \"%s\". Please import locations using the Speedy module administration.',1802502652),(2498,1,'Found more than one city named \"%s\".',951556676),(2499,1,'Could not find State %s.',2374008662),(2500,1,'No shipping methods activated for Speedy.',3115261555),(2501,1,'Table-based Shipping',1013795999),(2502,1,'Please setup UPS UserID, Password and Access Number first.',2474399755),(2503,1,'Please setup USPS UserID first.',377665883),(2504,1,'USPS cannot ship to this country. Country code \"%s\".',1042739198),(2505,1,'%s (Source: %s, Code: %s)',395145477),(2506,1,'New',1403912869),(2507,1,'Processed',2768935208),(2508,1,'Delivered',3789227194),(2509,1,'Setup Quick Links',2363194125),(2510,1,'Quantity of items sold',3305961868),(2511,1,'Value of items sold',2170461228),(2512,1,'Could not save the order: %s.',2044883406),(2513,1,'\"%s\" has an option of type \"user image\" which is not supported by \"Edit Order\".',640934425),(2514,1,'Not all conditions for coupon \"%s\" are met.',1036390347),(2515,1,'No currency code has been saved in the order.',2429757432),(2516,1,'The selected currency \"%s\" could not be found.',2670353289),(2517,1,'The selected currency \"%s\" is currently inactive.',1109538040),(2518,1,'The current currency \"%s\" will be used.',3836761498),(2519,1,'Multiple coupons found with code \"%s\". None will be applied.',3098763195),(2520,1,'Coupon \"%s\" not found.',1840303263),(2521,1,'Coupon \"%s\" will not be applied.',322559967),(2522,1,'Surcharge',3594007164),(2523,1,'Some total lines from the original order do not exist now:',3955385877),(2524,1,'Some total lines did not exist in the original order:',1962040625),(2525,1,'The amount of the \"%s\" total line has changed from %s to %s.',3899924871),(2526,1,'There was a discount of %s on \"%s\". It is %s now.',2440723355),(2527,1,'Product cannot be found (ProductID %d).',2932499639),(2528,1,'Unable to find language code \"%s\". \"%s\" will be used instead.',2774013299),(2529,1,'There are no active shipping modules.',3897097184),(2530,1,'The shipping module that the user has selected could not be found.',93649609),(2531,1,'The shipping method that the user has selected is not active.',1518610654),(2532,1,'The country \"%s\" that the customer has selected as shipping country could not be found.',3029286015),(2533,1,'The country \"%s\" that the customer has selected as billing country could not be found.',3101475492),(2534,1,'The state \"%s\" that the user has selected as his %s could not be found.',2910254793),(2535,1,'Product \"%s\" options\' count does not match the order item options\' count.',3827980616),(2536,1,'The order item has missing product options. These product options will be set to default values: %s',1209841706),(2537,1,'These product options have been selected for the order item, but are not supported by the product: %s',524603406),(2538,1,'News not found.',1201267415),(2539,1,'You will receive newsletters in %s.',1036467592),(2540,1,'E-mail sending failed.',1700537962),(2541,1,'Test message successfully sent.',2868414571),(2542,1,'Subscribed',378138088),(2543,1,'All including unsubscribed',1589477793),(2544,1,'Blast successfully stopped.',1958860084),(2545,1,'Newsletter \"%s\" Statistics',489363607),(2546,1,'All months',595429309),(2547,1,'January',3113862095),(2548,1,'February',3025422826),(2549,1,'March',3205994163),(2550,1,'April',1874880475),(2551,1,'June',1097932288),(2552,1,'July',1732649165),(2553,1,'August',3813010884),(2554,1,'September',1011490657),(2555,1,'October',596285180),(2556,1,'November',2365364793),(2557,1,'December',3931589271),(2558,1,'All languages',293367773),(2559,1,'Blast \"%s - %s\" Statistics',2327549235),(2560,1,'Inactive',1923443894),(2561,1,'No e-mails to add.',1991326958),(2562,1,'%s e-mails successfully subscribed.',1706330912),(2563,1,'These e-mails are invalid and were not subscribed: %s',3079681498),(2564,1,'No scheduled messages.',1075938043),(2565,1,'Subscribed (%s)',3566135737),(2566,1,'All (%s)',1867803181),(2567,1,'All including unsubscribed (%s)',3948876667),(2568,1,'You may unsubscribe by following this link:',2723494638),(2569,1,'Enable \"Email Opens\" tracking',201141228),(2570,1,'Enable \"Click-Through\" tracking',3700194837),(2571,1,'Subscribe checkbox checked by default',2188668833),(2572,1,'Do not add \"Unsubscribe\" link. It is recommended that you leave this box unchecked.',3270213856),(2573,1,'Subscriber',3797768377),(2574,1,'Is Active',2217367178),(2575,1,'Please enter a valid e-mail address.',514029753),(2576,1,'You need to log-in in order to subscribe for newsletter \"%s\".',2131480835),(2577,1,'Newsletter subscription to \"%s\"',1460842374),(2578,1,'A user with the email \"%s\" just subscribed for the \"%s\" newsletter.',4151955869),(2579,1,'Unable to add product \"%s\" for comparison.',1453211149),(2580,1,'Product Comparison',166495272),(2581,1,'Select language',1634594289),(2582,1,'Select currency',3705672827),(2583,1,'Products Feed',3348699508),(2584,1,'Invalid Products Feed Key.',812562298),(2585,1,'Waiting for approval',2573243337),(2586,1,'Disapproved',4039052383),(2587,1,'Poor',4121705435),(2588,1,'Average',1828591333),(2589,1,'Good',3434537388),(2590,1,'Very good',2761007372),(2591,1,'Excellent',551958626),(2592,1,'Only registered users can rate.',2597373484),(2593,1,'Only customers that have bought the product can rate it.',927169313),(2594,1,'Only registered users can write reviews.',1175543820),(2595,1,'Only customers that have bought the product can write review about it.',1715888140),(2596,1,'No review available.',377899250),(2597,1,'No rating available.',2179000251),(2598,1,'Rating / review',3148493063),(2599,1,'All ratings',2808175468),(2600,1,'Review Content',310527526),(2601,1,'Rating Value',2749701344),(2602,1,'Rating Action Status',1777785138),(2603,1,'Customer reviewed product \"%s\".',1207280236),(2604,1,'Customer rated product \"%s\".',2779464736),(2605,1,'Please select rating or write review.',868798906),(2606,1,'Please select rating.',46111629),(2607,1,'Please write review.',958856233),(2608,1,'Guest',1836496177),(2609,1,'Thank you for your feedback.',233027733),(2610,1,'Unknown RSS feed.',2600091244),(2611,1,'Wholesale Discount',427583051),(2612,1,'This item is already on your wishlist.',1568311921),(2613,1,'Item successfully added to your wishlist.',3819242224),(2614,1,'Wishlist item removed.',1194866349),(2615,1,'Here is my wishlist',829364355),(2616,1,'Wishlist sent.',3268514320),(2617,1,'Page not found.',2684748848),(2618,1,'Profile updated successfully.',3670592399),(2619,1,'My Profile',4265525075),(2620,1,'Register failed: %s',1537601948),(2621,1,'Failed to subscribe to newsletter: %s',2909322066),(2622,1,'-- All --',2365027333),(2623,1,'Your email was successfully sent.',485311805),(2624,1,'An error occurred while sending your email.',298311779),(2625,1,'Cannot find implementations for %s.',3198092169);
/*!40000 ALTER TABLE `Texts` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `TextsTranslated` WRITE;
/*!40000 ALTER TABLE `TextsTranslated` DISABLE KEYS */;
INSERT INTO `TextsTranslated` VALUES (1,1,2289755597,'Create',1),(2,1,1037276004,'Create Administrator',1),(3,1,2995482424,'Account',1),(4,1,2876326840,'Permissions',1),(5,1,892126259,'Administrator Account',1),(6,1,1483083269,'Username:',1),(7,1,1618169985,'Password:',1),(8,1,1143805008,'Email:',1),(9,1,3428050462,'Access Level:',1),(10,1,1169514477,'Administrator Sections',1),(11,1,2590913965,'Administrator permissions can be applied only when the administrator account has access level \"Limited\".',1),(12,1,554135844,'Edit',1),(13,1,2016076131,'Edit Administrator',1),(14,1,2676568142,'Update',1),(15,1,4168197166,'Are you sure you wish to delete this administrator?',1),(16,1,3395160503,'Administrators',1),(17,1,578394630,'New Administrator',1),(18,1,1159730082,'Export',1),(19,1,3558298466,'Print',1),(20,1,19424289,'Username',1),(21,1,642995056,'Email',1),(22,1,1358691240,'Access Level',1),(23,1,1035893169,'Delete',1),(24,1,1991199118,'No records found.',1),(25,1,2437429846,'Filter Administrators',1),(26,1,401120404,'Username...',1),(27,1,759615668,'Email...',1),(28,1,4173485446,'Reset Filters',1),(29,1,3440991137,'Create API Account',1),(30,1,979098257,'Edit API Account',1),(31,1,856131234,'API Account Permissions:',1),(32,1,594535439,'Are you sure you wish to delete this API account?',1),(33,1,510619022,'API Accounts',1),(34,1,769722276,'New API Account',1),(35,1,299066170,'ID',1),(36,1,3434357891,'Password',1),(37,1,1422021308,'Filter API Accounts',1),(38,1,1656057158,'ID...',1),(39,1,2029384602,'Add Transaction',1),(40,1,1621185387,'Customer email:',1),(41,1,2085752545,'Customer will:',1),(42,1,666537513,'points',1),(43,1,3730803834,'Description:',1),(44,1,1829616372,'Bonus Points',1),(45,1,786362779,'Are you sure you wish to delete this transaction?',1),(46,1,2018503775,'Customer',1),(47,1,3483776891,'Time',1),(48,1,1080068516,'Action',1),(49,1,538348319,'Points',1),(50,1,3950563313,'Description',1),(51,1,2091671594,'Status',1),(52,1,1273029392,'Approve',1),(53,1,1917417168,'Void',1),(54,1,3845477,'Customer Email...',1),(55,1,3090480774,'Filter Transactions',1),(56,1,3768765570,'Customers',1),(57,1,1399724308,'Create Box',1),(58,1,2522791519,'Box Type:',1),(59,1,1029537327,'Box Name:',1),(60,1,529056539,'Options',1),(61,1,4121317825,'Box Options',1),(62,1,2919767447,'Edit Box Options',1),(63,1,905343091,'Active:',1),(64,1,710380569,'Are you sure you wish to delete this box?',1),(65,1,204512749,'Boxes',1),(66,1,4110683034,'New Box',1),(67,1,2007405142,'Area',1),(68,1,4262580536,'Name',1),(69,1,1286797620,'Active',1),(70,1,753727511,'Type',1),(71,1,3664733115,'Change status',1),(72,1,3387538849,'Title:',1),(73,1,3718166553,'Show title:',1),(74,1,1116506645,'Content:',1),(75,1,3332629561,'Create Category',1),(76,1,2611773477,'Parent Category:',1),(77,1,1022533488,'Name:',1),(78,1,3904062056,'Image:',1),(79,1,2509092508,'Layout:',1),(80,1,1653073578,'SEO Title:',1),(81,1,592908905,'You can use %%COMPANY_NAME%%, %%PAGE_NAME%%, %%PAGE_NUMBER%% and %%FMT_PAGE_NUMBER%% which will be automatically replaced.',1),(82,1,3851858000,'SEO Keywords:',1),(83,1,4119834834,'SEO Description:',1),(84,1,4159192542,'Are you sure you wish to delete this category, all subcategories, and all listed products?',1),(85,1,590884430,'Delete category',1),(86,1,3735244906,'You chose to delete category: ',1),(87,1,914164045,'Deleting this category will also remove',1),(88,1,34053083,'subcategories.',1),(89,1,345866253,'products in current category and its subcategories.',1),(90,1,721012472,'Subcategories that will be deleted',1),(91,1,491010218,'Category name',1),(92,1,962550496,'No subcategories.',1),(93,1,1048183235,'Products that will be deleted',1),(94,1,2570549838,'SKU',1),(95,1,2960715841,'Product name',1),(96,1,4282022807,'Category',1),(97,1,185142749,'Price',1),(98,1,1294350323,'No products.',1),(99,1,1213241423,'Edit Category',1),(100,1,4285491557,'Are you sure you wish to delete this category and all subcategories?',1),(101,1,1974355384,'Categories',1),(102,1,2407014471,'New Category',1),(103,1,1254897676,'Products',1),(104,1,4044774684,'Sort',1),(105,1,3015334490,'products',1),(106,1,282756568,'Edit Checkout Module',1),(107,1,3257114989,'Edit Checkout Module Options',1),(108,1,2359548218,'Checkout Module Name:',1),(109,1,1010515290,'Checkout Module Display Name:',1),(110,1,2658432784,'Options:',1),(111,1,2133747315,'Checkout Modules',1),(112,1,382242975,'Display Name',1),(113,1,1235981300,'Slide right',1),(114,1,2830496658,'Help',1),(115,1,2037939570,'Slide left',1),(116,1,4097332503,'Last Orders',1),(117,1,1914014145,'Today',1),(118,1,1741006997,'Yesterday',1),(119,1,873400667,'Quick Links',1),(120,1,1407211951,'Are you sure?\\nThe setup wizard can be enabled later through \"Website Content :: Boxes\" menu.',1),(121,1,2820672820,'Setup Wizard',1),(122,1,71361365,'Quick setup steps:',1),(123,1,318403058,'1. Store owner',1),(124,1,1063320005,'2. Emails',1),(125,1,1497918823,'3. Currencies',1),(126,1,133536621,'and',1),(127,1,2163033279,'Localization',1),(128,1,237900732,'4. Payment',1),(129,1,842685971,'5. Shipping Modules',1),(130,1,1141612140,'Zones',1),(131,1,1263603970,'6. Checkout',1),(132,1,2472554517,'Create <a href=\"categories.php\">categories</a> and <a href=\"products.php\">products</a>.',1),(133,1,418204617,'Start selling !',1),(134,1,2645630361,'Remove Box',1),(135,1,3522603177,'Company - Store Owner',1),(136,1,839502324,'Company Name:',1),(137,1,1766359513,'Company Country:',1),(138,1,3551868704,'Company State:',1),(139,1,4205699080,'Company City:',1),(140,1,1467534244,'Company Address:',1),(141,1,3184102455,'Company Address 2:',1),(142,1,2799088763,'Company ZIP:',1),(143,1,3951350519,'Phone:',1),(144,1,1211405980,'Phone 2:',1),(145,1,4156838822,'Fax:',1),(146,1,115514393,'Create Country',1),(147,1,3747125869,'ISO 3166-1-alpha-2:',1),(148,1,2020171218,'2-letter country code',1),(149,1,3326323500,'ISO 3166-1-alpha-3:',1),(150,1,3887324748,'3-letter country code',1),(151,1,1265701764,'Edit Country',1),(152,1,1323169768,'Require valid customer city',1),(153,1,2446631621,'Make sure you have a full database of states and cities for this country before enabling',1),(154,1,1154463460,'Are you sure you wish to delete this country?',1),(155,1,3751241998,'Countries',1),(156,1,3026300927,'New Country',1),(157,1,2221352256,'Code 2',1),(158,1,4083160534,'Code 3',1),(159,1,913207931,'States',1),(160,1,753088835,'Default',1),(161,1,2535385811,'Set default',1),(162,1,419496075,'Filter Countries',1),(163,1,971770418,'Country name...',1),(164,1,699852639,'2-Letter code...',1),(165,1,2279503566,'3-Letter code...',1),(166,1,4039929781,'Create Coupon',1),(167,1,728504189,'Code:',1),(168,1,2549178112,'Type:',1),(169,1,3648363398,'Apply mode',1),(170,1,839626980,'Value:',1),(171,1,307808580,'Shipping Method:',1),(172,1,2338252958,'Valid From:',1),(173,1,464626289,'Valid To:',1),(174,1,2285077413,'Allowed uses:',1),(175,1,1100149183,'Coupon Conditions:',1),(176,1,3517418852,'Note: The coupon will be accepted only if all conditions are satisfied.',1),(177,1,887667868,'Order',1),(178,1,3571547723,'Customer Groups',1),(179,1,656937191,'Manufacturers',1),(180,1,1940046458,'Order subtotal exceeds',1),(181,1,311605988,'Add product',1),(182,1,2644734124,'Choose product',1),(183,1,515919727,'Browse ...',1),(184,1,2677780045,'Remove products',1),(185,1,3319213447,'Customer Name:',1),(186,1,2398662531,'Add customer',1),(187,1,3786205714,'Remove customers',1),(188,1,2426276932,'Manufacturer Name:',1),(189,1,3292489674,'Add manufacturer',1),(190,1,1328338441,'Remove manufacturers',1),(191,1,3508710101,'Edit Coupon',1),(192,1,3336226318,'Used:',1),(193,1,495727280,'Are you sure you wish to delete this coupon?',1),(194,1,987310212,'Coupons',1),(195,1,3472138508,'New Coupon',1),(196,1,3609698214,'Code',1),(197,1,3702945584,'Value',1),(198,1,4013556806,'Valid From',1),(199,1,3211622985,'Valid To',1),(200,1,895329285,'Filter Coupons',1),(201,1,3273198802,'Coupon Code...',1),(202,1,3255354999,'Coupon Value...',1),(203,1,2847503815,'Create Currency',1),(204,1,2257604640,'Code: (3-letters)',1),(205,1,4049401116,'Symbol Left:',1),(206,1,1068033941,'Symbol Right:',1),(207,1,4261341808,'Decimal Symbol:',1),(208,1,2106014093,'Thousands Separator:',1),(209,1,885873369,'Number Decimals:',1),(210,1,2316664076,'Rate:',1),(211,1,659163569,'Edit Currency',1),(212,1,1867670234,'Are you sure you wish to delete this currency?',1),(213,1,3101993193,'WARNING: Changing the default currency will change all prices to the new currency. No conversion is applied. Are you sure?',1),(214,1,2023310659,'Currencies',1),(215,1,3764564409,'New Currency',1),(216,1,1144470778,'Rate to',1),(217,1,3198531662,'Rate Updated',1),(218,1,3851265157,'Filter Currencies',1),(219,1,2102318287,'Currency Name...',1),(220,1,730052110,'Currency Code...',1),(221,1,2965428102,'Currency Rate...',1),(222,1,3735031810,'Update Currency Rates',1),(223,1,4255488631,'Currency Rate Modules',1),(224,1,3131407025,'Edit Currency Rate Module Options',1),(225,1,1363597389,'Currency Rate Module Name:',1),(226,1,2232779832,'Rates',1),(227,1,3857138066,'Currency Rates',1),(228,1,2277816345,'Currency Rates Of %%BANKNAME%%',1),(229,1,3218697270,'Base currency',1),(230,1,1628591218,'Quote currency',1),(231,1,2145292295,'Rate',1),(232,1,1616759769,'Date of update',1),(233,1,1503822767,'I will use custom urls',1),(234,1,495143701,'Custom Url',1),(235,1,810799440,'Custom Url Is Current',1),(236,1,3261111235,'Insert',1),(237,1,1865160710,'Remove',1),(238,1,734138096,'Add url',1),(239,1,1303866686,'Create Custom Url',1),(240,1,2242273707,'Url:',1),(241,1,1171046712,'Product:',1),(242,1,2056915619,'Category:',1),(243,1,673769939,'Manufacturer:',1),(244,1,872336839,'Form:',1),(245,1,639522870,'Rich Text Page:',1),(246,1,724805283,'Gallery:',1),(247,1,13213407,'Dynamic Page:',1),(248,1,1180273410,'Is Current:',1),(249,1,1457006762,'If a custom url is not current the visitor will be redirected to the current url of this page.',1),(250,1,1835073706,'Edit Custom Url',1),(251,1,950790732,'Are you sure you wish to delete this custom url?',1),(252,1,1993255083,'Custom Urls',1),(253,1,1610774068,'New Custom Url',1),(254,1,1657866020,'URL',1),(255,1,159662430,'Entity',1),(256,1,1271107802,'Entity Name',1),(257,1,1063193523,'Is Current',1),(258,1,586873638,'Filter custom urls',1),(259,1,3760750716,'Custom url text...',1),(260,1,2971479636,'Page ID...',1),(261,1,3465963864,'Create Customer Group',1),(262,1,1354171785,'Edit Customer Group',1),(263,1,2030727810,'Are you sure you wish to delete this customer group?',1),(264,1,1832239909,'New Customer Group',1),(265,1,62372502,'Filter Customer Groups',1),(266,1,3534204887,'Customer Group Name...',1),(267,1,3626964749,'Default billing address',1),(268,1,1298866674,'Default shipping address',1),(269,1,1633266105,'First Name:',1),(270,1,3952088495,'Last Name:',1),(271,1,190101345,'Company:',1),(272,1,1987276054,'VAT Number:',1),(273,1,1241179085,'Country:',1),(274,1,963545935,'State:',1),(275,1,4099323532,'City:',1),(276,1,3152090975,'Zip / Post Code:',1),(277,1,469117031,'Address 1:',1),(278,1,819690404,'Address 2:',1),(279,1,3025604379,'Add new',1),(280,1,1104573425,'Create Customer',1),(281,1,3688990591,'Customer Group:',1),(282,1,3486077833,'Status:',1),(283,1,2951236299,'Addresses:',1),(284,1,84373228,'Newsletters:',1),(285,1,3475312519,'Edit Customer',1),(286,1,2569416001,'Points:',1),(287,1,671550159,'View Points History',1),(288,1,2684393541,'Are you sure you wish to delete this customer?',1),(289,1,135116687,'New Customer',1),(290,1,3259950746,'Customer name',1),(291,1,1416126568,'Billing Address',1),(292,1,3631425621,'Order History',1),(293,1,640984327,'Filter Customers',1),(294,1,1938273026,'Customer name...',1),(295,1,139694043,'Newsletters',1),(296,1,4134497924,'Select the newsletters you want to subscribe for.',1),(297,1,724096885,'Most Recent Orders',1),(298,1,3505840376,'Last 5 Orders',1),(299,1,179083332,'Date',1),(300,1,3181064726,'Details',1),(301,1,65982042,'Total',1),(302,1,2682620377,'View all',1),(303,1,3178444827,'Views By Category',1),(304,1,922052886,'No data for selcted period.',1),(305,1,473154195,'Settings',1),(306,1,2812958730,'Period:',1),(307,1,3878477080,'Views By Product',1),(308,1,686891096,'Sales By Product',1),(309,1,327582746,'Page Views / Unique Visitors',1),(310,1,3785762269,'Access Denied',1),(311,1,3706373094,'Access denied to section \"%%SECTIONNAME%%\"!',1),(312,1,554650102,'Create Discount',1),(313,1,859799067,'Discount Conditions:',1),(314,1,1753317527,'Note: The discount will be granted only if all conditions are satisfied.',1),(315,1,2952541568,'Edit Discount',1),(316,1,1040504028,'Are you sure you wish to delete this discount?',1),(317,1,2124840987,'Discounts',1),(318,1,1758760328,'New Discount',1),(319,1,3090213278,'Filter Discounts',1),(320,1,384779057,'Discount Name...',1),(321,1,401325246,'Discount Value...',1),(322,1,1151858065,'Edit Dynamic Page',1),(323,1,4004852549,'Page:',1),(324,1,2097494675,'menu',1),(325,1,882035683,'Dynamic Page Areas:',1),(326,1,264857579,'Dynamic Pages',1),(327,1,3344210772,'Filter Dynamic Pages',1),(328,1,1435067696,'Page Name...',1),(329,1,1261301092,'Emails',1),(330,1,3826974845,'More info about the error',1),(331,1,1840744469,'Email Addresses',1),(332,1,3361431098,'Site Administrator Email:',1),(333,1,1294274427,'Order Department Email:',1),(334,1,2997004959,'Multiple emails separated by comma are supported.',1),(335,1,2993599821,'Help/Support Email:',1),(336,1,221380787,'Reply-to Notifications Email:',1),(337,1,3044419721,'This email will be put in From and Reply-To headers when sending notification emails to customers.',1),(338,1,2894426120,'Reply-to Newsletter Email:',1),(339,1,4185941722,'Method of Sending Emails:',1),(340,1,1666559931,'SMTP Server Settings',1),(341,1,3142575940,'SMTP Host:',1),(342,1,735870516,'SMTP port:',1),(343,1,3062696543,'Use SMTP Authentication:',1),(344,1,3330392952,'SMTP Username:',1),(345,1,4271152636,'SMTP Password:',1),(346,1,3837661202,'SMTP Security:',1),(347,1,3521870156,'Update and Send Test Email',1),(348,1,2896921823,'This is a test email.',1),(349,1,1220736883,'This email was sent from <a href=\"%%STORE_ROOT_URL%%\">%%COMPANYNAME%%</a> for the sole purpose to test email setup.',1),(350,1,4016487210,'Create Featured Product',1),(351,1,485965105,'Product',1),(352,1,2071043849,'Browse',1),(353,1,3650456851,'Feature on Home Page',1),(354,1,859962406,'Edit Featured Product',1),(355,1,1653583751,'Are you sure you wish remove this product from featured?',1),(356,1,1136261839,'Featured Products',1),(357,1,4064565271,'Search Product:',1),(358,1,561596911,'Product name...',1),(359,1,3497791286,'Filter Products',1),(360,1,1140086212,'New Featured Product',1),(361,1,83635035,'Image',1),(362,1,2942734885,'Featured In',1),(363,1,2382706641,'Create Form',1),(364,1,2948666624,'Confirm text:',1),(365,1,813452922,'Enable captcha:',1),(366,1,3121551407,'Edit Form',1),(367,1,3478282366,'Item Name',1),(368,1,498026833,'Item Type',1),(369,1,435013471,'Required',1),(370,1,418411255,'Input and select fields should have name prefixed with custom-field-, eg:',1),(371,1,1891574076,'Are you sure you wish to delete this form?',1),(372,1,1023292659,'Forms',1),(373,1,2225337316,'New Form',1),(374,1,4144669664,'Filter Forms',1),(375,1,2659577502,'Form Name...',1),(376,1,314191173,'Create Gallery',1),(377,1,247289170,'Gallery Name',1),(378,1,1197503405,'Gallery Title',1),(379,1,1915678372,'Gallery Description',1),(380,1,964021644,'Gallery Active',1),(381,1,1435567424,'SEO Title',1),(382,1,1596564184,'Edit Gallery',1),(383,1,558160881,'Import Images From Folder',1),(384,1,637989770,'Are you sure you wish to delete this gallery?',1),(385,1,1979706388,'Galleries',1),(386,1,2688097955,'New Gallery',1),(387,1,3942078319,'Title',1),(388,1,3010037137,'Filter Galleries',1),(389,1,124201707,'Gallery Name...',1),(390,1,1412881386,'Are you sure you want to delete gallery images before importing?',1),(391,1,1032305907,'Import images in \"%%GALLERYNAME%%\"',1),(392,1,3152560996,'Images found in directory \"%%DIRECTORY%%\"',1),(393,1,2488537117,'Delete gallery images before import',1),(394,1,1916110845,'Import Selected Images',1),(395,1,3958908650,'Create Gallery Item',1),(396,1,678364137,'URL:',1),(397,1,3453375687,'Edit Gallery Item',1),(398,1,1822348166,'Are you sure you wish to delete this item?',1),(399,1,2370364043,'Gallery Items',1),(400,1,2607950393,'New Gallery Item',1),(401,1,176078831,'Added',1),(402,1,4035319854,'Sort order',1),(403,1,2468205517,'General Options',1),(404,1,3887315804,'Images',1),(405,1,854454908,'E-Goods',1),(406,1,1361241570,'Ratings &amp; Reviews',1),(407,1,4043640331,'Miscellaneous',1),(408,1,269276975,'Upon upload the images will be automatically resized to fit in the sizes specified below.',1),(409,1,1384850146,'Product Images',1),(410,1,2918703136,'Large image max width:',1),(411,1,492802816,'Large image max height:',1),(412,1,3881581214,'Normal image max width:',1),(413,1,835495505,'Normal image max height:',1),(414,1,921966431,'Thumbnail image max width:',1),(415,1,3716086874,'Thumbnail image max height:',1),(416,1,4157063781,'Box image max width:',1),(417,1,464721469,'Box image max height:',1),(418,1,361089098,'Save settings and regenerate product images',1),(419,1,220566877,'Manufacturers Images',1),(420,1,3680048988,'Categories Images',1),(421,1,2457112548,'Gallery Images',1),(422,1,1517437511,'Gallery grid images per row:',1),(423,1,2504331047,'Gallery grid rows per page:',1),(424,1,2769143229,'Fullsize image max width:',1),(425,1,2481555164,'Fullsize image max height:',1),(426,1,2240765858,'Download link will stay active for:',1),(427,1,3957652582,'days',1),(428,1,2004198218,'Max downloads per E-Good:',1),(429,1,1265870005,'downloads',1),(430,1,539322459,'Auto unlock of E-Goods:',1),(431,1,716429498,'Products can be rated by:',1),(432,1,2645711072,'Products can be reviewed by:',1),(433,1,77241868,'Automatically approve ratings and reviews by:',1),(434,1,3055675652,'Products per page',1),(435,1,1383366238,'Default category view:',1),(436,1,3434089996,'Default product order:',1),(437,1,1369760445,'Grid view columns:',1),(438,1,1737381562,'Grid view rows:',1),(439,1,382330550,'List view products:',1),(440,1,2083096048,'Homepage view:',1),(441,1,750111958,'Automatic inventory tracking:',1),(442,1,2380118066,'When products are out of stock:',1),(443,1,402006418,'Add new products to the front of the category listings:',1),(444,1,1909781453,'Enable wholesale prices:',1),(445,1,4223135822,'Currency rates expire after:',1),(446,1,1281194530,'Products are considered new for:',1),(447,1,1202775632,'Maximum number of products to compare:',1),(448,1,924304961,'Captcha on register:',1),(449,1,62763753,'Captcha on register in checkout:',1),(450,1,3951021838,'Show unfinished orders:',1),(451,1,662215137,'A friend referral earns',1),(452,1,4060238471,'Limit to ',1),(453,1,3898582405,'uses per ',1),(454,1,414650819,'Referral cookie life',1),(455,1,1563505666,'A review earns',1),(456,1,1869955673,'A vote earns',1),(457,1,3808845936,'A purchase earns ',1),(458,1,1215727740,'Order statuses',1),(459,1,2482087779,'Spending ',1),(460,1,1902986711,'earns',1),(461,1,1689585026,'1 point equals',1),(462,1,3856038733,'when buying products.',1),(463,1,4263381803,'Manually approve point actions',1),(464,1,2536097032,'Let customers decide whether to spend points or not',1),(465,1,1205939790,'By default new products can be purchased with',1),(466,1,351951855,'Summer Cart - Admin Panel',1),(467,1,2616496417,'Search...',1),(468,1,2986050059,'Click to hide',1),(469,1,4168505391,'Welcome',1),(470,1,845213721,'Logout',1),(471,1,766317539,'Language',1),(472,1,2329144481,'Open Customer Area',1),(473,1,3521422318,'Home',1),(474,1,1050048371,'Store',1),(475,1,1625540659,'Website Content',1),(476,1,1050844889,'Reports',1),(477,1,590925805,'Plugins',1),(478,1,3009207953,'Search',1),(479,1,2856345408,'Sales',1),(480,1,3800299736,'Orders',1),(481,1,870606089,'Product Options',1),(482,1,3778863435,'Product Classes',1),(483,1,2598554411,'Import',1),(484,1,1139605362,'Promotion',1),(485,1,689873154,'Rich Text Pages',1),(486,1,3185653358,'News',1),(487,1,836273688,'Newsletter',1),(488,1,586864587,'Image Galleries',1),(489,1,2018988773,'Website Layout',1),(490,1,3014928331,'Menus',1),(491,1,549626884,'Skins',1),(492,1,2592952232,'Layouts',1),(493,1,4132776560,'Sales Reports',1),(494,1,3412108406,'Sales By Category',1),(495,1,1276457918,'Sales By Customer',1),(496,1,2831740307,'Sales By Country',1),(497,1,1076937254,'Customer Reports',1),(498,1,779024177,'Customer Countries',1),(499,1,2809413986,'Page Views / Visits',1),(500,1,248971099,'Order Reports',1),(501,1,3484514641,'Average Order Amount',1),(502,1,2969627178,'Order Statuses',1),(503,1,2107866557,'Payment Methods',1),(504,1,492318832,'Shipping Methods',1),(505,1,55544060,'Taxes',1),(506,1,1911357502,'Items Per Order',1),(507,1,3775560267,'Modules',1),(508,1,3563746674,'Shipping',1),(509,1,2727722385,'Payment',1),(510,1,1447972632,'Checkout',1),(511,1,4237855332,'Order Total',1),(512,1,1033236376,'Currency Rate',1),(513,1,3354049021,'Store<br />Configuration',1),(514,1,26480598,'General',1),(515,1,242724770,'Store Owner',1),(516,1,1022211991,'Security',1),(517,1,4208373434,'SEO',1),(518,1,2509950185,'Locations &amp; Taxes',1),(519,1,2642707482,'Shipping Zones',1),(520,1,4252246553,'Languages &amp; Currencies',1),(521,1,572576218,'Languages',1),(522,1,3557463602,'Create Help',1),(523,1,1389658646,'Page Action:',1),(524,1,3505702287,'Text:',1),(525,1,3758143948,'Edit Help',1),(526,1,1239850335,'Are you sure you wish to delete this help?',1),(527,1,94865552,'Helps',1),(528,1,3735835143,'New Help',1),(529,1,3023575326,'Page',1),(530,1,3461554051,'Filter Helps',1),(531,1,2587122860,'Page name...',1),(532,1,1153217644,'Import Products',1),(533,1,2478860166,'CSV File:',1),(534,1,2147132762,'Please make sure that the CSV file has the correct format. Take a look at the <a href=\"%%SKIN_URL%%admin/import/products.csv\" target=\"_blank\">example CSV file</a>.',1),(535,1,1915366692,'Languages:',1),(536,1,55916349,'All',1),(537,1,3997793959,'Auto-create manufacturers:',1),(538,1,4116337988,'Auto-create categories:',1),(539,1,517128142,'Auto-create product classes:',1),(540,1,1866055727,'Delete all products before import:',1),(541,1,1059048098,'WARNING! This will result in the deletion of ALL current products!',1),(542,1,2862194528,'Optionally you can choose to remove all current products first.',1),(543,1,2682384428,'Allow partial success:',1),(544,1,2388344707,'By default all products are imported as a single transaction that either succeeds or not. Allowing partial success will apply the changes to all successfully imported products even if part of the import fails.',1),(545,1,2960504523,'Imported Products',1),(546,1,1831847519,'Updated Products',1),(547,1,3527257968,'Imported New Categories',1),(548,1,1963134496,'Imported New Manufacturers',1),(549,1,2676543370,'Imported New Product Classes',1),(550,1,2162755878,'Products with failed images',1),(551,1,946252235,'Installation check fails for:<br/><strong>%%PROBLEMS%%</strong>.',1),(552,1,2196203420,'License Info',1),(553,1,2194961893,'Application Log',1),(554,1,3504735353,'Install Check',1),(555,1,2743614721,'Your installation passes the install checks.',1),(556,1,3855422341,'Find texts',1),(557,1,2654260861,'Find texts results',1),(558,1,2860613836,'Found texts',1),(559,1,3939961270,'Found template texts',1),(560,1,1533893826,'Found code texts',1),(561,1,1505227595,'All unique texts count',1),(562,1,4279887624,'Update operation results',1),(563,1,384604181,'Previous texts count',1),(564,1,1807440099,'Added texts count',1),(565,1,1545029533,'Removed texts count',1),(566,1,2687646265,'Return',1),(567,1,338988109,'Create Language',1),(568,1,94494848,'Based On:',1),(569,1,1005997555,'2-character language code (ISO 639-1)',1),(570,1,151362824,'Direction:',1),(571,1,1192782810,'While most languages are written left-to-right, some languages, like Arabic and Hebrew are written right-to-left.',1),(572,1,3299575374,'Icon:',1),(573,1,1030573456,'May take some time.',1),(574,1,2596794427,'Edit Language',1),(575,1,1807457897,'Info',1),(576,1,3440977850,'Language Pack',1),(577,1,1786319641,'Xliff Files',1),(578,1,3455484701,'Download language pack',1),(579,1,1320282873,'Author:',1),(580,1,2302973021,'License:',1),(581,1,3070820891,'Publish Date:',1),(582,1,4273363598,'Language pack:',1),(583,1,967710941,'Download / upload xliff files',1),(584,1,1393277713,'A language pack contains xliff files. XLIFF is an internationally standardized file format for software localization and translation.',1),(585,1,1334522620,'Download xliff files',1),(586,1,1059175203,'Interface language texts',1),(587,1,1094608267,'Download XLIFF',1),(588,1,3513281581,'Admin Quick Links',1),(589,1,2057606105,'Upload xliff files',1),(590,1,2454456072,'Upload XLIFF',1),(591,1,1148527715,'This is a php.ini setting beyond Summer Cart control. Please contact your hosting company to increase the upload limit.',1),(592,1,3765929189,'Install',1),(593,1,1116465884,'Install Language Pack',1),(594,1,1257387828,'Language pack file:',1),(595,1,2368833844,'It is a a zip file that contains the translations for one language.',1),(596,1,4220357726,'Please visit <a href=\"http://www.summercart.com/\" target=\"_blank\">www.summercart.com</a> to find language packs.',1),(597,1,1623261434,'Maximum upload file size is %%MAXUPLOADSIZE%%.',1),(598,1,3548864002,'How to increase?',1),(599,1,1877622045,'Language Pack Successfully Installed.',1),(600,1,1710096959,'Language pack info',1),(601,1,1010286815,'Successfully installed language files',1),(602,1,749574446,'File',1),(603,1,2331169344,'Texts to be translated',1),(604,1,401915326,'Installed translations',1),(605,1,2164804145,'Missing translations',1),(606,1,3360604285,'Unused translations',1),(607,1,3714345229,'Texts with missing translations',1),(608,1,1915095946,'details',1),(609,1,1455164762,'Unused translations for texts',1),(610,1,3935651977,'Continue',1),(611,1,1851207096,'Edit User Interface Translations',1),(612,1,1496342308,'Original Text',1),(613,1,424200871,'Text in',1),(614,1,3749695353,'Check all',1),(615,1,446897115,'Translation approved',1),(616,1,106014150,'Filter User Interface Translations',1),(617,1,2166909919,'Text ID...',1),(618,1,1056778569,'Original Text...',1),(619,1,122880609,'Translated Text...',1),(620,1,2485861965,'Filter Translations',1),(621,1,291378377,'User Interface Translations',1),(622,1,1652720925,'Are you sure you wish to delete this language?',1),(623,1,105775009,'WARNING: Changing the default language will change the language used to store the order items names. Are you sure?',1),(624,1,771978002,'Languages Management',1),(625,1,1575962675,'New Language',1),(626,1,1242588023,'translate',1),(627,1,1720970127,'view all',1),(628,1,3837179999,'Filter Languages',1),(629,1,69925236,'Language Name...',1),(630,1,568052308,'Update User Interface Texts',1),(631,1,2924034901,'Create Layout',1),(632,1,956611263,'CSS Class Names',1),(633,1,2410151477,'Edit Layout',1),(634,1,4287890366,'Layout ID',1),(635,1,3185071516,'Are you sure you wish to delete this layout?',1),(636,1,1205307603,'Layouts Management',1),(637,1,2423387628,'New Layout',1),(638,1,2968916085,'Change default layout',1),(639,1,2500444969,'Filter Layouts',1),(640,1,146829847,'Layout Name...',1),(641,1,412693723,'End-User License Agreement',1),(642,1,2682984555,'Summer Cart License Info',1),(643,1,2323996648,'Licensed To:',1),(644,1,1523516778,'License Type:',1),(645,1,3545320687,'Website:',1),(646,1,3864153367,'License Code:',1),(647,1,3045320497,'Check Authenticity',1),(648,1,63961100,'Demo:',1),(649,1,4203975461,'Weight Unit:',1),(650,1,2784187960,'WARNING: Changing the weight unit will change all product weights in the store to the new unit. No conversion is applied.',1),(651,1,3130602245,'Application log',1),(652,1,2030045667,'Message',1),(653,1,3953216932,'Administrator',1),(654,1,3749110151,'Customer Email',1),(655,1,253145917,'Severity',1),(656,1,316635914,'Filter log entries',1),(657,1,1613063122,'Message...',1),(658,1,1158643050,'Administrator Name...',1),(659,1,3873015737,'Log entries',1),(660,1,750740131,'Please enable JavaScript. Summer Cart requires JavaScript to function properly.',1),(661,1,4049669701,'Please login',1),(662,1,757082350,'Language:',1),(663,1,3342318177,'Log In',1),(664,1,2168853892,'Create Manufacturer',1),(665,1,2808637353,'Edit Manufacturer',1),(666,1,2944624444,'Are you sure you wish to delete this manufacturer?',1),(667,1,4056684887,'New Manufacturer',1),(668,1,2295489659,'Website',1),(669,1,4021677144,'Filter Manufacturers',1),(670,1,277105412,'Manufacturer Name...',1),(671,1,2536423828,'Manufacturer Site...',1),(672,1,3208812707,'Create Menu Item',1),(673,1,1958220373,'Edit Menu Items',1),(674,1,111853526,'Edit Menu Item',1),(675,1,73030122,'Menu Items',1),(676,1,146153308,'New Menu Item',1),(677,1,1691918083,'Link Type',1),(678,1,2604631168,'Links To',1),(679,1,2710106125,'Create Menu',1),(680,1,410452179,'Menu Name:',1),(681,1,1232203988,'Menu Location:',1),(682,1,2249378412,'Menu Title:',1),(683,1,3496752393,'Menu Active:',1),(684,1,2508382195,'Edit Menu',1),(685,1,4294259204,'Are you sure you wish to delete this menu?',1),(686,1,2871931960,'New Menu',1),(687,1,2817059741,'Location',1),(688,1,2017505496,'Filter Menus',1),(689,1,657625883,'Menu Name...',1),(690,1,3805367665,'See all',1),(691,1,3553794789,'Create Option Group',1),(692,1,4126992584,'Edit Option Group',1),(693,1,2462623563,'Are you sure you wish to delete this option group?',1),(694,1,500159910,'Option Groups',1),(695,1,2740491830,'New Option Group',1),(696,1,3578931481,'Filter Option Groups',1),(697,1,4236806916,'Option Group...',1),(698,1,3523343456,'Price Modifier',1),(699,1,3590926850,'Modification Type',1),(700,1,2299360628,'Amount',1),(701,1,1956349703,'% of product price',1),(702,1,424616805,'Create Order Status',1),(703,1,1360519729,'Send Notification:',1),(704,1,3743557245,'Inventory Action:',1),(705,1,1063342408,'Edit Order Status',1),(706,1,3081471352,'Are you sure you wish to delete this order status?',1),(707,1,1774530486,'New Order Status',1),(708,1,2808458546,'Notification',1),(709,1,870107285,'Inventory',1),(710,1,2067839808,'Predefined',1),(711,1,1207696150,'Change',1),(712,1,3927366091,'Filter Order Statuses',1),(713,1,620095717,'Order status...',1),(714,1,2006019800,'Edit Order Total Module Options',1),(715,1,1031408549,'Order Total Module Name:',1),(716,1,3825478277,'Order Total Modules',1),(717,1,3309110367,'image',1),(718,1,2247323090,'SKU:',1),(719,1,4125291397,'Administrative note is too short.',1),(720,1,2288505237,'Are you sure you want to delete this note?',1),(721,1,3215528822,'The CVV and all but the last 4 digits of the credit card number will be discarded. Are you sure?',1),(722,1,1929955923,'Print invoice',1),(723,1,3642958753,'Print packing slip and labels for order #%%ORDERID%%',1),(724,1,3185707023,'Print Packing Slip',1),(725,1,3094574373,'Edit Order',1),(726,1,2381271956,'Order Details',1),(727,1,1460565179,'Order number',1),(728,1,3551558051,'Order date',1),(729,1,4157998837,'Customer Info',1),(730,1,1436479071,'IP Address',1),(731,1,3735532719,'Billing information',1),(732,1,3702440234,'Bill To:',1),(733,1,2009770416,'Address:',1),(734,1,2245635979,'see map',1),(735,1,3912290734,'Shipping information',1),(736,1,1058344987,'Ship To:',1),(737,1,855323776,'Shipping Info',1),(738,1,3890635123,'Shipping method',1),(739,1,580378663,'Shipping tracking №',1),(740,1,81762214,'View Transactions',1),(741,1,2888137196,'Payment method',1),(742,1,2405271545,'Payment transaction №',1),(743,1,2941008396,'Credit Card Info',1),(744,1,2347830614,'Discard',1),(745,1,3961855662,'Cardholder Name:',1),(746,1,2373507299,'Card Number:',1),(747,1,1022260215,'Card Expiration:',1),(748,1,3551303276,'CVV / CVC Code:',1),(749,1,1028089187,'AVS:',1),(750,1,1747108340,'CVN:',1),(751,1,3135544870,'Check Info',1),(752,1,4264007409,'Name on Account:',1),(753,1,2210243515,'Account Number:',1),(754,1,2205281729,'Bank Name:',1),(755,1,3899945616,'Account Type:',1),(756,1,1255983578,'Special instructions from customer',1),(757,1,525886687,'Payment notes',1),(758,1,30367324,'Ordered products',1),(759,1,1720022112,'Quantity',1),(760,1,412538456,'Discount',1),(761,1,3940561649,'Price per unit',1),(762,1,1029285216,'Order total',1),(763,1,3391103084,'Customer paid in',1),(764,1,2313543638,'Send E-Goods',1),(765,1,1995554626,'View E-Goods',1),(766,1,2396005286,'Payment Status',1),(767,1,772090503,'Administrative notes about this order',1),(768,1,1871664426,'Note',1),(769,1,1364489895,'Sent to customer',1),(770,1,2105576996,'Created',1),(771,1,3519893586,'No order notes.',1),(772,1,3920048843,'New admin note',1),(773,1,1426351852,'Send the administrative note to customer',1),(774,1,123366371,'Note contents:',1),(775,1,1135686316,'Add note',1),(776,1,1833481689,'Unlock',1),(777,1,666711088,'Lock',1),(778,1,3380749846,'Downloads',1),(779,1,1428246800,'Expires',1),(780,1,1649497623,'Downloadable',1),(781,1,1303016265,'Yes',1),(782,1,4063104189,'No',1),(783,1,1011106260,'Invoice for order #%%ORDERID%%',1),(784,1,1608003288,'Invoice',1),(785,1,1526887444,'Order date:',1),(786,1,3722834136,'Shipping method:',1),(787,1,2972062900,'Shipping tracking №:',1),(788,1,3172908309,'Payment method:',1),(789,1,3504349440,'Payment transaction №:',1),(790,1,1736041562,'Please select orders first.',1),(791,1,2516486077,'Are you sure you wish to delete selected orders?',1),(792,1,3353338619,'Are you sure you wish to update all orders statuses?',1),(793,1,2453634288,'Search Orders',1),(794,1,2646813048,'Order ID...',1),(795,1,3157953182,'Customer Name...',1),(796,1,3796017169,'Create Order',1),(797,1,3514807676,'Update Statuses',1),(798,1,275359193,'Print Invoices',1),(799,1,2332831890,'Print Packing Slips',1),(800,1,4070162868,'Transactions',1),(801,1,551895527,'Order ID:',1),(802,1,1507437924,'Transaction Code',1),(803,1,4099588478,'Detail Name',1),(804,1,1124325509,'Detail Value',1),(805,1,3399427310,'No transactions found.',1),(806,1,4234656813,'Edit Payment Module',1),(807,1,52654519,'Edit Payment Module Options',1),(808,1,909362514,'Payment Module Name:',1),(809,1,3629807128,'Payment Module Display Name:',1),(810,1,100059395,'Payment Modules',1),(811,1,4023227825,'Integration Method',1),(812,1,1621980064,'Edit Plugin Options',1),(813,1,3696483166,'Plugin Name:',1),(814,1,1155909498,'Install Plugin',1),(815,1,3228116228,'Plugin package file:',1),(816,1,2612794959,'Plugin Modules',1),(817,1,4005700258,'Plugin',1),(818,1,193471262,'Module',1),(819,1,3424629120,'Please select image first.',1),(820,1,1392705431,'Only images can be uploaded. Please select JPG, PNG or GIF.',1),(821,1,3487826600,'Upload Image',1),(822,1,1336794860,'Select Image',1),(823,1,1983387308,'Preview',1),(824,1,703179297,'Auto-generate thumb.',1),(825,1,45485956,'Thumb:',1),(826,1,3535843008,'Close',1),(827,1,303993805,'Apply Now',1),(828,1,1371193412,'Cancel',1),(829,1,2589634787,'Please select print fields.',1),(830,1,4118653070,'Select the data you want to print',1),(831,1,3624458271,'Please select product.',1),(832,1,4054035588,'Please select category:',1),(833,1,737252216,'products found.',1),(834,1,2057586828,'Select Product',1),(835,1,3711818894,'Product Attributes',1),(836,1,3628166978,'Add value',1),(837,1,4145562852,'Add attribute',1),(838,1,313419750,'Create Product Class',1),(839,1,2126945696,'Attributes',1),(840,1,1465325025,'Edit Product Class',1),(841,1,4232330976,'Are you sure you wish to delete this product class?',1),(842,1,218394244,'New Product Class',1),(843,1,2631993219,'Product Class...',1),(844,1,912926102,'Filter Product Classes',1),(845,1,4142080300,'Find product',1),(846,1,4293700324,'switch to<br/>WYSIWYG editor<br/>',1),(847,1,589944230,'switch to<br/>Plain text',1),(848,1,1980386710,'Pictures',1),(849,1,2584338874,'Additional Categories',1),(850,1,3815204975,'Prices',1),(851,1,3563717080,'Related Products',1),(852,1,2732013515,'Bundle',1),(853,1,854319462,'Item Number (SKU)',1),(854,1,624639268,'Manufacturer',1),(855,1,273309567,'Product Name',1),(856,1,314147162,'Brief Description',1),(857,1,2857272176,'Detailed Description',1),(858,1,2224570068,'Available for Sale',1),(859,1,6377591,'Weight',1),(860,1,1892211746,'lbs, kgs',1),(861,1,2146757560,'Tax Classes',1),(862,1,3641567454,'No taxes defined.',1),(863,1,2594461011,'Product Page Title',1),(864,1,3570241586,'You can use %%COMPANY_NAME%%, %%PAGE_NAME%%, %%CATEGORY_NAME%% and %%CATEGORY_BRANCH%% which will be automatically replaced.',1),(865,1,2164287666,'Meta Keywords',1),(866,1,39755518,'Meta Description',1),(867,1,3424188446,'Global Options',1),(868,1,3893533752,'Product Option',1),(869,1,4250554258,'Product is E-Good:',1),(870,1,3302799654,'Product Class',1),(871,1,2022403416,'Attribute',1),(872,1,626226205,'Available with bonus points',1),(873,1,2254132409,'Price in points',1),(874,1,1807972765,'Leave blank for auto-price.',1),(875,1,3714791612,'If left blank the price in points will be ',1),(876,1,2824029570,'Product is bundle',1),(877,1,3047654571,'Auto-quantities',1),(878,1,2431883014,'If enabled changing a subproduct quantity will automatically update the bundle quantity.',1),(879,1,954096422,'Included products',1),(880,1,3664961198,'Are you sure you wish to delete this product and all of its e-good files?',1),(881,1,3366923039,'Delete product',1),(882,1,3917002164,'Product to be deleted:',1),(883,1,2664546985,'Deleting this product will also remove %%EGOODSCOUNT%% e-good files.',1),(884,1,2130013892,'Files that will be deleted:',1),(885,1,3410550351,'Edit Product',1),(886,1,1257124279,'Variants',1),(887,1,1778871822,'see variants',1),(888,1,2818503275,'see wholesale prices',1),(889,1,2445281649,'see bundles',1),(890,1,335754544,'Click on thumb to see larger image.',1),(891,1,4292304212,'You need to add options of type \"variant\" to have product variants.',1),(892,1,3629807937,'You need to save any changes you have made to this product\'s options before editing variants.',1),(893,1,4115961312,'Save',1),(894,1,2619480116,'Save And Close',1),(895,1,1021041466,'That would remove all E-Goods from this product. Are you sure?',1),(896,1,166431123,'Add Product E-Good',1),(897,1,3751438319,'Product E-Good is a file (image, movie, document, mp3 or other) that is to be used only by this product.',1),(898,1,75466410,'Add Shared E-Good',1),(899,1,4183963746,'Shared E-Good is a file that can be used by more than one product.',1),(900,1,428357396,'Note: When a product is deleted all of its E-Goods are deleted along with it, while the shared E-Goods will be left intact.',1),(901,1,3210431157,'Image Thumb',1),(902,1,3929915345,'Upload new image',1),(903,1,3607359936,'Add picture',1),(904,1,1146293855,'Local Options',1),(905,1,3810910862,'Add option',1),(906,1,384259134,'You have to filter by category to be able to reorder products.',1),(907,1,387876210,'Sorting failed.',1),(908,1,3932571580,'Enable drag and drop sorting?',1),(909,1,1400665124,'Drag products vertically to reorder them in the category.',1),(910,1,1224315921,'Are you sure you wish to delete this product?',1),(911,1,691153231,'Search Product',1),(912,1,1043481812,'Product number (SKU)...',1),(913,1,4005851251,'Product Name...',1),(914,1,1372295029,'Additional filters',1),(915,1,2850335413,'Price from...',1),(916,1,454427117,'Price to...',1),(917,1,903571526,'Product Description...',1),(918,1,878207540,'New Product',1),(919,1,2115538962,'Reorder products',1),(920,1,4038453503,'Qty',1),(921,1,2427847608,'Duplicate',1),(922,1,1291634369,'Wholesale Prices',1),(923,1,912557301,'Customer Group Prices',1),(924,1,4016236161,'Add price row',1),(925,1,1348646173,'Reset variants wholesale prices',1),(926,1,4218420269,'Are you sure you want to reset variants wholesale prices for this product?',1),(927,1,1377088974,'Bi-directional',1),(928,1,3967730406,'Create Admin Quick Link',1),(929,1,3395691925,'Link Text:',1),(930,1,2990819220,'Link Location:',1),(931,1,811173354,'Edit Admin Quick Link',1),(932,1,1543674835,'Are you sure you wish to delete this link?',1),(933,1,322693661,'New Quick Link',1),(934,1,4129737893,'Link Location',1),(935,1,2046232192,'Filter Admin Quick Links',1),(936,1,2989896966,'Regenerate images',1),(937,1,1428629460,'Product images',1),(938,1,570540454,'Variant images',1),(939,1,3979516769,'Go to general settings',1),(940,1,1682980639,'Error: ',1),(941,1,3119939844,'Warning: ',1),(942,1,3280171698,'Report',1),(943,1,1128758787,'View (Unit of Time):',1),(944,1,1567988421,'Download as CSV',1),(945,1,613877038,'Chart',1),(946,1,937992258,'Table',1),(947,1,1435361928,'Chart value:',1),(948,1,3482545072,'Top:',1),(949,1,552652585,'Currency:',1),(950,1,4292548849,'You need to upgrade your Flash Player.',1),(951,1,1918578068,'Records:',1),(952,1,1797036103,'No data for selected period.',1),(953,1,3711407533,'Menu',1),(954,1,1404066370,'Create Rich Text Page',1),(955,1,775396182,'Add to menus:',1),(956,1,3448845971,'Edit Rich Text Page',1),(957,1,231048233,'Are you sure you wish to delete this rich text page?',1),(958,1,4027838527,'New Rich Text Page',1),(959,1,1033268948,'Layout',1),(960,1,3264327005,'Open in customer area',1),(961,1,4266157535,'Filter Rich Text Pages',1),(962,1,1611866998,'You don\'t have permissions to see the search results.',1),(963,1,1708902902,'Search Results',1),(964,1,3377439838,'Search in the following product fields:',1),(965,1,4229313245,'Search in the following order fields:',1),(966,1,1089105628,'Results in products:',1),(967,1,2101845315,'No products match your query.',1),(968,1,904043044,'Results in orders:',1),(969,1,1661959455,'No orders match your query.',1),(970,1,287223950,'Use SSL:',1),(971,1,322374794,'Before enabling SSL please make sure that <a href=\"%%HTTPS_URL%%login.php\" target=\"_blank\">this SSL link</a> works. It should successfully open a secure login page.',1),(972,1,591812916,'Password store mode:',1),(973,1,637222123,'Site Title:',1),(974,1,2078895898,'You can use %%COMPANY_NAME%% and %%PAGE_NAME%% which will be automatically replaced.',1),(975,1,3064612706,'Site Keywords:',1),(976,1,2800913026,'Site Description:',1),(977,1,452323653,'SE-Friendly URLs:',1),(978,1,1248220876,'SE-Friendly URLs require working mod_rewrite Apache module.<br/>Before enabling SE-friendly URLs please check that they work<br/>correctly on your server by following <a href=\"../manufacturers.html\" target=\"_blank\">this link</a>. If it fails to open<br/>the manufacturers listing page please contact your hosting provider.',1),(979,1,234548374,'SE-Friendly URLs Type:',1),(980,1,1890709483,'\"en\" will be replaced with the current language code.',1),(981,1,145668893,'Sitemap:',1),(982,1,1787636607,'Summer Cart automatically generates a <a target=\"_blank\" href=\"../sitemap.xml\">XML file</a> with information<br />that helps search engines like Google, Yahoo and Bing<br />to find and index all of your pages.<br />The <a target=\"_blank\" href=\"../sitemap.xml\">XML file</a> is compliant with the official Sitemap Protocol.',1),(983,1,1997999718,'Setup New Shipping Module',1),(984,1,1695384782,'Shipping Modules',1),(985,1,1206177630,'Select module:',1),(986,1,1640552363,'Edit Shipping Module Options',1),(987,1,2460261966,'Shipping Module Name:',1),(988,1,1465446556,'Shipping Module Display Name:',1),(989,1,2458156334,'Shipping Zone:',1),(990,1,3644878690,'Methods:',1),(991,1,1509244758,'Method',1),(992,1,3069853601,'Display name',1),(993,1,2763921508,'Are you sure you wish to delete this shipping module?',1),(994,1,917579977,'New Shipping Module',1),(995,1,1503249872,'Shipping Zone',1),(996,1,2414549776,'Create Shipping Zone',1),(997,1,1051933231,'Choose Country:',1),(998,1,2634450168,'Choose States:',1),(999,1,3390204183,'Edit Shipping Zone',1),(1000,1,139103139,'Are you sure you wish to delete this zone?',1),(1001,1,2420183666,'New Shipping Zone',1),(1002,1,559872952,'Edit skin \"%%SKINNAME%%\" settings',1),(1003,1,900681827,'Skins Management',1),(1004,1,3955952330,'Customer Area',1),(1005,1,1667261560,'Admin Area',1),(1006,1,2399413882,'The following skins were detected, but not installed automatically, because they are for different Summer Cart version. You may attempt to install such skins by clicking the install button.',1),(1007,1,2261691191,'Skin Name:',1),(1008,1,2648372470,'For Summer Cart Version:',1),(1009,1,2304637720,'Create a State',1),(1010,1,3301864581,'Edit a State',1),(1011,1,509600253,'Are you sure you wish to delete this state?',1),(1012,1,2461920694,'Manage States',1),(1013,1,3795944341,'New State',1),(1014,1,2630807802,'Country',1),(1015,1,2988164914,'Filter States',1),(1016,1,1120297998,'State Name...',1),(1017,1,336266959,'State Code...',1),(1018,1,3541575390,'Create Tax Classes',1),(1019,1,3592612221,'Create Tax Class',1),(1020,1,1875561992,'Edit Tax Class',1),(1021,1,1641442946,'New Tax Class',1),(1022,1,3591424722,'Up',1),(1023,1,3167567621,'Down',1),(1024,1,1323977902,'Tax Rates',1),(1025,1,4286733379,'Update Tax Rates',1),(1026,1,3198370186,'Create Tax Zones',1),(1027,1,2805721639,'Create Tax Zone',1),(1028,1,122382079,'Edit Tax Zones',1),(1029,1,701011537,'Edit Tax Zone',1),(1030,1,2415154938,'Tax Zones',1),(1031,1,4007669337,'New Tax Zone',1),(1032,1,3578194776,'Create Tax',1),(1033,1,4144846822,'Tax Name:',1),(1034,1,2564721856,'Registration Number:',1),(1035,1,2659130368,'Apply to Shipping:',1),(1036,1,1468898402,'Apply by Default:',1),(1037,1,2981161265,'Edit Tax',1),(1038,1,1438361936,'Are you sure you wish to delete this tax?',1),(1039,1,1932327382,'New Tax',1),(1040,1,63310942,'Registration Number',1),(1041,1,2457820364,'Apply To Shipping',1),(1042,1,2770220216,'Apply By Default',1),(1043,1,3327491243,'Edit Tax Rates',1),(1044,1,3367706607,'Filter Taxes',1),(1045,1,4136245189,'Choose image to upload',1),(1046,1,842812345,'Upload...',1),(1047,1,3457770897,'Images larger than %%IMAGE_MAX_WIDTH%%x%%IMAGE_MAX_HEIGHT%% px will be scaled down automatically.',1),(1048,1,3215342,'Last 30 days',1),(1049,1,3043440391,'Last 7 days',1),(1050,1,3922919155,'This month',1),(1051,1,1507105497,'Last month',1),(1052,1,36063916,'This year',1),(1053,1,3571073750,'Last year',1),(1054,1,1009032439,'All time',1),(1055,1,403610525,'Specific Date',1),(1056,1,3060721506,'All Dates Before',1),(1057,1,3086509526,'All Dates After',1),(1058,1,1570709765,'Date Range',1),(1059,1,2717396598,'Start date',1),(1060,1,111718006,'End date',1),(1061,1,2753412866,'Next',1),(1062,1,483403627,'Prev',1),(1063,1,2954842005,'Done',1),(1064,1,4274732151,'Merchant ID:',1),(1065,1,2453922054,'Merchant Key:',1),(1066,1,3676946771,'The backup shipping amount will be used if the Shipping Calculation call-back fails.<br/>\nYour customers will pay the backup shipping amount if accurate shipping amount cannot be determined.<br/>\nIf you don\'t use the backup shipping amount and the call-back fails the customer will be notified that they cannot ship to that address.<br/>',1),(1067,1,1672584572,'Use Backup Shipping Amount:',1),(1068,1,1083706231,'Backup Shipping Amount:',1),(1069,1,2330328948,'Check this option if you do NOT ship to PO Boxes.',1),(1070,1,3372155483,'Disallow US Post-Office Box:',1),(1071,1,2052058202,'Seller Account Currency:',1),(1072,1,2489100572,'Mode:',1),(1073,1,147726518,'Quick setup instructions',1),(1074,1,1017425442,'Please login to your Google Checkout account, click on Settings tab, and choose Integration menu.',1),(1075,1,144205977,'1. Check \"My company will only post digitally signed carts.\" checkbox.',1),(1076,1,3022219378,'2. Set \"API callback URL:\" to \"%%HTTPS%%modules/checkout/google/notify.php?gkey=[Merchant_Key]&amp;gid=[Merchant_ID]\". Replace [Merchant_Key] and [Merchant_ID] with the actual values.',1),(1077,1,1228526745,'3. Set \"Callback method\" to be XML.',1),(1078,1,401607006,'In \"Advanced settings\" check the following options:',1),(1079,1,2549034529,'1. Provide the first name, last name and full name of the buyer and order recipient in separate fields in the new order notification.',1),(1080,1,3348692449,'2. Return the buyer\'s ship-to phone number in the new order notification.',1),(1081,1,3645134935,'3. Return the buyer\'s billing phone number in the new order notification.',1),(1082,1,412387362,'While logged into your Google Checkout account you can check for integration errors from the Tools tab, Integration Console menu.',1),(1083,1,1554049617,'General options',1),(1084,1,835196441,'Your account log-in email or the Secure Merchant Account ID.',1),(1085,1,1019086286,'Account:',1),(1086,1,554271247,'Payment Action:',1),(1087,1,3611595129,'Allow Customer Note:',1),(1088,1,3000703641,'Require Confirmed Shipping Address:',1),(1089,1,1520063823,'PayPal Landing Page:',1),(1090,1,1645277103,'Use Confirm Page:',1),(1091,1,1368278113,'When using the additional confirm page Summer Cart makes sure that the correct tax and shipping are calculated.',1),(1092,1,2771442886,'Checkout Button Type:',1),(1093,1,2848467461,'API Access',1),(1094,1,2578337366,'API Access allows you to perform Capture, Reauthorization, Refund and Void operations directly from Summer Cart order management screen. To allow API Access:',1),(1095,1,2942559741,'Log in to your account at <a href=\"https://www.paypal.com/\" target=\"_blank\">https://www.paypal.com/</a>',1),(1096,1,927331701,'Under \"My Account\" tab choose \"Profile\" subtab',1),(1097,1,3877642009,'Click on the link \"API Access\" under the \"Account Information\" column',1),(1098,1,2847613079,'Click \"Request API Credentials\" link',1),(1099,1,1389165952,'Select \"Request API signature\" and click \"Agree and Submit\"',1),(1100,1,4065605080,'PayPal will display \"API account username\", \"API Password\" and \"Signature\". Enter them in the fields below',1),(1101,1,1731671543,'Click \"Done\"',1),(1102,1,253979313,'API Username:',1),(1103,1,926299189,'API Password:',1),(1104,1,2524839449,'API Signature:',1),(1105,1,2363892471,'If checked the customer will confirm the order on PayPal.',1),(1106,1,2923539806,'Default Currency',1),(1107,1,2153718755,'The default currency will be used if the current customer currency is not supported by PayPal.',1),(1108,1,147299665,'The default currency must exists in <a href=\"currencies.php\">currencies management.</a>',1),(1109,1,2557676385,'Default Currency:',1),(1110,1,515095047,'Allow guest checkout',1),(1111,1,402334869,'User can enter order instructions during checkout',1),(1112,1,3811724674,'Require the user to accept the terms and conditions',1),(1113,1,1299144461,'Terms and conditions',1),(1114,1,3244184526,'Create News',1),(1115,1,837680854,'Add News',1),(1116,1,1706368814,'Date:',1),(1117,1,4115954736,'Edit News',1),(1118,1,4260919213,'Are you sure you wish to delete this news?',1),(1119,1,684042718,'Filter News',1),(1120,1,1521578592,'News Title...',1),(1121,1,1705759856,'The following fees will be applied when customer selects Collect On Delivery payment method:',1),(1122,1,3011918322,'Use shipping module CoD fee if it is available:',1),(1123,1,4071801088,'Fixed Amount:',1),(1124,1,1584702284,'Proportional Fee:',1),(1125,1,32364822,'Demo Mode:',1),(1126,1,2025693602,'To set up the secret word, login to your 2CO Account and look under the \"Look &amp; Feel\" section.',1),(1127,1,166627762,'The secret word is used to sign the transaction data that Summer Cart receives from 2Checkout.',1),(1128,1,4243974355,'Secret Word',1),(1129,1,187187385,'Secret Word:',1),(1130,1,1836520064,'Please remember to login to your 2CO Account and set both \"Approved URL\" and \"Pending URL\" under the \"Look &amp; Feel\" section to',1),(1131,1,3313317985,'Direct Return should be set to \"No\".',1),(1132,1,2455784416,'Atos Worldwide E - Transactions - Secure Internet Payment',1),(1133,1,2759416782,'Choose a method to pay',1),(1134,1,2510548134,'Default Language:',1),(1135,1,2838166432,'Please make sure that folder modules/payment/atos/executables/ has the \'request\' and \'response\' files and that they are executable. You will receive the files from your bank.',1),(1136,1,1252629769,'API Login ID:',1),(1137,1,2504138788,'Transaction Key:',1),(1138,1,1332928208,'MD5 Hash:',1),(1139,1,30186195,'Timezone Offset:',1),(1140,1,2317008269,'hours',1),(1141,1,1677552814,'Keys are already generated. This operation will delete current keys and the module will not work until new certificates are entered.',1),(1142,1,1499286651,'Key is already generated. Please confirm generation of new key.',1),(1143,1,3787401028,'Borica payment module setup wizard',1),(1144,1,3391458734,'Data to be used in the certificate',1),(1145,1,929483243,'State/Province:',1),(1146,1,3619342144,'Locality (city):',1),(1147,1,247743386,'Organization Unit:',1),(1148,1,2563698514,'Common name:',1),(1149,1,3253870329,'Generate keys wizard',1),(1150,1,487826370,'Step 1:',1),(1151,1,3578621044,'Generate live private key, test private key and their CSRs for payment gateway.',1),(1152,1,40894957,'Generate',1),(1153,1,910094337,'Step 2:',1),(1154,1,3851170156,'Generate private key and CSR for eTLog.',1),(1155,1,4053559235,'Download <strong>live</strong> payment gateway CSR (<a href=\"?ModuleName=com.summercart.payment.borica.gate&amp;action=acDownloadApgwCSR\">download</a>), <strong>test</strong> payment gateway CSR (<a href=\"?ModuleName=com.summercart.payment.borica.gate&amp;action=acDownloadApgwTestCSR\">download</a>) and eTLog CSR (<a href=\"?ModuleName=com.summercart.payment.borica.gate&amp;action=acDownloadEtlogCSR\">download</a>) files and send them to your bank.',1),(1156,1,1801018908,'The bank will send you back three certificates - for the live payment gateway, test payment gateway and for eTLog.',1),(1157,1,3174182879,'Send the Return URL, listed on the previous page, to your bank.',1),(1158,1,791003456,'Step 3:',1),(1159,1,172391364,'Set the 8-digit Terminal ID (TID) that you have received from your bank in the previous screen.',1),(1160,1,1617188743,'Step 4:',1),(1161,1,2727466293,'Put the eTLog certificate contents in the field below and get the .p12 file.',1),(1162,1,3878699623,'The certificate starts with \"-----BEGIN CERTIFICATE-----\".',1),(1163,1,3003313697,'Get .p12 file',1),(1164,1,3471349272,'Import the .p12 file into your browser.',1),(1165,1,1196369362,'Return to Borica module',1),(1166,1,3425203614,'Terminal ID (TID):',1),(1167,1,3978171891,'8-digit code provided by your bank.',1),(1168,1,442304913,'Order Description:',1),(1169,1,2254540171,'Please enter the description line for the order.',1),(1170,1,728497053,'Account Currency:',1),(1171,1,1580903947,'Private Key for Live APGW:',1),(1172,1,4044169584,'The private key starts with \"-----BEGIN RSA PRIVATE KEY-----\".',1),(1173,1,87950621,'Private Key for Test APGW:',1),(1174,1,1034705443,'Certificate for Live APGW:',1),(1175,1,1722347829,'Certificate for Test APGW:',1),(1176,1,1556796273,'Configuration steps:',1),(1177,1,1451649640,'Use the \"<a href=\"module.php?ModuleName=com.summercart.payment.borica.gate&amp;action=acBoricaSetupWizard\">Borica payment module setup wizard</a>\".',1),(1178,1,3028765641,'Return URL:',1),(1179,1,2288359418,'Reversal',1),(1180,1,914933220,'Total order amount:',1),(1181,1,1794229843,'Refund amount:',1),(1182,1,2310413392,'Client ID:',1),(1183,1,1706633060,'Activation Key:',1),(1184,1,2522822593,'Method:',1),(1185,1,1614476677,'Accepted Check Types:',1),(1186,1,2281461740,'Product ID:',1),(1187,1,1739691339,'Product Currency:',1),(1188,1,2751553006,'Maximum Amount:',1),(1189,1,3064029683,'To charge a fee if the customer selects \"Collect on delivery\" payment method please remember to activate the corresponding \"Collect on delivery\" order total module. The fee is set in the total module.',1),(1190,1,3060458674,'Will be provided by DSK Bank.',1),(1191,1,1268699863,'Currency Code:',1),(1192,1,372582953,'MD5 Password',1),(1193,1,1454021497,'MD5 Password:',1),(1194,1,1155475729,'The MD5 password is required. It is used to sign the transaction data that Summer Cart sends to and receives from DSK Direct.',1),(1195,1,4233366650,'IMPORTANT NOTICE',1),(1196,1,1780295817,'If you don\'t have SSL enabled your customers will see warnings in their browsers at the end of the payment process.',1),(1197,1,3901631899,'If the customer clicks cancel the store will not be notified about the payment.',1),(1198,1,2461502548,'Client number:',1),(1199,1,2223644698,'Secret Key:',1),(1200,1,2646160959,'Payment Request<br />Expiration Time:',1),(1201,1,1847368024,'Payment instructions:',1),(1202,1,3287268887,'Merchant number:',1),(1203,1,1571859967,'Merchant name:',1),(1204,1,173849435,'Merchant password:',1),(1205,1,40686185,'Order description:',1),(1206,1,887383748,'Storefront ID:',1),(1207,1,4252987528,'13-character string in the form of UK12345678CUR.',1),(1208,1,3793027758,'Transaction Type:',1),(1209,1,2443707600,'Shared Secret',1),(1210,1,2454473967,'Shared Secret:',1),(1211,1,4044273798,'You will receive your shared secret (32-character string) from HSBC.',1),(1212,1,444762562,'Default currency:',1),(1213,1,3199946140,'If the user checks out with currency different from USD or CAD which one to use',1),(1214,1,274243051,'Payment note:',1),(1215,1,31088455,'Options CAD',1),(1216,1,2952545973,'Hosted payment page id:',1),(1217,1,3744805632,'Hosted payment page key:',1),(1218,1,1636167766,'Options USD',1),(1219,1,2527265290,'Additional information for the Moneris Merchant Hosted Configuration',1),(1220,1,630578004,'For Response Method choose GET or POST and enter the following URL in the Response URL field:',1),(1221,1,3137146140,'In the Security Features check the <strong>\"Enable Transaction Verification\"</strong> checkbox.',1),(1222,1,3150990615,'Select <strong>\"Displayed as XML on our server\"</strong> option of the \"Response Method\" section.',1),(1223,1,2158506343,'Leave the <strong>\"Response URL\"</strong> field empty.',1),(1224,1,2202504530,'Merchant Pay To Email:',1),(1225,1,3975230462,'Recipient Description:',1),(1226,1,2822597311,'Logo URL:',1),(1227,1,2639952004,'URL to your logo, it should start with https://. It will be displayed on the payment page.',1),(1228,1,3283790610,'Hide Login:',1),(1229,1,4038141604,'If checked Moneybookers will not allow the customer to login into existing Moneybookers account.',1),(1230,1,28162475,'Use Iframe:',1),(1231,1,2831228941,'If checked the payment form will be embeded within the merchant site, otherwise the user will be redirected to Moneybookers site to complete the payment.',1),(1232,1,1008152630,'Confirmation screen',1),(1233,1,2431019173,'Shown at the Confirmation screen (end step of the process)',1),(1234,1,910248752,'Confirmation note:',1),(1235,1,3787582312,'You may use &lt;br&gt; for line breaks.',1),(1236,1,3195721565,'Return URL Text:',1),(1237,1,1977604747,'The text on the button to return to store when the user finishes his payment.',1),(1238,1,2999123729,'The default currency will be used if the current customer currency is not supported by Moneybookers.',1),(1239,1,1600929358,'To set up the secret word, login to your Moneybookers Account and look under the \"Merchant Tools\" section.',1),(1240,1,1503288321,'The secret word is used to sign the transaction data that Summer Cart receives from Moneybookers.',1),(1241,1,3635999792,'PSPID can be found on the left side of your Ogone account page.',1),(1242,1,614528529,'PSPID:',1),(1243,1,2741808256,'Title on the payment page:',1),(1244,1,737850223,'SHA-1-IN signature from your Ogone account (found in \"Technical information\" -> \"Data and origin verification\" -> \"SHA-1-IN Signature\")',1),(1245,1,390345667,'SHA-1-IN:',1),(1246,1,546023244,'SHA-1-OUT signature from your Ogone account (found in \"Technical information\" -> \"Transaction feedback\" -> \"SHA-1-OUT Signature\")',1),(1247,1,3625104482,'SHA-1-OUT:',1),(1248,1,1411657282,'Enabled Currencies:',1),(1249,1,1213247299,'Important',1),(1250,1,2279891751,'Please enable the \"I want to receive transaction feedback parameters on the redirection URLs\" option. You can find it in your Ogone account by going to \"Configuration\" -> \"Technical Information\" screen, in the \"Transaction Feedback\" tab.',1),(1251,1,1145282425,'Capture',1),(1252,1,1073846020,'Already captured amount:',1),(1253,1,55238551,'Capture amount:',1),(1254,1,2927438680,'Is final:',1),(1255,1,3190779602,'There will be more capture operations',1),(1256,1,3769638272,'This is the final capture',1),(1257,1,1229371311,'Note (optional):',1),(1258,1,205308943,'Vendor ID:',1),(1259,1,429771270,'Partner:',1),(1260,1,3661788121,'User:',1),(1261,1,178066530,'If you haven\'t created any user put Vendor ID here.',1),(1262,1,3029983581,'Enable Buyer Authentication:',1),(1263,1,1359090026,'If checked 3D secure auth (\"Verified By Visa\" and \"SecureCode\") will be attempted.',1),(1264,1,2360048237,'Reauthorization',1),(1265,1,2303808259,'Reauthorization amount:',1),(1266,1,1551896942,'Refund',1),(1267,1,1145322128,'Captured amount:',1),(1268,1,2162064995,'Transaction to refund:',1),(1269,1,1078819742,'Full',1),(1270,1,1706748264,'Partial',1),(1271,1,864998091,'Please enter the description line for the order. If left empty customers can enter the description at time of purchase.',1),(1272,1,2974419541,'Payment Data Transfer (PDT)',1),(1273,1,1828463134,'Please enable PDT.',1),(1274,1,3741902324,'Click on the link \"Website Payment Preferences\" under the \"Selling Preferences\" column',1),(1275,1,3902299500,'Enable \"Auto-Return\" (and copy and paste the Return URL shown below)',1),(1276,1,1874574508,'Enable \"Payment Data Transfer\"',1),(1277,1,1193147294,'Click \"Save\"',1),(1278,1,3825642984,'PayPal will show you the PDT identity token. Put it in the field below.',1),(1279,1,1104199793,'PDT Identity Token:',1),(1280,1,4230348253,'Language Encoding',1),(1281,1,3935609386,'By default PayPal sends notifications in windows-1252 encoding, which will mangle any non-western characters.',1),(1282,1,1916601122,'Instead PayPal should be informed to send the notifications in UTF-8. Here is how:',1),(1283,1,1853139557,'Click on the link \"Language Encoding\" under the \"Selling Preferences\" column',1),(1284,1,1699103402,'Select the \"More Options\" button',1),(1285,1,1143435416,'Using the drop down menu select UTF-8 and select \"Yes\" to use this preference with IPN',1),(1286,1,4271664381,'Click \"Save\" ',1),(1287,1,1371444183,'Installation ID:',1),(1288,1,3981919405,'Auth Mode:',1),(1289,1,3623864170,'Please note that to use &quot;Pre Auth&quot; you might need to request it from WorldPay support.',1),(1290,1,3767901768,'Allow contacts edit:',1),(1291,1,4075630300,'If checked the customers will be able to edit their name and address at the RBS WorldPay site.',1),(1292,1,3435607478,'The default currency will be used if the current customer currency is not supported by RBS WorldPay.',1),(1293,1,3435195543,'MD5 secret for transactions<br />(up to 16 characters):',1),(1294,1,1099005614,'The secret word is used to sign the transaction data that Summer Cart sends to RBS WorldPay.',1),(1295,1,1785134662,'Payment Response Password:',1),(1296,1,2128563735,'It is used to verify the response from RBS WorldPay.',1),(1297,1,1756952934,'Login to your RBS WorldPay Account and look in the \"Installations\" menu',1),(1298,1,841163493,'Choose the \"Installation\" you wish to configure',1),(1299,1,990984551,'Set \"Payment Response URL\" to \"%%HTTPS%%modules/payment/rbsworldpay/response.php\"',1),(1300,1,1938529821,'Check the \"Payment Response enabled?\" checkbox',1),(1301,1,118523628,'Check the \"Enable the Shopper Response\" checkbox',1),(1302,1,4057498740,'Set \"Payment Response password\". Remember to enter it above',1),(1303,1,2130128007,'Set \"MD5 secret for transactions\". Remember to enter it above',1),(1304,1,193969084,'Secret:',1),(1305,1,2399392064,'Account (optional):',1),(1306,1,2661746016,'Auto capture:',1),(1307,1,4089531088,'Referral URL:',1),(1308,1,2409134777,'Vendor:',1),(1309,1,1253391832,'The default currency will be used if the current customer currency is not supported by Sage Pay.',1),(1310,1,3157569171,'Encryption Password:',1),(1311,1,1001769353,'Emails from Sage Pay',1),(1312,1,2769525101,'Vendor Email (optional):',1),(1313,1,2774351315,'Vendor email address to receive transaction information. Multiple email addresses can be entered separated by \":\" (colon).',1),(1314,1,199766793,'Send emails with transaction info:',1),(1315,1,926829729,'Message to the customer (optional):',1),(1316,1,1242364881,'If provided, will be included toward the top of the customer confirmation emails.',1),(1317,1,2683762813,'9-digit',1),(1318,1,624437297,'Private Key for Live mode:',1),(1319,1,2117894951,'Private Key for Test mode:',1),(1320,1,1223025197,'Transcard certificate for Live mode:',1),(1321,1,333531451,'Transcard certificate for Test mode:',1),(1322,1,515708534,'Edit bank %%BANKNAME%%',1),(1323,1,2429941028,'Edit bank',1),(1324,1,1651168334,'Store ID:',1),(1325,1,434599511,'Is Active:',1),(1326,1,44303849,'Store Key',1),(1327,1,3453667558,'Store Key:',1),(1328,1,1466148554,'The store key is required. It is used to sign the transaction data that Summer Cart sends to and receives from your bank.',1),(1329,1,1132470983,'Installments:',1),(1330,1,1278578948,'You may offer payment in installments to your customers. Please set the number of installments and the interest rate.',1),(1331,1,3869367668,'Installments',1),(1332,1,649126636,'Interest rate (%)',1),(1333,1,69889613,'Default bank:',1),(1334,1,3695363791,'The default bank will be used to process the payment the customer selects \"Card from another bank\".',1),(1335,1,1791432850,'Banks',1),(1336,1,1153185069,'Logo',1),(1337,1,1633730451,'Terminal Aliases:',1),(1338,1,2554014956,'Upload resource.cgn file provided by UBB:',1),(1339,1,3108494789,'Use the \"<a href=\"module.php?ModuleName=com.summercart.payment.ubb_bg.hostedpage&amp;action=acUbbBgSetupWizard\">UBB payment module setup wizard</a>\".',1),(1340,1,2147088633,'UBB.bg payment module setup wizard',1),(1341,1,2731437692,'Upload resource.cgn file',1),(1342,1,2377979207,'Return to UBB.bg module',1),(1343,1,2255685458,'Bank info and wire instructions:',1),(1344,1,3948245510,'Retailer ID:',1),(1345,1,2382770493,'Postal Code:',1),(1346,1,2828876885,'Optional. In this field, you can supply the Postal Code of your warehouse. <strong>Must be Canadian</strong>.',1),(1347,1,494733389,'Turnaround Time:',1),(1348,1,3169761664,'Optional. In this field, you can specify the time it takes between receiving an order and getting the order ready to ship.',1),(1349,1,2361988811,'e-Econt username:',1),(1350,1,3034335311,'e-Econt password:',1),(1351,1,2848807441,'e-Econt',1),(1352,1,3849822505,'Login to e-Econt',1),(1353,1,2970828923,'Contact Information',1),(1354,1,4090029808,'Company name:',1),(1355,1,3007368028,'Person name:',1),(1356,1,3270727197,'Address',1),(1357,1,2025602183,'Street address 1:',1),(1358,1,1402040132,'Street address 2:',1),(1359,1,87389314,'Pickup from:',1),(1360,1,1915995396,'Delivery receipt:',1),(1361,1,2234420808,'Minimum declared amount (optional):',1),(1362,1,3907473293,'If set, shipments with lower value will not have any declared value.',1),(1363,1,4108804899,'CD agreement number (optional):',1),(1364,1,4061175651,'Please contact Econt to obtain collect on delivery agreement number.',1),(1365,1,3184466366,'Client number (optional):',1),(1366,1,431111556,'Please enter your FedEx account number. Your meter number will be obtained automatically.',1),(1367,1,830283296,'Meter Number:',1),(1368,1,1115236530,'Ship From',1),(1369,1,3657543221,'Contact Details',1),(1370,1,1921115224,'Person Name:',1),(1371,1,2670906935,'Department:',1),(1372,1,1124291200,'Only digits',1),(1373,1,4131668273,'Pager Number:',1),(1374,1,3968392638,'State Or Province Code:',1),(1375,1,3313956470,'Country Code:',1),(1376,1,3751130500,'Misc',1),(1377,1,610088699,'Insurance:',1),(1378,1,2475299491,'Shipments will be insured for the order subtotal amount.',1),(1379,1,1763209963,'Packaging Weight:',1),(1380,1,1472220333,'This weight will be added to the goods weight.',1),(1381,1,1457601935,'Shipping Fee:',1),(1382,1,3236430179,'Client',1),(1383,1,3309533356,'Test account data',1),(1384,1,2288290833,'Account information',1),(1385,1,4186509951,'Additional options',1),(1386,1,1484115338,'Fragile goods:',1),(1387,1,3859110517,'Add insurance:',1),(1388,1,3096612495,'Documents:',1),(1389,1,3513682807,'Include VAT:',1),(1390,1,1988450491,'Handling type:',1),(1391,1,3669659083,'Handling amount:',1),(1392,1,202443566,'Initialisation',1),(1393,1,1894811959,'Locations:',1),(1394,1,213284011,'Get locations from Speedy',1),(1395,1,1993580989,'Importing locations can take some time, please be patient.',1),(1396,1,1968273914,'You have made changes to the form. If you continue all changes would be lost. Do you want to continue?',1),(1397,1,382735039,'Importing cities could take some time. Do you want to continue?',1),(1398,1,2564620584,'Loading',1),(1399,1,1117520404,'Parcels count:',1),(1400,1,3857914122,'Pickup date:',1),(1401,1,98663625,'Print packing slip',1),(1402,1,2718602126,'Delete packing slip',1),(1403,1,387154378,'Deleting the shipping label will only delete it from Summer Cart database and will allow you to generate new packing slip for this order.',1),(1404,1,488747049,'You should also cancel it through Speedy\'s WebClients interface or by calling Speedy\'s customer service.',1),(1405,1,53144288,'Print label',1),(1406,1,957135579,'Are you sure you want to delete this packing slip?',1),(1407,1,1799531275,'Up To Weight/Subtotal/Quantity',1),(1408,1,3088333762,'Cost',1),(1409,1,860927180,'Please enter your UPS User ID, Password and XML Access Number:',1),(1410,1,3699446743,'UserID:',1),(1411,1,3165438484,'XML Access Number:',1),(1412,1,2402760031,'Server:',1),(1413,1,3598087712,'Pickup Type:',1),(1414,1,1275046918,'Package Type:',1),(1415,1,1095994250,'Customer Classification',1),(1416,1,2862999173,'Select how your UPS account is classified.',1),(1417,1,806419272,'Please enter your USPS User ID:',1),(1418,1,2386614917,'Packing Slip',1),(1419,1,1625579401,'Packing slip for order #%%ORDERID%%',1),(1420,1,2571559162,'Consider orders placed in the last',1),(1421,1,1658504578,'Number of best sellers to display',1),(1422,1,760001896,'List by',1),(1423,1,3278654271,'Display',1),(1424,1,2488687378,'manufacturers',1),(1425,1,1896218232,'Number of new products to display',1),(1426,1,234900711,'Shipping address is the same as billing',1),(1427,1,858079896,'Add Item',1),(1428,1,1347538713,'Remove Item',1),(1429,1,2492926120,'Product options:',1),(1430,1,3909844064,'List Price:',1),(1431,1,3966210395,'Price:',1),(1432,1,1444368431,'Add to cart',1),(1433,1,2685524125,'Out of stock',1),(1434,1,1158486406,'Add Products',1),(1435,1,3567521997,'Product Name:',1),(1436,1,2020104747,'Filter',1),(1437,1,917550841,'include subcategories',1),(1438,1,1437113292,'Grand Total',1),(1439,1,2408483464,'Blast',1),(1440,1,213186513,'To be able to send newsletter in this language you have to fill the Subject field.',1),(1441,1,666948076,'Blast Newsletter',1),(1442,1,1565721205,'Subject:',1),(1443,1,762611188,'Message:',1),(1444,1,2676347204,'Send to customers:',1),(1445,1,2633172727,'Send to subscribers:',1),(1446,1,4061451667,'Blast Progress',1),(1447,1,426031496,'Stop',1),(1448,1,1124418244,'Start New Process',1),(1449,1,2755086305,'Blasting successfully completed.',1),(1450,1,2265563646,'Are you sure you want to start a new process?',1),(1451,1,2955059868,'Are you sure you want to stop this blast?',1),(1452,1,3129553589,'Newsletter Statistics',1),(1453,1,3147226886,'Blast Statistics',1),(1454,1,1485082975,'View Blast',1),(1455,1,3614080499,'Subscribe to newsletter:',1),(1456,1,2746901891,'Notify admin upon subscribe:',1),(1457,1,1642897459,'Create Newsletter',1),(1458,1,3168659782,'Add Newsletter',1),(1459,1,1094372775,'Edit Newsletter',1),(1460,1,3859046914,'Are you sure you wish to delete this newsletter?',1),(1461,1,2840697211,'Subscribers',1),(1462,1,2018365746,'Test',1),(1463,1,2525382830,'Stats',1),(1464,1,1590625456,'View',1),(1465,1,254338594,'Tested',1),(1466,1,747041944,'Test first',1),(1467,1,714700702,'Newsletter name...',1),(1468,1,2060057791,'Filter Newsletters',1),(1469,1,2453435967,'Show',1),(1470,1,879953894,'Subject',1),(1471,1,1475250567,'Emails Sent',1),(1472,1,3918409999,'Emails Opened',1),(1473,1,1493021949,'Email Clicks',1),(1474,1,2679662937,'Detailed Statistics',1),(1475,1,3504695945,'Detailed statistics',1),(1476,1,2571484763,'View blast',1),(1477,1,621797607,'Add Subscribers',1),(1478,1,3547385618,'Subscribers:',1),(1479,1,1079513077,'Subscriber emails separated by commas and/or new lines.',1),(1480,1,3310826759,'Add',1),(1481,1,2461995782,'Edit Subscriber',1),(1482,1,1191605410,'Are you sure you wish to delete this subscriber?',1),(1483,1,3687574047,'Filter Subscribers',1),(1484,1,2952046730,'Test Newsletter',1),(1485,1,1587199635,'Emails:',1),(1486,1,3858340892,'Send Test',1),(1487,1,2779812973,'Products Feed Options',1),(1488,1,2663971073,'Require key:',1),(1489,1,616075044,'Secret key:',1),(1490,1,506785837,'Generate link',1),(1491,1,3482811661,'Ratings and Reviews',1),(1492,1,1743133016,'Edit Rating and Reviews',1),(1493,1,4019184820,'IP Address:',1),(1494,1,4020385206,'Customer:',1),(1495,1,3323015556,'Review Content:',1),(1496,1,235652961,'Rating:',1),(1497,1,643703905,'Are you sure you wish to delete this rating?',1),(1498,1,3743752980,'Rating',1),(1499,1,2129626352,'Review',1),(1500,1,244298452,'Filter Ratings',1),(1501,1,4190646508,'Review Text...',1),(1502,1,2867445730,'IP Address...',1),(1503,1,17514069,'Ratings',1),(1504,1,1132259710,'Powered by',1),(1505,1,908066045,'Welcome %%CUSTOMERFIRSTNAME%% %%CUSTOMERLASTNAME%%!',1),(1506,1,312708084,'Log Out',1),(1507,1,1808393236,'Login',1),(1508,1,2794398274,'Register',1),(1509,1,1323996051,'Profile',1),(1510,1,3980130229,'Addresses',1),(1511,1,3432436168,'Add address',1),(1512,1,3673263359,'Edit address',1),(1513,1,86938300,'Are you sure you want to delete this address?',1),(1514,1,749705681,'Default Billing',1),(1515,1,3926602309,'Default Shipping',1),(1516,1,480959536,'Bundled items:',1),(1517,1,2891456104,'View Cart',1),(1518,1,961073464,'Continue Shopping',1),(1519,1,3421549997,'Apply coupon',1),(1520,1,1821239519,'Remove coupon',1),(1521,1,3850054737,'Empty Cart',1),(1522,1,782637220,'%%CATEGORYPRODUCTCOUNT%% product(s)',1),(1523,1,3592219198,'Subcategories',1),(1524,1,566031201,'Grid view',1),(1525,1,3134167193,'Featured products',1),(1526,1,2568203735,'<strong>Page %%PAGE%%</strong> of %%NUMPAGES%%',1),(1527,1,3768902734,'Show products comparison',1),(1528,1,1111523802,'List view',1),(1529,1,58290041,'Billing / Shipping Address',1),(1530,1,1490417553,'Billing / Shipping Methods',1),(1531,1,1343015364,'Confirmation',1),(1532,1,756315074,'Final',1),(1533,1,1879189093,'Checkout Failure',1),(1534,1,4020425545,'Your payment has been declined. Please try again.',1),(1535,1,3453780242,'Try Again',1),(1536,1,4045718410,'Checkout success',1),(1537,1,1210789654,'Thank you! Your order has been successfully processed, but your payment is still pending.',1),(1538,1,906094716,'Thank you! Your order has been successfully processed.',1),(1539,1,869314853,'Authentication',1),(1540,1,1805277448,'Register for checkout',1),(1541,1,3099258724,'Confirm Password:',1),(1542,1,822156319,'Security code:',1),(1543,1,1626898610,'Security code',1),(1544,1,847984313,'Reload the image',1),(1545,1,789590253,'Please enter the letters you see in the box. Doing so helps prevent automated programs from abusing this form.',1),(1546,1,3407541179,'Guest Checkout',1),(1547,1,2121996478,'If you use Guest Checkout there is no need to register. However you won\'t be able to see your past orders.',1),(1548,1,3307505785,'Optional email: ',1),(1549,1,2421870257,'* Please note that your email address will be used only to send you order notifications.',1),(1550,1,3362839566,'Address Information',1),(1551,1,1190439064,'Shipping Address',1),(1552,1,610800229,'Next Step',1),(1553,1,1797069372,'Select address',1),(1554,1,2317107991,'Confirm Order',1),(1555,1,2007405874,'Bill To',1),(1556,1,2944186042,'Ship To',1),(1557,1,2212487076,'Contact',1),(1558,1,2877914330,'Payment Method',1),(1559,1,1727468277,'Shippnig Method',1),(1560,1,994804795,'Cart information',1),(1561,1,4001707996,'I agree to the terms and conditions',1),(1562,1,2111172529,'Prev Step',1),(1563,1,4032482767,'Modify',1),(1564,1,3412837404,'Billing Method',1),(1565,1,4210788597,'Use bonus points.',1),(1566,1,3762971717,'Shipping Method',1),(1567,1,2591431184,'Special instructions?',1),(1568,1,30083613,'Bestsellers',1),(1569,1,442779427,'Shopping Cart',1),(1570,1,3355742105,'Cart is empty.',1),(1571,1,456003789,'Items:',1),(1572,1,2679332891,'Total:',1),(1573,1,2765451054,'View &amp; Checkout',1),(1574,1,4157704578,'Hello',1),(1575,1,1704413287,'Wishlist',1),(1576,1,982410204,'New Products',1),(1577,1,2154430034,'Recently Viewed',1),(1578,1,792727095,'Advanced Search',1),(1579,1,2784385862,'Forgotten Password',1),(1580,1,39256687,'Your email is:',1),(1581,1,1830307645,'Your password is:',1),(1582,1,1014130425,'Please follow <a href=\"%%HTTPS%%login.php\">this</a> link to login.',1),(1583,1,4065048850,'To reset your password follow this link:',1),(1584,1,2663571239,'Form submitted:',1),(1585,1,519137004,'You can download your purchases from the',1),(1586,1,376591614,'E-Goods delivery section',1),(1587,1,2129829755,'Please feel free to contact us:',1),(1588,1,2320060907,'To view this order details',1),(1589,1,626704452,'click here',1),(1590,1,4192191998,'There is important update about your order',1),(1591,1,2228299012,'has sent you an invitation to take a look at the following product:',1),(1592,1,1535433401,'Thank you for registering!',1),(1593,1,3313959608,'Your profile:',1),(1594,1,2619118453,'Error',1),(1595,1,2367234431,'An error has occurred during the processing of your request. If the error persist please contact the store owner.',1),(1596,1,2226783450,'<a href=\"http://www.summercart.com/\" target=\"_blank\">shopping cart software</a>',1),(1597,1,1429023383,'The password will be sent to your email address.',1),(1598,1,58328078,'Send password',1),(1599,1,1679901357,'New password:',1),(1600,1,1791768478,'Confirm new password:',1),(1601,1,1541818425,'Reset password',1),(1602,1,4158181270,'Your password was successfully reset.',1),(1603,1,3756970489,'Please procced to login.',1),(1604,1,2696799790,'Success',1),(1605,1,949859957,'Submit',1),(1606,1,2291548582,'Gallery',1),(1607,1,3504437773,'Welcome to our store!',1),(1608,1,3335690486,'Our Featured Products',1),(1609,1,909788852,'View details',1),(1610,1,1507512851,'Quantity:',1),(1611,1,57972069,'View all products from %%MANUFACTURERNAME%%',1),(1612,1,4142905463,'products found from',1),(1613,1,2027916259,'<b>Page %%PAGE%%</b> of %%NUMPAGES%%',1),(1614,1,2462686142,'Shipping info',1),(1615,1,570706577,'You paid in',1),(1616,1,3334723224,'Special instructions',1),(1617,1,3970606310,'Product Image',1),(1618,1,2171396134,'Download',1),(1619,1,3862370978,'My Orders',1),(1620,1,3541515099,'You do not have any orders yet.',1),(1621,1,3852454006,'Your points:',1),(1622,1,251134918,'Account Information',1),(1623,1,2438360217,'Leave blank to preserve current password.',1),(1624,1,686869563,'You currently have: ',1),(1625,1,2673283087,'Default Billing Address',1),(1626,1,2515100435,'Default Shipping Address',1),(1627,1,1600593306,'Back to My Orders',1),(1628,1,3714655035,'Summer Cart - Send To Friend',1),(1629,1,1198176300,'Your Name:',1),(1630,1,646681000,'Your Email:',1),(1631,1,2118475349,'Your Friend\'s Email:',1),(1632,1,2458683357,'Additional Notes:',1),(1633,1,121738739,'Send',1),(1634,1,2380011981,'Add to compare list',1),(1635,1,2729119880,'Remove from compare list',1),(1636,1,3664753648,'Weight:',1),(1637,1,4233714837,'Product options',1),(1638,1,2016129824,'Send to friend',1),(1639,1,1763323970,'Rate this product',1),(1640,1,2798506643,'Reviews',1),(1641,1,966531448,'Quantity discounts',1),(1642,1,2155498677,'Bundled Products',1),(1643,1,1070322242,'by',1),(1644,1,2403360959,'Registration Success',1),(1645,1,3287053070,'You will shortly receive an e-mail from us confirming your registration.',1),(1646,1,710245342,'Please enter your search criteria:',1),(1647,1,474009099,'Find Products Containing:',1),(1648,1,3028788705,'also search in products details',1),(1649,1,3275397312,'Product Code:',1),(1650,1,422055502,'From',1),(1651,1,1107555942,'To',1),(1652,1,3334958971,'Product Class:',1),(1653,1,872791843,'Modify search',1),(1654,1,3676457160,'PayPal Express Checkout',1),(1655,1,1474342248,'Confirm Payment',1),(1656,1,2900568731,'Latest News',1),(1657,1,1988906978,'RSS 2.0',1),(1658,1,3930643869,'Subscribe',1),(1659,1,1982922322,'View all news',1),(1660,1,3780062704,'Billing Method - Check',1),(1661,1,2643468480,'Billing Method - Credit Card',1),(1662,1,2302948229,'Please enter your 3 or 4 digit CVV / CVC code, if available.',1),(1663,1,3242636189,'Easypay.bg payment note',1),(1664,1,891620106,'Payment code',1),(1665,1,3862000488,'Billing Method - Credit / Debit Card',1),(1666,1,451678722,'Card Type:',1),(1667,1,2159650956,'Card Start:',1),(1668,1,2759988489,'(where available)',1),(1669,1,3570763641,'Issue Number:',1),(1670,1,1628353965,'(Older Switch cards only. 1 or 2 digits as printed on the card)',1),(1671,1,2358789045,'Card Issuer:',1),(1672,1,2794146439,'Cash',1),(1673,1,4076891506,'Compare Products',1),(1674,1,3434387737,'Some products in your list cannot be compared.',1),(1675,1,3174868567,'There are no products in your compare list.',1),(1676,1,723556371,'Remove product',1),(1677,1,733929904,'This product is incompatible.',1),(1678,1,356924018,'You need to have at least 2 products in your comparison list to see comparison.',1),(1679,1,247356116,'Show comparison',1),(1680,1,3027694245,'Enter your email to subscribe to %%NEWSLETTERNAME%%:',1),(1681,1,1707695583,'Please provide a valid email address.',1),(1682,1,116380646,'Thank you for subscribing for our newsletter \"%%NEWSLETTERNAME%%\".',1),(1683,1,1674439883,'If you don\'t want to recieve any more e-mails for \"%%NEWSLETTERNAME%%\", please enter your email address below and click \"Unsubscribe\".',1),(1684,1,602980313,'Unsubscribe',1),(1685,1,3231745282,'You have successfully unsubscribed.',1),(1686,1,1195251778,'Your name: (optional)',1),(1687,1,3340366533,'Write your review:',1),(1688,1,2360675507,'Rate this product:',1),(1689,1,3397765978,'Please wait',1),(1690,1,1435329933,'Create your own wishlist and send it to your friends to let them know what you need.',1),(1691,1,1919431210,'Type your friends\' e-mails separated by commas to send them your complete wishlist and let them know what you need.',1),(1692,1,778980276,'Remove from wishlist',1),(1693,1,4076650759,'Add to wishlist',1),(1694,1,971690898,'Access denied.',1),(1695,1,206424473,'Address successfully created.',1),(1696,1,3931780025,'Address successfully updated.',1),(1697,1,1988007368,'Address successfully deleted.',1),(1698,1,3033757558,'Default addresses successfully changed.',1),(1699,1,337247436,'My Addresses',1),(1700,1,1060537073,'All access levels',1),(1701,1,1643484871,'API Account',1),(1702,1,3978665514,'All statuses',1),(1703,1,910769710,'There is no customer with this email address.',1),(1704,1,974874717,'Box options',1),(1705,1,1654365787,'Unknown',1),(1706,1,1214010334,'Can\'t delete this type of box.',1),(1707,1,3427545285,' successfully deleted.',1),(1708,1,462477906,'Discounts: ',1),(1709,1,1969273851,' were automatically disabled to prevent unpredicted behaviour.',1),(1710,1,893657890,'Coupons: ',1),(1711,1,1286454575,'Checkout module',1),(1712,1,3484844198,'Store owner',1),(1713,1,4154148757,'Default country cannot be deleted.',1),(1714,1,2616533983,'Default country successfully set.',1),(1715,1,1673566086,'Require Valid City',1),(1716,1,2626115326,'Available Categories',1),(1717,1,158388602,'Selected Categories',1),(1718,1,4192083481,'Available Customer Groups',1),(1719,1,1904975299,'Selected Customer Groups',1),(1720,1,1662204468,'Coupon',1),(1721,1,1223637619,'All coupon types',1),(1722,1,2418076265,'Currency',1),(1723,1,799914036,'Invalid decimal.',1),(1724,1,359110422,'Default currency successfully set. Currency rates updated.',1),(1725,1,1622119860,'Currency rates updated.',1),(1726,1,2777361223,'Default currency cannot be deleted.',1),(1727,1,3484117332,'Default currency cannot be deactivated.',1),(1728,1,3606238423,'Expired',1),(1729,1,2273128141,'Symbol Left',1),(1730,1,311113914,'Symbol Right',1),(1731,1,2474211846,'Decimal Symbol',1),(1732,1,2412596371,'Thousands Separator',1),(1733,1,2900972917,'Number Decimals',1),(1734,1,1228535726,'Currency rate module',1),(1735,1,349111103,'All page types',1),(1736,1,3673409282,'Not current',1),(1737,1,323882391,'Current',1),(1738,1,765567539,'Url cannot be empty.',1),(1739,1,71930170,'Url already exists.',1),(1740,1,2992138442,'Field is empty.',1),(1741,1,1428478262,'Customer Group',1),(1742,1,4280560865,'Default customer group successfully set.',1),(1743,1,916359985,'Default customer group cannot be deleted.',1),(1744,1,1426270757,'Customer Group Name',1),(1745,1,3972781833,'All countries',1),(1746,1,3326678627,'All customer groups',1),(1747,1,3712848290,'This email is already registered.',1),(1748,1,3309684772,'Admin updated number of points.',1),(1749,1,2978604238,'The guest customer cannot be deleted.',1),(1750,1,3514388826,'Invalid integer.',1),(1751,1,1027349186,'First Name',1),(1752,1,2437538009,'Last Name',1),(1753,1,2147627219,'Company',1),(1754,1,4175916105,'Address 1',1),(1755,1,1643003379,'Address 2',1),(1756,1,2372513034,'City',1),(1757,1,1649606143,'State',1),(1758,1,2240723161,'Phone',1),(1759,1,2842594184,'Fax',1),(1760,1,1194661543,'Country ID',1),(1761,1,233403792,'State ID',1),(1762,1,412686884,'Other',1),(1763,1,2605367606,'All discount types',1),(1764,1,1724252194,'Dynamic page',1),(1765,1,2245059026,'via php mail() fuction',1),(1766,1,3459792051,'via SMTP server',1),(1767,1,3751981041,'None',1),(1768,1,2135378647,'SSL',1),(1769,1,979001145,'TLS',1),(1770,1,1928099550,'Summer Cart test email',1),(1771,1,2494957135,'Data updated but couldn\'t send email to %s. Please check the setup.',1),(1772,1,3429979993,'Data updated and email was successfully sent to %s.',1),(1773,1,281341089,'Featured product',1),(1774,1,987936391,'Featured in',1),(1775,1,1195630948,'HOME',1),(1776,1,1544782654,'This product is already featured.',1),(1777,1,2447820944,'Create a product first.',1),(1778,1,4072297073,'Form',1),(1779,1,3294903477,'Confirm text',1),(1780,1,3336299507,'Enable captcha',1),(1781,1,1891647104,'No images selected.',1),(1782,1,2519533548,'Successfully imported %d images.',1),(1783,1,4021789044,'Gallery item',1),(1784,1,2612594937,'Text',1),(1785,1,1954655468,'No file uploaded.',1),(1786,1,1324475515,'Error during upload (error code %d).',1),(1787,1,311012738,'Cannot open file %s.',1),(1788,1,506301268,'Import failed! Reason: ',1),(1789,1,1073345337,'Partial success. %d products imported, %d products updated. Import stopped on line #%d with message: ',1),(1790,1,468324764,'Import successful.',1),(1791,1,2100858350,'All found images imported successfully.',1),(1792,1,765083125,'Unknown header \"%s\".',1),(1793,1,3929581076,'Unable to copy \"%s\" to \"%s\".',1),(1794,1,829264720,'Product with SKU \"%s\" already exists!',1),(1795,1,2438984671,'Category \"%s\" not found.',1),(1796,1,1582254705,'Default Layout not set.',1),(1797,1,4089697667,'Manufacturer \"%s\" not found.',1),(1798,1,1044163623,'Product class \"%s\" not found.',1),(1799,1,3633141250,'System requirements',1),(1800,1,2564148613,'License',1),(1801,1,709512653,'Directory permissions',1),(1802,1,93151306,'Not approved',1),(1803,1,2233580107,'Approved',1),(1804,1,2644336511,'Successfully updated language texts.',1),(1805,1,3414354415,'Default language successfully set.',1),(1806,1,3507618035,'Default language cannot be deleted.',1),(1807,1,2655559150,'Default language cannot be deactivated.',1),(1808,1,784760254,'Could not create language pack.',1),(1809,1,445195722,'The uploaded file is too large (%s bytes).',1),(1810,1,2015382419,'Please upload file.',1),(1811,1,1207227239,'You should upload language pack file (.zip).',1),(1812,1,2956520505,'Error processing \"%s\": %s',1),(1813,1,1061572800,'Cound not find langpack.xml in the language pack archive.',1),(1814,1,2677450897,'Language with code \"%s\" already exists.',1),(1815,1,2697320117,'Cannot find image file \"%s\" in the language pack archive.',1),(1816,1,1441564075,'Uploaded XLIFF filename \"%s\" is invalid.',1),(1817,1,4057922485,'Error uploading the file: %s (error code %s).',1),(1818,1,342401503,'Internal error.',1),(1819,1,1897767757,'The uploaded file is empty.',1),(1820,1,4151929386,'You should upload translation file (.xlf).',1),(1821,1,3838021215,'%d%% translated',1),(1822,1,3166393104,'Direction',1),(1823,1,778796279,'Language Pack Author',1),(1824,1,1079379558,'Language Pack Description',1),(1825,1,3785170304,'Language Pack License',1),(1826,1,3589568588,'Language Pack Publish Date',1),(1827,1,662578726,'Available',1),(1828,1,647256362,'Top',1),(1829,1,3663022166,'Left',1),(1830,1,1963678224,'Right',1),(1831,1,2398320530,'Bottom',1),(1832,1,3685643230,'Failed to save boxes layout: ',1),(1833,1,3119399505,'Default layout successfully changed.',1),(1834,1,1593855280,'To delete this layout, no dynamic pages, categories or rich text pages should refer to it.',1),(1835,1,3959000229,'All categories',1),(1836,1,716071528,'All severities',1),(1837,1,2142461233,'Please enter username and password!',1),(1838,1,1315737212,'Invalid username and/or password. Please try again.',1),(1839,1,2495292229,'Your account has been disabled.',1),(1840,1,774316269,'Menu item',1),(1841,1,3060702529,'Option group',1),(1842,1,3130920691,'Order status',1),(1843,1,706177376,'This status cannot be disabled.',1),(1844,1,4262583638,'Sending notifications for this status cannot be disabled.',1),(1845,1,1148841405,'Cannot delete predefined order status \"%s\".',1),(1846,1,2909636378,'There are orders with status \"%s\". You cannot delete it.',1),(1847,1,437395479,'Order total module',1),(1848,1,4087417155,'Subtotal must always precede other order total modules.',1),(1849,1,2472366501,'Selected order deleted successfully!',1),(1850,1,1258584605,'Order statuses updated successfully!',1),(1851,1,2277936408,'Order not found.',1),(1852,1,1060205392,'Error occured: %s',1),(1853,1,2255065229,'You can not bulk print PDF packing slips.',1),(1854,1,1534955588,'Note too short.',1),(1855,1,884912915,'Note added successfully, but problem occurred when sending the note email.',1),(1856,1,1847838487,'Note added successfully, but there is no customer email.',1),(1857,1,2924919114,'Note added successfully, but the order department email is not set.',1),(1858,1,2680044958,'Note added successfully.',1),(1859,1,2978673432,'Error occurred while adding the note.',1),(1860,1,3269079827,'Note deleted successfully.',1),(1861,1,3735730144,'Credit card number and CVV discarded successfully.',1),(1862,1,2256931719,'Unable to display the e-goods.',1),(1863,1,67482292,'Unable to send e-goods notification e-mail.',1),(1864,1,3667787196,'E-Goods notification email sent successfully.',1),(1865,1,1170936893,'Error occurred while sending e-goods notification email: \"%s\".',1),(1866,1,3304927357,'E-Good status successfully updated.',1),(1867,1,2005744939,'Cannot find payment module.',1),(1868,1,64071581,'Exception: ',1),(1869,1,1840034131,'Unknown operation.',1),(1870,1,4267206052,'Payment module',1),(1871,1,1419919011,'Plugin successfully installed.',1),(1872,1,762253123,'PHP extension ZIP is not installed. Please contact your hosting provider to enable it.',1),(1873,1,1983809766,'Cannot read ZIP archive. Error %d: %s',1),(1874,1,2476158058,'Could not create folder \"%s\"',1),(1875,1,2932655328,'File \"%s\" already exists.',1),(1876,1,3392287738,'Cannot open ZIP archive entry.',1),(1877,1,3525337433,'The uploaded file is not an image.',1),(1878,1,3648249677,'Cannot save the uploaded file!',1),(1879,1,3068422154,'Please upload an image.',1),(1880,1,2833957309,'Select a Category',1),(1881,1,3705767946,'All manufacturers',1),(1882,1,998618569,'All product classes',1),(1883,1,895607553,'A product bundle must have subproducts.',1),(1884,1,1452315037,'All bundled products must have a minimum quantity of 1.',1),(1885,1,2642524106,'A product bundle can contain other bundles but cannot contain itself.',1),(1886,1,4060421234,'A product bundle cannot have variant options.',1),(1887,1,4111963927,'Invalid number.',1),(1888,1,2418193025,'Create a category first.',1),(1889,1,3039632037,'Product Is E-Good',1),(1890,1,747255451,'Class',1),(1891,1,3465050114,'Quick link',1),(1892,1,299357700,'Unknown Report',1),(1893,1,3938568113,'Rich text page',1),(1894,1,829950261,'Content',1),(1895,1,3046866235,'Shipping module',1),(1896,1,3465572544,'This shipping module must have one instance and cannot be added.',1),(1897,1,3580000547,'Shipping module successfully created. Please setup the module.',1),(1898,1,695430002,'This shipping module must have one instance and cannot be deleted.',1),(1899,1,4188760814,'Shipping zone',1),(1900,1,2501974536,'Available Countries',1),(1901,1,3723238592,'Selected Countries',1),(1902,1,3554809502,'Available States',1),(1903,1,1478574432,'Selected States',1),(1904,1,521597972,'Cannot create directory \"%s\".',1),(1905,1,3947037298,'Skin selection',1),(1906,1,3732254855,'Skin location \"%s\" is not a valid directory.',1),(1907,1,31452408,'Skin description \"%s\" not found.',1),(1908,1,1311354019,'Unable to read skin description \"%s\".',1),(1909,1,3052803159,'The skin \"%s\" is for another version of the software.',1),(1910,1,548770039,'Automatically installed %d skin(s).',1),(1911,1,4139653556,'Cannot read \"skin.xml\".',1),(1912,1,2887437011,'Skin installed successfully.',1),(1913,1,1326475003,'Activate',1),(1914,1,1998283438,'State Code',1),(1915,1,649384201,'Tax class',1),(1916,1,2401985450,'Tax rates',1),(1917,1,2273774407,'You need to define tax classes and tax zones first.',1),(1918,1,1049680567,'Tax zone',1),(1919,1,3066887318,'Tax',1),(1920,1,2848081516,'Coupon applied.',1),(1921,1,2659381137,'Coupon removed.',1),(1922,1,612906988,'Cannot find category.',1),(1923,1,3760882688,'Unknown module name: \"%s\".',1),(1924,1,1658215604,'You are not allowed to view order %d!',1),(1925,1,2072252968,'Checkout Final',1),(1926,1,567520697,'The page that you have requested cannot be found. You will be redirected to the home page in 2 seconds.',1),(1927,1,1365745153,'Please enter email.',1),(1928,1,35798503,'Email not found. Please try again.',1),(1929,1,478502169,'Your password has been sent to %s. Please check your mail.',1),(1930,1,4210502971,'You have already changed your password.',1),(1931,1,2736803437,'Passwords mismatch.',1),(1932,1,500224504,'View form failed: ',1),(1933,1,2067417858,'Security code does not match.',1),(1934,1,4247598002,'Cannot find gallery.',1),(1935,1,2939161884,'Access denied! This operation is disallowed in Summer Cart demo.',1),(1936,1,2851240815,'Module option \"%s\" is not set. Please setup \"%s\" module.',1),(1937,1,3794871534,'No print fields selected.',1),(1938,1,521872670,'item',1),(1939,1,3776899405,'items',1),(1940,1,3469939714,'Category views',1),(1941,1,2211971065,'Product sales',1),(1942,1,4188410682,'Product views',1),(1943,1,3800588496,'You cannot delete the account you are currently logged in with.',1),(1944,1,246908558,'You cannot limit and/or disable the only full access account.',1),(1945,1,4197307457,'There are customers having their billing and/or shipping address in this country.',1),(1946,1,3355634220,'Rich Text Page',1),(1947,1,3337924380,'Dynamic Page',1),(1948,1,4060101575,'Customer\'s last address cannot be deleted.',1),(1949,1,976736592,'To delete this customer group, no customers should be assigned to it.',1),(1950,1,3520615993,'File \"%s\" not found.',1),(1951,1,3326180459,'Could not create gallery directory.',1),(1952,1,1961186936,'Could not create gallery images directory.',1),(1953,1,2776549596,'Could not create gallery thumbnails directory.',1),(1954,1,2733256268,'Gallery renaming failed: duplicate directory name.',1),(1955,1,3209771303,'Gallery renaming failed.',1),(1956,1,821124640,'Left-to-right',1),(1957,1,609036854,'Right-to-left',1),(1958,1,2495182195,'You cannot disable the only active language.',1),(1959,1,1104553861,'Menu ',1),(1960,1,3544640745,'Could not send new order email for order %s.',1),(1961,1,1966796274,'New order',1),(1962,1,2188138777,'Based on spent amount for order %s.',1),(1963,1,1252764064,'Referred customer %s.',1),(1964,1,2216265504,'Maximum number of downloads reached.',1),(1965,1,3487080762,'E-Good download link has expired.',1),(1966,1,2021271368,'E-Good is locked.',1),(1967,1,46009503,'There are products of this product class.',1),(1968,1,2066183052,'Product \"%s\" found as bundled product. This would cause recursive dependency.',1),(1969,1,2372983258,'Original image not found. Product ID: %s.',1),(1970,1,2699549413,'Original variant image not found. Product ID: %s',1),(1971,1,741113889,'To delete this shipping zone, no shipping modules should refer to it.',1),(1972,1,672387575,'This Month',1),(1973,1,2551559645,'Last Month',1),(1974,1,2719278482,'This Year',1),(1975,1,1961422312,'Last Year',1),(1976,1,3576125411,'Copying e-good file failed.',1),(1977,1,1440618055,'Moving e-good files failed.',1),(1978,1,2751018395,'Duplicating image failed: ',1),(1979,1,1885574410,'Failed to delete image \"%s\".',1),(1980,1,3854097274,'Thumb copying from \"%s\" to \"%s\" failed.',1),(1981,1,942111230,'Image copying from \"%s\" to \"%s\" failed.',1),(1982,1,2928828387,'Unknown (%s)',1),(1983,1,4153723213,'Payment Module ',1),(1984,1,3102305494,'Page Views / Unique Visits',1),(1985,1,60420241,'Page Views',1),(1986,1,3328718076,'Unique Visitors',1),(1987,1,3589852710,'Number of orders',1),(1988,1,769758617,'Customer country',1),(1989,1,1989299678,'Shipping costs',1),(1990,1,2975766011,'Payment costs',1),(1991,1,2211629218,'Number of items',1),(1992,1,3178665876,'Category Name',1),(1993,1,1617569995,'-Empty name-',1),(1994,1,3723325296,'Day',1),(1995,1,4217947902,'Week',1),(1996,1,1333214978,'Month',1),(1997,1,3543980187,'Quarter',1),(1998,1,464575497,'Year',1),(1999,1,26566655,'Summary',1),(2000,1,1331463278,'Daily',1),(2001,1,1500557074,'Weekly',1),(2002,1,622395140,'Monthly',1),(2003,1,3153405383,'Quarterly',1),(2004,1,4293902794,'Yearly',1),(2005,1,1419823037,'Jan',1),(2006,1,811644918,'Feb',1),(2007,1,1173261687,'Mar',1),(2008,1,523065091,'Apr',1),(2009,1,3527169279,'May',1),(2010,1,2047742184,'Jun',1),(2011,1,2483057092,'Jul',1),(2012,1,260523949,'Aug',1),(2013,1,3644106533,'Sep',1),(2014,1,2638192302,'Oct',1),(2015,1,3729185465,'Nov',1),(2016,1,1155748622,'Dec',1),(2017,1,1571557308,'Curl request failed for \"%s\". Response code \"%d\".',1),(2018,1,3673143881,'File \"%s\" is not an image.',1),(2019,1,1325301612,'Image copying failed.',1),(2020,1,606702645,'Invalid image format.',1),(2021,1,3243865366,'Image resizing failed.',1),(2022,1,4273361783,'The destination directory \"%s\" cannot be created.',1),(2023,1,4017556963,'\"%s\" is not a directory.',1),(2024,1,2065388674,'\"%s\" is not writable.',1),(2025,1,134666524,'Image write error.',1),(2026,1,4057668941,'Summer Cart is not licensed for this website. Please obtain a valid license.<br/><a href=\"http://www.summercart.com/\" target=\"_blank\">Buy License</a> | <a href=\"license.php\">License Info</a>',1),(2027,1,1659361011,'Summer Cart is not activated. The store functionality will be limited.<br/> <a href=\"#\">Activate Now</a>',1),(2028,1,3301984207,'Summer Cart has been activated for another server. The store functionality will be limited.<br/> <a href=\"#\">Reactivate Now</a>',1),(2029,1,687696898,'Folder \"%s\" cannot be created. You might not be able to upload images. <a href=\"#\">Help</a>',1),(2030,1,2187267186,'Folder \"%s\" is not writable. You might not be able to upload images. <a href=\"#\">Help</a>',1),(2031,1,10074882,'Cannot write to \"%s\". Your e-goods will not be secure. <a href=\"#\">Help</a>',1),(2032,1,1322276977,'PHP version is too old. Summer Cart needs at least PHP version 5.1.',1),(2033,1,1035921460,'Safe mode must be off.',1),(2034,1,79325551,'php.ini option file_uploads must be on.',1),(2035,1,1349081457,'PHP extension \"%s\" is required.',1),(2036,1,3687500167,'GIF support is required.',1),(2037,1,3476745476,'JPEG support is required.',1),(2038,1,4096294307,'PNG support is required.',1),(2039,1,3083089325,'Expires today',1),(2040,1,1362021340,'Expires in 1 day',1),(2041,1,3637722135,'Expires in %d days',1),(2042,1,2922609053,'Critical',1),(2043,1,2415109466,'Warning',1),(2044,1,2909038755,'Debug',1),(2045,1,606498454,'Currency rates',1),(2046,1,1565131615,'Directory %s does not exist!',1),(2047,1,2084164920,'Directory %s is not writtable!',1),(2048,1,2728886836,'The free disk space is low. You have %s bytes free space (%2.2f%% of total).',1),(2049,1,934284482,'Registered customers only',1),(2050,1,3415746634,'Only customers that have bought the product',1),(2051,1,3136150270,'No one',1),(2052,1,2302751552,'(page %s of %s)',1),(2053,1,2106068149,'Disabled',1),(2054,1,387805115,'Limited',1),(2055,1,129195397,'Full Access',1),(2056,1,4247900106,'Product Class Attribute',1),(2057,1,2185697575,'Product Class Attribute Value',1),(2058,1,1070217018,'Product Attribute',1),(2059,1,1377533868,'Bundle Product',1),(2060,1,1481202745,'Local Option',1),(2061,1,3160476386,'Customer Address',1),(2062,1,95021649,'Cleartext',1),(2063,1,2243593445,'Secure one-way hash (salted HMAC-SHA1)',1),(2064,1,413329838,'Products Option Groups',1),(2065,1,1885055086,'Import / Export',1),(2066,1,1354590562,'Logs',1),(2067,1,2361144370,'Locations and Taxes',1),(2068,1,2906653211,'Store Configuration',1),(2069,1,1427690073,'Languages and Currencies',1),(2070,1,3174898911,'You already used a coupon.',1),(2071,1,2890332796,'Not all conditions for this coupon are met.',1),(2072,1,3958051832,'Coupon module is not active.',1),(2073,1,1988732736,'\"%s\" is only available for registered customers.',1),(2074,1,1249500137,'You have insufficient bonus points.',1),(2075,1,1845102359,'Retrieving weight of intangible item.',1),(2076,1,2519874081,'There are only %d \"%s\" left.',1),(2077,1,2892561836,'\"%s\" is out of stock.',1),(2078,1,3298488485,'Invalid product option.',1),(2079,1,2386879254,'Only image uploads are accepted.',1),(2080,1,2166328991,'Please upload image.',1),(2081,1,1518930363,'Please enter text.',1),(2082,1,3997504040,'Invalid product.',1),(2083,1,2082714463,'Invalid product variant.',1),(2084,1,4244972103,'Order total module exception: \"%s\".',1),(2085,1,4043964841,'Products & Categories',1),(2086,1,3474686068,'Languages & Currencies',1),(2087,1,178379105,'Product List',1),(2088,1,3045310965,'Import/Export Catalog',1),(2089,1,3786787441,'Pages',1),(2090,1,2808863634,'Reports Center',1),(2091,1,4255372828,'Skin Settings',1),(2092,1,853338739,'Import Images',1),(2093,1,3263330688,'Customers Countries',1),(2094,1,1894666010,'Order Payment Methods',1),(2095,1,1441221385,'Order Shipping Methods',1),(2096,1,2170361627,'System Box',1),(2097,1,1651446388,'Menu Box',1),(2098,1,1127429936,'XHTML Box',1),(2099,1,653914245,'Newsletter Box',1),(2100,1,1619415391,'Base',1),(2101,1,1124959784,'Multiline Text',1),(2102,1,3876416187,'Checkbox',1),(2103,1,1938514344,'Radio Buttons',1),(2104,1,3636078245,'Drop-Down List',1),(2105,1,3199764228,'Specific',1),(2106,1,2436635234,'Number',1),(2107,1,857141173,'File upload',1),(2108,1,3531875685,'Custom HTML',1),(2109,1,1776201207,'Header',1),(2110,1,352538411,'Separator',1),(2111,1,544785870,'No image',1),(2112,1,512670514,'Predefined image',1),(2113,1,3832912090,'Custom image',1),(2114,1,3895991404,'Skin not found.',1),(2115,1,2914208189,'Skin location \"%s\" is invalid.',1),(2116,1,3366602241,'Cannot find column template!',1),(2117,1,820252378,'Box',1),(2118,1,658583250,'Fast Menu',1),(2119,1,3852271717,'Footer',1),(2120,1,3221496229,'Missing CMSBoxID when getting box menu items!',1),(2121,1,3863017503,'Currency not found.',1),(2122,1,317351350,'Cannot update rate for %s to %s.',1),(2123,1,720872515,'Error from module \"%s\": %s.',1),(2124,1,21006379,'Cannot find default currency.',1),(2125,1,998958233,'Money only',1),(2126,1,1825210422,'Points and money',1),(2127,1,2478440028,'Points only',1),(2128,1,1939374383,'Earn',1),(2129,1,756222009,'Spend',1),(2130,1,459817765,'Pending',1),(2131,1,2749143752,'7 days',1),(2132,1,201091938,'30 days',1),(2133,1,3799853467,'Return points.',1),(2134,1,3112438038,'Guest customer not found.',1),(2135,1,4288268905,'Free Shipping',1),(2136,1,1307767082,'Per product',1),(2137,1,4195381753,'Per product quantity',1),(2138,1,3695383545,'To subtotal',1),(2139,1,3085648491,'Information for product',1),(2140,1,3772192490,'Unknown product id \"%s\".',1),(2141,1,3659740162,'Signup notification',1),(2142,1,1447205245,'Form: %s',1),(2143,1,2968891335,'Cannot send new order notification - customer email is missing.',1),(2144,1,3772435740,'Cannot send new order notification - customer and administrator emails are missing.',1),(2145,1,671016963,'Thank you for ordering!',1),(2146,1,2462374820,'Your order will be fulfilled as soon as possible.',1),(2147,1,2383097839,'New order #',1),(2148,1,1274645748,'No E-Goods to send.',1),(2149,1,2159688091,'Cannot deliver E-Goods - customer email is missing.',1),(2150,1,1190481691,'E-Goods delivery for order #%s',1),(2151,1,3563440502,'Administrative note for order #',1),(2152,1,1532224661,'Order status changed to \"%s\".',1),(2153,1,1115676460,'Order #%s status changed',1),(2154,1,2925959239,'No error.',1),(2155,1,1323556796,'File size exceeds the upload_max_filesize directive in php.ini.',1),(2156,1,2000894469,'The uploaded file exceeds the maximum upload file size.',1),(2157,1,2774220693,'The uploaded file was only partially uploaded.',1),(2158,1,3406465656,'Missing temporary folder.',1),(2159,1,2410278471,'Failed to write file to disk.',1),(2160,1,2302500411,'File upload stopped by extension.',1),(2161,1,4225751778,'Unknown error.',1),(2162,1,1714678657,'GB',1),(2163,1,2631664395,'MB',1),(2164,1,3397821581,'KB',1),(2165,1,1952198132,'Default language is not set!',1),(2166,1,2963564181,'Expected target language code \"%s\", but found \"%s\".',1),(2167,1,1065373100,'Could not find langauge with language code %s.',1),(2168,1,2347183978,'Unknown option field %s.',1),(2169,1,2761744303,'Invalid module classes definitions.',1),(2170,1,2298128384,'Cannot find implementation for %s, ModuleID %s.',1),(2171,1,3245286568,'Trying to load class \"%s\" that does not exist.',1),(2172,1,3238758531,'Trying to load class \"%s\" that have ambiguous name.',1),(2173,1,1847543081,'Cannot find module file %s.',1),(2174,1,279504134,'Cannot find module class %s in file %s.',1),(2175,1,2556760663,'Module not found.',1),(2176,1,988886446,'Cannot load shipping module id %s. Error: \"%s\".',1),(2177,1,3288027779,'Reserve quantities',1),(2178,1,2972889638,'Do nothing',1),(2179,1,3524378733,'Return quantities to stock',1),(2180,1,2090210153,'Cannot find shipping module with ShippingModuleID \"%s\"!',1),(2181,1,4143372495,'Cannot find shipping module name for ShippingModuleID \"%s\".',1),(2182,1,907459679,'Unknown shipping method \"%s\" for shipping module \"%s\".',1),(2183,1,3983654493,'Cannot find payment module with PaymentModuleID \"%s\".',1),(2184,1,4154823801,'Cannot find checkout module with CheckoutModuleID \"%s\".',1),(2185,1,2306327481,'No address',1),(2186,1,809146176,'Not applicable',1),(2187,1,4005971042,'Unavailable',1),(2188,1,2198393684,'Unavailable - timeout',1),(2189,1,38979051,'Not supported',1),(2190,1,2669544596,'No match',1),(2191,1,2574025683,'Zip match',1),(2192,1,2709164901,'Street match',1),(2193,1,3130867008,'Full match',1),(2194,1,160801151,'Intl - not supported',1),(2195,1,3331178104,'Intl - no match',1),(2196,1,1232421026,'Intl - postal code match',1),(2197,1,3183552170,'Intl - street match',1),(2198,1,1675788961,'Intl - full match',1),(2199,1,3147491841,'Match',1),(2200,1,1358543466,'Not available',1),(2201,1,3882939189,'Not submitted',1),(2202,1,3812260290,'US Checks',1),(2203,1,1281643356,'UK Checks',1),(2204,1,2135669230,'Checking',1),(2205,1,3720111745,'Savings',1),(2206,1,1093252924,'ABA Routing Number:',1),(2207,1,784571595,'Sort Code:',1),(2208,1,2460243919,'Processing payment exception: ',1),(2209,1,3764852828,'Details:',1),(2210,1,645800559,'Redirecting to payment processor...',1),(2211,1,2908525122,'Payment Process',1),(2212,1,2245602422,'Currency code mismatch.',1),(2213,1,250637667,'OrderID',1),(2214,1,2063252635,'Received currency',1),(2215,1,556738789,'Expected currency',1),(2216,1,465800015,'Payment amount mismatch.',1),(2217,1,2554316093,'Received amount',1),(2218,1,2038651890,'Expected amount',1),(2219,1,2285410388,'Missing param \"%s\".',1),(2220,1,1744188893,'Pending payment info from processor',1),(2221,1,2515268484,'Declined',1),(2222,1,1491869543,'Auth',1),(2223,1,1611532643,'Partial Refund',1),(2224,1,514019258,'Chargeback',1),(2225,1,396418990,'Offline',1),(2226,1,986607068,'Partial Capture',1),(2227,1,423320567,'Cannot find OrderID with TransactionCode=%s and ModuleID=%s.',1),(2228,1,1090077381,'Multi-Language Text',1),(2229,1,4047669267,'Multiple Select',1),(2230,1,844974025,'No validator',1),(2231,1,3782412241,'Not selected',1),(2232,1,729257526,'Price modifier',1),(2233,1,1056867889,'Variant',1),(2234,1,1394044103,'User Image',1),(2235,1,407613837,'User Text',1),(2236,1,2480034857,'Cannot find product.',1),(2237,1,3801695625,'Keep selling',1),(2238,1,529233592,'Hide product',1),(2239,1,2922029292,'\"Out of stock\" tag',1),(2240,1,298651342,'Sort by relevance',1),(2241,1,4236668364,'Sort by price (low to high)',1),(2242,1,2206108970,'Sort by price (high to low)',1),(2243,1,1594729176,'Sort by product name',1),(2244,1,1983638598,'Sort by product code',1),(2245,1,1614702293,'Kgs',1),(2246,1,403080213,'Lbs',1),(2247,1,1281633745,'SEO Keywords',1),(2248,1,2401170763,'SEO Description',1),(2249,1,1856554936,'Billing first name',1),(2250,1,779633653,'Billing last name',1),(2251,1,3643031354,'Billing company',1),(2252,1,569783891,'Shipping first name',1),(2253,1,2944137814,'Shipping last name',1),(2254,1,3417896906,'Shipping company',1),(2255,1,2572074719,'Product code',1),(2256,1,3174173637,'Order Status',1),(2257,1,256217995,'Cannot find tax record.',1),(2258,1,3634676075,'Invalid VAT number.',1),(2259,1,1961341087,'There are errors with the form below.<br/>Please correct them and resubmit.',1),(2260,1,3020941352,'There is an error with the form below.<br/>Please correct it and resubmit.',1),(2261,1,4223270794,'Previous',1),(2262,1,2991817930,'%d more address',1),(2263,1,1268737845,'%d more addresses',1),(2264,1,1404092755,'First',1),(2265,1,3941140126,'Last',1),(2266,1,2072815210,'Records per page',1),(2267,1,2286432583,'Choose',1),(2268,1,2261280103,'No minValue property is specified for field %s.',1),(2269,1,374970102,'The value must be no smaller than %d.',1),(2270,1,2961549300,'No maxValue property is specified for field %s.',1),(2271,1,1003243756,'The value must be no bigger than %d.',1),(2272,1,217690918,'Invalid email format.',1),(2273,1,3322238850,'Not unique.',1),(2274,1,1411741488,'Invalid http url.',1),(2275,1,2233986892,'\"existsIn\" property must be specified for field %s.',1),(2276,1,290530147,'Record does not exist.',1),(2277,1,3176614794,'The selected currency is not defined. You can define new currencies using the Currencies management screen.',1),(2278,1,4140752483,'A shipping method has to be selected.',1),(2279,1,3613250963,'Value cannot be empty.',1),(2280,1,2108643981,'Please enter a valid city name.',1),(2281,1,2627246759,'Record',1),(2282,1,3688544399,'%s successfully created.',1),(2283,1,1036862127,'%s successfully updated.',1),(2284,1,2716460254,'%s successfully deleted.',1),(2285,1,4031308951,'Names are required to be set for all active menus.',1),(2286,1,3847004789,'-- Top Level --',1),(2287,1,2880630370,'\"%s\" can only be bought using points.',1),(2288,1,3619229128,'There are no available billing methods for your order!',1),(2289,1,1923584595,'Unknown billing method selected.',1),(2290,1,3416367529,'From %s: %s.',1),(2291,1,3519133715,'Exception \"%s\".',1),(2292,1,3978063606,'Free',1),(2293,1,2241996831,'Notices:<br/>',1),(2294,1,3749391800,'There are no available shipping methods for your order!',1),(2295,1,2905832602,'Invalid date format.',1),(2296,1,238049363,'This module has no options.',1),(2297,1,2376570436,'Options template file not set.',1),(2298,1,489853662,'Too many control variables.',1),(2299,1,1556001108,'Any',1),(2300,1,1890732172,'Invalid quantity.',1),(2301,1,3503465937,'Duplicate quantity.',1),(2302,1,31134505,'Invalid amount.',1),(2303,1,2806581010,'First row quantity must be 1.',1),(2304,1,2163897815,'Delete Image',1),(2305,1,3094486824,'Country and VAT number country do not match. Your VAT number should start with %s.',1),(2306,1,2455112543,'Cart must contain at least one item.',1),(2307,1,462582378,'Error processing your request: ',1),(2308,1,3823642818,'Wizard exception: ',1),(2309,1,2254663015,'Please enter e-mail and password.',1),(2310,1,3161538148,'Cannot find manufacturer.',1),(2311,1,844478805,'Module not found: ',1),(2312,1,4204349676,'Merchat ID or Merchant Key do not match.',1),(2313,1,4278307332,'Google Checkout Exception: ',1),(2314,1,694481955,'Tax zone \"%s\" cannot be used in Google Checkout.',1),(2315,1,2467941403,'Google Checkout supports only one tax class per product.',1),(2316,1,1909915985,'Google Checkout error: \"%s\".',1),(2317,1,2628825648,'Production',1),(2318,1,693618939,'Sandbox',1),(2319,1,345221533,'Shipping cost currency mismatch. Expected \"%s\", found \"%s\".',1),(2320,1,1078094406,'Tax currency mismatch. Expected \"%s\", found \"%s\".',1),(2321,1,2593546886,'New fulfillment state: %s.',1),(2322,1,2169159268,'Eligible for protection: %s.',1),(2323,1,1298284562,'Account age: %d days.',1),(2324,1,2810099095,'IP address: ',1),(2325,1,3604752062,'Total: %s %s',1),(2326,1,2492447259,'Auth Expiration %s',1),(2327,1,923861602,'Unknown Google Checkout notification: %s',1),(2328,1,3951170399,'Unknown payment status.',1),(2329,1,3594121633,'Order already paid.',1),(2330,1,2272013587,'Static',1),(2331,1,2216047400,'Dynamic',1),(2332,1,3895911047,'PayPal notification validation failed.',1),(2333,1,348570661,'Result',1),(2334,1,4022760396,'Test IPN to live system.',1),(2335,1,981519419,'Invalid username or password.',1),(2336,1,3232414853,'Exception during login: ',1),(2337,1,1381658824,'Passwords do not match!',1),(2338,1,2004258259,'Exception during register: ',1),(2339,1,171087513,'Guest checkout is not enabled.',1),(2340,1,69326121,'Exception during checkout: ',1),(2341,1,1685420733,'Proceed to payment',1),(2342,1,1513996144,'Finalize order',1),(2343,1,334391769,'Please agree to the terms.',1),(2344,1,3217002174,'Exception during processing payment: ',1),(2345,1,635515012,'New address',1),(2346,1,2416563426,'C.O.D. fee',1),(2347,1,1686551835,'Coupon %s',1),(2348,1,2012040438,'Invalid coupon.',1),(2349,1,1084554444,'%s bonus points',1),(2350,1,1440107854,'Invalid ShippingModuleID.',1),(2351,1,1351567222,'Exception from shipping module %s: %s.',1),(2352,1,2979398362,'No shipping rates for the selected shipping module %s.',1),(2353,1,1671436555,'No shipping rate for the selected shipping method \"%s\". Shipping module \"%s\".',1),(2354,1,1105882322,'Subtotal',1),(2355,1,901155661,'Tax %s',1),(2356,1,1508301426,'Invalid 2Checkout key. Please check you Secret Word.',1),(2357,1,2161169993,'Order in demo mode.',1),(2358,1,2749440435,'Unknown processing code.',1),(2359,1,3886614059,'Processing Code',1),(2360,1,4170617483,'Payment cancelled by customer.',1),(2361,1,618085942,'Payment failed.',1),(2362,1,779453244,'Processing error.',1),(2363,1,3011160535,'Response Code',1),(2364,1,2833827248,'Response Subcode',1),(2365,1,3449546607,'Response Reason Text',1),(2366,1,2164617264,'Response Reason Code',1),(2367,1,1110416711,'MD5 Hash does not match.',1),(2368,1,4080894865,'Live',1),(2369,1,1987080350,'Demo',1),(2370,1,3876194617,'Developer',1),(2371,1,1620695427,'Store owner country not set.',1),(2372,1,713582701,'Store owner city not set.',1),(2373,1,2283940953,'Store owner company name not set.',1),(2374,1,4104488403,'Administrator email address not set.',1),(2375,1,2870212386,'Two private keys and CSRs generated.',1),(2376,1,3054805519,'Error generating key: ',1),(2377,1,72922377,'Private key and CSR generated.',1),(2378,1,1428422942,'Generate key first.',1),(2379,1,1631500600,'Invalid certificate.',1),(2380,1,3610695981,'OK',1),(2381,1,196033053,'Cannot verify Borica signature. The message was corrupted or the store certificate is invalid.',1),(2382,1,1074052831,'Terminal ID (TID) does not match.',1),(2383,1,2033581598,'Unknown response code: %s.',1),(2384,1,3533853291,'Success.',1),(2385,1,2631704872,'Network error.',1),(2386,1,3318243894,'Foreign network failure.',1),(2387,1,2557496871,'Time-out at IEM.',1),(2388,1,3849667764,'Transaction failed.',1),(2389,1,3104815222,'Reversal already placed.',1),(2390,1,3300264337,'Duplicate transaction.',1),(2391,1,76042179,'Unsuccessful 3D auth.',1),(2392,1,3156081746,'Canceled transaction.',1),(2393,1,3980295143,'Invalid message signature.',1),(2394,1,1551420085,'Reversal failed.',1),(2395,1,2846181355,'Funds refunded successfully.',1),(2396,1,2031090396,'Test payment.',1),(2397,1,1558229877,'Invalid routing number.',1),(2398,1,3153024680,'Invalid sort code.',1),(2399,1,3499759594,'Please enter the account number.',1),(2400,1,993638850,'Please enter the bank name.',1),(2401,1,3597456143,'Please enter the name on account.',1),(2402,1,2868789593,'You exceeded the Collect On Delivery payment limit. Maximum amount is %d %s.',1),(2403,1,1440228075,'Please enter the name on card.',1),(2404,1,3119284692,'Invalid card number.',1),(2405,1,3231650341,'Invalid expiration date.',1),(2406,1,1390469070,'Invalid CVV code.',1),(2407,1,4234528552,'Unknown payment status %s.',1),(2408,1,1492592544,'MD5 signature not enabled in your DSK account. Please contact DSK.',1),(2409,1,3194788682,'Merchant does not match.',1),(2410,1,53661188,'Simulator',1),(2411,1,2645749437,'Required OrderID parameter is missing.',1),(2412,1,3784136527,'Pay time: %s, Borica code %s.',1),(2413,1,40437855,'Pay time: %s.',1),(2414,1,2535456934,'Payment expired.',1),(2415,1,3332691567,'Notification.',1),(2416,1,3954423699,'Error occured.',1),(2417,1,3415975849,'Could not find IDN.',1),(2418,1,690338763,'Invalid return from proccessor.',1),(2419,1,2595626995,'Unknown currency code.',1),(2420,1,1820587442,'Moneris payment module is not set up correctly.',1),(2421,1,239591290,'Payment cancelled.',1),(2422,1,145849291,'Moneris transaction verification failed.',1),(2423,1,2181488235,'Invalid security verification. Check your SHA-1-OUT signature.',1),(2424,1,1165586235,'Sale',1),(2425,1,3583367802,'Funds captured successfully.',1),(2426,1,941378614,'Authorization voided successfully.',1),(2427,1,800552064,'Funds reauthorized successfully.',1),(2428,1,3761312504,'Please enable Payment Data Transfer.',1),(2429,1,3157827527,'Error verifing Payment Data Transfer. Please check your PDT identity token. %s',1),(2430,1,1433195732,'Return to merchant',1),(2431,1,956808071,'Invalid response from Realex. Please contact the owner of the store.',1),(2432,1,2672067096,'Enabled',1),(2433,1,711999057,'Successful',1),(2434,1,3540366563,'Declined by Bank',1),(2435,1,248552064,'Referral by Bank',1),(2436,1,3201209846,'Card reported lost or stolen',1),(2437,1,2261189006,'Error with bank systems',1),(2438,1,1750758678,'Error with Realex Payments systems',1),(2439,1,2970791877,'Incorrect XML message formation or content',1),(2440,1,1620246495,'Client deactivated',1),(2441,1,1245642798,'Invalid start date.',1),(2442,1,1860431565,'Invalid issue number.',1),(2443,1,841623692,'Error status from Sage Pay: %s (%s).',1),(2444,1,1452716031,'Invalid data from Sage Pay.',1),(2445,1,3234925912,'Do not send',1),(2446,1,1915472064,'Send to customer and vendor',1),(2447,1,1798404581,'Send to vendor only',1),(2448,1,3178107275,'There are no active banks.',1),(2449,1,2966302554,'Other card issuer',1),(2450,1,1045070230,'Hash signature is incorrect. Please check your store key.',1),(2451,1,1106862291,'3D authentication failed. Reason: %s',1),(2452,1,1528080076,'Bank options updated successfully.',1),(2453,1,3456911010,'Please configure the bank before activating it.',1),(2454,1,989631439,'Bank deactivated successfully.',1),(2455,1,3104487354,'Bank activated successfully.',1),(2456,1,112362174,'PreAuth: Authorize only',1),(2457,1,3694170451,'Invalid number of installments.',1),(2458,1,2580567245,'Invalid interest rate.',1),(2459,1,3698181533,'Dublicated number of installments.',1),(2460,1,2682797684,'UBB.bg error: %s.',1),(2461,1,304847185,'UBB module is not set up.',1),(2462,1,2200299116,'Error from ubb.bg: \"%s\"',1),(2463,1,2556539757,'Purchase',1),(2464,1,4173210494,'Please use the setup wizard.',1),(2465,1,2759125876,'No terminal aliases found.',1),(2466,1,2134707015,'Success! Terminal aliases found: %s.',1),(2467,1,3807098547,'Please setup Canada Post merchant ID first.',1),(2468,1,371692282,'Digital Delivery',1),(2469,1,3892566628,'Invalid e-Econt username/password.',1),(2470,1,3131417127,'Missing product in order number: %s.',1),(2471,1,89269609,'Missing product variant in order number: %s.',1),(2472,1,2104340469,'Order %s has zero total weight.',1),(2473,1,1827194367,'Missing payment module in order number: %s',1),(2474,1,2708038800,'Connection Error.',1),(2475,1,645570083,'Invalid request.',1),(2476,1,718797587,'Door',1),(2477,1,1945988660,'Office',1),(2478,1,460155848,'Credit',1),(2479,1,947161889,'Invalid city.',1),(2480,1,525438188,'Invalid zip.',1),(2481,1,3674152100,'City and zip do not match.',1),(2482,1,1338961600,'Phone is not valid - digits only, multiple numbers are seperated with \",\".',1),(2483,1,1559384534,'Please setup FedEx Account Number first.',1),(2484,1,1943503702,'Flat Rate Shipping',1),(2485,1,4287710637,'You are not authorized to perform this operation.',1),(2486,1,4010557600,'Please enter username and password.',1),(2487,1,2013728466,'Could not authenticate to Speedy.',1),(2488,1,2717330026,'Please choose parcels count',1),(2489,1,2969808959,'Print packing slip and labels for order #%d',1),(2490,1,3761590774,'Speedy shipping module is not configured.',1),(2491,1,1594417462,'Fixed',1),(2492,1,2920004005,'Percent',1),(2493,1,718850353,'An error occured while importing cities with message: ',1),(2494,1,3909116274,'Locations were imported successfully. New cities imported: %d. Cities updated: %d.',1),(2495,1,496065408,'Please specify state.',1),(2496,1,475143414,'Could not find city \"%s\" in our city list for state \"%s\". Please check your spelling.',1),(2497,1,1802502652,'Could not find CityID \"%s\". Please import locations using the Speedy module administration.',1),(2498,1,951556676,'Found more than one city named \"%s\".',1),(2499,1,2374008662,'Could not find State %s.',1),(2500,1,3115261555,'No shipping methods activated for Speedy.',1),(2501,1,1013795999,'Table-based Shipping',1),(2502,1,2474399755,'Please setup UPS UserID, Password and Access Number first.',1),(2503,1,377665883,'Please setup USPS UserID first.',1),(2504,1,1042739198,'USPS cannot ship to this country. Country code \"%s\".',1),(2505,1,395145477,'%s (Source: %s, Code: %s)',1),(2506,1,1403912869,'New',1),(2507,1,2768935208,'Processed',1),(2508,1,3789227194,'Delivered',1),(2509,1,2363194125,'Setup Quick Links',1),(2510,1,3305961868,'Quantity of items sold',1),(2511,1,2170461228,'Value of items sold',1),(2512,1,2044883406,'Could not save the order: %s.',1),(2513,1,640934425,'\"%s\" has an option of type \"user image\" which is not supported by \"Edit Order\".',1),(2514,1,1036390347,'Not all conditions for coupon \"%s\" are met.',1),(2515,1,2429757432,'No currency code has been saved in the order.',1),(2516,1,2670353289,'The selected currency \"%s\" could not be found.',1),(2517,1,1109538040,'The selected currency \"%s\" is currently inactive.',1),(2518,1,3836761498,'The current currency \"%s\" will be used.',1),(2519,1,3098763195,'Multiple coupons found with code \"%s\". None will be applied.',1),(2520,1,1840303263,'Coupon \"%s\" not found.',1),(2521,1,322559967,'Coupon \"%s\" will not be applied.',1),(2522,1,3594007164,'Surcharge',1),(2523,1,3955385877,'Some total lines from the original order do not exist now:',1),(2524,1,1962040625,'Some total lines did not exist in the original order:',1),(2525,1,3899924871,'The amount of the \"%s\" total line has changed from %s to %s.',1),(2526,1,2440723355,'There was a discount of %s on \"%s\". It is %s now.',1),(2527,1,2932499639,'Product cannot be found (ProductID %d).',1),(2528,1,2774013299,'Unable to find language code \"%s\". \"%s\" will be used instead.',1),(2529,1,3897097184,'There are no active shipping modules.',1),(2530,1,93649609,'The shipping module that the user has selected could not be found.',1),(2531,1,1518610654,'The shipping method that the user has selected is not active.',1),(2532,1,3029286015,'The country \"%s\" that the customer has selected as shipping country could not be found.',1),(2533,1,3101475492,'The country \"%s\" that the customer has selected as billing country could not be found.',1),(2534,1,2910254793,'The state \"%s\" that the user has selected as his %s could not be found.',1),(2535,1,3827980616,'Product \"%s\" options\' count does not match the order item options\' count.',1),(2536,1,1209841706,'The order item has missing product options. These product options will be set to default values: %s',1),(2537,1,524603406,'These product options have been selected for the order item, but are not supported by the product: %s',1),(2538,1,1201267415,'News not found.',1),(2539,1,1036467592,'You will receive newsletters in %s.',1),(2540,1,1700537962,'E-mail sending failed.',1),(2541,1,2868414571,'Test message successfully sent.',1),(2542,1,378138088,'Subscribed',1),(2543,1,1589477793,'All including unsubscribed',1),(2544,1,1958860084,'Blast successfully stopped.',1),(2545,1,489363607,'Newsletter \"%s\" Statistics',1),(2546,1,595429309,'All months',1),(2547,1,3113862095,'January',1),(2548,1,3025422826,'February',1),(2549,1,3205994163,'March',1),(2550,1,1874880475,'April',1),(2551,1,1097932288,'June',1),(2552,1,1732649165,'July',1),(2553,1,3813010884,'August',1),(2554,1,1011490657,'September',1),(2555,1,596285180,'October',1),(2556,1,2365364793,'November',1),(2557,1,3931589271,'December',1),(2558,1,293367773,'All languages',1),(2559,1,2327549235,'Blast \"%s - %s\" Statistics',1),(2560,1,1923443894,'Inactive',1),(2561,1,1991326958,'No e-mails to add.',1),(2562,1,1706330912,'%s e-mails successfully subscribed.',1),(2563,1,3079681498,'These e-mails are invalid and were not subscribed: %s',1),(2564,1,1075938043,'No scheduled messages.',1),(2565,1,3566135737,'Subscribed (%s)',1),(2566,1,1867803181,'All (%s)',1),(2567,1,3948876667,'All including unsubscribed (%s)',1),(2568,1,2723494638,'You may unsubscribe by following this link:',1),(2569,1,201141228,'Enable \"Email Opens\" tracking',1),(2570,1,3700194837,'Enable \"Click-Through\" tracking',1),(2571,1,2188668833,'Subscribe checkbox checked by default',1),(2572,1,3270213856,'Do not add \"Unsubscribe\" link. It is recommended that you leave this box unchecked.',1),(2573,1,3797768377,'Subscriber',1),(2574,1,2217367178,'Is Active',1),(2575,1,514029753,'Please enter a valid e-mail address.',1),(2576,1,2131480835,'You need to log-in in order to subscribe for newsletter \"%s\".',1),(2577,1,1460842374,'Newsletter subscription to \"%s\"',1),(2578,1,4151955869,'A user with the email \"%s\" just subscribed for the \"%s\" newsletter.',1),(2579,1,1453211149,'Unable to add product \"%s\" for comparison.',1),(2580,1,166495272,'Product Comparison',1),(2581,1,1634594289,'Select language',1),(2582,1,3705672827,'Select currency',1),(2583,1,3348699508,'Products Feed',1),(2584,1,812562298,'Invalid Products Feed Key.',1),(2585,1,2573243337,'Waiting for approval',1),(2586,1,4039052383,'Disapproved',1),(2587,1,4121705435,'Poor',1),(2588,1,1828591333,'Average',1),(2589,1,3434537388,'Good',1),(2590,1,2761007372,'Very good',1),(2591,1,551958626,'Excellent',1),(2592,1,2597373484,'Only registered users can rate.',1),(2593,1,927169313,'Only customers that have bought the product can rate it.',1),(2594,1,1175543820,'Only registered users can write reviews.',1),(2595,1,1715888140,'Only customers that have bought the product can write review about it.',1),(2596,1,377899250,'No review available.',1),(2597,1,2179000251,'No rating available.',1),(2598,1,3148493063,'Rating / review',1),(2599,1,2808175468,'All ratings',1),(2600,1,310527526,'Review Content',1),(2601,1,2749701344,'Rating Value',1),(2602,1,1777785138,'Rating Action Status',1),(2603,1,1207280236,'Customer reviewed product \"%s\".',1),(2604,1,2779464736,'Customer rated product \"%s\".',1),(2605,1,868798906,'Please select rating or write review.',1),(2606,1,46111629,'Please select rating.',1),(2607,1,958856233,'Please write review.',1),(2608,1,1836496177,'Guest',1),(2609,1,233027733,'Thank you for your feedback.',1),(2610,1,2600091244,'Unknown RSS feed.',1),(2611,1,427583051,'Wholesale Discount',1),(2612,1,1568311921,'This item is already on your wishlist.',1),(2613,1,3819242224,'Item successfully added to your wishlist.',1),(2614,1,1194866349,'Wishlist item removed.',1),(2615,1,829364355,'Here is my wishlist',1),(2616,1,3268514320,'Wishlist sent.',1),(2617,1,2684748848,'Page not found.',1),(2618,1,3670592399,'Profile updated successfully.',1),(2619,1,4265525075,'My Profile',1),(2620,1,1537601948,'Register failed: %s',1),(2621,1,2909322066,'Failed to subscribe to newsletter: %s',1),(2622,1,2365027333,'-- All --',1),(2623,1,485311805,'Your email was successfully sent.',1),(2624,1,298311779,'An error occurred while sending your email.',1),(2625,1,3198092169,'Cannot find implementations for %s.',1),(1,2,2289755597,'Създай',1),(2,2,1037276004,'Създайте администратор',1),(3,2,2995482424,'Потребител',1),(4,2,2876326840,'Права',1),(5,2,892126259,'Администраторски потребител',1),(6,2,1483083269,'Потребителско име:',1),(7,2,1618169985,'Парола:',1),(8,2,1143805008,'Email:',1),(9,2,3428050462,'Ниво на достъп:',1),(10,2,1169514477,'Администраторски секции',1),(11,2,2590913965,'Администраторски права могат да бъдат използвани само когато администраторския потребител е от тип \"Ограничен\".',1),(12,2,554135844,'Редактирай',1),(13,2,2016076131,'Редактирай админстратор',1),(14,2,2676568142,'Обновяване',1),(15,2,4168197166,'Сигурни ли сте, че искате да изтриете този администратор?',1),(16,2,3395160503,'Администратори',1),(17,2,578394630,'Нов администратор',1),(18,2,1159730082,'Експорт',1),(19,2,3558298466,'Печат',1),(20,2,19424289,'Потребителско име',1),(21,2,642995056,'Email',1),(22,2,1358691240,'Ниво на достъп',1),(23,2,1035893169,'Изтрий',1),(24,2,1991199118,'Никакви записи не са открити.',1),(25,2,2437429846,'Филтрирайте администраторите',1),(26,2,401120404,'Потребителско име...',1),(27,2,759615668,'Email...',1),(28,2,4173485446,'Възстановете филтрите',1),(29,2,3440991137,'Създайте API потребител',1),(30,2,979098257,'Редактирайте API потребител',1),(31,2,856131234,'Права на API акаунт:',1),(32,2,594535439,'Сигурни ли сте, че искате да изтриете този API потребител?',1),(33,2,510619022,'API Потребители',1),(34,2,769722276,'Нов API потребител',1),(35,2,299066170,'ID',1),(36,2,3434357891,'Парола',1),(37,2,1422021308,'Филтрирайте API потребителите',1),(38,2,1656057158,'ID...',1),(39,2,2029384602,'Добави транзакция',1),(40,2,1621185387,'Клиентски email:',1),(41,2,2085752545,'Клиентът ще:',1),(42,2,666537513,'точки',1),(43,2,3730803834,'Описание:',1),(44,2,1829616372,'Бонус точки',1),(45,2,786362779,'Сигурни ли сте, че искате да изтриете тази транзакция?',1),(46,2,2018503775,'Клиент',1),(47,2,3483776891,'Време',1),(48,2,1080068516,'Действие',1),(49,2,538348319,'Точки',1),(50,2,3950563313,'Описание',1),(51,2,2091671594,'Статус',1),(52,2,1273029392,'Одобри',1),(53,2,1917417168,'Анулиране',1),(54,2,3845477,'Клиентски email...',1),(55,2,3090480774,'Филтрирай транзакции',1),(56,2,3768765570,'Клиенти',1),(57,2,1399724308,'Създайте кутия',1),(58,2,2522791519,'Тип на кутия:',1),(59,2,1029537327,'Име на кутия:',1),(60,2,529056539,'Опции',1),(61,2,4121317825,'Настройки на кутия',1),(62,2,2919767447,'Редактирайте опциите към кутия',1),(63,2,905343091,'Активен:',1),(64,2,710380569,'Сигурни ли сте, че искате да изтриете тази кутия?',1),(65,2,204512749,'Кутии',1),(66,2,4110683034,'Нова кутия',1),(67,2,2007405142,'Област',1),(68,2,4262580536,'Име',1),(69,2,1286797620,'Активен',1),(70,2,753727511,'Вид',1),(71,2,3664733115,'Промени статус',1),(72,2,3387538849,'Заглавие:',1),(73,2,3718166553,'Покажи заглавие:',1),(74,2,1116506645,'Съдържание:',1),(75,2,3332629561,'Създайте категория',1),(76,2,2611773477,'Категория родител:',1),(77,2,1022533488,'Име:',1),(78,2,3904062056,'Изображение:',1),(79,2,2509092508,'Подредба:',1),(80,2,1653073578,'SEO заглавие:',1),(81,2,592908905,'Може да ползвате %%COMPANY_NAME%%, %%PAGE_NAME%%, %%PAGE_NUMBER%% и %%FMT_PAGE_NUMBER%% които ще бъдат заменени автоматично.',1),(82,2,3851858000,'SEO ключови думи:',1),(83,2,4119834834,'SEO описание:',1),(84,2,4159192542,'Сигурни ли сте, че искате да изтриете тази категория, всички подкатегории, и всички описани продукти?',1),(85,2,590884430,'Изтрийте категория',1),(86,2,3735244906,'Вие избрахте да изтриете категория:',1),(87,2,914164045,'Изтриването на тази категория също така ще махне',1),(88,2,34053083,'подкатегории.',1),(89,2,345866253,'продукти в текуща категория и нейните подкатегории.',1),(90,2,721012472,'Подкатегории, които ще бъдат изтрити,',1),(91,2,491010218,'Име на категория',1),(92,2,962550496,'Няма подкатегории.',1),(93,2,1048183235,'Продукти, които ще бъдат изтрити',1),(94,2,2570549838,'SKU',1),(95,2,2960715841,'Име на продукт',1),(96,2,4282022807,'Категория',1),(97,2,185142749,'Цена',1),(98,2,1294350323,'Никакви продукти.',1),(99,2,1213241423,'Редактирайте категорията',1),(100,2,4285491557,'Сигурни ли сте, че искате да изтриете тази категория и всички подкатегории?',1),(101,2,1974355384,'Категории',1),(102,2,2407014471,'Нова категория',1),(103,2,1254897676,'Продукти',1),(104,2,4044774684,'Сортиране',1),(105,2,3015334490,'продукти',1),(106,2,282756568,'Редактирайте модул за поръчка',1),(107,2,3257114989,'Редактирайте опциите на модул за поръчка',1),(108,2,2359548218,'Име на модул за поръчка:',1),(109,2,1010515290,'Видимо име на модул за поръчка:',1),(110,2,2658432784,'Опции:',1),(111,2,2133747315,'Модули за поръчка',1),(112,2,382242975,'Видимо име',1),(113,2,1235981300,'Плъзни надясно',1),(114,2,2830496658,'Помощ',1),(115,2,2037939570,'Плъзни наляво',1),(116,2,4097332503,'Последни поръчки',1),(117,2,1914014145,'Днес',1),(118,2,1741006997,'Вчера',1),(119,2,873400667,'Бързи връзки',1),(120,2,1407211951,'Сигурни ли сте?\\nПомощник настройки може да бъде активиран по-късно чрез менюто \"Съдържание на уебсайт :: Кутии\".',1),(121,2,2820672820,'Помощник настройки',1),(122,2,71361365,'Стъпки на бързи настройки:',1),(123,2,318403058,'1. За магазина',1),(124,2,1063320005,'2. Email-и',1),(125,2,1497918823,'3. Валути',1),(126,2,133536621,'и',1),(127,2,2163033279,'Локализация',1),(128,2,237900732,'4. Плащане',1),(129,2,842685971,'5. Модули за доставка',1),(130,2,1141612140,'Зони',1),(131,2,1263603970,'6. Поръчки',1),(132,2,2472554517,'Създайте <a href=\"categories.php\">категории</a> и <a href=\"products.php\">продукти</a>.',1),(133,2,418204617,'Започнете да продавате !',1),(134,2,2645630361,'Махни кутията',1),(135,2,3522603177,'Собственик на магазина',1),(136,2,839502324,'Име на фирма:',1),(137,2,1766359513,'Държава:',1),(138,2,3551868704,'Област:',1),(139,2,4205699080,'Град:',1),(140,2,1467534244,'Фирмен адрес:',1),(141,2,3184102455,'Фирмен адрес 2:',1),(142,2,2799088763,'Пощенски код:',1),(143,2,3951350519,'Телефон:',1),(144,2,1211405980,'Телефон 2:',1),(145,2,4156838822,'Факс:',1),(146,2,115514393,'Създайте държава',1),(147,2,3747125869,'ISO 3166-1-alpha-2:',1),(148,2,2020171218,'2-буквен код на държава',1),(149,2,3326323500,'ISO 3166-1-alpha-3:',1),(150,2,3887324748,'3-буквен код на държава',1),(151,2,1265701764,'Редактирайте държавата',1),(152,2,1323169768,'Изисква се валиден град на клиент',1),(153,2,2446631621,'Уверете се, че имате пълна база с области и градове преди да активирате.',1),(154,2,1154463460,'Сигурни ли сте, че искате да изтриете тази държава?',1),(155,2,3751241998,'Държави',1),(156,2,3026300927,'Нова държава',1),(157,2,2221352256,'Код 2',1),(158,2,4083160534,'Код 3',1),(159,2,913207931,'Области',1),(160,2,753088835,'По подразбиране',1),(161,2,2535385811,'Определете стойността по подразбиране',1),(162,2,419496075,'Филтрирайте държавите',1),(163,2,971770418,'Име на държава...',1),(164,2,699852639,'2-буквен код...',1),(165,2,2279503566,'3-буквен код...',1),(166,2,4039929781,'Създайте купон',1),(167,2,728504189,'Код:',1),(168,2,2549178112,'Вид:',1),(169,2,3648363398,'Режим на прилагане',1),(170,2,839626980,'Стойност:',1),(171,2,307808580,'Метод на доставка:',1),(172,2,2338252958,'Валиден от:',1),(173,2,464626289,'Валиден до:',1),(174,2,2285077413,'Брой позволени използвания:',1),(175,2,1100149183,'Условия към купон:',1),(176,2,3517418852,'Забележка: купонът ще бъде приет само ако всички условия бъдат изпълнени.',1),(177,2,887667868,'Поръчка',1),(178,2,3571547723,'Клиентски групи',1),(179,2,656937191,'Производители',1),(180,2,1940046458,'Сума нето на поръчката превишава',1),(181,2,311605988,'Добави продукт',1),(182,2,2644734124,'Изберете продукт',1),(183,2,515919727,'Разгледайте ...',1),(184,2,2677780045,'Махнете продуктите',1),(185,2,3319213447,'Име на клиент:',1),(186,2,2398662531,'Добави клиент',1),(187,2,3786205714,'Махнете клиентите',1),(188,2,2426276932,'Име на производител:',1),(189,2,3292489674,'Добави производител',1),(190,2,1328338441,'Махни производители',1),(191,2,3508710101,'Редактирайте купона',1),(192,2,3336226318,'Използван:',1),(193,2,495727280,'Сигурни ли сте, че искате да изтриете този купон?',1),(194,2,987310212,'Купони',1),(195,2,3472138508,'Нов купон',1),(196,2,3609698214,'Код',1),(197,2,3702945584,'Стойност',1),(198,2,4013556806,'Валиден от',1),(199,2,3211622985,'Валиден до',1),(200,2,895329285,'Филтрирайте купоните',1),(201,2,3273198802,'Купонен код...',1),(202,2,3255354999,'Купонна стойност...',1),(203,2,2847503815,'Създайте валута',1),(204,2,2257604640,'Код: (3-букви)',1),(205,2,4049401116,'Символ отляво:',1),(206,2,1068033941,'Символ отдясно:',1),(207,2,4261341808,'Десетичен символ:',1),(208,2,2106014093,'Сепаратор за хиляди:',1),(209,2,885873369,'Брой числа след точката:',1),(210,2,2316664076,'Курс:',1),(211,2,659163569,'Редактирайте валутата',1),(212,2,1867670234,'Сигурни ли сте, че искате да изтриете тази валута?',1),(213,2,3101993193,'Предупреждение: Променяйки валутата по подразбиране всички цени ще бъдат променени към новата валута. Никакво преизчисляване няма да бъде извършено. Сигурни ли сте?',1),(214,2,2023310659,'Валути',1),(215,2,3764564409,'Нова валута',1),(216,2,1144470778,'Курс към',1),(217,2,3198531662,'Курса обновен',1),(218,2,3851265157,'Филтрирайте валутите',1),(219,2,2102318287,'Име на валута...',1),(220,2,730052110,'Код на държава...',1),(221,2,2965428102,'Валутен курс...',1),(222,2,3735031810,'Обновете валутните курсове',1),(223,2,4255488631,'Модули за валутни курсове',1),(224,2,3131407025,'Редактирайте опциите на модул за валутни курсове',1),(225,2,1363597389,'Име на модул за валутни курсове:',1),(226,2,2232779832,'Курсове',1),(227,2,3857138066,'Валутни курсове',1),(228,2,2277816345,'Валутни курсове на %%BANKNAME%%',1),(229,2,3218697270,'Базова валута',1),(230,2,1628591218,'Котирана валута',1),(231,2,2145292295,'Курс',1),(232,2,1616759769,'Дата на обновяване',1),(233,2,1503822767,'Ще използвам специален уеб адрес',1),(234,2,495143701,'Специален уеб адрес',1),(235,2,810799440,'Специалният уеб адрес е текущ',1),(236,2,3261111235,'Вмъкни',1),(237,2,1865160710,'Махни',1),(238,2,734138096,'Добави уеб адрес',1),(239,2,1303866686,'Създай специален уеб адрес',1),(240,2,2242273707,'Връзка:',1),(241,2,1171046712,'Продукт:',1),(242,2,2056915619,'Категория:',1),(243,2,673769939,'Производител:',1),(244,2,872336839,'Формуляр:',1),(245,2,639522870,'Страница с богат текст:',1),(246,2,724805283,'Галерия:',1),(247,2,13213407,'Динамична страница:',1),(248,2,1180273410,'Текуща:',1),(249,2,1457006762,'Ако специален уеб адрес не е текущ посетителите ще бъдат препращани към текущия уеб адрес на тази страница.',1),(250,2,1835073706,'Редактирайте специален уеб адрес',1),(251,2,950790732,'Сигурни ли сте, че искате да изтриете този специален уеб адрес?',1),(252,2,1993255083,'Специален уеб адрес',1),(253,2,1610774068,'Нов специален уеб адрес',1),(254,2,1657866020,'Интернет - адрес',1),(255,2,159662430,'Обект',1),(256,2,1271107802,'Име на обект',1),(257,2,1063193523,'Текуща',1),(258,2,586873638,'Филтрирай специални уеб адреси',1),(259,2,3760750716,'Специален уеб адрес...',1),(260,2,2971479636,'ID на страница...',1),(261,2,3465963864,'Създайте клиентска група',1),(262,2,1354171785,'Редактирайте клиентска група',1),(263,2,2030727810,'Сигурни ли сте, че искате да изтриете тази клиентска група?',1),(264,2,1832239909,'Нова клиентска група',1),(265,2,62372502,'Филтрирайте клиентските групи',1),(266,2,3534204887,'Име на клиентска група...',1),(267,2,3626964749,'Адрес по подразбиране за плащане',1),(268,2,1298866674,'Адрес по подразбиране за доставка',1),(269,2,1633266105,'Първо име:',1),(270,2,3952088495,'Фамилия:',1),(271,2,190101345,'Фирма:',1),(272,2,1987276054,'ДДС номер:',1),(273,2,1241179085,'Държава:',1),(274,2,963545935,'Област:',1),(275,2,4099323532,'Град:',1),(276,2,3152090975,'Пощенски код:',1),(277,2,469117031,'Адрес 1:',1),(278,2,819690404,'Адрес 2:',1),(279,2,3025604379,'Добави нов',1),(280,2,1104573425,'Създайте клиент',1),(281,2,3688990591,'Клиентска група:',1),(282,2,3486077833,'Статус:',1),(283,2,2951236299,'Адреси:',1),(284,2,84373228,'Бюлетини:',1),(285,2,3475312519,'Редактирайте клиента',1),(286,2,2569416001,'Точки:',1),(287,2,671550159,'Вижте история на точките',1),(288,2,2684393541,'Сигурни ли сте, че искате да изтриете този клиент?',1),(289,2,135116687,'Нов клиент',1),(290,2,3259950746,'Име на клиент',1),(291,2,1416126568,'Адрес за контакт',1),(292,2,3631425621,'Поръчки',1),(293,2,640984327,'Филтрирайте клиентите',1),(294,2,1938273026,'Име на клиент...',1),(295,2,139694043,'Бюлетини',1),(296,2,4134497924,'Изберете бюлетините, за които да се абонирате.',1),(297,2,724096885,'Най-скорошни поръчки',1),(298,2,3505840376,'Последните 5 поръчки',1),(299,2,179083332,'Дата',1),(300,2,3181064726,'Детайли',1),(301,2,65982042,'Общо',1),(302,2,2682620377,'Виж всички',1),(303,2,3178444827,'Показвания по категория',1),(304,2,922052886,'Няма данни за избрания период.',1),(305,2,473154195,'Настройки',1),(306,2,2812958730,'Период:',1),(307,2,3878477080,'Показвания по продукт',1),(308,2,686891096,'Продажби по продукт',1),(309,2,327582746,'Преглеждания на страница / уникални посетители',1),(310,2,3785762269,'Достъпът отказан',1),(311,2,3706373094,'Достъпът до секция \"%%SECTIONNAME%%\" отказан!',1),(312,2,554650102,'Създайте отстъпка',1),(313,2,859799067,'Условия за отстъпка:',1),(314,2,1753317527,'Забележка: отстъпката ще бъде дадена само ако всички условия бъдат изпълнени.',1),(315,2,2952541568,'Редактирайте отстъпката',1),(316,2,1040504028,'Сигурни ли сте, че искате да изтриете тази отстъпка?',1),(317,2,2124840987,'Отстъпки',1),(318,2,1758760328,'Нова отстъпка',1),(319,2,3090213278,'Филтрирайте отстъпките',1),(320,2,384779057,'Име на отстъпка...',1),(321,2,401325246,'Стойност на отстъпка...',1),(322,2,1151858065,'Редактирайте динамичната страница',1),(323,2,4004852549,'Страница:',1),(324,2,2097494675,'меню',1),(325,2,882035683,'Динамични области на страница:',1),(326,2,264857579,'Динамични страници',1),(327,2,3344210772,'Филтрирайте динамичните страници',1),(328,2,1435067696,'Име на страница...',1),(329,2,1261301092,'Email-и',1),(330,2,3826974845,'Още информация за грешката',1),(331,2,1840744469,'Email адреси',1),(332,2,3361431098,'Email на администратор на сайта:',1),(333,2,1294274427,'Email на отдел продажби:',1),(334,2,2997004959,'Може да въведете повече от един email адреси разделени със запетая.',1),(335,2,2993599821,'Помощ / Поддръжка от email:',1),(336,2,221380787,'Емейл изпращач на известия:',1),(337,2,3044419721,'Този адрес ще бъде поставен във From и Reply-To на съобщенията изпращани до клиентите.',1),(338,2,2894426120,'Емейл за бюлетин с новини:',1),(339,2,4185941722,'Метод за изпращане на email-и:',1),(340,2,1666559931,'Настройки на SMTP сървър',1),(341,2,3142575940,'SMTP Host:',1),(342,2,735870516,'SMTP порт:',1),(343,2,3062696543,'Използвайте SMTP автентикация:',1),(344,2,3330392952,'SMTP потребителско име:',1),(345,2,4271152636,'SMTP парола:',1),(346,2,3837661202,'SMTP сигурност:',1),(347,2,3521870156,'Обновете и изпратете тестовия email',1),(348,2,2896921823,'Това е тестов email.',1),(349,2,1220736883,'Този email бе изпратен от <a href=\"%%STORE_ROOT_URL%%\">%%COMPANYNAME%%</a> с единствената цел да се тестват настройките за изпращане на email-и.',1),(350,2,4016487210,'Създайте водещ продукт',1),(351,2,485965105,'Продукт',1),(352,2,2071043849,'Разгледайте',1),(353,2,3650456851,'Покажи на началната страница',1),(354,2,859962406,'Редактирайте водещия продукт',1),(355,2,1653583751,'Сигурни ли сте, че искате да премахнете този продукт от водещите?',1),(356,2,1136261839,'Водещи продукти',1),(357,2,4064565271,'Търсете продукти:',1),(358,2,561596911,'Име на продукт...',1),(359,2,3497791286,'Филтрирайте продуктите',1),(360,2,1140086212,'Нов водещ продукт',1),(361,2,83635035,'Изображение',1),(362,2,2942734885,'Водещ в',1),(363,2,2382706641,'Създайте формуляр',1),(364,2,2948666624,'Текст с потвърждение:',1),(365,2,813452922,'Разрешаване captcha:',1),(366,2,3121551407,'Редактирайте формуляра',1),(367,2,3478282366,'Име на артикул',1),(368,2,498026833,'Вид на артикул',1),(369,2,435013471,'Задължително',1),(370,2,418411255,'Имената на input и select полета трябва да започват със custom-field-, например:',1),(371,2,1891574076,'Сигурни ли сте, че искате да изтриете този формуляр?',1),(372,2,1023292659,'Формуляри',1),(373,2,2225337316,'Нов формуляр',1),(374,2,4144669664,'Филтрирайте формулярите',1),(375,2,2659577502,'Име на формуляр...',1),(376,2,314191173,'Създайте галерия',1),(377,2,247289170,'Име на галерия',1),(378,2,1197503405,'Заглавие на галерия',1),(379,2,1915678372,'Описание на галерия',1),(380,2,964021644,'Галерията е активна',1),(381,2,1435567424,'SEO заглавие',1),(382,2,1596564184,'Редактирайте галерия',1),(383,2,558160881,'Импортирайте снимки от папка',1),(384,2,637989770,'Сигурни ли сте, че искате да изтриете тази галерия?',1),(385,2,1979706388,'Галерии',1),(386,2,2688097955,'Нова галерия',1),(387,2,3942078319,'Заглавие',1),(388,2,3010037137,'Филтрирайте галериите',1),(389,2,124201707,'Име на галерия...',1),(390,2,1412881386,'Сигурни ли сте, че искате да изтриете снимките в галерията преди импорт?',1),(391,2,1032305907,'Импортирайте снимки в \"%%GALLERYNAME%%\"',1),(392,2,3152560996,'Снимките са намери в директория \"%%DIRECTORY%%\"',1),(393,2,2488537117,'Изтрийте снимките в галерията преди импорт',1),(394,2,1916110845,'Импортирайте избраните снимки',1),(395,2,3958908650,'Създайте нов елемент в галерия',1),(396,2,678364137,'Интернет адрес:',1),(397,2,3453375687,'Редактирайте елемент в галерия',1),(398,2,1822348166,'Сигурни ли сте, че искате да изтриете този артикул?',1),(399,2,2370364043,'Елементи в галерия',1),(400,2,2607950393,'Нов елемент в галерия',1),(401,2,176078831,'Добавен',1),(402,2,4035319854,'Сортиране',1),(403,2,2468205517,'Общи настройки',1),(404,2,3887315804,'Изображения',1),(405,2,854454908,'Е-стоки',1),(406,2,1361241570,'Оценки и ревюта',1),(407,2,4043640331,'Други',1),(408,2,269276975,'При качване картинките ще бъдат автоматично умалени, за да са не по-големи от размерите по-долу.',1),(409,2,1384850146,'Изображения на продукт',1),(410,2,2918703136,'Максимална широчина на голяма снимка:',1),(411,2,492802816,'Максимална височина на голяма снимка:',1),(412,2,3881581214,'Максимална широчина на нормална снимка:',1),(413,2,835495505,'Максимална височина на нормална снимка:',1),(414,2,921966431,'Максимална широчина на изображение на тъмба:',1),(415,2,3716086874,'Максимална височина на изображение на тъмба:',1),(416,2,4157063781,'Максимална широчина на картинка в кутия:',1),(417,2,464721469,'Максимална височина на картинка в кутия:',1),(418,2,361089098,'Запазете настройките и генерирайте отново продуктовите снимки',1),(419,2,220566877,'Изображения на производители',1),(420,2,3680048988,'Изображения на категории',1),(421,2,2457112548,'Снимки в галерия',1),(422,2,1517437511,'Брой снимки на ред в галерия:',1),(423,2,2504331047,'Брой редове със снимки в галерия:',1),(424,2,2769143229,'Максимална ширина на голямата картинка:',1),(425,2,2481555164,'Максимална височина на голямата картинка:',1),(426,2,2240765858,'Връзката за сваляне ще бъде активна за:',1),(427,2,3957652582,'дни',1),(428,2,2004198218,'Максимален брой сваляния на всяка е-стока:',1),(429,2,1265870005,'сваляния',1),(430,2,539322459,'Автоматично отключване на е-стоките:',1),(431,2,716429498,'Оценка на продукт разрешена за:',1),(432,2,2645711072,'Ревю за продукт разрешено за:',1),(433,2,77241868,'Автоматично одобрение на оценки и ревюта от:',1),(434,2,3055675652,'Продукти на страница',1),(435,2,1383366238,'Излед на категориите по подразбиране:',1),(436,2,3434089996,'Ред на продуктите по подразбиране:',1),(437,2,1369760445,'Колони в табличен вид:',1),(438,2,1737381562,'Редове в табличен вид:',1),(439,2,382330550,'Продукти в списъчен вид:',1),(440,2,2083096048,'Изглед на Началната страница:',1),(441,2,750111958,'Автоматично следене на наличностите:',1),(442,2,2380118066,'Когато няма наличност от продукт:',1),(443,2,402006418,'Добавяй новите продукти най-отпред в категориите:',1),(444,2,1909781453,'Разрешаване цени на едро:',1),(445,2,4223135822,'Валутните курсове са невалидни след:',1),(446,2,1281194530,'Продуктите се считат за нови за:',1),(447,2,1202775632,'Максимален брой продукти за сравнение:',1),(448,2,924304961,'Код за сигурност на регистрационната страница:',1),(449,2,62763753,'Код за сигурност на регистрационната страница при поръчка:',1),(450,2,3951021838,'Показвай незавършените поръчки:',1),(451,2,662215137,'Довеждане на приятел носи',1),(452,2,4060238471,'Ограничи до',1),(453,2,3898582405,'използвания на',1),(454,2,414650819,'Време на живот на бисквитката за рефъръл',1),(455,2,1563505666,'Ревю носи',1),(456,2,1869955673,'Гласуване носи',1),(457,2,3808845936,'Покупка носи',1),(458,2,1215727740,'Статуси на поръчка',1),(459,2,2482087779,'Изразходване на',1),(460,2,1902986711,'носи',1),(461,2,1689585026,'1 точка е равна на',1),(462,2,3856038733,'когато купувате продукт.',1),(463,2,4263381803,'Ръчно одобряване на придобиването на точки',1),(464,2,2536097032,'Позволете на клиентите да решат дали да ползват точки или не.',1),(465,2,1205939790,'По подразбиране новите продукти могат да бъдат закупени с',1),(466,2,351951855,'Summer Cart - Административна област',1),(467,2,2616496417,'Търси...',1),(468,2,2986050059,'Натисни да скриеш',1),(469,2,4168505391,'Добре дошъл,',1),(470,2,845213721,'Изход',1),(471,2,766317539,'Език',1),(472,2,2329144481,'Вижте клиентската област',1),(473,2,3521422318,'Начало',1),(474,2,1050048371,'Магазин',1),(475,2,1625540659,'Съдържание на уебсайт',1),(476,2,1050844889,'Отчети',1),(477,2,590925805,'Добавки',1),(478,2,3009207953,'Търси',1),(479,2,2856345408,'Продажби',1),(480,2,3800299736,'Поръчки',1),(481,2,870606089,'Продуктови опции',1),(482,2,3778863435,'Прод. класове',1),(483,2,2598554411,'Импорт',1),(484,2,1139605362,'Промоция',1),(485,2,689873154,'Страници с богат текст',1),(486,2,3185653358,'Новини',1),(487,2,836273688,'Бюлетин',1),(488,2,586864587,'Галерии със снимки',1),(489,2,2018988773,'Подредба на уебсайт',1),(490,2,3014928331,'Менюта',1),(491,2,549626884,'Визия',1),(492,2,2592952232,'Подредби',1),(493,2,4132776560,'Отчети за продажби',1),(494,2,3412108406,'Продажби по категория',1),(495,2,1276457918,'Продажби по клиент',1),(496,2,2831740307,'Продажби по държава',1),(497,2,1076937254,'Отчети за клиент',1),(498,2,779024177,'Държави на клиентите',1),(499,2,2809413986,'Преглеждания на страница / посещения',1),(500,2,248971099,'Отчети за поръчките',1),(501,2,3484514641,'Средна сума на поръчка',1),(502,2,2969627178,'Статуси на поръчка',1),(503,2,2107866557,'Методи за плащане',1),(504,2,492318832,'Методи на доставка',1),(505,2,55544060,'Данъци',1),(506,2,1911357502,'Артикули за поръчка',1),(507,2,3775560267,'Модули',1),(508,2,3563746674,'Доставка',1),(509,2,2727722385,'Плащане',1),(510,2,1447972632,'Поръчка',1),(511,2,4237855332,'Сума поръчка',1),(512,2,1033236376,'Валутен курс',1),(513,2,3354049021,'Конфигурация на <br />магазин',1),(514,2,26480598,'Общи',1),(515,2,242724770,'За магазина',1),(516,2,1022211991,'Сигурност',1),(517,2,4208373434,'SEO',1),(518,2,2509950185,'Данъци и местоположения',1),(519,2,2642707482,'Зони на доставка',1),(520,2,4252246553,'Езици и валути',1),(521,2,572576218,'Езици',1),(522,2,3557463602,'Създайте помощ',1),(523,2,1389658646,'Действие на страницата:',1),(524,2,3505702287,'Текст:',1),(525,2,3758143948,'Редактирайте помощта',1),(526,2,1239850335,'Сигурни ли сте, че искате да изтриете тази помощ?',1),(527,2,94865552,'Помощи',1),(528,2,3735835143,'Нова помощ',1),(529,2,3023575326,'Страница',1),(530,2,3461554051,'Филтрирайте помощите',1),(531,2,2587122860,'Име на страница...',1),(532,2,1153217644,'Импорт на продукти',1),(533,2,2478860166,'CSV файл:',1),(534,2,2147132762,'Моля проверете, че CSV файла е правилно форматиран. Погледнете <a href=\"%%SKIN_URL%%admin/import/products.csv\" target=\"_blank\">примерния CSV файл</a>.',1),(535,2,1915366692,'Езици:',1),(536,2,55916349,'Всички',1),(537,2,3997793959,'Автоматично създаване на производители:',1),(538,2,4116337988,'Автоматично създаване на категории:',1),(539,2,517128142,'Автоматично създаване на продуктови класове:',1),(540,2,1866055727,'Изтриване на всички продукти преди импорта:',1),(541,2,1059048098,'Предупреждение: Това ще доведе до изтриването на ВСИЧКИ текущи продукти!',1),(542,2,2862194528,'Може да изберете да изтриете всички текущи продукти преди импорта.',1),(543,2,2682384428,'Разрешаване на частичен успех:',1),(544,2,2388344707,'По подразбиране всички продукти се импортират в една операция, която или успява или неуспява. Ако е позволен частичния успех, софтуера ще отрази промените върху всички успешно импортирани продукти, дори ако част от импорта не успее.',1),(545,2,2960504523,'Импортирани продукти',1),(546,2,1831847519,'Обновени продукти',1),(547,2,3527257968,'Импортирани нови категории',1),(548,2,1963134496,'Импортирани нови производители',1),(549,2,2676543370,'Импортирани нови продуктови класове',1),(550,2,2162755878,'Продукти с неимпортирани картинки',1),(551,2,946252235,'Открит проблем с инсталациата:<br/><strong>%%PROBLEMS%%</strong>.',1),(552,2,2196203420,'Информация за лиценза',1),(553,2,2194961893,'Журнал на приложението',1),(554,2,3504735353,'Проверка на инсталацията',1),(555,2,2743614721,'Вашият магазин е инсталиран коректно.',1),(556,2,3855422341,'Търсене на текстове',1),(557,2,2654260861,'Резултати от търсене на текстове',1),(558,2,2860613836,'Намерени текстове',1),(559,2,3939961270,'Намерени темплейтни текстове',1),(560,2,1533893826,'Намерени текстове в кода',1),(561,2,1505227595,'Брой на уникални текстове',1),(562,2,4279887624,'Резултати от операция обновяване',1),(563,2,384604181,'Предишен брой текстове',1),(564,2,1807440099,'Брой добавени текстове',1),(565,2,1545029533,'Брой премахнати текстове',1),(566,2,2687646265,'Назад',1),(567,2,338988109,'Създайте език',1),(568,2,94494848,'Основавам  на:',1),(569,2,1005997555,'2-знаков езиков код (ISO 639-1)',1),(570,2,151362824,'Посока:',1),(571,2,1192782810,'Повечето езици се изписват от ляво надясно, но някои езици като арабски и иврит се пишат от дясно наляво.',1),(572,2,3299575374,'Иконка:',1),(573,2,1030573456,'Може да отнеме време.',1),(574,2,2596794427,'Редактирайте езика',1),(575,2,1807457897,'Информация',1),(576,2,3440977850,'Езиков пакет',1),(577,2,1786319641,'Xliff файлове',1),(578,2,3455484701,'Сваляне на езиков пакет',1),(579,2,1320282873,'Автор:',1),(580,2,2302973021,'Лиценз:',1),(581,2,3070820891,'Дата на публикуване:',1),(582,2,4273363598,'Езиков пакет:',1),(583,2,967710941,'Сваляне / качване на xliff файлове',1),(584,2,1393277713,'Езиковия пакет съдържа xliff файлове. XLIFF е международно стандартизиран файлов формат за софтуерна локализация и превод.',1),(585,2,1334522620,'Свали xliff файлове',1),(586,2,1059175203,'Текстове от интерфейса',1),(587,2,1094608267,'Свали XLIFF',1),(588,2,3513281581,'Администраторски бързи връзки',1),(589,2,2057606105,'Качете xliff файлове',1),(590,2,2454456072,'Качете XLIFF',1),(591,2,1148527715,'Това е php.ini настройка извън контрола на Summer Cart. Моля свържете се с вашата хостинг компания, за да увеличите този лимит.',1),(592,2,3765929189,'Инсталирай',1),(593,2,1116465884,'Инсталиране на езиков пакет',1),(594,2,1257387828,'Файл с езиков пакет:',1),(595,2,2368833844,'Това е zip файл, който съдържа преводите за един език.',1),(596,2,4220357726,'Моля посетете <a href=\"http://www.summercart.com/\" target=\"_blank\">www.summercart.com</a> за да намерите езикови пакети.',1),(597,2,1623261434,'Максималния размер на файл за трансфер е %%MAXUPLOADSIZE%%.',1),(598,2,3548864002,'Как да увеличим?',1),(599,2,1877622045,'Езиковият пакет е успешно инсталиран.',1),(600,2,1710096959,'Информация за езиков пакет',1),(601,2,1010286815,'Успешно инсталирани езикови файлове',1),(602,2,749574446,'Файл',1),(603,2,2331169344,'Текстове за превод',1),(604,2,401915326,'Инсталирани преводи',1),(605,2,2164804145,'Липсващи преводи',1),(606,2,3360604285,'Неизползвани преводи',1),(607,2,3714345229,'Текстове с липсващ превод',1),(608,2,1915095946,'детайли',1),(609,2,1455164762,'Неизползвани преводи за текстове',1),(610,2,3935651977,'Продължи',1),(611,2,1851207096,'Редактирайте превод на потребителския интерфейс',1),(612,2,1496342308,'Оригинален текст',1),(613,2,424200871,'Текст в',1),(614,2,3749695353,'Отметни всички',1),(615,2,446897115,'Превода е одобрен',1),(616,2,106014150,'Филтрирай преводи на потребителския интерфейс',1),(617,2,2166909919,'ID на текст...',1),(618,2,1056778569,'Оригинален текст...',1),(619,2,122880609,'Преведен текст...',1),(620,2,2485861965,'Филтрирай преводи',1),(621,2,291378377,'Преводи на потребителския интерфейс',1),(622,2,1652720925,'Сигурни ли сте, че искате да изтриете този език?',1),(623,2,105775009,'Предупреждение: Променяйки езика по подразбиране Вие ще промените и езика на който се записват имената на продуктите при поръчка. Сигурни ли сте?',1),(624,2,771978002,'Управление на езиците',1),(625,2,1575962675,'Нов език',1),(626,2,1242588023,'преведи',1),(627,2,1720970127,'вижте всички',1),(628,2,3837179999,'Филтрирайте езиците',1),(629,2,69925236,'Име на език...',1),(630,2,568052308,'Обновете текстовете на потребителския интерфейс',1),(631,2,2924034901,'Създайте подредба',1),(632,2,956611263,'CSS име на клас',1),(633,2,2410151477,'Редактирайте подредбата',1),(634,2,4287890366,'ID на подредба',1),(635,2,3185071516,'Сигурни ли сте, че искате да изтриете тази подредба?',1),(636,2,1205307603,'Упрваление на подредби',1),(637,2,2423387628,'Нова подредба',1),(638,2,2968916085,'Променете подредбата по подразбиране',1),(639,2,2500444969,'Филтрирайте подредбите',1),(640,2,146829847,'Име на пордредба...',1),(641,2,412693723,'Лицензно споразумение към краен потребител',1),(642,2,2682984555,'Информация за лизенза на Summer Cart',1),(643,2,2323996648,'Лицензирано на:',1),(644,2,1523516778,'Тип на лиценза:',1),(645,2,3545320687,'Уебсайт:',1),(646,2,3864153367,'Лицензен код:',1),(647,2,3045320497,'Проверете автентичността',1),(648,2,63961100,'Демо:',1),(649,2,4203975461,'Мярка за тегло:',1),(650,2,2784187960,'Предупреждение: Променяйки мярката за тегло ще се променят всички продуктови тегла. Никакво преизчисляване няма да бъде извършено.',1),(651,2,3130602245,'Журнал на приложението',1),(652,2,2030045667,'Съобщение',1),(653,2,3953216932,'Администратор',1),(654,2,3749110151,'Email на клиент',1),(655,2,253145917,'Строгост',1),(656,2,316635914,'Филтрирайте записите в журнала',1),(657,2,1613063122,'Съобщение...',1),(658,2,1158643050,'Има на администратор...',1),(659,2,3873015737,'Записи в журнала',1),(660,2,750740131,'Моля включете JavaScript. Summer Cart се нуждае от JavaScript, за да функционира правилно.',1),(661,2,4049669701,'Моля влезте',1),(662,2,757082350,'Език:',1),(663,2,3342318177,'Вход',1),(664,2,2168853892,'Създайте производител',1),(665,2,2808637353,'Edit производител',1),(666,2,2944624444,'Сигурни ли сте, че искате да изтриете този производител?',1),(667,2,4056684887,'Нов производител',1),(668,2,2295489659,'Уебсайт',1),(669,2,4021677144,'Филтрирайте производителите',1),(670,2,277105412,'Име на производител...',1),(671,2,2536423828,'Сайт на производител...',1),(672,2,3208812707,'Създайте меню елемент',1),(673,2,1958220373,'Редактирайте точките от меню',1),(674,2,111853526,'Редактирайте елемента за меню',1),(675,2,73030122,'Точки от меню',1),(676,2,146153308,'Нова точка от меню',1),(677,2,1691918083,'Тип на връзка',1),(678,2,2604631168,'Води до',1),(679,2,2710106125,'Създайте меню',1),(680,2,410452179,'Име в списък:',1),(681,2,1232203988,'Разположение на меню:',1),(682,2,2249378412,'Заглавие за меню:',1),(683,2,3496752393,'Менюто е активно:',1),(684,2,2508382195,'Редактирайте меню',1),(685,2,4294259204,'Сигурни ли сте, че искате да изтриете това меню?',1),(686,2,2871931960,'Ново меню',1),(687,2,2817059741,'Местоположение',1),(688,2,2017505496,'Филтрирайте менютата',1),(689,2,657625883,'Име на меню...',1),(690,2,3805367665,'Виж всички',1),(691,2,3553794789,'Създайте група опции',1),(692,2,4126992584,'Редактирайте групата с опции',1),(693,2,2462623563,'Сигурни ли сте, че искате да изтриете тази опционна група?',1),(694,2,500159910,'Групи с опции',1),(695,2,2740491830,'Нова група с опции',1),(696,2,3578931481,'Филтрирайте групите с опции',1),(697,2,4236806916,'Група опциии...',1),(698,2,3523343456,'Ценова модификация',1),(699,2,3590926850,'Вид на модификацията',1),(700,2,2299360628,'Сума',1),(701,2,1956349703,'% от продуктовата цена',1),(702,2,424616805,'Създайте статус на поръчка',1),(703,2,1360519729,'Изпрати известие:',1),(704,2,3743557245,'Инвентарно действие:',1),(705,2,1063342408,'Редактирайте статуса на поръчка',1),(706,2,3081471352,'Сигурни ли сте, че искате да изтриете този статус на поръчка?',1),(707,2,1774530486,'Нов поръчков статус',1),(708,2,2808458546,'Известие',1),(709,2,870107285,'Стока',1),(710,2,2067839808,'Предефиниран',1),(711,2,1207696150,'Промени',1),(712,2,3927366091,'Филтрирайте статусите на поръчки',1),(713,2,620095717,'Статус на поръчка...',1),(714,2,2006019800,'Редактирайте настройките към Order Total модул',1),(715,2,1031408549,'Име на модул сума на поръчка:',1),(716,2,3825478277,'Модули суми на поръчки',1),(717,2,3309110367,'снимка',1),(718,2,2247323090,'SKU:',1),(719,2,4125291397,'Административната бележка е твърде къса.',1),(720,2,2288505237,'Сигурни ли сте, че искате да изтриете тази бележка?',1),(721,2,3215528822,'CVV кода и всички освен последните 4 цифри на номера на кредитната карта ще бъдат изчистени. Сигурни ли сте?',1),(722,2,1929955923,'Отпечатай фактура',1),(723,2,3642958753,'Печат на товарителница и етикети за поръчка #%%ORDERID%%',1),(724,2,3185707023,'Отпечатай товарителница',1),(725,2,3094574373,'Редактирайте поръчка',1),(726,2,2381271956,'Детайли на поръчка',1),(727,2,1460565179,'Номер на поръчка',1),(728,2,3551558051,'Дата на поръчка',1),(729,2,4157998837,'Информация за клиент',1),(730,2,1436479071,'IP адрес',1),(731,2,3735532719,'Информация за платеца',1),(732,2,3702440234,'Платец:',1),(733,2,2009770416,'Адрес:',1),(734,2,2245635979,'виж карта',1),(735,2,3912290734,'Информация за доставката',1),(736,2,1058344987,'Изпрати до:',1),(737,2,855323776,'Информация за доставка',1),(738,2,3890635123,'Метод на доставка',1),(739,2,580378663,'Проследяващ номер №',1),(740,2,81762214,'Вижте транзакциите',1),(741,2,2888137196,'Метод за плащане',1),(742,2,2405271545,'Транзакция №',1),(743,2,2941008396,'Информация за кредитна карта',1),(744,2,2347830614,'Изчисти',1),(745,2,3961855662,'Име на картодържател:',1),(746,2,2373507299,'Номер на карта:',1),(747,2,1022260215,'Изтичане на карта:',1),(748,2,3551303276,'CVV / CVC код:',1),(749,2,1028089187,'AVS:',1),(750,2,1747108340,'CVN:',1),(751,2,3135544870,'Информация за чек',1),(752,2,4264007409,'Име на сметкодържател:',1),(753,2,2210243515,'Номер на сметка:',1),(754,2,2205281729,'Име на банкa:',1),(755,2,3899945616,'Тип на сметка:',1),(756,2,1255983578,'Специални инструкции от клиента',1),(757,2,525886687,'Бележки за плащането',1),(758,2,30367324,'Поръчани продукти',1),(759,2,1720022112,'Брой',1),(760,2,412538456,'Отстъпка',1),(761,2,3940561649,'Единична цена',1),(762,2,1029285216,'Сума поръчка',1),(763,2,3391103084,'Клиентът е платил в',1),(764,2,2313543638,'Изпращане на е-стоките',1),(765,2,1995554626,'Вижте е-стоките',1),(766,2,2396005286,'Статус към плащане',1),(767,2,772090503,'Административни бележки за тази поръчка',1),(768,2,1871664426,'Бележка',1),(769,2,1364489895,'Изпратено към клиент',1),(770,2,2105576996,'Създадена на',1),(771,2,3519893586,'Няма забележки към поръчката.',1),(772,2,3920048843,'Нова административна забележка',1),(773,2,1426351852,'Изпратете административните бележки до клиента',1),(774,2,123366371,'Съдържание на бележката:',1),(775,2,1135686316,'Добави бележка',1),(776,2,1833481689,'Отключване',1),(777,2,666711088,'Заключване',1),(778,2,3380749846,'Изтегляния',1),(779,2,1428246800,'Изтича',1),(780,2,1649497623,'Изтегляем',1),(781,2,1303016265,'Да',1),(782,2,4063104189,'Не',1),(783,2,1011106260,'Фактура за поръчка #%%ORDERID%%',1),(784,2,1608003288,'Фактура',1),(785,2,1526887444,'Дата на поръчка:',1),(786,2,3722834136,'Метод на доставка:',1),(787,2,2972062900,'Проследяващ номер №:',1),(788,2,3172908309,'Метод за плащане:',1),(789,2,3504349440,'Транзакция №:',1),(790,2,1736041562,'Моля първо изберете поръчки.',1),(791,2,2516486077,'Сигурни ли сте, че искате да възстановите избрани редове?',1),(792,2,3353338619,'Сигурни ли сте, че искате да обновите всички статуси на поръчки?',1),(793,2,2453634288,'Търсете поръчки',1),(794,2,2646813048,'Номер на поръчка...',1),(795,2,3157953182,'Име на клиент...',1),(796,2,3796017169,'Създай Поръчка',1),(797,2,3514807676,'Обновете статусите',1),(798,2,275359193,'Отпечатай фактури',1),(799,2,2332831890,'Отпечатай товарителници',1),(800,2,4070162868,'Транзакции',1),(801,2,551895527,'ID на поръчка:',1),(802,2,1507437924,'Код за транзакция',1),(803,2,4099588478,'Име на детайл',1),(804,2,1124325509,'Стойност на детайл',1),(805,2,3399427310,'Никакви транзакции не са намерени.',1),(806,2,4234656813,'Редактирайте модул за плащане',1),(807,2,52654519,'Редактирайте настройките към модул за плащане',1),(808,2,909362514,'Име на модул за плащане:',1),(809,2,3629807128,'Заглавие на модул за плащане:',1),(810,2,100059395,'Модули за плащане',1),(811,2,4023227825,'Метод за интеграция',1),(812,2,1621980064,'Редкация на опции на добавката',1),(813,2,3696483166,'Име на добавка:',1),(814,2,1155909498,'Инсталиране на добавка',1),(815,2,3228116228,'Файл с добавка:',1),(816,2,2612794959,'Модули в добавка',1),(817,2,4005700258,'Добавка',1),(818,2,193471262,'Модул',1),(819,2,3424629120,'Моля първо изберете изображение.',1),(820,2,1392705431,'Само изображения могат да бъдат качени. Моля изберете JPG, PNG или GIF.',1),(821,2,3487826600,'Качете изображението',1),(822,2,1336794860,'Изберете изображението',1),(823,2,1983387308,'Преглед',1),(824,2,703179297,'Автоматично генериране на тъмб.',1),(825,2,45485956,'Тъмб:',1),(826,2,3535843008,'Затвори',1),(827,2,303993805,'Приложи сега',1),(828,2,1371193412,'Отказ',1),(829,2,2589634787,'Моля изберете полетата за отпечатване.',1),(830,2,4118653070,'Изберете информацията, която искате да отпечатате,',1),(831,2,3624458271,'Моля изберете продукт.',1),(832,2,4054035588,'Моля изберете категория:',1),(833,2,737252216,'продукта открити.',1),(834,2,2057586828,'Изберете продукта',1),(835,2,3711818894,'Продуктови атрибути',1),(836,2,3628166978,'Добави стойност',1),(837,2,4145562852,'Добави атрибут',1),(838,2,313419750,'Създайте продуктов клас',1),(839,2,2126945696,'Атрибути',1),(840,2,1465325025,'Редактирайте продуктовия клас',1),(841,2,4232330976,'Сигурни ли сте, че искате да изтриете този продуктов клас?',1),(842,2,218394244,'Нов продуктов клас',1),(843,2,2631993219,'Продуктов клас...',1),(844,2,912926102,'Филтрирайте продуктовите класове',1),(845,2,4142080300,'Намери продукт',1),(846,2,4293700324,'преминете към<br/>визуален редактор<br/>',1),(847,2,589944230,'преминете към<br/>обикновен текст',1),(848,2,1980386710,'Снимки',1),(849,2,2584338874,'Допълнителни категории',1),(850,2,3815204975,'Цени',1),(851,2,3563717080,'Свързани продукти',1),(852,2,2732013515,'Комплект',1),(853,2,854319462,'Номер на артикул (SKU)',1),(854,2,624639268,'Производител',1),(855,2,273309567,'Име на продукт',1),(856,2,314147162,'Кратко описание',1),(857,2,2857272176,'Подробно описание',1),(858,2,2224570068,'Наличен за продажба',1),(859,2,6377591,'Тегло',1),(860,2,1892211746,'фунт, кг',1),(861,2,2146757560,'Данъчни класове',1),(862,2,3641567454,'Няма дефинирани данъци.',1),(863,2,2594461011,'Заглавие продуктова страница',1),(864,2,3570241586,'Може да ползвате %%COMPANY_NAME%%, %%PAGE_NAME%%, %%CATEGORY_NAME%% и %%CATEGORY_BRANCH%% които ще бъдат заменени автоматично.',1),(865,2,2164287666,'Мета ключови думи',1),(866,2,39755518,'Мета описание',1),(867,2,3424188446,'Глобални опции',1),(868,2,3893533752,'Продуктова опция',1),(869,2,4250554258,'Продукта е е-стока:',1),(870,2,3302799654,'Продуктов клас',1),(871,2,2022403416,'Атрибут',1),(872,2,626226205,'Достъпен с бонус точки',1),(873,2,2254132409,'Цена в точки',1),(874,2,1807972765,'Оставете празно за автоматична цена.',1),(875,2,3714791612,'Ако е празно цената в точки ще бъде',1),(876,2,2824029570,'Продуктът е комплект',1),(877,2,3047654571,'Автоматични количества',1),(878,2,2431883014,'Ако е включено, при промяна на броя на някой подпродукт броя комплекти ще се обнови автоматично.',1),(879,2,954096422,'Включени продукти',1),(880,2,3664961198,'Сигурни ли сте, че искате да изтриете този продукт и всичките негови файлове е-стоки?',1),(881,2,3366923039,'Изтриване продукт',1),(882,2,3917002164,'Продукт който ще бъде изтрит:',1),(883,2,2664546985,'Изтриването на този продукт ще изтрие %%EGOODSCOUNT%% файлове с е-стоки.',1),(884,2,2130013892,'Файлове, които ще бъдат изтрити:',1),(885,2,3410550351,'Редактирайте продукта',1),(886,2,1257124279,'Варианти',1),(887,2,1778871822,'вижте вариантите',1),(888,2,2818503275,'вижте цените на едро',1),(889,2,2445281649,'вижте комплектите',1),(890,2,335754544,'Кликнете на тъмба, за да видите по-голямо изображение.',1),(891,2,4292304212,'Необходимо е да добавите опции от тип \"вариант\", за да имате продуктови варианти.',1),(892,2,3629807937,'Трябва да запишете вашите промени в продуктовите опции преди да можете да редактирате вариантите.',1),(893,2,4115961312,'Запази',1),(894,2,2619480116,'Запази и затвори',1),(895,2,1021041466,'С това действие ще премахнете всички е-стоки от продукта. Сигурни ли сте?',1),(896,2,166431123,'Добави/качи продуктови е-стоки',1),(897,2,3751438319,'Продуктовата Е-стока е файл (картинка, филм, документ, mp3 или друго) който ще бъде използван само за този продукт.',1),(898,2,75466410,'Добави/качи споделени е-стоки',1),(899,2,4183963746,'Споделената Е-стока е файл който може да бъде използван от повече от един продукт.',1),(900,2,428357396,'Забележка: Когато се изтрие продукт всичките му Е-стоки се изтриват заедно с него, докато споделените Е-стоки ще останат.',1),(901,2,3210431157,'Тъмб на картинка',1),(902,2,3929915345,'Качете ново изображение',1),(903,2,3607359936,'Добави картинка',1),(904,2,1146293855,'Локални опции',1),(905,2,3810910862,'Добави опция',1),(906,2,384259134,'Първо трябва да изберете категория и след това може да подреждате наличните в нея продукти.',1),(907,2,387876210,'Неуспешно сортиране.',1),(908,2,3932571580,'Разрешавате ли сортиране с влачене-и-пускане?',1),(909,2,1400665124,'Продуктите се подреждат с влачене нагоре и надолу.',1),(910,2,1224315921,'Сигурни ли сте, че искате да изтриете този продукт?',1),(911,2,691153231,'Търсете продукти',1),(912,2,1043481812,'Код на продукт (SKU)...',1),(913,2,4005851251,'Име на продукт...',1),(914,2,1372295029,'Допълнителни филтри',1),(915,2,2850335413,'Цена от...',1),(916,2,454427117,'Цена до...',1),(917,2,903571526,'Описание на продукт...',1),(918,2,878207540,'Нов продукт',1),(919,2,2115538962,'Подреди продуктите',1),(920,2,4038453503,'Количество',1),(921,2,2427847608,'Дублирай',1),(922,2,1291634369,'Цени на едро',1),(923,2,912557301,'Цени по клиентска група',1),(924,2,4016236161,'Добави ред с цени',1),(925,2,1348646173,'Нулирай цените на едро',1),(926,2,4218420269,'Сигурни ли сте, че искате да подмените индивидуалните цени на едро за тази продукт със общите цени на едро?',1),(927,2,1377088974,'Двупосочно',1),(928,2,3967730406,'Създайте бърза връзка за администраторите',1),(929,2,3395691925,'Текст на връзката:',1),(930,2,2990819220,'Място на връзката:',1),(931,2,811173354,'Редактирайте бърза връска за администраторите',1),(932,2,1543674835,'Сигурни ли сте, че искате да изтриете тази връзка?',1),(933,2,322693661,'Нова бърза връзка',1),(934,2,4129737893,'Място на връзката',1),(935,2,2046232192,'Филтрирайте бързите връзки',1),(936,2,2989896966,'Генерирайте отново снимките',1),(937,2,1428629460,'Продуктови картинки',1),(938,2,570540454,'Вариантни картинки',1),(939,2,3979516769,'Отидете в Общи настройки ',1),(940,2,1682980639,'Грешка:',1),(941,2,3119939844,'Предупреждение:',1),(942,2,3280171698,'Отчет',1),(943,2,1128758787,'Вижте (единица от време):',1),(944,2,1567988421,'Свалете като CSV',1),(945,2,613877038,'Диаграма',1),(946,2,937992258,'Таблица',1),(947,2,1435361928,'Стойност за диаграма:',1),(948,2,3482545072,'Топ:',1),(949,2,552652585,'Валута:',1),(950,2,4292548849,'Необходимо е да обновите Вашия Flash Player.',1),(951,2,1918578068,'Записи:',1),(952,2,1797036103,'Няма данни за избрания период.',1),(953,2,3711407533,'Меню',1),(954,2,1404066370,'Създайте богата текстова страница',1),(955,2,775396182,'Добави към менютата:',1),(956,2,3448845971,'Редактирайте страница с богат текст',1),(957,2,231048233,'Сигурни ли сте, че искате да изтриете тази страница с богат текст?',1),(958,2,4027838527,'Нова страница с богат текст',1),(959,2,1033268948,'Подредба',1),(960,2,3264327005,'Виж в клиентската област',1),(961,2,4266157535,'Филтрирайте страниците с богат текст',1),(962,2,1611866998,'Вие нямата права да видите резултатите от търсенето.',1),(963,2,1708902902,'Резултати от търсене',1),(964,2,3377439838,'Търсене в следните полетата на продукта:',1),(965,2,4229313245,'Търсене в следните полета на поръчката:',1),(966,2,1089105628,'Резултати в продукти:',1),(967,2,2101845315,'Никакви продукти не съвпадат с вашето запитване.',1),(968,2,904043044,'Резултати в поръчки:',1),(969,2,1661959455,'Не са намерени поръчки за вашето търсене.',1),(970,2,287223950,'Активирайте SSL:',1),(971,2,322374794,'Преди да активирате SSL моля проверете че <a href=\"%%HTTPS_URL%%login.php\" target=\"_blank\">тази SSL връзка</a> работи. Тя би трябвало успешно да отвори сигурната страница за вход.',1),(972,2,591812916,'Режим на запазване на паролите:',1),(973,2,637222123,'Заглавие на сайта:',1),(974,2,2078895898,'Може да ползвате %%COMPANY_NAME%% и %%PAGE_NAME%% които ще бъдат заменени автоматично.',1),(975,2,3064612706,'Ключови думи на сайта:',1),(976,2,2800913026,'Описание на сайт:',1),(977,2,452323653,'Приятелски за търсачки URL-и:',1),(978,2,1248220876,'Приятелските за търсачки URL-и изискват работещ mod_rewrite Apache модул.<br/>Преди да разрешите приятелски за търсачките URL-и моля проверете че те работят<br/>правилно на Вашия сървър като използвате <a href=\"../manufacturers.html\" target=\"_blank\">тази връзка</a>. Ако чрез нея не успеете да отворите<br/>страницата с списък на производителита моля свържете се с Вашия хостинг.',1),(979,2,234548374,'Тип на приятелските за търсачки връзки:',1),(980,2,1890709483,'\"en\" ще бъде заменен с текущия код на език.',1),(981,2,145668893,'Карта на сайта:',1),(982,2,1787636607,'Summer Cart автоматично генерира <a target=\"_blank\" href=\"../sitemap.xml\">XML файл</a> с информация<br />която помага на търсачките като Google, Yahoo и Bing<br />да намерят и индексират всички ваши страници.<br />Този <a target=\"_blank\" href=\"../sitemap.xml\">XML файл</a> е съвместим с официалния Sitemap Протокол.',1),(983,2,1997999718,'Настройте нов модул за доставка',1),(984,2,1695384782,'Модули за доставка',1),(985,2,1206177630,'Изберете модул:',1),(986,2,1640552363,'Редактирайте настройките към модул за доставка',1),(987,2,2460261966,'Име на модул за доставка:',1),(988,2,1465446556,'Заглавие на модул за доставка:',1),(989,2,2458156334,'Зона на доставка:',1),(990,2,3644878690,'Методи:',1),(991,2,1509244758,'Метод',1),(992,2,3069853601,'Видимо име',1),(993,2,2763921508,'Сигурни ли сте, че искате да изтриете този модул за доставка?',1),(994,2,917579977,'Нов модул за доставка',1),(995,2,1503249872,'Зона на доставка',1),(996,2,2414549776,'Създайте зона на доставка',1),(997,2,1051933231,'Изберете държава:',1),(998,2,2634450168,'Изберете области:',1),(999,2,3390204183,'Редактирайте зона на доставка',1),(1000,2,139103139,'Сигурни ли сте, че искате да изтриете тази зона?',1),(1001,2,2420183666,'Нова зона на доставка',1),(1002,2,559872952,'Редактиране на настройките на визия \"%%SKINNAME%%\"',1),(1003,2,900681827,'Управление на визията',1),(1004,2,3955952330,'Област за клиенти',1),(1005,2,1667261560,'Административна област',1),(1006,2,2399413882,'Следните визии са открити, но не бяха автоматично инсталирани, тъй като са за друга версия на Summer Cart. Може да се опитате да инсталирате такива визии чрез натискане на бутона за инсталация.',1),(1007,2,2261691191,'Име на визия:',1),(1008,2,2648372470,'За Summer Cart версия:',1),(1009,2,2304637720,'Създайте област',1),(1010,2,3301864581,'Редактирайте област',1),(1011,2,509600253,'Сигурни ли сте, че искате да изтриете тази област?',1),(1012,2,2461920694,'Управление на области',1),(1013,2,3795944341,'Нова област',1),(1014,2,2630807802,'Държава',1),(1015,2,2988164914,'Филтрирайте областите',1),(1016,2,1120297998,'Име на област...',1),(1017,2,336266959,'Код на област...',1),(1018,2,3541575390,'Създайте данъчни класове',1),(1019,2,3592612221,'Създайте данъчен клас',1),(1020,2,1875561992,'Редактирайте данъчния клас',1),(1021,2,1641442946,'Нов данъчен клас',1),(1022,2,3591424722,'Нагоре',1),(1023,2,3167567621,'Надолу',1),(1024,2,1323977902,'Данъчни ставки',1),(1025,2,4286733379,'Обновете ставките',1),(1026,2,3198370186,'Създайте данъчни зони',1),(1027,2,2805721639,'Създайте данъчна зона',1),(1028,2,122382079,'Редактирайте данъчните зони',1),(1029,2,701011537,'Редактирайте данъчната зона',1),(1030,2,2415154938,'Данъчни зони',1),(1031,2,4007669337,'Нова данъчна зона',1),(1032,2,3578194776,'Създайте данък',1),(1033,2,4144846822,'Име на данък:',1),(1034,2,2564721856,'Регистрационен номер:',1),(1035,2,2659130368,'Важи за транспорта:',1),(1036,2,1468898402,'Приложи по подразбиране:',1),(1037,2,2981161265,'Редактирайте данъка',1),(1038,2,1438361936,'Сигурни ли сте, че искате да изтриете този данък?',1),(1039,2,1932327382,'Нов данък',1),(1040,2,63310942,'Регистрационен номер',1),(1041,2,2457820364,'Важи за транспорта',1),(1042,2,2770220216,'Приложи по подразбиране',1),(1043,2,3327491243,'Редактирайте ставките',1),(1044,2,3367706607,'Филтрирайте данъците',1),(1045,2,4136245189,'Изберете изображението за качване',1),(1046,2,842812345,'Качи...',1),(1047,2,3457770897,'Изображения, по-големи от %%IMAGE_MAX_WIDTH%%x%%IMAGE_MAX_HEIGHT%% пиксела ще бъдат намалени автоматично.',1),(1048,2,3215342,'Последните 30 дни',1),(1049,2,3043440391,'Последни 7 дни',1),(1050,2,3922919155,'Този месец',1),(1051,2,1507105497,'Миналия месец',1),(1052,2,36063916,'Тази година',1),(1053,2,3571073750,'Миналата година',1),(1054,2,1009032439,'Всичко',1),(1055,2,403610525,'Определена дата',1),(1056,2,3060721506,'Всички дати преди',1),(1057,2,3086509526,'Всички дати след',1),(1058,2,1570709765,'Период от време',1),(1059,2,2717396598,'Начална дата',1),(1060,2,111718006,'Крайна дата',1),(1061,2,2753412866,'Следваща',1),(1062,2,483403627,'Предишна',1),(1063,2,2954842005,'Готово.',1),(1064,2,4274732151,'Merchant ID:',1),(1065,2,2453922054,'Merchant Key:',1),(1066,2,3676946771,'Резервната сума за доставка ще бъде използвана ако изчислението на сумата за доставка се провали.<br/>\nВашите клиенти ще платят резервната сума за доставка ако точната сума не може да се изчисли.<br/>\nАко не използвате резервната сума за доставка и точната сума не може да се изчисли клиентът ще бъде уведомен, че не могат да поръчат доставка на този адрес.<br/>',1),(1067,2,1672584572,'Използвайте резервната сума за доставка:',1),(1068,2,1083706231,'Резервна сума за доставка:',1),(1069,2,2330328948,'Изберете тази опция ако не изпращате до пощенски кутии.',1),(1070,2,3372155483,'US пощенски кутии са забранени:',1),(1071,2,2052058202,'Валута на акаунта на продавача:',1),(1072,2,2489100572,'Режим:',1),(1073,2,147726518,'Инструкции за бърза настройка',1),(1074,2,1017425442,'Please login to your Google Checkout account, click on Settings tab, and choose Integration menu.',1),(1075,2,144205977,'1. Check \"My company will only post digitally signed carts.\" checkbox.',1),(1076,2,3022219378,'2. Set \"API callback URL:\" to \"%%HTTPS%%modules/checkout/google/notify.php?gkey=[Merchant_Key]&amp;gid=[Merchant_ID]\". Replace [Merchant_Key] and [Merchant_ID] with the actual values.',1),(1077,2,1228526745,'3. Set \"Callback method\" to be XML.',1),(1078,2,401607006,'In \"Advanced settings\" check the following options:',1),(1079,2,2549034529,'1. Provide the first name, last name and full name of the buyer and order recipient in separate fields in the new order notification.',1),(1080,2,3348692449,'2. Return the buyer\'s ship-to phone number in the new order notification.',1),(1081,2,3645134935,'3. Return the buyer\'s billing phone number in the new order notification.',1),(1082,2,412387362,'While logged into your Google Checkout account you can check for integration errors from the Tools tab, Integration Console menu.',1),(1083,2,1554049617,'Общи настройки',1),(1084,2,835196441,'Въведете email-а, с който влизате във Вашия акаунт, или Secure Merchant Account ID.',1),(1085,2,1019086286,'Потребител:',1),(1086,2,554271247,'Платежна Операция:',1),(1087,2,3611595129,'Разреши Клиентска Бележка:',1),(1088,2,3000703641,'Изисква се потвърден адрес на доставка:',1),(1089,2,1520063823,'PayPal входна страница:',1),(1090,2,1645277103,'Показвай страница за потвърждение:',1),(1091,2,1368278113,'Когато се ползва допълнителната страница за потвръждение Summer Cart винаги успява да начисли правилния данък и такса за доставка.',1),(1092,2,2771442886,'Тип на бутона за поръчка:',1),(1093,2,2848467461,'API Достъп',1),(1094,2,2578337366,'API достъпът Ви позволява да изпълнявате операциите Усвояване, Ре-оторизация, Възстановяване и Анулиране директно от екрана за управление на поръчки в Summer Cart. За да разрешите API Достъп:',1),(1095,2,2942559741,'Влезте във Вашия акаунт в <a href=\"https://www.paypal.com/\" target=\"_blank\">https://www.paypal.com/</a>',1),(1096,2,927331701,'В раздел \"My Account\" изберете подраздел \"Profile\"',1),(1097,2,3877642009,'Кликнете върху връзка \"API Access\" в колона \"Account Information\"',1),(1098,2,2847613079,'Кликнете върху връзка \"Request API Credentials\"',1),(1099,2,1389165952,'Изберете \"Request API signature\" и кликнете върху \"Agree and Submit\"',1),(1100,2,4065605080,'PayPal ще покаже \"API account username\", \"API Password\" и \"Signature\". Моля въведете ги в полетата по-долу',1),(1101,2,1731671543,'Кликнете върху \"Done\"',1),(1102,2,253979313,'API Username:',1),(1103,2,926299189,'API Password:',1),(1104,2,2524839449,'API Signature:',1),(1105,2,2363892471,'Ако е избрано, клиентът ще потвърди поръчката си в PayPal.',1),(1106,2,2923539806,'Валута по подразбиране',1),(1107,2,2153718755,'Валутата по подразбиране ще бъде използвана ако текущата валута на клиента не се поддържа от Paypal.',1),(1108,2,147299665,'Валутата по подразбиране трябва да съществува във <a href=\"currencies.php\">управление на валутите.</a>',1),(1109,2,2557676385,'Валута по подразбиране:',1),(1110,2,515095047,'Разрешаване на поръчки от гости',1),(1111,2,402334869,'Поребителя може да въвежда инструкции към поръчката',1),(1112,2,3811724674,'Изисквай потребителя да приеме условията',1),(1113,2,1299144461,'Условия',1),(1114,2,3244184526,'Създайте новина',1),(1115,2,837680854,'Добави новина',1),(1116,2,1706368814,'Дата:',1),(1117,2,4115954736,'Редактирайте новината',1),(1118,2,4260919213,'Сигурни ли сте, че искате да изтриете тази новина?',1),(1119,2,684042718,'Филтрирайте новините',1),(1120,2,1521578592,'Заглавие на новина...',1),(1121,2,1705759856,'Следните такси ще бъдат приложени когато клиент избере Наложен платеж като начин на плащане.',1),(1122,2,3011918322,'Използвай таксата за наложен платеж от модула за достава, ако е известна:',1),(1123,2,4071801088,'Фиксирана сума:',1),(1124,2,1584702284,'Пропорционална такса:',1),(1125,2,32364822,'Демо режим:',1),(1126,2,2025693602,'За да нагласите тайната дума, влезте във вашия 2CO Account и погледнете в секция \"Look &amp; Feel\".',1),(1127,2,166627762,'Тайната дума се използва за подписване на информацията за транзакция, която Summer Cart получава от 2Checkout.',1),(1128,2,4243974355,'Тайна дума',1),(1129,2,187187385,'Тайна дума:',1),(1130,2,1836520064,'Моля не забравяйите да влезете във Вашия 2CO Account и да настроите \"Approved URL\" и \"Pending URL\" в секция \"Look &amp; Feel\" на',1),(1131,2,3313317985,'Direct Return трябва да бъде настроено на \"No\".',1),(1132,2,2455784416,'Atos Worldwide E - Transactions - Сигурни Интернет Плащания',1),(1133,2,2759416782,'Изберете начин на плащане',1),(1134,2,2510548134,'Език по подразбиране:',1),(1135,2,2838166432,'Моля проверете, че в директория modules/payment/atos/executables/ има файлове \'request\' и \'response\' и че те са изпълними. Тези файлове ще получите от Вашата банка.',1),(1136,2,1252629769,'API Login ID:',1),(1137,2,2504138788,'Ключ за транзакция:',1),(1138,2,1332928208,'MD5 Хеш:',1),(1139,2,30186195,'Отместване на времевата зона:',1),(1140,2,2317008269,'часа',1),(1141,2,1677552814,'Ключовете са вече генерирани. Тази операция ще изтрие текущите ключове и модулът няма да работи докато не се въведът новите сертификати.',1),(1142,2,1499286651,'Ключът вече e генериран. Потвърдете генерирането на нов ключ.',1),(1143,2,3787401028,'Помощник за настройка на модул за плащане Борика',1),(1144,2,3391458734,'Данни, които ще бъдат използвани за сертификата',1),(1145,2,929483243,'Област:',1),(1146,2,3619342144,'Местоположение (град):',1),(1147,2,247743386,'Звено в организацията:',1),(1148,2,2563698514,'Общо име:',1),(1149,2,3253870329,'Помощник за генериране на ключове',1),(1150,2,487826370,'Стъпка 1:',1),(1151,2,3578621044,'Генерирайте реалния частен ключ, тестовия частен ключ и техните CSR-и за платежната система.',1),(1152,2,40894957,'Генериране',1),(1153,2,910094337,'Стъпка 2:',1),(1154,2,3851170156,'Генериране на частен ключ и CSR за eTLog.',1),(1155,2,4053559235,'Изтеглете файлове CSR за режим <strong>готов</strong> (<a href=\"?ModuleName=com.summercart.payment.borica.gate&amp;action=acDownloadApgwCSR\">изтегли</a>), CSR за режим <strong>тест</strong> (<a href=\"?ModuleName=com.summercart.payment.borica.gate&amp;action=acDownloadApgwTestCSR\">изтегли</a>) и eTLog CSR (<a href=\"?ModuleName=com.summercart.payment.borica.gate&amp;action=acDownloadEtlogCSR\">изтегли</a>) и ги изпратете на Вашата банка.',1),(1156,2,1801018908,'Банката ще Ви изпрати три сертификата - за режим \"готов\", за режим \"тест\" и за eTLog.',1),(1157,2,3174182879,'Изпратете Return URL, показано на предната страница, на вашата банка.',1),(1158,2,791003456,'Стъпка 3:',1),(1159,2,172391364,'Задайте 8-цифрения Terminal ID (TID), който сте получили от вашата банка.',1),(1160,2,1617188743,'Стъпка 4:',1),(1161,2,2727466293,'Поставете съдържанието на eTLog сертификата в полето по-долу и вземете .p12 файла.',1),(1162,2,3878699623,'Сертификата започва с \"-----BEGIN CERTIFICATE-----\".',1),(1163,2,3003313697,'Вземете .p12 файл',1),(1164,2,3471349272,'Импортирайте файла .p12 във вашия браузер.',1),(1165,2,1196369362,'Върнете се към модула Борика',1),(1166,2,3425203614,'Терминален номер (TID):',1),(1167,2,3978171891,'8-цифров код предоставен от Вашата банка.',1),(1168,2,442304913,'Описание на поръчка:',1),(1169,2,2254540171,'Моля въведете надписа с описание поръчката.',1),(1170,2,728497053,'Валута на акаунта:',1),(1171,2,1580903947,'Частен ключ за реалния APGW:',1),(1172,2,4044169584,'Частния ключ започва с \"-----BEGIN RSA PRIVATE KEY-----\".',1),(1173,2,87950621,'Частен ключ за тестов APGW:',1),(1174,2,1034705443,'Сертификат за реалния APGW:',1),(1175,2,1722347829,'Сертификат за тестовия APGW:',1),(1176,2,1556796273,'Стъпки за конфигуриране:',1),(1177,2,1451649640,'Използвайте \"<a href=\"module.php?ModuleName=com.summercart.payment.borica.gate&amp;action=acBoricaSetupWizard\">Помощник за настройка на модул за плащане Борика</a>\".',1),(1178,2,3028765641,'Обратно URL:',1),(1179,2,2288359418,'Отмяна на плащане',1),(1180,2,914933220,'Обща сума на поръчка:',1),(1181,2,1794229843,'Сума за възстановяване:',1),(1182,2,2310413392,'Клиентски номер:',1),(1183,2,1706633060,'Ключ за активация:',1),(1184,2,2522822593,'Метод:',1),(1185,2,1614476677,'Видове приемани чекове:',1),(1186,2,2281461740,'Продуктовo ID:',1),(1187,2,1739691339,'Валута на продукт:',1),(1188,2,2751553006,'Максимална сума:',1),(1189,2,3064029683,'За да приложите такса ако клиент избере \"Наложен платеж\" като начин на плащане, моля не забравяйте да активирате съответния \"Наложен платеж\" модул за сума на поръчка. Таксата се задава в модула за сума на поръчка.',1),(1190,2,3060458674,'Ще се осигури от Банка ДСК.',1),(1191,2,1268699863,'Код на валута:',1),(1192,2,372582953,'MD5 парола',1),(1193,2,1454021497,'MD5 парола:',1),(1194,2,1155475729,'Изисква се MD5 парола. Тя се използва за да се следят транзакциите, които Summer Cart изпраща и получава от ДСК Директ.',1),(1195,2,4233366650,'ВАЖНА ЗАБЕЛЕЖКА',1),(1196,2,1780295817,'Ако нямате активиран SSL сертикифат Вашите клиенти ще виждат предупреждение в техния браузер когато завършат плащането си. ',1),(1197,2,3901631899,'Ако клиент кликне Отказ магазинът няма да получи известие за плащането.',1),(1198,2,2461502548,'Клиентски номер:',1),(1199,2,2223644698,'Таен ключ:',1),(1200,2,2646160959,'Срок на валидност<br /> на заявката за плащане:',1),(1201,2,1847368024,'Инструкции за плащане:',1),(1202,2,3287268887,'Номер на търговец:',1),(1203,2,1571859967,'Име на търговец:',1),(1204,2,173849435,'Парола на търговец:',1),(1205,2,40686185,'Описание на поръчката:',1),(1206,2,887383748,'Storefront ID:',1),(1207,2,4252987528,'13-символен низ във формат UK12345678CUR.',1),(1208,2,3793027758,'Тип на транзакция:',1),(1209,2,2443707600,'Споделена тайна',1),(1210,2,2454473967,'Споделена тайна:',1),(1211,2,4044273798,'Ще получите вашия shared secret (32-символен низ) от HSBC.',1),(1212,2,444762562,'Валута по подразбиране:',1),(1213,2,3199946140,'Ако клиентът пазарува във валута различна от USD и CAD, в коя валута да плати.',1),(1214,2,274243051,'Забележки към плащането:',1),(1215,2,31088455,'Опции за CAD',1),(1216,2,2952545973,'Номер на хостед платежна страница:',1),(1217,2,3744805632,'Ключ на хостед платежна страница:',1),(1218,2,1636167766,'Опции за USD',1),(1219,2,2527265290,'Допълнителна информация за Moneris Merchant Hosted Configuration',1),(1220,2,630578004,'За Response Method изберете GET или POST и въведете следния URL в полето Response URL:',1),(1221,2,3137146140,'В Security Features сложете отметка на <strong>\"Enable Transaction Verification\"</strong> чекбокс.',1),(1222,2,3150990615,'Изберете опция <strong>\"Displayed as XML on our server\"</strong> в секция \"Response Method\".',1),(1223,2,2158506343,'Оставете полето <strong>\"Response URL\"</strong> празно.',1),(1224,2,2202504530,'Email на търговеца към който се плаща:',1),(1225,2,3975230462,'Описание на получателя:',1),(1226,2,2822597311,'URL към лого:',1),(1227,2,2639952004,'URL към вашето лого. Трябва да започва с https://. Ще бъде показано на страницата за плащане.',1),(1228,2,3283790610,'Скрий вход:',1),(1229,2,4038141604,'Ако е включено Moneybookers няма да позволи на клиента да влезне в сметка си в Moneybookers.',1),(1230,2,28162475,'Използвай Iframe:',1),(1231,2,2831228941,'Ако е включено формата за плащане ще бъде вградена в магазина, в противен случай клиента ще бъде препратен на сайта на Moneybookers за да извърши плащането.',1),(1232,2,1008152630,'Екран за потвърждение',1),(1233,2,2431019173,'Показват се на екрана с потвърждение (последната стъпка от процеса)',1),(1234,2,910248752,'Бележка с потвърждение:',1),(1235,2,3787582312,'Може да ползвате &lt;br&gt; за нов ред.',1),(1236,2,3195721565,'Текст за Return URL:',1),(1237,2,1977604747,'Текста на бутона за връщане когато потребителя завърши плащането.',1),(1238,2,2999123729,'Валутата по подразбиране ще бъде използвана ако текущата валута на клиента не се поддържа от Moneybookers.',1),(1239,2,1600929358,'За да нагласите тайната дума, влезте във вашия Moneybookers Account и погледнете в секция \"Merchant Tools\".',1),(1240,2,1503288321,'Тайната дума се използва за подписване на информацията за транзакция, която Summer Cart получава от Moneybookers.',1),(1241,2,3635999792,'Може да намерите PSPID отляво на страницата във вашия Ogone акаунт.',1),(1242,2,614528529,'PSPID:',1),(1243,2,2741808256,'Заглавие на страницата за плащане:',1),(1244,2,737850223,'SHA-1-IN Signature от Вашия акаунт в Ogone (ще го намерите в \"Technical information\" -> \"Data and origin verification\" -> \"SHA-1-IN Signature\")',1),(1245,2,390345667,'SHA-1-IN:',1),(1246,2,546023244,'SHA-1-OUT Signature от Вашия акаунт в Ogone (ще го намерите в \"Technical information\" -> \"Data and origin verification\" -> \"SHA-1-OUT Signature\")',1),(1247,2,3625104482,'SHA-1-OUT:',1),(1248,2,1411657282,'Разрешени валути:',1),(1249,2,1213247299,'Важно',1),(1250,2,2279891751,'Моля разрешете опцията \"I want to receive transaction feedback parameters on the redirection URLs\". Вие ще я намерите във Вашия акаунт в Ogone, като отворите \"Configuration\" -> екран \"Technical Information\", в раздел \"Transaction Feedback\".',1),(1251,2,1145282425,'Усвояване',1),(1252,2,1073846020,'Вече усвоена сума:',1),(1253,2,55238551,'Усвоена сума:',1),(1254,2,2927438680,'Е финален:',1),(1255,2,3190779602,'Ще има допълнителни операции за усвояване',1),(1256,2,3769638272,'Това е финално усвояване',1),(1257,2,1229371311,'Бележка (незадължително):',1),(1258,2,205308943,'Търговец ID:',1),(1259,2,429771270,'Партньор:',1),(1260,2,3661788121,'Потребител:',1),(1261,2,178066530,'Ако не сте създали потребител въведете Търговец ID тук.',1),(1262,2,3029983581,'Разреши клиентска идентификация:',1),(1263,2,1359090026,'Ако е избрано, клиентът ще премине през 3D secure оторизация (\"Verified By Visa\" и \"SecureCode\").',1),(1264,2,2360048237,'Ре-оторизация',1),(1265,2,2303808259,'Сума на ре-оторизация:',1),(1266,2,1551896942,'Възстановяване',1),(1267,2,1145322128,'Усвоена сума:',1),(1268,2,2162064995,'Транзакция по възстановяване:',1),(1269,2,1078819742,'Цяла',1),(1270,2,1706748264,'Частична',1),(1271,2,864998091,'Моля въведете надписа с описание на поръчката. Ако е оставен празен клиентите ще могат да въведат тяхно описание по време на покупка.',1),(1272,2,2974419541,'Payment Data Transfer (PDT)',1),(1273,2,1828463134,'Моля разрешете PDT.',1),(1274,2,3741902324,'Кликнете върху връзка \"Website Payment Preferences\" в колона \"Selling Preferences\"',1),(1275,2,3902299500,'Разрешете \"Auto-Return\" (и копирайте и поставете показаното по-долу Return URL)',1),(1276,2,1874574508,'Разрешете \"Payment Data Transfer\"',1),(1277,2,1193147294,'Кликнете \"Save\"',1),(1278,2,3825642984,'PayPal ще Ви покаже PDT identity token. Въведете го в полето по-долу.',1),(1279,2,1104199793,'PDT Identity Token:',1),(1280,2,4230348253,'Кодиране на език',1),(1281,2,3935609386,'По подразбиране PayPal изпраща известия с windows-1252 кодиране, което ще направи нечетими всички символи, които не са на латиница.  ',1),(1282,2,1916601122,'Вместо това, Вие трябва да информирате PayPal да изпраща известия с UTF-8 кодиране. Ето как:',1),(1283,2,1853139557,'Кликнете върху връзка \"Language Encoding\" в колона \"Selling Preferences\"',1),(1284,2,1699103402,'Използвайте бутон \"More Options\"',1),(1285,2,1143435416,'От падащото меню изберете UTF-8, и изберете \"Yes\" за да използвате това предпочитание с IPN',1),(1286,2,4271664381,'Кликнете \"Save\"',1),(1287,2,1371444183,'Инсталационно ID:',1),(1288,2,3981919405,'Режим на оторизация:',1),(1289,2,3623864170,'Моля забележете, че за да ползвате режим &quot;Pre Auth&quot; може да е необходимо да поискате активирането му от поддръжката на WorldPay.',1),(1290,2,3767901768,'Разрешаване на редакция на контактна информация:',1),(1291,2,4075630300,'Ако е включено клиентите ще могат да редактират техните имена и адреси на сайта на RBS WorldPay.',1),(1292,2,3435607478,'Валутата по подразбиране ще бъде използвана ако текущата валута на клиента не се поддържа от RBS WorldPay.',1),(1293,2,3435195543,'MD5 тайна за транзакциите<br />(до 16 символа):',1),(1294,2,1099005614,'Тайната дума се използва за подписване на информацията за транзакция, която Summer Cart изпраща към RBS WorldPay.',1),(1295,2,1785134662,'Парола за отговора:',1),(1296,2,2128563735,'Използва се, за да се провери отговора от RBS WorldPay.',1),(1297,2,1756952934,'Влезте във Вашия RBS WorldPay акаунт и вижте в меню \"Инсталации\"',1),(1298,2,841163493,'Изберете \"Инсталацията\", която искате да конфигурирате',1),(1299,2,990984551,'Въведете \"%%HTTPS%%modules/payment/rbsworldpay/response.php\" в \"Payment Response URL\"',1),(1300,2,1938529821,'Маркирайте отметка \"Payment Response enabled?\"',1),(1301,2,118523628,'Маркирайте отметка \"Enable the Shopper Response\"',1),(1302,2,4057498740,'Задайте стойността на \"Payment Response password\". Не забравяйте да я въведете по-горе',1),(1303,2,2130128007,'Задайте стойността на \"MD5 secret for transactions\". Не забравяйте да я въведете по-горе',1),(1304,2,193969084,'Тайна:',1),(1305,2,2399392064,'Акаунт (незадължителен):',1),(1306,2,2661746016,'Автоматичен capture:',1),(1307,2,4089531088,'Пренасочване от URL:',1),(1308,2,2409134777,'Доставчик:',1),(1309,2,1253391832,'Валутата по подразбиране ще бъде използвана ако текущата валута на клиента не се поддържа от Sage Pay.',1),(1310,2,3157569171,'Парола за кодиране:',1),(1311,2,1001769353,'Email-и от Sage Pay',1),(1312,2,2769525101,'Email на доставчика (опционно):',1),(1313,2,2774351315,'Email на доставчика на който да се изпраща информация за транзакцията. Множество email адреси могат да бъдат въведени като се разделят с \":\" (двуеточие).',1),(1314,2,199766793,'Изпращане на email-и с информация за транзакцията:',1),(1315,2,926829729,'Съобщение до клиента (опционнно):',1),(1316,2,1242364881,'Ако е въведено, ще се включи в началото на email-лите за потвърждение изпратени на клиента.',1),(1317,2,2683762813,'9-цифров',1),(1318,2,624437297,'Частен ключ за реалния режим:',1),(1319,2,2117894951,'Частен ключ за тестов режим:',1),(1320,2,1223025197,'Транскарт сертификат за реален режим:',1),(1321,2,333531451,'Транскарт сертификат за тестов режим:',1),(1322,2,515708534,'Редактирайте банка %%BANKNAME%%',1),(1323,2,2429941028,'Редактирайте банка',1),(1324,2,1651168334,'Store ID:',1),(1325,2,434599511,'Е активен:',1),(1326,2,44303849,'Store Key',1),(1327,2,3453667558,'Store Key:',1),(1328,2,1466148554,'Изисква се store key. Той се използва за да се следят транзакциите, които Summer Cart изпраща и получава от Вашата банка.',1),(1329,2,1132470983,'Вноски:',1),(1330,2,1278578948,'Може да предлагате на Вашите клиенти разплащане на вноски. Моля създайте брой вноски и съответните лихвени проценти.',1),(1331,2,3869367668,'Вноски',1),(1332,2,649126636,'Лихвен процент (%)',1),(1333,2,69889613,'Банка по подразбиране:',1),(1334,2,3695363791,'Банката по подразбиране се използва за обработка на плащания в случаите когато клиент избере \"Карта от друга банка\".',1),(1335,2,1791432850,'Банки',1),(1336,2,1153185069,'Лого',1),(1337,2,1633730451,'Терминали:',1),(1338,2,2554014956,'Качете файла resource.cgn, който ви е даден от ОББ:',1),(1339,2,3108494789,'Използвай \"<a href=\"module.php?ModuleName=com.summercart.payment.ubb_bg.hostedpage&action=acUbbBgSetupWizard\">помощник за настройки на модул за плащания чрез ОББ</a>\".',1),(1340,2,2147088633,'Помощник настройки за модул за плащане ОББ',1),(1341,2,2731437692,'Качете файл resource.cgn',1),(1342,2,2377979207,'Връщане към модула на ОББ.',1),(1343,2,2255685458,'Информация относно банкaта и инструкции за извършване трансфера:',1),(1344,2,3948245510,'Номер на търговец:',1),(1345,2,2382770493,'Пощенски код:',1),(1346,2,2828876885,'Незадължително. Пощенския код на Вашия склад. <strong>Трябва да е канадски</strong>.',1),(1347,2,494733389,'Време за обработка:',1),(1348,2,3169761664,'Незадължително. В това поле вие може да зададете времето, което е необходимо за да подготвите поръчката за изпращане.',1),(1349,2,2361988811,'e-Econt потребител:',1),(1350,2,3034335311,'e-Econt парола:',1),(1351,2,2848807441,'e-Econt',1),(1352,2,3849822505,'Влез в e-Econt',1),(1353,2,2970828923,'Информация за контакт',1),(1354,2,4090029808,'Име на фирма:',1),(1355,2,3007368028,'Име на лице:',1),(1356,2,3270727197,'Адрес',1),(1357,2,2025602183,'Адрес 1:',1),(1358,2,1402040132,'Адрес 2:',1),(1359,2,87389314,'Взимане от:',1),(1360,2,1915995396,'Обратна разписка:',1),(1361,2,2234420808,'Минимална сума за деклариране (незадължително):',1),(1362,2,3907473293,'Ако е зададено пратките на по-ниска стойност няма да имат декларирана стойност.',1),(1363,2,4108804899,'Номер на договор за наложен платеж (незадължително):',1),(1364,2,4061175651,'Моля свръжете се с Econt за да получите номер на споразумение за наложен платеж.',1),(1365,2,3184466366,'Клиентски номер (незадължителен):',1),(1366,2,431111556,'Моля въведете вашия FedEx Account Number. Вашият Meter Number ще бъде придобит автоматично.',1),(1367,2,830283296,'Meter Number:',1),(1368,2,1115236530,'Изпрати от',1),(1369,2,3657543221,'Детайли за контакт',1),(1370,2,1921115224,'Име на човек:',1),(1371,2,2670906935,'Отдел:',1),(1372,2,1124291200,'Само цифри',1),(1373,2,4131668273,'Номер на пейджър:',1),(1374,2,3968392638,'Код на област или провинция:',1),(1375,2,3313956470,'Код на държава:',1),(1376,2,3751130500,'Други',1),(1377,2,610088699,'Застраховка:',1),(1378,2,2475299491,'Пратките ще бъдат застраховани за нетната сума на поръчка.',1),(1379,2,1763209963,'Тегло на опаковката:',1),(1380,2,1472220333,'Това тегло ще бъде добавено към теглото на стоките.',1),(1381,2,1457601935,'Такса за доставка:',1),(1382,2,3236430179,'Клиент',1),(1383,2,3309533356,'Тествайте данните за акаунта',1),(1384,2,2288290833,'Информация за акаунта',1),(1385,2,4186509951,'Допълнителни опции',1),(1386,2,1484115338,'Чупливи стоки:',1),(1387,2,3859110517,'Добави застраховка:',1),(1388,2,3096612495,'Документи:',1),(1389,2,3513682807,'Включи ДДС:',1),(1390,2,1988450491,'Тип на обработка:',1),(1391,2,3669659083,'Сума за обработка:',1),(1392,2,202443566,'Инициализация',1),(1393,2,1894811959,'Локации:',1),(1394,2,213284011,'Вземи локации от Speedy',1),(1395,2,1993580989,'Импорт на локациите ще отнеме време. Моля изчакайте.',1),(1396,2,1968273914,'Правили сте промени по формуляра. Ако продължите тези промени ще бъдат загубени. Да се продължи ли?',1),(1397,2,382735039,'Импортирането на градове ще отнеме време. Да продължа ли?',1),(1398,2,2564620584,'Зареждане',1),(1399,2,1117520404,'Брой пакети:',1),(1400,2,3857914122,'Дата на взимане:',1),(1401,2,98663625,'Печат на товарителница',1),(1402,2,2718602126,'Изтриване на товарителница',1),(1403,2,387154378,'Изтривайки товарителницата Вие ще я изтриете само от базата данни на Summer Cart, и ще може дада създадете нова товарителница за тази поръчка.',1),(1404,2,488747049,'Също така е необходимо да я откажете чрез WebClients интерфейса на Speedy, или като им се обадите.',1),(1405,2,53144288,'Печат на етикет',1),(1406,2,957135579,'Сигурни ли сте, че искате да изтриете тази товарителница?',1),(1407,2,1799531275,'До Тегло/Сума/Брой',1),(1408,2,3088333762,'Цена',1),(1409,2,860927180,'Моля въведете вашите UPS User ID, парола за UPS и XML Access Number:',1),(1410,2,3699446743,'UserID:',1),(1411,2,3165438484,'XML Access Number:',1),(1412,2,2402760031,'Сървър:',1),(1413,2,3598087712,'Тип взимане:',1),(1414,2,1275046918,'Вид на пакет:',1),(1415,2,1095994250,'Класификация на клиент',1),(1416,2,2862999173,'Изберете това как е класифициран вашия UPS акаунт.',1),(1417,2,806419272,'Моля въведете вашия USPS User ID:',1),(1418,2,2386614917,'Товарителница',1),(1419,2,1625579401,'Товарителница за поръчка #%%ORDERID%%',1),(1420,2,2571559162,'Отчитане на поръчките направени за последните',1),(1421,2,1658504578,'Брой бестселъри, които да се покажат',1),(1422,2,760001896,'Подреди по',1),(1423,2,3278654271,'Покажи',1),(1424,2,2488687378,'производители',1),(1425,2,1896218232,'Брой нови продукти, които да се покажат',1),(1426,2,234900711,'Адресът за доставка е същият като за плащане',1),(1427,2,858079896,'Добави артикул',1),(1428,2,1347538713,'Извади артикул',1),(1429,2,2492926120,'Продуктови опции:',1),(1430,2,3909844064,'Каталожна цена:',1),(1431,2,3966210395,'Цена:',1),(1432,2,1444368431,'Добави в количката',1),(1433,2,2685524125,'Няма наличност',1),(1434,2,1158486406,'Добави продукти',1),(1435,2,3567521997,'Име на продукт:',1),(1436,2,2020104747,'Филтър',1),(1437,2,917550841,'включително подкатегориите',1),(1438,2,1437113292,'Всичко',1),(1439,2,2408483464,'Изпращане',1),(1440,2,213186513,'За да можете да изпратите бюлетин на този език трябва да попълните полето тема.',1),(1441,2,666948076,'Изпрати бюлетин',1),(1442,2,1565721205,'Тема:',1),(1443,2,762611188,'Съобщение:',1),(1444,2,2676347204,'Изпрати на клиенти:',1),(1445,2,2633172727,'Изпрати на абонати:',1),(1446,2,4061451667,'Прогрес на изпращането',1),(1447,2,426031496,'Спри',1),(1448,2,1124418244,'Стартирай нов процес',1),(1449,2,2755086305,'Изпращането завърши успешно.',1),(1450,2,2265563646,'Сигурни ли сте, че искате да стартирате нов процес?',1),(1451,2,2955059868,'Сигурни ли сте, че искате да спрете това изпращане?',1),(1452,2,3129553589,'Бюлетинни статистики',1),(1453,2,3147226886,'Статистики на изпращането',1),(1454,2,1485082975,'Вижте изпращането',1),(1455,2,3614080499,'Абонамент за бюлетин:',1),(1456,2,2746901891,'Известяване на администраторите при абониране:',1),(1457,2,1642897459,'Създайте бюлетин',1),(1458,2,3168659782,'Добави бюлетин',1),(1459,2,1094372775,'Редактирайте бюлетина',1),(1460,2,3859046914,'Сигурни ли сте, че искате да изтриете този бюлетин?',1),(1461,2,2840697211,'Абонати',1),(1462,2,2018365746,'Тест',1),(1463,2,2525382830,'Статистика',1),(1464,2,1590625456,'Виж',1),(1465,2,254338594,'Тестван',1),(1466,2,747041944,'Тествайте първо',1),(1467,2,714700702,'Име на бюлетин...',1),(1468,2,2060057791,'Филтрирайте бюлетините',1),(1469,2,2453435967,'Покажи',1),(1470,2,879953894,'Тема',1),(1471,2,1475250567,'Изпратени Email-и',1),(1472,2,3918409999,'Отворени Email-и',1),(1473,2,1493021949,'Email-и с кликове',1),(1474,2,2679662937,'Детайлни статистики',1),(1475,2,3504695945,'Детайлни статистики',1),(1476,2,2571484763,'Вижте изпращането',1),(1477,2,621797607,'Добави абонати',1),(1478,2,3547385618,'Абонати:',1),(1479,2,1079513077,'Email-и на абонати разделени със запетя и/или нов ред.',1),(1480,2,3310826759,'Добави',1),(1481,2,2461995782,'Редактирайте абонат',1),(1482,2,1191605410,'Сигурни ли сте, че искате да изтриете този абонат?',1),(1483,2,3687574047,'Филтрирайте абонатите',1),(1484,2,2952046730,'Тестов бюлетин',1),(1485,2,1587199635,'Email-и:',1),(1486,2,3858340892,'Изпратете тест',1),(1487,2,2779812973,'Опции на продуктов feed',1),(1488,2,2663971073,'Изисквай ключ:',1),(1489,2,616075044,'Таен ключ:',1),(1490,2,506785837,'Генерирай връзка',1),(1491,2,3482811661,'Оценки и ревюта',1),(1492,2,1743133016,'Редактирайте оценки и ревюта',1),(1493,2,4019184820,'IP адрес:',1),(1494,2,4020385206,'Клиент:',1),(1495,2,3323015556,'Съдържание на ревюто:',1),(1496,2,235652961,'Оценка:',1),(1497,2,643703905,'Сигурни ли сте, че искате да изтриете тази оценка?',1),(1498,2,3743752980,'Оценка',1),(1499,2,2129626352,'Ревю',1),(1500,2,244298452,'Филтрирайте оценки и ревюта',1),(1501,2,4190646508,'Текст на ревю...',1),(1502,2,2867445730,'IP адрес...',1),(1503,2,17514069,'Оценки',1),(1504,2,1132259710,'Работи на',1),(1505,2,908066045,'Добре дошъл, %%CUSTOMERFIRSTNAME%% %%CUSTOMERLASTNAME%%!',1),(1506,2,312708084,'Изход',1),(1507,2,1808393236,'Вход',1),(1508,2,2794398274,'Регистрация',1),(1509,2,1323996051,'Профил',1),(1510,2,3980130229,'Адреси',1),(1511,2,3432436168,'Добави адрес',1),(1512,2,3673263359,'Редактирайте адреса',1),(1513,2,86938300,'Сигурни ли сте, че искате да изтриете този адрес?',1),(1514,2,749705681,'По подразбиране за плащане',1),(1515,2,3926602309,'По подразбиране за доставка',1),(1516,2,480959536,'Продукти в комплекта:',1),(1517,2,2891456104,'Вижте Количката',1),(1518,2,961073464,'Продължи с пазаруването',1),(1519,2,3421549997,'Приложи купон',1),(1520,2,1821239519,'Премахване купон',1),(1521,2,3850054737,'Изчистване на количката',1),(1522,2,782637220,'%%CATEGORYPRODUCTCOUNT%% продукт(и)',1),(1523,2,3592219198,'Подкатегории',1),(1524,2,566031201,'Табличен вид',1),(1525,2,3134167193,'Водещи продукти',1),(1526,2,2568203735,'<strong>Страница %%PAGE%%</strong> от %%NUMPAGES%%',1),(1527,2,3768902734,'Покажи сравнението ',1),(1528,2,1111523802,'Списъчен вид',1),(1529,2,58290041,'Адрес за плащане / доставка',1),(1530,2,1490417553,'Метод на плащане / доставка',1),(1531,2,1343015364,'Потвърждение',1),(1532,2,756315074,'Финален',1),(1533,2,1879189093,'Неуспех на поръчката',1),(1534,2,4020425545,'Вашето плащане бе отказано. Моля опитайте пак.',1),(1535,2,3453780242,'Опитайте отново',1),(1536,2,4045718410,'Успешна поръчка',1),(1537,2,1210789654,'Благодаря! Вашата поръчка бе приета успешно, но плащането все още не е обработено.',1),(1538,2,906094716,'Благодаря! Вашата поръчка бе приета успешно.',1),(1539,2,869314853,'Вход за регистрирани потребители',1),(1540,2,1805277448,'Регистрирайте се за поръчка',1),(1541,2,3099258724,'Потвърдете паролата:',1),(1542,2,822156319,'Код за сигурност:',1),(1543,2,1626898610,'Код за сигурност',1),(1544,2,847984313,'Презареди картинката',1),(1545,2,789590253,'Моля, въведете буквите, които виждате в кутията. По този начин се спира спам от автоматизирани програми.',1),(1546,2,3407541179,'Поръчка от гост',1),(1547,2,2121996478,'Ако поръчате като Гост не е необходимо да се регистрирате. В този случай обаче няма да имате възможност да преглеждате Вашите предишни поръчки.',1),(1548,2,3307505785,'Email (незадължителeн): ',1),(1549,2,2421870257,'* Моля забележете, че Вашия email адрес ще бъде използван единствено, за да Ви изпращаме известия за Вашата поръчка.',1),(1550,2,3362839566,'Адресна информация',1),(1551,2,1190439064,'Адрес за доставка',1),(1552,2,610800229,'Следваща стъпка',1),(1553,2,1797069372,'Изберете адрес',1),(1554,2,2317107991,'Потвърждение на поръчката',1),(1555,2,2007405874,'Платец',1),(1556,2,2944186042,'Изпрати до',1),(1557,2,2212487076,'Контакт',1),(1558,2,2877914330,'Метод на плащане',1),(1559,2,1727468277,'Метод на доставка',1),(1560,2,994804795,'Съдържание на количката',1),(1561,2,4001707996,'Съгласен съм с условията',1),(1562,2,2111172529,'Предишна стъпка',1),(1563,2,4032482767,'Промени',1),(1564,2,3412837404,'Метод на плащане',1),(1565,2,4210788597,'Ползвай бонус точки',1),(1566,2,3762971717,'Метод на доставка',1),(1567,2,2591431184,'Специални инструкции?',1),(1568,2,30083613,'Най-продавани',1),(1569,2,442779427,'Количка',1),(1570,2,3355742105,'Количката е празна.',1),(1571,2,456003789,'Артикули:',1),(1572,2,2679332891,'Общо:',1),(1573,2,2765451054,'Виж &amp; Купи',1),(1574,2,4157704578,'Здравейте',1),(1575,2,1704413287,'Списък с желания ',1),(1576,2,982410204,'Нови продукти',1),(1577,2,2154430034,'Скоро разглеждани',1),(1578,2,792727095,'Разширено търсене',1),(1579,2,2784385862,'Забравена парола',1),(1580,2,39256687,'Вашия email е:',1),(1581,2,1830307645,'Вашата парола е:',1),(1582,2,1014130425,'Моля използвайте връзката <a href=\"%%HTTPS%%login.php\">this</a>, за да влезете.',1),(1583,2,4065048850,'За да подмените вашата парола използвайте тази връзка:',1),(1584,2,2663571239,'Изпратен е формуляр:',1),(1585,2,519137004,'Може да изтеглите Вашите покупки от',1),(1586,2,376591614,'Секция за доставка на е-стоки',1),(1587,2,2129829755,'Можете да се свържете с нас чрез:',1),(1588,2,2320060907,'За да видите детайли за тази поръчка',1),(1589,2,626704452,'кликнете тук',1),(1590,2,4192191998,'Има важна нова информация относно Вашата поръчка',1),(1591,2,2228299012,'Ви изпраща покана да разгледате следния продукт:',1),(1592,2,1535433401,'Благодаря, че се регистрирахте!',1),(1593,2,3313959608,'Вашия профил:',1),(1594,2,2619118453,'Грешка',1),(1595,2,2367234431,'Открита грешка при изпълнение на вашата заявка. Ако грешката се повтори моля свържете се със собственика на магазина.',1),(1596,2,2226783450,'<a href=\"http://www.summercart.bg/\" target=\"_blank\">онлайн магазин</a>',1),(1597,2,1429023383,'Паролата ще бъде изпратена на Вашия email адрес.',1),(1598,2,58328078,'Изпращане на парола',1),(1599,2,1679901357,'Нова парола:',1),(1600,2,1791768478,'Потвърдете новата парола:',1),(1601,2,1541818425,'Подменете паролата',1),(1602,2,4158181270,'Вашата парола бе успешно подменена.',1),(1603,2,3756970489,'Моля влезте.',1),(1604,2,2696799790,'Успех',1),(1605,2,949859957,'Изпълни',1),(1606,2,2291548582,'Галерия',1),(1607,2,3504437773,'Добре дошли в нашия магазин!',1),(1608,2,3335690486,'Водещи продукти',1),(1609,2,909788852,'Вижте детайли',1),(1610,2,1507512851,'Брой:',1),(1611,2,57972069,'Вижте всички продукти от %%MANUFACTURERNAME%%',1),(1612,2,4142905463,'продуктa открити от',1),(1613,2,2027916259,'<b>Страница %%PAGE%%</b> от %%NUMPAGES%%',1),(1614,2,2462686142,'Информация за доставка',1),(1615,2,570706577,'Вие платихте в',1),(1616,2,3334723224,'Специални инструкции',1),(1617,2,3970606310,'Продуктово изображение',1),(1618,2,2171396134,'Изтегли',1),(1619,2,3862370978,'Моите поръчки',1),(1620,2,3541515099,'Вие нямате поръчки.',1),(1621,2,3852454006,'Вашите точки:',1),(1622,2,251134918,'Информация за потребителя',1),(1623,2,2438360217,'Оставете празно, за да запазите текущата парола.',1),(1624,2,686869563,'Вие имате в момента:',1),(1625,2,2673283087,'Адрес на фактуриране по подразбиране',1),(1626,2,2515100435,'Адрес за доставка по подразбиране',1),(1627,2,1600593306,'Обратно към моите поръчки',1),(1628,2,3714655035,'Summer Cart - Изпрати на приятел',1),(1629,2,1198176300,'Вашето име:',1),(1630,2,646681000,'Вашия email:',1),(1631,2,2118475349,'Email адрес на вашия приятел:',1),(1632,2,2458683357,'Допълнителен коментар:',1),(1633,2,121738739,'Изпращане',1),(1634,2,2380011981,'Добави в списъка за сравнение',1),(1635,2,2729119880,'Махни от списъка за сравнение',1),(1636,2,3664753648,'Тегло:',1),(1637,2,4233714837,'Продуктови опции',1),(1638,2,2016129824,'Изпратете на приятел',1),(1639,2,1763323970,'Оценете продукта',1),(1640,2,2798506643,'Ревюта',1),(1641,2,966531448,'Отстъпки за количество',1),(1642,2,2155498677,'Продукти в комплекта',1),(1643,2,1070322242,'от',1),(1644,2,2403360959,'Успешна регистрация',1),(1645,2,3287053070,'Скоро ще получите e-mail от нас с потвърждение на Вашата регистрация.',1),(1646,2,710245342,'Моля въведете вашите критерии за търсене:',1),(1647,2,474009099,'Открийте продуктите които съдържат:',1),(1648,2,3028788705,'също търси в продуктовите детайли',1),(1649,2,3275397312,'Продуктов код:',1),(1650,2,422055502,'От',1),(1651,2,1107555942,'До',1),(1652,2,3334958971,'Продуктов клас:',1),(1653,2,872791843,'Промени критериите за търсене',1),(1654,2,3676457160,'Поръчка с PayPal Express',1),(1655,2,1474342248,'Потвърди плащането',1),(1656,2,2900568731,'Последни новини',1),(1657,2,1988906978,'RSS 2.0',1),(1658,2,3930643869,'Абонирай се',1),(1659,2,1982922322,'Виж всички',1),(1660,2,3780062704,'Метод на плащане - чек',1),(1661,2,2643468480,'Метод на плащане - кредитна карта',1),(1662,2,2302948229,'Моля въведете вашия 3 или 4 цифрен CVV / CVC код, ако e наличeн.',1),(1663,2,3242636189,'Easypay.bg бележка за плащането',1),(1664,2,891620106,'Код на плащане',1),(1665,2,3862000488,'Метод на плащане - кредитна / дебитна карта',1),(1666,2,451678722,'Тип на карта:',1),(1667,2,2159650956,'Издаване на карта:',1),(1668,2,2759988489,'(на които има)',1),(1669,2,3570763641,'Номер на издаване:',1),(1670,2,1628353965,'(Само за по-стари Switch карти. 1 или 2 цифри както са върху картата)',1),(1671,2,2358789045,'Издател на карта:',1),(1672,2,2794146439,'В брой',1),(1673,2,4076891506,'Сравни продукти',1),(1674,2,3434387737,'Някои от продуктите в списъка не могат да бъдат сравнени.',1),(1675,2,3174868567,'Няма продукти в списъка за сравнение.',1),(1676,2,723556371,'Махнете продукт',1),(1677,2,733929904,'Този продукт е несъвместим.',1),(1678,2,356924018,'Трябва да имате поне 2 продукта във Вашия списък за сравнение. ',1),(1679,2,247356116,'Вижте сравнението',1),(1680,2,3027694245,'Въведете Вашия email за да се абонирате за %%NEWSLETTERNAME%%:',1),(1681,2,1707695583,'Моля въведете валиден email адрес.',1),(1682,2,116380646,'Благодаря че се абонирахте за нашия бюлетин \"%%NEWSLETTERNAME%%\".',1),(1683,2,1674439883,'Ако не желаете да получавате още email-и за \"%%NEWSLETTERNAME%%\", моля въведете Вашия email адрес по-долу и кликнете \"Отписване\".',1),(1684,2,602980313,'Отписване',1),(1685,2,3231745282,'Вие успешно се отписахте.',1),(1686,2,1195251778,'Вашето име: (незадължително)',1),(1687,2,3340366533,'Напишете Вашето ревю:',1),(1688,2,2360675507,'Оценете продукта:',1),(1689,2,3397765978,'Моля изчакайте',1),(1690,2,1435329933,'Създайте Ваш списък с желания и го изпратете на приятелите си за да разберат от какво имате тнужда.',1),(1691,2,1919431210,'Въведете имейлите на приятелите Ви със запетаи за да им изпратите Вашия списък с желания, и те ще разберат от какво имате нужда.',1),(1692,2,778980276,'Извади от списъка с желания',1),(1693,2,4076650759,'Добави в списъка с желания',1),(1694,2,971690898,'Достъпът отказан.',1),(1695,2,206424473,'Адресът е създаден успешно.',1),(1696,2,3931780025,'Адресът е обновен успешно.',1),(1697,2,1988007368,'Адресът е изтрит успешно.',1),(1698,2,3033757558,'Адресите по подразбиране са успешно променени.',1),(1699,2,337247436,'Моите адреси',1),(1700,2,1060537073,'Всички нива на достъп',1),(1701,2,1643484871,'API Потребител',1),(1702,2,3978665514,'Всички статуси',1),(1703,2,910769710,'Няма клиент с този email адрес.',1),(1704,2,974874717,'Настройки на кутия',1),(1705,2,1654365787,'Неизвестно',1),(1706,2,1214010334,'Не може да се изтрие кутия от такъв тип.',1),(1707,2,3427545285,' успешно изтрит.',1),(1708,2,462477906,'Отстъпки:',1),(1709,2,1969273851,' беше автоматично изключен, за да се предотврати неопределено поведение.',1),(1710,2,893657890,'Купони:',1),(1711,2,1286454575,'Модул за поръчка',1),(1712,2,3484844198,'За магазина',1),(1713,2,4154148757,'Държавата по подразбиране не може да бъде изтрита.',1),(1714,2,2616533983,'Държавата по подразбиране е зададена успешно.',1),(1715,2,1673566086,'Изисква се валиден град',1),(1716,2,2626115326,'Налични категории',1),(1717,2,158388602,'Избрани категории',1),(1718,2,4192083481,'Налични клиентски групи',1),(1719,2,1904975299,'Избрани клиентски групи',1),(1720,2,1662204468,'Купон',1),(1721,2,1223637619,'Всички типове купони',1),(1722,2,2418076265,'Валута',1),(1723,2,799914036,'Невалидно десетично число.',1),(1724,2,359110422,'Валутата по подразбиране зададена успешно. Валутните курсове обновени.',1),(1725,2,1622119860,'Валутните курсове бяха обновени.',1),(1726,2,2777361223,'Валутата по подразбиране не може да бъде изтрита.',1),(1727,2,3484117332,'Валутата по подразбиране не може да бъде деактивирана.',1),(1728,2,3606238423,'Изтекъл',1),(1729,2,2273128141,'Символ отляво',1),(1730,2,311113914,'Символ отдясно',1),(1731,2,2474211846,'Десетичен символ',1),(1732,2,2412596371,'Сепаратор за хиляди',1),(1733,2,2900972917,'Брой числа след точката',1),(1734,2,1228535726,'Модул валутен курс',1),(1735,2,349111103,'Всички типове страници',1),(1736,2,3673409282,'Не е текуща',1),(1737,2,323882391,'Текущ',1),(1738,2,765567539,'Уеб адресът не може да е празен.',1),(1739,2,71930170,'Уеб адресът вече съществува.',1),(1740,2,2992138442,'Полето е празно.',1),(1741,2,1428478262,'Клиентска група',1),(1742,2,4280560865,'Клиентската група по подразбиране е зададена успешно.',1),(1743,2,916359985,'Клиентската група по подразбиране не може да бъде изтрита.',1),(1744,2,1426270757,'Име на клиентска група',1),(1745,2,3972781833,'Всички държави',1),(1746,2,3326678627,'Всички клиентски групи',1),(1747,2,3712848290,'Този email е вече регистриран.',1),(1748,2,3309684772,'Администраторът е променил броя точки.',1),(1749,2,2978604238,'Клиент Гост не може да бъде изтрит.',1),(1750,2,3514388826,'Невалидно цяло число.',1),(1751,2,1027349186,'Първо име',1),(1752,2,2437538009,'Фамилия',1),(1753,2,2147627219,'Компания',1),(1754,2,4175916105,'Адрес 1',1),(1755,2,1643003379,'Адрес 2',1),(1756,2,2372513034,'Град',1),(1757,2,1649606143,'Област',1),(1758,2,2240723161,'Телефон',1),(1759,2,2842594184,'Факс',1),(1760,2,1194661543,'Номер на държава',1),(1761,2,233403792,'Номер на област',1),(1762,2,412686884,'Друг',1),(1763,2,2605367606,'Всички типове отстъпки',1),(1764,2,1724252194,'Динамична страница',1),(1765,2,2245059026,'чрез функцията на php mail()',1),(1766,2,3459792051,'през SMTP сървър',1),(1767,2,3751981041,'Няма',1),(1768,2,2135378647,'SSL',1),(1769,2,979001145,'TLS',1),(1770,2,1928099550,'Summer Cart тестов email',1),(1771,2,2494957135,'Данните са обновени но неуспях да изпратя email до %s. Моля проверете настройките.',1),(1772,2,3429979993,'Данните са обновени и email бе изпратен успешно до %s.',1),(1773,2,281341089,'Водещ продукт',1),(1774,2,987936391,'Водещ в',1),(1775,2,1195630948,'НАЧАЛО',1),(1776,2,1544782654,'Този продукт вече е водещ.',1),(1777,2,2447820944,'Първо създайте продукт.',1),(1778,2,4072297073,'Формуляр',1),(1779,2,3294903477,'Текст с потвърждение',1),(1780,2,3336299507,'Разрешаване captcha',1),(1781,2,1891647104,'Не са избрани никакви снимки.',1),(1782,2,2519533548,'Успешен импорт на %d снимки.',1),(1783,2,4021789044,'Елемент в галерия',1),(1784,2,2612594937,'Текст',1),(1785,2,1954655468,'Няма качен файл.',1),(1786,2,1324475515,'Грешка при качване (код на грешка %d).',1),(1787,2,311012738,'Не мога да отворя файл %s.',1),(1788,2,506301268,'Неуспех на импорта! Причина: ',1),(1789,2,1073345337,'Частичен успех. %d импортирани продукти, %d обновени продукта. Импортирането спря на линия #%d със съобщение:',1),(1790,2,468324764,'Импорта е успешен.',1),(1791,2,2100858350,'Всички намерени картинки са импортирани успешно.',1),(1792,2,765083125,'Неизвестен хедър \"%s\".',1),(1793,2,3929581076,'Не може да се копира \"%s\" в \"%s\".',1),(1794,2,829264720,'Продукт с код \"%s\" вече съществува!',1),(1795,2,2438984671,'Категория \"%s\" не е намерена.',1),(1796,2,1582254705,'Няма зададена подредба по подразбиране.',1),(1797,2,4089697667,'Производител \"%s\" не е намерен.',1),(1798,2,1044163623,'Продуктов клас \"%s\"  не е намерен.',1),(1799,2,3633141250,'Системни изисквания',1),(1800,2,2564148613,'Лиценз',1),(1801,2,709512653,'Правата за достъп до директория',1),(1802,2,93151306,'Не е одобрено',1),(1803,2,2233580107,'Одобрено',1),(1804,2,2644336511,'Успешно обновени текстове на език.',1),(1805,2,3414354415,'Езикът по подразбиране е зададен успешно.',1),(1806,2,3507618035,'Езикът по подразбиране не може да бъде изтрит.',1),(1807,2,2655559150,'Езикът по подразбиране не може да бъде деактивиран.',1),(1808,2,784760254,'Неуспешно създаване на  езиков пакет.',1),(1809,2,445195722,'Каченият файл е твърде голям (%s байта).',1),(1810,2,2015382419,'Моля качете файл.',1),(1811,2,1207227239,'Моля качете файл с езиков пакет (.zip).',1),(1812,2,2956520505,'Грешка при обработката \"%s\": %s',1),(1813,2,1061572800,'Файл langpack.xml не може да бъде открит в архива с езиковия пакет.',1),(1814,2,2677450897,'Език с код \"%s\" вече съществува.',1),(1815,2,2697320117,'Не мога да намеря файл с картинка \"%s\" в архива на езиковия пакет.',1),(1816,2,1441564075,'Името на качения XLIFF файл \"%s\" е невалидно.',1),(1817,2,4057922485,'Грешка при качване на файл: %s (код на грешка %s).',1),(1818,2,342401503,'Вътрешната грешка.',1),(1819,2,1897767757,'Каченият файл е празен.',1),(1820,2,4151929386,'Моля качете файл с преводи (.xlf).',1),(1821,2,3838021215,'%d%% преведен',1),(1822,2,3166393104,'Посока',1),(1823,2,778796279,'Автор на езиковия пакет',1),(1824,2,1079379558,'Описание на езиковия пакет',1),(1825,2,3785170304,'Лиценз на езиков пакет',1),(1826,2,3589568588,'Дата на публикуване на езиков пакет',1),(1827,2,662578726,'Наличен',1),(1828,2,647256362,'Топ',1),(1829,2,3663022166,'Ляво',1),(1830,2,1963678224,'Дясно',1),(1831,2,2398320530,'Долно поле',1),(1832,2,3685643230,'Не мога да запазя подредбата на кутиите: ',1),(1833,2,3119399505,'Подредбата по подразбиране зададена успешно.',1),(1834,2,1593855280,'За да изтриете тази подредба не трябва да има категории, динамични страници или страници с богат текст които да я ползват.',1),(1835,2,3959000229,'Всички категории',1),(1836,2,716071528,'Всички строгости',1),(1837,2,2142461233,'Моля въведете потребителското име и парола!',1),(1838,2,1315737212,'Невалидно потребителско име и/или парола. Моля опитайте отново.',1),(1839,2,2495292229,'Вашия потребител е деактивиран.',1),(1840,2,774316269,'Точка от меню',1),(1841,2,3060702529,'Група с опции',1),(1842,2,3130920691,'Статус на поръчка',1),(1843,2,706177376,'Този статус не може да бъде изключен.',1),(1844,2,4262583638,'Не може да излючите известията за този статус.',1),(1845,2,1148841405,'Не може да изтриете предефиниран статус на поръчка \"%s\".',1),(1846,2,2909636378,'Има поръчки със статус \"%s\". Не можете да го изтриете.',1),(1847,2,437395479,'Сума на поръчка модул',1),(1848,2,4087417155,'Сума нето трябва винаги да е преди другите модули за сума на поръчка.',1),(1849,2,2472366501,'Избраните поръчки изтрити успешно!',1),(1850,2,1258584605,'Статусите на поръчките обновени успешно!',1),(1851,2,2277936408,'Поръчката не е намерена.',1),(1852,2,1060205392,'Настъпи грешка: %s',1),(1853,2,2255065229,'Не може да печатате накуп PDF товарителници.',1),(1854,2,1534955588,'Бележката е твърде къса.',1),(1855,2,884912915,'Бележката прибавена успешно, но имаше проблем при изпращане на email-а.',1),(1856,2,1847838487,'Бележката прибавена успешно, но няма клиентски email.',1),(1857,2,2924919114,'Бележката прибавена успешно, но няма зададен email-а на отдел продажби.',1),(1858,2,2680044958,'Бележката прибавена успешно.',1),(1859,2,2978673432,'Грешка при добавяне на бележка.',1),(1860,2,3269079827,'Бележката изтрита успешно.',1),(1861,2,3735730144,'Номера на кредитната карта и CVV са изчистени успешно.',1),(1862,2,2256931719,'Не мога да покажа е-стоките.',1),(1863,2,67482292,'Не мога да изпратя email с известие за е-стоките.',1),(1864,2,3667787196,'Известяващ email за е-стоките бе изпратен успешно.',1),(1865,2,1170936893,'Грешка при изпращане на е-стоки: \"%s\".',1),(1866,2,3304927357,'Статуса на е-стоката бе обновен успещно.',1),(1867,2,2005744939,'Платежният модул не може да бъде намерен.',1),(1868,2,64071581,'Изключение:',1),(1869,2,1840034131,'Неизвестна операция.',1),(1870,2,4267206052,'Модул за плащане',1),(1871,2,1419919011,'Добавката бе успешно инсталирана.',1),(1872,2,762253123,'Не е инсталирано PHP разширение ZIP. Моля свържете се с вашия хостинг за го инсталират.',1),(1873,2,1983809766,'Не мога да прочета ZIP архива. Грешка %d: %s',1),(1874,2,2476158058,'Не може да се създаде директория \"%s\"',1),(1875,2,2932655328,'Файл \"%s\" вече съществува.',1),(1876,2,3392287738,'Не мога да отворя файл в ZIP архива.',1),(1877,2,3525337433,'Каченият файл не е изображение.',1),(1878,2,3648249677,'Не мога да запиша качения файл!',1),(1879,2,3068422154,'Моля качете изображение.',1),(1880,2,2833957309,'Изберете категория',1),(1881,2,3705767946,'Всички производители',1),(1882,2,998618569,'Всички продуктови класове',1),(1883,2,895607553,'Комплектът трябва да има съставни продукти.',1),(1884,2,1452315037,'Всички съставни продукти трябва да участват с поне 1 бройка.',1),(1885,2,2642524106,'Един комплект може да съдържа други комплекти но не може да съдържа себе си.',1),(1886,2,4060421234,'Комплектите не могат да имат варианти опции.',1),(1887,2,4111963927,'Невалидно число.',1),(1888,2,2418193025,'Първо създайте категория.',1),(1889,2,3039632037,'Продуктът е е-стока',1),(1890,2,747255451,'Клас',1),(1891,2,3465050114,'Бърза връзка',1),(1892,2,299357700,'Непознат отчет',1),(1893,2,3938568113,'Страница с богат текст',1),(1894,2,829950261,'Съдържание',1),(1895,2,3046866235,'Модул за доставка',1),(1896,2,3465572544,'Tози модул за доставки може да го има само един път и не може да бъде добавен. ',1),(1897,2,3580000547,'Модул за доставка бе създаден успешно. Моля настройте модула.',1),(1898,2,695430002,'Tози модул за доставки може да го има само един път и не може да бъде изтрит. ',1),(1899,2,4188760814,'Зона на доставка',1),(1900,2,2501974536,'Налични държави',1),(1901,2,3723238592,'Избрани държави',1),(1902,2,3554809502,'Налични области',1),(1903,2,1478574432,'Избрани области',1),(1904,2,521597972,'Неуспешно създаването на директория \"%s\".',1),(1905,2,3947037298,'Избор на визия',1),(1906,2,3732254855,'Местоположението на визия \"%s\" не е валидна директория.',1),(1907,2,31452408,'Не е намерено описание на визия \"%s\".',1),(1908,2,1311354019,'Описание на визия \"%s\" не може да се прочете.',1),(1909,2,3052803159,'Визия \"%s\" е за друга версия на софтуера..',1),(1910,2,548770039,'Автоматично бяха инсталирани %d визии.',1),(1911,2,4139653556,'Не мога да прочета \"skin.xml\".',1),(1912,2,2887437011,'Визията бе инсталирана успешно.',1),(1913,2,1326475003,'Активация',1),(1914,2,1998283438,'Код на област',1),(1915,2,649384201,'Данъчен клас',1),(1916,2,2401985450,'Данъчни ставки',1),(1917,2,2273774407,'Вие първо трябва да дефинирате данъчни класове и данъчни зони.',1),(1918,2,1049680567,'Данъчна зона',1),(1919,2,3066887318,'Данък',1),(1920,2,2848081516,'Купона приет.',1),(1921,2,2659381137,'Купона е махнат.',1),(1922,2,612906988,'Не мога да открия категорията.',1),(1923,2,3760882688,'Неизвестно име на модул: \"%s\".',1),(1924,2,1658215604,'Не е позволено да виждате поръчка номер %d!',1),(1925,2,2072252968,'Край на поръчката',1),(1926,2,567520697,'Страницата, която търсите не може да бъде открита. Ще бъдете изпратени на началната страница след 2 секунди.',1),(1927,2,1365745153,'Моля въведете email.',1),(1928,2,35798503,'Email-а не е намерен. Моля опитайте отново.',1),(1929,2,478502169,'Вашата парола е изпратена на %s. Моля, проверете вашата поща.',1),(1930,2,4210502971,'Вече сте сменили вашата парола.',1),(1931,2,2736803437,'Паролите не съвпадат.',1),(1932,2,500224504,'Неуспех при визуализацията на формуляра: ',1),(1933,2,2067417858,'Кода за сигурност не съвпада.',1),(1934,2,4247598002,'Галерията не може да бъде намерена.',1),(1935,2,2939161884,'Достъпът отказан! Тази операция е забранена в демото на Summer Cart.',1),(1936,2,2851240815,'Модулна опция \"%s\" не е зададена. Моля настройте модул \"%s\".',1),(1937,2,3794871534,'Никакви полета на отпечатване не са избрани.',1),(1938,2,521872670,'артикул',1),(1939,2,3776899405,'артикули',1),(1940,2,3469939714,'Показвания на категория',1),(1941,2,2211971065,'Продуктови продажби',1),(1942,2,4188410682,'Преглеждания на продукт',1),(1943,2,3800588496,'Не може да изтриете потребителя с който сте влезли в момента.',1),(1944,2,246908558,'Не може да ограничите или деактивирате единствения потребител с пълен достъп.',1),(1945,2,4197307457,'Има клиенти чиито адреси за плащане и/или доставка са в тази държава.',1),(1946,2,3355634220,'Страница с богат текст',1),(1947,2,3337924380,'Динамична страница',1),(1948,2,4060101575,'Последният адрес на клиента не може да бъде изтрит.',1),(1949,2,976736592,'За да изтриете тази клиентска група не трябва да има клиенти които да са в нея.',1),(1950,2,3520615993,'Файлът \"%s\" не е намерен.',1),(1951,2,3326180459,'Не може да се създаде директория за галерията.',1),(1952,2,1961186936,'Не може да се създаде директория за снимки в галерията.',1),(1953,2,2776549596,'Не може да се създаде директория за малки картинки  в галерията.',1),(1954,2,2733256268,'Неуспешно преименуване на галерия: дублирано име на директория.',1),(1955,2,3209771303,'Неуспешно преименуване на галерия.',1),(1956,2,821124640,'От ляво надясно',1),(1957,2,609036854,'От дясно наляво',1),(1958,2,2495182195,'Не може да деактивирате единствения активен език.',1),(1959,2,1104553861,'Меню',1),(1960,2,3544640745,'Неуспех при изпращане на имейл за поръчка за поръчка %s.',1),(1961,2,1966796274,'Нова поръчка',1),(1962,2,2188138777,'Базирано на сумата на поръчката %s.',1),(1963,2,1252764064,'Препратен клиент %s.',1),(1964,2,2216265504,'Максималният брой сваляния достигнат.',1),(1965,2,3487080762,'Периода на валидност на връзката за сваляне на е-стоката е изтекъл.',1),(1966,2,2021271368,'Е-стоката е заключена.',1),(1967,2,46009503,'Има продукти от този продуктов клас.',1),(1968,2,2066183052,'Продукт \"%s\" е открит като съставен продукт. Това ще доведе до рекурсия.',1),(1969,2,2372983258,'Оригиналната картинка не е намерена. Продукт с ID: %s.',1),(1970,2,2699549413,'Оригиналната вариантна картинка не е намерена. Продукт с ID: %s.',1),(1971,2,741113889,'За да изтриете тази зона на доставка не трябва да има модули за доставка които да я ползват.',1),(1972,2,672387575,'Този месец',1),(1973,2,2551559645,'Миналия месец',1),(1974,2,2719278482,'Тази година',1),(1975,2,1961422312,'Миналата година',1),(1976,2,3576125411,'Неуспешно копиране на файл за е-стока.',1),(1977,2,1440618055,'Грешка при преместване на файловете с е-стоки.',1),(1978,2,2751018395,'Дублирането на картинката се провали: ',1),(1979,2,1885574410,'Не мога да изтрия картинка \"%s\".',1),(1980,2,3854097274,'Неуспех при копирането на тъмб от \"%s\" към \"%s\".',1),(1981,2,942111230,'Неуспех при копирането на изображението от \"%s\" на \"%s\".',1),(1982,2,2928828387,'Неизвестен (%s)',1),(1983,2,4153723213,'Модул за плащане ',1),(1984,2,3102305494,'Преглеждания на страница / уникални посещения',1),(1985,2,60420241,'Преглеждания на страница',1),(1986,2,3328718076,'Уникални посетители',1),(1987,2,3589852710,'Брой поръчки',1),(1988,2,769758617,'Държава на клиент',1),(1989,2,1989299678,'Разходи за доставка',1),(1990,2,2975766011,'Разходи за плащане',1),(1991,2,2211629218,'Брой елементи',1),(1992,2,3178665876,'Име на категория',1),(1993,2,1617569995,'-Празно име-',1),(1994,2,3723325296,'Ден',1),(1995,2,4217947902,'Седмица',1),(1996,2,1333214978,'Месец',1),(1997,2,3543980187,'3-месечие',1),(1998,2,464575497,'Година',1),(1999,2,26566655,'Резюме',1),(2000,2,1331463278,'Всекидневен',1),(2001,2,1500557074,'Седмичен',1),(2002,2,622395140,'Месечен',1),(2003,2,3153405383,'Тримесеченo',1),(2004,2,4293902794,'Годишен',1),(2005,2,1419823037,'Яну',1),(2006,2,811644918,'Фев',1),(2007,2,1173261687,'Мар',1),(2008,2,523065091,'Апр',1),(2009,2,3527169279,'Май',1),(2010,2,2047742184,'Юни',1),(2011,2,2483057092,'Юли',1),(2012,2,260523949,'Авг',1),(2013,2,3644106533,'Сеп',1),(2014,2,2638192302,'Окт',1),(2015,2,3729185465,'Ное',1),(2016,2,1155748622,'Дек',1),(2017,2,1571557308,'Грешка при Curl запитване към \"%s\". Код на отговор \"%d\".',1),(2018,2,3673143881,'Файлът \"%s\" не е изображение.',1),(2019,2,1325301612,'Грешка при копиране на картинка.',1),(2020,2,606702645,'Невалиден формат на картинка.',1),(2021,2,3243865366,'Неуспех при промяната на размера на картинката.',1),(2022,2,4273361783,'Директория \"%s\" не може да бъде създадена.',1),(2023,2,4017556963,'\"%s\" не е директория.',1),(2024,2,2065388674,'Не може да се записва в \"%s\".',1),(2025,2,134666524,'Грешка при запис на картинка.',1),(2026,2,4057668941,'Summer Cart не е лицензиран за този уебсайт. Моля придобийте валиден лиценз. <br/><a href=\"http://www.summercart.com/\" target=\"_blank\">Buy License</a> | <a href=\"license.php\">License Info</a>',1),(2027,2,1659361011,'Summer Cart не е активиран. Фукционалността на магазина ще бъде ограничена.<br/> <a href=\"#\">Активирай сега</a>',1),(2028,2,3301984207,'Summer Cart е бил активиран на друг сървър. Фукционалността на магазина ще бъде ограничена.<br/> <a href=\"#\">Реактивирай сега</a>',1),(2029,2,687696898,'Папка \"%s\" не може да бъде създадена. Вие не можете да качите изображения. <a href=\"#\">Помощ</a>',1),(2030,2,2187267186,'В папка \"%s\" не може да се записва. Вие не можете да качите изображения.  <a href=\"#\">Помощ</a>',1),(2031,2,10074882,'Не мога за запиша \"%s\". Вашите е-стоки няма да са сигурни. <a href=\"#\">Help</a>',1),(2032,2,1322276977,'Версията на PHP е твърде стара. Summer Cart изисква PHP 5.1 или по-нова.',1),(2033,2,1035921460,'Safe mode трябва да е изключен.',1),(2034,2,79325551,'php.ini опция file_uploads трябва да е активна.',1),(2035,2,1349081457,'PHP разширение \"%s\" е необходимо.',1),(2036,2,3687500167,'Поддръжка на GIF е необходима.',1),(2037,2,3476745476,'Поддръжка на JPEG е необходима.',1),(2038,2,4096294307,'Поддръжка на PNG е необходима.',1),(2039,2,3083089325,'Изтича днес',1),(2040,2,1362021340,'Изтича до 1 ден',1),(2041,2,3637722135,'Изтича до %d дни',1),(2042,2,2922609053,'Критичен',1),(2043,2,2415109466,'Предупреждение',1),(2044,2,2909038755,'Дебъгвам',1),(2045,2,606498454,'Валутни курсове',1),(2046,2,1565131615,'Директория %s не съществува!',1),(2047,2,2084164920,'В директория %s не може да се записва!',1),(2048,2,2728886836,'Свободното място е малко. Вие имате %s байта свободно пространство (%2.2f%% от общото пространство).',1),(2049,2,934284482,'Само за регистрирани потребители',1),(2050,2,3415746634,'Само клиенти закупили този продукт',1),(2051,2,3136150270,'Никой',1),(2052,2,2302751552,'(страница %s от %s)',1),(2053,2,2106068149,'Спрян',1),(2054,2,387805115,'Ограничен',1),(2055,2,129195397,'Пълен достъп',1),(2056,2,4247900106,'Атрибут на продуктов клас ',1),(2057,2,2185697575,'Стойност на атрибут на продуктов клас ',1),(2058,2,1070217018,'Продуктов атрибут',1),(2059,2,1377533868,'Продуктов комплект',1),(2060,2,1481202745,'Локална опция',1),(2061,2,3160476386,'Клиентски адрес',1),(2062,2,95021649,'Явен вид',1),(2063,2,2243593445,'Сигурно еднопосочно хеширане (salted HMAC-SHA1)',1),(2064,2,413329838,'Продуктови опционни групи',1),(2065,2,1885055086,'Импорт / Експорт',1),(2066,2,1354590562,'Журнал',1),(2067,2,2361144370,'Местоположения и данъци',1),(2068,2,2906653211,'Конфигурация на магазин',1),(2069,2,1427690073,'Езици и валути',1),(2070,2,3174898911,'Вие вече сте използвали купон.',1),(2071,2,2890332796,'Не всички условия за този купон са удовлетворени.',1),(2072,2,3958051832,'Купонния модул не е активен.',1),(2073,2,1988732736,'\"%s\" е достъпен само за регистрирани потребители.',1),(2074,2,1249500137,'Нямате достатъчно бонус точки.',1),(2075,2,1845102359,'Извличане на тегло на нефизически продукт.',1),(2076,2,2519874081,'Останали са само %d \"%s\".',1),(2077,2,2892561836,'\"%s\" не е наличен.',1),(2078,2,3298488485,'Невалидна продуктова опция.',1),(2079,2,2386879254,'Разрешено е само качването на снимки.',1),(2080,2,2166328991,'Моля качете снимка.',1),(2081,2,1518930363,'Моля въведете текст.',1),(2082,2,3997504040,'Невалиден продукт.',1),(2083,2,2082714463,'Невалиден продуктов вариант.',1),(2084,2,4244972103,'Изключение в модул за сума на поръчка: \"%s\".',1),(2085,2,4043964841,'Продукти и категории',1),(2086,2,3474686068,'Езици и валути',1),(2087,2,178379105,'Продуктов списък',1),(2088,2,3045310965,'Импорт / Експорт na каталога',1),(2089,2,3786787441,'Страници',1),(2090,2,2808863634,'Център за отчети',1),(2091,2,4255372828,'Настройки на визия',1),(2092,2,853338739,'Импортирайте снимки',1),(2093,2,3263330688,'Държави на клиенти',1),(2094,2,1894666010,'Методи за плащане',1),(2095,2,1441221385,'Методи на доставка',1),(2096,2,2170361627,'Системна кутия',1),(2097,2,1651446388,'Меню кутия',1),(2098,2,1127429936,'XHTML кутия',1),(2099,2,653914245,'Кутия за бюлетин',1),(2100,2,1619415391,'База',1),(2101,2,1124959784,'Многоредов текст',1),(2102,2,3876416187,'Oтметка',1),(2103,2,1938514344,'Бутони',1),(2104,2,3636078245,'Списък в падащо меню',1),(2105,2,3199764228,'Специфичен',1),(2106,2,2436635234,'Число',1),(2107,2,857141173,'Качване на файл',1),(2108,2,3531875685,'Произволен HTML',1),(2109,2,1776201207,'Заглавие',1),(2110,2,352538411,'Сепаратор',1),(2111,2,544785870,'Няма изображение',1),(2112,2,512670514,'Предефинирано изображение',1),(2113,2,3832912090,'Ваше изображение',1),(2114,2,3895991404,'Визията не е открита.',1),(2115,2,2914208189,'Пътя \"%s\" към визията е невалиден.',1),(2116,2,3366602241,'Не мога да открия шаблона на колоната!',1),(2117,2,820252378,'Кутия',1),(2118,2,658583250,'Бързо меню',1),(2119,2,3852271717,'Долен колонтитул',1),(2120,2,3221496229,'Липсва CMSBoxID при взимане на меню елементите!',1),(2121,2,3863017503,'Валутата не е открита.',1),(2122,2,317351350,'Не мога да обновя курса на %s към %s.',1),(2123,2,720872515,'Грепка от модул \"%s\": %s.',1),(2124,2,21006379,'Не мога да открия стандартната валута.',1),(2125,2,998958233,'Само с пари',1),(2126,2,1825210422,'Точки и пари',1),(2127,2,2478440028,'Само с точки',1),(2128,2,1939374383,'Получи',1),(2129,2,756222009,'Използва',1),(2130,2,459817765,'Предстои',1),(2131,2,2749143752,'7 дни',1),(2132,2,201091938,'30 дни',1),(2133,2,3799853467,'Връщане на точки.',1),(2134,2,3112438038,'Гост клиентът не е намерен.',1),(2135,2,4288268905,'Безплатна доставка',1),(2136,2,1307767082,'На продукт',1),(2137,2,4195381753,'На бройка от продукт',1),(2138,2,3695383545,'На сума нето',1),(2139,2,3085648491,'Информация за продукт',1),(2140,2,3772192490,'Непознат продукт с id \"%s\".',1),(2141,2,3659740162,'Регистрационно известяване',1),(2142,2,1447205245,'Формуляр: %s',1),(2143,2,2968891335,'Не мога да изпратя известие за нова поръчка - email-а на клиента липсва.',1),(2144,2,3772435740,'Не може да се изпрати известие за нова поръчка - липсват имейли на клиента и администратора. ',1),(2145,2,671016963,'Благодаря за поръчката!',1),(2146,2,2462374820,'Вашата поръчка ще бъде изпълнена възможно най-скоро.',1),(2147,2,2383097839,'Нова поръчка #',1),(2148,2,1274645748,'Няма е-стоки които да бъдат изпратени.',1),(2149,2,2159688091,'Не могат да бъдат доставени е-стоките - липсва email на клиента.',1),(2150,2,1190481691,'Доставка на е-стоки към поръчка #%s',1),(2151,2,3563440502,'Административна бележка към поръчка #',1),(2152,2,1532224661,'Статусът на поръчка бе променен на \"%s\".',1),(2153,2,1115676460,'Статусът на поръчка #%s е обновен',1),(2154,2,2925959239,'Няма грешка.',1),(2155,2,1323556796,'Файловият размер превишава директивата upload_max_filesize в php.ini.',1),(2156,2,2000894469,'Каченият файл превишава максималния файлов размер.',1),(2157,2,2774220693,'Каченият файл беше само частично качен.',1),(2158,2,3406465656,'Липсва временната папка.',1),(2159,2,2410278471,'Не мога да запиша файл на диска.',1),(2160,2,2302500411,'Трансфера спрян от разширение.',1),(2161,2,4225751778,'Неизвестната грешка.',1),(2162,2,1714678657,'GB',1),(2163,2,2631664395,'MB',1),(2164,2,3397821581,'KB',1),(2165,2,1952198132,'Не е зададен eзик по подразбиране!',1),(2166,2,2963564181,'Очакван код на език \"%s\", но открит \"%s\".',1),(2167,2,1065373100,'Не може да бъде открит език с езиков код %s.',1),(2168,2,2347183978,'Неизвестна опция %s.',1),(2169,2,2761744303,'Невалидни дефиниции на модулните класове.',1),(2170,2,2298128384,'Не мога да намеря реализация за %s, ModuleID %s.',1),(2171,2,3245286568,'Опит да се зареди клас \"%s\" който не съществува.',1),(2172,2,3238758531,'Опит да се зареди клас \"%s\" който има двусмислено име.',1),(2173,2,1847543081,'Не мога да намеря модул файл %s.',1),(2174,2,279504134,'Не мога да намеря клас от модул %s във файл %s.',1),(2175,2,2556760663,'Модула не е намеррен.',1),(2176,2,988886446,'Не мога да заредя модул за доставка %s. Грешка: \"%s\".',1),(2177,2,3288027779,'Резервирай количествата',1),(2178,2,2972889638,'Не прави нищо',1),(2179,2,3524378733,'Върни количестата в наличност.',1),(2180,2,2090210153,'Не мога да отркия модул за доставка с ShippingModuleID \"%s\"!',1),(2181,2,4143372495,'Не мога да отрия името на модул за доставка с ShippingModuleID \"%s\".',1),(2182,2,907459679,'Непознат метод на доставка \"%s\" за модул за доставка \"%s\".',1),(2183,2,3983654493,'Не мога да открия модул за плащане с PaymentModuleID \"%s\".',1),(2184,2,4154823801,'Не мога да открия модул с CheckoutModuleID \"%s\".',1),(2185,2,2306327481,'Няма адрес',1),(2186,2,809146176,'Не се отнася',1),(2187,2,4005971042,'Недостъпен',1),(2188,2,2198393684,'Недостъпен - таймаут',1),(2189,2,38979051,'Не се поддържа',1),(2190,2,2669544596,'Няма съвпадение',1),(2191,2,2574025683,'Пощенския код съвпада',1),(2192,2,2709164901,'Улицата съвпада',1),(2193,2,3130867008,'Всичко съвпада',1),(2194,2,160801151,'Intl - не се поддържа',1),(2195,2,3331178104,'Intl - не съвпада',1),(2196,2,1232421026,'Intl - пощенския код съвпада',1),(2197,2,3183552170,'Intl - улицата съвпада',1),(2198,2,1675788961,'Intl - всичко съвпада',1),(2199,2,3147491841,'Съвпада',1),(2200,2,1358543466,'Недостъпен',1),(2201,2,3882939189,'Не е подаден',1),(2202,2,3812260290,'US чекове',1),(2203,2,1281643356,'UK чекове',1),(2204,2,2135669230,'Чекова',1),(2205,2,3720111745,'Спестовна',1),(2206,2,1093252924,'ABA рутиращ номер:',1),(2207,2,784571595,'Сорт код:',1),(2208,2,2460243919,'Грешка при обработка на плащането: ',1),(2209,2,3764852828,'Детайли:',1),(2210,2,645800559,'Прехвърляне към системата за приемане плащания...',1),(2211,2,2908525122,'Процес на плащане',1),(2212,2,2245602422,'Несъответствие на валутните кодове.',1),(2213,2,250637667,'OrderID',1),(2214,2,2063252635,'Получавана валута',1),(2215,2,556738789,'Очаквана валута',1),(2216,2,465800015,'Сумата на плащането не съответства.',1),(2217,2,2554316093,'Получена сума',1),(2218,2,2038651890,'Очакванa сума',1),(2219,2,2285410388,'Липсва параметър \"%s\".',1),(2220,2,1744188893,'Чака информация за плащането от процесора',1),(2221,2,2515268484,'Отказано',1),(2222,2,1491869543,'Оторизирано',1),(2223,2,1611532643,'Частично възстановяване',1),(2224,2,514019258,'Chargeback',1),(2225,2,396418990,'Офлайн',1),(2226,2,986607068,'Частично Усвояване',1),(2227,2,423320567,'Не мога да намеря OrderID с TransactionCode=%s и ModuleID=%s.',1),(2228,2,1090077381,'Много-езичен текст',1),(2229,2,4047669267,'Множествен избор',1),(2230,2,844974025,'Без валидатор',1),(2231,2,3782412241,'Не е избран',1),(2232,2,729257526,'Ценова модификация',1),(2233,2,1056867889,'Вариант',1),(2234,2,1394044103,'Картинка от потребител',1),(2235,2,407613837,'Текст от потребител',1),(2236,2,2480034857,'Не мога да открия продукта.',1),(2237,2,3801695625,'Продължи продажбата',1),(2238,2,529233592,'Скрий продукта',1),(2239,2,2922029292,'Маркиране \"Няма наличност\"',1),(2240,2,298651342,'Сортиране по уместност',1),(2241,2,4236668364,'Сортирай по цена (възходящи)',1),(2242,2,2206108970,'Сортирай по цена (низходящи)',1),(2243,2,1594729176,'Сортирай по име на продукт',1),(2244,2,1983638598,'Сортирай по продуктов код',1),(2245,2,1614702293,'кг',1),(2246,2,403080213,'фунт',1),(2247,2,1281633745,'SEO ключови думи',1),(2248,2,2401170763,'SEO описание',1),(2249,2,1856554936,'Първо име на платец',1),(2250,2,779633653,'Фамилия на платец',1),(2251,2,3643031354,'Фирма платец',1),(2252,2,569783891,'Първо име',1),(2253,2,2944137814,'Фамилия',1),(2254,2,3417896906,'Компания за доставки',1),(2255,2,2572074719,'Код на продукт',1),(2256,2,3174173637,'Статус на поръчка',1),(2257,2,256217995,'Не мога да открия данъчния запис.',1),(2258,2,3634676075,'Невалиден ДДС номер.',1),(2259,2,1961341087,'Има грешки във формуляра по-долу.<br/>Моля поправете ги и изпратете отново.',1),(2260,2,3020941352,'Има грешка във формуляра по-долу.<br/>Моля поправете я и изпратете отново.',1),(2261,2,4223270794,'Предишна',1),(2262,2,2991817930,'%d допълнителен адрес',1),(2263,2,1268737845,'%d допълнителни адреси',1),(2264,2,1404092755,'Първa',1),(2265,2,3941140126,'Последна',1),(2266,2,2072815210,'Записи на страница',1),(2267,2,2286432583,'Избери',1),(2268,2,2261280103,'Не е зададено minValue за %s.',1),(2269,2,374970102,'Стойността трябва да бъде не по-малка от %d.',1),(2270,2,2961549300,'Не е зададено maxValue за %s.',1),(2271,2,1003243756,'Стойността трябва да бъде не по-голяма %d.',1),(2272,2,217690918,'Невалиден email формат.',1),(2273,2,3322238850,'Не е уникален.',1),(2274,2,1411741488,'Невалиден http интернет-адрес.',1),(2275,2,2233986892,'\"existsIn\" пропърти трябва да бъде зададено за поле %s.',1),(2276,2,290530147,'Записът не съществува.',1),(2277,2,3176614794,'Избраната валута не е дефинирана. Вие можете да дефинирате нови валути използвайки екрана за валутно управление.',1),(2278,2,4140752483,'Трябва да е избран метод на доставка.',1),(2279,2,3613250963,'Стойността не може да е празна.',1),(2280,2,2108643981,'Моля въведете валиден град.',1),(2281,2,2627246759,'Запис',1),(2282,2,3688544399,'Запис \"%s\" бе успешно създаден.',1),(2283,2,1036862127,'Запис \"%s\" бе успешно обновен.',1),(2284,2,2716460254,'Запис \"%s\" бе успешно изтрит.',1),(2285,2,4031308951,'Всички активни менюта трябва да имат имена.',1),(2286,2,3847004789,'-- Най-горно ниво --',1),(2287,2,2880630370,'\"%s\" може да бъде закупен само с точки.',1),(2288,2,3619229128,'Няма подходящи методи за плащане за Вашата поръчка!',1),(2289,2,1923584595,'Избран е непознат метод за плащане.',1),(2290,2,3416367529,'От %s: %s.',1),(2291,2,3519133715,'Изключение \"%s\".',1),(2292,2,3978063606,'Безплатно',1),(2293,2,2241996831,'Бележки:<br/>',1),(2294,2,3749391800,'Няма подходящи методи на доставка за Вашата поръчка!',1),(2295,2,2905832602,'Датата е с невалиден формат.',1),(2296,2,238049363,'Този модул няма никакви настройки.',1),(2297,2,2376570436,'Шаблон файла с опции не е зададен.',1),(2298,2,489853662,'Твърде много контролни променливи.',1),(2299,2,1556001108,'Всяка',1),(2300,2,1890732172,'Невалидно количество.',1),(2301,2,3503465937,'Дублиране на количествата.',1),(2302,2,31134505,'Невалидна сума.',1),(2303,2,2806581010,'Количеството на първия ред трябва да е 1.',1),(2304,2,2163897815,'Изтрий картинката',1),(2305,2,3094486824,'Държавата и ДДС номера не съвпадат. Вашият ДДС номер трябва да започва с %s.',1),(2306,2,2455112543,'Количката трябва да съдържа поне един артикул.',1),(2307,2,462582378,'Грешка при обработка на вашата заявка: ',1),(2308,2,3823642818,'Изключение на помощника: ',1),(2309,2,2254663015,'Моля въведете e-mail и парола.',1),(2310,2,3161538148,'Не мога да открия производителя.',1),(2311,2,844478805,'Модула не е намерен: ',1),(2312,2,4204349676,'Merchat ID или Merchant Key не съвпадат.',1),(2313,2,4278307332,'Google Checkout изключение: ',1),(2314,2,694481955,'Данъчна зона \"%s\" не може да се ползва с Google Checkout.',1),(2315,2,2467941403,'Google Checkout поддържа само един данъчен клас на продукт.',1),(2316,2,1909915985,'Грешка с Google Checkout: \"%s\".',1),(2317,2,2628825648,'Реална обработка',1),(2318,2,693618939,'Sandbox',1),(2319,2,345221533,'Не съвпада валутата на разходите за доставка. Очаквана \"%s\", намерена \"%s\".',1),(2320,2,1078094406,'Не съвпада валутата на данъците. Очаквана \"%s\", намерена \"%s\".',1),(2321,2,2593546886,'Нов статус на изпълнение: %s.',1),(2322,2,2169159268,'Подлежи на защита: %s.',1),(2323,2,1298284562,'Потребителя е регистриран преди %d дни.',1),(2324,2,2810099095,'IP адрес: ',1),(2325,2,3604752062,'Сума: %s %s',1),(2326,2,2492447259,'Auth изтичане %s',1),(2327,2,923861602,'Неизвестно известяване от Google Checkout: %s',1),(2328,2,3951170399,'Неизвестен статус на плащане.',1),(2329,2,3594121633,'Поръчката вече е платена.',1),(2330,2,2272013587,'Статичен',1),(2331,2,2216047400,'Динамичен',1),(2332,2,3895911047,'Проверката за валидност на известяване от Paypal се провали.',1),(2333,2,348570661,'Резултат',1),(2334,2,4022760396,'Тестов IPN, а системата е в режим готов.',1),(2335,2,981519419,'Невалидно потребителско име или парола.',1),(2336,2,3232414853,'Изключение по време на вход: ',1),(2337,2,1381658824,'Паролите не съвпадат!',1),(2338,2,2004258259,'Изключение по време на регистрация: ',1),(2339,2,171087513,'Не са разрешени поръчки от гости.',1),(2340,2,69326121,'Изключение по време на поръчка: ',1),(2341,2,1685420733,'Продължи към плащане',1),(2342,2,1513996144,'Финализирай поръчката',1),(2343,2,334391769,'Моля съгласете се с условията.',1),(2344,2,3217002174,'Изключение по време на обработка на плащане: ',1),(2345,2,635515012,'Нов адрес',1),(2346,2,2416563426,'Такса наложен платеж',1),(2347,2,1686551835,'Купон %s',1),(2348,2,2012040438,'Невалиден купон.',1),(2349,2,1084554444,'%s бонус точки',1),(2350,2,1440107854,'Невалиден ShippingModuleID.',1),(2351,2,1351567222,'Изключение от модул за доставка %s: %s.',1),(2352,2,2979398362,'Няма цени за доставка за избрания модул за доставка \"%s\".',1),(2353,2,1671436555,'Няма цена за доставка за избрания метод на доставка \"%s\". Mодул за доставка \"%s\".',1),(2354,2,1105882322,'Сума нето',1),(2355,2,901155661,'Данък %s',1),(2356,2,1508301426,'Невалиден ключ за 2Checkout. Моля проверете Вашата тайна дума.',1),(2357,2,2161169993,'Поръча в демонстрационен режим.',1),(2358,2,2749440435,'Неизвестен код за обработка.',1),(2359,2,3886614059,'Код на обработка',1),(2360,2,4170617483,'Плащането е отказано от клиента.',1),(2361,2,618085942,'Плащането неуспешно.',1),(2362,2,779453244,'Грешка при обработка.',1),(2363,2,3011160535,'Код на отговор',1),(2364,2,2833827248,'Отговор подкод',1),(2365,2,3449546607,'Текст на причина на отговор',1),(2366,2,2164617264,'Код за причина на отговор',1),(2367,2,1110416711,'MD5 хешът не съвпада.',1),(2368,2,4080894865,'Готов',1),(2369,2,1987080350,'Демо',1),(2370,2,3876194617,'За разработчици',1),(2371,2,1620695427,'Държавата на собственика на магазина не е зададена.',1),(2372,2,713582701,'Градът на собственика на магазина не е зададен.',1),(2373,2,2283940953,'Името на фирмата на собственика на магазина не е зададена.',1),(2374,2,4104488403,'E-mail-а на администратора не е зададен.',1),(2375,2,2870212386,'Двата частни ключа и CSR-и са генерирани.',1),(2376,2,3054805519,'Грешка при генериране на ключ: ',1),(2377,2,72922377,'Частният ключ и CSR са генерирани.',1),(2378,2,1428422942,'Първо генерирайте ключ.',1),(2379,2,1631500600,'Невалиден сертификат.',1),(2380,2,3610695981,'Добре',1),(2381,2,196033053,'Не мога да потвърдя е-подписа от БОРИКА. Съобщението е повредено или сертификата на магазина е невалиден.',1),(2382,2,1074052831,'Номера на терминал (TID) не съвпада.',1),(2383,2,2033581598,'Непознат код на завършване: %s.',1),(2384,2,3533853291,'Успех.',1),(2385,2,2631704872,'Грешка в мрежата.',1),(2386,2,3318243894,'Грешка в чужда мрежа.',1),(2387,2,2557496871,'Time-out в IEM.',1),(2388,2,3849667764,'Неуспешна транзакция.',1),(2389,2,3104815222,'Отмяна на плащане вече е зададено.',1),(2390,2,3300264337,'Дублиране на транзакцията.',1),(2391,2,76042179,'Неуспешена 3D оторизация.',1),(2392,2,3156081746,'Отказана транзакция.',1),(2393,2,3980295143,'Невалиден е-подпис на съобщението.',1),(2394,2,1551420085,'Връщане на сума неуспешно.',1),(2395,2,2846181355,'Паричната сума е успешно възстановена.',1),(2396,2,2031090396,'Тестово плащане.',1),(2397,2,1558229877,'Невалиден номер на рутиране.',1),(2398,2,3153024680,'Невалиден сорт код.',1),(2399,2,3499759594,'Моля въведете номера на сметката.',1),(2400,2,993638850,'Моля въведете името на банката.',1),(2401,2,3597456143,'Моля въведете името на акаунта.',1),(2402,2,2868789593,'Вие надвишавате лимита за Наложен платеж. Максималната сума е %d %s.',1),(2403,2,1440228075,'Моля въведете името на картодържателя.',1),(2404,2,3119284692,'Невалиден номер на карта.',1),(2405,2,3231650341,'Невалидна дата на изтичане.',1),(2406,2,1390469070,'Невалиден CVV код.',1),(2407,2,4234528552,'Неизвестен статус на плащане %s.',1),(2408,2,1492592544,'MD5 подписът не е активиран във Вашия ДСК акаунт. Моля свържете се с ДСК.',1),(2409,2,3194788682,'Търговецът не съвпада.',1),(2410,2,53661188,'Симулатор',1),(2411,2,2645749437,'Лиспва задължителен параметър OrderID.',1),(2412,2,3784136527,'Време на плащане: %s, Код на Борика: %s.',1),(2413,2,40437855,'Време на плащане: %s',1),(2414,2,2535456934,'Срока за плащане е изтекъл.',1),(2415,2,3332691567,'Известие.',1),(2416,2,3954423699,'Настъпи грешка.',1),(2417,2,3415975849,'IDN-на не може да бъде открит.',1),(2418,2,690338763,'Невалиден резултат от процесора.',1),(2419,2,2595626995,'Непознат код на валута.',1),(2420,2,1820587442,'Платежния модул Moneris не е настроен правилно.',1),(2421,2,239591290,'Плащането е отказано.',1),(2422,2,145849291,'Неуспех при проверката на Moneris транзакция.',1),(2423,2,2181488235,'Невалидна проверка на сигурността. Проверете Вашия SHA-1-OUT signature.  ',1),(2424,2,1165586235,'Продажба',1),(2425,2,3583367802,'Паричната сума е успешно усвоена.',1),(2426,2,941378614,'Оторизацията е успешно анулирана.',1),(2427,2,800552064,'Паричната сума е успешно ре-оторизирана.',1),(2428,2,3761312504,'Моля разрешете Payment Data Transfer.',1),(2429,2,3157827527,'Има грешка при потвърждаването на Payment Data Transfer. Моля проверете Вашият PDT identity token. %s',1),(2430,2,1433195732,'Върнете се към търговеца',1),(2431,2,956808071,'Невалиден отговор от Realex. Моля свържете се със собственика на сайта.',1),(2432,2,2672067096,'Разрешено',1),(2433,2,711999057,'Успешно',1),(2434,2,3540366563,'Отказано от банката',1),(2435,2,248552064,'Препращане от банката',1),(2436,2,3201209846,'Картата е обявена за загубена или открадната',1),(2437,2,2261189006,'Грешка с банковите системи',1),(2438,2,1750758678,'Грешка с платежните системи на Realex',1),(2439,2,2970791877,'Некоректен формат или съдържание на XML съобщение.',1),(2440,2,1620246495,'Клиентът е деактивиран',1),(2441,2,1245642798,'Невалидна дата на издаване.',1),(2442,2,1860431565,'Невалиден номер на издаване.',1),(2443,2,841623692,'Статус на грешка от Sage Pay: %s (%s).',1),(2444,2,1452716031,'Невалидни данни от Sage Pay.',1),(2445,2,3234925912,'Не изпращай',1),(2446,2,1915472064,'Изпрати към клиента и доставчика',1),(2447,2,1798404581,'Изпрати само към доставчика',1),(2448,2,3178107275,'Няма активни банки.',1),(2449,2,2966302554,'Друг издател на карти',1),(2450,2,1045070230,'Hash signature е грешен. Моля проверете Вашия store key.',1),(2451,2,1106862291,'Неуспешна 3D автентикация. Причинате е: %s',1),(2452,2,1528080076,'Опциите на банката са успешно обновени.',1),(2453,2,3456911010,'Моля конфигурирайте банката преди да я активирате.',1),(2454,2,989631439,'Банката е деактивирана успешно.',1),(2455,2,3104487354,'Банката е активирана успешно.',1),(2456,2,112362174,'PreAuth: Authorize only',1),(2457,2,3694170451,'Невалиден брой вноски.',1),(2458,2,2580567245,'Невалиден лихвен процент.',1),(2459,2,3698181533,'Дублирани са брой вноски.',1),(2460,2,2682797684,'Грепка от UBB.bg: %s.',1),(2461,2,304847185,'Модул ОББ не е настроен.',1),(2462,2,2200299116,'Грешка от ubb.bg: \"%s\"',1),(2463,2,2556539757,'Покупка',1),(2464,2,4173210494,'Моля използвайте помощника за настройки.',1),(2465,2,2759125876,'Не са намерени терминали.',1),(2466,2,2134707015,'Успех! Намерени терминали: %s.',1),(2467,2,3807098547,'Моля първо настройте номер на търговец в Canada Post.',1),(2468,2,371692282,'Дигитална доставка',1),(2469,2,3892566628,'Невалидно e-Econt потребителско име или парола.',1),(2470,2,3131417127,'Липсващ продукт в поръчка: %s.',1),(2471,2,89269609,'Липсващ продуктов вариант в поръчка: %s.',1),(2472,2,2104340469,'Поръчка %s има нулево тегло.',1),(2473,2,1827194367,'Не може да бъде намерен платежен модул в поръчка: %s',1),(2474,2,2708038800,'Грешка при свързване.',1),(2475,2,645570083,'Невалидна заявка.',1),(2476,2,718797587,'Врата',1),(2477,2,1945988660,'Офис',1),(2478,2,460155848,'Кредит',1),(2479,2,947161889,'Невалиден град.',1),(2480,2,525438188,'Невалиден пощенски код.',1),(2481,2,3674152100,'Градът и пощенския код не съвпадат.',1),(2482,2,1338961600,'Телефонът не е валиден - трябва да е само цифри, повече от един номер се разделят с \",\".',1),(2483,2,1559384534,'Моля първо настройте FedEx Account Number.',1),(2484,2,1943503702,'Твърда цена за доставка',1),(2485,2,4287710637,'Вие нямате права да изпълните това действие.',1),(2486,2,4010557600,'Моля въведете потребителско име и парола.',1),(2487,2,2013728466,'Неуспешна автентикация към Speedy.',1),(2488,2,2717330026,'Моля изберете брой пакети',1),(2489,2,2969808959,'Печат на товарителница и етикети за поръчка #%d',1),(2490,2,3761590774,'Модул за доставка Speedy не е конфигуриран.',1),(2491,2,1594417462,'Фиксирана',1),(2492,2,2920004005,'Процент',1),(2493,2,718850353,'Грешка при импортиране на градовете:',1),(2494,2,3909116274,'Локациите бяха импортирани успешно. Нови градове: %d. Обновени градове: %d.',1),(2495,2,496065408,'Моля задайте област.',1),(2496,2,475143414,'Не може да бъде намерен град \"%s\" в списъка ни с градове за област \"%s\". Моля проверете изписването.',1),(2497,2,1802502652,'Не може да бъде намерен град с ID \"%s\". Моля инициализирайте локациите чрез администрацията на модула за Speedy.',1),(2498,2,951556676,'Намерен е повече от един град именуван \"%s\".',1),(2499,2,2374008662,'Не може да бъде открита област %s.',1),(2500,2,3115261555,'Няма активирани методи за доставка за Speedy.',1),(2501,2,1013795999,'Цени за доставка базирани на таблица',1),(2502,2,2474399755,'Моля първо настройте UPS UserID, паролата, и XML Access Number.',1),(2503,2,377665883,'Моля първо настройте USPS UserID.',1),(2504,2,1042739198,'USPS не изпраща до тази държава. Кодът на държава \"%s\".',1),(2505,2,395145477,'%s (Сорс: %s, Код: %s)',1),(2506,2,1403912869,'Нов',1),(2507,2,2768935208,'Обработено',1),(2508,2,3789227194,'Доставено',1),(2509,2,2363194125,'Настройте бързите връзки',1),(2510,2,3305961868,'Количество продадени артикули',1),(2511,2,2170461228,'Стойност на продадени артикули',1),(2512,2,2044883406,'Не мога за запиша поръчката: %s.',1),(2513,2,640934425,'\"%s\" има опция от тип \"Картинка от потребител\" която не се поддържа от \"Редакция на поръчка\".',1),(2514,2,1036390347,'Не всички условия за купон \"%s\" са удовлетворени.',1),(2515,2,2429757432,'Няма записан код на валута в поръчката.',1),(2516,2,2670353289,'Избраната валута \"%s\" не може да бъде намерена.',1),(2517,2,1109538040,'Избраната валута \"%s\" е неактивна.',1),(2518,2,3836761498,'Ще бъде използвана текущата валута \"%s\" .',1),(2519,2,3098763195,'Множество купони с код \"%s\" са намерени. Нито един няма да се прилага.',1),(2520,2,1840303263,'Купон \"%s\" не е намерен.',1),(2521,2,322559967,'Купон \"%s\" няма да се прилага.',1),(2522,2,3594007164,'Допълнителна такса',1),(2523,2,3955385877,'Някои линии от оригиналната поръчка вече не присъстват:',1),(2524,2,1962040625,'Някои линии в поръчката не присъстват в оригиналната поръчка:',1),(2525,2,3899924871,'Сумата на \"%s\" линия се промени от %s на %s.',1),(2526,2,2440723355,'Имаше отстъпка от %s на \"%s\". Сега е %s.',1),(2527,2,2932499639,'Продукта не може да бъде намерен (ProductID %d).',1),(2528,2,2774013299,'Не мога да намеря език с код \"%s\". Вместо него ще бъде използван \"%s\".',1),(2529,2,3897097184,'Няма активни модули за доставка.',1),(2530,2,93649609,'Модула за доставка който потребителя е избрал не е намерен.',1),(2531,2,1518610654,'Метода на доставка, който потребителя е избрал не е активен.',1),(2532,2,3029286015,'Държавата \"%s\" която потребителя е избрал като държава за доставка не може да бъде намерена.',1),(2533,2,3101475492,'Държавата \"%s\" която потребителя е избрал като държава за плащане не може да бъде намерена.',1),(2534,2,2910254793,'Областта \"%s\" която потребителя е избрал като негова %s не е намерена.',1),(2535,2,3827980616,'Броят на опциите на продукт \"%s\" не съвпада с броя на опциите на поръчания артикул.',1),(2536,2,1209841706,'На артикул от поръчката му липсват продуктови опции. Тези продуктови опции ще получат стойности по подразбиране: %s',1),(2537,2,524603406,'Тези продуктови опции са били избрани за артитул от поръчката, но не се поддържат от продукта: %s',1),(2538,2,1201267415,'Новината не е намерена.',1),(2539,2,1036467592,'Ще получите бюлетини в %s.',1),(2540,2,1700537962,'Неуспех при изпращане на съобщение.',1),(2541,2,2868414571,'Тестовото съобщение бе успешно изпратено.',1),(2542,2,378138088,'Абонирани',1),(2543,2,1589477793,'Всички включително отписалите се',1),(2544,2,1958860084,'Изпращането спряно успешно.',1),(2545,2,489363607,'Статистика бюлетин \"%s\"',1),(2546,2,595429309,'Всички месеци',1),(2547,2,3113862095,'Януари',1),(2548,2,3025422826,'Февруари',1),(2549,2,3205994163,'Март',1),(2550,2,1874880475,'Април',1),(2551,2,1097932288,'Юни',1),(2552,2,1732649165,'Юли',1),(2553,2,3813010884,'Август',1),(2554,2,1011490657,'Септември',1),(2555,2,596285180,'Октомври',1),(2556,2,2365364793,'Ноември',1),(2557,2,3931589271,'Декември',1),(2558,2,293367773,'Всички езици',1),(2559,2,2327549235,'Изпращане \"%s - %s\" Статистики',1),(2560,2,1923443894,'Неактивен',1),(2561,2,1991326958,'Няма email-и за добавяне.',1),(2562,2,1706330912,'%s email-а успешно абонирани.',1),(2563,2,3079681498,'Тези email-и са невалидни и не бяха абонирани: %s',1),(2564,2,1075938043,'Няма съобщения за изпращане.',1),(2565,2,3566135737,'Абонирани (%s)',1),(2566,2,1867803181,'Всички (%s)',1),(2567,2,3948876667,'Всички включително отписалите се (%s)',1),(2568,2,2723494638,'Можете да се отпишете използвайки тази връзка:',1),(2569,2,201141228,'Разрешаване следене на \"отваряне на email-и\"',1),(2570,2,3700194837,'Разрешаване следене на \"кликове в email-и\"',1),(2571,2,2188668833,'Отметката за абониране е маркирана по подразбиране',1),(2572,2,3270213856,'Не добавяй връзка за отписване. Препоръчва се да оставите тази опция изключена.',1),(2573,2,3797768377,'Абонат',1),(2574,2,2217367178,'Активен',1),(2575,2,514029753,'Моля въведете валиден e-mail адрес.',1),(2576,2,2131480835,'Трябва да влезете за да абонирате за бюлетин \"%s\".',1),(2577,2,1460842374,'Абонамент за бюлетин \"%s\"',1),(2578,2,4151955869,'Потребител с email \"%s\" току що се абонира за бюлетин \"%s\".',1),(2579,2,1453211149,'Не мога да добавя продукт \"%s\" за сравнение.',1),(2580,2,166495272,'Сравнение на продукти',1),(2581,2,1634594289,'Избери език',1),(2582,2,3705672827,'Избери валута',1),(2583,2,3348699508,'Продуктов feed',1),(2584,2,812562298,'Невалиден ключ за продуктов feed.',1),(2585,2,2573243337,'Чака одобрение',1),(2586,2,4039052383,'Неодобрено',1),(2587,2,4121705435,'Слаб',1),(2588,2,1828591333,'Среден',1),(2589,2,3434537388,'Добър',1),(2590,2,2761007372,'Много добър',1),(2591,2,551958626,'Отличен',1),(2592,2,2597373484,'Само регистрирани потребители могат да оценяват.',1),(2593,2,927169313,'Само клиенти закупили този продукт могат да го оценяват.',1),(2594,2,1175543820,'Само регистрирани потребители могат да пишат ревюта.',1),(2595,2,1715888140,'Само клиенти закупили този продукт могат да пишат ревю за него.',1),(2596,2,377899250,'Няма ревю.',1),(2597,2,2179000251,'Няма оценка.',1),(2598,2,3148493063,'Оценка / ревю',1),(2599,2,2808175468,'Всички рейтинги',1),(2600,2,310527526,'Съдържание на ревюто',1),(2601,2,2749701344,'Стойност на оценката',1),(2602,2,1777785138,'Статус на райтингa',1),(2603,2,1207280236,'Клиентско ревю за продукт \"%s\".',1),(2604,2,2779464736,'Клиентски рейтинт за продукт \"%s\".',1),(2605,2,868798906,'Моля изберете оценка или напишете ревю.',1),(2606,2,46111629,'Моля изберете оценка.',1),(2607,2,958856233,'Моля напишете ревю.',1),(2608,2,1836496177,'Гост',1),(2609,2,233027733,'Благодаря, че споделихте вашето мнение.',1),(2610,2,2600091244,'Непознат RSS feed.',1),(2611,2,427583051,'Отстъпка цени на едро',1),(2612,2,1568311921,'Артикулът вече е добавен във Вашия списък с желания.',1),(2613,2,3819242224,'Артикулът е успешно добавен във Вашия списък с желания.',1),(2614,2,1194866349,'Артикулът е изваден от списъка с желания.',1),(2615,2,829364355,'Това е моят списък с желани продукти',1),(2616,2,3268514320,'Списъкът с желани продукти е изпратен.',1),(2617,2,2684748848,'Страницата не е открита.',1),(2618,2,3670592399,'Профила обновен успешно.',1),(2619,2,4265525075,'Моя профил',1),(2620,2,1537601948,'Регистрацията неуспешна: %s',1),(2621,2,2909322066,'Неуспех при абониране за бюлетин: %s',1),(2622,2,2365027333,'-- Всички --',1),(2623,2,485311805,'Вашия email бе успешно изпратен.',1),(2624,2,298311779,'Открита е грешка при изпращането на Вашия email.',1),(2625,2,3198092169,'Не мога да намеря реализация за %s.',1),(1,3,2289755597,'Oluştur',1),(2,3,1037276004,'Yönetici Oluştur',1),(3,3,2995482424,'Hesap',1),(4,3,2876326840,'İzinler',1),(5,3,892126259,'Yönetici Hesabı',1),(6,3,1483083269,'Kullanıcı Adı:',1),(7,3,1618169985,'Parola:',1),(8,3,1143805008,'E-mail:',1),(9,3,3428050462,'Erişim Seviyesi:',1),(10,3,1169514477,'Yönetici Bölümleri',1),(11,3,2590913965,'Yönetici hesabı erişim düzeyi \"Sınırlı\" olduğunda sadece Yönetici izniyle başvurulabilir.',1),(12,3,554135844,'Düzenle',1),(13,3,2016076131,'Yönetici Düzenle',1),(14,3,2676568142,'Güncelle',1),(15,3,4168197166,'Bu yöneticiyi silmek istediğinizden emin misiniz?',1),(16,3,3395160503,'Yöneticiler',1),(17,3,578394630,'Yeni Yönetici',1),(18,3,1159730082,'Gönder',1),(19,3,3558298466,'Yazdır',1),(20,3,19424289,'Kullanıcı Adı',1),(21,3,642995056,'E-Mail',1),(22,3,1358691240,'Erişim Seviyesi',1),(23,3,1035893169,'Sil',1),(24,3,1991199118,'Kayıt bulunamadı.',1),(25,3,2437429846,'Yönetici Süz',1),(26,3,401120404,'Kullanıcı Adı...',1),(27,3,759615668,'Email...',1),(28,3,4173485446,'Süzmeyi Geri Al',1),(29,3,3440991137,'API Hesabı Oluştur',1),(30,3,979098257,'API Hesabı Düzenle',1),(31,3,856131234,'API Hesap İzinleri:',1),(32,3,594535439,'Bu API hesabını silmek istediğinizden emin misiniz?',1),(33,3,510619022,'API Hesapları',1),(34,3,769722276,'Yeni API Hesabı',1),(35,3,299066170,'ID',1),(36,3,3434357891,'Parola',1),(37,3,1422021308,'API Hesaplarını Süz',1),(38,3,1656057158,'ID...',1),(39,3,2029384602,'İşlem Ekle',1),(40,3,1621185387,'Müşteri e-mail:',1),(41,3,2085752545,'Müşteri olacak:',1),(42,3,666537513,'puanlar',1),(43,3,3730803834,'Açıklama:',1),(44,3,1829616372,'Bonus Puanları',1),(45,3,786362779,'Bu işlemi silmek istediğinize emin misiniz?',1),(46,3,2018503775,'Müşteri',1),(47,3,3483776891,'Zaman',1),(48,3,1080068516,'Eylem',1),(49,3,538348319,'Puanlar',1),(50,3,3950563313,'Açıklama',1),(51,3,2091671594,'Durum',1),(52,3,1273029392,'Onayla',1),(53,3,1917417168,'İptal',1),(54,3,3845477,'Müşteri E-Mail...',1),(55,3,3090480774,'Süzme işlemleri',1),(56,3,3768765570,'Müşteriler',1),(57,3,1399724308,'Kutu Oluştur',1),(58,3,2522791519,'Kutu Tipi:',1),(59,3,1029537327,'Kutu İsmi:',1),(60,3,529056539,'Seçenekler',1),(61,3,4121317825,'Kutu Seçenekleri',1),(62,3,2919767447,'Kutu Seçeneklerini Düzenle',1),(63,3,905343091,'Aktif:',1),(64,3,710380569,'Bu kutuyu silmek istediğinizden emin misiniz?',1),(65,3,204512749,'Kutular',1),(66,3,4110683034,'Yeni Kutu',1),(67,3,2007405142,'Alan',1),(68,3,4262580536,'İsim',1),(69,3,1286797620,'Aktif',1),(70,3,753727511,'Tür',1),(71,3,3664733115,'Durum değiştir',1),(72,3,3387538849,'Başlık',1),(73,3,3718166553,'Başlığı Göster:',1),(74,3,1116506645,'İçerik:',1),(75,3,3332629561,'Kategori Oluştur',1),(76,3,2611773477,'Ana Kategori:',1),(77,3,1022533488,'İsim:',1),(78,3,3904062056,'Resim:',1),(79,3,2509092508,'Düzen:',1),(80,3,1653073578,'SEO Başlık:',1),(81,3,592908905,'%%COMPANY_NAME%%, %%PAGE_NAME%%, %%PAGE_NUMBER%% and %%FMT_PAGE_NUMBER%% Bunları Kullanabilirsiniz ve otomatik olarak değişecektir.',1),(82,3,3851858000,'SEO Anahtar Kelimeler:',1),(83,3,4119834834,'SEO Açıklama:',1),(84,3,4159192542,'Bu kategoriyi tüm alt kategoriler ve listelenen tüm ürünlerle birlikte silmek istediğinizden emin misiniz?',1),(85,3,590884430,'Kategori Sil',1),(86,3,3735244906,'Silinecek Kategoriyi Seçin:',1),(87,3,914164045,'Kategori silindiğinde aynı zamanda programdan tamamen kaldırılır',1),(88,3,34053083,'alt kategoriler.',1),(89,3,345866253,'Geçerli kategori ve onun alt kategorisindeki ürünler.',1),(90,3,721012472,'Silinecek altkategoriler',1),(91,3,491010218,'Kategori İsmi',1),(92,3,962550496,'Alt kategori yok',1),(93,3,1048183235,'Silinecek ürünler',1),(94,3,2570549838,'SKU (Stok Numarası)',1),(95,3,2960715841,'Ürün İsmi',1),(96,3,4282022807,'Kategori',1),(97,3,185142749,'Fiyat',1),(98,3,1294350323,'Ürün Yok',1),(99,3,1213241423,'Kategori Düzenle',1),(100,3,4285491557,'Bu kategoriyi ve tüm alt kategorilerini silmek istediğinizden emin misiniz?',1),(101,3,1974355384,'Kategoriler',1),(102,3,2407014471,'Yeni Kategori',1),(103,3,1254897676,'Ürünler',1),(104,3,4044774684,'Sırala',1),(105,3,3015334490,'ürünler',1),(106,3,282756568,'Kasa Modülü Düzenle',1),(107,3,3257114989,'Kasa Modülü Seçeneklerini Düzenle',1),(108,3,2359548218,'Kasa Modül Adı:',1),(109,3,1010515290,'Kasa Modülü Görüntüleme Adı:',1),(110,3,2658432784,'Seçenekler:',1),(111,3,2133747315,'Direkt Kasaya Ödeme Modülleri',1),(112,3,382242975,'Görüntü Adı',1),(113,3,1235981300,'Sağ slayt',1),(114,3,2830496658,'Yardım',1),(115,3,2037939570,'Sol slayt',1),(116,3,4097332503,'Geçmiş Siparişler',1),(117,3,1914014145,'Bugün',1),(118,3,1741006997,'Dün',1),(119,3,873400667,'Hızlı Linkler',1),(120,3,1407211951,'Emin misiniz?\n Kurulum sihirbazı daha sonra \"Website İçerik :: Kutular\" menüsü aracılığı ile etkin olabilir.',1),(121,3,2820672820,'Kurulum Sihirbazı',1),(122,3,71361365,'Hızlı Kurulum Adımları',1),(123,3,318403058,'1.Mağaza sahibi',1),(124,3,1063320005,'2.E-mailler',1),(125,3,1497918823,'3.Para Birimleri',1),(126,3,133536621,'ve',1),(127,3,2163033279,'Lokalizasyon',1),(128,3,237900732,'4. Ödeme',1),(129,3,842685971,'Gönderim Modülleri',1),(130,3,1141612140,'Bölgeler',1),(131,3,1263603970,'6.Kasa',1),(132,3,2472554517,'Oluştur <a href=\"categories.php\">kategoriler</a> and <a href=\"products.php\">ürünler</a>.',1),(133,3,418204617,'Satışa Başlayın !',1),(134,3,2645630361,'Kutu kaldır',1),(135,3,3522603177,'Firma - Mağaza Sahibi',1),(136,3,839502324,'Şirket Adı:',1),(137,3,1766359513,'Şirket Ülkesi:',1),(138,3,3551868704,'Şirket Şehri:',1),(139,3,4205699080,'Şirketin bulunduğu İlçe:',1),(140,3,1467534244,'Şirket Adresi:',1),(141,3,3184102455,'Şirket Adresi 2:',1),(142,3,2799088763,'Firma Posta Kodu:',1),(143,3,3951350519,'Telefon:',1),(144,3,1211405980,'Telefon 2:',1),(145,3,4156838822,'Fax:',1),(146,3,115514393,'Ülke Oluştur',1),(147,3,3747125869,'ISO 3166-1-alpha-2:',1),(148,3,2020171218,'2 harften oluşan ülke kodu',1),(149,3,3326323500,'ISO 3166-1-alpha-3:',1),(150,3,3887324748,'3 harften oluşan ülke kodu',1),(151,3,1265701764,'Ülke düzenle',1),(152,3,1323169768,'Geçerli müşteri şehri gerekiyor',1),(153,3,2446631621,'Etkinleştirmeden önce bu ülke için şehir ve ilçelerin database de var olduklarından emin olunç',1),(154,3,1154463460,'Bu ülkeyi silmek istediğinizden emin misiniz?',1),(155,3,3751241998,'Ülkeler',1),(156,3,3026300927,'Yeni Ülke',1),(157,3,2221352256,'Kod 2',1),(158,3,4083160534,'Kod 3',1),(159,3,913207931,'Şehirler',1),(160,3,753088835,'Varsayılan',1),(161,3,2535385811,'Varsayılan Ayarları',1),(162,3,419496075,'Ülkeleri Süz',1),(163,3,971770418,'Ülke ismi...',1),(164,3,699852639,'2-Haneli kod...',1),(165,3,2279503566,'3-Haneli Kod',1),(166,3,4039929781,'Kupon Oluştur',1),(167,3,728504189,'Kod:',1),(168,3,2549178112,'Tip:',1),(169,3,3648363398,'Uygulama modu',1),(170,3,839626980,'Değer:',1),(171,3,307808580,'Gönderim Şekli:',1),(172,3,2338252958,'Başlangıç Tarihi:',1),(173,3,464626289,'Bitiş Tarihi:',1),(174,3,2285077413,'Kullanım Miktarı:',1),(175,3,1100149183,'Kupon Koşulları:',1),(176,3,3517418852,'Not:Sadece tüm koşullar yerine geldiğinde kupon kabul edilir',1),(177,3,887667868,'Sipariş',1),(178,3,3571547723,'Müşteri Grupları',1),(179,3,656937191,'Tedarikçiler',1),(180,3,1940046458,'Sipariş alt toplamı aşıyor',1),(181,3,311605988,'Ürün ekle',1),(182,3,2644734124,'Ürün seç',1),(183,3,515919727,'Araştır...',1),(184,3,2677780045,'Ürünleri kaldır',1),(185,3,3319213447,'Müşteri İsmi:',1),(186,3,2398662531,'Müşteri ekle',1),(187,3,3786205714,'Müşterileri Kaldır',1),(188,3,2426276932,'Tedarikçi İsmi:',1),(189,3,3292489674,'Tedarikçi Ekle',1),(190,3,1328338441,'Tedarikçileri kaldır',1),(191,3,3508710101,'Kupon Düzenle',1),(192,3,3336226318,'Kullanılır:',1),(193,3,495727280,'Bu kuponu silmek istediğinizden emin misiniz?',1),(194,3,987310212,'Kuponlar',1),(195,3,3472138508,'Yeni Kupon',1),(196,3,3609698214,'Kod',1),(197,3,3702945584,'Değer',1),(198,3,4013556806,'Başlangıç Tarihi',1),(199,3,3211622985,'Bitiş Tarihi',1),(200,3,895329285,'Kuponları Süz',1),(201,3,3273198802,'Kupon Kodu...',1),(202,3,3255354999,'Kupon Değeri...',1),(203,3,2847503815,'Para Birimi Oluştur',1),(204,3,2257604640,'Kod: (3 Harf)',1),(205,3,4049401116,'Sol Sembol:',1),(206,3,1068033941,'Sağ Sembol:',1),(207,3,4261341808,'Ondalık Sembol:',1),(208,3,2106014093,'Binler Ayırıcısı:',1),(209,3,885873369,'Basamak Sayısı:',1),(210,3,2316664076,'Oran',1),(211,3,659163569,'Para Birimi Düzenle',1),(212,3,1867670234,'Bu para birimini silmek istediğinizden emin misiniz?',1),(213,3,3101993193,'UYARI: Varsayılan para birimini değiştirmek, tüm fiyatları yeni bir para birimine dönüştürür. Dönüşüm uygulanmaz. Emin misiniz?',1),(214,3,2023310659,'Para Birimleri',1),(215,3,3764564409,'Yeni Para Birimi',1),(216,3,1144470778,'Orana göre',1),(217,3,3198531662,'Oranı Güncelle',1),(218,3,3851265157,'Para Birimlerini Süz',1),(219,3,2102318287,'Para Birimi İsmi...',1),(220,3,730052110,'Para Birimi Kodu...',1),(221,3,2965428102,'Para Birimi Oranı...',1),(222,3,3735031810,'Para birimi oranını güncelle',1),(223,3,4255488631,'Para birimi oran modülleri',1),(224,3,3131407025,'Para birimi oran modülü seçeneklerini düzenle',1),(225,3,1363597389,'Para birimi oran modülü ismi:',1),(226,3,2232779832,'Oranlar',1),(227,3,3857138066,'Para Birimi Oranları',1),(228,3,2277816345,'%%BANKNAME%% sı Döviz Oranları',1),(229,3,3218697270,'Temel para birimi',1),(230,3,1628591218,'Para Birimini Fiyatlandırmak',1),(231,3,2145292295,'Oran',1),(232,3,1616759769,'Güncellenme Tarihi',1),(233,3,1503822767,'Özel Url\'ler kullanacağım',1),(234,3,495143701,'Özel Url',1),(235,3,810799440,'Geçerli Özel Url',1),(236,3,3261111235,'Ekleme',1),(237,3,1865160710,'Kaldır',1),(238,3,734138096,'Url Ekle',1),(239,3,1303866686,'Özel Url Oluştur',1),(240,3,2242273707,'Url:',1),(241,3,1171046712,'Ürün:',1),(242,3,2056915619,'Kategori:',1),(243,3,673769939,'Tedarikçi:',1),(244,3,872336839,'Form:',1),(245,3,639522870,'Zengin İçerik Sayfası:',1),(246,3,724805283,'Galeri:',1),(247,3,13213407,'Dinamik Sayfa:',1),(248,3,1180273410,'Güncel:',1),(249,3,1457006762,'Eğer Özel url kullanılabilir değilse ziyaretçi bu sayfaya yönlendirilecektir.',1),(250,3,1835073706,'Özel url düzenle',1),(251,3,950790732,'Bu özel url yi silmek istediğinize emin misiniz?',1),(252,3,1993255083,'Özel Url\'ler',1),(253,3,1610774068,'Yeni Özel Url',1),(254,3,1657866020,'URL',1),(255,3,159662430,'Varlık',1),(256,3,1271107802,'Varlık ismi',1),(257,3,1063193523,'Güncel',1),(258,3,586873638,'Özel Urlleri Süz',1),(259,3,3760750716,'Özel url yazısı...',1),(260,3,2971479636,'Sayfa ID...',1),(261,3,3465963864,'Müşteri Grubu Oluştur',1),(262,3,1354171785,'Müşteri Grubunu Düzenle',1),(263,3,2030727810,'Bu müşteri grubunu silmek istediğinize emin misiniz?',1),(264,3,1832239909,'Yeni Müşteri Grubu',1),(265,3,62372502,'Müşteri Gruplarını Süz',1),(266,3,3534204887,'Müşteri Grup İsmi...',1),(267,3,3626964749,'Varsayılan Fatura Adresi',1),(268,3,1298866674,'Varsayılan Gönderim Adresi',1),(269,3,1633266105,'İsim:',1),(270,3,3952088495,'Soyisim:',1),(271,3,190101345,'Firma:',1),(272,3,1987276054,'Vergi Numarası:',1),(273,3,1241179085,'Ülke:',1),(274,3,963545935,'Şehir:',1),(275,3,4099323532,'İlçe:',1),(276,3,3152090975,'Posta Kodu:',1),(277,3,469117031,'Adres 1:',1),(278,3,819690404,'Adres 2:',1),(279,3,3025604379,'Haber Ekle',1),(280,3,1104573425,'Müşteri Oluştur',1),(281,3,3688990591,'Müşteri Grubu:',1),(282,3,3486077833,'Durum:',1),(283,3,2951236299,'Adres:',1),(284,3,84373228,'Bültenler:',1),(285,3,3475312519,'Müşteri Düzenle',1),(286,3,2569416001,'Puanlar:',1),(287,3,671550159,'Puan Geçmişini Gör',1),(288,3,2684393541,'Bu müşteriyi silmeye emin misiniz?',1),(289,3,135116687,'Yeni Müşteri',1),(290,3,3259950746,'Müşteri İsmi',1),(291,3,1416126568,'Fatura Adresi',1),(292,3,3631425621,'Sipariş Geçmişi',1),(293,3,640984327,'Müşterileri Süz',1),(294,3,1938273026,'Müşteri İsmi...',1),(295,3,139694043,'Bültenler',1),(296,3,4134497924,'Abone olmak için seçtiğiniz haber bültenleri.',1),(297,3,724096885,'En Yeni Siparişler',1),(298,3,3505840376,'Son 5 Sipariş',1),(299,3,179083332,'Tarih',1),(300,3,3181064726,'Detaylar',1),(301,3,65982042,'Toplam',1),(302,3,2682620377,'Tümünü Gör',1),(303,3,3178444827,'Kategorileri Gör',1),(304,3,922052886,'Seçilen periyotta bilgi yok',1),(305,3,473154195,'Ayarlar',1),(306,3,2812958730,'Periyot:',1),(307,3,3878477080,'Ürünleri Gör',1),(308,3,686891096,'Ürüne Göre Satışlar',1),(309,3,327582746,'Sayfa Görüntülenmesi / Tekil Ziyaretçiler',1),(310,3,3785762269,'Erişim Engellendi',1),(311,3,3706373094,'\"%%SECTIONNAME%%\" Bölümüne erişim engellendi!',1),(312,3,554650102,'İndirim Oluştur',1),(313,3,859799067,'İndirim Koşulları:',1),(314,3,1753317527,'Not:Tüm koşullar yerine geldiğinde indirim uygulanır',1),(315,3,2952541568,'İndirim Düzenle',1),(316,3,1040504028,'Bu indirimi silmek istediğinizden emin misiniz?',1),(317,3,2124840987,'İndirimler',1),(318,3,1758760328,'Yeni İndirim',1),(319,3,3090213278,'İndirimleri Süz',1),(320,3,384779057,'İndirim İsmi...',1),(321,3,401325246,'İndirim Değeri...',1),(322,3,1151858065,'Dinamik Sayfa Düzenle',1),(323,3,4004852549,'Sayfa:',1),(324,3,2097494675,'menü',1),(325,3,882035683,'Dinamik Sayfa Alanları:',1),(326,3,264857579,'Dinamik Sayfalar',1),(327,3,3344210772,'Dinamik Sayfaları Süz',1),(328,3,1435067696,'Sayfa İsmi...',1),(329,3,1261301092,'E-mailler',1),(330,3,3826974845,'Hata hakkında daha fazla bilgi',1),(331,3,1840744469,'E-mail Adresleri',1),(332,3,3361431098,'Site Yönetici E-mail:',1),(333,3,1294274427,'Sipariş Departmanlığı E-Mail:',1),(334,3,2997004959,'Birden fazla e-mail adresleri virgülle ayrılarak desteklenir',1),(335,3,2993599821,'Yardım/Destek E-mail:',1),(336,3,221380787,'Cevap E-mail bildirimleri:',1),(337,3,3044419721,'Bu e-maildeki Kimden ve Yanıtlayan başlıkları,müşteriye bildirim postası gönderilirkende kullanılacaktır.',1),(338,3,2894426120,'Bülten için cevap e-maili:',1),(339,3,4185941722,'E-mailleri gönderim yöntemi:',1),(340,3,1666559931,'SMTP sunucu ayarları',1),(341,3,3142575940,'SMTP Host:',1),(342,3,735870516,'SMTP port:',1),(343,3,3062696543,'SMTP Kimlik Doğrulama:',1),(344,3,3330392952,'SMTP Kullanıcı Adı:',1),(345,3,4271152636,'SMTP Parola:',1),(346,3,3837661202,'SMTP güvenlik:',1),(347,3,3521870156,'Test E-maili güncelle ve gönder',1),(348,3,2896921823,'Bu test emailidir.',1),(349,3,1220736883,'Test etmek amacıyla <a href=\"%%STORE_ROOT_URL%%\">%%COMPANYNAME%%</a> adresinden email gönderildi.',1),(350,3,4016487210,'Vitrin Ürünü Oluştur',1),(351,3,485965105,'Ürün',1),(352,3,2071043849,'Araştır',1),(353,3,3650456851,'Anasayfada Gösterilsin..',1),(354,3,859962406,'Vitrin Ürünü Düzenle',1),(355,3,1653583751,'Bu ürünü vitrin ürünlerden kaldırmak istediğinize emin misiniz?',1),(356,3,1136261839,'Vitrin Ürünleri',1),(357,3,4064565271,'Ürün Arama:',1),(358,3,561596911,'Ürün İsmi...',1),(359,3,3497791286,'Ürünleri Süz',1),(360,3,1140086212,'Yeni Vitrin Ürünü',1),(361,3,83635035,'Resim',1),(362,3,2942734885,'Seçilen:',1),(363,3,2382706641,'Form Oluştur',1),(364,3,2948666624,'Metni Onaylayın:',1),(365,3,813452922,'Tüm Alanlar Zorunlu:',1),(366,3,3121551407,'Form Düzenle',1),(367,3,3478282366,'Öğe İsmi',1),(368,3,498026833,'Öğe Tipi',1),(369,3,435013471,'Gerekli',1),(370,3,418411255,'Giriş ve özel isimler seçtiğiniz alanların önünde olmalıdır, örneğin:',1),(371,3,1891574076,'Bu formu silmek istediğinize emin misiniz?',1),(372,3,1023292659,'Formlar',1),(373,3,2225337316,'Yeni Form',1),(374,3,4144669664,'Formları Süz',1),(375,3,2659577502,'Form İsmi...',1),(376,3,314191173,'Galeri Oluştur',1),(377,3,247289170,'Galeri İsmi',1),(378,3,1197503405,'Galeri Başlığı',1),(379,3,1915678372,'Galeri Açıklama',1),(380,3,964021644,'Galeri Aktif',1),(381,3,1435567424,'SEO Başlık:',1),(382,3,1596564184,'Galeri Düzenle',1),(383,3,558160881,'Dosyadan Resimleri Al',1),(384,3,637989770,'Bu galeriyi silmek istediğinize emin misiniz?',1),(385,3,1979706388,'Galeriler',1),(386,3,2688097955,'Yeni Galeri',1),(387,3,3942078319,'Başlık',1),(388,3,3010037137,'Galerileri Süz',1),(389,3,124201707,'Galeri İsmi...',1),(390,3,1412881386,'Dosya göndermeden önce resim galerisini silmek istediğinize emin misiniz?',1),(391,3,1032305907,'\"%%GALLERYNAME%%\"  resimleri al',1),(392,3,3152560996,' \"%%DIRECTORY%%\" dizininde resim bulundu.',1),(393,3,2488537117,'Dosya gönderimi öncesi galeri resimlerini sil',1),(394,3,1916110845,'Seçilen Resimleri Al',1),(395,3,3958908650,'Galeri Öğesi Oluştur',1),(396,3,678364137,'URL:',1),(397,3,3453375687,'Galeri Öğesi Düzenle',1),(398,3,1822348166,'Bu öğeyi silmek istediğinize emin misiniz?',1),(399,3,2370364043,'Galeri Öğeleri',1),(400,3,2607950393,'Yeni Galeri Öğesi',1),(401,3,176078831,'Eklendi',1),(402,3,4035319854,'Sıralama Düzeni',1),(403,3,2468205517,'Genel Seçenekler',1),(404,3,3887315804,'Resimler',1),(405,3,854454908,'e-eşyalar',1),(406,3,1361241570,'Değerlendirmeler &amp; Yorumlar',1),(407,3,4043640331,'Karışık',1),(408,3,269276975,'Yüklenen resimler otomatik olarak yeniden boyutlandırılacatır.',1),(409,3,1384850146,'Ürün Resimleri',1),(410,3,2918703136,'Büyük resim max genişlik:',1),(411,3,492802816,'Büyük resim max yükseklik:',1),(412,3,3881581214,'Normal resim max.genişliği:',1),(413,3,835495505,'Normal resim max.yükseklik:',1),(414,3,921966431,'Önizleme resmi max genişlik:',1),(415,3,3716086874,'Önizleme resmi max yükseklik:',1),(416,3,4157063781,'Kutu resmi max genişlik:',1),(417,3,464721469,'Kutu resmi max yükseklik:',1),(418,3,361089098,'Ürün resimlerini yenile ve ayarları kaydet',1),(419,3,220566877,'Tedarikçilerin Resimleri',1),(420,3,3680048988,'Kategorilerin Resimleri',1),(421,3,2457112548,'Resim Galerisi',1),(422,3,1517437511,'Yanyana sıralamada satır başı resim:',1),(423,3,2504331047,'Yanyana sıralamada sayfadaki satır:',1),(424,3,2769143229,'Büyük resim max genişlik:',1),(425,3,2481555164,'Büyük resim max yükseklik:',1),(426,3,2240765858,'İndirme linki aktif :',1),(427,3,3957652582,'gün/günler',1),(428,3,2004198218,'Her E-Eşyadan max indirme sayısı:',1),(429,3,1265870005,'indirmeler',1),(430,3,539322459,'E-Eşyanın Otomatik kilidini açmak için:',1),(431,3,716429498,'Ürün değerlendirmeyi kim yapabilir?:',1),(432,3,2645711072,'Ürün yorumlarını kim yapabilir?:',1),(433,3,77241868,'Otomatik olarak değerlendirme ve yorumlar:',1),(434,3,3055675652,'Sayfa başına ürünler',1),(435,3,1383366238,'Varsayılan kategori görünümü:',1),(436,3,3434089996,'Varsayılan Ürün siparişi:',1),(437,3,1369760445,'Sütun görünümü:',1),(438,3,1737381562,'Satır görünümü:',1),(439,3,382330550,'Ürünlerin Alt alta görünümü:',1),(440,3,2083096048,'Anasayfa görünümü:',1),(441,3,750111958,'Otomatik stok takibi:',1),(442,3,2380118066,'Ürünler stokda bittiği zaman:',1),(443,3,402006418,'Kategori listeleri önüne yeni ürünler ekle:',1),(444,3,1909781453,'Toptan satış fiyatlarına izin:',1),(445,3,4223135822,'Döviz kurlarının sona ereceği tarih:',1),(446,3,1281194530,'Ürünler kaç gün yeni kabul edilir:',1),(447,3,1202775632,'Karşılaştırmak için maximum ürün sayısı:',1),(448,3,924304961,'Kayıt olurken doğrulama:',1),(449,3,62763753,'Ödemede kayıt olurken doğrulama:',1),(450,3,3951021838,'Bitmemiş siparişleri göster:',1),(451,3,662215137,'Bir arkadaş tavsiyesinde kazanılan',1),(452,3,4060238471,'Sınırlar',1),(453,3,3898582405,'Kullanım başına',1),(454,3,414650819,'Referans Cookie Ömrü',1),(455,3,1563505666,'Bir yorum yapılmasında kazanılan',1),(456,3,1869955673,'Bir değerlendirmede kazanılan',1),(457,3,3808845936,'Bir satın almada kazanılan',1),(458,3,1215727740,'Sipariş Durumları',1),(459,3,2482087779,'Harcama',1),(460,3,1902986711,'kazançlar',1),(461,3,1689585026,'1 puan karşılığı',1),(462,3,3856038733,'Ürün satın alırınırken',1),(463,3,4263381803,'Puan eylemlerine manuel onay',1),(464,3,2536097032,'Müşteriler harcamalarında puan mı değil mi karar versinler',1),(465,3,1205939790,'Yeni ürünler varsayılan olarak satın alınabilir.',1),(466,3,351951855,'Summer Cart-Yönetim Paneli',1),(467,3,2616496417,'Arama...',1),(468,3,2986050059,'Gizlemek için tıklayın',1),(469,3,4168505391,'Hoşgeldiniz',1),(470,3,845213721,'Çıkış',1),(471,3,766317539,'Dil',1),(472,3,2329144481,'Açık Müşteri Alanı',1),(473,3,3521422318,'Anasayfa',1),(474,3,1050048371,'Mağaza',1),(475,3,1625540659,'Website İçerik',1),(476,3,1050844889,'Raporlar',1),(477,3,590925805,'Eklentiler',1),(478,3,3009207953,'Ara',1),(479,3,2856345408,'Satışlar',1),(480,3,3800299736,'Siparişler',1),(481,3,870606089,'Ürün Seçenekleri',1),(482,3,3778863435,'Ürün Sınıfları',1),(483,3,2598554411,'Ürünleri Toplu Yükle',1),(484,3,1139605362,'Promosyon',1),(485,3,689873154,'Zengin İçerik Sayfaları',1),(486,3,3185653358,'Haberler',1),(487,3,836273688,'Bültenler',1),(488,3,586864587,'Resim Galerileri',1),(489,3,2018988773,'Website Düzeni',1),(490,3,3014928331,'Menüler',1),(491,3,549626884,'Şablonlar',1),(492,3,2592952232,'Düzenler',1),(493,3,4132776560,'Satış Raporları',1),(494,3,3412108406,'Kategoriye Göre Satış',1),(495,3,1276457918,'Müşteriye Göre Satışlar',1),(496,3,2831740307,'Ülkeye Göre Satışlar',1),(497,3,1076937254,'Müşteri Raporları',1),(498,3,779024177,'Müşteri Ülkeleri',1),(499,3,2809413986,'Sayfa Görüntülenmesi / Ziyaretçiler',1),(500,3,248971099,'Sipariş Raporları',1),(501,3,3484514641,'Ortalama Sipariş Tutarı',1),(502,3,2969627178,'Sipariş Durumları',1),(503,3,2107866557,'Ödeme Metodları',1),(504,3,492318832,'Gönderim Metodları',1),(505,3,55544060,'Vergiler',1),(506,3,1911357502,'Sipariş Başına Öğeler',1),(507,3,3775560267,'Modüller',1),(508,3,3563746674,'Gönderim Bedeli',1),(509,3,2727722385,'Ödeme',1),(510,3,1447972632,'Direkt Kasaya Ödeme',1),(511,3,4237855332,'Toplam Sipariş',1),(512,3,1033236376,'Para Birimi Oranı',1),(513,3,3354049021,'Mağaza<br />Konfigirasyon',1),(514,3,26480598,'Genel',1),(515,3,242724770,'Mağaza Sahibi',1),(516,3,1022211991,'Güvenlik',1),(517,3,4208373434,'SEO',1),(518,3,2509950185,'Vergi bölgeleri &amp; Vergiler',1),(519,3,2642707482,'Gönderim Alanları',1),(520,3,4252246553,'Diller &amp; Para Birimleri',1),(521,3,572576218,'Diller',1),(522,3,3557463602,'Yardım Oluştur',1),(523,3,1389658646,'Sayfa Hareketi:',1),(524,3,3505702287,'İçerik:',1),(525,3,3758143948,'Yardım Düzenle',1),(526,3,1239850335,'Bu yardımı silmek istediğinizden emin misiniz?',1),(527,3,94865552,'Yardımlar',1),(528,3,3735835143,'Yeni Yardım',1),(529,3,3023575326,'Sayfa',1),(530,3,3461554051,'Yardımları Süz',1),(531,3,2587122860,'Sayfa ismi...',1),(532,3,1153217644,'Ürünleri Toplu Yükle',1),(533,3,2478860166,'CSV Dosya:',1),(534,3,2147132762,'Lütfen dosyanızın CSV formatından emin olunuz.Buradan <a href=\"%%SKIN_URL%%admin/import/products.csv\" target=\"_blank\">Örnek CSV dosyasına bakabilirsiniz.</a>.',1),(535,3,1915366692,'Diller:',1),(536,3,55916349,'Hepsi',1),(537,3,3997793959,'Tedarikçileri Otomatik Oluştur:',1),(538,3,4116337988,'Kategorileri Otomatik Oluştur:',1),(539,3,517128142,'Ürün Sınıflarını Otomatik Oluştur:',1),(540,3,1866055727,'Dosyayı yüklemeden önce tüm ürünleri silin',1),(541,3,1059048098,'UYARI! Bu tüm güncel ürünlerin silinmesine neden olacaktır!',1),(542,3,2862194528,'İsterseniz tüm ürünleri kaldırmayı seçebilirsiniz',1),(543,3,2682384428,'Kısmı başarı izni:',1),(544,3,2388344707,'Tüm ürünler varsayılan olarak import edildiğinde tek işlemde başarılı yada başarısız görülmezler.Eğer import ederken kısmi başarısızlık varsa, başarılı import edilen ürünlere değişim izni verilecektir.',1),(545,3,2960504523,'Ürünler Yüklendi',1),(546,3,1831847519,'Ürünler Güncellendi',1),(547,3,3527257968,'Yeni Kategoriler Yüklendi',1),(548,3,1963134496,'Yeni Tedarikçiler Yüklendi',1),(549,3,2676543370,'Yeni Ürün Sınıfları Yüklendi',1),(550,3,2162755878,'Ürünlerin görüntülenmesi başarız',1),(551,3,946252235,'Kurulum bu sebeplerden başarasız:<br/><strong>%%PROBLEMS%%</strong>.',1),(552,3,2196203420,'Lisans Bilgisi',1),(553,3,2194961893,'Application Log',1),(554,3,3504735353,'Kurulum Kontrolü',1),(555,3,2743614721,'Your installation passes the install checks.',1),(556,3,3855422341,'Metinleri Bul',1),(557,3,2654260861,'Metin Sonuçlarını Bul',1),(558,3,2860613836,'Bulunan Metinler',1),(559,3,3939961270,'Bulunan Metin Şablonu',1),(560,3,1533893826,'Bulunan Metin Kodu',1),(561,3,1505227595,'Tüm Eşsiz Metinleri Say',1),(562,3,4279887624,'İşlem sonuçlarını güncelle',1),(563,3,384604181,'Önceki metinlerin sayısı',1),(564,3,1807440099,'Eklenen metinlerin sayısı',1),(565,3,1545029533,'Kaldırılan metinlerin sayısı',1),(566,3,2687646265,'Geri Dön',1),(567,3,338988109,'Dil Oluştur',1),(568,3,94494848,'Geçerli:',1),(569,3,1005997555,'2 Karakterli dil kodu (ISO 639-1)',1),(570,3,151362824,'Yönetim:',1),(571,3,1192782810,'Çoğu diller soldan sağa yazılır,bazı diller Arapça ve İbranice de olduğu gibi sağdan sola yazılır.',1),(572,3,3299575374,'İkon:',1),(573,3,1030573456,'Biraz zaman alabilir.',1),(574,3,2596794427,'Dil Düzenle',1),(575,3,1807457897,'Bilgi',1),(576,3,3440977850,'Dil Paketi',1),(577,3,1786319641,'Xliff dosyaları',1),(578,3,3455484701,'Dil Paketi İndir',1),(579,3,1320282873,'Yazar:',1),(580,3,2302973021,'Lisans:',1),(581,3,3070820891,'Basım Tarihi:',1),(582,3,4273363598,'Dil Paketi:',1),(583,3,967710941,'İndir /  xliff dosyalarını Yükle ',1),(584,3,1393277713,'Bir dil paketi XLIFF dosyaları içerir. XLIFF yazılım yerelleştirme ve çeviri konusunda uluslararası standart dosya biçimidir.',1),(585,3,1334522620,'xliff dosyalarını indir',1),(586,3,1059175203,'Arayüz dil metinleri',1),(587,3,1094608267,'XLIFF İndir',1),(588,3,3513281581,'Yönetici Hızlı Linkleri',1),(589,3,2057606105,'XLIFF Dosyasını yükleyin',1),(590,3,2454456072,'XLIFF Yükleyin',1),(591,3,1148527715,'Not important',1),(592,3,3765929189,'Kur',1),(593,3,1116465884,'Dil Paketi Kurulumu',1),(594,3,1257387828,'Dil Paketi Dosyası:',1),(595,3,2368833844,'Bu bir dil için çeviriler içeren bir zip dosyası.',1),(596,3,4220357726,'Dil paketi için <a href=\"http://www.summercart.com/\" target=\"_blank\">www.summercart.com</a> adresini ziyaret ediniz.',1),(597,3,1623261434,'Maxiumum yüklenebilecek dosya büyüklüğü %%MAXUPLOADSIZE%%',1),(598,3,3548864002,'Nasıl Artırılır?',1),(599,3,1877622045,'Dil Paketi Başarıyla Kuruldu.',1),(600,3,1710096959,'Dil Paketi Bilgisi',1),(601,3,1010286815,'Dil dosyaları başarı ile kuruldu',1),(602,3,749574446,'Dosya',1),(603,3,2331169344,'Yazılar çevrildi',1),(604,3,401915326,'Yüklü Çeviriler',1),(605,3,2164804145,'Eksik çeviriler',1),(606,3,3360604285,'Kullanılmayan çeviriler',1),(607,3,3714345229,'Metinlerde çeviriler eksik',1),(608,3,1915095946,'detaylar',1),(609,3,1455164762,'Metinler için kullanılmayan çeviriler',1),(610,3,3935651977,'Devam',1),(611,3,1851207096,'Kullanıcı Arayüzü Çeviriler Düzenle',1),(612,3,1496342308,'Orjinal Metin',1),(613,3,424200871,'Metin',1),(614,3,3749695353,'Hepsini İşaretle',1),(615,3,446897115,'Çeviri Uygulandı',1),(616,3,106014150,'Süz Kullanıcı Arabirimi Çevirileri',1),(617,3,2166909919,'Yazı ID...',1),(618,3,1056778569,'Orjinal Yazı...',1),(619,3,122880609,'Çeviri Metni...',1),(620,3,2485861965,'Süzme Çevirileri',1),(621,3,291378377,'Kullanıcı arayüzü çevirileri',1),(622,3,1652720925,'Bu dili silmek istediğinize emin misiniz?',1),(623,3,105775009,'UYARI: Varsayılan dili değiştirdiğinizde mağazanızdaki sipariş öğelerinin isimleri de değişecektir. Emin misiniz?',1),(624,3,771978002,'Dillerin Yönetimi',1),(625,3,1575962675,'Yeni Dil',1),(626,3,1242588023,'çeviri',1),(627,3,1720970127,'Tümünü Gör',1),(628,3,3837179999,'Dilleri Süz',1),(629,3,69925236,'Dil ismi...',1),(630,3,568052308,'Kullanıcı arayüzü metnini yükleyin',1),(631,3,2924034901,'Düzen Oluşturun',1),(632,3,956611263,'CSS Sınıf İsimleri',1),(633,3,2410151477,'Düzeni Düzenleyin',1),(634,3,4287890366,'Düzen ID',1),(635,3,3185071516,'Bu düzeni silmek istediğinize emin misiniz?',1),(636,3,1205307603,'Düzenler Yönetimi',1),(637,3,2423387628,'Yeni Düzen',1),(638,3,2968916085,'Varsayılan Düzeni Değiştir',1),(639,3,2500444969,'Düzenleri Süz',1),(640,3,146829847,'Düzen İsmi...',1),(641,3,412693723,'Son Kullanıcı Lisans Sözleşmesi',1),(642,3,2682984555,'Summer Cart Lisans Bilgisi',1),(643,3,2323996648,'Lisans:',1),(644,3,1523516778,'Lisans Tipi:',1),(645,3,3545320687,'Website:',1),(646,3,3864153367,'Lisans Kodu:',1),(647,3,3045320497,'Orjinallik Kontrolü',1),(648,3,63961100,'Demo:',1),(649,3,4203975461,'Birim Ağırlığı:',1),(650,3,2784187960,'UYARI: Mağazada ağırlık birimini yenisi ile değiştirdiğinizde tüm ürünlerin birimi değişir. Dönüşüm Uygulanmaz.',1),(651,3,3130602245,'Application log',1),(652,3,2030045667,'Mesaj',1),(653,3,3953216932,'Yönetici',1),(654,3,3749110151,'Müşteri E-mail',1),(655,3,253145917,'Önem',1),(656,3,316635914,'Filter log entries',1),(657,3,1613063122,'Mesaj...',1),(658,3,1158643050,'Yönetici ismi...',1),(659,3,3873015737,'Log entries',1),(660,3,750740131,'Summer Cart\'ın düzgün çalışması için JavaScript izinleri olması gerekmektedir.Lütfen,JavaScript iznini verin.',1),(661,3,4049669701,'Lütfen Giriş Yapın',1),(662,3,757082350,'Dil:',1),(663,3,3342318177,'Giriş',1),(664,3,2168853892,'Tedarikçi Oluştur',1),(665,3,2808637353,'Tedarikçi Düzenle',1),(666,3,2944624444,'Bu Tedarikçiyi silmeye emin misiniz?',1),(667,3,4056684887,'Yeni Tedarikçi',1),(668,3,2295489659,'Website',1),(669,3,4021677144,'Tedarikçileri Süz',1),(670,3,277105412,'Tedarikçi İsmi...',1),(671,3,2536423828,'Tedarikçi Site...',1),(672,3,3208812707,'Menü Öğesi Oluştur',1),(673,3,1958220373,'Menü öğelerini düzenle',1),(674,3,111853526,'Menü öğesi düzenle',1),(675,3,73030122,'Menü öğeleri',1),(676,3,146153308,'Yeni menü öğesi',1),(677,3,1691918083,'Link Tipi',1),(678,3,2604631168,'Link için',1),(679,3,2710106125,'Menü Oluştur',1),(680,3,410452179,'Menü İsmi:',1),(681,3,1232203988,'Menü Konum:',1),(682,3,2249378412,'Menü Başlığı:',1),(683,3,3496752393,'Aktif Menü:',1),(684,3,2508382195,'Menü Düzenle',1),(685,3,4294259204,'Bu menüyü silmek istediğinize emin misiniz?',1),(686,3,2871931960,'Yeni Menü',1),(687,3,2817059741,'Konum',1),(688,3,2017505496,'Menüleri Süz',1),(689,3,657625883,'Menu İsmi...',1),(690,3,3805367665,'Tümünü Gör',1),(691,3,3553794789,'Ürün Seçeneği Oluştur',1),(692,3,4126992584,'Ürün Seçeneği Düzenle',1),(693,3,2462623563,'Bu grubu silmeye emin misiniz?',1),(694,3,500159910,'Ürünler Seçeneği',1),(695,3,2740491830,'Yeni Ürün Seçeneği',1),(696,3,3578931481,'Gruplar Seçeneklerini Süz',1),(697,3,4236806916,'Seçenek Grubu...',1),(698,3,3523343456,'Fiyat Değiştirici',1),(699,3,3590926850,'Değişiklik Tipi',1),(700,3,2299360628,'Miktar',1),(701,3,1956349703,'Ürün fiyatı %',1),(702,3,424616805,'Sipariş Durumu Oluştur',1),(703,3,1360519729,'Gönderim Notu:',1),(704,3,3743557245,'Envanter Eylemi:',1),(705,3,1063342408,'Sipariş Durumu Düzenle',1),(706,3,3081471352,'Bu sipariş durumunu silmeye emin misiniz?',1),(707,3,1774530486,'Yeni Sipariş Durumu',1),(708,3,2808458546,'Bildirim',1),(709,3,870107285,'Envanter',1),(710,3,2067839808,'Önceden Tanımlanmış',1),(711,3,1207696150,'Değiştir',1),(712,3,3927366091,'Sipariş Durumlarını Süz',1),(713,3,620095717,'Sipariş Durumu...',1),(714,3,2006019800,'Toplam Sipariş Modül Seçeneklerini Düzenle',1),(715,3,1031408549,'Toplam Sipariş Modül İsmi:',1),(716,3,3825478277,'Toplam Sipariş Modülleri',1),(717,3,3309110367,'resim',1),(718,3,2247323090,'SKU:',1),(719,3,4125291397,'Yönetim Notu Çok Kısa',1),(720,3,2288505237,'Bu notu silmek istediğinizden emin misiniz?',1),(721,3,3215528822,'Kredi kartı numarasının son 4 rakamı ve CVV atılacak.Emin misiniz?',1),(722,3,1929955923,'Faturayı Yazdır',1),(723,3,3642958753,'#%%ORDERID%% siparişi için demet fişi ve etiketi yazdır',1),(724,3,3185707023,'Sipariş Fişini Yazdır',1),(725,3,3094574373,'Sipariş Düzenle',1),(726,3,2381271956,'Sipariş Detayları',1),(727,3,1460565179,'Sipariş Numarası',1),(728,3,3551558051,'Sipariş Tarihi',1),(729,3,4157998837,'Müşteri Bilgileri',1),(730,3,1436479071,'IP Adresi',1),(731,3,3735532719,'Fatura Bilgileri',1),(732,3,3702440234,'Fatura İçin İsim:',1),(733,3,2009770416,'Adres',1),(734,3,2245635979,'Haritayı Gör',1),(735,3,3912290734,'Gönderim Bilgileri',1),(736,3,1058344987,'Gönderim İçin İsim:',1),(737,3,855323776,'Gönderim Bilgi',1),(738,3,3890635123,'Gönderim Şekli',1),(739,3,580378663,'Gönderim İzleme №',1),(740,3,81762214,'Profil İşlemleri',1),(741,3,2888137196,'Ödeme Şekli',1),(742,3,2405271545,'Ödeme İzleme №',1),(743,3,2941008396,'Kredi Kartı Bilgileri',1),(744,3,2347830614,'Geçersiz Kart',1),(745,3,3961855662,'Kart Kullanıcısı İsmi:',1),(746,3,2373507299,'Kart Numarası:',1),(747,3,1022260215,'Kart Son Kullanma Tarihi:',1),(748,3,3551303276,'CVV / CVC No:',1),(749,3,1028089187,'AVS:',1),(750,3,1747108340,'CVN:',1),(751,3,3135544870,'Kontrol Bilgileri',1),(752,3,4264007409,'Hesap İsmi:',1),(753,3,2210243515,'Hesap Numarası:',1),(754,3,2205281729,'Banka İsmi:',1),(755,3,3899945616,'Hesap Tipi:',1),(756,3,1255983578,'Müşteriden Özel İstekler',1),(757,3,525886687,'Ödeme Notu',1),(758,3,30367324,'Sipariş Edilen Ürünler',1),(759,3,1720022112,'Adet',1),(760,3,412538456,'İndirim',1),(761,3,3940561649,'Birim Fiyatı',1),(762,3,1029285216,'Sipariş Toplamı',1),(763,3,3391103084,'Müşteri ödenmişi',1),(764,3,2313543638,'E-Eşya gönder',1),(765,3,1995554626,'E-Eşya Görüntüle',1),(766,3,2396005286,'Ödeme Durumu',1),(767,3,772090503,'Bu sipariş ile ilgili yönetim notu',1),(768,3,1871664426,'Not',1),(769,3,1364489895,'Müşteriye Gönderilen',1),(770,3,2105576996,'Düzenleme Tarih ve Saati',1),(771,3,3519893586,'Sipariş Notu Yok.',1),(772,3,3920048843,'Yeni Yönetici Notu',1),(773,3,1426351852,'Müşterilere yönetim notu gönder',1),(774,3,123366371,'Not İçeriği:',1),(775,3,1135686316,'Not Ekle',1),(776,3,1833481689,'Kilit Aç',1),(777,3,666711088,'Kilitle',1),(778,3,3380749846,'İndirmeler',1),(779,3,1428246800,'Geçerliliği Dolmuş',1),(780,3,1649497623,'İndirilebilir',1),(781,3,1303016265,'Evet',1),(782,3,4063104189,'Hayır',1),(783,3,1011106260,'#%%ORDERID%% siparişi için fatura',1),(784,3,1608003288,'Fatura',1),(785,3,1526887444,'Sipariş Tarihi:',1),(786,3,3722834136,'Gönderim Şekli:',1),(787,3,2972062900,'Gönderim İzleme №:',1),(788,3,3172908309,'Ödeme Şekli:',1),(789,3,3504349440,'Ödeme işlemi №:',1),(790,3,1736041562,'Lütfen,öncelikle siparişleri seçin.',1),(791,3,2516486077,'Seçtiğiniz siparişleri silmeye emin misiniz?',1),(792,3,3353338619,'Tüm sipariş durumlarını güncellemeye emin misiniz?',1),(793,3,2453634288,'Siparişleri Arama',1),(794,3,2646813048,'Sipariş ID...',1),(795,3,3157953182,'Müşteri İsmi',1),(796,3,3796017169,'Sipariş Oluştur',1),(797,3,3514807676,'Durumları Güncelle',1),(798,3,275359193,'Faturayı Yazdır',1),(799,3,2332831890,'Sipariş Fişi Yazdır',1),(800,3,4070162868,'İşlemler',1),(801,3,551895527,'Sipariş ID:',1),(802,3,1507437924,'İşlem Kodu',1),(803,3,4099588478,'Detay İsmi',1),(804,3,1124325509,'Detay Değeri',1),(805,3,3399427310,'İşlem Bulunamadı.',1),(806,3,4234656813,'Ödeme Modülü Düzenle',1),(807,3,52654519,'Ödeme Modülü Seçeneklerini Düzenle',1),(808,3,909362514,'Ödeme Modülü İsmi:',1),(809,3,3629807128,'Ödeme Modülü Görüntü İsmi:',1),(810,3,100059395,'Ödeme Modülleri',1),(811,3,4023227825,'Entegrasyon Şekli',1),(812,3,1621980064,'Eklenti Seçeneklerini Düzenle',1),(813,3,3696483166,'Eklenti İsmi:',1),(814,3,1155909498,'Eklenti Kurulumu',1),(815,3,3228116228,'Eklenti paket dosyası:',1),(816,3,2612794959,'Eklenti Modülleri',1),(817,3,4005700258,'Eklenti',1),(818,3,193471262,'Modül',1),(819,3,3424629120,'Lütfen ilk resmi seçiniz',1),(820,3,1392705431,'Sadece resim yüklenebilir.Formatı JPG,PNG ve ya GIF olmalıdır',1),(821,3,3487826600,'Resim Yükle',1),(822,3,1336794860,'Resim Seç',1),(823,3,1983387308,'Önizleme',1),(824,3,703179297,'Küçük resimler otomatik oluşturulur',1),(825,3,45485956,'Küçük Resim:',1),(826,3,3535843008,'Kapat',1),(827,3,303993805,'Şimdi Uygula',1),(828,3,1371193412,'İptal',1),(829,3,2589634787,'Lütfen baskı alanlarını seçiniz.',1),(830,3,4118653070,'Yazdırmak istediğiniz veriyi seçiniz',1),(831,3,3624458271,'Lütfen ürün seçiniz.',1),(832,3,4054035588,'Lütfen kategori seçiniz:',1),(833,3,737252216,'ürün bulundu.',1),(834,3,2057586828,'Ürün Seçiniz',1),(835,3,3711818894,'Ürün Özellikleri',1),(836,3,3628166978,'Değer Ekle',1),(837,3,4145562852,'Özellik Ekle',1),(838,3,313419750,'Ürün Sınıfı Oluşturun',1),(839,3,2126945696,'Özellikler',1),(840,3,1465325025,'Ürün Sınıfı Düzenleme',1),(841,3,4232330976,'Bu ürün sınıfını silmek istediğinize emin misiniz?',1),(842,3,218394244,'Yeni Ürün Sınıfı',1),(843,3,2631993219,'Ürün Sınıfı...',1),(844,3,912926102,'Ürün Sınıflarını Süz',1),(845,3,4142080300,'Ürün Bul',1),(846,3,4293700324,'<br/>WYSIWYG editore<br/>geçiş',1),(847,3,589944230,'Düz Metine<br/>geçiş',1),(848,3,1980386710,'Resimler',1),(849,3,2584338874,'Ek Kategoriler',1),(850,3,3815204975,'Fiyatlar',1),(851,3,3563717080,'Benzer Ürünler',1),(852,3,2732013515,'Demet',1),(853,3,854319462,'Öğe Numarası (SKU)',1),(854,3,624639268,'Tedarikçiler',1),(855,3,273309567,'Ürün İsmi',1),(856,3,314147162,'Kısa Açıklama',1),(857,3,2857272176,'Detaylı Açıklama',1),(858,3,2224570068,'Mevcut Satışta',1),(859,3,6377591,'Ağırlık',1),(860,3,1892211746,'lbs, kg',1),(861,3,2146757560,'Vergi Sınıflandırması',1),(862,3,3641567454,'Tanımlanmış Vergi Yok',1),(863,3,2594461011,'Ürün Sayfa Başlığı',1),(864,3,3570241586,'%%COMPANY_NAME%%, %%PAGE_NAME%%, %%CATEGORY_NAME%% and %%CATEGORY_BRANCH%% Bunları Kullanabilirsiniz ve otomatik olarak değişecektir.',1),(865,3,2164287666,'Meta Anahtar Kelimeleri',1),(866,3,39755518,'Meta Açıklaması',1),(867,3,3424188446,'Global Seçenekler',1),(868,3,3893533752,'Ürün Seçenekleri',1),(869,3,4250554258,'Ürün e-eşyadır.',1),(870,3,3302799654,'Ürün Sınıfı',1),(871,3,2022403416,'Özellik',1),(872,3,626226205,'Kullanılabilir bonus puanları',1),(873,3,2254132409,'Fiyat puanları',1),(874,3,1807972765,'Otomatik fiyat için boş bırak.',1),(875,3,3714791612,'Fiyat boş olursa puanlar içinde olacaktır',1),(876,3,2824029570,'Ürün demettir',1),(877,3,3047654571,'Otomatik miktarlarda',1),(878,3,2431883014,'Alt ürün adet değişimi etkinse,ürün demet adeti otomatik olarak güncellenecektir.',1),(879,3,954096422,'Dahil Edilmiş Ürünler',1),(880,3,3664961198,'Tüm uzantılarıyla birlikte bu ürünü silmek istediğinize emin misiniz?',1),(881,3,3366923039,'Ürün Sil',1),(882,3,3917002164,'Silinecek Ürün:',1),(883,3,2664546985,'Ürünü silmek %%EGOODSCOUNT%% e-eşya uzantılanı da kaldırır.',1),(884,3,2130013892,'Silinecek dosyalar:',1),(885,3,3410550351,'Ürün Düzenle',1),(886,3,1257124279,'Değişkenler',1),(887,3,1778871822,'varyantları gör',1),(888,3,2818503275,'toptan satış fiyatlarını gör',1),(889,3,2445281649,'Ürün demetlerini gör',1),(890,3,335754544,'Büyük resmi görmek için tıklayın.',1),(891,3,4292304212,'Ürün varyantlarını ekleyebilmeniz için seçeneklerden \"varyant\" tiplerini eklemeniz gerekmektedir.',1),(892,3,3629807937,'Bu ürünün seçeneklerini düzeltmeden önce varyant değişikliklerini kaydetmeniz gerekmektedir.',1),(893,3,4115961312,'Kaydet',1),(894,3,2619480116,'Kaydet ve Kapat',1),(895,3,1021041466,'Bu üründen tüm e-eşyalar kaldırılacak. Emin misiniz?',1),(896,3,166431123,'e-eşya ürün ekle',1),(897,3,3751438319,'E-ürün dosyası(resim,film,döküman,mp3 veya diğerleri)sadece bu ürün için kullanılır.',1),(898,3,75466410,'Paylaşılan e-ürün ekle',1),(899,3,4183963746,'Paylaşılan e-ürün dosyası birden fazla ürün tarafından kullanılabilir.',1),(900,3,428357396,'Not:Paylaşılan e-ürünler sağlam kaldığı sürece, bir ürünsilindiğinde tüm e-ürünler de birlikte silinir.',1),(901,3,3210431157,'Küçük Resim',1),(902,3,3929915345,'Yeni resim yükle',1),(903,3,3607359936,'Resim ekle',1),(904,3,1146293855,'Yerel Seçenekler',1),(905,3,3810910862,'Seçenek Ekle',1),(906,3,384259134,'Kategorilerde süzme yapabilmeniz için ürülerin yeniden düzenlenmesi lazım.',1),(907,3,387876210,'Sıralama başarısız oldu.',1),(908,3,3932571580,'Sürükle ve sıralamayı etkinleştir?',1),(909,3,1400665124,'Ürünleri dikey kategoriye sürükleyerek yeniden düzenleyebilirsiniz.',1),(910,3,1224315921,'Bu ürünü silmek istediğinize emin misiniz?',1),(911,3,691153231,'Ürün Ara',1),(912,3,1043481812,'Ürün Numarası (SKU)...',1),(913,3,4005851251,'Ürün İsmi...',1),(914,3,1372295029,'Ek Filtreler',1),(915,3,2850335413,'Fiyattan',1),(916,3,454427117,'Fiyata...',1),(917,3,903571526,'Ürün Açıklaması...',1),(918,3,878207540,'Yeni Ürün',1),(919,3,2115538962,'Yeniden ürün siparişleri',1),(920,3,4038453503,'Adet',1),(921,3,2427847608,'Kopya',1),(922,3,1291634369,'Toptan Satış Fiyatları',1),(923,3,912557301,'Müşteri Grup Fiyatları',1),(924,3,4016236161,'Fiyat Satırı Ekle',1),(925,3,1348646173,'Toptan fiyatlarını sıfırlama ',1),(926,3,4218420269,'Bu ürün için varyant toptan fiyatlarını sıfırlamak istediğinize emin misiniz?',1),(927,3,1377088974,'İki Yönlü',1),(928,3,3967730406,'Yönetici Hızlı Link Oluştur',1),(929,3,3395691925,'Link İçerik:',1),(930,3,2990819220,'Link Konum:',1),(931,3,811173354,'Yönetici Hızlı Link Düzenle',1),(932,3,1543674835,'Bu linki silmek istediğinizden emin misiniz?',1),(933,3,322693661,'Yeni Hızlı Link',1),(934,3,4129737893,'Link Konumu',1),(935,3,2046232192,'Yönetici Hızlı Linklerini Süz',1),(936,3,2989896966,'Yeniden resim',1),(937,3,1428629460,'Ürün resimleri',1),(938,3,570540454,'Varyant resimleri',1),(939,3,3979516769,'Genel Ayarlara Git',1),(940,3,1682980639,'Hata:',1),(941,3,3119939844,'Uyarı:',1),(942,3,3280171698,'Rapor',1),(943,3,1128758787,'Görünüm (Zaman Birimi):',1),(944,3,1567988421,'CSV indir',1),(945,3,613877038,'Grafik',1),(946,3,937992258,'Tablo',1),(947,3,1435361928,'Grafik Değeri:',1),(948,3,3482545072,'Üst:',1),(949,3,552652585,'Para Birimi:',1),(950,3,4292548849,'Flash Player güncellenmesine ihtiyacınız var. ',1),(951,3,1918578068,'Kayıtlar:',1),(952,3,1797036103,'Seçilen dönem için veri yok.',1),(953,3,3711407533,'Menü',1),(954,3,1404066370,'Zengin İçerik Sayfası Oluştur',1),(955,3,775396182,'Menüler Ekle:',1),(956,3,3448845971,'Zengin İçerik Sayfası Düzenle',1),(957,3,231048233,'Bu zengin içeri sayfasını silmek istediğinize emin misiniz?',1),(958,3,4027838527,'Yeni Zengin İçerik Sayfası',1),(959,3,1033268948,'Düzen',1),(960,3,3264327005,'Müşteri alanında aç',1),(961,3,4266157535,'Zengin İçerik Sayfalarını Süz',1),(962,3,1611866998,'Bu arama sonuçları için izniniz yok.',1),(963,3,1708902902,'Arama Sonuçları',1),(964,3,3377439838,'Belirtilen ürün alanlarda arama:',1),(965,3,4229313245,'Belirtilen sipariş alanlarında arama:',1),(966,3,1089105628,'Ürün Sonuçları:',1),(967,3,2101845315,'Sorgunuzla eşleşen herhangi bir ürün bulunamadı.',1),(968,3,904043044,'Sipariş Sonuçları:',1),(969,3,1661959455,'Sorguyla eşleşen sipariş yok.',1),(970,3,287223950,'Kullanılan SSL:',1),(971,3,322374794,'SSL etkinleştirmeden önce,<a href=\"%%HTTPS_URL%%login.php\" target=\"_blank\">SSL linkin çalıştığına</a> emin olun.It should successfully open a secure login page.',1),(972,3,591812916,'Parola mağaza modu:',1),(973,3,637222123,'Site Başlığı:',1),(974,3,2078895898,'Siz %%COMPANY_NAME%% ve  %%PAGE_NAME%% kullanabilirsiniz.Otomatik olarak oluşturulacaktır.',1),(975,3,3064612706,'Site Anahtar Kelimeleri:',1),(976,3,2800913026,'Site Açıklaması:',1),(977,3,452323653,'Arama Motoru Dostu URL\'ler:',1),(978,3,1248220876,'Arama Motoru Dostu URL ler için Apache modülü mod_rewrite de çalışması gerekir.<br/>Arama M.D. URL <br/>leri etkinleştirmeden önce <a href=\"../manufacturers.html\" target=\"_blank\">bu linke </a>tıklayın. Eğer link başarıyla açılmazsa, Lütfen hosting sağlayacınızla görüşürünüz.',1),(979,3,234548374,'Arama Motoru Dostu Url\'ler',1),(980,3,1890709483,'Geçerli olacak dil koduyla \"en\" değiştirilmelidir. ',1),(981,3,145668893,'Site Haritası:',1),(982,3,1787636607,'Online Mağazanız site haritasını otomatik olarak oluşturmaktadır.Site haritası sitenizin sayfalaının google,yahoo ve bing gibi arama motorlarında bulunmanızı sağlar.<a target=\"_blank\" href=\"../sitemap.xml\">XML file</a>',1),(983,3,1997999718,'Yeni Gönderim Modülü Oluştur',1),(984,3,1695384782,'Gönderim Modülleri',1),(985,3,1206177630,'Modül Seç:',1),(986,3,1640552363,'Gönderim Modülü Seçenekleri Düzenle',1),(987,3,2460261966,'Gönderim Modülü İsmi:',1),(988,3,1465446556,'Gönderim Modülü Görünüm İsmi:',1),(989,3,2458156334,'Gönderim Alanı:',1),(990,3,3644878690,'Metotlar:',1),(991,3,1509244758,'Metot',1),(992,3,3069853601,'Görünüm İsmi',1),(993,3,2763921508,'Bu gönderim modülünü silmek istediğinize emin misiniz?',1),(994,3,917579977,'Yeni Gönderim Modülü',1),(995,3,1503249872,'Gönderim Alanı',1),(996,3,2414549776,'Gönderim Alanı Oluştur',1),(997,3,1051933231,'Ülke Seç:',1),(998,3,2634450168,'Şehir Seç:',1),(999,3,3390204183,'Gönderim Alanı Düzenle',1),(1000,3,139103139,'Bu gönderim alanını silmek istediğinize emin misiniz?',1),(1001,3,2420183666,'Yeni Gönderim Alanı',1),(1002,3,559872952,'\"%%SKINNAME%%\" şablonunu düzenle',1),(1003,3,900681827,'Şablon Yönetimi',1),(1004,3,3955952330,'Müşteri Alanı',1),(1005,3,1667261560,'Yönetici Alanı',1),(1006,3,2399413882,'Bu sablon otomatik olarak yüklenmedi.Çünkü kullanılan Summer Cart\'da versiyon farkı var.Burayı tıklayarak kurmak için başka şablonlar bulabilirsiniz.',1),(1007,3,2261691191,'Şablon İsmi:',1),(1008,3,2648372470,'Summer Cart Versiyon:',1),(1009,3,2304637720,'Şehir Oluştur',1),(1010,3,3301864581,'Şehir Düzenle',1),(1011,3,509600253,'Bu şehri silmek istediğinize emin misiniz?',1),(1012,3,2461920694,'Şehirleri Yönet',1),(1013,3,3795944341,'Yeni Şehir',1),(1014,3,2630807802,'Ülke',1),(1015,3,2988164914,'Şehirleri Süz',1),(1016,3,1120297998,'Şehir Adı...',1),(1017,3,336266959,'Şehir Kodu...',1),(1018,3,3541575390,'Vergi Sınıflarını Oluştur',1),(1019,3,3592612221,'Vergi Sınıfı Oluştur',1),(1020,3,1875561992,'Vergi Sınıfı Düzenle',1),(1021,3,1641442946,'Yeni Vergi Sınıfı',1),(1022,3,3591424722,'Yukarı',1),(1023,3,3167567621,'Aşağı',1),(1024,3,1323977902,'Vergi Oranları',1),(1025,3,4286733379,'Vergi Oranlarını Güncelle',1),(1026,3,3198370186,'Vergi Bölgeleri Oluştur',1),(1027,3,2805721639,'Vergi Bölgesi Oluştur',1),(1028,3,122382079,'Vergi Bölgelerini Düzenle',1),(1029,3,701011537,'Vergi Bölgesi Düzenle',1),(1030,3,2415154938,'Vergi Bölgeleri',1),(1031,3,4007669337,'Yeni Vergi Bölgesi',1),(1032,3,3578194776,'Vergi Oluştur',1),(1033,3,4144846822,'Vergi İsmi:',1),(1034,3,2564721856,'Kayıt Numarası:',1),(1035,3,2659130368,'Gönderim Uygula:',1),(1036,3,1468898402,'Varsayılanı Uygula:',1),(1037,3,2981161265,'Vergi Düzenle',1),(1038,3,1438361936,'Bu vergiyi silmek istediğinize emin misiniz?',1),(1039,3,1932327382,'Yeni Vergi',1),(1040,3,63310942,'Kayıt Numarası',1),(1041,3,2457820364,'Gönderim Uygula',1),(1042,3,2770220216,'Varsayılanı Uygula',1),(1043,3,3327491243,'Vergi Oranlarını Düzenle',1),(1044,3,3367706607,'Vergileri Süz',1),(1045,3,4136245189,'Yüklemek için resim seçin',1),(1046,3,842812345,'Yükleme...',1),(1047,3,3457770897,'Büyük resimler %%IMAGE_MAX_WIDTH%%x%%IMAGE_MAX_HEIGHT%% px den büyük olunca otomatik küçültülür.',1),(1048,3,3215342,'Son 30 Gün',1),(1049,3,3043440391,'Son 7 Gün',1),(1050,3,3922919155,'Bu Ay',1),(1051,3,1507105497,'Geçen Ay',1),(1052,3,36063916,'Bu Yıl',1),(1053,3,3571073750,'Geçen Yıl',1),(1054,3,1009032439,'Tüm Zamanlar',1),(1055,3,403610525,'Özel Tarih',1),(1056,3,3060721506,'Tüm tarihler öncesi',1),(1057,3,3086509526,'Tüm tarihler sonrası',1),(1058,3,1570709765,'Gün Aralığı',1),(1059,3,2717396598,'Başlangıç Tarihi',1),(1060,3,111718006,'Son tarih',1),(1061,3,2753412866,'Sonraki',1),(1062,3,483403627,'Önceki',1),(1063,3,2954842005,'Tamamlandı',1),(1064,3,4274732151,'Merchant ID:',1),(1065,3,2453922054,'Merchant Key:',1),(1066,3,3676946771,'Eğer arz miktarının hesaplanmasında başarısız arz için Rezerv miktarı kullanılacaktır. <br/> Müşterileriniz rezerv arz miktarı eğer tam miktarı hesaplanamaz ödeyecek. <br/> Değilseniz rezerv miktarı ve kesin teslimat yapmak tutarı bu adresin teslim sipariş edebilirsiniz bildirilecektir müşteri hesaplamak olamaz. <br/>',1),(1067,3,1672584572,'Kullanılacak alternatif gönderim bedeli:',1),(1068,3,1083706231,'Yedekleme Gönderim Bedeli:',1),(1069,3,2330328948,'Bu seçeneği kontrol edin eğer gönderim yapmayacaksınız.',1),(1070,3,3372155483,'Disallow US Post-Office Box:',1),(1071,3,2052058202,'Satıcı Hesabı Parabirimi:',1),(1072,3,2489100572,'Modu:',1),(1073,3,147726518,'Hızlı kurulum yönergeleri',1),(1074,3,1017425442,'Lütfen,Google Checkout hesabınıza girin ve entegrasyon menüsünden ayarlar sekmesini tıklayın.',1),(1075,3,144205977,'1. \"My company will only post digitally signed carts.\". BU KUTUYU İŞARETLEYİN',1),(1076,3,3022219378,'2. Set \"API callback URL:\" to \"%%HTTPS%%modules/checkout/google/notify.php?gkey=[Merchant_Key]&amp;gid=[Merchant_ID]\". [Merchant_Key] VE [Merchant_ID] GERÇEK DEĞERLERİ GİRİN. ',1),(1077,3,1228526745,'3.\"Callback method\" XML OLARAK AYARLAYIN.',1),(1078,3,401607006,'\"Advanced settings\" olarak buradan seçin:',1),(1079,3,2549034529,'1. Provide the first name, last name and full name of the buyer and order recipient in separate fields in the new order notification.',1),(1080,3,3348692449,'2. Return the buyer\'s ship-to phone number in the new order notification.',1),(1081,3,3645134935,'3. Return the buyer\'s billing phone number in the new order notification.',1),(1082,3,412387362,'While logged into your Google Checkout account you can check for integration errors from the Tools tab, Integration Console menu.',1),(1083,3,1554049617,'Genel Seçenekler',1),(1084,3,835196441,'Hesabınıza giriş e-postası veya Güvenli Mağaza Hesap ID.',1),(1085,3,1019086286,'Hesap:',1),(1086,3,554271247,'Ödeme İşlemi:',1),(1087,3,3611595129,'Müşteri Notu İzin Ver:',1),(1088,3,3000703641,'Onaylandı Nakliye Adresi Gerekiyor:',1),(1089,3,1520063823,'PayPal Açılış Sayfası:',1),(1090,3,1645277103,'Sayfa Kullanım Onayı:',1),(1091,3,1368278113,'Summer Cart onaylama sayfası doğru vergi ve nakliye hesaplamasını sağlar.',1),(1092,3,2771442886,'Ödeme Buton Tipi:',1),(1093,3,2848467461,'API Erişimi',1),(1094,3,2578337366,'API Erişim izni bir çok eylemin,Summer Cart sipariş yönetim ekranında gerçekleştirilmesine olanak sağlar.API Erişim izni vermek için:',1),(1095,3,2942559741,'Hesabınıza Giriş <a href=\"https://www.paypal.com/\" target=\"_blank\">https://www.paypal.com/</a>',1),(1096,3,927331701,'\"Hesabım\" sekmesi altındaki,alt sekmelerden \"Profil\" i seçin',1),(1097,3,3877642009,'\"Hesap Bilgileri\" sütunu altında \"API Erişim\" bağlantısını tıklayın',1),(1098,3,2847613079,' \"İstek API Sertifikaları\" bağlantısını tıklayın',1),(1099,3,1389165952,'\"API imza isteği\" seçiniz ve \"Kabul ve Gönder\" e tıklayın',1),(1100,3,4065605080,'PayPal \"API hesap adı\",\"API Parola\"ve\"imza\" nızı görüntüleyecek.Lütfen aşağıdaki boşluklara bunları girin.',1),(1101,3,1731671543,'Tıkla \"Bitti\"',1),(1102,3,253979313,'API Username:',1),(1103,3,926299189,'API Password:',1),(1104,3,2524839449,'API Signature:',1),(1105,3,2363892471,'If checked the customer will confirm the order on PayPal.',1),(1106,3,2923539806,'Varsayılan Para Birimi',1),(1107,3,2153718755,'Müşterinin tercih ettiği para birimini PayPal desteklemiyorsa varsayılan para birimi kullanılacaktır.',1),(1108,3,147299665,'Varsayılan para birimi,<a href=\"currencies.php\">para birimleri yönetiminin içinde olmalıdır.</a>',1),(1109,3,2557676385,'Varsayılan Para Birimi:',1),(1110,3,515095047,'Misafir ödeme kabulü',1),(1111,3,402334869,'Kullanıcı ödeme sırasında özel istekte bulunabilir',1),(1112,3,3811724674,'Kullanıcı sözleşmesi ve şartlarını kabul etmeniz gerekiyor',1),(1113,3,1299144461,'Şartlar ve Kullanım Kuralları:',1),(1114,3,3244184526,'Haber Oluştur',1),(1115,3,837680854,'Haber Ekle',1),(1116,3,1706368814,'Tarih:',1),(1117,3,4115954736,'Haberleri Düzenle',1),(1118,3,4260919213,'Bu haberi silmek istediğinize emin misiniz?',1),(1119,3,684042718,'Haberleri Süz',1),(1120,3,1521578592,'Haberler Başlığı...',1),(1121,3,1705759856,'Müşteri kapıda ödeme seçeneğini tercih ettiğinde,bu fiyatlar geçerli olacaktır:',1),(1122,3,3011918322,'CoD Gönderim modulü kullaılırsa ücretsizdir.',1),(1123,3,4071801088,'Sabit Tutar:',1),(1124,3,1584702284,'Orantılı Ücret:',1),(1125,3,32364822,'Demo Modu:',1),(1126,3,2025693602,'To set up the secret word, login to your 2CO Account and look under the \"Look&Feel\" section.',1),(1127,3,166627762,'The secret word is used to sign the transaction data that Summer Cart receives from 2Checkout.',1),(1128,3,4243974355,'Gizli Kelime',1),(1129,3,187187385,'Gizli Kelime:',1),(1130,3,1836520064,'Please remember to login to your 2CO Account and set both \"Approved URL\" and \"Pending URL\" under the \"Look &amp; Feel\" section to',1),(1131,3,3313317985,'Doğrudan Dönüş \"Hayır\" Ayarlanmalıdır.',1),(1132,3,2455784416,'Atos Worldwide E - Transactions - İnternet ödeme güvenliği',1),(1133,3,2759416782,'Bir ödeme yöntemi seç',1),(1134,3,2510548134,'Varsayılan Dil:',1),(1135,3,2838166432,'Banka dosyaları alacaksanız,lütfen modules/payment/atos/executables/ dosyalarının talep ve yanıt dosyalarının çalıştırılabilir olduğundan emin olunuz.',1),(1136,3,1252629769,'API Login ID:',1),(1137,3,2504138788,'Transaction Key:',1),(1138,3,1332928208,'MD5 Hash:',1),(1139,3,30186195,'Timezone Offset:',1),(1140,3,2317008269,'saatler',1),(1141,3,1677552814,'Keys are already generated. This operation will delete current keys and the module will not work until new certificates are entered.',1),(1142,3,1499286651,'Key is already generated. Please confirm generation of new key.',1),(1143,3,3787401028,'Borica payment module setup wizard',1),(1144,3,3391458734,'Data to be used in the certificate',1),(1145,3,929483243,'Şehir:',1),(1146,3,3619342144,'İlçe:',1),(1147,3,247743386,'Organizasyon Birimi:',1),(1148,3,2563698514,'Bilinen İsim:',1),(1149,3,3253870329,'Sihirbaz tuşları oluşturma',1),(1150,3,487826370,'Adım 1:',1),(1151,3,3578621044,'Ödeme Geçidi için,özel anahtar,özel test anahtarı ve CSR\'leri oluşturun.',1),(1152,3,40894957,'Oluştur',1),(1153,3,910094337,'Adım 2:',1),(1154,3,3851170156,'Özel anahtar ve CSR için eTLog oluşturun.',1),(1155,3,4053559235,'Download <strong>live</strong> payment gateway CSR (<a href=\"?ModuleName=com.summercart.payment.borica.gate&amp;action=acDownloadApgwCSR\">download</a>), <strong>test</strong> payment gateway CSR (<a href=\"?ModuleName=com.summercart.payment.borica.gate&amp;action=acDownloadApgwTestCSR\">download</a>) and eTLog CSR (<a href=\"?ModuleName=com.summercart.payment.borica.gate&amp;action=acDownloadEtlogCSR\">download</a>) files and send them to your bank.',1),(1156,3,1801018908,'3 Banka sertifikasını size geri gödereceğiz.eTLog için - Canlı ödeme geçidi,test ödeme geçidi ',1),(1157,3,3174182879,'Önceki sayfada listelenecek bankanız için,dönüş URL si gönderin',1),(1158,3,791003456,'Adım 3:',1),(1159,3,172391364,'Set the 8-digit Terminal ID (TID) that you have received from your bank in the previous screen.',1),(1160,3,1617188743,'Adım 4:',1),(1161,3,2727466293,'Put the eTLog certificate contents in the field below and get the .p12 file.',1),(1162,3,3878699623,'Serifila \"-----BEGIN CERTIFICATE-----\" ile başlar.',1),(1163,3,3003313697,'Get .p12 file',1),(1164,3,3471349272,'Import the .p12 file into your browser.',1),(1165,3,1196369362,'Borica modulüne geri dön',1),(1166,3,3425203614,'Terminal ID (TID):',1),(1167,3,3978171891,'Bankanız tarafından verilen 8 haneli kod.',1),(1168,3,442304913,'Sipariş Açıklaması:',1),(1169,3,2254540171,'Lütfen,sipariş için açıklama satırı girin.',1),(1170,3,728497053,'Döviz Hesabı:',1),(1171,3,1580903947,'Private Key for Live APGW:',1),(1172,3,4044169584,'Özel anahtar \"-----BEGIN RSA PRIVATE KEY-----\" ile başlar',1),(1173,3,87950621,'Private Key for Test APGW:',1),(1174,3,1034705443,'Gerçek APGW Sertifika:',1),(1175,3,1722347829,'Test APGW Sertifika:',1),(1176,3,1556796273,'Konfigirasyon Adımları:',1),(1177,3,1451649640,'Use the \"<a href=\"module.php?ModuleName=com.summercart.payment.borica.gate&amp;action=acBoricaSetupWizard\">Borica payment module setup wizard</a>\".',1),(1178,3,3028765641,'Dönüş URL:',1),(1179,3,2288359418,'Reversal',1),(1180,3,914933220,'Toplam Sipariş Tutarı:',1),(1181,3,1794229843,'Geri Ödeme Tutarı:',1),(1182,3,2310413392,'Alıcı ID:',1),(1183,3,1706633060,'Aktivasyon Anahtarı:',1),(1184,3,2522822593,'Yöntem:',1),(1185,3,1614476677,'Kabul Edilen Çek Tipleri:',1),(1186,3,2281461740,'Ürün ID:',1),(1187,3,1739691339,'Ürün Para Birimi:',1),(1188,3,2751553006,'Maximum Tutar:',1),(1189,3,3064029683,'Müşteri,ödeme metodunu \"Teslimatta Ödeme\" olarak seçerse, lütfen toplam modül sayfasındaki \"Teslimatta Ödeme\" seçeneğini etkinleştirmeyi unutmayın.Ödeme seçenekleri toplam modülden ayarlanır.',1),(1190,3,3060458674,'DSK Bankası tarafından sağlanacaktır.',1),(1191,3,1268699863,'Para Birimi Kodu:',1),(1192,3,372582953,'MD5 Parola',1),(1193,3,1454021497,'MD5 Parola:',1),(1194,3,1155475729,'MD5 şifre gereklidir.Summer Cart gönderileri ve DSK doğrudan aldıklarını veri imzalamak için kullanır.',1),(1195,3,4233366650,'ÖNEMLİ DUYURU',1),(1196,3,1780295817,'Eğer geçerli SSL sertifikanız yoksa,müşterileriniz ödeme işlemlerinin sonunda,tarayıcılarında uyarı göreceklerdir. ',1),(1197,3,3901631899,'Eğer müşteri iptali tıklarsa,mağazanın ödeme bildirimlerinden haberdar olmayacaktır.',1),(1198,3,2461502548,'Müşteri Numarası:',1),(1199,3,2223644698,'Gizli Anahtar',1),(1200,3,2646160959,'Ödeme Talebi<br />Son Kullanma Tarihi:',1),(1201,3,1847368024,'Ödeme talimatı:',1),(1202,3,3287268887,'Tüccar numarası:',1),(1203,3,1571859967,'Tüccar ismi:',1),(1204,3,173849435,'Tüccar parola:',1),(1205,3,40686185,'Sipariş açıklaması:',1),(1206,3,887383748,'Vitrin Kimliği:',1),(1207,3,4252987528,'13 karakter UK12345678CUR şeklinde dizilir',1),(1208,3,3793027758,'İşlem Türü:',1),(1209,3,2443707600,'Gizli Paylaşım',1),(1210,3,2454473967,'Gizli Paylaşım',1),(1211,3,4044273798,'HSBC den 32 karakterli gizli paylaşım kodunuzu alacaksınız.',1),(1212,3,444762562,'Varsayılan Para birimi:',1),(1213,3,3199946140,'Eğer kullanıcı başka bir para birimi seçmezse USD veya CAD \'dan birini kullanır',1),(1214,3,274243051,'Ödeme notu:',1),(1215,3,31088455,'Seçenekleri CAD',1),(1216,3,2952545973,'Barındırılan ödeme sayfası id:',1),(1217,3,3744805632,'Barındırılan ödeme sayfası anahtarı:',1),(1218,3,1636167766,'Seçenekleri USD',1),(1219,3,2527265290,'Moneris Merchant Hosted için konfigirasyon ekle',1),(1220,3,630578004,'Yanıt yöntemi GET veya POST ve yanıt yöntemi için bir URL girin:',1),(1221,3,3137146140,'Güvenlik Özelliklerini etkinleştimek için <strong>\"İşlem Doğrulama \"</strong> kutusunu işaretleyin.',1),(1222,3,3150990615,'<strong>\"Sunucumda XML görüntüle\"</strong> \"Tepki yönetimi\" bölümünde seçiminiz.',1),(1223,3,2158506343,'<strong>\"Yanıt URL\"</strong> alanı boş bırakın.',1),(1224,3,2202504530,'Ticari E-Ödeme:',1),(1225,3,3975230462,'Alıcı Tanımlama:',1),(1226,3,2822597311,'URL Logosu:',1),(1227,3,2639952004,'URL Logosu https:// ile başlamalıdır.Ödeme sayfasında görüntülenir.',1),(1228,3,3283790610,'Login\'i sakla:',1),(1229,3,4038141604,'Eğer Moneybookers işaretli ise müşterinin mevcut Moneybookers hesabına giriş yapmasına izin vermez. ',1),(1230,3,28162475,'Iframe (sayfa içinde sayfa açma) kullanın:',1),(1231,3,2831228941,'Ticari site içerisindeki yerleşik ödeme formu işaretli olduğunda kullanıcı, ödemeyi tamamlamak için Moneybookers sitesine yönlendirilir.',1),(1232,3,1008152630,'Onay ekranı',1),(1233,3,2431019173,'Onay ekranında Görüntülenir (sürecin son adımı)',1),(1234,3,910248752,'Onay notu:',1),(1235,3,3787582312,'Satır sonları için;&lt;br&gt kullanabilirsiniz.',1),(1236,3,3195721565,'URL Metnine Geri Dön:',1),(1237,3,1977604747,'Kullanıcı ödemesini tamamladığında stoğa geri dönmek için metin düğmesini kullanın.',1),(1238,3,2999123729,'Moneybookers mevcut müşteri para birimini desteklemiyorsa,varsayılan para birimi kullanılır.',1),(1239,3,1600929358,'Anahtar kelime ayarları için, Moneybookers hesabınıza giriş yapın ve \"Ticari Araçlar\" bölümünün altına bakın.',1),(1240,3,1503288321,'Anahtar kelime,Summercart\'ın Moneybookers\'dan aldığı işlem girdisini işaretlemekte kullanılır.',1),(1241,3,3635999792,'PSPID,Ogone hesap sayfanızın sol kenarında bulunabilir.',1),(1242,3,614528529,'PSPID:',1),(1243,3,2741808256,'Ödeme sayfası başlığı:',1),(1244,3,737850223,'SHA-1-IN signature from your Ogone account (found in \"Technical information\" -> \"Data and origin verification\" -> \"SHA-1-IN Signature\")',1),(1245,3,390345667,'SHA-1-IN:',1),(1246,3,546023244,'SHA-1-OUT signature from your Ogone account (found in \"Technical information\" -> \"Transaction feedback\" -> \"SHA-1-OUT Signature\")',1),(1247,3,3625104482,'SHA-1-OUT:',1),(1248,3,1411657282,'Etkin Para Birimleri:',1),(1249,3,1213247299,'Önemli',1),(1250,3,2279891751,'\"Geri bildirim parametrelerini Yönlendirme URL\'leri almak istiyorum\"seçeneği izni sağlar.Ogone hesabınızda \"Configuration\"-> giderek \"Technical Information\"ekranında \"Transaction Feedback\"sekmesinde bulabilirsiniz.',1),(1251,3,1145282425,'Alındı',1),(1252,3,1073846020,'Önceden alıkonulan miktar:',1),(1253,3,55238551,'Alıkonulan miktar:',1),(1254,3,2927438680,'Kesinleştirme:',1),(1255,3,3190779602,'Daha fazla alıkoyma işlemleri olacak',1),(1256,3,3769638272,'Nihai alıkoyma',1),(1257,3,1229371311,'Not (isteğe bağlı):',1),(1258,3,205308943,'Satıcı No (ID):',1),(1259,3,429771270,'Ortak:',1),(1260,3,3661788121,'Kullanıcı:',1),(1261,3,178066530,'Herhangi bir kullanıcı oluşturmadıysanız, buraya Satıcı ID (No) girin.',1),(1262,3,3029983581,'Yetkili Alıcı Kimlik Doğrulama:',1),(1263,3,1359090026,'3D güvenlik kontrolü (\"Visa onayı\"ve GüvenlikKodu\") ile sağlanır.',1),(1264,3,2360048237,'Yetkilendirme',1),(1265,3,2303808259,'Yetkilendirme miktarı:',1),(1266,3,1551896942,'Geri Ödeme',1),(1267,3,1145322128,'Çekilen miktar:',1),(1268,3,2162064995,'Para İade İşlemi:',1),(1269,3,1078819742,'Tam',1),(1270,3,1706748264,'Kısmi',1),(1271,3,864998091,'Lütfen açıklama satırına siparişi girin.Eğer boş bırakılırsa müşteriler satın alma sırasında açıklama girebilir.',1),(1272,3,2974419541,'Ödeme Bilgi Transferi (PDT)',1),(1273,3,1828463134,'lLütfen PDT etkinleştirin.',1),(1274,3,3741902324,' \"Satış Tercihleri\"sütunu altındaki \" Web Ödeme Tercihler\" bağlantısını tıklayın',1),(1275,3,3902299500,'İzin \"Otomatik-Dön\" (geri dönüş linkini kopyalıp yapıştırın)',1),(1276,3,1874574508,'Enable \"Payment Data Transfer\"',1),(1277,3,1193147294,'Tıkla \"Kaydet\"',1),(1278,3,3825642984,'PayPal size PDT kimlik simgesi gösterir. Aşağıdaki alana giriniz.',1),(1279,3,1104199793,'PDT Kimlik Simgesi:',1),(1280,3,4230348253,'Lisan Kodlaması',1),(1281,3,3935609386,'Varsayılan PayPal Windows bildirimler-1252 kodlaması ile gönderilir,Batı karakteri olmayan karakterleri bozulmuş olarak gönderebilir.',1),(1282,3,1916601122,'UTF-8 bildirimler gönderebilmek için PayPal\'den.Burada Nasıl Olduğunu Görün:',1),(1283,3,1853139557,'\"Satış Tercihleri\" sütunu altındaki \"Dil Kodlaması\" bağlantısını tıklayın',1),(1284,3,1699103402,'\"Daha fazla seçenekler\" butonunu seçin',1),(1285,3,1143435416,'Menü seçeneğini UTF-8 aşağı açılan kullanma ve seçme \"Evet\" IPN bu tercihi kullanmak içinAşağı açılan menüyü UTF-8 seç ve bu tercihler ile IPN de \"Yes\" i seç ',1),(1286,3,4271664381,'Tıkla \"Kaydet\"',1),(1287,3,1371444183,'Kurulum ID:',1),(1288,3,3981919405,'Auth modu:',1),(1289,3,3623864170,'Lütfen &quot;Pre Auth&quot dikkatle not edin; talep etmek için Worldpay desteğine gerek duyabilirsiniz.',1),(1290,3,3767901768,'Kişiler yönetimine izin ver:',1),(1291,3,4075630300,'RBS Worldpay sitesinde müşteriler kendi isim ve adreslerini düzenleyebilir.',1),(1292,3,3435607478,'RBS Wordpay Müşterinin mevcut para birimini desteklemiyorsa varsayılan para birimi kullanılır.',1),(1293,3,3435195543,'İşlemler için gizli MD5<br />(en fazla 16 karakter)',1),(1294,3,1099005614,'Summercart\'ın RBS Wordpay\'e gönderdiği İşlem verilerini işaretlemede anahtar kelime kullanılır.',1),(1295,3,1785134662,'Ödeme Yanıt Şifresi:',1),(1296,3,2128563735,'RBS Wordpay\'den gelen yanıtı doğrulamak için kullanılır.',1),(1297,3,1756952934,'RBS Worldpay hesabınıza giriş yapın ve \"Yüklemeler\" menüsüne bakın.',1),(1298,3,841163493,'Yapılandırmak istediğiniz \"Kurulum\"\'u seçin',1),(1299,3,990984551,'\"URL Ödeme Yanıt Sistemini\" \"%%HTTPS%% modüller/ödeme/rbsworldpay/yanıtla.php\" dan ayarlayın.',1),(1300,3,1938529821,'\"Ödeme yanıtlama etkin mi?\" onay kutusunu işaretleyin.',1),(1301,3,118523628,'\"Müşteri yanıtlama etkin\" onay kutucuğunu işaretleyin',1),(1302,3,4057498740,'\"Ödeme Yanıt Şifresi\" belirleyin.Yukarıdan giriş yapmayı unutmayın.',1),(1303,3,2130128007,'\"İşlemler için MD5 kodu\" belirleyin.Yukarıdan giriş yapmayı unutmayın.',1),(1304,3,193969084,'Gizli:',1),(1305,3,2399392064,'Hesap (opsiyonel):',1),(1306,3,2661746016,'Otomatik yakalama:',1),(1307,3,4089531088,'Referans URL:',1),(1308,3,2409134777,'Satıcı (Bayi):',1),(1309,3,1253391832,'Müşterinin mevcut para birimini Sage Pay ödeme sistemi desteklemiyorsa,varsayılan para birimi kullanılır.',1),(1310,3,3157569171,'Parola Şifreleme:',1),(1311,3,1001769353,'Sage Pay\'den gelen e-postalar',1),(1312,3,2769525101,'Satıcı e-posta(isteğe bağlı):',1),(1313,3,2774351315,'İşlem bilgisi almak için Satıcı e-posta adresi kullanılır.Birden fazla e-posta adresi olduğunda aralarına \":\" (iki nokta üst üste) konarak ayrı ayrı girilebilir.',1),(1314,3,199766793,'Bilgi İşlem ile e-posta gönder:',1),(1315,3,926829729,'Müşteriye mesaj gönder (isteğe bağlı):',1),(1316,3,1242364881,'Eğer sağlıyorsa,müşteri onay e-postalarının en üstüne eklenir.',1),(1317,3,2683762813,'9-basamak',1),(1318,3,624437297,'Canlı mod için Kişisel Anahtar:',1),(1319,3,2117894951,'Test modu için Kişisel Anahtar:',1),(1320,3,1223025197,'Canlı mod için Transcard Sertifikası:',1),(1321,3,333531451,'Test modu için Transcard Sertifikası:',1),(1322,3,515708534,'Banka düzenle %%BANKNAME%%',1),(1323,3,2429941028,'Banka düzenle',1),(1324,3,1651168334,'Mağaza ID:',1),(1325,3,434599511,'Aktif:',1),(1326,3,44303849,'Mağaza Anahtarı',1),(1327,3,3453667558,'Mağaza Anahtarı:',1),(1328,3,1466148554,'Mağaza anahtarı gereklidir.Veriler Summer Cart ile bankanıza gönderilir ve alınan bilgiler veri imzalamak için kullanılır.',1),(1329,3,1132470983,'Taksitler:',1),(1330,3,1278578948,'Müşterilerinize taksitli ödeme seçeneği sunabilirsiniz.Lütfen taksit sayısını ve faiz oranlarını ayarlayınız.',1),(1331,3,3869367668,'Taksit',1),(1332,3,649126636,'Faiz oranı (%)',1),(1333,3,69889613,'Varsayılan Banka:',1),(1334,3,3695363791,'Müşteri ödemeyi \"başka bir bankadan kartla ödemeyi\" seçse  de varsayılan banka kullanılacaktır. ',1),(1335,3,1791432850,'Bankalar',1),(1336,3,1153185069,'Logo',1),(1337,3,1633730451,'Terminal Aliases:',1),(1338,3,2554014956,'Upload resource.cgn file provided by UBB:',1),(1339,3,3108494789,'Use the \"<a href=\"module.php?ModuleName=com.summercart.payment.ubb_bg.hostedpage&action=acUbbBgSetupWizard\">UBB payment module setup wizard</a>\".',1),(1340,3,2147088633,'UBB.bg payment module setup wizard',1),(1341,3,2731437692,'resource.cgn dosyasını yükleyin',1),(1342,3,2377979207,'Return to UBB.bg module',1),(1343,3,2255685458,'Banka bilgi ve gönderim talimatları:',1),(1344,3,3948245510,'Perakendeci ID:',1),(1345,3,2382770493,'Posta Kodu:',1),(1346,3,2828876885,'Optional. In this field, you can supply the Postal Code of your warehouse. <strong>Must be Canadian</strong>.',1),(1347,3,494733389,'Geri dönüş süresi:',1),(1348,3,3169761664,'Opsiyonel.Bu boşlukta,Sipariş alınan zaman ile göndermeye hazırlanan zaman arasını belirleyebilirsiniz.',1),(1349,3,2361988811,'e-Econt kullanıcı adı:',1),(1350,3,3034335311,'e-Econt parola:',1),(1351,3,2848807441,'e-Econt',1),(1352,3,3849822505,'e-Econt giriş',1),(1353,3,2970828923,'İletişim Bilgileri',1),(1354,3,4090029808,'Firma ismi:',1),(1355,3,3007368028,'Kişi adı:',1),(1356,3,3270727197,'Adres',1),(1357,3,2025602183,'Cadde:',1),(1358,3,1402040132,'Sokak:',1),(1359,3,87389314,'Alıcıdan:',1),(1360,3,1915995396,'Teslim edildi:',1),(1361,3,2234420808,'Belirlenen minumum  tutar (opsiyonel):',1),(1362,3,3907473293,'Eğer ayarlarsanız,daha düşük gönderi değerleri başka beyana gerek duymaz.',1),(1363,3,4108804899,'CD anlaşma numarası (opsiyonel):',1),(1364,3,4061175651,'Please contact Econt to obtain collect on delivery agreement number.',1),(1365,3,3184466366,'Alıcı numarası (opsiyonel):',1),(1366,3,431111556,'Lütfen,FedEx hesap numaranızı giriniz.Kişisel sayaç numaranız otomatik olarak elde edilir.',1),(1367,3,830283296,'Sayaç Numarası:',1),(1368,3,1115236530,'Teslim yeri',1),(1369,3,3657543221,'İrtibat Detayları',1),(1370,3,1921115224,'Kişi Adı:',1),(1371,3,2670906935,'Departmanı:',1),(1372,3,1124291200,'Tek haneli rakamlar',1),(1373,3,4131668273,'Çağrı Numarası:',1),(1374,3,3968392638,'Şehir:',1),(1375,3,3313956470,'Ülke Kodu:',1),(1376,3,3751130500,'Misc',1),(1377,3,610088699,'Sigorta:',1),(1378,3,2475299491,'Gönderiler sipariş alt toplam miktarından sigortalanır.',1),(1379,3,1763209963,'Ambalaj Ağırlığı:',1),(1380,3,1472220333,'Bu ağırlık, malların ağırlığına eklenir.',1),(1381,3,1457601935,'Gönderim Ücreti:',1),(1382,3,3236430179,'Alıcı',1),(1383,3,3309533356,'Test hesap bilgisi',1),(1384,3,2288290833,'Hesap Bilgisi',1),(1385,3,4186509951,'Ek seçenekler',1),(1386,3,1484115338,'Kırılgan eşya:',1),(1387,3,3859110517,'Sigorta Ekle:',1),(1388,3,3096612495,'Dökümanlar:',1),(1389,3,3513682807,'KDV Dahil:',1),(1390,3,1988450491,'Kullanım Tipi:',1),(1391,3,3669659083,'Kullanım miktarı:',1),(1392,3,202443566,'Başlatma',1),(1393,3,1894811959,'Yerler:',1),(1394,3,213284011,'Hızlı gelen yerler alımı',1),(1395,3,1993580989,'Lokasyonları import etmek biraz zaman alacaktır.Lütfen bekleyiniz.',1),(1396,3,1968273914,'Formda değişiklikler yaptınız.Eğer devam ederseniz kaybedebilirsiniz.Devam etmek istiyor musunuz?',1),(1397,3,382735039,'Şehirleri yüklemek biraz zaman alacaktır.Devam etmek istiyor musunuz?',1),(1398,3,2564620584,'Yükleniyor',1),(1399,3,1117520404,'Parti sayısı:',1),(1400,3,3857914122,'Alıcı zamanı:',1),(1401,3,98663625,'Demet fişi yazdır',1),(1402,3,2718602126,'Demet fişini sil',1),(1403,3,387154378,'Nakliye etiketi yalnızca mağaza database\'i içinde silinecektir ve bu sipariş için yeni fiş oluşturulmasını sağlayaaktır.',1),(1404,3,488747049,'You should also cancel it through Speedy\'s WebClients interface or by calling Speedy\'s customer service.',1),(1405,3,53144288,'Etiket bas',1),(1406,3,957135579,'Bu paket slipini silmeye emin misiniz?',1),(1407,3,1799531275,'Yukarıya Ağırlık/Alt toplam/Adet ',1),(1408,3,3088333762,'Maliyet',1),(1409,3,860927180,'Lütfen UPS kullanıcı Id\'nizi, Parola ve XML Erişim Numaralarınızı Giriniz:',1),(1410,3,3699446743,'Kullanıcı ID:',1),(1411,3,3165438484,'XML Erişim Numarası:',1),(1412,3,2402760031,'Sunucu:',1),(1413,3,3598087712,'Alıcı Türü:',1),(1414,3,1275046918,'Ambalaj Türü:',1),(1415,3,1095994250,'Müşteri Sınıflandırma',1),(1416,3,2862999173,'UPS hesabınızı nasıl sınıflandıracağınızı seçiniz.',1),(1417,3,806419272,'Lütfen USPS kullanıcı ID giriniz:',1),(1418,3,2386614917,'Sipariş Fişi',1),(1419,3,1625579401,'#%%ORDERID%% siparişi için demet fişi',1),(1420,3,2571559162,'En son girilen siparişleri dikkate alın.',1),(1421,3,1658504578,'En çok satanlar sayısını görüntüleyin.',1),(1422,3,760001896,'Listele',1),(1423,3,3278654271,'Görüntüle',1),(1424,3,2488687378,'tedarikçiler',1),(1425,3,1896218232,'Yeni ürün sayısını görüntüle',1),(1426,3,234900711,'Gönderim Adresi Fatura Adresi ile Aynı',1),(1427,3,858079896,'Öğe Ekle',1),(1428,3,1347538713,'Ürünü Kaldır',1),(1429,3,2492926120,'Ürün Seçenekleri:',1),(1430,3,3909844064,'Liste Fiyatı:',1),(1431,3,3966210395,'Fiyatı:',1),(1432,3,1444368431,'Sepete Ekle',1),(1433,3,2685524125,'Stokda Kalmadı',1),(1434,3,1158486406,'Ürün Ekle',1),(1435,3,3567521997,'Ürün Adı:',1),(1436,3,2020104747,'Süz',1),(1437,3,917550841,'Alt kategoriler dahil edilsin',1),(1438,3,1437113292,'Toplam',1),(1439,3,2408483464,'Durdur',1),(1440,3,213186513,'Eğer konu alanını doldurursanız bu dilde bülten gönderebilirsiniz.',1),(1441,3,666948076,'Bülteni Durdur',1),(1442,3,1565721205,'Konu:',1),(1443,3,762611188,'Mesaj:',1),(1444,3,2676347204,'Müşterilere Gönder:',1),(1445,3,2633172727,'Abonelere Gönder:',1),(1446,3,4061451667,'Gelişmeyi durdur',1),(1447,3,426031496,'Duraklat',1),(1448,3,1124418244,'Yeni işleme başla',1),(1449,3,2755086305,'Durdurma başarıyla tamamlandı.',1),(1450,3,2265563646,'Yeni bir işlem başlatmaya emin misiniz?',1),(1451,3,2955059868,'Durdurmaya emin misiniz?',1),(1452,3,3129553589,'Bülten İstatistikleri',1),(1453,3,3147226886,'Faaliyet İstatistiği',1),(1454,3,1485082975,'Blast Gör',1),(1455,3,3614080499,'Bülten Aboneliği:',1),(1456,3,2746901891,'Aboneliği yönetime bildir',1),(1457,3,1642897459,'Bülten Oluştur',1),(1458,3,3168659782,'Bülten Ekle',1),(1459,3,1094372775,'Bülten Düzenle',1),(1460,3,3859046914,'Bu bülteni silmek istediğinizden emin misiniz?',1),(1461,3,2840697211,'Aboneler',1),(1462,3,2018365746,'Test',1),(1463,3,2525382830,'İstatistikler',1),(1464,3,1590625456,'Görüntüle',1),(1465,3,254338594,'Test edildi',1),(1466,3,747041944,'İlk deneme',1),(1467,3,714700702,'Bülten ismi...',1),(1468,3,2060057791,'Bültenleri Süz',1),(1469,3,2453435967,'Göster',1),(1470,3,879953894,'Konu',1),(1471,3,1475250567,'E-posta Gönder',1),(1472,3,3918409999,'Açılan e-postalar',1),(1473,3,1493021949,'Tıklanan e-postalar',1),(1474,3,2679662937,'Ayrıntılı İstatistikler',1),(1475,3,3504695945,'Ayrıntılı İstatistikler',1),(1476,3,2571484763,'Blast Gör',1),(1477,3,621797607,'Abone Ekle',1),(1478,3,3547385618,'Aboneler:',1),(1479,3,1079513077,'Abone e-postaları virgül ve/veya çizgiyle ayrılır.',1),(1480,3,3310826759,'Ekle',1),(1481,3,2461995782,'Abone Düzenle',1),(1482,3,1191605410,'Bu aboneyi silmek istediğinize emin misiniz?',1),(1483,3,3687574047,'Aboneleri Süz',1),(1484,3,2952046730,'Deneme Bülteni',1),(1485,3,1587199635,'E-postalar:',1),(1486,3,3858340892,'Deneme gönder',1),(1487,3,2779812973,'Ürünler Bildirim Seçenekleri',1),(1488,3,2663971073,'Zorunlu Anahtar:',1),(1489,3,616075044,'Secret key:',1),(1490,3,506785837,'Generate link',1),(1491,3,3482811661,'Değerlendirmeler ve Yorumlar',1),(1492,3,1743133016,'Değerlendirmeleri ve Yorumları Düzenle',1),(1493,3,4019184820,'IP Adresi:',1),(1494,3,4020385206,'Müşteri:',1),(1495,3,3323015556,'İçerik değerlendirmesi:',1),(1496,3,235652961,'Değerlendirme:',1),(1497,3,643703905,'Bu değerlendirmeyi silmek istediğinize emin misiniz?',1),(1498,3,3743752980,'Değerlendirme',1),(1499,3,2129626352,'Yorum',1),(1500,3,244298452,'Değerlendirmeleri Süz',1),(1501,3,4190646508,'İnceleme Metni...',1),(1502,3,2867445730,'IP Adres...',1),(1503,3,17514069,'Değerlendirmeler',1),(1504,3,1132259710,'Powered by',1),(1505,3,908066045,'Hoşgeldiniz %%CUSTOMERFIRSTNAME%% %%CUSTOMERLASTNAME%%!',1),(1506,3,312708084,'Çıkış',1),(1507,3,1808393236,'Giriş',1),(1508,3,2794398274,'Üye Ol',1),(1509,3,1323996051,'Profil',1),(1510,3,3980130229,'Adresler',1),(1511,3,3432436168,'Adres Ekle',1),(1512,3,3673263359,'Adres Düzenle',1),(1513,3,86938300,'Bu adresi silmek istediğinize emin misiniz?',1),(1514,3,749705681,'Varsayılan Fatura Adresi',1),(1515,3,3926602309,'Varsayılan Gönderim Adresi',1),(1516,3,480959536,'Demetlenmiş Öğeler:',1),(1517,3,2891456104,'Sepete Bak',1),(1518,3,961073464,'Alışverişe Devam Et',1),(1519,3,3421549997,'İndirim Kuponu Uygula',1),(1520,3,1821239519,'Kuponu Kaldır',1),(1521,3,3850054737,'Sepeti Boşalt',1),(1522,3,782637220,'  %%CATEGORYPRODUCTCOUNT%% ürün(ler) ',1),(1523,3,3592219198,'Alt Kategoriler',1),(1524,3,566031201,'Görünümü Sırala',1),(1525,3,3134167193,'Seçtiğimiz Ürünler',1),(1526,3,2568203735,'<strong>%%PAGE%% .SAYFA</strong>TOPLAM %%NUMPAGES%% SAYFA',1),(1527,3,3768902734,'Ürün karşılaştırmalarını göster',1),(1528,3,1111523802,'Listeye Bak',1),(1529,3,58290041,'Fatura / Gönderim Adresi',1),(1530,3,1490417553,'Fatura / Gönderim Metotları',1),(1531,3,1343015364,'Onaylama',1),(1532,3,756315074,'Son',1),(1533,3,1879189093,'Ödeme Hatası',1),(1534,3,4020425545,'Ödemeniz Kabul Edilmedi.Lütfen,Tekrar Deneyin',1),(1535,3,3453780242,'Tekrar deneyin',1),(1536,3,4045718410,'Kasaya Ödeme İşlemi Başarılı',1),(1537,3,1210789654,'Teşekkürler! Siparişiniz Başarıyla İşlendi.Sizden Ödeme Yapmanız Bekleniyor.',1),(1538,3,906094716,'Teşekkürler!Siparişiniz Başarıyla İşlendi.',1),(1539,3,869314853,'Kimlik Doğrulama',1),(1540,3,1805277448,'Ödeme yapmak için kayıt olmalısınız',1),(1541,3,3099258724,'Parolanızı Tekrar Giriniz:',1),(1542,3,822156319,'Güvenlik Kodu:',1),(1543,3,1626898610,'Güvenlik Kodu',1),(1544,3,847984313,'Resim yeniden yükleniyor',1),(1545,3,789590253,'Lütfen,kutudaki karakterleri giriniz.Bunu yapmanız,bu formun otomatik programlar tarafından kötüye kullanılmasını önler.',1),(1546,3,3407541179,'Misafir Ödeme',1),(1547,3,2121996478,'Eğer Misafir Ödeme seçeneğini seçerseniz üyeliğe ihtiyacınız yoktur.Bununla birlikte,daha sonraki ziyaretlerinizde geçmiş siparişlerinizi göremezsiniz.',1),(1548,3,3307505785,'İsteğe Bağlı E-mail:',1),(1549,3,2421870257,'*E-mail adresiniz SADECE sipariş bildirimi için kullanılacaktır.',1),(1550,3,3362839566,'Adres Bilgileri',1),(1551,3,1190439064,'Gönderim Adresi',1),(1552,3,610800229,'Sonraki Adım',1),(1553,3,1797069372,'Adres Seç',1),(1554,3,2317107991,'Siparişi Onayla',1),(1555,3,2007405874,'Fatura İçin',1),(1556,3,2944186042,'Gönderim İçin',1),(1557,3,2212487076,'İletişim',1),(1558,3,2877914330,'Ödeme Şekli',1),(1559,3,1727468277,'Gönderim Şekli',1),(1560,3,994804795,'Kart Bilgisi',1),(1561,3,4001707996,'Kullanım sözleşmesini ve şartları kabul ediyorum',1),(1562,3,2111172529,'Önceki Adım',1),(1563,3,4032482767,'Değiştir',1),(1564,3,3412837404,'Fatura Şekli',1),(1565,3,4210788597,'Bonus Puan Kullanın.',1),(1566,3,3762971717,'Gönderim Şekli',1),(1567,3,2591431184,'Özel İstekler?',1),(1568,3,30083613,'En Çok Satanlar',1),(1569,3,442779427,'Sepet',1),(1570,3,3355742105,'Sepet Boş',1),(1571,3,456003789,'Ürünler:',1),(1572,3,2679332891,'Toplam:',1),(1573,3,2765451054,'Bak &amp; Ödeme yap',1),(1574,3,4157704578,'Merhaba',1),(1575,3,1704413287,'İstek Listesi',1),(1576,3,982410204,'Yeni Ürünler',1),(1577,3,2154430034,'Son Görülen',1),(1578,3,792727095,'Gelişmiş Arama',1),(1579,3,2784385862,'Parolamı Unuttum',1),(1580,3,39256687,'E-mailiniz:',1),(1581,3,1830307645,'Parolanız:',1),(1582,3,1014130425,'Lütfen,giriş için <a href=\"%%HTTPS%%login.php\">burayı</a> ',1),(1583,3,4065048850,'Parolanızı sıfırlamak için bu bağlantıya tıklayın:',1),(1584,3,2663571239,'Form Gönderildi:',1),(1585,3,519137004,'Satın Aldıklarınızı buradan indirebilirsiniz',1),(1586,3,376591614,'E-Eşya dağıtım bölümü',1),(1587,3,2129829755,'Lütfen bize ulaşın:',1),(1588,3,2320060907,'Bu siparişin ayrıntılarını görüntülemek için',1),(1589,3,626704452,'Burayı Tıklayın',1),(1590,3,4192191998,'Siparişiniz hakkında önemli bir güncelleme vardır',1),(1591,3,2228299012,'bu ürüne bakman için davetiye gönderdi:',1),(1592,3,1535433401,'Üye olduğunuz için Teşekkür Ederiz!',1),(1593,3,3313959608,'Profiliniz:',1),(1594,3,2619118453,'Hata',1),(1595,3,2367234431,'İsteğiniz işlenirken bir hata oluştu.Eğer hata devam ediyorsa,Lütfen Mağaza Yönetimi ile iletişime geçiniz.',1),(1596,3,2226783450,'<a href=\"http://www.summercart.com.tr/\" target=\"_blank\">Online Alışveriş Yazılımı</a>',1),(1597,3,1429023383,'Parolanız e-mail adresinize gönderildi.',1),(1598,3,58328078,'Parola Gönder',1),(1599,3,1679901357,'Yeni Parola:',1),(1600,3,1791768478,'Yeni parolanızı onaylayınız:',1),(1601,3,1541818425,'Parolayı Sıfırla',1),(1602,3,4158181270,'Parolanız başarı ile sıfırlandı.',1),(1603,3,3756970489,'Lütfen giriş yapın.',1),(1604,3,2696799790,'Başarılı',1),(1605,3,949859957,'Kaydet',1),(1606,3,2291548582,'Galeri',1),(1607,3,3504437773,'Mağazamıza Hoşgeldiniz!',1),(1608,3,3335690486,'Seçtiğimiz Ürünler',1),(1609,3,909788852,'Detayları Gör',1),(1610,3,1507512851,'Adet:',1),(1611,3,57972069,'%%MANUFACTURERNAME%% Ürünlerinin tümünü gör',1),(1612,3,4142905463,'ürünleri bulundu',1),(1613,3,2027916259,'<b>%%PAGE%%.Sayfa</b> Toplam: %%NUMPAGES%%',1),(1614,3,2462686142,'Gönderim Bilgileri',1),(1615,3,570706577,'Ödediğiniz',1),(1616,3,3334723224,'Özel İstekler',1),(1617,3,3970606310,'Ürün Resmi',1),(1618,3,2171396134,'Download',1),(1619,3,3862370978,'Siparişlerim',1),(1620,3,3541515099,'Henüz bir siparişiniz yok.',1),(1621,3,3852454006,'Puanlarınız:',1),(1622,3,251134918,'Hesap Bilgileri',1),(1623,3,2438360217,'Geçerli parolayı kullanmak için boş bırakın.',1),(1624,3,686869563,'Sahip olduğunuz:',1),(1625,3,2673283087,'Varsayılan Fatura Adresi',1),(1626,3,2515100435,'Varsayılan Gönderim Adresi',1),(1627,3,1600593306,'Siparişimlerime Dön',1),(1628,3,3714655035,'Summer Cart - Arkadaşına Gönder',1),(1629,3,1198176300,'Sizin İsminiz:',1),(1630,3,646681000,'Sizin E-mail Adresiniz:',1),(1631,3,2118475349,'Arkadaşınızın E-mail Adresi:',1),(1632,3,2458683357,'Eklemek İstediğiniz Not:',1),(1633,3,121738739,'Gönder',1),(1634,3,2380011981,'Karşılaştırma listesine ekle',1),(1635,3,2729119880,'Karşılaştırma listesinden kaldır',1),(1636,3,3664753648,'Ağırlık:',1),(1637,3,4233714837,'Ürün Seçenekleri',1),(1638,3,2016129824,'Arkadaşına Gönder',1),(1639,3,1763323970,'Ürün Değerlendirmesi:',1),(1640,3,2798506643,'Yorumlar',1),(1641,3,966531448,'Adet İndirimi',1),(1642,3,2155498677,'Demetlenmiş Ürünler',1),(1643,3,1070322242,'ile',1),(1644,3,2403360959,'Kaydınız Başarı ile Alındı',1),(1645,3,3287053070,'Kısa bir süre içerisinde,bizden kaydınızın onaylandığına dair bir e-mail alacaksınız.',1),(1646,3,710245342,'Lütfen,arama kriterlerini giriniz:',1),(1647,3,474009099,'Ürün İçeriği Arayın:',1),(1648,3,3028788705,'Ürün detaylarında da aransın',1),(1649,3,3275397312,'Ürün Kodu:',1),(1650,3,422055502,'En düşük:',1),(1651,3,1107555942,'En yüksek:',1),(1652,3,3334958971,'Ürün Sınıfı:',1),(1653,3,872791843,'Arama Değiştirme',1),(1654,3,3676457160,'PayPal Ekspres Ödeme',1),(1655,3,1474342248,'Ödeme Onayı',1),(1656,3,2900568731,'Son Haberler',1),(1657,3,1988906978,'RSS 2.0',1),(1658,3,3930643869,'Abone',1),(1659,3,1982922322,'Tüm Haberleri Gör',1),(1660,3,3780062704,'Fatura Yöntemi - Çek',1),(1661,3,2643468480,'Faturalandırma Yöntemi - Kredi Kartı',1),(1662,3,2302948229,'Lütfen, eğer varsa 3 ya da 4 haneli CVV/CVC kodunu giriniz.',1),(1663,3,3242636189,'Easypay.bg ödeme notu',1),(1664,3,891620106,'Ödeme kodu',1),(1665,3,3862000488,'Faturalandırma Metodu-Kredi/Bankamatik Kartı',1),(1666,3,451678722,'Kart Tipi:',1),(1667,3,2159650956,'Kart Start:',1),(1668,3,2759988489,'(müsaitlik durumu)',1),(1669,3,3570763641,'Düzenleme Numarası:',1),(1670,3,1628353965,'(Sadece daha eski şifrelenen kartlarda.Karta 1 veya 2 basamak olarak basılır.)',1),(1671,3,2358789045,'Banka/Kart:',1),(1672,3,2794146439,'Nakit',1),(1673,3,4076891506,'Ürünleri karşılaştır',1),(1674,3,3434387737,'Listenizdeki bazı ürünler kıyaslanamaz.',1),(1675,3,3174868567,'Karşılaştırma listenizde ürün bulunmamaktadır.',1),(1676,3,723556371,'Ürün Kaldır',1),(1677,3,733929904,'Bağdaşmayan ürün.',1),(1678,3,356924018,'Karşılaştırma listenizde ürün karşılaştırmak için en az 2 ürüne ihtiyacınız var.',1),(1679,3,247356116,'Karşılaştırma Sonucunu Göster',1),(1680,3,3027694245,'%%NEWSLETTERNAME%% bültenine abonelik için e-posta adresinizi girin:',1),(1681,3,1707695583,'Lütfen geçerli bir email adresi giriniz.',1),(1682,3,116380646,'\"%%NEWSLETTERNAME%%\" bültenine abone olduğunuz için Teşekkür Ederiz',1),(1683,3,1674439883,'\"%%NEWSLETTERNAME%%\" bülteninden daha fazla e-mail almak istemiyorsanız,lütfen,e-mail adresinizi girip \"abonelik iptal\" i tıklayınız. ',1),(1684,3,602980313,'Abonelik İptal',1),(1685,3,3231745282,'Aboneliğiniz başarıyla iptal edildi.',1),(1686,3,1195251778,'İsminiz:(isteğe bağlı)',1),(1687,3,3340366533,'Yorumunuzu Yazın',1),(1688,3,2360675507,'Ürünü değerlendir:',1),(1689,3,3397765978,'Lütfen Bekleyin',1),(1690,3,1435329933,'İstediğiniz ürünleri oluşturun ve arkadaşlarınıza yollayın.',1),(1691,3,1919431210,'İstediğiniz ürünleri oluşturun ve arkadaşlarınıza yollayın.E-mailleri virgülle ayırın',1),(1692,3,778980276,'İstediğiniz ürünler listesinden kaldırın',1),(1693,3,4076650759,'İstediğiniz ürünler listesine ekleyin',1),(1694,3,971690898,'Erişim Engellendi.',1),(1695,3,206424473,'Adres Başarıyla Oluşturuldu.',1),(1696,3,3931780025,'Adres Başarıyla Güncellendi.',1),(1697,3,1988007368,'Adres Başarıyla Silindi.',1),(1698,3,3033757558,'Varsayılan Adres Başarıyla Değiştirildi.',1),(1699,3,337247436,'Adreslerim',1),(1700,3,1060537073,'Tüm giriş seviyeleri',1),(1701,3,1643484871,'API Hesap',1),(1702,3,3978665514,'Tüm durumlar',1),(1703,3,910769710,'Bu email adresinde müşteri yok.',1),(1704,3,974874717,'Kutu Seçenekleri',1),(1705,3,1654365787,'Bilinmeyen',1),(1706,3,1214010334,'Bu tip kutu silinemiyor.',1),(1707,3,3427545285,'başarıyla silindi.',1),(1708,3,462477906,'İndirimler:',1),(1709,3,1969273851,'otomatik tahmin yöntemlerini önlemek için devre dışı bırakılmıştır.',1),(1710,3,893657890,'Kuponlar:',1),(1711,3,1286454575,'Direkt Kasaya Ödeme Modülü',1),(1712,3,3484844198,'Mağaza Sahibi',1),(1713,3,4154148757,'Varsayılan Ülke Silinemez',1),(1714,3,2616533983,'Varsayılan Ülke Başarıyla Ayarlandı.',1),(1715,3,1673566086,'Geçerli şehir gerekiyor',1),(1716,3,2626115326,'Kullanılabilir Kategoriler',1),(1717,3,158388602,'Kategoriler Seçildi',1),(1718,3,4192083481,'Kullanılabilir Müşteri Grupları',1),(1719,3,1904975299,'Seçilen Müşteri Grupları',1),(1720,3,1662204468,'Kupon',1),(1721,3,1223637619,'Tüm kupon tipleri',1),(1722,3,2418076265,'Para Birimi',1),(1723,3,799914036,'Geçersiz Ondalık Sayı.',1),(1724,3,359110422,'Varsayılan para birimi ayarlandı.Para Birimi oranları güncellendi.',1),(1725,3,1622119860,'Para Birimi Oranları Güncellendi.',1),(1726,3,2777361223,'Varsayılan para birimi silinemez.',1),(1727,3,3484117332,'Varsayılan para birimi devre dışı bırakılamaz.',1),(1728,3,3606238423,'Süresi Doldu',1),(1729,3,2273128141,'Sol Sembol',1),(1730,3,311113914,'Sağ Sembol',1),(1731,3,2474211846,'Ondalık Sembol',1),(1732,3,2412596371,'Binlik Ayırıcısı',1),(1733,3,2900972917,'Ondalık Sayı',1),(1734,3,1228535726,'Döviz Kuru Oran Modülü',1),(1735,3,349111103,'Tüm sayfa tipleri',1),(1736,3,3673409282,'Mevcut değil',1),(1737,3,323882391,'Geçerli',1),(1738,3,765567539,'Url boş olamaz.',1),(1739,3,71930170,'Url zaten var',1),(1740,3,2992138442,'Alan Boş.',1),(1741,3,1428478262,'Müşteri Grubu',1),(1742,3,4280560865,'Varsayılan müşteri grubu başarıyla ayarlandı',1),(1743,3,916359985,'Varsayılan müşteri grubu silinemez.',1),(1744,3,1426270757,'Müşteri grup ismi',1),(1745,3,3972781833,'Tüm ülkeler',1),(1746,3,3326678627,'Tüm müşteri grupları',1),(1747,3,3712848290,'Bu e-mail kullanılmaktadır.',1),(1748,3,3309684772,'Admin Puan rakamlarını güncellendi.',1),(1749,3,2978604238,'Misafir müşteri silinemedi.',1),(1750,3,3514388826,'Geçersiz Tamsayı.',1),(1751,3,1027349186,'İsim',1),(1752,3,2437538009,'Soyisim',1),(1753,3,2147627219,'Firma',1),(1754,3,4175916105,'Adres',1),(1755,3,1643003379,'Adres',1),(1756,3,2372513034,'İlçe:',1),(1757,3,1649606143,'Şehir:',1),(1758,3,2240723161,'Telefon',1),(1759,3,2842594184,'Fax',1),(1760,3,1194661543,'Ülke ID',1),(1761,3,233403792,'Şehir ID',1),(1762,3,412686884,'Diğer',1),(1763,3,2605367606,'Tüm indirim tipleri',1),(1764,3,1724252194,'Dinamik Sayfa',1),(1765,3,2245059026,'php mail () fonksiyonu ile',1),(1766,3,3459792051,'SMTP sunucusu üzerinden',1),(1767,3,3751981041,'Hiçbiri',1),(1768,3,2135378647,'SSL',1),(1769,3,979001145,'TLS',1),(1770,3,1928099550,'Summer Cart test emaili',1),(1771,3,2494957135,'Bilgi güncellendi ama email %s \'e/a ya gönderilemedi.Lütfen ayarları kontrol ediniz.',1),(1772,3,3429979993,'Bilgi güncellendi ve email başarıyla %s  \'e/a gönderildi.',1),(1773,3,281341089,'Özellikli Ürün',1),(1774,3,987936391,'Seçme',1),(1775,3,1195630948,'ANASAYFA',1),(1776,3,1544782654,'Bu ürün zaten seçili.',1),(1777,3,2447820944,'İlk önce ürün oluştur.',1),(1778,3,4072297073,'Form',1),(1779,3,3294903477,'Metni Onayla',1),(1780,3,3336299507,'Etkin captcha',1),(1781,3,1891647104,'Resim Seçilmedi.',1),(1782,3,2519533548,'%d resimleri başarıyla alındı.',1),(1783,3,4021789044,'Galeri öğesi',1),(1784,3,2612594937,'Metin',1),(1785,3,1954655468,'Dosya Yüklenemedi.',1),(1786,3,1324475515,'Yükleme sırasında hata (hata kodu %d).',1),(1787,3,311012738,'Dosya Açılamıyor %s',1),(1788,3,506301268,'Dosya Alımı Başarız!Nedeni:',1),(1789,3,1073345337,'Kısmi başarı.%d import edilen ürünler,%d güncellenen ürünler.İmport #%d  mesajı ile durdu:',1),(1790,3,468324764,'Dosya Alımı Başarılı.',1),(1791,3,2100858350,'Tüm resimler başarıyla alındı.',1),(1792,3,765083125,'Bilmeyen başlık \"%s\".',1),(1793,3,3929581076,'\"%s\" dan \"%s\" kopyalanamıyor.',1),(1794,3,829264720,'SKU\'lu ürün \"%s\" zaten mevcut!',1),(1795,3,2438984671,'\"%s\" Kategorisi bulunamadı.',1),(1796,3,1582254705,'Varsayılan düzen bulunamadı.',1),(1797,3,4089697667,'\"%s\" Tedarikçileri bulunamadı.',1),(1798,3,1044163623,'\"%s\" Ürün sınıfı bulunamadı.',1),(1799,3,3633141250,'Sistem gereksinmeleri',1),(1800,3,2564148613,'Lisans',1),(1801,3,709512653,'Dizin İzinleri',1),(1802,3,93151306,'Uygulanmadı',1),(1803,3,2233580107,'Onaylandı',1),(1804,3,2644336511,'Dil metinleri başarıyla güncellendi.',1),(1805,3,3414354415,'Varsayılan dil başarıyla ayarlandı',1),(1806,3,3507618035,'Varsayılan dil silinemez.',1),(1807,3,2655559150,'Varsayılan dil devre dışı bırakılamaz.',1),(1808,3,784760254,'Dil paketi oluşturulmadı.',1),(1809,3,445195722,'Yüklenen dosya çok büyük (%s bytes).',1),(1810,3,2015382419,'Lütfen dosyayı yükleyiniz.',1),(1811,3,1207227239,'You should upload language pack file (.zip).',1),(1812,3,2956520505,'Hata işleniyor \"%s\": %s',1),(1813,3,1061572800,'Dil paketi arşivi içinde .xml dil paketi bulunamadı.',1),(1814,3,2677450897,'\"%s\" ile dil kodu zaten var.',1),(1815,3,2697320117,'Dil paketi arşivi içinde \"%s\"  resim dosyası bulunamadı.',1),(1816,3,1441564075,'Yüklenmiş XLIFF dosya ismi \"%s\" geçerli.',1),(1817,3,4057922485,'Yüklerken hata oluşan dosya: %s (error code %s).',1),(1818,3,342401503,'Dahili hata.',1),(1819,3,1897767757,'Yüklenen dosya boş.',1),(1820,3,4151929386,'You should upload translation file (.xlf).',1),(1821,3,3838021215,'%d%% tercüme ',1),(1822,3,3166393104,'Yönetim',1),(1823,3,778796279,'Dil Paketi Yazarı',1),(1824,3,1079379558,'Dil Paketi Açıklaması',1),(1825,3,3785170304,'Dil Paketi Lisansı',1),(1826,3,3589568588,'Dil Paketi Yayın Tarihi',1),(1827,3,662578726,'Kullanılabilir',1),(1828,3,647256362,'Üst',1),(1829,3,3663022166,'Sol',1),(1830,3,1963678224,'Sağ',1),(1831,3,2398320530,'Alt',1),(1832,3,3685643230,'Tasarım kutuları kaydetme başarısız:',1),(1833,3,3119399505,'Varsayılan düzen başarıyla değiştirildi.',1),(1834,3,1593855280,'Bu tasarımı silmek için, dinamik sayfalara,kategorilere veya zengin metin sayfalarına başvurun.',1),(1835,3,3959000229,'Tüm kategoriler',1),(1836,3,716071528,'Tüm şiddeti',1),(1837,3,2142461233,'Lütfen,Kullanıcı Adınızı ve Parolanızı Giriniz!',1),(1838,3,1315737212,'Geçersiz kullanıcı adı ve / veya parola. Lütfen,tekrar deneyin.',1),(1839,3,2495292229,'Hesabınız Devre Dışı Bırakıldı.',1),(1840,3,774316269,'Menü Öğesi',1),(1841,3,3060702529,'Ürün Seçeneği',1),(1842,3,3130920691,'Sipariş Durumu',1),(1843,3,706177376,'Bu durum devre dışı bırakılamaz.',1),(1844,3,4262583638,'Bu durum için gönderim notları devre dışı bırakılamaz.',1),(1845,3,1148841405,'\"%s\" önceden tanımlanmış sipariş durumu silinemiyor.',1),(1846,3,2909636378,'Siparişler bu \"%s\" durumdayken silemezsiniz. ',1),(1847,3,437395479,'Toplam Sipariş Modülü',1),(1848,3,4087417155,'Alt toplam herzaman diğer toplam modüllerinden önce gelmelidir.',1),(1849,3,2472366501,'Seçilen Sipariş Başarıyla Silindi!',1),(1850,3,1258584605,'Sipariş Durumları Başarıyla Güncellendi!',1),(1851,3,2277936408,'Sipariş Bulunamadı.',1),(1852,3,1060205392,'Hata oluştu:%s',1),(1853,3,2255065229,'Demet fişleri PDF baskı olamaz.',1),(1854,3,1534955588,'Not çok kısa.',1),(1855,3,884912915,'Not başarıyla eklendi ama not e-maili göderilirken sorun oluştu.',1),(1856,3,1847838487,'Not başarıyla eklendi ama müşteri e-maili yok.',1),(1857,3,2924919114,'Not başarıyla eklendi ama sipariş departmanlığı e-maili yapılandırılmamış.',1),(1858,3,2680044958,'Not Başarıyla Eklendi.',1),(1859,3,2978673432,'Notu eklerken hata oluştu.',1),(1860,3,3269079827,'Not Başarıyla Silindi.',1),(1861,3,3735730144,'Kredi kartı numarası ve CVV başarıyla silindi.',1),(1862,3,2256931719,'E-eşya görüntülenemiyor',1),(1863,3,67482292,'E-eşya bildirimi için e-posta gönderilemedi.',1),(1864,3,3667787196,'E-eşya için bildirim e-maili başarıyla gönderildi.',1),(1865,3,1170936893,'E-eşya bildirimi gönderilirken hata oluştu: \"%s\".',1),(1866,3,3304927357,'E-eşya durumu başarıyla güncellendi.',1),(1867,3,2005744939,'Ödeme modülü bulanamadı.',1),(1868,3,64071581,'İstisna:',1),(1869,3,1840034131,'Bilinmeyen işlem.',1),(1870,3,4267206052,'Ödeme Modülü',1),(1871,3,1419919011,'Eklenti başarı ile kuruldu.',1),(1872,3,762253123,'PHP uzantısı ZIP yüklü değildir. etkinleştirmek için barındırma sağlayıcınıza başvurun.',1),(1873,3,1983809766,'ZIP arşiv okunamıyor.Hata %d: %s',1),(1874,3,2476158058,'\"%s\" klasörü oluşturulmadı.',1),(1875,3,2932655328,'\"% S\" dosyası zaten var.',1),(1876,3,3392287738,'ZIP arşiv girişi açılamıyor.',1),(1877,3,3525337433,'Yüklenen dosya resim değildir.',1),(1878,3,3648249677,'Yüklenen Dosya Kaydedilemiyor!',1),(1879,3,3068422154,'Lütfen,bir resim yükleyin.',1),(1880,3,2833957309,'Kategori Seçin',1),(1881,3,3705767946,'Tüm tedarikçiler',1),(1882,3,998618569,'Tüm ürün sınıfları',1),(1883,3,895607553,'Bir ürün demetinin alt ürünleri olmalı.',1),(1884,3,1452315037,'Tüm ürün demetleri en az 1 adet olmalı.',1),(1885,3,2642524106,'Bir ürün demeti,diğer ürün demetlerini içerebilir ama kendisini içeremez.',1),(1886,3,4060421234,'Bir ürün demetinin değişik varyantları olamaz.',1),(1887,3,4111963927,'Geçersiz Numara.',1),(1888,3,2418193025,'Bir ilk kategori oluşturun',1),(1889,3,3039632037,'E-eşya ürünüdür',1),(1890,3,747255451,'Sınıf',1),(1891,3,3465050114,'Hızlı Link',1),(1892,3,299357700,'Bilinmeyen Rapor',1),(1893,3,3938568113,'Zengin İçerik Sayfası',1),(1894,3,829950261,'İçerik',1),(1895,3,3046866235,'Gönderim Modülü',1),(1896,3,3465572544,'Bu gönderim modülü bir örnek olmalıdır ve eklenemez.',1),(1897,3,3580000547,'Gönderim Modülü Başarıyla Oluşturuldu.Lütfen,Modülü Ayarlayın',1),(1898,3,695430002,'Bu gönderim modülü bir örnek olmalıdır ve silinemez.',1),(1899,3,4188760814,'Gönderim bölgesi',1),(1900,3,2501974536,'Geçerli Ülkeler',1),(1901,3,3723238592,'Seçilen Ülkeler ',1),(1902,3,3554809502,'Kullanılabilen Şehirler',1),(1903,3,1478574432,'Seçilen Şehirler',1),(1904,3,521597972,'\"%s\" Listesi oluşturulamıyor.',1),(1905,3,3947037298,'Şablon Seçimi',1),(1906,3,3732254855,'Görünüm yeri \"% s\" geçerli dizin değil.',1),(1907,3,31452408,' \"%s\" görünüm açıklaması bulunamadı.',1),(1908,3,1311354019,'\"%s\" görünüm açıklaması okunamıyor.',1),(1909,3,3052803159,'\"% s\" görünümü yazılımın başka bir sürümü içindir.',1),(1910,3,548770039,'%d şablonu otomatik kuruldu.',1),(1911,3,4139653556,'\"skin.xml\" Okunamıyor.',1),(1912,3,2887437011,'Şablon Başarıyla Kuruldu.',1),(1913,3,1326475003,'Aktivasyon',1),(1914,3,1998283438,'Yerleşim Kodu',1),(1915,3,649384201,'Vergi Sınıfı',1),(1916,3,2401985450,'Vergi Oranları',1),(1917,3,2273774407,'İlk Olarak vergi bölgeleri ve vergi oranlarını tanımlamak gerekir.',1),(1918,3,1049680567,'Vergi Bölgesi',1),(1919,3,3066887318,'Vergi',1),(1920,3,2848081516,'Kupon Uygulandı.',1),(1921,3,2659381137,'Kupon Kaldırıldı.',1),(1922,3,612906988,'Kategori Bulunamadı.',1),(1923,3,3760882688,'Bilinmeyen modül ismi: \"%s\".',1),(1924,3,1658215604,'%d siparişiniz için görüntüleme izin verilmiyor!',1),(1925,3,2072252968,'Ödeme Sonu',1),(1926,3,567520697,'Talep ettiğiniz sayfa bulunamıyor. 2 saniye içinde ana sayfaya yönlendirileceksiniz.',1),(1927,3,1365745153,'Lütfen,E-mail Adresi Giriniz.',1),(1928,3,35798503,'E-mail Bulunamadı.Lütfen,Tekrar Deneyin.',1),(1929,3,478502169,'Şifreniz %s buraya gönderildi.Lütfen e-mail adresinizi kontrol ediniz.',1),(1930,3,4210502971,'Parolanızı değiştirdiniz.',1),(1931,3,2736803437,'Parolalar Uyuşmadı...',1),(1932,3,500224504,'Hatalı formu gör:',1),(1933,3,2067417858,'Güvenlik kodu uyuşmuyor.',1),(1934,3,4247598002,'Galeri Bulunamadı.',1),(1935,3,2939161884,'Girişim Engellendi!Summer Cart demoda bu işleme izin verilmez.',1),(1936,3,2851240815,'\"%s\" Modülü yapılandırılmamış.Lütfen \"%s\" modülünü yapılandırın.',1),(1937,3,3794871534,'Yazdırılacak alan seçilmemiş.',1),(1938,3,521872670,'Öğe',1),(1939,3,3776899405,'Öğeler',1),(1940,3,3469939714,'Kategori görünüşleri',1),(1941,3,2211971065,'Ürün Satışları',1),(1942,3,4188410682,'Ürün Görüntülenmesi',1),(1943,3,3800588496,'Giriş yaptığınız hesabınızı silemezsiniz.',1),(1944,3,246908558,'Siz yalnızca tam erişim hesabını sınırladırma ve/veya devre dışı bırakamazsınız.',1),(1945,3,4197307457,'Müşterilerin bu ülkeye ait fatura ve/veya gönderim adresleri var.',1),(1946,3,3355634220,'Zengin İçerik Sayfası',1),(1947,3,3337924380,'Dinamik Sayfa',1),(1948,3,4060101575,'Müşterilerin son adresleri silinmez.',1),(1949,3,976736592,'Bu müşteri grubunu silmek için,gruba müşteri atanmamış olması gerekmektedir.',1),(1950,3,3520615993,'\"%s\" dosyası bulunamadı.',1),(1951,3,3326180459,'Galeri dizini oluşturulamadı.',1),(1952,3,1961186936,'Galeri resimleri dizini oluşturulamadı.',1),(1953,3,2776549596,'Galeri önizleme resimleri oluşturulamadı.',1),(1954,3,2733256268,'Galerinin yeniden adlandırılması başarısız oldu:tekrarlanan isim.',1),(1955,3,3209771303,'Galerinin yeniden adlandırılması başarısız oldu.',1),(1956,3,821124640,'Soldan sağa',1),(1957,3,609036854,'Sağdan sola',1),(1958,3,2495182195,'Sadece aktif dili devre dışı bırakamazsın.',1),(1959,3,1104553861,'Menü',1),(1960,3,3544640745,'%s siparişi için yeni sipariş e-maili gönderilemedi.',1),(1961,3,1966796274,'Yeni Sipariş',1),(1962,3,2188138777,'%s sipariş için harcanan miktara göre.',1),(1963,3,1252764064,'Referans olan müşteri %s.',1),(1964,3,2216265504,'Azami indirme sayısına ulaşıldı.',1),(1965,3,3487080762,'E-eşya indirme linkinin geçerlilik süresi doldu.',1),(1966,3,2021271368,'E-eşya kilitli.',1),(1967,3,46009503,'Bu ürün sınıfında bulunan ürünler.',1),(1968,3,2066183052,'\"%s\" ürün demetlenmiş üründe bulundu.Bu tekrarlanan bağımlılığa neden olur.',1),(1969,3,2372983258,'Orjinal resim bulunamadı.Ürün ID: %s.',1),(1970,3,2699549413,'Orjinal varyant resmi bulunamadı.Ürün ID: %s.',1),(1971,3,741113889,'Bu gönderim alanını silmek için,gönderim modülünün atanmamış olması gerekmektedir.',1),(1972,3,672387575,'Bu Ay',1),(1973,3,2551559645,'Geçen Ay',1),(1974,3,2719278482,'Bu Yıl',1),(1975,3,1961422312,'Geçen Yıl',1),(1976,3,3576125411,'E-eşya dosyası kopyalaması başarısız oldu.',1),(1977,3,1440618055,'E-eşya dosyalarının taşınmasında hata oluştu.',1),(1978,3,2751018395,'Resim kopyalama başarısız oldu:',1),(1979,3,1885574410,'Silinemiyen resim \"%s\".',1),(1980,3,3854097274,'Önizleme resim kopyalanması hatalı \"%s\" den \"%s\"',1),(1981,3,942111230,'Resim kopyalanması hatalı \"%s\" den \"%s\"',1),(1982,3,2928828387,'Bilinmiyor (%s)',1),(1983,3,4153723213,'Ödeme Modülü',1),(1984,3,3102305494,'Sayfa Görüntülenmesi / Tekil Ziyaretçiler',1),(1985,3,60420241,'Sayfa Görüntülenmesi',1),(1986,3,3328718076,'Tekil ziyaretçiler',1),(1987,3,3589852710,'Sipariş Numarası',1),(1988,3,769758617,'Müşteri Ülkesi',1),(1989,3,1989299678,'Gönderim Ücretleri',1),(1990,3,2975766011,'Ödeme Ücretleri',1),(1991,3,2211629218,'Ürün sayısı',1),(1992,3,3178665876,'Kategori İsmi',1),(1993,3,1617569995,'-Boş İsim-',1),(1994,3,3723325296,'Gün',1),(1995,3,4217947902,'Hafta',1),(1996,3,1333214978,'Ay',1),(1997,3,3543980187,'3 Aylık',1),(1998,3,464575497,'Yıl',1),(1999,3,26566655,'Özet',1),(2000,3,1331463278,'Günlük',1),(2001,3,1500557074,'Haftalık',1),(2002,3,622395140,'Aylık',1),(2003,3,3153405383,'3 Aylık',1),(2004,3,4293902794,'Yıllık',1),(2005,3,1419823037,'Ocak',1),(2006,3,811644918,'Şubat',1),(2007,3,1173261687,'Mart',1),(2008,3,523065091,'Nisan',1),(2009,3,3527169279,'Mayıs',1),(2010,3,2047742184,'Haziran',1),(2011,3,2483057092,'Temmuz',1),(2012,3,260523949,'Ağustos',1),(2013,3,3644106533,'Eylül',1),(2014,3,2638192302,'Ekim',1),(2015,3,3729185465,'Kasım',1),(2016,3,1155748622,'Aralık',1),(2017,3,1571557308,'\"%s\" Başarısız Curl isteği için Yanıt Kodu \"%d\".',1),(2018,3,3673143881,'\"%s\" Dosyası bir resim değildir.',1),(2019,3,1325301612,'Resim kopyalama başarısız.',1),(2020,3,606702645,'Geçersiz resim formatı.',1),(2021,3,3243865366,'Resim ölçülendirme hatalı.',1),(2022,3,4273361783,'\"%s\" hedef dizin oluşturulamadı.',1),(2023,3,4017556963,'\"%s\" dizin değildir.',1),(2024,3,2065388674,'\"%s\" yazılabilir değil.',1),(2025,3,134666524,'Hatalı resim yazımı.',1),(2026,3,4057668941,'Bu sitede Summer Cart lisanslı değil. Lütfen, lisans edinin.<br/><a href=\"http://www.summercart.com.tr\" target=\"_blank\">Satın Al</a>',1),(2027,3,1659361011,'Summer Cart aktif değil. Mağazanın fonksiyonları sınırlı olacaktır.<br/><a href=\"http://www.summercart.com.tr/\" target=\"_blank\">Satın Al</a>',1),(2028,3,3301984207,'Summer Cart başka bir sunucu için etkinleştirildi.Mağazanın fonksiyonları sınırlı olacaktır.<br/> <a href=\"#\">Şimdi yeniden aktif edin</a>',1),(2029,3,687696898,'\"%s\" dosyası oluşturulamadı.Yüklediğiniz resimler yüzünden olabilir.<a href=\"#\">Yardım</a>',1),(2030,3,2187267186,'\"%s\" dosyası yazılabilir değil.Yüklediğiniz resimler yüzünden olabilir.<a href=\"#\">Help</a>',1),(2031,3,10074882,'\"%s\" yazılamaz.E-ürünleriniz güvende olmaz.<a href=\"#\">Yardım</a>',1),(2032,3,1322276977,'PHP versiyonu çok eski.Yazılım için en az 5.1 versiyon gereklidir.',1),(2033,3,1035921460,'Güvenli mod kapalı olmalı.',1),(2034,3,79325551,'php.ini seçeneklerinde file_uploads açık olmalı.',1),(2035,3,1349081457,'PHP uzantısı \"%s\" gereklidir.',1),(2036,3,3687500167,'GIF desteği gereklidir.',1),(2037,3,3476745476,'JPEG desteği gereklidir.',1),(2038,3,4096294307,'PNG desteği gereklidir.',1),(2039,3,3083089325,'Bugün sona eriyor',1),(2040,3,1362021340,'Sona ermesine 1 gün kaldı',1),(2041,3,3637722135,'Sona ermesinde %d gün kaldı',1),(2042,3,2922609053,'Kritik',1),(2043,3,2415109466,'Uyarı',1),(2044,3,2909038755,'Onar',1),(2045,3,606498454,'Döviz Oranları',1),(2046,3,1565131615,' %s dizin yok!',1),(2047,3,2084164920,'Dizin %s yazılabilir değil!',1),(2048,3,2728886836,'Disk boşluk kapasitesi düşük.%s bytes alana sahipsiniz (%2.2f%% of total).',1),(2049,3,934284482,'Yalnız kayıtlı müşteri (üye)',1),(2050,3,3415746634,'Sadece ürün almış müşteriler',1),(2051,3,3136150270,'Hiç biri',1),(2052,3,2302751552,'(%s .Sayfa Toplam %s Sayfa',1),(2053,3,2106068149,'Devre dışı',1),(2054,3,387805115,'Sınırlı',1),(2055,3,129195397,'Tam Erişim',1),(2056,3,4247900106,'Ürün sınıf özelliği',1),(2057,3,2185697575,'Ürün Sınıf Özellik Değeri',1),(2058,3,1070217018,'Ürün Özelliği',1),(2059,3,1377533868,'Ürün Demeti',1),(2060,3,1481202745,'Yerel Seçenek',1),(2061,3,3160476386,'Müşteri Adresi',1),(2062,3,95021649,'Düzyazı',1),(2063,3,2243593445,'Secure one-way hash (salted HMAC-SHA1)',1),(2064,3,413329838,'Ürün Seçenek Grupları',1),(2065,3,1885055086,'Dosya Al/Gönder',1),(2066,3,1354590562,'Günlükler',1),(2067,3,2361144370,'Ülkeler ve Vergiler',1),(2068,3,2906653211,'Mağaza Konfigirasyonu',1),(2069,3,1427690073,'Diller ve Para Birimleri',1),(2070,3,3174898911,'Zaten bir kupon kullandınız.',1),(2071,3,2890332796,'Bu kupon tüm koşulları karşılamamaktadır.',1),(2072,3,3958051832,'Kupon modülü aktif değildir.',1),(2073,3,1988732736,'\"%s\" sadece kayıtlı müşteriler için kullanılabilir.',1),(2074,3,1249500137,'Sizin yetersiz bonus puanınız var.',1),(2075,3,1845102359,'Öğenin ağırlığı alınıyor.',1),(2076,3,2519874081,'Sadece %d \"%s\" solda',1),(2077,3,2892561836,'\"%s\" Stoklarımızda yok.',1),(2078,3,3298488485,'Geçersiz ürün seçeneği',1),(2079,3,2386879254,'Sadece yüklenen resimler kabul edildi.',1),(2080,3,2166328991,'Lütfen resmi yükleyin',1),(2081,3,1518930363,'Lütfen metni girin.',1),(2082,3,3997504040,'Geçersiz Ürün.',1),(2083,3,2082714463,'Geçersiz ürün varyantı.',1),(2084,3,4244972103,'Toplam sipariş modülü istisna: \"%s\".',1),(2085,3,4043964841,'Ürünler & Kategoriler',1),(2086,3,3474686068,'Diller & Para Birimleri',1),(2087,3,178379105,'Ürün Listesi',1),(2088,3,3045310965,'Al/Gönder Kataloğu',1),(2089,3,3786787441,'Sayfalar',1),(2090,3,2808863634,'Rapor Merkezi',1),(2091,3,4255372828,'Şablon Ayarları',1),(2092,3,853338739,'Resimleri Al',1),(2093,3,3263330688,'Müşteri Ülkeleri',1),(2094,3,1894666010,'Sipariş Ödeme Modülleri',1),(2095,3,1441221385,'Sipariş Gönderim Modülleri',1),(2096,3,2170361627,'Sistem Kutusu',1),(2097,3,1651446388,'Menü Kutusu',1),(2098,3,1127429936,'XHTML Kutusu',1),(2099,3,653914245,'Bülten Kutusu',1),(2100,3,1619415391,'Taban',1),(2101,3,1124959784,'Çok Satırlı Metin',1),(2102,3,3876416187,'Onay Kutusu',1),(2103,3,1938514344,'Radyo Düğmeleri',1),(2104,3,3636078245,'Aşağı Açılır Liste',1),(2105,3,3199764228,'Belirli',1),(2106,3,2436635234,'Numara',1),(2107,3,857141173,'Dosya Yükleme',1),(2108,3,3531875685,'Özel HTML',1),(2109,3,1776201207,'Başlık',1),(2110,3,352538411,'Ayırıcı',1),(2111,3,544785870,'Resim Yok',1),(2112,3,512670514,'Önceden tanımlı resim',1),(2113,3,3832912090,'Özel resim',1),(2114,3,3895991404,'Şablon Bulunamadı.',1),(2115,3,2914208189,'Şablon konumu \"%s\" geçersiz.',1),(2116,3,3366602241,'Sütun şablonu bulunamıyor!',1),(2117,3,820252378,'Kutu',1),(2118,3,658583250,'Hızlı Menü',1),(2119,3,3852271717,'Sayfa dipnotu',1),(2120,3,3221496229,'Menü öğeleri kutusunu alırken CMSBoxID eksiktir.',1),(2121,3,3863017503,'Para bulunamadı',1),(2122,3,317351350,'Oranlar %s dan %s daya güncellenemedi.',1),(2123,3,720872515,' \"%s\" Modülünde Hata: %s.',1),(2124,3,21006379,'Varsayılan para birimi bulunamadı.',1),(2125,3,998958233,'Sadece Para',1),(2126,3,1825210422,'Puan ve para',1),(2127,3,2478440028,'Sadece puanlar',1),(2128,3,1939374383,'Kazanç',1),(2129,3,756222009,'Harcamak',1),(2130,3,459817765,'Beklemede',1),(2131,3,2749143752,'7 Gün',1),(2132,3,201091938,'30 Gün',1),(2133,3,3799853467,'Dönüş puanları.',1),(2134,3,3112438038,'Misafir müşteri bulunamadı.',1),(2135,3,4288268905,'Ücretsiz Gönderim',1),(2136,3,1307767082,'Ürün başına',1),(2137,3,4195381753,'Ürün başına adet',1),(2138,3,3695383545,'Alt Toplam',1),(2139,3,3085648491,'Ürün bilgisi',1),(2140,3,3772192490,'Bilinmeyen ürün id\'si \"%s\".',1),(2141,3,3659740162,'Kayıt bildirim',1),(2142,3,1447205245,'Form: %s',1),(2143,3,2968891335,'Yeni sipariş bildirimi gönderilemedi - müşteri e-maili eksik.',1),(2144,3,3772435740,'Yeni sipariş bildirimi gönderilemiyor-Müşteri ve yönetici mailleri eksik.',1),(2145,3,671016963,'Siparişiniz için Teşekkür Ederiz!',1),(2146,3,2462374820,'Siparişiniz en kısa zamanda değerlendirilecektir.',1),(2147,3,2383097839,'Yeni Sipariş #',1),(2148,3,1274645748,'Gönderilecek e-eşya yok',1),(2149,3,2159688091,'Müşteri e-postası eksik-E-eşya teslim edilemiyor.',1),(2150,3,1190481691,'#%s siparişi için mal teslimi',1),(2151,3,3563440502,'# Siparişi için yönetici notu',1),(2152,3,1532224661,'Sipariş durumu ile \"%s\" değişti.',1),(2153,3,1115676460,' #%s Siparişinin durumu değişti',1),(2154,3,2925959239,'Hata yok.',1),(2155,3,1323556796,'php.ini Maxiumum upload yönergesini aşıyor.',1),(2156,3,2000894469,'Yüklemeye çalıştığınız dosya izin verilen boyutları aşıyor.',1),(2157,3,2774220693,'Yüklenen dosyanın bir kısmı yüklenebildi.',1),(2158,3,3406465656,'Geçici Klasörü Eksik.',1),(2159,3,2410278471,'Diske dosya yazma başarısız.',1),(2160,3,2302500411,'Dosya uzantısı yüzünden yükleme durduruldu.',1),(2161,3,4225751778,'Bilinmeyen Hata.',1),(2162,3,1714678657,'GB',1),(2163,3,2631664395,'MB',1),(2164,3,3397821581,'KB',1),(2165,3,1952198132,'Varsayılan dil ayarlanmadı!',1),(2166,3,2963564181,'Beklenen hedef dil kodu, \"% s\" ama \"% s\" bulunamadı.',1),(2167,3,1065373100,'%s dili ile dil dosyası bulunamadı.',1),(2168,3,2347183978,'%s Bilinmeyen seçenek alanı.',1),(2169,3,2761744303,'Geçersiz modül sınıfları tanımlar.',1),(2170,3,2298128384,'%s İçin uygulama bulunamıyor, ModuleID %s.',1),(2171,3,3245286568,'Var olmayan \"%s\" sınıf yüklemeyi deniyor.',1),(2172,3,3238758531,'Belirsiz isme sahip \"%s\" sınıf yüklemeyi deniyor.',1),(2173,3,1847543081,'%s modül dosyası bulunamadı.',1),(2174,3,279504134,'%s dosyasındaki %s sınıf modülü bulunamadı.',1),(2175,3,2556760663,'Modül Bulunamadı.',1),(2176,3,988886446,'%s. Error: \"%s\" id nolu gönderim modülü yüklenemedi.',1),(2177,3,3288027779,'Rezerv Miktarları',1),(2178,3,2972889638,'Hiç bir şey  yapılmaz',1),(2179,3,3524378733,'Stoklara dönüş miktarları',1),(2180,3,2090210153,'GönderimModülüID \"%s\" ile gönderim modülü bulunamadı!',1),(2181,3,4143372495,'Gönderim modülü ismi ile GönderimModülüID\"%s\" bulunamadı!',1),(2182,3,907459679,'Bilinmeyen gönderim şekli \"%s\" bu gönderim modülü için \"%s\".',1),(2183,3,3983654493,'ÖdemeModülüID \"%s\" ile ödeme modülü bulunamadı.',1),(2184,3,4154823801,'ÖdemeModülüID \"%s\" ile ödeme modülü bulunamadı.',1),(2185,3,2306327481,'Adres Yok',1),(2186,3,809146176,'Uygulanamaz',1),(2187,3,4005971042,'Ulaşılamıyor',1),(2188,3,2198393684,'Ulaşılamıyor -Zaman Aşımı',1),(2189,3,38979051,'Desteklenmedi',1),(2190,3,2669544596,'Eşleşme yok',1),(2191,3,2574025683,'P.K eşleştirme',1),(2192,3,2709164901,'Sokak eşleştirme',1),(2193,3,3130867008,'Tam eşleştirme',1),(2194,3,160801151,'Uluslararası-desteklenmiyor',1),(2195,3,3331178104,'Uluslararası-eşleşme yok',1),(2196,3,1232421026,'Uluslararası-posta kodu eşleştirme',1),(2197,3,3183552170,'Uluslararası-sokak eşleştirme',1),(2198,3,1675788961,'Uluslararası-tam eşleştirme',1),(2199,3,3147491841,'Eşleştirmek',1),(2200,3,1358543466,'Geçerli Değil',1),(2201,3,3882939189,'Gönderilmedi',1),(2202,3,3812260290,'ABD çekleri',1),(2203,3,1281643356,'İngiltere çekleri',1),(2204,3,2135669230,'Denetleme',1),(2205,3,3720111745,'Tasarruf',1),(2206,3,1093252924,'ABA Yönlendirme Numarası:',1),(2207,3,784571595,'Şube Kodu:',1),(2208,3,2460243919,'İstisna ödeme İşlemi:',1),(2209,3,3764852828,'Detaylar:',1),(2210,3,645800559,'Ödeme işlemcisi yönlendirme...',1),(2211,3,2908525122,'Ödeme İşlemcisi',1),(2212,3,2245602422,'Para birimi uyumsuzluğu.',1),(2213,3,250637667,'Sipariş ID',1),(2214,3,2063252635,'Alınan Para',1),(2215,3,556738789,'Beklenen Para',1),(2216,3,465800015,'Ödeme tutarı uyumsuzluğu',1),(2217,3,2554316093,'Alınan Tutar',1),(2218,3,2038651890,'Beklenen Tutar',1),(2219,3,2285410388,'Eksik parametre \"% s\".',1),(2220,3,1744188893,'İşlemcinin bekleyen ödeme bilgisi',1),(2221,3,2515268484,'Reddedildi',1),(2222,3,1491869543,'Auth',1),(2223,3,1611532643,'Kısmi İade',1),(2224,3,514019258,'Geri ödeme',1),(2225,3,396418990,'Çevrimdışı Ödeme',1),(2226,3,986607068,'Kısmi Ödeme',1),(2227,3,423320567,'Sipariş ID ile İşlem Kodu=%s ve Modül ID=%s bulunamıyor.',1),(2228,3,1090077381,'Çoklu Dil Metni',1),(2229,3,4047669267,'Çoklu Seçenek',1),(2230,3,844974025,'Onaylanmadı',1),(2231,3,3782412241,'Seçilmedi',1),(2232,3,729257526,'Fiyat değiştirici',1),(2233,3,1056867889,'Değişken',1),(2234,3,1394044103,'Kullanıcı Görüntüsü',1),(2235,3,407613837,'Kullanıcı Metni',1),(2236,3,2480034857,'Ürün bulunamadı.',1),(2237,3,3801695625,'Satışda',1),(2238,3,529233592,'Ürün Gizle',1),(2239,3,2922029292,'\"Stok Dışı\" Etiketi',1),(2240,3,298651342,'Benzerliğe Göre Sırala',1),(2241,3,4236668364,'Fiyata Göre Sırala (düşükden yükseğe)',1),(2242,3,2206108970,'Fiyata Göre Sırala (yüksekden düşüğe)',1),(2243,3,1594729176,'Ürün İsmine Göre Sırala',1),(2244,3,1983638598,'Ürün Koduna Göre Sırala',1),(2245,3,1614702293,'Kg',1),(2246,3,403080213,'Lb',1),(2247,3,1281633745,'SEO Anahtar Kelimeler',1),(2248,3,2401170763,'SEO Açıklama',1),(2249,3,1856554936,'Faturalama İsim',1),(2250,3,779633653,'Faturalama Soyisim',1),(2251,3,3643031354,'Faturalama Firma',1),(2252,3,569783891,'Gönderilecek İsim',1),(2253,3,2944137814,'Gönderilecek Soyisim',1),(2254,3,3417896906,'Gönderilecek Firma',1),(2255,3,2572074719,'Ürün Kodu',1),(2256,3,3174173637,'Sipariş Durumu',1),(2257,3,256217995,'Vergi kaydı bulunamadı',1),(2258,3,3634676075,'Geçersiz Vergi Numarası.',1),(2259,3,1961341087,'Aşağıdaki formda hatalar vardır.<br/>Lütfen düzeltip tekrar gönderin.',1),(2260,3,3020941352,'Aşağıdaki formda hata vardır.<br/>Lütfen düzeltip tekrar gönderin.',1),(2261,3,4223270794,'Önceki',1),(2262,3,2991817930,'%d daha fazla adres',1),(2263,3,1268737845,'%d daha fazla adresler',1),(2264,3,1404092755,'İlk',1),(2265,3,3941140126,'Son',1),(2266,3,2072815210,'Sayfa başı kayıt',1),(2267,3,2286432583,'Seç',1),(2268,3,2261280103,'%s alanı için belirlenen minimum eşya bedeli.',1),(2269,3,374970102,'Değeri %d den daha küçük olmamalıdır.',1),(2270,3,2961549300,'%s alanı için belirlenen maximum eşya bedeli.',1),(2271,3,1003243756,'Değeri %d den daha büyük olmamalıdır.',1),(2272,3,217690918,'Geçersiz E-mail formatı.',1),(2273,3,3322238850,'Benzersiz değil.',1),(2274,3,1411741488,'Geçersiz http url.',1),(2275,3,2233986892,'%s alanı için eşya \"existsIn\"belirlenmelidir.',1),(2276,3,290530147,'Kayıt Yok.',1),(2277,3,3176614794,'Seçilen para birimi tanımlı değil.Para birimi yönetim ekranından yeni para birimini tanımlayabilirsiniz.',1),(2278,3,4140752483,'Seçtiğiniz gönderim şekli.',1),(2279,3,3613250963,'Değer boş olamaz.',1),(2280,3,2108643981,'Lütfen geçerli bir şehir ismi giriniz.',1),(2281,3,2627246759,'Kayıt',1),(2282,3,3688544399,'%s başarıyla oluşturuldu.',1),(2283,3,1036862127,'%s başarıyla güncellendi.',1),(2284,3,2716460254,'%s başarıyla silindi.',1),(2285,3,4031308951,'Tüm aktif menüler için isimler ayarlanmış olmalıdır.',1),(2286,3,3847004789,'--En Üst Seviye--',1),(2287,3,2880630370,'\"%s\" sadece puan ile satın alınabilir.',1),(2288,3,3619229128,'Siparişiniz için kullanılabilir faturalandırma şekli yoktur!',1),(2289,3,1923584595,'Bilinmeyen faturalandırma şekli seçildi.',1),(2290,3,3416367529,'%s den: %s.',1),(2291,3,3519133715,'Durum \"% s\".',1),(2292,3,3978063606,'Ücretsiz',1),(2293,3,2241996831,'Uyarılar:<br/>',1),(2294,3,3749391800,'Siparişiniz için kullanılabilir gönderim şekli yoktur!',1),(2295,3,2905832602,'Geçersiz tarih formatı.',1),(2296,3,238049363,'Bu modül seçeneklere sahip değildir.',1),(2297,3,2376570436,'Şablon dosyası seçenekleri ayarlı değil.',1),(2298,3,489853662,'Kontrol değişkenleri çok fazla.',1),(2299,3,1556001108,'Farketmez',1),(2300,3,1890732172,'Geçersiz adet.',1),(2301,3,3503465937,'Yinelenen adet.',1),(2302,3,31134505,'Geçersiz Miktar.',1),(2303,3,2806581010,'İlk satırda miktar 1 olmalıdır.',1),(2304,3,2163897815,'Resim Sil',1),(2305,3,3094486824,'Ülke ve KDV numarası ülke uyuşmuyor. KDV numarası %s ile başlamalı',1),(2306,3,2455112543,'Sepet en az bir öğe içermesi gerekir.',1),(2307,3,462582378,'İsteğiniz işlenirken hata oluştu:',1),(2308,3,3823642818,'Sihirbaz istisnası:',1),(2309,3,2254663015,'Lütfen,E-mail ve parola giriniz.',1),(2310,3,3161538148,'Tedarikçi bulunamadı.',1),(2311,3,844478805,'Bulunmayan Modül:',1),(2312,3,4204349676,'Merchat ID veya Merchant Key eşleşmedi',1),(2313,3,4278307332,'Google Checkout İstisna:',1),(2314,3,694481955,'\"%s\" vergi bölgesini Google Checkout kullanmıyor',1),(2315,3,2467941403,'Google Checkout ürün başına sadece bir vergi sınıfı destekler.',1),(2316,3,1909915985,'Google Checkout hata: \"%s\".',1),(2317,3,2628825648,'Üretim',1),(2318,3,693618939,'Sandbox',1),(2319,3,345221533,'Gönderim ücreti para biriminde uyumsuzluk. Beklenen \"%s\", bulunan \"%s\".',1),(2320,3,1078094406,'Vergi para biriminde uyumsuzluk. Beklenen \"%s\", bulunan \"%s\".',1),(2321,3,2593546886,'Yeni yerine getirilmesi durum:% s.',1),(2322,3,2169159268,'Koruma için uygun:% s.',1),(2323,3,1298284562,'Hesap yaşı: %d gün.',1),(2324,3,2810099095,'IP Adres:',1),(2325,3,3604752062,'Toplam: %s %s',1),(2326,3,2492447259,'%s Kimlik Doğrulama sona erdi',1),(2327,3,923861602,'Bilinmeyen Google Checkout bildirimi: %s',1),(2328,3,3951170399,'Bilinmeyen Ödeme Durumu.',1),(2329,3,3594121633,'Ödenmiş sipariş.',1),(2330,3,2272013587,'Sabit',1),(2331,3,2216047400,'Dinamik',1),(2332,3,3895911047,'PayPal bildirim doğrulama başarısız oldu.',1),(2333,3,348570661,'Sonuç',1),(2334,3,4022760396,'IPN Testi çalışıyor.',1),(2335,3,981519419,'Geçersiz kullanıcı adı ve parola.',1),(2336,3,3232414853,'Giriş sırasında İstisna:',1),(2337,3,1381658824,'Parolalar Uyuşmuyor!',1),(2338,3,2004258259,'Kayıt sırasında İstisna:',1),(2339,3,171087513,'Misafir ödeme etkin değil.',1),(2340,3,69326121,'Ödeme sırasında istisna:',1),(2341,3,1685420733,'Ödeme işlendi',1),(2342,3,1513996144,'Sipariş Sonuçlandırma',1),(2343,3,334391769,'Kullanma şartlarını kabul ediniz.',1),(2344,3,3217002174,'Ödeme işleme sırasında istisna:',1),(2345,3,635515012,'Yeni Adres',1),(2346,3,2416563426,'C.O.D. ücret',1),(2347,3,1686551835,'Kupon %s',1),(2348,3,2012040438,'Geçersiz Kupon.',1),(2349,3,1084554444,'%s bonus puan',1),(2350,3,1440107854,'Geçersiz Gönderim Modülü ID.',1),(2351,3,1351567222,'%s gönderim modülünden istisna: %s.',1),(2352,3,2979398362,'Seçilen %s gönderim modulü için gönderim oranları mevcut değil.',1),(2353,3,1671436555,'Seçilen \"%s\" gönderim modulü için oranlar mevcut değildir. \"%s\" Gönderim modulü.',1),(2354,3,1105882322,'Ara Toplam',1),(2355,3,901155661,'Vergi %s',1),(2356,3,1508301426,'Geçersiz 2Checkout anahtarı. Lütfen Gizli Kelimenizi kontrol edin.',1),(2357,3,2161169993,'Demo modunda sipariş.',1),(2358,3,2749440435,'Bilinmeyen işlem kodu.',1),(2359,3,3886614059,'İşlem kodu',1),(2360,3,4170617483,'Ödeme müşteri tarafından iptal edildi.',1),(2361,3,618085942,'Ödeme Başarısız.',1),(2362,3,779453244,'İşlem Hatası.',1),(2363,3,3011160535,'Yanıt Kodu',1),(2364,3,2833827248,'Yanıt Altkodu',1),(2365,3,3449546607,'Yanıt Metni Nedeni',1),(2366,3,2164617264,'Yanıt Kodu Nedeni',1),(2367,3,1110416711,'MD5 Hash uyuşmuyor.',1),(2368,3,4080894865,'Canlı',1),(2369,3,1987080350,'Demo',1),(2370,3,3876194617,'Geliştirici',1),(2371,3,1620695427,'Mağaza sahibi ülkesini ayarlamadı.',1),(2372,3,713582701,'Mağaza sahibi ilçesini ayarlamadı.',1),(2373,3,2283940953,'Mağaza sahibi firma ismini ayarlamadı.',1),(2374,3,4104488403,'Yönetici E-mail adresini ayarlamadı.',1),(2375,3,2870212386,'Iki özel tuş ve CSR\'ler oluşturuldu.',1),(2376,3,3054805519,'Hata üreten anahtar:',1),(2377,3,72922377,'Özel anahtar ve CSR oluşturuldu.',1),(2378,3,1428422942,'Oluşturulan ilk anahtar.',1),(2379,3,1631500600,'Geçersiz Sertifika.',1),(2380,3,3610695981,'OK',1),(2381,3,196033053,'Borica imzasını doğrulayamayız. Mesaj geçersiz veya mağaza sertifikası bozuktur.',1),(2382,3,1074052831,'Terminal ID (TID) uyuşmuyor.',1),(2383,3,2033581598,'Bilinmeyen yanıt kodu: %s.',1),(2384,3,3533853291,'Başarılı',1),(2385,3,2631704872,'Ağ Hatası.',1),(2386,3,3318243894,'Yabancı ağ hatası.',1),(2387,3,2557496871,'IEM zaman aşımı.',1),(2388,3,3849667764,'İşlem başarısız oldu.',1),(2389,3,3104815222,'Zaten geçerliliğini yitirmiştir.',1),(2390,3,3300264337,'Yinelenen işlem.',1),(2391,3,76042179,'3D auth başarısız.',1),(2392,3,3156081746,'İptal edilen işlem.',1),(2393,3,3980295143,'Geçersiz mesaj imzası.',1),(2394,3,1551420085,'Yürürlükden kaldırma başarısız oldu.',1),(2395,3,2846181355,'Fon başarıyla iade edildi.',1),(2396,3,2031090396,'Test Ödeme.',1),(2397,3,1558229877,'Geçersiz yönlendirme numarası.',1),(2398,3,3153024680,'Geçersiz sınıflama kodu.',1),(2399,3,3499759594,'Lütfen,hesap numarası giriniz.',1),(2400,3,993638850,'Lütfen,banka ismi giriniz.',1),(2401,3,3597456143,'Lütfen,hesap ismi giriniz.',1),(2402,3,2868789593,'Tesimde ödeme limitini aştınız.Maximum tutar %d %s olmalıdır.',1),(2403,3,1440228075,'Lütfen,Kart üzerindeki ismi giriniz.',1),(2404,3,3119284692,'Geçersiz Kart Numarası.',1),(2405,3,3231650341,'Geçersiz Son Kullanma Tarihi.',1),(2406,3,1390469070,'Geçersiz CVV Kodu.',1),(2407,3,4234528552,'%s bilinmeyen ödeme durumu.',1),(2408,3,1492592544,'MD5 imza için DSK hesabınız etkin değil. Lütfen DSK ile kontak kurun.',1),(2409,3,3194788682,'Tüccar uyuşmuyor.',1),(2410,3,53661188,'Simulator',1),(2411,3,2645749437,'Sipariş ID numarası eksik.',1),(2412,3,3784136527,'Ödeme süresi: %s, Borica kodu %s.',1),(2413,3,40437855,'Ödeme zamanı:%s.',1),(2414,3,2535456934,'Ödeme süresi doldu.',1),(2415,3,3332691567,'Bildirim.',1),(2416,3,3954423699,'Hata oluştu.',1),(2417,3,3415975849,'IDN bulunamadı.',1),(2418,3,690338763,'Geçersiz işlemden çıkmak',1),(2419,3,2595626995,'Bilinmeyen Para Birimi Kodu.',1),(2420,3,1820587442,'Moneris ödeme modülü kurulu değil.',1),(2421,3,239591290,'Ödeme İptal Edildi.',1),(2422,3,145849291,'Hatalı Moneris kodu.',1),(2423,3,2181488235,'Güvenlik doğrulama geçersiz.SHA-1-OUT imzasını kontrol edin.',1),(2424,3,1165586235,'Satış',1),(2425,3,3583367802,'Fon başarıyla alındı.',1),(2426,3,941378614,'Yetkilendirme başarıyla geçersiz kılındı.',1),(2427,3,800552064,'Fonlar başarıyla yetkilendirilmiştir.',1),(2428,3,3761312504,'Lütfen Ödeme Veri transferi sağla.',1),(2429,3,3157827527,'Ödeme veri transferinde hata var.Lütfen PDT kimlik belirtecini kontrol edin % s',1),(2430,3,1433195732,'Mağazaya dön',1),(2431,3,956808071,'Realex\'den gelen yanıt geçersiz.Lütfen mağaza sahibi ile kontak kurun.',1),(2432,3,2672067096,'Etkin',1),(2433,3,711999057,'Başarılı',1),(2434,3,3540366563,'Banka tarafından reddedildi.',1),(2435,3,248552064,'Banka ile refere',1),(2436,3,3201209846,'Kart çalıntı veya kayıp bildirilmiş',1),(2437,3,2261189006,'Banka sistemleri ile hata',1),(2438,3,1750758678,'Realex Ödemeler sistemleri ile Hata',1),(2439,3,2970791877,'Yanlış XML mesaj oluşumu veya içerik',1),(2440,3,1620246495,'Alıcı deaktif edildi',1),(2441,3,1245642798,'Geçersiz başlangıç tarihi.',1),(2442,3,1860431565,'Geçersiz konu numarası.',1),(2443,3,841623692,'Sage Pay den hata durumu: %s (%s).',1),(2444,3,1452716031,'Sage Pay den geçersiz veri.',1),(2445,3,3234925912,'Gönderilmedi',1),(2446,3,1915472064,'Müşteri ve satıcıya gönder',1),(2447,3,1798404581,'Sadece satıcıya gönder',1),(2448,3,3178107275,'Aktif banka yok.',1),(2449,3,2966302554,'Diğer kart yayımcısı',1),(2450,3,1045070230,'Hash imza yanlıştır. Lütfen mağaza anahtarını kontrol.',1),(2451,3,1106862291,'3D kimlik doğrulaması başarısız oldu.Nedeni %s',1),(2452,3,1528080076,'Banka seçenekleri başarıyla güncellendi.',1),(2453,3,3456911010,'Etkinleştirmeden önce lütfen bankayı yapılandırın',1),(2454,3,989631439,'Banka başarıyla deaktif edildi.',1),(2455,3,3104487354,'Banka başarıyla aktif edildi.',1),(2456,3,112362174,'PreAuth: Yalnızca Yetkililer',1),(2457,3,3694170451,'Geçersiz taksit sayısı.',1),(2458,3,2580567245,'Geçersiz faiz oranı.',1),(2459,3,3698181533,'Taksit sayısı kurulumu',1),(2460,3,2682797684,'UBB.bg error: %s.',1),(2461,3,304847185,'UBB module is not set up.',1),(2462,3,2200299116,'Error from ubb.bg: \"%s\"',1),(2463,3,2556539757,'Ödeme',1),(2464,3,4173210494,'Lütfen setup sihirbazını kullanınız.',1),(2465,3,2759125876,'Hiç bir terminal bulunmadı.',1),(2466,3,2134707015,'Başarılı! Terminal Bulundu :%s.',1),(2467,3,3807098547,'Lütfen önce Kanada posta ID sini giriniz.',1),(2468,3,371692282,'Dijital Teslimat',1),(2469,3,3892566628,'Geçersiz e-Econt kullanıcı adı/parola.',1),(2470,3,3131417127,'Sipariş numarası içinde eksik olan ürün:%s.',1),(2471,3,89269609,'Sipariş numarası içinde eksik olan ürün varyantı:%s.',1),(2472,3,2104340469,'%s siparişinin toplam ağırlığı sıfır',1),(2473,3,1827194367,'Eksik sipariş numarası ödeme modulü içinde:%s ',1),(2474,3,2708038800,'Bağlantı hatası.',1),(2475,3,645570083,'Geçersiz istek.',1),(2476,3,718797587,'Giriş',1),(2477,3,1945988660,'Ofis',1),(2478,3,460155848,'Kredi',1),(2479,3,947161889,'Geçersiz şehir.',1),(2480,3,525438188,'Geçersiz zip.',1),(2481,3,3674152100,'Şehir ve zip kodu uyuşmadı.',1),(2482,3,1338961600,'Telefon Numarası Geçerli Değil - Sadece Rakam olmalı ve birden fazla numarayı \",\" ile ayırınız.',1),(2483,3,1559384534,'Lütfen,Önce FedEx Hesap numarasını yapılandırınız.',1),(2484,3,1943503702,'Sabit oran Nakliye',1),(2485,3,4287710637,'Bu operasyon için yetkili değilsiniz.',1),(2486,3,4010557600,'Lütfen kullanıcı adı ve parola giriniz.',1),(2487,3,2013728466,'Hızlı kimlik doğrulaması yapılamadı.',1),(2488,3,2717330026,'Lütfen bölüm sayısı seçiniz',1),(2489,3,2969808959,'#%d siparişi için demet fişi ve etiketi yazdır',1),(2490,3,3761590774,'Hızlı gönderim modülü ayarlanmamış.',1),(2491,3,1594417462,'Sabit',1),(2492,3,2920004005,'Yüzde',1),(2493,3,718850353,'Şehirleri import ederken bir hata oluştu:',1),(2494,3,3909116274,'Yerler başarı ile import edildi.İmport edilen yeni şehirler: %d  Güncellenen şehirler:%d.',1),(2495,3,496065408,'Lütfen şehir belirtin.',1),(2496,3,475143414,'Bu şehir için,ilçe listemizde \"%s\" ilçesi bulunamadı.Lütfen kontrol ediniz.',1),(2497,3,1802502652,'\"%s\" CityID bulunamadı.Lütfen Speedy modulünü kullanarak yerleri upload edin.',1),(2498,3,951556676,' \"%s\" adlı şehir birden fazla.',1),(2499,3,2374008662,'%s devleti bulunamadı.',1),(2500,3,3115261555,'Hiç bir nakliye gönderimi hızlı ödeme için çalıştırılmadı.',1),(2501,3,1013795999,'Tablo-tabanlı gönderim',1),(2502,3,2474399755,'Lütfen,Önce UPS KullanıcıID,Şifre ve Erişim Numarasını yapılandırınız.',1),(2503,3,377665883,'Lütfen,Önce USPS KullanıcıID yi yapılandırınız.',1),(2504,3,1042739198,'Bu ülkeye USPS nakliye yapamıyor.Ülke Kodu \"%s\".',1),(2505,3,395145477,'%s (Kaynak: %s, Kod: %s)',1),(2506,3,1403912869,'Yeni',1),(2507,3,2768935208,'İşlendi',1),(2508,3,3789227194,'Teslim Edildi',1),(2509,3,2363194125,'Hızlı Bağlantılar Kurulumu',1),(2510,3,3305961868,'Satılan parça miktarı',1),(2511,3,2170461228,'Satılan parça bedeli',1),(2512,3,2044883406,'Sipariş kaydedilemedi: %s.',1),(2513,3,640934425,'\"%s\" Kullanıcı resmi tipi bir seçenek var.\"Sipariş düzenle\" desteklenmiyor.',1),(2514,3,1036390347,'Kupon tüm koşulları karşılamıyor \"%s\"',1),(2515,3,2429757432,'Siparişde para birimi kodu kaydedilmedi.',1),(2516,3,2670353289,'Seçilen para birimi \"%s\" bulunamadı.',1),(2517,3,1109538040,'Seçilen para birimi \"%s\" şu anda etkin değil.',1),(2518,3,3836761498,'Geçerli para birimi \"% s\" kullanılacaktır.',1),(2519,3,3098763195,'Birden fazla kupon koduyla \"%s\" kodu bulundu.Yok uygulanacak.',1),(2520,3,1840303263,'\"%s\" Kuponu bulunamadı.',1),(2521,3,322559967,'Kupon \"%s\" uygulanmaz.',1),(2522,3,3594007164,'Fazla yüklendi',1),(2523,3,3955385877,'Orjinal siparişte bazı toplam satırlar şimdi yok:',1),(2524,3,1962040625,'Orjinal siparişte bazı toplam satırlar yok:',1),(2525,3,3899924871,'Tutar \"%s\"  Toplamda değişen  %s den %s.',1),(2526,3,2440723355,'Bir indirim  %s dan \"%s\" vardı.Şimdi %s',1),(2527,3,2932499639,'Ürün bulunamıyor (ProductID %d).',1),(2528,3,2774013299,'\"%s\" Dil kodu bulunamadı. \"%s\" yerine kullanılacaktır.',1),(2529,3,3897097184,'Hiçbir etkin gönderi modulü yok.',1),(2530,3,93649609,'Kullanıcının seçtiği gönderim modulü bulunamadı.',1),(2531,3,1518610654,'Kullanıcının seçtiği gönderim modulü etkin değil.',1),(2532,3,3029286015,'Ülke \"%s\" müşterinin seçtiği ülke gönderimi bulunamadı.',1),(2533,3,3101475492,'Ülke \"%s\" müşterinin seçtiği ülke faturalandırması bulunamadı.',1),(2534,3,2910254793,'The state \"%s\" that the user has selected as his %s could not be found.',1),(2535,3,3827980616,'Ürün\"%s\" seçenek sayısı ile sipariş kalemi seçenek sayısı eşleşmiyor.',1),(2536,3,1209841706,'Siparişin ürün seçenekleri eksik.Ürün seçenek değerleri varsayılan olarak ayarlanacak: %s ',1),(2537,3,524603406,'Ürün seçenekleri sipariş için seçilmiştir ama sipariş verilen ürün desteklemiyor: %s',1),(2538,3,1201267415,'Haber bulunamadı.',1),(2539,3,1036467592,'%s \'dan bülten aldınız.',1),(2540,3,1700537962,'E-posta gönderimi başarısız oldu.',1),(2541,3,2868414571,'Test Mesajı Başarıyla Gönderildi.',1),(2542,3,378138088,'Abone',1),(2543,3,1589477793,'Tüm abone olmayanlar dahil',1),(2544,3,1958860084,'Başarıyla durduruldu.',1),(2545,3,489363607,'\"%s\" bülten istatistiği',1),(2546,3,595429309,'Tüm aylar',1),(2547,3,3113862095,'Ocak',1),(2548,3,3025422826,'Şubat',1),(2549,3,3205994163,'Mart',1),(2550,3,1874880475,'Nisan',1),(2551,3,1097932288,'Haziran',1),(2552,3,1732649165,'Temmuz',1),(2553,3,3813010884,'Ağustos',1),(2554,3,1011490657,'Eylül',1),(2555,3,596285180,'Ekim',1),(2556,3,2365364793,'Kasım',1),(2557,3,3931589271,'Aralık',1),(2558,3,293367773,'Tüm diller',1),(2559,3,2327549235,'Faaliyet \"%s - %s\" İstatistik',1),(2560,3,1923443894,'Pasif',1),(2561,3,1991326958,'E-maillere eklenmedi.',1),(2562,3,1706330912,'%s e-mails successfully subscribed.',1),(2563,3,3079681498,'Bu e-postalar geçersiz ve abone değiller: %s',1),(2564,3,1075938043,'Planlan mesaj yok.',1),(2565,3,3566135737,'Abone (%s)',1),(2566,3,1867803181,'Hepsi (%s)',1),(2567,3,3948876667,'Abone olmayanlar dahil tümü (%s)',1),(2568,3,2723494638,'Abonelik iptali için bu linki tıklayın:',1),(2569,3,201141228,'Enable \"Email Opens\" tracking',1),(2570,3,3700194837,'Enable \"Click-Through\" tracking',1),(2571,3,2188668833,'Varsayılan ayarlar için abone onay kutusunu işaretleyin',1),(2572,3,3270213856,'\"Abone İptal\" başlantısı eklemeyin.Kutuyu işaretlemeden çıkmanız önerilir.',1),(2573,3,3797768377,'Abone',1),(2574,3,2217367178,'Aktif',1),(2575,3,514029753,'Lütfen geçerli bir e-posta adresinizi girin.',1),(2576,3,2131480835,'\"%s\" bültenine abonelik için giriş yapmanız gerekir.',1),(2577,3,1460842374,'\"%s\" bülteni aboneleği için',1),(2578,3,4151955869,'E-postası \"%s\" olan bir kullanıcının \"%s\" bültenine aboneliği gerçekleşir.',1),(2579,3,1453211149,'\"%s\" karşılaştırmak için ürün eklenemiyor. ',1),(2580,3,166495272,'Ürün Karşılaştırma',1),(2581,3,1634594289,'Select language',1),(2582,3,3705672827,'Select currency',1),(2583,3,3348699508,'Ürünler Bildirimi',1),(2584,3,812562298,'Geçersiz ürün besleme anahtarı.',1),(2585,3,2573243337,'Onay Bekleniyor',1),(2586,3,4039052383,'Onaylanmamış',1),(2587,3,4121705435,'Düşük',1),(2588,3,1828591333,'Fena Değil',1),(2589,3,3434537388,'İyi',1),(2590,3,2761007372,'Çok İyi',1),(2591,3,551958626,'Mükemmel',1),(2592,3,2597373484,'Sadece kayıtlı üyelerimiz oylayabilir.',1),(2593,3,927169313,'Sadece bu ürünü satın almış müşteriler değerlendirme yapabilir.',1),(2594,3,1175543820,'Sadece kayıtlı üyelerimiz yorum yazabilir.',1),(2595,3,1715888140,'Sadece bu ürünü satın almış müşteriler yorum yapabilir.',1),(2596,3,377899250,'Yorum Yapılmamış.',1),(2597,3,2179000251,'Değerlendirme Yapılmamış.',1),(2598,3,3148493063,'Değerlendirme/Yorum',1),(2599,3,2808175468,'Tüm değerlendirmeler',1),(2600,3,310527526,'Yorum İçerik',1),(2601,3,2749701344,'Değerlendirme Değeri',1),(2602,3,1777785138,'Değerlendirme Durumu',1),(2603,3,1207280236,'\"%s\" Müşterinin yorumladığı ürün.',1),(2604,3,2779464736,'\"%s\" Müşterinin beğendiği ürün.',1),(2605,3,868798906,'Lütfen,Değerlendirme veya Yorum seçiniz.',1),(2606,3,46111629,'Lütfen değerlendirme yapınız.',1),(2607,3,958856233,'Lütfen yorum yazınız.',1),(2608,3,1836496177,'Misafir',1),(2609,3,233027733,'Geri bildiriminiz için Teşekkür Ederiz.',1),(2610,3,2600091244,'Bilinmeyen RSS beslemesi.',1),(2611,3,427583051,'Toptan Satış İndirimi',1),(2612,3,1568311921,'Bu ürün zaten istek listenizde.',1),(2613,3,3819242224,'Ürün başarıyla istek listenize eklendi.',1),(2614,3,1194866349,'İstek listeniz kaldırıldı.',1),(2615,3,829364355,'İstek Listem Burada',1),(2616,3,3268514320,'İstek listesi gönderildi.',1),(2617,3,2684748848,'Sayfa Bulunamadı.',1),(2618,3,3670592399,'Profil başarıyla güncellendi.',1),(2619,3,4265525075,'Profilim',1),(2620,3,1537601948,'Kayıt başarısız: %s',1),(2621,3,2909322066,'Bülten aboneliği başarısız oldu: %s',1),(2622,3,2365027333,'--Hepsi--',1),(2623,3,485311805,'E-mailiniz başarıyla gönderildi.',1),(2624,3,298311779,'E-mail gönderilirken hata oluştu.',1),(2625,3,3198092169,'%s uygulamaları bulunamıyor.',1);
/*!40000 ALTER TABLE `TextsTranslated` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

LOCK TABLES `ModuleOptions` WRITE;
/*!40000 ALTER TABLE `ModuleOptions` DISABLE KEYS */;
/*!40000 ALTER TABLE `ModuleOptions` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

LOCK TABLES `ShippingModules` WRITE;
/*!40000 ALTER TABLE `ShippingModules` DISABLE KEYS */;
INSERT INTO `ShippingModules` VALUES (7,25,NULL,'com.summercart.shipping.digitaldelivery','skins/default/modules/shipping/digital_delivery/logo_digital-delivery.png',0,7);
/*!40000 ALTER TABLE `ShippingModules` ENABLE KEYS */;
UNLOCK TABLES;

LOCK TABLES `ShippingModulesML` WRITE;
/*!40000 ALTER TABLE `ShippingModulesML` DISABLE KEYS */;
INSERT INTO `ShippingModulesML` VALUES (7,1,'Digital Delivery'),(7,2,'Дигитална доставка'),(7,3,'Dijital Teslimat');
/*!40000 ALTER TABLE `ShippingModulesML` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

